/*
SQLyog Ultimate
MySQL - 5.7.19 : Database - test_drupal_8
*********************************************************************
*/


/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
CREATE DATABASE /*!32312 IF NOT EXISTS*/`test_drupal_8` /*!40100 DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci */;

/*Table structure for table `batch` */

DROP TABLE IF EXISTS `batch`;

CREATE TABLE `batch` (
  `bid` int(10) unsigned NOT NULL COMMENT 'Primary Key: Unique batch ID.',
  `token` varchar(64) CHARACTER SET ascii NOT NULL COMMENT 'A string token generated against the current user''s session id and the batch id, used to ensure that only the user who submitted the batch can effectively access it.',
  `timestamp` int(11) NOT NULL COMMENT 'A Unix timestamp indicating when this batch was submitted for processing. Stale batches are purged at cron time.',
  `batch` longblob COMMENT 'A serialized array containing the processing data for the batch.',
  PRIMARY KEY (`bid`),
  KEY `token` (`token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores details about batches (processes that run in…';

/*Data for the table `batch` */

/*Table structure for table `block_content` */

DROP TABLE IF EXISTS `block_content`;

CREATE TABLE `block_content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `revision_id` int(10) unsigned DEFAULT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `block_content_field__uuid__value` (`uuid`),
  UNIQUE KEY `block_content__revision_id` (`revision_id`),
  KEY `block_content_field__type__target_id` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=47 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for block_content entities.';

/*Data for the table `block_content` */

insert  into `block_content`(`id`,`revision_id`,`type`,`uuid`,`langcode`) values 

(1,1,'basic','0b6370a9-be73-4701-bb5b-719f350f0927','en'),

(2,2,'basic','ca4e996c-222b-4e10-b248-09930f18481b','en'),

(3,3,'basic','6a9dbf83-77b0-4d60-81e6-4ae5da969bce','en'),

(4,4,'basic','52a10536-56b5-4eb7-8df9-33230c18ba31','en'),

(5,5,'basic','653038ca-8c0b-4717-99d5-c3acc664d7af','en'),

(6,6,'basic','7bf565ba-d4c0-4dbb-88d7-3a62af679d29','en'),

(7,7,'basic','73ce061d-fb5d-4361-b842-95475bbcb67b','en'),

(8,8,'basic','9406b6d7-9c11-4ae3-b5bc-ce4d6b5892ac','en'),

(9,9,'basic','7d6a15ef-a32a-4303-b9bd-721ae7fc6e2f','en'),

(10,10,'basic','5383c346-1e60-4cfb-b197-f2c3cf81ff32','en'),

(11,11,'basic','3349535d-91e6-40ae-9177-58513f4cd5f6','en'),

(12,12,'basic','24d7103c-7e8f-4452-add5-9ce850946d3e','en'),

(13,13,'basic','cbea5a9b-6fdb-4634-81b2-a6813f136a28','en'),

(14,14,'basic','e9cb56b9-8887-4f6c-9c9f-ff621ad1a410','en'),

(15,15,'basic','b397d2ca-dcde-4faa-9a97-9b4424b233b7','en'),

(16,16,'basic','907807f0-9207-4580-8336-3c6f41767dde','en'),

(17,17,'basic','02bde269-1d46-4ba4-aa78-811bb904f0cc','en'),

(18,18,'basic','b0802411-d5eb-4a16-a6d6-ff7024e3dd34','en'),

(19,19,'basic','2aa33a4b-bb38-4f6a-9c66-5cc5c7f27094','en'),

(20,20,'basic','96e17d3d-5c4b-4699-95f9-ed2c65add661','en'),

(21,21,'basic','1411a6d8-cbeb-4474-b584-62163cc624d4','en'),

(22,22,'basic','3e57c7df-fc44-497a-b5d3-101a4180545b','en'),

(23,23,'basic','71affffc-cffa-4790-93df-5f7d6790619a','en'),

(24,24,'basic','ccc57983-ca62-407c-bc2d-cc693e7d4fab','en'),

(25,25,'basic','ace33e6a-ca9c-41ef-b0ee-ffb6a2a52274','en'),

(26,26,'basic','0f836014-c83c-4c70-a06b-010c20d64052','en'),

(27,27,'basic','4e4c5a44-2bf9-4b6a-9fc7-c4c77854c4f2','en'),

(28,28,'basic','fddb3dae-ff3f-4eab-b348-53afefc651b5','en'),

(29,29,'basic','a728edbb-0a33-4c10-89b8-dafda2501620','en'),

(30,30,'basic','371c38c9-61b6-4b61-813c-e781c77d9a2b','en'),

(31,31,'basic','5fa9ccfc-0083-4023-9905-f4c1e9969098','en'),

(32,32,'basic','7c4c579e-1361-49a3-a6d3-4f5f9529d16d','en'),

(33,33,'basic','b8196462-3d3f-42cd-865e-2070173cd6a7','en'),

(34,34,'basic','ac670683-9f00-4dc6-b4d4-4ff3497e48d0','en'),

(35,35,'basic','b0bd13b5-c922-4792-945f-15414b01b7c3','en'),

(36,36,'basic','21382078-dc04-4156-8562-c6bb4e02f0e1','en'),

(37,37,'basic','b9039c91-c46f-4831-991d-a9f2d08cf7cf','en'),

(38,38,'basic','d1a11564-3551-4347-b5bc-3a8cd1b894ed','en'),

(39,39,'basic','24110089-987a-4a14-a6ed-89553666f7df','en'),

(40,40,'basic','8379ba0a-99cf-4d6c-92bc-b0713eabb68a','en'),

(41,41,'basic','105211ef-6551-4e9c-816c-39c118e2b0f2','en'),

(42,42,'basic','7a5157bb-6c81-4dcf-9517-187aa57df270','en'),

(43,43,'basic','90013c4e-6be7-4967-bcd1-623ff20502df','en'),

(44,44,'basic','d5849bbf-634c-46be-8079-41e31edc2f28','en'),

(45,45,'basic','d2b2af3a-4ec7-42e3-86b9-a30492bc3970','en'),

(46,46,'basic','b1ba8190-4ca2-4150-a6ec-06d571eab1a0','en');

/*Table structure for table `block_content__body` */

DROP TABLE IF EXISTS `block_content__body`;

CREATE TABLE `block_content__body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext NOT NULL,
  `body_summary` longtext,
  `body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for block_content field body.';

/*Data for the table `block_content__body` */

insert  into `block_content__body`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`body_value`,`body_summary`,`body_format`) values 

('basic',0,1,1,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"0\" different_values=\"0\" search=\"1\" cart=\"1\" language=\"1\"]\r\n[/nd_menu]\r\n[nd_header type=\"bg-gray-lighter\" breadcrumbs=\"1\" description=\"LOREM IPSUM DOLOR SIT AMET CONSECTETUR\" different_values=\"0\" size=\"small-section\"]\r\n[/nd_header]\r\n ','','dynamic_shortcodes'),

('basic',0,2,2,'en',0,'[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" style_padding_bottom=\"60\" style_padding_top=\"140\"]\r\n[nd_container text_align=\"center\" different_values=\"0\"]\r\n[nd_div different_values=\"0\" style_margin_bottom=\"30\" animation=\"fadeInUp\"]\r\n[nd_image fid=\"22\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" width=\"78\" height=\"30\"]\r\n[/nd_image]\r\n[/nd_div]\r\n[nd_icon icon=\"fa fa-facebook\" boxed=\"0\" different_values=\"0\" link=\"https://www.facebook.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[nd_icon icon=\"fa fa-twitter\" boxed=\"0\" different_values=\"0\" link=\"https://www.twitter.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[nd_icon icon=\"fa fa-behance\" boxed=\"0\" different_values=\"0\" link=\"https://www.twitter.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[nd_icon icon=\"fa fa-linkedin\" boxed=\"0\" different_values=\"0\" link=\"https://www.twitter.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[nd_icon icon=\"fa fa-pinterest\" boxed=\"0\" different_values=\"0\" link=\"https://www.twitter.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" style_padding_top=\"110\"]<div class=\"footer-text footer\"><div class=\"footer-copy font-alt\">		<a href=\"http://themeforest.net/user/NikaDevs/portfolio\" target=\"_blank\">© Rhythm 2016</a>.</div><div class=\"footer-made\">		Made with love for great people.</div></div>[/html]\r\n[/nd_container]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,3,3,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" different_values=\"0\" search=\"1\" cart=\"0\" language=\"1\"]\r\n[/nd_menu]\r\n[nd_header fid=\"3\" type=\"bg-dark-alfa-50\" breadcrumbs=\"1\" description=\"LOREM IPSUM DOLOR SIT AMET CONSECTETUR\" different_values=\"0\" size=\"home-section parallax-2 fixed-height-small\"]\r\n[/nd_header]\r\n ','','shortcodes'),

('basic',0,4,4,'en',0,'[nd_menu menu=\"main\" fid = \"24\" type=\"white\" transparent=\"0\" different_values=\"0\" search=\"1\" cart=\"0\" language=\"1\"]\r\n[/nd_menu]\r\n[nd_header type=\"bg-gray-lighter\" breadcrumbs=\"1\" description=\"LOREM IPSUM DOLOR SIT AMET CONSECTETUR\" different_values=\"0\" size=\"small-section\"]\r\n[/nd_header]\r\n ','','shortcodes'),

('basic',0,5,5,'en',0,'[nd_menu menu=\"main-menu\" type=\"white\" transparent=\"1\" different_values=\"0\" fid=\"24\" search=\"1\" cart=\"0\" language=\"1\"]\r\n[/nd_menu]\r\n[nd_header fid=\"25\" type=\"bg-light-alfa-30\" breadcrumbs=\"1\" description=\"LOREM IPSUM DOLOR SIT AMET CONSECTETUR\" different_values=\"0\" size=\"home-section parallax-2 fixed-height-small\"]\r\n[/nd_header]\r\n ','','shortcodes'),

('basic',0,6,6,'en',0,'[html style_padding_top = \"140\"]<h4 class=\"font-alt mb-sm-40 mb-70 section-title \">Related Projects</h4>[/html]\r\n[nd_block admin_url = \"admin/structure/block/manage/views_block__related_projects_block_1\" style_padding_bottom = \"60\"][/nd_block]','','shortcodes'),

('basic',0,7,7,'en',0,'[nd_bg color=\"bg-dark\" slider=\"0\" banner=\"0\" different_values=\"0\" text_align=\"center\" style_padding_top=\"60\" style_padding_bottom=\"60\"]\r\n[nd_title title=\"Want to work with us?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" weight=\"fw-300\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"JOIN NOW\" link=\"http://rhythm.nikadevs.com\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,8,8,'en',0,'[nd_gmap type=\"roadmap\" overlay=\"1\" address=\"Belt Parkway, Queens, NY, United States\" different_values=\"0\"]\r\n[/nd_gmap]\r\n ','','shortcodes'),

('basic',0,9,9,'en',0,'[nd_gmap type=\"roadmap\" overlay=\"0\" address=\"Belt Parkway, Queens, NY, United States\" different_values=\"0\"]\r\n[/nd_gmap]\r\n ','','shortcodes'),

('basic',0,10,10,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"43\" full_height=\"1\" scroll_icon=\"1\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\"]\r\n[nd_title title=\"THOMAS RHYTHM\" size=\"h1_big\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"80\"]\r\n[/nd_title]\r\n[nd_title title=\"Extraordinary art studio &amp; creative minimalism lovers\" size=\"h6_big\" alignment=\" align-center\" styled=\"0\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,11,11,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-90\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"58\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,12,12,'en',0,'[nd_menu menu=\"main\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\" fid = \"24\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"25\" full_height=\"1\" scroll_icon=\"1\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,13,13,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"56\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,14,14,'en',0,'[nd_menu menu=\"main\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\" fid=\"24\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"60\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"WE LOVE DESIGN\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,15,15,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"61\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,16,16,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"3\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,17,17,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[nd_text_rotator text=\"Rhythm Creative Studio,We Have Magic Skills,We Love Smart Design\" different_values=\"0\" text_line_1=\"Rhythm Creative Studio\" op=\"Add new row\" text_line_2=\"We Have Magic Skills\" text_line_3=\"We Love Smart Design\"]\r\n[/nd_text_rotator]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,18,18,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth\" different_values=\"0\" slide_autoplay=\"3000\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"56\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"55\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,19,19,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth-zoom\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"55\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"56\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,20,20,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth\" different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-90\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"58\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"56\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"amazing design\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"59\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"rhythm creative studio\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,21,21,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth-bg\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" fid=\"56\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,22,22,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_icon icon=\"fa fa-play\" size=\"32\" boxed=\"0\" link=\"http://vimeo.com/50201327\" type=\"Big Icon\" different_values=\"0\"]\r\n[/nd_icon]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,23,23,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"0\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,24,24,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-pattern-over\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,25,25,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-pattern-over\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[nd_text_rotator text_line_1=\"RHYTHM CREATIVE STUDIO\" text_line_2=\"WE HAVE MAGIC SKILLS\" text_line_3=\"WE LOVE SMART DESIGN\" op=\"Add new row\" different_values=\"0\"]\r\n[/nd_text_rotator]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,26,26,'en',0,'[nd_menu menu=\"main\" type=\"white\" transparent=\"0\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\" style_padding_top=\"140\" style_padding_bottom=\"140\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[nd_view admin_url=\"admin/structure/views/view/portfolio_boxed/edit/page_6\" different_values=\"0\"]\r\n[/nd_view]\r\n[nd_bg color=\"bg-dark\" slider=\"0\" banner=\"0\" different_values=\"0\" text_align=\"center\" style_padding_top=\"60\" style_padding_bottom=\"60\"]\r\n[nd_title title=\"LIKE OUR CREATIVE WORKS?\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"start project\" link=\"http://rhythm.nikadevs.com\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,27,27,'en',0,'[nd_menu menu_type=\"popup_menu\" menu=\"main\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"0\" language=\"0\" different_values=\"0\" extra_classes=\"small-logo\" fid=\"67\"]\r\n[/nd_menu]\r\n[nd_slider different_values=\"0\" slide_anim=\"images_pager\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"58\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"59\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"60\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"61\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"62\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"63\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"64\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"95\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"65\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"66\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[nd_view admin_url=\"/admin/structure/views/view/gallery/edit/page_2\" different_values=\"0\"]\r\n[/nd_view]\r\n ','','shortcodes'),

('basic',0,28,28,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"43\" full_height=\"1\" scroll_icon=\"1\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\"]\r\n[nd_title title=\"THOMAS RHYTHM\" size=\"h1_big\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"80\"]\r\n[/nd_title]\r\n[nd_title title=\"Extraordinary art studio &amp; creative minimalism lovers\" size=\"h6_big\" alignment=\" align-center\" styled=\"0\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,29,29,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-90\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"42\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,30,30,'en',0,'[nd_menu menu=\"one-page\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"25\" full_height=\"1\" scroll_icon=\"1\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,31,31,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"52\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,32,32,'en',0,'[nd_menu menu=\"one-page\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"53\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"WE LOVE DESIGN\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,33,33,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"52\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,34,34,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"3\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,35,35,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[nd_text_rotator text=\"Rhythm Creative Studio,We Have Magic Skills,We Love Smart Design\" different_values=\"0\" text_line_1=\"Rhythm Creative Studio\" op=\"Add new row\" text_line_2=\"We Have Magic Skills\" text_line_3=\"We Love Smart Design\"]\r\n[/nd_text_rotator]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,36,36,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth\" different_values=\"0\" slide_autoplay=\"3000\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"55\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"52\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,37,37,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth-zoom\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"55\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"52\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,38,38,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth\" different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-90\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"42\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"41\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"amazing design\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"52\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"rhythm creative studio\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,39,39,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth-bg\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" fid=\"56\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,40,40,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_icon icon=\"fa fa-play\" size=\"32\" boxed=\"0\" link=\"http://vimeo.com/50201327\" type=\"Big Icon\" different_values=\"0\"]\r\n[/nd_icon]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,41,41,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"0\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,42,42,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-pattern-over\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,43,43,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-pattern-over\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[nd_text_rotator text_line_1=\"RHYTHM CREATIVE STUDIO\" text_line_2=\"WE HAVE MAGIC SKILLS\" text_line_3=\"WE LOVE SMART DESIGN\" op=\"Add new row\" different_values=\"0\"]\r\n[/nd_text_rotator]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,44,44,'en',0,'[nd_menu menu_type=\"popup_menu\" menu=\"one-page\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"0\" language=\"0\" different_values=\"0\" extra_classes=\"small-logo\"]\r\n[/nd_menu]\r\n[nd_slider different_values=\"0\" slide_anim=\"images_pager\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"58\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"59\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"60\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"61\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"62\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"63\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"64\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"95\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"65\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"66\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[nd_view admin_url=\"/admin/structure/views/view/gallery/edit/page_2\" different_values=\"0\"]\r\n[/nd_view]\r\n ','','shortcodes'),

('basic',0,45,45,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"widget-body widget-text clearfix\"]<p><img alt=\"\" class=\"img-circle left img-left\" src=\"http://local.rhythm.nikadevs.com/sites/rhythm.nikadevs.com/files/user-avatar.png\" style=\"height: 70px; width: 70px; margin: 0px 10px 10px 0px;\">Consectetur adipiscing elit. Quisque magna ante eleifend eleifend. Purus ut dignissim consectetur, nulla erat ultrices purus, ut consequat sem elit non sem. Quisque magna ante eleifend eleifend.</p>[/html]\r\n','','shortcodes'),

('basic',0,46,46,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\" style=\"\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/cart\" different_values=\"0\"]\r\n[/nd_block]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\" style=\"\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/views_block__products_tags_block\" different_values=\"0\"]\r\n[/nd_block]\r\n[nd_block admin_url=\"admin/structure/block/manage/textwidget\" different_values=\"0\"]\r\n[/nd_block]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\" style=\"\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/views_block__shop_categories_block\" different_values=\"0\"]\r\n[/nd_block]\r\n[nd_block admin_url=\"admin/structure/block/manage/rhythmproductsfilter\" different_values=\"0\"]\r\n[/nd_block]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\" style=\"\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/views_block__products_best_sellers_block\" different_values=\"0\"]\r\n[/nd_block]\r\n[/col]\r\n[/row]\r\n ','','shortcodes');

/*Table structure for table `block_content_field_data` */

DROP TABLE IF EXISTS `block_content_field_data`;

CREATE TABLE `block_content_field_data` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `info` varchar(255) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `status` tinyint(4) NOT NULL,
  `reusable` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`id`,`langcode`),
  KEY `block_content_field__type__target_id` (`type`),
  KEY `block_content__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `block_content__revision_id` (`revision_id`),
  KEY `block_content__status_type` (`status`,`type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for block_content entities.';

/*Data for the table `block_content_field_data` */

insert  into `block_content_field_data`(`id`,`revision_id`,`type`,`langcode`,`info`,`changed`,`revision_translation_affected`,`default_langcode`,`status`,`reusable`) values 

(1,1,'basic','en','Header Dark Main',1506762007,1,1,1,1),

(2,2,'basic','en','Footer',1480889681,1,1,1,1),

(3,3,'basic','en','Header Dark Transparent',1498464501,1,1,1,1),

(4,4,'basic','en','Header White',1480966889,1,1,1,1),

(5,5,'basic','en','Header White Transparent',1480966882,1,1,1,1),

(6,6,'basic','en','Related Projects',1481213604,1,1,1,1),

(7,7,'basic','en','Want to work with us?',1481213252,1,1,1,1),

(8,8,'basic','en','Gmap: Contact',1481648399,1,1,1,1),

(9,9,'basic','en','Gmap: Contact Top',1481648537,1,1,1,1),

(10,10,'basic','en','Header: Main Demo',1481654951,1,1,1,1),

(11,11,'basic','en','Header: Image Parallax 1',1490606859,1,1,1,1),

(12,12,'basic','en','Header: Image Parallax 2',1482963950,1,1,1,1),

(13,13,'basic','en','Header: Image Parallax 3',1490606892,1,1,1,1),

(14,14,'basic','en','Header: Image Parallax 4',1490606932,1,1,1,1),

(15,15,'basic','en','Header: Image Parallax 5',1490607011,1,1,1,1),

(16,16,'basic','en','Header: Fullwidth Image',1484854352,1,1,1,1),

(17,17,'basic','en','Header: Text Rotator',1484854485,1,1,1,1),

(18,18,'basic','en','Header: Slider Fullscreen',1490606559,1,1,1,1),

(19,19,'basic','en','Header: Slider Zoom Effect',1490606510,1,1,1,1),

(20,20,'basic','en','Header: Slider Fullwidth',1490606781,1,1,1,1),

(21,21,'basic','en','Header: Slider Background',1484857328,1,1,1,1),

(22,22,'basic','en','Header: With Play Button',1484857439,1,1,1,1),

(23,23,'basic','en','Header: BG Video Fullwidth',1484859734,1,1,1,1),

(24,24,'basic','en','Header: BG Video FullScreen 1',1484859837,1,1,1,1),

(25,25,'basic','en','Header: BG Video FullScreen 2',1484859916,1,1,1,1),

(26,26,'basic','en','Header: Agency Header',1484860214,1,1,1,1),

(27,27,'basic','en','Header: Special Photography',1484912025,1,1,1,1),

(28,28,'basic','en','Header: Main Demo - OnePage',1484927756,1,1,1,1),

(29,29,'basic','en','Header: Image Parallax 1 - OnePage',1485000575,1,1,1,1),

(30,30,'basic','en','Header: Image Parallax 2 - Onepage',1485020663,1,1,1,1),

(31,31,'basic','en','Header: Image Parallax 3 - OnePage',1485020723,1,1,1,1),

(32,32,'basic','en','Header: Image Parallax 4 - OnePage',1485020757,1,1,1,1),

(33,33,'basic','en','Header: Image Parallax 5 - OnePage',1485021038,1,1,1,1),

(34,34,'basic','en','Header: Fullwidth Image - OnePage',1485021130,1,1,1,1),

(35,35,'basic','en','Header: Text Rotator - OnePage',1485021224,1,1,1,1),

(36,36,'basic','en','Header: Slider Fullscreen - OnePage',1485021263,1,1,1,1),

(37,37,'basic','en','Header: Slider Zoom Effect - OnePage',1485021336,1,1,1,1),

(38,38,'basic','en','Header: Slider Fullwidth - OnePage',1485021376,1,1,1,1),

(39,39,'basic','en','Header: Slider Background - OnePage',1485021416,1,1,1,1),

(40,40,'basic','en','Header: With Play Button - OnePage',1485021465,1,1,1,1),

(41,41,'basic','en','Header: BG Video Fullwidth - OnePage',1485021523,1,1,1,1),

(42,42,'basic','en','Header: BG Video FullScreen 1 - OnePage',1485211474,1,1,1,1),

(43,43,'basic','en','Header: BG Video FullScreen 2 - OnePage',1485211544,1,1,1,1),

(44,44,'basic','en','Header: Special Photography - OnePage',1485211804,1,1,1,1),

(45,45,'basic','en','Text Widget',1503569219,1,1,1,1),

(46,46,'basic','en','Shop 4 Columns',1503664741,1,1,1,1);

/*Table structure for table `block_content_field_revision` */

DROP TABLE IF EXISTS `block_content_field_revision`;

CREATE TABLE `block_content_field_revision` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `info` varchar(255) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `status` tinyint(4) NOT NULL,
  PRIMARY KEY (`revision_id`,`langcode`),
  KEY `block_content__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The revision data table for block_content entities.';

/*Data for the table `block_content_field_revision` */

insert  into `block_content_field_revision`(`id`,`revision_id`,`langcode`,`info`,`changed`,`revision_translation_affected`,`default_langcode`,`status`) values 

(1,1,'en','Header Dark Main',1506762007,1,1,1),

(2,2,'en','Footer',1480889681,1,1,1),

(3,3,'en','Header Dark Transparent',1498464501,1,1,1),

(4,4,'en','Header White',1480966889,1,1,1),

(5,5,'en','Header White Transparent',1480966882,1,1,1),

(6,6,'en','Related Projects',1481213604,1,1,1),

(7,7,'en','Want to work with us?',1481213252,1,1,1),

(8,8,'en','Gmap: Contact',1481648399,1,1,1),

(9,9,'en','Gmap: Contact Top',1481648537,1,1,1),

(10,10,'en','Header: Main Demo',1481654951,1,1,1),

(11,11,'en','Header: Image Parallax 1',1490606859,1,1,1),

(12,12,'en','Header: Image Parallax 2',1482963950,1,1,1),

(13,13,'en','Header: Image Parallax 3',1490606892,1,1,1),

(14,14,'en','Header: Image Parallax 4',1490606932,1,1,1),

(15,15,'en','Header: Image Parallax 5',1490607011,1,1,1),

(16,16,'en','Header: Fullwidth Image',1484854352,1,1,1),

(17,17,'en','Header: Text Rotator',1484854485,1,1,1),

(18,18,'en','Header: Slider Fullscreen',1490606559,1,1,1),

(19,19,'en','Header: Slider Zoom Effect',1490606510,1,1,1),

(20,20,'en','Header: Slider Fullwidth',1490606781,1,1,1),

(21,21,'en','Header: Slider Background',1484857328,1,1,1),

(22,22,'en','Header: With Play Button',1484857439,1,1,1),

(23,23,'en','Header: BG Video Fullwidth',1484859734,1,1,1),

(24,24,'en','Header: BG Video FullScreen 1',1484859837,1,1,1),

(25,25,'en','Header: BG Video FullScreen 2',1484859916,1,1,1),

(26,26,'en','Header: Agency Header',1484860214,1,1,1),

(27,27,'en','Header: Special Photography',1484912025,1,1,1),

(28,28,'en','Header: Main Demo - OnePage',1484927756,1,1,1),

(29,29,'en','Header: Image Parallax 1 - OnePage',1485000575,1,1,1),

(30,30,'en','Header: Image Parallax 2 - Onepage',1485020663,1,1,1),

(31,31,'en','Header: Image Parallax 3 - OnePage',1485020723,1,1,1),

(32,32,'en','Header: Image Parallax 4 - OnePage',1485020757,1,1,1),

(33,33,'en','Header: Image Parallax 5 - OnePage',1485021038,1,1,1),

(34,34,'en','Header: Fullwidth Image - OnePage',1485021130,1,1,1),

(35,35,'en','Header: Text Rotator - OnePage',1485021224,1,1,1),

(36,36,'en','Header: Slider Fullscreen - OnePage',1485021263,1,1,1),

(37,37,'en','Header: Slider Zoom Effect - OnePage',1485021336,1,1,1),

(38,38,'en','Header: Slider Fullwidth - OnePage',1485021376,1,1,1),

(39,39,'en','Header: Slider Background - OnePage',1485021416,1,1,1),

(40,40,'en','Header: With Play Button - OnePage',1485021465,1,1,1),

(41,41,'en','Header: BG Video Fullwidth - OnePage',1485021523,1,1,1),

(42,42,'en','Header: BG Video FullScreen 1 - OnePage',1485211474,1,1,1),

(43,43,'en','Header: BG Video FullScreen 2 - OnePage',1485211544,1,1,1),

(44,44,'en','Header: Special Photography - OnePage',1485211804,1,1,1),

(45,45,'en','Text Widget',1503569219,1,1,1),

(46,46,'en','Shop 4 Columns',1503664741,1,1,1);

/*Table structure for table `block_content_revision` */

DROP TABLE IF EXISTS `block_content_revision`;

CREATE TABLE `block_content_revision` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `revision_log` longtext,
  `revision_created` int(11) DEFAULT NULL,
  `revision_user` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `revision_default` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`revision_id`),
  KEY `block_content_field__revision_user__target_id` (`revision_user`),
  KEY `block_content__id` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=47 DEFAULT CHARSET=utf8mb4 COMMENT='The revision table for block_content entities.';

/*Data for the table `block_content_revision` */

insert  into `block_content_revision`(`id`,`revision_id`,`langcode`,`revision_log`,`revision_created`,`revision_user`,`revision_default`) values 

(1,1,'en',NULL,1480872202,1,1),

(2,2,'en',NULL,1480889282,1,1),

(3,3,'en',NULL,1480889803,1,1),

(4,4,'en',NULL,1480942315,1,1),

(5,5,'en',NULL,1480942697,NULL,1),

(6,6,'en',NULL,1481212870,NULL,1),

(7,7,'en',NULL,1481213252,NULL,1),

(8,8,'en',NULL,1481648399,1,1),

(9,9,'en',NULL,1481648537,NULL,1),

(10,10,'en',NULL,1481654951,NULL,1),

(11,11,'en',NULL,1482963576,NULL,1),

(12,12,'en',NULL,1482963714,NULL,1),

(13,13,'en',NULL,1484852856,1,1),

(14,14,'en',NULL,1484853081,1,1),

(15,15,'en',NULL,1484854191,1,1),

(16,16,'en',NULL,1484854352,1,1),

(17,17,'en',NULL,1484854485,1,1),

(18,18,'en',NULL,1484854598,1,1),

(19,19,'en',NULL,1484854697,1,1),

(20,20,'en',NULL,1484856893,1,1),

(21,21,'en',NULL,1484857328,1,1),

(22,22,'en',NULL,1484857439,1,1),

(23,23,'en',NULL,1484859734,1,1),

(24,24,'en',NULL,1484859837,1,1),

(25,25,'en',NULL,1484859916,1,1),

(26,26,'en',NULL,1484860214,1,1),

(27,27,'en',NULL,1484911911,1,1),

(28,28,'en',NULL,1484927756,1,1),

(29,29,'en',NULL,1485000575,1,1),

(30,30,'en',NULL,1485020663,1,1),

(31,31,'en',NULL,1485020723,1,1),

(32,32,'en',NULL,1485020757,1,1),

(33,33,'en',NULL,1485021038,1,1),

(34,34,'en',NULL,1485021130,1,1),

(35,35,'en',NULL,1485021224,1,1),

(36,36,'en',NULL,1485021263,1,1),

(37,37,'en',NULL,1485021336,1,1),

(38,38,'en',NULL,1485021376,1,1),

(39,39,'en',NULL,1485021416,1,1),

(40,40,'en',NULL,1485021465,1,1),

(41,41,'en',NULL,1485021523,1,1),

(42,42,'en',NULL,1485211474,1,1),

(43,43,'en',NULL,1485211544,1,1),

(44,44,'en',NULL,1485211804,1,1),

(45,45,'en',NULL,1503569219,NULL,1),

(46,46,'en',NULL,1503578636,NULL,1);

/*Table structure for table `block_content_revision__body` */

DROP TABLE IF EXISTS `block_content_revision__body`;

CREATE TABLE `block_content_revision__body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext NOT NULL,
  `body_summary` longtext,
  `body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for block_content field body.';

/*Data for the table `block_content_revision__body` */

insert  into `block_content_revision__body`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`body_value`,`body_summary`,`body_format`) values 

('basic',0,1,1,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"0\" different_values=\"0\" search=\"1\" cart=\"1\" language=\"1\"]\r\n[/nd_menu]\r\n[nd_header type=\"bg-gray-lighter\" breadcrumbs=\"1\" description=\"LOREM IPSUM DOLOR SIT AMET CONSECTETUR\" different_values=\"0\" size=\"small-section\"]\r\n[/nd_header]\r\n ','','dynamic_shortcodes'),

('basic',0,2,2,'en',0,'[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" style_padding_bottom=\"60\" style_padding_top=\"140\"]\r\n[nd_container text_align=\"center\" different_values=\"0\"]\r\n[nd_div different_values=\"0\" style_margin_bottom=\"30\" animation=\"fadeInUp\"]\r\n[nd_image fid=\"22\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" width=\"78\" height=\"30\"]\r\n[/nd_image]\r\n[/nd_div]\r\n[nd_icon icon=\"fa fa-facebook\" boxed=\"0\" different_values=\"0\" link=\"https://www.facebook.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[nd_icon icon=\"fa fa-twitter\" boxed=\"0\" different_values=\"0\" link=\"https://www.twitter.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[nd_icon icon=\"fa fa-behance\" boxed=\"0\" different_values=\"0\" link=\"https://www.twitter.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[nd_icon icon=\"fa fa-linkedin\" boxed=\"0\" different_values=\"0\" link=\"https://www.twitter.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[nd_icon icon=\"fa fa-pinterest\" boxed=\"0\" different_values=\"0\" link=\"https://www.twitter.com/nikadevs\" type=\"Bordered\"]\r\n[/nd_icon]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" style_padding_top=\"110\"]<div class=\"footer-text footer\"><div class=\"footer-copy font-alt\">		<a href=\"http://themeforest.net/user/NikaDevs/portfolio\" target=\"_blank\">© Rhythm 2016</a>.</div><div class=\"footer-made\">		Made with love for great people.</div></div>[/html]\r\n[/nd_container]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,3,3,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" different_values=\"0\" search=\"1\" cart=\"0\" language=\"1\"]\r\n[/nd_menu]\r\n[nd_header fid=\"3\" type=\"bg-dark-alfa-50\" breadcrumbs=\"1\" description=\"LOREM IPSUM DOLOR SIT AMET CONSECTETUR\" different_values=\"0\" size=\"home-section parallax-2 fixed-height-small\"]\r\n[/nd_header]\r\n ','','shortcodes'),

('basic',0,4,4,'en',0,'[nd_menu menu=\"main\" fid = \"24\" type=\"white\" transparent=\"0\" different_values=\"0\" search=\"1\" cart=\"0\" language=\"1\"]\r\n[/nd_menu]\r\n[nd_header type=\"bg-gray-lighter\" breadcrumbs=\"1\" description=\"LOREM IPSUM DOLOR SIT AMET CONSECTETUR\" different_values=\"0\" size=\"small-section\"]\r\n[/nd_header]\r\n ','','shortcodes'),

('basic',0,5,5,'en',0,'[nd_menu menu=\"main-menu\" type=\"white\" transparent=\"1\" different_values=\"0\" fid=\"24\" search=\"1\" cart=\"0\" language=\"1\"]\r\n[/nd_menu]\r\n[nd_header fid=\"25\" type=\"bg-light-alfa-30\" breadcrumbs=\"1\" description=\"LOREM IPSUM DOLOR SIT AMET CONSECTETUR\" different_values=\"0\" size=\"home-section parallax-2 fixed-height-small\"]\r\n[/nd_header]\r\n ','','shortcodes'),

('basic',0,6,6,'en',0,'[html style_padding_top = \"140\"]<h4 class=\"font-alt mb-sm-40 mb-70 section-title \">Related Projects</h4>[/html]\r\n[nd_block admin_url = \"admin/structure/block/manage/views_block__related_projects_block_1\" style_padding_bottom = \"60\"][/nd_block]','','shortcodes'),

('basic',0,7,7,'en',0,'[nd_bg color=\"bg-dark\" slider=\"0\" banner=\"0\" different_values=\"0\" text_align=\"center\" style_padding_top=\"60\" style_padding_bottom=\"60\"]\r\n[nd_title title=\"Want to work with us?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" weight=\"fw-300\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"JOIN NOW\" link=\"http://rhythm.nikadevs.com\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,8,8,'en',0,'[nd_gmap type=\"roadmap\" overlay=\"1\" address=\"Belt Parkway, Queens, NY, United States\" different_values=\"0\"]\r\n[/nd_gmap]\r\n ','','shortcodes'),

('basic',0,9,9,'en',0,'[nd_gmap type=\"roadmap\" overlay=\"0\" address=\"Belt Parkway, Queens, NY, United States\" different_values=\"0\"]\r\n[/nd_gmap]\r\n ','','shortcodes'),

('basic',0,10,10,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"43\" full_height=\"1\" scroll_icon=\"1\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\"]\r\n[nd_title title=\"THOMAS RHYTHM\" size=\"h1_big\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"80\"]\r\n[/nd_title]\r\n[nd_title title=\"Extraordinary art studio &amp; creative minimalism lovers\" size=\"h6_big\" alignment=\" align-center\" styled=\"0\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,11,11,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-90\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"58\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,12,12,'en',0,'[nd_menu menu=\"main\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\" fid = \"24\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"25\" full_height=\"1\" scroll_icon=\"1\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,13,13,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"56\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,14,14,'en',0,'[nd_menu menu=\"main\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\" fid=\"24\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"60\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"WE LOVE DESIGN\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,15,15,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"61\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,16,16,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"3\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,17,17,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[nd_text_rotator text=\"Rhythm Creative Studio,We Have Magic Skills,We Love Smart Design\" different_values=\"0\" text_line_1=\"Rhythm Creative Studio\" op=\"Add new row\" text_line_2=\"We Have Magic Skills\" text_line_3=\"We Love Smart Design\"]\r\n[/nd_text_rotator]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,18,18,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth\" different_values=\"0\" slide_autoplay=\"3000\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"56\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"55\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,19,19,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth-zoom\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"55\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"56\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,20,20,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth\" different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-90\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"58\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"56\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"amazing design\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"59\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"rhythm creative studio\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,21,21,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth-bg\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" fid=\"56\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,22,22,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_icon icon=\"fa fa-play\" size=\"32\" boxed=\"0\" link=\"http://vimeo.com/50201327\" type=\"Big Icon\" different_values=\"0\"]\r\n[/nd_icon]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,23,23,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"0\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,24,24,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-pattern-over\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,25,25,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-pattern-over\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[nd_text_rotator text_line_1=\"RHYTHM CREATIVE STUDIO\" text_line_2=\"WE HAVE MAGIC SKILLS\" text_line_3=\"WE LOVE SMART DESIGN\" op=\"Add new row\" different_values=\"0\"]\r\n[/nd_text_rotator]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,26,26,'en',0,'[nd_menu menu=\"main\" type=\"white\" transparent=\"0\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\" style_padding_top=\"140\" style_padding_bottom=\"140\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[nd_view admin_url=\"admin/structure/views/view/portfolio_boxed/edit/page_6\" different_values=\"0\"]\r\n[/nd_view]\r\n[nd_bg color=\"bg-dark\" slider=\"0\" banner=\"0\" different_values=\"0\" text_align=\"center\" style_padding_top=\"60\" style_padding_bottom=\"60\"]\r\n[nd_title title=\"LIKE OUR CREATIVE WORKS?\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"start project\" link=\"http://rhythm.nikadevs.com\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,27,27,'en',0,'[nd_menu menu_type=\"popup_menu\" menu=\"main\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"0\" language=\"0\" different_values=\"0\" extra_classes=\"small-logo\" fid=\"67\"]\r\n[/nd_menu]\r\n[nd_slider different_values=\"0\" slide_anim=\"images_pager\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"58\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"59\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"60\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"61\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"62\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"63\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"64\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"95\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"65\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"66\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[nd_view admin_url=\"/admin/structure/views/view/gallery/edit/page_2\" different_values=\"0\"]\r\n[/nd_view]\r\n ','','shortcodes'),

('basic',0,28,28,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"43\" full_height=\"1\" scroll_icon=\"1\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\"]\r\n[nd_title title=\"THOMAS RHYTHM\" size=\"h1_big\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"80\"]\r\n[/nd_title]\r\n[nd_title title=\"Extraordinary art studio &amp; creative minimalism lovers\" size=\"h6_big\" alignment=\" align-center\" styled=\"0\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,29,29,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-90\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"42\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,30,30,'en',0,'[nd_menu menu=\"one-page\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"25\" full_height=\"1\" scroll_icon=\"1\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,31,31,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"52\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,32,32,'en',0,'[nd_menu menu=\"one-page\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"53\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"WE LOVE DESIGN\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"black\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,33,33,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"52\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,34,34,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"3\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,35,35,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"1\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[nd_text_rotator text=\"Rhythm Creative Studio,We Have Magic Skills,We Love Smart Design\" different_values=\"0\" text_line_1=\"Rhythm Creative Studio\" op=\"Add new row\" text_line_2=\"We Have Magic Skills\" text_line_3=\"We Love Smart Design\"]\r\n[/nd_text_rotator]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,36,36,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth\" different_values=\"0\" slide_autoplay=\"3000\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"55\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"52\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,37,37,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth-zoom\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"55\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"52\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,38,38,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth\" different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-90\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"42\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"41\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"amazing design\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"52\" full_height=\"0\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Hello &amp; Welcome\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"rhythm creative studio\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"circle\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,39,39,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_slider slide_anim=\"fullwidth-bg\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" fid=\"56\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-dark-alfa-30\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"54\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"UNIQUE EXPERIENCE WITH\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h2_64\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('basic',0,40,40,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" fid=\"57\" full_height=\"1\" scroll_icon=\"1\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_icon icon=\"fa fa-play\" size=\"32\" boxed=\"0\" link=\"http://vimeo.com/50201327\" type=\"Big Icon\" different_values=\"0\"]\r\n[/nd_icon]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,41,41,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-dark-alfa-50\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"0\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"BRANDING / DESIGN / DEVELOPMENT / PHOTO\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h2_42\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,42,42,'en',0,'[nd_menu menu=\"main\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-pattern-over\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title title=\"RHYTHM CREATIVE STUDIO\" size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,43,43,'en',0,'[nd_menu menu=\"one-page\" type=\"dark\" transparent=\"1\" search=\"1\" cart=\"1\" language=\"1\" different_values=\"0\"]\r\n[/nd_menu]\r\n[nd_bg color=\"bg-pattern-over\" slider=\"0\" banner=\"0\" different_values=\"0\" full_height=\"1\" scroll_icon=\"0\" video=\"http://youtu.be/I6jmZ5plZ3o\" fid=\"56\" video_sound=\"0\"]\r\n[nd_div vertical_align=\"1\" different_values=\"0\" text_align=\"center\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE ARE JUST CRATIVE PEOPLE\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"0\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_title size=\"h1_80\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" color=\"white\" style_margin_top=\"50\" style_margin_bottom=\"50\"]\r\n[nd_text_rotator text_line_1=\"RHYTHM CREATIVE STUDIO\" text_line_2=\"WE HAVE MAGIC SKILLS\" text_line_3=\"WE LOVE SMART DESIGN\" op=\"Add new row\" different_values=\"0\"]\r\n[/nd_text_rotator]\r\n[/nd_title]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"1\" style_margin_right=\"8\" different_values=\"0\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"PLAY REEL\" invert=\"1\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_container]\r\n[/nd_div]\r\n[/nd_bg]\r\n ','','shortcodes'),

('basic',0,44,44,'en',0,'[nd_menu menu_type=\"popup_menu\" menu=\"one-page\" type=\"white\" transparent=\"1\" search=\"1\" cart=\"0\" language=\"0\" different_values=\"0\" extra_classes=\"small-logo\"]\r\n[/nd_menu]\r\n[nd_slider different_values=\"0\" slide_anim=\"images_pager\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"58\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"59\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"60\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"61\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"62\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"63\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"64\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"95\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"65\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg fid=\"66\" slider=\"0\" banner=\"0\" full_height=\"1\" scroll_icon=\"0\" video_sound=\"0\" different_values=\"0\"]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[nd_view admin_url=\"/admin/structure/views/view/gallery/edit/page_2\" different_values=\"0\"]\r\n[/nd_view]\r\n ','','shortcodes'),

('basic',0,45,45,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"widget-body widget-text clearfix\"]<p><img alt=\"\" class=\"img-circle left img-left\" src=\"http://local.rhythm.nikadevs.com/sites/rhythm.nikadevs.com/files/user-avatar.png\" style=\"height: 70px; width: 70px; margin: 0px 10px 10px 0px;\">Consectetur adipiscing elit. Quisque magna ante eleifend eleifend. Purus ut dignissim consectetur, nulla erat ultrices purus, ut consequat sem elit non sem. Quisque magna ante eleifend eleifend.</p>[/html]\r\n','','shortcodes'),

('basic',0,46,46,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\" style=\"\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/cart\" different_values=\"0\"]\r\n[/nd_block]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\" style=\"\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/views_block__products_tags_block\" different_values=\"0\"]\r\n[/nd_block]\r\n[nd_block admin_url=\"admin/structure/block/manage/textwidget\" different_values=\"0\"]\r\n[/nd_block]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\" style=\"\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/views_block__shop_categories_block\" different_values=\"0\"]\r\n[/nd_block]\r\n[nd_block admin_url=\"admin/structure/block/manage/rhythmproductsfilter\" different_values=\"0\"]\r\n[/nd_block]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\" style=\"\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/views_block__products_best_sellers_block\" different_values=\"0\"]\r\n[/nd_block]\r\n[/col]\r\n[/row]\r\n ','','shortcodes');

/*Table structure for table `cache_bootstrap` */

DROP TABLE IF EXISTS `cache_bootstrap`;

CREATE TABLE `cache_bootstrap` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_bootstrap` */

/*Table structure for table `cache_config` */

DROP TABLE IF EXISTS `cache_config`;

CREATE TABLE `cache_config` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_config` */

/*Table structure for table `cache_container` */

DROP TABLE IF EXISTS `cache_container`;

CREATE TABLE `cache_container` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_container` */

/*Table structure for table `cache_data` */

DROP TABLE IF EXISTS `cache_data`;

CREATE TABLE `cache_data` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_data` */

/*Table structure for table `cache_default` */

DROP TABLE IF EXISTS `cache_default`;

CREATE TABLE `cache_default` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_default` */

/*Table structure for table `cache_discovery` */

DROP TABLE IF EXISTS `cache_discovery`;

CREATE TABLE `cache_discovery` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_discovery` */

/*Table structure for table `cache_entity` */

DROP TABLE IF EXISTS `cache_entity`;

CREATE TABLE `cache_entity` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_entity` */

/*Table structure for table `cache_menu` */

DROP TABLE IF EXISTS `cache_menu`;

CREATE TABLE `cache_menu` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_menu` */

/*Table structure for table `cache_render` */

DROP TABLE IF EXISTS `cache_render`;

CREATE TABLE `cache_render` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_render` */

/*Table structure for table `cache_rest` */

DROP TABLE IF EXISTS `cache_rest`;

CREATE TABLE `cache_rest` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_rest` */

/*Table structure for table `cache_toolbar` */

DROP TABLE IF EXISTS `cache_toolbar`;

CREATE TABLE `cache_toolbar` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';

/*Data for the table `cache_toolbar` */

/*Table structure for table `cachetags` */

DROP TABLE IF EXISTS `cachetags`;

CREATE TABLE `cachetags` (
  `tag` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Namespace-prefixed tag string.',
  `invalidations` int(11) NOT NULL DEFAULT '0' COMMENT 'Number incremented when the tag is invalidated.',
  PRIMARY KEY (`tag`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Cache table for tracking cache tag invalidations.';

/*Data for the table `cachetags` */

/*Table structure for table `comment` */

DROP TABLE IF EXISTS `comment`;

CREATE TABLE `comment` (
  `cid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `comment_type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`cid`),
  UNIQUE KEY `comment_field__uuid__value` (`uuid`),
  KEY `comment_field__comment_type__target_id` (`comment_type`)
) ENGINE=InnoDB AUTO_INCREMENT=26 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for comment entities.';

/*Data for the table `comment` */

insert  into `comment`(`cid`,`comment_type`,`uuid`,`langcode`) values 

(1,'comment','026e0579-f06a-4f0c-aa9d-05c191709191','en'),

(2,'comment','bb04c5ba-3389-4f96-9363-4453d89456c8','en'),

(3,'comment','a5f645ba-fe3d-4074-9e0e-986e0627132d','en'),

(4,'comment','b8c7e5fd-7ad4-459f-add4-5973b520f064','en'),

(5,'comment','3f83bc73-e63c-49ba-b4af-f381f442e75a','en'),

(6,'comment','bf5af66a-b1fc-48dd-aab9-ea02c9aa4a7b','en'),

(7,'default_reviews','5af77c2a-88e1-4a7f-9a64-0e81632295f3','en'),

(8,'default_reviews','114d1d34-2b93-4e8a-b343-57f7fbe70355','en'),

(9,'default_reviews','7ca3a7c1-0338-43e4-a74f-f13ff1112af2','en'),

(10,'comment','5d349538-7810-4b3e-89de-3cb8114d7455','en'),

(11,'comment','2e8ba2dd-2e52-4bee-9a78-9c58930c80d9','en'),

(12,'comment','2e5a39bb-f7e2-4fa9-a50a-5e7efc011d81','en'),

(13,'comment','e61033ad-fd44-4da6-9663-0f384a7f53cb','en'),

(14,'comment','021a8b6a-73b7-4fa9-96fa-d1464b01834a','en'),

(15,'comment','7bfcaa5f-c216-4929-8b48-ef22cee28dbf','en'),

(16,'comment','d527b1f1-4197-4e71-88f8-45000b322058','en'),

(17,'comment','4f7b38da-4722-440c-b5e3-6c24237fc266','en'),

(18,'comment','b645da32-9eb0-4f1e-8d7e-f1cf32c4441e','en'),

(19,'comment','96fa54b2-91d8-4f78-9ca2-1fa2b88e57d5','en'),

(20,'comment','1a8538b1-ba4d-43b8-806f-2b70e748d5f5','en'),

(21,'comment','dafb421e-a9e0-4b56-a6b2-3b749ae3f8f0','en'),

(22,'comment','a5e5a7be-ce8a-4ce3-b1b5-32859b9c893f','en'),

(23,'comment','4543deeb-d953-4053-8e55-68c798606078','en'),

(24,'comment','02e81ba6-9961-4e6d-bb03-63c661bfa4ae','en'),

(25,'comment','6d7c149b-cec0-4809-a9e3-080dc77c65af','en');

/*Table structure for table `comment__comment_body` */

DROP TABLE IF EXISTS `comment__comment_body`;

CREATE TABLE `comment__comment_body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext NOT NULL,
  `comment_body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for comment field comment_body.';

/*Data for the table `comment__comment_body` */

/*Table structure for table `comment__field_comment` */

DROP TABLE IF EXISTS `comment__field_comment`;

CREATE TABLE `comment__field_comment` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_comment_value` longtext NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for comment field field_comment.';

/*Data for the table `comment__field_comment` */

insert  into `comment__field_comment`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_comment_value`) values 

('comment',0,2,2,'en',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque at magna ut ante eleifend eleifend.'),

('comment',0,3,3,'en',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque at magna ut ante eleifend eleifend.'),

('comment',0,4,4,'en',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque at magna ut ante eleifend eleifend.'),

('comment',0,5,5,'en',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque at magna ut ante eleifend eleifend.'),

('comment',0,6,6,'en',0,'test'),

('default_reviews',0,7,7,'en',0,'Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.'),

('default_reviews',0,8,8,'en',0,'Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla.'),

('default_reviews',0,9,9,'en',0,'Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.'),

('comment',0,10,10,'en',0,'73vFsG http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('comment',0,11,11,'en',0,'w3kNHq http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('comment',0,12,12,'en',0,'2t2vdL http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('comment',0,13,13,'en',0,'lloQ6c http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('comment',0,14,14,'en',0,'TadEUe http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('comment',0,15,15,'en',0,'Y37lpd http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('comment',0,16,16,'en',0,'bCyNng http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('comment',0,17,17,'en',0,'uXygYG http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('comment',0,18,18,'en',0,'5v3bC1 http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('comment',0,19,19,'en',0,'NORbJs https://goldentabs.com/'),

('comment',0,20,20,'en',0,'VNw5QK  <a href=\"http://tsjalhvktpab.com/\">tsjalhvktpab</a>, [url=http://ysgyrcugsuky.com/]ysgyrcugsuky[/url], [link=http://dbixhomxbnlc.com/]dbixhomxbnlc[/link], http://ycribnctaeeh.com/'),

('comment',0,21,21,'en',0,'q698t2  <a href=\"http://uywrqxwlypfl.com/\">uywrqxwlypfl</a>, [url=http://deutublmophk.com/]deutublmophk[/url], [link=http://gmvsxzqcfpvf.com/]gmvsxzqcfpvf[/link], http://ymbhrafypzsp.com/'),

('comment',0,22,22,'en',0,'q698t2  <a href=\"http://uywrqxwlypfl.com/\">uywrqxwlypfl</a>, [url=http://deutublmophk.com/]deutublmophk[/url], [link=http://gmvsxzqcfpvf.com/]gmvsxzqcfpvf[/link], http://ymbhrafypzsp.com/'),

('comment',0,23,23,'en',0,'q698t2  <a href=\"http://uywrqxwlypfl.com/\">uywrqxwlypfl</a>, [url=http://deutublmophk.com/]deutublmophk[/url], [link=http://gmvsxzqcfpvf.com/]gmvsxzqcfpvf[/link], http://ymbhrafypzsp.com/'),

('comment',0,24,24,'en',0,'q698t2  <a href=\"http://uywrqxwlypfl.com/\">uywrqxwlypfl</a>, [url=http://deutublmophk.com/]deutublmophk[/url], [link=http://gmvsxzqcfpvf.com/]gmvsxzqcfpvf[/link], http://ymbhrafypzsp.com/'),

('comment',0,25,25,'en',0,'q698t2  <a href=\"http://uywrqxwlypfl.com/\">uywrqxwlypfl</a>, [url=http://deutublmophk.com/]deutublmophk[/url], [link=http://gmvsxzqcfpvf.com/]gmvsxzqcfpvf[/link], http://ymbhrafypzsp.com/');

/*Table structure for table `comment__field_email` */

DROP TABLE IF EXISTS `comment__field_email`;

CREATE TABLE `comment__field_email` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_email_value` varchar(254) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for comment field field_email.';

/*Data for the table `comment__field_email` */

insert  into `comment__field_email`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_email_value`) values 

('comment',0,2,2,'en',0,'aadsf@adf.com'),

('comment',0,6,6,'en',0,'test@gle.com'),

('default_reviews',0,7,7,'en',0,'dron.84.84@gmail.com'),

('default_reviews',0,8,8,'en',0,'dron.84.84@gmail.com'),

('default_reviews',0,9,9,'en',0,'dron.84.84@gmail.com');

/*Table structure for table `comment__field_rating` */

DROP TABLE IF EXISTS `comment__field_rating`;

CREATE TABLE `comment__field_rating` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_rating_rating` int(10) unsigned DEFAULT NULL,
  `field_rating_target` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for comment field field_rating.';

/*Data for the table `comment__field_rating` */

insert  into `comment__field_rating`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_rating_rating`,`field_rating_target`) values 

('default_reviews',0,7,7,'en',0,80,NULL),

('default_reviews',0,8,8,'en',0,100,NULL),

('default_reviews',0,9,9,'en',0,40,NULL);

/*Table structure for table `comment_entity_statistics` */

DROP TABLE IF EXISTS `comment_entity_statistics`;

CREATE TABLE `comment_entity_statistics` (
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The entity_id of the entity for which the statistics are compiled.',
  `entity_type` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT 'node' COMMENT 'The entity_type of the entity to which this comment is a reply.',
  `field_name` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field_name of the field that was used to add this comment.',
  `cid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid of the last comment.',
  `last_comment_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the last comment that was posted within this node, from comment.changed.',
  `last_comment_name` varchar(60) DEFAULT NULL COMMENT 'The name of the latest author to post a comment on this node, from comment.name.',
  `last_comment_uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The user ID of the latest author to post a comment on this node, from comment.uid.',
  `comment_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of comments on this entity.',
  PRIMARY KEY (`entity_id`,`entity_type`,`field_name`),
  KEY `last_comment_timestamp` (`last_comment_timestamp`),
  KEY `comment_count` (`comment_count`),
  KEY `last_comment_uid` (`last_comment_uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Maintains statistics of entity and comments posts to show …';

/*Data for the table `comment_entity_statistics` */

insert  into `comment_entity_statistics`(`entity_id`,`entity_type`,`field_name`,`cid`,`last_comment_timestamp`,`last_comment_name`,`last_comment_uid`,`comment_count`) values 

(3,'node','field_comments',1,1480029712,'',1,1),

(4,'commerce_product','field_reviews',9,1503423895,'',1,3),

(4,'node','field_comments',0,1480286158,'',1,0),

(5,'node','field_comments',0,1480286424,'',1,0),

(6,'node','field_comments',5,1480342612,'',1,4),

(7,'node','field_comments',0,1480287497,NULL,1,0),

(8,'node','field_comments',0,1480288187,NULL,1,0),

(9,'node','field_comments',0,1480288235,NULL,1,0);

/*Table structure for table `comment_field_data` */

DROP TABLE IF EXISTS `comment_field_data`;

CREATE TABLE `comment_field_data` (
  `cid` int(10) unsigned NOT NULL,
  `comment_type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `pid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `entity_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `subject` varchar(64) DEFAULT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `name` varchar(60) DEFAULT NULL,
  `mail` varchar(254) DEFAULT NULL,
  `homepage` varchar(255) DEFAULT NULL,
  `hostname` varchar(128) DEFAULT NULL,
  `created` int(11) NOT NULL,
  `changed` int(11) DEFAULT NULL,
  `status` tinyint(4) NOT NULL,
  `thread` varchar(255) NOT NULL,
  `entity_type` varchar(32) CHARACTER SET ascii NOT NULL,
  `field_name` varchar(32) CHARACTER SET ascii NOT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`cid`,`langcode`),
  KEY `comment_field__comment_type__target_id` (`comment_type`),
  KEY `comment_field__created` (`created`),
  KEY `comment__id__default_langcode__langcode` (`cid`,`default_langcode`,`langcode`),
  KEY `comment__status_comment_type` (`status`,`comment_type`,`cid`),
  KEY `comment__status_pid` (`pid`,`status`),
  KEY `comment__num_new` (`entity_id`,`entity_type`,`comment_type`,`status`,`created`,`cid`,`thread`(191)),
  KEY `comment__entity_langcode` (`entity_id`,`entity_type`,`comment_type`,`default_langcode`),
  KEY `comment_field__uid__target_id` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for comment entities.';

/*Data for the table `comment_field_data` */

insert  into `comment_field_data`(`cid`,`comment_type`,`langcode`,`pid`,`entity_id`,`subject`,`uid`,`name`,`mail`,`homepage`,`hostname`,`created`,`changed`,`status`,`thread`,`entity_type`,`field_name`,`default_langcode`) values 

(1,'comment','en',NULL,3,'Morbi lacus massa, euismod…',1,'Admin',NULL,NULL,'127.0.0.1',1480029712,1480029712,1,'01/','node','field_comments',1),

(2,'comment','en',NULL,6,'Hello',1,'Admin',NULL,NULL,'127.0.0.1',1480327384,1480327384,1,'01/','node','field_comments',1),

(3,'comment','en',2,6,'(No subject)',1,'Admin',NULL,NULL,'127.0.0.1',1480342151,1480342151,1,'01.00/','node','field_comments',1),

(4,'comment','en',NULL,6,'(No subject)',1,'Admin',NULL,NULL,'127.0.0.1',1480342607,1480342607,1,'02/','node','field_comments',1),

(5,'comment','en',NULL,6,'(No subject)',1,'Admin',NULL,NULL,'127.0.0.1',1480342612,1480342612,1,'03/','node','field_comments',1),

(6,'comment','en',NULL,6,'test',0,'test',NULL,NULL,'188.188.86.224',1500822777,1500822777,0,'04/','node','field_comments',1),

(7,'default_reviews','en',NULL,4,'(No subject)',1,'Admin',NULL,NULL,'127.0.0.1',1503419269,1503419269,1,'01/','commerce_product','field_reviews',1),

(8,'default_reviews','en',NULL,4,'(No subject)',1,'Admin',NULL,NULL,'127.0.0.1',1503419571,1503419571,1,'02/','commerce_product','field_reviews',1),

(9,'default_reviews','en',NULL,4,'Answer',1,'Admin',NULL,NULL,'127.0.0.1',1503423895,1503423895,1,'03/','commerce_product','field_reviews',1),

(10,'comment','en',NULL,6,'JZVCmsvaJBVxJL',0,'JimmiNil',NULL,NULL,'5.188.211.15',1511779940,1511779940,0,'05/','node','field_comments',1),

(11,'comment','en',NULL,5,'AbudCaOCOWM',0,'JimmiNil',NULL,NULL,'5.188.211.10',1511816447,1511816447,0,'01/','node','field_comments',1),

(12,'comment','en',NULL,5,'mSrlrsRTfDf',0,'JimmiNil',NULL,NULL,'5.188.211.10',1511816875,1511816875,0,'02/','node','field_comments',1),

(13,'comment','en',NULL,5,'LsdnYotJkmptXTSb',0,'JimmiNil',NULL,NULL,'5.188.211.14',1511817229,1511817229,0,'03/','node','field_comments',1),

(14,'comment','en',NULL,4,'DyqaKiMGQkNliE',0,'JimmiNil',NULL,NULL,'5.188.211.26',1511820336,1511820336,0,'01/','node','field_comments',1),

(15,'comment','en',NULL,4,'xaZguXpTus',0,'JimmiNil',NULL,NULL,'5.188.211.35',1511820512,1511820512,0,'02/','node','field_comments',1),

(16,'comment','en',NULL,4,'knYVceBskU',0,'JimmiNil',NULL,NULL,'5.188.211.10',1511825965,1511825965,0,'03/','node','field_comments',1),

(17,'comment','en',NULL,5,'EiXaovODucbDhLenDlY',0,'JimmiNil',NULL,NULL,'5.188.211.10',1511826055,1511826055,0,'04/','node','field_comments',1),

(18,'comment','en',NULL,3,'LqnippmLYSorPqTy',0,'JimmiNil',NULL,NULL,'5.188.211.16',1511846889,1511846889,0,'02/','node','field_comments',1),

(19,'comment','en',NULL,5,'hHIvnfiRyTI',0,'goldentabscom',NULL,NULL,'47.89.18.250',1513295985,1513295985,0,'05/','node','field_comments',1),

(20,'comment','en',NULL,5,'vaNJKBUPML',0,'tknmdogcx',NULL,NULL,'119.28.70.95',1520018376,1520018376,0,'06/','node','field_comments',1),

(21,'comment','en',NULL,5,'euElSmNnJCyJ',0,'otawer',NULL,NULL,'184.0.128.55',1520197616,1520197616,0,'07/','node','field_comments',1),

(22,'comment','en',NULL,5,'euElSmNnJCyJ',0,'otawer',NULL,NULL,'177.140.153.32',1520197618,1520197618,0,'08/','node','field_comments',1),

(23,'comment','en',NULL,5,'euElSmNnJCyJ',0,'otawer',NULL,NULL,'184.0.78.175',1520197620,1520197620,0,'09/','node','field_comments',1),

(24,'comment','en',NULL,5,'euElSmNnJCyJ',0,'otawer',NULL,NULL,'72.161.0.129',1520197622,1520197622,0,'0a/','node','field_comments',1),

(25,'comment','en',NULL,5,'euElSmNnJCyJ',0,'otawer',NULL,NULL,'99.195.12.103',1520197624,1520197624,0,'0b/','node','field_comments',1);

/*Table structure for table `commerce_log` */

DROP TABLE IF EXISTS `commerce_log`;

CREATE TABLE `commerce_log` (
  `log_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `uid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `template_id` varchar(255) DEFAULT NULL,
  `category_id` varchar(255) DEFAULT NULL,
  `source_entity_id` int(11) DEFAULT NULL,
  `source_entity_type` varchar(255) DEFAULT NULL,
  `params` longblob,
  `created` int(11) DEFAULT NULL,
  PRIMARY KEY (`log_id`),
  UNIQUE KEY `commerce_log_field__uuid__value` (`uuid`),
  KEY `commerce_log_field__uid__target_id` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=52 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_log entities.';

/*Data for the table `commerce_log` */

insert  into `commerce_log`(`log_id`,`uuid`,`uid`,`template_id`,`category_id`,`source_entity_id`,`source_entity_type`,`params`,`created`) values 

(1,'953310f9-a6ab-4bc4-84cd-02f7a85bf8f2',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1503408306),

(2,'218956cb-d146-4e39-8588-7a3e17b0cf07',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:30:\"Polo Shirt With Floral Sleeves\";}',1503478271),

(3,'a8a4f1f2-1abb-4baa-a4ba-a998917b491a',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:41:\"Polo Shirt With Floral Sleeves - Pink, XL\";}',1503482411),

(4,'4844c600-b323-4f6f-8402-ea4a24d273fa',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1503482439),

(5,'5f26d928-891d-4752-a1bf-da537498b5c8',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1503483785),

(6,'b59f00be-6881-4c94-84cd-a4b0a690a2ad',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:37:\"Only & Sons Pique Polo Shirt - Red, S\";}',1503485261),

(7,'f7d54e0c-3ecf-4408-a455-f8b85349af1f',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503485351),

(8,'2a1cdaa8-a84c-449c-89d9-735033c43a9a',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:37:\"Only & Sons Pique Polo Shirt - Red, S\";}',1503485376),

(9,'a6145863-71fb-4bf9-834e-203de2d25db4',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503509912),

(10,'c461e47c-e239-4810-a3a6-3be01ddd747a',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1503528712),

(11,'5a24eec8-dd8d-49b7-9c11-5ca1d205504d',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503528964),

(12,'cb361e20-49c4-4d06-83e4-9bdc6a7bc8e8',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503529024),

(13,'ebbb2367-349b-43f6-b536-805a331f0084',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503529044),

(14,'1f49bd81-0a05-4144-8ca1-f967ffca8860',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:37:\"Only & Sons Pique Polo Shirt - Red, S\";}',1503529224),

(15,'21554faa-814f-4723-8df5-f1e54b49aaa7',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:37:\"Only & Sons Pique Polo Shirt - Red, S\";}',1503529263),

(16,'0ec1761b-9283-41f5-8f4a-eb2edbf3d7dd',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:41:\"Polo Shirt With Floral Sleeves - Pink, XL\";}',1503529312),

(17,'c991b899-555a-4525-8412-fa45ac3d853a',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:37:\"Only & Sons Pique Polo Shirt - Red, S\";}',1503529381),

(18,'b937c143-c85d-41a5-92d4-0a2ecd5863d1',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503530099),

(19,'621f5204-edd2-4ec7-93e3-1773a57de539',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503573854),

(20,'75a876e3-bd9d-42e4-9c92-085967691152',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503573951),

(21,'2056427b-a75f-4b66-a866-3a68e3fd6c56',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503574606),

(22,'71011d4a-8f1a-4d93-9b2a-ed289bbd18e6',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503574653),

(23,'55356187-4952-40c5-8c29-db71b403ade4',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503574699),

(24,'e969a3f2-9655-4e0f-97db-e9bf5edde11d',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503574792),

(25,'c6ebe6a9-80bf-46d6-92bd-3bad0c7be8e1',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503598173),

(26,'7bf142e0-3b33-4b12-931e-f2a881f5ad88',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1503598246),

(27,'f47dc251-4c12-492f-a9e6-03538391df6c',1,'cart_entity_added','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503680889),

(28,'3d17470c-bddc-4b74-acdc-0a673f4ee5fa',1,'cart_item_removed','commerce_cart',1,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503681063),

(29,'a3eebdff-1977-4765-8a51-ad33a9632653',0,'cart_entity_added','commerce_cart',2,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1503930086),

(30,'5b7671bd-f131-4fde-beac-cbabb368195a',0,'cart_entity_added','commerce_cart',3,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:41:\"Polo Shirt With Floral Sleeves - Pink, XL\";}',1504004672),

(31,'6fac0496-0436-45bd-ac49-657d266df5f6',0,'cart_entity_added','commerce_cart',4,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1504286272),

(32,'1b908ea8-345b-49b3-bc5c-f05100ff0a4b',0,'cart_entity_added','commerce_cart',4,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:41:\"Polo Shirt With Floral Sleeves - Pink, XL\";}',1504361092),

(33,'9a1afe85-c4e6-44d9-8a04-7212a8131fdc',0,'cart_entity_added','commerce_cart',5,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1504515400),

(34,'bbc9f073-8f6e-4aa8-be7c-c5de9a48e53b',0,'cart_entity_added','commerce_cart',6,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:41:\"Polo Shirt With Floral Sleeves - Pink, XL\";}',1505051241),

(35,'37a14595-8cb8-43c4-a754-c72e4caee482',0,'cart_entity_added','commerce_cart',6,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:37:\"Only & Sons Pique Polo Shirt - Red, S\";}',1505057662),

(36,'04ae25ce-0cd6-4bc3-a110-f38832e7aaa7',0,'cart_entity_added','commerce_cart',7,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1505198359),

(37,'554cf999-46bb-4d4f-b0ec-566e9016e8f8',0,'cart_entity_added','commerce_cart',8,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1505330083),

(38,'ea732674-9111-49ed-94e6-b057b835a3f8',0,'cart_entity_added','commerce_cart',9,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1509031917),

(39,'77fce239-627d-490f-8164-e24c4934c349',0,'cart_entity_added','commerce_cart',10,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"G-Star Polo Applique Jersey - Green, M\";}',1510499193),

(40,'5062e62f-741f-4570-b79b-a740d7150938',0,'cart_entity_added','commerce_cart',11,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1510826949),

(41,'e193860a-ee54-436d-af62-2533d840812d',0,'cart_entity_added','commerce_cart',12,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1511523233),

(42,'78997a77-7742-46f5-a5be-c332e64489a0',0,'order_placed','commerce_order',12,'commerce_order','a:0:{}',1511523419),

(43,'34de4987-7950-468a-b44f-7cb802161920',0,'cart_entity_added','commerce_cart',13,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:38:\"Religion Jersey Polo Shirts - White, L\";}',1512075944),

(44,'0c4b100f-260d-42ad-9e5b-66bcf28db530',0,'cart_entity_added','commerce_cart',14,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:41:\"Polo Shirt With Floral Sleeves - Pink, XL\";}',1512283806),

(45,'9ad91319-42e7-4f8b-b346-611a92afd07f',0,'cart_entity_added','commerce_cart',15,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1512477030),

(46,'f2137484-5169-450a-a13a-f5e206d88ba4',0,'cart_entity_added','commerce_cart',13,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1512905550),

(47,'5e2097e7-dfb5-4233-979b-5151250c713e',0,'cart_entity_added','commerce_cart',16,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:37:\"Only & Sons Pique Polo Shirt - Red, S\";}',1513700472),

(48,'6054be34-9e59-428c-801b-2bf864d87a7c',0,'cart_entity_added','commerce_cart',16,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1513700481),

(49,'6dcf362c-50cd-4d39-8ff7-d422e6745cb7',0,'cart_entity_added','commerce_cart',17,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:37:\"Only & Sons Pique Polo Shirt - Red, S\";}',1514454690),

(50,'2e960845-0f33-4c8f-bbc2-96b4f51714bb',0,'cart_entity_added','commerce_cart',18,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:41:\"Polo Shirt With Floral Sleeves - Pink, XL\";}',1515025534),

(51,'89492fa1-5266-4dfb-a7e9-509ee45917f4',0,'cart_entity_added','commerce_cart',19,'commerce_order','a:1:{s:22:\"purchased_entity_label\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}',1520273823);

/*Table structure for table `commerce_order` */

DROP TABLE IF EXISTS `commerce_order`;

CREATE TABLE `commerce_order` (
  `order_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `order_number` varchar(255) DEFAULT NULL,
  `store_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `uid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `mail` varchar(254) DEFAULT NULL,
  `ip_address` varchar(128) DEFAULT NULL,
  `billing_profile__target_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `billing_profile__target_revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The revision ID of the target entity.',
  `total_price__number` decimal(19,6) DEFAULT NULL COMMENT 'The number.',
  `total_price__currency_code` varchar(3) DEFAULT NULL COMMENT 'The currency code.',
  `state` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `data` longblob,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `placed` int(11) DEFAULT NULL,
  `completed` int(11) DEFAULT NULL,
  `cart` tinyint(4) DEFAULT NULL,
  `checkout_flow` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The ID of the target entity.',
  `checkout_step` varchar(255) DEFAULT NULL,
  `payment_gateway` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The ID of the target entity.',
  `locked` tinyint(4) DEFAULT NULL,
  `payment_method` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `total_paid__number` decimal(19,6) DEFAULT NULL COMMENT 'The number.',
  `total_paid__currency_code` varchar(3) DEFAULT NULL COMMENT 'The currency code.',
  PRIMARY KEY (`order_id`),
  UNIQUE KEY `commerce_order_field__uuid__value` (`uuid`),
  KEY `commerce_order_field__type__target_id` (`type`),
  KEY `commerce_order_field__store_id__target_id` (`store_id`),
  KEY `commerce_order_field__uid__target_id` (`uid`),
  KEY `commerce_order_field__billing_profile__target_id` (`billing_profile__target_id`),
  KEY `commerce_order__f8b17b71af` (`billing_profile__target_revision_id`),
  KEY `commerce_order_field__checkout_flow__target_id` (`checkout_flow`),
  KEY `commerce_order_field__payment_gateway__target_id` (`payment_gateway`),
  KEY `commerce_order_field__payment_method__target_id` (`payment_method`)
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_order entities.';

/*Data for the table `commerce_order` */

insert  into `commerce_order`(`order_id`,`type`,`uuid`,`order_number`,`store_id`,`uid`,`mail`,`ip_address`,`billing_profile__target_id`,`billing_profile__target_revision_id`,`total_price__number`,`total_price__currency_code`,`state`,`data`,`created`,`changed`,`placed`,`completed`,`cart`,`checkout_flow`,`checkout_step`,`payment_gateway`,`locked`,`payment_method`,`total_paid__number`,`total_paid__currency_code`) values 

(1,'default','9416e06c-6dad-438a-a7da-1c159236a657',NULL,1,1,'4elove4ekfs@gmail.com','127.0.0.1',1,1,111.980000,'USD','draft','a:1:{s:21:\"paid_event_dispatched\";b:0;}',1503408306,1570974794,NULL,NULL,1,'default',NULL,'payment_gateway_example',NULL,NULL,NULL,NULL),

(2,'default','1a5631be-164b-4aaa-8d1b-3bef9868c78f',NULL,1,0,NULL,'46.33.32.13',NULL,NULL,94.750000,'USD','draft','a:0:{}',1503930086,1503932146,NULL,NULL,1,'default',NULL,NULL,NULL,NULL,NULL,NULL),

(3,'default','2af07334-0b34-45c6-8f56-a6295a990e2d',NULL,1,0,NULL,'60.139.98.68',NULL,NULL,85.990000,'USD','draft','a:0:{}',1504004672,1504004672,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL),

(4,'default','a4f9cdf2-ca4b-4f9b-a2ec-e9a184c0442c',NULL,1,0,NULL,'114.4.82.96',NULL,NULL,111.980000,'USD','draft','a:0:{}',1504286272,1504517880,NULL,NULL,1,'default','order_information',NULL,NULL,NULL,NULL,NULL),

(5,'default','81d42031-e1d9-4cc9-89b8-a164c9b1d7d8',NULL,1,0,NULL,'101.78.201.78',NULL,NULL,94.750000,'USD','draft','a:0:{}',1504515400,1504515400,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL),

(6,'default','471386bd-841a-4974-bb8f-a78da90968ed',NULL,1,0,NULL,'2.138.254.145',NULL,NULL,114.980000,'USD','draft','a:0:{}',1505051241,1505057662,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL),

(7,'default','a69bca8c-379f-4a31-9774-508b89e8b7f9',NULL,1,0,NULL,'96.55.137.182',NULL,NULL,25.990000,'USD','draft','a:0:{}',1505198359,1505198359,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL),

(8,'default','5d222162-2be4-4264-bd11-ede83f7a55e3',NULL,1,0,NULL,'77.167.232.192',NULL,NULL,94.750000,'USD','draft','a:0:{}',1505330083,1505330097,NULL,NULL,1,'default','order_information',NULL,NULL,NULL,NULL,NULL),

(9,'default','2367e05d-38cd-40d8-b872-4fa0fc0ef933',NULL,1,0,NULL,'92.237.10.6',NULL,NULL,94.750000,'USD','draft','a:0:{}',1509031917,1510149426,NULL,NULL,1,'default',NULL,NULL,0,NULL,NULL,NULL),

(10,'default','7839f4ff-bb23-4ab4-91be-832199ada1e6',NULL,1,0,NULL,'88.188.153.70',NULL,NULL,94.750000,'USD','draft','a:0:{}',1510499193,1510503425,NULL,NULL,1,NULL,NULL,NULL,0,NULL,NULL,NULL),

(11,'default','87a5abf2-5897-457b-8865-487aa3c35dc5',NULL,1,0,NULL,'37.146.51.103',NULL,NULL,25.990000,'USD','draft','a:0:{}',1510826949,1510826949,NULL,NULL,1,NULL,NULL,NULL,0,NULL,NULL,NULL),

(12,'default','f74607a8-9c69-4b83-bdfb-d516f9ecb3af','12',1,0,'dfg@sdfg.gr','91.138.131.186',2,2,25.990000,'USD','completed','a:0:{}',1511523233,1511523419,1511523419,1511523419,0,'default','complete','payment_gateway_example',0,NULL,NULL,NULL),

(13,'default','d46bf8d0-0dc1-4e77-8844-8ae4e69fc701',NULL,1,0,NULL,'79.154.83.46',NULL,NULL,54.980000,'USD','draft','a:0:{}',1512075944,1512905551,NULL,NULL,1,NULL,NULL,NULL,0,NULL,NULL,NULL),

(14,'default','195c070e-5ea7-4a5c-ac3b-53a78c054552',NULL,1,0,NULL,'140.113.123.60',NULL,NULL,85.990000,'USD','draft','a:0:{}',1512283806,1512396931,NULL,NULL,1,NULL,NULL,NULL,0,NULL,NULL,NULL),

(15,'default','5b32ef72-5154-407c-9b48-4f75fdb8a6d0',NULL,1,0,NULL,'145.131.207.134',NULL,NULL,25.990000,'USD','draft','a:0:{}',1512477030,1512477057,NULL,NULL,1,'default','order_information',NULL,0,NULL,NULL,NULL),

(16,'default','77b4da01-1c45-4c09-a70d-8ccfbdeebba1',NULL,1,0,NULL,'81.45.174.92',NULL,NULL,54.980000,'USD','draft','a:0:{}',1513700472,1513701022,NULL,NULL,1,NULL,NULL,NULL,0,NULL,NULL,NULL),

(17,'default','870cd367-fcb7-40c8-b02b-555dbe729116',NULL,1,0,NULL,'176.24.77.94',NULL,NULL,28.990000,'USD','draft','a:0:{}',1514454690,1514454729,NULL,NULL,1,'default','order_information',NULL,0,NULL,NULL,NULL),

(18,'default','5df79ebd-9cf5-4ee2-802c-3244b2be3be3',NULL,1,0,NULL,'79.144.124.134',NULL,NULL,85.990000,'USD','draft','a:0:{}',1515025534,1515025535,NULL,NULL,1,NULL,NULL,NULL,0,NULL,NULL,NULL),

(19,'default','51cc1832-9665-461f-bca6-1e3948f063a8',NULL,1,0,NULL,'160.120.136.154',NULL,NULL,25.990000,'USD','draft','a:0:{}',1520273823,1520273824,NULL,NULL,1,NULL,NULL,NULL,0,NULL,NULL,NULL);

/*Table structure for table `commerce_order__adjustments` */

DROP TABLE IF EXISTS `commerce_order__adjustments`;

CREATE TABLE `commerce_order__adjustments` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `adjustments_value` blob NOT NULL COMMENT 'The adjustment value.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_order field adjustments.';

/*Data for the table `commerce_order__adjustments` */

/*Table structure for table `commerce_order__coupons` */

DROP TABLE IF EXISTS `commerce_order__coupons`;

CREATE TABLE `commerce_order__coupons` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `coupons_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `coupons_target_id` (`coupons_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_order field coupons.';

/*Data for the table `commerce_order__coupons` */

/*Table structure for table `commerce_order__order_items` */

DROP TABLE IF EXISTS `commerce_order__order_items`;

CREATE TABLE `commerce_order__order_items` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `order_items_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `order_items_target_id` (`order_items_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_order field order_items.';

/*Data for the table `commerce_order__order_items` */

insert  into `commerce_order__order_items`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`order_items_target_id`) values 

('default',0,1,1,'und',0,9),

('default',0,1,1,'und',1,11),

('default',0,2,2,'und',0,13),

('default',0,3,3,'und',0,14),

('default',0,4,4,'und',0,15),

('default',0,4,4,'und',1,16),

('default',0,5,5,'und',0,17),

('default',0,6,6,'und',0,18),

('default',0,6,6,'und',1,19),

('default',0,7,7,'und',0,20),

('default',0,8,8,'und',0,21),

('default',0,9,9,'und',0,22),

('default',0,10,10,'und',0,23),

('default',0,11,11,'und',0,24),

('default',0,12,12,'und',0,25),

('default',0,13,13,'und',0,26),

('default',0,13,13,'und',1,29),

('default',0,14,14,'und',0,27),

('default',0,15,15,'und',0,28),

('default',0,16,16,'und',0,30),

('default',0,16,16,'und',1,31),

('default',0,17,17,'und',0,32),

('default',0,18,18,'und',0,33),

('default',0,19,19,'und',0,34);

/*Table structure for table `commerce_order_item` */

DROP TABLE IF EXISTS `commerce_order_item`;

CREATE TABLE `commerce_order_item` (
  `order_item_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `order_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `purchased_entity` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `title` varchar(512) DEFAULT NULL,
  `quantity` decimal(10,2) DEFAULT NULL,
  `unit_price__number` decimal(19,6) DEFAULT NULL COMMENT 'The number.',
  `unit_price__currency_code` varchar(3) DEFAULT NULL COMMENT 'The currency code.',
  `total_price__number` decimal(19,6) DEFAULT NULL COMMENT 'The number.',
  `total_price__currency_code` varchar(3) DEFAULT NULL COMMENT 'The currency code.',
  `data` longblob,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `overridden_unit_price` tinyint(4) DEFAULT NULL,
  `uses_legacy_adjustments` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`order_item_id`),
  UNIQUE KEY `commerce_order_item_field__uuid__value` (`uuid`),
  KEY `commerce_order_item_field__type__target_id` (`type`),
  KEY `commerce_order_item_field__order_id__target_id` (`order_id`),
  KEY `commerce_order_item__ffa66b75a4` (`purchased_entity`)
) ENGINE=InnoDB AUTO_INCREMENT=35 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_order_item entities.';

/*Data for the table `commerce_order_item` */

insert  into `commerce_order_item`(`order_item_id`,`type`,`uuid`,`order_id`,`purchased_entity`,`title`,`quantity`,`unit_price__number`,`unit_price__currency_code`,`total_price__number`,`total_price__currency_code`,`data`,`created`,`changed`,`overridden_unit_price`,`uses_legacy_adjustments`) values 

(9,'default','4731c26d-0e5c-43ce-bb83-c4c23c94725f',1,2,'Polo Shirt With Floral Sleeves - Pink, XL',1.00,85.990000,'USD',85.990000,'USD','a:0:{}',1503529312,1534957243,0,0),

(11,'default','a4f48fe4-39a5-4244-a6d4-9d8523b76e93',1,4,'Religion Jersey Polo Shirts - Black, XL',1.00,25.990000,'USD',25.990000,'USD','a:0:{}',1503598246,1534957243,0,0),

(13,'default','d2f1be9e-d20b-4fb7-b9b9-5c3f4ee557b0',2,3,'G-Star Polo Applique Jersey - Green, M',1.00,94.750000,'USD',94.750000,'USD','a:0:{}',1503930086,1503932144,NULL,1),

(14,'default','9c329d9e-218d-4b8c-87d0-421b9e0a7411',3,2,'Polo Shirt With Floral Sleeves - Pink, XL',1.00,85.990000,'USD',85.990000,'USD','a:0:{}',1504004672,1504004672,NULL,1),

(15,'default','08131684-c83b-4b2d-9eca-ef8c31768b8a',4,4,'Religion Jersey Polo Shirts - Black, XL',1.00,25.990000,'USD',25.990000,'USD','a:0:{}',1504286272,1504517880,NULL,1),

(16,'default','c3e430b7-128b-462d-bef8-1c3b78478884',4,2,'Polo Shirt With Floral Sleeves - Pink, XL',1.00,85.990000,'USD',85.990000,'USD','a:0:{}',1504361092,1504517880,NULL,1),

(17,'default','381cacf4-0249-4034-8a39-a83841a0e8c7',5,3,'G-Star Polo Applique Jersey - Green, M',1.00,94.750000,'USD',94.750000,'USD','a:0:{}',1504515400,1504515400,NULL,1),

(18,'default','cd8bbf4e-1c00-4d0f-952b-ce9a703c671f',6,2,'Polo Shirt With Floral Sleeves - Pink, XL',1.00,85.990000,'USD',85.990000,'USD','a:0:{}',1505051241,1505057662,NULL,1),

(19,'default','a01abe68-dfba-4b06-871f-fcb26f6e9e6f',6,1,'Only & Sons Pique Polo Shirt - Red, S',1.00,28.990000,'USD',28.990000,'USD','a:0:{}',1505057662,1505057662,NULL,1),

(20,'default','2593076a-7118-4089-a36a-e0dfddbecbb3',7,4,'Religion Jersey Polo Shirts - Black, XL',1.00,25.990000,'USD',25.990000,'USD','a:0:{}',1505198359,1505198359,NULL,1),

(21,'default','c39dde2b-6c46-46d9-a82d-65969e6ca119',8,3,'G-Star Polo Applique Jersey - Green, M',1.00,94.750000,'USD',94.750000,'USD','a:0:{}',1505330083,1505330097,NULL,1),

(22,'default','e25365e4-d24e-46a7-9f10-fc33a5f1dedc',9,3,'G-Star Polo Applique Jersey - Green, M',1.00,94.750000,'USD',94.750000,'USD','a:0:{}',1509031917,1509031917,0,1),

(23,'default','7f5acc3a-16aa-4472-9299-9d51350e32ec',10,3,'G-Star Polo Applique Jersey - Green, M',1.00,94.750000,'USD',94.750000,'USD','a:0:{}',1510499193,1510499193,0,1),

(24,'default','9791f018-dacc-46e9-bc52-ba0962789dcb',11,4,'Religion Jersey Polo Shirts - Black, XL',1.00,25.990000,'USD',25.990000,'USD','a:0:{}',1510826931,1510826949,0,1),

(25,'default','fe4fdb1f-7fe9-4da4-a9c0-716a5350e9c8',12,4,'Religion Jersey Polo Shirts - Black, XL',1.00,25.990000,'USD',25.990000,'USD','a:0:{}',1511523233,1511523233,0,1),

(26,'default','2388c861-5703-4cf5-8325-bfdb8a958b1e',13,5,'Religion Jersey Polo Shirts - White, L',1.00,28.990000,'USD',28.990000,'USD','a:0:{}',1512075939,1512075944,0,1),

(27,'default','72520db7-381b-4c10-bd5f-fc2223226feb',14,2,'Polo Shirt With Floral Sleeves - Pink, XL',1.00,85.990000,'USD',85.990000,'USD','a:0:{}',1512283806,1512283806,0,1),

(28,'default','8897f6d1-38d6-46f0-a7d8-34b49e6f8972',15,4,'Religion Jersey Polo Shirts - Black, XL',1.00,25.990000,'USD',25.990000,'USD','a:0:{}',1512477030,1512477030,0,1),

(29,'default','8549d6af-8b3a-4250-a330-0f93bd0c54b7',13,4,'Religion Jersey Polo Shirts - Black, XL',1.00,25.990000,'USD',25.990000,'USD','a:0:{}',1512905550,1512905550,0,1),

(30,'default','0b7022e4-316a-438b-be1c-2fe6eaf90b90',16,1,'Only & Sons Pique Polo Shirt - Red, S',1.00,28.990000,'USD',28.990000,'USD','a:0:{}',1513700472,1513700472,0,1),

(31,'default','9c70255a-f6a8-404b-9060-b6191bb9c87f',16,4,'Religion Jersey Polo Shirts - Black, XL',1.00,25.990000,'USD',25.990000,'USD','a:0:{}',1513700481,1513700481,0,1),

(32,'default','aa37ef57-6cc7-40a9-acb9-f968c5fcc2ba',17,1,'Only & Sons Pique Polo Shirt - Red, S',1.00,28.990000,'USD',28.990000,'USD','a:0:{}',1514454690,1514454690,0,1),

(33,'default','cae886e2-fbae-4620-bd70-c9062ed9c583',18,2,'Polo Shirt With Floral Sleeves - Pink, XL',1.00,85.990000,'USD',85.990000,'USD','a:0:{}',1515025534,1515025534,0,1),

(34,'default','02c391a3-98e9-41b2-aca8-88933aa7efb6',19,4,'Religion Jersey Polo Shirts - Black, XL',1.00,25.990000,'USD',25.990000,'USD','a:0:{}',1520273823,1520273823,0,1);

/*Table structure for table `commerce_order_item__adjustments` */

DROP TABLE IF EXISTS `commerce_order_item__adjustments`;

CREATE TABLE `commerce_order_item__adjustments` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `adjustments_value` blob NOT NULL COMMENT 'The adjustment value.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_order_item field adjustments.';

/*Data for the table `commerce_order_item__adjustments` */

/*Table structure for table `commerce_payment` */

DROP TABLE IF EXISTS `commerce_payment`;

CREATE TABLE `commerce_payment` (
  `payment_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(255) NOT NULL,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `payment_gateway` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The ID of the target entity.',
  `payment_method` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `order_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `remote_id` varchar(255) DEFAULT NULL,
  `remote_state` varchar(255) DEFAULT NULL,
  `amount__number` decimal(19,6) DEFAULT NULL COMMENT 'The number.',
  `amount__currency_code` varchar(3) DEFAULT NULL COMMENT 'The currency code.',
  `refunded_amount__number` decimal(19,6) DEFAULT NULL COMMENT 'The number.',
  `refunded_amount__currency_code` varchar(3) DEFAULT NULL COMMENT 'The currency code.',
  `state` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `test` tinyint(4) DEFAULT NULL,
  `authorized` int(11) DEFAULT NULL,
  `captured` int(11) DEFAULT NULL,
  `payment_gateway_mode` varchar(255) DEFAULT NULL,
  `expires` int(11) DEFAULT NULL,
  `completed` int(11) DEFAULT NULL,
  PRIMARY KEY (`payment_id`),
  UNIQUE KEY `commerce_payment_field__uuid__value` (`uuid`),
  KEY `commerce_payment__e115249117` (`payment_gateway`),
  KEY `commerce_payment__9a4058fc21` (`payment_method`),
  KEY `commerce_payment_field__order_id__target_id` (`order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_payment entities.';

/*Data for the table `commerce_payment` */

insert  into `commerce_payment`(`payment_id`,`type`,`uuid`,`payment_gateway`,`payment_method`,`order_id`,`remote_id`,`remote_state`,`amount__number`,`amount__currency_code`,`refunded_amount__number`,`refunded_amount__currency_code`,`state`,`test`,`authorized`,`captured`,`payment_gateway_mode`,`expires`,`completed`) values 

(1,'payment_default','a6e4df03-a12b-42d0-a4c9-c9ac156baf01','payment_gateway_example',NULL,12,NULL,NULL,25.990000,'USD',0.000000,'USD','authorization',NULL,NULL,NULL,'test',0,NULL);

/*Table structure for table `commerce_payment_method` */

DROP TABLE IF EXISTS `commerce_payment_method`;

CREATE TABLE `commerce_payment_method` (
  `method_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(255) NOT NULL,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `payment_gateway` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The ID of the target entity.',
  `remote_id` varchar(255) DEFAULT NULL,
  `billing_profile__target_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `billing_profile__target_revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The revision ID of the target entity.',
  `reusable` tinyint(4) DEFAULT NULL,
  `is_default` tinyint(4) DEFAULT NULL,
  `expires` int(11) DEFAULT NULL,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `payment_gateway_mode` varchar(255) DEFAULT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`method_id`),
  UNIQUE KEY `commerce_payment_method_field__uuid__value` (`uuid`),
  KEY `commerce_payment_method__06eef65667` (`payment_gateway`),
  KEY `commerce_payment_method__f1a4ca8a25` (`billing_profile__target_id`),
  KEY `commerce_payment_method__1a5d23bb97` (`billing_profile__target_revision_id`),
  KEY `commerce_payment_method_field__uid__target_id` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_payment_method entities.';

/*Data for the table `commerce_payment_method` */

/*Table structure for table `commerce_payment_method__card_exp_month` */

DROP TABLE IF EXISTS `commerce_payment_method__card_exp_month`;

CREATE TABLE `commerce_payment_method__card_exp_month` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `card_exp_month_value` tinyint(4) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_payment_method field card_exp…';

/*Data for the table `commerce_payment_method__card_exp_month` */

/*Table structure for table `commerce_payment_method__card_exp_year` */

DROP TABLE IF EXISTS `commerce_payment_method__card_exp_year`;

CREATE TABLE `commerce_payment_method__card_exp_year` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `card_exp_year_value` smallint(6) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_payment_method field card_exp…';

/*Data for the table `commerce_payment_method__card_exp_year` */

/*Table structure for table `commerce_payment_method__card_number` */

DROP TABLE IF EXISTS `commerce_payment_method__card_number`;

CREATE TABLE `commerce_payment_method__card_number` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `card_number_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_payment_method field card_number.';

/*Data for the table `commerce_payment_method__card_number` */

/*Table structure for table `commerce_payment_method__card_type` */

DROP TABLE IF EXISTS `commerce_payment_method__card_type`;

CREATE TABLE `commerce_payment_method__card_type` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `card_type_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `card_type_value` (`card_type_value`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_payment_method field card_type.';

/*Data for the table `commerce_payment_method__card_type` */

/*Table structure for table `commerce_payment_method__paypal_mail` */

DROP TABLE IF EXISTS `commerce_payment_method__paypal_mail`;

CREATE TABLE `commerce_payment_method__paypal_mail` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `paypal_mail_value` varchar(254) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_payment_method field paypal_mail.';

/*Data for the table `commerce_payment_method__paypal_mail` */

/*Table structure for table `commerce_product` */

DROP TABLE IF EXISTS `commerce_product`;

CREATE TABLE `commerce_product` (
  `product_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`product_id`),
  UNIQUE KEY `commerce_product_field__uuid__value` (`uuid`),
  KEY `commerce_product_field__type__target_id` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_product entities.';

/*Data for the table `commerce_product` */

insert  into `commerce_product`(`product_id`,`type`,`uuid`,`langcode`) values 

(1,'product_display','7f068835-8abd-4b90-8be7-7b791bbf2746','und'),

(2,'product_display','7f537ff0-30a0-477c-a55f-a3bf836a1c10','und'),

(3,'product_display','3237b124-e433-4715-a727-90ba893091a2','und'),

(4,'product_display','475cd204-99c8-43f0-9b34-ca6f8a652fdc','en');

/*Table structure for table `commerce_product__body` */

DROP TABLE IF EXISTS `commerce_product__body`;

CREATE TABLE `commerce_product__body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext NOT NULL,
  `body_summary` longtext,
  `body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product field body.';

/*Data for the table `commerce_product__body` */

/*Table structure for table `commerce_product__field_category` */

DROP TABLE IF EXISTS `commerce_product__field_category`;

CREATE TABLE `commerce_product__field_category` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_category_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_category_target_id` (`field_category_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product field field_category.';

/*Data for the table `commerce_product__field_category` */

insert  into `commerce_product__field_category`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_category_target_id`) values 

('product_display',0,1,1,'und',0,36),

('product_display',0,1,1,'und',1,31),

('product_display',0,1,1,'und',2,32),

('product_display',0,2,2,'und',0,28),

('product_display',0,2,2,'und',1,30),

('product_display',0,2,2,'und',2,36),

('product_display',0,3,3,'und',0,29),

('product_display',0,3,3,'und',1,36),

('product_display',0,4,4,'en',0,28),

('product_display',0,4,4,'en',1,31);

/*Table structure for table `commerce_product__field_rating` */

DROP TABLE IF EXISTS `commerce_product__field_rating`;

CREATE TABLE `commerce_product__field_rating` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_rating_rating` int(10) unsigned DEFAULT NULL,
  `field_rating_target` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product field field_rating.';

/*Data for the table `commerce_product__field_rating` */

insert  into `commerce_product__field_rating`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_rating_rating`,`field_rating_target`) values 

('product_display',0,1,1,'und',0,100,NULL),

('product_display',0,2,2,'und',0,100,NULL),

('product_display',0,3,3,'und',0,100,NULL),

('product_display',0,4,4,'en',0,100,NULL);

/*Table structure for table `commerce_product__field_reviews` */

DROP TABLE IF EXISTS `commerce_product__field_reviews`;

CREATE TABLE `commerce_product__field_reviews` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_reviews_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product field field_reviews.';

/*Data for the table `commerce_product__field_reviews` */

insert  into `commerce_product__field_reviews`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_reviews_status`) values 

('product_display',0,1,1,'und',0,2),

('product_display',0,2,2,'und',0,2),

('product_display',0,3,3,'und',0,2),

('product_display',0,4,4,'en',0,2);

/*Table structure for table `commerce_product__field_tags` */

DROP TABLE IF EXISTS `commerce_product__field_tags`;

CREATE TABLE `commerce_product__field_tags` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_tags_target_id` (`field_tags_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product field field_tags.';

/*Data for the table `commerce_product__field_tags` */

insert  into `commerce_product__field_tags`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_tags_target_id`) values 

('product_display',0,1,1,'und',0,37),

('product_display',0,1,1,'und',1,38),

('product_display',0,2,2,'und',0,37),

('product_display',0,3,3,'und',0,39),

('product_display',0,3,3,'und',1,38),

('product_display',0,4,4,'en',0,37),

('product_display',0,4,4,'en',1,38);

/*Table structure for table `commerce_product__stores` */

DROP TABLE IF EXISTS `commerce_product__stores`;

CREATE TABLE `commerce_product__stores` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `stores_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `stores_target_id` (`stores_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product field stores.';

/*Data for the table `commerce_product__stores` */

insert  into `commerce_product__stores`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`stores_target_id`) values 

('product_display',0,1,1,'und',0,1),

('product_display',0,2,2,'und',0,1),

('product_display',0,3,3,'und',0,1),

('product_display',0,4,4,'en',0,1);

/*Table structure for table `commerce_product__variations` */

DROP TABLE IF EXISTS `commerce_product__variations`;

CREATE TABLE `commerce_product__variations` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `variations_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `variations_target_id` (`variations_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product field variations.';

/*Data for the table `commerce_product__variations` */

insert  into `commerce_product__variations`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`variations_target_id`) values 

('product_display',0,1,1,'und',0,1),

('product_display',0,2,2,'und',0,2),

('product_display',0,3,3,'und',0,3),

('product_display',0,4,4,'en',0,4),

('product_display',0,4,4,'en',1,5);

/*Table structure for table `commerce_product_attribute_value` */

DROP TABLE IF EXISTS `commerce_product_attribute_value`;

CREATE TABLE `commerce_product_attribute_value` (
  `attribute_value_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `attribute` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`attribute_value_id`),
  UNIQUE KEY `commerce_product_attribute_value__b34e189361` (`uuid`),
  KEY `commerce_product_attribute_value__c87679daf8` (`attribute`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_product_attribute_value…';

/*Data for the table `commerce_product_attribute_value` */

insert  into `commerce_product_attribute_value`(`attribute_value_id`,`attribute`,`uuid`,`langcode`) values 

(12,'color','5daa1c9a-94f1-43bc-9519-b4a3c93e1f5a','en'),

(13,'color','2e86cfb5-d694-46ed-928f-b5ec4a813102','en'),

(14,'color','96eb798c-2c19-49a5-9844-c50f35acf745','en'),

(15,'color','6e0670e7-d131-4742-8ad8-cf35ad36bd8a','en'),

(16,'color','7a88c641-6744-4904-8714-eaf4b7c883de','en'),

(17,'color','a42aa8c5-e125-4092-bd79-0ef99eaf729f','en'),

(18,'color','811d13b2-8faa-47fe-9568-c7bad8eb66c2','en'),

(19,'size','3bf54131-4d60-44e2-826d-dc0e58f26ab8','en'),

(20,'size','c091d74d-a969-4e05-8a73-6ad900ff3200','en'),

(21,'size','8c12dfd5-7b91-422f-b3c0-54d65a7ccf76','en'),

(22,'size','04b3a035-e651-4e0a-a933-78b554c86e6c','en'),

(23,'size','00924320-1a69-44ff-b06d-946c993cb78d','en'),

(24,'size','d79f581d-649a-4de0-8c9d-6958da3b2a3b','en');

/*Table structure for table `commerce_product_attribute_value_field_data` */

DROP TABLE IF EXISTS `commerce_product_attribute_value_field_data`;

CREATE TABLE `commerce_product_attribute_value_field_data` (
  `attribute_value_id` int(10) unsigned NOT NULL,
  `attribute` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `weight` int(11) DEFAULT NULL,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`attribute_value_id`,`langcode`),
  KEY `commerce_product_attribute_value__id__default_langcode__langcode` (`attribute_value_id`,`default_langcode`,`langcode`),
  KEY `commerce_product_attribute_value__c87679daf8` (`attribute`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for commerce_product_attribute_value…';

/*Data for the table `commerce_product_attribute_value_field_data` */

insert  into `commerce_product_attribute_value_field_data`(`attribute_value_id`,`attribute`,`langcode`,`name`,`weight`,`created`,`changed`,`default_langcode`) values 

(12,'color','en','Black',1,1503325390,1503325390,1),

(13,'color','en','White',2,1503325390,1503325390,1),

(14,'color','en','Red',3,1503325390,1503325390,1),

(15,'color','en','Green',4,1503325390,1503325390,1),

(16,'color','en','Blue',5,1503325390,1503325390,1),

(17,'color','en','Yellow',6,1503325390,1503325390,1),

(18,'color','en','Pink',7,1503325390,1503325390,1),

(19,'size','en','S',1,1503325518,1503325518,1),

(20,'size','en','M',2,1503325518,1503325518,1),

(21,'size','en','L',3,1503325518,1503325518,1),

(22,'size','en','XL',4,1503325518,1503325518,1),

(23,'size','en','XXL',5,1503325518,1503325518,1),

(24,'size','en','XXXL',6,1503325518,1503325518,1);

/*Table structure for table `commerce_product_field_data` */

DROP TABLE IF EXISTS `commerce_product_field_data`;

CREATE TABLE `commerce_product_field_data` (
  `product_id` int(10) unsigned NOT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `title` varchar(255) DEFAULT NULL,
  `status` tinyint(4) NOT NULL,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`product_id`,`langcode`),
  KEY `commerce_product_field__type__target_id` (`type`),
  KEY `commerce_product__id__default_langcode__langcode` (`product_id`,`default_langcode`,`langcode`),
  KEY `commerce_product__status_type` (`status`,`type`,`product_id`),
  KEY `commerce_product_field__uid__target_id` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for commerce_product entities.';

/*Data for the table `commerce_product_field_data` */

insert  into `commerce_product_field_data`(`product_id`,`type`,`langcode`,`uid`,`title`,`status`,`created`,`changed`,`default_langcode`) values 

(1,'product_display','und',1,'Only & Sons Pique Polo Shirt',1,1503051226,1503564714,1),

(2,'product_display','und',1,'Polo Shirt With Floral Sleeves',1,1503052396,1503564706,1),

(3,'product_display','und',1,'G-Star Polo Applique Jersey',1,1503053273,1503564669,1),

(4,'product_display','en',1,'Religion Jersey Polo Shirts',1,1503053593,1503564727,1);

/*Table structure for table `commerce_product_variation` */

DROP TABLE IF EXISTS `commerce_product_variation`;

CREATE TABLE `commerce_product_variation` (
  `variation_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`variation_id`),
  UNIQUE KEY `commerce_product_variation_field__uuid__value` (`uuid`),
  KEY `commerce_product_variation__fc57e9c936` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_product_variation entities.';

/*Data for the table `commerce_product_variation` */

insert  into `commerce_product_variation`(`variation_id`,`type`,`uuid`,`langcode`) values 

(1,'product','a62d83a7-f220-4953-99ac-c62bb12e61c7','en'),

(2,'product','fd167796-b7c9-47bb-876a-2f13f6ebc9c8','en'),

(3,'product','fbdf1734-88ca-4428-9cd6-b49bfd16ac77','en'),

(4,'product','534712e5-05cc-42b8-a371-bb7af482f33f','en'),

(5,'product','05d2849e-88a1-4363-aab0-582ab908f846','en');

/*Table structure for table `commerce_product_variation__6541de6486` */

DROP TABLE IF EXISTS `commerce_product_variation__6541de6486`;

CREATE TABLE `commerce_product_variation__6541de6486` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_short_description_value` longtext NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field field…';

/*Data for the table `commerce_product_variation__6541de6486` */

insert  into `commerce_product_variation__6541de6486`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_short_description_value`) values 

('product',0,1,1,'en',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.'),

('product',0,2,2,'en',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.'),

('product',0,3,3,'en',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.'),

('product',0,4,4,'en',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.'),

('product',0,5,5,'en',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.');

/*Table structure for table `commerce_product_variation__attribute_color` */

DROP TABLE IF EXISTS `commerce_product_variation__attribute_color`;

CREATE TABLE `commerce_product_variation__attribute_color` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `attribute_color_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `attribute_color_target_id` (`attribute_color_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field attribute…';

/*Data for the table `commerce_product_variation__attribute_color` */

insert  into `commerce_product_variation__attribute_color`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`attribute_color_target_id`) values 

('product',0,1,1,'en',0,14),

('product',0,2,2,'en',0,18),

('product',0,3,3,'en',0,15),

('product',0,4,4,'en',0,12),

('product',0,5,5,'en',0,13);

/*Table structure for table `commerce_product_variation__attribute_size` */

DROP TABLE IF EXISTS `commerce_product_variation__attribute_size`;

CREATE TABLE `commerce_product_variation__attribute_size` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `attribute_size_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `attribute_size_target_id` (`attribute_size_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field attribute…';

/*Data for the table `commerce_product_variation__attribute_size` */

insert  into `commerce_product_variation__attribute_size`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`attribute_size_target_id`) values 

('product',0,1,1,'en',0,19),

('product',0,2,2,'en',0,22),

('product',0,3,3,'en',0,20),

('product',0,4,4,'en',0,22),

('product',0,5,5,'en',0,21);

/*Table structure for table `commerce_product_variation__e2367ebae5` */

DROP TABLE IF EXISTS `commerce_product_variation__e2367ebae5`;

CREATE TABLE `commerce_product_variation__e2367ebae5` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_right_side_description_value` longtext NOT NULL,
  `field_right_side_description_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_right_side_description_format` (`field_right_side_description_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field field…';

/*Data for the table `commerce_product_variation__e2367ebae5` */

insert  into `commerce_product_variation__e2367ebae5`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_right_side_description_value`,`field_right_side_description_format`) values 

('product',0,1,1,'en',0,'<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>','shortcodes'),

('product',0,2,2,'en',0,'<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>','shortcodes'),

('product',0,3,3,'en',0,'<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>','shortcodes'),

('product',0,4,4,'en',0,'<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>','shortcodes'),

('product',0,5,5,'en',0,'<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>','shortcodes');

/*Table structure for table `commerce_product_variation__field_description` */

DROP TABLE IF EXISTS `commerce_product_variation__field_description`;

CREATE TABLE `commerce_product_variation__field_description` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_description_value` longtext NOT NULL,
  `field_description_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_description_format` (`field_description_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field field…';

/*Data for the table `commerce_product_variation__field_description` */

insert  into `commerce_product_variation__field_description`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_description_value`,`field_description_format`) values 

('product',0,1,1,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n ','shortcodes'),

('product',0,2,2,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n ','shortcodes'),

('product',0,3,3,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n ','shortcodes'),

('product',0,4,4,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n ','shortcodes'),

('product',0,5,5,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n ','shortcodes');

/*Table structure for table `commerce_product_variation__field_images` */

DROP TABLE IF EXISTS `commerce_product_variation__field_images`;

CREATE TABLE `commerce_product_variation__field_images` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_images_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_images_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_images_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_images_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_images_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_images_target_id` (`field_images_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field field…';

/*Data for the table `commerce_product_variation__field_images` */

insert  into `commerce_product_variation__field_images`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_images_target_id`,`field_images_alt`,`field_images_title`,`field_images_width`,`field_images_height`) values 

('product',0,1,1,'en',0,62,'Product','',370,472),

('product',0,1,1,'en',1,63,'Product','',370,472),

('product',0,1,1,'en',2,64,'Product','',370,472),

('product',0,2,2,'en',0,65,'Product','',370,472),

('product',0,3,3,'en',0,63,'Product','',370,472),

('product',0,3,3,'en',1,65,'Product','',370,472),

('product',0,3,3,'en',2,66,'Product','',240,320),

('product',0,3,3,'en',3,67,'Product','',240,320),

('product',0,4,4,'en',0,62,'Product','',370,472),

('product',0,4,4,'en',1,63,'Product','',370,472),

('product',0,4,4,'en',2,64,'Product','',370,472),

('product',0,4,4,'en',3,65,'Product','',370,472),

('product',0,5,5,'en',0,63,'Product','',370,472),

('product',0,5,5,'en',1,64,'Product','',370,472),

('product',0,5,5,'en',2,62,'Product','',370,472);

/*Table structure for table `commerce_product_variation__field_length` */

DROP TABLE IF EXISTS `commerce_product_variation__field_length`;

CREATE TABLE `commerce_product_variation__field_length` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_length_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field field…';

/*Data for the table `commerce_product_variation__field_length` */

insert  into `commerce_product_variation__field_length`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_length_value`) values 

('product',0,1,1,'en',0,'50cm'),

('product',0,2,2,'en',0,'50cm'),

('product',0,3,3,'en',0,'50cm'),

('product',0,4,4,'en',0,'50 sm'),

('product',0,5,5,'en',0,'55 sm');

/*Table structure for table `commerce_product_variation__field_old_price` */

DROP TABLE IF EXISTS `commerce_product_variation__field_old_price`;

CREATE TABLE `commerce_product_variation__field_old_price` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_old_price_number` decimal(19,6) DEFAULT NULL COMMENT 'The number.',
  `field_old_price_currency_code` varchar(3) DEFAULT NULL COMMENT 'The currency code.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field field_old…';

/*Data for the table `commerce_product_variation__field_old_price` */

insert  into `commerce_product_variation__field_old_price`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_old_price_number`,`field_old_price_currency_code`) values 

('product',0,3,3,'en',0,150.000000,'USD'),

('product',0,4,4,'en',0,50.000000,'USD');

/*Table structure for table `commerce_product_variation__field_sale_text` */

DROP TABLE IF EXISTS `commerce_product_variation__field_sale_text`;

CREATE TABLE `commerce_product_variation__field_sale_text` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_sale_text_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field field…';

/*Data for the table `commerce_product_variation__field_sale_text` */

insert  into `commerce_product_variation__field_sale_text`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_sale_text_value`) values 

('product',0,3,3,'en',0,'Sale'),

('product',0,4,4,'en',0,'SALE');

/*Table structure for table `commerce_product_variation__field_waist` */

DROP TABLE IF EXISTS `commerce_product_variation__field_waist`;

CREATE TABLE `commerce_product_variation__field_waist` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_waist_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_product_variation field field…';

/*Data for the table `commerce_product_variation__field_waist` */

insert  into `commerce_product_variation__field_waist`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_waist_value`) values 

('product',0,1,1,'en',0,'25cm'),

('product',0,2,2,'en',0,'25cm'),

('product',0,3,3,'en',0,'25cm'),

('product',0,4,4,'en',0,'25 sm'),

('product',0,5,5,'en',0,'30 sm');

/*Table structure for table `commerce_product_variation_field_data` */

DROP TABLE IF EXISTS `commerce_product_variation_field_data`;

CREATE TABLE `commerce_product_variation_field_data` (
  `variation_id` int(10) unsigned NOT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `sku` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `price__number` decimal(19,6) DEFAULT NULL COMMENT 'The number.',
  `price__currency_code` varchar(3) DEFAULT NULL COMMENT 'The currency code.',
  `status` tinyint(4) NOT NULL,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `list_price__number` decimal(19,6) DEFAULT NULL COMMENT 'The number.',
  `list_price__currency_code` varchar(3) DEFAULT NULL COMMENT 'The currency code.',
  PRIMARY KEY (`variation_id`,`langcode`),
  KEY `commerce_product_variation__fc57e9c936` (`type`),
  KEY `commerce_product_variation__cef18578b5` (`product_id`),
  KEY `commerce_product_variation_field__uid__target_id` (`uid`),
  KEY `commerce_product_variation__id__default_langcode__langcode` (`variation_id`,`default_langcode`,`langcode`),
  KEY `commerce_product_variation__status_type` (`status`,`type`,`variation_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for commerce_product_variation entities.';

/*Data for the table `commerce_product_variation_field_data` */

insert  into `commerce_product_variation_field_data`(`variation_id`,`type`,`langcode`,`uid`,`product_id`,`sku`,`title`,`price__number`,`price__currency_code`,`status`,`created`,`changed`,`default_langcode`,`list_price__number`,`list_price__currency_code`) values 

(1,'product','en',1,1,'2138','Only & Sons Pique Polo Shirt - Red, S',28.990000,'USD',1,1503051577,1503485221,1,NULL,NULL),

(2,'product','en',1,2,'3159','Polo Shirt With Floral Sleeves - Pink, XL',85.990000,'USD',1,1503052598,1503481373,1,NULL,NULL),

(3,'product','en',1,3,'3158','G-Star Polo Applique Jersey - Green, M',94.750000,'USD',1,1503053515,1503485205,1,NULL,NULL),

(4,'product','en',1,4,'2134','Religion Jersey Polo Shirts - Black, XL',25.990000,'USD',1,1503053779,1503414210,1,NULL,NULL),

(5,'product','en',1,4,'2135','Religion Jersey Polo Shirts - White, L',28.990000,'USD',1,1503053967,1503412318,1,NULL,NULL);

/*Table structure for table `commerce_promotion` */

DROP TABLE IF EXISTS `commerce_promotion`;

CREATE TABLE `commerce_promotion` (
  `promotion_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`promotion_id`),
  UNIQUE KEY `commerce_promotion_field__uuid__value` (`uuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_promotion entities.';

/*Data for the table `commerce_promotion` */

/*Table structure for table `commerce_promotion__conditions` */

DROP TABLE IF EXISTS `commerce_promotion__conditions`;

CREATE TABLE `commerce_promotion__conditions` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `conditions_target_plugin_id` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The plugin ID.',
  `conditions_target_plugin_configuration` blob COMMENT 'The plugin configuration.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_promotion field conditions.';

/*Data for the table `commerce_promotion__conditions` */

/*Table structure for table `commerce_promotion__coupons` */

DROP TABLE IF EXISTS `commerce_promotion__coupons`;

CREATE TABLE `commerce_promotion__coupons` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `coupons_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `coupons_target_id` (`coupons_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_promotion field coupons.';

/*Data for the table `commerce_promotion__coupons` */

/*Table structure for table `commerce_promotion__order_types` */

DROP TABLE IF EXISTS `commerce_promotion__order_types`;

CREATE TABLE `commerce_promotion__order_types` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `order_types_target_id` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `order_types_target_id` (`order_types_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_promotion field order_types.';

/*Data for the table `commerce_promotion__order_types` */

/*Table structure for table `commerce_promotion__stores` */

DROP TABLE IF EXISTS `commerce_promotion__stores`;

CREATE TABLE `commerce_promotion__stores` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `stores_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `stores_target_id` (`stores_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_promotion field stores.';

/*Data for the table `commerce_promotion__stores` */

/*Table structure for table `commerce_promotion_coupon` */

DROP TABLE IF EXISTS `commerce_promotion_coupon`;

CREATE TABLE `commerce_promotion_coupon` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `promotion_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `code` varchar(50) DEFAULT NULL,
  `status` tinyint(4) NOT NULL,
  `usage_limit` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `commerce_promotion_coupon_field__uuid__value` (`uuid`),
  KEY `commerce_promotion_coupon__5167635140` (`promotion_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_promotion_coupon entities.';

/*Data for the table `commerce_promotion_coupon` */

/*Table structure for table `commerce_promotion_field_data` */

DROP TABLE IF EXISTS `commerce_promotion_field_data`;

CREATE TABLE `commerce_promotion_field_data` (
  `promotion_id` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description` longtext,
  `offer__target_plugin_id` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The plugin ID.',
  `offer__target_plugin_configuration` blob COMMENT 'The plugin configuration.',
  `usage_limit` int(11) DEFAULT NULL,
  `start_date` varchar(20) DEFAULT NULL COMMENT 'The date value.',
  `end_date` varchar(20) DEFAULT NULL COMMENT 'The date value.',
  `compatibility` varchar(255) DEFAULT NULL,
  `status` tinyint(4) NOT NULL,
  `weight` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `condition_operator` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`promotion_id`,`langcode`),
  KEY `commerce_promotion__id__default_langcode__langcode` (`promotion_id`,`default_langcode`,`langcode`),
  KEY `commerce_promotion_field__start_date__value` (`start_date`),
  KEY `commerce_promotion_field__end_date__value` (`end_date`),
  KEY `commerce_promotion_field__compatibility__value` (`compatibility`(191)),
  KEY `commerce_promotion__787d3617c5` (`condition_operator`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for commerce_promotion entities.';

/*Data for the table `commerce_promotion_field_data` */

/*Table structure for table `commerce_promotion_usage` */

DROP TABLE IF EXISTS `commerce_promotion_usage`;

CREATE TABLE `commerce_promotion_usage` (
  `usage_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Usage ID.',
  `promotion_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The commerce_promotion.promotion_id.',
  `coupon_id` int(10) unsigned DEFAULT '0' COMMENT 'The commerce_promotion_coupon.id.',
  `order_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The commerce_order.order_id.',
  `mail` varchar(254) DEFAULT NULL COMMENT 'The customer email.',
  PRIMARY KEY (`usage_id`),
  KEY `promotion_id` (`promotion_id`),
  KEY `coupon_id` (`coupon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores promotion usage.';

/*Data for the table `commerce_promotion_usage` */

/*Table structure for table `commerce_store` */

DROP TABLE IF EXISTS `commerce_store`;

CREATE TABLE `commerce_store` (
  `store_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`store_id`),
  UNIQUE KEY `commerce_store_field__uuid__value` (`uuid`),
  KEY `commerce_store_field__type__target_id` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for commerce_store entities.';

/*Data for the table `commerce_store` */

insert  into `commerce_store`(`store_id`,`type`,`uuid`,`langcode`) values 

(1,'online','b5c17bf4-f7c7-4c5a-ab7a-3acd37a849e2','en');

/*Table structure for table `commerce_store__billing_countries` */

DROP TABLE IF EXISTS `commerce_store__billing_countries`;

CREATE TABLE `commerce_store__billing_countries` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `billing_countries_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `billing_countries_value` (`billing_countries_value`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for commerce_store field billing_countries.';

/*Data for the table `commerce_store__billing_countries` */

insert  into `commerce_store__billing_countries`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`billing_countries_value`) values 

('online',0,1,1,'en',0,'CA');

/*Table structure for table `commerce_store_field_data` */

DROP TABLE IF EXISTS `commerce_store_field_data`;

CREATE TABLE `commerce_store_field_data` (
  `store_id` int(10) unsigned NOT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `name` varchar(255) DEFAULT NULL,
  `mail` varchar(254) DEFAULT NULL,
  `default_currency` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The ID of the target entity.',
  `address__langcode` varchar(32) DEFAULT NULL,
  `address__country_code` varchar(2) DEFAULT NULL,
  `address__administrative_area` varchar(255) DEFAULT NULL,
  `address__locality` varchar(255) DEFAULT NULL,
  `address__dependent_locality` varchar(255) DEFAULT NULL,
  `address__postal_code` varchar(255) DEFAULT NULL,
  `address__sorting_code` varchar(255) DEFAULT NULL,
  `address__address_line1` varchar(255) DEFAULT NULL,
  `address__address_line2` varchar(255) DEFAULT NULL,
  `address__organization` varchar(255) DEFAULT NULL,
  `address__given_name` varchar(255) DEFAULT NULL,
  `address__additional_name` varchar(255) DEFAULT NULL,
  `address__family_name` varchar(255) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`store_id`,`langcode`),
  KEY `commerce_store__id__default_langcode__langcode` (`store_id`,`default_langcode`,`langcode`),
  KEY `commerce_store_field__type__target_id` (`type`),
  KEY `commerce_store__a0c0b29304` (`default_currency`),
  KEY `commerce_store_field__uid__target_id` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for commerce_store entities.';

/*Data for the table `commerce_store_field_data` */

insert  into `commerce_store_field_data`(`store_id`,`type`,`langcode`,`uid`,`name`,`mail`,`default_currency`,`address__langcode`,`address__country_code`,`address__administrative_area`,`address__locality`,`address__dependent_locality`,`address__postal_code`,`address__sorting_code`,`address__address_line1`,`address__address_line2`,`address__organization`,`address__given_name`,`address__additional_name`,`address__family_name`,`default_langcode`) values 

(1,'online','en',1,'Rhythm Store','example@example.com','USD','en','US','CA','Los Angeles',NULL,'90210',NULL,'Sunset 15','',NULL,NULL,NULL,NULL,1);

/*Table structure for table `config` */

DROP TABLE IF EXISTS `config`;

CREATE TABLE `config` (
  `collection` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Primary Key: Config object collection.',
  `name` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Primary Key: Config object name.',
  `data` longblob COMMENT 'A serialized configuration object data.',
  PRIMARY KEY (`collection`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for configuration data.';

/*Data for the table `config` */

insert  into `config`(`collection`,`name`,`data`) values 

('','block.block.cart','a:12:{s:4:\"uuid\";s:36:\"94c1ff38-4027-4007-b8f9-96e6504c0f0b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:4:\"cart\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"sidebar\";s:6:\"weight\";i:-28;s:8:\"provider\";N;s:6:\"plugin\";s:13:\"commerce_cart\";s:8:\"settings\";a:5:{s:2:\"id\";s:13:\"commerce_cart\";s:5:\"label\";s:13:\"Shopping cart\";s:8:\"provider\";s:13:\"commerce_cart\";s:13:\"label_display\";s:7:\"visible\";s:8:\"dropdown\";b:1;}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:6:\"/shop*\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.footer','a:12:{s:4:\"uuid\";s:36:\"f35186e0-4d27-414f-8273-55ef0c061c4e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:ca4e996c-222b-4e10-b248-09930f18481b\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:6:\"footer\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"footer\";s:6:\"weight\";i:-11;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:ca4e996c-222b-4e10-b248-09930f18481b\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:ca4e996c-222b-4e10-b248-09930f18481b\";s:5:\"label\";s:6:\"Footer\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:15:\"gallery-images*\";s:6:\"negate\";b:1;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.gmapcontact','a:12:{s:4:\"uuid\";s:36:\"8c48b0a3-1d64-4d8a-9db6-94ceb4fbdf39\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:9406b6d7-9c11-4ae3-b5bc-ce4d6b5892ac\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:11:\"gmapcontact\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"footer\";s:6:\"weight\";i:-12;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:9406b6d7-9c11-4ae3-b5bc-ce4d6b5892ac\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:9406b6d7-9c11-4ae3-b5bc-ce4d6b5892ac\";s:5:\"label\";s:13:\"Gmap: Contact\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/74\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.gmapcontacttop','a:12:{s:4:\"uuid\";s:36:\"7ec13e18-3ee7-4040-b223-3f733fb1dba8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:7d6a15ef-a32a-4303-b9bd-721ae7fc6e2f\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:14:\"gmapcontacttop\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-24;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:7d6a15ef-a32a-4303-b9bd-721ae7fc6e2f\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:7d6a15ef-a32a-4303-b9bd-721ae7fc6e2f\";s:5:\"label\";s:17:\"Gmap: Contact Top\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/75\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headeragencyheader','a:12:{s:4:\"uuid\";s:36:\"7f37e06f-4a35-4cfc-a5f4-36709472c90b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:0f836014-c83c-4c70-a06b-010c20d64052\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:18:\"headeragencyheader\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-23;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:0f836014-c83c-4c70-a06b-010c20d64052\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:0f836014-c83c-4c70-a06b-010c20d64052\";s:5:\"label\";s:21:\"Header: Agency Header\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/16\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerbgvideofullscreen1','a:12:{s:4:\"uuid\";s:36:\"76b80ec7-ce57-46b6-9d3b-8f9794e65a70\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:ccc57983-ca62-407c-bc2d-cc693e7d4fab\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:24:\"headerbgvideofullscreen1\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-22;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:ccc57983-ca62-407c-bc2d-cc693e7d4fab\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:ccc57983-ca62-407c-bc2d-cc693e7d4fab\";s:5:\"label\";s:29:\"Header: BG Video FullScreen 1\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/14\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerbgvideofullscreen1onepage','a:12:{s:4:\"uuid\";s:36:\"aa55ac4e-a5b2-4356-9545-1f44c77f500a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:7a5157bb-6c81-4dcf-9517-187aa57df270\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:31:\"headerbgvideofullscreen1onepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-21;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:7a5157bb-6c81-4dcf-9517-187aa57df270\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:7a5157bb-6c81-4dcf-9517-187aa57df270\";s:5:\"label\";s:39:\"Header: BG Video FullScreen 1 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/14\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerbgvideofullscreen2','a:12:{s:4:\"uuid\";s:36:\"b36ff433-974c-4b1e-a111-25af465188cc\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:ace33e6a-ca9c-41ef-b0ee-ffb6a2a52274\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:24:\"headerbgvideofullscreen2\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-20;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:ace33e6a-ca9c-41ef-b0ee-ffb6a2a52274\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:ace33e6a-ca9c-41ef-b0ee-ffb6a2a52274\";s:5:\"label\";s:29:\"Header: BG Video FullScreen 2\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/15\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerbgvideofullscreen2onepage','a:12:{s:4:\"uuid\";s:36:\"44f53eb8-eb63-4012-9831-7a4f04a823ed\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:90013c4e-6be7-4967-bcd1-623ff20502df\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:31:\"headerbgvideofullscreen2onepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-19;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:90013c4e-6be7-4967-bcd1-623ff20502df\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:90013c4e-6be7-4967-bcd1-623ff20502df\";s:5:\"label\";s:39:\"Header: BG Video FullScreen 2 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/15\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerbgvideofullwidth','a:12:{s:4:\"uuid\";s:36:\"7b9788bc-cd42-4655-b624-0197e286eaa4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:71affffc-cffa-4790-93df-5f7d6790619a\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:22:\"headerbgvideofullwidth\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-18;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:71affffc-cffa-4790-93df-5f7d6790619a\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:71affffc-cffa-4790-93df-5f7d6790619a\";s:5:\"label\";s:26:\"Header: BG Video Fullwidth\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/13\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerbgvideofullwidthonepage','a:12:{s:4:\"uuid\";s:36:\"444a7c72-7e14-466d-b7e4-2f50c08c1fdf\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:105211ef-6551-4e9c-816c-39c118e2b0f2\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:29:\"headerbgvideofullwidthonepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-17;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:105211ef-6551-4e9c-816c-39c118e2b0f2\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:105211ef-6551-4e9c-816c-39c118e2b0f2\";s:5:\"label\";s:36:\"Header: BG Video Fullwidth - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/13\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerdarkmain','a:12:{s:4:\"uuid\";s:36:\"9f4af8d7-746c-4ab8-9abf-031f5926560d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:0b6370a9-be73-4701-bb5b-719f350f0927\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:14:\"headerdarkmain\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-28;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:0b6370a9-be73-4701-bb5b-719f350f0927\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:0b6370a9-be73-4701-bb5b-719f350f0927\";s:5:\"label\";s:16:\"Header Dark MAIN\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:385:\"/node/48\r\n/node/54\r\n/node/55\r\n/node/101\r\n/node/103\r\ncontent/contact-1\r\ncontent/contact-2\r\ncontent/landing-page\r\ncontent/main-demo\r\ncontent/all-demos\r\ncontent/about-us-1\r\ncontent/services-1\r\ncontent/services-2\r\ncontent/services-3\r\ncontent/team-1\r\ncontent/faq-1\r\ncontent/faq-2\r\ncontent/pricing-1\r\ngallery*\r\nportfolio-promo\r\nblog*\r\nportfolio-item*\r\n<front>\r\n/home/*\r\n/onepage/*\r\n/node/102\";s:6:\"negate\";b:1;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerdarktransparent','a:12:{s:4:\"uuid\";s:36:\"a026120c-56e4-4352-b7a7-c6a39bc78742\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:6a9dbf83-77b0-4d60-81e6-4ae5da969bce\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:21:\"headerdarktransparent\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-27;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:6a9dbf83-77b0-4d60-81e6-4ae5da969bce\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:6a9dbf83-77b0-4d60-81e6-4ae5da969bce\";s:5:\"label\";s:23:\"Header Dark Transparent\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/48\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerfullwidthimage','a:12:{s:4:\"uuid\";s:36:\"3bf0ca52-8a30-461c-8f3f-3c0880aa6a4b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:907807f0-9207-4580-8336-3c6f41767dde\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:20:\"headerfullwidthimage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-16;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:907807f0-9207-4580-8336-3c6f41767dde\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:907807f0-9207-4580-8336-3c6f41767dde\";s:5:\"label\";s:23:\"Header: Fullwidth Image\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/6\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerfullwidthimageonepage','a:12:{s:4:\"uuid\";s:36:\"8f62a8d4-9a1b-446a-9769-ec3451b31c85\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:ac670683-9f00-4dc6-b4d4-4ff3497e48d0\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:27:\"headerfullwidthimageonepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-14;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:ac670683-9f00-4dc6-b4d4-4ff3497e48d0\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:ac670683-9f00-4dc6-b4d4-4ff3497e48d0\";s:5:\"label\";s:33:\"Header: Fullwidth Image - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/7\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax1','a:12:{s:4:\"uuid\";s:36:\"9f08ecc2-5104-43eb-a017-24c5d251e29b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:3349535d-91e6-40ae-9177-58513f4cd5f6\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:20:\"headerimageparallax1\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-15;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:3349535d-91e6-40ae-9177-58513f4cd5f6\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:3349535d-91e6-40ae-9177-58513f4cd5f6\";s:5:\"label\";s:24:\"Header: Image Parallax 1\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/1\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax1onepage','a:12:{s:4:\"uuid\";s:36:\"0b6f8523-9dbc-4298-b374-63773b17d9d2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:a728edbb-0a33-4c10-89b8-dafda2501620\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:27:\"headerimageparallax1onepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:a728edbb-0a33-4c10-89b8-dafda2501620\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:a728edbb-0a33-4c10-89b8-dafda2501620\";s:5:\"label\";s:34:\"Header: Image Parallax 1 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/1\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax2','a:12:{s:4:\"uuid\";s:36:\"5d869f40-bf55-472d-88f3-3efa8effecaf\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:24d7103c-7e8f-4452-add5-9ce850946d3e\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:20:\"headerimageparallax2\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-13;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:24d7103c-7e8f-4452-add5-9ce850946d3e\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:24d7103c-7e8f-4452-add5-9ce850946d3e\";s:5:\"label\";s:24:\"Header: Image Parallax 2\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/2\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax2onepage','a:12:{s:4:\"uuid\";s:36:\"e82ac7eb-ace8-4f3b-91ad-96a5e545d4e5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:371c38c9-61b6-4b61-813c-e781c77d9a2b\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:27:\"headerimageparallax2onepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-12;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:371c38c9-61b6-4b61-813c-e781c77d9a2b\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:371c38c9-61b6-4b61-813c-e781c77d9a2b\";s:5:\"label\";s:34:\"Header: Image Parallax 2 - Onepage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/2\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax3','a:12:{s:4:\"uuid\";s:36:\"5015f346-52bf-4f74-84c6-17a4e3d5b670\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:cbea5a9b-6fdb-4634-81b2-a6813f136a28\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:20:\"headerimageparallax3\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-11;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:cbea5a9b-6fdb-4634-81b2-a6813f136a28\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:cbea5a9b-6fdb-4634-81b2-a6813f136a28\";s:5:\"label\";s:24:\"Header: Image Parallax 3\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/3\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax3onepage','a:12:{s:4:\"uuid\";s:36:\"95a262d9-21aa-4489-a656-27dea2d95bc7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:5fa9ccfc-0083-4023-9905-f4c1e9969098\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:27:\"headerimageparallax3onepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:5fa9ccfc-0083-4023-9905-f4c1e9969098\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:5fa9ccfc-0083-4023-9905-f4c1e9969098\";s:5:\"label\";s:34:\"Header: Image Parallax 3 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/3\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax4','a:12:{s:4:\"uuid\";s:36:\"aea29a9b-3f18-4b05-9b76-d9c5d8cc0c51\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:e9cb56b9-8887-4f6c-9c9f-ff621ad1a410\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:20:\"headerimageparallax4\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-9;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:e9cb56b9-8887-4f6c-9c9f-ff621ad1a410\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:e9cb56b9-8887-4f6c-9c9f-ff621ad1a410\";s:5:\"label\";s:24:\"Header: Image Parallax 4\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/4\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax4onepage','a:12:{s:4:\"uuid\";s:36:\"afd12111-5e64-4ed1-a8f0-caa4592ff02c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:7c4c579e-1361-49a3-a6d3-4f5f9529d16d\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:27:\"headerimageparallax4onepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-8;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:7c4c579e-1361-49a3-a6d3-4f5f9529d16d\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:7c4c579e-1361-49a3-a6d3-4f5f9529d16d\";s:5:\"label\";s:34:\"Header: Image Parallax 4 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/4\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax5','a:12:{s:4:\"uuid\";s:36:\"3b1e70f3-0807-4d9a-97bc-5de2488c0949\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b397d2ca-dcde-4faa-9a97-9b4424b233b7\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:20:\"headerimageparallax5\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b397d2ca-dcde-4faa-9a97-9b4424b233b7\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b397d2ca-dcde-4faa-9a97-9b4424b233b7\";s:5:\"label\";s:24:\"Header: Image Parallax 5\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/5\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerimageparallax5onepage','a:12:{s:4:\"uuid\";s:36:\"2dbcb7d7-fee4-4924-85c2-8ecff5520b67\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b8196462-3d3f-42cd-865e-2070173cd6a7\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:27:\"headerimageparallax5onepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-6;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b8196462-3d3f-42cd-865e-2070173cd6a7\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b8196462-3d3f-42cd-865e-2070173cd6a7\";s:5:\"label\";s:34:\"Header: Image Parallax 5 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/5\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headermaindemo','a:12:{s:4:\"uuid\";s:36:\"b9224ba5-ea30-4207-bfe8-5597ae82a2ca\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:5383c346-1e60-4cfb-b197-f2c3cf81ff32\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:14:\"headermaindemo\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-29;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:5383c346-1e60-4cfb-b197-f2c3cf81ff32\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:5383c346-1e60-4cfb-b197-f2c3cf81ff32\";s:5:\"label\";s:17:\"Header: Main Demo\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headermaindemoonepage','a:12:{s:4:\"uuid\";s:36:\"c35a6a42-6b76-4eb5-9b76-af4d677877a7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:fddb3dae-ff3f-4eab-b348-53afefc651b5\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:21:\"headermaindemoonepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-5;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:fddb3dae-ff3f-4eab-b348-53afefc651b5\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:fddb3dae-ff3f-4eab-b348-53afefc651b5\";s:5:\"label\";s:27:\"Header: Main Demo - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:9:\"/node/102\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headermaindemoonepage_2','a:12:{s:4:\"uuid\";s:36:\"cac8108c-3b61-4c6b-b7b3-cbacdf3895b5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:fddb3dae-ff3f-4eab-b348-53afefc651b5\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:23:\"headermaindemoonepage_2\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:fddb3dae-ff3f-4eab-b348-53afefc651b5\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:fddb3dae-ff3f-4eab-b348-53afefc651b5\";s:5:\"label\";s:27:\"Header: Main Demo - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/0\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headersliderbackground','a:12:{s:4:\"uuid\";s:36:\"ead5af5e-d237-440f-9e38-5d335dac5735\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:1411a6d8-cbeb-4474-b584-62163cc624d4\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:22:\"headersliderbackground\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-4;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:1411a6d8-cbeb-4474-b584-62163cc624d4\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:1411a6d8-cbeb-4474-b584-62163cc624d4\";s:5:\"label\";s:25:\"Header: Slider Background\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/11\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headersliderbackgroundonepage','a:12:{s:4:\"uuid\";s:36:\"3d06a0ef-8bfb-49f1-b3be-cf27f16a5131\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:24110089-987a-4a14-a6ed-89553666f7df\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:29:\"headersliderbackgroundonepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-3;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:24110089-987a-4a14-a6ed-89553666f7df\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:24110089-987a-4a14-a6ed-89553666f7df\";s:5:\"label\";s:35:\"Header: Slider Background - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/11\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headersliderfullscreen','a:12:{s:4:\"uuid\";s:36:\"c0b4f5a2-1e0c-4ae8-9980-ed3a2433741c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b0802411-d5eb-4a16-a6d6-ff7024e3dd34\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:22:\"headersliderfullscreen\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-2;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b0802411-d5eb-4a16-a6d6-ff7024e3dd34\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b0802411-d5eb-4a16-a6d6-ff7024e3dd34\";s:5:\"label\";s:25:\"Header: Slider Fullscreen\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/8\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headersliderfullscreenonepage','a:12:{s:4:\"uuid\";s:36:\"5b58453b-723c-4896-aa31-f0f9c7c9ae6b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:21382078-dc04-4156-8562-c6bb4e02f0e1\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:29:\"headersliderfullscreenonepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-1;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:21382078-dc04-4156-8562-c6bb4e02f0e1\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:21382078-dc04-4156-8562-c6bb4e02f0e1\";s:5:\"label\";s:35:\"Header: Slider Fullscreen - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/8\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headersliderfullwidth','a:12:{s:4:\"uuid\";s:36:\"6d35a56e-3544-443d-ba5e-65ccd966e616\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:96e17d3d-5c4b-4699-95f9-ed2c65add661\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:21:\"headersliderfullwidth\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:96e17d3d-5c4b-4699-95f9-ed2c65add661\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:96e17d3d-5c4b-4699-95f9-ed2c65add661\";s:5:\"label\";s:24:\"Header: Slider Fullwidth\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/10\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headersliderfullwidthonepage','a:12:{s:4:\"uuid\";s:36:\"4bd5f99e-8feb-4cc4-9309-490ea8294273\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:d1a11564-3551-4347-b5bc-3a8cd1b894ed\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:28:\"headersliderfullwidthonepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:1;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:d1a11564-3551-4347-b5bc-3a8cd1b894ed\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:d1a11564-3551-4347-b5bc-3a8cd1b894ed\";s:5:\"label\";s:34:\"Header: Slider Fullwidth - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/10\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headersliderzoomeffect','a:12:{s:4:\"uuid\";s:36:\"73728475-d531-4eb7-b607-dae797837e2f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:2aa33a4b-bb38-4f6a-9c66-5cc5c7f27094\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:22:\"headersliderzoomeffect\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:2;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:2aa33a4b-bb38-4f6a-9c66-5cc5c7f27094\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:2aa33a4b-bb38-4f6a-9c66-5cc5c7f27094\";s:5:\"label\";s:26:\"Header: Slider Zoom Effect\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/9\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headersliderzoomeffectonepage','a:12:{s:4:\"uuid\";s:36:\"fee32d35-bca7-4b85-92ee-5d2d3274cb4c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b9039c91-c46f-4831-991d-a9f2d08cf7cf\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:29:\"headersliderzoomeffectonepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:3;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b9039c91-c46f-4831-991d-a9f2d08cf7cf\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b9039c91-c46f-4831-991d-a9f2d08cf7cf\";s:5:\"label\";s:36:\"Header: Slider Zoom Effect - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/9\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerspecialphotography','a:12:{s:4:\"uuid\";s:36:\"20c7bc21-2204-4d89-84a8-c8cbb3030466\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:4e4c5a44-2bf9-4b6a-9fc7-c4c77854c4f2\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:24:\"headerspecialphotography\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:4;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:4e4c5a44-2bf9-4b6a-9fc7-c4c77854c4f2\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:4e4c5a44-2bf9-4b6a-9fc7-c4c77854c4f2\";s:5:\"label\";s:27:\"Header: Special Photography\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:9:\"/node/101\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerspecialphotographyonepage','a:12:{s:4:\"uuid\";s:36:\"16165ac4-8ba9-40bc-8119-125e88c27e3d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:d5849bbf-634c-46be-8079-41e31edc2f28\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:31:\"headerspecialphotographyonepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:5;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:d5849bbf-634c-46be-8079-41e31edc2f28\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:d5849bbf-634c-46be-8079-41e31edc2f28\";s:5:\"label\";s:37:\"Header: Special Photography - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:9:\"/node/103\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headertextrotator','a:12:{s:4:\"uuid\";s:36:\"a80291bc-8043-48fb-bb55-55d225367933\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:02bde269-1d46-4ba4-aa78-811bb904f0cc\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:17:\"headertextrotator\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:6;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:02bde269-1d46-4ba4-aa78-811bb904f0cc\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:02bde269-1d46-4ba4-aa78-811bb904f0cc\";s:5:\"label\";s:20:\"Header: Text Rotator\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/7\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headertextrotatoronepage','a:12:{s:4:\"uuid\";s:36:\"f76b817c-1287-45fd-8bdc-887d5a4b9370\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b0bd13b5-c922-4792-945f-15414b01b7c3\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:24:\"headertextrotatoronepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:7;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b0bd13b5-c922-4792-945f-15414b01b7c3\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b0bd13b5-c922-4792-945f-15414b01b7c3\";s:5:\"label\";s:30:\"Header: Text Rotator - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/8\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerwhite','a:12:{s:4:\"uuid\";s:36:\"9f216d60-1120-4056-8da9-195a29d3d0a0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:52a10536-56b5-4eb7-8df9-33230c18ba31\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:11:\"headerwhite\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-26;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:52a10536-56b5-4eb7-8df9-33230c18ba31\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:52a10536-56b5-4eb7-8df9-33230c18ba31\";s:5:\"label\";s:12:\"Header White\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/54\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerwhitetransparent','a:12:{s:4:\"uuid\";s:36:\"ec56d4fb-6cf2-4703-b16c-65e07b2c097a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:653038ca-8c0b-4717-99d5-c3acc664d7af\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:22:\"headerwhitetransparent\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-25;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:653038ca-8c0b-4717-99d5-c3acc664d7af\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:653038ca-8c0b-4717-99d5-c3acc664d7af\";s:5:\"label\";s:24:\"Header White Transparent\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/55\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerwithplaybutton','a:12:{s:4:\"uuid\";s:36:\"c6d4f79a-bda9-4be9-9c53-4d4bf756880e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:3e57c7df-fc44-497a-b5d3-101a4180545b\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:20:\"headerwithplaybutton\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:8;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:3e57c7df-fc44-497a-b5d3-101a4180545b\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:3e57c7df-fc44-497a-b5d3-101a4180545b\";s:5:\"label\";s:24:\"Header: With Play Button\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/12\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.headerwithplaybuttononepage','a:12:{s:4:\"uuid\";s:36:\"4d4baf14-4f71-4792-b584-ec7ecd6ca388\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:8379ba0a-99cf-4d6c-92bc-b0713eabb68a\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:27:\"headerwithplaybuttononepage\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:9;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:8379ba0a-99cf-4d6c-92bc-b0713eabb68a\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:8379ba0a-99cf-4d6c-92bc-b0713eabb68a\";s:5:\"label\";s:34:\"Header: With Play Button - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/12\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.languageswitcher','a:12:{s:4:\"uuid\";s:36:\"08ce090a-33bf-458e-b268-2c02e5da0206\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:8:\"language\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:16:\"languageswitcher\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-8;s:8:\"provider\";N;s:6:\"plugin\";s:33:\"language_block:language_interface\";s:8:\"settings\";a:4:{s:2:\"id\";s:33:\"language_block:language_interface\";s:5:\"label\";s:17:\"Language switcher\";s:8:\"provider\";s:8:\"language\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.relatedprojects','a:12:{s:4:\"uuid\";s:36:\"edd9a1f2-11af-45ae-b666-dbec178652e2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:7bf565ba-d4c0-4dbb-88d7-3a62af679d29\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"node\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:15:\"relatedprojects\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:7bf565ba-d4c0-4dbb-88d7-3a62af679d29\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:7bf565ba-d4c0-4dbb-88d7-3a62af679d29\";s:5:\"label\";s:16:\"Related Projects\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:9:\"node_type\";a:4:{s:2:\"id\";s:9:\"node_type\";s:7:\"bundles\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}s:6:\"negate\";b:0;s:15:\"context_mapping\";a:1:{s:4:\"node\";s:29:\"@node.node_route_context:node\";}}}}'),

('','block.block.rhythmproductsfilter','a:12:{s:4:\"uuid\";s:36:\"4824094a-4c9f-496c-813e-728a6f25384d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:2:{i:0;s:10:\"rhythm_cms\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:20:\"rhythmproductsfilter\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"sidebar\";s:6:\"weight\";i:-27;s:8:\"provider\";N;s:6:\"plugin\";s:25:\"nd_rhythm_products_filter\";s:8:\"settings\";a:4:{s:2:\"id\";s:25:\"nd_rhythm_products_filter\";s:5:\"label\";s:15:\"Filter by Price\";s:8:\"provider\";s:10:\"rhythm_cms\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:6:\"/shop*\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythmprojectnextprev','a:12:{s:4:\"uuid\";s:36:\"c44389fe-2f06-478e-8e40-5aa93eecc3a1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:10:\"rhythm_cms\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:21:\"rhythmprojectnextprev\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:12:\"content_full\";s:6:\"weight\";i:-14;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"nd_rhythm_prev_next\";s:8:\"settings\";a:5:{s:2:\"id\";s:19:\"nd_rhythm_prev_next\";s:5:\"label\";s:25:\"Rhythm: Project Next Prev\";s:8:\"provider\";s:10:\"rhythm_cms\";s:13:\"label_display\";s:1:\"0\";s:14:\"all_works_link\";s:15:\"portfolio-boxed\";}s:10:\"visibility\";a:1:{s:9:\"node_type\";a:4:{s:2:\"id\";s:9:\"node_type\";s:7:\"bundles\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}s:6:\"negate\";b:0;s:15:\"context_mapping\";a:1:{s:4:\"node\";s:29:\"@node.node_route_context:node\";}}}}'),

('','block.block.rhythm_account_menu','a:13:{s:4:\"uuid\";s:36:\"ebc611c4-c726-4588-88a8-9a73a9a245d1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:19:\"system.menu.account\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DweBpscQZdG0-fHkSpUzdYucrNH45G_KF7Z82V-oyQM\";}s:2:\"id\";s:19:\"rhythm_account_menu\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-1;s:8:\"provider\";N;s:6:\"plugin\";s:25:\"system_menu_block:account\";s:8:\"settings\";a:7:{s:2:\"id\";s:25:\"system_menu_block:account\";s:5:\"label\";s:17:\"User account menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;s:16:\"expand_all_items\";b:0;}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_branding','a:13:{s:4:\"uuid\";s:36:\"413644a4-9b49-42af-b103-9bbbbffba796\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NDwadleLD3YVSbDUaakxyYZyINYtkFtOVGShfq4kWy8\";}s:2:\"id\";s:15:\"rhythm_branding\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-2;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_branding_block\";s:8:\"settings\";a:7:{s:2:\"id\";s:21:\"system_branding_block\";s:5:\"label\";s:13:\"Site branding\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:13:\"use_site_logo\";b:1;s:13:\"use_site_name\";b:1;s:15:\"use_site_slogan\";b:1;}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_breadcrumbs','a:13:{s:4:\"uuid\";s:36:\"bd3eec29-b089-4550-ac3c-88e1e8bfeba6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oXUb3JZR2WW5VOdw4HrhRicCsq51mCgLfRyvheG68ck\";}s:2:\"id\";s:18:\"rhythm_breadcrumbs\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-11;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_breadcrumb_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_breadcrumb_block\";s:5:\"label\";s:11:\"Breadcrumbs\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_content','a:13:{s:4:\"uuid\";s:36:\"d8eb0a5d-9e41-4217-a02a-c3b0a02f3d53\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9EoWV2Lot6FVSr50t4hoKgiz1LIXYWNG-IIPYsWxBqo\";}s:2:\"id\";s:14:\"rhythm_content\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-8;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_footer','a:13:{s:4:\"uuid\";s:36:\"6640a04e-6da6-4793-b4bd-a73824fcb1bf\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:18:\"system.menu.footer\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"kkISXE1LT2FJEoYnqCrCpeFB-2pmGmMxMklVk7rQcfg\";}s:2:\"id\";s:13:\"rhythm_footer\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-9;s:8:\"provider\";N;s:6:\"plugin\";s:24:\"system_menu_block:footer\";s:8:\"settings\";a:7:{s:2:\"id\";s:24:\"system_menu_block:footer\";s:5:\"label\";s:11:\"Footer menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:0;s:16:\"expand_all_items\";b:0;}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_help','a:13:{s:4:\"uuid\";s:36:\"5fc3549f-2a88-4fc4-8af8-84f016757768\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8I8iACSa0sKO3k3jlvUG1ge52rfcKX7USJAQYnzuBgg\";}s:2:\"id\";s:11:\"rhythm_help\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-12;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_local_actions','a:13:{s:4:\"uuid\";s:36:\"f6fb1e55-61db-4a15-92aa-9c411a3cab04\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"13GQpeITIJsp1kyPniXtWZfyFH87vb1xxJCHifL4UeE\";}s:2:\"id\";s:20:\"rhythm_local_actions\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"local_actions_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:19:\"local_actions_block\";s:5:\"label\";s:21:\"Primary admin actions\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_local_tasks','a:13:{s:4:\"uuid\";s:36:\"39a029fc-3be1-4d17-a8fc-46724f57dbb7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"X9I1OB0W3WlWtrK-CNcg6hNWwa8wficanpH8pYnDZDE\";}s:2:\"id\";s:18:\"rhythm_local_tasks\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-9;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:4:\"Tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_main_menu','a:13:{s:4:\"uuid\";s:36:\"c855b4d4-43bb-4b28-9537-6f9557630031\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rx9IrdDv7Ldc4kpalZAxdhIPZfYIeOMh1N-qKoQZwHo\";}s:2:\"id\";s:16:\"rhythm_main_menu\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:22:\"system_menu_block:main\";s:8:\"settings\";a:7:{s:2:\"id\";s:22:\"system_menu_block:main\";s:5:\"label\";s:15:\"Main navigation\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:0;s:16:\"expand_all_items\";b:0;}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_messages','a:13:{s:4:\"uuid\";s:36:\"49463673-9895-4d8f-8c10-765132503be2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KHQIJ7Vfl25lTjzIc7qIvnuistt-Mw2O0kG4jCofmkI\";}s:2:\"id\";s:15:\"rhythm_messages\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-11;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_page_title','a:13:{s:4:\"uuid\";s:36:\"defb8319-ed5a-4bf3-978f-c7b93a44ee0b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7rR9chwXvdM2H8OYMAYx9Zj3GGlPMrZp_M3ZA4thYTk\";}s:2:\"id\";s:17:\"rhythm_page_title\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-6;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_powered','a:13:{s:4:\"uuid\";s:36:\"6131a539-a140-4fb3-a55b-b27a52836cec\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jQQUUWN2Uxr5qZtc9zcJKBCxpKY8orN1u2HPqYYRQDI\";}s:2:\"id\";s:14:\"rhythm_powered\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-5;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_powered_by_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_powered_by_block\";s:5:\"label\";s:17:\"Powered by Drupal\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_search','a:13:{s:4:\"uuid\";s:36:\"35c3df26-caf3-4300-bff2-2af6e79427a6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"search\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"za-39d5WDUg6XvbyqSnuVYEeq6QM4qKJxW8MnoAha5A\";}s:2:\"id\";s:13:\"rhythm_search\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-3;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"search_form_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"search_form_block\";s:5:\"label\";s:6:\"Search\";s:8:\"provider\";s:6:\"search\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_sub_account_menu','a:13:{s:4:\"uuid\";s:36:\"f30bcebe-5bd4-462b-ad03-1aec0fdf8c80\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:19:\"system.menu.account\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DweBpscQZdG0-fHkSpUzdYucrNH45G_KF7Z82V-oyQM\";}s:2:\"id\";s:23:\"rhythm_sub_account_menu\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-1;s:8:\"provider\";N;s:6:\"plugin\";s:25:\"system_menu_block:account\";s:8:\"settings\";a:7:{s:2:\"id\";s:25:\"system_menu_block:account\";s:5:\"label\";s:17:\"User account menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;s:16:\"expand_all_items\";b:0;}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_sub_branding','a:13:{s:4:\"uuid\";s:36:\"5d1c6131-e67c-4ebc-aa96-2a20d76ab5fa\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NDwadleLD3YVSbDUaakxyYZyINYtkFtOVGShfq4kWy8\";}s:2:\"id\";s:19:\"rhythm_sub_branding\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-2;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_branding_block\";s:8:\"settings\";a:7:{s:2:\"id\";s:21:\"system_branding_block\";s:5:\"label\";s:13:\"Site branding\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:13:\"use_site_logo\";b:1;s:13:\"use_site_name\";b:1;s:15:\"use_site_slogan\";b:1;}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_sub_content','a:13:{s:4:\"uuid\";s:36:\"bbd8565f-9370-43d1-88c4-6d65fd6cb1b8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9EoWV2Lot6FVSr50t4hoKgiz1LIXYWNG-IIPYsWxBqo\";}s:2:\"id\";s:18:\"rhythm_sub_content\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-23;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_sub_footer','a:12:{s:4:\"uuid\";s:36:\"09ac40b0-8433-4aed-9b30-f8c955f212fc\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:ca4e996c-222b-4e10-b248-09930f18481b\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:17:\"rhythm_sub_footer\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"footer\";s:6:\"weight\";i:-11;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:ca4e996c-222b-4e10-b248-09930f18481b\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:ca4e996c-222b-4e10-b248-09930f18481b\";s:5:\"label\";s:6:\"Footer\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:15:\"gallery-images*\";s:6:\"negate\";b:1;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_gmapcontact','a:12:{s:4:\"uuid\";s:36:\"932affb1-80d9-4b1d-9e7e-df4a3ef59658\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:9406b6d7-9c11-4ae3-b5bc-ce4d6b5892ac\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:22:\"rhythm_sub_gmapcontact\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"footer\";s:6:\"weight\";i:-12;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:9406b6d7-9c11-4ae3-b5bc-ce4d6b5892ac\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:9406b6d7-9c11-4ae3-b5bc-ce4d6b5892ac\";s:5:\"label\";s:13:\"Gmap: Contact\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/74\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_gmapcontacttop','a:12:{s:4:\"uuid\";s:36:\"8b9adc07-63b5-416f-854f-1e4dd3ed8802\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:7d6a15ef-a32a-4303-b9bd-721ae7fc6e2f\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:25:\"rhythm_sub_gmapcontacttop\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-24;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:7d6a15ef-a32a-4303-b9bd-721ae7fc6e2f\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:7d6a15ef-a32a-4303-b9bd-721ae7fc6e2f\";s:5:\"label\";s:17:\"Gmap: Contact Top\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/75\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headeragencyheader','a:12:{s:4:\"uuid\";s:36:\"70f1b314-2c3a-450d-ad3b-ceb3e2d0b817\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:0f836014-c83c-4c70-a06b-010c20d64052\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:29:\"rhythm_sub_headeragencyheader\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-23;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:0f836014-c83c-4c70-a06b-010c20d64052\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:0f836014-c83c-4c70-a06b-010c20d64052\";s:5:\"label\";s:21:\"Header: Agency Header\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/16\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerbgvideofullscreen1','a:12:{s:4:\"uuid\";s:36:\"02b51bfc-c4aa-4e7c-8be7-674eb1cb7faa\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:ccc57983-ca62-407c-bc2d-cc693e7d4fab\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:35:\"rhythm_sub_headerbgvideofullscreen1\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-22;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:ccc57983-ca62-407c-bc2d-cc693e7d4fab\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:ccc57983-ca62-407c-bc2d-cc693e7d4fab\";s:5:\"label\";s:29:\"Header: BG Video FullScreen 1\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/14\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerbgvideofullscreen1onepage','a:12:{s:4:\"uuid\";s:36:\"ee6160a2-84a3-46b2-91a4-66d56130faf1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:7a5157bb-6c81-4dcf-9517-187aa57df270\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:42:\"rhythm_sub_headerbgvideofullscreen1onepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-21;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:7a5157bb-6c81-4dcf-9517-187aa57df270\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:7a5157bb-6c81-4dcf-9517-187aa57df270\";s:5:\"label\";s:39:\"Header: BG Video FullScreen 1 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/14\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerbgvideofullscreen2','a:12:{s:4:\"uuid\";s:36:\"460e4b4a-e496-46ff-bd92-d8d1b90e28af\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:ace33e6a-ca9c-41ef-b0ee-ffb6a2a52274\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:35:\"rhythm_sub_headerbgvideofullscreen2\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-20;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:ace33e6a-ca9c-41ef-b0ee-ffb6a2a52274\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:ace33e6a-ca9c-41ef-b0ee-ffb6a2a52274\";s:5:\"label\";s:29:\"Header: BG Video FullScreen 2\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/15\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerbgvideofullscreen2onepage','a:12:{s:4:\"uuid\";s:36:\"e5641eec-7872-4d6a-81f5-f0a5b54631a2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:90013c4e-6be7-4967-bcd1-623ff20502df\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:42:\"rhythm_sub_headerbgvideofullscreen2onepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-19;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:90013c4e-6be7-4967-bcd1-623ff20502df\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:90013c4e-6be7-4967-bcd1-623ff20502df\";s:5:\"label\";s:39:\"Header: BG Video FullScreen 2 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/15\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerbgvideofullwidth','a:12:{s:4:\"uuid\";s:36:\"eebd65e3-6d0c-4c1d-b3d3-e7d6d4e4a531\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:71affffc-cffa-4790-93df-5f7d6790619a\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:33:\"rhythm_sub_headerbgvideofullwidth\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-18;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:71affffc-cffa-4790-93df-5f7d6790619a\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:71affffc-cffa-4790-93df-5f7d6790619a\";s:5:\"label\";s:26:\"Header: BG Video Fullwidth\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/13\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerbgvideofullwidthonepage','a:12:{s:4:\"uuid\";s:36:\"6d0cc7c3-809b-4664-af31-7b6d8f8bcda8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:105211ef-6551-4e9c-816c-39c118e2b0f2\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:40:\"rhythm_sub_headerbgvideofullwidthonepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-17;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:105211ef-6551-4e9c-816c-39c118e2b0f2\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:105211ef-6551-4e9c-816c-39c118e2b0f2\";s:5:\"label\";s:36:\"Header: BG Video Fullwidth - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/13\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerdarkmain','a:12:{s:4:\"uuid\";s:36:\"b67a7d60-ae37-46ee-b083-5182615d98fd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:0b6370a9-be73-4701-bb5b-719f350f0927\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:25:\"rhythm_sub_headerdarkmain\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-25;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:0b6370a9-be73-4701-bb5b-719f350f0927\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:0b6370a9-be73-4701-bb5b-719f350f0927\";s:5:\"label\";s:16:\"Header Dark MAIN\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:385:\"/node/48\r\n/node/54\r\n/node/55\r\n/node/101\r\n/node/103\r\ncontent/contact-1\r\ncontent/contact-2\r\ncontent/landing-page\r\ncontent/main-demo\r\ncontent/all-demos\r\ncontent/about-us-1\r\ncontent/services-1\r\ncontent/services-2\r\ncontent/services-3\r\ncontent/team-1\r\ncontent/faq-1\r\ncontent/faq-2\r\ncontent/pricing-1\r\ngallery*\r\nportfolio-promo\r\nblog*\r\nportfolio-item*\r\n<front>\r\n/home/*\r\n/onepage/*\r\n/node/102\";s:6:\"negate\";b:1;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerdarktransparent','a:12:{s:4:\"uuid\";s:36:\"2fbf239e-e24a-48e0-82ab-6d4c81b0be31\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:6a9dbf83-77b0-4d60-81e6-4ae5da969bce\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:32:\"rhythm_sub_headerdarktransparent\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-25;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:6a9dbf83-77b0-4d60-81e6-4ae5da969bce\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:6a9dbf83-77b0-4d60-81e6-4ae5da969bce\";s:5:\"label\";s:23:\"Header Dark Transparent\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/48\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerfullwidthimage','a:12:{s:4:\"uuid\";s:36:\"7aab4005-7324-4c90-9eb7-ec0b8c4a0184\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:907807f0-9207-4580-8336-3c6f41767dde\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:31:\"rhythm_sub_headerfullwidthimage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-16;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:907807f0-9207-4580-8336-3c6f41767dde\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:907807f0-9207-4580-8336-3c6f41767dde\";s:5:\"label\";s:23:\"Header: Fullwidth Image\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/6\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerfullwidthimageonepage','a:12:{s:4:\"uuid\";s:36:\"b1bf7b33-11e9-4ef6-b38c-89428eea1fd4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:ac670683-9f00-4dc6-b4d4-4ff3497e48d0\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:38:\"rhythm_sub_headerfullwidthimageonepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-14;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:ac670683-9f00-4dc6-b4d4-4ff3497e48d0\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:ac670683-9f00-4dc6-b4d4-4ff3497e48d0\";s:5:\"label\";s:33:\"Header: Fullwidth Image - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/7\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax1','a:12:{s:4:\"uuid\";s:36:\"0b04ff76-752c-480d-a5b0-de65ebb3f76e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:3349535d-91e6-40ae-9177-58513f4cd5f6\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:31:\"rhythm_sub_headerimageparallax1\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-15;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:3349535d-91e6-40ae-9177-58513f4cd5f6\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:3349535d-91e6-40ae-9177-58513f4cd5f6\";s:5:\"label\";s:24:\"Header: Image Parallax 1\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/1\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax1onepage','a:12:{s:4:\"uuid\";s:36:\"0f09ac4a-6c70-48a6-8e28-38ad3f6287e6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:a728edbb-0a33-4c10-89b8-dafda2501620\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:38:\"rhythm_sub_headerimageparallax1onepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:a728edbb-0a33-4c10-89b8-dafda2501620\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:a728edbb-0a33-4c10-89b8-dafda2501620\";s:5:\"label\";s:34:\"Header: Image Parallax 1 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/1\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax2','a:12:{s:4:\"uuid\";s:36:\"0f5f0b78-98d3-44c7-a32a-fef9d8cb1f33\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:24d7103c-7e8f-4452-add5-9ce850946d3e\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:31:\"rhythm_sub_headerimageparallax2\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-13;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:24d7103c-7e8f-4452-add5-9ce850946d3e\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:24d7103c-7e8f-4452-add5-9ce850946d3e\";s:5:\"label\";s:24:\"Header: Image Parallax 2\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/2\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax2onepage','a:12:{s:4:\"uuid\";s:36:\"c8ccbb73-7ce6-4c06-b638-2c74321a1e3b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:371c38c9-61b6-4b61-813c-e781c77d9a2b\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:38:\"rhythm_sub_headerimageparallax2onepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-12;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:371c38c9-61b6-4b61-813c-e781c77d9a2b\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:371c38c9-61b6-4b61-813c-e781c77d9a2b\";s:5:\"label\";s:34:\"Header: Image Parallax 2 - Onepage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/2\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax3','a:12:{s:4:\"uuid\";s:36:\"370b9f43-64b4-4a2a-9780-12fd9152f75d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:cbea5a9b-6fdb-4634-81b2-a6813f136a28\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:31:\"rhythm_sub_headerimageparallax3\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-11;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:cbea5a9b-6fdb-4634-81b2-a6813f136a28\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:cbea5a9b-6fdb-4634-81b2-a6813f136a28\";s:5:\"label\";s:24:\"Header: Image Parallax 3\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/3\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax3onepage','a:12:{s:4:\"uuid\";s:36:\"664162b8-4194-490e-bafe-1eb24a3f6e3d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:5fa9ccfc-0083-4023-9905-f4c1e9969098\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:38:\"rhythm_sub_headerimageparallax3onepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:5fa9ccfc-0083-4023-9905-f4c1e9969098\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:5fa9ccfc-0083-4023-9905-f4c1e9969098\";s:5:\"label\";s:34:\"Header: Image Parallax 3 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/3\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax4','a:12:{s:4:\"uuid\";s:36:\"00373451-f262-4026-b1d9-1f33315a0f36\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:e9cb56b9-8887-4f6c-9c9f-ff621ad1a410\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:31:\"rhythm_sub_headerimageparallax4\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-9;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:e9cb56b9-8887-4f6c-9c9f-ff621ad1a410\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:e9cb56b9-8887-4f6c-9c9f-ff621ad1a410\";s:5:\"label\";s:24:\"Header: Image Parallax 4\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/4\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax4onepage','a:12:{s:4:\"uuid\";s:36:\"9ef9d7c8-6f04-4d5b-b27d-352c1111d3f9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:7c4c579e-1361-49a3-a6d3-4f5f9529d16d\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:38:\"rhythm_sub_headerimageparallax4onepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-8;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:7c4c579e-1361-49a3-a6d3-4f5f9529d16d\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:7c4c579e-1361-49a3-a6d3-4f5f9529d16d\";s:5:\"label\";s:34:\"Header: Image Parallax 4 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/4\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax5','a:12:{s:4:\"uuid\";s:36:\"b4da920b-8548-4f35-a385-4b0e0044bb11\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b397d2ca-dcde-4faa-9a97-9b4424b233b7\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:31:\"rhythm_sub_headerimageparallax5\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b397d2ca-dcde-4faa-9a97-9b4424b233b7\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b397d2ca-dcde-4faa-9a97-9b4424b233b7\";s:5:\"label\";s:24:\"Header: Image Parallax 5\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/5\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerimageparallax5onepage','a:12:{s:4:\"uuid\";s:36:\"856ef520-4ebd-458e-b64c-2553dec4ddd6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b8196462-3d3f-42cd-865e-2070173cd6a7\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:38:\"rhythm_sub_headerimageparallax5onepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-6;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b8196462-3d3f-42cd-865e-2070173cd6a7\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b8196462-3d3f-42cd-865e-2070173cd6a7\";s:5:\"label\";s:34:\"Header: Image Parallax 5 - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/5\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headermaindemo','a:12:{s:4:\"uuid\";s:36:\"c792217e-9ad2-463a-97cb-bcf64e8c4723\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:5383c346-1e60-4cfb-b197-f2c3cf81ff32\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:25:\"rhythm_sub_headermaindemo\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-25;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:5383c346-1e60-4cfb-b197-f2c3cf81ff32\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:5383c346-1e60-4cfb-b197-f2c3cf81ff32\";s:5:\"label\";s:17:\"Header: Main Demo\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headermaindemoonepage','a:12:{s:4:\"uuid\";s:36:\"17f72c76-8aba-44ba-86ba-11b735e498f6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:fddb3dae-ff3f-4eab-b348-53afefc651b5\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:32:\"rhythm_sub_headermaindemoonepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-5;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:fddb3dae-ff3f-4eab-b348-53afefc651b5\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:fddb3dae-ff3f-4eab-b348-53afefc651b5\";s:5:\"label\";s:27:\"Header: Main Demo - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:9:\"/node/102\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headermaindemoonepage_2','a:12:{s:4:\"uuid\";s:36:\"2243e9b8-a322-496c-8b91-885f3b6edb6c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:fddb3dae-ff3f-4eab-b348-53afefc651b5\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:34:\"rhythm_sub_headermaindemoonepage_2\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:fddb3dae-ff3f-4eab-b348-53afefc651b5\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:fddb3dae-ff3f-4eab-b348-53afefc651b5\";s:5:\"label\";s:27:\"Header: Main Demo - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/0\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headersliderbackground','a:12:{s:4:\"uuid\";s:36:\"cd122023-e3fe-4c65-bde9-1e48021ab865\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:1411a6d8-cbeb-4474-b584-62163cc624d4\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:33:\"rhythm_sub_headersliderbackground\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-4;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:1411a6d8-cbeb-4474-b584-62163cc624d4\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:1411a6d8-cbeb-4474-b584-62163cc624d4\";s:5:\"label\";s:25:\"Header: Slider Background\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/11\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headersliderbackgroundonepage','a:12:{s:4:\"uuid\";s:36:\"0872ac0e-5591-4288-84d1-f9131ddbc035\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:24110089-987a-4a14-a6ed-89553666f7df\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:40:\"rhythm_sub_headersliderbackgroundonepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-3;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:24110089-987a-4a14-a6ed-89553666f7df\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:24110089-987a-4a14-a6ed-89553666f7df\";s:5:\"label\";s:35:\"Header: Slider Background - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/11\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headersliderfullscreen','a:12:{s:4:\"uuid\";s:36:\"a3a59cb6-9215-4a01-9bb0-096116abd034\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b0802411-d5eb-4a16-a6d6-ff7024e3dd34\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:33:\"rhythm_sub_headersliderfullscreen\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-2;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b0802411-d5eb-4a16-a6d6-ff7024e3dd34\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b0802411-d5eb-4a16-a6d6-ff7024e3dd34\";s:5:\"label\";s:25:\"Header: Slider Fullscreen\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/8\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headersliderfullscreenonepage','a:12:{s:4:\"uuid\";s:36:\"c3d5d145-a8f4-4fa4-8d8d-e9ad3153d8a5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:21382078-dc04-4156-8562-c6bb4e02f0e1\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:40:\"rhythm_sub_headersliderfullscreenonepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-1;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:21382078-dc04-4156-8562-c6bb4e02f0e1\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:21382078-dc04-4156-8562-c6bb4e02f0e1\";s:5:\"label\";s:35:\"Header: Slider Fullscreen - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/8\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headersliderfullwidth','a:12:{s:4:\"uuid\";s:36:\"2822e449-fc8a-453c-b626-86ac2f1bdb4a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:96e17d3d-5c4b-4699-95f9-ed2c65add661\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:32:\"rhythm_sub_headersliderfullwidth\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:96e17d3d-5c4b-4699-95f9-ed2c65add661\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:96e17d3d-5c4b-4699-95f9-ed2c65add661\";s:5:\"label\";s:24:\"Header: Slider Fullwidth\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/10\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headersliderfullwidthonepage','a:12:{s:4:\"uuid\";s:36:\"04d92947-dd24-4a6f-bd7a-be6c00d20a2d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:d1a11564-3551-4347-b5bc-3a8cd1b894ed\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:39:\"rhythm_sub_headersliderfullwidthonepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:1;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:d1a11564-3551-4347-b5bc-3a8cd1b894ed\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:d1a11564-3551-4347-b5bc-3a8cd1b894ed\";s:5:\"label\";s:34:\"Header: Slider Fullwidth - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/10\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headersliderzoomeffect','a:12:{s:4:\"uuid\";s:36:\"c3e70a80-534a-42be-982e-b027035cba7c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:2aa33a4b-bb38-4f6a-9c66-5cc5c7f27094\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:33:\"rhythm_sub_headersliderzoomeffect\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:2;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:2aa33a4b-bb38-4f6a-9c66-5cc5c7f27094\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:2aa33a4b-bb38-4f6a-9c66-5cc5c7f27094\";s:5:\"label\";s:26:\"Header: Slider Zoom Effect\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/9\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headersliderzoomeffectonepage','a:12:{s:4:\"uuid\";s:36:\"f15d14f9-a95b-446a-b25b-efb57c5b70fe\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b9039c91-c46f-4831-991d-a9f2d08cf7cf\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:40:\"rhythm_sub_headersliderzoomeffectonepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:3;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b9039c91-c46f-4831-991d-a9f2d08cf7cf\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b9039c91-c46f-4831-991d-a9f2d08cf7cf\";s:5:\"label\";s:36:\"Header: Slider Zoom Effect - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/9\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerspecialphotography','a:12:{s:4:\"uuid\";s:36:\"9ff86076-a02d-47f4-825d-e031775668bb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:4e4c5a44-2bf9-4b6a-9fc7-c4c77854c4f2\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:35:\"rhythm_sub_headerspecialphotography\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:4;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:4e4c5a44-2bf9-4b6a-9fc7-c4c77854c4f2\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:4e4c5a44-2bf9-4b6a-9fc7-c4c77854c4f2\";s:5:\"label\";s:27:\"Header: Special Photography\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:9:\"/node/101\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerspecialphotographyonepage','a:12:{s:4:\"uuid\";s:36:\"7b209f30-1665-4a86-8e38-a32316cd2bfb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:d5849bbf-634c-46be-8079-41e31edc2f28\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:42:\"rhythm_sub_headerspecialphotographyonepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:5;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:d5849bbf-634c-46be-8079-41e31edc2f28\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:d5849bbf-634c-46be-8079-41e31edc2f28\";s:5:\"label\";s:37:\"Header: Special Photography - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:9:\"/node/103\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headertextrotator','a:12:{s:4:\"uuid\";s:36:\"d76941cf-3169-45fa-bf31-74910cf5bf76\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:02bde269-1d46-4ba4-aa78-811bb904f0cc\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:28:\"rhythm_sub_headertextrotator\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:6;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:02bde269-1d46-4ba4-aa78-811bb904f0cc\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:02bde269-1d46-4ba4-aa78-811bb904f0cc\";s:5:\"label\";s:20:\"Header: Text Rotator\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"/home/7\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headertextrotatoronepage','a:12:{s:4:\"uuid\";s:36:\"09491eac-2686-4f01-90bd-ec46edef0afa\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b0bd13b5-c922-4792-945f-15414b01b7c3\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:35:\"rhythm_sub_headertextrotatoronepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:7;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b0bd13b5-c922-4792-945f-15414b01b7c3\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b0bd13b5-c922-4792-945f-15414b01b7c3\";s:5:\"label\";s:30:\"Header: Text Rotator - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/onepage/8\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerwhite','a:12:{s:4:\"uuid\";s:36:\"3b82cdf8-8b5b-4b30-b17c-4080f7badb49\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:52a10536-56b5-4eb7-8df9-33230c18ba31\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:22:\"rhythm_sub_headerwhite\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-25;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:52a10536-56b5-4eb7-8df9-33230c18ba31\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:52a10536-56b5-4eb7-8df9-33230c18ba31\";s:5:\"label\";s:12:\"Header White\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/54\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerwhitetransparent','a:12:{s:4:\"uuid\";s:36:\"c8975b71-7c7c-433a-a98a-e66c0a94e9ca\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:653038ca-8c0b-4717-99d5-c3acc664d7af\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:33:\"rhythm_sub_headerwhitetransparent\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-25;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:653038ca-8c0b-4717-99d5-c3acc664d7af\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:653038ca-8c0b-4717-99d5-c3acc664d7af\";s:5:\"label\";s:24:\"Header White Transparent\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/node/55\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerwithplaybutton','a:12:{s:4:\"uuid\";s:36:\"c4e0a1cc-8ca9-46be-88f1-13d29f4ef409\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:3e57c7df-fc44-497a-b5d3-101a4180545b\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:31:\"rhythm_sub_headerwithplaybutton\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:8;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:3e57c7df-fc44-497a-b5d3-101a4180545b\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:3e57c7df-fc44-497a-b5d3-101a4180545b\";s:5:\"label\";s:24:\"Header: With Play Button\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:8:\"/home/12\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_headerwithplaybuttononepage','a:12:{s:4:\"uuid\";s:36:\"4d6c4b5e-01c7-4500-8fbe-2000435e7c99\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:8379ba0a-99cf-4d6c-92bc-b0713eabb68a\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:38:\"rhythm_sub_headerwithplaybuttononepage\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:9;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:8379ba0a-99cf-4d6c-92bc-b0713eabb68a\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:8379ba0a-99cf-4d6c-92bc-b0713eabb68a\";s:5:\"label\";s:34:\"Header: With Play Button - OnePage\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:11:\"/onepage/12\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.rhythm_sub_languageswitcher','a:12:{s:4:\"uuid\";s:36:\"ce828c05-82a9-4870-8ab1-e6dabea55e25\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:8:\"language\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:27:\"rhythm_sub_languageswitcher\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-8;s:8:\"provider\";N;s:6:\"plugin\";s:33:\"language_block:language_interface\";s:8:\"settings\";a:4:{s:2:\"id\";s:33:\"language_block:language_interface\";s:5:\"label\";s:17:\"Language switcher\";s:8:\"provider\";s:8:\"language\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.rhythm_sub_relatedprojects','a:12:{s:4:\"uuid\";s:36:\"090f80eb-5824-4b2a-a760-f299ea9779a2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:7bf565ba-d4c0-4dbb-88d7-3a62af679d29\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"node\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:26:\"rhythm_sub_relatedprojects\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-22;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:7bf565ba-d4c0-4dbb-88d7-3a62af679d29\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:7bf565ba-d4c0-4dbb-88d7-3a62af679d29\";s:5:\"label\";s:16:\"Related Projects\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:9:\"node_type\";a:4:{s:2:\"id\";s:9:\"node_type\";s:7:\"bundles\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}s:6:\"negate\";b:0;s:15:\"context_mapping\";a:1:{s:4:\"node\";s:29:\"@node.node_route_context:node\";}}}}'),

('','block.block.rhythm_tools','a:13:{s:4:\"uuid\";s:36:\"f5934bc7-4e63-45e8-ae47-527a583401cb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:17:\"system.menu.tools\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NeHSoqm4XFqA7_0bDmR429ZZQt3LRbZMNRJTMsFyOfI\";}s:2:\"id\";s:12:\"rhythm_tools\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_menu_block:tools\";s:8:\"settings\";a:7:{s:2:\"id\";s:23:\"system_menu_block:tools\";s:5:\"label\";s:5:\"Tools\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:7:\"visible\";s:5:\"level\";i:1;s:5:\"depth\";i:0;s:16:\"expand_all_items\";b:0;}s:10:\"visibility\";a:0:{}}'),

('','block.block.seven_breadcrumbs','a:13:{s:4:\"uuid\";s:36:\"23b8b5c4-92a8-45f5-97f8-80d3b7aca2b2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WWu2OQswgCztl9OeXjD1stexIEMZsSgPMYIdC-JHx9c\";}s:2:\"id\";s:17:\"seven_breadcrumbs\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:10:\"breadcrumb\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_breadcrumb_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_breadcrumb_block\";s:5:\"label\";s:11:\"Breadcrumbs\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.seven_content','a:13:{s:4:\"uuid\";s:36:\"bc646bf3-7526-49e4-9f95-62175c6d19c4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"YRY68JWkaUiGeZlWMv1nzeIgDm0ZZwXYgpqUpLFzwAY\";}s:2:\"id\";s:13:\"seven_content\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.seven_help','a:13:{s:4:\"uuid\";s:36:\"27d309a7-4d3e-43ca-9e39-cbb15c06a524\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NU5A_49mwLHfs5xFzMFrZ850w9pgUolxMS9NNF3vv4c\";}s:2:\"id\";s:10:\"seven_help\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:4:\"help\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.seven_local_actions','a:13:{s:4:\"uuid\";s:36:\"2e7990dc-5dec-4780-88b9-0bc2510fae36\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"HHryZVJbeKi9WnuBGC8FOhBZmBnk2G1H6KxFuy-rC9A\";}s:2:\"id\";s:19:\"seven_local_actions\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"local_actions_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:19:\"local_actions_block\";s:5:\"label\";s:21:\"Primary admin actions\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.seven_login','a:13:{s:4:\"uuid\";s:36:\"51508430-a627-40d0-9d66-df8864eca354\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"IItlF4SKHgxduIysVQdvirDJ_v3HGuAviOkidAOJYRE\";}s:2:\"id\";s:11:\"seven_login\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:10;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"user_login_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"user_login_block\";s:5:\"label\";s:10:\"User login\";s:8:\"provider\";s:4:\"user\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.seven_messages','a:13:{s:4:\"uuid\";s:36:\"c09c2459-4324-44a1-a9b6-cf91aa754dbe\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"XJqWwLt1LDCnazcEN6QkJmCLjk4R0__-8s0OO9xeNjg\";}s:2:\"id\";s:14:\"seven_messages\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.seven_page_title','a:13:{s:4:\"uuid\";s:36:\"2bed48a0-b7f7-4dea-9923-2682efd94018\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ZSpc3IoSaLd0PkB02nxjVPBMztIdsTdHek9SiGaqZ_c\";}s:2:\"id\";s:16:\"seven_page_title\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-30;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),

('','block.block.seven_primary_local_tasks','a:13:{s:4:\"uuid\";s:36:\"98c09a7f-553a-498c-ac87-288f13f365e0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ddy1OsBbWxjwEI8VL1viD4I69qcLHOkul4BxbTqLBTs\";}s:2:\"id\";s:25:\"seven_primary_local_tasks\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:12:\"Primary tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:0;}s:10:\"visibility\";a:0:{}}'),

('','block.block.seven_secondary_local_tasks','a:13:{s:4:\"uuid\";s:36:\"51cea072-aeaa-4e8c-9858-9c7cbb7dae64\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QeZBeCilQfeET3GeW6ZtJkEiwROADTZktFgKWwPieD4\";}s:2:\"id\";s:27:\"seven_secondary_local_tasks\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:11:\"pre_content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:14:\"Secondary tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:0;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}'),

('','block.block.shop4columns','a:12:{s:4:\"uuid\";s:36:\"8a1a12bd-1738-4da6-b226-015f687c7d24\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b1ba8190-4ca2-4150-a6ec-06d571eab1a0\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:12:\"shop4columns\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b1ba8190-4ca2-4150-a6ec-06d571eab1a0\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b1ba8190-4ca2-4150-a6ec-06d571eab1a0\";s:5:\"label\";s:14:\"Shop 4 Columns\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:15:\"/4-columns-shop\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.tabs','a:12:{s:4:\"uuid\";s:36:\"c87719bc-efdf-4b10-a202-ca4973277bc9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:4:\"tabs\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-24;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:4:\"Tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}'),

('','block.block.textwidget','a:12:{s:4:\"uuid\";s:36:\"2a976291-60ea-4724-8d86-59ab2d40a920\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:d2b2af3a-4ec7-42e3-86b9-a30492bc3970\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:10:\"textwidget\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"sidebar\";s:6:\"weight\";i:-22;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:d2b2af3a-4ec7-42e3-86b9-a30492bc3970\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:d2b2af3a-4ec7-42e3-86b9-a30492bc3970\";s:5:\"label\";s:11:\"Text Widget\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:7:\"visible\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:173:\"/shop*\r\n/blog-item/new-web-design-trends-2015-year\r\n/blog-item/minimalistic-design-forever\r\n/blog-sidebar-left\r\n/blog-sidebar-right\r\n/blog-2-columns\r\n/blog-masonry-2-columns\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.views_block__products_best_sellers_block','a:12:{s:4:\"uuid\";s:36:\"666f95cf-9db9-4f53-a414-27d1a2caaf5e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:32:\"views.view.products_best_sellers\";}s:6:\"module\";a:2:{i:0;s:6:\"system\";i:1;s:5:\"views\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:40:\"views_block__products_best_sellers_block\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"sidebar\";s:6:\"weight\";i:-25;s:8:\"provider\";N;s:6:\"plugin\";s:39:\"views_block:products_best_sellers-block\";s:8:\"settings\";a:6:{s:2:\"id\";s:39:\"views_block:products_best_sellers-block\";s:5:\"label\";s:0:\"\";s:8:\"provider\";s:5:\"views\";s:13:\"label_display\";s:7:\"visible\";s:11:\"views_label\";s:0:\"\";s:14:\"items_per_page\";s:4:\"none\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:6:\"/shop*\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.views_block__products_comments_block_1','a:12:{s:4:\"uuid\";s:36:\"255b74f2-152e-42ba-ac1a-657027defd3c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:28:\"views.view.products_comments\";}s:6:\"module\";a:2:{i:0;s:6:\"system\";i:1;s:5:\"views\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:38:\"views_block__products_comments_block_1\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"sidebar\";s:6:\"weight\";i:-23;s:8:\"provider\";N;s:6:\"plugin\";s:37:\"views_block:products_comments-block_1\";s:8:\"settings\";a:6:{s:2:\"id\";s:37:\"views_block:products_comments-block_1\";s:5:\"label\";s:8:\"Comments\";s:8:\"provider\";s:5:\"views\";s:13:\"label_display\";s:7:\"visible\";s:11:\"views_label\";s:8:\"Comments\";s:14:\"items_per_page\";s:4:\"none\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:6:\"/shop*\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.views_block__products_tags_block','a:12:{s:4:\"uuid\";s:36:\"f52ee1b9-2c69-45e6-b70a-a8a898a42a15\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:24:\"views.view.products_tags\";}s:6:\"module\";a:2:{i:0;s:6:\"system\";i:1;s:5:\"views\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:32:\"views_block__products_tags_block\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"sidebar\";s:6:\"weight\";i:-24;s:8:\"provider\";N;s:6:\"plugin\";s:31:\"views_block:products_tags-block\";s:8:\"settings\";a:6:{s:2:\"id\";s:31:\"views_block:products_tags-block\";s:5:\"label\";s:4:\"Tags\";s:8:\"provider\";s:5:\"views\";s:13:\"label_display\";s:7:\"visible\";s:11:\"views_label\";s:4:\"Tags\";s:14:\"items_per_page\";s:4:\"none\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:173:\"/shop*\r\n/blog-item/new-web-design-trends-2015-year\r\n/blog-item/minimalistic-design-forever\r\n/blog-sidebar-left\r\n/blog-sidebar-right\r\n/blog-2-columns\r\n/blog-masonry-2-columns\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.views_block__related_products_block_1','a:12:{s:4:\"uuid\";s:36:\"3702c98a-327e-4204-8950-9bc4ffb6d7da\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:27:\"views.view.related_products\";}s:6:\"module\";a:2:{i:0;s:6:\"system\";i:1;s:5:\"views\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:37:\"views_block__related_products_block_1\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:36:\"views_block:related_products-block_1\";s:8:\"settings\";a:6:{s:2:\"id\";s:36:\"views_block:related_products-block_1\";s:5:\"label\";s:0:\"\";s:8:\"provider\";s:5:\"views\";s:13:\"label_display\";s:7:\"visible\";s:11:\"views_label\";s:0:\"\";s:14:\"items_per_page\";s:4:\"none\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:10:\"/product/*\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.views_block__related_projects_block_1','a:12:{s:4:\"uuid\";s:36:\"fc994139-80de-4266-9c3c-cdf5766d5eae\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:27:\"views.view.related_projects\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:5:\"views\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:37:\"views_block__related_projects_block_1\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-4;s:8:\"provider\";N;s:6:\"plugin\";s:36:\"views_block:related_projects-block_1\";s:8:\"settings\";a:6:{s:2:\"id\";s:36:\"views_block:related_projects-block_1\";s:5:\"label\";s:0:\"\";s:8:\"provider\";s:5:\"views\";s:13:\"label_display\";s:7:\"visible\";s:11:\"views_label\";s:0:\"\";s:14:\"items_per_page\";s:4:\"none\";}s:10:\"visibility\";a:1:{s:9:\"node_type\";a:4:{s:2:\"id\";s:9:\"node_type\";s:7:\"bundles\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}s:6:\"negate\";b:0;s:15:\"context_mapping\";a:1:{s:4:\"node\";s:29:\"@node.node_route_context:node\";}}}}'),

('','block.block.views_block__shop_categories_block','a:12:{s:4:\"uuid\";s:36:\"acddd933-ea2d-436e-9d38-17103ee44f00\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:26:\"views.view.shop_categories\";}s:6:\"module\";a:2:{i:0;s:6:\"system\";i:1;s:5:\"views\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:34:\"views_block__shop_categories_block\";s:5:\"theme\";s:10:\"rhythm_sub\";s:6:\"region\";s:7:\"sidebar\";s:6:\"weight\";i:-26;s:8:\"provider\";N;s:6:\"plugin\";s:33:\"views_block:shop_categories-block\";s:8:\"settings\";a:6:{s:2:\"id\";s:33:\"views_block:shop_categories-block\";s:5:\"label\";s:0:\"\";s:8:\"provider\";s:5:\"views\";s:13:\"label_display\";s:7:\"visible\";s:11:\"views_label\";s:0:\"\";s:14:\"items_per_page\";s:4:\"none\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:6:\"/shop*\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block.block.wanttoworkwithus','a:12:{s:4:\"uuid\";s:36:\"1347b61a-323d-41b9-bd7c-8751a1812999\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:73ce061d-fb5d-4361-b842-95475bbcb67b\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"rhythm\";}}s:2:\"id\";s:16:\"wanttoworkwithus\";s:5:\"theme\";s:6:\"rhythm\";s:6:\"region\";s:6:\"footer\";s:6:\"weight\";i:-13;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:73ce061d-fb5d-4361-b842-95475bbcb67b\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:73ce061d-fb5d-4361-b842-95475bbcb67b\";s:5:\"label\";s:21:\"Want to work with us?\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:27:\"/node/16\r\n/node/64\r\n<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),

('','block_content.type.basic','a:9:{s:4:\"uuid\";s:36:\"37d3192a-f3d9-4fa0-b933-2764c23fe3e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"zglzjmYxi0G0ag9MZ02y0LSJOdpWRwJxyP_OvFojFyo\";}s:2:\"id\";s:5:\"basic\";s:5:\"label\";s:11:\"Basic block\";s:8:\"revision\";i:0;s:11:\"description\";s:42:\"A basic block contains a title and a body.\";}'),

('','comment.settings','a:1:{s:16:\"log_ip_addresses\";b:1;}'),

('','comment.type.comment','a:9:{s:4:\"uuid\";s:36:\"33c5a8c8-4b95-42e0-8853-09dd350bf461\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"bqZsN31T2n0UjcbyCpOPi9D2iO0sAOHR7FnEs9qMvaA\";}s:2:\"id\";s:7:\"comment\";s:5:\"label\";s:16:\"Default comments\";s:21:\"target_entity_type_id\";s:4:\"node\";s:11:\"description\";s:28:\"Allows commenting on content\";}'),

('','comment.type.default_reviews','a:8:{s:4:\"uuid\";s:36:\"41e10ade-3f2d-4682-9fd4-0da40f591d64\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:2:\"id\";s:15:\"default_reviews\";s:5:\"label\";s:15:\"Default reviews\";s:21:\"target_entity_type_id\";s:16:\"commerce_product\";s:11:\"description\";s:29:\"Allows commenting on products\";}'),

('','commerce_checkout.commerce_checkout_flow.default','a:9:{s:4:\"uuid\";s:36:\"e7bf6f91-1296-40c6-972a-21d0afb97b61\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wwkDVBiXUqSzRifJbb71ajFBklJdNJ_DgS67IF-_qgY\";}s:2:\"id\";s:7:\"default\";s:5:\"label\";s:7:\"Default\";s:6:\"plugin\";s:17:\"multistep_default\";s:13:\"configuration\";a:2:{s:25:\"display_checkout_progress\";b:1;s:5:\"panes\";a:6:{s:5:\"login\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:19:\"contact_information\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:19:\"billing_information\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:2;}s:6:\"review\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:18:\"completion_message\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:13:\"order_summary\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}}}}'),

('','commerce_order.commerce_order_item_type.default','a:10:{s:4:\"uuid\";s:36:\"2cd74ffd-939d-4376-a7ed-af33ccd29c86\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jNPt_s6r5tiynMJ5tvaDZjlOtQ4ply0Ii-GBJ7lMZ7Y\";}s:5:\"label\";s:7:\"Default\";s:2:\"id\";s:7:\"default\";s:21:\"purchasableEntityType\";s:26:\"commerce_product_variation\";s:9:\"orderType\";s:7:\"default\";s:6:\"traits\";a:0:{}}'),

('','commerce_order.commerce_order_type.default','a:13:{s:4:\"uuid\";s:36:\"0d00ceb7-872d-411e-9a6f-5873ec373424\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"zf7YA-OOtWhhrphbf3YOlc49POwC9rePktH9cBavEiA\";}s:5:\"label\";s:7:\"Default\";s:2:\"id\";s:7:\"default\";s:8:\"workflow\";s:13:\"order_default\";s:6:\"traits\";a:0:{}s:12:\"refresh_mode\";s:8:\"customer\";s:17:\"refresh_frequency\";i:300;s:11:\"sendReceipt\";b:1;s:10:\"receiptBcc\";s:0:\"\";}'),

('','commerce_payment.commerce_payment_gateway.payment_gateway_example','a:9:{s:4:\"uuid\";s:36:\"e4104691-70cf-4d28-ab6b-e043d0359249\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:24:\"commerce_payment_example\";}}s:2:\"id\";s:23:\"payment_gateway_example\";s:5:\"label\";s:23:\"Payment gateway Example\";s:6:\"weight\";N;s:6:\"plugin\";s:24:\"example_offsite_redirect\";s:13:\"configuration\";a:3:{s:15:\"redirect_method\";s:4:\"post\";s:4:\"mode\";s:4:\"test\";s:20:\"payment_method_types\";a:1:{i:0;s:11:\"credit_card\";}}}'),

('','commerce_price.commerce_currency.USD','a:9:{s:4:\"uuid\";s:36:\"d6f2c027-2ac8-4fd7-a893-5912eeab7013\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:12:\"currencyCode\";s:3:\"USD\";s:4:\"name\";s:9:\"US Dollar\";s:11:\"numericCode\";s:3:\"840\";s:6:\"symbol\";s:1:\"$\";s:14:\"fractionDigits\";i:2;}'),

('','commerce_product.commerce_product_attribute.color','a:7:{s:4:\"uuid\";s:36:\"2a611036-881a-4bd0-a1f8-4680c3390f9d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:2:\"id\";s:5:\"color\";s:5:\"label\";s:5:\"Color\";s:11:\"elementType\";s:6:\"select\";}'),

('','commerce_product.commerce_product_attribute.size','a:7:{s:4:\"uuid\";s:36:\"e92d4e7f-0ccc-42ef-b5a4-953f0fd2a584\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:2:\"id\";s:4:\"size\";s:5:\"label\";s:4:\"Size\";s:11:\"elementType\";s:6:\"select\";}'),

('','commerce_product.commerce_product_type.default','a:11:{s:4:\"uuid\";s:36:\"b61277a1-1b8b-474d-a854-110140d836b6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"96ryTApvzUl00vKGZusJUDgPHQALAKN8Mb13Jxm02KU\";}s:2:\"id\";s:7:\"default\";s:5:\"label\";s:7:\"Default\";s:11:\"description\";s:0:\"\";s:13:\"variationType\";s:7:\"default\";s:21:\"injectVariationFields\";b:1;s:6:\"traits\";a:0:{}}'),

('','commerce_product.commerce_product_type.product_display','a:10:{s:4:\"uuid\";s:36:\"bba72e99-15a4-426d-9915-4d717dae6655\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:2:\"id\";s:15:\"product_display\";s:5:\"label\";s:15:\"Product Display\";s:11:\"description\";s:0:\"\";s:13:\"variationType\";s:7:\"product\";s:21:\"injectVariationFields\";b:1;s:6:\"traits\";a:0:{}}'),

('','commerce_product.commerce_product_variation_type.default','a:10:{s:4:\"uuid\";s:36:\"1d91e425-a007-416f-aec8-c5d6f7d2ebb3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QPuFH9E4612ox18hXdUXL8FhU021rCvOtYISSmvMQzc\";}s:2:\"id\";s:7:\"default\";s:5:\"label\";s:7:\"Default\";s:13:\"orderItemType\";s:7:\"default\";s:13:\"generateTitle\";b:1;s:6:\"traits\";a:0:{}}'),

('','commerce_product.commerce_product_variation_type.product','a:9:{s:4:\"uuid\";s:36:\"6b885057-0f85-4197-acd9-fc8729de2c4d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:2:\"id\";s:7:\"product\";s:5:\"label\";s:7:\"Product\";s:13:\"orderItemType\";s:7:\"default\";s:13:\"generateTitle\";b:1;s:6:\"traits\";a:0:{}}'),

('','commerce_store.commerce_store_type.online','a:9:{s:4:\"uuid\";s:36:\"0ddab949-f9c8-42f9-82b5-58c3d9994cbc\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"uXc7SNfdNF3TJ81MWGMvCjsKlNSElo6Cc0lTrhLSels\";}s:2:\"id\";s:6:\"online\";s:5:\"label\";s:6:\"Online\";s:11:\"description\";s:0:\"\";s:6:\"traits\";a:0:{}}'),

('','commerce_store.settings','a:2:{s:13:\"default_store\";s:36:\"b5c17bf4-f7c7-4c5a-ab7a-3acd37a849e2\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"B9ZFGR76POyzj9f3Sh66F346_Jp-wnnUc78Hk3Q-60o\";}}'),

('','contact.form.feedback','a:12:{s:4:\"uuid\";s:36:\"b50d3e0b-e927-4500-a4f5-f22f19fbfa45\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vymHlgJy26BuI5GGj9-IXjwR3dRC5C0tij4BpWJnoqw\";}s:2:\"id\";s:8:\"feedback\";s:5:\"label\";s:16:\"Website feedback\";s:10:\"recipients\";a:1:{i:0;s:20:\"example@nikadevs.com\";}s:5:\"reply\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"message\";s:27:\"Your message has been sent.\";s:8:\"redirect\";s:0:\"\";}'),

('','contact.form.personal','a:12:{s:4:\"uuid\";s:36:\"6bf6def2-f5fa-4a7f-be2a-c0d50de47289\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jonvgt3CkUM2eMLTFwWfHileWWDC4YtXCuIlCahTk_I\";}s:2:\"id\";s:8:\"personal\";s:5:\"label\";s:21:\"Personal contact form\";s:10:\"recipients\";a:0:{}s:5:\"reply\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"message\";s:27:\"Your message has been sent.\";s:8:\"redirect\";s:0:\"\";}'),

('','contact.settings','a:4:{s:12:\"default_form\";s:8:\"feedback\";s:5:\"flood\";a:2:{s:5:\"limit\";i:5;s:8:\"interval\";i:3600;}s:20:\"user_default_enabled\";b:1;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U69DBeuvXuNVOC15rVNaBjDPK2fWFbo9v4takdYSSO8\";}}'),

('','core.base_field_override.node.gallery_item.promote','a:16:{s:4:\"uuid\";s:36:\"1cd1baeb-1231-4c25-b3d8-bdf3f8589fe4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:22:\"node.type.gallery_item\";}}s:2:\"id\";s:25:\"node.gallery_item.promote\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"gallery_item\";s:5:\"label\";s:22:\"Promoted to front page\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:8:\"on_label\";s:2:\"On\";s:9:\"off_label\";s:3:\"Off\";}s:10:\"field_type\";s:7:\"boolean\";}'),

('','core.base_field_override.node.nd_blog.promote','a:16:{s:4:\"uuid\";s:36:\"bf673c29-c35d-421f-a1b6-ba3b14ebddab\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:17:\"node.type.nd_blog\";}}s:2:\"id\";s:20:\"node.nd_blog.promote\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:5:\"label\";s:22:\"Promoted to front page\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:8:\"on_label\";s:2:\"On\";s:9:\"off_label\";s:3:\"Off\";}s:10:\"field_type\";s:7:\"boolean\";}'),

('','core.base_field_override.node.nd_person.promote','a:16:{s:4:\"uuid\";s:36:\"61284a8a-59cd-44eb-b177-5f6aaf1b23ac\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:19:\"node.type.nd_person\";}}s:2:\"id\";s:22:\"node.nd_person.promote\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"nd_person\";s:5:\"label\";s:22:\"Promoted to front page\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:8:\"on_label\";s:2:\"On\";s:9:\"off_label\";s:3:\"Off\";}s:10:\"field_type\";s:7:\"boolean\";}'),

('','core.base_field_override.node.nd_portfolio.promote','a:16:{s:4:\"uuid\";s:36:\"9f537a08-e7b3-41a7-bdf8-9a96638d1980\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:22:\"node.type.nd_portfolio\";}}s:2:\"id\";s:25:\"node.nd_portfolio.promote\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:5:\"label\";s:22:\"Promoted to front page\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:8:\"on_label\";s:2:\"On\";s:9:\"off_label\";s:3:\"Off\";}s:10:\"field_type\";s:7:\"boolean\";}'),

('','core.base_field_override.node.page.promote','a:17:{s:4:\"uuid\";s:36:\"7be01430-9843-41bf-8e0f-044609a4ebb4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:14:\"node.type.page\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fPUEnm4T5zfZRr3ttDUqq7yCDd2uW3clWD-pvos4tlQ\";}s:2:\"id\";s:17:\"node.page.promote\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:5:\"label\";s:22:\"Promoted to front page\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:8:\"on_label\";s:2:\"On\";s:9:\"off_label\";s:3:\"Off\";}s:10:\"field_type\";s:7:\"boolean\";}'),

('','core.base_field_override.node.webform.promote','a:17:{s:4:\"uuid\";s:36:\"ddb97df1-d4af-453a-b578-cbdf0f9e46db\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:17:\"node.type.webform\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"FvXJkxryo6J_0TQRlb5Z77Ge-sim5GHzCI1Ft3kZu-4\";}s:2:\"id\";s:20:\"node.webform.promote\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"webform\";s:5:\"label\";s:22:\"Promoted to front page\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:8:\"on_label\";s:2:\"On\";s:9:\"off_label\";s:3:\"Off\";}s:10:\"field_type\";s:7:\"boolean\";}'),

('','core.date_format.fallback','a:9:{s:4:\"uuid\";s:36:\"ea891b67-a4e8-4e1b-bc8e-c348e561d70f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7klS5IWXrwzVaPpYZFAs6wcx8U2FF1X73OfrtTsvuvE\";}s:2:\"id\";s:8:\"fallback\";s:5:\"label\";s:20:\"Fallback date format\";s:6:\"locked\";b:1;s:7:\"pattern\";s:14:\"D, m/d/Y - H:i\";}'),

('','core.date_format.html_date','a:9:{s:4:\"uuid\";s:36:\"1024f29a-587a-4f59-b5eb-2f241578f21b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EOQltUQPmgc6UQ2rcJ4Xi_leCEJj5ui0TR-12duS-Tk\";}s:2:\"id\";s:9:\"html_date\";s:5:\"label\";s:9:\"HTML Date\";s:6:\"locked\";b:1;s:7:\"pattern\";s:5:\"Y-m-d\";}'),

('','core.date_format.html_datetime','a:9:{s:4:\"uuid\";s:36:\"9f4d6f8f-0dc6-493e-9dd8-4140f78dad76\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jxfClwZIRXIdcvMrE--WkcZxDGUVoOIE3Sm2NRZlFuE\";}s:2:\"id\";s:13:\"html_datetime\";s:5:\"label\";s:13:\"HTML Datetime\";s:6:\"locked\";b:1;s:7:\"pattern\";s:13:\"Y-m-d\\TH:i:sO\";}'),

('','core.date_format.html_month','a:9:{s:4:\"uuid\";s:36:\"595b09f8-4ba9-4f63-9cd1-6fb36fd35ce6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Z7KuCUwM_WdTNvLcoltuX3_8d-s-8FZkTN6KgNwF0eM\";}s:2:\"id\";s:10:\"html_month\";s:5:\"label\";s:10:\"HTML Month\";s:6:\"locked\";b:1;s:7:\"pattern\";s:3:\"Y-m\";}'),

('','core.date_format.html_time','a:9:{s:4:\"uuid\";s:36:\"fd68b7ba-36fa-48d6-a38a-230c901568c6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"M7yqicYkU36hRy5p9drAaGBBihhUD1OyujFrAaQ93ZE\";}s:2:\"id\";s:9:\"html_time\";s:5:\"label\";s:9:\"HTML Time\";s:6:\"locked\";b:1;s:7:\"pattern\";s:5:\"H:i:s\";}'),

('','core.date_format.html_week','a:9:{s:4:\"uuid\";s:36:\"036b3237-e0f0-489c-8aa8-82cbde303417\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wKD4WsoV_wFgv2vgI4mcAAFSIzrye17ykzdwrnApkfY\";}s:2:\"id\";s:9:\"html_week\";s:5:\"label\";s:9:\"HTML Week\";s:6:\"locked\";b:1;s:7:\"pattern\";s:5:\"Y-\\WW\";}'),

('','core.date_format.html_year','a:9:{s:4:\"uuid\";s:36:\"78fbbbc8-302e-44b0-ad4c-22a832b1b383\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"OjekiQuX9RbVQ2_8jOHBL94RgYLePqX7wpfNGgcQzrk\";}s:2:\"id\";s:9:\"html_year\";s:5:\"label\";s:9:\"HTML Year\";s:6:\"locked\";b:1;s:7:\"pattern\";s:1:\"Y\";}'),

('','core.date_format.html_yearless_date','a:9:{s:4:\"uuid\";s:36:\"7d03b549-cb7c-4e30-831e-8909a373383f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"5VpawMrKPEPCkoO4YpPa0TDFO2dgiIHfTziJtwlmUxc\";}s:2:\"id\";s:18:\"html_yearless_date\";s:5:\"label\";s:18:\"HTML Yearless date\";s:6:\"locked\";b:1;s:7:\"pattern\";s:3:\"m-d\";}'),

('','core.date_format.long','a:9:{s:4:\"uuid\";s:36:\"99a5140d-1fff-4d7e-b116-d1004fd290a6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"og8sWXhBuHbLMw3CoiBEZjgqSyhFBFmcbUW_wLcfNbo\";}s:2:\"id\";s:4:\"long\";s:5:\"label\";s:17:\"Default long date\";s:6:\"locked\";b:0;s:7:\"pattern\";s:15:\"l, F j, Y - H:i\";}'),

('','core.date_format.medium','a:9:{s:4:\"uuid\";s:36:\"bb3e8f3e-f8f4-41ff-816e-d6c12e29dc6c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nzL5d024NjXIX_8TlT6uFAu973lmfkmHklJC-2i9rAE\";}s:2:\"id\";s:6:\"medium\";s:5:\"label\";s:19:\"Default medium date\";s:6:\"locked\";b:0;s:7:\"pattern\";s:14:\"D, m/d/Y - H:i\";}'),

('','core.date_format.short','a:9:{s:4:\"uuid\";s:36:\"2cd01971-980c-484a-a5fd-0e42235c1d47\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AlzeyytA8InBgxIG9H2UDJYs3CG98Zj6yRsDKmlbZwA\";}s:2:\"id\";s:5:\"short\";s:5:\"label\";s:18:\"Default short date\";s:6:\"locked\";b:0;s:7:\"pattern\";s:11:\"m/d/Y - H:i\";}'),

('','core.entity_form_display.block_content.basic.default','a:11:{s:4:\"uuid\";s:36:\"99603433-3055-4189-bbfa-4faffe07e985\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:24:\"block_content.type.basic\";i:1;s:36:\"field.field.block_content.basic.body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"kv6gwb6PJ8DcMSj5kgsd52qCIHl1xkxBDL5_AMm-g8k\";}s:2:\"id\";s:27:\"block_content.basic.default\";s:16:\"targetEntityType\";s:13:\"block_content\";s:6:\"bundle\";s:5:\"basic\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:3:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:-4;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"info\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.comment.comment.default','a:11:{s:4:\"uuid\";s:36:\"d576c386-2944-4f59-a2a9-6a2d6b5d098f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:20:\"comment.type.comment\";i:1;s:41:\"field.field.comment.comment.field_comment\";i:2;s:39:\"field.field.comment.comment.field_email\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ooVjelXSXbiQtp-hYb7LS44vR5UO-Kqu4vf484ggR8w\";}s:2:\"id\";s:23:\"comment.comment.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:5:{s:6:\"author\";a:4:{s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:13:\"field_comment\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"string_textarea\";s:6:\"region\";s:7:\"content\";}s:11:\"field_email\";a:5:{s:6:\"weight\";i:1;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"email_default\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"subject\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:2;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.comment.default_reviews.default','a:10:{s:4:\"uuid\";s:36:\"a8eb744e-0c01-4abb-a5d0-43eacba1881c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:28:\"comment.type.default_reviews\";i:1;s:49:\"field.field.comment.default_reviews.field_comment\";i:2;s:47:\"field.field.comment.default_reviews.field_email\";i:3;s:48:\"field.field.comment.default_reviews.field_rating\";}s:6:\"module\";a:1:{i:0;s:8:\"fivestar\";}}s:2:\"id\";s:31:\"comment.default_reviews.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:15:\"default_reviews\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:5:{s:6:\"author\";a:4:{s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:13:\"field_comment\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"string_textarea\";s:6:\"region\";s:7:\"content\";}s:11:\"field_email\";a:5:{s:6:\"weight\";i:1;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"email_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_rating\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:44:\"modules/fivestar/widgets/minimal/minimal.css\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"fivestar_stars\";s:6:\"region\";s:7:\"content\";}s:7:\"subject\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:2;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:1:{s:8:\"langcode\";b:1;}}'),

('','core.entity_form_display.commerce_order.default.default','a:11:{s:4:\"uuid\";s:36:\"71d3a372-d7d5-47cb-a465-bcfad9528b6b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:42:\"commerce_order.commerce_order_type.default\";i:1;s:46:\"field.field.commerce_order.default.order_items\";}s:6:\"module\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:18:\"inline_entity_form\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1NKrIQBqELStd0cyiuHeNArhuPvOZj36faDEG1dWqEA\";}s:2:\"id\";s:30:\"commerce_order.default.default\";s:16:\"targetEntityType\";s:14:\"commerce_order\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:3:{s:11:\"adjustments\";a:5:{s:4:\"type\";s:27:\"commerce_adjustment_default\";s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:15:\"billing_profile\";a:5:{s:4:\"type\";s:24:\"commerce_billing_profile\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"order_items\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:1;s:8:\"settings\";a:7:{s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:10:\"order item\";s:12:\"label_plural\";s:11:\"order items\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;s:9:\"form_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:7:{s:7:\"created\";b:1;s:10:\"ip_address\";b:1;s:4:\"mail\";b:1;s:12:\"order_number\";b:1;s:5:\"state\";b:1;s:8:\"store_id\";b:1;s:3:\"uid\";b:1;}}'),

('','core.entity_form_display.commerce_order_item.default.add_to_cart','a:11:{s:4:\"uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:2:\"id\";s:39:\"commerce_order_item.default.add_to_cart\";s:16:\"targetEntityType\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:11:\"add_to_cart\";s:7:\"content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:5:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;}}'),

('','core.entity_form_display.commerce_order_item.default.default','a:11:{s:4:\"uuid\";s:36:\"67b3a9e4-bff6-44c7-a338-ea0c55c515c7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"UZVAkGQqaNTvv788-BJ6xs8ZmfrWc2qjUwCFThnx4yE\";}s:2:\"id\";s:35:\"commerce_order_item.default.default\";s:16:\"targetEntityType\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:3:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:8:\"quantity\";a:5:{s:4:\"type\";s:17:\"commerce_quantity\";s:6:\"weight\";i:1;s:8:\"settings\";a:2:{s:11:\"placeholder\";s:0:\"\";s:4:\"step\";s:1:\"1\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:10:\"unit_price\";a:5:{s:4:\"type\";s:19:\"commerce_unit_price\";s:6:\"weight\";i:2;s:8:\"settings\";a:1:{s:20:\"require_confirmation\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:3:{s:7:\"created\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;}}'),

('','core.entity_form_display.commerce_order_item.default.variation_cart_form','a:11:{s:4:\"uuid\";s:36:\"6520b7bb-e9fb-45a1-8869-c1044f6b1deb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:61:\"core.entity_form_mode.commerce_order_item.variation_cart_form\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:3:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";i:2;s:28:\"commerce_variation_cart_form\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ckTrNmHo6qD3KP5GGTjzA4UhBNN9vhLXRJqwMlT__E4\";}s:2:\"id\";s:47:\"commerce_order_item.default.variation_cart_form\";s:16:\"targetEntityType\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:19:\"variation_cart_form\";s:7:\"content\";a:1:{s:8:\"quantity\";a:5:{s:4:\"type\";s:6:\"number\";s:6:\"weight\";i:1;s:8:\"settings\";a:1:{s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:5:{s:7:\"created\";b:1;s:16:\"purchased_entity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;}}'),

('','core.entity_form_display.commerce_product.default.default','a:11:{s:4:\"uuid\";s:36:\"f707c36f-cdfd-435f-a0f6-97ccae5ebe24\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:46:\"commerce_product.commerce_product_type.default\";i:1;s:41:\"field.field.commerce_product.default.body\";i:2;s:43:\"field.field.commerce_product.default.stores\";i:3;s:47:\"field.field.commerce_product.default.variations\";}s:6:\"module\";a:3:{i:0;s:8:\"commerce\";i:1;s:4:\"path\";i:2;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"o7hmyguUX6UeVQHlXaHSO_4mI0GfY85kn7qGrlkrdpw\";}s:2:\"id\";s:32:\"commerce_product.default.default\";s:16:\"targetEntityType\";s:16:\"commerce_product\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:8:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:3;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:6;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:8;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:1:{s:10:\"variations\";b:1;}}'),

('','core.entity_form_display.commerce_product.product_display.default','a:10:{s:4:\"uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:3:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:4:\"path\";}}s:2:\"id\";s:40:\"commerce_product.product_display.default\";s:16:\"targetEntityType\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:8;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:9;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:10;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:2:{s:12:\"field_rating\";b:1;s:10:\"variations\";b:1;}}'),

('','core.entity_form_display.commerce_product_variation.default.default','a:11:{s:4:\"uuid\";s:36:\"861cae79-494d-4bd3-b53d-72f877e9b634\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:56:\"commerce_product.commerce_product_variation_type.default\";}s:6:\"module\";a:1:{i:0;s:14:\"commerce_price\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tPYXAFcoBHG1jtgfl021t-ns7EE7da_S-o2zfS7aLUQ\";}s:2:\"id\";s:42:\"commerce_product_variation.default.default\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:4:{s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"price\";a:5:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"sku\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-4;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:6:\"weight\";i:10;s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:2:{s:7:\"created\";b:1;s:3:\"uid\";b:1;}}'),

('','core.entity_form_display.commerce_product_variation.product.default','a:11:{s:4:\"uuid\";s:36:\"7ead05bb-48d9-4c0d-8503-3978179228c2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:12:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:35:\"entity_browser.browser.browse_files\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:59:\"field.field.commerce_product_variation.product.field_length\";i:7;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:8;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:9;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:10;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:11;s:58:\"field.field.commerce_product_variation.product.field_waist\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:14:\"entity_browser\";i:2;s:11:\"field_group\";i:3;s:4:\"text\";}}s:20:\"third_party_settings\";a:1:{s:11:\"field_group\";a:1:{s:16:\"group_properties\";a:7:{s:8:\"children\";a:2:{i:0;s:11:\"field_waist\";i:1;s:12:\"field_length\";}s:11:\"parent_name\";s:0:\"\";s:6:\"weight\";i:8;s:11:\"format_type\";s:7:\"details\";s:15:\"format_settings\";a:4:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:4:\"open\";b:1;s:15:\"required_fields\";b:1;}s:5:\"label\";s:10:\"Properties\";s:6:\"region\";s:7:\"content\";}}}s:2:\"id\";s:42:\"commerce_product_variation.product.default\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:14:{s:15:\"attribute_color\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"attribute_size\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:4;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:5:{s:6:\"weight\";i:10;s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:5:{s:6:\"weight\";i:6;s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:17:\"field_widget_edit\";b:1;s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:5:{s:6:\"weight\";i:24;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:5:{s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:5:{s:6:\"weight\";i:11;s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:5:{s:6:\"weight\";i:7;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"string_textarea\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:5:{s:6:\"weight\";i:23;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:10:\"list_price\";a:5:{s:4:\"type\";s:19:\"commerce_list_price\";s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:5:\"price\";a:5:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:3:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:3:\"uid\";b:1;}}'),

('','core.entity_form_display.node.article.default','a:11:{s:4:\"uuid\";s:36:\"b0c8b372-c317-4a17-aa89-22c7d99dc2b2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:29:\"field.field.node.article.body\";i:1;s:32:\"field.field.node.article.comment\";i:2;s:36:\"field.field.node.article.field_image\";i:3;s:35:\"field.field.node.article.field_tags\";i:4;s:21:\"image.style.thumbnail\";i:5;s:17:\"node.type.article\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:5:\"image\";i:2;s:4:\"path\";i:3;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7CvVDwPYotAZFBa36mcpMKZOfVRRp_iGuPHpHaavI6E\";}s:2:\"id\";s:20:\"node.article.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:12:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:1;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"comment\";a:5:{s:4:\"type\";s:15:\"comment_default\";s:6:\"weight\";i:20;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"field_image\";a:5:{s:4:\"type\";s:11:\"image_image\";s:6:\"weight\";i:4;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:121;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.node.gallery_item.default','a:10:{s:4:\"uuid\";s:36:\"3bb288f6-5017-4356-8015-ca4ebc5b6a4b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:35:\"entity_browser.browser.browse_files\";i:1;s:43:\"field.field.node.gallery_item.field_gallery\";i:2;s:41:\"field.field.node.gallery_item.field_image\";i:3;s:22:\"node.type.gallery_item\";}s:6:\"module\";a:2:{i:0;s:14:\"entity_browser\";i:1;s:4:\"path\";}}s:2:\"id\";s:25:\"node.gallery_item.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:12:\"gallery_item\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:5;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:13:\"field_gallery\";a:5:{s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:11:\"field_image\";a:5:{s:6:\"weight\";i:1;s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:17:\"field_widget_edit\";b:1;s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:3;s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:6;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:121;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:7;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.node.nd_blog.default','a:10:{s:4:\"uuid\";s:36:\"57345f72-44de-467a-81de-25064a7baf8c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:9:{i:0;s:35:\"entity_browser.browser.browse_files\";i:1;s:29:\"field.field.node.nd_blog.body\";i:2;s:44:\"field.field.node.nd_blog.field_blog_category\";i:3;s:39:\"field.field.node.nd_blog.field_comments\";i:4;s:37:\"field.field.node.nd_blog.field_images\";i:5;s:40:\"field.field.node.nd_blog.field_lead_text\";i:6;s:43:\"field.field.node.nd_blog.field_second_title\";i:7;s:35:\"field.field.node.nd_blog.field_tags\";i:8;s:17:\"node.type.nd_blog\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:14:\"entity_browser\";i:2;s:4:\"path\";i:3;s:4:\"text\";}}s:2:\"id\";s:20:\"node.nd_blog.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:15:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:19:\"field_blog_category\";a:5:{s:6:\"weight\";i:5;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:14:\"field_comments\";a:5:{s:6:\"weight\";i:12;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:5:{s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:17:\"field_widget_edit\";b:1;s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:15:\"field_lead_text\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:18:\"field_second_title\";a:5:{s:6:\"weight\";i:1;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:8;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:121;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:9;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:11;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.node.nd_person.default','a:10:{s:4:\"uuid\";s:36:\"43bcfd19-72e2-4cf4-be3a-7446b9943adb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:35:\"entity_browser.browser.browse_files\";i:1;s:31:\"field.field.node.nd_person.body\";i:2;s:38:\"field.field.node.nd_person.field_image\";i:3;s:41:\"field.field.node.nd_person.field_position\";i:4;s:45:\"field.field.node.nd_person.field_social_links\";i:5;s:19:\"node.type.nd_person\";}s:6:\"module\";a:4:{i:0;s:14:\"entity_browser\";i:1;s:4:\"link\";i:2;s:4:\"path\";i:3;s:4:\"text\";}}s:2:\"id\";s:22:\"node.nd_person.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:9:\"nd_person\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:12:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"field_image\";a:5:{s:6:\"weight\";i:1;s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:17:\"field_widget_edit\";b:1;s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:14:\"field_position\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:18:\"field_social_links\";a:5:{s:6:\"weight\";i:2;s:8:\"settings\";a:2:{s:15:\"placeholder_url\";s:0:\"\";s:17:\"placeholder_title\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"link_default\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:5;s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:8;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:121;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:9;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.node.nd_portfolio.default','a:10:{s:4:\"uuid\";s:36:\"1d5c37f8-1fd2-419c-9453-f7787f18d2b3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:9:{i:0;s:35:\"entity_browser.browser.browse_files\";i:1;s:34:\"field.field.node.nd_portfolio.body\";i:2;s:44:\"field.field.node.nd_portfolio.field_category\";i:3;s:47:\"field.field.node.nd_portfolio.field_description\";i:4;s:42:\"field.field.node.nd_portfolio.field_images\";i:5;s:54:\"field.field.node.nd_portfolio.field_portfolio_category\";i:6;s:43:\"field.field.node.nd_portfolio.field_project\";i:7;s:48:\"field.field.node.nd_portfolio.field_project_link\";i:8;s:22:\"node.type.nd_portfolio\";}s:6:\"module\";a:4:{i:0;s:14:\"entity_browser\";i:1;s:4:\"link\";i:2;s:4:\"path\";i:3;s:4:\"text\";}}s:2:\"id\";s:25:\"node.nd_portfolio.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:15:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:3;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:8;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"field_category\";a:5:{s:6:\"weight\";i:6;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:5:{s:6:\"weight\";i:1;s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:5:{s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:17:\"field_widget_edit\";b:1;s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:14:\"selection_edit\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:24:\"field_portfolio_category\";a:5:{s:6:\"weight\";i:7;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_project\";a:5:{s:6:\"weight\";i:5;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:18:\"field_project_link\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:2:{s:15:\"placeholder_url\";s:0:\"\";s:17:\"placeholder_title\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"link_default\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:12;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:121;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:9;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:11;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.node.page.default','a:11:{s:4:\"uuid\";s:36:\"ebdf7c6e-c15b-4337-8c4c-7934cc127c4f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"field.field.node.page.body\";i:1;s:14:\"node.type.page\";}s:6:\"module\";a:2:{i:0;s:4:\"path\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KSvzyFhdLuxniTsunUnUfpfMmod2l57GibtVjL8ymHM\";}s:2:\"id\";s:17:\"node.page.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:9:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:31;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:121;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.node.webform.default','a:11:{s:4:\"uuid\";s:36:\"a4a174fc-c839-4a9e-bada-a7e7f9534173\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:29:\"field.field.node.webform.body\";i:1;s:32:\"field.field.node.webform.webform\";i:2;s:17:\"node.type.webform\";}s:6:\"module\";a:3:{i:0;s:4:\"path\";i:1;s:4:\"text\";i:2;s:7:\"webform\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"3QPllhmSDNxHFnxrVUPmO5RhAOJtt5AWVmXxyfHQBS0\";}s:2:\"id\";s:20:\"node.webform.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"webform\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:10:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;s:8:\"settings\";a:1:{s:14:\"include_locked\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:121;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"webform\";a:5:{s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:31:\"webform_entity_reference_select\";s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.profile.customer.default','a:11:{s:4:\"uuid\";s:36:\"fbf53517-abbf-48b9-a8ff-3179445cd121\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:36:\"field.field.profile.customer.address\";i:1;s:21:\"profile.type.customer\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:6:\"module\";a:1:{i:0;s:7:\"address\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"hLsGttE_aayocJAy545caXaV1xyLgsw4Q-22aeDN-Tc\";}s:2:\"id\";s:24:\"profile.customer.default\";s:16:\"targetEntityType\";s:7:\"profile\";s:6:\"bundle\";s:8:\"customer\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:1:{s:7:\"address\";a:5:{s:4:\"type\";s:15:\"address_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:15:\"default_country\";N;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_form_display.user.user.default','a:11:{s:4:\"uuid\";s:36:\"fc4f8b66-0239-4194-9214-1a4d08bfd25a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:40:\"field.field.user.user.commerce_remote_id\";i:1;s:34:\"field.field.user.user.user_picture\";i:2;s:21:\"image.style.thumbnail\";}s:6:\"module\";a:3:{i:0;s:5:\"image\";i:1;s:4:\"path\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"LLAieeozVsoZDb-2PbFxRJpQqnKmpR7-4OoRJnduz-U\";}s:2:\"id\";s:17:\"user.user.default\";s:16:\"targetEntityType\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:6:{s:7:\"account\";a:4:{s:6:\"weight\";i:-10;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:7:\"contact\";a:4:{s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:8:\"language\";a:4:{s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:8:\"timezone\";a:4:{s:6:\"weight\";i:6;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"user_picture\";a:5:{s:4:\"type\";s:11:\"image_image\";s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:20:\"third_party_settings\";a:0:{}s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:2:{s:18:\"commerce_remote_id\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_form_mode.commerce_order_item.add_to_cart','a:9:{s:4:\"uuid\";s:36:\"0a452422-a173-4f6a-9f52-ad35f46f4fe0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:13:\"commerce_cart\";}}s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"BeqBf6Mm59Nebv4SsV0yvK5EspkCegPqvwnqwEBvEp0\";}s:2:\"id\";s:31:\"commerce_order_item.add_to_cart\";s:5:\"label\";s:11:\"Add to cart\";s:16:\"targetEntityType\";s:19:\"commerce_order_item\";s:5:\"cache\";b:1;}'),

('','core.entity_form_mode.commerce_order_item.variation_cart_form','a:9:{s:4:\"uuid\";s:36:\"79746294-6893-4476-8dfd-21233abdeef8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:3:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";i:2;s:28:\"commerce_variation_cart_form\";}}s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"u--mTnS-vYPf2RaezDnxj9Sl0GFgFSi4fgzVPPlCMM0\";}s:2:\"id\";s:39:\"commerce_order_item.variation_cart_form\";s:5:\"label\";s:19:\"Variation cart form\";s:16:\"targetEntityType\";s:19:\"commerce_order_item\";s:5:\"cache\";b:1;}'),

('','core.entity_form_mode.user.register','a:9:{s:4:\"uuid\";s:36:\"2bf66c0f-264d-4a5a-86c3-260a97ff9e7a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"flXhTcp55yLcyy7ZLOhPGKGZobZQJdkAFVWV3LseiuI\";}s:2:\"id\";s:13:\"user.register\";s:5:\"label\";s:8:\"Register\";s:16:\"targetEntityType\";s:4:\"user\";s:5:\"cache\";b:1;}'),

('','core.entity_view_display.block_content.basic.default','a:11:{s:4:\"uuid\";s:36:\"c9784356-4b9f-4bc4-8849-878a26de5c1f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:24:\"block_content.type.basic\";i:1;s:36:\"field.field.block_content.basic.body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"zCrrHAjrsQgWjBXBsshAZjND21czBy8sH_L5v_xDKSA\";}s:2:\"id\";s:27:\"block_content.basic.default\";s:16:\"targetEntityType\";s:13:\"block_content\";s:6:\"bundle\";s:5:\"basic\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:1:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:1:{s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.comment.comment.default','a:11:{s:4:\"uuid\";s:36:\"9521e71f-f730-48e4-9868-9bbb589ed027\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:20:\"comment.type.comment\";i:1;s:41:\"field.field.comment.comment.field_comment\";i:2;s:39:\"field.field.comment.comment.field_email\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1yBeJcGufCbnbSolmaYgTIXZWYUaO7kw6xszGA8TYs8\";}s:2:\"id\";s:23:\"comment.comment.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:13:\"field_comment\";a:6:{s:6:\"weight\";i:101;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:2:{s:11:\"field_email\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.comment.default_reviews.default','a:10:{s:4:\"uuid\";s:36:\"4ae6a983-0864-4215-aad3-544647c26b53\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:28:\"comment.type.default_reviews\";i:1;s:49:\"field.field.comment.default_reviews.field_comment\";i:2;s:47:\"field.field.comment.default_reviews.field_email\";i:3;s:48:\"field.field.comment.default_reviews.field_rating\";}s:6:\"module\";a:1:{i:0;s:8:\"fivestar\";}}s:2:\"id\";s:31:\"comment.default_reviews.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:15:\"default_reviews\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:3:{s:13:\"field_comment\";a:6:{s:6:\"weight\";i:1;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:12:\"field_rating\";a:6:{s:4:\"type\";s:14:\"fivestar_stars\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:52:\"modules/contrib/fivestar/widgets/outline/outline.css\";}s:20:\"third_party_settings\";a:0:{}}s:5:\"links\";a:4:{s:6:\"weight\";i:2;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:2:{s:11:\"field_email\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.commerce_order.default.default','a:11:{s:4:\"uuid\";s:36:\"91726b82-0bbf-489f-9d53-b750d52656e5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:42:\"commerce_order.commerce_order_type.default\";i:1;s:46:\"field.field.commerce_order.default.order_items\";}s:6:\"module\";a:3:{i:0;s:14:\"commerce_order\";i:1;s:13:\"state_machine\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DGdHybHLw9uLIR4f16miPoJYlsJxbxZk_li7kD13aE4\";}s:2:\"id\";s:30:\"commerce_order.default.default\";s:16:\"targetEntityType\";s:14:\"commerce_order\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:9:{s:7:\"changed\";a:6:{s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:4;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:9:\"completed\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:2;s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:10:\"ip_address\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:7;s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"mail\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:12:\"basic_string\";s:6:\"weight\";i:6;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"order_items\";a:6:{s:4:\"type\";s:25:\"commerce_order_item_table\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}s:6:\"placed\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:3;s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"state\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"state_transition_form\";s:6:\"weight\";i:8;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"total_price\";a:6:{s:4:\"type\";s:28:\"commerce_order_total_summary\";s:6:\"weight\";i:1;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"author\";s:6:\"weight\";i:5;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:3:{s:15:\"billing_profile\";b:1;s:12:\"order_number\";b:1;s:8:\"store_id\";b:1;}}'),

('','core.entity_view_display.commerce_order.default.user','a:11:{s:4:\"uuid\";s:36:\"5087d032-26f1-4b5f-887a-c438532a2458\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:42:\"commerce_order.commerce_order_type.default\";i:1;s:41:\"core.entity_view_mode.commerce_order.user\";i:2;s:46:\"field.field.commerce_order.default.order_items\";}s:6:\"module\";a:3:{i:0;s:14:\"commerce_order\";i:1;s:26:\"entity_reference_revisions\";i:2;s:7:\"options\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"UcQydNwgf9NMjqKyyPwC9mJu-QmHqV7HKOcIp0VuV7w\";}s:2:\"id\";s:27:\"commerce_order.default.user\";s:16:\"targetEntityType\";s:14:\"commerce_order\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:4:\"user\";s:7:\"content\";a:8:{s:15:\"billing_profile\";a:6:{s:4:\"type\";s:38:\"entity_reference_revisions_entity_view\";s:6:\"weight\";i:0;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:4:\"link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:9:\"completed\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:2;s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"mail\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:12:\"basic_string\";s:6:\"weight\";i:1;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"order_items\";a:6:{s:4:\"type\";s:25:\"commerce_order_item_table\";s:6:\"weight\";i:5;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}s:12:\"order_number\";a:6:{s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"placed\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:3;s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"state\";a:6:{s:4:\"type\";s:12:\"list_default\";s:6:\"weight\";i:4;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"total_price\";a:6:{s:4:\"type\";s:28:\"commerce_order_total_summary\";s:6:\"weight\";i:6;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:4:{s:7:\"changed\";b:1;s:10:\"ip_address\";b:1;s:8:\"store_id\";b:1;s:3:\"uid\";b:1;}}'),

('','core.entity_view_display.commerce_order_item.default.default','a:11:{s:4:\"uuid\";s:36:\"a226e650-6b0a-4142-adda-4a2184843f1e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:14:\"commerce_price\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"YvPk7-s7bZEOuxWBbu1G5wo4qc-OOnZpmCwPUdhp40o\";}s:2:\"id\";s:35:\"commerce_order_item.default.default\";s:16:\"targetEntityType\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:4:{s:16:\"purchased_entity\";a:6:{s:4:\"type\";s:28:\"entity_reference_entity_view\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"product\";s:4:\"link\";b:0;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:8:\"quantity\";a:6:{s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";i:1;s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:11:\"total_price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:10:\"unit_price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:2;s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:1:{s:11:\"adjustments\";b:1;}}'),

('','core.entity_view_display.commerce_product.default.default','a:11:{s:4:\"uuid\";s:36:\"ef55e6d3-d8b2-467a-bf69-a02b0aed8740\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:46:\"commerce_product.commerce_product_type.default\";i:1;s:41:\"field.field.commerce_product.default.body\";i:2;s:43:\"field.field.commerce_product.default.stores\";i:3;s:47:\"field.field.commerce_product.default.variations\";}s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"gT03TFcuSod4d9uPQNs_gqK1F1QZ0Ray5CBYW0BNLnk\";}s:2:\"id\";s:32:\"commerce_product.default.default\";s:16:\"targetEntityType\";s:16:\"commerce_product\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";i:1;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:3:{s:16:\"default_quantity\";s:1:\"1\";s:7:\"combine\";b:1;s:13:\"show_quantity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:4:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}}'),

('','core.entity_view_display.commerce_product.product_display.default','a:10:{s:4:\"uuid\";s:36:\"09d511c6-2622-4997-b678-90c8ff763aed\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"core.entity_view_display.comment.default_reviews.default\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:3:{i:0;s:7:\"comment\";i:1;s:16:\"commerce_product\";i:2;s:8:\"fivestar\";}}s:2:\"id\";s:40:\"commerce_product.product_display.default\";s:16:\"targetEntityType\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:6:{s:14:\"field_category\";a:6:{s:6:\"weight\";i:2;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:12:\"field_rating\";a:6:{s:6:\"weight\";i:0;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:52:\"modules/contrib/fivestar/widgets/outline/outline.css\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"fivestar_stars\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:6:{s:6:\"weight\";i:4;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:6:{s:6:\"weight\";i:3;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:4:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}}'),

('','core.entity_view_display.commerce_product.product_display.teaser','a:10:{s:4:\"uuid\";s:36:\"025ac682-e1c1-45ec-8ee9-bff4d42a193c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"core.entity_view_mode.commerce_product.teaser\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:39:\"commerce_product.product_display.teaser\";s:16:\"targetEntityType\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:1:{s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:8:{s:7:\"created\";b:1;s:14:\"field_category\";b:1;s:12:\"field_rating\";b:1;s:13:\"field_reviews\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}}'),

('','core.entity_view_display.commerce_product_variation.default.cart','a:11:{s:4:\"uuid\";s:36:\"6ff99f01-ff72-4e35-bb33-a4eb41f584f3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.default\";i:1;s:53:\"core.entity_view_mode.commerce_product_variation.cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:14:\"commerce_price\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EVn6BiYwtiYYiS-9vG5bvZDkkX9hQq1SgIqeQ_iPC-I\";}s:2:\"id\";s:39:\"commerce_product_variation.default.cart\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:4:\"cart\";s:7:\"content\";a:4:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:10:\"list_price\";a:6:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:16:\"currency_display\";s:6:\"symbol\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"product_id\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:0;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:3:{s:8:\"langcode\";b:1;s:5:\"price\";b:1;s:3:\"sku\";b:1;}}'),

('','core.entity_view_display.commerce_product_variation.default.summary','a:11:{s:4:\"uuid\";s:36:\"0068b3ac-ea3e-4b38-ad9a-bf1faee78b26\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.default\";i:1;s:56:\"core.entity_view_mode.commerce_product_variation.summary\";}s:6:\"module\";a:1:{i:0;s:14:\"commerce_price\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nWr1ZTB007GRrqbIhsncMGNe3-kSio6mGWfNkEgE28M\";}s:2:\"id\";s:42:\"commerce_product_variation.default.summary\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"default\";s:4:\"mode\";s:7:\"summary\";s:7:\"content\";a:4:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:10:\"list_price\";a:6:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:16:\"currency_display\";s:6:\"symbol\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"product_id\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:0;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:3:{s:8:\"langcode\";b:1;s:5:\"price\";b:1;s:3:\"sku\";b:1;}}'),

('','core.entity_view_display.commerce_product_variation.product.cart','a:11:{s:4:\"uuid\";s:36:\"dc239f0c-8448-478c-afd6-0043a7aefc68\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:12:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:53:\"core.entity_view_mode.commerce_product_variation.cart\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:59:\"field.field.commerce_product_variation.product.field_length\";i:7;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:8;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:9;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:10;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:11;s:58:\"field.field.commerce_product_variation.product.field_waist\";}s:6:\"module\";a:2:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";}}s:20:\"third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:2:\"id\";s:39:\"commerce_product_variation.product.cart\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:4:\"mode\";s:4:\"cart\";s:7:\"content\";a:2:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:10:\"list_price\";a:6:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:16:\"currency_display\";s:6:\"symbol\";}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:15:{s:15:\"attribute_color\";b:1;s:14:\"attribute_size\";b:1;s:17:\"field_description\";b:1;s:12:\"field_images\";b:1;s:12:\"field_length\";b:1;s:15:\"field_old_price\";b:1;s:28:\"field_right_side_description\";b:1;s:15:\"field_sale_text\";b:1;s:23:\"field_short_description\";b:1;s:11:\"field_waist\";b:1;s:8:\"langcode\";b:1;s:5:\"price\";b:1;s:10:\"product_id\";b:1;s:3:\"sku\";b:1;s:5:\"title\";b:1;}}'),

('','core.entity_view_display.commerce_product_variation.product.default','a:11:{s:4:\"uuid\";s:36:\"bc5d6188-cefe-4350-a39e-4005f7f36258\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:12:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:2;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:3;s:64:\"field.field.commerce_product_variation.product.field_description\";i:4;s:59:\"field.field.commerce_product_variation.product.field_images\";i:5;s:59:\"field.field.commerce_product_variation.product.field_length\";i:6;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:7;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:8;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:9;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:10;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:11;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:10:\"rhythm_cms\";i:3;s:4:\"text\";}}s:20:\"third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:2:\"id\";s:42:\"commerce_product_variation.product.default\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:16:{s:15:\"attribute_color\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:2;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:14:\"attribute_size\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";i:14;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:17:\"field_description\";a:6:{s:6:\"weight\";i:6;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";i:4;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:5:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:17:\"image_style_small\";s:19:\"product_small_68x86\";s:3:\"col\";s:1:\"3\";s:4:\"zoom\";s:1:\"1\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";i:12;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";i:9;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";i:7;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";i:8;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";i:10;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";i:11;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:10:\"list_price\";a:6:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:16:\"currency_display\";s:6:\"symbol\";}s:20:\"third_party_settings\";a:0:{}}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:3;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:14:\"qty_increments\";a:6:{s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";i:13;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:2:{s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;}}'),

('','core.entity_view_display.commerce_product_variation.product.product','a:11:{s:4:\"uuid\";s:36:\"17ba37a5-f96b-4674-9546-6ecfdf98e091\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:13:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:56:\"core.entity_view_mode.commerce_product_variation.product\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:59:\"field.field.commerce_product_variation.product.field_length\";i:7;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:8;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:9;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:10;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:11;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:12;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:3:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:5:\"image\";}}s:20:\"third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:2:\"id\";s:42:\"commerce_product_variation.product.product\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:4:\"mode\";s:7:\"product\";s:7:\"content\";a:5:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";i:3;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"field_images\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:10:\"image_link\";s:7:\"content\";}s:20:\"third_party_settings\";a:0:{}}s:15:\"field_old_price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:10:\"list_price\";a:6:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:16:\"currency_display\";s:6:\"symbol\";}s:20:\"third_party_settings\";a:0:{}}s:5:\"price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:2;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:12:{s:15:\"attribute_color\";b:1;s:14:\"attribute_size\";b:1;s:17:\"field_description\";b:1;s:12:\"field_length\";b:1;s:28:\"field_right_side_description\";b:1;s:15:\"field_sale_text\";b:1;s:23:\"field_short_description\";b:1;s:11:\"field_waist\";b:1;s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;s:3:\"sku\";b:1;s:5:\"title\";b:1;}}'),

('','core.entity_view_display.commerce_product_variation.product.teaser','a:11:{s:4:\"uuid\";s:36:\"39905ec4-5514-43fa-a549-89ea776a35b1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:13:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:55:\"core.entity_view_mode.commerce_product_variation.teaser\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:59:\"field.field.commerce_product_variation.product.field_length\";i:7;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:8;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:9;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:10;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:11;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:12;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:10:\"rhythm_cms\";i:3;s:4:\"text\";}}s:20:\"third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:2:\"id\";s:41:\"commerce_product_variation.product.teaser\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:16:{s:15:\"attribute_color\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:2;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:14:\"attribute_size\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";i:14;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:17:\"field_description\";a:6:{s:6:\"weight\";i:6;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";i:4;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:5:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:17:\"image_style_small\";s:19:\"product_small_68x86\";s:3:\"col\";s:1:\"3\";s:4:\"zoom\";s:1:\"1\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";i:12;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";i:9;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";i:7;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";i:8;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";i:10;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";i:11;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:10:\"list_price\";a:6:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:16:\"currency_display\";s:6:\"symbol\";}s:20:\"third_party_settings\";a:0:{}}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:3;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:14:\"qty_increments\";a:6:{s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";i:13;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:2:{s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;}}'),

('','core.entity_view_display.commerce_store.online.default','a:11:{s:4:\"uuid\";s:36:\"878b8292-ffdb-451e-a0ba-ce4f413abb47\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:41:\"commerce_store.commerce_store_type.online\";}s:6:\"module\";a:1:{i:0;s:7:\"address\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fUxrlZt5z8U8dKAADqGtH0YQWZSVXIkH9Ga5abq8HwU\";}s:2:\"id\";s:29:\"commerce_store.online.default\";s:16:\"targetEntityType\";s:14:\"commerce_store\";s:6:\"bundle\";s:6:\"online\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:1:{s:7:\"address\";a:6:{s:4:\"type\";s:15:\"address_default\";s:6:\"weight\";i:1;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:5:{s:17:\"billing_countries\";b:1;s:16:\"default_currency\";b:1;s:8:\"langcode\";b:1;s:4:\"mail\";b:1;s:4:\"name\";b:1;}}'),

('','core.entity_view_display.node.article.default','a:11:{s:4:\"uuid\";s:36:\"820b29f7-403f-4049-8545-e38639e04de9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:48:\"core.entity_view_display.comment.comment.default\";i:1;s:29:\"field.field.node.article.body\";i:2;s:32:\"field.field.node.article.comment\";i:3;s:36:\"field.field.node.article.field_image\";i:4;s:35:\"field.field.node.article.field_tags\";i:5;s:17:\"image.style.large\";i:6;s:17:\"node.type.article\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:5:\"image\";i:2;s:4:\"text\";i:3;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1x2VMLBhwpRPa-_Q_6J_ZN4QNazwCmP1dt01Zc-Iors\";}s:2:\"id\";s:20:\"node.article.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:5:{s:4:\"body\";a:6:{s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}s:7:\"comment\";a:6:{s:4:\"type\";s:15:\"comment_default\";s:6:\"weight\";i:110;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"field_image\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";i:-1;s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:3:{s:11:\"field_image\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.article.rss','a:11:{s:4:\"uuid\";s:36:\"1a23f746-ff95-4115-b34a-9dacccb7ceca\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:30:\"core.entity_view_mode.node.rss\";i:1;s:29:\"field.field.node.article.body\";i:2;s:32:\"field.field.node.article.comment\";i:3;s:36:\"field.field.node.article.field_image\";i:4;s:35:\"field.field.node.article.field_tags\";i:5;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Q90X1FmFdOkTx8udckWPoAgleOstOerbgDnNpoP6PO4\";}s:2:\"id\";s:16:\"node.article.rss\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:4:\"mode\";s:3:\"rss\";s:7:\"content\";a:1:{s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:5:{s:4:\"body\";b:1;s:7:\"comment\";b:1;s:11:\"field_image\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.article.teaser','a:11:{s:4:\"uuid\";s:36:\"239f50af-5651-41b5-92ca-3938d01dc4a0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:29:\"field.field.node.article.body\";i:2;s:32:\"field.field.node.article.comment\";i:3;s:36:\"field.field.node.article.field_image\";i:4;s:35:\"field.field.node.article.field_tags\";i:5;s:18:\"image.style.medium\";i:6;s:17:\"node.type.article\";}s:6:\"module\";a:3:{i:0;s:5:\"image\";i:1;s:4:\"text\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U8ghxJXn8JE2p6Q2wLpPWAxpz4r_8crL1LxtapSrHAE\";}s:2:\"id\";s:19:\"node.article.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:4:{s:4:\"body\";a:6:{s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}s:11:\"field_image\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";i:-1;s:8:\"settings\";a:2:{s:11:\"image_style\";s:6:\"medium\";s:10:\"image_link\";s:7:\"content\";}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:10;s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:4:{s:7:\"comment\";b:1;s:11:\"field_image\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.gallery_item.default','a:10:{s:4:\"uuid\";s:36:\"0707f1c1-1174-4f98-a6f5-b0aeca023362\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:43:\"field.field.node.gallery_item.field_gallery\";i:1;s:41:\"field.field.node.gallery_item.field_image\";i:2;s:22:\"node.type.gallery_item\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}s:2:\"id\";s:25:\"node.gallery_item.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:12:\"gallery_item\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:11:\"field_image\";a:6:{s:6:\"weight\";i:1;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:5:\"image\";s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:2:{s:13:\"field_gallery\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.gallery_item.teaser','a:10:{s:4:\"uuid\";s:36:\"d3bd3693-c333-4715-9063-f39a5f23a6c6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:43:\"field.field.node.gallery_item.field_gallery\";i:2;s:41:\"field.field.node.gallery_item.field_image\";i:3;s:22:\"node.type.gallery_item\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:2:\"id\";s:24:\"node.gallery_item.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:12:\"gallery_item\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:1:{s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:3:{s:13:\"field_gallery\";b:1;s:11:\"field_image\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.nd_blog.default','a:10:{s:4:\"uuid\";s:36:\"a36579e2-f92c-453d-8053-3264bc0be1df\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:10:{i:0;s:48:\"core.entity_view_display.comment.comment.default\";i:1;s:29:\"field.field.node.nd_blog.body\";i:2;s:44:\"field.field.node.nd_blog.field_blog_category\";i:3;s:39:\"field.field.node.nd_blog.field_comments\";i:4;s:37:\"field.field.node.nd_blog.field_images\";i:5;s:40:\"field.field.node.nd_blog.field_lead_text\";i:6;s:43:\"field.field.node.nd_blog.field_second_title\";i:7;s:35:\"field.field.node.nd_blog.field_tags\";i:8;s:26:\"image.style.blog_1140x642_\";i:9;s:17:\"node.type.nd_blog\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:10:\"rhythm_cms\";i:2;s:4:\"text\";i:3;s:4:\"user\";}}s:2:\"id\";s:20:\"node.nd_blog.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:5:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"field_comments\";a:6:{s:6:\"weight\";i:4;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";i:2;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:14:\"blog_1140x642_\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:24:\"rhythm_cms_images_slider\";s:6:\"region\";s:7:\"content\";}s:15:\"field_lead_text\";a:6:{s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:1;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:18:\"field_second_title\";a:6:{s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:4:{s:19:\"field_blog_category\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;s:5:\"links\";b:1;}}'),

('','core.entity_view_display.node.nd_blog.teaser','a:10:{s:4:\"uuid\";s:36:\"f5cbc13f-5fab-4b87-bb2a-7abd50e05d55\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:10:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:29:\"field.field.node.nd_blog.body\";i:2;s:44:\"field.field.node.nd_blog.field_blog_category\";i:3;s:39:\"field.field.node.nd_blog.field_comments\";i:4;s:37:\"field.field.node.nd_blog.field_images\";i:5;s:40:\"field.field.node.nd_blog.field_lead_text\";i:6;s:43:\"field.field.node.nd_blog.field_second_title\";i:7;s:35:\"field.field.node.nd_blog.field_tags\";i:8;s:26:\"image.style.blog_1140x642_\";i:9;s:17:\"node.type.nd_blog\";}s:6:\"module\";a:3:{i:0;s:10:\"rhythm_cms\";i:1;s:4:\"text\";i:2;s:4:\"user\";}}s:2:\"id\";s:19:\"node.nd_blog.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:3:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:2;s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:19:\"field_blog_category\";a:6:{s:4:\"type\";s:28:\"entity_reference_entity_view\";s:6:\"weight\";i:0;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:4:\"link\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:4:\"type\";s:24:\"rhythm_cms_images_slider\";s:6:\"weight\";i:1;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:14:\"blog_1140x642_\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:6:{s:14:\"field_comments\";b:1;s:15:\"field_lead_text\";b:1;s:18:\"field_second_title\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;s:5:\"links\";b:1;}}'),

('','core.entity_view_display.node.nd_person.default','a:10:{s:4:\"uuid\";s:36:\"9849d905-2cf2-489a-8b94-322051c86e48\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:31:\"field.field.node.nd_person.body\";i:1;s:38:\"field.field.node.nd_person.field_image\";i:2;s:41:\"field.field.node.nd_person.field_position\";i:3;s:45:\"field.field.node.nd_person.field_social_links\";i:4;s:27:\"image.style.person_360x438_\";i:5;s:19:\"node.type.nd_person\";}s:6:\"module\";a:4:{i:0;s:5:\"image\";i:1;s:10:\"rhythm_cms\";i:2;s:4:\"text\";i:3;s:4:\"user\";}}s:2:\"id\";s:22:\"node.nd_person.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:9:\"nd_person\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:4:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"field_image\";a:6:{s:6:\"weight\";i:1;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:15:\"person_360x438_\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:5:\"image\";s:6:\"region\";s:7:\"content\";}s:14:\"field_position\";a:6:{s:6:\"weight\";i:3;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:18:\"field_social_links\";a:6:{s:6:\"weight\";i:2;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"rhythm_cms_social_link\";s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:2:{s:8:\"langcode\";b:1;s:5:\"links\";b:1;}}'),

('','core.entity_view_display.node.nd_person.teaser','a:10:{s:4:\"uuid\";s:36:\"ae40113c-509b-4f39-b3e8-cba342f491be\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:31:\"field.field.node.nd_person.body\";i:2;s:38:\"field.field.node.nd_person.field_image\";i:3;s:41:\"field.field.node.nd_person.field_position\";i:4;s:45:\"field.field.node.nd_person.field_social_links\";i:5;s:19:\"node.type.nd_person\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:2:\"id\";s:21:\"node.nd_person.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:9:\"nd_person\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:101;s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:4:{s:11:\"field_image\";b:1;s:14:\"field_position\";b:1;s:18:\"field_social_links\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.nd_portfolio.default','a:10:{s:4:\"uuid\";s:36:\"fd1e5995-9254-452a-9777-e83226d7fa6d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:9:{i:0;s:34:\"field.field.node.nd_portfolio.body\";i:1;s:44:\"field.field.node.nd_portfolio.field_category\";i:2;s:47:\"field.field.node.nd_portfolio.field_description\";i:3;s:42:\"field.field.node.nd_portfolio.field_images\";i:4;s:54:\"field.field.node.nd_portfolio.field_portfolio_category\";i:5;s:43:\"field.field.node.nd_portfolio.field_project\";i:6;s:48:\"field.field.node.nd_portfolio.field_project_link\";i:7;s:30:\"image.style.portfolio_952x_613\";i:8;s:22:\"node.type.nd_portfolio\";}s:6:\"module\";a:3:{i:0;s:10:\"rhythm_cms\";i:1;s:4:\"text\";i:2;s:4:\"user\";}}s:2:\"id\";s:25:\"node.nd_portfolio.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:5:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"field_category\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:3;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:17:\"field_description\";a:6:{s:6:\"weight\";i:0;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";i:1;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_952x_613\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:24:\"rhythm_cms_images_slider\";s:6:\"region\";s:7:\"content\";}s:13:\"field_project\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:4;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:4:{s:24:\"field_portfolio_category\";b:1;s:18:\"field_project_link\";b:1;s:8:\"langcode\";b:1;s:5:\"links\";b:1;}}'),

('','core.entity_view_display.node.nd_portfolio.teaser','a:10:{s:4:\"uuid\";s:36:\"399b2426-e8ab-40af-b722-11e0a0713c5f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:9:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:34:\"field.field.node.nd_portfolio.body\";i:2;s:44:\"field.field.node.nd_portfolio.field_category\";i:3;s:47:\"field.field.node.nd_portfolio.field_description\";i:4;s:42:\"field.field.node.nd_portfolio.field_images\";i:5;s:54:\"field.field.node.nd_portfolio.field_portfolio_category\";i:6;s:43:\"field.field.node.nd_portfolio.field_project\";i:7;s:48:\"field.field.node.nd_portfolio.field_project_link\";i:8;s:22:\"node.type.nd_portfolio\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:2:\"id\";s:24:\"node.nd_portfolio.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:101;s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:7:{s:14:\"field_category\";b:1;s:17:\"field_description\";b:1;s:12:\"field_images\";b:1;s:24:\"field_portfolio_category\";b:1;s:13:\"field_project\";b:1;s:18:\"field_project_link\";b:1;s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.page.default','a:11:{s:4:\"uuid\";s:36:\"4b5d356b-cddb-43d2-b937-048d92545e4f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"field.field.node.page.body\";i:1;s:14:\"node.type.page\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oZ-7vpIJxjxL2up9B5KrJGD0lazQ9aN0P-fIPo6OrSU\";}s:2:\"id\";s:17:\"node.page.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:1:{s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.page.teaser','a:11:{s:4:\"uuid\";s:36:\"1b9438b8-9cb8-4fde-b23d-b4a3de6fb4e8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:26:\"field.field.node.page.body\";i:2;s:14:\"node.type.page\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rN2zrScZAJ9xB16hm_Deb9QJKy6JXnn0PdI2n5Z3KRs\";}s:2:\"id\";s:16:\"node.page.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:100;s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:101;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:1:{s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.webform.default','a:11:{s:4:\"uuid\";s:36:\"239a4af4-005e-471c-acbc-411c533aaf1b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:29:\"field.field.node.webform.body\";i:1;s:32:\"field.field.node.webform.webform\";i:2;s:17:\"node.type.webform\";}s:6:\"module\";a:3:{i:0;s:4:\"text\";i:1;s:4:\"user\";i:2;s:7:\"webform\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lYtZnqtymopb5p4jvDFIJxP6GVRShntzUW4lC-6PVjE\";}s:2:\"id\";s:20:\"node.webform.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"webform\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:3:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:101;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"webform\";a:6:{s:6:\"weight\";i:102;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:36:\"webform_entity_reference_entity_view\";s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:1:{s:8:\"langcode\";b:1;}}'),

('','core.entity_view_display.node.webform.teaser','a:11:{s:4:\"uuid\";s:36:\"fec6bbda-ecff-4c72-9dc6-7408e00bfb62\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:29:\"field.field.node.webform.body\";i:2;s:32:\"field.field.node.webform.webform\";i:3;s:17:\"node.type.webform\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"GcTiETZqKZA6eKXXDvwzpP73csiMScB5_TyYGrKJMd8\";}s:2:\"id\";s:19:\"node.webform.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"webform\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:101;s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:2:{s:8:\"langcode\";b:1;s:7:\"webform\";b:1;}}'),

('','core.entity_view_display.profile.customer.default','a:11:{s:4:\"uuid\";s:36:\"cb97d704-d24b-4855-9d4a-ba7e59dbae53\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:36:\"field.field.profile.customer.address\";i:1;s:21:\"profile.type.customer\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:6:\"module\";a:1:{i:0;s:7:\"address\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-D8G44VGLIAIFvoHm_u7-Awnie4iCenOWfldrpNy_ys\";}s:2:\"id\";s:24:\"profile.customer.default\";s:16:\"targetEntityType\";s:7:\"profile\";s:6:\"bundle\";s:8:\"customer\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:1:{s:7:\"address\";a:6:{s:4:\"type\";s:15:\"address_default\";s:6:\"weight\";i:0;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),

('','core.entity_view_display.user.user.compact','a:11:{s:4:\"uuid\";s:36:\"059c1969-0726-46ce-9d52-896977422683\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:34:\"core.entity_view_mode.user.compact\";i:1;s:34:\"field.field.user.user.user_picture\";i:2;s:21:\"image.style.thumbnail\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"C3k_McOy8bL8rTnIjspy5OfFdgqV1z6OdGZaI-tO5eM\";}s:2:\"id\";s:17:\"user.user.compact\";s:16:\"targetEntityType\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:4:\"mode\";s:7:\"compact\";s:7:\"content\";a:1:{s:12:\"user_picture\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:11:\"image_style\";s:9:\"thumbnail\";s:10:\"image_link\";s:7:\"content\";}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:2:{s:8:\"langcode\";b:1;s:10:\"member_for\";b:1;}}'),

('','core.entity_view_display.user.user.default','a:11:{s:4:\"uuid\";s:36:\"ed00d8be-a7cd-4b2b-aa5f-cc677ac5eb29\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:40:\"field.field.user.user.commerce_remote_id\";i:1;s:34:\"field.field.user.user.user_picture\";i:2;s:21:\"image.style.thumbnail\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"L2mtwGWH_7wDRCMIR4r_Iu_jmvQ10DV1L8ht8iNZ5qY\";}s:2:\"id\";s:17:\"user.user.default\";s:16:\"targetEntityType\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:10:\"member_for\";a:4:{s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"user_picture\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:11:\"image_style\";s:9:\"thumbnail\";s:10:\"image_link\";s:7:\"content\";}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:3:{s:18:\"commerce_remote_id\";b:1;s:8:\"langcode\";b:1;s:16:\"profile_customer\";b:1;}}'),

('','core.entity_view_mode.block.token','a:8:{s:4:\"uuid\";s:36:\"94e9cbff-17b7-4b8a-9030-eb22324886f7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:5:\"block\";}}s:2:\"id\";s:11:\"block.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:5:\"block\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.block_content.full','a:9:{s:4:\"uuid\";s:36:\"72e43784-2487-4568-bd9b-05c3a338056c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:13:\"block_content\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"4tedlMuvQjDOdvHdw86_e-2Rt78aR7TGFMfOK8Ejppg\";}s:2:\"id\";s:18:\"block_content.full\";s:5:\"label\";s:4:\"Full\";s:16:\"targetEntityType\";s:13:\"block_content\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.block_content.token','a:8:{s:4:\"uuid\";s:36:\"07673261-080e-4a50-852c-bd9e886db1d6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:13:\"block_content\";}}s:2:\"id\";s:19:\"block_content.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:13:\"block_content\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.comment.full','a:9:{s:4:\"uuid\";s:36:\"60a9b621-eb2d-46e4-916f-f739edf85897\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"K7eNlfU7NEUajz01wItywZklr2oaPgL6s1_97fmDXLA\";}s:2:\"id\";s:12:\"comment.full\";s:5:\"label\";s:12:\"Full comment\";s:16:\"targetEntityType\";s:7:\"comment\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.comment.token','a:8:{s:4:\"uuid\";s:36:\"db1fcb51-5bc7-4e05-849e-ca6b77c7fec9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:2:\"id\";s:13:\"comment.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:7:\"comment\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_log.token','a:8:{s:4:\"uuid\";s:36:\"d2caae91-d08e-421c-9278-5c1bb875107b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:12:\"commerce_log\";}}s:2:\"id\";s:18:\"commerce_log.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:12:\"commerce_log\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_order.token','a:8:{s:4:\"uuid\";s:36:\"b3b612ac-3d51-4261-8868-de1375d2918a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:2:\"id\";s:20:\"commerce_order.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:14:\"commerce_order\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_order.user','a:9:{s:4:\"uuid\";s:36:\"e99adf1b-7fa7-4142-9dcd-33d3dc72d291\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"zGcQPC5MWgNSsQxarSWsXNIVpjb_vDAdcDLPupYmxQ8\";}s:2:\"id\";s:19:\"commerce_order.user\";s:5:\"label\";s:4:\"User\";s:16:\"targetEntityType\";s:14:\"commerce_order\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_order_item.token','a:8:{s:4:\"uuid\";s:36:\"e8b6282a-8507-4d69-ba74-63f1028cc573\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:2:\"id\";s:25:\"commerce_order_item.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:19:\"commerce_order_item\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_payment.token','a:8:{s:4:\"uuid\";s:36:\"97630941-78b2-4a55-9ed9-6283ca5f0761\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_payment\";}}s:2:\"id\";s:22:\"commerce_payment.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:16:\"commerce_payment\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_payment_method.token','a:8:{s:4:\"uuid\";s:36:\"9e7f623f-49e1-4c4a-a35d-afc6d1a0e00a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_payment\";}}s:2:\"id\";s:29:\"commerce_payment_method.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:23:\"commerce_payment_method\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_product.teaser','a:8:{s:4:\"uuid\";s:36:\"4c697c8d-f33a-4067-959f-d695db140887\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:23:\"commerce_product.teaser\";s:5:\"label\";s:6:\"Teaser\";s:16:\"targetEntityType\";s:16:\"commerce_product\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_product.token','a:8:{s:4:\"uuid\";s:36:\"f10494c0-cf92-406d-9fb5-e38568aff69f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:22:\"commerce_product.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:16:\"commerce_product\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_product_attribute_value.add_to_cart','a:9:{s:4:\"uuid\";s:36:\"a1bb2193-4919-4e99-8a78-5422d7b9ee6a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ry5RvX-mOnp2GQWzMqSYjPz-jKfP1nSo4Xo4kJCodlE\";}s:2:\"id\";s:44:\"commerce_product_attribute_value.add_to_cart\";s:5:\"label\";s:16:\"Add to Cart Form\";s:16:\"targetEntityType\";s:32:\"commerce_product_attribute_value\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_product_attribute_value.token','a:8:{s:4:\"uuid\";s:36:\"10f47fbf-5872-42c5-88ea-846b358284b6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:38:\"commerce_product_attribute_value.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:32:\"commerce_product_attribute_value\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_product_variation.cart','a:9:{s:4:\"uuid\";s:36:\"f67a6d60-c44e-43a0-af92-08fcda4c2c58\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SjZo-csuMc7wQHh55OpVRuTrQTp8zy3k6cR9RykDWIg\";}s:2:\"id\";s:31:\"commerce_product_variation.cart\";s:5:\"label\";s:4:\"Cart\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_product_variation.product','a:8:{s:4:\"uuid\";s:36:\"00a23ac9-466f-4d50-a5ed-99ec83d28919\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:34:\"commerce_product_variation.product\";s:5:\"label\";s:7:\"Product\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_product_variation.summary','a:9:{s:4:\"uuid\";s:36:\"ab59069e-a0ee-48e5-91b7-df9600f5b25b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QL02YVm5CFmG2b5knIj9s_FkzaNGqMWtMsTER6zzCtE\";}s:2:\"id\";s:34:\"commerce_product_variation.summary\";s:5:\"label\";s:7:\"Summary\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_product_variation.teaser','a:8:{s:4:\"uuid\";s:36:\"c2a4209a-8e50-41e0-8925-ad1d19e6dd9f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:33:\"commerce_product_variation.teaser\";s:5:\"label\";s:6:\"Teaser\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_product_variation.token','a:8:{s:4:\"uuid\";s:36:\"f5730cea-958a-48f6-b091-3fbecc2d8fb8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:32:\"commerce_product_variation.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:26:\"commerce_product_variation\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_promotion.token','a:8:{s:4:\"uuid\";s:36:\"87a751f6-2ac3-42cf-bdfb-f1cef31ca7cb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:18:\"commerce_promotion\";}}s:2:\"id\";s:24:\"commerce_promotion.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:18:\"commerce_promotion\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_promotion_coupon.token','a:8:{s:4:\"uuid\";s:36:\"858594c0-b77f-4459-a9bc-c219832dfd5b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:18:\"commerce_promotion\";}}s:2:\"id\";s:31:\"commerce_promotion_coupon.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:25:\"commerce_promotion_coupon\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.commerce_store.token','a:8:{s:4:\"uuid\";s:36:\"137e0af5-04e2-4a91-9c65-d2e69f436ad1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_store\";}}s:2:\"id\";s:20:\"commerce_store.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:14:\"commerce_store\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.contact_message.token','a:8:{s:4:\"uuid\";s:36:\"c72ea520-4b1d-40ee-b6dd-ab3adb6c2fd8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"contact\";}}s:2:\"id\";s:21:\"contact_message.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:15:\"contact_message\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.file.token','a:8:{s:4:\"uuid\";s:36:\"a57c17e2-4d3f-47e1-869f-76a70cd98b91\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"file\";}}s:2:\"id\";s:10:\"file.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:4:\"file\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.menu_link_content.token','a:8:{s:4:\"uuid\";s:36:\"e56dc2cb-93e5-47b2-a253-5b5850500add\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:17:\"menu_link_content\";}}s:2:\"id\";s:23:\"menu_link_content.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:17:\"menu_link_content\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.node.full','a:9:{s:4:\"uuid\";s:36:\"43261824-1385-4cca-b883-32b43ffd74f6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ElrtInxGjZd7GaapJ5O9n-ugi2hG2IxFivtgn0tHOsk\";}s:2:\"id\";s:9:\"node.full\";s:5:\"label\";s:12:\"Full content\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.node.rss','a:9:{s:4:\"uuid\";s:36:\"0e61c089-b9ab-41ac-ada7-62fb84458a52\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vlYzr-rp2f9NMp-Qlr4sFjlqRq-90mco5-afLNGwCrU\";}s:2:\"id\";s:8:\"node.rss\";s:5:\"label\";s:3:\"RSS\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.node.search_index','a:9:{s:4:\"uuid\";s:36:\"2bbb0235-f556-41fb-8a2d-4835d7aa9989\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fVFfJv_GzBRE-wpRHbfD5a3VjnhbEOXG6lvRd3uaccY\";}s:2:\"id\";s:17:\"node.search_index\";s:5:\"label\";s:12:\"Search index\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.node.search_result','a:9:{s:4:\"uuid\";s:36:\"e4c61b96-61b4-4ad7-9eff-38abc6e1cd23\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6GCOQ-jP2RbdbHA5YWQ6bT8CfGbqrBYKOSC_XY4E3ZM\";}s:2:\"id\";s:18:\"node.search_result\";s:5:\"label\";s:32:\"Search result highlighting input\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.node.teaser','a:9:{s:4:\"uuid\";s:36:\"21bfaf23-c45a-4076-b449-08488497ba0c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Mz9qWr1kUYK0mjRAGDsr5XS6PvtZ24en_7ndt-pyWe4\";}s:2:\"id\";s:11:\"node.teaser\";s:5:\"label\";s:6:\"Teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.node.token','a:8:{s:4:\"uuid\";s:36:\"269ffdd3-3d85-47cc-9ff5-18ab1673c499\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:2:\"id\";s:10:\"node.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.profile.token','a:8:{s:4:\"uuid\";s:36:\"5651025a-8ab7-41d9-829f-0354b897f54b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"profile\";}}s:2:\"id\";s:13:\"profile.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:7:\"profile\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.shortcut.token','a:8:{s:4:\"uuid\";s:36:\"1b13d02f-a6f6-44e2-9dec-12565d0b5469\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"shortcut\";}}s:2:\"id\";s:14:\"shortcut.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:8:\"shortcut\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.taxonomy_term.full','a:9:{s:4:\"uuid\";s:36:\"89f05268-da12-49e4-8840-d191757cd0bf\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-PPKjsNQPvoIDjOuUAvlLocYD976MNjb9Zpgyz5_BWE\";}s:2:\"id\";s:18:\"taxonomy_term.full\";s:5:\"label\";s:18:\"Taxonomy term page\";s:16:\"targetEntityType\";s:13:\"taxonomy_term\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.taxonomy_term.token','a:8:{s:4:\"uuid\";s:36:\"9d1671c5-e222-439b-a13c-09089b103b55\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"taxonomy\";}}s:2:\"id\";s:19:\"taxonomy_term.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:13:\"taxonomy_term\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.tour.token','a:8:{s:4:\"uuid\";s:36:\"3255b3e3-650b-40d1-bea3-8a7e6e3d6f3b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"tour\";}}s:2:\"id\";s:10:\"tour.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:4:\"tour\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.user.compact','a:9:{s:4:\"uuid\";s:36:\"d2398234-4c6b-48d1-bf42-9e06abcd48fa\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"71CSAr_LNPcgu6D6jI4INl1KATkahmeyUFBETAWya8g\";}s:2:\"id\";s:12:\"user.compact\";s:5:\"label\";s:7:\"Compact\";s:16:\"targetEntityType\";s:4:\"user\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.user.full','a:9:{s:4:\"uuid\";s:36:\"f8e7377a-e0f4-464a-b37d-4d0913c938e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"mQIF_foYjmnVSr9MpcD4CTaJE_FpO1AyDd_DskztGhM\";}s:2:\"id\";s:9:\"user.full\";s:5:\"label\";s:12:\"User account\";s:16:\"targetEntityType\";s:4:\"user\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.user.token','a:8:{s:4:\"uuid\";s:36:\"d89f15e3-66b9-4d1e-93db-976341fa8be7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:2:\"id\";s:10:\"user.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:4:\"user\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.vote.token','a:8:{s:4:\"uuid\";s:36:\"adc28452-0a97-4256-924e-6281c00888fd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:9:\"votingapi\";}}s:2:\"id\";s:10:\"vote.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:4:\"vote\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.vote_result.token','a:8:{s:4:\"uuid\";s:36:\"895a4f03-c97f-4d96-bb19-6719e458e93b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:9:\"votingapi\";}}s:2:\"id\";s:17:\"vote_result.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:11:\"vote_result\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.webform.token','a:8:{s:4:\"uuid\";s:36:\"82d7176a-cdcb-4c8d-8fd8-b4e188e3d6e5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}s:2:\"id\";s:13:\"webform.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:7:\"webform\";s:5:\"cache\";b:1;}'),

('','core.entity_view_mode.webform_submission.token','a:8:{s:4:\"uuid\";s:36:\"625e67d4-fc08-4f83-aca3-3ba6ccf0d22c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}s:2:\"id\";s:24:\"webform_submission.token\";s:5:\"label\";s:5:\"Token\";s:16:\"targetEntityType\";s:18:\"webform_submission\";s:5:\"cache\";b:1;}'),

('','core.extension','a:4:{s:6:\"module\";a:83:{s:7:\"address\";i:0;s:13:\"admin_toolbar\";i:0;s:19:\"admin_toolbar_tools\";i:0;s:5:\"block\";i:0;s:13:\"block_content\";i:0;s:10:\"breakpoint\";i:0;s:8:\"ckeditor\";i:0;s:5:\"color\";i:0;s:7:\"comment\";i:0;s:8:\"commerce\";i:0;s:13:\"commerce_cart\";i:0;s:17:\"commerce_checkout\";i:0;s:12:\"commerce_ext\";i:0;s:12:\"commerce_log\";i:0;s:14:\"commerce_order\";i:0;s:16:\"commerce_payment\";i:0;s:24:\"commerce_payment_example\";i:0;s:14:\"commerce_price\";i:0;s:16:\"commerce_product\";i:0;s:18:\"commerce_promotion\";i:0;s:14:\"commerce_store\";i:0;s:28:\"commerce_variation_cart_form\";i:0;s:6:\"config\";i:0;s:13:\"config_update\";i:0;s:7:\"contact\";i:0;s:10:\"contextual\";i:0;s:6:\"ctools\";i:0;s:8:\"datetime\";i:0;s:5:\"dblog\";i:0;s:10:\"dropzonejs\";i:0;s:20:\"dropzonejs_eb_widget\";i:0;s:6:\"editor\";i:0;s:5:\"embed\";i:0;s:6:\"entity\";i:0;s:14:\"entity_browser\";i:0;s:12:\"entity_embed\";i:0;s:26:\"entity_reference_revisions\";i:0;s:5:\"field\";i:0;s:11:\"field_group\";i:0;s:8:\"field_ui\";i:0;s:4:\"file\";i:0;s:12:\"file_browser\";i:0;s:6:\"filter\";i:0;s:8:\"fivestar\";i:0;s:3:\"hal\";i:0;s:4:\"help\";i:0;s:5:\"image\";i:0;s:18:\"inline_entity_form\";i:0;s:8:\"language\";i:0;s:4:\"link\";i:0;s:7:\"menu_ui\";i:0;s:19:\"nd_visualshortcodes\";i:0;s:12:\"nikadevs_cms\";i:0;s:4:\"node\";i:0;s:7:\"options\";i:0;s:4:\"path\";i:0;s:7:\"profile\";i:0;s:4:\"rest\";i:0;s:10:\"rhythm_cms\";i:0;s:17:\"rhythm_shortcodes\";i:0;s:6:\"search\";i:0;s:13:\"serialization\";i:0;s:9:\"shortcode\";i:0;s:8:\"shortcut\";i:0;s:13:\"state_machine\";i:0;s:6:\"system\";i:0;s:8:\"taxonomy\";i:0;s:11:\"tb_megamenu\";i:0;s:4:\"text\";i:0;s:5:\"token\";i:0;s:7:\"toolbar\";i:0;s:4:\"tour\";i:0;s:6:\"update\";i:0;s:4:\"user\";i:0;s:8:\"views_ui\";i:0;s:9:\"votingapi\";i:0;s:7:\"webform\";i:0;s:12:\"webform_node\";i:0;s:10:\"webform_ui\";i:0;s:17:\"menu_link_content\";i:1;s:8:\"pathauto\";i:1;s:5:\"views\";i:10;s:8:\"standard\";i:1000;}s:5:\"theme\";a:5:{s:6:\"stable\";i:0;s:6:\"classy\";i:0;s:5:\"seven\";i:0;s:6:\"rhythm\";i:0;s:10:\"rhythm_sub\";i:0;}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"m2GVq11UAOVuNgj8x0t5fMOPujpvQQ_zxLoaly1BMEU\";}s:7:\"profile\";s:8:\"standard\";}'),

('','core.menu.static_menu_link_overrides','a:2:{s:11:\"definitions\";a:2:{s:18:\"contact__site_page\";a:5:{s:7:\"enabled\";b:1;s:9:\"menu_name\";s:6:\"footer\";s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:0;s:8:\"expanded\";b:0;}s:20:\"standard__front_page\";a:5:{s:6:\"weight\";i:-50;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:8:\"expanded\";b:0;s:7:\"enabled\";b:1;}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jdY7AU0tU-QsjmiOw3W8vwpYMb-By--_MSFgbqKUTYM\";}}'),

('','dblog.settings','a:2:{s:9:\"row_limit\";i:1000;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"e883aGsrt1wFrsydlYU584PZONCSfRy0DtkZ9KzHb58\";}}'),

('','dropzonejs.settings','a:2:{s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-kBG2Wgj1xQI9TKw5tYCEZovGDsS_0D6k394eWokypM\";}s:17:\"tmp_upload_scheme\";s:9:\"temporary\";}'),

('','editor.editor.basic_html','a:9:{s:4:\"uuid\";s:36:\"0fcb0d4b-89cc-404d-abc4-dbc5aaf31e45\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:24:\"filter.format.basic_html\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AqlPmO16LvJI4D0Ih6u4GFQIzqr5OnLgAUSjcUGWk2g\";}s:6:\"format\";s:10:\"basic_html\";s:6:\"editor\";s:8:\"ckeditor\";s:8:\"settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:6:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:2:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";}}i:1;a:2:{s:4:\"name\";s:7:\"Linking\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:2:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";}}i:4;a:2:{s:4:\"name\";s:16:\"Block Formatting\";s:5:\"items\";a:1:{i:0;s:6:\"Format\";}}i:5;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:1:{i:0;s:6:\"Source\";}}}}}s:7:\"plugins\";a:1:{s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:12:\"image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";i:0;s:6:\"height\";i:0;}}}'),

('','editor.editor.ckeditor','a:8:{s:4:\"uuid\";s:36:\"af9b5cee-8d4c-4a99-bb39-42fe2ce351d5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:22:\"filter.format.ckeditor\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}s:6:\"format\";s:8:\"ckeditor\";s:6:\"editor\";s:8:\"ckeditor\";s:8:\"settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:5:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:2:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";}}i:1;a:2:{s:4:\"name\";s:5:\"Links\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:2:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";}}i:4;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:1:{i:0;s:6:\"Source\";}}}}}s:7:\"plugins\";a:2:{s:8:\"language\";a:1:{s:13:\"language_list\";s:2:\"un\";}s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:12:\"image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";N;s:6:\"height\";N;}}}'),

('','editor.editor.full_html','a:9:{s:4:\"uuid\";s:36:\"0d612a63-de40-431e-bef7-0f27909891d2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:23:\"filter.format.full_html\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"967ijj7p6i7rwrYl7r08WQFeCY_c23YAh0h8u-w_CXM\";}s:6:\"format\";s:9:\"full_html\";s:6:\"editor\";s:8:\"ckeditor\";s:8:\"settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:6:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:7:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";i:2;s:6:\"Strike\";i:3;s:11:\"Superscript\";i:4;s:9:\"Subscript\";i:5;s:1:\"-\";i:6;s:12:\"RemoveFormat\";}}i:1;a:2:{s:4:\"name\";s:7:\"Linking\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:4:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";i:2;s:5:\"Table\";i:3;s:14:\"HorizontalRule\";}}i:4;a:2:{s:4:\"name\";s:16:\"Block Formatting\";s:5:\"items\";a:1:{i:0;s:6:\"Format\";}}i:5;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:2:{i:0;s:10:\"ShowBlocks\";i:1;s:6:\"Source\";}}}}}s:7:\"plugins\";a:1:{s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:12:\"image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";i:0;s:6:\"height\";i:0;}}}'),

('','embed.button.file_browser','a:10:{s:4:\"uuid\";s:36:\"fa7c6394-c7a8-477b-a404-32e03bb3a327\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:12:\"entity_embed\";i:1;s:4:\"file\";i:2;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"D5QbkhbHfWlohKBxTofPCBUqp9vCE2dFnJii5JdWEk4\";}s:5:\"label\";s:12:\"File Browser\";s:2:\"id\";s:12:\"file_browser\";s:7:\"type_id\";s:6:\"entity\";s:13:\"type_settings\";a:5:{s:11:\"entity_type\";s:4:\"file\";s:7:\"bundles\";a:0:{}s:15:\"display_plugins\";a:2:{i:0;s:17:\"file:file_default\";i:1;s:11:\"image:image\";}s:14:\"entity_browser\";s:12:\"browse_files\";s:23:\"entity_browser_settings\";a:1:{s:14:\"display_review\";b:0;}}s:9:\"icon_uuid\";s:36:\"db2cad05-1e3b-4b35-b163-99d7d036130c\";}'),

('','embed.button.node','a:10:{s:4:\"uuid\";s:36:\"004523b2-cffc-44d9-b946-2fff79471ed2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:12:\"entity_embed\";i:1;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"xgvZUh-eaMilacE1XYCQ9nLH-2-meOjCyofXSO82gqg\";}s:5:\"label\";s:4:\"Node\";s:2:\"id\";s:4:\"node\";s:7:\"type_id\";s:6:\"entity\";s:13:\"type_settings\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:7:\"bundles\";a:0:{}s:15:\"display_plugins\";a:0:{}}s:9:\"icon_uuid\";N;}'),

('','embed.settings','a:3:{s:11:\"file_scheme\";s:6:\"public\";s:16:\"upload_directory\";s:13:\"embed_buttons\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ed6LXVlKotwVS4tx7_rnsL-6NlBoD-PLu3KFPAvpNMc\";}}'),

('','entity_browser.browser.browse_files','a:14:{s:4:\"uuid\";s:36:\"5352b42f-b8a4-478b-91bc-c875de12c35d\";s:8:\"langcode\";s:3:\"und\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:30:\"views.view.file_entity_browser\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:12:\"file_browser\";}}s:6:\"module\";a:2:{i:0;s:20:\"dropzonejs_eb_widget\";i:1;s:5:\"views\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1Y-fC4LxFu8Rg3SCSaYMZMXRAvMtueQ3JQIiKuna8hM\";}s:4:\"name\";s:12:\"browse_files\";s:5:\"label\";s:17:\"Browser for files\";s:7:\"display\";s:6:\"iframe\";s:21:\"display_configuration\";a:4:{s:5:\"width\";s:4:\"100%\";s:6:\"height\";s:3:\"768\";s:9:\"link_text\";s:12:\"Select files\";s:9:\"auto_open\";b:1;}s:17:\"selection_display\";s:18:\"multi_step_display\";s:31:\"selection_display_configuration\";a:5:{s:11:\"entity_type\";s:4:\"file\";s:7:\"display\";s:9:\"thumbnail\";s:16:\"display_settings\";a:1:{s:11:\"image_style\";s:25:\"file_entity_browser_small\";}s:11:\"select_text\";s:12:\"Use selected\";s:16:\"selection_hidden\";b:0;}s:15:\"widget_selector\";s:4:\"tabs\";s:29:\"widget_selector_configuration\";a:0:{}s:7:\"widgets\";a:2:{s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";a:5:{s:8:\"settings\";a:4:{s:4:\"view\";s:19:\"file_entity_browser\";s:12:\"view_display\";s:16:\"entity_browser_1\";s:11:\"submit_text\";s:15:\"Select entities\";s:11:\"auto_select\";b:1;}s:4:\"uuid\";s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";s:6:\"weight\";i:1;s:5:\"label\";s:13:\"Files listing\";s:2:\"id\";s:4:\"view\";}s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";a:5:{s:8:\"settings\";a:12:{s:15:\"upload_location\";s:9:\"public://\";s:20:\"dropzone_description\";s:39:\"Click or drop files here to upload them\";s:12:\"max_filesize\";s:4:\"100M\";s:10:\"extensions\";s:52:\"jpg jpeg gif png txt doc xls pdf ppt pps odt ods odp\";s:17:\"clientside_resize\";b:0;s:12:\"resize_width\";i:0;s:13:\"resize_height\";i:0;s:14:\"resize_quality\";d:1;s:13:\"resize_method\";s:7:\"contain\";s:16:\"thumbnail_method\";s:7:\"contain\";s:11:\"submit_text\";s:15:\"Select entities\";s:11:\"auto_select\";b:0;}s:4:\"uuid\";s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";s:6:\"weight\";i:0;s:5:\"label\";s:12:\"Upload files\";s:2:\"id\";s:10:\"dropzonejs\";}}}'),

('','entity_browser.browser.browse_files_modal','a:14:{s:4:\"uuid\";s:36:\"913ed4a9-5f97-4f82-9a61-a4e18faaf1c5\";s:8:\"langcode\";s:3:\"und\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:30:\"views.view.file_entity_browser\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:12:\"file_browser\";}}s:6:\"module\";a:2:{i:0;s:20:\"dropzonejs_eb_widget\";i:1;s:5:\"views\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"pmVBtnEbW_kn2teUZPaK_iHWnP9mw7OaZzQvuX7g0BM\";}s:4:\"name\";s:18:\"browse_files_modal\";s:5:\"label\";s:25:\"Browser for files (modal)\";s:7:\"display\";s:5:\"modal\";s:21:\"display_configuration\";a:4:{s:5:\"width\";s:4:\"1100\";s:6:\"height\";s:3:\"650\";s:9:\"link_text\";s:12:\"Select files\";s:9:\"auto_open\";b:0;}s:17:\"selection_display\";s:18:\"multi_step_display\";s:31:\"selection_display_configuration\";a:5:{s:11:\"entity_type\";s:4:\"file\";s:7:\"display\";s:9:\"thumbnail\";s:16:\"display_settings\";a:1:{s:11:\"image_style\";s:25:\"file_entity_browser_small\";}s:11:\"select_text\";s:12:\"Use selected\";s:16:\"selection_hidden\";b:0;}s:15:\"widget_selector\";s:4:\"tabs\";s:29:\"widget_selector_configuration\";a:0:{}s:7:\"widgets\";a:2:{s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";a:5:{s:8:\"settings\";a:4:{s:4:\"view\";s:19:\"file_entity_browser\";s:12:\"view_display\";s:16:\"entity_browser_1\";s:11:\"submit_text\";s:15:\"Select entities\";s:11:\"auto_select\";b:1;}s:4:\"uuid\";s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";s:6:\"weight\";i:1;s:5:\"label\";s:13:\"Files listing\";s:2:\"id\";s:4:\"view\";}s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";a:5:{s:8:\"settings\";a:12:{s:15:\"upload_location\";s:9:\"public://\";s:20:\"dropzone_description\";s:39:\"Click or drop files here to upload them\";s:12:\"max_filesize\";s:4:\"100M\";s:10:\"extensions\";s:52:\"jpg jpeg gif png txt doc xls pdf ppt pps odt ods odp\";s:17:\"clientside_resize\";b:0;s:12:\"resize_width\";i:0;s:13:\"resize_height\";i:0;s:14:\"resize_quality\";d:1;s:13:\"resize_method\";s:7:\"contain\";s:16:\"thumbnail_method\";s:7:\"contain\";s:11:\"submit_text\";s:15:\"Select entities\";s:11:\"auto_select\";b:0;}s:4:\"uuid\";s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";s:6:\"weight\";i:0;s:5:\"label\";s:12:\"Upload files\";s:2:\"id\";s:10:\"dropzonejs\";}}}'),

('','entity_embed.settings','a:2:{s:20:\"rendered_entity_mode\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"2qpyZdlgcQidJq1yw1VHXLCl5jDi4dKBWFWLQR4VDfw\";}}'),

('','field.field.block_content.basic.body','a:17:{s:4:\"uuid\";s:36:\"90a6eb7e-12aa-4789-bc1b-1f40004297f6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:24:\"block_content.type.basic\";i:1;s:32:\"field.storage.block_content.body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"R__6wc-rMfFMO8d7jcgqnqiA92j8spKhcc5MiqecrMc\";}s:2:\"id\";s:24:\"block_content.basic.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";s:5:\"basic\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:0;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),

('','field.field.comment.comment.field_comment','a:16:{s:4:\"uuid\";s:36:\"c482d988-cf89-4ca8-9506-defe4cc5a017\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:20:\"comment.type.comment\";i:1;s:35:\"field.storage.comment.field_comment\";}}s:2:\"id\";s:29:\"comment.comment.field_comment\";s:10:\"field_name\";s:13:\"field_comment\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";s:5:\"label\";s:7:\"Comment\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:11:\"string_long\";}'),

('','field.field.comment.comment.field_email','a:16:{s:4:\"uuid\";s:36:\"93f1f700-fec3-4483-b45c-595db092fd6f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:20:\"comment.type.comment\";i:1;s:33:\"field.storage.comment.field_email\";}}s:2:\"id\";s:27:\"comment.comment.field_email\";s:10:\"field_name\";s:11:\"field_email\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";s:5:\"label\";s:5:\"Email\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:5:\"email\";}'),

('','field.field.comment.default_reviews.field_comment','a:16:{s:4:\"uuid\";s:36:\"fad04b88-9378-485b-b79d-c3a8ea284f40\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:28:\"comment.type.default_reviews\";i:1;s:35:\"field.storage.comment.field_comment\";}}s:2:\"id\";s:37:\"comment.default_reviews.field_comment\";s:10:\"field_name\";s:13:\"field_comment\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:15:\"default_reviews\";s:5:\"label\";s:7:\"Comment\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:11:\"string_long\";}'),

('','field.field.comment.default_reviews.field_email','a:16:{s:4:\"uuid\";s:36:\"b2ef3702-a984-4c6b-aa3c-cadb24aa651f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:28:\"comment.type.default_reviews\";i:1;s:33:\"field.storage.comment.field_email\";}}s:2:\"id\";s:35:\"comment.default_reviews.field_email\";s:10:\"field_name\";s:11:\"field_email\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:15:\"default_reviews\";s:5:\"label\";s:5:\"Email\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:5:\"email\";}'),

('','field.field.comment.default_reviews.field_rating','a:16:{s:4:\"uuid\";s:36:\"574ef56c-fdbf-4cf3-85a1-1917d7fa0034\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:28:\"comment.type.default_reviews\";i:1;s:34:\"field.storage.comment.field_rating\";}s:6:\"module\";a:1:{i:0;s:8:\"fivestar\";}}s:2:\"id\";s:36:\"comment.default_reviews.field_rating\";s:10:\"field_name\";s:12:\"field_rating\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:15:\"default_reviews\";s:5:\"label\";s:6:\"Rating\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:11:\"rated_while\";s:7:\"viewing\";s:6:\"target\";s:0:\"\";}s:10:\"field_type\";s:8:\"fivestar\";}'),

('','field.field.commerce_order.default.order_items','a:17:{s:4:\"uuid\";s:36:\"7fea0d50-385e-4201-87ee-49532870483e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:42:\"commerce_order.commerce_order_type.default\";i:1;s:40:\"field.storage.commerce_order.order_items\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"iqPSpcfsl-SdT3MtQLp1uBc4udRzM_185m3Yqd5KdTA\";}s:2:\"id\";s:34:\"commerce_order.default.order_items\";s:10:\"field_name\";s:11:\"order_items\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";s:7:\"default\";s:5:\"label\";s:11:\"Order items\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:27:\"default:commerce_order_item\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.commerce_product.default.body','a:17:{s:4:\"uuid\";s:36:\"7c1e45a6-9c35-4122-ba59-3da81dabce1c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:46:\"commerce_product.commerce_product_type.default\";i:1;s:35:\"field.storage.commerce_product.body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ObNdu_OSuSmozy8UUi9cKY41dPs7s1ZOuWhG6Q5KdR8\";}s:2:\"id\";s:29:\"commerce_product.default.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:7:\"default\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:0;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),

('','field.field.commerce_product.default.stores','a:17:{s:4:\"uuid\";s:36:\"94063973-4846-4d28-8079-636230d854c5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:46:\"commerce_product.commerce_product_type.default\";i:1;s:37:\"field.storage.commerce_product.stores\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"RYNTEdoNOXnNo71_mrAz8Gz37XTuuUsXOZTzAYx9wI8\";}s:2:\"id\";s:31:\"commerce_product.default.stores\";s:10:\"field_name\";s:6:\"stores\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:7:\"default\";s:5:\"label\";s:6:\"Stores\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:22:\"default:commerce_store\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.commerce_product.default.variations','a:17:{s:4:\"uuid\";s:36:\"cbc3bd3b-73c0-462a-8fcf-8c36a45f3538\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:46:\"commerce_product.commerce_product_type.default\";i:1;s:56:\"commerce_product.commerce_product_variation_type.default\";i:2;s:41:\"field.storage.commerce_product.variations\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-I2JKkD4E2ths6CAmEuI9IWXzBLBO5CcOKVIyc81CNE\";}s:2:\"id\";s:35:\"commerce_product.default.variations\";s:10:\"field_name\";s:10:\"variations\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:7:\"default\";s:5:\"label\";s:10:\"Variations\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"default\";}}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.commerce_product.product_display.field_category','a:16:{s:4:\"uuid\";s:36:\"8e0c0798-1c2d-453d-925d-0014acda854d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"field.storage.commerce_product.field_category\";i:2;s:28:\"taxonomy.vocabulary.category\";}}s:2:\"id\";s:47:\"commerce_product.product_display.field_category\";s:10:\"field_name\";s:14:\"field_category\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:5:\"label\";s:8:\"Category\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:4:{s:14:\"target_bundles\";a:1:{s:8:\"category\";s:8:\"category\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.commerce_product.product_display.field_rating','a:16:{s:4:\"uuid\";s:36:\"a0bfaa4a-c7eb-4698-bde0-8ea62ce66979\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:43:\"field.storage.commerce_product.field_rating\";}s:6:\"module\";a:1:{i:0;s:8:\"fivestar\";}}s:2:\"id\";s:45:\"commerce_product.product_display.field_rating\";s:10:\"field_name\";s:12:\"field_rating\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:5:\"label\";s:6:\"Rating\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:2:{s:6:\"rating\";s:2:\"20\";s:6:\"target\";N;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:11:\"rated_while\";s:7:\"viewing\";s:6:\"target\";s:0:\"\";}s:10:\"field_type\";s:8:\"fivestar\";}'),

('','field.field.commerce_product.product_display.field_reviews','a:16:{s:4:\"uuid\";s:36:\"986a1e1d-96d9-47ec-8cae-485d0565e59e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:44:\"field.storage.commerce_product.field_reviews\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:2:\"id\";s:46:\"commerce_product.product_display.field_reviews\";s:10:\"field_name\";s:13:\"field_reviews\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:5:\"label\";s:7:\"Reviews\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:9:\"anonymous\";i:0;s:13:\"form_location\";b:1;s:7:\"preview\";i:0;}s:10:\"field_type\";s:7:\"comment\";}'),

('','field.field.commerce_product.product_display.field_tags','a:16:{s:4:\"uuid\";s:36:\"b69d73f2-71d5-4cc5-8147-318e1052d030\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:41:\"field.storage.commerce_product.field_tags\";i:2;s:24:\"taxonomy.vocabulary.tags\";}}s:2:\"id\";s:43:\"commerce_product.product_display.field_tags\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:4:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.commerce_product.product_display.stores','a:16:{s:4:\"uuid\";s:36:\"554cfe29-4a86-410d-b523-75fb4b615ae6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:37:\"field.storage.commerce_product.stores\";}}s:2:\"id\";s:39:\"commerce_product.product_display.stores\";s:10:\"field_name\";s:6:\"stores\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:5:\"label\";s:6:\"Stores\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";N;s:8:\"settings\";a:2:{s:7:\"handler\";s:22:\"default:commerce_store\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.commerce_product.product_display.variations','a:16:{s:4:\"uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}s:2:\"id\";s:43:\"commerce_product.product_display.variations\";s:10:\"field_name\";s:10:\"variations\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:5:\"label\";s:10:\"Variations\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";N;s:8:\"settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.commerce_product_variation.product.attribute_color','a:16:{s:4:\"uuid\";s:36:\"a19b6f33-3d39-401d-a5b0-3c6d6a4f5705\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:49:\"commerce_product.commerce_product_attribute.color\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:56:\"field.storage.commerce_product_variation.attribute_color\";}}s:2:\"id\";s:50:\"commerce_product_variation.product.attribute_color\";s:10:\"field_name\";s:15:\"attribute_color\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:5:\"Color\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:40:\"default:commerce_product_attribute_value\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:5:\"color\";}}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.commerce_product_variation.product.attribute_size','a:16:{s:4:\"uuid\";s:36:\"34861c66-95f2-4023-95f8-9fe67b06ff97\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:48:\"commerce_product.commerce_product_attribute.size\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:55:\"field.storage.commerce_product_variation.attribute_size\";}}s:2:\"id\";s:49:\"commerce_product_variation.product.attribute_size\";s:10:\"field_name\";s:14:\"attribute_size\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:4:\"Size\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:40:\"default:commerce_product_attribute_value\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:4:\"size\";}}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.commerce_product_variation.product.field_description','a:16:{s:4:\"uuid\";s:36:\"61375016-53a6-4fbc-8ce8-37589320889b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:58:\"field.storage.commerce_product_variation.field_description\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:2:\"id\";s:52:\"commerce_product_variation.product.field_description\";s:10:\"field_name\";s:17:\"field_description\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}'),

('','field.field.commerce_product_variation.product.field_images','a:16:{s:4:\"uuid\";s:36:\"7300e286-d57c-4fc2-9bb8-458dbc70ea43\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:53:\"field.storage.commerce_product_variation.field_images\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:2:\"id\";s:47:\"commerce_product_variation.product.field_images\";s:10:\"field_name\";s:12:\"field_images\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:6:\"Images\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:1;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),

('','field.field.commerce_product_variation.product.field_length','a:16:{s:4:\"uuid\";s:36:\"783d557b-e8e7-4552-909b-1f6b94f3017a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:53:\"field.storage.commerce_product_variation.field_length\";}}s:2:\"id\";s:47:\"commerce_product_variation.product.field_length\";s:10:\"field_name\";s:12:\"field_length\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:6:\"Length\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}'),

('','field.field.commerce_product_variation.product.field_old_price','a:16:{s:4:\"uuid\";s:36:\"89a431f2-70bc-4c3b-82f2-f47211d9072b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:56:\"field.storage.commerce_product_variation.field_old_price\";}s:6:\"module\";a:1:{i:0;s:14:\"commerce_price\";}}s:2:\"id\";s:50:\"commerce_product_variation.product.field_old_price\";s:10:\"field_name\";s:15:\"field_old_price\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:9:\"Old Price\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:20:\"available_currencies\";a:1:{s:3:\"USD\";s:3:\"USD\";}}s:10:\"field_type\";s:14:\"commerce_price\";}'),

('','field.field.commerce_product_variation.product.field_right_side_description','a:16:{s:4:\"uuid\";s:36:\"1b1dc360-45ef-4812-8565-26ff7a0e037c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:69:\"field.storage.commerce_product_variation.field_right_side_description\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:2:\"id\";s:63:\"commerce_product_variation.product.field_right_side_description\";s:10:\"field_name\";s:28:\"field_right_side_description\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:22:\"Right Side Description\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}'),

('','field.field.commerce_product_variation.product.field_sale_text','a:16:{s:4:\"uuid\";s:36:\"1e8bbed1-a729-4caa-9fd2-f5de5dc36c0d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:56:\"field.storage.commerce_product_variation.field_sale_text\";}}s:2:\"id\";s:50:\"commerce_product_variation.product.field_sale_text\";s:10:\"field_name\";s:15:\"field_sale_text\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:9:\"Sale text\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}'),

('','field.field.commerce_product_variation.product.field_short_description','a:16:{s:4:\"uuid\";s:36:\"c1e8ee36-77c1-44a6-ab8d-9e50be4e43d1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:64:\"field.storage.commerce_product_variation.field_short_description\";}}s:2:\"id\";s:58:\"commerce_product_variation.product.field_short_description\";s:10:\"field_name\";s:23:\"field_short_description\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:17:\"Short Description\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:11:\"string_long\";}'),

('','field.field.commerce_product_variation.product.field_waist','a:16:{s:4:\"uuid\";s:36:\"095a2dde-3f9b-4583-8e34-d1c9ce74bc5a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:52:\"field.storage.commerce_product_variation.field_waist\";}}s:2:\"id\";s:46:\"commerce_product_variation.product.field_waist\";s:10:\"field_name\";s:11:\"field_waist\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:5:\"label\";s:5:\"Waist\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}'),

('','field.field.node.article.body','a:17:{s:4:\"uuid\";s:36:\"024925ec-7efe-40fc-b005-43b911e175ac\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ay3b2hq42cpQTFB_lNu8S2ZxuVIY6-dlBsc7vLeJ-YY\";}s:2:\"id\";s:17:\"node.article.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),

('','field.field.node.article.comment','a:17:{s:4:\"uuid\";s:36:\"9fa91801-2955-4202-90c4-56dd33cb3ff7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"field.storage.node.comment\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"szSOp-8eNsMcuh8usDre1x76RhDKaPhNUuwzRX5cgv4\";}s:2:\"id\";s:20:\"node.article.comment\";s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:8:\"Comments\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:17:\"last_comment_name\";N;s:22:\"last_comment_timestamp\";i:0;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:13:\"form_location\";b:1;s:9:\"anonymous\";i:0;s:7:\"preview\";i:1;}s:10:\"field_type\";s:7:\"comment\";}'),

('','field.field.node.article.field_image','a:17:{s:4:\"uuid\";s:36:\"0d1135c9-2e67-4cdd-9c21-80c6cbb67354\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:30:\"field.storage.node.field_image\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tgJzhA7Swh4M_gWU5FwFe5lPxPj5rebpMbvhpdNrERs\";}s:2:\"id\";s:24:\"node.article.field_image\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";b:0;s:18:\"alt_field_required\";b:1;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),

('','field.field.node.article.field_tags','a:17:{s:4:\"uuid\";s:36:\"9f332e64-b08c-4637-9c7c-7e111dfa9b12\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:29:\"field.storage.node.field_tags\";i:1;s:17:\"node.type.article\";i:2;s:24:\"taxonomy.vocabulary.tags\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QdUgf_beeoaPiyKorFv0q1fcJpWH_uZTqe_xoVJacrw\";}s:2:\"id\";s:23:\"node.article.field_tags\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:84:\"Enter a comma-separated list. For example: Amsterdam, Mexico City, \"Cleveland, Ohio\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:1;}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.node.gallery_item.field_gallery','a:16:{s:4:\"uuid\";s:36:\"74d09322-5311-492a-a05d-f02eef1d9644\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:32:\"field.storage.node.field_gallery\";i:1;s:22:\"node.type.gallery_item\";i:2;s:27:\"taxonomy.vocabulary.gallery\";}}s:2:\"id\";s:31:\"node.gallery_item.field_gallery\";s:10:\"field_name\";s:13:\"field_gallery\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"gallery_item\";s:5:\"label\";s:7:\"Gallery\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:4:{s:14:\"target_bundles\";a:1:{s:7:\"gallery\";s:7:\"gallery\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.node.gallery_item.field_image','a:16:{s:4:\"uuid\";s:36:\"94057bf8-4850-43b1-a68a-e64483e0e408\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:30:\"field.storage.node.field_image\";i:1;s:22:\"node.type.gallery_item\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:2:\"id\";s:29:\"node.gallery_item.field_image\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"gallery_item\";s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:1;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),

('','field.field.node.nd_blog.body','a:16:{s:4:\"uuid\";s:36:\"ecc80d6d-f877-42ed-babb-2e75d3b74081\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:17:\"node.type.nd_blog\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:2:\"id\";s:17:\"node.nd_blog.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),

('','field.field.node.nd_blog.field_blog_category','a:16:{s:4:\"uuid\";s:36:\"ebcd6e6e-fdca-43c9-804f-641f45450f8f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:38:\"field.storage.node.field_blog_category\";i:1;s:17:\"node.type.nd_blog\";i:2;s:33:\"taxonomy.vocabulary.blog_category\";}}s:2:\"id\";s:32:\"node.nd_blog.field_blog_category\";s:10:\"field_name\";s:19:\"field_blog_category\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:5:\"label\";s:13:\"Blog Category\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:4:{s:14:\"target_bundles\";a:1:{s:13:\"blog_category\";s:13:\"blog_category\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.node.nd_blog.field_comments','a:16:{s:4:\"uuid\";s:36:\"c8588174-d951-459d-9818-64b64979d89d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:33:\"field.storage.node.field_comments\";i:1;s:17:\"node.type.nd_blog\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:2:\"id\";s:27:\"node.nd_blog.field_comments\";s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:5:\"label\";s:8:\"Comments\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:9:\"anonymous\";i:0;s:13:\"form_location\";b:1;s:7:\"preview\";i:0;}s:10:\"field_type\";s:7:\"comment\";}'),

('','field.field.node.nd_blog.field_images','a:16:{s:4:\"uuid\";s:36:\"0fad841c-bdb7-42a2-b443-79aa30f96766\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:31:\"field.storage.node.field_images\";i:1;s:17:\"node.type.nd_blog\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:2:\"id\";s:25:\"node.nd_blog.field_images\";s:10:\"field_name\";s:12:\"field_images\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:5:\"label\";s:6:\"Images\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:1;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),

('','field.field.node.nd_blog.field_lead_text','a:16:{s:4:\"uuid\";s:36:\"370d03f2-81a8-4bb7-8657-cef260417116\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:34:\"field.storage.node.field_lead_text\";i:1;s:17:\"node.type.nd_blog\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:2:\"id\";s:28:\"node.nd_blog.field_lead_text\";s:10:\"field_name\";s:15:\"field_lead_text\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:5:\"label\";s:9:\"Lead Text\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:2:{s:5:\"value\";s:39:\"<p>Something with HTML textformat</p>\r\n\";s:6:\"format\";s:9:\"full_html\";}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}'),

('','field.field.node.nd_blog.field_second_title','a:16:{s:4:\"uuid\";s:36:\"c6d823d6-7f46-47ca-b0dd-f461a86421ed\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:37:\"field.storage.node.field_second_title\";i:1;s:17:\"node.type.nd_blog\";}}s:2:\"id\";s:31:\"node.nd_blog.field_second_title\";s:10:\"field_name\";s:18:\"field_second_title\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:5:\"label\";s:12:\"Second Title\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}'),

('','field.field.node.nd_blog.field_tags','a:16:{s:4:\"uuid\";s:36:\"4bb682af-48cc-4239-ac91-f2275d6688bc\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:29:\"field.storage.node.field_tags\";i:1;s:17:\"node.type.nd_blog\";i:2;s:24:\"taxonomy.vocabulary.tags\";}}s:2:\"id\";s:23:\"node.nd_blog.field_tags\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"nd_blog\";s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:4:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.node.nd_person.body','a:16:{s:4:\"uuid\";s:36:\"2d3d34a2-8401-41e7-ae51-32b7a6d9eed8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:19:\"node.type.nd_person\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:2:\"id\";s:19:\"node.nd_person.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"nd_person\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),

('','field.field.node.nd_person.field_image','a:16:{s:4:\"uuid\";s:36:\"0cc63017-c2aa-4d3f-bc59-89389e3885c1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:30:\"field.storage.node.field_image\";i:1;s:19:\"node.type.nd_person\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:2:\"id\";s:26:\"node.nd_person.field_image\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"nd_person\";s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:1;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),

('','field.field.node.nd_person.field_position','a:16:{s:4:\"uuid\";s:36:\"2eafa3fb-b951-49a5-8c66-c83e366ad6f7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:33:\"field.storage.node.field_position\";i:1;s:19:\"node.type.nd_person\";}}s:2:\"id\";s:29:\"node.nd_person.field_position\";s:10:\"field_name\";s:14:\"field_position\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"nd_person\";s:5:\"label\";s:8:\"Position\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}'),

('','field.field.node.nd_person.field_social_links','a:16:{s:4:\"uuid\";s:36:\"23073b07-7dd4-4176-a4b1-5aeae54c632f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:37:\"field.storage.node.field_social_links\";i:1;s:19:\"node.type.nd_person\";}s:6:\"module\";a:1:{i:0;s:4:\"link\";}}s:2:\"id\";s:33:\"node.nd_person.field_social_links\";s:10:\"field_name\";s:18:\"field_social_links\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"nd_person\";s:5:\"label\";s:12:\"Social Links\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:9:\"link_type\";i:17;s:5:\"title\";i:2;}s:10:\"field_type\";s:4:\"link\";}'),

('','field.field.node.nd_portfolio.body','a:16:{s:4:\"uuid\";s:36:\"a6394352-26bf-476a-ac43-69f3c093a275\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:22:\"node.type.nd_portfolio\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:2:\"id\";s:22:\"node.nd_portfolio.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),

('','field.field.node.nd_portfolio.field_category','a:16:{s:4:\"uuid\";s:36:\"82a92b6f-bd6e-442c-8054-48f27073aca8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:33:\"field.storage.node.field_category\";i:1;s:22:\"node.type.nd_portfolio\";i:2;s:28:\"taxonomy.vocabulary.category\";}}s:2:\"id\";s:32:\"node.nd_portfolio.field_category\";s:10:\"field_name\";s:14:\"field_category\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:5:\"label\";s:8:\"Category\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:4:{s:14:\"target_bundles\";a:1:{s:8:\"category\";s:8:\"category\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.node.nd_portfolio.field_description','a:16:{s:4:\"uuid\";s:36:\"f39b4c16-844c-4e9e-a338-b52a1f0807f3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:36:\"field.storage.node.field_description\";i:1;s:22:\"node.type.nd_portfolio\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:2:\"id\";s:35:\"node.nd_portfolio.field_description\";s:10:\"field_name\";s:17:\"field_description\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}'),

('','field.field.node.nd_portfolio.field_images','a:16:{s:4:\"uuid\";s:36:\"4ddfc91e-5a59-4cb2-9d6c-c8c91c3d4823\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:31:\"field.storage.node.field_images\";i:1;s:22:\"node.type.nd_portfolio\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:2:\"id\";s:30:\"node.nd_portfolio.field_images\";s:10:\"field_name\";s:12:\"field_images\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:5:\"label\";s:6:\"Images\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:1;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),

('','field.field.node.nd_portfolio.field_portfolio_category','a:16:{s:4:\"uuid\";s:36:\"0eee8724-c776-4537-85c5-4a2cc43dc5c4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:43:\"field.storage.node.field_portfolio_category\";i:1;s:22:\"node.type.nd_portfolio\";i:2;s:38:\"taxonomy.vocabulary.portfolio_category\";}}s:2:\"id\";s:42:\"node.nd_portfolio.field_portfolio_category\";s:10:\"field_name\";s:24:\"field_portfolio_category\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:5:\"label\";s:18:\"Portfolio Category\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:4:{s:14:\"target_bundles\";a:1:{s:18:\"portfolio_category\";s:18:\"portfolio_category\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.node.nd_portfolio.field_project','a:16:{s:4:\"uuid\";s:36:\"17c04dba-dfa5-4a63-8477-d4c82ac46a63\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:32:\"field.storage.node.field_project\";i:1;s:22:\"node.type.nd_portfolio\";i:2;s:27:\"taxonomy.vocabulary.project\";}}s:2:\"id\";s:31:\"node.nd_portfolio.field_project\";s:10:\"field_name\";s:13:\"field_project\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:5:\"label\";s:7:\"Project\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:4:{s:14:\"target_bundles\";a:1:{s:7:\"project\";s:7:\"project\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:8:\"category\";}}s:10:\"field_type\";s:16:\"entity_reference\";}'),

('','field.field.node.nd_portfolio.field_project_link','a:16:{s:4:\"uuid\";s:36:\"28ce384c-31d9-4614-affd-48140ad5e24b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:37:\"field.storage.node.field_project_link\";i:1;s:22:\"node.type.nd_portfolio\";}s:6:\"module\";a:1:{i:0;s:4:\"link\";}}s:2:\"id\";s:36:\"node.nd_portfolio.field_project_link\";s:10:\"field_name\";s:18:\"field_project_link\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:12:\"nd_portfolio\";s:5:\"label\";s:12:\"Project Link\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:9:\"link_type\";i:17;s:5:\"title\";i:1;}s:10:\"field_type\";s:4:\"link\";}'),

('','field.field.node.page.body','a:17:{s:4:\"uuid\";s:36:\"f0165325-0874-412b-af11-84dec3b45672\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:14:\"node.type.page\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rUop-8b6hvxxDYbv-KobTfNIBNbPY9qOPl8f6kBNSpw\";}s:2:\"id\";s:14:\"node.page.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),

('','field.field.node.webform.body','a:17:{s:4:\"uuid\";s:36:\"aecfbe9d-e984-4f7c-ae79-e49dad86bc03\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:17:\"node.type.webform\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-Qu0UyzQ0jD4TDYq8fOasS-D-vGd3gSwzi15PzRJUD4\";}s:2:\"id\";s:17:\"node.webform.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"webform\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),

('','field.field.node.webform.webform','a:17:{s:4:\"uuid\";s:36:\"14b4de37-fecf-4587-85d3-f35456e48c3f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"field.storage.node.webform\";i:1;s:17:\"node.type.webform\";}s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8lAeR9K2aPJaEzc_sjShqayrWxWOp2WCcW4xEp6_OUY\";}s:2:\"id\";s:20:\"node.webform.webform\";s:10:\"field_name\";s:7:\"webform\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"webform\";s:5:\"label\";s:4:\"Form\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:15:\"default:webform\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:7:\"webform\";}'),

('','field.field.profile.customer.address','a:17:{s:4:\"uuid\";s:36:\"a74749a5-7d23-4fa0-bef2-edeff19b3946\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:29:\"field.storage.profile.address\";i:1;s:21:\"profile.type.customer\";}s:6:\"module\";a:1:{i:0;s:7:\"address\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"0lW9atu6EsqDPufp7ZJ4IVzmKSzeZv0vhbHwZ2fIh8k\";}s:2:\"id\";s:24:\"profile.customer.address\";s:10:\"field_name\";s:7:\"address\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";s:8:\"customer\";s:5:\"label\";s:7:\"Address\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:3:{s:19:\"available_countries\";a:0:{}s:6:\"fields\";a:11:{s:18:\"administrativeArea\";s:18:\"administrativeArea\";s:8:\"locality\";s:8:\"locality\";s:17:\"dependentLocality\";s:17:\"dependentLocality\";s:10:\"postalCode\";s:10:\"postalCode\";s:11:\"sortingCode\";s:11:\"sortingCode\";s:12:\"addressLine1\";s:12:\"addressLine1\";s:12:\"addressLine2\";s:12:\"addressLine2\";s:12:\"organization\";s:12:\"organization\";s:9:\"givenName\";s:9:\"givenName\";s:14:\"additionalName\";s:14:\"additionalName\";s:10:\"familyName\";s:10:\"familyName\";}s:17:\"langcode_override\";s:0:\"\";}s:10:\"field_type\";s:7:\"address\";}'),

('','field.field.user.user.commerce_remote_id','a:17:{s:4:\"uuid\";s:36:\"bee6d101-914d-46b0-b94e-d3c189ab243a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:37:\"field.storage.user.commerce_remote_id\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_payment\";}}s:6:\"module\";a:2:{i:0;s:8:\"commerce\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Zu4REVGzMPlwpQVE7u1sM_74HqLCp0u42VNWlAwZcIw\";}s:2:\"id\";s:28:\"user.user.commerce_remote_id\";s:10:\"field_name\";s:18:\"commerce_remote_id\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:5:\"label\";s:9:\"Remote ID\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:18:\"commerce_remote_id\";}'),

('','field.field.user.user.user_picture','a:17:{s:4:\"uuid\";s:36:\"5cb0f722-a8b6-4dcd-a27f-b636615c1336\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:31:\"field.storage.user.user_picture\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"cL7i1kgJvlJa6H00f0E_fZ2KdD1ag0ASpLts0K-KNII\";}s:2:\"id\";s:22:\"user.user.user_picture\";s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:5:\"label\";s:7:\"Picture\";s:11:\"description\";s:29:\"Your virtual face or picture.\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:14:\"file_directory\";s:40:\"pictures/[date:custom:Y]-[date:custom:m]\";s:12:\"max_filesize\";s:5:\"30 KB\";s:9:\"alt_field\";b:0;s:11:\"title_field\";b:0;s:14:\"max_resolution\";s:5:\"85x85\";s:14:\"min_resolution\";s:0:\"\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:18:\"alt_field_required\";b:0;s:20:\"title_field_required\";b:0;s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),

('','field.settings','a:2:{s:16:\"purge_batch_size\";i:50;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nJk0TAQBzlNo52ehiHI7bIEPLGi0BYqZvPdEn7Chfu0\";}}'),

('','field.storage.block_content.body','a:17:{s:4:\"uuid\";s:36:\"6aeb1549-be68-4923-a9ab-5328825769d6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eS0snV_L3dx9shtWRTzm5eblwOJ7qKWC9IE-4GMTDFc\";}s:2:\"id\";s:18:\"block_content.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:4:\"type\";s:17:\"text_with_summary\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;}'),

('','field.storage.comment.comment_body','a:17:{s:4:\"uuid\";s:36:\"cd2079a4-0599-44e2-9aa7-9b5c7d15991f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"swYoCch_hY8QO5uwr4FURplfnUCUlpPB4idF8WGVCpw\";}s:2:\"id\";s:20:\"comment.comment_body\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:4:\"type\";s:9:\"text_long\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;}'),

('','field.storage.comment.field_comment','a:16:{s:4:\"uuid\";s:36:\"05031807-3ec1-45f3-988c-bf04457938db\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:2:\"id\";s:21:\"comment.field_comment\";s:10:\"field_name\";s:13:\"field_comment\";s:11:\"entity_type\";s:7:\"comment\";s:4:\"type\";s:11:\"string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.comment.field_email','a:16:{s:4:\"uuid\";s:36:\"600ac5dc-843c-41f8-ad7f-ecbdb5c97962\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:2:\"id\";s:19:\"comment.field_email\";s:10:\"field_name\";s:11:\"field_email\";s:11:\"entity_type\";s:7:\"comment\";s:4:\"type\";s:5:\"email\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.comment.field_rating','a:16:{s:4:\"uuid\";s:36:\"7d2356fb-e305-4c01-9235-b0a94458a78f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:8:\"fivestar\";}}s:2:\"id\";s:20:\"comment.field_rating\";s:10:\"field_name\";s:12:\"field_rating\";s:11:\"entity_type\";s:7:\"comment\";s:4:\"type\";s:8:\"fivestar\";s:8:\"settings\";a:1:{s:10:\"voting_tag\";s:4:\"vote\";}s:6:\"module\";s:8:\"fivestar\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_order.order_items','a:17:{s:4:\"uuid\";s:36:\"9b482903-ea77-4dd3-a43a-79539bb89fce\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"XXkG3364KELPh2dm7U58qNcPNoUgrvC2zj9LTHF4V5E\";}s:2:\"id\";s:26:\"commerce_order.order_items\";s:10:\"field_name\";s:11:\"order_items\";s:11:\"entity_type\";s:14:\"commerce_order\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:19:\"commerce_order_item\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:1;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:0;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product.body','a:17:{s:4:\"uuid\";s:36:\"d60ff54d-c125-496a-ac21-bc345fe74e9c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nhYtx4dRhENXHM78QmiysOM5d1H8OLi_837Ukf5Mpb8\";}s:2:\"id\";s:21:\"commerce_product.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:16:\"commerce_product\";s:4:\"type\";s:17:\"text_with_summary\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product.field_category','a:16:{s:4:\"uuid\";s:36:\"e47b0e0d-0b8f-42bc-9e7e-dffa4ef07177\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:8:\"taxonomy\";}}s:2:\"id\";s:31:\"commerce_product.field_category\";s:10:\"field_name\";s:14:\"field_category\";s:11:\"entity_type\";s:16:\"commerce_product\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product.field_rating','a:16:{s:4:\"uuid\";s:36:\"0cb161c6-01a2-422d-8fe7-2752d28e35c1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:8:\"fivestar\";}}s:2:\"id\";s:29:\"commerce_product.field_rating\";s:10:\"field_name\";s:12:\"field_rating\";s:11:\"entity_type\";s:16:\"commerce_product\";s:4:\"type\";s:8:\"fivestar\";s:8:\"settings\";a:1:{s:10:\"voting_tag\";s:4:\"vote\";}s:6:\"module\";s:8:\"fivestar\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product.field_reviews','a:16:{s:4:\"uuid\";s:36:\"68d6363e-0bd7-4582-8149-04aabde5cd2e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:16:\"commerce_product\";}}s:2:\"id\";s:30:\"commerce_product.field_reviews\";s:10:\"field_name\";s:13:\"field_reviews\";s:11:\"entity_type\";s:16:\"commerce_product\";s:4:\"type\";s:7:\"comment\";s:8:\"settings\";a:1:{s:12:\"comment_type\";s:15:\"default_reviews\";}s:6:\"module\";s:7:\"comment\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product.field_tags','a:16:{s:4:\"uuid\";s:36:\"1bd59879-f65b-48f4-87e1-98a80db1f8ed\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:8:\"taxonomy\";}}s:2:\"id\";s:27:\"commerce_product.field_tags\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:16:\"commerce_product\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product.stores','a:17:{s:4:\"uuid\";s:36:\"2517331e-c92f-41f4-8e9a-ea3b113dacb0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:14:\"commerce_store\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"qzJaXjkjRd_-1CF6EnCb5fpCcA6mnBB34P4qOOQ6n9g\";}s:2:\"id\";s:23:\"commerce_product.stores\";s:10:\"field_name\";s:6:\"stores\";s:11:\"entity_type\";s:16:\"commerce_product\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:14:\"commerce_store\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:1;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:0;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product.variations','a:17:{s:4:\"uuid\";s:36:\"a1d7db47-ab38-457a-94ed-f5f7b74052a7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-sSnK9eimilO8WwVtSpdX2rg9gGrtSKccb6s59G_kBM\";}s:2:\"id\";s:27:\"commerce_product.variations\";s:10:\"field_name\";s:10:\"variations\";s:11:\"entity_type\";s:16:\"commerce_product\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:26:\"commerce_product_variation\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:1;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:0;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.attribute_color','a:16:{s:4:\"uuid\";s:36:\"710ac2c1-5c31-4b9a-a295-5ca95dcfcf23\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:42:\"commerce_product_variation.attribute_color\";s:10:\"field_name\";s:15:\"attribute_color\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:32:\"commerce_product_attribute_value\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:0;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.attribute_size','a:16:{s:4:\"uuid\";s:36:\"e71db06f-65dd-474a-b718-e888c96586cc\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:41:\"commerce_product_variation.attribute_size\";s:10:\"field_name\";s:14:\"attribute_size\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:32:\"commerce_product_attribute_value\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:0;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.field_description','a:16:{s:4:\"uuid\";s:36:\"1771b593-3ae9-4c1e-bcf6-1eedd3f31d41\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:4:\"text\";}}s:2:\"id\";s:44:\"commerce_product_variation.field_description\";s:10:\"field_name\";s:17:\"field_description\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:9:\"text_long\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.field_images','a:16:{s:4:\"uuid\";s:36:\"1962e2d5-67e1-43bb-bad5-bb27b2283e68\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:16:\"commerce_product\";i:1;s:4:\"file\";i:2;s:5:\"image\";}}s:2:\"id\";s:39:\"commerce_product_variation.field_images\";s:10:\"field_name\";s:12:\"field_images\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.field_length','a:16:{s:4:\"uuid\";s:36:\"fe16587c-28aa-473a-80f1-73f915f8f628\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:39:\"commerce_product_variation.field_length\";s:10:\"field_name\";s:12:\"field_length\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.field_old_price','a:16:{s:4:\"uuid\";s:36:\"e1660665-8557-4ae6-8a8f-2b8cdd8afdaf\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:14:\"commerce_price\";i:1;s:16:\"commerce_product\";}}s:2:\"id\";s:42:\"commerce_product_variation.field_old_price\";s:10:\"field_name\";s:15:\"field_old_price\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:14:\"commerce_price\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"commerce_price\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.field_right_side_description','a:16:{s:4:\"uuid\";s:36:\"24336415-3815-4b60-90ba-438f55938640\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:4:\"text\";}}s:2:\"id\";s:55:\"commerce_product_variation.field_right_side_description\";s:10:\"field_name\";s:28:\"field_right_side_description\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:9:\"text_long\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.field_sale_text','a:16:{s:4:\"uuid\";s:36:\"0eaf2b41-5e64-4325-b11e-14e6a1e6def9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:42:\"commerce_product_variation.field_sale_text\";s:10:\"field_name\";s:15:\"field_sale_text\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.field_short_description','a:16:{s:4:\"uuid\";s:36:\"339d3c2c-2268-4ee3-ba8e-4214ce301fa1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:50:\"commerce_product_variation.field_short_description\";s:10:\"field_name\";s:23:\"field_short_description\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:11:\"string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.commerce_product_variation.field_waist','a:16:{s:4:\"uuid\";s:36:\"90b1ad03-45a0-4c75-9927-a11fffa88263\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:2:\"id\";s:38:\"commerce_product_variation.field_waist\";s:10:\"field_name\";s:11:\"field_waist\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.body','a:17:{s:4:\"uuid\";s:36:\"17ff9d2a-51f7-478e-a18c-586dc327f14c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EBUo7qOWqaiZaQ_RC9sLY5IoDKphS34v77VIHSACmVY\";}s:2:\"id\";s:9:\"node.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:17:\"text_with_summary\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.comment','a:17:{s:4:\"uuid\";s:36:\"66ba7bdb-1bbc-4a11-b1e3-87e7e24f6978\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ktCna9xmWvYZIUfOCUyDQvedn5RtnS4CRmEIwNmvYjc\";}s:2:\"id\";s:12:\"node.comment\";s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"comment\";s:8:\"settings\";a:1:{s:12:\"comment_type\";s:7:\"comment\";}s:6:\"module\";s:7:\"comment\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_blog_category','a:16:{s:4:\"uuid\";s:36:\"4e2b8db9-b4b7-408c-93a7-fb453f56750b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:2:\"id\";s:24:\"node.field_blog_category\";s:10:\"field_name\";s:19:\"field_blog_category\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_category','a:16:{s:4:\"uuid\";s:36:\"c114c9ee-6504-4d73-afb1-003b600ebe78\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:2:\"id\";s:19:\"node.field_category\";s:10:\"field_name\";s:14:\"field_category\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_comments','a:16:{s:4:\"uuid\";s:36:\"db889761-dd45-468e-9e1b-6bb7c7ca6da9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:2:\"id\";s:19:\"node.field_comments\";s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"comment\";s:8:\"settings\";a:1:{s:12:\"comment_type\";s:7:\"comment\";}s:6:\"module\";s:7:\"comment\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_description','a:16:{s:4:\"uuid\";s:36:\"9d747b94-edd6-42ea-81de-fbc5e01f6fde\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}s:2:\"id\";s:22:\"node.field_description\";s:10:\"field_name\";s:17:\"field_description\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:9:\"text_long\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_gallery','a:16:{s:4:\"uuid\";s:36:\"7a4c4f30-f6ad-4785-9575-dcf0fb8b5c06\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:2:\"id\";s:18:\"node.field_gallery\";s:10:\"field_name\";s:13:\"field_gallery\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_image','a:17:{s:4:\"uuid\";s:36:\"4f7121a5-c189-4d77-8e92-7df6031e7fb5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SkXIPKZYiIMMtnBmfnxk58RYfbZ8cHSw5NZPY_JByME\";}s:2:\"id\";s:16:\"node.field_image\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_images','a:16:{s:4:\"uuid\";s:36:\"bdf0cdf5-31b9-45d6-8c39-a6ad4cbd8738\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:2:\"id\";s:17:\"node.field_images\";s:10:\"field_name\";s:12:\"field_images\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_lead_text','a:16:{s:4:\"uuid\";s:36:\"563c1246-b560-45a7-b8c4-79613c5b1d6c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}s:2:\"id\";s:20:\"node.field_lead_text\";s:10:\"field_name\";s:15:\"field_lead_text\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:9:\"text_long\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_portfolio_category','a:16:{s:4:\"uuid\";s:36:\"97224b12-1de4-4c7a-8a6b-ff7576712db6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:2:\"id\";s:29:\"node.field_portfolio_category\";s:10:\"field_name\";s:24:\"field_portfolio_category\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_position','a:16:{s:4:\"uuid\";s:36:\"6951603d-3b79-4da3-a414-d6bb1d1a0431\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:2:\"id\";s:19:\"node.field_position\";s:10:\"field_name\";s:14:\"field_position\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_project','a:16:{s:4:\"uuid\";s:36:\"a68a7ada-26ea-4cc6-b4f8-8db5efe80994\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:2:\"id\";s:18:\"node.field_project\";s:10:\"field_name\";s:13:\"field_project\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_project_link','a:16:{s:4:\"uuid\";s:36:\"665271a2-3053-498b-9480-a75c293fa985\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"link\";i:1;s:4:\"node\";}}s:2:\"id\";s:23:\"node.field_project_link\";s:10:\"field_name\";s:18:\"field_project_link\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:4:\"link\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_second_title','a:16:{s:4:\"uuid\";s:36:\"c8ac51e0-50db-4e83-842e-db0356890fe0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:2:\"id\";s:23:\"node.field_second_title\";s:10:\"field_name\";s:18:\"field_second_title\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_social_links','a:16:{s:4:\"uuid\";s:36:\"b1311ac1-e885-4933-a31a-9db515095639\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"link\";i:1;s:4:\"node\";}}s:2:\"id\";s:23:\"node.field_social_links\";s:10:\"field_name\";s:18:\"field_social_links\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:4:\"link\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.field_tags','a:17:{s:4:\"uuid\";s:36:\"92f7e7e0-5ca9-4e8d-b819-cd04c43e2276\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WpOE_bs8Bs_HY2ns7n2r__de-xno0-Bxkqep5-MsHAs\";}s:2:\"id\";s:15:\"node.field_tags\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.node.webform','a:17:{s:4:\"uuid\";s:36:\"d18cd2a1-355c-4d4a-94a7-76d7fb01b31a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:7:\"webform\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8IMrzn49aZMWfnGDoHdXqYfSi8NLmLq9gdblAAL1EZc\";}s:2:\"id\";s:12:\"node.webform\";s:10:\"field_name\";s:7:\"webform\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"webform\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:7:\"webform\";}s:6:\"module\";s:7:\"webform\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.profile.address','a:17:{s:4:\"uuid\";s:36:\"b1f7f989-c657-4f31-aa01-4d37f63135e3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:6:\"module\";a:2:{i:0;s:7:\"address\";i:1;s:7:\"profile\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Epax3eTdFPMQ3dTymm1zHnwqZ9DmyyHA0F18AMuUKtE\";}s:2:\"id\";s:15:\"profile.address\";s:10:\"field_name\";s:7:\"address\";s:11:\"entity_type\";s:7:\"profile\";s:4:\"type\";s:7:\"address\";s:8:\"settings\";a:0:{}s:6:\"module\";s:7:\"address\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.user.commerce_remote_id','a:17:{s:4:\"uuid\";s:36:\"20881c09-17f4-4742-9a44-96c3ac912b23\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_payment\";}}s:6:\"module\";a:2:{i:0;s:8:\"commerce\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"YLh2hnX0ZtVtJpFWUkcjkpbgJAP85JuAamng9bLk8M8\";}s:2:\"id\";s:23:\"user.commerce_remote_id\";s:10:\"field_name\";s:18:\"commerce_remote_id\";s:11:\"entity_type\";s:4:\"user\";s:4:\"type\";s:18:\"commerce_remote_id\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"commerce\";s:6:\"locked\";b:1;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:0;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field.storage.user.user_picture','a:17:{s:4:\"uuid\";s:36:\"7774566e-2d83-440e-a02b-6df978eba52e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6k-VBFilDLuzgSOT-77CFgHFlcd5D-kqRixtH89EShU\";}s:2:\"id\";s:17:\"user.user_picture\";s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),

('','field_ui.settings','a:2:{s:12:\"field_prefix\";s:6:\"field_\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Q1nMi90W6YQxKzZAgJQw7Ag9U4JrsEUwkomF0lhvbIM\";}}'),

('','file.settings','a:4:{s:11:\"description\";a:2:{s:4:\"type\";s:9:\"textfield\";s:6:\"length\";i:128;}s:4:\"icon\";a:1:{s:9:\"directory\";s:23:\"core/modules/file/icons\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8LI-1XgwLt9hYRns_7c81S632d6JhdqXKs4vDheaG6E\";}s:35:\"make_unused_managed_files_temporary\";b:0;}'),

('','filter.format.basic_html','a:9:{s:4:\"uuid\";s:36:\"68dee1c5-3d01-4530-8952-6c270bf49a00\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:6:\"editor\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"P8ddpAIKtawJDi5SzOwCzVnnNYqONewSTJ6Xn0dW_aQ\";}s:4:\"name\";s:10:\"Basic HTML\";s:6:\"format\";s:10:\"basic_html\";s:6:\"weight\";i:-8;s:7:\"filters\";a:5:{s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:250:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <p> <br> <span> <img src alt height width data-entity-type data-entity-uuid data-align data-caption>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:12:\"filter_align\";a:5:{s:2:\"id\";s:12:\"filter_align\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:7;s:8:\"settings\";a:0:{}}s:14:\"filter_caption\";a:5:{s:2:\"id\";s:14:\"filter_caption\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:8;s:8:\"settings\";a:0:{}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:11;s:8:\"settings\";a:0:{}}}}'),

('','filter.format.ckeditor','a:8:{s:4:\"uuid\";s:36:\"24aa033e-b666-403d-bb7c-d4bb14e01318\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:6:\"editor\";i:1;s:12:\"entity_embed\";i:2;s:9:\"shortcode\";}}s:4:\"name\";s:8:\"CKeditor\";s:6:\"format\";s:8:\"ckeditor\";s:6:\"weight\";i:-9;s:7:\"filters\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}}'),

('','filter.format.dynamic_shortcodes','a:8:{s:4:\"uuid\";s:36:\"5aab2017-b642-436b-8c56-9026ed9fb2b4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:19:\"nd_visualshortcodes\";i:1;s:9:\"shortcode\";}}s:4:\"name\";s:18:\"Dynamic Shortcodes\";s:6:\"format\";s:18:\"dynamic_shortcodes\";s:6:\"weight\";i:0;s:7:\"filters\";a:2:{s:17:\"dynamicshortcodes\";a:5:{s:2:\"id\";s:17:\"dynamicshortcodes\";s:8:\"provider\";s:19:\"nd_visualshortcodes\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:45:{s:12:\"nd_accordion\";s:1:\"1\";s:9:\"nd_slider\";s:1:\"1\";s:15:\"nd_pricing_item\";s:1:\"1\";s:16:\"nd_pricing_table\";s:1:\"1\";s:11:\"nd_progress\";s:1:\"1\";s:8:\"nd_quote\";s:1:\"1\";s:3:\"row\";s:1:\"1\";s:7:\"nd_save\";s:1:\"1\";s:14:\"nd_slider_item\";s:1:\"1\";s:10:\"nd_message\";s:1:\"1\";s:7:\"nd_tabs\";s:1:\"1\";s:6:\"nd_tab\";s:1:\"1\";s:15:\"nd_text_rotator\";s:1:\"1\";s:17:\"nd_text_n_tooltip\";s:1:\"1\";s:8:\"nd_title\";s:1:\"1\";s:8:\"nd_video\";s:1:\"1\";s:7:\"nd_node\";s:1:\"1\";s:7:\"nd_menu\";s:1:\"1\";s:13:\"nd_accordions\";s:1:\"1\";s:12:\"nd_container\";s:1:\"1\";s:5:\"nd_bg\";s:1:\"1\";s:8:\"nd_block\";s:1:\"1\";s:9:\"nd_button\";s:1:\"1\";s:15:\"nd_chartpieitem\";s:1:\"1\";s:11:\"nd_chartpie\";s:1:\"1\";s:3:\"col\";s:1:\"1\";s:10:\"nd_counter\";s:1:\"1\";s:8:\"nd_image\";s:1:\"1\";s:6:\"nd_div\";s:1:\"1\";s:10:\"nd_feature\";s:1:\"1\";s:7:\"nd_gmap\";s:1:\"1\";s:9:\"nd_header\";s:1:\"1\";s:5:\"nd_hr\";s:1:\"1\";s:4:\"html\";s:1:\"1\";s:7:\"nd_icon\";s:1:\"1\";s:7:\"nd_view\";s:1:\"1\";s:6:\"button\";s:1:\"0\";s:5:\"clear\";s:1:\"0\";s:7:\"dropcap\";s:1:\"0\";s:9:\"highlight\";s:1:\"0\";s:3:\"img\";s:1:\"0\";s:4:\"item\";s:1:\"0\";s:4:\"link\";s:1:\"0\";s:5:\"quote\";s:1:\"0\";s:6:\"random\";s:1:\"0\";}}}}'),

('','filter.format.full_html','a:9:{s:4:\"uuid\";s:36:\"133f61bc-d908-42fa-b8a7-d0110fc3eb0e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:6:\"editor\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"hewPmBgni9jlDK_IjLxUx1HsTbinK-hdl0lOwjbteIY\";}s:4:\"name\";s:9:\"Full HTML\";s:6:\"format\";s:9:\"full_html\";s:6:\"weight\";i:-6;s:7:\"filters\";a:4:{s:12:\"filter_align\";a:5:{s:2:\"id\";s:12:\"filter_align\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:8;s:8:\"settings\";a:0:{}}s:14:\"filter_caption\";a:5:{s:2:\"id\";s:14:\"filter_caption\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}s:20:\"filter_htmlcorrector\";a:5:{s:2:\"id\";s:20:\"filter_htmlcorrector\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}}s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:11;s:8:\"settings\";a:0:{}}}}'),

('','filter.format.plain_text','a:9:{s:4:\"uuid\";s:36:\"4fbcfda4-b62a-42e6-b141-a50bbb27cea1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NIKBt6kw_uPhNI0qtR2DnRf7mSOgAQdx7Q94SKMjXbQ\";}s:4:\"name\";s:10:\"Plain text\";s:6:\"format\";s:10:\"plain_text\";s:6:\"weight\";i:-5;s:7:\"filters\";a:3:{s:18:\"filter_html_escape\";a:5:{s:2:\"id\";s:18:\"filter_html_escape\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:-10;s:8:\"settings\";a:0:{}}s:10:\"filter_url\";a:5:{s:2:\"id\";s:10:\"filter_url\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}}s:12:\"filter_autop\";a:5:{s:2:\"id\";s:12:\"filter_autop\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}}}'),

('','filter.format.restricted_html','a:9:{s:4:\"uuid\";s:36:\"8f254822-8787-4126-8675-b899b8cdb05f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KUjJ8Ti_ZJSlhGM88E_mhJP-8mmQRNUB6RFof615Kt0\";}s:4:\"name\";s:15:\"Restricted HTML\";s:6:\"format\";s:15:\"restricted_html\";s:6:\"weight\";i:-7;s:7:\"filters\";a:3:{s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:149:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}}s:12:\"filter_autop\";a:5:{s:2:\"id\";s:12:\"filter_autop\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:10:\"filter_url\";a:5:{s:2:\"id\";s:10:\"filter_url\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}}}}'),

('','filter.format.shortcodes','a:8:{s:4:\"uuid\";s:36:\"d1c8544a-22ce-4498-a2c9-122424902d02\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:9:\"shortcode\";}}s:4:\"name\";s:10:\"Shortcodes\";s:6:\"format\";s:10:\"shortcodes\";s:6:\"weight\";i:-10;s:7:\"filters\";a:1:{s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:45:{s:12:\"nd_accordion\";s:1:\"1\";s:9:\"nd_slider\";s:1:\"1\";s:15:\"nd_pricing_item\";s:1:\"1\";s:16:\"nd_pricing_table\";s:1:\"1\";s:11:\"nd_progress\";s:1:\"1\";s:8:\"nd_quote\";s:1:\"1\";s:3:\"row\";s:1:\"1\";s:7:\"nd_save\";s:1:\"1\";s:14:\"nd_slider_item\";s:1:\"1\";s:10:\"nd_message\";s:1:\"1\";s:7:\"nd_tabs\";s:1:\"1\";s:6:\"nd_tab\";s:1:\"1\";s:15:\"nd_text_rotator\";s:1:\"1\";s:17:\"nd_text_n_tooltip\";s:1:\"1\";s:8:\"nd_title\";s:1:\"1\";s:8:\"nd_video\";s:1:\"1\";s:7:\"nd_node\";s:1:\"1\";s:7:\"nd_menu\";s:1:\"1\";s:13:\"nd_accordions\";s:1:\"1\";s:12:\"nd_container\";s:1:\"1\";s:5:\"nd_bg\";s:1:\"1\";s:8:\"nd_block\";s:1:\"1\";s:9:\"nd_button\";s:1:\"1\";s:15:\"nd_chartpieitem\";s:1:\"1\";s:11:\"nd_chartpie\";s:1:\"1\";s:3:\"col\";s:1:\"1\";s:10:\"nd_counter\";s:1:\"1\";s:8:\"nd_image\";s:1:\"1\";s:6:\"nd_div\";s:1:\"1\";s:10:\"nd_feature\";s:1:\"1\";s:7:\"nd_gmap\";s:1:\"1\";s:9:\"nd_header\";s:1:\"1\";s:5:\"nd_hr\";s:1:\"1\";s:4:\"html\";s:1:\"1\";s:7:\"nd_icon\";s:1:\"1\";s:7:\"nd_view\";s:1:\"1\";s:6:\"button\";s:1:\"0\";s:5:\"clear\";s:1:\"0\";s:7:\"dropcap\";s:1:\"0\";s:9:\"highlight\";s:1:\"0\";s:3:\"img\";s:1:\"0\";s:4:\"item\";s:1:\"0\";s:4:\"link\";s:1:\"0\";s:5:\"quote\";s:1:\"0\";s:6:\"random\";s:1:\"0\";}}}}'),

('','filter.format.visual_shortcodes','a:8:{s:4:\"uuid\";s:36:\"98828904-4285-403a-ba22-db073f53cffe\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:9:\"shortcode\";}}s:4:\"name\";s:17:\"Visual Shortcodes\";s:6:\"format\";s:17:\"visual_shortcodes\";s:6:\"weight\";i:-10;s:7:\"filters\";a:1:{s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}}}'),

('','filter.settings','a:3:{s:15:\"fallback_format\";s:10:\"plain_text\";s:27:\"always_show_fallback_choice\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"FiPjM3WdB__ruFA7B6TLwni_UcZbmek5G4b2dxQItxA\";}}'),

('','hal.settings','a:2:{s:11:\"link_domain\";N;s:29:\"bc_file_uri_as_url_normalizer\";b:1;}'),

('','image.settings','a:4:{s:13:\"preview_image\";s:29:\"core/modules/image/sample.png\";s:26:\"allow_insecure_derivatives\";b:0;s:20:\"suppress_itok_output\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"k-yDFHbqNfpe-Srg4sdCSqaosCl2D8uwyEY5esF8gEw\";}}'),

('','image.style.blog_1140x642_','a:7:{s:4:\"uuid\";s:36:\"76122db4-9d76-49b5-91e4-c54e170cea51\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:14:\"blog_1140x642_\";s:5:\"label\";s:15:\"Blog (1140x642)\";s:7:\"effects\";a:1:{s:36:\"7c8f6a58-1abb-435e-87fa-19fae37bcfeb\";a:4:{s:4:\"uuid\";s:36:\"7c8f6a58-1abb-435e-87fa-19fae37bcfeb\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:1140;s:6:\"height\";i:642;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.blog_360x195_','a:7:{s:4:\"uuid\";s:36:\"4fb6b1e0-a0c1-49e9-8392-b1b8f512c1ee\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:13:\"blog_360x195_\";s:5:\"label\";s:14:\"Blog (360x195)\";s:7:\"effects\";a:1:{s:36:\"0425f547-327a-4282-84c7-1f00b97f4267\";a:4:{s:4:\"uuid\";s:36:\"0425f547-327a-4282-84c7-1f00b97f4267\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:360;s:6:\"height\";i:195;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.file_entity_browser_small','a:8:{s:4:\"uuid\";s:36:\"979697ec-f1f0-4a1b-8dd4-11d8c5e1c89f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"suNOm3Y-bkskF2wk8W3vd_uEIkXy-yxrc60JcUAKdcs\";}s:4:\"name\";s:25:\"file_entity_browser_small\";s:5:\"label\";s:35:\"File Entity Browser small thumbnail\";s:7:\"effects\";a:1:{s:36:\"374fe20a-a27c-45f5-b76d-d851cabcf7b0\";a:4:{s:4:\"uuid\";s:36:\"374fe20a-a27c-45f5-b76d-d851cabcf7b0\";s:2:\"id\";s:11:\"image_scale\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:100;s:6:\"height\";i:100;s:7:\"upscale\";b:0;}}}}'),

('','image.style.file_entity_browser_thumbnail','a:8:{s:4:\"uuid\";s:36:\"7a445b30-a896-407c-a792-fcd8e5458a27\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dD2oNaTNxmbg6nLu4Rm49vJR3eZqunZibfSDOHDlDMU\";}s:4:\"name\";s:29:\"file_entity_browser_thumbnail\";s:5:\"label\";s:29:\"File Entity Browser thumbnail\";s:7:\"effects\";a:1:{s:36:\"2002cfd3-6b51-4668-b204-4b33425cf3f7\";a:4:{s:4:\"uuid\";s:36:\"2002cfd3-6b51-4668-b204-4b33425cf3f7\";s:2:\"id\";s:11:\"image_scale\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:350;s:6:\"height\";N;s:7:\"upscale\";b:0;}}}}'),

('','image.style.gallery_165x106','a:7:{s:4:\"uuid\";s:36:\"7256c597-beac-4bbc-bdff-71d02b508b5a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:15:\"gallery_165x106\";s:5:\"label\";s:17:\"Gallery (165x106)\";s:7:\"effects\";a:1:{s:36:\"967cfa4a-fbee-4f6e-9332-1a173cdb81ed\";a:4:{s:4:\"uuid\";s:36:\"967cfa4a-fbee-4f6e-9332-1a173cdb81ed\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:165;s:6:\"height\";i:106;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.gallery_263x169_','a:7:{s:4:\"uuid\";s:36:\"88e66d54-f4da-45f1-881f-c2d7720cf59a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:16:\"gallery_263x169_\";s:5:\"label\";s:17:\"Gallery (263x169)\";s:7:\"effects\";a:1:{s:36:\"8af97f08-0766-496f-8932-bcf9873f96e8\";a:4:{s:4:\"uuid\";s:36:\"8af97f08-0766-496f-8932-bcf9873f96e8\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:263;s:6:\"height\";i:169;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.gallery_360x232_','a:7:{s:4:\"uuid\";s:36:\"14502b96-b651-4374-a807-37920dcd4227\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:16:\"gallery_360x232_\";s:5:\"label\";s:17:\"Gallery (360x232)\";s:7:\"effects\";a:1:{s:36:\"1e24023b-d046-4e76-b038-730687af4194\";a:4:{s:4:\"uuid\";s:36:\"1e24023b-d046-4e76-b038-730687af4194\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:360;s:6:\"height\";i:232;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.gallery_555x357','a:7:{s:4:\"uuid\";s:36:\"5f922053-02e5-4fce-8368-b542aa95167a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:15:\"gallery_555x357\";s:5:\"label\";s:17:\"Gallery (555x357)\";s:7:\"effects\";a:1:{s:36:\"173db059-ca6a-46d7-84fc-3e15ad7f6e2b\";a:4:{s:4:\"uuid\";s:36:\"173db059-ca6a-46d7-84fc-3e15ad7f6e2b\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:555;s:6:\"height\";i:357;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.gallery_800x533_','a:7:{s:4:\"uuid\";s:36:\"962ead23-383d-43f3-9285-17725116373d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:16:\"gallery_800x533_\";s:5:\"label\";s:17:\"Gallery (800x533)\";s:7:\"effects\";a:1:{s:36:\"d07b964b-f2cc-4439-b3f7-85d7f3a9cf30\";a:4:{s:4:\"uuid\";s:36:\"d07b964b-f2cc-4439-b3f7-85d7f3a9cf30\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:800;s:6:\"height\";i:533;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.large','a:8:{s:4:\"uuid\";s:36:\"7b3cbd70-be4c-4ee7-92e5-70df8369893a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"J2n0RpFzS0-bgSyxjs6rSdgxB1rb-bTAgqywNx_964M\";}s:4:\"name\";s:5:\"large\";s:5:\"label\";s:16:\"Large (480×480)\";s:7:\"effects\";a:1:{s:36:\"ddd73aa7-4bd6-4c85-b600-bdf2b1628d1d\";a:4:{s:4:\"uuid\";s:36:\"ddd73aa7-4bd6-4c85-b600-bdf2b1628d1d\";s:2:\"id\";s:11:\"image_scale\";s:6:\"weight\";i:0;s:4:\"data\";a:3:{s:5:\"width\";i:480;s:6:\"height\";i:480;s:7:\"upscale\";b:0;}}}}'),

('','image.style.md_slider_thumb','a:8:{s:4:\"uuid\";s:36:\"b0ac6465-a1d5-422f-b28e-0283b089bb7d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"v3hxgQfcZeyw_hlqavLcS7ctSOa1A9URbhdZAsrJDQc\";}s:4:\"name\";s:15:\"md_slider_thumb\";s:5:\"label\";s:15:\"MD Slider Thumb\";s:7:\"effects\";a:1:{s:36:\"dedaa26c-dba1-4bff-a409-9c36bd65a894\";a:4:{s:4:\"uuid\";s:36:\"dedaa26c-dba1-4bff-a409-9c36bd65a894\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:160;s:6:\"height\";i:160;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.medium','a:8:{s:4:\"uuid\";s:36:\"bab89f50-8e5f-42e0-995f-1e24b12763a1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Y9NmnZHQq20ASSyTNA6JnwtWrJJiSajOehGDtmUFdM0\";}s:4:\"name\";s:6:\"medium\";s:5:\"label\";s:17:\"Medium (220×220)\";s:7:\"effects\";a:1:{s:36:\"bddf0d06-42f9-4c75-a700-a33cafa25ea0\";a:4:{s:4:\"uuid\";s:36:\"bddf0d06-42f9-4c75-a700-a33cafa25ea0\";s:2:\"id\";s:11:\"image_scale\";s:6:\"weight\";i:0;s:4:\"data\";a:3:{s:5:\"width\";i:220;s:6:\"height\";i:220;s:7:\"upscale\";b:0;}}}}'),

('','image.style.person_360x438_','a:7:{s:4:\"uuid\";s:36:\"c2d4185a-49e3-4e68-9ae7-0dbe5998e0c6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:15:\"person_360x438_\";s:5:\"label\";s:16:\"Person (360x438)\";s:7:\"effects\";a:1:{s:36:\"54cadb7a-6f20-43b9-b74c-fb9b4f24409c\";a:4:{s:4:\"uuid\";s:36:\"54cadb7a-6f20-43b9-b74c-fb9b4f24409c\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:360;s:6:\"height\";i:438;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.portfolio_570x367_','a:7:{s:4:\"uuid\";s:36:\"674748c7-9c30-4c37-a500-4b6c51da1252\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:18:\"portfolio_570x367_\";s:5:\"label\";s:19:\"Portfolio (570x367)\";s:7:\"effects\";a:1:{s:36:\"48445371-2bb3-490f-bf8f-d4155f8485ff\";a:4:{s:4:\"uuid\";s:36:\"48445371-2bb3-490f-bf8f-d4155f8485ff\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:570;s:6:\"height\";i:367;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.portfolio_650xauto_','a:7:{s:4:\"uuid\";s:36:\"dda90f64-3e74-4e10-8be8-37648f3b5110\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:19:\"portfolio_650xauto_\";s:5:\"label\";s:20:\"Portfolio (650xauto)\";s:7:\"effects\";a:1:{s:36:\"8038207a-34bc-4832-bd08-33169ec2e684\";a:4:{s:4:\"uuid\";s:36:\"8038207a-34bc-4832-bd08-33169ec2e684\";s:2:\"id\";s:11:\"image_scale\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:650;s:6:\"height\";N;s:7:\"upscale\";b:0;}}}}'),

('','image.style.portfolio_653x368_','a:7:{s:4:\"uuid\";s:36:\"652df59e-d169-4dac-9244-ca4899f3226d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:18:\"portfolio_653x368_\";s:5:\"label\";s:19:\"Portfolio (653x368)\";s:7:\"effects\";a:1:{s:36:\"1931dc2c-996d-48ee-aca7-e23c46ef1dd5\";a:4:{s:4:\"uuid\";s:36:\"1931dc2c-996d-48ee-aca7-e23c46ef1dd5\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:653;s:6:\"height\";i:368;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.portfolio_952x_613','a:7:{s:4:\"uuid\";s:36:\"e7c23e4b-4590-4af6-92f0-5b4b0232152f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:18:\"portfolio_952x_613\";s:5:\"label\";s:19:\"Portfolio (952x613)\";s:7:\"effects\";a:1:{s:36:\"f7c31bb5-cd5e-4bda-827f-c93a6623ca0e\";a:4:{s:4:\"uuid\";s:36:\"f7c31bb5-cd5e-4bda-827f-c93a6623ca0e\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:953;s:6:\"height\";i:613;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.product_263x335','a:7:{s:4:\"uuid\";s:36:\"8d3e80af-961f-4062-ba99-2220b6c64ca6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:15:\"product_263x335\";s:5:\"label\";s:17:\"Product (263x335)\";s:7:\"effects\";a:1:{s:36:\"c5e985d8-26d4-403e-aa2d-928fdbf06707\";a:4:{s:4:\"uuid\";s:36:\"c5e985d8-26d4-403e-aa2d-928fdbf06707\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:263;s:6:\"height\";i:335;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.product_70x70','a:7:{s:4:\"uuid\";s:36:\"638883c8-6f6f-40bf-8ba0-03ae0dcbd49c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:13:\"product_70x70\";s:5:\"label\";s:15:\"Product (70x70)\";s:7:\"effects\";a:1:{s:36:\"93ba13e3-fd1e-4567-9be1-2d7656fea4d1\";a:4:{s:4:\"uuid\";s:36:\"93ba13e3-fd1e-4567-9be1-2d7656fea4d1\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:70;s:6:\"height\";i:70;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.product_main_360x459','a:7:{s:4:\"uuid\";s:36:\"9e859a24-4d1a-4dae-9822-a16a9663868f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:20:\"product_main_360x459\";s:5:\"label\";s:22:\"Product Main (360x459)\";s:7:\"effects\";a:1:{s:36:\"1d32c7c3-5814-4348-958c-42703571911b\";a:4:{s:4:\"uuid\";s:36:\"1d32c7c3-5814-4348-958c-42703571911b\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:360;s:6:\"height\";i:459;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.product_small_68x86','a:7:{s:4:\"uuid\";s:36:\"75b17973-07b2-4d7e-bab6-eb77b1e729ef\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:19:\"product_small_68x86\";s:5:\"label\";s:21:\"Product Small (68x86)\";s:7:\"effects\";a:1:{s:36:\"58e92461-9409-472f-b6e5-c50458e5ce1a\";a:4:{s:4:\"uuid\";s:36:\"58e92461-9409-472f-b6e5-c50458e5ce1a\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:68;s:6:\"height\";i:86;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.slider_pager','a:7:{s:4:\"uuid\";s:36:\"b4ab63bf-34cc-4e06-a581-aa4b17e0cbd1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:12:\"slider_pager\";s:5:\"label\";s:12:\"Slider Pager\";s:7:\"effects\";a:1:{s:36:\"8cfdcd73-cdee-4bb5-96f2-c0dd1ddaf0e0\";a:4:{s:4:\"uuid\";s:36:\"8cfdcd73-cdee-4bb5-96f2-c0dd1ddaf0e0\";s:2:\"id\";s:20:\"image_scale_and_crop\";s:6:\"weight\";i:1;s:4:\"data\";a:3:{s:5:\"width\";i:90;s:6:\"height\";i:60;s:6:\"anchor\";s:13:\"center-center\";}}}}'),

('','image.style.thumbnail','a:8:{s:4:\"uuid\";s:36:\"0b3fdb77-565f-4e1d-a366-3046385ffdf7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"cCiWdBHgLwj5omG35lsKc4LkW4MBdmcctkVop4ol5x0\";}s:4:\"name\";s:9:\"thumbnail\";s:5:\"label\";s:20:\"Thumbnail (100×100)\";s:7:\"effects\";a:1:{s:36:\"1cfec298-8620-4749-b100-ccb6c4500779\";a:4:{s:4:\"uuid\";s:36:\"1cfec298-8620-4749-b100-ccb6c4500779\";s:2:\"id\";s:11:\"image_scale\";s:6:\"weight\";i:0;s:4:\"data\";a:3:{s:5:\"width\";i:100;s:6:\"height\";i:100;s:7:\"upscale\";b:0;}}}}'),

('','language.content_settings.commerce_product.product_display','a:9:{s:4:\"uuid\";s:36:\"67a2960e-6ba4-4c0b-8bdd-f5c825316ad6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";}}s:2:\"id\";s:32:\"commerce_product.product_display\";s:21:\"target_entity_type_id\";s:16:\"commerce_product\";s:13:\"target_bundle\";s:15:\"product_display\";s:16:\"default_langcode\";s:12:\"site_default\";s:18:\"language_alterable\";b:1;}'),

('','language.content_settings.commerce_product_variation.product','a:9:{s:4:\"uuid\";s:36:\"8ead954e-c1a0-4f8e-b7a3-f9827ae3dfef\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";}}s:2:\"id\";s:34:\"commerce_product_variation.product\";s:21:\"target_entity_type_id\";s:26:\"commerce_product_variation\";s:13:\"target_bundle\";s:7:\"product\";s:16:\"default_langcode\";s:12:\"site_default\";s:18:\"language_alterable\";b:0;}'),

('','language.content_settings.node.gallery_item','a:9:{s:4:\"uuid\";s:36:\"b7263b20-5c53-494b-aba5-e27b0d553cbd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:22:\"node.type.gallery_item\";}}s:2:\"id\";s:17:\"node.gallery_item\";s:21:\"target_entity_type_id\";s:4:\"node\";s:13:\"target_bundle\";s:12:\"gallery_item\";s:16:\"default_langcode\";s:12:\"site_default\";s:18:\"language_alterable\";b:0;}'),

('','language.content_settings.node.nd_person','a:9:{s:4:\"uuid\";s:36:\"88089675-0687-474b-8c8f-03cf43f51d4a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:19:\"node.type.nd_person\";}}s:2:\"id\";s:14:\"node.nd_person\";s:21:\"target_entity_type_id\";s:4:\"node\";s:13:\"target_bundle\";s:9:\"nd_person\";s:16:\"default_langcode\";s:12:\"site_default\";s:18:\"language_alterable\";b:0;}'),

('','language.content_settings.node.webform','a:9:{s:4:\"uuid\";s:36:\"a6a15ddb-8243-4f41-8d69-43422931bbb3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:17:\"node.type.webform\";}}s:2:\"id\";s:12:\"node.webform\";s:21:\"target_entity_type_id\";s:4:\"node\";s:13:\"target_bundle\";s:7:\"webform\";s:16:\"default_langcode\";s:12:\"site_default\";s:18:\"language_alterable\";b:0;}'),

('','language.content_settings.taxonomy_term.gallery','a:9:{s:4:\"uuid\";s:36:\"cc541afb-12b5-4e1b-b764-bb2b9e201f06\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:27:\"taxonomy.vocabulary.gallery\";}}s:2:\"id\";s:21:\"taxonomy_term.gallery\";s:21:\"target_entity_type_id\";s:13:\"taxonomy_term\";s:13:\"target_bundle\";s:7:\"gallery\";s:16:\"default_langcode\";s:12:\"site_default\";s:18:\"language_alterable\";b:0;}'),

('','language.entity.de','a:9:{s:4:\"uuid\";s:36:\"579f46fc-7a71-45ea-8d46-73c5a43cc5f0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:2:\"id\";s:2:\"de\";s:5:\"label\";s:6:\"German\";s:9:\"direction\";s:3:\"ltr\";s:6:\"weight\";i:2;s:6:\"locked\";b:0;}'),

('','language.entity.en','a:10:{s:4:\"uuid\";s:36:\"c0d7c2b5-042a-4e89-93df-81d84f30f7da\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lBXDpdDPXQtrfTJQhr6MjRJJEEyYSoRJ0acdvHLsWeA\";}s:2:\"id\";s:2:\"en\";s:5:\"label\";s:7:\"English\";s:9:\"direction\";s:3:\"ltr\";s:6:\"weight\";i:0;s:6:\"locked\";b:0;}'),

('','language.entity.fr','a:9:{s:4:\"uuid\";s:36:\"10b36fe6-add0-450a-bcf2-a22a77a75fff\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:2:\"id\";s:2:\"fr\";s:5:\"label\";s:6:\"French\";s:9:\"direction\";s:3:\"ltr\";s:6:\"weight\";i:1;s:6:\"locked\";b:0;}'),

('','language.entity.und','a:10:{s:4:\"uuid\";s:36:\"de7bd6c5-f613-4ae5-910e-82cf8c41ab6b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eNX6lLCKDaY83nCMh20My---y03KbiFlv802DKCCpvg\";}s:2:\"id\";s:3:\"und\";s:5:\"label\";s:13:\"Not specified\";s:9:\"direction\";s:3:\"ltr\";s:6:\"weight\";i:3;s:6:\"locked\";b:1;}'),

('','language.entity.zxx','a:10:{s:4:\"uuid\";s:36:\"ff1a8750-b012-4368-81a0-142c0ddce876\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"35CefWbnzaiytcg3acexxz_GTvuwIjYd_ZTcmmR-tXA\";}s:2:\"id\";s:3:\"zxx\";s:5:\"label\";s:14:\"Not applicable\";s:9:\"direction\";s:3:\"ltr\";s:6:\"weight\";i:4;s:6:\"locked\";b:1;}'),

('','language.mappings','a:2:{s:3:\"map\";a:10:{s:2:\"no\";s:2:\"nb\";s:2:\"pt\";s:5:\"pt-pt\";s:2:\"zh\";s:7:\"zh-hans\";s:5:\"zh-tw\";s:7:\"zh-hant\";s:5:\"zh-hk\";s:7:\"zh-hant\";s:5:\"zh-mo\";s:7:\"zh-hant\";s:6:\"zh-cht\";s:7:\"zh-hant\";s:5:\"zh-cn\";s:7:\"zh-hans\";s:5:\"zh-sg\";s:7:\"zh-hans\";s:6:\"zh-chs\";s:7:\"zh-hans\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EMWe7Yu4Q5eD-NUfNuQAWGBvYUNZPIinztEtONSmsDc\";}}'),

('','language.negotiation','a:4:{s:7:\"session\";a:1:{s:9:\"parameter\";s:8:\"language\";}s:3:\"url\";a:3:{s:6:\"source\";s:11:\"path_prefix\";s:8:\"prefixes\";a:3:{s:2:\"en\";s:0:\"\";s:2:\"fr\";s:2:\"fr\";s:2:\"de\";s:2:\"de\";}s:7:\"domains\";a:3:{s:2:\"en\";s:0:\"\";s:2:\"fr\";s:0:\"\";s:2:\"de\";s:0:\"\";}}s:17:\"selected_langcode\";s:12:\"site_default\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"uEePITI9tV6WqzmsTb7MfPCi5yPWXSxAN1xeLcYFQbM\";}}'),

('','language.types','a:4:{s:3:\"all\";a:3:{i:0;s:18:\"language_interface\";i:1;s:16:\"language_content\";i:2;s:12:\"language_url\";}s:12:\"configurable\";a:1:{i:0;s:18:\"language_interface\";}s:11:\"negotiation\";a:3:{s:16:\"language_content\";a:1:{s:7:\"enabled\";a:1:{s:18:\"language-interface\";i:0;}}s:12:\"language_url\";a:1:{s:7:\"enabled\";a:2:{s:12:\"language-url\";i:0;s:21:\"language-url-fallback\";i:1;}}s:18:\"language_interface\";a:1:{s:7:\"enabled\";a:1:{s:12:\"language-url\";i:0;}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dqouFqVseNJNvEjsoYKxbinFOITuCxYhi4y2OTNQP_8\";}}'),

('','menu_ui.settings','a:2:{s:24:\"override_parent_selector\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SqMarzIjxC3F8dZo9FEOxfqDKD_sdW1tbcFTV1BA2zU\";}}'),

('','nd_visualshortcodes.settings','a:4:{s:9:\"autostart\";i:1;s:7:\"formats\";a:7:{s:10:\"shortcodes\";s:10:\"shortcodes\";s:18:\"dynamic_shortcodes\";s:18:\"dynamic_shortcodes\";s:8:\"ckeditor\";i:0;s:10:\"basic_html\";i:0;s:15:\"restricted_html\";i:0;s:9:\"full_html\";i:0;s:10:\"plain_text\";i:0;}s:14:\"confirm_delete\";i:0;s:19:\"html_default_format\";s:8:\"ckeditor\";}'),

('','node.settings','a:2:{s:15:\"use_admin_theme\";b:1;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"2OMXCScXUOLSYID9-phjO4q36nnnaMWNUlDxEqZzG1U\";}}'),

('','node.type.article','a:12:{s:4:\"uuid\";s:36:\"7ec3a74a-c075-4861-a394-5497aff0c6c1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AeW1SEDgb1OTQACAWGhzvMknMYAJlcZu0jljfeU3oso\";}s:4:\"name\";s:7:\"Article\";s:4:\"type\";s:7:\"article\";s:11:\"description\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:1;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:1;}'),

('','node.type.gallery_item','a:12:{s:4:\"uuid\";s:36:\"450601a8-cc33-47f1-ad9c-3851007b12ea\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"menu_ui\";}}s:20:\"third_party_settings\";a:1:{s:7:\"menu_ui\";a:2:{s:15:\"available_menus\";a:1:{i:0;s:4:\"main\";}s:6:\"parent\";s:5:\"main:\";}}s:4:\"name\";s:12:\"Gallery Item\";s:4:\"type\";s:12:\"gallery_item\";s:11:\"description\";s:0:\"\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:0;}'),

('','node.type.nd_blog','a:12:{s:4:\"uuid\";s:36:\"14ed6ebe-c003-4c68-870c-6eec4f495ad7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"menu_ui\";}}s:20:\"third_party_settings\";a:1:{s:7:\"menu_ui\";a:2:{s:15:\"available_menus\";a:1:{i:0;s:4:\"main\";}s:6:\"parent\";s:5:\"main:\";}}s:4:\"name\";s:4:\"Blog\";s:4:\"type\";s:7:\"nd_blog\";s:11:\"description\";s:0:\"\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:0;}'),

('','node.type.nd_person','a:12:{s:4:\"uuid\";s:36:\"fe136bf6-bb85-4dac-86d3-b34e15112456\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"menu_ui\";}}s:20:\"third_party_settings\";a:1:{s:7:\"menu_ui\";a:2:{s:15:\"available_menus\";a:1:{i:0;s:4:\"main\";}s:6:\"parent\";s:5:\"main:\";}}s:4:\"name\";s:6:\"Person\";s:4:\"type\";s:9:\"nd_person\";s:11:\"description\";s:0:\"\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:0;s:17:\"display_submitted\";b:0;}'),

('','node.type.nd_portfolio','a:12:{s:4:\"uuid\";s:36:\"417e6c4e-81b2-4b3c-9fdd-36e4cbf79817\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"menu_ui\";}}s:20:\"third_party_settings\";a:1:{s:7:\"menu_ui\";a:2:{s:15:\"available_menus\";a:1:{i:0;s:4:\"main\";}s:6:\"parent\";s:5:\"main:\";}}s:4:\"name\";s:9:\"Portfolio\";s:4:\"type\";s:12:\"nd_portfolio\";s:11:\"description\";s:0:\"\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:0;}'),

('','node.type.page','a:13:{s:4:\"uuid\";s:36:\"d980fb46-2bd4-4e1a-8cb5-7752e8ddb3d3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"menu_ui\";}}s:20:\"third_party_settings\";a:1:{s:7:\"menu_ui\";a:2:{s:15:\"available_menus\";a:1:{i:0;s:4:\"main\";}s:6:\"parent\";s:5:\"main:\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KuyA4NHPXcmKAjRtwa0vQc2ZcyrUJy6IlS2TAyMNRbc\";}s:4:\"name\";s:10:\"Basic page\";s:4:\"type\";s:4:\"page\";s:11:\"description\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:0;}'),

('','node.type.webform','a:13:{s:4:\"uuid\";s:36:\"f0247403-4df3-4593-9555-65323ca32415\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}s:6:\"module\";a:1:{i:0;s:7:\"menu_ui\";}}s:20:\"third_party_settings\";a:1:{s:7:\"menu_ui\";a:2:{s:15:\"available_menus\";a:1:{i:0;s:4:\"main\";}s:6:\"parent\";s:5:\"main:\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"e0BoXlrxD4xhZMqJm5A1gTUkmntzhvyhDNY-3Y4glyc\";}s:4:\"name\";s:7:\"Webform\";s:4:\"type\";s:7:\"webform\";s:11:\"description\";s:37:\"A basic page with a webform attached.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:0;}'),

('','pathauto.settings','a:13:{s:20:\"enabled_entity_types\";a:1:{i:0;s:4:\"user\";}s:11:\"punctuation\";a:1:{s:6:\"hyphen\";i:1;}s:7:\"verbose\";b:0;s:9:\"separator\";s:1:\"-\";s:10:\"max_length\";i:100;s:20:\"max_component_length\";i:100;s:13:\"transliterate\";b:1;s:12:\"reduce_ascii\";b:0;s:4:\"case\";b:1;s:12:\"ignore_words\";s:134:\"a, an, as, at, before, but, by, for, from, is, in, into, like, of, off, on, onto, per, since, than, the, this, that, to, up, via, with\";s:13:\"update_action\";i:2;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"GcMSgi6uAfG5R_FGEsWUVCvRPkNIzPUH2bNVcx6H0JA\";}s:11:\"safe_tokens\";a:7:{i:0;s:5:\"alias\";i:1;s:5:\"alias\";i:2;s:4:\"path\";i:3;s:9:\"join-path\";i:4;s:9:\"login-url\";i:5;s:3:\"url\";i:6;s:9:\"url-brief\";}}'),

('','profile.type.customer','a:14:{s:4:\"uuid\";s:36:\"81d683bb-e06a-49a8-bfa5-1cb7644bd83e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}}s:20:\"third_party_settings\";a:1:{s:14:\"commerce_order\";a:1:{s:21:\"customer_profile_type\";b:1;}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"PZl4AQDUouSVwavb0FNRlcbJx924n5FtCq8l73AMj5g\";}s:2:\"id\";s:8:\"customer\";s:5:\"label\";s:8:\"Customer\";s:13:\"display_label\";s:20:\"Customer information\";s:8:\"multiple\";b:1;s:12:\"registration\";b:0;s:5:\"roles\";a:0:{}s:15:\"allow_revisions\";b:0;s:12:\"new_revision\";b:0;}'),

('','rest.settings','a:2:{s:30:\"bc_entity_resource_permissions\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"bwcdqlollZ-bMAg90HtLMFFBgY7UXJohIln7BICIooE\";}}'),

('','rhythm.settings','a:9:{s:8:\"features\";a:4:{s:17:\"node_user_picture\";i:1;s:20:\"comment_user_picture\";i:1;s:25:\"comment_user_verification\";i:1;s:7:\"favicon\";i:1;}s:4:\"logo\";a:2:{s:11:\"use_default\";i:0;s:4:\"path\";s:29:\"themes/custom/rhythm/logo.png\";}s:7:\"favicon\";a:1:{s:11:\"use_default\";i:1;}s:6:\"retina\";i:0;s:12:\"loader_image\";i:1;s:5:\"phone\";s:13:\" 0307-567-890\";s:6:\"404_bg\";a:1:{i:0;s:2:\"41\";}s:14:\"maintenance_bg\";a:1:{i:0;s:2:\"42\";}s:8:\"gmap_key\";s:0:\"\";}'),

('','rhythm_sub.settings','a:10:{s:8:\"features\";a:4:{s:17:\"node_user_picture\";i:1;s:20:\"comment_user_picture\";i:1;s:25:\"comment_user_verification\";i:1;s:7:\"favicon\";i:1;}s:4:\"logo\";a:2:{s:11:\"use_default\";i:0;s:4:\"path\";s:33:\"themes/custom/rhythm_sub/logo.png\";}s:7:\"favicon\";a:1:{s:11:\"use_default\";i:1;}s:6:\"retina\";i:0;s:12:\"loader_image\";i:1;s:5:\"phone\";s:12:\"0307-567-890\";s:6:\"404_bg\";a:0:{}s:14:\"maintenance_bg\";a:0:{}s:8:\"gmap_key\";s:0:\"\";s:19:\"nikadevs_cms_layout\";a:6:{s:14:\"layout-default\";a:4:{s:4:\"name\";s:7:\"Default\";s:5:\"pages\";s:0:\"\";s:4:\"rows\";a:5:{s:4:\"id-1\";a:3:{s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-1\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:4:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";s:14:\"padding_bottom\";s:3:\"100\";}}s:4:\"id-2\";a:3:{s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-2\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:2:{s:3:\"tag\";s:3:\"div\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-3\";a:3:{s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-3\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-4\";a:3:{s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-4\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-0\";a:2:{s:4:\"name\";s:6:\"Hidden\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-0\";s:5:\"class\";a:2:{i:0;s:3:\"row\";i:1;s:15:\"sortable-parent\";}}}}s:7:\"regions\";a:5:{s:6:\"header\";a:3:{s:6:\"row_id\";s:4:\"id-1\";s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"header\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:7:\"content\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"content\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:7:\"sidebar\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Sidebar\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"sidebar\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:12:\"content_full\";a:3:{s:6:\"row_id\";s:4:\"id-3\";s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:12:\"content_full\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:6:\"footer\";a:3:{s:6:\"row_id\";s:4:\"id-4\";s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"footer\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}}}s:20:\"layout-right-sidebar\";a:4:{s:4:\"name\";s:13:\"Right Sidebar\";s:5:\"pages\";s:22:\"/shop*\n/blog-2-columns\";s:4:\"rows\";a:5:{s:4:\"id-1\";a:3:{s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-1\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:4:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";s:14:\"padding_bottom\";s:3:\"100\";}}s:4:\"id-2\";a:3:{s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-2\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:2:{s:3:\"tag\";s:3:\"div\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-3\";a:3:{s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-3\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-4\";a:3:{s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-4\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-0\";a:2:{s:4:\"name\";s:6:\"Hidden\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-0\";s:5:\"class\";a:2:{i:0;s:3:\"row\";i:1;s:15:\"sortable-parent\";}}}}s:7:\"regions\";a:7:{s:6:\"header\";a:3:{s:6:\"row_id\";s:4:\"id-1\";s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"header\";s:5:\"class\";a:1:{i:2;s:9:\"col-md-12\";}}}s:8:\"page_top\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:8:\"Page Top\";s:10:\"attributes\";a:2:{s:2:\"id\";s:8:\"page_top\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:7:\"content\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"content\";s:5:\"class\";a:1:{i:0;s:8:\"col-md-8\";}}}s:7:\"sidebar\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Sidebar\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"sidebar\";s:5:\"class\";a:2:{i:0;s:8:\"col-md-3\";i:1;s:15:\"col-md-offset-1\";}}}s:11:\"page_bottom\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:11:\"Page Bottom\";s:10:\"attributes\";a:2:{s:2:\"id\";s:11:\"page_bottom\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:12:\"content_full\";a:3:{s:6:\"row_id\";s:4:\"id-3\";s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:12:\"content_full\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:6:\"footer\";a:3:{s:6:\"row_id\";s:4:\"id-4\";s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"footer\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}}}s:30:\"layout-content-8-columns-width\";a:4:{s:4:\"name\";s:23:\"Content 8 Columns Width\";s:5:\"pages\";s:5:\"/cart\";s:4:\"rows\";a:5:{s:4:\"id-1\";a:3:{s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-1\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-2\";a:3:{s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-2\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:2:{s:3:\"tag\";s:3:\"div\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-3\";a:3:{s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-3\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-4\";a:3:{s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-4\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-0\";a:2:{s:4:\"name\";s:6:\"Hidden\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-0\";s:5:\"class\";a:2:{i:0;s:3:\"row\";i:1;s:15:\"sortable-parent\";}}}}s:7:\"regions\";a:7:{s:6:\"header\";a:4:{s:6:\"row_id\";s:4:\"id-1\";s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"header\";s:5:\"class\";a:1:{i:2;s:9:\"col-md-12\";}}s:8:\"settings\";a:1:{s:14:\"padding_bottom\";s:3:\"140\";}}s:8:\"page_top\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:8:\"Page Top\";s:10:\"attributes\";a:2:{s:2:\"id\";s:8:\"page_top\";s:5:\"class\";a:1:{i:2;s:9:\"col-md-12\";}}}s:7:\"content\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"content\";s:5:\"class\";a:2:{i:0;s:8:\"col-md-8\";i:1;s:15:\"col-md-offset-2\";}}}s:7:\"sidebar\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Sidebar\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"sidebar\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:11:\"page_bottom\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:11:\"Page Bottom\";s:10:\"attributes\";a:2:{s:2:\"id\";s:11:\"page_bottom\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:12:\"content_full\";a:3:{s:6:\"row_id\";s:4:\"id-3\";s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:12:\"content_full\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:6:\"footer\";a:4:{s:6:\"row_id\";s:4:\"id-4\";s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"footer\";s:5:\"class\";a:1:{i:2;s:9:\"col-md-12\";}}s:8:\"settings\";a:1:{s:11:\"padding_top\";s:3:\"140\";}}}}s:31:\"layout-content-10-columns-width\";a:4:{s:4:\"name\";s:24:\"Content 10 Columns Width\";s:5:\"pages\";s:14:\"blog-fullwidth\";s:4:\"rows\";a:5:{s:4:\"id-1\";a:3:{s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-1\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-2\";a:3:{s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-2\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:2:{s:3:\"tag\";s:3:\"div\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-3\";a:3:{s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-3\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-4\";a:3:{s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-4\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-0\";a:2:{s:4:\"name\";s:6:\"Hidden\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-0\";s:5:\"class\";a:2:{i:0;s:3:\"row\";i:1;s:15:\"sortable-parent\";}}}}s:7:\"regions\";a:7:{s:6:\"header\";a:3:{s:6:\"row_id\";s:4:\"id-1\";s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"header\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:8:\"page_top\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:8:\"Page Top\";s:10:\"attributes\";a:2:{s:2:\"id\";s:8:\"page_top\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:7:\"content\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"content\";s:5:\"class\";a:2:{i:2;s:9:\"col-md-10\";i:3;s:15:\"col-md-offset-1\";}}}s:7:\"sidebar\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Sidebar\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"sidebar\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:11:\"page_bottom\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:11:\"Page Bottom\";s:10:\"attributes\";a:2:{s:2:\"id\";s:11:\"page_bottom\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:12:\"content_full\";a:3:{s:6:\"row_id\";s:4:\"id-3\";s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:12:\"content_full\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:6:\"footer\";a:3:{s:6:\"row_id\";s:4:\"id-4\";s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"footer\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}}}s:17:\"layout-full-width\";a:4:{s:4:\"name\";s:10:\"Full Width\";s:5:\"pages\";s:86:\"portfolio-promo\nportfolio-parallax\n*wide\n<front>\n/node/102\n/onepage/*\n/home/*\n/node/66\";s:4:\"rows\";a:5:{s:4:\"id-1\";a:3:{s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-1\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:4:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";s:14:\"padding_bottom\";s:2:\"20\";}}s:4:\"id-2\";a:3:{s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-2\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:13:\"bg_image_type\";s:1:\"0\";s:10:\"full_width\";s:1:\"1\";}}s:4:\"id-3\";a:3:{s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-3\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-4\";a:3:{s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-4\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-0\";a:2:{s:4:\"name\";s:6:\"Hidden\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-0\";s:5:\"class\";a:2:{i:0;s:3:\"row\";i:1;s:15:\"sortable-parent\";}}}}s:7:\"regions\";a:7:{s:6:\"header\";a:3:{s:6:\"row_id\";s:4:\"id-1\";s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"header\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:8:\"page_top\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:8:\"Page Top\";s:10:\"attributes\";a:2:{s:2:\"id\";s:8:\"page_top\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:7:\"content\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"content\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:7:\"sidebar\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Sidebar\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"sidebar\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:11:\"page_bottom\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:11:\"Page Bottom\";s:10:\"attributes\";a:2:{s:2:\"id\";s:11:\"page_bottom\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:12:\"content_full\";a:3:{s:6:\"row_id\";s:4:\"id-3\";s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:12:\"content_full\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:6:\"footer\";a:3:{s:6:\"row_id\";s:4:\"id-4\";s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"footer\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}}}s:29:\"layout-full-width-paddingtop0\";a:4:{s:4:\"name\";s:24:\"Full Width Padding-Top-0\";s:5:\"pages\";s:16:\"gallery-images/*\";s:4:\"rows\";a:5:{s:4:\"id-1\";a:3:{s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-1\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-2\";a:3:{s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-2\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:13:\"bg_image_type\";s:1:\"0\";s:10:\"full_width\";s:1:\"1\";}}s:4:\"id-3\";a:3:{s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-3\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-4\";a:3:{s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-4\";s:5:\"class\";a:1:{i:0;s:3:\"row\";}}s:8:\"settings\";a:3:{s:3:\"tag\";s:3:\"div\";s:10:\"full_width\";s:1:\"1\";s:13:\"bg_image_type\";s:1:\"0\";}}s:4:\"id-0\";a:2:{s:4:\"name\";s:6:\"Hidden\";s:10:\"attributes\";a:2:{s:2:\"id\";s:4:\"id-0\";s:5:\"class\";a:2:{i:0;s:3:\"row\";i:1;s:15:\"sortable-parent\";}}}}s:7:\"regions\";a:7:{s:6:\"header\";a:3:{s:6:\"row_id\";s:4:\"id-1\";s:4:\"name\";s:6:\"Header\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"header\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:8:\"page_top\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:8:\"Page Top\";s:10:\"attributes\";a:2:{s:2:\"id\";s:8:\"page_top\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:7:\"content\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Content\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"content\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:7:\"sidebar\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:7:\"Sidebar\";s:10:\"attributes\";a:2:{s:2:\"id\";s:7:\"sidebar\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:11:\"page_bottom\";a:3:{s:6:\"row_id\";s:4:\"id-2\";s:4:\"name\";s:11:\"Page Bottom\";s:10:\"attributes\";a:2:{s:2:\"id\";s:11:\"page_bottom\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:12:\"content_full\";a:3:{s:6:\"row_id\";s:4:\"id-3\";s:4:\"name\";s:18:\"Content Full Width\";s:10:\"attributes\";a:2:{s:2:\"id\";s:12:\"content_full\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}s:6:\"footer\";a:3:{s:6:\"row_id\";s:4:\"id-4\";s:4:\"name\";s:6:\"Footer\";s:10:\"attributes\";a:2:{s:2:\"id\";s:6:\"footer\";s:5:\"class\";a:1:{i:0;s:9:\"col-md-12\";}}}}}}}'),

('','search.page.node_search','a:11:{s:4:\"uuid\";s:36:\"4df754c5-99d9-44e0-be3b-b173007a12eb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"97tvtzGOa8_flb22CzSjgtm_YkiGMHvEBO-6q2K9V_U\";}s:2:\"id\";s:11:\"node_search\";s:5:\"label\";s:7:\"Content\";s:4:\"path\";s:4:\"node\";s:6:\"weight\";i:-10;s:6:\"plugin\";s:11:\"node_search\";s:13:\"configuration\";a:1:{s:8:\"rankings\";a:0:{}}}'),

('','search.page.user_search','a:11:{s:4:\"uuid\";s:36:\"b7ab86c4-37f2-4c24-842f-0f404ba6796a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"k3aUaZXGDuhkek2TZIee0PApOPTvYZLadziekdyHA5A\";}s:2:\"id\";s:11:\"user_search\";s:5:\"label\";s:5:\"Users\";s:4:\"path\";s:4:\"user\";s:6:\"weight\";i:0;s:6:\"plugin\";s:11:\"user_search\";s:13:\"configuration\";a:0:{}}'),

('','search.settings','a:5:{s:12:\"and_or_limit\";i:7;s:12:\"default_page\";s:11:\"node_search\";s:5:\"index\";a:4:{s:10:\"cron_limit\";i:100;s:11:\"overlap_cjk\";b:1;s:17:\"minimum_word_size\";i:3;s:11:\"tag_weights\";a:12:{s:2:\"h1\";i:25;s:2:\"h2\";i:18;s:2:\"h3\";i:15;s:2:\"h4\";i:14;s:2:\"h5\";i:9;s:2:\"h6\";i:6;s:1:\"u\";i:3;s:1:\"b\";i:3;s:1:\"i\";i:3;s:6:\"strong\";i:3;s:2:\"em\";i:3;s:1:\"a\";i:10;}}s:7:\"logging\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"hvVxL1G-ZCxaq32IZws0YsfuhvaDiQE_np-0g35KjUk\";}}'),

('','serialization.settings','a:2:{s:24:\"bc_primitives_as_strings\";b:0;s:28:\"bc_timestamp_normalizer_unix\";b:1;}'),

('','seven.settings','a:1:{s:20:\"third_party_settings\";a:1:{s:8:\"shortcut\";a:1:{s:11:\"module_link\";b:1;}}}'),

('','shortcut.set.default','a:7:{s:4:\"uuid\";s:36:\"0f0b2a97-0738-41b7-aa52-8454c5967576\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U5VlGjd_SfV0Qm_EfnaynOfc549cNscFAx48JfYoMRI\";}s:2:\"id\";s:7:\"default\";s:5:\"label\";s:7:\"Default\";}'),

('','system.action.comment_delete_action','a:9:{s:4:\"uuid\";s:36:\"e8a78e66-c02d-4548-b7d7-c3da986a243a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:2:\"id\";s:21:\"comment_delete_action\";s:5:\"label\";s:14:\"Delete comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:28:\"entity:delete_action:comment\";s:13:\"configuration\";a:0:{}}'),

('','system.action.comment_publish_action','a:10:{s:4:\"uuid\";s:36:\"b58decdb-33d8-4ba0-9d02-ad4454cd634c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"f6w_Pd30AyyDIoMkD4QpPMM2-I8FTEHICchFVOpjiCI\";}s:2:\"id\";s:22:\"comment_publish_action\";s:5:\"label\";s:15:\"Publish comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:29:\"entity:publish_action:comment\";s:13:\"configuration\";a:0:{}}'),

('','system.action.comment_save_action','a:10:{s:4:\"uuid\";s:36:\"9f4e59f8-370e-43b1-b6fd-c567d4a3e8c9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TSkg_gUZvk-39yXFrIFnKjsxuEzO0qBH82TdDxOMMr4\";}s:2:\"id\";s:19:\"comment_save_action\";s:5:\"label\";s:12:\"Save comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:26:\"entity:save_action:comment\";s:13:\"configuration\";a:0:{}}'),

('','system.action.comment_unpublish_action','a:10:{s:4:\"uuid\";s:36:\"761a63f0-3a26-47a6-80ac-2ad7f2216cdc\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"MLin6S_PsJ7Oo480DxS46D46IM8tqFkkWOLyH7TGByI\";}s:2:\"id\";s:24:\"comment_unpublish_action\";s:5:\"label\";s:17:\"Unpublish comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:31:\"entity:unpublish_action:comment\";s:13:\"configuration\";a:0:{}}'),

('','system.action.commerce_order_delete_action','a:10:{s:4:\"uuid\";s:36:\"03f2d5db-56aa-4839-9ae0-872bcfd45a10\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:6:\"module\";a:1:{i:0;s:6:\"entity\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"GDUgwBmDhcGNHBz3FBgXqXvyuMJVsKy9oytH9wNOJns\";}s:2:\"id\";s:28:\"commerce_order_delete_action\";s:5:\"label\";s:12:\"Delete order\";s:4:\"type\";s:14:\"commerce_order\";s:6:\"plugin\";s:35:\"entity_delete_action:commerce_order\";s:13:\"configuration\";a:0:{}}'),

('','system.action.commerce_product_delete_action','a:10:{s:4:\"uuid\";s:36:\"74a0836d-c2c5-4f92-97de-e2d2651f4938\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:6:\"entity\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rxmGRw66r86CkHY9zkcXVic946t0v1Qn0boxBY5n6c0\";}s:2:\"id\";s:30:\"commerce_product_delete_action\";s:5:\"label\";s:14:\"Delete product\";s:4:\"type\";s:16:\"commerce_product\";s:6:\"plugin\";s:37:\"entity_delete_action:commerce_product\";s:13:\"configuration\";a:0:{}}'),

('','system.action.commerce_publish_product','a:10:{s:4:\"uuid\";s:36:\"de37e755-2899-4fa1-b41c-35e8c8040468\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"83abjxFWTlkso65OfwvUzv_VvAc9iIswF2kW_MGZmY8\";}s:2:\"id\";s:24:\"commerce_publish_product\";s:5:\"label\";s:15:\"Publish product\";s:4:\"type\";s:16:\"commerce_product\";s:6:\"plugin\";s:24:\"commerce_publish_product\";s:13:\"configuration\";a:0:{}}'),

('','system.action.commerce_store_delete_action','a:10:{s:4:\"uuid\";s:36:\"2315c0ba-efe3-4daf-acd4-83246fcc148f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_store\";}}s:6:\"module\";a:1:{i:0;s:6:\"entity\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"UdhJAuixyuIu-hp_uqul-Gm97CiABMd1mM6GgzdwL3I\";}s:2:\"id\";s:28:\"commerce_store_delete_action\";s:5:\"label\";s:12:\"Delete store\";s:4:\"type\";s:14:\"commerce_store\";s:6:\"plugin\";s:35:\"entity_delete_action:commerce_store\";s:13:\"configuration\";a:0:{}}'),

('','system.action.commerce_unpublish_product','a:10:{s:4:\"uuid\";s:36:\"8f948afb-5fcc-4c2a-8765-4bec60018837\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6gfQWDjHFkJsE2C2ayhUL7x1jBGPgOhr3SGF15Kxy-w\";}s:2:\"id\";s:26:\"commerce_unpublish_product\";s:5:\"label\";s:17:\"Unpublish product\";s:4:\"type\";s:16:\"commerce_product\";s:6:\"plugin\";s:26:\"commerce_unpublish_product\";s:13:\"configuration\";a:0:{}}'),

('','system.action.node_delete_action','a:10:{s:4:\"uuid\";s:36:\"5ded8915-25a3-4ace-80f0-5dc07f7cdf1d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Zx0jD1Klh5tZaGJy8uOeR_2MCu9FDM4xg7TaUJUEbkI\";}s:2:\"id\";s:18:\"node_delete_action\";s:5:\"label\";s:14:\"Delete content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:25:\"entity:delete_action:node\";s:13:\"configuration\";a:0:{}}'),

('','system.action.node_make_sticky_action','a:10:{s:4:\"uuid\";s:36:\"a6aecdf7-d8f2-47d9-a5c8-96850ccb3238\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sOb26JSy3fGpWkvR0WYN6_hMqj_6d1rvbvrkzp1yya0\";}s:2:\"id\";s:23:\"node_make_sticky_action\";s:5:\"label\";s:19:\"Make content sticky\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:23:\"node_make_sticky_action\";s:13:\"configuration\";a:0:{}}'),

('','system.action.node_make_unsticky_action','a:10:{s:4:\"uuid\";s:36:\"fdd3ef42-6e3c-4e45-bd33-76b76f62b1f5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lDM9mvIGAu8Sw8rt-uCO4Sr7yX5VPrDPxYcawkbKd6k\";}s:2:\"id\";s:25:\"node_make_unsticky_action\";s:5:\"label\";s:21:\"Make content unsticky\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:25:\"node_make_unsticky_action\";s:13:\"configuration\";a:0:{}}'),

('','system.action.node_promote_action','a:10:{s:4:\"uuid\";s:36:\"ed364b5a-046b-4b2b-a815-5ac4bee6c522\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"N0RDBTqiK4dKoN4p4oW2j0SGWycdHyALUe9M-Ofp89U\";}s:2:\"id\";s:19:\"node_promote_action\";s:5:\"label\";s:29:\"Promote content to front page\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:19:\"node_promote_action\";s:13:\"configuration\";a:0:{}}'),

('','system.action.node_publish_action','a:10:{s:4:\"uuid\";s:36:\"6a6bc3ba-0e63-4e67-8574-7cd900b03cc7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lsQkbo4njZ-Q_oGKCPGXGWFjWF1I7QpgA6m-t9rcRoA\";}s:2:\"id\";s:19:\"node_publish_action\";s:5:\"label\";s:15:\"Publish content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:26:\"entity:publish_action:node\";s:13:\"configuration\";a:0:{}}'),

('','system.action.node_save_action','a:10:{s:4:\"uuid\";s:36:\"ac408f45-c626-47cf-aa1e-4d2df0bd9dfe\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U9HspszLxcw6pZmRacFa6yDbbheyMN-We4fPbrWWHGg\";}s:2:\"id\";s:16:\"node_save_action\";s:5:\"label\";s:12:\"Save content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:23:\"entity:save_action:node\";s:13:\"configuration\";a:0:{}}'),

('','system.action.node_unpromote_action','a:10:{s:4:\"uuid\";s:36:\"215abe1b-65e9-4a11-8040-af0aec8d595c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"JBptjnfuOMtsdKygklXxoOgeOCTMtQxlkymjnnj-cC0\";}s:2:\"id\";s:21:\"node_unpromote_action\";s:5:\"label\";s:30:\"Remove content from front page\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:21:\"node_unpromote_action\";s:13:\"configuration\";a:0:{}}'),

('','system.action.node_unpublish_action','a:10:{s:4:\"uuid\";s:36:\"ab6c1f2b-cc41-4d9f-aafc-b7cd076fbda9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"gGQXiSspwGl0lyOS6w_HCPpvGAPDciqDNLFwWOydVtI\";}s:2:\"id\";s:21:\"node_unpublish_action\";s:5:\"label\";s:17:\"Unpublish content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:28:\"entity:unpublish_action:node\";s:13:\"configuration\";a:0:{}}'),

('','system.action.pathauto_update_alias_node','a:10:{s:4:\"uuid\";s:36:\"3d8851d6-400a-4c5f-aa63-d933128cbd8f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"pathauto\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-SdRoSbsl_FULjbX8mgESZdeoEOjgi7rDhHNdLOJ8n8\";}s:2:\"id\";s:26:\"pathauto_update_alias_node\";s:5:\"label\";s:16:\"Update URL alias\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:21:\"pathauto_update_alias\";s:13:\"configuration\";a:0:{}}'),

('','system.action.pathauto_update_alias_user','a:10:{s:4:\"uuid\";s:36:\"d7a5b116-a443-4193-a0a0-a34e33a7b67f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"pathauto\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fWszFHPeJ_dhZ8kJEEWo4w-FQH_etR4AxTQkQCW9OLk\";}s:2:\"id\";s:26:\"pathauto_update_alias_user\";s:5:\"label\";s:16:\"Update URL alias\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:21:\"pathauto_update_alias\";s:13:\"configuration\";a:0:{}}'),

('','system.action.profile_delete_action','a:10:{s:4:\"uuid\";s:36:\"c2405ee7-1df0-4083-b7e4-c9d0b2a6d260\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"profile\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7iaCHiR7rJnpuIcqcYxtZ6OFm7HnFfjZJdE1s-8K4RM\";}s:2:\"id\";s:21:\"profile_delete_action\";s:5:\"label\";s:23:\"Delete selected profile\";s:4:\"type\";s:7:\"profile\";s:6:\"plugin\";s:28:\"entity:delete_action:profile\";s:13:\"configuration\";a:0:{}}'),

('','system.action.profile_publish_action','a:10:{s:4:\"uuid\";s:36:\"902cc1d2-7103-4f75-bcc3-56a43e79a620\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"profile\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dz5_l09fj1m6b4MZVYlHjYHsXSlG9aQHGGoupPb8phg\";}s:2:\"id\";s:22:\"profile_publish_action\";s:5:\"label\";s:24:\"Publish selected profile\";s:4:\"type\";s:7:\"profile\";s:6:\"plugin\";s:29:\"entity:publish_action:profile\";s:13:\"configuration\";a:0:{}}'),

('','system.action.profile_unpublish_action','a:10:{s:4:\"uuid\";s:36:\"157308d6-383c-4ffe-ab48-f54651c93673\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"profile\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QWiXic0BIuoYYgvkiSTxsCsPPi7k1mYuHOTIAPhoT4Q\";}s:2:\"id\";s:24:\"profile_unpublish_action\";s:5:\"label\";s:26:\"Unpublish selected profile\";s:4:\"type\";s:7:\"profile\";s:6:\"plugin\";s:31:\"entity:unpublish_action:profile\";s:13:\"configuration\";a:0:{}}'),

('','system.action.user_add_role_action.administrator','a:9:{s:4:\"uuid\";s:36:\"1f8e9ca0-4b88-4dc0-b431-c8961b5a9945\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:23:\"user.role.administrator\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:2:\"id\";s:34:\"user_add_role_action.administrator\";s:5:\"label\";s:48:\"Add the Administrator role to the selected users\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:20:\"user_add_role_action\";s:13:\"configuration\";a:1:{s:3:\"rid\";s:13:\"administrator\";}}'),

('','system.action.user_block_user_action','a:10:{s:4:\"uuid\";s:36:\"b0031184-d631-4c30-9e7d-47b74721da08\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DyypzTfThX10FFQw-399qPfEbLLyrhXgQrKPVsmAoJ4\";}s:2:\"id\";s:22:\"user_block_user_action\";s:5:\"label\";s:26:\"Block the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:22:\"user_block_user_action\";s:13:\"configuration\";a:0:{}}'),

('','system.action.user_cancel_user_action','a:10:{s:4:\"uuid\";s:36:\"2e19587f-803d-4b50-a479-d636ca2ee222\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nvrL9bFilzBvm2bjO9rQnFDpBA7dBBUjShSSt6NS-DU\";}s:2:\"id\";s:23:\"user_cancel_user_action\";s:5:\"label\";s:35:\"Cancel the selected user account(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:23:\"user_cancel_user_action\";s:13:\"configuration\";a:0:{}}'),

('','system.action.user_remove_role_action.administrator','a:9:{s:4:\"uuid\";s:36:\"848793b1-fdad-41e3-97c3-08da27181cbf\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:23:\"user.role.administrator\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:2:\"id\";s:37:\"user_remove_role_action.administrator\";s:5:\"label\";s:53:\"Remove the Administrator role from the selected users\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:23:\"user_remove_role_action\";s:13:\"configuration\";a:1:{s:3:\"rid\";s:13:\"administrator\";}}'),

('','system.action.user_unblock_user_action','a:10:{s:4:\"uuid\";s:36:\"dfd83f68-9de9-490e-99b0-6ec46aeafbb9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SPsUXsR3Rc8d1y3gewzaAKWa1ncea_ywXX3f7LTn7k0\";}s:2:\"id\";s:24:\"user_unblock_user_action\";s:5:\"label\";s:28:\"Unblock the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:24:\"user_unblock_user_action\";s:13:\"configuration\";a:0:{}}'),

('','system.action.webform_submission_delete_action','a:9:{s:4:\"uuid\";s:36:\"c06327be-b234-4498-8dda-b7f6da340027\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}s:2:\"id\";s:32:\"webform_submission_delete_action\";s:5:\"label\";s:17:\"Delete submission\";s:4:\"type\";s:18:\"webform_submission\";s:6:\"plugin\";s:32:\"webform_submission_delete_action\";s:13:\"configuration\";a:0:{}}'),

('','system.action.webform_submission_make_sticky_action','a:9:{s:4:\"uuid\";s:36:\"e11b1c42-0b99-410a-81f5-55987d60815f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}s:2:\"id\";s:37:\"webform_submission_make_sticky_action\";s:5:\"label\";s:20:\"Star/Flag submission\";s:4:\"type\";s:18:\"webform_submission\";s:6:\"plugin\";s:37:\"webform_submission_make_sticky_action\";s:13:\"configuration\";a:0:{}}'),

('','system.action.webform_submission_make_unsticky_action','a:9:{s:4:\"uuid\";s:36:\"d4bd15f3-4cea-43eb-aca2-db427029ac40\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}s:2:\"id\";s:39:\"webform_submission_make_unsticky_action\";s:5:\"label\";s:24:\"Unstar/unflag submission\";s:4:\"type\";s:18:\"webform_submission\";s:6:\"plugin\";s:39:\"webform_submission_make_unsticky_action\";s:13:\"configuration\";a:0:{}}'),

('','system.authorize','a:2:{s:20:\"filetransfer_default\";N;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"z63ds8M4zPrylEgFRkRcOlfcsXWwfITzjD4cj1kRdfg\";}}'),

('','system.cron','a:3:{s:9:\"threshold\";a:2:{s:20:\"requirements_warning\";i:172800;s:18:\"requirements_error\";i:1209600;}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"05U0n1_8zHYzxEFSWjyHCWuJyhdez2a6Z_aTIXin04E\";}s:7:\"logging\";i:1;}'),

('','system.date','a:4:{s:7:\"country\";a:1:{s:7:\"default\";s:0:\"\";}s:9:\"first_day\";i:0;s:8:\"timezone\";a:2:{s:7:\"default\";s:13:\"Europe/Moscow\";s:4:\"user\";a:3:{s:12:\"configurable\";b:1;s:4:\"warn\";b:0;s:7:\"default\";i:0;}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"V9UurX2GPT05NWKG9f2GWQqFG2TRG8vczidwjpy7Woo\";}}'),

('','system.diff','a:2:{s:7:\"context\";a:2:{s:13:\"lines_leading\";i:2;s:14:\"lines_trailing\";i:2;}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1WanmaEhxW_vM8_5Ktsdntj8MaO9UBHXg0lN603PsWM\";}}'),

('','system.file','a:5:{s:22:\"allow_insecure_uploads\";b:0;s:14:\"default_scheme\";s:6:\"public\";s:4:\"path\";a:1:{s:9:\"temporary\";s:23:\"sites/default/files/tmp\";}s:21:\"temporary_maximum_age\";i:21600;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"t48gCU9DzYfjb3bAOIqHLzhL0ChBlXh6_5B5Pyo9t8g\";}}'),

('','system.image','a:2:{s:7:\"toolkit\";s:2:\"gd\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"durWHaKeBaq4d9Wpi4RqwADj1OufDepcnJuhVLmKN24\";}}'),

('','system.image.gd','a:2:{s:12:\"jpeg_quality\";i:85;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eNXaHfkJJUThHeF0nvkoXyPLRrKYGxgHRjORvT4F5rQ\";}}'),

('','system.logging','a:2:{s:11:\"error_level\";s:7:\"verbose\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"u3-njszl92FaxjrCMiq0yDcjAfcdx72w1zT1O9dx6aA\";}}'),

('','system.mail','a:2:{s:9:\"interface\";a:2:{s:7:\"default\";s:8:\"php_mail\";s:7:\"webform\";s:16:\"webform_php_mail\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rYgt7uhPafP2ngaN_ZUPFuyI4KdE0zU868zLNSlzKoE\";}}'),

('','system.maintenance','a:3:{s:7:\"message\";s:93:\"@site is currently under maintenance. We should be back shortly. Thank you for your patience.\";s:8:\"langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Z5MXifrF77GEAgx0GQ6iWT8wStjFuY8BD9OruofWTJ8\";}}'),

('','system.menu.account','a:9:{s:4:\"uuid\";s:36:\"9252f9c3-f2b6-423b-93ae-cfac946ffd8a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"M_Bh81osDyUQ4wV0GgU_NdBNqkzM87sLxjaCdFj9mnw\";}s:2:\"id\";s:7:\"account\";s:5:\"label\";s:17:\"User account menu\";s:11:\"description\";s:40:\"Links related to the active user account\";s:6:\"locked\";b:1;}'),

('','system.menu.admin','a:9:{s:4:\"uuid\";s:36:\"2f66cb0c-46b3-417c-a342-36dc0c3bbd58\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sapEi2YDGoI9yQIT_WgIV2vUdQ6DScH0V3fAyTadAL0\";}s:2:\"id\";s:5:\"admin\";s:5:\"label\";s:14:\"Administration\";s:11:\"description\";s:25:\"Administrative task links\";s:6:\"locked\";b:1;}'),

('','system.menu.footer','a:9:{s:4:\"uuid\";s:36:\"d70d79ca-75b0-4ae2-ba85-673366eda18b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7yrlW5z9zdg2eBucB2GPqXKSMQfH9lSRSO4DbWF7AFc\";}s:2:\"id\";s:6:\"footer\";s:5:\"label\";s:6:\"Footer\";s:11:\"description\";s:22:\"Site information links\";s:6:\"locked\";b:1;}'),

('','system.menu.main','a:9:{s:4:\"uuid\";s:36:\"fd05204d-a8e7-4708-91f4-e3e26bed83d4\";s:8:\"langcode\";s:3:\"und\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Q2Ra3jfoIVk0f3SjxJX61byRQFVBAbpzYDQOiY-kno8\";}s:2:\"id\";s:4:\"main\";s:5:\"label\";s:15:\"Main navigation\";s:11:\"description\";s:18:\"Site section links\";s:6:\"locked\";b:1;}'),

('','system.menu.one-page','a:8:{s:4:\"uuid\";s:36:\"40ab76db-9d7a-471d-8055-21a76bd3835b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:2:\"id\";s:8:\"one-page\";s:5:\"label\";s:8:\"One Page\";s:11:\"description\";s:8:\"One Page\";s:6:\"locked\";b:0;}'),

('','system.menu.tools','a:9:{s:4:\"uuid\";s:36:\"59b1831b-4e28-4e7e-a9b5-2a05678acbaf\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"BCM-vV1zzRaLHN18dqAR_CuGOj8AFJvTx7BKl_8Gcxc\";}s:2:\"id\";s:5:\"tools\";s:5:\"label\";s:5:\"Tools\";s:11:\"description\";s:39:\"User tool links, often added by modules\";s:6:\"locked\";b:1;}'),

('','system.performance','a:6:{s:5:\"cache\";a:1:{s:4:\"page\";a:1:{s:7:\"max_age\";i:86400;}}s:3:\"css\";a:2:{s:10:\"preprocess\";b:1;s:4:\"gzip\";b:1;}s:8:\"fast_404\";a:4:{s:7:\"enabled\";b:1;s:5:\"paths\";s:69:\"/\\.(?:txt|png|gif|jpe?g|css|js|ico|swf|flv|cgi|bat|pl|dll|exe|asp)$/i\";s:13:\"exclude_paths\";s:27:\"/\\/(?:styles|imagecache)\\//\";s:4:\"html\";s:162:\"<!DOCTYPE html><html><head><title>404 Not Found</title></head><body><h1>Not Found</h1><p>The requested URL \"@path\" was not found on this server.</p></body></html>\";}s:2:\"js\";a:2:{s:10:\"preprocess\";b:1;s:4:\"gzip\";b:1;}s:20:\"stale_file_threshold\";i:2592000;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"b2cssrj-lOmATIbdehfCqfCFgVR0qCdxxWhwqa2KBVQ\";}}'),

('','system.rss','a:4:{s:7:\"channel\";a:1:{s:11:\"description\";s:0:\"\";}s:5:\"items\";a:2:{s:5:\"limit\";i:10;s:9:\"view_mode\";s:3:\"rss\";}s:8:\"langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TlH7NNk46phfxu1mSUfwg1C0YqaGsUCeD4l9JQnQlDU\";}}'),

('','system.site','a:10:{s:4:\"uuid\";s:36:\"5c453838-2dae-4711-b03c-d2f7224585f1\";s:4:\"name\";s:6:\"Rhythm\";s:4:\"mail\";s:19:\"example@example.com\";s:6:\"slogan\";s:0:\"\";s:4:\"page\";a:3:{i:403;s:0:\"\";i:404;s:0:\"\";s:5:\"front\";s:8:\"/node/97\";}s:18:\"admin_compact_mode\";b:0;s:17:\"weight_select_max\";i:100;s:8:\"langcode\";s:2:\"en\";s:16:\"default_langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AyT9s8OUcclfALRE_imByOMgtZ19eOlqdF6zI3p7yqo\";}}'),

('','system.theme','a:3:{s:5:\"admin\";s:5:\"seven\";s:7:\"default\";s:10:\"rhythm_sub\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fOjer9hADYYnbCJVZMFZIIM1azTFWyg84ZkFDHfAbUg\";}}'),

('','system.theme.global','a:4:{s:7:\"favicon\";a:4:{s:8:\"mimetype\";s:24:\"image/vnd.microsoft.icon\";s:4:\"path\";s:0:\"\";s:3:\"url\";s:0:\"\";s:11:\"use_default\";b:1;}s:8:\"features\";a:4:{s:20:\"comment_user_picture\";b:1;s:25:\"comment_user_verification\";b:1;s:7:\"favicon\";b:1;s:17:\"node_user_picture\";b:1;}s:4:\"logo\";a:3:{s:4:\"path\";s:0:\"\";s:3:\"url\";s:0:\"\";s:11:\"use_default\";b:1;}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9rAU4Pku7eMBQxauQqAgjzlcicFZ2As6zEa6zvTlCB8\";}}'),

('','taxonomy.settings','a:4:{s:20:\"maintain_index_table\";b:1;s:17:\"override_selector\";b:0;s:20:\"terms_per_page_admin\";i:100;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"zKpaWT6cJc1tVQQaTqatGELaCqU_oyRym6zTl27Yias\";}}'),

('','taxonomy.vocabulary.blog_category','a:8:{s:4:\"uuid\";s:36:\"86f101ec-5726-49f2-b39b-6bba3ac7a794\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:13:\"Blog Category\";s:3:\"vid\";s:13:\"blog_category\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}'),

('','taxonomy.vocabulary.category','a:8:{s:4:\"uuid\";s:36:\"d1f9fdfb-2136-4ebf-92ee-fb49d5b0e2de\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:8:\"Category\";s:3:\"vid\";s:8:\"category\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}'),

('','taxonomy.vocabulary.gallery','a:8:{s:4:\"uuid\";s:36:\"0e02cdbb-74a7-4e71-8664-a8b3724f83f3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:7:\"Gallery\";s:3:\"vid\";s:7:\"gallery\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}'),

('','taxonomy.vocabulary.portfolio_category','a:8:{s:4:\"uuid\";s:36:\"3fe666b0-e5f2-4759-bf94-d0e1c9392b41\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:18:\"Portfolio Category\";s:3:\"vid\";s:18:\"portfolio_category\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}'),

('','taxonomy.vocabulary.project','a:8:{s:4:\"uuid\";s:36:\"978f2b36-6c3d-44f8-b71b-541b333cc262\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:4:\"name\";s:7:\"Project\";s:3:\"vid\";s:7:\"project\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}'),

('','taxonomy.vocabulary.tags','a:9:{s:4:\"uuid\";s:36:\"92bac0d2-aba9-41d1-ba44-79ebc289d900\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lO5ziR5dVI1PpEeHZsSOfQ-Y7NWihSDKW8-MMf6uoms\";}s:4:\"name\";s:4:\"Tags\";s:3:\"vid\";s:4:\"tags\";s:11:\"description\";s:61:\"Use tags to group articles on similar topics into categories.\";s:6:\"weight\";i:0;}'),

('','tb_megamenu.menu_config.main__rhythm_sub','a:9:{s:4:\"uuid\";s:36:\"104a642f-6caa-47d2-8e80-0048b10945bb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:4:\"menu\";a:1:{i:0;s:4:\"main\";}s:5:\"theme\";a:1:{i:0;s:10:\"rhythm_sub\";}}s:2:\"id\";s:16:\"main__rhythm_sub\";s:4:\"menu\";s:4:\"main\";s:5:\"theme\";s:10:\"rhythm_sub\";s:12:\"block_config\";s:127:\"{\"animation\":\"none\",\"duration\":\"400\",\"delay\":\"200\",\"style\":\"\",\"auto-arrow\":\"1\",\"always-show-submenu\":\"1\",\"number-columns\":\"23\"}\";s:11:\"menu_config\";s:43233:\"{\"standard.front_page\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:f24ed196-0a8b-471e-95d8-177e20a9e9ba\",\"type\":\"menu_item\",\"weight\":\"26\"},{\"plugin_id\":\"menu_link_content:a669b9ca-166c-45ba-8e77-1faad3feb3eb\",\"type\":\"menu_item\",\"weight\":\"27\"},{\"plugin_id\":\"menu_link_content:d9f4d184-1bcf-483a-ac64-9a287afa146b\",\"type\":\"menu_item\",\"weight\":\"28\"},{\"plugin_id\":\"menu_link_content:861d0785-e6ed-4109-969a-c8aa12644e81\",\"type\":\"menu_item\",\"weight\":\"29\"},{\"plugin_id\":\"menu_link_content:c4129e2d-44f0-4687-a510-ad45c568bce1\",\"type\":\"menu_item\",\"weight\":\"30\"},{\"plugin_id\":\"menu_link_content:d4d5b6bd-9b29-4eb5-9acf-f87af995214c\",\"type\":\"menu_item\",\"weight\":\"31\"},{\"plugin_id\":\"menu_link_content:691ba057-a9fe-4a02-9bc4-105aa7e3d5f4\",\"type\":\"menu_item\",\"weight\":\"32\"},{\"plugin_id\":\"menu_link_content:fe3cc388-c8c1-4e13-91e2-c6d26d4f10e3\",\"type\":\"menu_item\",\"weight\":\"33\"},{\"plugin_id\":\"menu_link_content:9483d07a-5aa5-41a3-8ad6-456f80f78ac3\",\"type\":\"menu_item\",\"weight\":\"34\"}],\"col_config\":{\"width\":\"3\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"plugin_id\":\"menu_link_content:506ee439-af38-47ef-a5e4-59c275e58937\",\"type\":\"menu_item\",\"weight\":\"35\"},{\"plugin_id\":\"menu_link_content:ce38002a-7dec-4a04-89f3-91f46b47858a\",\"type\":\"menu_item\",\"weight\":\"36\"},{\"plugin_id\":\"menu_link_content:48eb8cfb-67f8-44a4-b680-a154f132796c\",\"type\":\"menu_item\",\"weight\":\"37\"},{\"plugin_id\":\"menu_link_content:d0a9cd75-588f-4e44-98a6-d3b4bfbd80b2\",\"type\":\"menu_item\",\"weight\":\"38\"},{\"plugin_id\":\"menu_link_content:c74a5095-9a45-49ae-8da3-0be2e4717b32\",\"type\":\"menu_item\",\"weight\":\"39\"},{\"plugin_id\":\"menu_link_content:4dc6c8de-d27e-484f-8968-01b208414702\",\"type\":\"menu_item\",\"weight\":\"40\"},{\"plugin_id\":\"menu_link_content:ba223303-602f-4245-9b65-1c11d81c46f2\",\"type\":\"menu_item\",\"weight\":\"41\"},{\"plugin_id\":\"menu_link_content:eb3345f8-d32e-449f-a28d-3384b6b4ac96\",\"type\":\"menu_item\",\"weight\":\"42\"},{\"plugin_id\":\"menu_link_content:6b2a820d-9368-4a7f-8b42-465f88d3e1bb\",\"type\":\"menu_item\",\"weight\":\"43\"}],\"col_config\":{\"width\":\"3\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"plugin_id\":\"menu_link_content:ad36f87b-f542-454b-9685-2da56272071d\",\"type\":\"menu_item\",\"weight\":\"44\"},{\"plugin_id\":\"menu_link_content:58547176-ac14-452d-9bab-fe6204fcd2ea\",\"type\":\"menu_item\",\"weight\":\"45\"},{\"plugin_id\":\"menu_link_content:c5f9385e-3b46-4f25-b2a0-1b22b4df4c2d\",\"type\":\"menu_item\",\"weight\":\"46\"},{\"plugin_id\":\"menu_link_content:d03a8906-685a-4fa6-b4bb-e753de92fff6\",\"type\":\"menu_item\",\"weight\":\"47\"},{\"plugin_id\":\"menu_link_content:76e447c9-6d4f-4814-8a67-83d92a294ba4\",\"type\":\"menu_item\",\"weight\":\"48\"},{\"plugin_id\":\"menu_link_content:137a5d20-1c92-46b1-adc8-6986ef4ba061\",\"type\":\"menu_item\",\"weight\":\"49\"},{\"plugin_id\":\"menu_link_content:a8ebb28d-2a08-4f46-bc41-c7d2e380e341\",\"type\":\"menu_item\",\"weight\":\"50\"},{\"plugin_id\":\"menu_link_content:12b26d04-ea1a-467a-b0d3-72733ba93a88\",\"type\":\"menu_item\",\"weight\":\"51\"},{\"plugin_id\":\"menu_link_content:2999ccf3-e949-47dc-911a-51ce4f0b1f4b\",\"type\":\"menu_item\",\"weight\":\"52\"}],\"col_config\":{\"width\":\"3\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"plugin_id\":\"menu_link_content:6df35863-66bf-4822-b031-aea60d06ef46\",\"type\":\"menu_item\",\"weight\":\"53\"},{\"plugin_id\":\"menu_link_content:92a230bd-a998-4bd2-b5ef-4266cb0e45a4\",\"type\":\"menu_item\",\"weight\":\"54\"},{\"plugin_id\":\"menu_link_content:cebaa43c-205f-4f89-b0fc-6ff322ecfd39\",\"type\":\"menu_item\",\"weight\":\"55\"},{\"plugin_id\":\"menu_link_content:3fa83a2b-7b51-4597-9cbe-70ba8d569b58\",\"type\":\"menu_item\",\"weight\":\"56\"},{\"plugin_id\":\"menu_link_content:7cd859fa-e56c-460a-b258-fbdb90e4d2b6\",\"type\":\"menu_item\",\"weight\":\"57\"},{\"plugin_id\":\"menu_link_content:d953421d-2381-48a2-8ec6-b3556e193d27\",\"type\":\"menu_item\",\"weight\":\"58\"},{\"plugin_id\":\"menu_link_content:e1b2f94e-df9b-4de0-994d-896fea2a566c\",\"type\":\"menu_item\",\"weight\":\"59\"},{\"plugin_id\":\"menu_link_content:76dce2dd-4bbe-48ce-be35-01e61c904ba0\",\"type\":\"menu_item\",\"weight\":\"60\"},{\"plugin_id\":\"menu_link_content:7c682988-9e8a-4380-aeba-a2bc289d04b1\",\"type\":\"menu_item\",\"weight\":\"61\"}],\"col_config\":{\"width\":\"3\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"800\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:f24ed196-0a8b-471e-95d8-177e20a9e9ba\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"Multi Pages\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:a669b9ca-166c-45ba-8e77-1faad3feb3eb\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:d9f4d184-1bcf-483a-ac64-9a287afa146b\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:861d0785-e6ed-4109-969a-c8aa12644e81\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:c4129e2d-44f0-4687-a510-ad45c568bce1\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:d4d5b6bd-9b29-4eb5-9acf-f87af995214c\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:691ba057-a9fe-4a02-9bc4-105aa7e3d5f4\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:fe3cc388-c8c1-4e13-91e2-c6d26d4f10e3\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:9483d07a-5aa5-41a3-8ad6-456f80f78ac3\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:506ee439-af38-47ef-a5e4-59c275e58937\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\" \",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:ce38002a-7dec-4a04-89f3-91f46b47858a\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:48eb8cfb-67f8-44a4-b680-a154f132796c\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:d0a9cd75-588f-4e44-98a6-d3b4bfbd80b2\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:c74a5095-9a45-49ae-8da3-0be2e4717b32\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:4dc6c8de-d27e-484f-8968-01b208414702\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:ba223303-602f-4245-9b65-1c11d81c46f2\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:eb3345f8-d32e-449f-a28d-3384b6b4ac96\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:6b2a820d-9368-4a7f-8b42-465f88d3e1bb\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:ad36f87b-f542-454b-9685-2da56272071d\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"One Page\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:58547176-ac14-452d-9bab-fe6204fcd2ea\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:c5f9385e-3b46-4f25-b2a0-1b22b4df4c2d\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:d03a8906-685a-4fa6-b4bb-e753de92fff6\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:76e447c9-6d4f-4814-8a67-83d92a294ba4\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:137a5d20-1c92-46b1-adc8-6986ef4ba061\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:a8ebb28d-2a08-4f46-bc41-c7d2e380e341\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:12b26d04-ea1a-467a-b0d3-72733ba93a88\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:2999ccf3-e949-47dc-911a-51ce4f0b1f4b\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:6df35863-66bf-4822-b031-aea60d06ef46\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\" \",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:92a230bd-a998-4bd2-b5ef-4266cb0e45a4\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:cebaa43c-205f-4f89-b0fc-6ff322ecfd39\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:3fa83a2b-7b51-4597-9cbe-70ba8d569b58\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:7cd859fa-e56c-460a-b258-fbdb90e4d2b6\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:d953421d-2381-48a2-8ec6-b3556e193d27\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:e1b2f94e-df9b-4de0-994d-896fea2a566c\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:76dce2dd-4bbe-48ce-be35-01e61c904ba0\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:7c682988-9e8a-4380-aeba-a2bc289d04b1\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:733a539d-3c2a-45fd-a73b-bb5063207240\",\"type\":\"menu_item\",\"weight\":\"3\"},{\"plugin_id\":\"menu_link_content:3d302ce2-fcbc-427c-b63e-7dd13fd3d705\",\"type\":\"menu_item\",\"weight\":\"4\"},{\"plugin_id\":\"menu_link_content:367c68ba-1ef2-4e41-bf74-7688e5904093\",\"type\":\"menu_item\",\"weight\":\"5\"},{\"plugin_id\":\"menu_link_content:e91489b9-2232-4827-8e2e-2668769f7665\",\"type\":\"menu_item\",\"weight\":\"6\"},{\"plugin_id\":\"menu_link_content:71554a3f-b4c2-4cf1-acd0-f3e91727b086\",\"type\":\"menu_item\",\"weight\":\"7\"},{\"plugin_id\":\"menu_link_content:34c07aab-b309-4699-b861-a6c292e165d2\",\"type\":\"menu_item\",\"weight\":\"8\"},{\"plugin_id\":\"menu_link_content:c1470211-9873-446f-9797-6089dffdee4f\",\"type\":\"menu_item\",\"weight\":\"9\"},{\"plugin_id\":\"menu_link_content:c73021cd-900f-469b-9491-07e016d521aa\",\"type\":\"menu_item\",\"weight\":\"10\"}],\"col_config\":{\"width\":\"4\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"plugin_id\":\"menu_link_content:7a67997c-7b80-46b1-820b-a1b9c57535e5\",\"type\":\"menu_item\",\"weight\":\"11\"},{\"plugin_id\":\"menu_link_content:4adcc82e-4225-4b54-ae75-1874f637e3d6\",\"type\":\"menu_item\",\"weight\":\"12\"},{\"plugin_id\":\"menu_link_content:86580bef-aa20-4a1b-a234-30eeb1f64b8d\",\"type\":\"menu_item\",\"weight\":\"13\"},{\"plugin_id\":\"menu_link_content:b329caef-882c-4fb4-88d6-5c0e956c3230\",\"type\":\"menu_item\",\"weight\":\"14\"},{\"plugin_id\":\"menu_link_content:32567f5e-6902-41e1-87a2-140840992d0f\",\"type\":\"menu_item\",\"weight\":\"15\"},{\"plugin_id\":\"menu_link_content:c065ff63-c661-41e5-afdc-f27d0815c3b0\",\"type\":\"menu_item\",\"weight\":\"16\"},{\"plugin_id\":\"menu_link_content:6d235af9-aa59-4a1f-86f4-f7cf95990571\",\"type\":\"menu_item\",\"weight\":\"17\"},{\"plugin_id\":\"menu_link_content:7ac5c97e-66e5-44ba-9701-3a4250b7b1d9\",\"type\":\"menu_item\",\"weight\":\"18\"}],\"col_config\":{\"width\":\"4\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"plugin_id\":\"views_view:views.gallery.page_1\",\"type\":\"menu_item\",\"weight\":\"19\"},{\"plugin_id\":\"views_view:views.gallery.page_2\",\"type\":\"menu_item\",\"weight\":\"20\"},{\"plugin_id\":\"views_view:views.gallery.page_3\",\"type\":\"menu_item\",\"weight\":\"21\"},{\"plugin_id\":\"views_view:views.gallery.page_4\",\"type\":\"menu_item\",\"weight\":\"22\"},{\"plugin_id\":\"views_view:views.gallery.page_5\",\"type\":\"menu_item\",\"weight\":\"23\"},{\"plugin_id\":\"menu_link_content:d2a5e366-81b2-4334-84c8-31557554f0e1\",\"type\":\"menu_item\",\"weight\":\"24\"},{\"plugin_id\":\"menu_link_content:f1a1def5-badc-404a-a5a7-4b7c80e06deb\",\"type\":\"menu_item\",\"weight\":\"25\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:776125fa-b4d7-4344-bf41-1ea5892e91ef\",\"type\":\"menu_item\",\"weight\":\"26\"},{\"plugin_id\":\"menu_link_content:16141053-6ad4-4886-8a35-c406aac8e9e4\",\"type\":\"menu_item\",\"weight\":\"27\"}],\"col_config\":{\"width\":\"4\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"600\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"center\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:733a539d-3c2a-45fd-a73b-bb5063207240\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:3d302ce2-fcbc-427c-b63e-7dd13fd3d705\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:367c68ba-1ef2-4e41-bf74-7688e5904093\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:e91489b9-2232-4827-8e2e-2668769f7665\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:71554a3f-b4c2-4cf1-acd0-f3e91727b086\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:34c07aab-b309-4699-b861-a6c292e165d2\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:c1470211-9873-446f-9797-6089dffdee4f\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:c73021cd-900f-469b-9491-07e016d521aa\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:7a67997c-7b80-46b1-820b-a1b9c57535e5\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:4adcc82e-4225-4b54-ae75-1874f637e3d6\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:86580bef-aa20-4a1b-a234-30eeb1f64b8d\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:b329caef-882c-4fb4-88d6-5c0e956c3230\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:32567f5e-6902-41e1-87a2-140840992d0f\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:c065ff63-c661-41e5-afdc-f27d0815c3b0\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:6d235af9-aa59-4a1f-86f4-f7cf95990571\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:7ac5c97e-66e5-44ba-9701-3a4250b7b1d9\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.gallery.page_1\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.gallery.page_2\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.gallery.page_3\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.gallery.page_4\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.gallery.page_5\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:d2a5e366-81b2-4334-84c8-31557554f0e1\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:776125fa-b4d7-4344-bf41-1ea5892e91ef\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:16141053-6ad4-4886-8a35-c406aac8e9e4\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:a3ee399f-9674-40b8-a77b-af91a5415b33\",\"type\":\"menu_item\",\"weight\":\"-50\"},{\"plugin_id\":\"menu_link_content:ffbafeb5-13ce-4a9e-aebb-517a82b75abf\",\"type\":\"menu_item\",\"weight\":\"-49\"},{\"plugin_id\":\"menu_link_content:be27f22d-c5ff-4994-92d5-a3185bc2c43e\",\"type\":\"menu_item\",\"weight\":\"-48\"},{\"plugin_id\":\"menu_link_content:bf32227d-9747-40a2-92f2-76f9a59cac2d\",\"type\":\"menu_item\",\"weight\":\"-47\"},{\"plugin_id\":\"menu_link_content:fdde11a8-2a92-4936-91e9-4b802ab31b5b\",\"type\":\"menu_item\",\"weight\":\"-46\"},{\"plugin_id\":\"menu_link_content:0c8d517f-c88c-429b-808c-99be0d64142c\",\"type\":\"menu_item\",\"weight\":\"-45\"},{\"plugin_id\":\"menu_link_content:37367b13-a605-42e8-9472-0e5788a65542\",\"type\":\"menu_item\",\"weight\":\"-44\"},{\"plugin_id\":\"menu_link_content:46d6164c-bf4c-4e3b-8a63-f3a0bb29becb\",\"type\":\"menu_item\",\"weight\":\"-43\"},{\"plugin_id\":\"menu_link_content:59c760df-faa4-4c04-a71d-6ebed8addc3b\",\"type\":\"menu_item\",\"weight\":\"-42\"}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"plugin_id\":\"menu_link_content:9300ca4c-bce1-4990-8f18-f2e888c2fb04\",\"type\":\"menu_item\",\"weight\":\"-41\"},{\"plugin_id\":\"menu_link_content:36321b57-7fe6-4eac-a535-bfdbfb32f86f\",\"type\":\"menu_item\",\"weight\":\"-40\"},{\"plugin_id\":\"menu_link_content:1d8b7d03-1fbd-47d7-ac61-14b66ae230cc\",\"type\":\"menu_item\",\"weight\":\"-39\"},{\"plugin_id\":\"menu_link_content:40656ee6-77d0-4bdc-8d5b-89bfb1846fd7\",\"type\":\"menu_item\",\"weight\":\"-38\"},{\"plugin_id\":\"menu_link_content:2dd67deb-b273-48e1-897e-3c0bcbcf5718\",\"type\":\"menu_item\",\"weight\":\"-37\"},{\"plugin_id\":\"menu_link_content:bde03df4-5838-4fea-bb45-0a5ba212e6e7\",\"type\":\"menu_item\",\"weight\":\"-36\"},{\"plugin_id\":\"menu_link_content:bbdf5868-dc3c-4d40-bf02-ed5a98de6baa\",\"type\":\"menu_item\",\"weight\":\"-35\"},{\"plugin_id\":\"menu_link_content:bf270903-a251-43ce-b89c-526df226d233\",\"type\":\"menu_item\",\"weight\":\"-34\"}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"600\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"center\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:a3ee399f-9674-40b8-a77b-af91a5415b33\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-plus-circle\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:ffbafeb5-13ce-4a9e-aebb-517a82b75abf\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-tachometer\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:be27f22d-c5ff-4994-92d5-a3185bc2c43e\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-link\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:bf32227d-9747-40a2-92f2-76f9a59cac2d\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-th-large\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:fdde11a8-2a92-4936-91e9-4b802ab31b5b\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-th\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:0c8d517f-c88c-429b-808c-99be0d64142c\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-heart-o\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:37367b13-a605-42e8-9472-0e5788a65542\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-heart\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:46d6164c-bf4c-4e3b-8a63-f3a0bb29becb\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-comment\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:59c760df-faa4-4c04-a71d-6ebed8addc3b\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-header\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:9300ca4c-bce1-4990-8f18-f2e888c2fb04\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-chevron-circle-right\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:36321b57-7fe6-4eac-a535-bfdbfb32f86f\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-columns\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:1d8b7d03-1fbd-47d7-ac61-14b66ae230cc\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-font\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:40656ee6-77d0-4bdc-8d5b-89bfb1846fd7\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-youtube-play\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:2dd67deb-b273-48e1-897e-3c0bcbcf5718\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-header\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:bde03df4-5838-4fea-bb45-0a5ba212e6e7\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-header\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:bbdf5868-dc3c-4d40-bf02-ed5a98de6baa\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-header\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:bf270903-a251-43ce-b89c-526df226d233\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"fa fa-header\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb\",\"type\":\"menu_item\",\"weight\":\"-73\"},{\"plugin_id\":\"menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962\",\"type\":\"menu_item\",\"weight\":\"-72\"},{\"plugin_id\":\"menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6\",\"type\":\"menu_item\",\"weight\":\"-71\"},{\"plugin_id\":\"menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a\",\"type\":\"menu_item\",\"weight\":\"-70\"},{\"plugin_id\":\"menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f\",\"type\":\"menu_item\",\"weight\":\"-69\"},{\"plugin_id\":\"menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8\",\"type\":\"menu_item\",\"weight\":\"-68\"},{\"plugin_id\":\"views_view:views.portfolio_promo.page_1\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"views_view:views.portfolio_parallax.page_1\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:314f69c9-6761-46c8-8f7f-eba5ba26b421\",\"type\":\"menu_item\",\"weight\":\"0\"}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:6d3a98ea-8ac7-47f3-a41b-f95903b6b944\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:e7e67b14-7d3a-48e2-aa6f-1efbd14a7cce\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:fd17614d-d7f1-4ba4-a132-ae8a0b4113b6\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:0de6635d-abe6-46ad-a198-30427b7ef1a5\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:bdf3d8d7-7e39-4761-9517-525862ece922\",\"type\":\"menu_item\",\"weight\":\"0\"}],\"col_config\":[]}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:bdf3d8d7-7e39-4761-9517-525862ece922\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:54d0a093-232c-4a42-807c-99e5f261c476\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:0cb1c61d-8003-44c3-b0b3-436b7965c92d\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:19579bde-904c-4869-bcc0-d577fca81c00\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:f0751b8b-ca71-400c-8ed4-8f17ff2e9b04\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:d36bda57-2f21-43c6-acf0-1028c0dfc419\",\"type\":\"menu_item\",\"weight\":\"0\"}],\"col_config\":[]}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:d36bda57-2f21-43c6-acf0-1028c0dfc419\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:e8b2b5e6-1fd0-4879-add1-d64f65071e52\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:8de4bf5b-4d62-49dc-a8f3-17312f378b96\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:63af3b84-3b40-4e78-ae2a-6a82bed21ce0\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:4cc45e07-f95f-43c4-911b-d611e55bffed\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:c2758267-44c1-47cc-ad2f-9ed26b5a7b66\",\"type\":\"menu_item\",\"weight\":\"0\"}],\"col_config\":[]}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:c2758267-44c1-47cc-ad2f-9ed26b5a7b66\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:6079aec3-9b0f-44ac-b956-f456e93598ef\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:7f9d4c9f-e68c-45e9-bba3-b8a7606a6e44\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:0c2acf13-be99-400e-a516-3eeb0250a939\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:d70e25d4-48f8-4d30-ad1b-140b19b8d86d\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:5fe360b7-8317-4fb0-82c7-c96816ce453c\",\"type\":\"menu_item\",\"weight\":\"0\"}],\"col_config\":[]}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:5fe360b7-8317-4fb0-82c7-c96816ce453c\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:0c806bda-6622-44ad-acd3-ea6039e259de\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:91cfd1c4-b40e-488c-9c60-8e7390a84b68\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:75001a20-1143-4b16-a9a0-52cb6cdb7a37\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:27fbc9d4-80f5-4766-aa51-033eb100c01e\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:63d22618-b4fe-4342-8655-821ad8640798\",\"type\":\"menu_item\",\"weight\":\"0\"}],\"col_config\":[]}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:63d22618-b4fe-4342-8655-821ad8640798\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:63c6495e-8c2e-45f4-b372-b542fc123fdb\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:dd84e93e-078f-45c7-a7e6-a0797fc4cb89\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:4326f5db-5e0d-44dc-9a52-5dc744ef772d\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:cbd74fb9-4e21-48a4-8255-cf16a114b84b\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:018d37e6-b392-4228-8943-7c3f433d837d\",\"type\":\"menu_item\",\"weight\":\"0\"}],\"col_config\":[]}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:018d37e6-b392-4228-8943-7c3f433d837d\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:314f69c9-6761-46c8-8f7f-eba5ba26b421\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:5cdb5b2b-389c-47b0-8140-19bcaee5eb6b\",\"type\":\"menu_item\",\"weight\":\"-50\"},{\"plugin_id\":\"views_view:views.blog_fullwidth.page_1\",\"type\":\"menu_item\",\"weight\":\"-49\",\"tb_item_config\":[]},{\"plugin_id\":\"views_view:views.blog_timeline.page_1\",\"type\":\"menu_item\",\"weight\":\"-49\"},{\"plugin_id\":\"menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c\",\"type\":\"menu_item\",\"weight\":\"-48\"},{\"plugin_id\":\"menu_link_content:ac9a45ab-a3e4-4771-9d12-016c19b8cd87\",\"type\":\"menu_item\",\"weight\":\"-47\"},{\"plugin_id\":\"menu_link_content:92dae41b-bd24-4890-b442-1c209567d7ff\",\"type\":\"menu_item\",\"weight\":\"-46\"}],\"col_config\":[]}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:5cdb5b2b-389c-47b0-8140-19bcaee5eb6b\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.blog_timeline.page_1\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"views_view:views.blog_grid.page_1\",\"type\":\"menu_item\",\"weight\":\"-50\"},{\"plugin_id\":\"views_view:views.blog_grid.page_2\",\"type\":\"menu_item\",\"weight\":\"-49\"},{\"plugin_id\":\"views_view:views.blog_grid.page_3\",\"type\":\"menu_item\",\"weight\":\"-48\"}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"views_view:views.blog_grid.page_1\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.blog_grid.page_2\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.blog_grid.page_3\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:ac9a45ab-a3e4-4771-9d12-016c19b8cd87\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"views_view:views.blog_masonry.page_1\",\"type\":\"menu_item\",\"weight\":\"-50\"},{\"plugin_id\":\"views_view:views.blog_masonry.page_2\",\"type\":\"menu_item\",\"weight\":\"-49\"},{\"plugin_id\":\"views_view:views.blog_masonry.page_3\",\"type\":\"menu_item\",\"weight\":\"-48\"}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"views_view:views.blog_masonry.page_1\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.blog_masonry.page_2\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.blog_masonry.page_3\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:92dae41b-bd24-4890-b442-1c209567d7ff\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:961ccfdb-fc32-416f-b479-33645b457808\",\"type\":\"menu_item\",\"weight\":\"-50\"}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"menu_link_content:961ccfdb-fc32-416f-b479-33645b457808\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"views_view:views.shop_columns.page\",\"type\":\"menu_item\",\"weight\":\"1\"},{\"plugin_id\":\"views_view:views.shop_columns.page_1\",\"type\":\"menu_item\",\"weight\":\"2\"},{\"plugin_id\":\"views_view:views.shop_columns.page_2\",\"type\":\"menu_item\",\"weight\":\"3\"},{\"plugin_id\":\"menu_link_content:37310cde-bf20-4b44-bf35-ad1befa88b75\",\"type\":\"menu_item\",\"weight\":\"4\"},{\"plugin_id\":\"menu_link_content:86a4b73a-822d-4a11-95f4-efdcb5e34973\",\"type\":\"menu_item\",\"weight\":\"5\"}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"views_view:views.shop_columns.page\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.shop_columns.page_1\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"views_view:views.shop_columns.page_2\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:37310cde-bf20-4b44-bf35-ad1befa88b75\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:86a4b73a-822d-4a11-95f4-efdcb5e34973\":{\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"},\"rows_content\":[]},\"menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2\":{\"rows_content\":[[{\"col_content\":[{\"plugin_id\":\"menu_link_content:65a0627d-7961-40e4-b2f1-93280c2f0a20\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:f9df1e47-273b-4684-81e4-da37304c140d\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:8795dfe3-3f26-42dc-b987-3e9353df3831\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"plugin_id\":\"menu_link_content:a046d288-c42b-45a6-b22d-c4e7e341e473\",\"type\":\"menu_item\",\"weight\":\"0\",\"tb_item_config\":[]},{\"type\":\"menu_item\",\"plugin_id\":\"menu_link_content:192ee9a4-4616-4135-9de9-ad3f469f1c22\",\"tb_item_config\":[],\"weight\":\"0\"}],\"col_config\":[]}]]}}\";}'),

('','text.settings','a:2:{s:22:\"default_summary_length\";i:600;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Bkewb77RBOK3_aXMPsp8p87gbc03NvmC5gBLzPl7hVA\";}}'),

('','tour.tour.language','a:10:{s:4:\"uuid\";s:36:\"ebe8cb21-99a1-476f-b953-7bab8dc67b55\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"language\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"LlLH_HQYhZxal4iB88sQSB45acF-8GJH0PJcvziEmqg\";}s:2:\"id\";s:8:\"language\";s:5:\"label\";s:8:\"Language\";s:6:\"module\";s:8:\"language\";s:6:\"routes\";a:1:{i:0;a:1:{s:10:\"route_name\";s:39:\"entity.configurable_language.collection\";}}s:4:\"tips\";a:6:{s:17:\"language-overview\";a:5:{s:2:\"id\";s:17:\"language-overview\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:9:\"Languages\";s:4:\"body\";s:96:\"<p>The \"Languages\" page allows you to add, edit, delete, and reorder languages for the site.</p>\";s:6:\"weight\";i:1;}s:12:\"language-add\";a:6:{s:2:\"id\";s:12:\"language-add\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:16:\"Adding languages\";s:4:\"body\";s:171:\"<p>To add more languages to your site, click the \"Add language\" button.</p><p>Added languages will be displayed in the language list and can then be edited or deleted.</p>\";s:6:\"weight\";i:2;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:13:\"button-action\";}}s:16:\"language-reorder\";a:6:{s:2:\"id\";s:16:\"language-reorder\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:20:\"Reordering languages\";s:4:\"body\";s:402:\"<p>To reorder the languages on your site, use the drag icons next to each language.</p><p>The order shown here is the display order for language lists on the site such as in the language switcher blocks provided by the Interface Translation and Content Translation modules.</p><p>When you are done with reordering the languages, click the \"Save configuration\" button for the changes to take effect.</p>\";s:6:\"weight\";i:3;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:9:\"draggable\";}}s:16:\"language-default\";a:6:{s:2:\"id\";s:16:\"language-default\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:25:\"Set a language as default\";s:4:\"body\";s:274:\"<p>You can change the default language of the site by choosing one of your configured languages as default. The site will use the default language in situations where no choice is made but a language should be set, for example as the language of the displayed interface.</p>\";s:6:\"weight\";i:4;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:34:\"js-form-item-site-default-language\";}}s:19:\"language-operations\";a:6:{s:2:\"id\";s:19:\"language-operations\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:19:\"Modifying languages\";s:4:\"body\";s:399:\"<p>Operations are provided for editing and deleting your languages.</p><p>You can edit the name and the direction of the language.</p><p>Deleted languages can be added back at a later time. Deleting a language will remove all interface translations associated with it, and content in this language will be set to be language neutral. Note that you cannot delete the default language of the site.</p>\";s:6:\"weight\";i:5;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:18:\"dropbutton-wrapper\";}}s:17:\"language-continue\";a:5:{s:2:\"id\";s:17:\"language-continue\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:13:\"Continuing on\";s:4:\"body\";s:261:\"<p>Now that you have an overview of the \"Languages\" page, you can continue by:<ul><li><a href=\"[site:url]/admin/config/regional/language/add\">Adding a language</a></li><li>Reordering languages</li><li>Editing a language</li><li>Deleting a language</li></ul></p>\";s:6:\"weight\";i:6;}}}'),

('','tour.tour.language-add','a:10:{s:4:\"uuid\";s:36:\"4d995cc0-5bac-47e1-a515-4bebfe9e5bbe\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"language\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AMWw3H7E7fuBLMW6LmsCJvYFYQiWwSCl0Fbwe0wiIrU\";}s:2:\"id\";s:12:\"language-add\";s:5:\"label\";s:16:\"Adding languages\";s:6:\"module\";s:8:\"language\";s:6:\"routes\";a:1:{i:0;a:1:{s:10:\"route_name\";s:12:\"language.add\";}}s:4:\"tips\";a:3:{s:21:\"language-add-overview\";a:5:{s:2:\"id\";s:21:\"language-add-overview\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:16:\"Adding languages\";s:4:\"body\";s:154:\"<p>This page provides the ability to add common languages to your site.</p><p>If the desired language is not available, you can add a custom language.</p>\";s:6:\"weight\";i:1;}s:19:\"language-add-choose\";a:6:{s:2:\"id\";s:19:\"language-add-choose\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:15:\"Select language\";s:4:\"body\";s:312:\"<p>Choose a language from the list, or choose \"Custom language...\" at the end of the list.</p><p>Click the \"Add language\" button when you are done choosing your language.</p><p>When adding a custom language, you will get an additional form where you can provide the name, code, and direction of the language.</p>\";s:6:\"weight\";i:2;s:10:\"attributes\";a:1:{s:7:\"data-id\";s:24:\"edit-predefined-langcode\";}}s:21:\"language-add-continue\";a:5:{s:2:\"id\";s:21:\"language-add-continue\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:13:\"Continuing on\";s:4:\"body\";s:250:\"<p>Now that you have an overview of the \"Add languages\" feature, you can continue by:<ul><li>Adding a language</li><li>Adding a custom language</li><li><a href=\"[site:url]/admin/config/regional/language\">Viewing configured languages</a></li></ul></p>\";s:6:\"weight\";i:3;}}}'),

('','tour.tour.language-edit','a:10:{s:4:\"uuid\";s:36:\"39a33bc5-3e2c-47ae-a811-6e898e7d6a06\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"language\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eYyOjXVghEin1Ed7t7vr9X0dSn018_zeZegu2Ao-j4Q\";}s:2:\"id\";s:13:\"language-edit\";s:5:\"label\";s:17:\"Editing languages\";s:6:\"module\";s:8:\"language\";s:6:\"routes\";a:1:{i:0;a:1:{s:10:\"route_name\";s:38:\"entity.configurable_language.edit_form\";}}s:4:\"tips\";a:5:{s:22:\"language-edit-overview\";a:5:{s:2:\"id\";s:22:\"language-edit-overview\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:17:\"Editing languages\";s:4:\"body\";s:98:\"<p>This page provides the ability to edit a language on your site, including custom languages.</p>\";s:6:\"weight\";i:1;}s:22:\"language-edit-langcode\";a:6:{s:2:\"id\";s:22:\"language-edit-langcode\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:13:\"Language code\";s:4:\"body\";s:122:\"<p>You cannot change the code of a language on the site, since it is used by the system to keep track of the language.</p>\";s:6:\"weight\";i:2;s:10:\"attributes\";a:1:{s:7:\"data-id\";s:18:\"edit-langcode-view\";}}s:19:\"language-edit-label\";a:6:{s:2:\"id\";s:19:\"language-edit-label\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:13:\"Language name\";s:4:\"body\";s:289:\"<p>The language name is used throughout the site for all users and is written in English. Names of built-in languages can be translated using the Interface Translation module, and names of both built-in and custom languages can be translated using the Configuration Translation module.</p>\";s:6:\"weight\";i:3;s:10:\"attributes\";a:1:{s:7:\"data-id\";s:10:\"edit-label\";}}s:23:\"language-edit-direction\";a:6:{s:2:\"id\";s:23:\"language-edit-direction\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:18:\"Language direction\";s:4:\"body\";s:196:\"<p>Choose if the language is a \"Left to right\" or \"Right to left\" language.</p><p>Note that not all themes support \"Right to left\" layouts, so test your theme if you are using \"Right to left\".</p>\";s:6:\"weight\";i:4;s:10:\"attributes\";a:1:{s:7:\"data-id\";s:36:\"edit-direction--wrapper--description\";}}s:22:\"language-edit-continue\";a:5:{s:2:\"id\";s:22:\"language-edit-continue\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:13:\"Continuing on\";s:4:\"body\";s:218:\"<p>Now that you have an overview of the \"Edit language\" feature, you can continue by:<ul><li>Editing a language</li><li><a href=\"[site:url]/admin/config/regional/language\">Viewing configured languages</a></li></ul></p>\";s:6:\"weight\";i:5;}}}'),

('','tour.tour.views-ui','a:10:{s:4:\"uuid\";s:36:\"db568695-facf-4d9b-9727-aa07d29bc6ce\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"views_ui\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"c-HMyZwgeP8H6AITDcq4hznePkd7azpe8xl_WTnx2O0\";}s:2:\"id\";s:8:\"views-ui\";s:5:\"label\";s:14:\"View edit page\";s:6:\"module\";s:8:\"views_ui\";s:6:\"routes\";a:2:{i:0;a:1:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";}i:1;a:1:{s:10:\"route_name\";s:29:\"entity.view.edit_display_form\";}}s:4:\"tips\";a:10:{s:10:\"views-main\";a:5:{s:2:\"id\";s:10:\"views-main\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:20:\"Manage view settings\";s:4:\"body\";s:31:\"View or edit the configuration.\";s:6:\"weight\";i:1;}s:17:\"views-ui-displays\";a:6:{s:2:\"id\";s:17:\"views-ui-displays\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:21:\"Displays in this view\";s:4:\"body\";s:169:\"A display is a way of outputting the results, e.g., as a page or a block. A view can contain multiple displays, which are listed here. The active display is highlighted.\";s:6:\"weight\";i:2;s:10:\"attributes\";a:1:{s:7:\"data-id\";s:17:\"views-display-top\";}}s:19:\"views-ui-view-admin\";a:7:{s:2:\"id\";s:19:\"views-ui-view-admin\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:19:\"View administration\";s:4:\"body\";s:140:\"Perform administrative tasks, including adding a description and creating a clone. Click the drop-down button to view the available options.\";s:6:\"weight\";i:3;s:8:\"location\";s:4:\"left\";s:10:\"attributes\";a:1:{s:7:\"data-id\";s:27:\"views-display-extra-actions\";}}s:15:\"views-ui-format\";a:6:{s:2:\"id\";s:15:\"views-ui-format\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:13:\"Output format\";s:4:\"body\";s:325:\"Choose how to output results. E.g., choose <em>Content</em> to output each item completely, using your configured display settings. Or choose <em>Fields</em>, which allows you to output only specific fields for each result. Additional formats can be added by installing modules to <em>extend</em> Drupal\'s base functionality.\";s:6:\"weight\";i:4;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:34:\"views-ui-display-tab-bucket.format\";}}s:15:\"views-ui-fields\";a:6:{s:2:\"id\";s:15:\"views-ui-fields\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:6:\"Fields\";s:4:\"body\";s:89:\"If this view uses fields, they are listed here. You can click on a field to configure it.\";s:6:\"weight\";i:5;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:33:\"views-ui-display-tab-bucket.field\";}}s:15:\"views-ui-filter\";a:6:{s:2:\"id\";s:15:\"views-ui-filter\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:16:\"Filter your view\";s:4:\"body\";s:173:\"Add filters to limit the results in the output. E.g., to only show content that is <em>published</em>, you would add a filter for <em>Published</em> and select <em>Yes</em>.\";s:6:\"weight\";i:6;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:34:\"views-ui-display-tab-bucket.filter\";}}s:26:\"views-ui-filter-operations\";a:6:{s:2:\"id\";s:26:\"views-ui-filter-operations\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:14:\"Filter actions\";s:4:\"body\";s:33:\"Add, rearrange or remove filters.\";s:6:\"weight\";i:7;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:53:\"views-ui-display-tab-bucket.filter .dropbutton-widget\";}}s:14:\"views-ui-sorts\";a:6:{s:2:\"id\";s:14:\"views-ui-sorts\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:13:\"Sort Criteria\";s:4:\"body\";s:96:\"Control the order in which the results are output. Click on an active sort rule to configure it.\";s:6:\"weight\";i:8;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:32:\"views-ui-display-tab-bucket.sort\";}}s:25:\"views-ui-sorts-operations\";a:6:{s:2:\"id\";s:25:\"views-ui-sorts-operations\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:12:\"Sort actions\";s:4:\"body\";s:39:\"Add, rearrange or remove sorting rules.\";s:6:\"weight\";i:9;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:51:\"views-ui-display-tab-bucket.sort .dropbutton-widget\";}}s:16:\"views-ui-preview\";a:7:{s:2:\"id\";s:16:\"views-ui-preview\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:7:\"Preview\";s:4:\"body\";s:34:\"Show a preview of the view output.\";s:6:\"weight\";i:10;s:8:\"location\";s:4:\"left\";s:10:\"attributes\";a:1:{s:7:\"data-id\";s:14:\"preview-submit\";}}}}'),

('','update.settings','a:4:{s:5:\"check\";a:2:{s:19:\"disabled_extensions\";b:0;s:13:\"interval_days\";i:1;}s:5:\"fetch\";a:3:{s:3:\"url\";s:0:\"\";s:12:\"max_attempts\";i:2;s:7:\"timeout\";i:30;}s:12:\"notification\";a:2:{s:6:\"emails\";a:0:{}s:9:\"threshold\";s:3:\"all\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"2QzULf0zovJQx3J06Y9rufzzfi-CY2CTTlEfJJh2Qyw\";}}'),

('','user.flood','a:6:{s:8:\"uid_only\";b:0;s:8:\"ip_limit\";i:50;s:9:\"ip_window\";i:3600;s:10:\"user_limit\";i:5;s:11:\"user_window\";i:21600;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"UYfMzeP1S8jKm9PSvxf7nQNe8DsNS-3bc2WSNNXBQWs\";}}'),

('','user.mail','a:11:{s:14:\"cancel_confirm\";a:2:{s:4:\"body\";s:377:\"[user:display-name],\n\nA request to cancel your account has been made at [site:name].\n\nYou may now cancel your account on [site:url-brief] by clicking this link or copying and pasting it into your browser:\n\n[user:cancel-url]\n\nNOTE: The cancellation of your account is not reversible.\n\nThis link expires in one day and nothing will happen if it is not used.\n\n--  [site:name] team\";s:7:\"subject\";s:67:\"Account cancellation request for [user:display-name] at [site:name]\";}s:14:\"password_reset\";a:2:{s:4:\"body\";s:407:\"[user:display-name],\n\nA request to reset the password for your account has been made at [site:name].\n\nYou may now log in by clicking this link or copying and pasting it into your browser:\n\n[user:one-time-login-url]\n\nThis link can only be used once to log in and will lead you to a page where you can set your password. It expires after one day and nothing will happen if it\'s not used.\n\n--  [site:name] team\";s:7:\"subject\";s:68:\"Replacement login information for [user:display-name] at [site:name]\";}s:22:\"register_admin_created\";a:2:{s:4:\"body\";s:473:\"[user:display-name],\n\nA site administrator at [site:name] has created an account for you. You may now log in by clicking this link or copying and pasting it into your browser:\n\n[user:one-time-login-url]\n\nThis link can only be used once to log in and will lead you to a page where you can set your password.\n\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\n\nusername: [user:name]\npassword: Your password\n\n--  [site:name] team\";s:7:\"subject\";s:58:\"An administrator created an account for you at [site:name]\";}s:29:\"register_no_approval_required\";a:2:{s:4:\"body\";s:447:\"[user:display-name],\n\nThank you for registering at [site:name]. You may now log in by clicking this link or copying and pasting it into your browser:\n\n[user:one-time-login-url]\n\nThis link can only be used once to log in and will lead you to a page where you can set your password.\n\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\n\nusername: [user:name]\npassword: Your password\n\n--  [site:name] team\";s:7:\"subject\";s:54:\"Account details for [user:display-name] at [site:name]\";}s:25:\"register_pending_approval\";a:2:{s:4:\"body\";s:289:\"[user:display-name],\n\nThank you for registering at [site:name]. Your application for an account is currently pending approval. Once it has been approved, you will receive another email containing information about how to log in, set your password, and other details.\n\n\n--  [site:name] team\";s:7:\"subject\";s:79:\"Account details for [user:display-name] at [site:name] (pending admin approval)\";}s:31:\"register_pending_approval_admin\";a:2:{s:4:\"body\";s:64:\"[user:display-name] has applied for an account.\n\n[user:edit-url]\";s:7:\"subject\";s:79:\"Account details for [user:display-name] at [site:name] (pending admin approval)\";}s:16:\"status_activated\";a:2:{s:4:\"body\";s:462:\"[user:display-name],\n\nYour account at [site:name] has been activated.\n\nYou may now log in by clicking this link or copying and pasting it into your browser:\n\n[user:one-time-login-url]\n\nThis link can only be used once to log in and will lead you to a page where you can set your password.\n\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\n\nusername: [user:account-name]\npassword: Your password\n\n--  [site:name] team\";s:7:\"subject\";s:65:\"Account details for [user:display-name] at [site:name] (approved)\";}s:14:\"status_blocked\";a:2:{s:4:\"body\";s:89:\"[user:display-name],\n\nYour account on [site:name] has been blocked.\n\n--  [site:name] team\";s:7:\"subject\";s:64:\"Account details for [user:display-name] at [site:name] (blocked)\";}s:15:\"status_canceled\";a:2:{s:4:\"body\";s:90:\"[user:display-name],\n\nYour account on [site:name] has been canceled.\n\n--  [site:name] team\";s:7:\"subject\";s:65:\"Account details for [user:display-name] at [site:name] (canceled)\";}s:8:\"langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"m4J3ROov32OEquRYGLbx3SpdDGuqx9l_zJtNvihqdCg\";}}'),

('','user.role.administrator','a:10:{s:4:\"uuid\";s:36:\"53fee539-54b1-4d05-b5a6-c0f9eb31b3b4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Om6FEO7vZZMkPIbVvfxtdkWerQ2PvQM4sWUd6Q3ZnfI\";}s:2:\"id\";s:13:\"administrator\";s:5:\"label\";s:13:\"Administrator\";s:6:\"weight\";i:2;s:8:\"is_admin\";b:1;s:11:\"permissions\";a:0:{}}'),

('','user.role.anonymous','a:10:{s:4:\"uuid\";s:36:\"c5095308-5ab5-4c02-827a-71a4ba8671ef\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"j5zLMOdJBqC0bMvSdth5UebkprJB8g_2FXHqhfpJzow\";}s:2:\"id\";s:9:\"anonymous\";s:5:\"label\";s:14:\"Anonymous user\";s:6:\"weight\";i:0;s:8:\"is_admin\";b:0;s:11:\"permissions\";a:12:{i:0;s:11:\"access cart\";i:1;s:15:\"access checkout\";i:2;s:15:\"access comments\";i:3;s:32:\"access commerce_product overview\";i:4;s:42:\"access commerce_product_attribute overview\";i:5;s:14:\"access content\";i:6;s:29:\"access site-wide contact form\";i:7;s:13:\"post comments\";i:8;s:14:\"search content\";i:9;s:31:\"use text format restricted_html\";i:10;s:21:\"view commerce_product\";i:11;s:31:\"view commerce_product_attribute\";}}'),

('','user.role.authenticated','a:10:{s:4:\"uuid\";s:36:\"07405ee8-61ac-47d6-8381-9259ebd611a2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dJ0L2DNSj5q6XVZAGsuVDpJTh5UeYkIPwKrUOOpr8YI\";}s:2:\"id\";s:13:\"authenticated\";s:5:\"label\";s:18:\"Authenticated user\";s:6:\"weight\";i:1;s:8:\"is_admin\";b:0;s:11:\"permissions\";a:12:{i:0;s:11:\"access cart\";i:1;s:15:\"access checkout\";i:2;s:15:\"access comments\";i:3;s:14:\"access content\";i:4;s:16:\"access shortcuts\";i:5;s:29:\"access site-wide contact form\";i:6;s:13:\"post comments\";i:7;s:14:\"search content\";i:8;s:21:\"skip comment approval\";i:9;s:26:\"use text format basic_html\";i:10;s:21:\"view commerce_product\";i:11;s:31:\"view commerce_product_attribute\";}}'),

('','user.settings','a:9:{s:9:\"anonymous\";s:9:\"Anonymous\";s:11:\"verify_mail\";b:1;s:6:\"notify\";a:8:{s:14:\"cancel_confirm\";b:1;s:14:\"password_reset\";b:1;s:16:\"status_activated\";b:1;s:14:\"status_blocked\";b:0;s:15:\"status_canceled\";b:0;s:22:\"register_admin_created\";b:1;s:29:\"register_no_approval_required\";b:1;s:25:\"register_pending_approval\";b:1;}s:8:\"register\";s:23:\"visitors_admin_approval\";s:13:\"cancel_method\";s:17:\"user_cancel_block\";s:22:\"password_reset_timeout\";i:86400;s:17:\"password_strength\";b:1;s:8:\"langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"r4kwhOM0IWXVMUZDz744Yc16EOh37ZhYbA8kGOhSmLk\";}}'),

('','views.settings','a:6:{s:17:\"display_extenders\";a:0:{}s:10:\"skip_cache\";b:0;s:13:\"sql_signature\";b:0;s:2:\"ui\";a:3:{s:4:\"show\";a:7:{s:18:\"additional_queries\";b:0;s:15:\"advanced_column\";b:0;s:14:\"master_display\";b:0;s:22:\"performance_statistics\";b:0;s:19:\"preview_information\";b:1;s:9:\"sql_query\";a:2:{s:7:\"enabled\";b:0;s:5:\"where\";s:5:\"above\";}s:13:\"display_embed\";b:0;}s:19:\"always_live_preview\";b:1;s:24:\"exposed_filter_any_label\";s:7:\"old_any\";}s:22:\"field_rewrite_elements\";a:29:{s:3:\"div\";s:3:\"DIV\";s:4:\"span\";s:4:\"SPAN\";s:2:\"h1\";s:2:\"H1\";s:2:\"h2\";s:2:\"H2\";s:2:\"h3\";s:2:\"H3\";s:2:\"h4\";s:2:\"H4\";s:2:\"h5\";s:2:\"H5\";s:2:\"h6\";s:2:\"H6\";s:1:\"p\";s:1:\"P\";s:6:\"header\";s:6:\"HEADER\";s:6:\"footer\";s:6:\"FOOTER\";s:7:\"article\";s:7:\"ARTICLE\";s:7:\"section\";s:7:\"SECTION\";s:5:\"aside\";s:5:\"ASIDE\";s:7:\"details\";s:7:\"DETAILS\";s:10:\"blockquote\";s:10:\"BLOCKQUOTE\";s:6:\"figure\";s:6:\"FIGURE\";s:7:\"address\";s:7:\"ADDRESS\";s:4:\"code\";s:4:\"CODE\";s:3:\"pre\";s:3:\"PRE\";s:3:\"var\";s:3:\"VAR\";s:4:\"samp\";s:4:\"SAMP\";s:3:\"kbd\";s:3:\"KBD\";s:6:\"strong\";s:6:\"STRONG\";s:2:\"em\";s:2:\"EM\";s:3:\"del\";s:3:\"DEL\";s:3:\"ins\";s:3:\"INS\";s:1:\"q\";s:1:\"Q\";s:1:\"s\";s:1:\"S\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"RaRd9EIcwA4u3qCSRLL8EnCicbda1kV__ASmVbyehvQ\";}}'),

('','views.view.archive','a:14:{s:4:\"uuid\";s:36:\"e856eb05-317c-46a5-bb8b-1a5eaacb07d3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:33:\"core.entity_view_mode.node.teaser\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SRH1EhxAiIRj01P9xYv0h_LfIfWxjll0Yq-eDfjziFI\";}s:2:\"id\";s:7:\"archive\";s:5:\"label\";s:7:\"Archive\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:22:\"All content, by month.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:1:\"8\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:5:\"title\";s:15:\"Monthly archive\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";}}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:13:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:12:\"title_enable\";b:1;s:5:\"title\";s:34:\"{{ arguments.created_year_month }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:10:\"sort_order\";s:4:\"desc\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:2:{s:8:\"override\";b:1;s:14:\"items_per_page\";i:30;}s:18:\"specify_validation\";b:1;s:9:\"plugin_id\";s:15:\"date_year_month\";s:11:\"entity_type\";s:4:\"node\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";s:1:\"0\";}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:13:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:12:\"title_enable\";b:1;s:5:\"title\";s:34:\"{{ arguments.created_year_month }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";i:30;}s:18:\"specify_validation\";b:1;s:9:\"plugin_id\";s:15:\"date_year_month\";s:11:\"entity_type\";s:4:\"node\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:2;s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:7:\"archive\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.block_content','a:14:{s:4:\"uuid\";s:36:\"7a5b2ffd-c7bd-451f-a21c-a4f4bc3bef22\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"msYnighLW1IbiBfyQbwbQwb2cU-5LECiFryt60k0Nfk\";}s:2:\"id\";s:13:\"block_content\";s:5:\"label\";s:20:\"Custom block library\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:30:\"Find and manage custom blocks.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:24:\"block_content_field_data\";s:10:\"base_field\";s:2:\"id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:17:\"administer blocks\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:4:\"info\";s:4:\"info\";s:4:\"type\";s:4:\"type\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:4:{s:4:\"info\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:4:{s:4:\"info\";a:37:{s:2:\"id\";s:4:\"info\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"info\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:17:\"Block description\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:4:\"info\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Block type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:7:\"changed\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:13:\"block_content\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:13:\"block_content\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:3:{s:4:\"info\";a:16:{s:2:\"id\";s:4:\"info\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"info\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"info_op\";s:5:\"label\";s:17:\"Block description\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"info_op\";s:10:\"identifier\";s:4:\"info\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"info\";s:9:\"plugin_id\";s:6:\"string\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:10:\"Block type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}s:8:\"reusable\";a:16:{s:2:\"id\";s:8:\"reusable\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:8:\"reusable\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:9:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:8:\"reusable\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:20:\"Custom block library\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:2:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:38:\"There are no custom blocks available. \";s:9:\"plugin_id\";s:11:\"text_custom\";}s:27:\"block_content_listing_empty\";a:10:{s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"field\";s:27:\"block_content_listing_empty\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:27:\"block_content_listing_empty\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:13:\"block_content\";s:9:\"plugin_id\";s:27:\"block_content_listing_empty\";s:11:\"entity_type\";s:13:\"block_content\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:35:\"admin/structure/block/block-content\";s:4:\"menu\";a:7:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:20:\"Custom block library\";s:11:\"description\";s:0:\"\";s:6:\"parent\";s:19:\"block.admin_display\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.blog_fullwidth','a:13:{s:4:\"uuid\";s:36:\"07403f95-c487-46e5-8d4c-b7796fc6004d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:17:\"node.type.nd_blog\";i:2;s:16:\"system.menu.main\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:2:\"id\";s:14:\"blog_fullwidth\";s:5:\"label\";s:14:\"Blog Fullwidth\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:3:{s:9:\"row_class\";s:14:\"fullwidth-date\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"fields\";a:1:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:7:\"nd_blog\";s:7:\"nd_blog\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:14:\"Blog Fullwidth\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:14:\"blog-fullwidth\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:14:\"Blog Fullwidth\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc\";s:6:\"weight\";i:-49;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.blog_grid','a:13:{s:4:\"uuid\";s:36:\"ebb88ffd-00eb-45b3-8db2-ab495be93b19\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:5:{i:0;s:23:\"field.storage.node.body\";i:1;s:31:\"field.storage.node.field_images\";i:2;s:25:\"image.style.blog_360x195_\";i:3;s:17:\"node.type.nd_blog\";i:4;s:16:\"system.menu.main\";}s:6:\"module\";a:4:{i:0;s:5:\"image\";i:1;s:4:\"node\";i:2;s:4:\"text\";i:3;s:4:\"user\";}}s:2:\"id\";s:9:\"blog_grid\";s:5:\"label\";s:9:\"Blog Grid\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:9:\"blog_grid\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:5:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:1;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:2;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:14:\"mb-60 mb-xs-40\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:6:\"fields\";a:6:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"created\";a:37:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:3:\"d F\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"body\";a:35:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:10:\"node__body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:160;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:1;s:4:\"trim\";b:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:13:\"blog_360x195_\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:9:\"view_node\";a:26:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:30:\"btn btn-mod btn-gray btn-round\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"text\";s:9:\"Read More\";s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:0;s:8:\"absolute\";b:0;}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:7:\"nd_blog\";s:7:\"nd_blog\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:9:\"Blog Grid\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:9:\"2 Columns\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:14:\"blog-2-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c\";s:6:\"weight\";i:-50;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";}}}s:6:\"page_2\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:9:\"3 Columns\";s:8:\"position\";i:1;s:15:\"display_options\";a:7:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:14:\"blog-3-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c\";s:6:\"weight\";i:-49;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:3;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:14:\"mb-60 mb-xs-40\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:0:\"\";}}s:8:\"defaults\";a:2:{s:5:\"style\";b:0;s:3:\"row\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";}}}s:6:\"page_3\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_3\";s:13:\"display_title\";s:9:\"4 Columns\";s:8:\"position\";i:1;s:15:\"display_options\";a:7:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:14:\"blog-4-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c\";s:6:\"weight\";i:-48;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:4;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:14:\"mb-60 mb-xs-40\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:0:\"\";}}s:8:\"defaults\";a:2:{s:5:\"style\";b:0;s:3:\"row\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";}}}s:6:\"page_4\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_4\";s:13:\"display_title\";s:7:\"3 items\";s:8:\"position\";i:1;s:15:\"display_options\";a:11:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:12:\"blog-3-items\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c\";s:6:\"weight\";i:-49;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:3;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:0:\"\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:0:\"\";}}s:8:\"defaults\";a:6:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:5:\"title\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:3;s:6:\"offset\";i:0;}}s:5:\"title\";s:7:\"3 Items\";s:7:\"filters\";a:3:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:7:\"nd_blog\";s:7:\"nd_blog\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}s:22:\"field_images_target_id\";a:14:{s:2:\"id\";s:22:\"field_images_target_id\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:22:\"field_images_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:9:\"not empty\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:0:\"\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:13:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:11:\"placeholder\";s:0:\"\";s:15:\"min_placeholder\";s:0:\"\";s:15:\"max_placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"numeric\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";}}}}}'),

('','views.view.blog_masonry','a:13:{s:4:\"uuid\";s:36:\"847793f2-bb41-45bc-b3a4-0d2c2c1b0971\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:5:{i:0;s:23:\"field.storage.node.body\";i:1;s:31:\"field.storage.node.field_images\";i:2;s:25:\"image.style.blog_360x195_\";i:3;s:17:\"node.type.nd_blog\";i:4;s:16:\"system.menu.main\";}s:6:\"module\";a:4:{i:0;s:5:\"image\";i:1;s:4:\"node\";i:2;s:4:\"text\";i:3;s:4:\"user\";}}s:2:\"id\";s:12:\"blog_masonry\";s:5:\"label\";s:12:\"Blog Masonry\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:22:\"blog_grid, masonry_row\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:4:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:2;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:14:\"mb-60 mb-xs-40\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:7:\"masonry\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:6:\"fields\";a:6:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"created\";a:37:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:3:\"d F\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"body\";a:35:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:10:\"node__body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:180;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:1;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:13:\"blog_360x195_\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:9:\"view_node\";a:26:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:30:\"btn btn-mod btn-gray btn-round\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"text\";s:9:\"Read More\";s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:0;s:8:\"absolute\";b:0;}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:7:\"nd_blog\";s:7:\"nd_blog\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:9:\"Blog Grid\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:9:\"2 Columns\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:22:\"blog-masonry-2-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:ac9a45ab-a3e4-4771-9d12-016c19b8cd87\";s:6:\"weight\";i:-50;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";}}}s:6:\"page_2\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:9:\"3 Columns\";s:8:\"position\";i:1;s:15:\"display_options\";a:7:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:22:\"blog-masonry-3-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:ac9a45ab-a3e4-4771-9d12-016c19b8cd87\";s:6:\"weight\";i:-49;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:3;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:14:\"mb-60 mb-xs-40\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:7:\"masonry\";}}s:8:\"defaults\";a:2:{s:5:\"style\";b:0;s:3:\"row\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";}}}s:6:\"page_3\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_3\";s:13:\"display_title\";s:9:\"4 Columns\";s:8:\"position\";i:1;s:15:\"display_options\";a:7:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:22:\"blog-masonry-4-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:ac9a45ab-a3e4-4771-9d12-016c19b8cd87\";s:6:\"weight\";i:-48;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:4;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:14:\"mb-60 mb-xs-40\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:7:\"masonry\";}}s:8:\"defaults\";a:2:{s:5:\"style\";b:0;s:3:\"row\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";}}}}}'),

('','views.view.blog_timeline','a:13:{s:4:\"uuid\";s:36:\"566d95df-8225-40f6-b0af-2dc859cb58ac\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:17:\"node.type.nd_blog\";i:2;s:16:\"system.menu.main\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:2:\"id\";s:13:\"blog_timeline\";s:5:\"label\";s:13:\"Blog TimeLine\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:9:\"row_class\";s:14:\"fullwidth-date\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:8:\"timeline\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"fields\";a:1:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:7:\"nd_blog\";s:7:\"nd_blog\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:14:\"Blog Fullwidth\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:13:\"blog-timeline\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:13:\"Blog TimeLine\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc\";s:6:\"weight\";i:-49;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.comment','a:13:{s:4:\"uuid\";s:36:\"ddd65c6d-2ee3-4081-92d2-8c1979abed2f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"user\";}}s:2:\"id\";s:7:\"comment\";s:5:\"label\";s:8:\"Comments\";s:6:\"module\";s:7:\"comment\";s:11:\"description\";s:25:\"Find and manage comments.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:18:\"comment_field_data\";s:10:\"base_field\";s:3:\"cid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:26:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:19:\"administer comments\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:5:\"first\";s:8:\"« first\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:6:{s:17:\"comment_bulk_form\";s:17:\"comment_bulk_form\";s:7:\"subject\";s:7:\"subject\";s:3:\"uid\";s:3:\"uid\";s:9:\"entity_id\";s:9:\"entity_id\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:6:{s:17:\"comment_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"subject\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:3:\"uid\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"entity_id\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:17:\"comment_bulk_form\";a:26:{s:2:\"id\";s:17:\"comment_bulk_form\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:17:\"comment_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"include\";s:16:\"selected_actions\";a:2:{i:0;s:21:\"comment_delete_action\";i:1;s:24:\"comment_unpublish_action\";}s:9:\"plugin_id\";s:17:\"comment_bulk_form\";s:11:\"entity_type\";s:7:\"comment\";}s:7:\"subject\";a:37:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Subject\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:17:\"comment_permalink\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:9:\"{{ uid }}\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:16:\"comment_username\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"entity_id\";a:37:{s:2:\"id\";s:9:\"entity_id\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:9:\"entity_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Posted in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:9:\"entity_id\";s:9:\"plugin_id\";s:16:\"commented_entity\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:6:\"name_1\";a:37:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:4:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"subject\";a:16:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:10:\"subject_op\";s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"subject_op\";s:10:\"identifier\";s:7:\"subject\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:6:\"string\";}s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:11:\"Author name\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:11:\"author_name\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:6:\"name_1\";s:6:\"name_1\";}s:9:\"plugin_id\";s:7:\"combine\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:5:\"sorts\";a:1:{s:7:\"changed\";a:13:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:4:\"date\";}}s:5:\"title\";s:8:\"Comments\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:22:\"No comments available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"group_by\";b:0;s:9:\"css_class\";s:0:\"\";s:13:\"relationships\";a:1:{s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:14:\"page_published\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:14:\"page_published\";s:13:\"display_title\";s:18:\"Published comments\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:4:\"path\";s:21:\"admin/content/comment\";s:4:\"menu\";a:7:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:8:\"Comments\";s:11:\"description\";s:18:\"Comments published\";s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}s:19:\"display_description\";s:30:\"The approved comments listing.\";s:17:\"display_extenders\";a:0:{}s:13:\"exposed_block\";b:0;s:15:\"display_comment\";s:0:\"\";}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:15:\"page_unapproved\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:15:\"page_unapproved\";s:13:\"display_title\";s:19:\"Unapproved comments\";s:8:\"position\";i:2;s:15:\"display_options\";a:8:{s:4:\"path\";s:30:\"admin/content/comment/approval\";s:4:\"menu\";a:7:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:19:\"Unapproved comments\";s:11:\"description\";s:19:\"Comments unapproved\";s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:1;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}s:19:\"display_description\";s:32:\"The unapproved comments listing.\";s:7:\"filters\";a:4:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"subject\";a:16:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:10:\"subject_op\";s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"subject_op\";s:10:\"identifier\";s:7:\"subject\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:6:\"string\";}s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:11:\"Author Name\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:11:\"author_name\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:6:\"name_1\";s:6:\"name_1\";}s:9:\"plugin_id\";s:7:\"combine\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:8:\"defaults\";a:3:{s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;}s:17:\"display_extenders\";a:0:{}s:6:\"fields\";a:8:{s:17:\"comment_bulk_form\";a:26:{s:2:\"id\";s:17:\"comment_bulk_form\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:17:\"comment_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"include\";s:16:\"selected_actions\";a:2:{i:0;s:21:\"comment_delete_action\";i:1;s:22:\"comment_publish_action\";}s:9:\"plugin_id\";s:17:\"comment_bulk_form\";s:11:\"entity_type\";s:7:\"comment\";}s:7:\"subject\";a:37:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Subject\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:17:\"comment_permalink\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:9:\"{{ uid }}\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:16:\"comment_username\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"entity_id\";a:37:{s:2:\"id\";s:9:\"entity_id\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:9:\"entity_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Posted in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:9:\"entity_id\";s:9:\"plugin_id\";s:16:\"commented_entity\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:6:\"name_1\";a:37:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.comments_recent','a:14:{s:4:\"uuid\";s:36:\"2f569fe6-72a5-4eaf-bc8a-a39662c300b4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:7:\"comment\";i:1;s:4:\"node\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"HDMjKTBWeuHvsV6i6VvULmfhiSjNzIH1hCoy5GuZD0E\";}s:2:\"id\";s:15:\"comments_recent\";s:5:\"label\";s:15:\"Recent comments\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:16:\"Recent comments.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:18:\"comment_field_data\";s:10:\"base_field\";s:3:\"cid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:14:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:15:\"access comments\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:3:\"tag\";}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:2:{s:7:\"subject\";s:7:\"subject\";s:7:\"changed\";s:7:\"changed\";}s:9:\"separator\";s:1:\" \";s:10:\"hide_empty\";b:0;}}s:13:\"relationships\";a:1:{s:4:\"node\";a:5:{s:5:\"field\";s:4:\"node\";s:2:\"id\";s:4:\"node\";s:5:\"table\";s:18:\"comment_field_data\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"fields\";a:2:{s:7:\"subject\";a:26:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:9:\"plugin_id\";s:5:\"field\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:15:\"@interval hence\";s:11:\"past_format\";s:13:\"@interval ago\";s:11:\"granularity\";i:2;}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";}s:11:\"status_node\";a:10:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"node\";s:2:\"id\";s:11:\"status_node\";s:9:\"plugin_id\";s:7:\"boolean\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}}s:5:\"sorts\";a:2:{s:7:\"created\";a:12:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"created\";}s:3:\"cid\";a:11:{s:2:\"id\";s:3:\"cid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"cid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"cid\";}}s:5:\"title\";s:15:\"Recent comments\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:11:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:22:\"No comments available.\";s:8:\"tokenize\";b:0;s:9:\"plugin_id\";s:11:\"text_custom\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"block_description\";s:15:\"Recent comments\";s:14:\"block_category\";s:13:\"Lists (Views)\";s:5:\"allow\";a:1:{s:14:\"items_per_page\";b:1;}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.commerce_activity','a:14:{s:4:\"uuid\";s:36:\"2ac02287-1878-470e-ae63-cc96238f1359\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:12:\"commerce_log\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-RZu5UoVfuliWCTIlTW8oVsjPzRmrEDZG0fBU5aDM6c\";}s:2:\"id\";s:17:\"commerce_activity\";s:5:\"label\";s:8:\"Activity\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:12:\"commerce_log\";s:10:\"base_field\";s:6:\"log_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:3:{s:7:\"created\";s:7:\"created\";s:15:\"rendered_entity\";s:15:\"rendered_entity\";s:3:\"uid\";s:3:\"uid\";}s:4:\"info\";a:3:{s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:15:\"rendered_entity\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:3:\"uid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:3:{s:7:\"created\";a:37:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:12:\"commerce_log\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:12:\"commerce_log\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:5:\"field\";}s:15:\"rendered_entity\";a:25:{s:2:\"id\";s:15:\"rendered_entity\";s:5:\"table\";s:12:\"commerce_log\";s:5:\"field\";s:15:\"rendered_entity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Message\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"view_mode\";s:7:\"default\";s:11:\"entity_type\";N;s:12:\"entity_field\";N;s:9:\"plugin_id\";s:15:\"rendered_entity\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:12:\"commerce_log\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"User\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:6:\"author\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:12:\"commerce_log\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:0:{}s:5:\"sorts\";a:1:{s:6:\"log_id\";a:12:{s:2:\"id\";s:6:\"log_id\";s:5:\"table\";s:12:\"commerce_log\";s:5:\"field\";s:6:\"log_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"entity_type\";s:12:\"commerce_log\";s:12:\"entity_field\";s:6:\"log_id\";s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"title\";s:10:\"Order logs\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:15:\"No log entries.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:2:{s:16:\"source_entity_id\";a:23:{s:2:\"id\";s:16:\"source_entity_id\";s:5:\"table\";s:12:\"commerce_log\";s:5:\"field\";s:16:\"source_entity_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:5:\"empty\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:12:\"commerce_log\";s:12:\"entity_field\";s:16:\"source_entity_id\";s:9:\"plugin_id\";s:7:\"numeric\";}s:18:\"source_entity_type\";a:27:{s:2:\"id\";s:18:\"source_entity_type\";s:5:\"table\";s:12:\"commerce_log\";s:5:\"field\";s:18:\"source_entity_type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:8:\"glossary\";b:0;s:5:\"limit\";i:0;s:4:\"case\";s:4:\"none\";s:9:\"path_case\";s:4:\"none\";s:14:\"transform_dash\";b:0;s:12:\"break_phrase\";b:0;s:11:\"entity_type\";s:12:\"commerce_log\";s:12:\"entity_field\";s:18:\"source_entity_type\";s:9:\"plugin_id\";s:6:\"string\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";}s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.commerce_carts','a:14:{s:4:\"uuid\";s:36:\"2c70c091-a613-4853-ae7b-945a8bf814d8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:13:\"commerce_cart\";}}s:6:\"module\";a:5:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_price\";i:3;s:14:\"commerce_store\";i:4;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"bGAM41fAo6XN1BYIWEsfcsAVEvOIRQlCQzZXRnOz9Ic\";}s:2:\"id\";s:14:\"commerce_carts\";s:5:\"label\";s:5:\"Carts\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:8:\"Commerce\";s:10:\"base_table\";s:14:\"commerce_order\";s:10:\"base_field\";s:8:\"order_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:30:\"access commerce_order overview\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:5:\"first\";s:8:\"« first\";s:4:\"last\";s:7:\"last »\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:7:{s:4:\"type\";s:4:\"type\";s:8:\"store_id\";s:8:\"store_id\";s:3:\"uid\";s:3:\"uid\";s:4:\"mail\";s:3:\"uid\";s:19:\"total_price__number\";s:19:\"total_price__number\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:7:{s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:1;s:10:\"responsive\";s:15:\"priority-medium\";}s:8:\"store_id\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:1;s:10:\"responsive\";s:15:\"priority-medium\";}s:3:\"uid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:6:\"<br />\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"mail\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:19:\"total_price__number\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:1;s:10:\"responsive\";s:0:\"\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:24:\"commerce_order_bulk_form\";a:26:{s:2:\"id\";s:24:\"commerce_order_bulk_form\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:24:\"commerce_order_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:14:\"With selection\";s:15:\"include_exclude\";s:7:\"exclude\";s:16:\"selected_actions\";a:0:{}s:11:\"entity_type\";s:14:\"commerce_order\";s:9:\"plugin_id\";s:9:\"bulk_form\";}s:4:\"type\";a:38:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:18:\"hide_single_bundle\";b:1;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}s:8:\"store_id\";a:38:{s:2:\"id\";s:8:\"store_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"store_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Store\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:17:\"hide_single_store\";b:1;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:8:\"store_id\";s:9:\"plugin_id\";s:14:\"commerce_store\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Customer\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"mail\";a:37:{s:2:\"id\";s:4:\"mail\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:4:\"mail\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Email\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"basic_string\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:4:\"mail\";s:9:\"plugin_id\";s:5:\"field\";}s:19:\"total_price__number\";a:37:{s:2:\"id\";s:19:\"total_price__number\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:19:\"total_price__number\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Total\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:11:\"total_price\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:1:{s:11:\"granularity\";i:2;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:14:\"commerce_order\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:2:{s:4:\"cart\";a:16:{s:2:\"id\";s:4:\"cart\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:4:\"cart\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:4:\"cart\";s:9:\"plugin_id\";s:7:\"boolean\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:12:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;s:18:\"hide_single_bundle\";b:1;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:5:\"Carts\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"No orders available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"use_ajax\";b:0;}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:27:\"admin/commerce/orders/carts\";s:4:\"menu\";a:8:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:5:\"Carts\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.commerce_cart_block','a:14:{s:4:\"uuid\";s:36:\"6338a28d-0169-45c6-a250-ea14ad5f5c43\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:53:\"field.storage.commerce_product_variation.field_images\";i:1;s:25:\"image.style.product_70x70\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:13:\"commerce_cart\";}}s:6:\"module\";a:5:{i:0;s:13:\"commerce_cart\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_price\";i:3;s:16:\"commerce_product\";i:4;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"l3fypt3kcp9rdktG4mKnQvlejXH8I0q2mXlAOFAknzU\";}s:2:\"id\";s:19:\"commerce_cart_block\";s:5:\"label\";s:10:\"Cart block\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:19:\"commerce_cart_block\";s:10:\"base_table\";s:14:\"commerce_order\";s:10:\"base_field\";s:8:\"order_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:1:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:16:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:8:\"clearfix\";s:17:\"default_row_class\";b:0;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:0:\"\";s:5:\"class\";s:22:\"clearlist widget-posts\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"fields\";a:5:{s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:40:\"commerce_product_variation__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:26:\"commerce_product_variation\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:13:\"product_70x70\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:37:\"commerce_product_variation_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:26:\"commerce_product_variation\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:8:\"quantity\";a:37:{s:2:\"id\";s:8:\"quantity\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:8:\"quantity\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:21:\"{{ quantity }}&nbsp;x\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:0;s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:8:\"quantity\";s:9:\"plugin_id\";s:5:\"field\";}s:18:\"unit_price__number\";a:37:{s:2:\"id\";s:18:\"unit_price__number\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:18:\"unit_price__number\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:10:\"unit_price\";s:9:\"plugin_id\";s:5:\"field\";}s:13:\"remove_button\";a:23:{s:2:\"id\";s:13:\"remove_button\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:13:\"remove_button\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:9:\"plugin_id\";s:33:\"commerce_order_item_remove_button\";}}s:7:\"filters\";a:1:{s:4:\"cart\";a:16:{s:2:\"id\";s:4:\"cart\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:4:\"cart\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:4:\"cart\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"sorts\";a:1:{s:13:\"order_item_id\";a:12:{s:2:\"id\";s:13:\"order_item_id\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:13:\"order_item_id\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:13:\"order_item_id\";s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"header\";a:0:{}s:6:\"footer\";a:1:{s:20:\"commerce_order_total\";a:8:{s:2:\"id\";s:20:\"commerce_order_total\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:20:\"commerce_order_total\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:0;s:9:\"plugin_id\";s:20:\"commerce_order_total\";}}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:2:{s:11:\"order_items\";a:8:{s:2:\"id\";s:11:\"order_items\";s:5:\"table\";s:27:\"commerce_order__order_items\";s:5:\"field\";s:11:\"order_items\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:23:\"order_items: Order Item\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:26:\"commerce_product_variation\";a:9:{s:2:\"id\";s:26:\"commerce_product_variation\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:26:\"commerce_product_variation\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:17:\"Product variation\";s:8:\"required\";b:1;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:1:{s:8:\"order_id\";a:23:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"order_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:8:\"order_id\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";}s:4:\"tags\";a:1:{i:0;s:60:\"config:field.storage.commerce_product_variation.field_images\";}}}}}'),

('','views.view.commerce_cart_form','a:14:{s:4:\"uuid\";s:36:\"b3c49ec1-50ba-4b2e-ae85-97a850790b3c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:53:\"field.storage.commerce_product_variation.field_images\";i:1;s:25:\"image.style.product_70x70\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:13:\"commerce_cart\";}}s:6:\"module\";a:5:{i:0;s:13:\"commerce_cart\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_price\";i:3;s:16:\"commerce_product\";i:4;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ADHFqDLD7jZk4Gh_rF1TOh7eze4y0wWQAO2JHZyCCV4\";}s:2:\"id\";s:18:\"commerce_cart_form\";s:5:\"label\";s:9:\"Cart form\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:18:\"commerce_cart_form\";s:10:\"base_table\";s:14:\"commerce_order\";s:10:\"base_field\";s:8:\"order_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:1:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:16:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:1:{s:12:\"order_number\";s:12:\"order_number\";}s:4:\"info\";a:1:{s:12:\"order_number\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:2:\"-1\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"fields\";a:7:{s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:40:\"commerce_product_variation__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:26:\"commerce_product_variation\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Photo\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:13:\"product_70x70\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:37:\"commerce_product_variation_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:26:\"commerce_product_variation\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Product\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:13:\"edit_quantity\";a:23:{s:2:\"id\";s:13:\"edit_quantity\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:13:\"edit_quantity\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Q-ty\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:9:\"plugin_id\";s:33:\"commerce_order_item_edit_quantity\";}s:19:\"total_price__number\";a:37:{s:2:\"id\";s:19:\"total_price__number\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:19:\"total_price__number\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Total\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:11:\"total_price\";s:9:\"plugin_id\";s:5:\"field\";}s:13:\"remove_button\";a:23:{s:2:\"id\";s:13:\"remove_button\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:13:\"remove_button\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:9:\"plugin_id\";s:33:\"commerce_order_item_remove_button\";}s:16:\"purchased_entity\";a:37:{s:2:\"id\";s:16:\"purchased_entity\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:16:\"purchased_entity\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Item\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:28:\"entity_reference_entity_view\";s:8:\"settings\";a:1:{s:9:\"view_mode\";s:7:\"default\";}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:16:\"purchased_entity\";s:9:\"plugin_id\";s:5:\"field\";}s:18:\"unit_price__number\";a:37:{s:2:\"id\";s:18:\"unit_price__number\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:18:\"unit_price__number\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Price\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:10:\"unit_price\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:0:{}s:5:\"sorts\";a:1:{s:13:\"order_item_id\";a:12:{s:2:\"id\";s:13:\"order_item_id\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:13:\"order_item_id\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:13:\"order_item_id\";s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"header\";a:0:{}s:6:\"footer\";a:1:{s:20:\"commerce_order_total\";a:8:{s:2:\"id\";s:20:\"commerce_order_total\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:20:\"commerce_order_total\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:0;s:9:\"plugin_id\";s:20:\"commerce_order_total\";}}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:2:{s:11:\"order_items\";a:8:{s:2:\"id\";s:11:\"order_items\";s:5:\"table\";s:27:\"commerce_order__order_items\";s:5:\"field\";s:11:\"order_items\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:23:\"order_items: Order Item\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:26:\"commerce_product_variation\";a:9:{s:2:\"id\";s:26:\"commerce_product_variation\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:26:\"commerce_product_variation\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:17:\"Product variation\";s:8:\"required\";b:1;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:1:{s:8:\"order_id\";a:23:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"order_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:8:\"order_id\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";}s:4:\"tags\";a:1:{i:0;s:60:\"config:field.storage.commerce_product_variation.field_images\";}}}}}'),

('','views.view.commerce_checkout_order_summary','a:14:{s:4:\"uuid\";s:36:\"23435072-1cf2-4d4a-b1a4-2b429bfc8937\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:53:\"field.storage.commerce_product_variation.field_images\";i:1;s:25:\"image.style.product_70x70\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:6:\"module\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_price\";i:2;s:16:\"commerce_product\";i:3;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"D-aj_NEmyw-wjss4Gsqim6DzfB4_YRl65ROmEI7v96U\";}s:2:\"id\";s:31:\"commerce_checkout_order_summary\";s:5:\"label\";s:22:\"Checkout Order Summary\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:22:\"commerce_order_summary\";s:10:\"base_table\";s:14:\"commerce_order\";s:10:\"base_field\";s:8:\"order_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:1:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:16:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:1:{s:12:\"order_number\";s:12:\"order_number\";}s:4:\"info\";a:1:{s:12:\"order_number\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:2:\"-1\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"fields\";a:5:{s:8:\"quantity\";a:37:{s:2:\"id\";s:8:\"quantity\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:8:\"quantity\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:21:\"{{ quantity }}&nbsp;x\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:0;s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:8:\"quantity\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:40:\"commerce_product_variation__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:26:\"commerce_product_variation\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:13:\"product_70x70\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:37:\"commerce_product_variation_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:26:\"commerce_product_variation\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:19:\"total_price__number\";a:37:{s:2:\"id\";s:19:\"total_price__number\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:19:\"total_price__number\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:11:\"total_price\";s:9:\"plugin_id\";s:5:\"field\";}s:16:\"purchased_entity\";a:37:{s:2:\"id\";s:16:\"purchased_entity\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:16:\"purchased_entity\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:28:\"entity_reference_entity_view\";s:8:\"settings\";a:1:{s:9:\"view_mode\";s:7:\"default\";}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:16:\"purchased_entity\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:0:{}s:5:\"sorts\";a:1:{s:13:\"order_item_id\";a:12:{s:2:\"id\";s:13:\"order_item_id\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:13:\"order_item_id\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:13:\"order_item_id\";s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"header\";a:0:{}s:6:\"footer\";a:1:{s:20:\"commerce_order_total\";a:8:{s:2:\"id\";s:20:\"commerce_order_total\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:20:\"commerce_order_total\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:0;s:9:\"plugin_id\";s:20:\"commerce_order_total\";}}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:2:{s:11:\"order_items\";a:8:{s:2:\"id\";s:11:\"order_items\";s:5:\"table\";s:27:\"commerce_order__order_items\";s:5:\"field\";s:11:\"order_items\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:23:\"order_items: Order Item\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:26:\"commerce_product_variation\";a:9:{s:2:\"id\";s:26:\"commerce_product_variation\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:26:\"commerce_product_variation\";s:12:\"relationship\";s:11:\"order_items\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:17:\"Product variation\";s:8:\"required\";b:1;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:1:{s:8:\"order_id\";a:23:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"order_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:8:\"order_id\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";}s:4:\"tags\";a:1:{i:0;s:60:\"config:field.storage.commerce_product_variation.field_images\";}}}}}'),

('','views.view.commerce_orders','a:14:{s:4:\"uuid\";s:36:\"5749fab7-3882-4ca2-95dc-322bd09963dd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:7:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_price\";i:3;s:14:\"commerce_store\";i:4;s:7:\"options\";i:5;s:13:\"state_machine\";i:6;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tpDt6NuuckyWNxkctwBhb-wOuIK--Fk8OBMk6OuRCZg\";}s:2:\"id\";s:15:\"commerce_orders\";s:5:\"label\";s:6:\"Orders\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:8:\"Commerce\";s:10:\"base_table\";s:14:\"commerce_order\";s:10:\"base_field\";s:8:\"order_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:19:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:30:\"access commerce_order overview\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:5:\"first\";s:8:\"« first\";s:4:\"last\";s:7:\"last »\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:9:{s:12:\"order_number\";s:12:\"order_number\";s:6:\"placed\";s:6:\"placed\";s:4:\"type\";s:4:\"type\";s:8:\"store_id\";s:8:\"store_id\";s:3:\"uid\";s:3:\"uid\";s:4:\"mail\";s:3:\"uid\";s:5:\"state\";s:5:\"state\";s:19:\"total_price__number\";s:19:\"total_price__number\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:9:{s:12:\"order_number\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"placed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:1;s:10:\"responsive\";s:15:\"priority-medium\";}s:8:\"store_id\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:1;s:10:\"responsive\";s:15:\"priority-medium\";}s:3:\"uid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:6:\"<br />\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"mail\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"state\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:19:\"total_price__number\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:6:\"placed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:10:{s:24:\"commerce_order_bulk_form\";a:26:{s:2:\"id\";s:24:\"commerce_order_bulk_form\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:24:\"commerce_order_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:14:\"With selection\";s:15:\"include_exclude\";s:7:\"exclude\";s:16:\"selected_actions\";a:0:{}s:11:\"entity_type\";s:14:\"commerce_order\";s:9:\"plugin_id\";s:9:\"bulk_form\";}s:12:\"order_number\";a:37:{s:2:\"id\";s:12:\"order_number\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:12:\"order_number\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:1:\"#\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:12:\"order_number\";s:9:\"plugin_id\";s:5:\"field\";}s:6:\"placed\";a:37:{s:2:\"id\";s:6:\"placed\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:6:\"placed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:3:\"N/A\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:6:\"placed\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:38:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:18:\"hide_single_bundle\";b:1;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}s:8:\"store_id\";a:38:{s:2:\"id\";s:8:\"store_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"store_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Store\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:17:\"hide_single_store\";b:1;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:8:\"store_id\";s:9:\"plugin_id\";s:14:\"commerce_store\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Customer\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"mail\";a:37:{s:2:\"id\";s:4:\"mail\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:4:\"mail\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Email\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"basic_string\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:4:\"mail\";s:9:\"plugin_id\";s:5:\"field\";}s:5:\"state\";a:37:{s:2:\"id\";s:5:\"state\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:5:\"state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"State\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:5:\"field\";}s:19:\"total_price__number\";a:37:{s:2:\"id\";s:19:\"total_price__number\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:19:\"total_price__number\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Total\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:11:\"total_price\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:14:\"commerce_order\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:3:{s:12:\"order_number\";a:16:{s:2:\"id\";s:12:\"order_number\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:12:\"order_number\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:6:\"starts\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:15:\"order_number_op\";s:5:\"label\";s:12:\"Order number\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:15:\"order_number_op\";s:10:\"identifier\";s:12:\"order_number\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:12:\"order_number\";s:9:\"plugin_id\";s:6:\"string\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:12:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;s:18:\"hide_single_bundle\";b:1;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}s:5:\"state\";a:16:{s:2:\"id\";s:5:\"state\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:5:\"state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:8:\"state_op\";s:5:\"label\";s:5:\"State\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:8:\"state_op\";s:10:\"identifier\";s:5:\"state\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:5:\"state\";s:9:\"plugin_id\";s:19:\"state_machine_state\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:6:\"Orders\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"No orders available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"use_ajax\";b:0;s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:26:\"admin/commerce/orders/list\";s:4:\"menu\";a:8:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:6:\"Orders\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:-10;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:11:\"tab_options\";a:4:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:6:\"Orders\";s:11:\"description\";s:19:\"Manage your orders.\";s:6:\"weight\";i:0;}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.commerce_order_item_table','a:14:{s:4:\"uuid\";s:36:\"2bd8b3f2-3795-4487-8e9d-f717dad87f3b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_price\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"n9Ex_quBSEoJSBauWflhu627_KJLiobwpc1HvKLcv8Q\";}s:2:\"id\";s:25:\"commerce_order_item_table\";s:5:\"label\";s:11:\"Order items\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:40:\"Display a set of order items in a table.\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:19:\"commerce_order_item\";s:10:\"base_field\";s:13:\"order_item_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:1:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:16:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:5:\"title\";s:5:\"title\";s:18:\"unit_price__number\";s:18:\"unit_price__number\";s:8:\"quantity\";s:8:\"quantity\";s:19:\"total_price__number\";s:19:\"total_price__number\";}s:4:\"info\";a:4:{s:5:\"title\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:18:\"unit_price__number\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"quantity\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:19:\"total_price__number\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:2:\"-1\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:18:\"unit_price__number\";a:37:{s:2:\"id\";s:18:\"unit_price__number\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:18:\"unit_price__number\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Unit price\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:10:\"unit_price\";s:9:\"plugin_id\";s:5:\"field\";}s:8:\"quantity\";a:37:{s:2:\"id\";s:8:\"quantity\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:8:\"quantity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Quantity\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:1;s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:8:\"quantity\";s:9:\"plugin_id\";s:5:\"field\";}s:19:\"total_price__number\";a:37:{s:2:\"id\";s:19:\"total_price__number\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:19:\"total_price__number\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Total price\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:11:\"total_price\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:0:{}s:5:\"sorts\";a:0:{}s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:29:\"There are no order items yet.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:1:{s:8:\"order_id\";a:23:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:19:\"commerce_order_item\";s:5:\"field\";s:8:\"order_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:19:\"commerce_order_item\";s:12:\"entity_field\";s:8:\"order_id\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.commerce_products','a:14:{s:4:\"uuid\";s:36:\"dddb5b07-5f3f-4aaf-9ef1-9dbaf20ca01a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:8:\"commerce\";i:1;s:16:\"commerce_product\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lTfF_aenIIJ8YnvaratQgGpNEkFtA7tSDiElcgecVQo\";}s:2:\"id\";s:17:\"commerce_products\";s:5:\"label\";s:8:\"Products\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:8:\"Commerce\";s:10:\"base_table\";s:27:\"commerce_product_field_data\";s:10:\"base_field\";s:10:\"product_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:32:\"access commerce_product overview\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:5:\"first\";s:8:\"« first\";s:4:\"last\";s:7:\"last »\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:5:{s:5:\"title\";s:5:\"title\";s:4:\"type\";s:4:\"type\";s:6:\"status\";s:6:\"status\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:5:{s:5:\"title\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:1;s:10:\"responsive\";s:0:\"\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:6:{s:26:\"commerce_product_bulk_form\";a:26:{s:2:\"id\";s:26:\"commerce_product_bulk_form\";s:5:\"table\";s:16:\"commerce_product\";s:5:\"field\";s:26:\"commerce_product_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:14:\"With selection\";s:15:\"include_exclude\";s:7:\"exclude\";s:16:\"selected_actions\";a:0:{}s:11:\"entity_type\";s:16:\"commerce_product\";s:9:\"plugin_id\";s:9:\"bulk_form\";}s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:38:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:18:\"hide_single_bundle\";b:1;s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}s:6:\"status\";a:37:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";s:9:\"Published\";s:19:\"format_custom_false\";s:11:\"Unpublished\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:16:\"commerce_product\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:16:\"commerce_product\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:2:{s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:12:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;s:18:\"hide_single_bundle\";b:1;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}s:5:\"title\";a:16:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:8:\"title_op\";s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:8:\"title_op\";s:10:\"identifier\";s:5:\"title\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:6:\"string\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:8:\"Products\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:22:\"No products available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:2:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:23:\"admin/commerce/products\";}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.commerce_stores','a:14:{s:4:\"uuid\";s:36:\"3dece191-47ed-442a-b1aa-035539f2fe18\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_store\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oHsklE_XUCqbT57_8chfj2OrDcR4ikKQ1go5WEz3PK0\";}s:2:\"id\";s:15:\"commerce_stores\";s:5:\"label\";s:6:\"Stores\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:8:\"Commerce\";s:10:\"base_table\";s:25:\"commerce_store_field_data\";s:10:\"base_field\";s:8:\"store_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:30:\"access commerce_store overview\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:5:\"first\";s:8:\"« first\";s:4:\"last\";s:7:\"last »\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:3:{s:4:\"name\";s:4:\"name\";s:4:\"type\";s:4:\"type\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:3:{s:4:\"name\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:1;s:10:\"responsive\";s:0:\"\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:2:\"-1\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:4:{s:24:\"commerce_store_bulk_form\";a:26:{s:2:\"id\";s:24:\"commerce_store_bulk_form\";s:5:\"table\";s:14:\"commerce_store\";s:5:\"field\";s:24:\"commerce_store_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:14:\"With selection\";s:15:\"include_exclude\";s:7:\"exclude\";s:16:\"selected_actions\";a:0:{}s:11:\"entity_type\";s:14:\"commerce_store\";s:9:\"plugin_id\";s:9:\"bulk_form\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:25:\"commerce_store_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Name\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:38:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:25:\"commerce_store_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:18:\"hide_single_bundle\";b:1;s:11:\"entity_type\";s:14:\"commerce_store\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:14:\"commerce_store\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:0;s:11:\"entity_type\";s:14:\"commerce_store\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:1:{s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:25:\"commerce_store_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:12:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;s:18:\"hide_single_bundle\";b:1;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:14:\"commerce_store\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:6:\"Stores\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"No stores available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:2:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:28:\"admin/commerce/config/stores\";}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.commerce_user_orders','a:14:{s:4:\"uuid\";s:36:\"8e3ada56-8056-473e-8275-03ee6f57a788\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:5:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_price\";i:2;s:7:\"options\";i:3;s:13:\"state_machine\";i:4;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"InlzG5jd3RryfIKQvjJqhVyA8SOyJmmXfjdl5l8eYD8\";}s:2:\"id\";s:20:\"commerce_user_orders\";s:5:\"label\";s:11:\"User orders\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:43:\"Display a list of placed orders for a user.\";s:3:\"tag\";s:8:\"Commerce\";s:10:\"base_table\";s:14:\"commerce_order\";s:10:\"base_field\";s:8:\"order_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:23:\"view own commerce_order\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:25;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:12:\"order_number\";s:12:\"order_number\";s:6:\"placed\";s:6:\"placed\";s:19:\"total_price__number\";s:19:\"total_price__number\";s:5:\"state\";s:5:\"state\";}s:4:\"info\";a:5:{s:12:\"order_number\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"placed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:19:\"total_price__number\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"state\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:6:\"placed\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:5:{s:8:\"order_id\";a:37:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"order_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:2:\"ID\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:8:\"order_id\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"order_number\";a:37:{s:2:\"id\";s:12:\"order_number\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:12:\"order_number\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Order number\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:1;s:4:\"path\";s:46:\"user/{{ arguments.uid }}/orders/{{ order_id }}\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:12:\"order_number\";s:9:\"plugin_id\";s:5:\"field\";}s:6:\"placed\";a:37:{s:2:\"id\";s:6:\"placed\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:6:\"placed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:6:\"placed\";s:9:\"plugin_id\";s:5:\"field\";}s:19:\"total_price__number\";a:37:{s:2:\"id\";s:19:\"total_price__number\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:19:\"total_price__number\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Total\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:11:\"total_price\";s:9:\"plugin_id\";s:5:\"field\";}s:5:\"state\";a:37:{s:2:\"id\";s:5:\"state\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:5:\"state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"State\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:5:\"state\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:1:{s:5:\"state\";a:16:{s:2:\"id\";s:5:\"state\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:5:\"state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:6:\"not in\";s:5:\"value\";a:1:{s:5:\"draft\";s:5:\"draft\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:5:\"state\";s:9:\"plugin_id\";s:19:\"state_machine_state\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:6:\"Orders\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:10:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";a:2:{s:5:\"value\";s:43:\"You have not placed any orders with us yet.\";s:6:\"format\";s:10:\"basic_html\";}s:9:\"plugin_id\";s:4:\"text\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:1:{s:3:\"uid\";a:23:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:2:{s:4:\"type\";s:21:\"commerce_current_user\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:1:{s:16:\"admin_permission\";s:25:\"administer commerce_order\";}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:14:\"commerce_order\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:10:\"order_page\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:10:\"order_page\";s:13:\"display_title\";s:11:\"User orders\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:17:\"user/%user/orders\";s:4:\"menu\";a:8:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:6:\"Orders\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:7:\"account\";}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.content','a:14:{s:4:\"uuid\";s:36:\"62d12724-c217-4b74-a47a-4470b7f9fe6d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fUDNcSYKNw6cTMPsX3G9VhsUGov5yUe6_TBHbcnZHyo\";}s:2:\"id\";s:7:\"content\";s:5:\"label\";s:7:\"Content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:24:\"Find and manage content.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:23:\"access content overview\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:3:\"tag\";}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:50;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:10:{s:14:\"node_bulk_form\";s:14:\"node_bulk_form\";s:5:\"title\";s:5:\"title\";s:4:\"type\";s:4:\"type\";s:4:\"name\";s:4:\"name\";s:6:\"status\";s:6:\"status\";s:7:\"changed\";s:7:\"changed\";s:9:\"edit_node\";s:9:\"edit_node\";s:11:\"delete_node\";s:11:\"delete_node\";s:10:\"dropbutton\";s:10:\"dropbutton\";s:9:\"timestamp\";s:5:\"title\";}s:4:\"info\";a:10:{s:14:\"node_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"title\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:9:\"edit_node\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:11:\"delete_node\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"dropbutton\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"timestamp\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:7:{s:14:\"node_bulk_form\";a:14:{s:2:\"id\";s:14:\"node_bulk_form\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:14:\"node_bulk_form\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:14:\"node_bulk_form\";s:11:\"entity_type\";s:4:\"node\";}s:5:\"title\";a:17:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Content type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:17:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:6:\"status\";a:17:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";s:9:\"Published\";s:19:\"format_custom_false\";s:11:\"Unpublished\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:7:\"changed\";a:17:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";}s:10:\"operations\";a:23:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:5:{s:12:\"status_extra\";a:8:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:12:\"status_extra\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";b:0;s:9:\"plugin_id\";s:11:\"node_status\";s:5:\"group\";i:1;s:11:\"entity_type\";s:4:\"node\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:1;s:10:\"group_info\";a:10:{s:5:\"label\";s:16:\"Published status\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:6:\"status\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:2:{i:1;a:3:{s:5:\"title\";s:9:\"Published\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";}i:2;a:3:{s:5:\"title\";s:11:\"Unpublished\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";}}}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:12:\"Content type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"bundle\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";}s:5:\"title\";a:16:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:8:\"title_op\";s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:8:\"title_op\";s:10:\"identifier\";s:5:\"title\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:7:\"Content\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:21:\"No content available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:0:{}s:13:\"relationships\";a:1:{s:3:\"uid\";a:6:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}}s:16:\"show_admin_links\";b:0;s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:2:\"id\";s:7:\"default\";s:8:\"position\";i:0;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:7:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:21:\"user.node_grants:view\";i:6;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:15:\"display_options\";a:4:{s:4:\"path\";s:18:\"admin/content/node\";s:4:\"menu\";a:6:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:7:\"Content\";s:11:\"description\";s:0:\"\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:-10;s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:7:\"Content\";s:11:\"description\";s:23:\"Find and manage content\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:-10;}s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:2:\"id\";s:6:\"page_1\";s:8:\"position\";i:1;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:7:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:21:\"user.node_grants:view\";i:6;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.content_recent','a:14:{s:4:\"uuid\";s:36:\"187616b8-a65a-4b8d-9804-9d0955cbd08f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tDcmzGfShE0XJbfwJzyA6lJTUYC6X4iVu887dgoFfDg\";}s:2:\"id\";s:14:\"content_recent\";s:5:\"label\";s:14:\"Recent content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:15:\"Recent content.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:22:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:2:{s:5:\"title\";a:26:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:2:{s:12:\"status_extra\";a:15:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:12:\"status_extra\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";b:0;s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"node_status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:5:\"sorts\";a:1:{s:7:\"changed\";a:13:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:4:\"date\";}}s:5:\"title\";s:14:\"Recent content\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:21:\"No content available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"More\";s:8:\"link_url\";s:0:\"\";s:12:\"link_display\";s:1:\"0\";}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:4:\"user\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:4:\"user\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.files','a:14:{s:4:\"uuid\";s:36:\"22ae0af2-830a-4c19-bc0d-aaee6de9618e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"file\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rRWxAX-IQkJ5viACQRovRkC784EyCl9493GU_G23n2Q\";}s:2:\"id\";s:5:\"files\";s:5:\"label\";s:5:\"Files\";s:6:\"module\";s:4:\"file\";s:11:\"description\";s:22:\"Find and manage files.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:12:\"file_managed\";s:10:\"base_field\";s:3:\"fid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:19:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:21:\"access files overview\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:8:{s:3:\"fid\";s:3:\"fid\";s:8:\"filename\";s:8:\"filename\";s:8:\"filemime\";s:8:\"filemime\";s:8:\"filesize\";s:8:\"filesize\";s:6:\"status\";s:6:\"status\";s:7:\"created\";s:7:\"created\";s:7:\"changed\";s:7:\"changed\";s:5:\"count\";s:5:\"count\";}s:4:\"info\";a:8:{s:3:\"fid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"filename\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"filemime\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:8:\"filesize\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"count\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:3:\"fid\";a:24:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:3:\"Fid\";s:7:\"exclude\";b:1;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"fid\";}s:8:\"filename\";a:36:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Name\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"file_link\";s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";}s:8:\"filemime\";a:25:{s:2:\"id\";s:8:\"filemime\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filemime\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"MIME type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"file_filemime\";s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filemime\";}s:8:\"filesize\";a:25:{s:2:\"id\";s:8:\"filesize\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filesize\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Size\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"file_size\";s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filesize\";}s:6:\"status\";a:26:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:19:\"format_custom_false\";s:9:\"Temporary\";s:18:\"format_custom_true\";s:9:\"Permanent\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:6:\"status\";}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Upload date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:7:\"created\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Changed date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:7:\"changed\";}s:5:\"count\";a:30:{s:2:\"id\";s:5:\"count\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:5:\"count\";s:12:\"relationship\";s:3:\"fid\";s:10:\"group_type\";s:3:\"sum\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Used in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:1;s:4:\"path\";s:35:\"admin/content/files/usage/{{ fid }}\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:1;s:20:\"format_plural_string\";s:21:\"1 place@count places\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:3:{s:8:\"filename\";a:16:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:4:\"word\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"filemime_op\";s:5:\"label\";s:8:\"Filename\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filename_op\";s:10:\"identifier\";s:8:\"filename\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";}s:8:\"filemime\";a:16:{s:2:\"id\";s:8:\"filemime\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filemime\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:4:\"word\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"filemime_op\";s:5:\"label\";s:9:\"MIME type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filemime_op\";s:10:\"identifier\";s:8:\"filemime\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filemime\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:9:\"status_op\";s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"file_status\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:6:\"status\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:5:\"Files\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:19:\"No files available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:1;}}s:9:\"arguments\";a:0:{}s:8:\"group_by\";b:1;s:16:\"show_admin_links\";b:1;s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:14:\"Files overview\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:4:\"path\";s:19:\"admin/content/files\";s:4:\"menu\";a:6:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:5:\"Files\";s:11:\"description\";s:0:\"\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:0;s:7:\"context\";s:0:\"\";}s:19:\"display_description\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"pager\";b:1;s:13:\"relationships\";b:0;}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:0;}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_2\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:10:\"File usage\";s:8:\"position\";i:2;s:15:\"display_options\";a:15:{s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:27:\"admin/content/files/usage/%\";s:5:\"empty\";a:0:{}s:8:\"defaults\";a:11:{s:5:\"empty\";b:0;s:5:\"pager\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;s:8:\"group_by\";b:0;s:5:\"title\";b:0;s:9:\"arguments\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:13:\"relationships\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:7:\"filters\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:0:{}}s:6:\"fields\";a:4:{s:12:\"entity_label\";a:23:{s:2:\"id\";s:12:\"entity_label\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:12:\"entity_label\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Entity\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:14:\"link_to_entity\";b:1;s:9:\"plugin_id\";s:12:\"entity_label\";}s:4:\"type\";a:22:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Entity type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:6:\"module\";a:22:{s:2:\"id\";s:6:\"module\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:6:\"module\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:18:\"Registering module\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:5:\"count\";a:30:{s:2:\"id\";s:5:\"count\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:5:\"count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Use count\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"group_by\";b:0;s:5:\"title\";s:10:\"File usage\";s:9:\"arguments\";a:1:{s:3:\"fid\";a:23:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:46:\"File usage information for {{ arguments.fid }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:9:\"plugin_id\";s:8:\"file_fid\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"fid\";}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:12:\"entity_label\";s:12:\"entity_label\";s:4:\"type\";s:4:\"type\";s:6:\"module\";s:6:\"module\";s:5:\"count\";s:5:\"count\";}s:4:\"info\";a:4:{s:12:\"entity_label\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:6:\"module\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:5:\"count\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:12:\"entity_label\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:1;}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.file_entity_browser','a:14:{s:4:\"uuid\";s:36:\"6ba538ee-9ea8-4c49-a3e7-871f6f375fcf\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:12:\"file_browser\";}}s:6:\"module\";a:4:{i:0;s:14:\"entity_browser\";i:1;s:4:\"file\";i:2;s:12:\"file_browser\";i:3;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"00YaQhkOvdJZ_-A2LIs_o9dxQDF-o9zSi7dg2Q-UCs4\";}s:2:\"id\";s:19:\"file_entity_browser\";s:5:\"label\";s:19:\"File Entity Browser\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:12:\"file_managed\";s:10:\"base_field\";s:3:\"fid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:20:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:25;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:5:\"first\";s:8:\"« first\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:3:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:9:\"grid-item\";s:17:\"default_row_class\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"fields\";a:5:{s:21:\"entity_browser_select\";a:23:{s:2:\"id\";s:21:\"entity_browser_select\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:21:\"entity_browser_select\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";N;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"file\";s:9:\"plugin_id\";s:21:\"entity_browser_select\";}s:20:\"file_browser_preview\";a:23:{s:2:\"id\";s:20:\"file_browser_preview\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:20:\"file_browser_preview\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"file\";s:9:\"plugin_id\";s:20:\"file_browser_preview\";}s:8:\"filename\";a:37:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:15;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";s:9:\"plugin_id\";s:5:\"field\";}s:8:\"filesize\";a:37:{s:2:\"id\";s:8:\"filesize\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filesize\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"file_size\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filesize\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"nothing\";a:22:{s:2:\"id\";s:7:\"nothing\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"nothing\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:167:\"<div class=\"grid-item-info\">\n<div class=\"grid-item-info-left\" title=\"{{ filename }}\">{{ filename }}</div>\n<div class=\"grid-item-info-right\">{{ filesize }}</div>\n</div>\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:0;s:9:\"plugin_id\";s:6:\"custom\";}}s:7:\"filters\";a:3:{s:8:\"filename\";a:16:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"filename_op\";s:5:\"label\";s:8:\"Filename\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filename_op\";s:10:\"identifier\";s:8:\"filename\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";s:9:\"plugin_id\";s:6:\"string\";}s:8:\"filemime\";a:16:{s:2:\"id\";s:8:\"filemime\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filemime\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"filemime_op\";s:5:\"label\";s:14:\"File MIME type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filemime_op\";s:10:\"identifier\";s:8:\"filemime\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filemime\";s:9:\"plugin_id\";s:6:\"string\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{i:1;s:1:\"1\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:11:\"file_status\";}}s:5:\"sorts\";a:3:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:1;s:6:\"expose\";a:1:{s:5:\"label\";s:12:\"Created date\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";}s:8:\"filesize\";a:12:{s:2:\"id\";s:8:\"filesize\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filesize\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:1;s:6:\"expose\";a:1:{s:5:\"label\";s:9:\"File size\";}s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filesize\";s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"filename\";a:12:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:1;s:6:\"expose\";a:1:{s:5:\"label\";s:8:\"Filename\";}s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:14:\"field_langcode\";s:31:\"***LANGUAGE_language_content***\";s:27:\"field_langcode_add_to_query\";N;s:9:\"css_class\";s:0:\"\";s:8:\"use_ajax\";b:1;}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:7:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:22:\"url.query_args:sort_by\";i:5;s:25:\"url.query_args:sort_order\";i:6;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:16:\"entity_browser_1\";a:6:{s:14:\"display_plugin\";s:14:\"entity_browser\";s:2:\"id\";s:16:\"entity_browser_1\";s:13:\"display_title\";s:14:\"Entity browser\";s:8:\"position\";i:2;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:14:\"field_langcode\";s:31:\"***LANGUAGE_language_content***\";s:27:\"field_langcode_add_to_query\";N;}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:7:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:22:\"url.query_args:sort_by\";i:5;s:25:\"url.query_args:sort_order\";i:6;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.frontpage','a:14:{s:4:\"uuid\";s:36:\"909a80c1-4830-41f9-a386-6482197a2bb5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:30:\"core.entity_view_mode.node.rss\";i:1;s:33:\"core.entity_view_mode.node.teaser\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"GNfx9kN8-0_KgQ-xf3fjdXCCzZwXCI8T0IPFW8SIe7g\";}s:2:\"id\";s:9:\"frontpage\";s:5:\"label\";s:9:\"Frontpage\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:39:\"All content promoted to the front page.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"empty\";a:3:{s:16:\"area_text_custom\";a:11:{s:11:\"admin_label\";s:0:\"\";s:7:\"content\";s:43:\"No front page content has been created yet.\";s:5:\"empty\";b:1;s:5:\"field\";s:16:\"area_text_custom\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:16:\"area_text_custom\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:5:\"views\";s:8:\"tokenize\";b:0;s:9:\"plugin_id\";s:11:\"text_custom\";}s:18:\"node_listing_empty\";a:10:{s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"field\";s:18:\"node_listing_empty\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:18:\"node_listing_empty\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:4:\"node\";s:9:\"plugin_id\";s:18:\"node_listing_empty\";s:11:\"entity_type\";s:4:\"node\";}s:5:\"title\";a:10:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"title\";s:22:\"Welcome to [site:name]\";s:9:\"plugin_id\";s:5:\"title\";}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:7:\"filters\";a:3:{s:7:\"promote\";a:16:{s:11:\"admin_label\";s:0:\"\";s:6:\"expose\";a:10:{s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:5:\"label\";s:0:\"\";s:8:\"multiple\";b:0;s:8:\"operator\";s:0:\"\";s:11:\"operator_id\";s:0:\"\";s:8:\"remember\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:8:\"required\";b:0;s:12:\"use_operator\";b:0;}s:7:\"exposed\";b:0;s:5:\"field\";s:7:\"promote\";s:5:\"group\";i:1;s:10:\"group_info\";a:10:{s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"description\";s:0:\"\";s:11:\"group_items\";a:0:{}s:10:\"identifier\";s:0:\"\";s:5:\"label\";s:0:\"\";s:8:\"multiple\";b:0;s:8:\"optional\";b:1;s:8:\"remember\";b:0;s:6:\"widget\";s:6:\"select\";}s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:7:\"promote\";s:10:\"is_grouped\";b:0;s:8:\"operator\";s:1:\"=\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"value\";s:1:\"1\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"promote\";}s:6:\"status\";a:9:{s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"field\";s:6:\"status\";s:5:\"group\";i:1;s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"value\";s:1:\"1\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:8:\"quantity\";i:9;}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:12:{s:11:\"admin_label\";s:0:\"\";s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:7:\"exposed\";b:0;s:5:\"field\";s:6:\"sticky\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:15:\"node_field_data\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"sticky\";}s:7:\"created\";a:13:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:5:\"table\";s:15:\"node_field_data\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:5:\"title\";s:0:\"\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:2:\"id\";s:7:\"default\";s:8:\"position\";i:0;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:14:\"url.query_args\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"feed_1\";a:6:{s:14:\"display_plugin\";s:4:\"feed\";s:2:\"id\";s:6:\"feed_1\";s:13:\"display_title\";s:4:\"Feed\";s:8:\"position\";i:2;s:15:\"display_options\";a:7:{s:14:\"sitename_title\";b:1;s:4:\"path\";s:7:\"rss.xml\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";s:0:\"\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:3:\"rss\";s:7:\"options\";a:3:{s:11:\"description\";s:0:\"\";s:8:\"grouping\";a:0:{}s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:8:\"node_rss\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:3:\"rss\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:21:\"user.node_grants:view\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:15:\"display_options\";a:2:{s:4:\"path\";s:4:\"node\";s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:2:\"id\";s:6:\"page_1\";s:8:\"position\";i:1;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:14:\"url.query_args\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.gallery','a:13:{s:4:\"uuid\";s:36:\"4998f724-533d-4149-9e9d-c408f78a6006\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:30:\"field.storage.node.field_image\";i:1;s:26:\"image.style.blog_1140x642_\";i:2;s:27:\"image.style.gallery_165x106\";i:3;s:28:\"image.style.gallery_263x169_\";i:4;s:28:\"image.style.gallery_360x232_\";i:5;s:27:\"image.style.gallery_555x357\";i:6;s:22:\"node.type.gallery_item\";i:7;s:16:\"system.menu.main\";}s:6:\"module\";a:4:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";i:3;s:4:\"user\";}}s:2:\"id\";s:7:\"gallery\";s:5:\"label\";s:7:\"Gallery\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:6:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:8;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:1:{s:4:\"type\";s:7:\"default\";}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:2:{s:11:\"field_image\";a:35:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:17:\"node__field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:14:\"blog_1140x642_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uri\";a:37:{s:2:\"id\";s:3:\"uri\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"uri\";s:12:\"relationship\";s:21:\"field_image_target_id\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:8:\"file_uri\";s:8:\"settings\";a:2:{s:12:\"link_to_file\";b:0;s:18:\"file_download_path\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"uri\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:12:\"gallery_item\";s:12:\"gallery_item\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:20:\"GalleryGallery Col 1\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:21:\"field_image_target_id\";a:8:{s:2:\"id\";s:21:\"field_image_target_id\";s:5:\"table\";s:17:\"node__field_image\";s:5:\"field\";s:21:\"field_image_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:22:\"image from field_image\";s:8:\"required\";b:0;s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:37:\"config:field.storage.node.field_image\";}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:13:\"Gallery Col 1\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:7:\"gallery\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:13:\"Gallery Col 1\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8\";s:6:\"weight\";i:19;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:37:\"config:field.storage.node.field_image\";}}}s:6:\"page_2\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:13:\"Gallery Col 2\";s:8:\"position\";i:1;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:13:\"gallery-col-2\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:13:\"Gallery Col 2\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8\";s:6:\"weight\";i:20;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:13:\"Gallery Col 2\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:6:\"fields\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;}s:6:\"fields\";a:2:{s:11:\"field_image\";a:35:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:17:\"node__field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:15:\"gallery_555x357\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uri\";a:37:{s:2:\"id\";s:3:\"uri\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"uri\";s:12:\"relationship\";s:21:\"field_image_target_id\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:8:\"file_uri\";s:8:\"settings\";a:2:{s:12:\"link_to_file\";b:0;s:18:\"file_download_path\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"uri\";s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:2;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:0:\"\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:17:\"col-lg-6 mb-md-10\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:37:\"config:field.storage.node.field_image\";}}}s:6:\"page_3\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_3\";s:13:\"display_title\";s:13:\"Gallery Col 3\";s:8:\"position\";i:1;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:13:\"gallery-col-3\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:13:\"Gallery Col 3\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8\";s:6:\"weight\";i:21;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:13:\"Gallery Col 3\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:6:\"fields\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;}s:6:\"fields\";a:2:{s:11:\"field_image\";a:35:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:17:\"node__field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:16:\"gallery_360x232_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uri\";a:37:{s:2:\"id\";s:3:\"uri\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"uri\";s:12:\"relationship\";s:21:\"field_image_target_id\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:8:\"file_uri\";s:8:\"settings\";a:2:{s:12:\"link_to_file\";b:0;s:18:\"file_download_path\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"uri\";s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:3;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:0:\"\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:17:\"col-lg-6 mb-md-10\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:37:\"config:field.storage.node.field_image\";}}}s:6:\"page_4\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_4\";s:13:\"display_title\";s:13:\"Gallery Col 4\";s:8:\"position\";i:1;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:13:\"gallery-col-4\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:13:\"Gallery Col 4\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8\";s:6:\"weight\";i:22;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:13:\"Gallery Col 4\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:6:\"fields\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;}s:6:\"fields\";a:2:{s:11:\"field_image\";a:35:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:17:\"node__field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:16:\"gallery_263x169_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uri\";a:37:{s:2:\"id\";s:3:\"uri\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"uri\";s:12:\"relationship\";s:21:\"field_image_target_id\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:8:\"file_uri\";s:8:\"settings\";a:2:{s:12:\"link_to_file\";b:0;s:18:\"file_download_path\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"uri\";s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:4;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:0:\"\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:17:\"col-lg-3 mb-md-10\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:37:\"config:field.storage.node.field_image\";}}}s:6:\"page_5\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_5\";s:13:\"display_title\";s:13:\"Gallery Col 6\";s:8:\"position\";i:1;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:13:\"gallery-col-6\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:13:\"Gallery Col 6\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8\";s:6:\"weight\";i:23;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:13:\"Gallery Col 6\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:6:\"fields\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;}s:6:\"fields\";a:2:{s:11:\"field_image\";a:35:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:17:\"node__field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:15:\"gallery_165x106\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uri\";a:37:{s:2:\"id\";s:3:\"uri\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"uri\";s:12:\"relationship\";s:21:\"field_image_target_id\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:8:\"file_uri\";s:8:\"settings\";a:2:{s:12:\"link_to_file\";b:0;s:18:\"file_download_path\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"uri\";s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:6;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:0:\"\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:17:\"col-lg-3 mb-md-10\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:17;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:37:\"config:field.storage.node.field_image\";}}}}}'),

('','views.view.glossary','a:14:{s:4:\"uuid\";s:36:\"4a1262a0-0b80-452b-a545-c9afb32d3d87\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-pCFOVfbt__jaohFffTLnVavh4OBC6CjREAnchiRomQ\";}s:2:\"id\";s:8:\"glossary\";s:5:\"label\";s:8:\"Glossary\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:23:\"All content, by letter.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:1:\"8\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:8:\"use_ajax\";b:1;s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:36;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:6:\"fields\";a:3:{s:5:\"title\";a:24:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:6:\"Author\";s:12:\"relationship\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:11:\"Last update\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:4:\"long\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";}}s:9:\"arguments\";a:1:{s:5:\"title\";a:27:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"glossary\";b:1;s:5:\"limit\";i:1;s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";b:0;s:9:\"plugin_id\";s:6:\"string\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:0:{}s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:7:\"columns\";a:3:{s:5:\"title\";s:5:\"title\";s:4:\"name\";s:4:\"name\";s:7:\"changed\";s:7:\"changed\";}s:7:\"default\";s:5:\"title\";s:4:\"info\";a:3:{s:5:\"title\";a:2:{s:8:\"sortable\";b:1;s:9:\"separator\";s:0:\"\";}s:4:\"name\";a:2:{s:8:\"sortable\";b:1;s:9:\"separator\";s:0:\"\";}s:7:\"changed\";a:2:{s:8:\"sortable\";b:1;s:9:\"separator\";s:0:\"\";}}s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;s:5:\"order\";s:3:\"asc\";s:7:\"summary\";s:0:\"\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:5:\"sorts\";a:0:{}s:7:\"filters\";a:1:{s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:12:\"attachment_1\";a:6:{s:2:\"id\";s:12:\"attachment_1\";s:13:\"display_title\";s:10:\"Attachment\";s:14:\"display_plugin\";s:10:\"attachment\";s:8:\"position\";i:2;s:15:\"display_options\";a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:0;}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:5:\"title\";a:27:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:19:\"unformatted_summary\";}s:15:\"summary_options\";a:3:{s:14:\"items_per_page\";i:25;s:6:\"inline\";b:1;s:9:\"separator\";s:3:\" | \";}s:18:\"specify_validation\";b:1;s:8:\"glossary\";b:1;s:5:\"limit\";i:1;s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";b:0;s:9:\"plugin_id\";s:6:\"string\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:25:\"default_argument_skip_url\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}}s:8:\"displays\";a:2:{s:7:\"default\";s:7:\"default\";s:6:\"page_1\";s:6:\"page_1\";}s:17:\"inherit_arguments\";b:0;s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:8:\"glossary\";s:4:\"menu\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:8:\"Glossary\";s:6:\"weight\";i:0;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.portfolio_boxed','a:13:{s:4:\"uuid\";s:36:\"0e10f7c5-a2f1-4cf9-98fc-717973950acf\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:31:\"field.storage.node.field_images\";i:1;s:43:\"field.storage.node.field_portfolio_category\";i:2;s:30:\"image.style.portfolio_570x367_\";i:3;s:31:\"image.style.portfolio_650xauto_\";i:4;s:30:\"image.style.portfolio_952x_613\";i:5;s:22:\"node.type.nd_portfolio\";}s:6:\"module\";a:4:{i:0;s:5:\"image\";i:1;s:4:\"node\";i:2;s:10:\"rhythm_cms\";i:3;s:4:\"user\";}}s:2:\"id\";s:15:\"portfolio_boxed\";s:5:\"label\";s:9:\"Portfolio\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:17:\"portfolio_isotope\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:36:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:6;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"3\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_570x367_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:23:\"Boxed Gutter: 2 Columns\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:16:\"Boxed: 2 Columns\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:15:\"portfolio-boxed\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb\";s:6:\"weight\";i:-50;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:16:\"Boxed: 2 Columns\";s:8:\"defaults\";a:1:{s:5:\"title\";b:0;}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_10\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_10\";s:13:\"display_title\";s:29:\"Boxed Gutter: 5 Columns Black\";s:8:\"position\";i:10;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:38:\"portfolio-boxed-gutter-5-black-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:11:\"Black Hover\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962\";s:6:\"weight\";i:-50;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:29:\"Boxed Gutter: 5 Columns Black\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"5\";s:9:\"grid_type\";s:0:\"\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:0:\"\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:15;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_11\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_11\";s:13:\"display_title\";s:22:\"Boxed Title: 2 Columns\";s:8:\"position\";i:11;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:31:\"portfolio-boxed-title-2-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6\";s:6:\"weight\";i:-51;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:22:\"Boxed Title: 2 Columns\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"2\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:15;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_12\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_12\";s:13:\"display_title\";s:22:\"Boxed Title: 3 Columns\";s:8:\"position\";i:11;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:31:\"portfolio-boxed-title-3-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6\";s:6:\"weight\";i:-51;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:22:\"Boxed Title: 3 Columns\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"3\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:9;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_13\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_13\";s:13:\"display_title\";s:22:\"Boxed Title: 4 Columns\";s:8:\"position\";i:11;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:31:\"portfolio-boxed-title-4-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6\";s:6:\"weight\";i:-51;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:22:\"Boxed Title: 4 Columns\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"4\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:8;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_14\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_14\";s:13:\"display_title\";s:22:\"Boxed Title: 5 Columns\";s:8:\"position\";i:11;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:31:\"portfolio-boxed-title-5-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"5 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6\";s:6:\"weight\";i:-51;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:22:\"Boxed Title: 5 Columns\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:15;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_15\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_15\";s:13:\"display_title\";s:28:\"Boxed Title: 5 Columns Black\";s:8:\"position\";i:11;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:37:\"portfolio-boxed-title-5-columns-black\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:11:\"Black Hover\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6\";s:6:\"weight\";i:-51;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:28:\"Boxed Title: 5 Columns Black\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:0:\"\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:15;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_16\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_16\";s:13:\"display_title\";s:21:\"Boxed Wide: 2 Columns\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:30:\"portfolio-boxed-wide-2-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a\";s:6:\"weight\";i:-61;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:21:\"Boxed Wide: 2 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"2\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:6;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_952x_613\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_17\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_17\";s:13:\"display_title\";s:21:\"Boxed Wide: 3 Columns\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:30:\"portfolio-boxed-wide-3-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a\";s:6:\"weight\";i:-60;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:21:\"Boxed Wide: 3 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"3\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:6;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_952x_613\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_18\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_18\";s:13:\"display_title\";s:21:\"Boxed Wide: 4 Columns\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:30:\"portfolio-boxed-wide-4-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a\";s:6:\"weight\";i:-59;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:21:\"Boxed Wide: 4 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"4\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:8;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_952x_613\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_19\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_19\";s:13:\"display_title\";s:21:\"Boxed Wide: 5 Columns\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:30:\"portfolio-boxed-wide-5-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"5 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a\";s:6:\"weight\";i:-58;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:21:\"Boxed Wide: 5 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:15;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_570x367_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:6:\"page_2\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:16:\"Boxed: 3 Columns\";s:8:\"position\";i:2;s:15:\"display_options\";a:8:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:25:\"portfolio-boxed-3-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"3\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:8:\"defaults\";a:3:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"title\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:16:\"Boxed: 3 Columns\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_20\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_20\";s:13:\"display_title\";s:26:\"Boxed Wide: 5 Columns Dark\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:35:\"portfolio-boxed-wide-5-columns-dark\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:11:\"Black Hover\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a\";s:6:\"weight\";i:-57;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:26:\"Boxed Wide: 5 Columns Dark\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:0:\"\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:15;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_570x367_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_21\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_21\";s:13:\"display_title\";s:18:\"Gutter Wide: 2 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:31:\"portfolio-gutter-wide-2-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f\";s:6:\"weight\";i:-67;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:22:\"Gutter Wide: 2 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"2\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:6;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_952x_613\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_22\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_22\";s:13:\"display_title\";s:18:\"Gutter Wide: 3 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:31:\"portfolio-gutter-wide-3-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f\";s:6:\"weight\";i:-66;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:22:\"Gutter Wide: 3 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"3\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:9;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_952x_613\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_23\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_23\";s:13:\"display_title\";s:18:\"Gutter Wide: 4 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:31:\"portfolio-gutter-wide-4-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f\";s:6:\"weight\";i:-65;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:22:\"Gutter Wide: 4 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"4\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:8;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_570x367_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_24\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_24\";s:13:\"display_title\";s:18:\"Gutter Wide: 5 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:31:\"portfolio-gutter-wide-5-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"5 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f\";s:6:\"weight\";i:-64;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:22:\"Gutter Wide: 5 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_570x367_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_25\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_25\";s:13:\"display_title\";s:23:\"Gutter Wide: 5 Col Dark\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:36:\"portfolio-gutter-wide-5-columns-dark\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:12:\"Black Hovers\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f\";s:6:\"weight\";i:-63;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:27:\"Gutter Wide: 5 Columns Dark\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:0:\"\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_570x367_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_26\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_26\";s:13:\"display_title\";s:17:\"Wide Title: 2 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:30:\"portfolio-title-wide-2-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8\";s:6:\"weight\";i:-73;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:21:\"Wide Title: 2 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"2\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:6;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_952x_613\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_27\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_27\";s:13:\"display_title\";s:17:\"Wide Title: 3 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:30:\"portfolio-title-wide-3-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8\";s:6:\"weight\";i:-72;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:21:\"Wide Title: 3 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"3\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:6;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_952x_613\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_28\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_28\";s:13:\"display_title\";s:17:\"Wide Title: 4 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:30:\"portfolio-title-wide-4-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8\";s:6:\"weight\";i:-71;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:21:\"Wide Title: 4 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"4\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:8;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_570x367_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_29\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_29\";s:13:\"display_title\";s:17:\"Wide Title: 5 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:30:\"portfolio-title-wide-5-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"5 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8\";s:6:\"weight\";i:-70;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:21:\"Wide Title: 5 Columns\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_570x367_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:6:\"page_3\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_3\";s:13:\"display_title\";s:16:\"Boxed: 4 Columns\";s:8:\"position\";i:3;s:15:\"display_options\";a:8:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:25:\"portfolio-boxed-4-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"4\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:23:\"hide-titles hover-white\";}}s:8:\"defaults\";a:3:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"title\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:16:\"Boxed: 4 Columns\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_30\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_30\";s:13:\"display_title\";s:22:\"Wide Title: 5 Col Dark\";s:8:\"position\";i:11;s:15:\"display_options\";a:10:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:35:\"portfolio-title-wide-5-columns-dark\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:12:\"Black Hovers\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8\";s:6:\"weight\";i:-69;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:26:\"Wide Title: 5 Columns Dark\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:0:\"\";s:10:\"title_show\";s:0:\"\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:18:\"portfolio_570x367_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_31\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_31\";s:13:\"display_title\";s:14:\"Masonry: 2 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:11:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:27:\"portfolio-masonry-2-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2\";s:6:\"weight\";i:-75;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:14:\"Masonry: 2 Col\";s:8:\"defaults\";a:6:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"2\";s:9:\"grid_type\";s:7:\"masonry\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:6;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:19:\"portfolio_650xauto_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_32\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_32\";s:13:\"display_title\";s:14:\"Masonry: 3 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:11:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:27:\"portfolio-masonry-3-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2\";s:6:\"weight\";i:-75;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:14:\"Masonry: 3 Col\";s:8:\"defaults\";a:6:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"3\";s:9:\"grid_type\";s:7:\"masonry\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:9;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:19:\"portfolio_650xauto_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_33\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_33\";s:13:\"display_title\";s:14:\"Masonry: 4 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:11:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:27:\"portfolio-masonry-4-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2\";s:6:\"weight\";i:-75;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:14:\"Masonry: 4 Col\";s:8:\"defaults\";a:6:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"4\";s:9:\"grid_type\";s:7:\"masonry\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:19:\"portfolio_650xauto_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_34\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_34\";s:13:\"display_title\";s:14:\"Masonry: 5 Col\";s:8:\"position\";i:11;s:15:\"display_options\";a:11:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:27:\"portfolio-masonry-5-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"5 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2\";s:6:\"weight\";i:-75;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:14:\"Masonry: 5 Col\";s:8:\"defaults\";a:6:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"5\";s:9:\"grid_type\";s:7:\"masonry\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:19:\"portfolio_650xauto_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:7:\"page_35\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:7:\"page_35\";s:13:\"display_title\";s:19:\"Masonry: 5 Col Dark\";s:8:\"position\";i:11;s:15:\"display_options\";a:11:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:32:\"portfolio-masonry-5-columns-dark\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:12:\"Black Hovers\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2\";s:6:\"weight\";i:-75;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:19:\"Masonry: 5 Col Dark\";s:8:\"defaults\";a:6:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:7:\"columns\";s:1:\"5\";s:9:\"grid_type\";s:7:\"masonry\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:0:\"\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:6:\"fields\";a:4:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:19:\"portfolio_650xauto_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:24:\"field_portfolio_category\";a:35:{s:2:\"id\";s:24:\"field_portfolio_category\";s:5:\"table\";s:30:\"node__field_portfolio_category\";s:5:\"field\";s:24:\"field_portfolio_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\" \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:6:\"page_4\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_4\";s:13:\"display_title\";s:16:\"Boxed: 5 Columns\";s:8:\"position\";i:4;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:25:\"portfolio-boxed-5-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"5 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:8:\"defaults\";a:4:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"title\";b:0;s:5:\"pager\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:16:\"Boxed: 5 Columns\";s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:15;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:6:\"page_5\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_5\";s:13:\"display_title\";s:23:\"Boxed Gutter: 2 Columns\";s:8:\"position\";i:6;s:15:\"display_options\";a:8:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:32:\"portfolio-boxed-gutter-2-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962\";s:6:\"weight\";i:-50;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:23:\"Boxed Gutter: 2 Columns\";s:8:\"defaults\";a:3:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"3\";s:9:\"grid_type\";s:0:\"\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:6:\"page_6\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_6\";s:13:\"display_title\";s:23:\"Boxed Gutter: 3 Columns\";s:8:\"position\";i:7;s:15:\"display_options\";a:8:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:32:\"portfolio-boxed-gutter-3-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962\";s:6:\"weight\";i:-50;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:23:\"Boxed Gutter: 3 Columns\";s:8:\"defaults\";a:3:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"3\";s:9:\"grid_type\";s:0:\"\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:6:\"page_7\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_7\";s:13:\"display_title\";s:23:\"Boxed Gutter: 4 Columns\";s:8:\"position\";i:8;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:32:\"portfolio-boxed-gutter-4-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962\";s:6:\"weight\";i:-50;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:23:\"Boxed Gutter: 4 Columns\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"4\";s:9:\"grid_type\";s:0:\"\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:8;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:6:\"page_8\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_8\";s:13:\"display_title\";s:23:\"Boxed Gutter: 5 Columns\";s:8:\"position\";i:9;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:32:\"portfolio-boxed-gutter-5-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:9:\"5 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962\";s:6:\"weight\";i:-50;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"title\";s:23:\"Boxed Gutter: 5 Columns\";s:8:\"defaults\";a:4:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"pager\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"5\";s:9:\"grid_type\";s:0:\"\";s:4:\"type\";s:14:\" work-grid-gut\";s:5:\"hover\";s:11:\"hover-white\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:15;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}s:6:\"page_9\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_9\";s:13:\"display_title\";s:22:\"Boxed: 5 Columns Black\";s:8:\"position\";i:5;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:31:\"portfolio-boxed-5-columns-black\";s:4:\"menu\";a:8:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:11:\"Black Hover\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"style\";a:2:{s:4:\"type\";s:19:\"nd_portfolio_filter\";s:7:\"options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:7:\"columns\";s:1:\"5\";s:4:\"type\";s:0:\"\";s:5:\"hover\";s:0:\"\";s:10:\"title_show\";s:11:\"hide-titles\";s:12:\"field_filter\";s:24:\"field_portfolio_category\";s:7:\"classes\";s:0:\"\";}}s:8:\"defaults\";a:4:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"title\";b:0;s:5:\"pager\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:22:\"Boxed: 5 Columns Black\";s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:15;s:6:\"offset\";i:0;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:2:{i:0;s:38:\"config:field.storage.node.field_images\";i:1;s:50:\"config:field.storage.node.field_portfolio_category\";}}}}}'),

('','views.view.portfolio_parallax','a:13:{s:4:\"uuid\";s:36:\"0a8078da-b243-4132-8896-07782de7e7f9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:22:\"node.type.nd_portfolio\";i:1;s:16:\"system.menu.main\";}s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:4:\"node\";i:2;s:4:\"user\";}}s:2:\"id\";s:18:\"portfolio_parallax\";s:5:\"label\";s:18:\"Portfolio Parallax\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:1;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:1:{s:4:\"type\";s:7:\"default\";}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:6:\"fields\";a:3:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:2:\"h2\";s:13:\"element_class\";s:34:\"hs-line-14 font-alt mb-50 mb-xs-30\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}s:3:\"uri\";a:37:{s:2:\"id\";s:3:\"uri\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"uri\";s:12:\"relationship\";s:22:\"field_images_target_id\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:8:\"file_uri\";s:8:\"settings\";a:2:{s:12:\"link_to_file\";b:0;s:18:\"file_download_path\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"uri\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:18:\"Portfolio Parallax\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:22:\"field_images_target_id\";a:8:{s:2:\"id\";s:22:\"field_images_target_id\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:22:\"field_images_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:23:\"image from field_images\";s:8:\"required\";b:0;s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:18:\"portfolio-parallax\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:18:\"Portfolio Parallax\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.portfolio_promo','a:13:{s:4:\"uuid\";s:36:\"d56aa3ad-b600-417e-938d-320bf976af63\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:23:\"field.storage.node.body\";i:1;s:31:\"field.storage.node.field_images\";i:2;s:37:\"field.storage.node.field_project_link\";i:3;s:30:\"image.style.portfolio_653x368_\";i:4;s:22:\"node.type.nd_portfolio\";i:5;s:16:\"system.menu.main\";}s:6:\"module\";a:4:{i:0;s:4:\"node\";i:1;s:10:\"rhythm_cms\";i:2;s:4:\"text\";i:3;s:4:\"user\";}}s:2:\"id\";s:15:\"portfolio_promo\";s:5:\"label\";s:15:\"Portfolio Promo\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:1;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:3:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:10:\"promo-view\";s:17:\"default_row_class\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:6:\"fields\";a:5:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:2:\"h2\";s:13:\"element_class\";s:34:\"hs-line-14 font-alt mb-50 mb-xs-30\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:4:\"NONE\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:0;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:24:\"rhythm_cms_images_slider\";s:8:\"settings\";a:1:{s:11:\"image_style\";s:18:\"portfolio_653x368_\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:1;s:9:\"plugin_id\";s:5:\"field\";}s:18:\"field_project_link\";a:35:{s:2:\"id\";s:18:\"field_project_link\";s:5:\"table\";s:24:\"node__field_project_link\";s:5:\"field\";s:18:\"field_project_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:3:\"div\";s:13:\"element_class\";s:5:\"mt-40\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:3:\"uri\";s:4:\"type\";s:22:\"rhythm_cms_button_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"body\";a:35:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:10:\"node__body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:1;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:200;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:15:\"Portfolio Promo\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:3:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";i:2;s:44:\"config:field.storage.node.field_project_link\";}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:15:\"portfolio-promo\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:15:\"Portfolio Promo\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:3:{i:0;s:30:\"config:field.storage.node.body\";i:1;s:38:\"config:field.storage.node.field_images\";i:2;s:44:\"config:field.storage.node.field_project_link\";}}}}}'),

('','views.view.products_archive','a:13:{s:4:\"uuid\";s:36:\"851fa1ae-f995-4c8f-b2d6-c99da72d8f45\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"core.entity_view_mode.commerce_product.teaser\";}s:6:\"module\";a:2:{i:0;s:8:\"commerce\";i:1;s:16:\"commerce_product\";}}s:2:\"id\";s:16:\"products_archive\";s:5:\"label\";s:16:\"Products archive\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:27:\"commerce_product_field_data\";s:10:\"base_field\";s:10:\"product_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:5;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:11:\"uses_fields\";b:0;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:11:\"widget-body\";s:5:\"class\";s:21:\"clearlist widget-menu\";}}s:3:\"row\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"fields\";a:1:{s:5:\"title\";a:37:{s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:5:\"title\";s:2:\"id\";s:5:\"title\";s:11:\"entity_type\";N;s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;}}s:7:\"filters\";a:2:{s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:15:\"product_display\";s:15:\"product_display\";}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";}}s:5:\"title\";s:15:\"Monthly archive\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:1:{s:7:\"created\";a:21:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:2:\"%1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";}s:4:\"tags\";a:0:{}}}s:5:\"block\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.products_best_sellers','a:13:{s:4:\"uuid\";s:36:\"62175247-1c62-4180-8bd9-b056b7bdc790\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:5:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:43:\"field.storage.commerce_product.field_rating\";i:2;s:53:\"field.storage.commerce_product_variation.field_images\";i:3;s:56:\"field.storage.commerce_product_variation.field_old_price\";i:4;s:25:\"image.style.product_70x70\";}s:6:\"module\";a:5:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_price\";i:2;s:16:\"commerce_product\";i:3;s:8:\"fivestar\";i:4;s:5:\"image\";}}s:2:\"id\";s:21:\"products_best_sellers\";s:5:\"label\";s:21:\"Products best sellers\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:27:\"commerce_product_field_data\";s:10:\"base_field\";s:10:\"product_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:4;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:8:\"clearfix\";s:17:\"default_row_class\";b:0;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:11:\"widget-body\";s:5:\"class\";s:22:\"clearlist widget-posts\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:5:{s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:40:\"commerce_product_variation__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:3:\"div\";s:13:\"element_class\";s:16:\"widget-posts-img\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:13:\"product_70x70\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:15:\"field_old_price\";a:35:{s:2:\"id\";s:15:\"field_old_price\";s:5:\"table\";s:43:\"commerce_product_variation__field_old_price\";s:5:\"field\";s:15:\"field_old_price\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:32:\"<del>{{ field_old_price }}</del>\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:13:\"price__number\";a:37:{s:2:\"id\";s:13:\"price__number\";s:5:\"table\";s:37:\"commerce_product_variation_field_data\";s:5:\"field\";s:13:\"price__number\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:12:\"entity_field\";s:5:\"price\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_rating\";a:35:{s:2:\"id\";s:12:\"field_rating\";s:5:\"table\";s:30:\"commerce_product__field_rating\";s:5:\"field\";s:12:\"field_rating\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"rating\";s:4:\"type\";s:14:\"fivestar_stars\";s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:52:\"modules/contrib/fivestar/widgets/outline/outline.css\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:3:{s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:15:\"product_display\";s:15:\"product_display\";}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:5:\"delta\";a:14:{s:2:\"id\";s:5:\"delta\";s:5:\"table\";s:28:\"commerce_product__variations\";s:5:\"field\";s:5:\"delta\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:1:\"0\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:13:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:11:\"placeholder\";s:0:\"\";s:15:\"min_placeholder\";s:0:\"\";s:15:\"max_placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"numeric\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";}}s:5:\"title\";s:21:\"Products best sellers\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:10:\"variations\";a:8:{s:2:\"id\";s:10:\"variations\";s:5:\"table\";s:28:\"commerce_product__variations\";s:5:\"field\";s:10:\"variations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:29:\"variations: Product variation\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";}s:4:\"tags\";a:3:{i:0;s:50:\"config:field.storage.commerce_product.field_rating\";i:1;s:60:\"config:field.storage.commerce_product_variation.field_images\";i:2;s:63:\"config:field.storage.commerce_product_variation.field_old_price\";}}}s:5:\"block\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";}s:4:\"tags\";a:3:{i:0;s:50:\"config:field.storage.commerce_product.field_rating\";i:1;s:60:\"config:field.storage.commerce_product_variation.field_images\";i:2;s:63:\"config:field.storage.commerce_product_variation.field_old_price\";}}}}}'),

('','views.view.products_comments','a:13:{s:4:\"uuid\";s:36:\"0e4ee9ae-006d-4f60-8435-7cd9990d409f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:28:\"comment.type.default_reviews\";}s:6:\"module\";a:3:{i:0;s:7:\"comment\";i:1;s:16:\"commerce_product\";i:2;s:4:\"user\";}}s:2:\"id\";s:17:\"products_comments\";s:5:\"label\";s:17:\"Products comments\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:18:\"comment_field_data\";s:10:\"base_field\";s:3:\"cid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:15:\"access comments\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:5;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:11:\"widget-body\";s:5:\"class\";s:25:\"clearlist widget-comments\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;}}s:13:\"relationships\";a:1:{s:16:\"commerce_product\";a:9:{s:2:\"id\";s:16:\"commerce_product\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:16:\"commerce_product\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:7:\"Product\";s:8:\"required\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"fields\";a:2:{s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:13:\"{{ name }} on\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:16:\"commerce_product\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:12:\"comment_type\";a:8:{s:2:\"id\";s:12:\"comment_type\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:12:\"comment_type\";s:5:\"value\";a:1:{s:15:\"default_reviews\";s:15:\"default_reviews\";}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:12:\"comment_type\";s:9:\"plugin_id\";s:6:\"bundle\";s:5:\"group\";i:1;}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:17:\"Products comments\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.products_tags','a:13:{s:4:\"uuid\";s:36:\"88cb8c71-02f6-44e9-9a43-56dfd89f696f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:24:\"taxonomy.vocabulary.tags\";}s:6:\"module\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:4:\"user\";}}s:2:\"id\";s:13:\"products_tags\";s:5:\"label\";s:13:\"Products Tags\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:24:\"taxonomy_term_field_data\";s:10:\"base_field\";s:3:\"tid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:0;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:3:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:4:\"tags\";s:17:\"default_row_class\";b:0;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:1:{s:4:\"name\";a:38:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:14:\"convert_spaces\";b:0;s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:9:\"term_name\";}}s:7:\"filters\";a:2:{s:3:\"vid\";a:7:{s:2:\"id\";s:3:\"vid\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:3:\"vid\";s:5:\"value\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:3:\"vid\";s:9:\"plugin_id\";s:6:\"bundle\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:13:\"Products Tags\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:5:\"block\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"display_extenders\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:7:\"filters\";a:1:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.profiles','a:13:{s:4:\"uuid\";s:36:\"89a32dce-3d25-460d-9bbd-7818c16f5392\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"profile\";}}s:2:\"id\";s:8:\"profiles\";s:5:\"label\";s:8:\"Profiles\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:7:\"profile\";s:10:\"base_field\";s:10:\"profile_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:4;s:15:\"automatic_width\";b:1;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:1;s:16:\"col_class_custom\";s:0:\"\";s:17:\"row_class_default\";b:1;s:16:\"row_class_custom\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"fields\";a:2:{s:15:\"rendered_entity\";a:24:{s:2:\"id\";s:15:\"rendered_entity\";s:5:\"table\";s:7:\"profile\";s:5:\"field\";s:15:\"rendered_entity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"view_mode\";s:7:\"default\";s:11:\"entity_type\";s:7:\"profile\";s:9:\"plugin_id\";s:15:\"rendered_entity\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:7:\"profile\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:7:\"profile\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:0:{}s:5:\"sorts\";a:2:{s:10:\"is_default\";a:12:{s:2:\"id\";s:10:\"is_default\";s:5:\"table\";s:7:\"profile\";s:5:\"field\";s:10:\"is_default\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"entity_type\";s:7:\"profile\";s:12:\"entity_field\";s:10:\"is_default\";s:9:\"plugin_id\";s:8:\"standard\";}s:10:\"profile_id\";a:12:{s:2:\"id\";s:10:\"profile_id\";s:5:\"table\";s:7:\"profile\";s:5:\"field\";s:10:\"profile_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"entity_type\";s:7:\"profile\";s:12:\"entity_field\";s:10:\"profile_id\";s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:10:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";a:2:{s:5:\"value\";s:26:\"There are no profiles yet.\";s:6:\"format\";s:10:\"basic_html\";}s:9:\"plugin_id\";s:4:\"text\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:3:{s:3:\"uid\";a:23:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:7:\"profile\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:4:\"user\";s:24:\"default_argument_options\";a:1:{s:4:\"user\";b:0;}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:7:\"profile\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:7:\"numeric\";}s:4:\"type\";a:27:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:7:\"profile\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:6:\"ignore\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:8:\"glossary\";b:0;s:5:\"limit\";i:0;s:4:\"case\";s:4:\"none\";s:9:\"path_case\";s:4:\"none\";s:14:\"transform_dash\";b:0;s:12:\"break_phrase\";b:0;s:11:\"entity_type\";s:7:\"profile\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"string\";}s:6:\"status\";a:23:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:7:\"profile\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:6:\"ignore\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:7:\"profile\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:17:\"display_extenders\";a:0:{}s:5:\"title\";s:8:\"Profiles\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";}s:4:\"tags\";a:0:{}}}s:9:\"user_page\";a:6:{s:14:\"display_plugin\";s:5:\"embed\";s:2:\"id\";s:9:\"user_page\";s:13:\"display_title\";s:9:\"User page\";s:8:\"position\";i:1;s:15:\"display_options\";a:2:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.related_products','a:13:{s:4:\"uuid\";s:36:\"5531784a-21ee-4ade-b2b0-fabf4642f3cc\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:53:\"core.entity_view_mode.commerce_product_variation.cart\";i:2;s:53:\"field.storage.commerce_product_variation.field_images\";i:3;s:56:\"field.storage.commerce_product_variation.field_old_price\";i:4;s:56:\"field.storage.commerce_product_variation.field_sale_text\";i:5;s:27:\"image.style.product_263x335\";}s:6:\"module\";a:4:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_price\";i:2;s:16:\"commerce_product\";i:3;s:5:\"image\";}}s:2:\"id\";s:16:\"related_products\";s:5:\"label\";s:16:\"Related Products\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:27:\"commerce_product_field_data\";s:10:\"base_field\";s:10:\"product_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:4;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:8:\"grouping\";a:0:{}s:7:\"columns\";i:4;s:15:\"automatic_width\";b:1;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:0;s:16:\"col_class_custom\";s:23:\"col-lg-3 mb-60 mb-xs-40\";s:17:\"row_class_default\";b:0;s:16:\"row_class_custom\";s:0:\"\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:6:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:13:\"price__number\";a:37:{s:2:\"id\";s:13:\"price__number\";s:5:\"table\";s:37:\"commerce_product_variation_field_data\";s:5:\"field\";s:13:\"price__number\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:12:\"entity_field\";s:5:\"price\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:40:\"commerce_product_variation__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:15:\"product_263x335\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:15:\"field_sale_text\";a:35:{s:2:\"id\";s:15:\"field_sale_text\";s:5:\"table\";s:43:\"commerce_product_variation__field_sale_text\";s:5:\"field\";s:15:\"field_sale_text\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:15:\"field_old_price\";a:35:{s:2:\"id\";s:15:\"field_old_price\";s:5:\"table\";s:43:\"commerce_product_variation__field_old_price\";s:5:\"field\";s:15:\"field_old_price\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:6:\"number\";s:4:\"type\";s:22:\"commerce_price_default\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:15:\"rendered_entity\";a:24:{s:2:\"id\";s:15:\"rendered_entity\";s:5:\"table\";s:26:\"commerce_product_variation\";s:5:\"field\";s:15:\"rendered_entity\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"view_mode\";s:4:\"cart\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:9:\"plugin_id\";s:15:\"rendered_entity\";}}s:7:\"filters\";a:1:{s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:15:\"product_display\";s:15:\"product_display\";}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:16:\"Related Products\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:10:\"variations\";a:8:{s:2:\"id\";s:10:\"variations\";s:5:\"table\";s:28:\"commerce_product__variations\";s:5:\"field\";s:10:\"variations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:29:\"variations: Product variation\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";}s:4:\"tags\";a:8:{i:0;s:71:\"config:core.entity_view_display.commerce_product_variation.default.cart\";i:1;s:74:\"config:core.entity_view_display.commerce_product_variation.default.summary\";i:2;s:71:\"config:core.entity_view_display.commerce_product_variation.product.cart\";i:3;s:74:\"config:core.entity_view_display.commerce_product_variation.product.default\";i:4;s:74:\"config:core.entity_view_display.commerce_product_variation.product.product\";i:5;s:60:\"config:field.storage.commerce_product_variation.field_images\";i:6;s:63:\"config:field.storage.commerce_product_variation.field_old_price\";i:7;s:63:\"config:field.storage.commerce_product_variation.field_sale_text\";}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";}s:4:\"tags\";a:8:{i:0;s:71:\"config:core.entity_view_display.commerce_product_variation.default.cart\";i:1;s:74:\"config:core.entity_view_display.commerce_product_variation.default.summary\";i:2;s:71:\"config:core.entity_view_display.commerce_product_variation.product.cart\";i:3;s:74:\"config:core.entity_view_display.commerce_product_variation.product.default\";i:4;s:74:\"config:core.entity_view_display.commerce_product_variation.product.product\";i:5;s:60:\"config:field.storage.commerce_product_variation.field_images\";i:6;s:63:\"config:field.storage.commerce_product_variation.field_old_price\";i:7;s:63:\"config:field.storage.commerce_product_variation.field_sale_text\";}}}}}'),

('','views.view.related_projects','a:13:{s:4:\"uuid\";s:36:\"4e8756eb-daaf-4100-a3c8-4458c635ee78\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:31:\"field.storage.node.field_images\";i:1;s:28:\"image.style.gallery_360x232_\";i:2;s:22:\"node.type.nd_portfolio\";i:3;s:38:\"taxonomy.vocabulary.portfolio_category\";}s:6:\"module\";a:4:{i:0;s:5:\"image\";i:1;s:4:\"node\";i:2;s:8:\"taxonomy\";i:3;s:4:\"user\";}}s:2:\"id\";s:16:\"related_projects\";s:5:\"label\";s:16:\"Related Projects\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:4;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:9:\"work-item\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:0:\"\";s:5:\"class\";s:54:\"works-grid work-grid-gut clearfix font-alt hover-white\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:3:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:12:\"field_images\";a:35:{s:2:\"id\";s:12:\"field_images\";s:5:\"table\";s:18:\"node__field_images\";s:5:\"field\";s:12:\"field_images\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:16:\"gallery_360x232_\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:1;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";}s:4:\"path\";a:25:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"entity_link\";s:18:\"output_url_as_text\";b:1;}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:16:\"Related Projects\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:1:{s:3:\"tid\";a:23:{s:2:\"id\";s:3:\"tid\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:3:\"tid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:12:\"taxonomy_tid\";s:24:\"default_argument_options\";a:5:{s:4:\"node\";b:1;s:5:\"limit\";b:1;s:4:\"vids\";a:1:{s:18:\"portfolio_category\";s:18:\"portfolio_category\";}s:6:\"anyall\";s:1:\",\";s:9:\"term_page\";s:1:\"0\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:9:\"add_table\";b:0;s:13:\"require_value\";b:0;s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:18:\"taxonomy_index_tid\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:38:\"config:field.storage.node.field_images\";}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:38:\"config:field.storage.node.field_images\";}}}}}'),

('','views.view.shop_categories','a:13:{s:4:\"uuid\";s:36:\"9680fbd2-7f75-4151-9028-545698faf51c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:28:\"taxonomy.vocabulary.category\";}s:6:\"module\";a:3:{i:0;s:16:\"commerce_product\";i:1;s:8:\"taxonomy\";i:2;s:4:\"user\";}}s:2:\"id\";s:15:\"shop_categories\";s:5:\"label\";s:15:\"Shop Categories\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:24:\"taxonomy_term_field_data\";s:10:\"base_field\";s:3:\"tid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:0;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:0;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:11:\"widget-body\";s:5:\"class\";s:21:\"clearlist widget-menu\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:3:{s:3:\"tid\";a:37:{s:2:\"id\";s:3:\"tid\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:3:\"tid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:3:\"tid\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"product_id\";a:44:{s:2:\"id\";s:10:\"product_id\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:10:\"product_id\";s:12:\"relationship\";s:41:\"reverse__commerce_product__field_category\";s:10:\"group_type\";s:5:\"count\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:10:\"product_id\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:38:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:107:\"<a href=\"{{ url(\'view.shop_columns.page_1\') }}/{{ tid }}\">{{ name }} <small> - {{ product_id }}</small></a>\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:14:\"convert_spaces\";b:0;s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:9:\"term_name\";}}s:7:\"filters\";a:2:{s:3:\"vid\";a:7:{s:2:\"id\";s:3:\"vid\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:3:\"vid\";s:5:\"value\";a:1:{s:8:\"category\";s:8:\"category\";}s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:3:\"vid\";s:9:\"plugin_id\";s:6:\"bundle\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:15:\"Shop Categories\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:41:\"reverse__commerce_product__field_category\";a:9:{s:2:\"id\";s:41:\"reverse__commerce_product__field_category\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:41:\"reverse__commerce_product__field_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:14:\"field_category\";s:8:\"required\";b:1;s:11:\"entity_type\";s:13:\"taxonomy_term\";s:9:\"plugin_id\";s:14:\"entity_reverse\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"group_by\";b:1;}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:5:\"block\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:15:\"Shop Categories\";s:8:\"position\";i:1;s:15:\"display_options\";a:5:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:7:\"filters\";a:1:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.shop_columns','a:13:{s:4:\"uuid\";s:36:\"7e7068b6-9d17-4ad8-bf0e-d4f8a83a73a7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"core.entity_view_mode.commerce_product.teaser\";i:2;s:16:\"system.menu.main\";}s:6:\"module\";a:3:{i:0;s:8:\"commerce\";i:1;s:16:\"commerce_product\";i:2;s:8:\"taxonomy\";}}s:2:\"id\";s:12:\"shop_columns\";s:5:\"label\";s:12:\"Shop Columns\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:27:\"commerce_product_field_data\";s:10:\"base_field\";s:10:\"product_id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:4:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:19:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:11:\"Low to High\";s:15:\"sort_desc_label\";s:11:\"High to Low\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:8;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:9;s:4:\"tags\";a:4:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:11:\"uses_fields\";b:0;s:7:\"columns\";i:2;s:15:\"automatic_width\";b:1;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:0;s:16:\"col_class_custom\";s:23:\"col-lg-6 mb-60 mb-xs-40\";s:17:\"row_class_default\";b:0;s:16:\"row_class_custom\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"fields\";a:1:{s:5:\"title\";a:37:{s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:5:\"title\";s:2:\"id\";s:5:\"title\";s:11:\"entity_type\";N;s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;}}s:7:\"filters\";a:4:{s:4:\"type\";a:8:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:15:\"product_display\";s:15:\"product_display\";}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";s:5:\"group\";i:1;}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:5:\"delta\";a:14:{s:2:\"id\";s:5:\"delta\";s:5:\"table\";s:28:\"commerce_product__variations\";s:5:\"field\";s:5:\"delta\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:1:\"0\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:13:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:11:\"placeholder\";s:0:\"\";s:15:\"min_placeholder\";s:0:\"\";s:15:\"max_placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"numeric\";}s:13:\"price__number\";a:16:{s:2:\"id\";s:13:\"price__number\";s:5:\"table\";s:37:\"commerce_product_variation_field_data\";s:5:\"field\";s:13:\"price__number\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:7:\"between\";s:5:\"value\";a:3:{s:3:\"min\";s:1:\"0\";s:3:\"max\";s:7:\"1000000\";s:5:\"value\";s:0:\"\";}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:13:{s:11:\"operator_id\";s:16:\"price__number_op\";s:5:\"label\";s:5:\"Price\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:16:\"price__number_op\";s:10:\"identifier\";s:13:\"price__number\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";s:15:\"min_placeholder\";s:0:\"\";s:15:\"max_placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:12:\"entity_field\";s:5:\"price\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:5:\"sorts\";a:1:{s:13:\"price__number\";a:12:{s:2:\"id\";s:13:\"price__number\";s:5:\"table\";s:37:\"commerce_product_variation_field_data\";s:5:\"field\";s:13:\"price__number\";s:12:\"relationship\";s:10:\"variations\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:1;s:6:\"expose\";a:1:{s:5:\"label\";s:5:\"Price\";}s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:12:\"entity_field\";s:5:\"price\";s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"title\";s:14:\"Shop 2 Columns\";s:6:\"header\";a:1:{s:6:\"result\";a:9:{s:2:\"id\";s:6:\"result\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:6:\"result\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:0;s:7:\"content\";s:42:\"Displaying @start - @end of @total results\";s:9:\"plugin_id\";s:6:\"result\";}}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:2:{s:10:\"variations\";a:8:{s:2:\"id\";s:10:\"variations\";s:5:\"table\";s:28:\"commerce_product__variations\";s:5:\"field\";s:10:\"variations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:29:\"variations: Product variation\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:14:\"field_category\";a:8:{s:2:\"id\";s:14:\"field_category\";s:5:\"table\";s:32:\"commerce_product__field_category\";s:5:\"field\";s:14:\"field_category\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:29:\"field_category: Taxonomy term\";s:8:\"required\";b:0;s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:1:{s:3:\"tid\";a:23:{s:2:\"id\";s:3:\"tid\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";s:5:\"field\";s:3:\"tid\";s:12:\"relationship\";s:14:\"field_category\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:6:\"ignore\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:13:\"taxonomy_term\";s:12:\"entity_field\";s:3:\"tid\";s:9:\"plugin_id\";s:8:\"taxonomy\";}}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:8:\"use_ajax\";b:0;}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:22:\"url.query_args:sort_by\";i:5;s:25:\"url.query_args:sort_order\";}s:4:\"tags\";a:0:{}}}s:4:\"page\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:9:\"2 Columns\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:14:\"shop-2-columns\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:9:\"2 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354\";s:6:\"weight\";i:1;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:22:\"url.query_args:sort_by\";i:5;s:25:\"url.query_args:sort_order\";}s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:9:\"3 Columns\";s:8:\"position\";i:2;s:15:\"display_options\";a:8:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:14:\"shop-3-columns\";s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:14:\"Shop 3 Columns\";s:8:\"defaults\";a:3:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;}s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:9:\"3 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354\";s:6:\"weight\";i:2;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:11:\"uses_fields\";b:0;s:7:\"columns\";i:3;s:15:\"automatic_width\";b:1;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:0;s:16:\"col_class_custom\";s:23:\"col-lg-4 mb-60 mb-xs-40\";s:17:\"row_class_default\";b:0;s:16:\"row_class_custom\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:6:\"teaser\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:22:\"url.query_args:sort_by\";i:5;s:25:\"url.query_args:sort_order\";}s:4:\"tags\";a:0:{}}}s:6:\"page_2\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:9:\"4 Columns\";s:8:\"position\";i:3;s:15:\"display_options\";a:8:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:14:\"4-columns-shop\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:9:\"4 Columns\";s:11:\"description\";s:0:\"\";s:8:\"expanded\";b:0;s:6:\"parent\";s:54:\"menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354\";s:6:\"weight\";i:3;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:4:\"main\";}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:11:\"uses_fields\";b:0;s:7:\"columns\";i:4;s:15:\"automatic_width\";b:1;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:0;s:16:\"col_class_custom\";s:23:\"col-lg-3 mb-60 mb-xs-40\";s:17:\"row_class_default\";b:0;s:16:\"row_class_custom\";s:0:\"\";}}s:8:\"defaults\";a:3:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"title\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:6:\"teaser\";}}s:5:\"title\";s:14:\"Shop 4 Columns\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:22:\"url.query_args:sort_by\";i:5;s:25:\"url.query_args:sort_order\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.taxonomy_term','a:14:{s:4:\"uuid\";s:36:\"6a5124fa-e33c-4a2b-bdbd-673393232d89\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:33:\"core.entity_view_mode.node.teaser\";}s:6:\"module\";a:3:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Gy5PaLdfFhtFSRqJxV-DBTF5AocKgNA2CsCNNEbvx4c\";}s:2:\"id\";s:13:\"taxonomy_term\";s:5:\"label\";s:13:\"Taxonomy term\";s:6:\"module\";s:8:\"taxonomy\";s:11:\"description\";s:45:\"Content belonging to a certain taxonomy term.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:1:\"8\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:10:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:8:\"standard\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"created\";a:11:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:9:\"arguments\";a:1:{s:3:\"tid\";a:23:{s:2:\"id\";s:3:\"tid\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:3:\"tid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:19:\"{{ arguments.tid }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:4:{s:6:\"access\";b:1;s:9:\"operation\";s:4:\"view\";s:8:\"multiple\";i:0;s:7:\"bundles\";a:0:{}}s:12:\"break_phrase\";b:0;s:9:\"add_table\";b:0;s:13:\"require_value\";b:0;s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:18:\"taxonomy_index_tid\";}}s:7:\"filters\";a:2:{s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}s:6:\"status\";a:14:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"header\";a:1:{s:20:\"entity_taxonomy_term\";a:12:{s:2:\"id\";s:20:\"entity_taxonomy_term\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:20:\"entity_taxonomy_term\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:1;s:6:\"target\";s:23:\"{{ raw_arguments.tid }}\";s:9:\"view_mode\";s:4:\"full\";s:13:\"bypass_access\";b:0;s:9:\"plugin_id\";s:6:\"entity\";}}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"link_url\";s:0:\"\";s:12:\"link_display\";s:6:\"page_1\";}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"feed_1\";a:6:{s:2:\"id\";s:6:\"feed_1\";s:13:\"display_title\";s:4:\"Feed\";s:14:\"display_plugin\";s:4:\"feed\";s:8:\"position\";i:2;s:15:\"display_options\";a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:4:\"path\";s:20:\"taxonomy/term/%/feed\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";s:1:\"0\";}s:5:\"style\";a:2:{s:4:\"type\";s:3:\"rss\";s:7:\"options\";a:3:{s:11:\"description\";s:0:\"\";s:8:\"grouping\";a:0:{}s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:8:\"node_rss\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:7:\"default\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:15:\"taxonomy/term/%\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.team','a:13:{s:4:\"uuid\";s:36:\"bd05a105-83e0-4caf-8f29-1203ec714128\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:31:\"core.entity_view_mode.node.full\";i:1;s:19:\"node.type.nd_person\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:2:\"id\";s:4:\"team\";s:5:\"label\";s:4:\"Team\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:4;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:11:\"uses_fields\";b:0;s:7:\"columns\";i:4;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:0;s:16:\"col_class_custom\";s:0:\"\";s:17:\"row_class_default\";b:0;s:16:\"row_class_custom\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:4:\"full\";}}s:6:\"fields\";a:1:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;}s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:9:\"nd_person\";s:9:\"nd_person\";}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:5:\"title\";s:4:\"Team\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:8:\"4 Person\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:4;s:6:\"offset\";i:0;}}s:8:\"defaults\";a:1:{s:5:\"pager\";b:0;}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:7:\"block_2\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_2\";s:13:\"display_title\";s:8:\"3 Person\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:3;s:6:\"offset\";i:0;}}s:8:\"defaults\";a:3:{s:5:\"pager\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:4:\"grid\";s:7:\"options\";a:8:{s:11:\"uses_fields\";b:0;s:7:\"columns\";i:3;s:15:\"automatic_width\";b:0;s:9:\"alignment\";s:10:\"horizontal\";s:17:\"col_class_default\";b:0;s:16:\"col_class_custom\";s:0:\"\";s:17:\"row_class_default\";b:0;s:16:\"row_class_custom\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:4:\"full\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:4:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.user_admin_people','a:14:{s:4:\"uuid\";s:36:\"080f538e-0160-4e35-9be7-7ddd7e34fc8d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7kCByILhEFqBK9eFmxHNVbEq2z3-pl-cwWjDnzLn67I\";}s:2:\"id\";s:17:\"user_admin_people\";s:5:\"label\";s:6:\"People\";s:6:\"module\";s:4:\"user\";s:11:\"description\";s:50:\"Find and manage people interacting with your site.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:16:\"users_field_data\";s:10:\"base_field\";s:3:\"uid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:25:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:16:\"administer users\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:3:\"tag\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"summary\";s:0:\"\";s:7:\"columns\";a:8:{s:14:\"user_bulk_form\";s:14:\"user_bulk_form\";s:4:\"name\";s:4:\"name\";s:6:\"status\";s:6:\"status\";s:3:\"rid\";s:3:\"rid\";s:7:\"created\";s:7:\"created\";s:6:\"access\";s:6:\"access\";s:9:\"edit_node\";s:9:\"edit_node\";s:10:\"dropbutton\";s:10:\"dropbutton\";}s:4:\"info\";a:8:{s:14:\"user_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:3:\"rid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"access\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:9:\"edit_node\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:10:\"dropbutton\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:14:\"user_bulk_form\";a:23:{s:2:\"id\";s:14:\"user_bulk_form\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:14:\"user_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bulk update\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:14:\"user_bulk_form\";s:11:\"entity_type\";s:4:\"user\";}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Username\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:6:\"status\";a:26:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";s:6:\"Active\";s:19:\"format_custom_false\";s:7:\"Blocked\";}s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:15:\"roles_target_id\";a:24:{s:2:\"id\";s:15:\"roles_target_id\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:15:\"roles_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Roles\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:9:\"plugin_id\";s:10:\"user_roles\";}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Member for\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:9:\"@interval\";s:11:\"past_format\";s:9:\"@interval\";s:11:\"granularity\";i:2;}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}s:6:\"access\";a:26:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Last access\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:15:\"@interval hence\";s:11:\"past_format\";s:13:\"@interval ago\";s:11:\"granularity\";i:2;}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:4:\"user\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:4:\"mail\";a:37:{s:2:\"id\";s:4:\"mail\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"mail\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"basic_string\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"mail\";}}s:7:\"filters\";a:6:{s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:22:\"Name or email contains\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:4:\"user\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:4:\"mail\";s:4:\"mail\";}s:9:\"plugin_id\";s:7:\"combine\";}s:15:\"roles_target_id\";a:15:{s:2:\"id\";s:15:\"roles_target_id\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:15:\"roles_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:18:\"roles_target_id_op\";s:5:\"label\";s:4:\"Role\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:18:\"roles_target_id_op\";s:10:\"identifier\";s:4:\"role\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:10:\"user_roles\";}s:10:\"permission\";a:15:{s:2:\"id\";s:10:\"permission\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:10:\"permission\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:13:\"permission_op\";s:5:\"label\";s:10:\"Permission\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:13:\"permission_op\";s:10:\"identifier\";s:10:\"permission\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:16:\"user_permissions\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:1;s:10:\"group_info\";a:10:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:6:\"status\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:2:{i:1;a:3:{s:5:\"title\";s:6:\"Active\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";}i:2;a:3:{s:5:\"title\";s:7:\"Blocked\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";}}}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:16:\"default_langcode\";a:16:{s:2:\"id\";s:16:\"default_langcode\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:16:\"default_langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:16:\"default_langcode\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"uid_raw\";a:15:{s:2:\"id\";s:7:\"uid_raw\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"uid_raw\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"!=\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:1:\"0\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:13:{s:11:\"operator_id\";s:1:\"0\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:11:\"placeholder\";s:0:\"\";s:15:\"min_placeholder\";s:0:\"\";s:15:\"max_placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"numeric\";s:11:\"entity_type\";s:4:\"user\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}}s:5:\"title\";s:6:\"People\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"No people available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:15:\"display_comment\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"group_by\";b:0;s:8:\"link_url\";s:0:\"\";s:12:\"link_display\";s:6:\"page_1\";s:9:\"css_class\";s:0:\"\";s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:4:\"path\";s:17:\"admin/people/list\";s:16:\"show_admin_links\";b:0;s:4:\"menu\";a:6:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:4:\"List\";s:11:\"description\";s:50:\"Find and manage people interacting with your site.\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:-10;s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:6:\"People\";s:11:\"description\";s:45:\"Manage user accounts, roles, and permissions.\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:0;}s:8:\"defaults\";a:1:{s:16:\"show_admin_links\";b:0;}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.watchdog','a:13:{s:4:\"uuid\";s:36:\"08502ab1-9440-46b3-85c2-6dfbb5d5fb0d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:5:\"dblog\";i:1;s:4:\"user\";}}s:2:\"id\";s:8:\"watchdog\";s:5:\"label\";s:8:\"Watchdog\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:19:\"Recent log messages\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:8:\"watchdog\";s:10:\"base_field\";s:3:\"wid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:19:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:19:\"access site reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:0;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:25:\"{{ type }} {{ severity }}\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:8:{s:7:\"nothing\";s:7:\"nothing\";s:3:\"wid\";s:3:\"wid\";s:8:\"severity\";s:8:\"severity\";s:4:\"type\";s:4:\"type\";s:9:\"timestamp\";s:9:\"timestamp\";s:7:\"message\";s:7:\"message\";s:4:\"name\";s:4:\"name\";s:4:\"link\";s:4:\"link\";}s:4:\"info\";a:8:{s:7:\"nothing\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:3:\"wid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:8:\"severity\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:9:\"timestamp\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"message\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:4:\"link\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}}s:7:\"default\";s:3:\"wid\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:7:\"nothing\";a:22:{s:2:\"id\";s:7:\"nothing\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"nothing\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"Icon\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:4:\"icon\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:0;s:9:\"plugin_id\";s:6:\"custom\";}s:3:\"wid\";a:22:{s:2:\"id\";s:3:\"wid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"wid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:3:\"WID\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"severity\";a:23:{s:2:\"id\";s:8:\"severity\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:8:\"severity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Severity\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"machine_name\";b:0;s:9:\"plugin_id\";s:12:\"machine_name\";}s:4:\"type\";a:22:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"timestamp\";a:25:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:9:\"timestamp\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:7:\"message\";a:23:{s:2:\"id\";s:7:\"message\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:7:\"message\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Message\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:1;s:4:\"path\";s:35:\"admin/reports/dblog/event/{{ wid }}\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:13:\"{{ message }}\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:56;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:1;s:4:\"trim\";b:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"replace_variables\";b:1;s:9:\"plugin_id\";s:13:\"dblog_message\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"User\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"link\";a:22:{s:2:\"id\";s:4:\"link\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:16:\"dblog_operations\";}}s:7:\"filters\";a:2:{s:4:\"type\";a:14:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:1;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"dblog_types\";}s:8:\"severity\";a:14:{s:2:\"id\";s:8:\"severity\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:8:\"severity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"severity_op\";s:5:\"label\";s:8:\"Severity\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"severity_op\";s:10:\"identifier\";s:8:\"severity\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:1;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"in_operator\";}}s:5:\"sorts\";a:1:{s:3:\"wid\";a:10:{s:2:\"id\";s:3:\"wid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"wid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"title\";s:19:\"Recent log messages\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:26:\"No log messages available.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:26:\"No log messages available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"User\";s:8:\"required\";b:0;s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:9:\"css_class\";s:11:\"admin-dblog\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:4:\"page\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:2:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:19:\"admin/reports/dblog\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.webform_submissions','a:13:{s:4:\"uuid\";s:36:\"fb72a8ac-5a16-47b5-92ef-33e4970e39d3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}s:6:\"module\";a:2:{i:0;s:4:\"user\";i:1;s:7:\"webform\";}}s:2:\"id\";s:19:\"webform_submissions\";s:5:\"label\";s:19:\"Webform submissions\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:34:\"Default webform submissions views.\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:18:\"webform_submission\";s:10:\"base_field\";s:3:\"sid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:5:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:25;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:23:\"5, 10, 25, 50, 100, 200\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:10:{s:28:\"webform_submission_bulk_form\";s:28:\"webform_submission_bulk_form\";s:3:\"sid\";s:3:\"sid\";s:8:\"in_draft\";s:8:\"in_draft\";s:6:\"sticky\";s:6:\"sticky\";s:6:\"locked\";s:6:\"locked\";s:7:\"created\";s:7:\"created\";s:9:\"completed\";s:9:\"completed\";s:11:\"remote_addr\";s:11:\"remote_addr\";s:23:\"view_webform_submission\";s:23:\"view_webform_submission\";s:23:\"edit_webform_submission\";s:23:\"view_webform_submission\";}s:4:\"info\";a:10:{s:28:\"webform_submission_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:3:\"sid\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"in_draft\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"sticky\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"locked\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"completed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:11:\"remote_addr\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:23:\"view_webform_submission\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:1:\" \";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:23:\"edit_webform_submission\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"fields\";a:5:{s:3:\"sid\";a:37:{s:2:\"id\";s:3:\"sid\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:3:\"sid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:1:\"#\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:3:\"sid\";s:9:\"plugin_id\";s:5:\"field\";}s:8:\"in_draft\";a:37:{s:2:\"id\";s:8:\"in_draft\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:8:\"in_draft\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Draft\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:8:\"in_draft\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"created\";a:37:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Created\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:5:\"field\";}s:11:\"remote_addr\";a:37:{s:2:\"id\";s:11:\"remote_addr\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:11:\"remote_addr\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"IP address\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:11:\"remote_addr\";s:9:\"plugin_id\";s:5:\"field\";}s:23:\"view_webform_submission\";a:26:{s:2:\"id\";s:23:\"view_webform_submission\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:23:\"view_webform_submission\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"text\";s:4:\"view\";s:18:\"output_url_as_text\";b:0;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:9:\"plugin_id\";s:11:\"entity_link\";}}s:7:\"filters\";a:0:{}s:5:\"sorts\";a:0:{}s:6:\"header\";a:1:{s:6:\"result\";a:9:{s:2:\"id\";s:6:\"result\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:6:\"result\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:0;s:7:\"content\";s:34:\"Displaying @start - @end of @total\";s:9:\"plugin_id\";s:6:\"result\";}}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:25:\"No submissions available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:5:{s:10:\"webform_id\";a:6:{s:2:\"id\";s:10:\"webform_id\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:10:\"webform_id\";s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:10:\"webform_id\";s:9:\"plugin_id\";s:6:\"string\";}s:11:\"entity_type\";a:6:{s:2:\"id\";s:11:\"entity_type\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:11:\"entity_type\";s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:11:\"entity_type\";s:9:\"plugin_id\";s:6:\"string\";}s:9:\"entity_id\";a:6:{s:2:\"id\";s:9:\"entity_id\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:9:\"entity_id\";s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:9:\"entity_id\";s:9:\"plugin_id\";s:6:\"string\";}s:3:\"uid\";a:6:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:3:\"uid\";s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:7:\"numeric\";}s:8:\"in_draft\";a:23:{s:2:\"id\";s:8:\"in_draft\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:8:\"in_draft\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:6:\"ignore\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:8:\"in_draft\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:0:{}}s:5:\"title\";s:19:\"Webform submissions\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";}s:4:\"tags\";a:0:{}}}s:13:\"embed_default\";a:6:{s:14:\"display_plugin\";s:5:\"embed\";s:2:\"id\";s:13:\"embed_default\";s:13:\"display_title\";s:14:\"Embed: Default\";s:8:\"position\";i:1;s:15:\"display_options\";a:5:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:20:\"Display submissions.\";s:8:\"defaults\";a:5:{s:6:\"fields\";b:1;s:5:\"style\";b:0;s:3:\"row\";b:0;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:5:{s:3:\"sid\";s:3:\"sid\";s:8:\"in_draft\";s:8:\"in_draft\";s:7:\"created\";s:7:\"created\";s:11:\"remote_addr\";s:11:\"remote_addr\";s:23:\"view_webform_submission\";s:23:\"view_webform_submission\";}s:4:\"info\";a:5:{s:3:\"sid\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"in_draft\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:11:\"remote_addr\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:23:\"view_webform_submission\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:1:\" \";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";}s:4:\"tags\";a:0:{}}}s:16:\"embed_administer\";a:6:{s:14:\"display_plugin\";s:5:\"embed\";s:2:\"id\";s:16:\"embed_administer\";s:13:\"display_title\";s:17:\"Embed: Administer\";s:8:\"position\";i:2;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:23:\"Administer submissions.\";s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:10:{s:28:\"webform_submission_bulk_form\";s:28:\"webform_submission_bulk_form\";s:3:\"sid\";s:3:\"sid\";s:8:\"in_draft\";s:8:\"in_draft\";s:6:\"sticky\";s:6:\"sticky\";s:6:\"locked\";s:6:\"locked\";s:7:\"created\";s:7:\"created\";s:9:\"completed\";s:9:\"completed\";s:11:\"remote_addr\";s:11:\"remote_addr\";s:23:\"view_webform_submission\";s:23:\"view_webform_submission\";s:23:\"edit_webform_submission\";s:23:\"view_webform_submission\";}s:4:\"info\";a:10:{s:28:\"webform_submission_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:3:\"sid\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"in_draft\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"sticky\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"locked\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"completed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:11:\"remote_addr\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:23:\"view_webform_submission\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:1:\" \";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:23:\"edit_webform_submission\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:0;}}s:8:\"defaults\";a:6:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"access\";b:0;s:6:\"fields\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:29:\"administer webform submission\";}}s:6:\"fields\";a:9:{s:28:\"webform_submission_bulk_form\";a:26:{s:2:\"id\";s:28:\"webform_submission_bulk_form\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:28:\"webform_submission_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:39:\"Webform submission operations bulk form\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"exclude\";s:16:\"selected_actions\";a:0:{}s:11:\"entity_type\";s:18:\"webform_submission\";s:9:\"plugin_id\";s:28:\"webform_submission_bulk_form\";}s:3:\"sid\";a:37:{s:2:\"id\";s:3:\"sid\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:3:\"sid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:1:\"#\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:3:\"sid\";s:9:\"plugin_id\";s:5:\"field\";}s:8:\"in_draft\";a:37:{s:2:\"id\";s:8:\"in_draft\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:8:\"in_draft\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Draft\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:8:\"in_draft\";s:9:\"plugin_id\";s:5:\"field\";}s:6:\"sticky\";a:37:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Sticky\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"sticky\";s:9:\"plugin_id\";s:5:\"field\";}s:6:\"locked\";a:37:{s:2:\"id\";s:6:\"locked\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"locked\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Locked\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"locked\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"created\";a:37:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Created\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"completed\";a:37:{s:2:\"id\";s:9:\"completed\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:9:\"completed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Completed\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:9:\"completed\";s:9:\"plugin_id\";s:5:\"field\";}s:11:\"remote_addr\";a:37:{s:2:\"id\";s:11:\"remote_addr\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:11:\"remote_addr\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"IP address\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:11:\"remote_addr\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:25:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";N;s:12:\"entity_field\";N;s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:3:{s:8:\"in_draft\";a:16:{s:2:\"id\";s:8:\"in_draft\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:8:\"in_draft\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:3:\"All\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:8:\"Is draft\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"in_draft_op\";s:10:\"identifier\";s:8:\"in_draft\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:8:\"in_draft\";s:9:\"plugin_id\";s:7:\"boolean\";}s:6:\"sticky\";a:16:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:3:\"All\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Sticky\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"sticky_op\";s:10:\"identifier\";s:6:\"sticky\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"sticky\";s:9:\"plugin_id\";s:7:\"boolean\";}s:6:\"locked\";a:16:{s:2:\"id\";s:6:\"locked\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"locked\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:3:\"All\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Locked\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"locked_op\";s:10:\"identifier\";s:6:\"locked\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:4:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";s:11:\"demo_region\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"locked\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:0;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:12:\"embed_manage\";a:6:{s:14:\"display_plugin\";s:5:\"embed\";s:2:\"id\";s:12:\"embed_manage\";s:13:\"display_title\";s:13:\"Embed: Manage\";s:8:\"position\";i:3;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:19:\"Manage submissions.\";s:6:\"fields\";a:10:{s:28:\"webform_submission_bulk_form\";a:26:{s:2:\"id\";s:28:\"webform_submission_bulk_form\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:28:\"webform_submission_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:39:\"Webform submission operations bulk form\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"include\";s:16:\"selected_actions\";a:4:{i:0;s:35:\"webform_submission_make_lock_action\";i:1;s:37:\"webform_submission_make_sticky_action\";i:2;s:37:\"webform_submission_make_unlock_action\";i:3;s:39:\"webform_submission_make_unsticky_action\";}s:11:\"entity_type\";s:18:\"webform_submission\";s:9:\"plugin_id\";s:28:\"webform_submission_bulk_form\";}s:3:\"sid\";a:37:{s:2:\"id\";s:3:\"sid\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:3:\"sid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:1:\"#\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:3:\"sid\";s:9:\"plugin_id\";s:5:\"field\";}s:8:\"in_draft\";a:37:{s:2:\"id\";s:8:\"in_draft\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:8:\"in_draft\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Draft\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:8:\"in_draft\";s:9:\"plugin_id\";s:5:\"field\";}s:6:\"sticky\";a:37:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Sticky\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"sticky\";s:9:\"plugin_id\";s:5:\"field\";}s:6:\"locked\";a:37:{s:2:\"id\";s:6:\"locked\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"locked\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Locked\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"locked\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"created\";a:37:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Created\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"completed\";a:37:{s:2:\"id\";s:9:\"completed\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:9:\"completed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Completed\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:9:\"completed\";s:9:\"plugin_id\";s:5:\"field\";}s:11:\"remote_addr\";a:37:{s:2:\"id\";s:11:\"remote_addr\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:11:\"remote_addr\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"IP address\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:11:\"remote_addr\";s:9:\"plugin_id\";s:5:\"field\";}s:23:\"view_webform_submission\";a:26:{s:2:\"id\";s:23:\"view_webform_submission\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:23:\"view_webform_submission\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"text\";s:4:\"view\";s:18:\"output_url_as_text\";b:0;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:9:\"plugin_id\";s:11:\"entity_link\";}s:23:\"edit_webform_submission\";a:26:{s:2:\"id\";s:23:\"edit_webform_submission\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:23:\"edit_webform_submission\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"text\";s:4:\"edit\";s:18:\"output_url_as_text\";b:0;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:9:\"plugin_id\";s:16:\"entity_link_edit\";}}s:8:\"defaults\";a:6:{s:6:\"fields\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"access\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:10:{s:28:\"webform_submission_bulk_form\";s:28:\"webform_submission_bulk_form\";s:3:\"sid\";s:3:\"sid\";s:8:\"in_draft\";s:8:\"in_draft\";s:6:\"sticky\";s:6:\"sticky\";s:6:\"locked\";s:6:\"locked\";s:7:\"created\";s:7:\"created\";s:9:\"completed\";s:9:\"completed\";s:11:\"remote_addr\";s:11:\"remote_addr\";s:23:\"view_webform_submission\";s:23:\"view_webform_submission\";s:23:\"edit_webform_submission\";s:23:\"view_webform_submission\";}s:4:\"info\";a:10:{s:28:\"webform_submission_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:3:\"sid\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"in_draft\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"sticky\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"locked\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"completed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:11:\"remote_addr\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:23:\"view_webform_submission\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:1:\" \";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:23:\"edit_webform_submission\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:27:\"edit any webform submission\";}}s:7:\"filters\";a:3:{s:8:\"in_draft\";a:16:{s:2:\"id\";s:8:\"in_draft\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:8:\"in_draft\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:3:\"All\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:8:\"Is draft\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"in_draft_op\";s:10:\"identifier\";s:8:\"in_draft\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:8:\"in_draft\";s:9:\"plugin_id\";s:7:\"boolean\";}s:6:\"sticky\";a:16:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:3:\"All\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Sticky\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"sticky_op\";s:10:\"identifier\";s:6:\"sticky\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"sticky\";s:9:\"plugin_id\";s:7:\"boolean\";}s:6:\"locked\";a:16:{s:2:\"id\";s:6:\"locked\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"locked\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:3:\"All\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Locked\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"locked_op\";s:10:\"identifier\";s:6:\"locked\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:4:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";s:11:\"demo_region\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"locked\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:0;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:12:\"embed_review\";a:6:{s:14:\"display_plugin\";s:5:\"embed\";s:2:\"id\";s:12:\"embed_review\";s:13:\"display_title\";s:13:\"Embed: Review\";s:8:\"position\";i:4;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:19:\"Review submissions.\";s:6:\"fields\";a:8:{s:3:\"sid\";a:37:{s:2:\"id\";s:3:\"sid\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:3:\"sid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:1:\"#\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:3:\"sid\";s:9:\"plugin_id\";s:5:\"field\";}s:8:\"in_draft\";a:37:{s:2:\"id\";s:8:\"in_draft\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:8:\"in_draft\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Draft\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:8:\"in_draft\";s:9:\"plugin_id\";s:5:\"field\";}s:6:\"sticky\";a:37:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Sticky\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"sticky\";s:9:\"plugin_id\";s:5:\"field\";}s:6:\"locked\";a:37:{s:2:\"id\";s:6:\"locked\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"locked\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Locked\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"yes-no\";s:18:\"format_custom_true\";s:0:\"\";s:19:\"format_custom_false\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"locked\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"created\";a:37:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Created\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:7:\"created\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"completed\";a:37:{s:2:\"id\";s:9:\"completed\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:9:\"completed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Completed\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:9:\"completed\";s:9:\"plugin_id\";s:5:\"field\";}s:11:\"remote_addr\";a:37:{s:2:\"id\";s:11:\"remote_addr\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:11:\"remote_addr\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"IP address\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:11:\"remote_addr\";s:9:\"plugin_id\";s:5:\"field\";}s:23:\"view_webform_submission\";a:26:{s:2:\"id\";s:23:\"view_webform_submission\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:23:\"view_webform_submission\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"text\";s:4:\"view\";s:18:\"output_url_as_text\";b:0;s:8:\"absolute\";b:0;s:11:\"entity_type\";s:18:\"webform_submission\";s:9:\"plugin_id\";s:11:\"entity_link\";}}s:8:\"defaults\";a:6:{s:6:\"fields\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"access\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:10:{s:28:\"webform_submission_bulk_form\";s:28:\"webform_submission_bulk_form\";s:3:\"sid\";s:3:\"sid\";s:8:\"in_draft\";s:8:\"in_draft\";s:6:\"sticky\";s:6:\"sticky\";s:6:\"locked\";s:6:\"locked\";s:7:\"created\";s:7:\"created\";s:9:\"completed\";s:9:\"completed\";s:11:\"remote_addr\";s:11:\"remote_addr\";s:23:\"view_webform_submission\";s:23:\"view_webform_submission\";s:23:\"edit_webform_submission\";s:23:\"view_webform_submission\";}s:4:\"info\";a:10:{s:28:\"webform_submission_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:3:\"sid\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"in_draft\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"sticky\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"locked\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"completed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:11:\"remote_addr\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:23:\"view_webform_submission\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:1:\" \";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:23:\"edit_webform_submission\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:27:\"view any webform submission\";}}s:7:\"filters\";a:3:{s:8:\"in_draft\";a:16:{s:2:\"id\";s:8:\"in_draft\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:8:\"in_draft\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:3:\"All\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:8:\"Is draft\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"in_draft_op\";s:10:\"identifier\";s:8:\"in_draft\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:8:\"in_draft\";s:9:\"plugin_id\";s:7:\"boolean\";}s:6:\"sticky\";a:16:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:3:\"All\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Sticky\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"sticky_op\";s:10:\"identifier\";s:6:\"sticky\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"sticky\";s:9:\"plugin_id\";s:7:\"boolean\";}s:6:\"locked\";a:16:{s:2:\"id\";s:6:\"locked\";s:5:\"table\";s:18:\"webform_submission\";s:5:\"field\";s:6:\"locked\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:3:\"All\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Locked\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"locked_op\";s:10:\"identifier\";s:6:\"locked\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:4:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";s:11:\"demo_region\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:18:\"webform_submission\";s:12:\"entity_field\";s:6:\"locked\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),

('','views.view.who_s_new','a:14:{s:4:\"uuid\";s:36:\"9d59eb0b-da2c-4969-857d-60fc644dd82d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"o_8fSWHZOVIbydZACGsSX09DtuJhqkRmNOzcVj-4bQI\";}s:2:\"id\";s:9:\"who_s_new\";s:5:\"label\";s:9:\"Who\'s new\";s:6:\"module\";s:4:\"user\";s:11:\"description\";s:53:\"Shows a list of the newest user accounts on the site.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:16:\"users_field_data\";s:10:\"base_field\";s:3:\"uid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:5;s:6:\"offset\";i:0;}}s:5:\"style\";a:1:{s:4:\"type\";s:9:\"html_list\";}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:1:{s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:0:\"\";s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:1:\"0\";}s:5:\"group\";i:1;s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:6:\"access\";a:16:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\">\";s:5:\"value\";a:4:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:10:\"1970-01-01\";s:4:\"type\";s:4:\"date\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:13:{s:11:\"operator_id\";s:1:\"0\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:11:\"placeholder\";s:0:\"\";s:15:\"min_placeholder\";s:0:\"\";s:15:\"max_placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}}s:5:\"title\";s:9:\"Who\'s new\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:9:\"Who\'s new\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:19:\"display_description\";s:19:\"A list of new users\";s:17:\"block_description\";s:9:\"Who\'s new\";s:14:\"block_category\";s:4:\"User\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','views.view.who_s_online','a:14:{s:4:\"uuid\";s:36:\"c9febb47-c648-4f9e-abac-f0705766c37a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"m0vmYmhrzMR6S_IC0UlK0Cl-q5lEvL8-EbxbbcDtk34\";}s:2:\"id\";s:12:\"who_s_online\";s:5:\"label\";s:18:\"Who\'s online block\";s:6:\"module\";s:4:\"user\";s:11:\"description\";s:93:\"Shows the user names of the most recently active users, and the total number of active users.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:16:\"users_field_data\";s:10:\"base_field\";s:3:\"uid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:20:\"access user profiles\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:1:{s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:0:\"\";s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:1:\"0\";}s:5:\"group\";i:1;s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:6:\"access\";a:16:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\">=\";s:5:\"value\";a:4:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:11:\"-15 minutes\";s:4:\"type\";s:6:\"offset\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:13:{s:11:\"operator_id\";s:9:\"access_op\";s:5:\"label\";s:11:\"Last access\";s:11:\"description\";s:77:\"A user is considered online for this long after they have last viewed a page.\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"access_op\";s:10:\"identifier\";s:6:\"access\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:11:\"placeholder\";s:0:\"\";s:15:\"min_placeholder\";s:0:\"\";s:15:\"max_placeholder\";s:0:\"\";}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}}s:5:\"sorts\";a:1:{s:6:\"access\";a:13:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:5:\"order\";s:4:\"DESC\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}}s:5:\"title\";s:12:\"Who\'s online\";s:6:\"header\";a:1:{s:6:\"result\";a:9:{s:2:\"id\";s:6:\"result\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:6:\"result\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:0;s:7:\"content\";s:40:\"There are currently @total users online.\";s:9:\"plugin_id\";s:6:\"result\";}}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:35:\"There are currently 0 users online.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:18:\"who_s_online_block\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:18:\"who_s_online_block\";s:13:\"display_title\";s:12:\"Who\'s online\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"block_description\";s:12:\"Who\'s online\";s:19:\"display_description\";s:45:\"A list of users that are currently logged in.\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),

('','votingapi.settings','a:4:{s:16:\"anonymous_window\";i:86400;s:11:\"user_window\";i:-1;s:20:\"calculation_schedule\";s:9:\"immediate\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Y34Rvyr1t1dALM27QEd2E8UYnJ_31c9ToOkfpFTPzzQ\";}}'),

('','votingapi.vote_type.vote','a:9:{s:4:\"uuid\";s:36:\"d9b58c3f-1c5b-454d-82bb-7a7a61f896b8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"aXZ2sOR-jVF6_oScPSJTjXCo333arzczomYQMnsJ8wU\";}s:2:\"id\";s:4:\"vote\";s:5:\"label\";s:11:\"Normal vote\";s:10:\"value_type\";s:6:\"points\";s:11:\"description\";s:170:\"The default tag for votes on content. If multiple votes with different tags are being cast on a piece of content, consider casting a \"summary\" vote with this tag as well.\";}'),

('','webform.settings','a:17:{s:8:\"settings\";a:61:{s:14:\"default_status\";s:4:\"open\";s:22:\"default_page_base_path\";s:4:\"form\";s:12:\"default_ajax\";b:0;s:19:\"default_ajax_effect\";s:4:\"fade\";s:18:\"default_ajax_speed\";i:500;s:26:\"default_ajax_progress_type\";s:8:\"throbber\";s:25:\"default_form_open_message\";s:49:\"This form has not yet been opened to submissions.\";s:26:\"default_form_close_message\";s:47:\"Sorry...This form is closed to new submissions.\";s:30:\"default_form_exception_message\";s:70:\"Unable to display this webform. Please contact the site administrator.\";s:27:\"default_submit_button_label\";s:6:\"Submit\";s:26:\"default_reset_button_label\";s:5:\"Reset\";s:24:\"default_form_submit_once\";b:0;s:33:\"default_form_confidential_message\";s:135:\"This form is confidential. You must <a href=\"[site:login-url]/logout?destination=[current-page:url:relative]\">Log out</a> to submit it.\";s:34:\"default_form_access_denied_message\";s:36:\"Please login to access this webform.\";s:25:\"default_form_disable_back\";b:0;s:24:\"default_form_submit_back\";b:0;s:20:\"default_form_unsaved\";b:0;s:23:\"default_form_novalidate\";b:0;s:34:\"default_form_disable_inline_errors\";b:0;s:21:\"default_form_required\";b:0;s:27:\"default_form_required_label\";s:24:\"Indicates required field\";s:27:\"default_form_details_toggle\";b:1;s:23:\"default_form_file_limit\";s:0:\"\";s:12:\"form_classes\";s:131:\"container-inline clearfix\r\nform--inline clearfix\r\nmessages messages--error\r\nmessages messages--warning\r\nmessages messages--status\r\n\";s:14:\"button_classes\";s:0:\"\";s:32:\"default_wizard_prev_button_label\";s:15:\"< Previous Page\";s:32:\"default_wizard_next_button_label\";s:11:\"Next Page >\";s:26:\"default_wizard_start_label\";s:5:\"Start\";s:33:\"default_wizard_confirmation_label\";s:8:\"Complete\";s:33:\"default_preview_next_button_label\";s:7:\"Preview\";s:33:\"default_preview_prev_button_label\";s:10:\"< Previous\";s:21:\"default_preview_label\";s:7:\"Preview\";s:21:\"default_preview_title\";s:24:\"[webform:title]: Preview\";s:23:\"default_preview_message\";s:109:\"Please review your submission. Your submission is not complete until you press the &quot;Submit&quot; button!\";s:26:\"default_draft_button_label\";s:10:\"Save Draft\";s:27:\"default_draft_saved_message\";s:91:\"Submission saved. You may return to this form later and it will restore the current values.\";s:28:\"default_draft_loaded_message\";s:77:\"A partially-completed form was found. Please complete the remaining portions.\";s:36:\"default_draft_pending_single_message\";s:83:\"You have a pending draft for this webform. <a href=\"#\">Load your pending draft</a>.\";s:38:\"default_draft_pending_multiple_message\";s:83:\"You have pending drafts for this webform. <a href=\"#\">View your pending drafts</a>.\";s:28:\"default_confirmation_message\";s:40:\"New submission added to [webform:title].\";s:31:\"default_confirmation_back_label\";s:12:\"Back to form\";s:24:\"default_submission_label\";s:74:\"[webform_submission:submitted-to]: Submission #[webform_submission:serial]\";s:40:\"default_submission_access_denied_message\";s:39:\"Please login to access this submission.\";s:36:\"default_submission_exception_message\";s:73:\"Unable to process this submission. Please contact the site administrator.\";s:33:\"default_submission_locked_message\";s:32:\"This submission has been locked.\";s:22:\"default_submission_log\";b:0;s:24:\"default_submission_views\";a:0:{}s:32:\"default_submission_views_replace\";a:3:{s:13:\"global_routes\";a:2:{i:0;s:36:\"entity.webform_submission.collection\";i:1;s:30:\"entity.webform_submission.user\";}s:14:\"webform_routes\";a:3:{i:0;s:34:\"entity.webform.results_submissions\";i:1;s:26:\"entity.webform.user.drafts\";i:2;s:31:\"entity.webform.user.submissions\";}s:11:\"node_routes\";a:3:{i:0;s:39:\"entity.node.webform.results_submissions\";i:1;s:31:\"entity.node.webform.user.drafts\";i:2;s:36:\"entity.node.webform.user.submissions\";}}s:35:\"default_previous_submission_message\";s:87:\"You have already submitted this webform. <a href=\"#\">View your previous submission</a>.\";s:36:\"default_previous_submissions_message\";s:88:\"You have already submitted this webform. <a href=\"#\">View your previous submissions</a>.\";s:24:\"default_autofill_message\";s:66:\"This submission has been autofilled with your previous submission.\";s:15:\"preview_classes\";s:81:\"messages messages--error\r\nmessages messages--warning\r\nmessages messages--status\r\n\";s:20:\"confirmation_classes\";s:81:\"messages messages--error\r\nmessages messages--warning\r\nmessages messages--status\r\n\";s:25:\"confirmation_back_classes\";s:8:\"button\r\n\";s:27:\"default_limit_total_message\";s:34:\"No more submissions are permitted.\";s:26:\"default_limit_user_message\";s:34:\"No more submissions are permitted.\";s:6:\"dialog\";b:0;s:14:\"dialog_options\";a:3:{s:6:\"narrow\";a:2:{s:5:\"title\";s:6:\"Narrow\";s:5:\"width\";i:600;}s:6:\"normal\";a:2:{s:5:\"title\";s:6:\"Normal\";s:5:\"width\";i:800;}s:4:\"wide\";a:2:{s:5:\"title\";s:4:\"Wide\";s:5:\"width\";i:1000;}}s:32:\"default_submission_login_message\";s:39:\"Please login to access this submission.\";s:29:\"default_wizard_complete_label\";s:8:\"Complete\";s:25:\"default_form_submit_label\";s:6:\"Submit\";}s:6:\"assets\";a:2:{s:3:\"css\";s:0:\"\";s:10:\"javascript\";s:0:\"\";}s:7:\"handler\";a:1:{s:17:\"excluded_handlers\";a:0:{}}s:6:\"export\";a:18:{s:14:\"temp_directory\";s:0:\"\";s:8:\"exporter\";s:9:\"delimited\";s:18:\"multiple_delimiter\";s:1:\";\";s:13:\"header_format\";s:5:\"label\";s:13:\"header_prefix\";b:1;s:29:\"header_prefix_label_delimiter\";s:2:\": \";s:27:\"header_prefix_key_delimiter\";s:2:\"__\";s:29:\"composite_element_item_format\";s:5:\"label\";s:21:\"options_single_format\";s:7:\"compact\";s:23:\"options_multiple_format\";s:7:\"compact\";s:19:\"options_item_format\";s:5:\"label\";s:22:\"entity_reference_items\";a:3:{i:0;s:2:\"id\";i:1;s:5:\"title\";i:2;s:3:\"url\";}s:21:\"likert_answers_format\";s:5:\"label\";s:16:\"signature_format\";s:6:\"status\";s:9:\"delimiter\";s:1:\",\";s:5:\"excel\";b:0;s:18:\"excluded_exporters\";a:0:{}s:9:\"file_name\";s:38:\"submission-[webform_submission:serial]\";}s:5:\"batch\";a:5:{s:25:\"default_batch_export_size\";i:500;s:25:\"default_batch_import_size\";i:100;s:25:\"default_batch_update_size\";i:500;s:25:\"default_batch_delete_size\";i:500;s:24:\"default_batch_email_size\";i:500;}s:5:\"purge\";a:1:{s:9:\"cron_size\";i:100;}s:7:\"element\";a:17:{s:20:\"machine_name_pattern\";s:7:\"a-z0-9_\";s:13:\"empty_message\";s:7:\"{Empty}\";s:12:\"allowed_tags\";s:5:\"admin\";s:15:\"wrapper_classes\";s:126:\"container-inline clearfix\nform--inline clearfix\nmessages messages--error\nmessages messages--warning\nmessages messages--status\n\";s:7:\"classes\";s:126:\"container-inline clearfix\nform--inline clearfix\nmessages messages--error\nmessages messages--warning\nmessages messages--status\n\";s:23:\"horizontal_rule_classes\";s:286:\"webform-horizontal-rule--solid\nwebform-horizontal-rule--dashed\nwebform-horizontal-rule--dotted\nwebform-horizontal-rule--gradient\nwebform-horizontal-rule--thin\nwebform-horizontal-rule--medium\nwebform-horizontal-rule--thick\nwebform-horizontal-rule--flaired\nwebform-horizontal-rule--glyph\n\";s:27:\"default_description_display\";s:0:\"\";s:18:\"default_more_title\";s:4:\"More\";s:25:\"default_section_title_tag\";s:2:\"h2\";s:20:\"default_empty_option\";b:1;s:29:\"default_empty_option_required\";s:0:\"\";s:29:\"default_empty_option_optional\";s:0:\"\";s:14:\"default_icheck\";s:0:\"\";s:27:\"default_google_maps_api_key\";s:0:\"\";s:29:\"default_algolia_places_app_id\";s:0:\"\";s:30:\"default_algolia_places_api_key\";s:0:\"\";s:17:\"excluded_elements\";a:3:{s:8:\"password\";s:8:\"password\";s:16:\"password_confirm\";s:16:\"password_confirm\";s:28:\"webform_location_geocomplete\";s:28:\"webform_location_geocomplete\";}}s:11:\"html_editor\";a:5:{s:8:\"disabled\";b:0;s:14:\"element_format\";s:0:\"\";s:11:\"mail_format\";s:0:\"\";s:4:\"tidy\";b:1;s:35:\"make_unused_managed_files_temporary\";b:1;}s:4:\"file\";a:11:{s:11:\"file_public\";b:0;s:21:\"file_private_redirect\";b:1;s:29:\"file_private_redirect_message\";s:41:\"Please login to access the uploaded file.\";s:20:\"default_max_filesize\";s:0:\"\";s:31:\"default_managed_file_extensions\";s:139:\"gif jpg png bmp eps tif pict psd txt rtf html odf pdf doc docx ppt pptx xls xlsx xml avi mov mp3 ogg wav bz2 dmg gz jar rar sit svg tar zip\";s:29:\"default_audio_file_extensions\";s:11:\"mp3 ogg wav\";s:32:\"default_document_file_extensions\";s:50:\"txt rtf pdf doc docx odt ppt pptx odp xls xlsx ods\";s:29:\"default_image_file_extensions\";s:15:\"gif jpg png svg\";s:29:\"default_video_file_extensions\";s:24:\"avi mov mp4 ogg wav webm\";s:35:\"make_unused_managed_files_temporary\";b:1;s:30:\"delete_temporary_managed_files\";b:1;}s:6:\"format\";a:0:{}s:4:\"mail\";a:11:{s:15:\"default_to_mail\";s:11:\"[site:mail]\";s:17:\"default_from_mail\";s:11:\"[site:mail]\";s:17:\"default_from_name\";s:11:\"[site:name]\";s:16:\"default_reply_to\";s:0:\"\";s:19:\"default_return_path\";s:0:\"\";s:19:\"default_sender_mail\";s:0:\"\";s:19:\"default_sender_name\";s:0:\"\";s:15:\"default_subject\";s:59:\"Webform submission from: [webform_submission:source-entity]\";s:17:\"default_body_text\";s:133:\"Submitted on [webform_submission:created]\nSubmitted by: [webform_submission:user]\n\nSubmitted values are:\n[webform_submission:values]\n\";s:17:\"default_body_html\";s:152:\"<p>Submitted on [webform_submission:created]</p>\n<p>Submitted by: [webform_submission:user]</p>\n<p>Submitted values are:</p>\n[webform_submission:values]\";s:5:\"roles\";a:0:{}}s:4:\"test\";a:2:{s:5:\"types\";s:3579:\"checkbox:\n  - true\ncolor:\n  - \'#ffffcc\'\n  - \'#ffffcc\'\n  - \'#ccffff\'\nemail:\n  - example@example.com\n  - test@test.com\n  - random@random.com\nlanguage_select:\n  - en\nmachine_name:\n  - loremipsum\n  - oratione\n  - dixisset\ntel:\n  - 123-456-7890\n  - 098-765-4321\ntextarea:\n  - \'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Negat esse eam, inquit, propter se expetendam. Primum Theophrasti, Strato, physicum se voluit; Id mihi magnum videtur. Itaque mihi non satis videmini considerare quod iter sit naturae quaeque progressio. Quare hoc videndum est, possitne nobis hoc ratio philosophorum dare. Est enim tanti philosophi tamque nobilis audacter sua decreta defendere.\'\n  - \'Huius, Lyco, oratione locuples, rebus ipsis ielunior. Duo Reges: constructio interrete. Sed haec in pueris; Sed utrum hortandus es nobis, Luci, inquit, an etiam tua sponte propensus es? Sapiens autem semper beatus est et est aliquando in dolore; Immo videri fortasse. Paulum, cum regem Persem captum adduceret, eodem flumine invectio? Et ille ridens: Video, inquit, quid agas;\'\n  - \'Quae cum dixisset, finem ille. Quamquam non negatis nos intellegere quid sit voluptas, sed quid ille dicat. Progredientibus autem aetatibus sensim tardeve potius quasi nosmet ipsos cognoscimus. Gloriosa ostentatio in constituendo summo bono. Qui-vere falsone, quaerere mittimus-dicitur oculis se privasse; Duarum enim vitarum nobis erunt instituta capienda. Comprehensum, quod cognitum non habet? Qui enim existimabit posse se miserum esse beatus non erit. Causa autem fuit huc veniendi ut quosdam hinc libros promerem. Nunc omni virtuti vitium contrario nomine opponitur.\'\ntext_format:\n  -\n    value: \'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Negat esse eam, inquit, propter se expetendam. Primum Theophrasti, Strato, physicum se voluit; Id mihi magnum videtur. Itaque mihi non satis videmini considerare quod iter sit naturae quaeque progressio. Quare hoc videndum est, possitne nobis hoc ratio philosophorum dare. Est enim tanti philosophi tamque nobilis audacter sua decreta defendere.</p>\'\n  -\n    value: \'<p>Huius, Lyco, oratione locuples, rebus ipsis ielunior. Duo Reges: constructio interrete. Sed haec in pueris; Sed utrum hortandus es nobis, Luci, inquit, an etiam tua sponte propensus es? Sapiens autem semper beatus est et est aliquando in dolore; Immo videri fortasse. Paulum, cum regem Persem captum adduceret, eodem flumine invectio? Et ille ridens: Video, inquit, quid agas;</p>\'\n  -\n    value: \'<p>Quae cum dixisset, finem ille. Quamquam non negatis nos intellegere quid sit voluptas, sed quid ille dicat. Progredientibus autem aetatibus sensim tardeve potius quasi nosmet ipsos cognoscimus. Gloriosa ostentatio in constituendo summo bono. Qui-vere falsone, quaerere mittimus-dicitur oculis se privasse; Duarum enim vitarum nobis erunt instituta capienda. Comprehensum, quod cognitum non habet? Qui enim existimabit posse se miserum esse beatus non erit. Causa autem fuit huc veniendi ut quosdam hinc libros promerem. Nunc omni virtuti vitium contrario nomine opponitur.</p>\'\nurl:\n  - \'http://example.com\'\n  - \'http://test.com\'\nwebform_creditcard_number:\n  - \'4111111111111111\'\nwebform_email_confirm:\n  - example@example.com\n  - test@test.com\n  - random@random.com\nwebform_email_multiple:\n  - \'example@example.com, test@test.com, random@random.com\'\nwebform_location:\n  -\n    value: \'The White House, 1600 Pennsylvania Ave NW, Washington, DC 20500, USA\'\n  -\n    value: \'London SW1A 1AA, United Kingdom\'\n  -\n    value: \'Moscow, Russia, 10307\'\nwebform_time:\n  - \'09:00\'\n  - \'17:00\'\n\";s:5:\"names\";s:469:\"first_name:\n  - John\n  - Paul\n  - Ringo\n  - George\nlast_name:\n  - Lennon\n  - McCartney\n  - Starr\n  - Harrison\naddress:\n  - \'10 Main Street\'\n  - \'11 Brook Alley Road. APT 1\'\nzip:\n  - \'11111\'\n  - \'12345\'\n  - 12345-6789\nphone:\n  - 123-456-7890\n  - 098-765-4321\ncity:\n  - Springfield\n  - Pleasantville\n  - \'Hill Valley\'\nurl:\n  - \'http://example.com\'\n  - \'http://test.com\'\ndefault:\n  - Loremipsum\n  - Oratione\n  - Dixisset\npostal_code:\n  - \'11111\'\n  - \'12345\'\n  - 12345-6789\";}s:2:\"ui\";a:9:{s:13:\"video_display\";s:6:\"dialog\";s:12:\"details_save\";b:1;s:13:\"help_disabled\";b:0;s:15:\"dialog_disabled\";b:0;s:18:\"offcanvas_disabled\";b:0;s:19:\"promotions_disabled\";b:0;s:16:\"description_help\";b:1;s:14:\"about_disabled\";b:0;s:20:\"html_editor_disabled\";b:0;}s:9:\"libraries\";a:1:{s:18:\"excluded_libraries\";a:3:{i:0;s:13:\"jquery.chosen\";i:1;s:13:\"jquery.chosen\";i:2;s:14:\"jquery.toggles\";}}s:12:\"requirements\";a:3:{s:3:\"cdn\";b:1;s:9:\"bootstrap\";b:1;s:4:\"spam\";b:1;}s:8:\"langcode\";s:2:\"en\";s:20:\"third_party_settings\";a:1:{s:7:\"captcha\";a:1:{s:27:\"replace_administration_mode\";b:1;}}}'),

('','webform.webform.contact','a:21:{s:8:\"langcode\";s:2:\"en\";s:6:\"status\";s:4:\"open\";s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:4:\"open\";N;s:5:\"close\";N;s:6:\"weight\";i:0;s:3:\"uid\";N;s:8:\"template\";b:0;s:7:\"archive\";b:0;s:2:\"id\";s:7:\"contact\";s:5:\"title\";s:7:\"Contact\";s:11:\"description\";s:28:\"Basic email contact webform.\";s:8:\"category\";s:0:\"\";s:8:\"elements\";s:566:\"name:\n  \'#title\': \'Your Name\'\n  \'#type\': textfield\n  \'#required\': true\n  \'#default_value\': \'[current-user:display-name]\'\nemail:\n  \'#title\': \'Your Email\'\n  \'#type\': email\n  \'#required\': true\n  \'#default_value\': \'[current-user:mail]\'\nsubject:\n  \'#title\': Subject\n  \'#type\': textfield\n  \'#required\': true\n  \'#test\': \'Testing contact webform from [site:name]\'\nmessage:\n  \'#title\': Message\n  \'#type\': textarea\n  \'#required\': true\n  \'#test\': \'Please ignore this email.\'\nactions:\n  \'#type\': webform_actions\n  \'#title\': \'Submit button(s)\'\n  \'#submit__label\': \'Send message\'\n\";s:3:\"css\";s:0:\"\";s:10:\"javascript\";s:0:\"\";s:8:\"settings\";a:110:{s:4:\"ajax\";b:0;s:15:\"ajax_scroll_top\";s:4:\"form\";s:18:\"ajax_progress_type\";s:0:\"\";s:11:\"ajax_effect\";s:0:\"\";s:10:\"ajax_speed\";N;s:4:\"page\";b:1;s:16:\"page_submit_path\";s:0:\"\";s:17:\"page_confirm_path\";s:0:\"\";s:16:\"page_admin_theme\";b:0;s:10:\"form_title\";s:4:\"both\";s:16:\"form_submit_once\";b:0;s:22:\"form_exception_message\";s:0:\"\";s:17:\"form_open_message\";s:0:\"\";s:18:\"form_close_message\";s:0:\"\";s:25:\"form_previous_submissions\";b:1;s:17:\"form_confidential\";b:0;s:25:\"form_confidential_message\";s:0:\"\";s:16:\"form_remote_addr\";b:1;s:22:\"form_convert_anonymous\";b:0;s:16:\"form_prepopulate\";b:0;s:30:\"form_prepopulate_source_entity\";b:0;s:39:\"form_prepopulate_source_entity_required\";b:0;s:35:\"form_prepopulate_source_entity_type\";s:0:\"\";s:10:\"form_reset\";b:0;s:25:\"form_disable_autocomplete\";b:0;s:15:\"form_novalidate\";b:0;s:26:\"form_disable_inline_errors\";b:0;s:13:\"form_required\";b:0;s:12:\"form_unsaved\";b:0;s:17:\"form_disable_back\";b:0;s:16:\"form_submit_back\";b:0;s:14:\"form_autofocus\";b:0;s:19:\"form_details_toggle\";b:0;s:18:\"form_access_denied\";s:7:\"default\";s:24:\"form_access_denied_title\";s:0:\"\";s:26:\"form_access_denied_message\";s:0:\"\";s:29:\"form_access_denied_attributes\";a:0:{}s:15:\"form_file_limit\";s:0:\"\";s:16:\"submission_label\";s:0:\"\";s:14:\"submission_log\";b:0;s:16:\"submission_views\";a:0:{}s:24:\"submission_views_replace\";a:0:{}s:23:\"submission_user_columns\";a:0:{}s:25:\"submission_user_duplicate\";b:0;s:24:\"submission_access_denied\";s:7:\"default\";s:30:\"submission_access_denied_title\";s:0:\"\";s:32:\"submission_access_denied_message\";s:0:\"\";s:35:\"submission_access_denied_attributes\";a:0:{}s:28:\"submission_exception_message\";s:0:\"\";s:25:\"submission_locked_message\";s:0:\"\";s:28:\"submission_excluded_elements\";a:0:{}s:24:\"submission_exclude_empty\";b:0;s:33:\"submission_exclude_empty_checkbox\";b:0;s:27:\"previous_submission_message\";s:0:\"\";s:28:\"previous_submissions_message\";s:0:\"\";s:8:\"autofill\";b:0;s:16:\"autofill_message\";s:0:\"\";s:26:\"autofill_excluded_elements\";a:0:{}s:19:\"wizard_progress_bar\";b:1;s:21:\"wizard_progress_pages\";b:0;s:26:\"wizard_progress_percentage\";b:0;s:20:\"wizard_progress_link\";b:0;s:18:\"wizard_start_label\";s:0:\"\";s:19:\"wizard_preview_link\";b:0;s:19:\"wizard_confirmation\";b:1;s:25:\"wizard_confirmation_label\";s:0:\"\";s:12:\"wizard_track\";s:0:\"\";s:7:\"preview\";i:0;s:13:\"preview_label\";s:0:\"\";s:13:\"preview_title\";s:0:\"\";s:15:\"preview_message\";s:0:\"\";s:18:\"preview_attributes\";a:0:{}s:25:\"preview_excluded_elements\";a:0:{}s:21:\"preview_exclude_empty\";b:1;s:30:\"preview_exclude_empty_checkbox\";b:0;s:5:\"draft\";s:4:\"none\";s:14:\"draft_multiple\";b:0;s:15:\"draft_auto_save\";b:0;s:19:\"draft_saved_message\";s:0:\"\";s:20:\"draft_loaded_message\";s:0:\"\";s:28:\"draft_pending_single_message\";s:0:\"\";s:30:\"draft_pending_multiple_message\";s:0:\"\";s:17:\"confirmation_type\";s:11:\"url_message\";s:18:\"confirmation_title\";s:0:\"\";s:20:\"confirmation_message\";s:27:\"Your message has been sent.\";s:16:\"confirmation_url\";s:7:\"<front>\";s:23:\"confirmation_attributes\";a:0:{}s:17:\"confirmation_back\";b:1;s:23:\"confirmation_back_label\";s:0:\"\";s:28:\"confirmation_back_attributes\";a:0:{}s:26:\"confirmation_exclude_query\";b:0;s:26:\"confirmation_exclude_token\";b:0;s:19:\"confirmation_update\";b:0;s:11:\"limit_total\";N;s:20:\"limit_total_interval\";N;s:19:\"limit_total_message\";s:0:\"\";s:18:\"limit_total_unique\";b:0;s:10:\"limit_user\";N;s:19:\"limit_user_interval\";N;s:18:\"limit_user_message\";s:0:\"\";s:17:\"limit_user_unique\";b:0;s:18:\"entity_limit_total\";N;s:27:\"entity_limit_total_interval\";N;s:17:\"entity_limit_user\";N;s:26:\"entity_limit_user_interval\";N;s:5:\"purge\";s:4:\"none\";s:10:\"purge_days\";N;s:16:\"results_disabled\";b:0;s:23:\"results_disabled_ignore\";b:0;s:12:\"token_update\";b:0;}s:6:\"access\";a:11:{s:6:\"create\";a:3:{s:5:\"roles\";a:2:{i:0;s:9:\"anonymous\";i:1;s:13:\"authenticated\";}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:8:\"view_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"update_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"delete_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:9:\"purge_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:8:\"view_own\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"update_own\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"delete_own\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"administer\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:4:\"test\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:13:\"configuration\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}}s:8:\"handlers\";a:2:{s:18:\"email_confirmation\";a:7:{s:2:\"id\";s:5:\"email\";s:5:\"label\";s:18:\"Email confirmation\";s:10:\"handler_id\";s:18:\"email_confirmation\";s:6:\"status\";b:1;s:10:\"conditions\";a:0:{}s:6:\"weight\";i:1;s:8:\"settings\";a:25:{s:6:\"states\";a:1:{i:0;s:9:\"completed\";}s:7:\"to_mail\";s:37:\"[webform_submission:values:email:raw]\";s:10:\"to_options\";a:0:{}s:7:\"cc_mail\";s:0:\"\";s:10:\"cc_options\";a:0:{}s:8:\"bcc_mail\";s:0:\"\";s:11:\"bcc_options\";a:0:{}s:9:\"from_mail\";s:8:\"_default\";s:12:\"from_options\";a:0:{}s:9:\"from_name\";s:8:\"_default\";s:7:\"subject\";s:39:\"[webform_submission:values:subject:raw]\";s:4:\"body\";s:41:\"[webform_submission:values:message:value]\";s:17:\"excluded_elements\";a:0:{}s:13:\"ignore_access\";b:0;s:13:\"exclude_empty\";b:1;s:22:\"exclude_empty_checkbox\";b:0;s:4:\"html\";b:1;s:11:\"attachments\";b:0;s:4:\"twig\";b:0;s:5:\"debug\";b:0;s:8:\"reply_to\";s:0:\"\";s:11:\"return_path\";s:0:\"\";s:11:\"sender_mail\";s:0:\"\";s:11:\"sender_name\";s:0:\"\";s:10:\"theme_name\";s:0:\"\";}}s:18:\"email_notification\";a:7:{s:2:\"id\";s:5:\"email\";s:5:\"label\";s:18:\"Email notification\";s:10:\"handler_id\";s:18:\"email_notification\";s:6:\"status\";b:1;s:10:\"conditions\";a:0:{}s:6:\"weight\";i:1;s:8:\"settings\";a:25:{s:6:\"states\";a:1:{i:0;s:9:\"completed\";}s:7:\"to_mail\";s:8:\"_default\";s:10:\"to_options\";a:0:{}s:7:\"cc_mail\";s:0:\"\";s:10:\"cc_options\";a:0:{}s:8:\"bcc_mail\";s:0:\"\";s:11:\"bcc_options\";a:0:{}s:9:\"from_mail\";s:37:\"[webform_submission:values:email:raw]\";s:12:\"from_options\";a:0:{}s:9:\"from_name\";s:36:\"[webform_submission:values:name:raw]\";s:7:\"subject\";s:39:\"[webform_submission:values:subject:raw]\";s:4:\"body\";s:41:\"[webform_submission:values:message:value]\";s:17:\"excluded_elements\";a:0:{}s:13:\"ignore_access\";b:0;s:13:\"exclude_empty\";b:1;s:22:\"exclude_empty_checkbox\";b:0;s:4:\"html\";b:1;s:11:\"attachments\";b:0;s:4:\"twig\";b:0;s:5:\"debug\";b:0;s:8:\"reply_to\";s:0:\"\";s:11:\"return_path\";s:0:\"\";s:11:\"sender_mail\";s:0:\"\";s:11:\"sender_name\";s:0:\"\";s:10:\"theme_name\";s:0:\"\";}}}s:4:\"uuid\";s:36:\"f87398a6-7455-4f13-81e7-2dc9bdffd69c\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Mv7z8sI17hVNDdf2nOfg7y_jPAJ0JScp9y0iVbF0XhI\";}}'),

('','webform.webform.contact_1','a:20:{s:8:\"langcode\";s:2:\"en\";s:6:\"status\";s:4:\"open\";s:12:\"dependencies\";a:0:{}s:4:\"open\";N;s:5:\"close\";N;s:6:\"weight\";i:0;s:3:\"uid\";i:1;s:8:\"template\";b:0;s:7:\"archive\";b:0;s:2:\"id\";s:9:\"contact_1\";s:5:\"title\";s:9:\"Contact 1\";s:11:\"description\";s:0:\"\";s:8:\"category\";s:0:\"\";s:8:\"elements\";s:698:\"row:\n  \'#type\': container\n  \'#attributes\':\n    class:\n      - row\n  col1:\n    \'#type\': container\n    \'#attributes\':\n      class:\n        - col-sm-6\n    name:\n      \'#type\': textfield\n      \'#title\': Name\n      \'#title_display\': invisible\n      \'#placeholder\': Name\n    email:\n      \'#type\': email\n      \'#title\': Email\n      \'#title_display\': invisible\n      \'#placeholder\': Email\n  col2:\n    \'#type\': container\n    \'#attributes\':\n      class:\n        - col-sm-6\n    message:\n      \'#type\': textarea\n      \'#title\': message\n      \'#title_display\': invisible\n      \'#placeholder\': Message\nnotes:\n  \'#type\': webform_markup\n  \'#markup\': \'<div class=\"form-tip pt-20\">All the fields are required</div>\'\n\";s:3:\"css\";s:0:\"\";s:10:\"javascript\";s:0:\"\";s:8:\"settings\";a:110:{s:4:\"ajax\";b:0;s:15:\"ajax_scroll_top\";s:4:\"form\";s:18:\"ajax_progress_type\";s:0:\"\";s:11:\"ajax_effect\";s:0:\"\";s:10:\"ajax_speed\";N;s:4:\"page\";b:1;s:16:\"page_submit_path\";s:0:\"\";s:17:\"page_confirm_path\";s:0:\"\";s:16:\"page_admin_theme\";b:0;s:10:\"form_title\";s:4:\"both\";s:16:\"form_submit_once\";b:0;s:22:\"form_exception_message\";s:0:\"\";s:17:\"form_open_message\";s:0:\"\";s:18:\"form_close_message\";s:0:\"\";s:25:\"form_previous_submissions\";b:1;s:17:\"form_confidential\";b:0;s:25:\"form_confidential_message\";s:0:\"\";s:16:\"form_remote_addr\";b:1;s:22:\"form_convert_anonymous\";b:0;s:16:\"form_prepopulate\";b:0;s:30:\"form_prepopulate_source_entity\";b:0;s:39:\"form_prepopulate_source_entity_required\";b:0;s:35:\"form_prepopulate_source_entity_type\";s:0:\"\";s:10:\"form_reset\";b:0;s:25:\"form_disable_autocomplete\";b:0;s:15:\"form_novalidate\";b:0;s:26:\"form_disable_inline_errors\";b:0;s:13:\"form_required\";b:0;s:12:\"form_unsaved\";b:0;s:17:\"form_disable_back\";b:0;s:16:\"form_submit_back\";b:0;s:14:\"form_autofocus\";b:0;s:19:\"form_details_toggle\";b:0;s:18:\"form_access_denied\";s:7:\"default\";s:24:\"form_access_denied_title\";s:0:\"\";s:26:\"form_access_denied_message\";s:0:\"\";s:29:\"form_access_denied_attributes\";a:0:{}s:15:\"form_file_limit\";s:0:\"\";s:16:\"submission_label\";s:0:\"\";s:14:\"submission_log\";b:0;s:16:\"submission_views\";a:0:{}s:24:\"submission_views_replace\";a:0:{}s:23:\"submission_user_columns\";a:0:{}s:25:\"submission_user_duplicate\";b:0;s:24:\"submission_access_denied\";s:7:\"default\";s:30:\"submission_access_denied_title\";s:0:\"\";s:32:\"submission_access_denied_message\";s:0:\"\";s:35:\"submission_access_denied_attributes\";a:0:{}s:28:\"submission_exception_message\";s:0:\"\";s:25:\"submission_locked_message\";s:0:\"\";s:28:\"submission_excluded_elements\";a:0:{}s:24:\"submission_exclude_empty\";b:0;s:33:\"submission_exclude_empty_checkbox\";b:0;s:27:\"previous_submission_message\";s:0:\"\";s:28:\"previous_submissions_message\";s:0:\"\";s:8:\"autofill\";b:0;s:16:\"autofill_message\";s:0:\"\";s:26:\"autofill_excluded_elements\";a:0:{}s:19:\"wizard_progress_bar\";b:1;s:21:\"wizard_progress_pages\";b:0;s:26:\"wizard_progress_percentage\";b:0;s:20:\"wizard_progress_link\";b:0;s:18:\"wizard_start_label\";s:0:\"\";s:19:\"wizard_preview_link\";b:0;s:19:\"wizard_confirmation\";b:1;s:25:\"wizard_confirmation_label\";s:0:\"\";s:12:\"wizard_track\";s:0:\"\";s:7:\"preview\";i:0;s:13:\"preview_label\";s:0:\"\";s:13:\"preview_title\";s:0:\"\";s:15:\"preview_message\";s:0:\"\";s:18:\"preview_attributes\";a:0:{}s:25:\"preview_excluded_elements\";a:0:{}s:21:\"preview_exclude_empty\";b:1;s:30:\"preview_exclude_empty_checkbox\";b:0;s:5:\"draft\";s:4:\"none\";s:14:\"draft_multiple\";b:0;s:15:\"draft_auto_save\";b:0;s:19:\"draft_saved_message\";s:0:\"\";s:20:\"draft_loaded_message\";s:0:\"\";s:28:\"draft_pending_single_message\";s:0:\"\";s:30:\"draft_pending_multiple_message\";s:0:\"\";s:17:\"confirmation_type\";s:4:\"page\";s:18:\"confirmation_title\";s:0:\"\";s:20:\"confirmation_message\";s:0:\"\";s:16:\"confirmation_url\";s:0:\"\";s:23:\"confirmation_attributes\";a:0:{}s:17:\"confirmation_back\";b:1;s:23:\"confirmation_back_label\";s:0:\"\";s:28:\"confirmation_back_attributes\";a:0:{}s:26:\"confirmation_exclude_query\";b:0;s:26:\"confirmation_exclude_token\";b:0;s:19:\"confirmation_update\";b:0;s:11:\"limit_total\";N;s:20:\"limit_total_interval\";N;s:19:\"limit_total_message\";s:0:\"\";s:18:\"limit_total_unique\";b:0;s:10:\"limit_user\";N;s:19:\"limit_user_interval\";N;s:18:\"limit_user_message\";s:0:\"\";s:17:\"limit_user_unique\";b:0;s:18:\"entity_limit_total\";N;s:27:\"entity_limit_total_interval\";N;s:17:\"entity_limit_user\";N;s:26:\"entity_limit_user_interval\";N;s:5:\"purge\";s:4:\"none\";s:10:\"purge_days\";N;s:16:\"results_disabled\";b:0;s:23:\"results_disabled_ignore\";b:0;s:12:\"token_update\";b:0;}s:6:\"access\";a:11:{s:6:\"create\";a:3:{s:5:\"roles\";a:2:{i:0;s:9:\"anonymous\";i:1;s:13:\"authenticated\";}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:8:\"view_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"update_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"delete_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:9:\"purge_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:8:\"view_own\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"update_own\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"delete_own\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"administer\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:4:\"test\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:13:\"configuration\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}}s:8:\"handlers\";a:0:{}s:4:\"uuid\";s:36:\"5bd89c2c-f97e-4619-9d4f-1f93ee35f511\";}'),

('','webform.webform.subscribe','a:20:{s:8:\"langcode\";s:2:\"en\";s:6:\"status\";s:4:\"open\";s:12:\"dependencies\";a:0:{}s:4:\"open\";N;s:5:\"close\";N;s:6:\"weight\";i:0;s:3:\"uid\";i:1;s:8:\"template\";b:0;s:7:\"archive\";b:0;s:2:\"id\";s:9:\"subscribe\";s:5:\"title\";s:9:\"Subscribe\";s:11:\"description\";s:0:\"\";s:8:\"category\";s:0:\"\";s:8:\"elements\";s:336:\"email:\n  \'#type\': email\n  \'#title\': Email\n  \'#title_display\': invisible\n  \'#placeholder\': Email\nsubmit:\n  \'#type\': webform_markup\n  \'#markup\': \'<div class=\"btn button-js btn-mod btn-medium btn-round mb-xs-10\" type=\"submit\">Subscribe</div>\'\nactions:\n  \'#type\': webform_actions\n  \'#title\': \'Submit button(s)\'\n  \'#submit__label\': \'<none>\'\n\";s:3:\"css\";s:0:\"\";s:10:\"javascript\";s:0:\"\";s:8:\"settings\";a:110:{s:4:\"ajax\";b:0;s:15:\"ajax_scroll_top\";s:4:\"form\";s:18:\"ajax_progress_type\";s:0:\"\";s:11:\"ajax_effect\";s:0:\"\";s:10:\"ajax_speed\";N;s:4:\"page\";b:1;s:16:\"page_submit_path\";s:0:\"\";s:17:\"page_confirm_path\";s:0:\"\";s:16:\"page_admin_theme\";b:0;s:10:\"form_title\";s:4:\"both\";s:16:\"form_submit_once\";b:0;s:22:\"form_exception_message\";s:0:\"\";s:17:\"form_open_message\";s:0:\"\";s:18:\"form_close_message\";s:0:\"\";s:25:\"form_previous_submissions\";b:1;s:17:\"form_confidential\";b:0;s:25:\"form_confidential_message\";s:0:\"\";s:16:\"form_remote_addr\";b:1;s:22:\"form_convert_anonymous\";b:0;s:16:\"form_prepopulate\";b:0;s:30:\"form_prepopulate_source_entity\";b:0;s:39:\"form_prepopulate_source_entity_required\";b:0;s:35:\"form_prepopulate_source_entity_type\";s:0:\"\";s:10:\"form_reset\";b:0;s:25:\"form_disable_autocomplete\";b:0;s:15:\"form_novalidate\";b:0;s:26:\"form_disable_inline_errors\";b:0;s:13:\"form_required\";b:0;s:12:\"form_unsaved\";b:0;s:17:\"form_disable_back\";b:0;s:16:\"form_submit_back\";b:0;s:14:\"form_autofocus\";b:0;s:19:\"form_details_toggle\";b:0;s:18:\"form_access_denied\";s:7:\"default\";s:24:\"form_access_denied_title\";s:0:\"\";s:26:\"form_access_denied_message\";s:0:\"\";s:29:\"form_access_denied_attributes\";a:0:{}s:15:\"form_file_limit\";s:0:\"\";s:16:\"submission_label\";s:0:\"\";s:14:\"submission_log\";b:0;s:16:\"submission_views\";a:0:{}s:24:\"submission_views_replace\";a:0:{}s:23:\"submission_user_columns\";a:0:{}s:25:\"submission_user_duplicate\";b:0;s:24:\"submission_access_denied\";s:7:\"default\";s:30:\"submission_access_denied_title\";s:0:\"\";s:32:\"submission_access_denied_message\";s:0:\"\";s:35:\"submission_access_denied_attributes\";a:0:{}s:28:\"submission_exception_message\";s:0:\"\";s:25:\"submission_locked_message\";s:0:\"\";s:28:\"submission_excluded_elements\";a:0:{}s:24:\"submission_exclude_empty\";b:0;s:33:\"submission_exclude_empty_checkbox\";b:0;s:27:\"previous_submission_message\";s:0:\"\";s:28:\"previous_submissions_message\";s:0:\"\";s:8:\"autofill\";b:0;s:16:\"autofill_message\";s:0:\"\";s:26:\"autofill_excluded_elements\";a:0:{}s:19:\"wizard_progress_bar\";b:1;s:21:\"wizard_progress_pages\";b:0;s:26:\"wizard_progress_percentage\";b:0;s:20:\"wizard_progress_link\";b:0;s:18:\"wizard_start_label\";s:0:\"\";s:19:\"wizard_preview_link\";b:0;s:19:\"wizard_confirmation\";b:1;s:25:\"wizard_confirmation_label\";s:0:\"\";s:12:\"wizard_track\";s:0:\"\";s:7:\"preview\";i:0;s:13:\"preview_label\";s:0:\"\";s:13:\"preview_title\";s:0:\"\";s:15:\"preview_message\";s:0:\"\";s:18:\"preview_attributes\";a:0:{}s:25:\"preview_excluded_elements\";a:0:{}s:21:\"preview_exclude_empty\";b:1;s:30:\"preview_exclude_empty_checkbox\";b:0;s:5:\"draft\";s:4:\"none\";s:14:\"draft_multiple\";b:0;s:15:\"draft_auto_save\";b:0;s:19:\"draft_saved_message\";s:0:\"\";s:20:\"draft_loaded_message\";s:0:\"\";s:28:\"draft_pending_single_message\";s:0:\"\";s:30:\"draft_pending_multiple_message\";s:0:\"\";s:17:\"confirmation_type\";s:4:\"page\";s:18:\"confirmation_title\";s:0:\"\";s:20:\"confirmation_message\";s:0:\"\";s:16:\"confirmation_url\";s:0:\"\";s:23:\"confirmation_attributes\";a:0:{}s:17:\"confirmation_back\";b:1;s:23:\"confirmation_back_label\";s:0:\"\";s:28:\"confirmation_back_attributes\";a:0:{}s:26:\"confirmation_exclude_query\";b:0;s:26:\"confirmation_exclude_token\";b:0;s:19:\"confirmation_update\";b:0;s:11:\"limit_total\";N;s:20:\"limit_total_interval\";N;s:19:\"limit_total_message\";s:0:\"\";s:18:\"limit_total_unique\";b:0;s:10:\"limit_user\";N;s:19:\"limit_user_interval\";N;s:18:\"limit_user_message\";s:0:\"\";s:17:\"limit_user_unique\";b:0;s:18:\"entity_limit_total\";N;s:27:\"entity_limit_total_interval\";N;s:17:\"entity_limit_user\";N;s:26:\"entity_limit_user_interval\";N;s:5:\"purge\";s:4:\"none\";s:10:\"purge_days\";N;s:16:\"results_disabled\";b:0;s:23:\"results_disabled_ignore\";b:0;s:12:\"token_update\";b:0;}s:6:\"access\";a:11:{s:6:\"create\";a:3:{s:5:\"roles\";a:2:{i:0;s:9:\"anonymous\";i:1;s:13:\"authenticated\";}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:8:\"view_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"update_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"delete_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:9:\"purge_any\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:8:\"view_own\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"update_own\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"delete_own\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:10:\"administer\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:4:\"test\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}s:13:\"configuration\";a:3:{s:5:\"roles\";a:0:{}s:5:\"users\";a:0:{}s:11:\"permissions\";a:0:{}}}s:8:\"handlers\";a:0:{}s:4:\"uuid\";s:36:\"d8a48f86-c84b-44ca-b1ec-62d77fc3498a\";}'),

('','webform.webform_options.country_codes','a:8:{s:4:\"uuid\";s:36:\"251dae8c-bd3f-47cb-883b-473999eb446d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WKyw6_wHd1Ls-12ra-byuG23rJPOaCO9o6QrLYo0fbY\";}s:2:\"id\";s:13:\"country_codes\";s:5:\"label\";s:13:\"Country codes\";s:7:\"options\";s:0:\"\";}'),

('','webform.webform_options.country_names','a:8:{s:4:\"uuid\";s:36:\"606c2415-cffd-4d4b-9e4a-074b8bbe008c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"LcoGYtMhMwy6X5Wryrr_mUqNPzdSCVNcyqZULa_7qo0\";}s:2:\"id\";s:13:\"country_names\";s:5:\"label\";s:13:\"Country names\";s:7:\"options\";s:0:\"\";}'),

('','webform.webform_options.creditcard_codes','a:8:{s:4:\"uuid\";s:36:\"896ade15-d68e-40cf-ab9e-e0aa6ba8f1a7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ai9t0SUFQABCrwdqoi8LBqhaMzROfaFHGgsURpEWnm4\";}s:2:\"id\";s:16:\"creditcard_codes\";s:5:\"label\";s:17:\"Credit card codes\";s:7:\"options\";s:66:\"VI: \'Visa\'\nMC: \'Mastercard\'\nAE: \'American Express\'\nDC: \'Discover\'\n\";}'),

('','webform.webform_options.days','a:8:{s:4:\"uuid\";s:36:\"42ee862f-1c9e-4749-b9ce-348ca57b3857\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"T744d_CMtx_CsVZD1MNNvyiSNlemzmFgmzVdBKtuKq8\";}s:2:\"id\";s:4:\"days\";s:5:\"label\";s:4:\"Days\";s:7:\"options\";s:121:\"Sunday: Sunday\nMonday: Monday\nTuesday: Tuesday\nWednesday: Wednesday\nThursday: Thursday\nFriday: Friday\nSaturday: Saturday\n\";}'),

('','webform.webform_options.education','a:8:{s:4:\"uuid\";s:36:\"390e3ad2-8c93-4f64-9fff-a337f935ce87\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"cidMez3wHXoTzTg_4KqylNWeDY2lYJ-DRLIAF7xq57M\";}s:2:\"id\";s:9:\"education\";s:5:\"label\";s:9:\"Education\";s:7:\"options\";s:187:\"High School: High School\nAssociate Degree: Associate Degree\nAssociate Degree: Associate Degree\nGraduate or Professional Degree: Graduate or Professional Degree\nSome College: Some College\n\";}'),

('','webform.webform_options.employment_status','a:8:{s:4:\"uuid\";s:36:\"5b480678-5d6b-4588-97a6-e82aabd9e398\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6iKOLiv3WqdDwbLEYesK2txBl-1W8frLFe3PbT8-AaE\";}s:2:\"id\";s:17:\"employment_status\";s:5:\"label\";s:17:\"Employment status\";s:7:\"options\";s:113:\"\'Full Time\': \'Full Time\'\n\'Part Time\': \'Part Time\'\n\'Military\': \'Military\'\nUnemployed: Unemployed\nRetired: Retired\n\";}'),

('','webform.webform_options.ethnicity','a:8:{s:4:\"uuid\";s:36:\"c636b488-3852-46db-a793-af19d6d16a03\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SSV6f9SV3qO5qcz99jSqj7-2eGNaD9RfOYDdMPUffew\";}s:2:\"id\";s:9:\"ethnicity\";s:5:\"label\";s:9:\"Ethnicity\";s:7:\"options\";s:200:\"Caucasian: Caucasian\n\'Latino/Hispanic\': \'Latino/Hispanic\'\n\'Middle Eastern\': \'Middle Eastern\'\nAfrican: African\nCaribbean: Caribbean\n\'South Asian\': \'South Asian\'\n\'East Asian\': \'East Asian\'\nMixed: Mixed\n\";}'),

('','webform.webform_options.gender','a:8:{s:4:\"uuid\";s:36:\"e04017f8-c64f-472d-88e4-46a52f02e0a2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6WYQFjFAQkeNPRRklUX_i7UaJK_Uw3iNDU7ux2j3pCo\";}s:2:\"id\";s:6:\"gender\";s:5:\"label\";s:6:\"Gender\";s:7:\"options\";s:51:\"Male: Male\nFemale: Female\nTransgender: Transgender\n\";}'),

('','webform.webform_options.industry','a:8:{s:4:\"uuid\";s:36:\"794e1637-a0b7-42e8-ad6e-7520098c1fa7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AkLS04Kjzd3Z8UBlMVBMBYgJdpYZhF9ZVyPIUQs9dRk\";}s:2:\"id\";s:8:\"industry\";s:5:\"label\";s:8:\"Industry\";s:7:\"options\";s:1425:\"Accounting/Finance: Accounting/Finance\nAdvertising/Public Relations: Advertising/Public Relations\nAerospace/Aviation: Aerospace/Aviation\nArts/Entertainment/Publishing: Arts/Entertainment/Publishing\nAutomotive: Automotive\nBanking/Mortgage: Banking/Mortgage\nBusiness Development: Business Development\nBusiness Opportunity: Business Opportunity\nClerical/Administrative: Clerical/Administrative\nConstruction/Facilities: Construction/Facilities\nConsumer Goods: Consumer Goods\nCustomer Service: Customer Service\nEducation/Training: Education/Training\nEnergy/Utilities: Energy/Utilities\nEngineering: Engineering\nGovernment/Military: Government/Military\nHealthcare: Healthcare\nHospitality/Travel: Hospitality/Travel\nHuman Resources: Human Resources\nInstallation/Maintenance: Installation/Maintenance\nInsurance: Insurance\nInternet: Internet\nLaw Enforcement/Security: Law Enforcement/Security\nLegal: Legal\nManagement/Executive: Management/Executive\nManufacturing/Operations: Manufacturing/Operations\nMarketing: Marketing\nNon-Profit/Volunteer: Non-Profit/Volunteer\nPharmaceutical/Biotech: Pharmaceutical/Biotech\nProfessional Services: Professional Services\nReal Estate: Real Estate\nRestaurant/Food Service: Restaurant/Food Service\nRetail: Retail\nSales: Sales\nScience/Research: Science/Research\nSkilled Labor: Skilled Labor\nTechnology: Technology\nTelecommunications: Telecommunications\nTransportation/Logistics: Transportation/Logistics\n\";}'),

('','webform.webform_options.languages','a:8:{s:4:\"uuid\";s:36:\"5862df58-677d-4bd1-ba88-1d09151db361\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vDwaQMB485SRDS5QUFJf8awBp0DdlOYSMnYsLiw1l5s\";}s:2:\"id\";s:9:\"languages\";s:5:\"label\";s:9:\"Languages\";s:7:\"options\";s:0:\"\";}'),

('','webform.webform_options.likert_agreement','a:8:{s:4:\"uuid\";s:36:\"fe9a08f8-45f7-42f9-9cbf-ad510e6d9293\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"kTJEQFpTapkGkf4XD51vPW2-7aZU7awzSenC65YDqGQ\";}s:2:\"id\";s:16:\"likert_agreement\";s:5:\"label\";s:17:\"Likert: Agreement\";s:7:\"options\";s:84:\"1: Much Worse\n2: Somewhat Worse\n3: About the Same\n4: Somewhat Better\n5: Much Better\n\";}'),

('','webform.webform_options.likert_comparison','a:8:{s:4:\"uuid\";s:36:\"04d7d516-1f55-4cc4-84e8-87ed77ac8860\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"saeeZhVt98h_n7CVmx4DOg02g7x3cIdctN_E7BYzMgs\";}s:2:\"id\";s:17:\"likert_comparison\";s:5:\"label\";s:18:\"Likert: Comparison\";s:7:\"options\";s:71:\"1: Strongly Disagree\n2: Disagree\n3: Neutral\n4: Agree\n5: Strongly Agree\n\";}'),

('','webform.webform_options.likert_importance','a:8:{s:4:\"uuid\";s:36:\"fc7b1bab-7a9e-4627-a611-1040a0fa06a0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"UZmRfKwhC1I8mlY5XuVV3DF7MpWAbFxyynhNFR9kuOo\";}s:2:\"id\";s:17:\"likert_importance\";s:5:\"label\";s:18:\"Likert: Importance\";s:7:\"options\";s:88:\"1: Not at all Important\n2: Somewhat Important\n3: Neutral\n4: Important\n5: Very Important\n\";}'),

('','webform.webform_options.likert_quality','a:8:{s:4:\"uuid\";s:36:\"2f9b2509-dd97-4628-8151-a717462b018f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"kyCI0E0VJVJXi_Z61m6Mom95_ot1haYPehpPr_IxdcM\";}s:2:\"id\";s:14:\"likert_quality\";s:5:\"label\";s:15:\"Likert: Quality\";s:7:\"options\";s:50:\"1: Poor\n2: Fair\n3: Good\n4: Very good\n5: Excellent\n\";}'),

('','webform.webform_options.likert_satisfaction','a:8:{s:4:\"uuid\";s:36:\"52371a23-daca-44e7-88ee-32e942a6c822\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"neOMp5gtbo4DzHTQAmmvrsN8VkSA7LXCl5R1oXTqKX0\";}s:2:\"id\";s:19:\"likert_satisfaction\";s:5:\"label\";s:20:\"Likert: Satisfaction\";s:7:\"options\";s:77:\"1: Very Unsatisfied\n2: Unsatisfied\n3: Neutral\n4: Satisfied\n5: Very Satisfied\n\";}'),

('','webform.webform_options.likert_ten_scale','a:8:{s:4:\"uuid\";s:36:\"749b2285-48b6-48e4-b1fc-1206cbde706e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"VtI_OJow8fKXIo4jyhi2UF_WmE6MQf94_fR9qctlv7s\";}s:2:\"id\";s:16:\"likert_ten_scale\";s:5:\"label\";s:17:\"Likert: Ten Scale\";s:7:\"options\";s:52:\"1: 1\n2: 2\n3: 3\n4: 4\n5: 5\n6: 6\n7: 7\n8: 8\n9: 9\n10: 10\n\";}'),

('','webform.webform_options.likert_would_you','a:8:{s:4:\"uuid\";s:36:\"37128d1d-3e70-4ee8-8ca3-335d7cf659df\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"98M-DPZLTuMVYsG1XrXy1h90nf3al-jgdqGJrW8Elcg\";}s:2:\"id\";s:16:\"likert_would_you\";s:5:\"label\";s:17:\"Likert: Would You\";s:7:\"options\";s:72:\"1: Definitely Not\n2: Probably Not\n3: Not Sure\n4: Probably\n5: Definitely\n\";}'),

('','webform.webform_options.marital_status','a:8:{s:4:\"uuid\";s:36:\"1f15f7d1-32f8-4b54-a249-682f1919b227\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"0saefTQh-QUbxCT1hBxeNaEN2g63K2R21rRXxGXQoCs\";}s:2:\"id\";s:14:\"marital_status\";s:5:\"label\";s:14:\"Marital status\";s:7:\"options\";s:68:\"Single: Single\nMarried: Married\nDivorced: Divorced\nWidowed: Widowed\n\";}'),

('','webform.webform_options.months','a:8:{s:4:\"uuid\";s:36:\"3d4f80c3-ab18-430b-a795-aa2e872f198b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Y0ajkmoLjJ568EZRzaBSy_vEejATn3EA2RTymPoGZ5U\";}s:2:\"id\";s:6:\"months\";s:5:\"label\";s:6:\"Months\";s:7:\"options\";s:184:\"January: January\nFebruary: February\nMarch: March\nApril: April\nMay: May\nJune: June\nJuly: July\nAugust: August\nSeptember: September\nOctober: October\nNovember: November\nDecember: December\n\";}'),

('','webform.webform_options.relationship','a:8:{s:4:\"uuid\";s:36:\"91e5ffe9-607a-4455-844e-33b5e3125935\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"y8t4RZdGS6VERGR7rBmSPFIG0fO5OZb87IB6P5A6Avw\";}s:2:\"id\";s:12:\"relationship\";s:5:\"label\";s:12:\"Relationship\";s:7:\"options\";s:101:\"Parent: Parent\n\'Significant Other\': \'Significant Other\'\nSibling: Sibling\nChild: Child\nFriend: Friend\n\";}'),

('','webform.webform_options.size','a:8:{s:4:\"uuid\";s:36:\"f6bffd2b-eeb2-4676-8524-07c4563b6884\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Tq6nZxoRP6_RwY5Q6Z4ecRFadf4xCmFRgg6PqnBzJLc\";}s:2:\"id\";s:4:\"size\";s:5:\"label\";s:4:\"Size\";s:7:\"options\";s:91:\"Extra Small: Extra Small\nSmall: Small\nMedium: Medium\nLarge: Large\nExtra Large: Extra Large\n\";}'),

('','webform.webform_options.state_codes','a:8:{s:4:\"uuid\";s:36:\"247276a7-d9b9-4a41-b79d-bbd6e56ca556\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"m3g0-QKCeVgtX-uSscYIDojtBBljuRJWq_212R4o-Pg\";}s:2:\"id\";s:11:\"state_codes\";s:5:\"label\";s:11:\"State codes\";s:7:\"options\";s:728:\"AL: Alabama\nAK: Alaska\nAZ: Arizona\nAR: Arkansas\nCA: California\nCO: Colorado\nCT: Connecticut\nDE: Delaware\nDC: \'District of Columbia\'\nFL: Florida\nGA: Georgia\nGU: Guam\nHI: Hawaii\nID: Idaho\nIL: Illinois\nIN: Indiana\nIA: Iowa\nKS: Kansas\nKY: Kentucky\nLA: Louisiana\nME: Maine\nMD: Maryland\nMA: Massachusetts\nMI: Michigan\nMN: Minnesota\nMS: Mississippi\nMO: Missouri\nMT: Montana\nNE: Nebraska\nNV: Nevada\nNH: \'New Hampshire\'\nNJ: \'New Jersey\'\nNM: \'New Mexico\'\nNY: \'New York\'\nNC: \'North Carolina\'\nND: \'North Dakota\'\nOH: Ohio\nOK: Oklahoma\nOR: Oregon\nPA: Pennsylvania\nRI: \'Rhode Island\'\nSC: \'South Carolina\'\nSD: \'South Dakota\'\nTN: Tennessee\nTX: Texas\nUT: Utah\nVT: Vermont\nVA: Virginia\nWA: Washington\nWV: \'West Virginia\'\nWI: Wisconsin\nWY: Wyoming\n\";}'),

('','webform.webform_options.state_names','a:8:{s:4:\"uuid\";s:36:\"775f157f-854f-4149-a578-42393cdcfa6c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"I5ixKB0YwXXr8YCu-8oSY3lAuC7NEnBGuL0SHm2eRfY\";}s:2:\"id\";s:11:\"state_names\";s:5:\"label\";s:11:\"State names\";s:7:\"options\";s:1081:\"Alabama: Alabama\nAlaska: Alaska\nArizona: Arizona\nArkansas: Arkansas\nCalifornia: California\nColorado: Colorado\nConnecticut: Connecticut\nDelaware: Delaware\n\'District of Columbia\': \'District of Columbia\'\nFlorida: Florida\nGeorgia: Georgia\nHawaii: Hawaii\nIdaho: Idaho\nIllinois: Illinois\nIndiana: Indiana\nIowa: Iowa\nKansas: Kansas\nKentucky: Kentucky\nLouisiana: Louisiana\nMaine: Maine\nMaryland: Maryland\nMassachusetts: Massachusetts\nMichigan: Michigan\nMinnesota: Minnesota\nMississippi: Mississippi\nMissouri: Missouri\nMontana: Montana\nNebraska: Nebraska\nNevada: Nevada\n\'New Hampshire\': \'New Hampshire\'\n\'New Jersey\': \'New Jersey\'\n\'New Mexico\': \'New Mexico\'\n\'New York\': \'New York\'\n\'North Carolina\': \'North Carolina\'\n\'North Dakota\': \'North Dakota\'\nOhio: Ohio\nOklahoma: Oklahoma\nOregon: Oregon\nPennsylvania: Pennsylvania\n\'Rhode Island\': \'Rhode Island\'\n\'South Carolina\': \'South Carolina\'\n\'South Dakota\': \'South Dakota\'\nTennessee: Tennessee\nTexas: Texas\nUtah: Utah\nVermont: Vermont\nVirginia: Virginia\nWashington: Washington\n\'West Virginia\': \'West Virginia\'\nWisconsin: Wisconsin\nWyoming: Wyoming\n\";}'),

('','webform.webform_options.state_province_codes','a:10:{s:4:\"uuid\";s:36:\"99685bb1-27c5-4809-b23e-2400bdcc8d18\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"qHBCN68U1lClhKHP06dP4gjeZa3bZTSPbTSNIpW3Y98\";}s:2:\"id\";s:20:\"state_province_codes\";s:5:\"label\";s:20:\"State/Province codes\";s:8:\"category\";N;s:6:\"likert\";b:0;s:7:\"options\";s:1003:\"AL: Alabama\nAK: Alaska\nAS: \'American Samoa\'\nAZ: Arizona\nAR: Arkansas\nAE: \'Armed Forces (Canada, Europe, Africa, or Middle East)\'\nAA: \'Armed Forces Americas\'\nAP: \'Armed Forces Pacific\'\nCA: California\nCO: Colorado\nCT: Connecticut\nDE: Delaware\nDC: \'District of Columbia\'\nFM: \'Federate States of Micronesia\'\nFL: Florida\nGA: Georgia\nGU: Guam\nHI: Hawaii\nID: Idaho\nIL: Illinois\nIN: Indiana\nIA: Iowa\nKS: Kansas\nKY: Kentucky\nLA: Louisiana\nME: Maine\nMH: \'Marshall Islands\'\nMD: Maryland\nMA: Massachusetts\nMI: Michigan\nMN: Minnesota\nMS: Mississippi\nMO: Missouri\nMT: Montana\nNE: Nebraska\nNV: Nevada\nNH: \'New Hampshire\'\nNJ: \'New Jersey\'\nNM: \'New Mexico\'\nNY: \'New York\'\nNC: \'North Carolina\'\nND: \'North Dakota\'\nMP: \'Northern Mariana Islands\'\nOH: Ohio\nOK: Oklahoma\nOR: Oregon\nPW: Palau\nPA: Pennsylvania\nPR: \'Puerto Rico\'\nRI: \'Rhode Island\'\nSC: \'South Carolina\'\nSD: \'South Dakota\'\nTN: Tennessee\nTX: Texas\nUT: Utah\nVT: Vermont\nVI: \'Virgin Islands\'\nVA: Virginia\nWA: Washington\nWV: \'West Virginia\'\nWI: Wisconsin\nWY: Wyoming\n\";}'),

('','webform.webform_options.state_province_names','a:8:{s:4:\"uuid\";s:36:\"3bf8fc48-a7f1-40e3-9169-2052a795fa17\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Dsbo0h8kGlwB0RgwOOPBhnQzwgoJXwsiqxznsQADipI\";}s:2:\"id\";s:20:\"state_province_names\";s:5:\"label\";s:20:\"State/Province names\";s:7:\"options\";s:1570:\"Alabama: Alabama\nAlaska: Alaska\n\'American Samoa\': \'American Samoa\'\nArizona: Arizona\nArkansas: Arkansas\n\'Armed Forces (Canada, Europe, Africa, or Middle East\': \'Armed Forces (Canada, Europe, Africa, or Middle East\'\n\'Armed Forces Americas\': \'Armed Forces Americas\'\n\'Armed Forces Pacific\': \'Armed Forces Pacific\'\nCalifornia: California\nColorado: Colorado\nConnecticut: Connecticut\nDelaware: Delaware\n\'District of Columbia\': \'District of Columbia\'\n\'Federate States of Micronesia\': \'Federate States of Micronesia\'\nFlorida: Florida\nGeorgia: Georgia\nGuam: Guam\nHawaii: Hawaii\nIdaho: Idaho\nIllinois: Illinois\nIndiana: Indiana\nIowa: Iowa\nKansas: Kansas\nKentucky: Kentucky\nLouisiana: Louisiana\nMaine: Maine\n\'Marshall Islands\': \'Marshall Islands\'\nMaryland: Maryland\nMassachusetts: Massachusetts\nMichigan: Michigan\nMinnesota: Minnesota\nMississippi: Mississippi\nMissouri: Missouri\nMontana: Montana\nNebraska: Nebraska\nNevada: Nevada\n\'New Hampshire\': \'New Hampshire\'\n\'New Jersey\': \'New Jersey\'\n\'New Mexico\': \'New Mexico\'\n\'New York\': \'New York\'\n\'North Carolina\': \'North Carolina\'\n\'North Dakota\': \'North Dakota\'\n\'Northern Mariana Islands\': \'Northern Mariana Islands\'\nOhio: Ohio\nOklahoma: Oklahoma\nOregon: Oregon\nPalau: Palau\nPennsylvania: Pennsylvania\n\'Puerto Rico\': \'Puerto Rico\'\n\'Rhode Island\': \'Rhode Island\'\n\'South Carolina\': \'South Carolina\'\n\'South Dakota\': \'South Dakota\'\nTennessee: Tennessee\nTexas: Texas\nUtah: Utah\nVermont: Vermont\n\'Virgin Islands\': \'Virgin Islands\'\nVirginia: Virginia\nWashington: Washington\n\'West Virginia\': \'West Virginia\'\nWisconsin: Wisconsin\nWyoming: Wyoming\n\";}'),

('','webform.webform_options.time_zones','a:8:{s:4:\"uuid\";s:36:\"43688776-8900-46c4-b576-7c1dc533cc28\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"egUVOkBF8Rfzd-cuycbVPEBBfN8PpBQAyq_8iRd7Nns\";}s:2:\"id\";s:10:\"time_zones\";s:5:\"label\";s:10:\"Time zones\";s:7:\"options\";s:0:\"\";}'),

('','webform.webform_options.titles','a:8:{s:4:\"uuid\";s:36:\"72e3d7ee-059f-4dac-bcda-f78f3e8229af\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Onwyr2kH5zCeHvMfSSPDJIKUKrvX7x7tAr-7Uv_-k-c\";}s:2:\"id\";s:6:\"titles\";s:5:\"label\";s:6:\"Titles\";s:7:\"options\";s:41:\"Miss: Miss\nMs: Ms\nMr: Mr\nMrs: Mrs\nDr: Dr\n\";}'),

('','webform.webform_options.yes_no','a:8:{s:4:\"uuid\";s:36:\"2597eb3c-d1b3-40ea-b4db-09a8c141c1bd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"webform\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KAEJv6Gks8rU-P0XcmUfjRuk-92T32qbkBCn1LQgKr8\";}s:2:\"id\";s:6:\"yes_no\";s:5:\"label\";s:6:\"Yes/No\";s:7:\"options\";s:16:\"Yes: Yes\nNo: No\n\";}'),

('language.de','commerce_price.commerce_currency.USD','a:2:{s:4:\"name\";s:9:\"US-Dollar\";s:6:\"symbol\";s:1:\"$\";}'),

('language.fr','commerce_price.commerce_currency.USD','a:2:{s:4:\"name\";s:22:\"dollar des États-Unis\";s:6:\"symbol\";s:3:\"$US\";}');

/*Table structure for table `file_managed` */

DROP TABLE IF EXISTS `file_managed`;

CREATE TABLE `file_managed` (
  `fid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `uid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `filename` varchar(255) DEFAULT NULL,
  `uri` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL,
  `filemime` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `filesize` bigint(20) unsigned DEFAULT NULL,
  `status` tinyint(4) NOT NULL,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) NOT NULL,
  PRIMARY KEY (`fid`),
  UNIQUE KEY `file_field__uuid__value` (`uuid`),
  KEY `file_field__uri` (`uri`(191)),
  KEY `file_field__status` (`status`),
  KEY `file_field__changed` (`changed`),
  KEY `file_field__uid__target_id` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=71 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for file entities.';

/*Data for the table `file_managed` */

insert  into `file_managed`(`fid`,`uuid`,`langcode`,`uid`,`filename`,`uri`,`filemime`,`filesize`,`status`,`created`,`changed`) values 

(1,'db2cad05-1e3b-4b35-b163-99d7d036130c','en',1,'file_browser_icon.png','public://file_browser_icon.png','image/png',304,1,1479926885,1479926885),

(2,'c1e488db-179c-4078-9ed6-f950a44d73b7','en',1,'section-bg-3.jpg','public://section-bg-3.jpg','image/jpeg',112484,1,1479930755,1479930755),

(3,'501b4d53-9be5-49f9-85f5-68be6576c88d','en',1,'section-bg-15.jpg','public://section-bg-15.jpg','image/jpeg',180800,1,1479930755,1479930755),

(4,'39ffcf96-5867-425b-b750-d80f35c3af54','en',1,'section-bg-23.jpg','public://section-bg-23.jpg','image/jpeg',125411,1,1479930755,1479930755),

(5,'1722aeea-195a-4e2a-91bb-e2ab3fc9a882','en',1,'section-bg-23.jpg','public://section-bg-23_0.jpg','image/jpeg',125411,1,1479935790,1479935790),

(6,'725d795a-68f0-4f26-8205-28d7b30eb26c','en',1,'section-bg-24.jpg','public://section-bg-24.jpg','image/jpeg',106765,1,1479935790,1479935790),

(7,'eeb2cbbe-8ee5-46a8-98fa-9cf790ceaac0','en',1,'section-bg-22_0.jpg','public://section-bg-22_0.jpg','image/jpeg',69872,1,1480286384,1480286384),

(8,'88d7943f-ebb8-4e55-99e4-005b954d28fa','en',1,'user-avatar.png','public://pictures/2016-11/user-avatar.png','image/png',2833,1,1480341750,1480341754),

(9,'5b477360-9f8f-4eb2-af2c-c0ed50efe952','en',1,'projects-1.jpg','public://projects-1.jpg','image/jpeg',40512,1,1480369951,1480369951),

(10,'ea10276b-2053-4c80-a65a-09375d1a50f3','en',1,'projects-2.jpg','public://projects-2.jpg','image/jpeg',20651,1,1480369951,1480369951),

(11,'0a0fd0c8-f341-4769-a93c-931814a773b4','en',1,'projects-4.jpg','public://projects-4.jpg','image/jpeg',41058,1,1480370234,1480370234),

(12,'9a9bda74-1569-48c9-90b4-7ed0974448c3','en',1,'projects-3.jpg','public://projects-3.jpg','image/jpeg',74307,1,1480370234,1480370234),

(13,'535ed491-8e9e-4cba-ae5a-d0a271f616bc','en',1,'projects-6.jpg','public://projects-6.jpg','image/jpeg',77250,1,1480370312,1480370312),

(14,'4f612fcd-73c2-40f4-8974-328ef714b261','en',1,'projects-5.jpg','public://projects-5.jpg','image/jpeg',37867,1,1480370312,1480370312),

(15,'9ac63ab8-7e64-4178-ac28-5a289f8bc024','en',1,'projects-8.jpg','public://projects-8.jpg','image/jpeg',80619,1,1480371806,1480371806),

(16,'76c22bd6-3192-4d08-a01f-e1302358a069','en',1,'projects-7.jpg','public://projects-7.jpg','image/jpeg',16009,1,1480371806,1480371806),

(17,'f6c2dc39-eb02-4d57-b866-910303d7019d','en',1,'projects-9.jpg','public://projects-9.jpg','image/jpeg',33836,1,1480371844,1480371844),

(18,'92a4f677-a72d-4962-93a6-77dadedaaabf','en',1,'projects-10.jpg','public://projects-10.jpg','image/jpeg',42485,1,1480371844,1480371844),

(19,'61e3a4aa-70f2-407d-a4e7-164c824d3620','en',1,'projects-11.jpg','public://projects-11.jpg','image/jpeg',38101,1,1480371914,1480371914),

(20,'feb8c270-779e-4fa9-8c0a-d911228aa1b8','en',1,'projects-12_0.jpg','public://projects-12_0.jpg','image/jpeg',43088,1,1480371914,1480371914),

(21,'f9fad354-81f6-4799-a270-0b0abc7bc55c','en',1,'projects-15.jpg','public://projects-15.jpg','image/jpeg',50986,1,1480371939,1480371939),

(22,'148650d5-1932-4144-846d-dd60f687e083','en',1,'logo-footer.png','public://logo-footer.png','image/png',3325,1,1480889226,1480889226),

(23,'611372dd-9927-41ee-b6d3-74183f2aafad','en',1,'logo.png','public://logo.png','image/png',2828,1,1480942402,1480942402),

(24,'07538f5a-e4b2-4660-8436-75827a13be8a','en',1,'logo-dark.png','public://logo-dark.png','image/png',2911,1,1480942535,1480942535),

(25,'104499e7-bd0f-41cc-ad67-ea10de08d7ba','en',1,'section-bg-5.jpg','public://section-bg-5.jpg','image/jpeg',93740,1,1480942645,1480942645),

(26,'2ecd8943-594c-4e05-94bd-5ed3e319bd4d','en',1,'projects-6_1.jpg','public://projects-6_1.jpg','image/jpeg',232500,1,1481049625,1481049625),

(27,'fae4d219-f7e8-49c6-8d8e-14b887b9a862','en',1,'team-1.jpg','public://team-1.jpg','image/jpeg',16798,1,1481227753,1481227753),

(28,'fabc30af-39e2-49b9-841c-6cdcbcd690f4','en',1,'team-2.jpg','public://team-2_0.jpg','image/jpeg',15784,1,1481228791,1481228791),

(29,'c7bbd000-b1a6-47f8-81d5-b03d96630c36','en',1,'team-3.jpg','public://team-3_0.jpg','image/jpeg',18276,1,1481228896,1481228896),

(30,'5119c9c9-9b8c-4fdc-a028-a54b3337a8bc','en',1,'team-4.jpg','public://team-4.jpg','image/jpeg',10758,1,1481229083,1481229083),

(31,'9292254b-02d2-428e-9bb0-000de369a9d7','en',1,'photographer-1.jpg','public://photographer-1.jpg','image/jpeg',536117,1,1481650792,1481650792),

(32,'3c552e13-1a97-4dca-9d64-41faf5b3c762','en',1,'photographer-2.jpg','public://photographer-2.jpg','image/jpeg',365339,1,1481650816,1481650816),

(33,'ec1459de-49cc-4f8c-92d3-6cc01bf70bc5','en',1,'photographer-3.jpg','public://photographer-3.jpg','image/jpeg',593149,1,1481650845,1481650845),

(34,'893835b2-aa30-4faf-b545-59c6989d1186','en',1,'photographer-4.jpg','public://photographer-4.jpg','image/jpeg',616509,1,1481650957,1481650957),

(35,'3bd6e9fb-b7d4-40b5-8967-45476d5ed6b5','en',1,'photographer-5.jpg','public://photographer-5.jpg','image/jpeg',414013,1,1481650975,1481650975),

(36,'029ebcd5-1bb1-45b3-b6be-f300e6f7a200','en',1,'photographer-6.jpg','public://photographer-6.jpg','image/jpeg',600731,1,1481650996,1481650996),

(37,'a5f17858-218e-4499-ba45-74585090c11f','en',1,'photographer-7.jpg','public://photographer-7.jpg','image/jpeg',200280,1,1481651017,1481651017),

(38,'201c6667-a82c-4f0a-9cf9-3436a086cee3','en',1,'photographer-8.jpg','public://photographer-8.jpg','image/jpeg',419727,1,1481651040,1481651040),

(39,'184d948b-7c7f-41bf-92b4-fe579ca52c59','en',1,'photographer-9.jpg','public://photographer-9.jpg','image/jpeg',170877,1,1481651061,1481651061),

(40,'450f5f8b-81dc-44bc-acbd-2b5e867d640f','en',1,'photographer-10.jpg','public://photographer-10.jpg','image/jpeg',540281,1,1481651082,1481651082),

(43,'255f90e6-9bf8-41c4-802a-0de859201581','en',1,'section-bg-1.jpg','public://section-bg-1.jpg','image/jpeg',133653,1,1481654901,1481654901),

(44,'9927d4b5-ad37-4225-9d3c-d8a7bb3b65d1','en',1,'section-bg-2.jpg','public://section-bg-2.jpg','image/jpeg',66509,1,1481906355,1481906355),

(45,'6a28a24c-2a49-43a5-9a0c-0c4a5ca97ea2','en',1,'promo-1.png','public://promo-1.png','image/png',70330,1,1481906402,1481906402),

(46,'4620dbf6-63d4-4594-b6d6-c09889b79c06','en',1,'section-bg-3.jpg','public://section-bg-3_0.jpg','image/jpeg',290154,1,1481906561,1481906561),

(47,'8844cf63-2092-4b5a-8179-2e3e63a2f794','en',1,'section-bg-22_0.jpg','public://section-bg-22_0_0.jpg','image/jpeg',122540,1,1481906692,1481906692),

(48,'68a8f45c-66b4-4163-af5c-9591490b6f2c','en',1,'promo-3.png','public://promo-3.png','image/png',285291,1,1481906692,1481906692),

(49,'6349fa23-a4a8-4bc7-828d-742a5cc664a7','en',1,'promo-4.png','public://promo-4.png','image/png',130189,1,1481906826,1481906826),

(50,'20719d36-3401-4de2-ae63-effe6a33a78b','en',1,'section-bg-16.jpg','public://section-bg-16.jpg','image/jpeg',251346,1,1481906879,1481906879),

(53,'ae0ffa7c-0c9d-4b42-af17-c20a3542f4f1','en',1,'GOPR0252.MP4_snapshot_06.01_[2017.03.05_17.19.14].jpg','public://GOPR0252.MP4_snapshot_06.01_[2017.03.05_17.19.14].jpg','image/jpeg',126744,0,1489395374,1489395374),

(54,'64124884-6a8d-407f-9101-e4c68d077fa5','en',1,'nikadevs-59.png','public://nikadevs-59.png','image/png',52502,0,1489395497,1489395497),

(55,'08b521b7-1a1d-4771-949b-da70b0d6ffba','en',1,'section-bg-10.jpg','public://section-bg-10.jpg','image/jpeg',428773,0,1490606457,1490606457),

(56,'e46e67c8-b4d0-4a21-a9ca-b061608590a3','en',1,'section-bg-6.jpg','public://section-bg-6.jpg','image/jpeg',340136,0,1490606483,1490606483),

(57,'bd3aa66c-1134-434b-8bd0-9a49b19e1501','en',1,'section-bg-9.jpg','public://section-bg-9.jpg','image/jpeg',269527,0,1490606503,1490606503),

(58,'cdb5293c-2902-4a4c-a8b3-0eda2990172d','en',1,'section-bg-4.jpg','public://section-bg-4.jpg','image/jpeg',174116,0,1490606735,1490606735),

(59,'5c618280-b9a6-4dfd-a30b-ddb53e3ac9b2','en',1,'section-bg-12.jpg','public://section-bg-12.jpg','image/jpeg',563958,0,1490606771,1490606771),

(60,'3f2b3452-fc4d-4d4a-8697-3619d554a6d0','en',1,'section-bg-7.jpg','public://section-bg-7.jpg','image/jpeg',86928,0,1490606927,1490606927),

(61,'548825c8-f5ac-4877-b05d-8f794ac984fd','en',1,'section-bg-20.jpg','public://section-bg-20.jpg','image/jpeg',266846,0,1490606953,1490606953),

(62,'cac4c0bf-b5eb-46d9-9014-49e18850c65a','en',1,'shop-prev-1.jpg','public://2017-08/shop-prev-1.jpg','image/jpeg',44602,1,1503051420,1503051420),

(63,'6d58db44-e358-4ba6-9efb-5478ef7a8c0a','en',1,'shop-prev-2.jpg','public://2017-08/shop-prev-2.jpg','image/jpeg',48236,1,1503051435,1503051435),

(64,'77969739-01b9-407f-a9d4-349c1774b0d6','en',1,'shop-prev-3.jpg','public://2017-08/shop-prev-3.jpg','image/jpeg',34330,1,1503051657,1503051657),

(65,'97b48011-a20f-4905-bdce-8e626b2fb7b1','en',1,'shop-prev-4.jpg','public://2017-08/shop-prev-4.jpg','image/jpeg',39999,1,1503052477,1503052477),

(66,'c4f6079a-6eca-42d4-b6b6-276e5a198afe','en',1,'guitar_freak.jpg','public://2017-08/guitar_freak.jpg','image/jpeg',22169,1,1503310305,1503310305),

(67,'d5668069-cbae-4715-8c5b-5026b78d6850','en',1,'dance_now.jpg','public://2017-08/dance_now.jpg','image/jpeg',18542,1,1503310562,1503310562),

(68,'cbdfbd00-2bd5-4766-b966-18d312c845bb','en',1,'Screenshot_1.png','public://inline-images/Screenshot_1.png','image/png',513598,0,1531731883,1531731883),

(69,'4177d8b8-1d2a-462a-8c90-d0b80d222b2c','en',1,'Screenshot_1.png','public://inline-images/Screenshot_1_0.png','image/png',513598,0,1531731888,1531731888),

(70,'07b474d8-15c5-4cbb-9519-20a4148f3018','en',1,'01_preview.png','public://01_preview.png','image/png',144748,1,1569659003,1569659003);

/*Table structure for table `file_usage` */

DROP TABLE IF EXISTS `file_usage`;

CREATE TABLE `file_usage` (
  `fid` int(10) unsigned NOT NULL COMMENT 'File ID.',
  `module` varchar(50) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The name of the module that is using the file.',
  `type` varchar(64) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The name of the object type in which the file is used.',
  `id` varchar(64) CHARACTER SET ascii NOT NULL DEFAULT '0' COMMENT 'The primary key of the object using the file.',
  `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The number of times this file is used by this object.',
  PRIMARY KEY (`fid`,`type`,`id`,`module`),
  KEY `type_id` (`type`,`id`),
  KEY `fid_count` (`fid`,`count`),
  KEY `fid_module` (`fid`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Track where a file is used.';

/*Data for the table `file_usage` */

insert  into `file_usage`(`fid`,`module`,`type`,`id`,`count`) values 

(1,'embed','embed_button','file_browser',1),

(2,'file','node','2',1),

(2,'file','node','3',1),

(2,'file','node','4',1),

(2,'file','node','5',1),

(2,'file','node','6',1),

(3,'file','node','2',1),

(3,'file','node','4',1),

(3,'file','node','5',1),

(3,'file','node','6',1),

(4,'file','node','2',1),

(5,'file','node','3',1),

(5,'file','node','6',1),

(6,'file','node','3',2),

(7,'file','node','26',1),

(7,'file','node','5',2),

(8,'file','user','1',1),

(9,'file','node','25',1),

(9,'file','node','10',2),

(10,'file','node','25',1),

(10,'file','node','26',1),

(10,'file','node','10',2),

(11,'file','node','12',1),

(11,'file','node','23',1),

(11,'file','node','24',1),

(11,'file','node','11',2),

(12,'file','node','24',1),

(12,'file','node','11',2),

(13,'file','node','21',1),

(13,'file','node','22',1),

(13,'file','node','32',1),

(13,'file','node','33',1),

(14,'file','node','12',1),

(14,'file','node','22',1),

(14,'file','node','23',1),

(14,'file','node','33',1),

(15,'file','node','19',1),

(15,'file','node','20',1),

(15,'file','node','31',1),

(15,'file','node','90',1),

(15,'file','node','11',2),

(16,'file','node','20',1),

(16,'file','node','21',1),

(16,'file','node','32',1),

(17,'file','node','17',1),

(17,'file','node','18',1),

(17,'file','node','29',1),

(17,'file','node','30',1),

(17,'file','node','13',2),

(18,'file','node','18',1),

(18,'file','node','19',1),

(18,'file','node','30',1),

(18,'file','node','31',1),

(18,'file','node','89',1),

(18,'file','node','13',2),

(19,'file','node','16',1),

(19,'file','node','27',1),

(19,'file','node','28',1),

(19,'file','node','91',1),

(19,'file','node','14',2),

(20,'file','node','16',1),

(20,'file','node','17',1),

(20,'file','node','28',1),

(20,'file','node','29',1),

(20,'file','node','86',1),

(20,'file','node','14',2),

(21,'file','node','27',1),

(21,'file','node','88',1),

(21,'file','node','15',2),

(25,'file','node','87',1),

(26,'file','node','56',1),

(27,'file','node','59',1),

(28,'file','node','57',1),

(29,'file','node','58',1),

(30,'file','node','60',1),

(31,'file','node','76',1),

(31,'file','node','92',1),

(32,'file','node','77',1),

(32,'file','node','93',1),

(33,'file','node','78',1),

(33,'file','node','94',1),

(34,'file','node','79',1),

(35,'file','node','80',1),

(36,'file','node','81',1),

(37,'file','node','82',1),

(38,'file','node','83',1),

(39,'file','node','84',1),

(40,'file','node','85',1),

(45,'file','node','99',1),

(53,'nb_visualshortcodes','','file_ajax',1),

(54,'file','nd_visualshortcodes','file_ajax',1),

(55,'file','nd_visualshortcodes','file_ajax',1),

(56,'file','nd_visualshortcodes','file_ajax',1),

(57,'file','nd_visualshortcodes','file_ajax',1),

(58,'file','nd_visualshortcodes','file_ajax',1),

(59,'file','nd_visualshortcodes','file_ajax',1),

(60,'file','nd_visualshortcodes','file_ajax',1),

(61,'file','nd_visualshortcodes','file_ajax',1),

(62,'file','commerce_product_variation','1',1),

(62,'file','commerce_product_variation','4',1),

(62,'file','commerce_product_variation','5',1),

(63,'file','commerce_product_variation','1',1),

(63,'file','commerce_product_variation','3',1),

(63,'file','commerce_product_variation','4',1),

(63,'file','commerce_product_variation','5',1),

(64,'file','commerce_product_variation','1',1),

(64,'file','commerce_product_variation','4',1),

(64,'file','commerce_product_variation','5',1),

(65,'file','commerce_product_variation','2',1),

(65,'file','commerce_product_variation','3',1),

(65,'file','commerce_product_variation','4',1),

(66,'file','commerce_product_variation','3',1),

(67,'file','commerce_product_variation','3',1),

(70,'file','nd_visualshortcodes','file_ajax',1);

/*Table structure for table `flood` */

DROP TABLE IF EXISTS `flood`;

CREATE TABLE `flood` (
  `fid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique flood event ID.',
  `event` varchar(64) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Name of event (e.g. contact).',
  `identifier` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Identifier of the visitor, such as an IP address or hostname.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp of the event.',
  `expiration` int(11) NOT NULL DEFAULT '0' COMMENT 'Expiration timestamp. Expired events are purged on cron run.',
  PRIMARY KEY (`fid`),
  KEY `allow` (`event`,`identifier`,`timestamp`),
  KEY `purge` (`expiration`)
) ENGINE=InnoDB AUTO_INCREMENT=47 DEFAULT CHARSET=utf8mb4 COMMENT='Flood controls the threshold of events, such as the number…';

/*Data for the table `flood` */

insert  into `flood`(`fid`,`event`,`identifier`,`timestamp`,`expiration`) values 

(1,'user.failed_login_ip','46.33.32.13',1491812968,1491816568),

(3,'user.failed_login_ip','62.183.127.27',1491819211,1491822811),

(4,'user.failed_login_user','1-62.183.127.27',1491819211,1491840811),

(5,'user.failed_login_ip','92.50.223.63',1492162452,1492166052),

(6,'user.failed_login_user','1-92.50.223.63',1492162452,1492184052),

(7,'user.failed_login_ip','127.0.0.1',1496179769,1496183369),

(9,'user.failed_login_ip','127.0.0.1',1496179775,1496183375),

(10,'user.failed_login_ip','127.0.0.1',1499242246,1499245846),

(12,'user.failed_login_ip','127.0.0.1',1499242256,1499245856),

(13,'user.failed_login_ip','78.130.150.202',1501229556,1501233156),

(14,'user.failed_login_user','1-78.130.150.202',1501229556,1501251156),

(15,'user.failed_login_ip','46.33.32.13',1503940131,1503943731),

(16,'user.failed_login_ip','127.0.0.1',1505464939,1505468539),

(17,'user.failed_login_ip','127.0.0.1',1516344877,1516348477),

(19,'user.failed_login_ip','127.0.0.1',1516344892,1516348492),

(20,'user.failed_login_ip','127.0.0.1',1519984450,1519988050),

(21,'user.failed_login_ip','127.0.0.1',1523355374,1523358974),

(22,'user.failed_login_ip','127.0.0.1',1526972328,1526975928),

(24,'user.failed_login_ip','127.0.0.1',1526972346,1526975946),

(25,'user.failed_login_ip','127.0.0.1',1533032374,1533035974),

(27,'user.failed_login_ip','127.0.0.1',1533032382,1533035982),

(29,'user.failed_login_ip','127.0.0.1',1533032389,1533035989),

(30,'user.failed_login_ip','127.0.0.1',1535622449,1535626049),

(31,'user.failed_login_ip','127.0.0.1',1538305633,1538309233),

(33,'user.failed_login_ip','127.0.0.1',1538305646,1538309246),

(34,'user.failed_login_ip','127.0.0.1',1545902015,1545905615),

(35,'user.failed_login_ip','127.0.0.1',1548061052,1548064652),

(37,'user.failed_login_ip','127.0.0.1',1548061064,1548064664),

(39,'user.failed_login_ip','127.0.0.1',1548061076,1548064676),

(40,'user.failed_login_ip','127.0.0.1',1550484563,1550488163),

(42,'user.failed_login_ip','127.0.0.1',1550484571,1550488171),

(43,'user.failed_login_ip','127.0.0.1',1558254801,1558258401),

(44,'user.failed_login_ip','127.0.0.1',1560753038,1560756638),

(45,'user.failed_login_ip','127.0.0.1',1564823696,1564827296),

(46,'user.failed_login_ip','127.0.0.1',1569657691,1569661291);

/*Table structure for table `key_value` */

DROP TABLE IF EXISTS `key_value`;

CREATE TABLE `key_value` (
  `collection` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'A named collection of key and value pairs.',
  `name` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The key of the key-value pair. As KEY is a SQL reserved keyword, name was chosen instead.',
  `value` longblob NOT NULL COMMENT 'The value.',
  PRIMARY KEY (`collection`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Generic key-value storage table. See the state system for…';

/*Data for the table `key_value` */

insert  into `key_value`(`collection`,`name`,`value`) values 

('config.entity.key_store.action','uuid:03f2d5db-56aa-4839-9ae0-872bcfd45a10','a:1:{i:0;s:42:\"system.action.commerce_order_delete_action\";}'),

('config.entity.key_store.action','uuid:157308d6-383c-4ffe-ab48-f54651c93673','a:1:{i:0;s:38:\"system.action.profile_unpublish_action\";}'),

('config.entity.key_store.action','uuid:1f8e9ca0-4b88-4dc0-b431-c8961b5a9945','a:1:{i:0;s:48:\"system.action.user_add_role_action.administrator\";}'),

('config.entity.key_store.action','uuid:215abe1b-65e9-4a11-8040-af0aec8d595c','a:1:{i:0;s:35:\"system.action.node_unpromote_action\";}'),

('config.entity.key_store.action','uuid:2315c0ba-efe3-4daf-acd4-83246fcc148f','a:1:{i:0;s:42:\"system.action.commerce_store_delete_action\";}'),

('config.entity.key_store.action','uuid:2e19587f-803d-4b50-a479-d636ca2ee222','a:1:{i:0;s:37:\"system.action.user_cancel_user_action\";}'),

('config.entity.key_store.action','uuid:3d8851d6-400a-4c5f-aa63-d933128cbd8f','a:1:{i:0;s:40:\"system.action.pathauto_update_alias_node\";}'),

('config.entity.key_store.action','uuid:5ded8915-25a3-4ace-80f0-5dc07f7cdf1d','a:1:{i:0;s:32:\"system.action.node_delete_action\";}'),

('config.entity.key_store.action','uuid:6a6bc3ba-0e63-4e67-8574-7cd900b03cc7','a:1:{i:0;s:33:\"system.action.node_publish_action\";}'),

('config.entity.key_store.action','uuid:74a0836d-c2c5-4f92-97de-e2d2651f4938','a:1:{i:0;s:44:\"system.action.commerce_product_delete_action\";}'),

('config.entity.key_store.action','uuid:761a63f0-3a26-47a6-80ac-2ad7f2216cdc','a:1:{i:0;s:38:\"system.action.comment_unpublish_action\";}'),

('config.entity.key_store.action','uuid:848793b1-fdad-41e3-97c3-08da27181cbf','a:1:{i:0;s:51:\"system.action.user_remove_role_action.administrator\";}'),

('config.entity.key_store.action','uuid:8f948afb-5fcc-4c2a-8765-4bec60018837','a:1:{i:0;s:40:\"system.action.commerce_unpublish_product\";}'),

('config.entity.key_store.action','uuid:902cc1d2-7103-4f75-bcc3-56a43e79a620','a:1:{i:0;s:36:\"system.action.profile_publish_action\";}'),

('config.entity.key_store.action','uuid:9f4e59f8-370e-43b1-b6fd-c567d4a3e8c9','a:1:{i:0;s:33:\"system.action.comment_save_action\";}'),

('config.entity.key_store.action','uuid:a6aecdf7-d8f2-47d9-a5c8-96850ccb3238','a:1:{i:0;s:37:\"system.action.node_make_sticky_action\";}'),

('config.entity.key_store.action','uuid:ab6c1f2b-cc41-4d9f-aafc-b7cd076fbda9','a:1:{i:0;s:35:\"system.action.node_unpublish_action\";}'),

('config.entity.key_store.action','uuid:ac408f45-c626-47cf-aa1e-4d2df0bd9dfe','a:1:{i:0;s:30:\"system.action.node_save_action\";}'),

('config.entity.key_store.action','uuid:b0031184-d631-4c30-9e7d-47b74721da08','a:1:{i:0;s:36:\"system.action.user_block_user_action\";}'),

('config.entity.key_store.action','uuid:b58decdb-33d8-4ba0-9d02-ad4454cd634c','a:1:{i:0;s:36:\"system.action.comment_publish_action\";}'),

('config.entity.key_store.action','uuid:c06327be-b234-4498-8dda-b7f6da340027','a:1:{i:0;s:46:\"system.action.webform_submission_delete_action\";}'),

('config.entity.key_store.action','uuid:c2405ee7-1df0-4083-b7e4-c9d0b2a6d260','a:1:{i:0;s:35:\"system.action.profile_delete_action\";}'),

('config.entity.key_store.action','uuid:d4bd15f3-4cea-43eb-aca2-db427029ac40','a:1:{i:0;s:53:\"system.action.webform_submission_make_unsticky_action\";}'),

('config.entity.key_store.action','uuid:d7a5b116-a443-4193-a0a0-a34e33a7b67f','a:1:{i:0;s:40:\"system.action.pathauto_update_alias_user\";}'),

('config.entity.key_store.action','uuid:de37e755-2899-4fa1-b41c-35e8c8040468','a:1:{i:0;s:38:\"system.action.commerce_publish_product\";}'),

('config.entity.key_store.action','uuid:dfd83f68-9de9-490e-99b0-6ec46aeafbb9','a:1:{i:0;s:38:\"system.action.user_unblock_user_action\";}'),

('config.entity.key_store.action','uuid:e11b1c42-0b99-410a-81f5-55987d60815f','a:1:{i:0;s:51:\"system.action.webform_submission_make_sticky_action\";}'),

('config.entity.key_store.action','uuid:e8a78e66-c02d-4548-b7d7-c3da986a243a','a:1:{i:0;s:35:\"system.action.comment_delete_action\";}'),

('config.entity.key_store.action','uuid:ed364b5a-046b-4b2b-a815-5ac4bee6c522','a:1:{i:0;s:33:\"system.action.node_promote_action\";}'),

('config.entity.key_store.action','uuid:fdd3ef42-6e3c-4e45-bd33-76b76f62b1f5','a:1:{i:0;s:39:\"system.action.node_make_unsticky_action\";}'),

('config.entity.key_store.base_field_override','uuid:1cd1baeb-1231-4c25-b3d8-bdf3f8589fe4','a:1:{i:0;s:50:\"core.base_field_override.node.gallery_item.promote\";}'),

('config.entity.key_store.base_field_override','uuid:61284a8a-59cd-44eb-b177-5f6aaf1b23ac','a:1:{i:0;s:47:\"core.base_field_override.node.nd_person.promote\";}'),

('config.entity.key_store.base_field_override','uuid:7be01430-9843-41bf-8e0f-044609a4ebb4','a:1:{i:0;s:42:\"core.base_field_override.node.page.promote\";}'),

('config.entity.key_store.base_field_override','uuid:9f537a08-e7b3-41a7-bdf8-9a96638d1980','a:1:{i:0;s:50:\"core.base_field_override.node.nd_portfolio.promote\";}'),

('config.entity.key_store.base_field_override','uuid:bf673c29-c35d-421f-a1b6-ba3b14ebddab','a:1:{i:0;s:45:\"core.base_field_override.node.nd_blog.promote\";}'),

('config.entity.key_store.base_field_override','uuid:ddb97df1-d4af-453a-b578-cbdf0f9e46db','a:1:{i:0;s:45:\"core.base_field_override.node.webform.promote\";}'),

('config.entity.key_store.block','theme:rhythm','a:62:{i:0;s:31:\"block.block.rhythm_account_menu\";i:1;s:27:\"block.block.rhythm_branding\";i:2;s:30:\"block.block.rhythm_breadcrumbs\";i:3;s:26:\"block.block.rhythm_content\";i:4;s:25:\"block.block.rhythm_footer\";i:5;s:23:\"block.block.rhythm_help\";i:6;s:32:\"block.block.rhythm_local_actions\";i:7;s:30:\"block.block.rhythm_local_tasks\";i:8;s:28:\"block.block.rhythm_main_menu\";i:9;s:27:\"block.block.rhythm_messages\";i:10;s:29:\"block.block.rhythm_page_title\";i:11;s:26:\"block.block.rhythm_powered\";i:12;s:25:\"block.block.rhythm_search\";i:13;s:24:\"block.block.rhythm_tools\";i:14;s:26:\"block.block.headerdarkmain\";i:15;s:18:\"block.block.footer\";i:16;s:33:\"block.block.headerdarktransparent\";i:17;s:23:\"block.block.headerwhite\";i:18;s:34:\"block.block.headerwhitetransparent\";i:19;s:28:\"block.block.languageswitcher\";i:20;s:33:\"block.block.rhythmprojectnextprev\";i:21;s:49:\"block.block.views_block__related_projects_block_1\";i:22;s:27:\"block.block.relatedprojects\";i:23;s:28:\"block.block.wanttoworkwithus\";i:24;s:23:\"block.block.gmapcontact\";i:25;s:26:\"block.block.gmapcontacttop\";i:26;s:26:\"block.block.headermaindemo\";i:27;s:32:\"block.block.headerimageparallax1\";i:28;s:32:\"block.block.headerimageparallax2\";i:29;s:32:\"block.block.headerimageparallax3\";i:30;s:32:\"block.block.headerimageparallax4\";i:31;s:32:\"block.block.headerimageparallax5\";i:32;s:32:\"block.block.headerfullwidthimage\";i:33;s:29:\"block.block.headertextrotator\";i:34;s:34:\"block.block.headersliderfullscreen\";i:35;s:34:\"block.block.headersliderzoomeffect\";i:36;s:33:\"block.block.headersliderfullwidth\";i:37;s:34:\"block.block.headersliderbackground\";i:38;s:32:\"block.block.headerwithplaybutton\";i:39;s:34:\"block.block.headerbgvideofullwidth\";i:40;s:36:\"block.block.headerbgvideofullscreen1\";i:41;s:36:\"block.block.headerbgvideofullscreen2\";i:42;s:30:\"block.block.headeragencyheader\";i:43;s:36:\"block.block.headerspecialphotography\";i:44;s:33:\"block.block.headermaindemoonepage\";i:45;s:39:\"block.block.headerimageparallax2onepage\";i:46;s:39:\"block.block.headerimageparallax3onepage\";i:47;s:39:\"block.block.headerimageparallax4onepage\";i:48;s:39:\"block.block.headerimageparallax5onepage\";i:49;s:39:\"block.block.headerfullwidthimageonepage\";i:50;s:36:\"block.block.headertextrotatoronepage\";i:51;s:41:\"block.block.headersliderfullscreenonepage\";i:52;s:41:\"block.block.headersliderzoomeffectonepage\";i:53;s:40:\"block.block.headersliderfullwidthonepage\";i:54;s:41:\"block.block.headersliderbackgroundonepage\";i:55;s:39:\"block.block.headerwithplaybuttononepage\";i:56;s:41:\"block.block.headerbgvideofullwidthonepage\";i:57;s:43:\"block.block.headerbgvideofullscreen1onepage\";i:58;s:43:\"block.block.headerbgvideofullscreen2onepage\";i:59;s:43:\"block.block.headerspecialphotographyonepage\";i:60;s:39:\"block.block.headerimageparallax1onepage\";i:61;s:35:\"block.block.headermaindemoonepage_2\";}'),

('config.entity.key_store.block','theme:rhythm_sub','a:58:{i:0;s:35:\"block.block.rhythm_sub_account_menu\";i:1;s:31:\"block.block.rhythm_sub_branding\";i:3;s:30:\"block.block.rhythm_sub_content\";i:4;s:29:\"block.block.rhythm_sub_footer\";i:5;s:34:\"block.block.rhythm_sub_gmapcontact\";i:6;s:37:\"block.block.rhythm_sub_gmapcontacttop\";i:7;s:41:\"block.block.rhythm_sub_headeragencyheader\";i:8;s:47:\"block.block.rhythm_sub_headerbgvideofullscreen1\";i:9;s:54:\"block.block.rhythm_sub_headerbgvideofullscreen1onepage\";i:10;s:47:\"block.block.rhythm_sub_headerbgvideofullscreen2\";i:11;s:54:\"block.block.rhythm_sub_headerbgvideofullscreen2onepage\";i:12;s:45:\"block.block.rhythm_sub_headerbgvideofullwidth\";i:13;s:52:\"block.block.rhythm_sub_headerbgvideofullwidthonepage\";i:14;s:37:\"block.block.rhythm_sub_headerdarkmain\";i:15;s:44:\"block.block.rhythm_sub_headerdarktransparent\";i:16;s:43:\"block.block.rhythm_sub_headerfullwidthimage\";i:17;s:50:\"block.block.rhythm_sub_headerfullwidthimageonepage\";i:18;s:43:\"block.block.rhythm_sub_headerimageparallax1\";i:19;s:50:\"block.block.rhythm_sub_headerimageparallax1onepage\";i:20;s:43:\"block.block.rhythm_sub_headerimageparallax2\";i:21;s:50:\"block.block.rhythm_sub_headerimageparallax2onepage\";i:22;s:43:\"block.block.rhythm_sub_headerimageparallax3\";i:23;s:50:\"block.block.rhythm_sub_headerimageparallax3onepage\";i:24;s:43:\"block.block.rhythm_sub_headerimageparallax4\";i:25;s:50:\"block.block.rhythm_sub_headerimageparallax4onepage\";i:26;s:43:\"block.block.rhythm_sub_headerimageparallax5\";i:27;s:50:\"block.block.rhythm_sub_headerimageparallax5onepage\";i:28;s:37:\"block.block.rhythm_sub_headermaindemo\";i:29;s:44:\"block.block.rhythm_sub_headermaindemoonepage\";i:30;s:46:\"block.block.rhythm_sub_headermaindemoonepage_2\";i:31;s:45:\"block.block.rhythm_sub_headersliderbackground\";i:32;s:52:\"block.block.rhythm_sub_headersliderbackgroundonepage\";i:33;s:45:\"block.block.rhythm_sub_headersliderfullscreen\";i:34;s:52:\"block.block.rhythm_sub_headersliderfullscreenonepage\";i:35;s:44:\"block.block.rhythm_sub_headersliderfullwidth\";i:36;s:51:\"block.block.rhythm_sub_headersliderfullwidthonepage\";i:37;s:45:\"block.block.rhythm_sub_headersliderzoomeffect\";i:38;s:52:\"block.block.rhythm_sub_headersliderzoomeffectonepage\";i:39;s:47:\"block.block.rhythm_sub_headerspecialphotography\";i:40;s:54:\"block.block.rhythm_sub_headerspecialphotographyonepage\";i:41;s:40:\"block.block.rhythm_sub_headertextrotator\";i:42;s:47:\"block.block.rhythm_sub_headertextrotatoronepage\";i:43;s:34:\"block.block.rhythm_sub_headerwhite\";i:44;s:45:\"block.block.rhythm_sub_headerwhitetransparent\";i:45;s:43:\"block.block.rhythm_sub_headerwithplaybutton\";i:46;s:50:\"block.block.rhythm_sub_headerwithplaybuttononepage\";i:47;s:39:\"block.block.rhythm_sub_languageswitcher\";i:48;s:38:\"block.block.rhythm_sub_relatedprojects\";i:49;s:16:\"block.block.tabs\";i:50;s:49:\"block.block.views_block__related_products_block_1\";i:51;s:16:\"block.block.cart\";i:52;s:32:\"block.block.rhythmproductsfilter\";i:53;s:46:\"block.block.views_block__shop_categories_block\";i:54;s:52:\"block.block.views_block__products_best_sellers_block\";i:55;s:44:\"block.block.views_block__products_tags_block\";i:56;s:50:\"block.block.views_block__products_comments_block_1\";i:57;s:22:\"block.block.textwidget\";i:58;s:24:\"block.block.shop4columns\";}'),

('config.entity.key_store.block','theme:seven','a:9:{i:0;s:39:\"block.block.seven_secondary_local_tasks\";i:1;s:37:\"block.block.seven_primary_local_tasks\";i:2;s:28:\"block.block.seven_page_title\";i:3;s:31:\"block.block.seven_local_actions\";i:4;s:22:\"block.block.seven_help\";i:5;s:26:\"block.block.seven_messages\";i:6;s:25:\"block.block.seven_content\";i:7;s:29:\"block.block.seven_breadcrumbs\";i:8;s:23:\"block.block.seven_login\";}'),

('config.entity.key_store.block','uuid:00373451-f262-4026-b1d9-1f33315a0f36','a:1:{i:0;s:43:\"block.block.rhythm_sub_headerimageparallax4\";}'),

('config.entity.key_store.block','uuid:02b51bfc-c4aa-4e7c-8be7-674eb1cb7faa','a:1:{i:0;s:47:\"block.block.rhythm_sub_headerbgvideofullscreen1\";}'),

('config.entity.key_store.block','uuid:04d92947-dd24-4a6f-bd7a-be6c00d20a2d','a:1:{i:0;s:51:\"block.block.rhythm_sub_headersliderfullwidthonepage\";}'),

('config.entity.key_store.block','uuid:0872ac0e-5591-4288-84d1-f9131ddbc035','a:1:{i:0;s:52:\"block.block.rhythm_sub_headersliderbackgroundonepage\";}'),

('config.entity.key_store.block','uuid:08ce090a-33bf-458e-b268-2c02e5da0206','a:1:{i:0;s:28:\"block.block.languageswitcher\";}'),

('config.entity.key_store.block','uuid:090f80eb-5824-4b2a-a760-f299ea9779a2','a:1:{i:0;s:38:\"block.block.rhythm_sub_relatedprojects\";}'),

('config.entity.key_store.block','uuid:09491eac-2686-4f01-90bd-ec46edef0afa','a:1:{i:0;s:47:\"block.block.rhythm_sub_headertextrotatoronepage\";}'),

('config.entity.key_store.block','uuid:09ac40b0-8433-4aed-9b30-f8c955f212fc','a:1:{i:0;s:29:\"block.block.rhythm_sub_footer\";}'),

('config.entity.key_store.block','uuid:0b04ff76-752c-480d-a5b0-de65ebb3f76e','a:1:{i:0;s:43:\"block.block.rhythm_sub_headerimageparallax1\";}'),

('config.entity.key_store.block','uuid:0b6f8523-9dbc-4298-b374-63773b17d9d2','a:1:{i:0;s:39:\"block.block.headerimageparallax1onepage\";}'),

('config.entity.key_store.block','uuid:0f09ac4a-6c70-48a6-8e28-38ad3f6287e6','a:1:{i:0;s:50:\"block.block.rhythm_sub_headerimageparallax1onepage\";}'),

('config.entity.key_store.block','uuid:0f5f0b78-98d3-44c7-a32a-fef9d8cb1f33','a:1:{i:0;s:43:\"block.block.rhythm_sub_headerimageparallax2\";}'),

('config.entity.key_store.block','uuid:1347b61a-323d-41b9-bd7c-8751a1812999','a:1:{i:0;s:28:\"block.block.wanttoworkwithus\";}'),

('config.entity.key_store.block','uuid:16165ac4-8ba9-40bc-8119-125e88c27e3d','a:1:{i:0;s:43:\"block.block.headerspecialphotographyonepage\";}'),

('config.entity.key_store.block','uuid:17f72c76-8aba-44ba-86ba-11b735e498f6','a:1:{i:0;s:44:\"block.block.rhythm_sub_headermaindemoonepage\";}'),

('config.entity.key_store.block','uuid:20c7bc21-2204-4d89-84a8-c8cbb3030466','a:1:{i:0;s:36:\"block.block.headerspecialphotography\";}'),

('config.entity.key_store.block','uuid:2243e9b8-a322-496c-8b91-885f3b6edb6c','a:1:{i:0;s:46:\"block.block.rhythm_sub_headermaindemoonepage_2\";}'),

('config.entity.key_store.block','uuid:23b8b5c4-92a8-45f5-97f8-80d3b7aca2b2','a:1:{i:0;s:29:\"block.block.seven_breadcrumbs\";}'),

('config.entity.key_store.block','uuid:255b74f2-152e-42ba-ac1a-657027defd3c','a:1:{i:0;s:50:\"block.block.views_block__products_comments_block_1\";}'),

('config.entity.key_store.block','uuid:27d309a7-4d3e-43ca-9e39-cbb15c06a524','a:1:{i:0;s:22:\"block.block.seven_help\";}'),

('config.entity.key_store.block','uuid:2822e449-fc8a-453c-b626-86ac2f1bdb4a','a:1:{i:0;s:44:\"block.block.rhythm_sub_headersliderfullwidth\";}'),

('config.entity.key_store.block','uuid:2a976291-60ea-4724-8d86-59ab2d40a920','a:1:{i:0;s:22:\"block.block.textwidget\";}'),

('config.entity.key_store.block','uuid:2bed48a0-b7f7-4dea-9923-2682efd94018','a:1:{i:0;s:28:\"block.block.seven_page_title\";}'),

('config.entity.key_store.block','uuid:2dbcb7d7-fee4-4924-85c2-8ecff5520b67','a:1:{i:0;s:39:\"block.block.headerimageparallax5onepage\";}'),

('config.entity.key_store.block','uuid:2e7990dc-5dec-4780-88b9-0bc2510fae36','a:1:{i:0;s:31:\"block.block.seven_local_actions\";}'),

('config.entity.key_store.block','uuid:2fbf239e-e24a-48e0-82ab-6d4c81b0be31','a:1:{i:0;s:44:\"block.block.rhythm_sub_headerdarktransparent\";}'),

('config.entity.key_store.block','uuid:35c3df26-caf3-4300-bff2-2af6e79427a6','a:1:{i:0;s:25:\"block.block.rhythm_search\";}'),

('config.entity.key_store.block','uuid:3702c98a-327e-4204-8950-9bc4ffb6d7da','a:1:{i:0;s:49:\"block.block.views_block__related_products_block_1\";}'),

('config.entity.key_store.block','uuid:370b9f43-64b4-4a2a-9780-12fd9152f75d','a:1:{i:0;s:43:\"block.block.rhythm_sub_headerimageparallax3\";}'),

('config.entity.key_store.block','uuid:39a029fc-3be1-4d17-a8fc-46724f57dbb7','a:1:{i:0;s:30:\"block.block.rhythm_local_tasks\";}'),

('config.entity.key_store.block','uuid:3b1e70f3-0807-4d9a-97bc-5de2488c0949','a:1:{i:0;s:32:\"block.block.headerimageparallax5\";}'),

('config.entity.key_store.block','uuid:3b82cdf8-8b5b-4b30-b17c-4080f7badb49','a:1:{i:0;s:34:\"block.block.rhythm_sub_headerwhite\";}'),

('config.entity.key_store.block','uuid:3bf0ca52-8a30-461c-8f3f-3c0880aa6a4b','a:1:{i:0;s:32:\"block.block.headerfullwidthimage\";}'),

('config.entity.key_store.block','uuid:3d06a0ef-8bfb-49f1-b3be-cf27f16a5131','a:1:{i:0;s:41:\"block.block.headersliderbackgroundonepage\";}'),

('config.entity.key_store.block','uuid:413644a4-9b49-42af-b103-9bbbbffba796','a:1:{i:0;s:27:\"block.block.rhythm_branding\";}'),

('config.entity.key_store.block','uuid:444a7c72-7e14-466d-b7e4-2f50c08c1fdf','a:1:{i:0;s:41:\"block.block.headerbgvideofullwidthonepage\";}'),

('config.entity.key_store.block','uuid:44f53eb8-eb63-4012-9831-7a4f04a823ed','a:1:{i:0;s:43:\"block.block.headerbgvideofullscreen2onepage\";}'),

('config.entity.key_store.block','uuid:460e4b4a-e496-46ff-bd92-d8d1b90e28af','a:1:{i:0;s:47:\"block.block.rhythm_sub_headerbgvideofullscreen2\";}'),

('config.entity.key_store.block','uuid:4824094a-4c9f-496c-813e-728a6f25384d','a:1:{i:0;s:32:\"block.block.rhythmproductsfilter\";}'),

('config.entity.key_store.block','uuid:49463673-9895-4d8f-8c10-765132503be2','a:1:{i:0;s:27:\"block.block.rhythm_messages\";}'),

('config.entity.key_store.block','uuid:4bd5f99e-8feb-4cc4-9309-490ea8294273','a:1:{i:0;s:40:\"block.block.headersliderfullwidthonepage\";}'),

('config.entity.key_store.block','uuid:4d4baf14-4f71-4792-b584-ec7ecd6ca388','a:1:{i:0;s:39:\"block.block.headerwithplaybuttononepage\";}'),

('config.entity.key_store.block','uuid:4d6c4b5e-01c7-4500-8fbe-2000435e7c99','a:1:{i:0;s:50:\"block.block.rhythm_sub_headerwithplaybuttononepage\";}'),

('config.entity.key_store.block','uuid:5015f346-52bf-4f74-84c6-17a4e3d5b670','a:1:{i:0;s:32:\"block.block.headerimageparallax3\";}'),

('config.entity.key_store.block','uuid:51508430-a627-40d0-9d66-df8864eca354','a:1:{i:0;s:23:\"block.block.seven_login\";}'),

('config.entity.key_store.block','uuid:51cea072-aeaa-4e8c-9858-9c7cbb7dae64','a:1:{i:0;s:39:\"block.block.seven_secondary_local_tasks\";}'),

('config.entity.key_store.block','uuid:5b58453b-723c-4896-aa31-f0f9c7c9ae6b','a:1:{i:0;s:41:\"block.block.headersliderfullscreenonepage\";}'),

('config.entity.key_store.block','uuid:5d1c6131-e67c-4ebc-aa96-2a20d76ab5fa','a:1:{i:0;s:31:\"block.block.rhythm_sub_branding\";}'),

('config.entity.key_store.block','uuid:5d869f40-bf55-472d-88f3-3efa8effecaf','a:1:{i:0;s:32:\"block.block.headerimageparallax2\";}'),

('config.entity.key_store.block','uuid:5fc3549f-2a88-4fc4-8af8-84f016757768','a:1:{i:0;s:23:\"block.block.rhythm_help\";}'),

('config.entity.key_store.block','uuid:6131a539-a140-4fb3-a55b-b27a52836cec','a:1:{i:0;s:26:\"block.block.rhythm_powered\";}'),

('config.entity.key_store.block','uuid:6640a04e-6da6-4793-b4bd-a73824fcb1bf','a:1:{i:0;s:25:\"block.block.rhythm_footer\";}'),

('config.entity.key_store.block','uuid:664162b8-4194-490e-bafe-1eb24a3f6e3d','a:1:{i:0;s:50:\"block.block.rhythm_sub_headerimageparallax3onepage\";}'),

('config.entity.key_store.block','uuid:666f95cf-9db9-4f53-a414-27d1a2caaf5e','a:1:{i:0;s:52:\"block.block.views_block__products_best_sellers_block\";}'),

('config.entity.key_store.block','uuid:6d0cc7c3-809b-4664-af31-7b6d8f8bcda8','a:1:{i:0;s:52:\"block.block.rhythm_sub_headerbgvideofullwidthonepage\";}'),

('config.entity.key_store.block','uuid:6d35a56e-3544-443d-ba5e-65ccd966e616','a:1:{i:0;s:33:\"block.block.headersliderfullwidth\";}'),

('config.entity.key_store.block','uuid:70f1b314-2c3a-450d-ad3b-ceb3e2d0b817','a:1:{i:0;s:41:\"block.block.rhythm_sub_headeragencyheader\";}'),

('config.entity.key_store.block','uuid:73728475-d531-4eb7-b607-dae797837e2f','a:1:{i:0;s:34:\"block.block.headersliderzoomeffect\";}'),

('config.entity.key_store.block','uuid:76b80ec7-ce57-46b6-9d3b-8f9794e65a70','a:1:{i:0;s:36:\"block.block.headerbgvideofullscreen1\";}'),

('config.entity.key_store.block','uuid:7aab4005-7324-4c90-9eb7-ec0b8c4a0184','a:1:{i:0;s:43:\"block.block.rhythm_sub_headerfullwidthimage\";}'),

('config.entity.key_store.block','uuid:7b209f30-1665-4a86-8e38-a32316cd2bfb','a:1:{i:0;s:54:\"block.block.rhythm_sub_headerspecialphotographyonepage\";}'),

('config.entity.key_store.block','uuid:7b9788bc-cd42-4655-b624-0197e286eaa4','a:1:{i:0;s:34:\"block.block.headerbgvideofullwidth\";}'),

('config.entity.key_store.block','uuid:7ec13e18-3ee7-4040-b223-3f733fb1dba8','a:1:{i:0;s:26:\"block.block.gmapcontacttop\";}'),

('config.entity.key_store.block','uuid:7f37e06f-4a35-4cfc-a5f4-36709472c90b','a:1:{i:0;s:30:\"block.block.headeragencyheader\";}'),

('config.entity.key_store.block','uuid:856ef520-4ebd-458e-b64c-2553dec4ddd6','a:1:{i:0;s:50:\"block.block.rhythm_sub_headerimageparallax5onepage\";}'),

('config.entity.key_store.block','uuid:8a1a12bd-1738-4da6-b226-015f687c7d24','a:1:{i:0;s:24:\"block.block.shop4columns\";}'),

('config.entity.key_store.block','uuid:8b9adc07-63b5-416f-854f-1e4dd3ed8802','a:1:{i:0;s:37:\"block.block.rhythm_sub_gmapcontacttop\";}'),

('config.entity.key_store.block','uuid:8c48b0a3-1d64-4d8a-9db6-94ceb4fbdf39','a:1:{i:0;s:23:\"block.block.gmapcontact\";}'),

('config.entity.key_store.block','uuid:8f62a8d4-9a1b-446a-9769-ec3451b31c85','a:1:{i:0;s:39:\"block.block.headerfullwidthimageonepage\";}'),

('config.entity.key_store.block','uuid:932affb1-80d9-4b1d-9e7e-df4a3ef59658','a:1:{i:0;s:34:\"block.block.rhythm_sub_gmapcontact\";}'),

('config.entity.key_store.block','uuid:94c1ff38-4027-4007-b8f9-96e6504c0f0b','a:1:{i:0;s:16:\"block.block.cart\";}'),

('config.entity.key_store.block','uuid:95a262d9-21aa-4489-a656-27dea2d95bc7','a:1:{i:0;s:39:\"block.block.headerimageparallax3onepage\";}'),

('config.entity.key_store.block','uuid:98c09a7f-553a-498c-ac87-288f13f365e0','a:1:{i:0;s:37:\"block.block.seven_primary_local_tasks\";}'),

('config.entity.key_store.block','uuid:9ef9d7c8-6f04-4d5b-b27d-352c1111d3f9','a:1:{i:0;s:50:\"block.block.rhythm_sub_headerimageparallax4onepage\";}'),

('config.entity.key_store.block','uuid:9f08ecc2-5104-43eb-a017-24c5d251e29b','a:1:{i:0;s:32:\"block.block.headerimageparallax1\";}'),

('config.entity.key_store.block','uuid:9f216d60-1120-4056-8da9-195a29d3d0a0','a:1:{i:0;s:23:\"block.block.headerwhite\";}'),

('config.entity.key_store.block','uuid:9f4af8d7-746c-4ab8-9abf-031f5926560d','a:1:{i:0;s:26:\"block.block.headerdarkmain\";}'),

('config.entity.key_store.block','uuid:9ff86076-a02d-47f4-825d-e031775668bb','a:1:{i:0;s:47:\"block.block.rhythm_sub_headerspecialphotography\";}'),

('config.entity.key_store.block','uuid:a026120c-56e4-4352-b7a7-c6a39bc78742','a:1:{i:0;s:33:\"block.block.headerdarktransparent\";}'),

('config.entity.key_store.block','uuid:a3a59cb6-9215-4a01-9bb0-096116abd034','a:1:{i:0;s:45:\"block.block.rhythm_sub_headersliderfullscreen\";}'),

('config.entity.key_store.block','uuid:a80291bc-8043-48fb-bb55-55d225367933','a:1:{i:0;s:29:\"block.block.headertextrotator\";}'),

('config.entity.key_store.block','uuid:aa55ac4e-a5b2-4356-9545-1f44c77f500a','a:1:{i:0;s:43:\"block.block.headerbgvideofullscreen1onepage\";}'),

('config.entity.key_store.block','uuid:acddd933-ea2d-436e-9d38-17103ee44f00','a:1:{i:0;s:46:\"block.block.views_block__shop_categories_block\";}'),

('config.entity.key_store.block','uuid:aea29a9b-3f18-4b05-9b76-d9c5d8cc0c51','a:1:{i:0;s:32:\"block.block.headerimageparallax4\";}'),

('config.entity.key_store.block','uuid:afd12111-5e64-4ed1-a8f0-caa4592ff02c','a:1:{i:0;s:39:\"block.block.headerimageparallax4onepage\";}'),

('config.entity.key_store.block','uuid:b1bf7b33-11e9-4ef6-b38c-89428eea1fd4','a:1:{i:0;s:50:\"block.block.rhythm_sub_headerfullwidthimageonepage\";}'),

('config.entity.key_store.block','uuid:b36ff433-974c-4b1e-a111-25af465188cc','a:1:{i:0;s:36:\"block.block.headerbgvideofullscreen2\";}'),

('config.entity.key_store.block','uuid:b4da920b-8548-4f35-a385-4b0e0044bb11','a:1:{i:0;s:43:\"block.block.rhythm_sub_headerimageparallax5\";}'),

('config.entity.key_store.block','uuid:b67a7d60-ae37-46ee-b083-5182615d98fd','a:1:{i:0;s:37:\"block.block.rhythm_sub_headerdarkmain\";}'),

('config.entity.key_store.block','uuid:b9224ba5-ea30-4207-bfe8-5597ae82a2ca','a:1:{i:0;s:26:\"block.block.headermaindemo\";}'),

('config.entity.key_store.block','uuid:bbd8565f-9370-43d1-88c4-6d65fd6cb1b8','a:1:{i:0;s:30:\"block.block.rhythm_sub_content\";}'),

('config.entity.key_store.block','uuid:bc646bf3-7526-49e4-9f95-62175c6d19c4','a:1:{i:0;s:25:\"block.block.seven_content\";}'),

('config.entity.key_store.block','uuid:bd3eec29-b089-4550-ac3c-88e1e8bfeba6','a:1:{i:0;s:30:\"block.block.rhythm_breadcrumbs\";}'),

('config.entity.key_store.block','uuid:c09c2459-4324-44a1-a9b6-cf91aa754dbe','a:1:{i:0;s:26:\"block.block.seven_messages\";}'),

('config.entity.key_store.block','uuid:c0b4f5a2-1e0c-4ae8-9980-ed3a2433741c','a:1:{i:0;s:34:\"block.block.headersliderfullscreen\";}'),

('config.entity.key_store.block','uuid:c35a6a42-6b76-4eb5-9b76-af4d677877a7','a:1:{i:0;s:33:\"block.block.headermaindemoonepage\";}'),

('config.entity.key_store.block','uuid:c3d5d145-a8f4-4fa4-8d8d-e9ad3153d8a5','a:1:{i:0;s:52:\"block.block.rhythm_sub_headersliderfullscreenonepage\";}'),

('config.entity.key_store.block','uuid:c3e70a80-534a-42be-982e-b027035cba7c','a:1:{i:0;s:45:\"block.block.rhythm_sub_headersliderzoomeffect\";}'),

('config.entity.key_store.block','uuid:c44389fe-2f06-478e-8e40-5aa93eecc3a1','a:1:{i:0;s:33:\"block.block.rhythmprojectnextprev\";}'),

('config.entity.key_store.block','uuid:c4e0a1cc-8ca9-46be-88f1-13d29f4ef409','a:1:{i:0;s:43:\"block.block.rhythm_sub_headerwithplaybutton\";}'),

('config.entity.key_store.block','uuid:c6d4f79a-bda9-4be9-9c53-4d4bf756880e','a:1:{i:0;s:32:\"block.block.headerwithplaybutton\";}'),

('config.entity.key_store.block','uuid:c792217e-9ad2-463a-97cb-bcf64e8c4723','a:1:{i:0;s:37:\"block.block.rhythm_sub_headermaindemo\";}'),

('config.entity.key_store.block','uuid:c855b4d4-43bb-4b28-9537-6f9557630031','a:1:{i:0;s:28:\"block.block.rhythm_main_menu\";}'),

('config.entity.key_store.block','uuid:c87719bc-efdf-4b10-a202-ca4973277bc9','a:1:{i:0;s:16:\"block.block.tabs\";}'),

('config.entity.key_store.block','uuid:c8975b71-7c7c-433a-a98a-e66c0a94e9ca','a:1:{i:0;s:45:\"block.block.rhythm_sub_headerwhitetransparent\";}'),

('config.entity.key_store.block','uuid:c8ccbb73-7ce6-4c06-b638-2c74321a1e3b','a:1:{i:0;s:50:\"block.block.rhythm_sub_headerimageparallax2onepage\";}'),

('config.entity.key_store.block','uuid:cac8108c-3b61-4c6b-b7b3-cbacdf3895b5','a:1:{i:0;s:35:\"block.block.headermaindemoonepage_2\";}'),

('config.entity.key_store.block','uuid:cd122023-e3fe-4c65-bde9-1e48021ab865','a:1:{i:0;s:45:\"block.block.rhythm_sub_headersliderbackground\";}'),

('config.entity.key_store.block','uuid:ce828c05-82a9-4870-8ab1-e6dabea55e25','a:1:{i:0;s:39:\"block.block.rhythm_sub_languageswitcher\";}'),

('config.entity.key_store.block','uuid:d76941cf-3169-45fa-bf31-74910cf5bf76','a:1:{i:0;s:40:\"block.block.rhythm_sub_headertextrotator\";}'),

('config.entity.key_store.block','uuid:d8eb0a5d-9e41-4217-a02a-c3b0a02f3d53','a:1:{i:0;s:26:\"block.block.rhythm_content\";}'),

('config.entity.key_store.block','uuid:defb8319-ed5a-4bf3-978f-c7b93a44ee0b','a:1:{i:0;s:29:\"block.block.rhythm_page_title\";}'),

('config.entity.key_store.block','uuid:e5641eec-7872-4d6a-81f5-f0a5b54631a2','a:1:{i:0;s:54:\"block.block.rhythm_sub_headerbgvideofullscreen2onepage\";}'),

('config.entity.key_store.block','uuid:e82ac7eb-ace8-4f3b-91ad-96a5e545d4e5','a:1:{i:0;s:39:\"block.block.headerimageparallax2onepage\";}'),

('config.entity.key_store.block','uuid:ead5af5e-d237-440f-9e38-5d335dac5735','a:1:{i:0;s:34:\"block.block.headersliderbackground\";}'),

('config.entity.key_store.block','uuid:ebc611c4-c726-4588-88a8-9a73a9a245d1','a:1:{i:0;s:31:\"block.block.rhythm_account_menu\";}'),

('config.entity.key_store.block','uuid:ec56d4fb-6cf2-4703-b16c-65e07b2c097a','a:1:{i:0;s:34:\"block.block.headerwhitetransparent\";}'),

('config.entity.key_store.block','uuid:edd9a1f2-11af-45ae-b666-dbec178652e2','a:1:{i:0;s:27:\"block.block.relatedprojects\";}'),

('config.entity.key_store.block','uuid:ee6160a2-84a3-46b2-91a4-66d56130faf1','a:1:{i:0;s:54:\"block.block.rhythm_sub_headerbgvideofullscreen1onepage\";}'),

('config.entity.key_store.block','uuid:eebd65e3-6d0c-4c1d-b3d3-e7d6d4e4a531','a:1:{i:0;s:45:\"block.block.rhythm_sub_headerbgvideofullwidth\";}'),

('config.entity.key_store.block','uuid:f15d14f9-a95b-446a-b25b-efb57c5b70fe','a:1:{i:0;s:52:\"block.block.rhythm_sub_headersliderzoomeffectonepage\";}'),

('config.entity.key_store.block','uuid:f30bcebe-5bd4-462b-ad03-1aec0fdf8c80','a:1:{i:0;s:35:\"block.block.rhythm_sub_account_menu\";}'),

('config.entity.key_store.block','uuid:f35186e0-4d27-414f-8273-55ef0c061c4e','a:1:{i:0;s:18:\"block.block.footer\";}'),

('config.entity.key_store.block','uuid:f52ee1b9-2c69-45e6-b70a-a8a898a42a15','a:1:{i:0;s:44:\"block.block.views_block__products_tags_block\";}'),

('config.entity.key_store.block','uuid:f5934bc7-4e63-45e8-ae47-527a583401cb','a:1:{i:0;s:24:\"block.block.rhythm_tools\";}'),

('config.entity.key_store.block','uuid:f6fb1e55-61db-4a15-92aa-9c411a3cab04','a:1:{i:0;s:32:\"block.block.rhythm_local_actions\";}'),

('config.entity.key_store.block','uuid:f76b817c-1287-45fd-8bdc-887d5a4b9370','a:1:{i:0;s:36:\"block.block.headertextrotatoronepage\";}'),

('config.entity.key_store.block','uuid:fc994139-80de-4266-9c3c-cdf5766d5eae','a:1:{i:0;s:49:\"block.block.views_block__related_projects_block_1\";}'),

('config.entity.key_store.block','uuid:fee32d35-bca7-4b85-92ee-5d2d3274cb4c','a:1:{i:0;s:41:\"block.block.headersliderzoomeffectonepage\";}'),

('config.entity.key_store.block_content_type','uuid:37d3192a-f3d9-4fa0-b933-2764c23fe3e1','a:1:{i:0;s:24:\"block_content.type.basic\";}'),

('config.entity.key_store.comment_type','uuid:33c5a8c8-4b95-42e0-8853-09dd350bf461','a:1:{i:0;s:20:\"comment.type.comment\";}'),

('config.entity.key_store.comment_type','uuid:41e10ade-3f2d-4682-9fd4-0da40f591d64','a:1:{i:0;s:28:\"comment.type.default_reviews\";}'),

('config.entity.key_store.commerce_checkout_flow','uuid:e7bf6f91-1296-40c6-972a-21d0afb97b61','a:1:{i:0;s:48:\"commerce_checkout.commerce_checkout_flow.default\";}'),

('config.entity.key_store.commerce_currency','uuid:d6f2c027-2ac8-4fd7-a893-5912eeab7013','a:1:{i:0;s:36:\"commerce_price.commerce_currency.USD\";}'),

('config.entity.key_store.commerce_order_item_type','uuid:2cd74ffd-939d-4376-a7ed-af33ccd29c86','a:1:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";}'),

('config.entity.key_store.commerce_order_type','uuid:0d00ceb7-872d-411e-9a6f-5873ec373424','a:1:{i:0;s:42:\"commerce_order.commerce_order_type.default\";}'),

('config.entity.key_store.commerce_payment_gateway','uuid:e4104691-70cf-4d28-ab6b-e043d0359249','a:1:{i:0;s:65:\"commerce_payment.commerce_payment_gateway.payment_gateway_example\";}'),

('config.entity.key_store.commerce_product_attribute','uuid:2a611036-881a-4bd0-a1f8-4680c3390f9d','a:1:{i:0;s:49:\"commerce_product.commerce_product_attribute.color\";}'),

('config.entity.key_store.commerce_product_attribute','uuid:e92d4e7f-0ccc-42ef-b5a4-953f0fd2a584','a:1:{i:0;s:48:\"commerce_product.commerce_product_attribute.size\";}'),

('config.entity.key_store.commerce_product_type','uuid:b61277a1-1b8b-474d-a854-110140d836b6','a:1:{i:0;s:46:\"commerce_product.commerce_product_type.default\";}'),

('config.entity.key_store.commerce_product_type','uuid:bba72e99-15a4-426d-9915-4d717dae6655','a:1:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";}'),

('config.entity.key_store.commerce_product_variation_type','uuid:1d91e425-a007-416f-aec8-c5d6f7d2ebb3','a:1:{i:0;s:56:\"commerce_product.commerce_product_variation_type.default\";}'),

('config.entity.key_store.commerce_product_variation_type','uuid:6b885057-0f85-4197-acd9-fc8729de2c4d','a:1:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";}'),

('config.entity.key_store.commerce_store_type','uuid:0ddab949-f9c8-42f9-82b5-58c3d9994cbc','a:1:{i:0;s:41:\"commerce_store.commerce_store_type.online\";}'),

('config.entity.key_store.configurable_language','uuid:10b36fe6-add0-450a-bcf2-a22a77a75fff','a:1:{i:0;s:18:\"language.entity.fr\";}'),

('config.entity.key_store.configurable_language','uuid:579f46fc-7a71-45ea-8d46-73c5a43cc5f0','a:1:{i:0;s:18:\"language.entity.de\";}'),

('config.entity.key_store.configurable_language','uuid:c0d7c2b5-042a-4e89-93df-81d84f30f7da','a:1:{i:0;s:18:\"language.entity.en\";}'),

('config.entity.key_store.configurable_language','uuid:de7bd6c5-f613-4ae5-910e-82cf8c41ab6b','a:1:{i:0;s:19:\"language.entity.und\";}'),

('config.entity.key_store.configurable_language','uuid:ff1a8750-b012-4368-81a0-142c0ddce876','a:1:{i:0;s:19:\"language.entity.zxx\";}'),

('config.entity.key_store.contact_form','uuid:6bf6def2-f5fa-4a7f-be2a-c0d50de47289','a:1:{i:0;s:21:\"contact.form.personal\";}'),

('config.entity.key_store.contact_form','uuid:b50d3e0b-e927-4500-a4f5-f22f19fbfa45','a:1:{i:0;s:21:\"contact.form.feedback\";}'),

('config.entity.key_store.date_format','uuid:036b3237-e0f0-489c-8aa8-82cbde303417','a:1:{i:0;s:26:\"core.date_format.html_week\";}'),

('config.entity.key_store.date_format','uuid:1024f29a-587a-4f59-b5eb-2f241578f21b','a:1:{i:0;s:26:\"core.date_format.html_date\";}'),

('config.entity.key_store.date_format','uuid:2cd01971-980c-484a-a5fd-0e42235c1d47','a:1:{i:0;s:22:\"core.date_format.short\";}'),

('config.entity.key_store.date_format','uuid:595b09f8-4ba9-4f63-9cd1-6fb36fd35ce6','a:1:{i:0;s:27:\"core.date_format.html_month\";}'),

('config.entity.key_store.date_format','uuid:78fbbbc8-302e-44b0-ad4c-22a832b1b383','a:1:{i:0;s:26:\"core.date_format.html_year\";}'),

('config.entity.key_store.date_format','uuid:7d03b549-cb7c-4e30-831e-8909a373383f','a:1:{i:0;s:35:\"core.date_format.html_yearless_date\";}'),

('config.entity.key_store.date_format','uuid:99a5140d-1fff-4d7e-b116-d1004fd290a6','a:1:{i:0;s:21:\"core.date_format.long\";}'),

('config.entity.key_store.date_format','uuid:9f4d6f8f-0dc6-493e-9dd8-4140f78dad76','a:1:{i:0;s:30:\"core.date_format.html_datetime\";}'),

('config.entity.key_store.date_format','uuid:bb3e8f3e-f8f4-41ff-816e-d6c12e29dc6c','a:1:{i:0;s:23:\"core.date_format.medium\";}'),

('config.entity.key_store.date_format','uuid:ea891b67-a4e8-4e1b-bc8e-c348e561d70f','a:1:{i:0;s:25:\"core.date_format.fallback\";}'),

('config.entity.key_store.date_format','uuid:fd68b7ba-36fa-48d6-a38a-230c901568c6','a:1:{i:0;s:26:\"core.date_format.html_time\";}'),

('config.entity.key_store.editor','uuid:0d612a63-de40-431e-bef7-0f27909891d2','a:1:{i:0;s:23:\"editor.editor.full_html\";}'),

('config.entity.key_store.editor','uuid:0fcb0d4b-89cc-404d-abc4-dbc5aaf31e45','a:1:{i:0;s:24:\"editor.editor.basic_html\";}'),

('config.entity.key_store.editor','uuid:af9b5cee-8d4c-4a99-bb39-42fe2ce351d5','a:1:{i:0;s:22:\"editor.editor.ckeditor\";}'),

('config.entity.key_store.embed_button','uuid:004523b2-cffc-44d9-b946-2fff79471ed2','a:1:{i:0;s:17:\"embed.button.node\";}'),

('config.entity.key_store.embed_button','uuid:fa7c6394-c7a8-477b-a404-32e03bb3a327','a:1:{i:0;s:25:\"embed.button.file_browser\";}'),

('config.entity.key_store.entity_browser','uuid:5352b42f-b8a4-478b-91bc-c875de12c35d','a:1:{i:0;s:35:\"entity_browser.browser.browse_files\";}'),

('config.entity.key_store.entity_browser','uuid:913ed4a9-5f97-4f82-9a61-a4e18faaf1c5','a:1:{i:0;s:41:\"entity_browser.browser.browse_files_modal\";}'),

('config.entity.key_store.entity_form_display','uuid:1d5c37f8-1fd2-419c-9453-f7787f18d2b3','a:1:{i:0;s:50:\"core.entity_form_display.node.nd_portfolio.default\";}'),

('config.entity.key_store.entity_form_display','uuid:3bb288f6-5017-4356-8015-ca4ebc5b6a4b','a:1:{i:0;s:50:\"core.entity_form_display.node.gallery_item.default\";}'),

('config.entity.key_store.entity_form_display','uuid:43bcfd19-72e2-4cf4-be3a-7446b9943adb','a:1:{i:0;s:47:\"core.entity_form_display.node.nd_person.default\";}'),

('config.entity.key_store.entity_form_display','uuid:4fe7e568-ffc5-4e38-b116-b1635176d69f','a:1:{i:0;s:64:\"core.entity_form_display.commerce_order_item.default.add_to_cart\";}'),

('config.entity.key_store.entity_form_display','uuid:57345f72-44de-467a-81de-25064a7baf8c','a:1:{i:0;s:45:\"core.entity_form_display.node.nd_blog.default\";}'),

('config.entity.key_store.entity_form_display','uuid:6520b7bb-e9fb-45a1-8869-c1044f6b1deb','a:1:{i:0;s:72:\"core.entity_form_display.commerce_order_item.default.variation_cart_form\";}'),

('config.entity.key_store.entity_form_display','uuid:67b3a9e4-bff6-44c7-a338-ea0c55c515c7','a:1:{i:0;s:60:\"core.entity_form_display.commerce_order_item.default.default\";}'),

('config.entity.key_store.entity_form_display','uuid:71d3a372-d7d5-47cb-a465-bcfad9528b6b','a:1:{i:0;s:55:\"core.entity_form_display.commerce_order.default.default\";}'),

('config.entity.key_store.entity_form_display','uuid:7ead05bb-48d9-4c0d-8503-3978179228c2','a:1:{i:0;s:67:\"core.entity_form_display.commerce_product_variation.product.default\";}'),

('config.entity.key_store.entity_form_display','uuid:861cae79-494d-4bd3-b53d-72f877e9b634','a:1:{i:0;s:67:\"core.entity_form_display.commerce_product_variation.default.default\";}'),

('config.entity.key_store.entity_form_display','uuid:99603433-3055-4189-bbfa-4faffe07e985','a:1:{i:0;s:52:\"core.entity_form_display.block_content.basic.default\";}'),

('config.entity.key_store.entity_form_display','uuid:a4a174fc-c839-4a9e-bada-a7e7f9534173','a:1:{i:0;s:45:\"core.entity_form_display.node.webform.default\";}'),

('config.entity.key_store.entity_form_display','uuid:a8eb744e-0c01-4abb-a5d0-43eacba1881c','a:1:{i:0;s:56:\"core.entity_form_display.comment.default_reviews.default\";}'),

('config.entity.key_store.entity_form_display','uuid:b0c8b372-c317-4a17-aa89-22c7d99dc2b2','a:1:{i:0;s:45:\"core.entity_form_display.node.article.default\";}'),

('config.entity.key_store.entity_form_display','uuid:d576c386-2944-4f59-a2a9-6a2d6b5d098f','a:1:{i:0;s:48:\"core.entity_form_display.comment.comment.default\";}'),

('config.entity.key_store.entity_form_display','uuid:ebdf7c6e-c15b-4337-8c4c-7934cc127c4f','a:1:{i:0;s:42:\"core.entity_form_display.node.page.default\";}'),

('config.entity.key_store.entity_form_display','uuid:f707c36f-cdfd-435f-a0f6-97ccae5ebe24','a:1:{i:0;s:57:\"core.entity_form_display.commerce_product.default.default\";}'),

('config.entity.key_store.entity_form_display','uuid:fbf53517-abbf-48b9-a8ff-3179445cd121','a:1:{i:0;s:49:\"core.entity_form_display.profile.customer.default\";}'),

('config.entity.key_store.entity_form_display','uuid:fc4f8b66-0239-4194-9214-1a4d08bfd25a','a:1:{i:0;s:42:\"core.entity_form_display.user.user.default\";}'),

('config.entity.key_store.entity_form_display','uuid:ff8f6f87-1629-45b7-a4b4-5edc1972c792','a:1:{i:0;s:65:\"core.entity_form_display.commerce_product.product_display.default\";}'),

('config.entity.key_store.entity_form_mode','uuid:0a452422-a173-4f6a-9f52-ad35f46f4fe0','a:1:{i:0;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}'),

('config.entity.key_store.entity_form_mode','uuid:2bf66c0f-264d-4a5a-86c3-260a97ff9e7a','a:1:{i:0;s:35:\"core.entity_form_mode.user.register\";}'),

('config.entity.key_store.entity_form_mode','uuid:79746294-6893-4476-8dfd-21233abdeef8','a:1:{i:0;s:61:\"core.entity_form_mode.commerce_order_item.variation_cart_form\";}'),

('config.entity.key_store.entity_view_display','uuid:0068b3ac-ea3e-4b38-ad9a-bf1faee78b26','a:1:{i:0;s:67:\"core.entity_view_display.commerce_product_variation.default.summary\";}'),

('config.entity.key_store.entity_view_display','uuid:025ac682-e1c1-45ec-8ee9-bff4d42a193c','a:1:{i:0;s:64:\"core.entity_view_display.commerce_product.product_display.teaser\";}'),

('config.entity.key_store.entity_view_display','uuid:059c1969-0726-46ce-9d52-896977422683','a:1:{i:0;s:42:\"core.entity_view_display.user.user.compact\";}'),

('config.entity.key_store.entity_view_display','uuid:0707f1c1-1174-4f98-a6f5-b0aeca023362','a:1:{i:0;s:50:\"core.entity_view_display.node.gallery_item.default\";}'),

('config.entity.key_store.entity_view_display','uuid:09d511c6-2622-4997-b678-90c8ff763aed','a:1:{i:0;s:65:\"core.entity_view_display.commerce_product.product_display.default\";}'),

('config.entity.key_store.entity_view_display','uuid:17ba37a5-f96b-4674-9546-6ecfdf98e091','a:1:{i:0;s:67:\"core.entity_view_display.commerce_product_variation.product.product\";}'),

('config.entity.key_store.entity_view_display','uuid:1a23f746-ff95-4115-b34a-9dacccb7ceca','a:1:{i:0;s:41:\"core.entity_view_display.node.article.rss\";}'),

('config.entity.key_store.entity_view_display','uuid:1b9438b8-9cb8-4fde-b23d-b4a3de6fb4e8','a:1:{i:0;s:41:\"core.entity_view_display.node.page.teaser\";}'),

('config.entity.key_store.entity_view_display','uuid:239a4af4-005e-471c-acbc-411c533aaf1b','a:1:{i:0;s:45:\"core.entity_view_display.node.webform.default\";}'),

('config.entity.key_store.entity_view_display','uuid:239f50af-5651-41b5-92ca-3938d01dc4a0','a:1:{i:0;s:44:\"core.entity_view_display.node.article.teaser\";}'),

('config.entity.key_store.entity_view_display','uuid:39905ec4-5514-43fa-a549-89ea776a35b1','a:1:{i:0;s:66:\"core.entity_view_display.commerce_product_variation.product.teaser\";}'),

('config.entity.key_store.entity_view_display','uuid:399b2426-e8ab-40af-b722-11e0a0713c5f','a:1:{i:0;s:49:\"core.entity_view_display.node.nd_portfolio.teaser\";}'),

('config.entity.key_store.entity_view_display','uuid:4ae6a983-0864-4215-aad3-544647c26b53','a:1:{i:0;s:56:\"core.entity_view_display.comment.default_reviews.default\";}'),

('config.entity.key_store.entity_view_display','uuid:4b5d356b-cddb-43d2-b937-048d92545e4f','a:1:{i:0;s:42:\"core.entity_view_display.node.page.default\";}'),

('config.entity.key_store.entity_view_display','uuid:5087d032-26f1-4b5f-887a-c438532a2458','a:1:{i:0;s:52:\"core.entity_view_display.commerce_order.default.user\";}'),

('config.entity.key_store.entity_view_display','uuid:6ff99f01-ff72-4e35-bb33-a4eb41f584f3','a:1:{i:0;s:64:\"core.entity_view_display.commerce_product_variation.default.cart\";}'),

('config.entity.key_store.entity_view_display','uuid:820b29f7-403f-4049-8545-e38639e04de9','a:1:{i:0;s:45:\"core.entity_view_display.node.article.default\";}'),

('config.entity.key_store.entity_view_display','uuid:878b8292-ffdb-451e-a0ba-ce4f413abb47','a:1:{i:0;s:54:\"core.entity_view_display.commerce_store.online.default\";}'),

('config.entity.key_store.entity_view_display','uuid:91726b82-0bbf-489f-9d53-b750d52656e5','a:1:{i:0;s:55:\"core.entity_view_display.commerce_order.default.default\";}'),

('config.entity.key_store.entity_view_display','uuid:9521e71f-f730-48e4-9868-9bbb589ed027','a:1:{i:0;s:48:\"core.entity_view_display.comment.comment.default\";}'),

('config.entity.key_store.entity_view_display','uuid:9849d905-2cf2-489a-8b94-322051c86e48','a:1:{i:0;s:47:\"core.entity_view_display.node.nd_person.default\";}'),

('config.entity.key_store.entity_view_display','uuid:a226e650-6b0a-4142-adda-4a2184843f1e','a:1:{i:0;s:60:\"core.entity_view_display.commerce_order_item.default.default\";}'),

('config.entity.key_store.entity_view_display','uuid:a36579e2-f92c-453d-8053-3264bc0be1df','a:1:{i:0;s:45:\"core.entity_view_display.node.nd_blog.default\";}'),

('config.entity.key_store.entity_view_display','uuid:ae40113c-509b-4f39-b3e8-cba342f491be','a:1:{i:0;s:46:\"core.entity_view_display.node.nd_person.teaser\";}'),

('config.entity.key_store.entity_view_display','uuid:bc5d6188-cefe-4350-a39e-4005f7f36258','a:1:{i:0;s:67:\"core.entity_view_display.commerce_product_variation.product.default\";}'),

('config.entity.key_store.entity_view_display','uuid:c9784356-4b9f-4bc4-8849-878a26de5c1f','a:1:{i:0;s:52:\"core.entity_view_display.block_content.basic.default\";}'),

('config.entity.key_store.entity_view_display','uuid:cb97d704-d24b-4855-9d4a-ba7e59dbae53','a:1:{i:0;s:49:\"core.entity_view_display.profile.customer.default\";}'),

('config.entity.key_store.entity_view_display','uuid:d3bd3693-c333-4715-9063-f39a5f23a6c6','a:1:{i:0;s:49:\"core.entity_view_display.node.gallery_item.teaser\";}'),

('config.entity.key_store.entity_view_display','uuid:dc239f0c-8448-478c-afd6-0043a7aefc68','a:1:{i:0;s:64:\"core.entity_view_display.commerce_product_variation.product.cart\";}'),

('config.entity.key_store.entity_view_display','uuid:ed00d8be-a7cd-4b2b-aa5f-cc677ac5eb29','a:1:{i:0;s:42:\"core.entity_view_display.user.user.default\";}'),

('config.entity.key_store.entity_view_display','uuid:ef55e6d3-d8b2-467a-bf69-a02b0aed8740','a:1:{i:0;s:57:\"core.entity_view_display.commerce_product.default.default\";}'),

('config.entity.key_store.entity_view_display','uuid:f5cbc13f-5fab-4b87-bb2a-7abd50e05d55','a:1:{i:0;s:44:\"core.entity_view_display.node.nd_blog.teaser\";}'),

('config.entity.key_store.entity_view_display','uuid:fd1e5995-9254-452a-9777-e83226d7fa6d','a:1:{i:0;s:50:\"core.entity_view_display.node.nd_portfolio.default\";}'),

('config.entity.key_store.entity_view_display','uuid:fec6bbda-ecff-4c72-9dc6-7408e00bfb62','a:1:{i:0;s:44:\"core.entity_view_display.node.webform.teaser\";}'),

('config.entity.key_store.entity_view_mode','uuid:00a23ac9-466f-4d50-a5ed-99ec83d28919','a:1:{i:0;s:56:\"core.entity_view_mode.commerce_product_variation.product\";}'),

('config.entity.key_store.entity_view_mode','uuid:07673261-080e-4a50-852c-bd9e886db1d6','a:1:{i:0;s:41:\"core.entity_view_mode.block_content.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:0e61c089-b9ab-41ac-ada7-62fb84458a52','a:1:{i:0;s:30:\"core.entity_view_mode.node.rss\";}'),

('config.entity.key_store.entity_view_mode','uuid:10f47fbf-5872-42c5-88ea-846b358284b6','a:1:{i:0;s:60:\"core.entity_view_mode.commerce_product_attribute_value.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:137e0af5-04e2-4a91-9c65-d2e69f436ad1','a:1:{i:0;s:42:\"core.entity_view_mode.commerce_store.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:1b13d02f-a6f6-44e2-9dec-12565d0b5469','a:1:{i:0;s:36:\"core.entity_view_mode.shortcut.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:21bfaf23-c45a-4076-b449-08488497ba0c','a:1:{i:0;s:33:\"core.entity_view_mode.node.teaser\";}'),

('config.entity.key_store.entity_view_mode','uuid:269ffdd3-3d85-47cc-9ff5-18ab1673c499','a:1:{i:0;s:32:\"core.entity_view_mode.node.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:2bbb0235-f556-41fb-8a2d-4835d7aa9989','a:1:{i:0;s:39:\"core.entity_view_mode.node.search_index\";}'),

('config.entity.key_store.entity_view_mode','uuid:3255b3e3-650b-40d1-bea3-8a7e6e3d6f3b','a:1:{i:0;s:32:\"core.entity_view_mode.tour.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:43261824-1385-4cca-b883-32b43ffd74f6','a:1:{i:0;s:31:\"core.entity_view_mode.node.full\";}'),

('config.entity.key_store.entity_view_mode','uuid:4c697c8d-f33a-4067-959f-d695db140887','a:1:{i:0;s:45:\"core.entity_view_mode.commerce_product.teaser\";}'),

('config.entity.key_store.entity_view_mode','uuid:5651025a-8ab7-41d9-829f-0354b897f54b','a:1:{i:0;s:35:\"core.entity_view_mode.profile.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:60a9b621-eb2d-46e4-916f-f739edf85897','a:1:{i:0;s:34:\"core.entity_view_mode.comment.full\";}'),

('config.entity.key_store.entity_view_mode','uuid:625e67d4-fc08-4f83-aca3-3ba6ccf0d22c','a:1:{i:0;s:46:\"core.entity_view_mode.webform_submission.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:72e43784-2487-4568-bd9b-05c3a338056c','a:1:{i:0;s:40:\"core.entity_view_mode.block_content.full\";}'),

('config.entity.key_store.entity_view_mode','uuid:82d7176a-cdcb-4c8d-8fd8-b4e188e3d6e5','a:1:{i:0;s:35:\"core.entity_view_mode.webform.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:858594c0-b77f-4459-a9bc-c219832dfd5b','a:1:{i:0;s:53:\"core.entity_view_mode.commerce_promotion_coupon.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:87a751f6-2ac3-42cf-bdfb-f1cef31ca7cb','a:1:{i:0;s:46:\"core.entity_view_mode.commerce_promotion.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:895a4f03-c97f-4d96-bb19-6719e458e93b','a:1:{i:0;s:39:\"core.entity_view_mode.vote_result.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:89f05268-da12-49e4-8840-d191757cd0bf','a:1:{i:0;s:40:\"core.entity_view_mode.taxonomy_term.full\";}'),

('config.entity.key_store.entity_view_mode','uuid:94e9cbff-17b7-4b8a-9030-eb22324886f7','a:1:{i:0;s:33:\"core.entity_view_mode.block.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:97630941-78b2-4a55-9ed9-6283ca5f0761','a:1:{i:0;s:44:\"core.entity_view_mode.commerce_payment.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:9d1671c5-e222-439b-a13c-09089b103b55','a:1:{i:0;s:41:\"core.entity_view_mode.taxonomy_term.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:9e7f623f-49e1-4c4a-a35d-afc6d1a0e00a','a:1:{i:0;s:51:\"core.entity_view_mode.commerce_payment_method.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:a1bb2193-4919-4e99-8a78-5422d7b9ee6a','a:1:{i:0;s:66:\"core.entity_view_mode.commerce_product_attribute_value.add_to_cart\";}'),

('config.entity.key_store.entity_view_mode','uuid:a57c17e2-4d3f-47e1-869f-76a70cd98b91','a:1:{i:0;s:32:\"core.entity_view_mode.file.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:ab59069e-a0ee-48e5-91b7-df9600f5b25b','a:1:{i:0;s:56:\"core.entity_view_mode.commerce_product_variation.summary\";}'),

('config.entity.key_store.entity_view_mode','uuid:adc28452-0a97-4256-924e-6281c00888fd','a:1:{i:0;s:32:\"core.entity_view_mode.vote.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:b3b612ac-3d51-4261-8868-de1375d2918a','a:1:{i:0;s:42:\"core.entity_view_mode.commerce_order.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:c2a4209a-8e50-41e0-8925-ad1d19e6dd9f','a:1:{i:0;s:55:\"core.entity_view_mode.commerce_product_variation.teaser\";}'),

('config.entity.key_store.entity_view_mode','uuid:c72ea520-4b1d-40ee-b6dd-ab3adb6c2fd8','a:1:{i:0;s:43:\"core.entity_view_mode.contact_message.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:d2398234-4c6b-48d1-bf42-9e06abcd48fa','a:1:{i:0;s:34:\"core.entity_view_mode.user.compact\";}'),

('config.entity.key_store.entity_view_mode','uuid:d2caae91-d08e-421c-9278-5c1bb875107b','a:1:{i:0;s:40:\"core.entity_view_mode.commerce_log.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:d89f15e3-66b9-4d1e-93db-976341fa8be7','a:1:{i:0;s:32:\"core.entity_view_mode.user.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:db1fcb51-5bc7-4e05-849e-ca6b77c7fec9','a:1:{i:0;s:35:\"core.entity_view_mode.comment.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:e4c61b96-61b4-4ad7-9eff-38abc6e1cd23','a:1:{i:0;s:40:\"core.entity_view_mode.node.search_result\";}'),

('config.entity.key_store.entity_view_mode','uuid:e56dc2cb-93e5-47b2-a253-5b5850500add','a:1:{i:0;s:45:\"core.entity_view_mode.menu_link_content.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:e8b6282a-8507-4d69-ba74-63f1028cc573','a:1:{i:0;s:47:\"core.entity_view_mode.commerce_order_item.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:e99adf1b-7fa7-4142-9dcd-33d3dc72d291','a:1:{i:0;s:41:\"core.entity_view_mode.commerce_order.user\";}'),

('config.entity.key_store.entity_view_mode','uuid:f10494c0-cf92-406d-9fb5-e38568aff69f','a:1:{i:0;s:44:\"core.entity_view_mode.commerce_product.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:f5730cea-958a-48f6-b091-3fbecc2d8fb8','a:1:{i:0;s:54:\"core.entity_view_mode.commerce_product_variation.token\";}'),

('config.entity.key_store.entity_view_mode','uuid:f67a6d60-c44e-43a0-af92-08fcda4c2c58','a:1:{i:0;s:53:\"core.entity_view_mode.commerce_product_variation.cart\";}'),

('config.entity.key_store.entity_view_mode','uuid:f8e7377a-e0f4-464a-b37d-4d0913c938e1','a:1:{i:0;s:31:\"core.entity_view_mode.user.full\";}'),

('config.entity.key_store.field_config','uuid:024925ec-7efe-40fc-b005-43b911e175ac','a:1:{i:0;s:29:\"field.field.node.article.body\";}'),

('config.entity.key_store.field_config','uuid:095a2dde-3f9b-4583-8e34-d1c9ce74bc5a','a:1:{i:0;s:58:\"field.field.commerce_product_variation.product.field_waist\";}'),

('config.entity.key_store.field_config','uuid:0cc63017-c2aa-4d3f-bc59-89389e3885c1','a:1:{i:0;s:38:\"field.field.node.nd_person.field_image\";}'),

('config.entity.key_store.field_config','uuid:0d1135c9-2e67-4cdd-9c21-80c6cbb67354','a:1:{i:0;s:36:\"field.field.node.article.field_image\";}'),

('config.entity.key_store.field_config','uuid:0eee8724-c776-4537-85c5-4a2cc43dc5c4','a:1:{i:0;s:54:\"field.field.node.nd_portfolio.field_portfolio_category\";}'),

('config.entity.key_store.field_config','uuid:0fad841c-bdb7-42a2-b443-79aa30f96766','a:1:{i:0;s:37:\"field.field.node.nd_blog.field_images\";}'),

('config.entity.key_store.field_config','uuid:14b4de37-fecf-4587-85d3-f35456e48c3f','a:1:{i:0;s:32:\"field.field.node.webform.webform\";}'),

('config.entity.key_store.field_config','uuid:17c04dba-dfa5-4a63-8477-d4c82ac46a63','a:1:{i:0;s:43:\"field.field.node.nd_portfolio.field_project\";}'),

('config.entity.key_store.field_config','uuid:1b1dc360-45ef-4812-8565-26ff7a0e037c','a:1:{i:0;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";}'),

('config.entity.key_store.field_config','uuid:1e8bbed1-a729-4caa-9fd2-f5de5dc36c0d','a:1:{i:0;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";}'),

('config.entity.key_store.field_config','uuid:23073b07-7dd4-4176-a4b1-5aeae54c632f','a:1:{i:0;s:45:\"field.field.node.nd_person.field_social_links\";}'),

('config.entity.key_store.field_config','uuid:28ce384c-31d9-4614-affd-48140ad5e24b','a:1:{i:0;s:48:\"field.field.node.nd_portfolio.field_project_link\";}'),

('config.entity.key_store.field_config','uuid:2d3d34a2-8401-41e7-ae51-32b7a6d9eed8','a:1:{i:0;s:31:\"field.field.node.nd_person.body\";}'),

('config.entity.key_store.field_config','uuid:2eafa3fb-b951-49a5-8c66-c83e366ad6f7','a:1:{i:0;s:41:\"field.field.node.nd_person.field_position\";}'),

('config.entity.key_store.field_config','uuid:34861c66-95f2-4023-95f8-9fe67b06ff97','a:1:{i:0;s:61:\"field.field.commerce_product_variation.product.attribute_size\";}'),

('config.entity.key_store.field_config','uuid:370d03f2-81a8-4bb7-8657-cef260417116','a:1:{i:0;s:40:\"field.field.node.nd_blog.field_lead_text\";}'),

('config.entity.key_store.field_config','uuid:4bb682af-48cc-4239-ac91-f2275d6688bc','a:1:{i:0;s:35:\"field.field.node.nd_blog.field_tags\";}'),

('config.entity.key_store.field_config','uuid:4ddfc91e-5a59-4cb2-9d6c-c8c91c3d4823','a:1:{i:0;s:42:\"field.field.node.nd_portfolio.field_images\";}'),

('config.entity.key_store.field_config','uuid:554cfe29-4a86-410d-b523-75fb4b615ae6','a:1:{i:0;s:51:\"field.field.commerce_product.product_display.stores\";}'),

('config.entity.key_store.field_config','uuid:574ef56c-fdbf-4cf3-85a1-1917d7fa0034','a:1:{i:0;s:48:\"field.field.comment.default_reviews.field_rating\";}'),

('config.entity.key_store.field_config','uuid:5cb0f722-a8b6-4dcd-a27f-b636615c1336','a:1:{i:0;s:34:\"field.field.user.user.user_picture\";}'),

('config.entity.key_store.field_config','uuid:61375016-53a6-4fbc-8ce8-37589320889b','a:1:{i:0;s:64:\"field.field.commerce_product_variation.product.field_description\";}'),

('config.entity.key_store.field_config','uuid:7300e286-d57c-4fc2-9bb8-458dbc70ea43','a:1:{i:0;s:59:\"field.field.commerce_product_variation.product.field_images\";}'),

('config.entity.key_store.field_config','uuid:74d09322-5311-492a-a05d-f02eef1d9644','a:1:{i:0;s:43:\"field.field.node.gallery_item.field_gallery\";}'),

('config.entity.key_store.field_config','uuid:783d557b-e8e7-4552-909b-1f6b94f3017a','a:1:{i:0;s:59:\"field.field.commerce_product_variation.product.field_length\";}'),

('config.entity.key_store.field_config','uuid:7c1e45a6-9c35-4122-ba59-3da81dabce1c','a:1:{i:0;s:41:\"field.field.commerce_product.default.body\";}'),

('config.entity.key_store.field_config','uuid:7fea0d50-385e-4201-87ee-49532870483e','a:1:{i:0;s:46:\"field.field.commerce_order.default.order_items\";}'),

('config.entity.key_store.field_config','uuid:82a92b6f-bd6e-442c-8054-48f27073aca8','a:1:{i:0;s:44:\"field.field.node.nd_portfolio.field_category\";}'),

('config.entity.key_store.field_config','uuid:89a431f2-70bc-4c3b-82f2-f47211d9072b','a:1:{i:0;s:62:\"field.field.commerce_product_variation.product.field_old_price\";}'),

('config.entity.key_store.field_config','uuid:8e0c0798-1c2d-453d-925d-0014acda854d','a:1:{i:0;s:59:\"field.field.commerce_product.product_display.field_category\";}'),

('config.entity.key_store.field_config','uuid:90a6eb7e-12aa-4789-bc1b-1f40004297f6','a:1:{i:0;s:36:\"field.field.block_content.basic.body\";}'),

('config.entity.key_store.field_config','uuid:93f1f700-fec3-4483-b45c-595db092fd6f','a:1:{i:0;s:39:\"field.field.comment.comment.field_email\";}'),

('config.entity.key_store.field_config','uuid:94057bf8-4850-43b1-a68a-e64483e0e408','a:1:{i:0;s:41:\"field.field.node.gallery_item.field_image\";}'),

('config.entity.key_store.field_config','uuid:94063973-4846-4d28-8079-636230d854c5','a:1:{i:0;s:43:\"field.field.commerce_product.default.stores\";}'),

('config.entity.key_store.field_config','uuid:986a1e1d-96d9-47ec-8cae-485d0565e59e','a:1:{i:0;s:58:\"field.field.commerce_product.product_display.field_reviews\";}'),

('config.entity.key_store.field_config','uuid:9f332e64-b08c-4637-9c7c-7e111dfa9b12','a:1:{i:0;s:35:\"field.field.node.article.field_tags\";}'),

('config.entity.key_store.field_config','uuid:9fa91801-2955-4202-90c4-56dd33cb3ff7','a:1:{i:0;s:32:\"field.field.node.article.comment\";}'),

('config.entity.key_store.field_config','uuid:a0bfaa4a-c7eb-4698-bde0-8ea62ce66979','a:1:{i:0;s:57:\"field.field.commerce_product.product_display.field_rating\";}'),

('config.entity.key_store.field_config','uuid:a19b6f33-3d39-401d-a5b0-3c6d6a4f5705','a:1:{i:0;s:62:\"field.field.commerce_product_variation.product.attribute_color\";}'),

('config.entity.key_store.field_config','uuid:a6394352-26bf-476a-ac43-69f3c093a275','a:1:{i:0;s:34:\"field.field.node.nd_portfolio.body\";}'),

('config.entity.key_store.field_config','uuid:a74749a5-7d23-4fa0-bef2-edeff19b3946','a:1:{i:0;s:36:\"field.field.profile.customer.address\";}'),

('config.entity.key_store.field_config','uuid:aecfbe9d-e984-4f7c-ae79-e49dad86bc03','a:1:{i:0;s:29:\"field.field.node.webform.body\";}'),

('config.entity.key_store.field_config','uuid:b0ad8cd1-ef92-4171-9613-2a02edfcaa4d','a:1:{i:0;s:55:\"field.field.commerce_product.product_display.variations\";}'),

('config.entity.key_store.field_config','uuid:b2ef3702-a984-4c6b-aa3c-cadb24aa651f','a:1:{i:0;s:47:\"field.field.comment.default_reviews.field_email\";}'),

('config.entity.key_store.field_config','uuid:b69d73f2-71d5-4cc5-8147-318e1052d030','a:1:{i:0;s:55:\"field.field.commerce_product.product_display.field_tags\";}'),

('config.entity.key_store.field_config','uuid:bee6d101-914d-46b0-b94e-d3c189ab243a','a:1:{i:0;s:40:\"field.field.user.user.commerce_remote_id\";}'),

('config.entity.key_store.field_config','uuid:c1e8ee36-77c1-44a6-ab8d-9e50be4e43d1','a:1:{i:0;s:70:\"field.field.commerce_product_variation.product.field_short_description\";}'),

('config.entity.key_store.field_config','uuid:c482d988-cf89-4ca8-9506-defe4cc5a017','a:1:{i:0;s:41:\"field.field.comment.comment.field_comment\";}'),

('config.entity.key_store.field_config','uuid:c6d823d6-7f46-47ca-b0dd-f461a86421ed','a:1:{i:0;s:43:\"field.field.node.nd_blog.field_second_title\";}'),

('config.entity.key_store.field_config','uuid:c8588174-d951-459d-9818-64b64979d89d','a:1:{i:0;s:39:\"field.field.node.nd_blog.field_comments\";}'),

('config.entity.key_store.field_config','uuid:cbc3bd3b-73c0-462a-8fcf-8c36a45f3538','a:1:{i:0;s:47:\"field.field.commerce_product.default.variations\";}'),

('config.entity.key_store.field_config','uuid:ebcd6e6e-fdca-43c9-804f-641f45450f8f','a:1:{i:0;s:44:\"field.field.node.nd_blog.field_blog_category\";}'),

('config.entity.key_store.field_config','uuid:ecc80d6d-f877-42ed-babb-2e75d3b74081','a:1:{i:0;s:29:\"field.field.node.nd_blog.body\";}'),

('config.entity.key_store.field_config','uuid:f0165325-0874-412b-af11-84dec3b45672','a:1:{i:0;s:26:\"field.field.node.page.body\";}'),

('config.entity.key_store.field_config','uuid:f39b4c16-844c-4e9e-a338-b52a1f0807f3','a:1:{i:0;s:47:\"field.field.node.nd_portfolio.field_description\";}'),

('config.entity.key_store.field_config','uuid:fad04b88-9378-485b-b79d-c3a8ea284f40','a:1:{i:0;s:49:\"field.field.comment.default_reviews.field_comment\";}'),

('config.entity.key_store.field_storage_config','uuid:05031807-3ec1-45f3-988c-bf04457938db','a:1:{i:0;s:35:\"field.storage.comment.field_comment\";}'),

('config.entity.key_store.field_storage_config','uuid:0cb161c6-01a2-422d-8fe7-2752d28e35c1','a:1:{i:0;s:43:\"field.storage.commerce_product.field_rating\";}'),

('config.entity.key_store.field_storage_config','uuid:0eaf2b41-5e64-4325-b11e-14e6a1e6def9','a:1:{i:0;s:56:\"field.storage.commerce_product_variation.field_sale_text\";}'),

('config.entity.key_store.field_storage_config','uuid:1771b593-3ae9-4c1e-bcf6-1eedd3f31d41','a:1:{i:0;s:58:\"field.storage.commerce_product_variation.field_description\";}'),

('config.entity.key_store.field_storage_config','uuid:17ff9d2a-51f7-478e-a18c-586dc327f14c','a:1:{i:0;s:23:\"field.storage.node.body\";}'),

('config.entity.key_store.field_storage_config','uuid:1962e2d5-67e1-43bb-bad5-bb27b2283e68','a:1:{i:0;s:53:\"field.storage.commerce_product_variation.field_images\";}'),

('config.entity.key_store.field_storage_config','uuid:1bd59879-f65b-48f4-87e1-98a80db1f8ed','a:1:{i:0;s:41:\"field.storage.commerce_product.field_tags\";}'),

('config.entity.key_store.field_storage_config','uuid:20881c09-17f4-4742-9a44-96c3ac912b23','a:1:{i:0;s:37:\"field.storage.user.commerce_remote_id\";}'),

('config.entity.key_store.field_storage_config','uuid:24336415-3815-4b60-90ba-438f55938640','a:1:{i:0;s:69:\"field.storage.commerce_product_variation.field_right_side_description\";}'),

('config.entity.key_store.field_storage_config','uuid:2517331e-c92f-41f4-8e9a-ea3b113dacb0','a:1:{i:0;s:37:\"field.storage.commerce_product.stores\";}'),

('config.entity.key_store.field_storage_config','uuid:339d3c2c-2268-4ee3-ba8e-4214ce301fa1','a:1:{i:0;s:64:\"field.storage.commerce_product_variation.field_short_description\";}'),

('config.entity.key_store.field_storage_config','uuid:4e2b8db9-b4b7-408c-93a7-fb453f56750b','a:1:{i:0;s:38:\"field.storage.node.field_blog_category\";}'),

('config.entity.key_store.field_storage_config','uuid:4f7121a5-c189-4d77-8e92-7df6031e7fb5','a:1:{i:0;s:30:\"field.storage.node.field_image\";}'),

('config.entity.key_store.field_storage_config','uuid:563c1246-b560-45a7-b8c4-79613c5b1d6c','a:1:{i:0;s:34:\"field.storage.node.field_lead_text\";}'),

('config.entity.key_store.field_storage_config','uuid:600ac5dc-843c-41f8-ad7f-ecbdb5c97962','a:1:{i:0;s:33:\"field.storage.comment.field_email\";}'),

('config.entity.key_store.field_storage_config','uuid:665271a2-3053-498b-9480-a75c293fa985','a:1:{i:0;s:37:\"field.storage.node.field_project_link\";}'),

('config.entity.key_store.field_storage_config','uuid:66ba7bdb-1bbc-4a11-b1e3-87e7e24f6978','a:1:{i:0;s:26:\"field.storage.node.comment\";}'),

('config.entity.key_store.field_storage_config','uuid:68d6363e-0bd7-4582-8149-04aabde5cd2e','a:1:{i:0;s:44:\"field.storage.commerce_product.field_reviews\";}'),

('config.entity.key_store.field_storage_config','uuid:6951603d-3b79-4da3-a414-d6bb1d1a0431','a:1:{i:0;s:33:\"field.storage.node.field_position\";}'),

('config.entity.key_store.field_storage_config','uuid:6aeb1549-be68-4923-a9ab-5328825769d6','a:1:{i:0;s:32:\"field.storage.block_content.body\";}'),

('config.entity.key_store.field_storage_config','uuid:710ac2c1-5c31-4b9a-a295-5ca95dcfcf23','a:1:{i:0;s:56:\"field.storage.commerce_product_variation.attribute_color\";}'),

('config.entity.key_store.field_storage_config','uuid:7774566e-2d83-440e-a02b-6df978eba52e','a:1:{i:0;s:31:\"field.storage.user.user_picture\";}'),

('config.entity.key_store.field_storage_config','uuid:7a4c4f30-f6ad-4785-9575-dcf0fb8b5c06','a:1:{i:0;s:32:\"field.storage.node.field_gallery\";}'),

('config.entity.key_store.field_storage_config','uuid:7d2356fb-e305-4c01-9235-b0a94458a78f','a:1:{i:0;s:34:\"field.storage.comment.field_rating\";}'),

('config.entity.key_store.field_storage_config','uuid:90b1ad03-45a0-4c75-9927-a11fffa88263','a:1:{i:0;s:52:\"field.storage.commerce_product_variation.field_waist\";}'),

('config.entity.key_store.field_storage_config','uuid:92f7e7e0-5ca9-4e8d-b819-cd04c43e2276','a:1:{i:0;s:29:\"field.storage.node.field_tags\";}'),

('config.entity.key_store.field_storage_config','uuid:97224b12-1de4-4c7a-8a6b-ff7576712db6','a:1:{i:0;s:43:\"field.storage.node.field_portfolio_category\";}'),

('config.entity.key_store.field_storage_config','uuid:9b482903-ea77-4dd3-a43a-79539bb89fce','a:1:{i:0;s:40:\"field.storage.commerce_order.order_items\";}'),

('config.entity.key_store.field_storage_config','uuid:9d747b94-edd6-42ea-81de-fbc5e01f6fde','a:1:{i:0;s:36:\"field.storage.node.field_description\";}'),

('config.entity.key_store.field_storage_config','uuid:a1d7db47-ab38-457a-94ed-f5f7b74052a7','a:1:{i:0;s:41:\"field.storage.commerce_product.variations\";}'),

('config.entity.key_store.field_storage_config','uuid:a68a7ada-26ea-4cc6-b4f8-8db5efe80994','a:1:{i:0;s:32:\"field.storage.node.field_project\";}'),

('config.entity.key_store.field_storage_config','uuid:b1311ac1-e885-4933-a31a-9db515095639','a:1:{i:0;s:37:\"field.storage.node.field_social_links\";}'),

('config.entity.key_store.field_storage_config','uuid:b1f7f989-c657-4f31-aa01-4d37f63135e3','a:1:{i:0;s:29:\"field.storage.profile.address\";}'),

('config.entity.key_store.field_storage_config','uuid:bdf0cdf5-31b9-45d6-8c39-a6ad4cbd8738','a:1:{i:0;s:31:\"field.storage.node.field_images\";}'),

('config.entity.key_store.field_storage_config','uuid:c114c9ee-6504-4d73-afb1-003b600ebe78','a:1:{i:0;s:33:\"field.storage.node.field_category\";}'),

('config.entity.key_store.field_storage_config','uuid:c8ac51e0-50db-4e83-842e-db0356890fe0','a:1:{i:0;s:37:\"field.storage.node.field_second_title\";}'),

('config.entity.key_store.field_storage_config','uuid:cd2079a4-0599-44e2-9aa7-9b5c7d15991f','a:1:{i:0;s:34:\"field.storage.comment.comment_body\";}'),

('config.entity.key_store.field_storage_config','uuid:d18cd2a1-355c-4d4a-94a7-76d7fb01b31a','a:1:{i:0;s:26:\"field.storage.node.webform\";}'),

('config.entity.key_store.field_storage_config','uuid:d60ff54d-c125-496a-ac21-bc345fe74e9c','a:1:{i:0;s:35:\"field.storage.commerce_product.body\";}'),

('config.entity.key_store.field_storage_config','uuid:db889761-dd45-468e-9e1b-6bb7c7ca6da9','a:1:{i:0;s:33:\"field.storage.node.field_comments\";}'),

('config.entity.key_store.field_storage_config','uuid:e1660665-8557-4ae6-8a8f-2b8cdd8afdaf','a:1:{i:0;s:56:\"field.storage.commerce_product_variation.field_old_price\";}'),

('config.entity.key_store.field_storage_config','uuid:e47b0e0d-0b8f-42bc-9e7e-dffa4ef07177','a:1:{i:0;s:45:\"field.storage.commerce_product.field_category\";}'),

('config.entity.key_store.field_storage_config','uuid:e71db06f-65dd-474a-b718-e888c96586cc','a:1:{i:0;s:55:\"field.storage.commerce_product_variation.attribute_size\";}'),

('config.entity.key_store.field_storage_config','uuid:fe16587c-28aa-473a-80f1-73f915f8f628','a:1:{i:0;s:53:\"field.storage.commerce_product_variation.field_length\";}'),

('config.entity.key_store.filter_format','uuid:133f61bc-d908-42fa-b8a7-d0110fc3eb0e','a:1:{i:0;s:23:\"filter.format.full_html\";}'),

('config.entity.key_store.filter_format','uuid:24aa033e-b666-403d-bb7c-d4bb14e01318','a:1:{i:0;s:22:\"filter.format.ckeditor\";}'),

('config.entity.key_store.filter_format','uuid:4fbcfda4-b62a-42e6-b141-a50bbb27cea1','a:1:{i:0;s:24:\"filter.format.plain_text\";}'),

('config.entity.key_store.filter_format','uuid:5aab2017-b642-436b-8c56-9026ed9fb2b4','a:1:{i:0;s:32:\"filter.format.dynamic_shortcodes\";}'),

('config.entity.key_store.filter_format','uuid:68dee1c5-3d01-4530-8952-6c270bf49a00','a:1:{i:0;s:24:\"filter.format.basic_html\";}'),

('config.entity.key_store.filter_format','uuid:8f254822-8787-4126-8675-b899b8cdb05f','a:1:{i:0;s:29:\"filter.format.restricted_html\";}'),

('config.entity.key_store.filter_format','uuid:98828904-4285-403a-ba22-db073f53cffe','a:1:{i:0;s:31:\"filter.format.visual_shortcodes\";}'),

('config.entity.key_store.filter_format','uuid:d1c8544a-22ce-4498-a2c9-122424902d02','a:1:{i:0;s:24:\"filter.format.shortcodes\";}'),

('config.entity.key_store.image_style','uuid:0b3fdb77-565f-4e1d-a366-3046385ffdf7','a:1:{i:0;s:21:\"image.style.thumbnail\";}'),

('config.entity.key_store.image_style','uuid:14502b96-b651-4374-a807-37920dcd4227','a:1:{i:0;s:28:\"image.style.gallery_360x232_\";}'),

('config.entity.key_store.image_style','uuid:4fb6b1e0-a0c1-49e9-8392-b1b8f512c1ee','a:1:{i:0;s:25:\"image.style.blog_360x195_\";}'),

('config.entity.key_store.image_style','uuid:5f922053-02e5-4fce-8368-b542aa95167a','a:1:{i:0;s:27:\"image.style.gallery_555x357\";}'),

('config.entity.key_store.image_style','uuid:638883c8-6f6f-40bf-8ba0-03ae0dcbd49c','a:1:{i:0;s:25:\"image.style.product_70x70\";}'),

('config.entity.key_store.image_style','uuid:652df59e-d169-4dac-9244-ca4899f3226d','a:1:{i:0;s:30:\"image.style.portfolio_653x368_\";}'),

('config.entity.key_store.image_style','uuid:674748c7-9c30-4c37-a500-4b6c51da1252','a:1:{i:0;s:30:\"image.style.portfolio_570x367_\";}'),

('config.entity.key_store.image_style','uuid:7256c597-beac-4bbc-bdff-71d02b508b5a','a:1:{i:0;s:27:\"image.style.gallery_165x106\";}'),

('config.entity.key_store.image_style','uuid:75b17973-07b2-4d7e-bab6-eb77b1e729ef','a:1:{i:0;s:31:\"image.style.product_small_68x86\";}'),

('config.entity.key_store.image_style','uuid:76122db4-9d76-49b5-91e4-c54e170cea51','a:1:{i:0;s:26:\"image.style.blog_1140x642_\";}'),

('config.entity.key_store.image_style','uuid:7a445b30-a896-407c-a792-fcd8e5458a27','a:1:{i:0;s:41:\"image.style.file_entity_browser_thumbnail\";}'),

('config.entity.key_store.image_style','uuid:7b3cbd70-be4c-4ee7-92e5-70df8369893a','a:1:{i:0;s:17:\"image.style.large\";}'),

('config.entity.key_store.image_style','uuid:88e66d54-f4da-45f1-881f-c2d7720cf59a','a:1:{i:0;s:28:\"image.style.gallery_263x169_\";}'),

('config.entity.key_store.image_style','uuid:8d3e80af-961f-4062-ba99-2220b6c64ca6','a:1:{i:0;s:27:\"image.style.product_263x335\";}'),

('config.entity.key_store.image_style','uuid:962ead23-383d-43f3-9285-17725116373d','a:1:{i:0;s:28:\"image.style.gallery_800x533_\";}'),

('config.entity.key_store.image_style','uuid:979697ec-f1f0-4a1b-8dd4-11d8c5e1c89f','a:1:{i:0;s:37:\"image.style.file_entity_browser_small\";}'),

('config.entity.key_store.image_style','uuid:9e859a24-4d1a-4dae-9822-a16a9663868f','a:1:{i:0;s:32:\"image.style.product_main_360x459\";}'),

('config.entity.key_store.image_style','uuid:b0ac6465-a1d5-422f-b28e-0283b089bb7d','a:1:{i:0;s:27:\"image.style.md_slider_thumb\";}'),

('config.entity.key_store.image_style','uuid:b4ab63bf-34cc-4e06-a581-aa4b17e0cbd1','a:1:{i:0;s:24:\"image.style.slider_pager\";}'),

('config.entity.key_store.image_style','uuid:bab89f50-8e5f-42e0-995f-1e24b12763a1','a:1:{i:0;s:18:\"image.style.medium\";}'),

('config.entity.key_store.image_style','uuid:c2d4185a-49e3-4e68-9ae7-0dbe5998e0c6','a:1:{i:0;s:27:\"image.style.person_360x438_\";}'),

('config.entity.key_store.image_style','uuid:dda90f64-3e74-4e10-8be8-37648f3b5110','a:1:{i:0;s:31:\"image.style.portfolio_650xauto_\";}'),

('config.entity.key_store.image_style','uuid:e7c23e4b-4590-4af6-92f0-5b4b0232152f','a:2:{i:0;s:27:\"image.style.portfolio_952x_\";i:1;s:30:\"image.style.portfolio_952x_613\";}'),

('config.entity.key_store.language_content_settings','uuid:67a2960e-6ba4-4c0b-8bdd-f5c825316ad6','a:1:{i:0;s:58:\"language.content_settings.commerce_product.product_display\";}'),

('config.entity.key_store.language_content_settings','uuid:88089675-0687-474b-8c8f-03cf43f51d4a','a:1:{i:0;s:40:\"language.content_settings.node.nd_person\";}'),

('config.entity.key_store.language_content_settings','uuid:8ead954e-c1a0-4f8e-b7a3-f9827ae3dfef','a:1:{i:0;s:60:\"language.content_settings.commerce_product_variation.product\";}'),

('config.entity.key_store.language_content_settings','uuid:a6a15ddb-8243-4f41-8d69-43422931bbb3','a:1:{i:0;s:38:\"language.content_settings.node.webform\";}'),

('config.entity.key_store.language_content_settings','uuid:b7263b20-5c53-494b-aba5-e27b0d553cbd','a:1:{i:0;s:43:\"language.content_settings.node.gallery_item\";}'),

('config.entity.key_store.language_content_settings','uuid:cc541afb-12b5-4e1b-b764-bb2b9e201f06','a:1:{i:0;s:47:\"language.content_settings.taxonomy_term.gallery\";}'),

('config.entity.key_store.menu','uuid:2f66cb0c-46b3-417c-a342-36dc0c3bbd58','a:1:{i:0;s:17:\"system.menu.admin\";}'),

('config.entity.key_store.menu','uuid:40ab76db-9d7a-471d-8055-21a76bd3835b','a:1:{i:0;s:20:\"system.menu.one-page\";}'),

('config.entity.key_store.menu','uuid:59b1831b-4e28-4e7e-a9b5-2a05678acbaf','a:1:{i:0;s:17:\"system.menu.tools\";}'),

('config.entity.key_store.menu','uuid:9252f9c3-f2b6-423b-93ae-cfac946ffd8a','a:1:{i:0;s:19:\"system.menu.account\";}'),

('config.entity.key_store.menu','uuid:d70d79ca-75b0-4ae2-ba85-673366eda18b','a:1:{i:0;s:18:\"system.menu.footer\";}'),

('config.entity.key_store.menu','uuid:fd05204d-a8e7-4708-91f4-e3e26bed83d4','a:1:{i:0;s:16:\"system.menu.main\";}'),

('config.entity.key_store.node_type','uuid:14ed6ebe-c003-4c68-870c-6eec4f495ad7','a:1:{i:0;s:17:\"node.type.nd_blog\";}'),

('config.entity.key_store.node_type','uuid:417e6c4e-81b2-4b3c-9fdd-36e4cbf79817','a:1:{i:0;s:22:\"node.type.nd_portfolio\";}'),

('config.entity.key_store.node_type','uuid:450601a8-cc33-47f1-ad9c-3851007b12ea','a:1:{i:0;s:22:\"node.type.gallery_item\";}'),

('config.entity.key_store.node_type','uuid:7ec3a74a-c075-4861-a394-5497aff0c6c1','a:1:{i:0;s:17:\"node.type.article\";}'),

('config.entity.key_store.node_type','uuid:d980fb46-2bd4-4e1a-8cb5-7752e8ddb3d3','a:1:{i:0;s:14:\"node.type.page\";}'),

('config.entity.key_store.node_type','uuid:f0247403-4df3-4593-9555-65323ca32415','a:1:{i:0;s:17:\"node.type.webform\";}'),

('config.entity.key_store.node_type','uuid:fe136bf6-bb85-4dac-86d3-b34e15112456','a:1:{i:0;s:19:\"node.type.nd_person\";}'),

('config.entity.key_store.profile_type','uuid:81d683bb-e06a-49a8-bfa5-1cb7644bd83e','a:1:{i:0;s:21:\"profile.type.customer\";}'),

('config.entity.key_store.search_page','uuid:4df754c5-99d9-44e0-be3b-b173007a12eb','a:1:{i:0;s:23:\"search.page.node_search\";}'),

('config.entity.key_store.search_page','uuid:b7ab86c4-37f2-4c24-842f-0f404ba6796a','a:1:{i:0;s:23:\"search.page.user_search\";}'),

('config.entity.key_store.shortcut_set','uuid:0f0b2a97-0738-41b7-aa52-8454c5967576','a:1:{i:0;s:20:\"shortcut.set.default\";}'),

('config.entity.key_store.taxonomy_vocabulary','uuid:0e02cdbb-74a7-4e71-8664-a8b3724f83f3','a:1:{i:0;s:27:\"taxonomy.vocabulary.gallery\";}'),

('config.entity.key_store.taxonomy_vocabulary','uuid:3fe666b0-e5f2-4759-bf94-d0e1c9392b41','a:1:{i:0;s:38:\"taxonomy.vocabulary.portfolio_category\";}'),

('config.entity.key_store.taxonomy_vocabulary','uuid:86f101ec-5726-49f2-b39b-6bba3ac7a794','a:1:{i:0;s:33:\"taxonomy.vocabulary.blog_category\";}'),

('config.entity.key_store.taxonomy_vocabulary','uuid:92bac0d2-aba9-41d1-ba44-79ebc289d900','a:1:{i:0;s:24:\"taxonomy.vocabulary.tags\";}'),

('config.entity.key_store.taxonomy_vocabulary','uuid:978f2b36-6c3d-44f8-b71b-541b333cc262','a:1:{i:0;s:27:\"taxonomy.vocabulary.project\";}'),

('config.entity.key_store.taxonomy_vocabulary','uuid:d1f9fdfb-2136-4ebf-92ee-fb49d5b0e2de','a:1:{i:0;s:28:\"taxonomy.vocabulary.category\";}'),

('config.entity.key_store.tb_megamenu','uuid:104a642f-6caa-47d2-8e80-0048b10945bb','a:1:{i:0;s:40:\"tb_megamenu.menu_config.main__rhythm_sub\";}'),

('config.entity.key_store.tour','routes.*.route_name:entity.configurable_language.collection','a:1:{i:0;s:18:\"tour.tour.language\";}'),

('config.entity.key_store.tour','routes.*.route_name:entity.configurable_language.edit_form','a:1:{i:0;s:23:\"tour.tour.language-edit\";}'),

('config.entity.key_store.tour','routes.*.route_name:entity.view.edit_display_form','a:1:{i:0;s:18:\"tour.tour.views-ui\";}'),

('config.entity.key_store.tour','routes.*.route_name:entity.view.edit_form','a:1:{i:0;s:18:\"tour.tour.views-ui\";}'),

('config.entity.key_store.tour','routes.*.route_name:language.add','a:1:{i:0;s:22:\"tour.tour.language-add\";}'),

('config.entity.key_store.tour','uuid:39a33bc5-3e2c-47ae-a811-6e898e7d6a06','a:1:{i:0;s:23:\"tour.tour.language-edit\";}'),

('config.entity.key_store.tour','uuid:4d995cc0-5bac-47e1-a515-4bebfe9e5bbe','a:1:{i:0;s:22:\"tour.tour.language-add\";}'),

('config.entity.key_store.tour','uuid:db568695-facf-4d9b-9727-aa07d29bc6ce','a:1:{i:0;s:18:\"tour.tour.views-ui\";}'),

('config.entity.key_store.tour','uuid:ebe8cb21-99a1-476f-b953-7bab8dc67b55','a:1:{i:0;s:18:\"tour.tour.language\";}'),

('config.entity.key_store.user_role','uuid:07405ee8-61ac-47d6-8381-9259ebd611a2','a:1:{i:0;s:23:\"user.role.authenticated\";}'),

('config.entity.key_store.user_role','uuid:53fee539-54b1-4d05-b5a6-c0f9eb31b3b4','a:1:{i:0;s:23:\"user.role.administrator\";}'),

('config.entity.key_store.user_role','uuid:c5095308-5ab5-4c02-827a-71a4ba8671ef','a:1:{i:0;s:19:\"user.role.anonymous\";}'),

('config.entity.key_store.view','uuid:07403f95-c487-46e5-8d4c-b7796fc6004d','a:1:{i:0;s:25:\"views.view.blog_fullwidth\";}'),

('config.entity.key_store.view','uuid:080f538e-0160-4e35-9be7-7ddd7e34fc8d','a:1:{i:0;s:28:\"views.view.user_admin_people\";}'),

('config.entity.key_store.view','uuid:08502ab1-9440-46b3-85c2-6dfbb5d5fb0d','a:1:{i:0;s:19:\"views.view.watchdog\";}'),

('config.entity.key_store.view','uuid:0a8078da-b243-4132-8896-07782de7e7f9','a:1:{i:0;s:29:\"views.view.portfolio_parallax\";}'),

('config.entity.key_store.view','uuid:0e10f7c5-a2f1-4cf9-98fc-717973950acf','a:1:{i:0;s:26:\"views.view.portfolio_boxed\";}'),

('config.entity.key_store.view','uuid:0e4ee9ae-006d-4f60-8435-7cd9990d409f','a:1:{i:0;s:28:\"views.view.products_comments\";}'),

('config.entity.key_store.view','uuid:187616b8-a65a-4b8d-9804-9d0955cbd08f','a:1:{i:0;s:25:\"views.view.content_recent\";}'),

('config.entity.key_store.view','uuid:22ae0af2-830a-4c19-bc0d-aaee6de9618e','a:1:{i:0;s:16:\"views.view.files\";}'),

('config.entity.key_store.view','uuid:23435072-1cf2-4d4a-b1a4-2b429bfc8937','a:1:{i:0;s:42:\"views.view.commerce_checkout_order_summary\";}'),

('config.entity.key_store.view','uuid:2ac02287-1878-470e-ae63-cc96238f1359','a:1:{i:0;s:28:\"views.view.commerce_activity\";}'),

('config.entity.key_store.view','uuid:2bd8b3f2-3795-4487-8e9d-f717dad87f3b','a:1:{i:0;s:36:\"views.view.commerce_order_item_table\";}'),

('config.entity.key_store.view','uuid:2c70c091-a613-4853-ae7b-945a8bf814d8','a:1:{i:0;s:25:\"views.view.commerce_carts\";}'),

('config.entity.key_store.view','uuid:2f569fe6-72a5-4eaf-bc8a-a39662c300b4','a:1:{i:0;s:26:\"views.view.comments_recent\";}'),

('config.entity.key_store.view','uuid:3dece191-47ed-442a-b1aa-035539f2fe18','a:1:{i:0;s:26:\"views.view.commerce_stores\";}'),

('config.entity.key_store.view','uuid:4998f724-533d-4149-9e9d-c408f78a6006','a:1:{i:0;s:18:\"views.view.gallery\";}'),

('config.entity.key_store.view','uuid:4a1262a0-0b80-452b-a545-c9afb32d3d87','a:1:{i:0;s:19:\"views.view.glossary\";}'),

('config.entity.key_store.view','uuid:4e8756eb-daaf-4100-a3c8-4458c635ee78','a:1:{i:0;s:27:\"views.view.related_projects\";}'),

('config.entity.key_store.view','uuid:5531784a-21ee-4ade-b2b0-fabf4642f3cc','a:1:{i:0;s:27:\"views.view.related_products\";}'),

('config.entity.key_store.view','uuid:566d95df-8225-40f6-b0af-2dc859cb58ac','a:1:{i:0;s:24:\"views.view.blog_timeline\";}'),

('config.entity.key_store.view','uuid:5749fab7-3882-4ca2-95dc-322bd09963dd','a:1:{i:0;s:26:\"views.view.commerce_orders\";}'),

('config.entity.key_store.view','uuid:62175247-1c62-4180-8bd9-b056b7bdc790','a:1:{i:0;s:32:\"views.view.products_best_sellers\";}'),

('config.entity.key_store.view','uuid:62d12724-c217-4b74-a47a-4470b7f9fe6d','a:1:{i:0;s:18:\"views.view.content\";}'),

('config.entity.key_store.view','uuid:6338a28d-0169-45c6-a250-ea14ad5f5c43','a:1:{i:0;s:30:\"views.view.commerce_cart_block\";}'),

('config.entity.key_store.view','uuid:6a5124fa-e33c-4a2b-bdbd-673393232d89','a:1:{i:0;s:24:\"views.view.taxonomy_term\";}'),

('config.entity.key_store.view','uuid:6ba538ee-9ea8-4c49-a3e7-871f6f375fcf','a:1:{i:0;s:30:\"views.view.file_entity_browser\";}'),

('config.entity.key_store.view','uuid:7a5b2ffd-c7bd-451f-a21c-a4f4bc3bef22','a:1:{i:0;s:24:\"views.view.block_content\";}'),

('config.entity.key_store.view','uuid:7e7068b6-9d17-4ad8-bf0e-d4f8a83a73a7','a:1:{i:0;s:23:\"views.view.shop_columns\";}'),

('config.entity.key_store.view','uuid:847793f2-bb41-45bc-b3a4-0d2c2c1b0971','a:1:{i:0;s:23:\"views.view.blog_masonry\";}'),

('config.entity.key_store.view','uuid:851fa1ae-f995-4c8f-b2d6-c99da72d8f45','a:1:{i:0;s:27:\"views.view.products_archive\";}'),

('config.entity.key_store.view','uuid:88cb8c71-02f6-44e9-9a43-56dfd89f696f','a:1:{i:0;s:24:\"views.view.products_tags\";}'),

('config.entity.key_store.view','uuid:89a32dce-3d25-460d-9bbd-7818c16f5392','a:1:{i:0;s:19:\"views.view.profiles\";}'),

('config.entity.key_store.view','uuid:8e3ada56-8056-473e-8275-03ee6f57a788','a:1:{i:0;s:31:\"views.view.commerce_user_orders\";}'),

('config.entity.key_store.view','uuid:909a80c1-4830-41f9-a386-6482197a2bb5','a:1:{i:0;s:20:\"views.view.frontpage\";}'),

('config.entity.key_store.view','uuid:9680fbd2-7f75-4151-9028-545698faf51c','a:1:{i:0;s:26:\"views.view.shop_categories\";}'),

('config.entity.key_store.view','uuid:9d59eb0b-da2c-4969-857d-60fc644dd82d','a:1:{i:0;s:20:\"views.view.who_s_new\";}'),

('config.entity.key_store.view','uuid:b3c49ec1-50ba-4b2e-ae85-97a850790b3c','a:1:{i:0;s:29:\"views.view.commerce_cart_form\";}'),

('config.entity.key_store.view','uuid:bd05a105-83e0-4caf-8f29-1203ec714128','a:1:{i:0;s:15:\"views.view.team\";}'),

('config.entity.key_store.view','uuid:c9febb47-c648-4f9e-abac-f0705766c37a','a:1:{i:0;s:23:\"views.view.who_s_online\";}'),

('config.entity.key_store.view','uuid:d56aa3ad-b600-417e-938d-320bf976af63','a:1:{i:0;s:26:\"views.view.portfolio_promo\";}'),

('config.entity.key_store.view','uuid:ddd65c6d-2ee3-4081-92d2-8c1979abed2f','a:1:{i:0;s:18:\"views.view.comment\";}'),

('config.entity.key_store.view','uuid:dddb5b07-5f3f-4aaf-9ef1-9dbaf20ca01a','a:1:{i:0;s:28:\"views.view.commerce_products\";}'),

('config.entity.key_store.view','uuid:e856eb05-317c-46a5-bb8b-1a5eaacb07d3','a:1:{i:0;s:18:\"views.view.archive\";}'),

('config.entity.key_store.view','uuid:ebb88ffd-00eb-45b3-8db2-ab495be93b19','a:1:{i:0;s:20:\"views.view.blog_grid\";}'),

('config.entity.key_store.view','uuid:fb72a8ac-5a16-47b5-92ef-33e4970e39d3','a:1:{i:0;s:30:\"views.view.webform_submissions\";}'),

('config.entity.key_store.vote_type','uuid:d9b58c3f-1c5b-454d-82bb-7a7a61f896b8','a:1:{i:0;s:24:\"votingapi.vote_type.vote\";}'),

('config.entity.key_store.webform','category:','a:3:{i:0;s:23:\"webform.webform.contact\";i:1;s:25:\"webform.webform.contact_1\";i:2;s:25:\"webform.webform.subscribe\";}'),

('config.entity.key_store.webform','status:1','a:3:{i:0;s:23:\"webform.webform.contact\";i:1;s:25:\"webform.webform.contact_1\";i:2;s:25:\"webform.webform.subscribe\";}'),

('config.entity.key_store.webform','status:open','a:3:{i:0;s:23:\"webform.webform.contact\";i:1;s:25:\"webform.webform.contact_1\";i:2;s:25:\"webform.webform.subscribe\";}'),

('config.entity.key_store.webform','template:','a:3:{i:0;s:23:\"webform.webform.contact\";i:1;s:25:\"webform.webform.contact_1\";i:2;s:25:\"webform.webform.subscribe\";}'),

('config.entity.key_store.webform','uuid:5bd89c2c-f97e-4619-9d4f-1f93ee35f511','a:1:{i:0;s:25:\"webform.webform.contact_1\";}'),

('config.entity.key_store.webform','uuid:d8a48f86-c84b-44ca-b1ec-62d77fc3498a','a:1:{i:0;s:25:\"webform.webform.subscribe\";}'),

('config.entity.key_store.webform','uuid:f87398a6-7455-4f13-81e7-2dc9bdffd69c','a:1:{i:0;s:23:\"webform.webform.contact\";}'),

('config.entity.key_store.webform_options','uuid:04d7d516-1f55-4cc4-84e8-87ed77ac8860','a:1:{i:0;s:41:\"webform.webform_options.likert_comparison\";}'),

('config.entity.key_store.webform_options','uuid:1f15f7d1-32f8-4b54-a249-682f1919b227','a:1:{i:0;s:38:\"webform.webform_options.marital_status\";}'),

('config.entity.key_store.webform_options','uuid:247276a7-d9b9-4a41-b79d-bbd6e56ca556','a:1:{i:0;s:35:\"webform.webform_options.state_codes\";}'),

('config.entity.key_store.webform_options','uuid:251dae8c-bd3f-47cb-883b-473999eb446d','a:1:{i:0;s:37:\"webform.webform_options.country_codes\";}'),

('config.entity.key_store.webform_options','uuid:2597eb3c-d1b3-40ea-b4db-09a8c141c1bd','a:1:{i:0;s:30:\"webform.webform_options.yes_no\";}'),

('config.entity.key_store.webform_options','uuid:2f9b2509-dd97-4628-8151-a717462b018f','a:1:{i:0;s:38:\"webform.webform_options.likert_quality\";}'),

('config.entity.key_store.webform_options','uuid:37128d1d-3e70-4ee8-8ca3-335d7cf659df','a:1:{i:0;s:40:\"webform.webform_options.likert_would_you\";}'),

('config.entity.key_store.webform_options','uuid:390e3ad2-8c93-4f64-9fff-a337f935ce87','a:1:{i:0;s:33:\"webform.webform_options.education\";}'),

('config.entity.key_store.webform_options','uuid:3bf8fc48-a7f1-40e3-9169-2052a795fa17','a:1:{i:0;s:44:\"webform.webform_options.state_province_names\";}'),

('config.entity.key_store.webform_options','uuid:3d4f80c3-ab18-430b-a795-aa2e872f198b','a:1:{i:0;s:30:\"webform.webform_options.months\";}'),

('config.entity.key_store.webform_options','uuid:42ee862f-1c9e-4749-b9ce-348ca57b3857','a:1:{i:0;s:28:\"webform.webform_options.days\";}'),

('config.entity.key_store.webform_options','uuid:43688776-8900-46c4-b576-7c1dc533cc28','a:1:{i:0;s:34:\"webform.webform_options.time_zones\";}'),

('config.entity.key_store.webform_options','uuid:52371a23-daca-44e7-88ee-32e942a6c822','a:1:{i:0;s:43:\"webform.webform_options.likert_satisfaction\";}'),

('config.entity.key_store.webform_options','uuid:5862df58-677d-4bd1-ba88-1d09151db361','a:1:{i:0;s:33:\"webform.webform_options.languages\";}'),

('config.entity.key_store.webform_options','uuid:5b480678-5d6b-4588-97a6-e82aabd9e398','a:1:{i:0;s:41:\"webform.webform_options.employment_status\";}'),

('config.entity.key_store.webform_options','uuid:606c2415-cffd-4d4b-9e4a-074b8bbe008c','a:1:{i:0;s:37:\"webform.webform_options.country_names\";}'),

('config.entity.key_store.webform_options','uuid:72e3d7ee-059f-4dac-bcda-f78f3e8229af','a:1:{i:0;s:30:\"webform.webform_options.titles\";}'),

('config.entity.key_store.webform_options','uuid:749b2285-48b6-48e4-b1fc-1206cbde706e','a:1:{i:0;s:40:\"webform.webform_options.likert_ten_scale\";}'),

('config.entity.key_store.webform_options','uuid:775f157f-854f-4149-a578-42393cdcfa6c','a:1:{i:0;s:35:\"webform.webform_options.state_names\";}'),

('config.entity.key_store.webform_options','uuid:794e1637-a0b7-42e8-ad6e-7520098c1fa7','a:1:{i:0;s:32:\"webform.webform_options.industry\";}'),

('config.entity.key_store.webform_options','uuid:896ade15-d68e-40cf-ab9e-e0aa6ba8f1a7','a:1:{i:0;s:40:\"webform.webform_options.creditcard_codes\";}'),

('config.entity.key_store.webform_options','uuid:91e5ffe9-607a-4455-844e-33b5e3125935','a:1:{i:0;s:36:\"webform.webform_options.relationship\";}'),

('config.entity.key_store.webform_options','uuid:99685bb1-27c5-4809-b23e-2400bdcc8d18','a:1:{i:0;s:44:\"webform.webform_options.state_province_codes\";}'),

('config.entity.key_store.webform_options','uuid:c636b488-3852-46db-a793-af19d6d16a03','a:1:{i:0;s:33:\"webform.webform_options.ethnicity\";}'),

('config.entity.key_store.webform_options','uuid:e04017f8-c64f-472d-88e4-46a52f02e0a2','a:1:{i:0;s:30:\"webform.webform_options.gender\";}'),

('config.entity.key_store.webform_options','uuid:f6bffd2b-eeb2-4676-8524-07c4563b6884','a:1:{i:0;s:28:\"webform.webform_options.size\";}'),

('config.entity.key_store.webform_options','uuid:fc7b1bab-7a9e-4627-a611-1040a0fa06a0','a:1:{i:0;s:41:\"webform.webform_options.likert_importance\";}'),

('config.entity.key_store.webform_options','uuid:fe9a08f8-45f7-42f9-9cbf-ad510e6d9293','a:1:{i:0;s:40:\"webform.webform_options.likert_agreement\";}'),

('entity.definitions.bundle_field_map','block_content','a:1:{s:4:\"body\";a:2:{s:4:\"type\";s:17:\"text_with_summary\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}}'),

('entity.definitions.bundle_field_map','comment','a:3:{s:13:\"field_comment\";a:2:{s:4:\"type\";s:11:\"string_long\";s:7:\"bundles\";a:2:{s:7:\"comment\";s:7:\"comment\";s:15:\"default_reviews\";s:15:\"default_reviews\";}}s:11:\"field_email\";a:2:{s:4:\"type\";s:5:\"email\";s:7:\"bundles\";a:2:{s:7:\"comment\";s:7:\"comment\";s:15:\"default_reviews\";s:15:\"default_reviews\";}}s:12:\"field_rating\";a:2:{s:4:\"type\";s:8:\"fivestar\";s:7:\"bundles\";a:1:{s:15:\"default_reviews\";s:15:\"default_reviews\";}}}'),

('entity.definitions.bundle_field_map','commerce_order','a:1:{s:11:\"order_items\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}}'),

('entity.definitions.bundle_field_map','commerce_payment_method','a:5:{s:9:\"card_type\";a:2:{s:4:\"type\";s:11:\"list_string\";s:7:\"bundles\";a:1:{s:11:\"credit_card\";s:11:\"credit_card\";}}s:11:\"card_number\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:11:\"credit_card\";s:11:\"credit_card\";}}s:14:\"card_exp_month\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:11:\"credit_card\";s:11:\"credit_card\";}}s:13:\"card_exp_year\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:11:\"credit_card\";s:11:\"credit_card\";}}s:11:\"paypal_mail\";a:2:{s:4:\"type\";s:5:\"email\";s:7:\"bundles\";a:1:{s:6:\"paypal\";s:6:\"paypal\";}}}'),

('entity.definitions.bundle_field_map','commerce_product','a:7:{s:6:\"stores\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:2:{s:7:\"default\";s:7:\"default\";s:15:\"product_display\";s:15:\"product_display\";}}s:10:\"variations\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:2:{s:7:\"default\";s:7:\"default\";s:15:\"product_display\";s:15:\"product_display\";}}s:4:\"body\";a:2:{s:4:\"type\";s:17:\"text_with_summary\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}s:12:\"field_rating\";a:2:{s:4:\"type\";s:8:\"fivestar\";s:7:\"bundles\";a:1:{s:15:\"product_display\";s:15:\"product_display\";}}s:14:\"field_category\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:15:\"product_display\";s:15:\"product_display\";}}s:10:\"field_tags\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:15:\"product_display\";s:15:\"product_display\";}}s:13:\"field_reviews\";a:2:{s:4:\"type\";s:7:\"comment\";s:7:\"bundles\";a:1:{s:15:\"product_display\";s:15:\"product_display\";}}}'),

('entity.definitions.bundle_field_map','commerce_product_attribute_value','a:0:{}'),

('entity.definitions.bundle_field_map','commerce_product_variation','a:10:{s:15:\"field_old_price\";a:2:{s:4:\"type\";s:14:\"commerce_price\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}s:12:\"field_images\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}s:15:\"field_sale_text\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}s:23:\"field_short_description\";a:2:{s:4:\"type\";s:11:\"string_long\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}s:17:\"field_description\";a:2:{s:4:\"type\";s:9:\"text_long\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}s:28:\"field_right_side_description\";a:2:{s:4:\"type\";s:9:\"text_long\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}s:11:\"field_waist\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}s:12:\"field_length\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}s:15:\"attribute_color\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}s:14:\"attribute_size\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:7:\"product\";s:7:\"product\";}}}'),

('entity.definitions.bundle_field_map','node','a:18:{s:11:\"field_image\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:3:{s:7:\"article\";s:7:\"article\";s:9:\"nd_person\";s:9:\"nd_person\";s:12:\"gallery_item\";s:12:\"gallery_item\";}}s:7:\"comment\";a:2:{s:4:\"type\";s:7:\"comment\";s:7:\"bundles\";a:1:{s:7:\"article\";s:7:\"article\";}}s:10:\"field_tags\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:2:{s:7:\"article\";s:7:\"article\";s:7:\"nd_blog\";s:7:\"nd_blog\";}}s:4:\"body\";a:2:{s:4:\"type\";s:17:\"text_with_summary\";s:7:\"bundles\";a:6:{s:4:\"page\";s:4:\"page\";s:7:\"article\";s:7:\"article\";s:7:\"nd_blog\";s:7:\"nd_blog\";s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";s:9:\"nd_person\";s:9:\"nd_person\";s:7:\"webform\";s:7:\"webform\";}}s:18:\"field_second_title\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:7:\"nd_blog\";s:7:\"nd_blog\";}}s:15:\"field_lead_text\";a:2:{s:4:\"type\";s:9:\"text_long\";s:7:\"bundles\";a:1:{s:7:\"nd_blog\";s:7:\"nd_blog\";}}s:12:\"field_images\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:2:{s:7:\"nd_blog\";s:7:\"nd_blog\";s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}}s:19:\"field_blog_category\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:7:\"nd_blog\";s:7:\"nd_blog\";}}s:14:\"field_comments\";a:2:{s:4:\"type\";s:7:\"comment\";s:7:\"bundles\";a:1:{s:7:\"nd_blog\";s:7:\"nd_blog\";}}s:17:\"field_description\";a:2:{s:4:\"type\";s:9:\"text_long\";s:7:\"bundles\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}}s:18:\"field_project_link\";a:2:{s:4:\"type\";s:4:\"link\";s:7:\"bundles\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}}s:13:\"field_project\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}}s:14:\"field_category\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}}s:24:\"field_portfolio_category\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:12:\"nd_portfolio\";s:12:\"nd_portfolio\";}}s:18:\"field_social_links\";a:2:{s:4:\"type\";s:4:\"link\";s:7:\"bundles\";a:1:{s:9:\"nd_person\";s:9:\"nd_person\";}}s:14:\"field_position\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:9:\"nd_person\";s:9:\"nd_person\";}}s:7:\"webform\";a:2:{s:4:\"type\";s:7:\"webform\";s:7:\"bundles\";a:1:{s:7:\"webform\";s:7:\"webform\";}}s:13:\"field_gallery\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:12:\"gallery_item\";s:12:\"gallery_item\";}}}'),

('entity.definitions.bundle_field_map','profile','a:1:{s:7:\"address\";a:2:{s:4:\"type\";s:7:\"address\";s:7:\"bundles\";a:1:{s:8:\"customer\";s:8:\"customer\";}}}'),

('entity.definitions.bundle_field_map','user','a:2:{s:12:\"user_picture\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:18:\"commerce_remote_id\";a:2:{s:4:\"type\";s:18:\"commerce_remote_id\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}}'),

('entity.definitions.installed','action.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"type\";i:3;s:6:\"plugin\";i:4;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:6:\"action\";s:11:\"\0*\0provider\";s:6:\"system\";s:8:\"\0*\0class\";s:27:\"Drupal\\system\\Entity\\Action\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:18:\"administer actions\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"config:action_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','base_field_override.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:19:\"base_field_override\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:6:\"bundle\";i:4;s:5:\"label\";i:5;s:11:\"description\";i:6;s:8:\"required\";i:7;s:12:\"translatable\";i:8;s:13:\"default_value\";i:9;s:22:\"default_value_callback\";i:10;s:8:\"settings\";i:11;s:10:\"field_type\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"base_field_override\";s:11:\"\0*\0provider\";s:4:\"core\";s:8:\"\0*\0class\";s:42:\"Drupal\\Core\\Field\\Entity\\BaseFieldOverride\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:7:\"storage\";s:42:\"Drupal\\Core\\Field\\BaseFieldOverrideStorage\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Base field override\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:base_field_override_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','block.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:2:{i:0;s:5:\"theme\";i:1;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:8:{i:0;s:2:\"id\";i:1;s:5:\"theme\";i:2;s:6:\"region\";i:3;s:6:\"weight\";i:4;s:8:\"provider\";i:5;s:6:\"plugin\";i:6;s:8:\"settings\";i:7;s:10:\"visibility\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:5:\"block\";s:11:\"\0*\0provider\";s:5:\"block\";s:8:\"\0*\0class\";s:25:\"Drupal\\block\\Entity\\Block\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:38:\"Drupal\\block\\BlockAccessControlHandler\";s:12:\"view_builder\";s:29:\"Drupal\\block\\BlockViewBuilder\";s:12:\"list_builder\";s:29:\"Drupal\\block\\BlockListBuilder\";s:4:\"form\";a:2:{s:7:\"default\";s:22:\"Drupal\\block\\BlockForm\";s:6:\"delete\";s:33:\"Drupal\\block\\Form\\BlockDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:2:{s:11:\"delete-form\";s:44:\"/admin/structure/block/manage/{block}/delete\";s:9:\"edit-form\";s:37:\"/admin/structure/block/manage/{block}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:17:\"config:block_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','block_content.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:4:{s:16:\"revision_default\";s:16:\"revision_default\";s:13:\"revision_user\";s:13:\"revision_user\";s:16:\"revision_created\";s:16:\"revision_created\";s:20:\"revision_log_message\";s:12:\"revision_log\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:0;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:11:\"revision_id\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:4:\"info\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:9:\"published\";s:6:\"status\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:13:\"block_content\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:7:{s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:6:\"access\";s:53:\"Drupal\\block_content\\BlockContentAccessControlHandler\";s:12:\"list_builder\";s:44:\"Drupal\\block_content\\BlockContentListBuilder\";s:12:\"view_builder\";s:44:\"Drupal\\block_content\\BlockContentViewBuilder\";s:10:\"views_data\";s:42:\"Drupal\\block_content\\BlockContentViewsData\";s:4:\"form\";a:4:{s:3:\"add\";s:37:\"Drupal\\block_content\\BlockContentForm\";s:4:\"edit\";s:37:\"Drupal\\block_content\\BlockContentForm\";s:6:\"delete\";s:48:\"Drupal\\block_content\\Form\\BlockContentDeleteForm\";s:7:\"default\";s:37:\"Drupal\\block_content\\BlockContentForm\";}s:11:\"translation\";s:51:\"Drupal\\block_content\\BlockContentTranslationHandler\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:9:\"canonical\";s:22:\"/block/{block_content}\";s:11:\"delete-form\";s:29:\"/block/{block_content}/delete\";s:9:\"edit-form\";s:22:\"/block/{block_content}\";s:10:\"collection\";s:36:\"/admin/structure/block/block-content\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:18:\"block_content_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:13:\"block_content\";s:22:\"\0*\0revision_data_table\";s:28:\"block_content_field_revision\";s:17:\"\0*\0revision_table\";s:22:\"block_content_revision\";s:13:\"\0*\0data_table\";s:24:\"block_content_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:35:\"entity.block_content_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"block_content_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:40:\"Drupal\\block_content\\Entity\\BlockContent\";s:11:\"\0*\0provider\";s:13:\"block_content\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','block_content.field_storage_definitions','a:16:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Custom block ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The custom block ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The custom block UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:11:\"revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"The revision ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:11:\"revision_id\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:112;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"The custom block language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:151;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:18:\"block_content_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The block type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"info\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:188;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:11:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Block description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"A brief description of your block.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:11:\"constraints\";a:1:{s:11:\"UniqueField\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:4:\"info\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:12:\"revision_log\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:232;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The log entry explaining the changes in this revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:12:\"revision_log\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:263;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the custom block was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:16:\"revision_created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:293;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:16:\"revision_created\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:13:\"revision_user\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:322;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:13:\"revision_user\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:358;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:398;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:18:\"block_content.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:14:\"\0*\0entity_type\";s:13:\"block_content\";s:7:\"\0*\0type\";s:17:\"text_with_summary\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:18:\"block_content.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"6aeb1549-be68-4923-a9ab-5328825769d6\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eS0snV_L3dx9shtWRTzm5eblwOJ7qKWC9IE-4GMTDFc\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"text\";}}}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:474;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:13:\"block_content\";s:8:\"provider\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:517;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Publishing status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"A boolean indicating the published state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:13:\"block_content\";s:8:\"provider\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:8:\"reusable\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:562;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Reusable\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"A boolean indicating whether this block is reusable.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:0;s:12:\"revisionable\";b:0;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:8:\"reusable\";s:11:\"entity_type\";s:13:\"block_content\";s:8:\"provider\";s:13:\"block_content\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','block_content_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:8:\"revision\";i:3;s:11:\"description\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:18:\"block_content_type\";s:11:\"\0*\0provider\";s:13:\"block_content\";s:8:\"\0*\0class\";s:44:\"Drupal\\block_content\\Entity\\BlockContentType\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:4:{s:7:\"default\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:3:\"add\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:4:\"edit\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:6:\"delete\";s:52:\"Drupal\\block_content\\Form\\BlockContentTypeDeleteForm\";}s:12:\"list_builder\";s:48:\"Drupal\\block_content\\BlockContentTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:11:\"delete-form\";s:71:\"/admin/structure/block/block-content/manage/{block_content_type}/delete\";s:9:\"edit-form\";s:64:\"/admin/structure/block/block-content/manage/{block_content_type}\";s:10:\"collection\";s:42:\"/admin/structure/block/block-content/types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:13:\"block_content\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:30:\"config:block_content_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','comment.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:3:\"cid\";s:6:\"bundle\";s:12:\"comment_type\";s:5:\"label\";s:7:\"subject\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:9:\"published\";s:6:\"status\";s:5:\"owner\";s:3:\"uid\";}s:5:\"\0*\0id\";s:7:\"comment\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:8:{s:7:\"storage\";s:29:\"Drupal\\comment\\CommentStorage\";s:14:\"storage_schema\";s:35:\"Drupal\\comment\\CommentStorageSchema\";s:6:\"access\";s:42:\"Drupal\\comment\\CommentAccessControlHandler\";s:12:\"list_builder\";s:36:\"Drupal\\Core\\Entity\\EntityListBuilder\";s:12:\"view_builder\";s:33:\"Drupal\\comment\\CommentViewBuilder\";s:10:\"views_data\";s:31:\"Drupal\\comment\\CommentViewsData\";s:4:\"form\";a:2:{s:7:\"default\";s:26:\"Drupal\\comment\\CommentForm\";s:6:\"delete\";s:30:\"Drupal\\comment\\Form\\DeleteForm\";}s:11:\"translation\";s:40:\"Drupal\\comment\\CommentTranslationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"canonical\";s:18:\"/comment/{comment}\";s:11:\"delete-form\";s:25:\"/comment/{comment}/delete\";s:9:\"edit-form\";s:23:\"/comment/{comment}/edit\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"comment_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:7:\"comment\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:18:\"comment_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";s:11:\"comment_uri\";s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:29:\"entity.comment_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:12:\"comment_list\";}s:14:\"\0*\0constraints\";a:2:{s:11:\"CommentName\";a:0:{}s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:29:\"Drupal\\comment\\Entity\\Comment\";s:11:\"\0*\0provider\";s:7:\"comment\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','comment.field_storage_definitions','a:23:{s:3:\"cid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Comment ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The comment ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:3:\"cid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The comment UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The comment language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:12:\"comment_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:113;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"comment_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The comment type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:12:\"comment_type\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:3:\"pid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:150;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:7:\"comment\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Parent ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The parent comment ID if this is a reply to a comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:3:\"pid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:9:\"entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:185;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The ID of the entity of which this comment is a reply.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:9:\"entity_id\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:7:\"subject\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:221;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:64;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Subject\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:7:\"subject\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:257;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The user ID of the comment author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:9:\"target_id\";i:0;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:296;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:60;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The comment author\'s name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:333;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The comment author\'s email address.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:8:\"homepage\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:3:\"uri\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:363;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:14:\"field_item:uri\";s:8:\"settings\";a:2:{s:10:\"max_length\";i:255;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Homepage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The comment author\'s home page address.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:8:\"homepage\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:8:\"hostname\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:396;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Hostname\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The comment author\'s hostname.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:8:\"hostname\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;s:22:\"default_value_callback\";s:49:\"Drupal\\comment\\Entity\\Comment::getDefaultHostname\";}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:431;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time that the comment was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:460;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"The time that the comment was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";r:500;s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Publishing status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"A boolean indicating whether the comment is published.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";r:514;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"A boolean indicating the published state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:6:\"thread\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:556;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Thread place\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"The alphadecimal representation of the comment\'s place in a thread, consisting of a base 36 string prefixed by an integer indicating its length.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:6:\"thread\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:11:\"entity_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:589;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The entity type to which this comment is attached.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:11:\"entity_type\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;s:8:\"required\";b:1;}}s:10:\"field_name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:623;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Comment field name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The field name through which this comment was added.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:10:\"field_name\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;s:8:\"required\";b:1;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:657;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:12:\"comment_body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":30:{s:5:\"\0*\0id\";s:20:\"comment.comment_body\";s:13:\"\0*\0field_name\";s:12:\"comment_body\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:20:\"comment.comment_body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"cd2079a4-0599-44e2-9aa7-9b5c7d15991f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"swYoCch_hY8QO5uwr4FURplfnUCUlpPB4idF8WGVCpw\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"text\";}}s:12:\"\0*\0isSyncing\";b:0;}s:13:\"field_comment\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:21:\"comment.field_comment\";s:13:\"\0*\0field_name\";s:13:\"field_comment\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:21:\"comment.field_comment\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"05031807-3ec1-45f3-988c-bf04457938db\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-P-jv6yxmWt8MEfYGHXGHo7C4UjZbqfY3dzAY7Cgr0AQ\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:11:\"field_email\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:19:\"comment.field_email\";s:13:\"\0*\0field_name\";s:11:\"field_email\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:19:\"comment.field_email\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"600ac5dc-843c-41f8-ad7f-ecbdb5c97962\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-OIy9cDCqZSn-HZ_-4y6x49U2Wc3yuiaa6Vk0F5ouDTA\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:12:\"field_rating\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:20:\"comment.field_rating\";s:13:\"\0*\0field_name\";s:12:\"field_rating\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:7:\"\0*\0type\";s:8:\"fivestar\";s:9:\"\0*\0module\";s:8:\"fivestar\";s:11:\"\0*\0settings\";a:1:{s:10:\"voting_tag\";s:4:\"vote\";}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:20:\"comment.field_rating\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"7d2356fb-e305-4c01-9235-b0a94458a78f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:8:\"fivestar\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-J8EV8_fH6oOp4LbDyvn6KNhxLpJ3al_zNgmDNgyPMz4\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}}'),

('entity.definitions.installed','comment_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:21:\"target_entity_type_id\";i:3;s:11:\"description\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"comment_type\";s:11:\"\0*\0provider\";s:7:\"comment\";s:8:\"\0*\0class\";s:33:\"Drupal\\comment\\Entity\\CommentType\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:4:{s:7:\"default\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:3:\"add\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:4:\"edit\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:6:\"delete\";s:41:\"Drupal\\comment\\Form\\CommentTypeDeleteForm\";}s:12:\"list_builder\";s:37:\"Drupal\\comment\\CommentTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer comment types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:53:\"/admin/structure/comment/manage/{comment_type}/delete\";s:9:\"edit-form\";s:46:\"/admin/structure/comment/manage/{comment_type}\";s:8:\"add-form\";s:34:\"/admin/structure/comment/types/add\";s:10:\"collection\";s:30:\"/admin/structure/comment/types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:7:\"comment\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:comment_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_checkout_flow.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:22:\"commerce_checkout_flow\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"plugin\";i:3;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:22:\"commerce_checkout_flow\";s:16:\"\0*\0originalClass\";s:44:\"Drupal\\commerce_checkout\\Entity\\CheckoutFlow\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:48:\"Drupal\\commerce_checkout\\CheckoutFlowListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:46:\"Drupal\\commerce_checkout\\Form\\CheckoutFlowForm\";s:4:\"edit\";s:46:\"Drupal\\commerce_checkout\\Form\\CheckoutFlowForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:33:\"administer commerce_checkout_flow\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:41:\"/admin/commerce/config/checkout-flows/add\";s:9:\"edit-form\";s:69:\"/admin/commerce/config/checkout-flows/manage/{commerce_checkout_flow}\";s:11:\"delete-form\";s:76:\"/admin/commerce/config/checkout-flows/manage/{commerce_checkout_flow}/delete\";s:10:\"collection\";s:37:\"/admin/commerce/config/checkout-flows\";s:10:\"devel-load\";s:54:\"/devel/commerce_checkout_flow/{commerce_checkout_flow}\";s:16:\"devel-definition\";s:65:\"/devel/commerce_checkout_flow/{commerce_checkout_flow}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Checkout flow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Checkout flows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"checkout flow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"checkout flows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:20:\"@count checkout flow\";s:6:\"plural\";s:21:\"@count checkout flows\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:34:\"config:commerce_checkout_flow_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:44:\"Drupal\\commerce_checkout\\Entity\\CheckoutFlow\";s:11:\"\0*\0provider\";s:17:\"commerce_checkout\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_currency.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:17:\"commerce_currency\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:12:\"currencyCode\";i:1;s:4:\"name\";i:2;s:11:\"numericCode\";i:3;s:6:\"symbol\";i:4;s:14:\"fractionDigits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:12:\"currencyCode\";s:5:\"label\";s:4:\"name\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:17:\"commerce_currency\";s:16:\"\0*\0originalClass\";s:37:\"Drupal\\commerce_price\\Entity\\Currency\";s:11:\"\0*\0handlers\";a:6:{s:4:\"form\";a:3:{s:3:\"add\";s:39:\"Drupal\\commerce_price\\Form\\CurrencyForm\";s:4:\"edit\";s:39:\"Drupal\\commerce_price\\Form\\CurrencyForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:49:\"Drupal\\Core\\Entity\\Routing\\AdminHtmlRouteProvider\";}s:12:\"list_builder\";s:41:\"Drupal\\commerce_price\\CurrencyListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:28:\"administer commerce_currency\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:35:\"/admin/commerce/config/currency/add\";s:9:\"edit-form\";s:51:\"/admin/commerce/config/currency/{commerce_currency}\";s:11:\"delete-form\";s:58:\"/admin/commerce/config/currency/{commerce_currency}/delete\";s:10:\"collection\";s:31:\"/admin/commerce/config/currency\";s:10:\"devel-load\";s:44:\"/devel/commerce_currency/{commerce_currency}\";s:16:\"devel-definition\";s:55:\"/devel/commerce_currency/{commerce_currency}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Currency\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Currencies\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"currency\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"currencies\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:15:\"@count currency\";s:6:\"plural\";s:17:\"@count currencies\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:29:\"config:commerce_currency_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:37:\"Drupal\\commerce_price\\Entity\\Currency\";s:11:\"\0*\0provider\";s:14:\"commerce_price\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_log.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:2:\"id\";s:6:\"log_id\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:12:\"commerce_log\";s:16:\"\0*\0originalClass\";s:30:\"Drupal\\commerce_log\\Entity\\Log\";s:11:\"\0*\0handlers\";a:6:{s:6:\"access\";s:50:\"Drupal\\commerce\\EmbeddedEntityAccessControlHandler\";s:12:\"list_builder\";s:34:\"Drupal\\commerce_log\\LogListBuilder\";s:7:\"storage\";s:30:\"Drupal\\commerce_log\\LogStorage\";s:12:\"view_builder\";s:34:\"Drupal\\commerce_log\\LogViewBuilder\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"commerce_log\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Log\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"log\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"logs\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:10:\"@count log\";s:6:\"plural\";s:11:\"@count logs\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:17:\"commerce_log_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:30:\"Drupal\\commerce_log\\Entity\\Log\";s:11:\"\0*\0provider\";s:12:\"commerce_log\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_log.field_storage_definitions','a:9:{s:6:\"log_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:12:\"commerce_log\";s:10:\"field_name\";s:6:\"log_id\";s:11:\"entity_type\";s:12:\"commerce_log\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:12:\"commerce_log\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:12:\"commerce_log\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The user for the log.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:48:\"Drupal\\commerce_log\\Entity\\Log::getCurrentUserId\";s:8:\"provider\";s:12:\"commerce_log\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:12:\"commerce_log\";s:6:\"bundle\";N;}}s:11:\"template_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:103;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Log template ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The log template plugin ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:12:\"commerce_log\";s:10:\"field_name\";s:11:\"template_id\";s:11:\"entity_type\";s:12:\"commerce_log\";s:6:\"bundle\";N;}}s:11:\"category_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:136;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Log category ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The log category plugin ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:12:\"commerce_log\";s:10:\"field_name\";s:11:\"category_id\";s:11:\"entity_type\";s:12:\"commerce_log\";s:6:\"bundle\";N;}}s:16:\"source_entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:169;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Source entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The source entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:12:\"commerce_log\";s:10:\"field_name\";s:16:\"source_entity_id\";s:11:\"entity_type\";s:12:\"commerce_log\";s:6:\"bundle\";N;}}s:18:\"source_entity_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:205;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Source entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The source entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:12:\"commerce_log\";s:10:\"field_name\";s:18:\"source_entity_type\";s:11:\"entity_type\";s:12:\"commerce_log\";s:6:\"bundle\";N;}}s:6:\"params\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:3:\"map\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:238;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:14:\"field_item:map\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Params\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"A serialized array of parameters for the log template.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:12:\"commerce_log\";s:10:\"field_name\";s:6:\"params\";s:11:\"entity_type\";s:12:\"commerce_log\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:268;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The time when the log was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:12:\"commerce_log\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:12:\"commerce_log\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','commerce_order.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:8:\"order_id\";s:5:\"label\";s:12:\"order_number\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:4:\"type\";s:8:\"revision\";s:0:\"\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:14:\"commerce_order\";s:16:\"\0*\0originalClass\";s:34:\"Drupal\\commerce_order\\Entity\\Order\";s:11:\"\0*\0handlers\";a:10:{s:5:\"event\";s:38:\"Drupal\\commerce_order\\Event\\OrderEvent\";s:7:\"storage\";s:34:\"Drupal\\commerce_order\\OrderStorage\";s:6:\"access\";s:47:\"Drupal\\commerce_order\\OrderAccessControlHandler\";s:19:\"permission_provider\";s:45:\"Drupal\\commerce_order\\OrderPermissionProvider\";s:12:\"list_builder\";s:38:\"Drupal\\commerce_order\\OrderListBuilder\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:4:\"form\";a:4:{s:7:\"default\";s:36:\"Drupal\\commerce_order\\Form\\OrderForm\";s:3:\"add\";s:36:\"Drupal\\commerce_order\\Form\\OrderForm\";s:4:\"edit\";s:36:\"Drupal\\commerce_order\\Form\\OrderForm\";s:6:\"delete\";s:42:\"Drupal\\Core\\Entity\\ContentEntityDeleteForm\";}s:14:\"route_provider\";a:2:{s:7:\"default\";s:40:\"Drupal\\commerce_order\\OrderRouteProvider\";s:15:\"delete-multiple\";s:49:\"Drupal\\entity\\Routing\\DeleteMultipleRouteProvider\";}s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:25:\"administer commerce_order\";s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:9:{s:9:\"canonical\";s:39:\"/admin/commerce/orders/{commerce_order}\";s:9:\"edit-form\";s:44:\"/admin/commerce/orders/{commerce_order}/edit\";s:11:\"delete-form\";s:46:\"/admin/commerce/orders/{commerce_order}/delete\";s:20:\"delete-multiple-form\";s:29:\"/admin/commerce/orders/delete\";s:13:\"reassign-form\";s:48:\"/admin/commerce/orders/{commerce_order}/reassign\";s:10:\"collection\";s:22:\"/admin/commerce/orders\";s:10:\"devel-load\";s:38:\"/devel/commerce_order/{commerce_order}\";s:12:\"devel-render\";s:45:\"/devel/commerce_order/{commerce_order}/render\";s:16:\"devel-definition\";s:49:\"/devel/commerce_order/{commerce_order}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:19:\"commerce_order_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Order type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:14:\"commerce_order\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Order\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Orders\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"order\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"orders\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:12:\"@count order\";s:6:\"plural\";s:13:\"@count orders\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:36:\"entity.commerce_order_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:19:\"commerce_order_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:1:{s:9:\"fieldable\";b:1;}s:8:\"\0*\0class\";s:34:\"Drupal\\commerce_order\\Entity\\Order\";s:11:\"\0*\0provider\";s:14:\"commerce_order\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_order.field_storage_definitions','a:26:{s:8:\"order_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:8:\"order_id\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:19:\"commerce_order_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:10:\"Order type\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:12:\"order_number\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:97;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Order number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"The order number displayed to the customer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:12:\"order_number\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:8:\"store_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:143;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:14:\"commerce_store\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Store\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"The store to which the order belongs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:1;s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:8:\"store_id\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:190;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Customer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"The customer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:52:\"Drupal\\commerce_order\\Entity\\Order::getCurrentUserId\";s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"author\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:238;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:1:{s:10:\"max_length\";i:255;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Contact email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"The email address associated with the order.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:10:\"ip_address\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:282;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"IP address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"The IP address of the order.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:10:\"ip_address\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:15:\"billing_profile\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:26:\"entity_reference_revisions\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:18:\"target_revision_id\";a:3:{s:11:\"description\";s:37:\"The revision ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:2:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}s:18:\"target_revision_id\";a:1:{i:0;s:18:\"target_revision_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:330;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:37:\"field_item:entity_reference_revisions\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:7:\"profile\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:8:\"customer\";}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Billing information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Billing profile\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:24:\"commerce_billing_profile\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:15:\"billing_profile\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:11:\"adjustments\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:19:\"commerce_adjustment\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:11:\"description\";s:21:\"The adjustment value.\";s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:385;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:30:\"field_item:commerce_adjustment\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Adjustments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:0;s:11:\"cardinality\";i:-1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:27:\"commerce_adjustment_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:0;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:11:\"adjustments\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:11:\"total_price\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:14:\"commerce_price\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:6:\"number\";a:4:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;}s:13:\"currency_code\";a:3:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:424;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:25:\"field_item:commerce_price\";s:8:\"settings\";a:1:{s:20:\"available_currencies\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Total price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"The total price of the order.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"commerce_order_total_summary\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:0;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:11:\"total_price\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:5:\"state\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"state\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:472;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:state\";s:8:\"settings\";a:3:{s:8:\"workflow\";s:0:\"\";s:17:\"workflow_callback\";a:2:{i:0;s:35:\"\\Drupal\\commerce_order\\Entity\\Order\";i:1;s:13:\"getWorkflowId\";}s:10:\"max_length\";i:255;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"The order state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"state_transition_form\";s:6:\"weight\";i:10;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:5:\"state\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:4:\"data\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:3:\"map\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:518;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:14:\"field_item:map\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Data\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"A serialized array of additional data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:4:\"data\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:548;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"The time when the order was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:576;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The time when the order was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:6:\"placed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:609;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Placed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The time when the order was placed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:6:\"placed\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:9:\"completed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:644;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Completed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time when the order was completed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:9:\"completed\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:11:\"order_items\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:26:\"commerce_order.order_items\";s:13:\"\0*\0field_name\";s:11:\"order_items\";s:14:\"\0*\0entity_type\";s:14:\"commerce_order\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:19:\"commerce_order_item\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:0;s:9:\"\0*\0locked\";b:1;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:26:\"commerce_order.order_items\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"9b482903-ea77-4dd3-a43a-79539bb89fce\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"XXkG3364KELPh2dm7U58qNcPNoUgrvC2zj9LTHF4V5E\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}}s:4:\"cart\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:713;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Yes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"No\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:20;}s:12:\"configurable\";b:1;}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:13:\"commerce_cart\";s:10:\"field_name\";s:4:\"cart\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:13:\"checkout_flow\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:757;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:22:\"commerce_checkout_flow\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Checkout flow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:0;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:0;}}s:8:\"provider\";s:17:\"commerce_checkout\";s:10:\"field_name\";s:13:\"checkout_flow\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:13:\"checkout_step\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:798;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Checkout step\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:0;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:0;}}s:8:\"provider\";s:17:\"commerce_checkout\";s:10:\"field_name\";s:13:\"checkout_step\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:15:\"payment_gateway\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";r:851;s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment gateway\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The payment gateway.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:15:\"payment_gateway\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:24:\"commerce_payment_gateway\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";r:868;s:11:\"description\";r:872;s:8:\"required\";b:0;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:15:\"payment_gateway\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:14:\"payment_method\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";r:909;s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Payment method\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"The payment method.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:14:\"payment_method\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:23:\"commerce_payment_method\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";r:926;s:11:\"description\";r:930;s:8:\"required\";b:0;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:14:\"payment_method\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:7:\"coupons\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:953;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:25:\"commerce_promotion_coupon\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Coupons\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Coupons which have been applied to order.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:4:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:17:\"autocomplete_type\";s:4:\"tags\";s:11:\"placeholder\";s:0:\"\";}}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:7:\"coupons\";s:11:\"entity_type\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:6:\"locked\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1001;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Yes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"No\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Locked\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:10:\"field_name\";s:6:\"locked\";s:11:\"entity_type\";s:14:\"commerce_order\";s:8:\"provider\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:10:\"total_paid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:14:\"commerce_price\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:6:\"number\";a:4:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;}s:13:\"currency_code\";a:3:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1037;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:25:\"field_item:commerce_price\";s:8:\"settings\";a:1:{s:20:\"available_currencies\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Total paid\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The total paid price of the order.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:0;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:10:\"field_name\";s:10:\"total_paid\";s:11:\"entity_type\";s:14:\"commerce_order\";s:8:\"provider\";s:14:\"commerce_order\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}}'),

('entity.definitions.installed','commerce_order_item.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:13:\"order_item_id\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"revision\";s:0:\"\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:19:\"commerce_order_item\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\commerce_order\\Entity\\OrderItem\";s:11:\"\0*\0handlers\";a:7:{s:5:\"event\";s:42:\"Drupal\\commerce_order\\Event\\OrderItemEvent\";s:7:\"storage\";s:38:\"Drupal\\commerce_order\\OrderItemStorage\";s:6:\"access\";s:50:\"Drupal\\commerce\\EmbeddedEntityAccessControlHandler\";s:10:\"views_data\";s:40:\"Drupal\\commerce_order\\OrderItemViewsData\";s:4:\"form\";a:1:{s:7:\"default\";s:36:\"Drupal\\Core\\Entity\\ContentEntityForm\";}s:11:\"inline_form\";s:46:\"Drupal\\commerce_order\\Form\\OrderItemInlineForm\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";s:25:\"administer commerce_order\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:24:\"commerce_order_item_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"order item type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:19:\"commerce_order_item\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Order item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"order item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"order items\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:17:\"@count order item\";s:6:\"plural\";s:18:\"@count order items\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:41:\"entity.commerce_order_item_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"commerce_order_item_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:1:{s:9:\"fieldable\";b:1;}s:8:\"\0*\0class\";s:38:\"Drupal\\commerce_order\\Entity\\OrderItem\";s:11:\"\0*\0provider\";s:14:\"commerce_order\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_order_item.field_storage_definitions','a:15:{s:13:\"order_item_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:13:\"order_item_id\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:24:\"commerce_order_item_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:15:\"order item type\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:8:\"order_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:97;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:14:\"commerce_order\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Order\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The parent order.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:8:\"order_id\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:16:\"purchased_entity\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:133;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:-1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:11:\"placeholder\";s:0:\"\";}}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:16:\"purchased_entity\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:183;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:4:{s:10:\"max_length\";i:512;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;s:13:\"default_value\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The order item title.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:8:\"quantity\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"decimal\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:10;s:5:\"scale\";i:2;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:217;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:decimal\";s:8:\"settings\";a:7:{s:9:\"precision\";i:10;s:5:\"scale\";i:2;s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:8:\"unsigned\";b:1;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Quantity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The number of purchased units.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:6:\"number\";s:6:\"weight\";i:1;}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:8:\"quantity\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:10:\"unit_price\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:14:\"commerce_price\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:6:\"number\";a:4:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;}s:13:\"currency_code\";a:3:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:268;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:25:\"field_item:commerce_price\";s:8:\"settings\";a:1:{s:20:\"available_currencies\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Unit price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The price of a single unit.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:2;}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:10:\"unit_price\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:11:\"adjustments\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:19:\"commerce_adjustment\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:11:\"description\";s:21:\"The adjustment value.\";s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:315;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:30:\"field_item:commerce_adjustment\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Adjustments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:0;s:11:\"cardinality\";i:-1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:0;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:11:\"adjustments\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:11:\"total_price\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:14:\"commerce_price\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:6:\"number\";a:4:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;}s:13:\"currency_code\";a:3:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:353;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:25:\"field_item:commerce_price\";s:8:\"settings\";a:1:{s:20:\"available_currencies\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Total price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The total price of the order item.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:0;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:11:\"total_price\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:4:\"data\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:3:\"map\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:399;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:14:\"field_item:map\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Data\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"A serialized array of additional data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:4:\"data\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:429;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"The time when the order item was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:0;}}s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:468;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The time when the order item was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:14:\"commerce_order\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";N;}}s:21:\"overridden_unit_price\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:497;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Overridden unit price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Whether the unit price is overridden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:10:\"field_name\";s:21:\"overridden_unit_price\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:8:\"provider\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}s:23:\"uses_legacy_adjustments\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:537;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Yes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"No\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Uses legacy adjustments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:23:\"uses_legacy_adjustments\";s:11:\"entity_type\";s:19:\"commerce_order_item\";s:8:\"provider\";s:14:\"commerce_order\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','commerce_order_item_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:24:\"commerce_order_item_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:5:\"label\";i:1;s:2:\"id\";i:2;s:21:\"purchasableEntityType\";i:3;s:9:\"orderType\";i:4;s:6:\"traits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:24:\"commerce_order_item_type\";s:16:\"\0*\0originalClass\";s:42:\"Drupal\\commerce_order\\Entity\\OrderItemType\";s:11:\"\0*\0handlers\";a:6:{s:4:\"form\";a:3:{s:3:\"add\";s:44:\"Drupal\\commerce_order\\Form\\OrderItemTypeForm\";s:4:\"edit\";s:44:\"Drupal\\commerce_order\\Form\\OrderItemTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:12:\"list_builder\";s:46:\"Drupal\\commerce_order\\OrderItemTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:30:\"administer commerce_order_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:43:\"/admin/commerce/config/order-item-types/add\";s:9:\"edit-form\";s:71:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit\";s:11:\"delete-form\";s:73:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/delete\";s:10:\"collection\";s:39:\"/admin/commerce/config/order-item-types\";s:10:\"devel-load\";s:58:\"/devel/commerce_order_item_type/{commerce_order_item_type}\";s:16:\"devel-definition\";s:69:\"/devel/commerce_order_item_type/{commerce_order_item_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:19:\"commerce_order_item\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Order item type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Order item types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"order item type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"order item types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:22:\"@count order item type\";s:6:\"plural\";s:23:\"@count order item types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:36:\"config:commerce_order_item_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:42:\"Drupal\\commerce_order\\Entity\\OrderItemType\";s:11:\"\0*\0provider\";s:14:\"commerce_order\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_order_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:19:\"commerce_order_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:8:{i:0;s:5:\"label\";i:1;s:2:\"id\";i:2;s:8:\"workflow\";i:3;s:6:\"traits\";i:4;s:12:\"refresh_mode\";i:5;s:17:\"refresh_frequency\";i:6;s:11:\"sendReceipt\";i:7;s:10:\"receiptBcc\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:19:\"commerce_order_type\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\commerce_order\\Entity\\OrderType\";s:11:\"\0*\0handlers\";a:6:{s:4:\"form\";a:3:{s:3:\"add\";s:40:\"Drupal\\commerce_order\\Form\\OrderTypeForm\";s:4:\"edit\";s:40:\"Drupal\\commerce_order\\Form\\OrderTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:12:\"list_builder\";s:42:\"Drupal\\commerce_order\\OrderTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:30:\"administer commerce_order_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:38:\"/admin/commerce/config/order-types/add\";s:9:\"edit-form\";s:61:\"/admin/commerce/config/order-types/{commerce_order_type}/edit\";s:11:\"delete-form\";s:63:\"/admin/commerce/config/order-types/{commerce_order_type}/delete\";s:10:\"collection\";s:34:\"/admin/commerce/config/order-types\";s:10:\"devel-load\";s:48:\"/devel/commerce_order_type/{commerce_order_type}\";s:16:\"devel-definition\";s:59:\"/devel/commerce_order_type/{commerce_order_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:14:\"commerce_order\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Order type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Order types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"order type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"order types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:17:\"@count order type\";s:6:\"plural\";s:18:\"@count order types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:commerce_order_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:38:\"Drupal\\commerce_order\\Entity\\OrderType\";s:11:\"\0*\0provider\";s:14:\"commerce_order\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_payment.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:2:\"id\";s:10:\"payment_id\";s:6:\"bundle\";s:4:\"type\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:16:\"commerce_payment\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\commerce_payment\\Entity\\Payment\";s:11:\"\0*\0handlers\";a:9:{s:6:\"access\";s:51:\"Drupal\\commerce_payment\\PaymentAccessControlHandler\";s:12:\"list_builder\";s:42:\"Drupal\\commerce_payment\\PaymentListBuilder\";s:7:\"storage\";s:38:\"Drupal\\commerce_payment\\PaymentStorage\";s:4:\"form\";a:2:{s:9:\"operation\";s:49:\"Drupal\\commerce_payment\\Form\\PaymentOperationForm\";s:6:\"delete\";s:42:\"Drupal\\Core\\Entity\\ContentEntityDeleteForm\";}s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:13:\"bundle_plugin\";s:35:\"Drupal\\commerce\\BundlePluginHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:27:\"administer commerce_payment\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:10:\"collection\";s:48:\"/admin/commerce/orders/{commerce_order}/payments\";s:9:\"canonical\";s:70:\"/admin/commerce/orders/{commerce_order}/payments/commerce_payment/edit\";s:14:\"operation-form\";s:89:\"/admin/commerce/orders/{commerce_order}/payments/{commerce_payment}/operation/{operation}\";s:11:\"delete-form\";s:74:\"/admin/commerce/orders/{commerce_order}/payments/{commerce_payment}/delete\";s:12:\"devel-render\";s:49:\"/devel/commerce_payment/{commerce_payment}/render\";s:16:\"devel-definition\";s:53:\"/devel/commerce_payment/{commerce_payment}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Payment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:16:\"commerce_payment\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Payments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"payments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:14:\"@count payment\";s:6:\"plural\";s:15:\"@count payments\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"commerce_payment_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:2:{s:18:\"bundle_plugin_type\";s:21:\"commerce_payment_type\";s:9:\"fieldable\";b:1;}s:8:\"\0*\0class\";s:38:\"Drupal\\commerce_payment\\Entity\\Payment\";s:11:\"\0*\0provider\";s:16:\"commerce_payment\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_payment.field_storage_definitions','a:17:{s:10:\"payment_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:10:\"payment_id\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:12:\"Payment type\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:15:\"payment_gateway\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:95;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:24:\"commerce_payment_gateway\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment gateway\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The payment gateway.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:15:\"payment_gateway\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:14:\"payment_method\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:131;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:23:\"commerce_payment_method\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Payment method\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"The payment method.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:14:\"payment_method\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:8:\"order_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:167;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:14:\"commerce_order\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Order\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The parent order.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:8:\"order_id\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:9:\"remote_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:203;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The remote payment ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:9:\"remote_id\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:12:\"remote_state\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:241;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Remote State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The remote payment state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:12:\"remote_state\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:6:\"amount\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:14:\"commerce_price\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:6:\"number\";a:4:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;}s:13:\"currency_code\";a:3:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:279;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:25:\"field_item:commerce_price\";s:8:\"settings\";a:1:{s:20:\"available_currencies\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Amount\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"The payment amount.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:6:\"amount\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:15:\"refunded_amount\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:14:\"commerce_price\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:6:\"number\";a:4:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;}s:13:\"currency_code\";a:3:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:321;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:25:\"field_item:commerce_price\";s:8:\"settings\";a:1:{s:20:\"available_currencies\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Refunded amount\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"The refunded payment amount.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:15:\"refunded_amount\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:5:\"state\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"state\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:362;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:state\";s:8:\"settings\";a:3:{s:8:\"workflow\";s:0:\"\";s:17:\"workflow_callback\";a:2:{i:0;s:39:\"\\Drupal\\commerce_payment\\Entity\\Payment\";i:1;s:13:\"getWorkflowId\";}s:10:\"max_length\";i:255;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"The payment state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"list_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:5:\"state\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:4:\"test\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:404;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Test\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Whether this is a test payment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:4:\"test\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:10:\"authorized\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:441;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Authorized\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"The time when the payment was authorized.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:10:\"authorized\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:8:\"captured\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:474;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Captured\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time when the payment was captured.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:8:\"captured\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:20:\"payment_gateway_mode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:507;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Payment gateway mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The payment gateway mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:10:\"field_name\";s:20:\"payment_gateway_mode\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:8:\"provider\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:7:\"expires\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:541;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Expires\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The time when the payment expires.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:10:\"field_name\";s:7:\"expires\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:8:\"provider\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}s:9:\"completed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:574;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Completed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The time when the payment was completed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:10:\"field_name\";s:9:\"completed\";s:11:\"entity_type\";s:16:\"commerce_payment\";s:8:\"provider\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','commerce_payment_gateway.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:24:\"commerce_payment_gateway\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"weight\";i:3;s:6:\"status\";i:4;s:6:\"plugin\";i:5;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:24:\"commerce_payment_gateway\";s:16:\"\0*\0originalClass\";s:45:\"Drupal\\commerce_payment\\Entity\\PaymentGateway\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:49:\"Drupal\\commerce_payment\\PaymentGatewayListBuilder\";s:7:\"storage\";s:45:\"Drupal\\commerce_payment\\PaymentGatewayStorage\";s:4:\"form\";a:3:{s:3:\"add\";s:47:\"Drupal\\commerce_payment\\Form\\PaymentGatewayForm\";s:4:\"edit\";s:47:\"Drupal\\commerce_payment\\Form\\PaymentGatewayForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:35:\"administer commerce_payment_gateway\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:43:\"/admin/commerce/config/payment-gateways/add\";s:9:\"edit-form\";s:73:\"/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}\";s:11:\"delete-form\";s:80:\"/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}/delete\";s:10:\"collection\";s:39:\"/admin/commerce/config/payment-gateways\";s:10:\"devel-load\";s:58:\"/devel/commerce_payment_gateway/{commerce_payment_gateway}\";s:16:\"devel-definition\";s:69:\"/devel/commerce_payment_gateway/{commerce_payment_gateway}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment gateway\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Payment gateways\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"payment gateway\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"payment gateways\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:22:\"@count payment gateway\";s:6:\"plural\";s:23:\"@count payment gateways\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:36:\"config:commerce_payment_gateway_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:45:\"Drupal\\commerce_payment\\Entity\\PaymentGateway\";s:11:\"\0*\0provider\";s:16:\"commerce_payment\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_payment_method.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:9:\"method_id\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:4:\"type\";s:8:\"revision\";s:0:\"\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:5:\"owner\";s:3:\"uid\";s:3:\"uid\";s:3:\"uid\";}s:5:\"\0*\0id\";s:23:\"commerce_payment_method\";s:16:\"\0*\0originalClass\";s:44:\"Drupal\\commerce_payment\\Entity\\PaymentMethod\";s:11:\"\0*\0handlers\";a:8:{s:6:\"access\";s:57:\"Drupal\\commerce_payment\\PaymentMethodAccessControlHandler\";s:12:\"list_builder\";s:48:\"Drupal\\commerce_payment\\PaymentMethodListBuilder\";s:7:\"storage\";s:44:\"Drupal\\commerce_payment\\PaymentMethodStorage\";s:4:\"form\";a:2:{s:4:\"edit\";s:50:\"Drupal\\commerce_payment\\Form\\PaymentMethodEditForm\";s:6:\"delete\";s:52:\"Drupal\\commerce_payment\\Form\\PaymentMethodDeleteForm\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:13:\"bundle_plugin\";s:35:\"Drupal\\commerce\\BundlePluginHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:34:\"administer commerce_payment_method\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:7:{s:10:\"collection\";s:28:\"/user/{user}/payment-methods\";s:9:\"canonical\";s:59:\"/user/{user}/payment-methods/{commerce_payment_method}/edit\";s:9:\"edit-form\";s:59:\"/user/{user}/payment-methods/{commerce_payment_method}/edit\";s:11:\"delete-form\";s:61:\"/user/{user}/payment-methods/{commerce_payment_method}/delete\";s:10:\"devel-load\";s:56:\"/devel/commerce_payment_method/{commerce_payment_method}\";s:12:\"devel-render\";s:63:\"/devel/commerce_payment_method/{commerce_payment_method}/render\";s:16:\"devel-definition\";s:67:\"/devel/commerce_payment_method/{commerce_payment_method}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Payment method type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:23:\"commerce_payment_method\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Payment method\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment methods\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"payment method\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"payment methods\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:21:\"@count payment method\";s:6:\"plural\";s:22:\"@count payment methods\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"commerce_payment_method_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:2:{s:18:\"bundle_plugin_type\";s:28:\"commerce_payment_method_type\";s:9:\"fieldable\";b:1;}s:8:\"\0*\0class\";s:44:\"Drupal\\commerce_payment\\Entity\\PaymentMethod\";s:11:\"\0*\0provider\";s:16:\"commerce_payment\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_payment_method.field_storage_definitions','a:18:{s:9:\"method_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:9:\"method_id\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:19:\"Payment method type\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:15:\"payment_gateway\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:95;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:24:\"commerce_payment_gateway\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment gateway\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The payment gateway.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:15:\"payment_gateway\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:131;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Owner\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The payment method owner.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:62:\"Drupal\\commerce_payment\\Entity\\PaymentMethod::getCurrentUserId\";s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"author\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:9:\"remote_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:175;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"The payment method remote ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:9:\"remote_id\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:15:\"billing_profile\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:26:\"entity_reference_revisions\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:18:\"target_revision_id\";a:3:{s:11:\"description\";s:37:\"The revision ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:2:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}s:18:\"target_revision_id\";a:1:{i:0;s:18:\"target_revision_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:213;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:37:\"field_item:entity_reference_revisions\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:7:\"profile\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:8:\"customer\";}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Billing profile\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Billing profile\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}}s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"entity_reference_entity_view\";s:6:\"weight\";i:2;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:15:\"billing_profile\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:8:\"reusable\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:268;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Reusable\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Whether the payment method is reusable.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:8:\"reusable\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:10:\"is_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:313;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"Whether this is the user\'s default payment method.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:10:\"is_default\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:7:\"expires\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:350;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Expires\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The time when the payment method expires. 0 for never.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:1;s:8:\"settings\";a:2:{s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:3:\"n/Y\";}}s:12:\"configurable\";b:1;}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:7:\"expires\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:391;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The time when the payment method was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:419;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"The time when the payment method was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:16:\"commerce_payment\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";N;}}s:9:\"card_type\";O:37:\"Drupal\\commerce\\BundleFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"list_string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:447;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:list_string\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";a:2:{i:0;s:35:\"\\Drupal\\commerce_payment\\CreditCard\";i:1;s:13:\"getTypeLabels\";}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Card type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The credit card type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:10:\"field_name\";s:9:\"card_type\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";s:11:\"credit_card\";}}s:11:\"card_number\";O:37:\"Drupal\\commerce\\BundleFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:482;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Card number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The last few digits of the credit card number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:10:\"field_name\";s:11:\"card_number\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";s:11:\"credit_card\";}}s:14:\"card_exp_month\";O:37:\"Drupal\\commerce\\BundleFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:515;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:4:\"tiny\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:5:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Card expiration month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"The credit card expiration month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:14:\"card_exp_month\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";s:11:\"credit_card\";}}s:13:\"card_exp_year\";O:37:\"Drupal\\commerce\\BundleFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:5:\"small\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:550;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:5:\"small\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:5:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Card expiration year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"The credit card expiration year.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:13:\"card_exp_year\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";s:11:\"credit_card\";}}s:11:\"paypal_mail\";O:37:\"Drupal\\commerce\\BundleFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:585;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"PayPal Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"The email address associated with the PayPal account.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:10:\"field_name\";s:11:\"paypal_mail\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:6:\"bundle\";s:6:\"paypal\";}}s:20:\"payment_gateway_mode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:614;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Payment gateway mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The payment gateway mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:10:\"field_name\";s:20:\"payment_gateway_mode\";s:11:\"entity_type\";s:23:\"commerce_payment_method\";s:8:\"provider\";s:16:\"commerce_payment\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','commerce_product.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:10:\"product_id\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:9:\"published\";s:6:\"status\";s:5:\"owner\";s:3:\"uid\";s:3:\"uid\";s:3:\"uid\";}s:5:\"\0*\0id\";s:16:\"commerce_product\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\commerce_product\\Entity\\Product\";s:11:\"\0*\0handlers\";a:11:{s:5:\"event\";s:42:\"Drupal\\commerce_product\\Event\\ProductEvent\";s:7:\"storage\";s:44:\"Drupal\\commerce\\CommerceContentEntityStorage\";s:6:\"access\";s:42:\"Drupal\\commerce\\EntityAccessControlHandler\";s:19:\"permission_provider\";s:40:\"Drupal\\commerce\\EntityPermissionProvider\";s:12:\"view_builder\";s:42:\"Drupal\\commerce_product\\ProductViewBuilder\";s:12:\"list_builder\";s:42:\"Drupal\\commerce_product\\ProductListBuilder\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:4:\"form\";a:4:{s:7:\"default\";s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";s:3:\"add\";s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";s:4:\"edit\";s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";s:6:\"delete\";s:42:\"Drupal\\Core\\Entity\\ContentEntityDeleteForm\";}s:14:\"route_provider\";a:2:{s:7:\"default\";s:49:\"Drupal\\Core\\Entity\\Routing\\AdminHtmlRouteProvider\";s:15:\"delete-multiple\";s:49:\"Drupal\\entity\\Routing\\DeleteMultipleRouteProvider\";}s:11:\"translation\";s:49:\"Drupal\\commerce_product\\ProductTranslationHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:27:\"administer commerce_product\";s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:10:{s:9:\"canonical\";s:27:\"/product/{commerce_product}\";s:8:\"add-page\";s:12:\"/product/add\";s:8:\"add-form\";s:36:\"/product/add/{commerce_product_type}\";s:9:\"edit-form\";s:32:\"/product/{commerce_product}/edit\";s:11:\"delete-form\";s:34:\"/product/{commerce_product}/delete\";s:20:\"delete-multiple-form\";s:31:\"/admin/commerce/products/delete\";s:10:\"collection\";s:24:\"/admin/commerce/products\";s:10:\"devel-load\";s:42:\"/devel/commerce_product/{commerce_product}\";s:12:\"devel-render\";s:49:\"/devel/commerce_product/{commerce_product}/render\";s:16:\"devel-definition\";s:53:\"/devel/commerce_product/{commerce_product}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:21:\"commerce_product_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Product type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:16:\"commerce_product\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:27:\"commerce_product_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Products\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"products\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:14:\"@count product\";s:6:\"plural\";s:15:\"@count products\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:38:\"entity.commerce_product_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"commerce_product_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:1:{s:9:\"fieldable\";b:1;}s:8:\"\0*\0class\";s:38:\"Drupal\\commerce_product\\Entity\\Product\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_product.field_storage_definitions','a:17:{s:10:\"product_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:10:\"product_id\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}s:12:\"configurable\";b:1;}}s:12:\"translatable\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:103;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:21:\"commerce_product_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:12:\"Product type\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:133;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"The product author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:56:\"Drupal\\commerce_product\\Entity\\Product::getCurrentUserId\";s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:180;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:4:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;s:13:\"default_value\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"The product title.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:227;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:16:\"commerce_product\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:90;}s:12:\"configurable\";b:1;}}}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:271;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:310;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"The time when the product was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:339;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}s:6:\"stores\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:23:\"commerce_product.stores\";s:13:\"\0*\0field_name\";s:6:\"stores\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:14:\"commerce_store\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:0;s:9:\"\0*\0locked\";b:1;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:23:\"commerce_product.stores\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"2517331e-c92f-41f4-8e9a-ea3b113dacb0\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"qzJaXjkjRd_-1CF6EnCb5fpCcA6mnBB34P4qOOQ6n9g\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:14:\"commerce_store\";}}}s:10:\"variations\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:27:\"commerce_product.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:26:\"commerce_product_variation\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:0;s:9:\"\0*\0locked\";b:1;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:27:\"commerce_product.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"a1d7db47-ab38-457a-94ed-f5f7b74052a7\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-sSnK9eimilO8WwVtSpdX2rg9gGrtSKccb6s59G_kBM\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}}s:4:\"body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:21:\"commerce_product.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:7:\"\0*\0type\";s:17:\"text_with_summary\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:21:\"commerce_product.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"d60ff54d-c125-496a-ac21-bc345fe74e9c\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nhYtx4dRhENXHM78QmiysOM5d1H8OLi_837Ukf5Mpb8\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:4:\"text\";}}}s:12:\"field_rating\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:29:\"commerce_product.field_rating\";s:13:\"\0*\0field_name\";s:12:\"field_rating\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:7:\"\0*\0type\";s:8:\"fivestar\";s:9:\"\0*\0module\";s:8:\"fivestar\";s:11:\"\0*\0settings\";a:1:{s:10:\"voting_tag\";s:4:\"vote\";}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:29:\"commerce_product.field_rating\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"0cb161c6-01a2-422d-8fe7-2752d28e35c1\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:8:\"fivestar\";}}s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-ey5cmVt4hAc4xnIJBsWQ4CVEUUbLyhjl4HqqX_I0OeU\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:14:\"field_category\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:31:\"commerce_product.field_category\";s:13:\"\0*\0field_name\";s:14:\"field_category\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:31:\"commerce_product.field_category\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"e47b0e0d-0b8f-42bc-9e7e-dffa4ef07177\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:8:\"taxonomy\";}}s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-8OgcFuiIS6Kn6onNEiJ1TCdmS26oUnTcUKqPb1CBDlg\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:10:\"field_tags\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:27:\"commerce_product.field_tags\";s:13:\"\0*\0field_name\";s:10:\"field_tags\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:27:\"commerce_product.field_tags\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"1bd59879-f65b-48f4-87e1-98a80db1f8ed\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:8:\"taxonomy\";}}s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-gVtpZNzjL0rKLU06SOvGwiiJpygiKdSgZwaZYwNicSI\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:13:\"field_reviews\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:30:\"commerce_product.field_reviews\";s:13:\"\0*\0field_name\";s:13:\"field_reviews\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:7:\"\0*\0type\";s:7:\"comment\";s:9:\"\0*\0module\";s:7:\"comment\";s:11:\"\0*\0settings\";a:1:{s:12:\"comment_type\";s:15:\"default_reviews\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:30:\"commerce_product.field_reviews\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"68d6363e-0bd7-4582-8149-04aabde5cd2e\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:16:\"commerce_product\";}}s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-68jcwvCo95miZY22OTRzHFW8vqh1jpKQan0pxEt04lA\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}}'),

('entity.definitions.installed','commerce_product_attribute.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:26:\"commerce_product_attribute\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:3:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:11:\"elementType\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:26:\"commerce_product_attribute\";s:16:\"\0*\0originalClass\";s:47:\"Drupal\\commerce_product\\Entity\\ProductAttribute\";s:11:\"\0*\0handlers\";a:7:{s:6:\"access\";s:42:\"Drupal\\commerce\\EntityAccessControlHandler\";s:19:\"permission_provider\";s:40:\"Drupal\\commerce\\EntityPermissionProvider\";s:12:\"list_builder\";s:51:\"Drupal\\commerce_product\\ProductAttributeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:49:\"Drupal\\commerce_product\\Form\\ProductAttributeForm\";s:4:\"edit\";s:49:\"Drupal\\commerce_product\\Form\\ProductAttributeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce_product\\Form\\ProductAttributeDeleteForm\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:37:\"administer commerce_product_attribute\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:38:\"/admin/commerce/product-attributes/add\";s:9:\"edit-form\";s:70:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}\";s:11:\"delete-form\";s:77:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/delete\";s:10:\"collection\";s:34:\"/admin/commerce/product-attributes\";s:10:\"devel-load\";s:62:\"/devel/commerce_product_attribute/{commerce_product_attribute}\";s:16:\"devel-definition\";s:73:\"/devel/commerce_product_attribute/{commerce_product_attribute}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:32:\"commerce_product_attribute_value\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Product attribute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Product attributes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"product attribute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"product attributes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:24:\"@count product attribute\";s:6:\"plural\";s:25:\"@count product attributes\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:38:\"config:commerce_product_attribute_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:47:\"Drupal\\commerce_product\\Entity\\ProductAttribute\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_product_attribute_value.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:18:\"attribute_value_id\";s:6:\"bundle\";s:9:\"attribute\";s:5:\"label\";s:4:\"name\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:32:\"commerce_product_attribute_value\";s:16:\"\0*\0originalClass\";s:52:\"Drupal\\commerce_product\\Entity\\ProductAttributeValue\";s:11:\"\0*\0handlers\";a:7:{s:5:\"event\";s:56:\"Drupal\\commerce_product\\Event\\ProductAttributeValueEvent\";s:7:\"storage\";s:52:\"Drupal\\commerce_product\\ProductAttributeValueStorage\";s:6:\"access\";s:50:\"Drupal\\commerce\\EmbeddedEntityAccessControlHandler\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:11:\"translation\";s:52:\"Drupal\\content_translation\\ContentTranslationHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:37:\"administer commerce_product_attribute\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:26:\"commerce_product_attribute\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Product attribute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:32:\"commerce_product_attribute_value\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:43:\"commerce_product_attribute_value_field_data\";s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Product attribute value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"product attribute value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"product attribute values\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:30:\"@count product attribute value\";s:6:\"plural\";s:31:\"@count product attribute values\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:43:\"entity.commerce_product_attribute.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:37:\"commerce_product_attribute_value_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:2:{s:9:\"fieldable\";b:1;s:27:\"content_translation_ui_skip\";b:1;}s:8:\"\0*\0class\";s:52:\"Drupal\\commerce_product\\Entity\\ProductAttributeValue\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_product_attribute_value.field_storage_definitions','a:9:{s:18:\"attribute_value_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:18:\"attribute_value_id\";s:11:\"entity_type\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}s:12:\"configurable\";b:1;}}s:12:\"translatable\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";N;}}s:9:\"attribute\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:103;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:26:\"commerce_product_attribute\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Attribute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:9:\"attribute\";s:11:\"entity_type\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:136;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:4:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;s:13:\"default_value\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The attribute value name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:184;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"The weight of this attribute value in relation to others.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:223;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The time when the attribute value was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:252;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The time when the attribute value was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:281;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','commerce_product_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:21:\"commerce_product_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:11:\"description\";i:3;s:13:\"variationType\";i:4;s:21:\"injectVariationFields\";i:5;s:6:\"traits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:21:\"commerce_product_type\";s:16:\"\0*\0originalClass\";s:42:\"Drupal\\commerce_product\\Entity\\ProductType\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:46:\"Drupal\\commerce_product\\ProductTypeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:44:\"Drupal\\commerce_product\\Form\\ProductTypeForm\";s:4:\"edit\";s:44:\"Drupal\\commerce_product\\Form\\ProductTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:32:\"administer commerce_product_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:40:\"/admin/commerce/config/product-types/add\";s:9:\"edit-form\";s:65:\"/admin/commerce/config/product-types/{commerce_product_type}/edit\";s:11:\"delete-form\";s:67:\"/admin/commerce/config/product-types/{commerce_product_type}/delete\";s:10:\"collection\";s:36:\"/admin/commerce/config/product-types\";s:10:\"devel-load\";s:52:\"/devel/commerce_product_type/{commerce_product_type}\";s:16:\"devel-definition\";s:63:\"/devel/commerce_product_type/{commerce_product_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:16:\"commerce_product\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Product type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Product types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"product type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"product types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count product type\";s:6:\"plural\";s:20:\"@count product types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:33:\"config:commerce_product_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:42:\"Drupal\\commerce_product\\Entity\\ProductType\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_product_variation.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:12:\"variation_id\";s:6:\"bundle\";s:4:\"type\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:5:\"label\";s:5:\"title\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:5:\"owner\";s:3:\"uid\";s:3:\"uid\";s:3:\"uid\";s:9:\"published\";s:6:\"status\";}s:5:\"\0*\0id\";s:26:\"commerce_product_variation\";s:16:\"\0*\0originalClass\";s:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\";s:11:\"\0*\0handlers\";a:8:{s:5:\"event\";s:51:\"Drupal\\commerce_product\\Event\\ProductVariationEvent\";s:7:\"storage\";s:47:\"Drupal\\commerce_product\\ProductVariationStorage\";s:6:\"access\";s:50:\"Drupal\\commerce\\EmbeddedEntityAccessControlHandler\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:4:\"form\";a:1:{s:7:\"default\";s:36:\"Drupal\\Core\\Entity\\ContentEntityForm\";}s:11:\"inline_form\";s:55:\"Drupal\\commerce_product\\Form\\ProductVariationInlineForm\";s:11:\"translation\";s:52:\"Drupal\\content_translation\\ContentTranslationHandler\";}s:19:\"\0*\0admin_permission\";s:27:\"administer commerce_product\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:31:\"commerce_product_variation_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Product variation type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:26:\"commerce_product_variation\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:37:\"commerce_product_variation_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Product variation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Product variations\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"product variation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"product variations\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:24:\"@count product variation\";s:6:\"plural\";s:25:\"@count product variations\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:48:\"entity.commerce_product_variation_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"commerce_product_variation_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:2:{s:9:\"fieldable\";b:1;s:27:\"content_translation_ui_skip\";b:1;}s:8:\"\0*\0class\";s:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_product_variation.field_storage_definitions','a:24:{s:12:\"variation_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:12:\"variation_id\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}s:12:\"configurable\";b:1;}}s:12:\"translatable\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:103;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:31:\"commerce_product_variation_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:22:\"Product variation type\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:133;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The variation author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:65:\"Drupal\\commerce_product\\Entity\\ProductVariation::getCurrentUserId\";s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:10:\"product_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:175;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:16:\"commerce_product\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"The parent product.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:10:\"product_id\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:3:\"sku\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:216;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:4:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;s:19:\"display_description\";b:1;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:56:\"The unique, machine-readable identifier for a variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:11:\"constraints\";a:1:{s:19:\"ProductVariationSku\";N;}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-4;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-4;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:3:\"sku\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:265;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:4:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;s:13:\"default_value\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The variation title.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:5:\"price\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:14:\"commerce_price\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:6:\"number\";a:4:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;}s:13:\"currency_code\";a:3:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:313;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:25:\"field_item:commerce_price\";s:8:\"settings\";a:1:{s:20:\"available_currencies\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"The variation price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:5:\"price\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:361;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:90;}s:12:\"configurable\";b:1;}}}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:405;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The time when the variation was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:439;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"The time when the variation was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:468;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:16:\"commerce_product\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";N;}}s:15:\"field_old_price\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:42:\"commerce_product_variation.field_old_price\";s:13:\"\0*\0field_name\";s:15:\"field_old_price\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:14:\"commerce_price\";s:9:\"\0*\0module\";s:14:\"commerce_price\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:42:\"commerce_product_variation.field_old_price\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"e1660665-8557-4ae6-8a8f-2b8cdd8afdaf\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:14:\"commerce_price\";i:1;s:16:\"commerce_product\";}}s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-5sH256XmnPeO7LLG23mSMaTlf3Aj4BvAyFptAbyeLSM\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:12:\"field_images\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:39:\"commerce_product_variation.field_images\";s:13:\"\0*\0field_name\";s:12:\"field_images\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:39:\"commerce_product_variation.field_images\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"1962e2d5-67e1-43bb-bad5-bb27b2283e68\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:16:\"commerce_product\";i:1;s:4:\"file\";i:2;s:5:\"image\";}}s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-37sTGZ4O625zDDiSerDKG28aYExabT4jugPyuNRLEJk\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:15:\"field_sale_text\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:42:\"commerce_product_variation.field_sale_text\";s:13:\"\0*\0field_name\";s:15:\"field_sale_text\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";s:3:\"255\";s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:42:\"commerce_product_variation.field_sale_text\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"0eaf2b41-5e64-4325-b11e-14e6a1e6def9\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-mmXC-JdkSjYFVEsuSCRx9GXN9B75wo6zzEkdZV-yG38\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:23:\"field_short_description\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:50:\"commerce_product_variation.field_short_description\";s:13:\"\0*\0field_name\";s:23:\"field_short_description\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:50:\"commerce_product_variation.field_short_description\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"339d3c2c-2268-4ee3-ba8e-4214ce301fa1\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-YCEQukjEQMPAOH2Xi-uDYuluTA91HJlgs38vkDlWFAQ\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:17:\"field_description\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:44:\"commerce_product_variation.field_description\";s:13:\"\0*\0field_name\";s:17:\"field_description\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:44:\"commerce_product_variation.field_description\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"1771b593-3ae9-4c1e-bcf6-1eedd3f31d41\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:4:\"text\";}}s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-7jVkcqnOJI8LoOG7KiDvEIhohM7UbZYvRwmmDKbqnHU\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:28:\"field_right_side_description\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:55:\"commerce_product_variation.field_right_side_description\";s:13:\"\0*\0field_name\";s:28:\"field_right_side_description\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:55:\"commerce_product_variation.field_right_side_description\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"24336415-3815-4b60-90ba-438f55938640\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:4:\"text\";}}s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-mRB8UFv5XxS6OLedHHhEreHSLQR3L9gg6DRz1hfDOm8\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:11:\"field_waist\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:38:\"commerce_product_variation.field_waist\";s:13:\"\0*\0field_name\";s:11:\"field_waist\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";s:3:\"255\";s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:38:\"commerce_product_variation.field_waist\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"90b1ad03-45a0-4c75-9927-a11fffa88263\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-IaqSYWTS_J3CHansHvRixfiFVWajMkUYeyQomwlxUBU\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:12:\"field_length\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":34:{s:5:\"\0*\0id\";s:39:\"commerce_product_variation.field_length\";s:13:\"\0*\0field_name\";s:12:\"field_length\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";s:3:\"255\";s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:39:\"commerce_product_variation.field_length\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"fe16587c-28aa-473a-80f1-73f915f8f628\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-aztc4LdxKVG0tvGTkDchRfETkppAnV1BJKn_IG_s3x0\";s:10:\"form_token\";s:43:\"1LXDVudDZycxUvpMvSP-9q2kzsnSb8hYR883siPDPQI\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:15:\"attribute_color\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:42:\"commerce_product_variation.attribute_color\";s:13:\"\0*\0field_name\";s:15:\"attribute_color\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:32:\"commerce_product_attribute_value\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:0;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:42:\"commerce_product_variation.attribute_color\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"710ac2c1-5c31-4b9a-a295-5ca95dcfcf23\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}}s:14:\"attribute_size\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:41:\"commerce_product_variation.attribute_size\";s:13:\"\0*\0field_name\";s:14:\"attribute_size\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:32:\"commerce_product_attribute_value\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:0;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:41:\"commerce_product_variation.attribute_size\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"e71db06f-65dd-474a-b718-e888c96586cc\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:0:{}}s:10:\"list_price\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:14:\"commerce_price\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:6:\"number\";a:4:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;}s:13:\"currency_code\";a:3:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:928;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:25:\"field_item:commerce_price\";s:8:\"settings\";a:1:{s:20:\"available_currencies\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"List price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The list price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:-1;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:19:\"commerce_list_price\";s:6:\"weight\";i:-1;}s:12:\"configurable\";b:1;}}s:10:\"field_name\";s:10:\"list_price\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:8:\"provider\";s:16:\"commerce_product\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','commerce_product_variation_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:31:\"commerce_product_variation_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:13:\"orderItemType\";i:3;s:13:\"generateTitle\";i:4;s:6:\"traits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:31:\"commerce_product_variation_type\";s:16:\"\0*\0originalClass\";s:51:\"Drupal\\commerce_product\\Entity\\ProductVariationType\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:55:\"Drupal\\commerce_product\\ProductVariationTypeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:53:\"Drupal\\commerce_product\\Form\\ProductVariationTypeForm\";s:4:\"edit\";s:53:\"Drupal\\commerce_product\\Form\\ProductVariationTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:32:\"administer commerce_product_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:50:\"/admin/commerce/config/product-variation-types/add\";s:9:\"edit-form\";s:85:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit\";s:11:\"delete-form\";s:87:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/delete\";s:10:\"collection\";s:46:\"/admin/commerce/config/product-variation-types\";s:10:\"devel-load\";s:72:\"/devel/commerce_product_variation_type/{commerce_product_variation_type}\";s:16:\"devel-definition\";s:83:\"/devel/commerce_product_variation_type/{commerce_product_variation_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:26:\"commerce_product_variation\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Product variation type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Product variation types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"product variation type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"product variation types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:29:\"@count product variation type\";s:6:\"plural\";s:30:\"@count product variation types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:43:\"config:commerce_product_variation_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:51:\"Drupal\\commerce_product\\Entity\\ProductVariationType\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_promotion.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:12:\"promotion_id\";s:5:\"label\";s:4:\"name\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:18:\"commerce_promotion\";s:16:\"\0*\0originalClass\";s:42:\"Drupal\\commerce_promotion\\Entity\\Promotion\";s:11:\"\0*\0handlers\";a:11:{s:5:\"event\";s:46:\"Drupal\\commerce_promotion\\Event\\PromotionEvent\";s:7:\"storage\";s:42:\"Drupal\\commerce_promotion\\PromotionStorage\";s:6:\"access\";s:42:\"Drupal\\commerce\\EntityAccessControlHandler\";s:19:\"permission_provider\";s:40:\"Drupal\\commerce\\EntityPermissionProvider\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:12:\"list_builder\";s:46:\"Drupal\\commerce_promotion\\PromotionListBuilder\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:4:\"form\";a:4:{s:7:\"default\";s:44:\"Drupal\\commerce_promotion\\Form\\PromotionForm\";s:3:\"add\";s:44:\"Drupal\\commerce_promotion\\Form\\PromotionForm\";s:4:\"edit\";s:44:\"Drupal\\commerce_promotion\\Form\\PromotionForm\";s:6:\"delete\";s:42:\"Drupal\\Core\\Entity\\ContentEntityDeleteForm\";}s:14:\"route_provider\";a:2:{s:7:\"default\";s:48:\"Drupal\\commerce_promotion\\PromotionRouteProvider\";s:15:\"delete-multiple\";s:49:\"Drupal\\entity\\Routing\\DeleteMultipleRouteProvider\";}s:11:\"translation\";s:52:\"Drupal\\content_translation\\ContentTranslationHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:29:\"administer commerce_promotion\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:9:{s:8:\"add-form\";s:14:\"/promotion/add\";s:9:\"canonical\";s:36:\"/promotion/{commerce_promotion}/edit\";s:9:\"edit-form\";s:36:\"/promotion/{commerce_promotion}/edit\";s:11:\"delete-form\";s:38:\"/promotion/{commerce_promotion}/delete\";s:20:\"delete-multiple-form\";s:33:\"/admin/commerce/promotions/delete\";s:10:\"collection\";s:26:\"/admin/commerce/promotions\";s:10:\"devel-load\";s:46:\"/devel/commerce_promotion/{commerce_promotion}\";s:12:\"devel-render\";s:53:\"/devel/commerce_promotion/{commerce_promotion}/render\";s:16:\"devel-definition\";s:57:\"/devel/commerce_promotion/{commerce_promotion}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:18:\"commerce_promotion\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:29:\"commerce_promotion_field_data\";s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Promotion\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Promotions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"promotion\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"promotions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:16:\"@count promotion\";s:6:\"plural\";s:17:\"@count promotions\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"commerce_promotion_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:9:\"fieldable\";b:1;}s:8:\"\0*\0class\";s:42:\"Drupal\\commerce_promotion\\Entity\\Promotion\";s:11:\"\0*\0provider\";s:18:\"commerce_promotion\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_promotion.field_storage_definitions','a:18:{s:12:\"promotion_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:12:\"promotion_id\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}s:12:\"configurable\";b:1;}}s:12:\"translatable\";b:1;s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:103;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:4:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;s:13:\"default_value\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"The promotion name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:149;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Additional information about the promotion to show to the customer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";i:3;}}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:11:\"order_types\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:195;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:19:\"commerce_order_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Order types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"The order types for which the promotion is valid.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:2;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:11:\"order_types\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:6:\"stores\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:238;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:14:\"commerce_store\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Stores\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"The stores for which the promotion is valid.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:2;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:6:\"stores\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:5:\"offer\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:45:\"commerce_plugin_item:commerce_promotion_offer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:16:\"target_plugin_id\";a:4:{s:11:\"description\";s:14:\"The plugin ID.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:27:\"target_plugin_configuration\";a:4:{s:11:\"description\";s:25:\"The plugin configuration.\";s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:281;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:56:\"field_item:commerce_plugin_item:commerce_promotion_offer\";s:8:\"settings\";a:1:{s:10:\"categories\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:1;s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:22:\"commerce_plugin_radios\";s:6:\"weight\";i:3;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:5:\"offer\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:10:\"conditions\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:49:\"commerce_plugin_item:commerce_promotion_condition\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:16:\"target_plugin_id\";a:4:{s:11:\"description\";s:14:\"The plugin ID.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:27:\"target_plugin_configuration\";a:4:{s:11:\"description\";s:25:\"The plugin configuration.\";s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:321;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:60:\"field_item:commerce_plugin_item:commerce_promotion_condition\";s:8:\"settings\";a:1:{s:10:\"categories\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"required\";b:0;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:22:\"commerce_plugin_select\";s:6:\"weight\";i:3;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:10:\"conditions\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:7:\"coupons\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:361;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:25:\"commerce_promotion_coupon\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Coupons\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Coupons which allow promotion to be redeemed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:3;s:8:\"settings\";a:3:{s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:6:\"coupon\";s:12:\"label_plural\";s:7:\"coupons\";}}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:7:\"coupons\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:11:\"usage_limit\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:408;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Usage limit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:71:\"The maximum number of times the promotion can be used. 0 for unlimited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:20:\"commerce_usage_limit\";s:6:\"weight\";i:4;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:11:\"usage_limit\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:10:\"start_date\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"datetime\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:11:\"description\";s:15:\"The date value.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;}}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:452;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:datetime\";s:8:\"settings\";a:1:{s:13:\"datetime_type\";s:4:\"date\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Start date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"The date the promotion becomes valid.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:22:\"default_value_callback\";s:63:\"Drupal\\commerce_promotion\\Entity\\Promotion::getDefaultStartDate\";s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"datetime_default\";s:6:\"weight\";i:5;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:10:\"start_date\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:8:\"end_date\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"datetime\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:11:\"description\";s:15:\"The date value.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;}}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:492;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:datetime\";s:8:\"settings\";a:1:{s:13:\"datetime_type\";s:4:\"date\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"End date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The date after which the promotion is invalid.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:0;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:17:\"commerce_end_date\";s:6:\"weight\";i:6;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:8:\"end_date\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:13:\"compatibility\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"list_string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:531;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:list_string\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";a:2:{i:0;s:43:\"\\Drupal\\commerce_promotion\\Entity\\Promotion\";i:1;s:23:\"getCompatibilityOptions\";}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Compatibility with other promotions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"any\";}}s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"options_buttons\";s:6:\"weight\";i:4;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:13:\"compatibility\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:571;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Enabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Whether the promotion is enabled.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"options_buttons\";s:6:\"weight\";i:0;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:617;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"The weight of this promotion in relation to others.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:656;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}s:18:\"condition_operator\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"list_string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:698;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:list_string\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:3:\"AND\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"All conditions must pass\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"OR\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Only one condition must pass\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:23:\"allowed_values_function\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Condition operator\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The condition operator.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"options_buttons\";s:6:\"weight\";i:4;}s:12:\"configurable\";b:1;}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"AND\";}}s:10:\"field_name\";s:18:\"condition_operator\";s:11:\"entity_type\";s:18:\"commerce_promotion\";s:8:\"provider\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','commerce_promotion_coupon.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:4:\"code\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:25:\"commerce_promotion_coupon\";s:16:\"\0*\0originalClass\";s:39:\"Drupal\\commerce_promotion\\Entity\\Coupon\";s:11:\"\0*\0handlers\";a:6:{s:7:\"storage\";s:39:\"Drupal\\commerce_promotion\\CouponStorage\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\Core\\Entity\\ContentEntityForm\";s:4:\"edit\";s:36:\"Drupal\\Core\\Entity\\ContentEntityForm\";s:6:\"delete\";s:42:\"Drupal\\Core\\Entity\\ContentEntityDeleteForm\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:29:\"administer commerce_promotion\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:25:\"commerce_promotion_coupon\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Coupon\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"coupon\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"coupons\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:13:\"@count coupon\";s:6:\"plural\";s:14:\"@count coupons\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:30:\"commerce_promotion_coupon_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:39:\"Drupal\\commerce_promotion\\Entity\\Coupon\";s:11:\"\0*\0provider\";s:18:\"commerce_promotion\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_promotion_coupon.field_storage_definitions','a:6:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:25:\"commerce_promotion_coupon\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:25:\"commerce_promotion_coupon\";s:6:\"bundle\";N;}}s:12:\"promotion_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:18:\"commerce_promotion\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Promotion\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The parent promotion.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:7:\"display\";a:1:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:12:\"promotion_id\";s:11:\"entity_type\";s:25:\"commerce_promotion_coupon\";s:6:\"bundle\";N;}}s:4:\"code\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:108;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:4:{s:10:\"max_length\";i:50;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;s:15:\"text_processing\";i:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Coupon code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"The unique, machine-readable identifier for a coupon.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:10:\"CouponCode\";N;}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-4;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-4;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:4:\"code\";s:11:\"entity_type\";s:25:\"commerce_promotion_coupon\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:159;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Enabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Whether the coupon is enabled.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"options_buttons\";s:6:\"weight\";i:0;}}}s:8:\"provider\";s:18:\"commerce_promotion\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:25:\"commerce_promotion_coupon\";s:6:\"bundle\";N;}}s:11:\"usage_limit\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:205;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Usage limit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"The maximum number of times the coupon can be used. 0 for unlimited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:20:\"commerce_usage_limit\";s:6:\"weight\";i:4;}}}s:10:\"field_name\";s:11:\"usage_limit\";s:11:\"entity_type\";s:25:\"commerce_promotion_coupon\";s:8:\"provider\";s:18:\"commerce_promotion\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','commerce_store.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:8:\"store_id\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:4:\"name\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:5:\"owner\";s:3:\"uid\";s:3:\"uid\";s:3:\"uid\";}s:5:\"\0*\0id\";s:14:\"commerce_store\";s:16:\"\0*\0originalClass\";s:34:\"Drupal\\commerce_store\\Entity\\Store\";s:11:\"\0*\0handlers\";a:11:{s:5:\"event\";s:38:\"Drupal\\commerce_store\\Event\\StoreEvent\";s:7:\"storage\";s:34:\"Drupal\\commerce_store\\StoreStorage\";s:6:\"access\";s:42:\"Drupal\\commerce\\EntityAccessControlHandler\";s:19:\"permission_provider\";s:40:\"Drupal\\commerce\\EntityPermissionProvider\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:12:\"list_builder\";s:38:\"Drupal\\commerce_store\\StoreListBuilder\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:4:\"form\";a:4:{s:7:\"default\";s:36:\"Drupal\\commerce_store\\Form\\StoreForm\";s:3:\"add\";s:36:\"Drupal\\commerce_store\\Form\\StoreForm\";s:4:\"edit\";s:36:\"Drupal\\commerce_store\\Form\\StoreForm\";s:6:\"delete\";s:42:\"Drupal\\Core\\Entity\\ContentEntityDeleteForm\";}s:14:\"route_provider\";a:2:{s:7:\"default\";s:49:\"Drupal\\Core\\Entity\\Routing\\AdminHtmlRouteProvider\";s:15:\"delete-multiple\";s:49:\"Drupal\\entity\\Routing\\DeleteMultipleRouteProvider\";}s:11:\"translation\";s:52:\"Drupal\\content_translation\\ContentTranslationHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:25:\"administer commerce_store\";s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:10:{s:9:\"canonical\";s:23:\"/store/{commerce_store}\";s:8:\"add-page\";s:10:\"/store/add\";s:8:\"add-form\";s:32:\"/store/add/{commerce_store_type}\";s:9:\"edit-form\";s:28:\"/store/{commerce_store}/edit\";s:11:\"delete-form\";s:30:\"/store/{commerce_store}/delete\";s:20:\"delete-multiple-form\";s:29:\"/admin/commerce/stores/delete\";s:10:\"collection\";s:22:\"/admin/commerce/stores\";s:10:\"devel-load\";s:38:\"/devel/commerce_store/{commerce_store}\";s:12:\"devel-render\";s:45:\"/devel/commerce_store/{commerce_store}/render\";s:16:\"devel-definition\";s:49:\"/devel/commerce_store/{commerce_store}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:19:\"commerce_store_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Store type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:14:\"commerce_store\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:25:\"commerce_store_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Store\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Stores\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"store\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"stores\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:12:\"@count store\";s:6:\"plural\";s:13:\"@count stores\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:36:\"entity.commerce_store_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:19:\"commerce_store_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:9:\"fieldable\";b:1;}s:8:\"\0*\0class\";s:34:\"Drupal\\commerce_store\\Entity\\Store\";s:11:\"\0*\0provider\";s:14:\"commerce_store\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','commerce_store.field_storage_definitions','a:12:{s:8:\"store_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:8:\"store_id\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}s:12:\"configurable\";b:1;}}s:12:\"translatable\";b:1;s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:103;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:19:\"commerce_store_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The store type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:139;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Owner\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"The store owner.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:52:\"Drupal\\commerce_store\\Entity\\Store::getCurrentUserId\";s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:50;}}}s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:180;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:4:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;s:13:\"default_value\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The store name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:226;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:1:{s:19:\"display_description\";b:1;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Store email notifications are sent from this address.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:13:\"email_default\";s:6:\"weight\";i:1;}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:16:\"default_currency\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:267;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:17:\"commerce_currency\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default currency\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The default currency of the store.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:1;s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:2;}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:16:\"default_currency\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:7:\"address\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"address\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:13:{s:8:\"langcode\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;}s:12:\"country_code\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2;}s:19:\"administrative_area\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:8:\"locality\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:18:\"dependent_locality\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:11:\"postal_code\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:12:\"sorting_code\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:13:\"address_line1\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:13:\"address_line2\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:12:\"organization\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:10:\"given_name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:15:\"additional_name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:11:\"family_name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:315;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:address\";s:8:\"settings\";a:3:{s:19:\"available_countries\";a:0:{}s:6:\"fields\";a:7:{s:19:\"ADMINISTRATIVE_AREA\";s:18:\"administrativeArea\";s:8:\"LOCALITY\";s:8:\"locality\";s:18:\"DEPENDENT_LOCALITY\";s:17:\"dependentLocality\";s:11:\"POSTAL_CODE\";s:10:\"postalCode\";s:12:\"SORTING_CODE\";s:11:\"sortingCode\";s:13:\"ADDRESS_LINE1\";s:12:\"addressLine1\";s:13:\"ADDRESS_LINE2\";s:12:\"addressLine2\";}s:17:\"langcode_override\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"The store address.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:1;s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"address_default\";s:8:\"settings\";a:1:{s:15:\"default_country\";s:12:\"site_default\";}s:6:\"weight\";i:3;}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:7:\"address\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:17:\"billing_countries\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"list_string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:404;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:list_string\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";a:2:{i:0;s:35:\"\\Drupal\\commerce_store\\Entity\\Store\";i:1;s:21:\"getAvailableCountries\";}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Supported billing countries\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:4;}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:17:\"billing_countries\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:446;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:14:\"commerce_store\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}s:4:\"path\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"path\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:488;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:path\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The store URL alias.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;}s:12:\"configurable\";b:1;}}s:14:\"custom_storage\";b:1;s:10:\"field_name\";s:4:\"path\";s:11:\"entity_type\";s:14:\"commerce_store\";s:8:\"provider\";s:14:\"commerce_store\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','commerce_store_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:19:\"commerce_store_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"uuid\";i:3;s:11:\"description\";i:4;s:6:\"traits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:19:\"commerce_store_type\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\commerce_store\\Entity\\StoreType\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:42:\"Drupal\\commerce_store\\StoreTypeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:40:\"Drupal\\commerce_store\\Form\\StoreTypeForm\";s:4:\"edit\";s:40:\"Drupal\\commerce_store\\Form\\StoreTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:30:\"administer commerce_store_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:38:\"/admin/commerce/config/store-types/add\";s:9:\"edit-form\";s:61:\"/admin/commerce/config/store-types/{commerce_store_type}/edit\";s:11:\"delete-form\";s:63:\"/admin/commerce/config/store-types/{commerce_store_type}/delete\";s:10:\"collection\";s:34:\"/admin/commerce/config/store-types\";s:10:\"devel-load\";s:48:\"/devel/commerce_store_type/{commerce_store_type}\";s:16:\"devel-definition\";s:59:\"/devel/commerce_store_type/{commerce_store_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:14:\"commerce_store\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Store type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Store types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"store type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"store types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:17:\"@count store type\";s:6:\"plural\";s:18:\"@count store types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:commerce_store_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:38:\"Drupal\\commerce_store\\Entity\\StoreType\";s:11:\"\0*\0provider\";s:14:\"commerce_store\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','configurable_language.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:6:\"entity\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"weight\";s:6:\"weight\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:21:\"configurable_language\";s:11:\"\0*\0provider\";s:8:\"language\";s:8:\"\0*\0class\";s:43:\"Drupal\\language\\Entity\\ConfigurableLanguage\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:12:\"list_builder\";s:35:\"Drupal\\language\\LanguageListBuilder\";s:6:\"access\";s:44:\"Drupal\\language\\LanguageAccessControlHandler\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\language\\Form\\LanguageAddForm\";s:4:\"edit\";s:37:\"Drupal\\language\\Form\\LanguageEditForm\";s:6:\"delete\";s:39:\"Drupal\\language\\Form\\LanguageDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:20:\"administer languages\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:62:\"/admin/config/regional/language/delete/{configurable_language}\";s:9:\"edit-form\";s:60:\"/admin/config/regional/language/edit/{configurable_language}\";s:10:\"collection\";s:31:\"/admin/config/regional/language\";s:10:\"devel-load\";s:52:\"/devel/configurable_language/{configurable_language}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:33:\"config:configurable_language_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','contact_form.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:4:\"form\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:7:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:10:\"recipients\";i:3;s:5:\"reply\";i:4;s:6:\"weight\";i:5;s:7:\"message\";i:6;s:8:\"redirect\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"contact_form\";s:11:\"\0*\0provider\";s:7:\"contact\";s:8:\"\0*\0class\";s:33:\"Drupal\\contact\\Entity\\ContactForm\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:46:\"Drupal\\contact\\ContactFormAccessControlHandler\";s:12:\"list_builder\";s:37:\"Drupal\\contact\\ContactFormListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:34:\"Drupal\\contact\\ContactFormEditForm\";s:4:\"edit\";s:34:\"Drupal\\contact\\ContactFormEditForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer contact forms\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:53:\"/admin/structure/contact/manage/{contact_form}/delete\";s:9:\"edit-form\";s:46:\"/admin/structure/contact/manage/{contact_form}\";s:10:\"collection\";s:24:\"/admin/structure/contact\";s:9:\"canonical\";s:23:\"/contact/{contact_form}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:15:\"contact_message\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:contact_form_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','contact_message.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":35:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:5:{s:6:\"bundle\";s:12:\"contact_form\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"langcode\";s:8:\"langcode\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:15:\"contact_message\";s:11:\"\0*\0provider\";s:7:\"contact\";s:8:\"\0*\0class\";s:29:\"Drupal\\contact\\Entity\\Message\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:49:\"Drupal\\contact\\ContactMessageAccessControlHandler\";s:7:\"storage\";s:43:\"Drupal\\Core\\Entity\\ContentEntityNullStorage\";s:12:\"view_builder\";s:33:\"Drupal\\contact\\MessageViewBuilder\";s:4:\"form\";a:1:{s:7:\"default\";s:26:\"Drupal\\contact\\MessageForm\";}}s:19:\"\0*\0admin_permission\";s:24:\"administer contact forms\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"contact_form\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Contact message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:29:\"entity.contact_form.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:20:\"contact_message_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','contact_message.field_storage_definitions','a:9:{s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The message UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:28;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The message language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:12:\"contact_form\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:58;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"contact_form\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Form ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The ID of the associated form.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:12:\"contact_form\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:85;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The sender\'s name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"The name of the person that is sending the contact message.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:110;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"The sender\'s email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"The email of the person that is sending the contact message.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:7:\"subject\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:132;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:100;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Subject\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:7:\"subject\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:7:\"message\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:160;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:4:\"rows\";i:12;}}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;s:5:\"label\";s:5:\"above\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:7:\"message\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:4:\"copy\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:194;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Copy\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"Whether to send a copy of the message to the sender.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"copy\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:9:\"recipient\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:224;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Recipient ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"The ID of the recipient user for personal contact messages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:9:\"recipient\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','date_format.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"locked\";i:3;s:7:\"pattern\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"date_format\";s:11:\"\0*\0provider\";s:4:\"core\";s:8:\"\0*\0class\";s:38:\"Drupal\\Core\\Datetime\\Entity\\DateFormat\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:44:\"Drupal\\system\\DateFormatAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\system\\Form\\DateFormatAddForm\";s:4:\"edit\";s:37:\"Drupal\\system\\Form\\DateFormatEditForm\";s:6:\"delete\";s:39:\"Drupal\\system\\Form\\DateFormatDeleteForm\";}s:12:\"list_builder\";s:35:\"Drupal\\system\\DateFormatListBuilder\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"edit-form\";s:61:\"/admin/config/regional/date-time/formats/manage/{date_format}\";s:11:\"delete-form\";s:68:\"/admin/config/regional/date-time/formats/manage/{date_format}/delete\";s:10:\"collection\";s:40:\"/admin/config/regional/date-time/formats\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Date format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:8:\"rendered\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','editor.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:6:\"format\";i:1;s:6:\"editor\";i:2;s:8:\"settings\";i:3;s:12:\"image_upload\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:2:\"id\";s:6:\"format\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:6:\"editor\";s:11:\"\0*\0provider\";s:6:\"editor\";s:8:\"\0*\0class\";s:27:\"Drupal\\editor\\Entity\\Editor\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:40:\"Drupal\\editor\\EditorAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"config:editor_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','embed_button.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:6:\"button\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:5:\"label\";i:1;s:2:\"id\";i:2;s:7:\"type_id\";i:3;s:13:\"type_settings\";i:4;s:9:\"icon_uuid\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"embed_button\";s:11:\"\0*\0provider\";s:5:\"embed\";s:8:\"\0*\0class\";s:31:\"Drupal\\embed\\Entity\\EmbedButton\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:3:{s:3:\"add\";s:33:\"Drupal\\embed\\Form\\EmbedButtonForm\";s:4:\"edit\";s:33:\"Drupal\\embed\\Form\\EmbedButtonForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:12:\"list_builder\";s:35:\"Drupal\\embed\\EmbedButtonListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer embed buttons\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:9:\"edit-form\";s:56:\"/admin/config/content/embed/button/manage/{embed_button}\";s:11:\"delete-form\";s:63:\"/admin/config/content/embed/button/manage/{embed_button}/delete\";s:10:\"collection\";s:27:\"/admin/config/content/embed\";s:10:\"devel-load\";s:34:\"/devel/embed_button/{embed_button}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Embed button\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:embed_button_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','entity_browser.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:7:\"browser\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:9:{i:0;s:4:\"name\";i:1;s:5:\"label\";i:2;s:7:\"display\";i:3;s:21:\"display_configuration\";i:4;s:17:\"selection_display\";i:5;s:31:\"selection_display_configuration\";i:6;s:15:\"widget_selector\";i:7;s:29:\"widget_selector_configuration\";i:8;s:7:\"widgets\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:4:\"name\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:14:\"entity_browser\";s:11:\"\0*\0provider\";s:14:\"entity_browser\";s:8:\"\0*\0class\";s:42:\"Drupal\\entity_browser\\Entity\\EntityBrowser\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:5:{s:4:\"form\";a:2:{s:14:\"entity_browser\";s:44:\"Drupal\\entity_browser\\Form\\EntityBrowserForm\";s:6:\"delete\";s:50:\"Drupal\\entity_browser\\Form\\EntityBrowserDeleteForm\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:12:\"list_builder\";s:58:\"Drupal\\entity_browser\\Controllers\\EntityBrowserListBuilder\";s:6:\"wizard\";a:2:{s:3:\"add\";s:51:\"Drupal\\entity_browser\\Wizard\\EntityBrowserWizardAdd\";s:4:\"edit\";s:48:\"Drupal\\entity_browser\\Wizard\\EntityBrowserWizard\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:26:\"administer entity browsers\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:9:\"canonical\";s:58:\"/admin/config/content/entity_browser/{machine_name}/{step}\";s:10:\"collection\";s:36:\"/admin/config/content/entity_browser\";s:9:\"edit-form\";s:58:\"/admin/config/content/entity_browser/{machine_name}/{step}\";s:11:\"delete-form\";s:60:\"/admin/config/content/entity_browser/{entity_browser}/delete\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:26:\"config:entity_browser_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','entity_embed_fake_entity.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:5:{s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:24:\"entity_embed_fake_entity\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:3:{s:7:\"storage\";s:43:\"Drupal\\Core\\Entity\\ContentEntityNullStorage\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Fake entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";N;s:14:\"\0*\0group_label\";N;s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:29:\"entity_embed_fake_entity_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";N;s:11:\"\0*\0provider\";N;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','entity_form_display.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:4:\"mode\";i:4;s:7:\"content\";i:5;s:6:\"hidden\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"entity_form_display\";s:11:\"\0*\0provider\";s:4:\"core\";s:8:\"\0*\0class\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:entity_form_display_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','entity_form_mode.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:16:\"targetEntityType\";i:3;s:5:\"cache\";}s:21:\"\0*\0mergedConfigExport\";a:10:{s:4:\"uuid\";s:4:\"uuid\";s:8:\"langcode\";s:8:\"langcode\";s:6:\"status\";s:6:\"status\";s:12:\"dependencies\";s:12:\"dependencies\";s:20:\"third_party_settings\";s:20:\"third_party_settings\";s:5:\"_core\";s:5:\"_core\";s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:16:\"targetEntityType\";s:16:\"targetEntityType\";s:5:\"cache\";s:5:\"cache\";}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:16:\"entity_form_mode\";s:11:\"\0*\0provider\";s:4:\"core\";s:8:\"\0*\0class\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityFormMode\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:entity_form_mode_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','entity_view_display.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:4:\"mode\";i:4;s:7:\"content\";i:5;s:6:\"hidden\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"entity_view_display\";s:11:\"\0*\0provider\";s:4:\"core\";s:8:\"\0*\0class\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity view display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:entity_view_display_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','entity_view_mode.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:16:\"targetEntityType\";i:3;s:5:\"cache\";}s:21:\"\0*\0mergedConfigExport\";a:10:{s:4:\"uuid\";s:4:\"uuid\";s:8:\"langcode\";s:8:\"langcode\";s:6:\"status\";s:6:\"status\";s:12:\"dependencies\";s:12:\"dependencies\";s:20:\"third_party_settings\";s:20:\"third_party_settings\";s:5:\"_core\";s:5:\"_core\";s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:16:\"targetEntityType\";s:16:\"targetEntityType\";s:5:\"cache\";s:5:\"cache\";}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:16:\"entity_view_mode\";s:11:\"\0*\0provider\";s:4:\"core\";s:8:\"\0*\0class\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityViewMode\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:entity_view_mode_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','field_config.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:5:\"field\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:6:\"bundle\";i:4;s:5:\"label\";i:5;s:11:\"description\";i:6;s:8:\"required\";i:7;s:12:\"translatable\";i:8;s:13:\"default_value\";i:9;s:22:\"default_value_callback\";i:10;s:8:\"settings\";i:11;s:10:\"field_type\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"field_config\";s:11:\"\0*\0provider\";s:5:\"field\";s:8:\"\0*\0class\";s:31:\"Drupal\\field\\Entity\\FieldConfig\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:44:\"Drupal\\field\\FieldConfigAccessControlHandler\";s:7:\"storage\";s:31:\"Drupal\\field\\FieldConfigStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:field_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','field_storage_config.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:7:\"storage\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:4:\"type\";i:4;s:8:\"settings\";i:5;s:6:\"module\";i:6;s:6:\"locked\";i:7;s:11:\"cardinality\";i:8;s:12:\"translatable\";i:9;s:7:\"indexes\";i:10;s:22:\"persist_with_no_fields\";i:11;s:14:\"custom_storage\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:20:\"field_storage_config\";s:11:\"\0*\0provider\";s:5:\"field\";s:8:\"\0*\0class\";s:38:\"Drupal\\field\\Entity\\FieldStorageConfig\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:7:\"storage\";s:38:\"Drupal\\field\\FieldStorageConfigStorage\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Field storage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:32:\"config:field_storage_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','file.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:5:\"owner\";s:3:\"uid\";}s:5:\"\0*\0id\";s:4:\"file\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:23:\"Drupal\\file\\FileStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\file\\FileStorageSchema\";s:6:\"access\";s:36:\"Drupal\\file\\FileAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\file\\FileViewsData\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"file_managed\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"file_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0provider\";s:4:\"file\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','file.field_storage_definitions','a:11:{s:3:\"fid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"File ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The file ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:3:\"fid\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The file UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The file language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:112;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"The user ID of the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"filename\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:147;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Filename\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Name of the file with no path components.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"filename\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:3:\"uri\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:3:\"uri\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:180;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:14:\"field_item:uri\";s:8:\"settings\";a:2:{s:10:\"max_length\";i:255;s:14:\"case_sensitive\";b:1;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The URI to access the file (either local or remote).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:13:\"FileUriUnique\";N;}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:3:\"uri\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"filemime\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:214;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"File MIME type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The file\'s MIME type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"filemime\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"filesize\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:247;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:3:\"big\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"File size\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The size of the file in bytes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"filesize\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:283;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:63:\"The status of the file, temporary (FALSE) and permanent (TRUE).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:323;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The timestamp that the file was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:351;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The timestamp that the file was last changed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','filter_format.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:6:\"format\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:4:\"name\";i:1;s:6:\"format\";i:2;s:6:\"weight\";i:3;s:5:\"roles\";i:4;s:7:\"filters\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:6:\"format\";s:5:\"label\";s:4:\"name\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:13:\"filter_format\";s:11:\"\0*\0provider\";s:6:\"filter\";s:8:\"\0*\0class\";s:33:\"Drupal\\filter\\Entity\\FilterFormat\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:3:{s:3:\"add\";s:33:\"Drupal\\filter\\FilterFormatAddForm\";s:4:\"edit\";s:34:\"Drupal\\filter\\FilterFormatEditForm\";s:7:\"disable\";s:36:\"Drupal\\filter\\Form\\FilterDisableForm\";}s:12:\"list_builder\";s:37:\"Drupal\\filter\\FilterFormatListBuilder\";s:6:\"access\";s:46:\"Drupal\\filter\\FilterFormatAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:18:\"administer filters\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:2:{s:9:\"edit-form\";s:52:\"/admin/config/content/formats/manage/{filter_format}\";s:7:\"disable\";s:60:\"/admin/config/content/formats/manage/{filter_format}/disable\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:25:\"config:filter_format_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','image_style.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:5:\"style\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:3:{i:0;s:4:\"name\";i:1;s:5:\"label\";i:2;s:7:\"effects\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:4:\"name\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"image_style\";s:11:\"\0*\0provider\";s:5:\"image\";s:8:\"\0*\0class\";s:30:\"Drupal\\image\\Entity\\ImageStyle\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:4:{s:3:\"add\";s:35:\"Drupal\\image\\Form\\ImageStyleAddForm\";s:4:\"edit\";s:36:\"Drupal\\image\\Form\\ImageStyleEditForm\";s:6:\"delete\";s:38:\"Drupal\\image\\Form\\ImageStyleDeleteForm\";s:5:\"flush\";s:37:\"Drupal\\image\\Form\\ImageStyleFlushForm\";}s:12:\"list_builder\";s:34:\"Drupal\\image\\ImageStyleListBuilder\";s:7:\"storage\";s:30:\"Drupal\\image\\ImageStyleStorage\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";}s:19:\"\0*\0admin_permission\";s:23:\"administer image styles\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:10:\"flush-form\";s:59:\"/admin/config/media/image-styles/manage/{image_style}/flush\";s:9:\"edit-form\";s:53:\"/admin/config/media/image-styles/manage/{image_style}\";s:11:\"delete-form\";s:60:\"/admin/config/media/image-styles/manage/{image_style}/delete\";s:10:\"collection\";s:32:\"/admin/config/media/image-styles\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:image_style_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','language_content_settings.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:16:\"content_settings\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:25:\"language_content_settings\";s:11:\"\0*\0provider\";s:8:\"language\";s:8:\"\0*\0class\";s:46:\"Drupal\\language\\Entity\\ContentLanguageSettings\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:20:\"administer languages\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Content Language Settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:8:\"rendered\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','menu.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:11:\"description\";i:3;s:6:\"locked\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"menu\";s:11:\"\0*\0provider\";s:6:\"system\";s:8:\"\0*\0class\";s:25:\"Drupal\\system\\Entity\\Menu\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:38:\"Drupal\\system\\MenuAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:15:\"administer menu\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:menu_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','menu_link_content.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:4:{s:16:\"revision_default\";s:16:\"revision_default\";s:13:\"revision_user\";s:13:\"revision_user\";s:16:\"revision_created\";s:16:\"revision_created\";s:20:\"revision_log_message\";s:20:\"revision_log_message\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:6:\"bundle\";s:8:\"revision\";s:11:\"revision_id\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:9:\"published\";s:7:\"enabled\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:17:\"menu_link_content\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:14:\"storage_schema\";s:53:\"Drupal\\menu_link_content\\MenuLinkContentStorageSchema\";s:6:\"access\";s:60:\"Drupal\\menu_link_content\\MenuLinkContentAccessControlHandler\";s:4:\"form\";a:2:{s:7:\"default\";s:49:\"Drupal\\menu_link_content\\Form\\MenuLinkContentForm\";s:6:\"delete\";s:55:\"Drupal\\menu_link_content\\Form\\MenuLinkContentDeleteForm\";}s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";s:15:\"administer menu\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"canonical\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:9:\"edit-form\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:11:\"delete-form\";s:53:\"/admin/structure/menu/item/{menu_link_content}/delete\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:17:\"menu_link_content\";s:22:\"\0*\0revision_data_table\";s:32:\"menu_link_content_field_revision\";s:17:\"\0*\0revision_table\";s:26:\"menu_link_content_revision\";s:13:\"\0*\0data_table\";s:22:\"menu_link_content_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:22:\"menu_link_content_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\";s:11:\"\0*\0provider\";s:17:\"menu_link_content\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','menu_link_content.field_storage_definitions','a:22:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"The entity ID for this menu link content entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The content menu link UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"The menu link language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:6:\"bundle\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:114;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";s:0:\"\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"The content menu link bundle.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"bundle\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:146;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Menu link title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The text to be used for this link in the menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:193;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Shown when hovering over the menu link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:9:\"menu_name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:238;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Menu name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:93:\"The menu name. All links with the same menu name (such as \"tools\") are part of the same menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"tools\";}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:9:\"menu_name\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"link\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:3:{s:3:\"uri\";a:3:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;}s:5:\"title\";a:3:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:7:\"options\";a:4:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:1:{s:3:\"uri\";a:1:{i:0;a:2:{i:0;s:3:\"uri\";i:1;i:30;}}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:274;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:link\";s:8:\"settings\";a:2:{s:5:\"title\";i:0;s:9:\"link_type\";i:17;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The location this menu link points to.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:12:\"link_default\";s:6:\"weight\";i:-2;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"link\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:8:\"external\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:326;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"External\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:120:\"A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"external\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:10:\"rediscover\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:367;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"Indicates whether the menu link should be rediscovered\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:10:\"rediscover\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:403;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:172:\"Link weight among links in the same menu at the same depth. In the menu, the links with high weight will sink and links with a low weight will be positioned nearer the top.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"integer\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:6:\"number\";s:6:\"weight\";i:20;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"expanded\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:452;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Show as expanded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:82:\"If selected and this menu link has children, the menu will always appear expanded.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"expanded\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"enabled\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:503;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Enabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:65:\"A flag for whether the link should be enabled in menus or hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:-1;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"enabled\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:555;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Parent plugin ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"The ID of the parent menu link plugin, or empty string when at the top level of the hierarchy.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:588;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"The time that the menu link was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:618;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:11:\"revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:660;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:10:\"field_name\";s:11:\"revision_id\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:13:\"initial_value\";N;}}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:693;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:8:\"internal\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:13:\"initial_value\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:734;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"initial_value\";N;}}s:16:\"revision_created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:774;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:10:\"field_name\";s:16:\"revision_created\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"initial_value\";N;}}s:13:\"revision_user\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:803;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:10:\"field_name\";s:13:\"revision_user\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"initial_value\";N;}}s:20:\"revision_log_message\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:839;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:10:\"field_name\";s:20:\"revision_log_message\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Briefly describe the changes you have made.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:13:\"initial_value\";N;}}}'),

('entity.definitions.installed','node.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:4:{s:16:\"revision_default\";s:16:\"revision_default\";s:13:\"revision_user\";s:12:\"revision_uid\";s:16:\"revision_created\";s:18:\"revision_timestamp\";s:20:\"revision_log_message\";s:12:\"revision_log\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:12:{s:2:\"id\";s:3:\"nid\";s:8:\"revision\";s:3:\"vid\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"status\";s:6:\"status\";s:3:\"uid\";s:3:\"uid\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:9:\"published\";s:6:\"status\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:5:\"owner\";s:3:\"uid\";}s:5:\"\0*\0id\";s:4:\"node\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:9:{s:7:\"storage\";s:23:\"Drupal\\node\\NodeStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\node\\NodeStorageSchema\";s:12:\"view_builder\";s:27:\"Drupal\\node\\NodeViewBuilder\";s:6:\"access\";s:36:\"Drupal\\node\\NodeAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\node\\NodeViewsData\";s:4:\"form\";a:3:{s:7:\"default\";s:20:\"Drupal\\node\\NodeForm\";s:6:\"delete\";s:31:\"Drupal\\node\\Form\\NodeDeleteForm\";s:4:\"edit\";s:20:\"Drupal\\node\\NodeForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:36:\"Drupal\\node\\Entity\\NodeRouteProvider\";}s:12:\"list_builder\";s:27:\"Drupal\\node\\NodeListBuilder\";s:11:\"translation\";s:34:\"Drupal\\node\\NodeTranslationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:5:{s:9:\"canonical\";s:12:\"/node/{node}\";s:11:\"delete-form\";s:19:\"/node/{node}/delete\";s:9:\"edit-form\";s:17:\"/node/{node}/edit\";s:15:\"version-history\";s:22:\"/node/{node}/revisions\";s:8:\"revision\";s:43:\"/node/{node}/revisions/{node_revision}/view\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:9:\"node_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:4:\"node\";s:22:\"\0*\0revision_data_table\";s:19:\"node_field_revision\";s:17:\"\0*\0revision_table\";s:13:\"node_revision\";s:13:\"\0*\0data_table\";s:15:\"node_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"content item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"content items\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count content item\";s:6:\"plural\";s:20:\"@count content items\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:26:\"entity.node_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:1:{i:0;s:21:\"user.node_grants:view\";}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"node_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\node\\Entity\\Node\";s:11:\"\0*\0provider\";s:4:\"node\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','node.field_storage_definitions','a:36:{s:3:\"nid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:3:\"nid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:3:\"vid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:3:\"vid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:100;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:135;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:9:\"node_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:12:\"Content type\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:165;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:208;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Authored by\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The username of the content author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:22:\"default_value_callback\";s:41:\"Drupal\\node\\Entity\\Node::getCurrentUserId\";s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"author\";s:6:\"weight\";i:0;}}s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:11:\"placeholder\";s:0:\"\";}}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:261;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Publishing status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"A boolean indicating whether the node is published.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:303;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Authored on\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The time that the node was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:0;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:344;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the node was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:7:\"promote\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:374;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Promoted to front page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:6:\"sticky\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:420;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Sticky at top of lists\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:6:\"sticky\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:18:\"revision_timestamp\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:466;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Revision timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"queryable\";b:0;s:12:\"revisionable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:18:\"revision_timestamp\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:12:\"revision_uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:496;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Revision user ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"queryable\";b:0;s:12:\"revisionable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:12:\"revision_uid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:12:\"revision_log\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:533;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Briefly describe the changes you have made.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:25;s:8:\"settings\";a:1:{s:4:\"rows\";i:4;}}}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:12:\"revision_log\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:574;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:614;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:4:\"body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":30:{s:5:\"\0*\0id\";s:9:\"node.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:17:\"text_with_summary\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:9:\"node.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"17ff9d2a-51f7-478e-a18c-586dc327f14c\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EBUo7qOWqaiZaQ_RC9sLY5IoDKphS34v77VIHSACmVY\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}s:12:\"\0*\0isSyncing\";b:0;}s:11:\"field_image\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":30:{s:5:\"\0*\0id\";s:16:\"node.field_image\";s:13:\"\0*\0field_name\";s:11:\"field_image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:16:\"node.field_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"4f7121a5-c189-4d77-8e92-7df6031e7fb5\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SkXIPKZYiIMMtnBmfnxk58RYfbZ8cHSw5NZPY_JByME\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:12:\"\0*\0isSyncing\";b:0;}s:7:\"comment\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":30:{s:5:\"\0*\0id\";s:12:\"node.comment\";s:13:\"\0*\0field_name\";s:7:\"comment\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"comment\";s:9:\"\0*\0module\";s:7:\"comment\";s:11:\"\0*\0settings\";a:1:{s:12:\"comment_type\";s:7:\"comment\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:12:\"node.comment\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"66ba7bdb-1bbc-4a11-b1e3-87e7e24f6978\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ktCna9xmWvYZIUfOCUyDQvedn5RtnS4CRmEIwNmvYjc\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:12:\"\0*\0isSyncing\";b:0;}s:10:\"field_tags\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":30:{s:5:\"\0*\0id\";s:15:\"node.field_tags\";s:13:\"\0*\0field_name\";s:10:\"field_tags\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:15:\"node.field_tags\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"92f7e7e0-5ca9-4e8d-b819-cd04c43e2276\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WpOE_bs8Bs_HY2ns7n2r__de-xno0-Bxkqep5-MsHAs\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:12:\"\0*\0isSyncing\";b:0;}s:18:\"field_second_title\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:23:\"node.field_second_title\";s:13:\"\0*\0field_name\";s:18:\"field_second_title\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";s:3:\"255\";s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:23:\"node.field_second_title\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"c8ac51e0-50db-4e83-842e-db0356890fe0\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-4DupU5z0l-PfUAL0PXN_5nNCp9aecAS_AvYXIHs5jTU\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:15:\"field_lead_text\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:20:\"node.field_lead_text\";s:13:\"\0*\0field_name\";s:15:\"field_lead_text\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:20:\"node.field_lead_text\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"563c1246-b560-45a7-b8c4-79613c5b1d6c\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-vAJtC7VBJISnDe3lD2rpJmDd5n24il5uCF5yMjhGeiA\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:12:\"field_images\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:17:\"node.field_images\";s:13:\"\0*\0field_name\";s:12:\"field_images\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:17:\"node.field_images\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"bdf0cdf5-31b9-45d6-8c39-a6ad4cbd8738\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-R9WGFPz_j1cLw9zYc7DI11OVydi-a_UJ1rm4YQxzUB0\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:19:\"field_blog_category\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:24:\"node.field_blog_category\";s:13:\"\0*\0field_name\";s:19:\"field_blog_category\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:24:\"node.field_blog_category\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"4e2b8db9-b4b7-408c-93a7-fb453f56750b\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-qMBE2LL0rlnAUs9gupu87hTNIxh2wW4MDVfWuaidubg\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:14:\"field_comments\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:19:\"node.field_comments\";s:13:\"\0*\0field_name\";s:14:\"field_comments\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"comment\";s:9:\"\0*\0module\";s:7:\"comment\";s:11:\"\0*\0settings\";a:1:{s:12:\"comment_type\";s:7:\"comment\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:19:\"node.field_comments\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"db889761-dd45-468e-9e1b-6bb7c7ca6da9\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-nm0_hczosbD_83UOkuYiyyqjsAqA2g0qt-gesJn2Cl4\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:17:\"field_description\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:22:\"node.field_description\";s:13:\"\0*\0field_name\";s:17:\"field_description\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:22:\"node.field_description\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"9d747b94-edd6-42ea-81de-fbc5e01f6fde\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-bcZQi_Wm3y28SHTBx1HHfe4wcXlAcexJt_WPSNhUjYc\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:18:\"field_project_link\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:23:\"node.field_project_link\";s:13:\"\0*\0field_name\";s:18:\"field_project_link\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0module\";s:4:\"link\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:23:\"node.field_project_link\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"665271a2-3053-498b-9480-a75c293fa985\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"link\";i:1;s:4:\"node\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-wND3D4GMoshe2x3NK-XrYYA-ZoGt7YM86g-O9yjFt-8\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:13:\"field_project\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:18:\"node.field_project\";s:13:\"\0*\0field_name\";s:13:\"field_project\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:18:\"node.field_project\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"a68a7ada-26ea-4cc6-b4f8-8db5efe80994\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-Ms34Uy8giM9bnIOsWMXwXSekhkvLzPPFx1ig4TYUucY\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:14:\"field_category\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:19:\"node.field_category\";s:13:\"\0*\0field_name\";s:14:\"field_category\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:19:\"node.field_category\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"c114c9ee-6504-4d73-afb1-003b600ebe78\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-E_5zhstBRXW2htpbg4NjPqe5NS1pdB-nFpaH1JhFFG8\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:24:\"field_portfolio_category\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:29:\"node.field_portfolio_category\";s:13:\"\0*\0field_name\";s:24:\"field_portfolio_category\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:29:\"node.field_portfolio_category\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"97224b12-1de4-4c7a-8a6b-ff7576712db6\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-8K6whbyEjhV47lxLgNJyY8J3xGkST6CWsTq3t9e8VNM\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:18:\"field_social_links\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:23:\"node.field_social_links\";s:13:\"\0*\0field_name\";s:18:\"field_social_links\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0module\";s:4:\"link\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:23:\"node.field_social_links\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b1311ac1-e885-4933-a31a-9db515095639\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"link\";i:1;s:4:\"node\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-4OZQy53tADijfvAbqit1AyBx9QNIZUo6qwfPf-n9DrY\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:14:\"field_position\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:19:\"node.field_position\";s:13:\"\0*\0field_name\";s:14:\"field_position\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";s:3:\"255\";s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";s:1:\"1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:19:\"node.field_position\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"6951603d-3b79-4da3-a414-d6bb1d1a0431\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";s:1:\"1\";s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-sOTMH00mbKTUz0u3uP_b4BsarL0LCgNl4Oq27ZC7Q60\";s:10:\"form_token\";s:43:\"rNN_WtTkUuCgF3RhVyu7aYl2xizF2SyrqE8iC7Cop1U\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:7:\"webform\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":30:{s:5:\"\0*\0id\";s:12:\"node.webform\";s:13:\"\0*\0field_name\";s:7:\"webform\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"webform\";s:9:\"\0*\0module\";s:7:\"webform\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:7:\"webform\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:12:\"node.webform\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"d18cd2a1-355c-4d4a-94a7-76d7fb01b31a\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8IMrzn49aZMWfnGDoHdXqYfSi8NLmLq9gdblAAL1EZc\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:7:\"webform\";}}s:12:\"\0*\0isSyncing\";b:0;}s:13:\"field_gallery\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":35:{s:5:\"\0*\0id\";s:18:\"node.field_gallery\";s:13:\"\0*\0field_name\";s:13:\"field_gallery\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";s:2:\"-1\";s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:18:\"node.field_gallery\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"7a4c4f30-f6ad-4785-9575-dcf0fb8b5c06\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:12:\"\0*\0isSyncing\";b:0;s:18:\"cardinality_number\";i:1;s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Save field settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"form_build_id\";s:48:\"form-PKlLWg-hLvuU5fRWHcT-yhdaeDLuV65JMtF51KOsvL0\";s:10:\"form_token\";s:43:\"aCoKVrTZmyb0JiQsXJIjwi_FK3T83V9llMISMqaWg8M\";s:7:\"form_id\";s:30:\"field_storage_config_edit_form\";}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1417;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:4:\"node\";s:8:\"provider\";s:4:\"node\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','node_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:7:{i:0;s:4:\"name\";i:1;s:4:\"type\";i:2;s:11:\"description\";i:3;s:4:\"help\";i:4;s:12:\"new_revision\";i:5;s:12:\"preview_mode\";i:6;s:17:\"display_submitted\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"node_type\";s:11:\"\0*\0provider\";s:4:\"node\";s:8:\"\0*\0class\";s:27:\"Drupal\\node\\Entity\\NodeType\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:40:\"Drupal\\node\\NodeTypeAccessControlHandler\";s:4:\"form\";a:3:{s:3:\"add\";s:24:\"Drupal\\node\\NodeTypeForm\";s:4:\"edit\";s:24:\"Drupal\\node\\NodeTypeForm\";s:6:\"delete\";s:38:\"Drupal\\node\\Form\\NodeTypeDeleteConfirm\";}s:12:\"list_builder\";s:31:\"Drupal\\node\\NodeTypeListBuilder\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer content types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"edit-form\";s:41:\"/admin/structure/types/manage/{node_type}\";s:11:\"delete-form\";s:48:\"/admin/structure/types/manage/{node_type}/delete\";s:10:\"collection\";s:22:\"/admin/structure/types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:4:\"node\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:node_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','pathauto_pattern.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:7:\"pattern\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:3:{i:0;s:4:\"type\";i:1;s:6:\"status\";i:2;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:8:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"type\";i:3;s:7:\"pattern\";i:4;s:18:\"selection_criteria\";i:5;s:15:\"selection_logic\";i:6;s:6:\"weight\";i:7;s:13:\"relationships\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:16:\"pathauto_pattern\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\pathauto\\Entity\\PathautoPattern\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:42:\"Drupal\\pathauto\\PathautoPatternListBuilder\";s:4:\"form\";a:4:{s:7:\"default\";s:36:\"Drupal\\pathauto\\Form\\PatternEditForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";s:6:\"enable\";s:38:\"Drupal\\pathauto\\Form\\PatternEnableForm\";s:7:\"disable\";s:39:\"Drupal\\pathauto\\Form\\PatternDisableForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:19:\"administer pathauto\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:10:\"collection\";s:34:\"/admin/config/search/path/patterns\";s:9:\"edit-form\";s:53:\"/admin/config/search/path/patterns/{pathauto_pattern}\";s:11:\"delete-form\";s:60:\"/admin/config/search/path/patterns/{pathauto_pattern}/delete\";s:6:\"enable\";s:60:\"/admin/config/search/path/patterns/{pathauto_pattern}/enable\";s:7:\"disable\";s:61:\"/admin/config/search/path/patterns/{pathauto_pattern}/disable\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Pathauto pattern\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:pathauto_pattern_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:16:\"pathauto_pattern\";}s:8:\"\0*\0class\";s:38:\"Drupal\\pathauto\\Entity\\PathautoPattern\";s:11:\"\0*\0provider\";s:8:\"pathauto\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','profile.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:4:{s:16:\"revision_default\";s:16:\"revision_default\";s:13:\"revision_user\";s:13:\"revision_user\";s:16:\"revision_created\";s:16:\"revision_created\";s:20:\"revision_log_message\";s:20:\"revision_log_message\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:10:\"profile_id\";s:8:\"revision\";s:11:\"revision_id\";s:6:\"bundle\";s:4:\"type\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:3:\"uid\";s:3:\"uid\";s:5:\"owner\";s:3:\"uid\";s:9:\"published\";s:6:\"status\";}s:5:\"\0*\0id\";s:7:\"profile\";s:16:\"\0*\0originalClass\";s:29:\"Drupal\\profile\\Entity\\Profile\";s:11:\"\0*\0handlers\";a:10:{s:7:\"storage\";s:29:\"Drupal\\profile\\ProfileStorage\";s:12:\"view_builder\";s:33:\"Drupal\\profile\\ProfileViewBuilder\";s:10:\"views_data\";s:31:\"Drupal\\profile\\ProfileViewsData\";s:6:\"access\";s:42:\"Drupal\\profile\\ProfileAccessControlHandler\";s:19:\"permission_provider\";s:40:\"Drupal\\profile\\ProfilePermissionProvider\";s:12:\"list_builder\";s:33:\"Drupal\\profile\\ProfileListBuilder\";s:4:\"form\";a:4:{s:7:\"default\";s:31:\"Drupal\\profile\\Form\\ProfileForm\";s:3:\"add\";s:31:\"Drupal\\profile\\Form\\ProfileForm\";s:4:\"edit\";s:31:\"Drupal\\profile\\Form\\ProfileForm\";s:6:\"delete\";s:37:\"Drupal\\profile\\Form\\ProfileDeleteForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";s:14:\"storage_schema\";s:35:\"Drupal\\profile\\ProfileStorageSchema\";}s:19:\"\0*\0admin_permission\";s:18:\"administer profile\";s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:8:{s:9:\"canonical\";s:18:\"/profile/{profile}\";s:9:\"edit-form\";s:23:\"/profile/{profile}/edit\";s:11:\"delete-form\";s:25:\"/profile/{profile}/delete\";s:10:\"collection\";s:29:\"/admin/config/people/profiles\";s:11:\"set-default\";s:30:\"/profile/{profile}/set-default\";s:10:\"devel-load\";s:24:\"/devel/profile/{profile}\";s:12:\"devel-render\";s:31:\"/devel/profile/{profile}/render\";s:16:\"devel-definition\";s:35:\"/devel/profile/{profile}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"profile_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Profile\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:7:\"profile\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";s:16:\"profile_revision\";s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Profile\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:29:\"entity.profile_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:12:\"profile_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:1:{s:9:\"fieldable\";b:1;}s:8:\"\0*\0class\";s:29:\"Drupal\\profile\\Entity\\Profile\";s:11:\"\0*\0provider\";s:7:\"profile\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','profile.field_storage_definitions','a:15:{s:10:\"profile_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:7:\"profile\";s:10:\"field_name\";s:10:\"profile_id\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:7:\"profile\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";N;}}s:11:\"revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:7:\"profile\";s:10:\"field_name\";s:11:\"revision_id\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:100;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"profile_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:7:\"Profile\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:7:\"profile\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:130;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Owner\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"The user that owns this profile.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:7:\"profile\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:166;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Whether the profile is active.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:7:\"profile\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";N;s:12:\"translatable\";b:0;}}s:10:\"is_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:208;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Whether this is the default profile.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:7:\"profile\";s:10:\"field_name\";s:10:\"is_default\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:246;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time when the profile was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:7:\"profile\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:275;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"The time when the profile was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:7:\"profile\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:7:\"profile\";s:6:\"bundle\";N;}}s:7:\"address\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":30:{s:5:\"\0*\0id\";s:15:\"profile.address\";s:13:\"\0*\0field_name\";s:7:\"address\";s:14:\"\0*\0entity_type\";s:7:\"profile\";s:7:\"\0*\0type\";s:7:\"address\";s:9:\"\0*\0module\";s:7:\"address\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:15:\"profile.address\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b1f7f989-c657-4f31-aa01-4d37f63135e3\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Epax3eTdFPMQ3dTymm1zHnwqZ9DmyyHA0F18AMuUKtE\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:14:\"commerce_order\";}}s:6:\"module\";a:2:{i:0;s:7:\"address\";i:1;s:7:\"profile\";}}s:12:\"\0*\0isSyncing\";b:0;}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:343;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:7:\"profile\";s:8:\"provider\";s:7:\"profile\";s:6:\"bundle\";N;}}s:4:\"data\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:3:\"map\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:386;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:14:\"field_item:map\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Data\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"A serialized array of additional data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:10:\"field_name\";s:4:\"data\";s:11:\"entity_type\";s:7:\"profile\";s:8:\"provider\";s:7:\"profile\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:16:\"revision_created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:418;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:10:\"field_name\";s:16:\"revision_created\";s:11:\"entity_type\";s:7:\"profile\";s:8:\"provider\";s:7:\"profile\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:13:\"revision_user\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:448;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:24:\"initial_value_from_field\";s:3:\"uid\";s:13:\"initial_value\";a:0:{}s:12:\"revisionable\";b:1;s:10:\"field_name\";s:13:\"revision_user\";s:11:\"entity_type\";s:7:\"profile\";s:8:\"provider\";s:7:\"profile\";s:6:\"bundle\";N;}}s:20:\"revision_log_message\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:486;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Briefly describe the changes you have made.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:25;s:8:\"settings\";a:1:{s:4:\"rows\";i:4;}}}}s:10:\"field_name\";s:20:\"revision_log_message\";s:11:\"entity_type\";s:7:\"profile\";s:8:\"provider\";s:7:\"profile\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}}'),

('entity.definitions.installed','profile_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:9:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:12:\"registration\";i:3;s:8:\"multiple\";i:4;s:5:\"roles\";i:5;s:6:\"weight\";i:6;s:6:\"status\";i:7;s:8:\"langcode\";i:8;s:13:\"use_revisions\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"profile_type\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\profile\\Entity\\ProfileType\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:37:\"Drupal\\profile\\ProfileTypeListBuilder\";s:4:\"form\";a:4:{s:7:\"default\";s:35:\"Drupal\\profile\\Form\\ProfileTypeForm\";s:3:\"add\";s:35:\"Drupal\\profile\\Form\\ProfileTypeForm\";s:4:\"edit\";s:35:\"Drupal\\profile\\Form\\ProfileTypeForm\";s:6:\"delete\";s:41:\"Drupal\\profile\\Form\\ProfileTypeDeleteForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:24:\"administer profile types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:7:{s:8:\"add-form\";s:39:\"/admin/config/people/profiles/types/add\";s:11:\"delete-form\";s:64:\"/admin/config/people/profiles/types/manage/{profile_type}/delete\";s:9:\"edit-form\";s:57:\"/admin/config/people/profiles/types/manage/{profile_type}\";s:10:\"admin-form\";s:57:\"/admin/config/people/profiles/types/manage/{profile_type}\";s:10:\"collection\";s:35:\"/admin/config/people/profiles/types\";s:10:\"devel-load\";s:34:\"/devel/profile_type/{profile_type}\";s:16:\"devel-definition\";s:45:\"/devel/profile_type/{profile_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:7:\"profile\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Profile type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:profile_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:33:\"Drupal\\profile\\Entity\\ProfileType\";s:11:\"\0*\0provider\";s:7:\"profile\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','rest_resource_config.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:8:\"resource\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:9:\"plugin_id\";i:2;s:11:\"granularity\";i:3;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:20:\"rest_resource_config\";s:11:\"\0*\0provider\";s:4:\"rest\";s:8:\"\0*\0class\";s:37:\"Drupal\\rest\\Entity\\RestResourceConfig\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:25:\"administer rest resources\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";s:18:\"getLabelFromPlugin\";s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"REST resource configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:32:\"config:rest_resource_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','search_page.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:4:\"page\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"path\";i:3;s:6:\"weight\";i:4;s:6:\"plugin\";i:5;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"search_page\";s:11:\"\0*\0provider\";s:6:\"search\";s:8:\"\0*\0class\";s:31:\"Drupal\\search\\Entity\\SearchPage\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:44:\"Drupal\\search\\SearchPageAccessControlHandler\";s:12:\"list_builder\";s:35:\"Drupal\\search\\SearchPageListBuilder\";s:4:\"form\";a:4:{s:3:\"add\";s:36:\"Drupal\\search\\Form\\SearchPageAddForm\";s:4:\"edit\";s:37:\"Drupal\\search\\Form\\SearchPageEditForm\";s:6:\"search\";s:33:\"Drupal\\search\\Form\\SearchPageForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:17:\"administer search\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:9:\"edit-form\";s:47:\"/admin/config/search/pages/manage/{search_page}\";s:11:\"delete-form\";s:54:\"/admin/config/search/pages/manage/{search_page}/delete\";s:6:\"enable\";s:54:\"/admin/config/search/pages/manage/{search_page}/enable\";s:7:\"disable\";s:55:\"/admin/config/search/pages/manage/{search_page}/disable\";s:11:\"set-default\";s:59:\"/admin/config/search/pages/manage/{search_page}/set-default\";s:10:\"collection\";s:26:\"/admin/config/search/pages\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Search page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:search_page_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','shortcut.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":35:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:12:\"shortcut_set\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:8:\"shortcut\";s:11:\"\0*\0provider\";s:8:\"shortcut\";s:8:\"\0*\0class\";s:31:\"Drupal\\shortcut\\Entity\\Shortcut\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:44:\"Drupal\\shortcut\\ShortcutAccessControlHandler\";s:4:\"form\";a:4:{s:7:\"default\";s:28:\"Drupal\\shortcut\\ShortcutForm\";s:3:\"add\";s:28:\"Drupal\\shortcut\\ShortcutForm\";s:4:\"edit\";s:28:\"Drupal\\shortcut\\ShortcutForm\";s:6:\"delete\";s:39:\"Drupal\\shortcut\\Form\\ShortcutDeleteForm\";}s:11:\"translation\";s:52:\"Drupal\\content_translation\\ContentTranslationHandler\";s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"canonical\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";s:11:\"delete-form\";s:60:\"/admin/config/user-interface/shortcut/link/{shortcut}/delete\";s:9:\"edit-form\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"shortcut_set\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:8:\"shortcut\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:19:\"shortcut_field_data\";s:15:\"\0*\0translatable\";b:1;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Shortcut link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:shortcut_set_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','shortcut.field_storage_definitions','a:8:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The ID of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The UUID of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The language code of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:12:\"shortcut_set\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:113;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"shortcut_set\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The bundle of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:12:\"shortcut_set\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:150;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The name of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-10;s:8:\"settings\";a:1:{s:4:\"size\";i:40;}}}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:192;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Weight among shortcuts in the same shortcut set.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:4:\"link\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:3:{s:3:\"uri\";a:3:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;}s:5:\"title\";a:3:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:7:\"options\";a:4:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:1:{s:3:\"uri\";a:1:{i:0;a:2:{i:0;s:3:\"uri\";i:1;i:30;}}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:228;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:link\";s:8:\"settings\";a:2:{s:5:\"title\";i:0;s:9:\"link_type\";i:1;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"The location this shortcut points to.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:12:\"link_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:4:\"link\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:280;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','shortcut_set.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:3:\"set\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:2:{i:0;s:2:\"id\";i:1;s:5:\"label\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"shortcut_set\";s:11:\"\0*\0provider\";s:8:\"shortcut\";s:8:\"\0*\0class\";s:34:\"Drupal\\shortcut\\Entity\\ShortcutSet\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:7:\"storage\";s:34:\"Drupal\\shortcut\\ShortcutSetStorage\";s:6:\"access\";s:47:\"Drupal\\shortcut\\ShortcutSetAccessControlHandler\";s:12:\"list_builder\";s:38:\"Drupal\\shortcut\\ShortcutSetListBuilder\";s:4:\"form\";a:5:{s:7:\"default\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:3:\"add\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:4:\"edit\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:9:\"customize\";s:33:\"Drupal\\shortcut\\Form\\SetCustomize\";s:6:\"delete\";s:42:\"Drupal\\shortcut\\Form\\ShortcutSetDeleteForm\";}}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:14:\"customize-form\";s:69:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/customize\";s:11:\"delete-form\";s:66:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/delete\";s:9:\"edit-form\";s:59:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}\";s:10:\"collection\";s:37:\"/admin/config/user-interface/shortcut\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:8:\"shortcut\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:shortcut_set_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','taxonomy_term.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:4:{s:16:\"revision_default\";s:16:\"revision_default\";s:13:\"revision_user\";s:13:\"revision_user\";s:16:\"revision_created\";s:16:\"revision_created\";s:20:\"revision_log_message\";s:20:\"revision_log_message\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:3:\"tid\";s:6:\"bundle\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:11:\"revision_id\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:9:\"published\";s:6:\"status\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:13:\"taxonomy_term\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:7:{s:7:\"storage\";s:27:\"Drupal\\taxonomy\\TermStorage\";s:14:\"storage_schema\";s:33:\"Drupal\\taxonomy\\TermStorageSchema\";s:12:\"view_builder\";s:31:\"Drupal\\taxonomy\\TermViewBuilder\";s:6:\"access\";s:40:\"Drupal\\taxonomy\\TermAccessControlHandler\";s:10:\"views_data\";s:29:\"Drupal\\taxonomy\\TermViewsData\";s:4:\"form\";a:2:{s:7:\"default\";s:24:\"Drupal\\taxonomy\\TermForm\";s:6:\"delete\";s:35:\"Drupal\\taxonomy\\Form\\TermDeleteForm\";}s:11:\"translation\";s:38:\"Drupal\\taxonomy\\TermTranslationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:3:{s:9:\"canonical\";s:30:\"/taxonomy/term/{taxonomy_term}\";s:11:\"delete-form\";s:37:\"/taxonomy/term/{taxonomy_term}/delete\";s:9:\"edit-form\";s:35:\"/taxonomy/term/{taxonomy_term}/edit\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:19:\"taxonomy_vocabulary\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:18:\"taxonomy_term_data\";s:22:\"\0*\0revision_data_table\";s:28:\"taxonomy_term_field_revision\";s:17:\"\0*\0revision_table\";s:22:\"taxonomy_term_revision\";s:13:\"\0*\0data_table\";s:24:\"taxonomy_term_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";s:17:\"taxonomy_term_uri\";s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:40:\"entity.taxonomy_vocabulary.overview_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"taxonomy_term_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\taxonomy\\Entity\\Term\";s:11:\"\0*\0provider\";s:8:\"taxonomy\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','taxonomy_term.field_storage_definitions','a:17:{s:3:\"tid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Term ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The term ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:3:\"tid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The term UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The term language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:3:\"vid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:114;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:19:\"taxonomy_vocabulary\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The vocabulary to which the term is assigned.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:3:\"vid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:151;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The term name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}s:6:\"format\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:198;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:text_long\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"A description of the term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:14:\"text_textfield\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:246;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"The weight of this term in relation to other terms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:285;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:13:\"taxonomy_term\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The parents of this term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:14:\"custom_storage\";b:0;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:322;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the term was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:12:\"revisionable\";b:1;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:352;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:394;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Publishing status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"A boolean indicating the published state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:8:\"provider\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:11:\"revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:439;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:10:\"field_name\";s:11:\"revision_id\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:13:\"initial_value\";N;}}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:472;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:8:\"internal\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:13:\"initial_value\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:513;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"initial_value\";N;}}s:16:\"revision_created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:553;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:10:\"field_name\";s:16:\"revision_created\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"initial_value\";N;}}s:13:\"revision_user\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:582;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:10:\"field_name\";s:13:\"revision_user\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"initial_value\";N;}}s:20:\"revision_log_message\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:618;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:10:\"field_name\";s:20:\"revision_log_message\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Briefly describe the changes you have made.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:13:\"initial_value\";N;}}}'),

('entity.definitions.installed','taxonomy_vocabulary.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:10:\"vocabulary\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:4:\"name\";i:1;s:3:\"vid\";i:2;s:11:\"description\";i:3;s:9:\"hierarchy\";i:4;s:6:\"weight\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:6:\"weight\";s:6:\"weight\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"taxonomy_vocabulary\";s:11:\"\0*\0provider\";s:8:\"taxonomy\";s:8:\"\0*\0class\";s:33:\"Drupal\\taxonomy\\Entity\\Vocabulary\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:7:\"storage\";s:33:\"Drupal\\taxonomy\\VocabularyStorage\";s:12:\"list_builder\";s:37:\"Drupal\\taxonomy\\VocabularyListBuilder\";s:4:\"form\";a:3:{s:7:\"default\";s:30:\"Drupal\\taxonomy\\VocabularyForm\";s:5:\"reset\";s:40:\"Drupal\\taxonomy\\Form\\VocabularyResetForm\";s:6:\"delete\";s:41:\"Drupal\\taxonomy\\Form\\VocabularyDeleteForm\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";}s:19:\"\0*\0admin_permission\";s:19:\"administer taxonomy\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:58:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/add\";s:11:\"delete-form\";s:61:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/delete\";s:10:\"reset-form\";s:60:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/reset\";s:13:\"overview-form\";s:63:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview\";s:9:\"edit-form\";s:54:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}\";s:10:\"collection\";s:25:\"/admin/structure/taxonomy\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:13:\"taxonomy_term\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Taxonomy vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:taxonomy_vocabulary_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','tb_megamenu.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:11:\"menu_config\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:4:\"menu\";s:4:\"menu\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"tb_megamenu\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\tb_megamenu\\Entity\\MegaMenuConfig\";s:11:\"\0*\0handlers\";a:5:{s:12:\"list_builder\";s:42:\"Drupal\\tb_megamenu\\Controller\\MegaMenuList\";s:4:\"form\";a:3:{s:3:\"add\";s:35:\"Drupal\\tb_megamenu\\Form\\MegaMenuAdd\";s:4:\"edit\";s:35:\"Drupal\\tb_megamenu\\Form\\MegaMenuAdd\";s:6:\"delete\";s:38:\"Drupal\\tb_megamenu\\Form\\MegaMenuDelete\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:2:{s:9:\"edit-form\";s:42:\"/admin/structure/tb-megamenu/{tb_megamenu}\";s:11:\"delete-form\";s:49:\"/admin/structure/tb-megamenu/{tb_megamenu}/delete\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"TB Mega Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:tb_megamenu_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:11:\"tb_megamenu\";}s:8:\"\0*\0class\";s:40:\"Drupal\\tb_megamenu\\Entity\\MegaMenuConfig\";s:11:\"\0*\0provider\";s:11:\"tb_megamenu\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','tour.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:2:{i:0;s:19:\"routes.*.route_name\";i:1;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"module\";i:3;s:6:\"routes\";i:4;s:4:\"tips\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"tour\";s:11:\"\0*\0provider\";s:4:\"tour\";s:8:\"\0*\0class\";s:23:\"Drupal\\tour\\Entity\\Tour\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:3:{s:12:\"view_builder\";s:27:\"Drupal\\tour\\TourViewBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:tour_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','user.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":35:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:2:\"id\";s:3:\"uid\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:4:\"user\";s:11:\"\0*\0provider\";s:4:\"user\";s:8:\"\0*\0class\";s:23:\"Drupal\\user\\Entity\\User\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:9:{s:7:\"storage\";s:23:\"Drupal\\user\\UserStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\user\\UserStorageSchema\";s:6:\"access\";s:36:\"Drupal\\user\\UserAccessControlHandler\";s:12:\"list_builder\";s:27:\"Drupal\\user\\UserListBuilder\";s:10:\"views_data\";s:25:\"Drupal\\user\\UserViewsData\";s:14:\"route_provider\";a:1:{s:4:\"html\";s:36:\"Drupal\\user\\Entity\\UserRouteProvider\";}s:4:\"form\";a:3:{s:7:\"default\";s:23:\"Drupal\\user\\ProfileForm\";s:6:\"cancel\";s:31:\"Drupal\\user\\Form\\UserCancelForm\";s:8:\"register\";s:24:\"Drupal\\user\\RegisterForm\";}s:11:\"translation\";s:37:\"Drupal\\user\\ProfileTranslationHandler\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";s:16:\"administer users\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:9:\"canonical\";s:12:\"/user/{user}\";s:9:\"edit-form\";s:17:\"/user/{user}/edit\";s:11:\"cancel-form\";s:19:\"/user/{user}/cancel\";s:10:\"collection\";s:13:\"/admin/people\";}s:17:\"\0*\0label_callback\";s:16:\"user_format_name\";s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:5:\"users\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:16:\"users_field_data\";s:15:\"\0*\0translatable\";b:1;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:22:\"entity.user.admin_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"user_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','user.field_storage_definitions','a:19:{s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The user ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The user UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The user language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:18:\"preferred_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:112;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:60:\"Drupal\\user\\Entity\\User::getAllowedConfigurableLanguageCodes\";}s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Preferred language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"The user\'s preferred language code for receiving emails and viewing the site.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:18:\"preferred_langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:24:\"preferred_admin_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:148;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:60:\"Drupal\\user\\Entity\\User::getAllowedConfigurableLanguageCodes\";}s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Preferred admin language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"The user\'s preferred language code for viewing administration pages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";N;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:24:\"preferred_admin_langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:187;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:5:\"class\";s:25:\"\\Drupal\\user\\UserNameItem\";}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The name of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:11:\"constraints\";a:2:{s:8:\"UserName\";a:0:{}s:14:\"UserNameUnique\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"pass\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"password\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:225;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:password\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The password of this user (hashed).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:18:\"ProtectedUserField\";N;}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"pass\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:260;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The email of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:11:\"constraints\";a:3:{s:14:\"UserMailUnique\";N;s:16:\"UserMailRequired\";N;s:18:\"ProtectedUserField\";N;}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:8:\"timezone\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:296;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:44:\"Drupal\\user\\Entity\\User::getAllowedTimezones\";}}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Timezone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The timezone of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:8:\"timezone\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:334;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"User status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"Whether the user is active or blocked.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:374;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The time that the user was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:402;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the user was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:6:\"access\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:431;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Last access\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The time that the user last accessed the site.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:6:\"access\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:5:\"login\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:462;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Last login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time that the user last logged in.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:5:\"login\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"init\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:493;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Initial email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The email address used for initial account creation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"init\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:5:\"roles\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:525;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:9:\"user_role\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Roles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The roles the user has.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:5:\"roles\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:561;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:12:\"user_picture\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":28:{s:5:\"\0*\0id\";s:17:\"user.user_picture\";s:13:\"\0*\0field_name\";s:12:\"user_picture\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:17:\"user.user_picture\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"7774566e-2d83-440e-a02b-6df978eba52e\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6k-VBFilDLuzgSOT-77CFgHFlcd5D-kqRixtH89EShU\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"user\";}}}s:18:\"commerce_remote_id\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":28:{s:5:\"\0*\0id\";s:23:\"user.commerce_remote_id\";s:13:\"\0*\0field_name\";s:18:\"commerce_remote_id\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:7:\"\0*\0type\";s:18:\"commerce_remote_id\";s:9:\"\0*\0module\";s:8:\"commerce\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:0;s:9:\"\0*\0locked\";b:1;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:23:\"user.commerce_remote_id\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"20881c09-17f4-4742-9a44-96c3ac912b23\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"YLh2hnX0ZtVtJpFWUkcjkpbgJAP85JuAamng9bLk8M8\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_payment\";}}s:6:\"module\";a:2:{i:0;s:8:\"commerce\";i:1;s:4:\"user\";}}}}'),

('entity.definitions.installed','user_role.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";s:4:\"role\";s:15:\"\0*\0static_cache\";b:1;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"weight\";i:3;s:8:\"is_admin\";i:4;s:11:\"permissions\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"weight\";s:6:\"weight\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"user_role\";s:11:\"\0*\0provider\";s:4:\"user\";s:8:\"\0*\0class\";s:23:\"Drupal\\user\\Entity\\Role\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:7:\"storage\";s:23:\"Drupal\\user\\RoleStorage\";s:6:\"access\";s:36:\"Drupal\\user\\RoleAccessControlHandler\";s:12:\"list_builder\";s:27:\"Drupal\\user\\RoleListBuilder\";s:4:\"form\";a:2:{s:7:\"default\";s:20:\"Drupal\\user\\RoleForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}}s:19:\"\0*\0admin_permission\";s:22:\"administer permissions\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:45:\"/admin/people/roles/manage/{user_role}/delete\";s:9:\"edit-form\";s:38:\"/admin/people/roles/manage/{user_role}\";s:21:\"edit-permissions-form\";s:37:\"/admin/people/permissions/{user_role}\";s:10:\"collection\";s:19:\"/admin/people/roles\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:user_role_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','view.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:9:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"module\";i:3;s:11:\"description\";i:4;s:3:\"tag\";i:5;s:10:\"base_table\";i:6;s:10:\"base_field\";i:7;s:4:\"core\";i:8;s:7:\"display\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"view\";s:11:\"\0*\0provider\";s:5:\"views\";s:8:\"\0*\0class\";s:24:\"Drupal\\views\\Entity\\View\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:37:\"Drupal\\views\\ViewAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:16:\"administer views\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"View\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:view_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','vote.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:2:\"id\";s:2:\"id\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:4:\"type\";s:8:\"revision\";s:0:\"\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:4:\"vote\";s:16:\"\0*\0originalClass\";s:28:\"Drupal\\votingapi\\Entity\\Vote\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:28:\"Drupal\\votingapi\\VoteStorage\";s:10:\"views_data\";s:37:\"Drupal\\votingapi\\Entity\\VoteViewsData\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:9:\"vote_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Vote type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:14:\"votingapi_vote\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Vote\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"vote_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:28:\"Drupal\\votingapi\\Entity\\Vote\";s:11:\"\0*\0provider\";s:9:\"votingapi\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','vote.field_storage_definitions','a:10:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The vote ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The vote UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:9:\"vote_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The vote type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}s:11:\"entity_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:111;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:64;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Entity Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"The type from the voted entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"node\";}}s:8:\"required\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:11:\"entity_type\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}s:9:\"entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:148;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Voted entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"The ID from the voted entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:9:\"target_id\";i:0;}}s:8:\"required\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:9:\"entity_id\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}s:5:\"value\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"float\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:5:\"float\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:187;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:float\";s:8:\"settings\";a:4:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The numeric value of the vote.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"required\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:5:\"value\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}s:10:\"value_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:223;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:64;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Value Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:7:\"percent\";}}s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:10:\"value_type\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}s:7:\"user_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:255;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Authored by\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"The user who submitted the vote.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:46:\"Drupal\\votingapi\\Entity\\Vote::getCurrentUserId\";s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:7:\"user_id\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}s:9:\"timestamp\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:291;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"The time that the entity was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:4:\"time\";s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:9:\"timestamp\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}s:11:\"vote_source\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:320;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Vote Source\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"The IP from the user who submitted the vote.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:42:\"Drupal\\votingapi\\Entity\\Vote::getCurrentIp\";s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:11:\"vote_source\";s:11:\"entity_type\";s:4:\"vote\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','vote_result.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:5:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:11:\"vote_result\";s:16:\"\0*\0originalClass\";s:34:\"Drupal\\votingapi\\Entity\\VoteResult\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:34:\"Drupal\\votingapi\\VoteResultStorage\";s:10:\"views_data\";s:43:\"Drupal\\votingapi\\Entity\\VoteResultViewsData\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:16:\"votingapi_result\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Vote Result\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"vote_result_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:34:\"Drupal\\votingapi\\Entity\\VoteResult\";s:11:\"\0*\0provider\";s:9:\"votingapi\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','vote_result.field_storage_definitions','a:8:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"The vote result ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:11:\"vote_result\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:9:\"vote_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The vote type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:11:\"vote_result\";s:6:\"bundle\";N;}}s:11:\"entity_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:64;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Entity Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"The type from the voted entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:11:\"entity_type\";s:11:\"entity_type\";s:11:\"vote_result\";s:6:\"bundle\";N;}}s:9:\"entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:109;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Voted entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"The ID from the voted entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:9:\"entity_id\";s:11:\"entity_type\";s:11:\"vote_result\";s:6:\"bundle\";N;}}s:5:\"value\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"float\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:5:\"float\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:145;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:float\";s:8:\"settings\";a:4:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The numeric value of the vote.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:5:\"value\";s:11:\"entity_type\";s:11:\"vote_result\";s:6:\"bundle\";N;}}s:10:\"value_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:178;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:64;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Value Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:10:\"value_type\";s:11:\"entity_type\";s:11:\"vote_result\";s:6:\"bundle\";N;}}s:8:\"function\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:100;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:208;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:100;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Function\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Function to apply to the numbers.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:8:\"function\";s:11:\"entity_type\";s:11:\"vote_result\";s:6:\"bundle\";N;}}s:9:\"timestamp\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:242;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"The time that the entity was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:9:\"votingapi\";s:10:\"field_name\";s:9:\"timestamp\";s:11:\"entity_type\";s:11:\"vote_result\";s:6:\"bundle\";N;}}}'),

('entity.definitions.installed','vote_type.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"vote_type\";s:16:\"\0*\0originalClass\";s:32:\"Drupal\\votingapi\\Entity\\VoteType\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:45:\"Drupal\\votingapi\\VoteTypeAccessControlHandler\";s:4:\"form\";a:3:{s:3:\"add\";s:29:\"Drupal\\votingapi\\VoteTypeForm\";s:4:\"edit\";s:29:\"Drupal\\votingapi\\VoteTypeForm\";s:6:\"delete\";s:43:\"Drupal\\votingapi\\Form\\VoteTypeDeleteConfirm\";}s:12:\"list_builder\";s:36:\"Drupal\\votingapi\\VoteTypeListBuilder\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:21:\"administer vote types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:9:\"edit-form\";s:39:\"/admin/structure/vote-types/{vote_type}\";s:11:\"delete-form\";s:46:\"/admin/structure/vote-types/{vote_type}/delete\";s:10:\"collection\";s:27:\"/admin/structure/vote-types\";s:10:\"devel-load\";s:28:\"/devel/vote_type/{vote_type}\";s:16:\"devel-definition\";s:39:\"/devel/vote_type/{vote_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:4:\"vote\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Vote Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:vote_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:32:\"Drupal\\votingapi\\Entity\\VoteType\";s:11:\"\0*\0provider\";s:9:\"votingapi\";s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','webform.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:14:{i:0;s:6:\"status\";i:1;s:3:\"uid\";i:2;s:8:\"template\";i:3;s:2:\"id\";i:4;s:4:\"uuid\";i:5;s:5:\"title\";i:6;s:11:\"description\";i:7;s:8:\"elements\";i:8;s:3:\"css\";i:9;s:10:\"javascript\";i:10;s:8:\"settings\";i:11;s:6:\"access\";i:12;s:8:\"handlers\";i:13;s:20:\"third_party_settings\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"title\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:7:\"webform\";s:11:\"\0*\0provider\";s:7:\"webform\";s:8:\"\0*\0class\";s:29:\"Drupal\\webform\\Entity\\Webform\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:36:\"\\Drupal\\webform\\WebformEntityStorage\";s:12:\"view_builder\";s:39:\"Drupal\\webform\\WebformEntityViewBuilder\";s:12:\"list_builder\";s:39:\"Drupal\\webform\\WebformEntityListBuilder\";s:6:\"access\";s:48:\"Drupal\\webform\\WebformEntityAccessControlHandler\";s:4:\"form\";a:8:{s:7:\"default\";s:32:\"Drupal\\webform\\WebformEntityForm\";s:8:\"settings\";s:40:\"Drupal\\webform\\WebformEntitySettingsForm\";s:20:\"third_party_settings\";s:50:\"Drupal\\webform\\WebformEntityThirdPartySettingsForm\";s:6:\"assets\";s:38:\"Drupal\\webform\\WebformEntityAssetsForm\";s:6:\"access\";s:38:\"Drupal\\webform\\WebformEntityAccessForm\";s:8:\"handlers\";s:40:\"Drupal\\webform\\WebformEntityHandlersForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";s:9:\"duplicate\";s:32:\"Drupal\\webform\\WebformEntityForm\";}}s:19:\"\0*\0admin_permission\";s:18:\"administer webform\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:20:{s:9:\"canonical\";s:18:\"/webform/{webform}\";s:11:\"submissions\";s:30:\"/webform/{webform}/submissions\";s:8:\"add-form\";s:18:\"/webform/{webform}\";s:9:\"test-form\";s:23:\"/webform/{webform}/test\";s:9:\"edit-form\";s:41:\"/admin/structure/webform/manage/{webform}\";s:13:\"settings-form\";s:50:\"/admin/structure/webform/manage/{webform}/settings\";s:11:\"assets-form\";s:48:\"/admin/structure/webform/manage/{webform}/assets\";s:25:\"third-party-settings-form\";s:53:\"/admin/structure/webform/manage/{webform}/third-party\";s:11:\"access-form\";s:48:\"/admin/structure/webform/manage/{webform}/access\";s:13:\"handlers-form\";s:50:\"/admin/structure/webform/manage/{webform}/handlers\";s:14:\"duplicate-form\";s:51:\"/admin/structure/webform/manage/{webform}/duplicate\";s:11:\"delete-form\";s:48:\"/admin/structure/webform/manage/{webform}/delete\";s:11:\"export-form\";s:48:\"/admin/structure/webform/manage/{webform}/export\";s:19:\"results-submissions\";s:61:\"/admin/structure/webform/manage/{webform}/results/submissions\";s:13:\"results-table\";s:55:\"/admin/structure/webform/manage/{webform}/results/table\";s:14:\"results-export\";s:58:\"/admin/structure/webform/manage/{webform}/results/download\";s:13:\"results-clear\";s:55:\"/admin/structure/webform/manage/{webform}/results/clear\";s:10:\"collection\";s:24:\"/admin/structure/webform\";s:12:\"devel-render\";s:31:\"/devel/webform/{webform}/render\";s:10:\"devel-load\";s:24:\"/devel/webform/{webform}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:18:\"webform_submission\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:19:\"config:webform_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','webform_options.entity_type','O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":39:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:4:\"uuid\";i:2;s:5:\"label\";i:3;s:7:\"options\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:15:\"webform_options\";s:11:\"\0*\0provider\";s:7:\"webform\";s:8:\"\0*\0class\";s:36:\"Drupal\\webform\\Entity\\WebformOptions\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:49:\"Drupal\\webform\\WebformOptionsAccessControlHandler\";s:12:\"list_builder\";s:40:\"Drupal\\webform\\WebformOptionsListBuilder\";s:4:\"form\";a:2:{s:7:\"default\";s:33:\"Drupal\\webform\\WebformOptionsForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:18:\"administer webform\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:8:\"add-form\";s:45:\"/admin/structure/webform/settings/options/add\";s:9:\"edit-form\";s:71:\"/admin/structure/webform/settings/options/manage/{webform_options}/edit\";s:11:\"delete-form\";s:73:\"/admin/structure/webform/settings/options/manage/{webform_options}/delete\";s:10:\"collection\";s:48:\"/admin/structure/webform/settings/options/manage\";s:10:\"devel-load\";s:40:\"/devel/webform_options/{webform_options}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Webform options\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:27:\"config:webform_options_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','webform_submission.entity_type','O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:2:\"id\";s:3:\"sid\";s:6:\"bundle\";s:10:\"webform_id\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:18:\"webform_submission\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:7:{s:7:\"storage\";s:39:\"Drupal\\webform\\WebformSubmissionStorage\";s:14:\"storage_schema\";s:45:\"Drupal\\webform\\WebformSubmissionStorageSchema\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:12:\"view_builder\";s:43:\"Drupal\\webform\\WebformSubmissionViewBuilder\";s:12:\"list_builder\";s:43:\"Drupal\\webform\\WebformSubmissionListBuilder\";s:6:\"access\";s:52:\"Drupal\\webform\\WebformSubmissionAccessControlHandler\";s:4:\"form\";a:3:{s:7:\"default\";s:36:\"Drupal\\webform\\WebformSubmissionForm\";s:5:\"notes\";s:41:\"Drupal\\webform\\WebformSubmissionNotesForm\";s:6:\"delete\";s:47:\"Drupal\\webform\\Form\\WebformSubmissionDeleteForm\";}}s:19:\"\0*\0admin_permission\";s:18:\"administer webform\";s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:11:{s:9:\"canonical\";s:73:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}\";s:5:\"table\";s:79:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/table\";s:4:\"text\";s:78:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/text\";s:4:\"yaml\";s:78:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/yaml\";s:9:\"edit-form\";s:78:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/edit\";s:10:\"notes-form\";s:79:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/notes\";s:11:\"resend-form\";s:80:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/resend\";s:11:\"delete-form\";s:80:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/delete\";s:10:\"collection\";s:44:\"/admin/structure/webform/results/manage/list\";s:12:\"devel-render\";s:53:\"/devel/webform_submission/{webform_submission}/render\";s:10:\"devel-load\";s:46:\"/devel/webform_submission/{webform_submission}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:7:\"webform\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:18:\"webform_submission\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Webform submission\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:1:{i:0;s:4:\"user\";}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"webform_submission_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:39:\"Drupal\\webform\\Entity\\WebformSubmission\";s:11:\"\0*\0provider\";s:7:\"webform\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),

('entity.definitions.installed','webform_submission.field_storage_definitions','a:19:{s:6:\"serial\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Serial number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"The serial number of the webform submission entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:6:\"serial\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:3:\"sid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Submission ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The ID of the webform submission entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:3:\"sid\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:76;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Submission UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"The UUID of the webform submission entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:5:\"token\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:112;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Token\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"A secure token used to look up a submission.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:5:\"token\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:3:\"uri\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2000;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:146;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:2000;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Submission URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The URI the user submitted the webform.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:3:\"uri\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:180;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"The time that the webform submission was first saved as draft or submitted.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:9:\"completed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:208;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Completed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"The time that the webform submission was submitted as complete (not draft).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:9:\"completed\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:236;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"The time that the webform submission was last saved (complete or draft).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:8:\"in_draft\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:264;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Is draft\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Is this a draft of the submission?\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:8:\"in_draft\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:12:\"current_page\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:304;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Current page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"The current wizard page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:12:\"current_page\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:11:\"remote_addr\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:337;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Remote IP address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The IP address of the user that submitted the webform.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:11:\"remote_addr\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:370;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Submitted by\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The submitter.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:405;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:4:{s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:18:\"webform_submission\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"The submission language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:10:\"webform_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:432;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:7:\"webform\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The associated webform.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:10:\"webform_id\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:11:\"entity_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:467;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Submitted to: Entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"The entity type to which this submission was submitted from.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:11:\"entity_type\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:9:\"entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:500;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Submitted to: Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:73:\"The ID of the entity of which this webform submission was submitted from.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:9:\"entity_id\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:6:\"sticky\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:533;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Sticky\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag that indicate the status of the webform submission.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:6:\"sticky\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:5:\"notes\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:573;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Notes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"Administrative notes about the webform submission.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:8:\"provider\";s:7:\"webform\";s:10:\"field_name\";s:5:\"notes\";s:11:\"entity_type\";s:18:\"webform_submission\";s:6:\"bundle\";N;}}s:6:\"locked\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:606;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Locked\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"A flag that indicates a locked webform submission.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:10:\"field_name\";s:6:\"locked\";s:11:\"entity_type\";s:18:\"webform_submission\";s:8:\"provider\";s:7:\"webform\";s:6:\"bundle\";N;}}}'),

('entity.storage_schema.sql','block_content.entity_schema_data','a:4:{s:13:\"block_content\";a:2:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:11:\"unique keys\";a:1:{s:26:\"block_content__revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:22:\"block_content_revision\";a:2:{s:11:\"primary key\";a:1:{i:0;s:11:\"revision_id\";}s:7:\"indexes\";a:1:{s:17:\"block_content__id\";a:1:{i:0;s:2:\"id\";}}}s:24:\"block_content_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:2:\"id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:45:\"block_content__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:26:\"block_content__revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:26:\"block_content__status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:2:\"id\";}}}s:28:\"block_content_field_revision\";a:2:{s:11:\"primary key\";a:2:{i:0;s:11:\"revision_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:45:\"block_content__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.body','a:2:{s:19:\"block_content__body\";a:4:{s:11:\"description\";s:42:\"Data storage for block_content field body.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}}s:28:\"block_content_revision__body\";a:4:{s:11:\"description\";s:54:\"Revision archive storage for block_content field body.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.changed','a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.default_langcode','a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.id','a:4:{s:13:\"block_content\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.info','a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"info\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:4:\"info\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.langcode','a:4:{s:13:\"block_content\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.reusable','a:1:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"reusable\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.revision_created','a:1:{s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.revision_default','a:1:{s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.revision_id','a:4:{s:13:\"block_content\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.revision_log','a:1:{s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:12:\"revision_log\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.revision_translation_affected','a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.revision_user','a:1:{s:22:\"block_content_revision\";a:2:{s:6:\"fields\";a:1:{s:13:\"revision_user\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:45:\"block_content_field__revision_user__target_id\";a:1:{i:0;s:13:\"revision_user\";}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.status','a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.type','a:2:{s:13:\"block_content\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:36:\"block_content_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}s:24:\"block_content_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:36:\"block_content_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','block_content.field_schema_data.uuid','a:1:{s:13:\"block_content\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:32:\"block_content_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','comment.entity_schema_data','a:2:{s:7:\"comment\";a:1:{s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}}s:18:\"comment_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"cid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:5:{s:39:\"comment__id__default_langcode__langcode\";a:3:{i:0;s:3:\"cid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:28:\"comment__status_comment_type\";a:3:{i:0;s:6:\"status\";i:1;s:12:\"comment_type\";i:2;s:3:\"cid\";}s:19:\"comment__status_pid\";a:2:{i:0;s:3:\"pid\";i:1;s:6:\"status\";}s:16:\"comment__num_new\";a:7:{i:0;s:9:\"entity_id\";i:1;s:11:\"entity_type\";i:2;s:12:\"comment_type\";i:3;s:6:\"status\";i:4;s:7:\"created\";i:5;s:3:\"cid\";i:6;s:6:\"thread\";}s:24:\"comment__entity_langcode\";a:4:{i:0;s:9:\"entity_id\";i:1;s:11:\"entity_type\";i:2;s:12:\"comment_type\";i:3;s:16:\"default_langcode\";}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.changed','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.cid','a:2:{s:7:\"comment\";a:1:{s:6:\"fields\";a:1:{s:3:\"cid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"cid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.comment_body','a:1:{s:21:\"comment__comment_body\";a:4:{s:11:\"description\";s:44:\"Data storage for comment field comment_body.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:18:\"comment_body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:19:\"comment_body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:19:\"comment_body_format\";a:1:{i:0;s:19:\"comment_body_format\";}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.comment_type','a:2:{s:7:\"comment\";a:2:{s:6:\"fields\";a:1:{s:12:\"comment_type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:38:\"comment_field__comment_type__target_id\";a:1:{i:0;s:12:\"comment_type\";}}}s:18:\"comment_field_data\";a:2:{s:6:\"fields\";a:1:{s:12:\"comment_type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:38:\"comment_field__comment_type__target_id\";a:1:{i:0;s:12:\"comment_type\";}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.created','a:1:{s:18:\"comment_field_data\";a:2:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:22:\"comment_field__created\";a:1:{i:0;s:7:\"created\";}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.default_langcode','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.entity_id','a:1:{s:18:\"comment_field_data\";a:2:{s:6:\"fields\";a:1:{s:9:\"entity_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:0:{}}}'),

('entity.storage_schema.sql','comment.field_schema_data.entity_type','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.field_comment','a:1:{s:22:\"comment__field_comment\";a:4:{s:11:\"description\";s:45:\"Data storage for comment field field_comment.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:19:\"field_comment_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.field_email','a:1:{s:20:\"comment__field_email\";a:4:{s:11:\"description\";s:43:\"Data storage for comment field field_email.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"field_email_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.field_name','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:10:\"field_name\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.field_rating','a:1:{s:21:\"comment__field_rating\";a:4:{s:11:\"description\";s:44:\"Data storage for comment field field_rating.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:19:\"field_rating_rating\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:19:\"field_rating_target\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.homepage','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"homepage\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.hostname','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.langcode','a:2:{s:7:\"comment\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.mail','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.name','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.pid','a:1:{s:18:\"comment_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"pid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:0:{}}}'),

('entity.storage_schema.sql','comment.field_schema_data.status','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.subject','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"subject\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.thread','a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"thread\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.uid','a:1:{s:18:\"comment_field_data\";a:3:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:29:\"comment_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}s:12:\"foreign keys\";a:1:{s:18:\"comment_field__uid\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}}}'),

('entity.storage_schema.sql','comment.field_schema_data.uuid','a:1:{s:7:\"comment\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:26:\"comment_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_log.entity_schema_data','a:1:{s:12:\"commerce_log\";a:1:{s:11:\"primary key\";a:1:{i:0;s:6:\"log_id\";}}}'),

('entity.storage_schema.sql','commerce_log.field_schema_data.category_id','a:1:{s:12:\"commerce_log\";a:1:{s:6:\"fields\";a:1:{s:11:\"category_id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_log.field_schema_data.created','a:1:{s:12:\"commerce_log\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_log.field_schema_data.log_id','a:1:{s:12:\"commerce_log\";a:1:{s:6:\"fields\";a:1:{s:6:\"log_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_log.field_schema_data.params','a:1:{s:12:\"commerce_log\";a:1:{s:6:\"fields\";a:1:{s:6:\"params\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_log.field_schema_data.source_entity_id','a:1:{s:12:\"commerce_log\";a:1:{s:6:\"fields\";a:1:{s:16:\"source_entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_log.field_schema_data.source_entity_type','a:1:{s:12:\"commerce_log\";a:1:{s:6:\"fields\";a:1:{s:18:\"source_entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_log.field_schema_data.template_id','a:1:{s:12:\"commerce_log\";a:1:{s:6:\"fields\";a:1:{s:11:\"template_id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_log.field_schema_data.uid','a:1:{s:12:\"commerce_log\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:34:\"commerce_log_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','commerce_log.field_schema_data.uuid','a:1:{s:12:\"commerce_log\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:31:\"commerce_log_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_order.entity_schema_data','a:1:{s:14:\"commerce_order\";a:1:{s:11:\"primary key\";a:1:{i:0;s:8:\"order_id\";}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.adjustments','a:1:{s:27:\"commerce_order__adjustments\";a:4:{s:11:\"description\";s:50:\"Data storage for commerce_order field adjustments.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"adjustments_value\";a:4:{s:11:\"description\";s:21:\"The adjustment value.\";s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.billing_profile','a:1:{s:14:\"commerce_order\";a:2:{s:6:\"fields\";a:2:{s:26:\"billing_profile__target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:35:\"billing_profile__target_revision_id\";a:4:{s:11:\"description\";s:37:\"The revision ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:2:{s:48:\"commerce_order_field__billing_profile__target_id\";a:1:{i:0;s:26:\"billing_profile__target_id\";}s:26:\"commerce_order__f8b17b71af\";a:1:{i:0;s:35:\"billing_profile__target_revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.cart','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:4:\"cart\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.changed','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.checkout_flow','a:1:{s:14:\"commerce_order\";a:2:{s:6:\"fields\";a:1:{s:13:\"checkout_flow\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:46:\"commerce_order_field__checkout_flow__target_id\";a:1:{i:0;s:13:\"checkout_flow\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.checkout_step','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:13:\"checkout_step\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.completed','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:9:\"completed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.coupons','a:1:{s:23:\"commerce_order__coupons\";a:4:{s:11:\"description\";s:46:\"Data storage for commerce_order field coupons.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"coupons_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:17:\"coupons_target_id\";a:1:{i:0;s:17:\"coupons_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.created','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.data','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.ip_address','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:10:\"ip_address\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.locked','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:6:\"locked\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.mail','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.order_id','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:8:\"order_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.order_items','a:1:{s:27:\"commerce_order__order_items\";a:4:{s:11:\"description\";s:50:\"Data storage for commerce_order field order_items.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"order_items_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:21:\"order_items_target_id\";a:1:{i:0;s:21:\"order_items_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.order_number','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:12:\"order_number\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.payment_gateway','a:1:{s:14:\"commerce_order\";a:2:{s:6:\"fields\";a:1:{s:15:\"payment_gateway\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:48:\"commerce_order_field__payment_gateway__target_id\";a:1:{i:0;s:15:\"payment_gateway\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.payment_method','a:1:{s:14:\"commerce_order\";a:2:{s:6:\"fields\";a:1:{s:14:\"payment_method\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:47:\"commerce_order_field__payment_method__target_id\";a:1:{i:0;s:14:\"payment_method\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.placed','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:6:\"placed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.state','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:1:{s:5:\"state\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.store_id','a:1:{s:14:\"commerce_order\";a:2:{s:6:\"fields\";a:1:{s:8:\"store_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:41:\"commerce_order_field__store_id__target_id\";a:1:{i:0;s:8:\"store_id\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.total_paid','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:2:{s:18:\"total_paid__number\";a:5:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;s:8:\"not null\";b:0;}s:25:\"total_paid__currency_code\";a:4:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.total_price','a:1:{s:14:\"commerce_order\";a:1:{s:6:\"fields\";a:2:{s:19:\"total_price__number\";a:5:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;s:8:\"not null\";b:0;}s:26:\"total_price__currency_code\";a:4:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.type','a:1:{s:14:\"commerce_order\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:37:\"commerce_order_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.uid','a:1:{s:14:\"commerce_order\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:36:\"commerce_order_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','commerce_order.field_schema_data.uuid','a:1:{s:14:\"commerce_order\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:33:\"commerce_order_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_order_item.entity_schema_data','a:1:{s:19:\"commerce_order_item\";a:1:{s:11:\"primary key\";a:1:{i:0;s:13:\"order_item_id\";}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.adjustments','a:1:{s:32:\"commerce_order_item__adjustments\";a:4:{s:11:\"description\";s:55:\"Data storage for commerce_order_item field adjustments.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"adjustments_value\";a:4:{s:11:\"description\";s:21:\"The adjustment value.\";s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.changed','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.created','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.data','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:1:{s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.order_id','a:1:{s:19:\"commerce_order_item\";a:2:{s:6:\"fields\";a:1:{s:8:\"order_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:46:\"commerce_order_item_field__order_id__target_id\";a:1:{i:0;s:8:\"order_id\";}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.order_item_id','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:1:{s:13:\"order_item_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.overridden_unit_price','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:1:{s:21:\"overridden_unit_price\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.purchased_entity','a:1:{s:19:\"commerce_order_item\";a:2:{s:6:\"fields\";a:1:{s:16:\"purchased_entity\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:31:\"commerce_order_item__ffa66b75a4\";a:1:{i:0;s:16:\"purchased_entity\";}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.quantity','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:1:{s:8:\"quantity\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:10;s:5:\"scale\";i:2;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.title','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.total_price','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:2:{s:19:\"total_price__number\";a:5:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;s:8:\"not null\";b:0;}s:26:\"total_price__currency_code\";a:4:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.type','a:1:{s:19:\"commerce_order_item\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:42:\"commerce_order_item_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.unit_price','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:2:{s:18:\"unit_price__number\";a:5:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;s:8:\"not null\";b:0;}s:25:\"unit_price__currency_code\";a:4:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.uses_legacy_adjustments','a:1:{s:19:\"commerce_order_item\";a:1:{s:6:\"fields\";a:1:{s:23:\"uses_legacy_adjustments\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_order_item.field_schema_data.uuid','a:1:{s:19:\"commerce_order_item\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:38:\"commerce_order_item_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_payment.entity_schema_data','a:1:{s:16:\"commerce_payment\";a:1:{s:11:\"primary key\";a:1:{i:0;s:10:\"payment_id\";}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.amount','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:2:{s:14:\"amount__number\";a:5:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;s:8:\"not null\";b:0;}s:21:\"amount__currency_code\";a:4:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.authorized','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:10:\"authorized\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.captured','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:8:\"captured\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.completed','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:9:\"completed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.expires','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:7:\"expires\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.order_id','a:1:{s:16:\"commerce_payment\";a:2:{s:6:\"fields\";a:1:{s:8:\"order_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:43:\"commerce_payment_field__order_id__target_id\";a:1:{i:0;s:8:\"order_id\";}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.payment_gateway','a:1:{s:16:\"commerce_payment\";a:2:{s:6:\"fields\";a:1:{s:15:\"payment_gateway\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:28:\"commerce_payment__e115249117\";a:1:{i:0;s:15:\"payment_gateway\";}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.payment_gateway_mode','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:20:\"payment_gateway_mode\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.payment_id','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:10:\"payment_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.payment_method','a:1:{s:16:\"commerce_payment\";a:2:{s:6:\"fields\";a:1:{s:14:\"payment_method\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:28:\"commerce_payment__9a4058fc21\";a:1:{i:0;s:14:\"payment_method\";}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.refunded_amount','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:2:{s:23:\"refunded_amount__number\";a:5:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;s:8:\"not null\";b:0;}s:30:\"refunded_amount__currency_code\";a:4:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.remote_id','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:9:\"remote_id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.remote_state','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:12:\"remote_state\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.state','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:5:\"state\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.test','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:4:\"test\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.type','a:1:{s:16:\"commerce_payment\";a:1:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_payment.field_schema_data.uuid','a:1:{s:16:\"commerce_payment\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:35:\"commerce_payment_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_payment_method.entity_schema_data','a:1:{s:23:\"commerce_payment_method\";a:1:{s:11:\"primary key\";a:1:{i:0;s:9:\"method_id\";}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.billing_profile','a:1:{s:23:\"commerce_payment_method\";a:2:{s:6:\"fields\";a:2:{s:26:\"billing_profile__target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:35:\"billing_profile__target_revision_id\";a:4:{s:11:\"description\";s:37:\"The revision ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:2:{s:35:\"commerce_payment_method__f1a4ca8a25\";a:1:{i:0;s:26:\"billing_profile__target_id\";}s:35:\"commerce_payment_method__1a5d23bb97\";a:1:{i:0;s:35:\"billing_profile__target_revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.card_exp_month','a:1:{s:39:\"commerce_payment_method__card_exp_month\";a:4:{s:11:\"description\";s:62:\"Data storage for commerce_payment_method field card_exp_month.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"card_exp_month_value\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.card_exp_year','a:1:{s:38:\"commerce_payment_method__card_exp_year\";a:4:{s:11:\"description\";s:61:\"Data storage for commerce_payment_method field card_exp_year.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:19:\"card_exp_year_value\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.card_number','a:1:{s:36:\"commerce_payment_method__card_number\";a:4:{s:11:\"description\";s:59:\"Data storage for commerce_payment_method field card_number.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"card_number_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.card_type','a:1:{s:34:\"commerce_payment_method__card_type\";a:4:{s:11:\"description\";s:57:\"Data storage for commerce_payment_method field card_type.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:15:\"card_type_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:15:\"card_type_value\";a:1:{i:0;s:15:\"card_type_value\";}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.changed','a:1:{s:23:\"commerce_payment_method\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.created','a:1:{s:23:\"commerce_payment_method\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.expires','a:1:{s:23:\"commerce_payment_method\";a:1:{s:6:\"fields\";a:1:{s:7:\"expires\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.is_default','a:1:{s:23:\"commerce_payment_method\";a:1:{s:6:\"fields\";a:1:{s:10:\"is_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.method_id','a:1:{s:23:\"commerce_payment_method\";a:1:{s:6:\"fields\";a:1:{s:9:\"method_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.payment_gateway','a:1:{s:23:\"commerce_payment_method\";a:2:{s:6:\"fields\";a:1:{s:15:\"payment_gateway\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:35:\"commerce_payment_method__06eef65667\";a:1:{i:0;s:15:\"payment_gateway\";}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.payment_gateway_mode','a:1:{s:23:\"commerce_payment_method\";a:1:{s:6:\"fields\";a:1:{s:20:\"payment_gateway_mode\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.paypal_mail','a:1:{s:36:\"commerce_payment_method__paypal_mail\";a:4:{s:11:\"description\";s:59:\"Data storage for commerce_payment_method field paypal_mail.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"paypal_mail_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.remote_id','a:1:{s:23:\"commerce_payment_method\";a:1:{s:6:\"fields\";a:1:{s:9:\"remote_id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.reusable','a:1:{s:23:\"commerce_payment_method\";a:1:{s:6:\"fields\";a:1:{s:8:\"reusable\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.type','a:1:{s:23:\"commerce_payment_method\";a:1:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.uid','a:1:{s:23:\"commerce_payment_method\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:45:\"commerce_payment_method_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','commerce_payment_method.field_schema_data.uuid','a:1:{s:23:\"commerce_payment_method\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:42:\"commerce_payment_method_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_product.entity_schema_data','a:2:{s:16:\"commerce_product\";a:1:{s:11:\"primary key\";a:1:{i:0;s:10:\"product_id\";}}s:27:\"commerce_product_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:10:\"product_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:48:\"commerce_product__id__default_langcode__langcode\";a:3:{i:0;s:10:\"product_id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:29:\"commerce_product__status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:10:\"product_id\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.body','a:1:{s:22:\"commerce_product__body\";a:4:{s:11:\"description\";s:45:\"Data storage for commerce_product field body.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.changed','a:1:{s:27:\"commerce_product_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.created','a:1:{s:27:\"commerce_product_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.default_langcode','a:1:{s:27:\"commerce_product_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.field_category','a:1:{s:32:\"commerce_product__field_category\";a:4:{s:11:\"description\";s:55:\"Data storage for commerce_product field field_category.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:24:\"field_category_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:24:\"field_category_target_id\";a:1:{i:0;s:24:\"field_category_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.field_rating','a:1:{s:30:\"commerce_product__field_rating\";a:4:{s:11:\"description\";s:53:\"Data storage for commerce_product field field_rating.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:19:\"field_rating_rating\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:19:\"field_rating_target\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.field_reviews','a:1:{s:31:\"commerce_product__field_reviews\";a:4:{s:11:\"description\";s:54:\"Data storage for commerce_product field field_reviews.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"field_reviews_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.field_tags','a:1:{s:28:\"commerce_product__field_tags\";a:4:{s:11:\"description\";s:51:\"Data storage for commerce_product field field_tags.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"field_tags_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:20:\"field_tags_target_id\";a:1:{i:0;s:20:\"field_tags_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.langcode','a:2:{s:16:\"commerce_product\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:27:\"commerce_product_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.product_id','a:2:{s:16:\"commerce_product\";a:1:{s:6:\"fields\";a:1:{s:10:\"product_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:27:\"commerce_product_field_data\";a:1:{s:6:\"fields\";a:1:{s:10:\"product_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.status','a:1:{s:27:\"commerce_product_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.stores','a:1:{s:24:\"commerce_product__stores\";a:4:{s:11:\"description\";s:47:\"Data storage for commerce_product field stores.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:16:\"stores_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:16:\"stores_target_id\";a:1:{i:0;s:16:\"stores_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.title','a:1:{s:27:\"commerce_product_field_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.type','a:2:{s:16:\"commerce_product\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:39:\"commerce_product_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}s:27:\"commerce_product_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:39:\"commerce_product_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.uid','a:1:{s:27:\"commerce_product_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:38:\"commerce_product_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.uuid','a:1:{s:16:\"commerce_product\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:35:\"commerce_product_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_product.field_schema_data.variations','a:1:{s:28:\"commerce_product__variations\";a:4:{s:11:\"description\";s:51:\"Data storage for commerce_product field variations.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"variations_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:20:\"variations_target_id\";a:1:{i:0;s:20:\"variations_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.entity_schema_data','a:2:{s:32:\"commerce_product_attribute_value\";a:1:{s:11:\"primary key\";a:1:{i:0;s:18:\"attribute_value_id\";}}s:43:\"commerce_product_attribute_value_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:18:\"attribute_value_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:64:\"commerce_product_attribute_value__id__default_langcode__langcode\";a:3:{i:0;s:18:\"attribute_value_id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.field_schema_data.attribute','a:2:{s:32:\"commerce_product_attribute_value\";a:2:{s:6:\"fields\";a:1:{s:9:\"attribute\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:44:\"commerce_product_attribute_value__c87679daf8\";a:1:{i:0;s:9:\"attribute\";}}}s:43:\"commerce_product_attribute_value_field_data\";a:2:{s:6:\"fields\";a:1:{s:9:\"attribute\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:44:\"commerce_product_attribute_value__c87679daf8\";a:1:{i:0;s:9:\"attribute\";}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.field_schema_data.attribute_value_id','a:2:{s:32:\"commerce_product_attribute_value\";a:1:{s:6:\"fields\";a:1:{s:18:\"attribute_value_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:43:\"commerce_product_attribute_value_field_data\";a:1:{s:6:\"fields\";a:1:{s:18:\"attribute_value_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.field_schema_data.changed','a:1:{s:43:\"commerce_product_attribute_value_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.field_schema_data.created','a:1:{s:43:\"commerce_product_attribute_value_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.field_schema_data.default_langcode','a:1:{s:43:\"commerce_product_attribute_value_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.field_schema_data.langcode','a:2:{s:32:\"commerce_product_attribute_value\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:43:\"commerce_product_attribute_value_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.field_schema_data.name','a:1:{s:43:\"commerce_product_attribute_value_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.field_schema_data.uuid','a:1:{s:32:\"commerce_product_attribute_value\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:44:\"commerce_product_attribute_value__b34e189361\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_product_attribute_value.field_schema_data.weight','a:1:{s:43:\"commerce_product_attribute_value_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.entity_schema_data','a:2:{s:26:\"commerce_product_variation\";a:1:{s:11:\"primary key\";a:1:{i:0;s:12:\"variation_id\";}}s:37:\"commerce_product_variation_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:12:\"variation_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:58:\"commerce_product_variation__id__default_langcode__langcode\";a:3:{i:0;s:12:\"variation_id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:39:\"commerce_product_variation__status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:12:\"variation_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.attribute_color','a:1:{s:43:\"commerce_product_variation__attribute_color\";a:4:{s:11:\"description\";s:66:\"Data storage for commerce_product_variation field attribute_color.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:25:\"attribute_color_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:25:\"attribute_color_target_id\";a:1:{i:0;s:25:\"attribute_color_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.attribute_size','a:1:{s:42:\"commerce_product_variation__attribute_size\";a:4:{s:11:\"description\";s:65:\"Data storage for commerce_product_variation field attribute_size.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:24:\"attribute_size_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:24:\"attribute_size_target_id\";a:1:{i:0;s:24:\"attribute_size_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.changed','a:1:{s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.created','a:1:{s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.default_langcode','a:1:{s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.field_description','a:1:{s:45:\"commerce_product_variation__field_description\";a:4:{s:11:\"description\";s:68:\"Data storage for commerce_product_variation field field_description.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:23:\"field_description_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:24:\"field_description_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:24:\"field_description_format\";a:1:{i:0;s:24:\"field_description_format\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.field_images','a:1:{s:40:\"commerce_product_variation__field_images\";a:5:{s:11:\"description\";s:63:\"Data storage for commerce_product_variation field field_images.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"field_images_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"field_images_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:18:\"field_images_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:18:\"field_images_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:19:\"field_images_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"field_images_target_id\";a:1:{i:0;s:22:\"field_images_target_id\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_images_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:22:\"field_images_target_id\";s:3:\"fid\";}}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.field_length','a:1:{s:40:\"commerce_product_variation__field_length\";a:4:{s:11:\"description\";s:63:\"Data storage for commerce_product_variation field field_length.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:18:\"field_length_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.field_old_price','a:1:{s:43:\"commerce_product_variation__field_old_price\";a:4:{s:11:\"description\";s:66:\"Data storage for commerce_product_variation field field_old_price.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"field_old_price_number\";a:5:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;s:8:\"not null\";b:0;}s:29:\"field_old_price_currency_code\";a:4:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.field_right_side_description','a:1:{s:38:\"commerce_product_variation__e2367ebae5\";a:4:{s:11:\"description\";s:79:\"Data storage for commerce_product_variation field field_right_side_description.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:34:\"field_right_side_description_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:35:\"field_right_side_description_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:35:\"field_right_side_description_format\";a:1:{i:0;s:35:\"field_right_side_description_format\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.field_sale_text','a:1:{s:43:\"commerce_product_variation__field_sale_text\";a:4:{s:11:\"description\";s:66:\"Data storage for commerce_product_variation field field_sale_text.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_sale_text_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.field_short_description','a:1:{s:38:\"commerce_product_variation__6541de6486\";a:4:{s:11:\"description\";s:74:\"Data storage for commerce_product_variation field field_short_description.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:29:\"field_short_description_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.field_waist','a:1:{s:39:\"commerce_product_variation__field_waist\";a:4:{s:11:\"description\";s:62:\"Data storage for commerce_product_variation field field_waist.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"field_waist_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.langcode','a:2:{s:26:\"commerce_product_variation\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.list_price','a:1:{s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:2:{s:18:\"list_price__number\";a:5:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;s:8:\"not null\";b:0;}s:25:\"list_price__currency_code\";a:4:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.price','a:1:{s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:2:{s:13:\"price__number\";a:5:{s:11:\"description\";s:11:\"The number.\";s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:19;s:5:\"scale\";i:6;s:8:\"not null\";b:0;}s:20:\"price__currency_code\";a:4:{s:11:\"description\";s:18:\"The currency code.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:3;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.product_id','a:1:{s:37:\"commerce_product_variation_field_data\";a:2:{s:6:\"fields\";a:1:{s:10:\"product_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:38:\"commerce_product_variation__cef18578b5\";a:1:{i:0;s:10:\"product_id\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.sku','a:1:{s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"sku\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.status','a:1:{s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.title','a:1:{s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.type','a:2:{s:26:\"commerce_product_variation\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:38:\"commerce_product_variation__fc57e9c936\";a:1:{i:0;s:4:\"type\";}}}s:37:\"commerce_product_variation_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:38:\"commerce_product_variation__fc57e9c936\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.uid','a:1:{s:37:\"commerce_product_variation_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:48:\"commerce_product_variation_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.uuid','a:1:{s:26:\"commerce_product_variation\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:45:\"commerce_product_variation_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_product_variation.field_schema_data.variation_id','a:2:{s:26:\"commerce_product_variation\";a:1:{s:6:\"fields\";a:1:{s:12:\"variation_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:37:\"commerce_product_variation_field_data\";a:1:{s:6:\"fields\";a:1:{s:12:\"variation_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_promotion.entity_schema_data','a:2:{s:18:\"commerce_promotion\";a:1:{s:11:\"primary key\";a:1:{i:0;s:12:\"promotion_id\";}}s:29:\"commerce_promotion_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:12:\"promotion_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:50:\"commerce_promotion__id__default_langcode__langcode\";a:3:{i:0;s:12:\"promotion_id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.compatibility','a:1:{s:29:\"commerce_promotion_field_data\";a:2:{s:6:\"fields\";a:1:{s:13:\"compatibility\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:46:\"commerce_promotion_field__compatibility__value\";a:1:{i:0;s:13:\"compatibility\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.conditions','a:1:{s:30:\"commerce_promotion__conditions\";a:4:{s:11:\"description\";s:53:\"Data storage for commerce_promotion field conditions.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:27:\"conditions_target_plugin_id\";a:4:{s:11:\"description\";s:14:\"The plugin ID.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:38:\"conditions_target_plugin_configuration\";a:4:{s:11:\"description\";s:25:\"The plugin configuration.\";s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.condition_operator','a:1:{s:29:\"commerce_promotion_field_data\";a:2:{s:6:\"fields\";a:1:{s:18:\"condition_operator\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:30:\"commerce_promotion__787d3617c5\";a:1:{i:0;s:18:\"condition_operator\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.coupons','a:1:{s:27:\"commerce_promotion__coupons\";a:4:{s:11:\"description\";s:50:\"Data storage for commerce_promotion field coupons.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"coupons_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:17:\"coupons_target_id\";a:1:{i:0;s:17:\"coupons_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.default_langcode','a:1:{s:29:\"commerce_promotion_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.description','a:1:{s:29:\"commerce_promotion_field_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.end_date','a:1:{s:29:\"commerce_promotion_field_data\";a:2:{s:6:\"fields\";a:1:{s:8:\"end_date\";a:4:{s:11:\"description\";s:15:\"The date value.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:41:\"commerce_promotion_field__end_date__value\";a:1:{i:0;s:8:\"end_date\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.langcode','a:2:{s:18:\"commerce_promotion\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:29:\"commerce_promotion_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.name','a:1:{s:29:\"commerce_promotion_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.offer','a:1:{s:29:\"commerce_promotion_field_data\";a:1:{s:6:\"fields\";a:2:{s:23:\"offer__target_plugin_id\";a:4:{s:11:\"description\";s:14:\"The plugin ID.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:34:\"offer__target_plugin_configuration\";a:4:{s:11:\"description\";s:25:\"The plugin configuration.\";s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:9:\"serialize\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.order_types','a:1:{s:31:\"commerce_promotion__order_types\";a:4:{s:11:\"description\";s:54:\"Data storage for commerce_promotion field order_types.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"order_types_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:21:\"order_types_target_id\";a:1:{i:0;s:21:\"order_types_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.promotion_id','a:2:{s:18:\"commerce_promotion\";a:1:{s:6:\"fields\";a:1:{s:12:\"promotion_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:29:\"commerce_promotion_field_data\";a:1:{s:6:\"fields\";a:1:{s:12:\"promotion_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.start_date','a:1:{s:29:\"commerce_promotion_field_data\";a:2:{s:6:\"fields\";a:1:{s:10:\"start_date\";a:4:{s:11:\"description\";s:15:\"The date value.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:43:\"commerce_promotion_field__start_date__value\";a:1:{i:0;s:10:\"start_date\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.status','a:1:{s:29:\"commerce_promotion_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.stores','a:1:{s:26:\"commerce_promotion__stores\";a:4:{s:11:\"description\";s:49:\"Data storage for commerce_promotion field stores.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:16:\"stores_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:16:\"stores_target_id\";a:1:{i:0;s:16:\"stores_target_id\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.usage_limit','a:1:{s:29:\"commerce_promotion_field_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"usage_limit\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.uuid','a:1:{s:18:\"commerce_promotion\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:37:\"commerce_promotion_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_promotion.field_schema_data.weight','a:1:{s:29:\"commerce_promotion_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_promotion_coupon.entity_schema_data','a:1:{s:25:\"commerce_promotion_coupon\";a:1:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}}}'),

('entity.storage_schema.sql','commerce_promotion_coupon.field_schema_data.code','a:1:{s:25:\"commerce_promotion_coupon\";a:1:{s:6:\"fields\";a:1:{s:4:\"code\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_promotion_coupon.field_schema_data.id','a:1:{s:25:\"commerce_promotion_coupon\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_promotion_coupon.field_schema_data.promotion_id','a:1:{s:25:\"commerce_promotion_coupon\";a:2:{s:6:\"fields\";a:1:{s:12:\"promotion_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:37:\"commerce_promotion_coupon__5167635140\";a:1:{i:0;s:12:\"promotion_id\";}}}}'),

('entity.storage_schema.sql','commerce_promotion_coupon.field_schema_data.status','a:1:{s:25:\"commerce_promotion_coupon\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_promotion_coupon.field_schema_data.usage_limit','a:1:{s:25:\"commerce_promotion_coupon\";a:1:{s:6:\"fields\";a:1:{s:11:\"usage_limit\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_promotion_coupon.field_schema_data.uuid','a:1:{s:25:\"commerce_promotion_coupon\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:44:\"commerce_promotion_coupon_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','commerce_store.entity_schema_data','a:2:{s:14:\"commerce_store\";a:1:{s:11:\"primary key\";a:1:{i:0;s:8:\"store_id\";}}s:25:\"commerce_store_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:8:\"store_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:46:\"commerce_store__id__default_langcode__langcode\";a:3:{i:0;s:8:\"store_id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.address','a:1:{s:25:\"commerce_store_field_data\";a:1:{s:6:\"fields\";a:13:{s:17:\"address__langcode\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}s:21:\"address__country_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2;s:8:\"not null\";b:0;}s:28:\"address__administrative_area\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:17:\"address__locality\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:27:\"address__dependent_locality\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:20:\"address__postal_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:21:\"address__sorting_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:22:\"address__address_line1\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:22:\"address__address_line2\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:21:\"address__organization\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:19:\"address__given_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:24:\"address__additional_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:20:\"address__family_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.billing_countries','a:1:{s:33:\"commerce_store__billing_countries\";a:4:{s:11:\"description\";s:56:\"Data storage for commerce_store field billing_countries.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:23:\"billing_countries_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:23:\"billing_countries_value\";a:1:{i:0;s:23:\"billing_countries_value\";}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.default_currency','a:1:{s:25:\"commerce_store_field_data\";a:2:{s:6:\"fields\";a:1:{s:16:\"default_currency\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:26:\"commerce_store__a0c0b29304\";a:1:{i:0;s:16:\"default_currency\";}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.default_langcode','a:1:{s:25:\"commerce_store_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.langcode','a:2:{s:14:\"commerce_store\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:25:\"commerce_store_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.mail','a:1:{s:25:\"commerce_store_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.name','a:1:{s:25:\"commerce_store_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.store_id','a:2:{s:14:\"commerce_store\";a:1:{s:6:\"fields\";a:1:{s:8:\"store_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:25:\"commerce_store_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"store_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.type','a:2:{s:14:\"commerce_store\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:37:\"commerce_store_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}s:25:\"commerce_store_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:37:\"commerce_store_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.uid','a:1:{s:25:\"commerce_store_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:36:\"commerce_store_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','commerce_store.field_schema_data.uuid','a:1:{s:14:\"commerce_store\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:33:\"commerce_store_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','file.entity_schema_data','a:1:{s:12:\"file_managed\";a:1:{s:11:\"primary key\";a:1:{i:0;s:3:\"fid\";}}}'),

('entity.storage_schema.sql','file.field_schema_data.changed','a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:19:\"file_field__changed\";a:1:{i:0;s:7:\"changed\";}}}}'),

('entity.storage_schema.sql','file.field_schema_data.created','a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','file.field_schema_data.fid','a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:3:\"fid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','file.field_schema_data.filemime','a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:8:\"filemime\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','file.field_schema_data.filename','a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:8:\"filename\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','file.field_schema_data.filesize','a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:8:\"filesize\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','file.field_schema_data.langcode','a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','file.field_schema_data.status','a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:18:\"file_field__status\";a:1:{i:0;s:6:\"status\";}}}}'),

('entity.storage_schema.sql','file.field_schema_data.uid','a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:26:\"file_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','file.field_schema_data.uri','a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:3:\"uri\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:15:\"file_field__uri\";a:1:{i:0;s:3:\"uri\";}}}}'),

('entity.storage_schema.sql','file.field_schema_data.uuid','a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:23:\"file_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','menu_link_content.entity_schema_data','a:4:{s:17:\"menu_link_content\";a:2:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:11:\"unique keys\";a:1:{s:30:\"menu_link_content__revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:26:\"menu_link_content_revision\";a:2:{s:11:\"primary key\";a:1:{i:0;s:11:\"revision_id\";}s:7:\"indexes\";a:1:{s:21:\"menu_link_content__id\";a:1:{i:0;s:2:\"id\";}}}s:22:\"menu_link_content_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:2:\"id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:49:\"menu_link_content__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:30:\"menu_link_content__revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:33:\"menu_link_content__enabled_bundle\";a:3:{i:0;s:7:\"enabled\";i:1;s:6:\"bundle\";i:2;s:2:\"id\";}}}s:32:\"menu_link_content_field_revision\";a:2:{s:11:\"primary key\";a:2:{i:0;s:11:\"revision_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:49:\"menu_link_content__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.bundle','a:2:{s:17:\"menu_link_content\";a:1:{s:6:\"fields\";a:1:{s:6:\"bundle\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"bundle\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.changed','a:2:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.default_langcode','a:2:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.description','a:2:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"description\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"description\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.enabled','a:2:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"enabled\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"enabled\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.expanded','a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"expanded\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.external','a:2:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"external\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"external\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.id','a:4:{s:17:\"menu_link_content\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:26:\"menu_link_content_revision\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.langcode','a:4:{s:17:\"menu_link_content\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:26:\"menu_link_content_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.link','a:2:{s:22:\"menu_link_content_data\";a:2:{s:6:\"fields\";a:3:{s:9:\"link__uri\";a:4:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;}s:11:\"link__title\";a:4:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:13:\"link__options\";a:5:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:34:\"menu_link_content_field__link__uri\";a:1:{i:0;a:2:{i:0;s:9:\"link__uri\";i:1;i:30;}}}}s:32:\"menu_link_content_field_revision\";a:2:{s:6:\"fields\";a:3:{s:9:\"link__uri\";a:4:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;}s:11:\"link__title\";a:4:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:13:\"link__options\";a:5:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:34:\"menu_link_content_field__link__uri\";a:1:{i:0;a:2:{i:0;s:9:\"link__uri\";i:1;i:30;}}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.menu_name','a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:9:\"menu_name\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.parent','a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"parent\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.rediscover','a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:10:\"rediscover\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.revision_created','a:1:{s:26:\"menu_link_content_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.revision_default','a:1:{s:26:\"menu_link_content_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.revision_id','a:4:{s:17:\"menu_link_content\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:26:\"menu_link_content_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.revision_log_message','a:1:{s:26:\"menu_link_content_revision\";a:1:{s:6:\"fields\";a:1:{s:20:\"revision_log_message\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.revision_translation_affected','a:2:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.revision_user','a:1:{s:26:\"menu_link_content_revision\";a:2:{s:6:\"fields\";a:1:{s:13:\"revision_user\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:29:\"menu_link_content__ef029a1897\";a:1:{i:0;s:13:\"revision_user\";}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.title','a:2:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}s:32:\"menu_link_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.uuid','a:1:{s:17:\"menu_link_content\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:36:\"menu_link_content_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','menu_link_content.field_schema_data.weight','a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.entity_schema_data','a:4:{s:4:\"node\";a:2:{s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:11:\"unique keys\";a:1:{s:9:\"node__vid\";a:1:{i:0;s:3:\"vid\";}}}s:13:\"node_revision\";a:2:{s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:7:\"indexes\";a:1:{s:9:\"node__nid\";a:1:{i:0;s:3:\"nid\";}}}s:15:\"node_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:5:{s:36:\"node__id__default_langcode__langcode\";a:3:{i:0;s:3:\"nid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:9:\"node__vid\";a:1:{i:0;s:3:\"vid\";}s:15:\"node__frontpage\";a:4:{i:0;s:7:\"promote\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}s:17:\"node__status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:16:\"node__title_type\";a:2:{i:0;s:5:\"title\";i:1;a:2:{i:0;s:4:\"type\";i:1;i:4;}}}}s:19:\"node_field_revision\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"vid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:36:\"node__id__default_langcode__langcode\";a:3:{i:0;s:3:\"nid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.body','a:2:{s:10:\"node__body\";a:4:{s:11:\"description\";s:33:\"Data storage for node field body.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}}s:19:\"node_revision__body\";a:4:{s:11:\"description\";s:45:\"Revision archive storage for node field body.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.changed','a:2:{s:15:\"node_field_data\";a:2:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:19:\"node_field__changed\";a:1:{i:0;s:7:\"changed\";}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.comment','a:2:{s:13:\"node__comment\";a:4:{s:11:\"description\";s:36:\"Data storage for node field comment.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:14:\"comment_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:22:\"node_revision__comment\";a:4:{s:11:\"description\";s:48:\"Revision archive storage for node field comment.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:14:\"comment_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.created','a:2:{s:15:\"node_field_data\";a:2:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:19:\"node_field__created\";a:1:{i:0;s:7:\"created\";}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.default_langcode','a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_blog_category','a:2:{s:25:\"node__field_blog_category\";a:4:{s:11:\"description\";s:48:\"Data storage for node field field_blog_category.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:29:\"field_blog_category_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:29:\"field_blog_category_target_id\";a:1:{i:0;s:29:\"field_blog_category_target_id\";}}}s:34:\"node_revision__field_blog_category\";a:4:{s:11:\"description\";s:60:\"Revision archive storage for node field field_blog_category.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:29:\"field_blog_category_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:29:\"field_blog_category_target_id\";a:1:{i:0;s:29:\"field_blog_category_target_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_category','a:2:{s:20:\"node__field_category\";a:4:{s:11:\"description\";s:43:\"Data storage for node field field_category.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:24:\"field_category_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:24:\"field_category_target_id\";a:1:{i:0;s:24:\"field_category_target_id\";}}}s:29:\"node_revision__field_category\";a:4:{s:11:\"description\";s:55:\"Revision archive storage for node field field_category.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:24:\"field_category_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:24:\"field_category_target_id\";a:1:{i:0;s:24:\"field_category_target_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_comments','a:2:{s:20:\"node__field_comments\";a:4:{s:11:\"description\";s:43:\"Data storage for node field field_comments.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_comments_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:29:\"node_revision__field_comments\";a:4:{s:11:\"description\";s:55:\"Revision archive storage for node field field_comments.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_comments_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_description','a:2:{s:23:\"node__field_description\";a:4:{s:11:\"description\";s:46:\"Data storage for node field field_description.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:23:\"field_description_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:24:\"field_description_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:24:\"field_description_format\";a:1:{i:0;s:24:\"field_description_format\";}}}s:32:\"node_revision__field_description\";a:4:{s:11:\"description\";s:58:\"Revision archive storage for node field field_description.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:23:\"field_description_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:24:\"field_description_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:24:\"field_description_format\";a:1:{i:0;s:24:\"field_description_format\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_gallery','a:2:{s:19:\"node__field_gallery\";a:4:{s:11:\"description\";s:42:\"Data storage for node field field_gallery.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:23:\"field_gallery_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:23:\"field_gallery_target_id\";a:1:{i:0;s:23:\"field_gallery_target_id\";}}}s:28:\"node_revision__field_gallery\";a:4:{s:11:\"description\";s:54:\"Revision archive storage for node field field_gallery.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:23:\"field_gallery_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:23:\"field_gallery_target_id\";a:1:{i:0;s:23:\"field_gallery_target_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_image','a:2:{s:17:\"node__field_image\";a:5:{s:11:\"description\";s:40:\"Data storage for node field field_image.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_image_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:15:\"field_image_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:17:\"field_image_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:17:\"field_image_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:18:\"field_image_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:21:\"field_image_target_id\";a:1:{i:0;s:21:\"field_image_target_id\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_image_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:21:\"field_image_target_id\";s:3:\"fid\";}}}}s:26:\"node_revision__field_image\";a:5:{s:11:\"description\";s:52:\"Revision archive storage for node field field_image.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_image_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:15:\"field_image_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:17:\"field_image_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:17:\"field_image_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:18:\"field_image_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:21:\"field_image_target_id\";a:1:{i:0;s:21:\"field_image_target_id\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_image_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:21:\"field_image_target_id\";s:3:\"fid\";}}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_images','a:2:{s:18:\"node__field_images\";a:5:{s:11:\"description\";s:41:\"Data storage for node field field_images.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"field_images_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"field_images_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:18:\"field_images_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:18:\"field_images_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:19:\"field_images_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"field_images_target_id\";a:1:{i:0;s:22:\"field_images_target_id\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_images_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:22:\"field_images_target_id\";s:3:\"fid\";}}}}s:27:\"node_revision__field_images\";a:5:{s:11:\"description\";s:53:\"Revision archive storage for node field field_images.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"field_images_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"field_images_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:18:\"field_images_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:18:\"field_images_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:19:\"field_images_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"field_images_target_id\";a:1:{i:0;s:22:\"field_images_target_id\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_images_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:22:\"field_images_target_id\";s:3:\"fid\";}}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_lead_text','a:2:{s:21:\"node__field_lead_text\";a:4:{s:11:\"description\";s:44:\"Data storage for node field field_lead_text.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_lead_text_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:22:\"field_lead_text_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"field_lead_text_format\";a:1:{i:0;s:22:\"field_lead_text_format\";}}}s:30:\"node_revision__field_lead_text\";a:4:{s:11:\"description\";s:56:\"Revision archive storage for node field field_lead_text.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_lead_text_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:22:\"field_lead_text_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"field_lead_text_format\";a:1:{i:0;s:22:\"field_lead_text_format\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_portfolio_category','a:2:{s:30:\"node__field_portfolio_category\";a:4:{s:11:\"description\";s:53:\"Data storage for node field field_portfolio_category.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:34:\"field_portfolio_category_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:34:\"field_portfolio_category_target_id\";a:1:{i:0;s:34:\"field_portfolio_category_target_id\";}}}s:39:\"node_revision__field_portfolio_category\";a:4:{s:11:\"description\";s:65:\"Revision archive storage for node field field_portfolio_category.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:34:\"field_portfolio_category_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:34:\"field_portfolio_category_target_id\";a:1:{i:0;s:34:\"field_portfolio_category_target_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_position','a:2:{s:20:\"node__field_position\";a:4:{s:11:\"description\";s:43:\"Data storage for node field field_position.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"field_position_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:29:\"node_revision__field_position\";a:4:{s:11:\"description\";s:55:\"Revision archive storage for node field field_position.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"field_position_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_project','a:2:{s:19:\"node__field_project\";a:4:{s:11:\"description\";s:42:\"Data storage for node field field_project.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:23:\"field_project_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:23:\"field_project_target_id\";a:1:{i:0;s:23:\"field_project_target_id\";}}}s:28:\"node_revision__field_project\";a:4:{s:11:\"description\";s:54:\"Revision archive storage for node field field_project.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:23:\"field_project_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:23:\"field_project_target_id\";a:1:{i:0;s:23:\"field_project_target_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_project_link','a:2:{s:24:\"node__field_project_link\";a:4:{s:11:\"description\";s:47:\"Data storage for node field field_project_link.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"field_project_link_uri\";a:4:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;}s:24:\"field_project_link_title\";a:4:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:26:\"field_project_link_options\";a:5:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"field_project_link_uri\";a:1:{i:0;a:2:{i:0;s:22:\"field_project_link_uri\";i:1;i:30;}}}}s:33:\"node_revision__field_project_link\";a:4:{s:11:\"description\";s:59:\"Revision archive storage for node field field_project_link.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"field_project_link_uri\";a:4:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;}s:24:\"field_project_link_title\";a:4:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:26:\"field_project_link_options\";a:5:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"field_project_link_uri\";a:1:{i:0;a:2:{i:0;s:22:\"field_project_link_uri\";i:1;i:30;}}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_second_title','a:2:{s:24:\"node__field_second_title\";a:4:{s:11:\"description\";s:47:\"Data storage for node field field_second_title.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:24:\"field_second_title_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:33:\"node_revision__field_second_title\";a:4:{s:11:\"description\";s:59:\"Revision archive storage for node field field_second_title.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:24:\"field_second_title_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_social_links','a:2:{s:24:\"node__field_social_links\";a:4:{s:11:\"description\";s:47:\"Data storage for node field field_social_links.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"field_social_links_uri\";a:4:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;}s:24:\"field_social_links_title\";a:4:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:26:\"field_social_links_options\";a:5:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"field_social_links_uri\";a:1:{i:0;a:2:{i:0;s:22:\"field_social_links_uri\";i:1;i:30;}}}}s:33:\"node_revision__field_social_links\";a:4:{s:11:\"description\";s:59:\"Revision archive storage for node field field_social_links.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"field_social_links_uri\";a:4:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;}s:24:\"field_social_links_title\";a:4:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:26:\"field_social_links_options\";a:5:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"field_social_links_uri\";a:1:{i:0;a:2:{i:0;s:22:\"field_social_links_uri\";i:1;i:30;}}}}}'),

('entity.storage_schema.sql','node.field_schema_data.field_tags','a:2:{s:16:\"node__field_tags\";a:4:{s:11:\"description\";s:39:\"Data storage for node field field_tags.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"field_tags_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:20:\"field_tags_target_id\";a:1:{i:0;s:20:\"field_tags_target_id\";}}}s:25:\"node_revision__field_tags\";a:4:{s:11:\"description\";s:51:\"Revision archive storage for node field field_tags.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"field_tags_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:20:\"field_tags_target_id\";a:1:{i:0;s:20:\"field_tags_target_id\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.langcode','a:4:{s:4:\"node\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:13:\"node_revision\";a:2:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:20:\"node_field__langcode\";a:1:{i:0;s:8:\"langcode\";}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.nid','a:4:{s:4:\"node\";a:1:{s:6:\"fields\";a:1:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.promote','a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.revision_default','a:1:{s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.revision_log','a:1:{s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:12:\"revision_log\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.revision_timestamp','a:1:{s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:18:\"revision_timestamp\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.revision_translation_affected','a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.revision_uid','a:1:{s:13:\"node_revision\";a:3:{s:6:\"fields\";a:1:{s:12:\"revision_uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:35:\"node_field__revision_uid__target_id\";a:1:{i:0;s:12:\"revision_uid\";}}s:12:\"foreign keys\";a:1:{s:24:\"node_field__revision_uid\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:12:\"revision_uid\";s:3:\"uid\";}}}}}'),

('entity.storage_schema.sql','node.field_schema_data.status','a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.sticky','a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.title','a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.type','a:2:{s:4:\"node\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:27:\"node_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}s:15:\"node_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:27:\"node_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.uid','a:2:{s:15:\"node_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:26:\"node_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}s:19:\"node_field_revision\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:26:\"node_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.uuid','a:1:{s:4:\"node\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:23:\"node_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','node.field_schema_data.vid','a:4:{s:4:\"node\";a:1:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','node.field_schema_data.webform','a:2:{s:13:\"node__webform\";a:4:{s:11:\"description\";s:36:\"Data storage for node field webform.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"webform_target_id\";a:4:{s:11:\"description\";s:29:\"The ID of the webform entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:20:\"webform_default_data\";a:3:{s:11:\"description\";s:24:\"Default submission data.\";s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:14:\"webform_status\";a:4:{s:11:\"description\";s:94:\"Flag to control whether this webform should be open, closed, or scheduled for new submissions.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;s:8:\"not null\";b:0;}s:12:\"webform_open\";a:4:{s:11:\"description\";s:19:\"The open date/time.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;s:8:\"not null\";b:0;}s:13:\"webform_close\";a:4:{s:11:\"description\";s:20:\"The close date/time.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:17:\"webform_target_id\";a:1:{i:0;s:17:\"webform_target_id\";}}}s:22:\"node_revision__webform\";a:4:{s:11:\"description\";s:48:\"Revision archive storage for node field webform.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:17:\"webform_target_id\";a:4:{s:11:\"description\";s:29:\"The ID of the webform entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:20:\"webform_default_data\";a:3:{s:11:\"description\";s:24:\"Default submission data.\";s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:14:\"webform_status\";a:4:{s:11:\"description\";s:94:\"Flag to control whether this webform should be open, closed, or scheduled for new submissions.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;s:8:\"not null\";b:0;}s:12:\"webform_open\";a:4:{s:11:\"description\";s:19:\"The open date/time.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;s:8:\"not null\";b:0;}s:13:\"webform_close\";a:4:{s:11:\"description\";s:20:\"The close date/time.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:17:\"webform_target_id\";a:1:{i:0;s:17:\"webform_target_id\";}}}}'),

('entity.storage_schema.sql','profile.entity_schema_data','a:2:{s:7:\"profile\";a:3:{s:11:\"primary key\";a:1:{i:0;s:10:\"profile_id\";}s:7:\"indexes\";a:2:{s:20:\"profile__status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:10:\"profile_id\";}s:35:\"profile__uid_type_status_is_default\";a:4:{i:0;s:3:\"uid\";i:1;s:4:\"type\";i:2;s:6:\"status\";i:3;s:10:\"is_default\";}}s:11:\"unique keys\";a:1:{s:20:\"profile__revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:16:\"profile_revision\";a:2:{s:11:\"primary key\";a:1:{i:0;s:11:\"revision_id\";}s:7:\"indexes\";a:1:{s:19:\"profile__profile_id\";a:1:{i:0;s:10:\"profile_id\";}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.address','a:2:{s:16:\"profile__address\";a:4:{s:11:\"description\";s:39:\"Data storage for profile field address.\";s:6:\"fields\";a:19:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:16:\"address_langcode\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}s:20:\"address_country_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2;s:8:\"not null\";b:0;}s:27:\"address_administrative_area\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:16:\"address_locality\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:26:\"address_dependent_locality\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:19:\"address_postal_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:20:\"address_sorting_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:21:\"address_address_line1\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:21:\"address_address_line2\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:20:\"address_organization\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:18:\"address_given_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:23:\"address_additional_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:19:\"address_family_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:25:\"profile_revision__address\";a:4:{s:11:\"description\";s:51:\"Revision archive storage for profile field address.\";s:6:\"fields\";a:19:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:16:\"address_langcode\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}s:20:\"address_country_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2;s:8:\"not null\";b:0;}s:27:\"address_administrative_area\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:16:\"address_locality\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:26:\"address_dependent_locality\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:19:\"address_postal_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:20:\"address_sorting_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:21:\"address_address_line1\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:21:\"address_address_line2\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:20:\"address_organization\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:18:\"address_given_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:23:\"address_additional_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:19:\"address_family_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.changed','a:2:{s:7:\"profile\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.created','a:2:{s:7:\"profile\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.data','a:2:{s:7:\"profile\";a:1:{s:6:\"fields\";a:1:{s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}}s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.is_default','a:2:{s:7:\"profile\";a:1:{s:6:\"fields\";a:1:{s:10:\"is_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:10:\"is_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.profile_id','a:2:{s:7:\"profile\";a:1:{s:6:\"fields\";a:1:{s:10:\"profile_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:10:\"profile_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.revision_created','a:1:{s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.revision_default','a:1:{s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.revision_id','a:2:{s:7:\"profile\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.revision_log_message','a:1:{s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:20:\"revision_log_message\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.revision_user','a:1:{s:16:\"profile_revision\";a:2:{s:6:\"fields\";a:1:{s:13:\"revision_user\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:39:\"profile_field__revision_user__target_id\";a:1:{i:0;s:13:\"revision_user\";}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.status','a:2:{s:7:\"profile\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:16:\"profile_revision\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.type','a:1:{s:7:\"profile\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:30:\"profile_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.uid','a:2:{s:7:\"profile\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:29:\"profile_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}s:16:\"profile_revision\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:29:\"profile_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','profile.field_schema_data.uuid','a:1:{s:7:\"profile\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:26:\"profile_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','shortcut.entity_schema_data','a:2:{s:8:\"shortcut\";a:1:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}}s:19:\"shortcut_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:2:\"id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:40:\"shortcut__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),

('entity.storage_schema.sql','shortcut.field_schema_data.default_langcode','a:1:{s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','shortcut.field_schema_data.id','a:2:{s:8:\"shortcut\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','shortcut.field_schema_data.langcode','a:2:{s:8:\"shortcut\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','shortcut.field_schema_data.link','a:1:{s:19:\"shortcut_field_data\";a:2:{s:6:\"fields\";a:3:{s:9:\"link__uri\";a:4:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;}s:11:\"link__title\";a:4:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:13:\"link__options\";a:5:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:25:\"shortcut_field__link__uri\";a:1:{i:0;a:2:{i:0;s:9:\"link__uri\";i:1;i:30;}}}}}'),

('entity.storage_schema.sql','shortcut.field_schema_data.shortcut_set','a:2:{s:8:\"shortcut\";a:2:{s:6:\"fields\";a:1:{s:12:\"shortcut_set\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:39:\"shortcut_field__shortcut_set__target_id\";a:1:{i:0;s:12:\"shortcut_set\";}}}s:19:\"shortcut_field_data\";a:2:{s:6:\"fields\";a:1:{s:12:\"shortcut_set\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:39:\"shortcut_field__shortcut_set__target_id\";a:1:{i:0;s:12:\"shortcut_set\";}}}}'),

('entity.storage_schema.sql','shortcut.field_schema_data.title','a:1:{s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','shortcut.field_schema_data.uuid','a:1:{s:8:\"shortcut\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:27:\"shortcut_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','shortcut.field_schema_data.weight','a:1:{s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','taxonomy_term.entity_schema_data','a:5:{s:18:\"taxonomy_term_data\";a:2:{s:11:\"primary key\";a:1:{i:0;s:3:\"tid\";}s:11:\"unique keys\";a:1:{s:26:\"taxonomy_term__revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:22:\"taxonomy_term_revision\";a:2:{s:11:\"primary key\";a:1:{i:0;s:11:\"revision_id\";}s:7:\"indexes\";a:1:{s:18:\"taxonomy_term__tid\";a:1:{i:0;s:3:\"tid\";}}}s:24:\"taxonomy_term_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"tid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:5:{s:45:\"taxonomy_term__id__default_langcode__langcode\";a:3:{i:0;s:3:\"tid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:26:\"taxonomy_term__revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:25:\"taxonomy_term__status_vid\";a:3:{i:0;s:6:\"status\";i:1;s:3:\"vid\";i:2;s:3:\"tid\";}s:19:\"taxonomy_term__tree\";a:3:{i:0;s:3:\"vid\";i:1;s:6:\"weight\";i:2;s:4:\"name\";}s:23:\"taxonomy_term__vid_name\";a:2:{i:0;s:3:\"vid\";i:1;s:4:\"name\";}}}s:28:\"taxonomy_term_field_revision\";a:2:{s:11:\"primary key\";a:2:{i:0;s:11:\"revision_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:45:\"taxonomy_term__id__default_langcode__langcode\";a:3:{i:0;s:3:\"tid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}s:14:\"taxonomy_index\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"tid\";}s:7:\"indexes\";a:1:{s:9:\"term_node\";a:4:{i:0;s:3:\"tid\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.changed','a:2:{s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}s:28:\"taxonomy_term_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.default_langcode','a:2:{s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:28:\"taxonomy_term_field_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.description','a:2:{s:24:\"taxonomy_term_field_data\";a:2:{s:6:\"fields\";a:2:{s:18:\"description__value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:19:\"description__format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:0:{}}s:28:\"taxonomy_term_field_revision\";a:2:{s:6:\"fields\";a:2:{s:18:\"description__value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:19:\"description__format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:40:\"taxonomy_term_field__description__format\";a:1:{i:0;s:19:\"description__format\";}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.langcode','a:4:{s:18:\"taxonomy_term_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:22:\"taxonomy_term_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:28:\"taxonomy_term_field_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.name','a:2:{s:24:\"taxonomy_term_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:25:\"taxonomy_term_field__name\";a:1:{i:0;s:4:\"name\";}}}s:28:\"taxonomy_term_field_revision\";a:1:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.parent','a:2:{s:21:\"taxonomy_term__parent\";a:4:{s:11:\"description\";s:44:\"Data storage for taxonomy_term field parent.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:16:\"parent_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:16:\"parent_target_id\";a:1:{i:0;s:16:\"parent_target_id\";}s:22:\"bundle_delta_target_id\";a:3:{i:0;s:6:\"bundle\";i:1;s:5:\"delta\";i:2;s:16:\"parent_target_id\";}}}s:30:\"taxonomy_term_revision__parent\";a:4:{s:11:\"description\";s:56:\"Revision archive storage for taxonomy_term field parent.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:16:\"parent_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:16:\"parent_target_id\";a:1:{i:0;s:16:\"parent_target_id\";}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.revision_created','a:1:{s:22:\"taxonomy_term_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.revision_default','a:1:{s:22:\"taxonomy_term_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.revision_id','a:4:{s:18:\"taxonomy_term_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:22:\"taxonomy_term_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:28:\"taxonomy_term_field_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.revision_log_message','a:1:{s:22:\"taxonomy_term_revision\";a:1:{s:6:\"fields\";a:1:{s:20:\"revision_log_message\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.revision_translation_affected','a:2:{s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}s:28:\"taxonomy_term_field_revision\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.revision_user','a:1:{s:22:\"taxonomy_term_revision\";a:2:{s:6:\"fields\";a:1:{s:13:\"revision_user\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:45:\"taxonomy_term_field__revision_user__target_id\";a:1:{i:0;s:13:\"revision_user\";}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.status','a:2:{s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:28:\"taxonomy_term_field_revision\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.tid','a:4:{s:18:\"taxonomy_term_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:22:\"taxonomy_term_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:28:\"taxonomy_term_field_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.uuid','a:1:{s:18:\"taxonomy_term_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:32:\"taxonomy_term_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.vid','a:2:{s:18:\"taxonomy_term_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:35:\"taxonomy_term_field__vid__target_id\";a:1:{i:0;s:3:\"vid\";}}}s:24:\"taxonomy_term_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:0:{}}}'),

('entity.storage_schema.sql','taxonomy_term.field_schema_data.weight','a:1:{s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','user.entity_schema_data','a:2:{s:5:\"users\";a:1:{s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}}s:16:\"users_field_data\";a:3:{s:11:\"primary key\";a:2:{i:0;s:3:\"uid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:36:\"user__id__default_langcode__langcode\";a:3:{i:0;s:3:\"uid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}s:11:\"unique keys\";a:1:{s:10:\"user__name\";a:2:{i:0;s:4:\"name\";i:1;s:8:\"langcode\";}}}}'),

('entity.storage_schema.sql','user.field_schema_data.access','a:1:{s:16:\"users_field_data\";a:2:{s:6:\"fields\";a:1:{s:6:\"access\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:18:\"user_field__access\";a:1:{i:0;s:6:\"access\";}}}}'),

('entity.storage_schema.sql','user.field_schema_data.changed','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.commerce_remote_id','a:1:{s:24:\"user__commerce_remote_id\";a:4:{s:11:\"description\";s:47:\"Data storage for user field commerce_remote_id.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:27:\"commerce_remote_id_provider\";a:4:{s:11:\"description\";s:13:\"The provider.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:28:\"commerce_remote_id_remote_id\";a:4:{s:11:\"description\";s:14:\"The remote ID.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),

('entity.storage_schema.sql','user.field_schema_data.created','a:1:{s:16:\"users_field_data\";a:2:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:19:\"user_field__created\";a:1:{i:0;s:7:\"created\";}}}}'),

('entity.storage_schema.sql','user.field_schema_data.default_langcode','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.init','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"init\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.langcode','a:2:{s:5:\"users\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.login','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"login\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.mail','a:1:{s:16:\"users_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:16:\"user_field__mail\";a:1:{i:0;s:4:\"mail\";}}}}'),

('entity.storage_schema.sql','user.field_schema_data.name','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.pass','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"pass\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.preferred_admin_langcode','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:24:\"preferred_admin_langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.preferred_langcode','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:18:\"preferred_langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.roles','a:1:{s:11:\"user__roles\";a:4:{s:11:\"description\";s:34:\"Data storage for user field roles.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:15:\"roles_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:15:\"roles_target_id\";a:1:{i:0;s:15:\"roles_target_id\";}}}}'),

('entity.storage_schema.sql','user.field_schema_data.status','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.timezone','a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"timezone\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.uid','a:2:{s:5:\"users\";a:1:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','user.field_schema_data.user_picture','a:1:{s:18:\"user__user_picture\";a:5:{s:11:\"description\";s:41:\"Data storage for user field user_picture.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"user_picture_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"user_picture_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:18:\"user_picture_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:18:\"user_picture_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:19:\"user_picture_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"user_picture_target_id\";a:1:{i:0;s:22:\"user_picture_target_id\";}}s:12:\"foreign keys\";a:1:{s:22:\"user_picture_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:22:\"user_picture_target_id\";s:3:\"fid\";}}}}}'),

('entity.storage_schema.sql','user.field_schema_data.uuid','a:1:{s:5:\"users\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:23:\"user_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','vote.entity_schema_data','a:1:{s:14:\"votingapi_vote\";a:1:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}}}'),

('entity.storage_schema.sql','vote.field_schema_data.entity_id','a:1:{s:14:\"votingapi_vote\";a:2:{s:6:\"fields\";a:1:{s:9:\"entity_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:32:\"vote_field__entity_id__target_id\";a:1:{i:0;s:9:\"entity_id\";}}}}'),

('entity.storage_schema.sql','vote.field_schema_data.entity_type','a:1:{s:14:\"votingapi_vote\";a:1:{s:6:\"fields\";a:1:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','vote.field_schema_data.id','a:1:{s:14:\"votingapi_vote\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','vote.field_schema_data.timestamp','a:1:{s:14:\"votingapi_vote\";a:1:{s:6:\"fields\";a:1:{s:9:\"timestamp\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','vote.field_schema_data.type','a:1:{s:14:\"votingapi_vote\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:27:\"vote_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','vote.field_schema_data.user_id','a:1:{s:14:\"votingapi_vote\";a:2:{s:6:\"fields\";a:1:{s:7:\"user_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:30:\"vote_field__user_id__target_id\";a:1:{i:0;s:7:\"user_id\";}}}}'),

('entity.storage_schema.sql','vote.field_schema_data.uuid','a:1:{s:14:\"votingapi_vote\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:23:\"vote_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','vote.field_schema_data.value','a:1:{s:14:\"votingapi_vote\";a:1:{s:6:\"fields\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:5:\"float\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','vote.field_schema_data.value_type','a:1:{s:14:\"votingapi_vote\";a:1:{s:6:\"fields\";a:1:{s:10:\"value_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','vote.field_schema_data.vote_source','a:1:{s:14:\"votingapi_vote\";a:1:{s:6:\"fields\";a:1:{s:11:\"vote_source\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','vote_result.entity_schema_data','a:1:{s:16:\"votingapi_result\";a:1:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}}}'),

('entity.storage_schema.sql','vote_result.field_schema_data.entity_id','a:1:{s:16:\"votingapi_result\";a:2:{s:6:\"fields\";a:1:{s:9:\"entity_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:39:\"vote_result_field__entity_id__target_id\";a:1:{i:0;s:9:\"entity_id\";}}}}'),

('entity.storage_schema.sql','vote_result.field_schema_data.entity_type','a:1:{s:16:\"votingapi_result\";a:1:{s:6:\"fields\";a:1:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','vote_result.field_schema_data.function','a:1:{s:16:\"votingapi_result\";a:1:{s:6:\"fields\";a:1:{s:8:\"function\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:100;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','vote_result.field_schema_data.id','a:1:{s:16:\"votingapi_result\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','vote_result.field_schema_data.timestamp','a:1:{s:16:\"votingapi_result\";a:1:{s:6:\"fields\";a:1:{s:9:\"timestamp\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','vote_result.field_schema_data.type','a:1:{s:16:\"votingapi_result\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:34:\"vote_result_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),

('entity.storage_schema.sql','vote_result.field_schema_data.value','a:1:{s:16:\"votingapi_result\";a:1:{s:6:\"fields\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:5:\"float\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','vote_result.field_schema_data.value_type','a:1:{s:16:\"votingapi_result\";a:1:{s:6:\"fields\";a:1:{s:10:\"value_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.entity_schema_data','a:2:{s:18:\"webform_submission\";a:1:{s:11:\"primary key\";a:1:{i:0;s:3:\"sid\";}}s:23:\"webform_submission_data\";a:2:{s:11:\"primary key\";a:4:{i:0;s:3:\"sid\";i:1;s:4:\"name\";i:2;s:8:\"property\";i:3;s:5:\"delta\";}s:7:\"indexes\";a:2:{s:10:\"webform_id\";a:1:{i:0;s:10:\"webform_id\";}s:14:\"sid_webform_id\";a:2:{i:0;s:3:\"sid\";i:1;s:10:\"webform_id\";}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.changed','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.completed','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:9:\"completed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.created','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.current_page','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:12:\"current_page\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.entity_id','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:9:\"entity_id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.entity_type','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.in_draft','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:8:\"in_draft\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.langcode','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.locked','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:6:\"locked\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.notes','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:5:\"notes\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.remote_addr','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:11:\"remote_addr\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.serial','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:6:\"serial\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.sid','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:3:\"sid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.sticky','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.token','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:5:\"token\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.uid','a:1:{s:18:\"webform_submission\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:40:\"webform_submission_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.uri','a:1:{s:18:\"webform_submission\";a:1:{s:6:\"fields\";a:1:{s:3:\"uri\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2000;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.uuid','a:1:{s:18:\"webform_submission\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:37:\"webform_submission_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),

('entity.storage_schema.sql','webform_submission.field_schema_data.webform_id','a:1:{s:18:\"webform_submission\";a:2:{s:6:\"fields\";a:1:{s:10:\"webform_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:47:\"webform_submission_field__webform_id__target_id\";a:1:{i:0;s:10:\"webform_id\";}}}}'),

('entity.update_backup','menu_link_content.57c6cf','a:4:{s:11:\"entity_type\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:6:\"bundle\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:9:\"published\";s:7:\"enabled\";}s:5:\"\0*\0id\";s:17:\"menu_link_content\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:14:\"storage_schema\";s:53:\"Drupal\\menu_link_content\\MenuLinkContentStorageSchema\";s:6:\"access\";s:60:\"Drupal\\menu_link_content\\MenuLinkContentAccessControlHandler\";s:4:\"form\";a:2:{s:7:\"default\";s:49:\"Drupal\\menu_link_content\\Form\\MenuLinkContentForm\";s:6:\"delete\";s:55:\"Drupal\\menu_link_content\\Form\\MenuLinkContentDeleteForm\";}s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";s:15:\"administer menu\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"canonical\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:9:\"edit-form\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:11:\"delete-form\";s:53:\"/admin/structure/menu/item/{menu_link_content}/delete\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:17:\"menu_link_content\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:22:\"menu_link_content_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:22:\"menu_link_content_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\";s:11:\"\0*\0provider\";s:17:\"menu_link_content\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:25:\"field_storage_definitions\";a:16:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:73;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"The entity ID for this menu link content entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:110;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The content menu link UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:146;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"The menu link language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"bundle\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:184;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";s:0:\"\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"The content menu link bundle.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"bundle\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:216;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Menu link title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The text to be used for this link in the menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:262;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Shown when hovering over the menu link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:9:\"menu_name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:306;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Menu name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:93:\"The menu name. All links with the same menu name (such as \"tools\") are part of the same menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"tools\";}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:9:\"menu_name\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"link\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:3:{s:3:\"uri\";a:3:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;}s:5:\"title\";a:3:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:7:\"options\";a:4:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:1:{s:3:\"uri\";a:1:{i:0;a:2:{i:0;s:3:\"uri\";i:1;i:30;}}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:342;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:link\";s:8:\"settings\";a:2:{s:5:\"title\";i:0;s:9:\"link_type\";i:17;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The location this menu link points to.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:12:\"link_default\";s:6:\"weight\";i:-2;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"link\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"external\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:393;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"External\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:120:\"A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"external\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:10:\"rediscover\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:433;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"Indicates whether the menu link should be rediscovered\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:10:\"rediscover\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:469;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:172:\"Link weight among links in the same menu at the same depth. In the menu, the links with high weight will sink and links with a low weight will be positioned nearer the top.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"integer\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:6:\"number\";s:6:\"weight\";i:20;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"expanded\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:518;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Show as expanded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:82:\"If selected and this menu link has children, the menu will always appear expanded.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"expanded\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"enabled\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:569;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Enabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:65:\"A flag for whether the link should be enabled in menus or hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:-1;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"enabled\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:620;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Parent plugin ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"The ID of the parent menu link plugin, or empty string when at the top level of the hierarchy.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:653;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"The time that the menu link was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:682;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}}s:13:\"table_mapping\";O:42:\"Drupal\\Core\\Entity\\Sql\\DefaultTableMapping\":11:{s:13:\"\0*\0entityType\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:6:\"bundle\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:9:\"published\";s:7:\"enabled\";}s:5:\"\0*\0id\";s:17:\"menu_link_content\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:14:\"storage_schema\";s:53:\"Drupal\\menu_link_content\\MenuLinkContentStorageSchema\";s:6:\"access\";s:60:\"Drupal\\menu_link_content\\MenuLinkContentAccessControlHandler\";s:4:\"form\";a:2:{s:7:\"default\";s:49:\"Drupal\\menu_link_content\\Form\\MenuLinkContentForm\";s:6:\"delete\";s:55:\"Drupal\\menu_link_content\\Form\\MenuLinkContentDeleteForm\";}s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";s:15:\"administer menu\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"canonical\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:9:\"edit-form\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:11:\"delete-form\";s:53:\"/admin/structure/menu/item/{menu_link_content}/delete\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:17:\"menu_link_content\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:22:\"menu_link_content_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:22:\"menu_link_content_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\";s:11:\"\0*\0provider\";s:17:\"menu_link_content\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:26:\"\0*\0fieldStorageDefinitions\";a:16:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:796;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"The entity ID for this menu link content entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:833;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The content menu link UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:869;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"The menu link language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"bundle\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:907;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";s:0:\"\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"The content menu link bundle.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"bundle\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:939;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Menu link title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The text to be used for this link in the menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:985;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Shown when hovering over the menu link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:9:\"menu_name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1029;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Menu name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:93:\"The menu name. All links with the same menu name (such as \"tools\") are part of the same menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"tools\";}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:9:\"menu_name\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"link\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:3:{s:3:\"uri\";a:3:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;}s:5:\"title\";a:3:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:7:\"options\";a:4:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:1:{s:3:\"uri\";a:1:{i:0;a:2:{i:0;s:3:\"uri\";i:1;i:30;}}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1065;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:link\";s:8:\"settings\";a:2:{s:5:\"title\";i:0;s:9:\"link_type\";i:17;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The location this menu link points to.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:12:\"link_default\";s:6:\"weight\";i:-2;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"link\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"external\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1116;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"External\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:120:\"A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"external\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:10:\"rediscover\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1156;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"Indicates whether the menu link should be rediscovered\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:10:\"rediscover\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1192;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:172:\"Link weight among links in the same menu at the same depth. In the menu, the links with high weight will sink and links with a low weight will be positioned nearer the top.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"integer\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:6:\"number\";s:6:\"weight\";i:20;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"expanded\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1241;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Show as expanded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:82:\"If selected and this menu link has children, the menu will always appear expanded.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"expanded\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"enabled\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1292;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Enabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:65:\"A flag for whether the link should be enabled in menus or hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:-1;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"enabled\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1343;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Parent plugin ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"The ID of the parent menu link plugin, or empty string when at the top level of the hierarchy.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1376;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"The time that the menu link was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:1405;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}}s:9:\"\0*\0prefix\";s:10:\"old_57c6cf\";s:12:\"\0*\0baseTable\";s:27:\"old_57c6cfmenu_link_content\";s:16:\"\0*\0revisionTable\";N;s:12:\"\0*\0dataTable\";s:32:\"old_57c6cfmenu_link_content_data\";s:20:\"\0*\0revisionDataTable\";N;s:13:\"\0*\0fieldNames\";a:2:{s:27:\"old_57c6cfmenu_link_content\";a:4:{i:0;s:2:\"id\";i:1;s:6:\"bundle\";i:2;s:4:\"uuid\";i:3;s:8:\"langcode\";}s:32:\"old_57c6cfmenu_link_content_data\";a:15:{i:0;s:2:\"id\";i:1;s:6:\"bundle\";i:2;s:8:\"langcode\";i:3;s:5:\"title\";i:4;s:11:\"description\";i:5;s:9:\"menu_name\";i:6;s:4:\"link\";i:7;s:8:\"external\";i:8;s:10:\"rediscover\";i:9;s:6:\"weight\";i:10;s:8:\"expanded\";i:11;s:7:\"enabled\";i:12;s:6:\"parent\";i:13;s:7:\"changed\";i:14;s:16:\"default_langcode\";}}s:15:\"\0*\0extraColumns\";a:0:{}s:16:\"\0*\0columnMapping\";a:0:{}s:13:\"\0*\0allColumns\";a:0:{}}s:12:\"request_time\";i:1561189067;}'),

('entity.update_backup','taxonomy_term.f979f4','a:4:{s:11:\"entity_type\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:0:{}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:0:{}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:3:\"tid\";s:6:\"bundle\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:9:\"published\";s:6:\"status\";}s:5:\"\0*\0id\";s:13:\"taxonomy_term\";s:16:\"\0*\0originalClass\";N;s:11:\"\0*\0handlers\";a:7:{s:7:\"storage\";s:27:\"Drupal\\taxonomy\\TermStorage\";s:14:\"storage_schema\";s:33:\"Drupal\\taxonomy\\TermStorageSchema\";s:12:\"view_builder\";s:31:\"Drupal\\taxonomy\\TermViewBuilder\";s:6:\"access\";s:40:\"Drupal\\taxonomy\\TermAccessControlHandler\";s:10:\"views_data\";s:29:\"Drupal\\taxonomy\\TermViewsData\";s:4:\"form\";a:2:{s:7:\"default\";s:24:\"Drupal\\taxonomy\\TermForm\";s:6:\"delete\";s:35:\"Drupal\\taxonomy\\Form\\TermDeleteForm\";}s:11:\"translation\";s:38:\"Drupal\\taxonomy\\TermTranslationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:3:{s:9:\"canonical\";s:30:\"/taxonomy/term/{taxonomy_term}\";s:11:\"delete-form\";s:37:\"/taxonomy/term/{taxonomy_term}/delete\";s:9:\"edit-form\";s:35:\"/taxonomy/term/{taxonomy_term}/edit\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:19:\"taxonomy_vocabulary\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:18:\"taxonomy_term_data\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:24:\"taxonomy_term_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";s:17:\"taxonomy_term_uri\";s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:40:\"entity.taxonomy_vocabulary.overview_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"taxonomy_term_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\taxonomy\\Entity\\Term\";s:11:\"\0*\0provider\";s:8:\"taxonomy\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:25:\"field_storage_definitions\";a:11:{s:3:\"tid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:78;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Term ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The term ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:3:\"tid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:115;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The term UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:151;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:4:\"type\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The term language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:3:\"vid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:189;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:19:\"taxonomy_vocabulary\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The vocabulary to which the term is assigned.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:3:\"vid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:226;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The term name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}s:6:\"format\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:272;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:text_long\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"A description of the term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:14:\"text_textfield\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:319;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"The weight of this term in relation to other terms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:358;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:13:\"taxonomy_term\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The parents of this term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:14:\"custom_storage\";b:0;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:395;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the term was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:424;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:466;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Publishing status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"A boolean indicating the published state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:8:\"provider\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}}s:13:\"table_mapping\";O:42:\"Drupal\\Core\\Entity\\Sql\\DefaultTableMapping\":11:{s:13:\"\0*\0entityType\";r:2;s:26:\"\0*\0fieldStorageDefinitions\";a:11:{s:3:\"tid\";r:78;s:4:\"uuid\";r:115;s:8:\"langcode\";r:151;s:3:\"vid\";r:189;s:4:\"name\";r:226;s:11:\"description\";r:272;s:6:\"weight\";r:319;s:6:\"parent\";r:358;s:7:\"changed\";r:395;s:16:\"default_langcode\";r:424;s:6:\"status\";r:466;}s:9:\"\0*\0prefix\";s:10:\"old_f979f4\";s:12:\"\0*\0baseTable\";s:28:\"old_f979f4taxonomy_term_data\";s:16:\"\0*\0revisionTable\";N;s:12:\"\0*\0dataTable\";s:34:\"old_f979f4taxonomy_term_field_data\";s:20:\"\0*\0revisionDataTable\";N;s:13:\"\0*\0fieldNames\";a:3:{s:28:\"old_f979f4taxonomy_term_data\";a:4:{i:0;s:3:\"tid\";i:1;s:3:\"vid\";i:2;s:4:\"uuid\";i:3;s:8:\"langcode\";}s:34:\"old_f979f4taxonomy_term_field_data\";a:9:{i:0;s:3:\"tid\";i:1;s:3:\"vid\";i:2;s:8:\"langcode\";i:3;s:4:\"name\";i:4;s:11:\"description\";i:5;s:6:\"weight\";i:6;s:7:\"changed\";i:7;s:16:\"default_langcode\";i:8;s:6:\"status\";}s:31:\"old_f979f4taxonomy_term__parent\";a:1:{i:0;s:6:\"parent\";}}s:15:\"\0*\0extraColumns\";a:1:{s:31:\"old_f979f4taxonomy_term__parent\";a:6:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";}}s:16:\"\0*\0columnMapping\";a:0:{}s:13:\"\0*\0allColumns\";a:0:{}}s:12:\"request_time\";i:1561189075;}'),

('entity_autocomplete','-PK6pCVfCwE7EvEza49-9690AJW3HOdHiNgnizlirp4','a:1:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}}'),

('entity_autocomplete','1oHs-9ilgRvWrXm7LYt5NfFuJaIvfvhtzIZwn0VFKvw','a:0:{}'),

('entity_autocomplete','45v9_sylL0bJURXqbDvx6Kk_4vmp40PVmGpXx4FPU1E','a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}'),

('entity_autocomplete','4rmIKeHCQcQx1FlO4nHx6y_5KJrjZcJ5P3mF1odOCU4','a:3:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:1;}'),

('entity_autocomplete','EmnTXD9f-DE89e6g2ukZJVpqi92dAeSUfXtDdWk7r-Y','a:4:{s:14:\"target_bundles\";a:1:{s:18:\"portfolio_category\";s:18:\"portfolio_category\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}'),

('entity_autocomplete','HQ992d6TeDdySQVPkOI88VdIdBf9AshiALtPm4KI4nQ','a:0:{}'),

('entity_autocomplete','KIXyScq7aVNR4LUhHOooJkKYSzpcegcolQnoXIFEugU','a:1:{s:17:\"include_anonymous\";b:0;}'),

('entity_autocomplete','psr1P524vgQYr4lTYVF_lwLtOLBHw5ZZMBBz6NkLtRI','a:4:{s:14:\"target_bundles\";a:1:{s:7:\"project\";s:7:\"project\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:8:\"category\";}'),

('entity_autocomplete','qQATPhxmWkoKr_0jKwhneKRqsENn_o_YIHpV2B0P2VM','a:4:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";}'),

('entity_autocomplete','rU5cfhK33YYPbNGRjXkMeumAR-_ixVZTRbKhDNe4jwc','a:1:{s:17:\"include_anonymous\";b:1;}'),

('entity_autocomplete','td8-a0Sd8mJiFxhwEFSuCecohCaCgL1zQf3_-DN50oM','a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}'),

('entity_autocomplete','vx6h4Tu5IsNqrSxAtoTiGq4hKWQ_-lsyMLtLepSwtoQ','a:4:{s:14:\"target_bundles\";a:1:{s:8:\"category\";s:8:\"category\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}'),

('entity_autocomplete','W2iqqzP4f5trhF3DfdsFwZh4frUpXQSvOoiCTfQzzjE','a:0:{}'),

('entity_autocomplete','WuI9tpoodlf1T8XfaoU1LZ7yGtIrvhJQZJ8fDxMGt7k','a:4:{s:14:\"target_bundles\";a:1:{s:13:\"blog_category\";s:13:\"blog_category\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}'),

('entity_autocomplete','yCL_cknZoJWDrXizdhVVUlwJm5o1LaLVK_9LN-Oq2YI','a:4:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";}'),

('entity_autocomplete','zKfRMvOeNMXOxRsNYdu-J1Oo2NbVkG2gADRnnuwqcUo','a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}'),

('entity_autocomplete','_5DZYOnofgOQ230GXaAIAFJA7UnnmjxGbRwILDrB9J4','a:5:{s:14:\"target_bundles\";a:1:{s:8:\"category\";s:8:\"category\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}'),

('pathauto_state.commerce_product','1','i:1;'),

('pathauto_state.commerce_product','2','i:1;'),

('pathauto_state.commerce_product','3','i:1;'),

('pathauto_state.commerce_product','4','i:1;'),

('pathauto_state.node','107','i:1;'),

('pathauto_state.node','43','i:1;'),

('pathauto_state.node','70','i:1;'),

('pathauto_state.taxonomy_term','36','i:0;'),

('pathauto_state.taxonomy_term','37','i:0;'),

('pathauto_state.taxonomy_term','38','i:0;'),

('pathauto_state.taxonomy_term','39','i:0;'),

('pathauto_state.user','1','i:0;'),

('pathauto_state.user','7','i:0;'),

('pathauto_state.user','8','i:0;'),

('post_update','existing_updates','a:103:{i:0;s:64:\"system_post_update_recalculate_configuration_entity_dependencies\";i:1;s:43:\"field_post_update_email_widget_size_setting\";i:2;s:50:\"field_post_update_entity_reference_handler_setting\";i:3;s:46:\"field_post_update_save_custom_storage_property\";i:4;s:54:\"block_post_update_disable_blocks_with_missing_contexts\";i:5;s:42:\"block_post_update_fix_negate_in_conditions\";i:6;s:56:\"editor_post_update_clear_cache_for_file_reference_filter\";i:7;s:62:\"contact_post_update_add_message_redirect_field_to_contact_form\";i:8;s:42:\"image_post_update_image_style_dependencies\";i:9;s:39:\"views_post_update_boolean_filter_values\";i:10;s:46:\"views_post_update_cleanup_duplicate_views_data\";i:11;s:46:\"views_post_update_field_formatter_dependencies\";i:12;s:41:\"views_post_update_serializer_dependencies\";i:13;s:36:\"views_post_update_taxonomy_index_tid\";i:14;s:46:\"views_post_update_update_cacheability_metadata\";i:15;s:37:\"file_browser_post_update_default_uuid\";i:16;s:53:\"rest_post_update_create_rest_resource_config_entities\";i:17;s:37:\"rest_post_update_resource_granularity\";i:18;s:40:\"block_post_update_disabled_region_update\";i:19;s:48:\"system_post_update_add_region_to_entity_displays\";i:20;s:37:\"system_post_update_hashes_clear_cache\";i:21;s:36:\"system_post_update_timestamp_plugins\";i:22;s:45:\"user_post_update_enforce_order_of_permissions\";i:23;s:33:\"views_post_update_grouped_filters\";i:24;s:46:\"address_post_update_convert_names_subdivisions\";i:25;s:28:\"commerce_store_post_update_1\";i:26;s:28:\"commerce_order_post_update_1\";i:27;s:28:\"commerce_order_post_update_2\";i:28;s:28:\"commerce_order_post_update_3\";i:29;s:28:\"commerce_order_post_update_4\";i:30;s:28:\"commerce_order_post_update_5\";i:31;s:30:\"commerce_product_post_update_1\";i:32;s:27:\"commerce_cart_post_update_1\";i:33;s:27:\"commerce_cart_post_update_2\";i:34;s:31:\"commerce_checkout_post_update_1\";i:35;s:26:\"commerce_log_post_update_1\";i:36;s:26:\"commerce_log_post_update_2\";i:37;s:32:\"commerce_promotion_post_update_1\";i:38;s:32:\"commerce_promotion_post_update_2\";i:39;s:32:\"commerce_promotion_post_update_3\";i:40;s:32:\"commerce_promotion_post_update_4\";i:41;s:28:\"commerce_order_post_update_6\";i:42;s:30:\"commerce_payment_post_update_1\";i:43;s:30:\"commerce_payment_post_update_2\";i:44;s:30:\"commerce_product_post_update_2\";i:45;s:30:\"commerce_product_post_update_3\";i:46;s:30:\"commerce_product_post_update_4\";i:47;s:32:\"commerce_promotion_post_update_6\";i:48;s:32:\"commerce_promotion_post_update_7\";i:49;s:32:\"commerce_promotion_post_update_8\";i:50;s:28:\"commerce_store_post_update_2\";i:51;s:45:\"comment_post_update_enable_comment_admin_view\";i:52;s:49:\"dblog_post_update_convert_recent_messages_to_view\";i:53;s:47:\"field_post_update_remove_handler_submit_setting\";i:54;s:43:\"language_post_update_language_select_widget\";i:55;s:46:\"node_post_update_configure_status_field_widget\";i:56;s:41:\"system_post_update_classy_message_library\";i:57;s:37:\"system_post_update_field_type_plugins\";i:58;s:42:\"views_post_update_revision_metadata_fields\";i:59;s:28:\"commerce_order_post_update_7\";i:60;s:40:\"system_post_update_change_action_plugins\";i:61;s:48:\"system_post_update_field_formatter_entity_schema\";i:62;s:34:\"views_post_update_bulk_field_moved\";i:63;s:33:\"views_post_update_entity_link_url\";i:64;s:41:\"views_post_update_filter_placeholder_text\";i:65;s:45:\"views_post_update_table_display_cache_max_age\";i:66;s:47:\"views_post_update_views_data_table_dependencies\";i:67;s:38:\"address_post_update_clear_country_list\";i:68;s:28:\"commerce_order_post_update_8\";i:69;s:30:\"commerce_product_post_update_5\";i:70;s:32:\"commerce_promotion_post_update_9\";i:71;s:28:\"commerce_order_post_update_9\";i:72;s:30:\"commerce_product_post_update_6\";i:73;s:51:\"block_content_post_update_add_views_reusable_filter\";i:74;s:50:\"image_post_update_scale_and_crop_effect_add_anchor\";i:75;s:47:\"system_post_update_change_delete_action_plugins\";i:76;s:31:\"system_post_update_extra_fields\";i:77;s:41:\"system_post_update_language_item_callback\";i:78;s:64:\"taxonomy_post_update_clear_entity_bundle_field_definitions_cache\";i:79;s:43:\"taxonomy_post_update_clear_views_data_cache\";i:80;s:63:\"taxonomy_post_update_handle_publishing_status_addition_in_views\";i:81;s:30:\"commerce_product_post_update_7\";i:82;s:48:\"contextual_post_update_fixed_endpoint_and_markup\";i:83;s:37:\"system_post_update_states_clear_cache\";i:84;s:41:\"node_post_update_node_revision_views_data\";i:85;s:33:\"commerce_promotion_post_update_10\";i:86;s:23:\"rest_post_update_161923\";i:87;s:41:\"profile_post_update_add_revision_settings\";i:88;s:47:\"profile_post_update_change_delete_action_plugin\";i:89;s:49:\"profile_post_update_change_publish_action_plugins\";i:90;s:48:\"profile_post_update_configure_register_form_mode\";i:91;s:36:\"system_post_update_fix_jquery_extend\";i:92;s:42:\"comment_post_update_add_ip_address_setting\";i:93;s:65:\"menu_link_content_post_update_make_menu_link_content_revisionable\";i:94;s:64:\"system_post_update_add_expand_all_items_key_in_system_menu_block\";i:95;s:35:\"system_post_update_clear_menu_cache\";i:96;s:52:\"taxonomy_post_update_make_taxonomy_term_revisionable\";i:97;s:55:\"taxonomy_post_update_remove_hierarchy_from_vocabularies\";i:98;s:53:\"views_post_update_exposed_filter_blocks_label_display\";i:99;s:48:\"views_post_update_make_placeholders_translatable\";i:100;s:29:\"commerce_order_post_update_10\";i:101;s:30:\"commerce_payment_post_update_3\";i:102;s:32:\"profile_post_update_replace_view\";}'),

('state','comment.maintain_entity_statistics','b:1;'),

('state','comment.node_comment_statistics_scale','d:0.25;'),

('state','drupal_css_cache_files','a:9:{s:64:\"66708fa6fb05adab730f3cade3d561788b5e69d539d66fa7ba685e594d03c967\";s:64:\"public://css/css_i1WVKRWGBQ5v6uh0RD5LXqfyyF8iaIgUBoUSGovazdo.css\";s:64:\"9a4362e0556298f86ccb8090eda2c8951379ba73dd00c9a63b93c7a611ca8884\";s:64:\"public://css/css_rppRGD_OoHfR_SJsouUbDXbYqdDsbR40sRSsm5MvFnw.css\";s:64:\"47fc16802eadaa490b6633db2f0a8a9d137af351f1ba55256280f0c1b31f883b\";s:64:\"public://css/css_UyiwahO6xhGq-B3QlpS0FWp9Isr2k3Ug0ABdozlubVA.css\";s:64:\"c31a8eeddcddabdac7029d5fd958a3948078f741f7de9b2bbfd7543247b823e4\";s:64:\"public://css/css_BCzSPU6q6ezaWWPoGu0qLAMlPqmQnl3ELJ7HMEJnwfQ.css\";s:64:\"b9bbb78c6fa29b8ac05f123203a0a9818a295f2952b263eed3e16f40d3f4e2ce\";s:64:\"public://css/css_8-EiLAMWblN15I0Mf7--ey89i67pvw-rlYBefGyqN44.css\";s:64:\"839ffc516ee4bf68a25edf3c6aff8bcbb98ecc81cdd3242692d8ef5968a88e22\";s:64:\"public://css/css_4CO3cKX5jMG5OypdIQMNMxpwQ9t1QZoStim6FadpXU0.css\";s:64:\"86cb5d77e1a3e85256ca88ae955f0e943b7ebb62c02a339dff76b0fdeb21f061\";s:64:\"public://css/css_wQEkHuovw6WHj54_Ne607f81xcwILBkLH8CgLlAVAIs.css\";s:64:\"254f30ad27af6a192cd15022678537783addfbe9373758f3651c400e8566c26f\";s:64:\"public://css/css_gtBlL_8IzYKjlosGaetYDFW8bfi_nRxXdYywxuPtbqY.css\";s:64:\"0163e6808b96a362ca8e167ff3dd0190d5917163d8bfe0b399d1b037bb855aef\";s:64:\"public://css/css_0GLUhK4kuHiWWFdc8RTa-CMapbup2k9EiwGk2UrAd3M.css\";}'),

('state','field.field.deleted','a:1:{s:36:\"ba6b123f-5d43-4f64-9a4b-536b58ef5128\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:1;s:5:\"\0*\0id\";s:49:\"commerce_order.checkout_order_summary.order_items\";s:13:\"\0*\0field_name\";s:11:\"order_items\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:14:\"commerce_order\";s:9:\"\0*\0bundle\";s:22:\"checkout_order_summary\";s:8:\"\0*\0label\";s:11:\"Order items\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:27:\"default:commerce_order_item\";s:16:\"handler_settings\";a:0:{}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:49:\"commerce_order.checkout_order_summary.order_items\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"ba6b123f-5d43-4f64-9a4b-536b58ef5128\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:57:\"commerce_order.commerce_order_type.checkout_order_summary\";i:1;s:40:\"field.storage.commerce_order.order_items\";}}s:18:\"field_storage_uuid\";s:36:\"9b482903-ea77-4dd3-a43a-79539bb89fce\";}}'),

('state','field.storage.deleted','a:0:{}'),

('state','install_task','s:4:\"done\";'),

('state','install_time','i:1478015733;'),

('state','node.min_max_update_time','a:2:{s:11:\"min_created\";s:10:\"1479930877\";s:11:\"max_created\";s:10:\"1490349659\";}'),

('state','router.path_roots','a:104:{i:0;s:5:\"admin\";i:1;s:8:\"run-cron\";i:2;s:14:\"block-category\";i:3;s:5:\"block\";i:4;s:7:\"comment\";i:5;s:8:\"comments\";i:6;s:4:\"cart\";i:7;s:8:\"checkout\";i:8;s:4:\"user\";i:9;s:7:\"payment\";i:10;s:24:\"commerce_payment_example\";i:11;s:9:\"promotion\";i:12;s:7:\"contact\";i:13;s:10:\"contextual\";i:14;s:10:\"dropzonejs\";i:15;s:6:\"editor\";i:16;s:5:\"embed\";i:17;s:14:\"entity-browser\";i:18;s:14:\"entity_browser\";i:19;s:12:\"entity-embed\";i:20;s:4:\"file\";i:21;s:6:\"filter\";i:22;s:5:\"sites\";i:23;s:6:\"system\";i:24;s:9:\"quickedit\";i:25;s:4:\"ajax\";i:26;s:10:\"admin_ajax\";i:27;s:12:\"nikadevs_cms\";i:28;s:4:\"node\";i:29;s:7:\"profile\";i:30;s:4:\"rest\";i:31;s:4:\"home\";i:32;s:7:\"onepage\";i:33;s:6:\"search\";i:34;s:4:\"cron\";i:35;s:12:\"machine_name\";i:36;s:0:\"\";i:37;s:9:\"<current>\";i:38;s:5:\"batch\";i:39;s:10:\"update.php\";i:40;s:29:\"entity_reference_autocomplete\";i:41;s:7:\"session\";i:42;s:8:\"taxonomy\";i:43;s:5:\"token\";i:44;s:7:\"toolbar\";i:45;s:7:\"webform\";i:46;s:14:\"blog-fullwidth\";i:47;s:14:\"blog-2-columns\";i:48;s:14:\"blog-3-columns\";i:49;s:14:\"blog-4-columns\";i:50;s:12:\"blog-3-items\";i:51;s:22:\"blog-masonry-2-columns\";i:52;s:22:\"blog-masonry-3-columns\";i:53;s:22:\"blog-masonry-4-columns\";i:54;s:13:\"blog-timeline\";i:55;s:7:\"rss.xml\";i:56;s:7:\"gallery\";i:57;s:13:\"gallery-col-2\";i:58;s:13:\"gallery-col-3\";i:59;s:13:\"gallery-col-4\";i:60;s:13:\"gallery-col-6\";i:61;s:15:\"portfolio-boxed\";i:62;s:38:\"portfolio-boxed-gutter-5-black-columns\";i:63;s:31:\"portfolio-boxed-title-2-columns\";i:64;s:31:\"portfolio-boxed-title-3-columns\";i:65;s:31:\"portfolio-boxed-title-4-columns\";i:66;s:31:\"portfolio-boxed-title-5-columns\";i:67;s:37:\"portfolio-boxed-title-5-columns-black\";i:68;s:30:\"portfolio-boxed-wide-2-columns\";i:69;s:30:\"portfolio-boxed-wide-3-columns\";i:70;s:30:\"portfolio-boxed-wide-4-columns\";i:71;s:30:\"portfolio-boxed-wide-5-columns\";i:72;s:25:\"portfolio-boxed-3-columns\";i:73;s:35:\"portfolio-boxed-wide-5-columns-dark\";i:74;s:31:\"portfolio-gutter-wide-2-columns\";i:75;s:31:\"portfolio-gutter-wide-3-columns\";i:76;s:31:\"portfolio-gutter-wide-4-columns\";i:77;s:31:\"portfolio-gutter-wide-5-columns\";i:78;s:36:\"portfolio-gutter-wide-5-columns-dark\";i:79;s:30:\"portfolio-title-wide-2-columns\";i:80;s:30:\"portfolio-title-wide-3-columns\";i:81;s:30:\"portfolio-title-wide-4-columns\";i:82;s:30:\"portfolio-title-wide-5-columns\";i:83;s:25:\"portfolio-boxed-4-columns\";i:84;s:35:\"portfolio-title-wide-5-columns-dark\";i:85;s:27:\"portfolio-masonry-2-columns\";i:86;s:27:\"portfolio-masonry-3-columns\";i:87;s:27:\"portfolio-masonry-4-columns\";i:88;s:27:\"portfolio-masonry-5-columns\";i:89;s:32:\"portfolio-masonry-5-columns-dark\";i:90;s:25:\"portfolio-boxed-5-columns\";i:91;s:32:\"portfolio-boxed-gutter-2-columns\";i:92;s:32:\"portfolio-boxed-gutter-3-columns\";i:93;s:32:\"portfolio-boxed-gutter-4-columns\";i:94;s:32:\"portfolio-boxed-gutter-5-columns\";i:95;s:31:\"portfolio-boxed-5-columns-black\";i:96;s:18:\"portfolio-parallax\";i:97;s:15:\"portfolio-promo\";i:98;s:14:\"shop-2-columns\";i:99;s:14:\"shop-3-columns\";i:100;s:14:\"4-columns-shop\";i:101;s:5:\"views\";i:102;s:7:\"product\";i:103;s:5:\"store\";}'),

('state','routing.menu_masks.router','a:71:{i:0;i:2025;i:1;i:1013;i:2;i:1001;i:3;i:985;i:4;i:507;i:5;i:506;i:6;i:501;i:7;i:494;i:8;i:493;i:9;i:491;i:10;i:489;i:11;i:479;i:12;i:464;i:13;i:254;i:14;i:253;i:15;i:252;i:16;i:251;i:17;i:250;i:18;i:249;i:19;i:247;i:20;i:246;i:21;i:245;i:22;i:234;i:23;i:232;i:24;i:224;i:25;i:127;i:26;i:126;i:27;i:125;i:28;i:123;i:29;i:122;i:30;i:119;i:31;i:117;i:32;i:116;i:33;i:96;i:34;i:94;i:35;i:91;i:36;i:87;i:37;i:63;i:38;i:62;i:39;i:61;i:40;i:60;i:41;i:59;i:42;i:49;i:43;i:47;i:44;i:45;i:45;i:42;i:46;i:32;i:47;i:31;i:48;i:30;i:49;i:29;i:50;i:28;i:51;i:27;i:52;i:24;i:53;i:23;i:54;i:22;i:55;i:21;i:56;i:15;i:57;i:14;i:58;i:13;i:59;i:12;i:60;i:11;i:61;i:10;i:62;i:9;i:63;i:8;i:64;i:7;i:65;i:6;i:66;i:5;i:67;i:4;i:68;i:3;i:69;i:2;i:70;i:1;}'),

('state','routing.non_admin_routes','a:259:{i:0;s:22:\"admin_toolbar.run.cron\";i:1;s:27:\"block.category_autocomplete\";i:2;s:22:\"block_content.add_page\";i:3;s:22:\"block_content.add_form\";i:4;s:30:\"entity.block_content.canonical\";i:5;s:30:\"entity.block_content.edit_form\";i:6;s:32:\"entity.block_content.delete_form\";i:7;s:24:\"entity.comment.edit_form\";i:8;s:15:\"comment.approve\";i:9;s:24:\"entity.comment.canonical\";i:10;s:26:\"entity.comment.delete_form\";i:11;s:13:\"comment.reply\";i:12;s:31:\"comment.new_comments_node_links\";i:13;s:21:\"comment.node_redirect\";i:14;s:18:\"commerce_cart.page\";i:15;s:22:\"commerce_checkout.form\";i:16;s:31:\"entity.commerce_order.user_view\";i:17;s:36:\"commerce_order.address_book.overview\";i:18;s:36:\"commerce_order.address_book.add_form\";i:19;s:37:\"commerce_order.address_book.edit_form\";i:20;s:39:\"commerce_order.address_book.delete_form\";i:21;s:39:\"commerce_order.address_book.set_default\";i:22;s:39:\"entity.commerce_payment_method.add_form\";i:23;s:41:\"entity.commerce_payment_method.collection\";i:24;s:32:\"commerce_payment.checkout.return\";i:25;s:32:\"commerce_payment.checkout.cancel\";i:26;s:23:\"commerce_payment.notify\";i:27;s:44:\"commerce_payment_example.dummy_redirect_post\";i:28;s:43:\"commerce_payment_example.dummy_redirect_302\";i:29;s:43:\"entity.commerce_promotion_coupon.collection\";i:30;s:46:\"entity.commerce_promotion_coupon.generate_form\";i:31;s:17:\"contact.site_page\";i:32;s:29:\"entity.contact_form.canonical\";i:33;s:24:\"entity.user.contact_form\";i:34;s:17:\"contextual.render\";i:35;s:17:\"dropzonejs.upload\";i:36;s:17:\"editor.filter_xss\";i:37;s:31:\"editor.field_untransformed_text\";i:38;s:19:\"editor.image_dialog\";i:39;s:18:\"editor.link_dialog\";i:40;s:13:\"embed.preview\";i:41;s:27:\"entity_browser.browse_files\";i:42;s:33:\"entity_browser.browse_files_modal\";i:43;s:24:\"entity_browser.edit_form\";i:44;s:19:\"entity_embed.dialog\";i:45;s:20:\"entity_embed.preview\";i:46;s:18:\"file.ajax_progress\";i:47;s:15:\"filter.tips_all\";i:48;s:11:\"filter.tips\";i:49;s:18:\"image.style_public\";i:50;s:19:\"image.style_private\";i:51;s:12:\"image.upload\";i:52;s:10:\"image.info\";i:53;s:39:\"nd_visualshortcodes_ajax_backend_layout\";i:54;s:50:\"nd_visualshortcodes_ajax_backend_shortcode_preview\";i:55;s:42:\"nd_visualshortcodes_ajax_backend_shortcode\";i:56;s:44:\"nd_visualshortcodes_ajax_shortcodes_list_add\";i:57;s:40:\"nd_visualshortcodes_ajax_shortcodes_list\";i:58;s:40:\"nd_visualshortcodes_ajax_shortcodes_save\";i:59;s:42:\"nd_visualshortcodes_ajax_shortcodes_delete\";i:60;s:35:\"nd_visualshortcodes_ajax_upload_img\";i:61;s:38:\"nd_visualshortcodes_media_upload_image\";i:62;s:19:\"nikadevs_cms.update\";i:63;s:24:\"nikadevs_cms.blockupdate\";i:64;s:23:\"nikadevs_cms.filedelete\";i:65;s:20:\"nikadevs_cms.release\";i:66;s:25:\"nikadevs_cms.flag_cleanup\";i:67;s:13:\"node.add_page\";i:68;s:8:\"node.add\";i:69;s:19:\"entity.node.preview\";i:70;s:27:\"entity.node.version_history\";i:71;s:20:\"entity.node.revision\";i:72;s:28:\"node.revision_revert_confirm\";i:73;s:40:\"node.revision_revert_translation_confirm\";i:74;s:28:\"node.revision_delete_confirm\";i:75;s:26:\"entity.profile.set_default\";i:76;s:24:\"profile.user_page.single\";i:77;s:26:\"profile.user_page.multiple\";i:78;s:26:\"profile.user_page.add_form\";i:79;s:14:\"rest.csrftoken\";i:80;s:15:\"rhythm_cms_home\";i:81;s:18:\"rhythm_cms_onepage\";i:82;s:11:\"search.view\";i:83;s:23:\"search.view_node_search\";i:84;s:23:\"search.help_node_search\";i:85;s:23:\"search.view_user_search\";i:86;s:23:\"search.help_user_search\";i:87;s:19:\"shortcut.set_switch\";i:88;s:10:\"system.401\";i:89;s:10:\"system.403\";i:90;s:10:\"system.404\";i:91;s:10:\"system.4xx\";i:92;s:11:\"system.cron\";i:93;s:33:\"system.machine_name_transliterate\";i:94;s:12:\"system.files\";i:95;s:28:\"system.private_file_download\";i:96;s:16:\"system.temporary\";i:97;s:7:\"<front>\";i:98;s:6:\"<none>\";i:99;s:8:\"<nolink>\";i:100;s:9:\"<current>\";i:101;s:15:\"system.timezone\";i:102;s:22:\"system.batch_page.html\";i:103;s:22:\"system.batch_page.json\";i:104;s:16:\"system.db_update\";i:105;s:26:\"system.entity_autocomplete\";i:106;s:16:\"system.csrftoken\";i:107;s:30:\"entity.taxonomy_term.edit_form\";i:108;s:32:\"entity.taxonomy_term.delete_form\";i:109;s:10:\"token.tree\";i:110;s:18:\"token.autocomplete\";i:111;s:16:\"toolbar.subtrees\";i:112;s:13:\"user.register\";i:113;s:11:\"user.logout\";i:114;s:9:\"user.pass\";i:115;s:14:\"user.pass.http\";i:116;s:9:\"user.page\";i:117;s:10:\"user.login\";i:118;s:15:\"user.login.http\";i:119;s:22:\"user.login_status.http\";i:120;s:16:\"user.logout.http\";i:121;s:19:\"user.cancel_confirm\";i:122;s:16:\"user.reset.login\";i:123;s:10:\"user.reset\";i:124;s:15:\"user.reset.form\";i:125;s:24:\"entity.webform.canonical\";i:126;s:28:\"entity.webform.access_denied\";i:127;s:32:\"entity.webform.assets.javascript\";i:128;s:25:\"entity.webform.assets.css\";i:129;s:27:\"entity.webform.confirmation\";i:130;s:31:\"entity.webform.user.submissions\";i:131;s:26:\"entity.webform.user.drafts\";i:132;s:30:\"entity.webform.user.submission\";i:133;s:35:\"entity.webform.user.submission.edit\";i:134;s:37:\"entity.webform.user.submission.delete\";i:135;s:40:\"entity.webform.user.submission.duplicate\";i:136;s:24:\"entity.webform.test_form\";i:137;s:30:\"entity.webform_submission.user\";i:138;s:28:\"webform.element.autocomplete\";i:139;s:29:\"webform.element.message.close\";i:140;s:32:\"entity.node.webform.confirmation\";i:141;s:36:\"entity.node.webform.user.submissions\";i:142;s:31:\"entity.node.webform.user.drafts\";i:143;s:35:\"entity.node.webform.user.submission\";i:144;s:40:\"entity.node.webform.user.submission.edit\";i:145;s:42:\"entity.node.webform.user.submission.delete\";i:146;s:45:\"entity.node.webform.user.submission.duplicate\";i:147;s:29:\"entity.node.webform.test_form\";i:148;s:39:\"entity.node.webform.results_submissions\";i:149;s:46:\"entity.node.webform.results_submissions.custom\";i:150;s:34:\"entity.node.webform.results_export\";i:151;s:39:\"entity.node.webform.results_export_file\";i:152;s:33:\"entity.node.webform.results_clear\";i:153;s:40:\"entity.node.webform_submission.canonical\";i:154;s:36:\"entity.node.webform_submission.table\";i:155;s:35:\"entity.node.webform_submission.text\";i:156;s:35:\"entity.node.webform_submission.yaml\";i:157;s:40:\"entity.node.webform_submission.edit_form\";i:158;s:44:\"entity.node.webform_submission.edit_form.all\";i:159;s:41:\"entity.node.webform_submission.notes_form\";i:160;s:42:\"entity.node.webform_submission.resend_form\";i:161;s:45:\"entity.node.webform_submission.duplicate_form\";i:162;s:42:\"entity.node.webform_submission.delete_form\";i:163;s:40:\"entity.node.webform.entity_reference.set\";i:164;s:26:\"view.blog_fullwidth.page_1\";i:165;s:21:\"view.blog_grid.page_1\";i:166;s:21:\"view.blog_grid.page_2\";i:167;s:21:\"view.blog_grid.page_3\";i:168;s:21:\"view.blog_grid.page_4\";i:169;s:24:\"view.blog_masonry.page_1\";i:170;s:24:\"view.blog_masonry.page_2\";i:171;s:24:\"view.blog_masonry.page_3\";i:172;s:25:\"view.blog_timeline.page_1\";i:173;s:36:\"view.commerce_user_orders.order_page\";i:174;s:21:\"view.frontpage.feed_1\";i:175;s:21:\"view.frontpage.page_1\";i:176;s:19:\"view.gallery.page_1\";i:177;s:19:\"view.gallery.page_2\";i:178;s:19:\"view.gallery.page_3\";i:179;s:19:\"view.gallery.page_4\";i:180;s:19:\"view.gallery.page_5\";i:181;s:27:\"view.portfolio_boxed.page_1\";i:182;s:28:\"view.portfolio_boxed.page_10\";i:183;s:28:\"view.portfolio_boxed.page_11\";i:184;s:28:\"view.portfolio_boxed.page_12\";i:185;s:28:\"view.portfolio_boxed.page_13\";i:186;s:28:\"view.portfolio_boxed.page_14\";i:187;s:28:\"view.portfolio_boxed.page_15\";i:188;s:28:\"view.portfolio_boxed.page_16\";i:189;s:28:\"view.portfolio_boxed.page_17\";i:190;s:28:\"view.portfolio_boxed.page_18\";i:191;s:28:\"view.portfolio_boxed.page_19\";i:192;s:27:\"view.portfolio_boxed.page_2\";i:193;s:28:\"view.portfolio_boxed.page_20\";i:194;s:28:\"view.portfolio_boxed.page_21\";i:195;s:28:\"view.portfolio_boxed.page_22\";i:196;s:28:\"view.portfolio_boxed.page_23\";i:197;s:28:\"view.portfolio_boxed.page_24\";i:198;s:28:\"view.portfolio_boxed.page_25\";i:199;s:28:\"view.portfolio_boxed.page_26\";i:200;s:28:\"view.portfolio_boxed.page_27\";i:201;s:28:\"view.portfolio_boxed.page_28\";i:202;s:28:\"view.portfolio_boxed.page_29\";i:203;s:27:\"view.portfolio_boxed.page_3\";i:204;s:28:\"view.portfolio_boxed.page_30\";i:205;s:28:\"view.portfolio_boxed.page_31\";i:206;s:28:\"view.portfolio_boxed.page_32\";i:207;s:28:\"view.portfolio_boxed.page_33\";i:208;s:28:\"view.portfolio_boxed.page_34\";i:209;s:28:\"view.portfolio_boxed.page_35\";i:210;s:27:\"view.portfolio_boxed.page_4\";i:211;s:27:\"view.portfolio_boxed.page_5\";i:212;s:27:\"view.portfolio_boxed.page_6\";i:213;s:27:\"view.portfolio_boxed.page_7\";i:214;s:27:\"view.portfolio_boxed.page_8\";i:215;s:27:\"view.portfolio_boxed.page_9\";i:216;s:30:\"view.portfolio_parallax.page_1\";i:217;s:27:\"view.portfolio_promo.page_1\";i:218;s:22:\"view.shop_columns.page\";i:219;s:24:\"view.shop_columns.page_1\";i:220;s:24:\"view.shop_columns.page_2\";i:221;s:25:\"view.taxonomy_term.feed_1\";i:222;s:25:\"view.taxonomy_term.page_1\";i:223;s:10:\"views.ajax\";i:224;s:40:\"entity.commerce_payment_method.edit_form\";i:225;s:42:\"entity.commerce_payment_method.delete_form\";i:226;s:32:\"entity.commerce_product.add_page\";i:227;s:32:\"entity.commerce_product.add_form\";i:228;s:33:\"entity.commerce_product.canonical\";i:229;s:33:\"entity.commerce_product.edit_form\";i:230;s:35:\"entity.commerce_product.delete_form\";i:231;s:42:\"entity.commerce_product_variation.add_form\";i:232;s:43:\"entity.commerce_product_variation.edit_form\";i:233;s:45:\"entity.commerce_product_variation.delete_form\";i:234;s:44:\"entity.commerce_product_variation.collection\";i:235;s:48:\"entity.commerce_product_variation.duplicate_form\";i:236;s:41:\"entity.commerce_promotion_coupon.add_form\";i:237;s:42:\"entity.commerce_promotion_coupon.edit_form\";i:238;s:44:\"entity.commerce_promotion_coupon.delete_form\";i:239;s:34:\"entity.commerce_promotion.add_form\";i:240;s:35:\"entity.commerce_promotion.edit_form\";i:241;s:37:\"entity.commerce_promotion.delete_form\";i:242;s:40:\"entity.commerce_promotion.duplicate_form\";i:243;s:30:\"entity.commerce_store.add_page\";i:244;s:30:\"entity.commerce_store.add_form\";i:245;s:31:\"entity.commerce_store.canonical\";i:246;s:31:\"entity.commerce_store.edit_form\";i:247;s:33:\"entity.commerce_store.delete_form\";i:248;s:36:\"entity.commerce_store.duplicate_form\";i:249;s:21:\"entity.node.canonical\";i:250;s:23:\"entity.node.delete_form\";i:251;s:21:\"entity.node.edit_form\";i:252;s:24:\"entity.profile.canonical\";i:253;s:24:\"entity.profile.edit_form\";i:254;s:26:\"entity.profile.delete_form\";i:255;s:21:\"entity.user.canonical\";i:256;s:21:\"entity.user.edit_form\";i:257;s:23:\"entity.user.cancel_form\";i:258;s:30:\"entity.taxonomy_term.canonical\";}'),

('state','system.cron_key','s:74:\"eCpVPh8DPfqxSz_CndVhKQxM9lVZDbTX5fmmha-G8BK-OWhB5ZveQ2V0r1VgICz2ImS2DBAbig\";'),

('state','system.cron_last','i:1490604749;'),

('state','system.css_js_query_string','s:6:\"pzb21m\";'),

('state','system.js_cache_files','a:6:{s:64:\"ef5219d33ebedcd4b9b0ccc64f741d50bebb463122945dd3b12519b97e268ab4\";s:61:\"public://js/js_VtafjXmRvoUgAzqzYTA3Wrjkx9wcWhjP0G4ZnnqRamA.js\";s:64:\"22b57c12b5f7dfa20d16a8fb27842e2c48a55df949019086a2e14bfa9b53ed21\";s:61:\"public://js/js_BKcMdIbOMdbTdLn9dkUq3KCJfIKKo2SvKoQ1AnB8D-g.js\";s:64:\"c839df7c4fcaff2cb7890a0c2e9316f456b4c990c363fb4eb87a2a601c594055\";s:61:\"public://js/js_VhqXmo4azheUjYC30rijnR_Dddo0WjWkF27k5gTL8S4.js\";s:64:\"b5cc35f0b87fc259f73e2b80856da197335683f28e24c8124e1357e734123036\";s:61:\"public://js/js_0OPKiXtleDz8v-HNc7uB1v8KJayj8gE9XI7-yCTGLh8.js\";s:64:\"4851816659b669620f4169c866f359bd9ff5e71a0fd00bd512b77f91f959ee4b\";s:61:\"public://js/js_-1MF1YkbXf1zdM2c1d4p353DwZsqWwAIVRqAdNs4faY.js\";s:64:\"da216122e82f5181d91c5680a541c7c84af75ff45eb2eceeb4c0ffc523cd4c3f\";s:61:\"public://js/js_KTm_fBvEXSblrl-wW3JquNEaNJTX_3_YpsTA_jq7E4c.js\";}'),

('state','system.maintenance_mode','b:0;'),

('state','system.private_key','s:74:\"uY_4BOkwnviOPNyeT1ebPltsc99_-3Hfe0xuRD0SA4kwbtTfWofFKg6tC-8-XrYN10ipTLFSUg\";'),

('state','system.profile.files','a:12:{s:10:\"demo_umami\";s:44:\"core/profiles/demo_umami/demo_umami.info.yml\";s:7:\"minimal\";s:38:\"core/profiles/minimal/minimal.info.yml\";s:8:\"standard\";s:40:\"core/profiles/standard/standard.info.yml\";s:7:\"testing\";s:38:\"core/profiles/testing/testing.info.yml\";s:21:\"testing_config_import\";s:66:\"core/profiles/testing_config_import/testing_config_import.info.yml\";s:24:\"testing_config_overrides\";s:72:\"core/profiles/testing_config_overrides/testing_config_overrides.info.yml\";s:40:\"testing_install_profile_all_dependencies\";s:104:\"core/profiles/testing_install_profile_all_dependencies/testing_install_profile_all_dependencies.info.yml\";s:36:\"testing_install_profile_dependencies\";s:96:\"core/profiles/testing_install_profile_dependencies/testing_install_profile_dependencies.info.yml\";s:39:\"testing_install_profile_dependencies_bc\";s:102:\"core/profiles/testing_install_profile_dependencies_bc/testing_install_profile_dependencies_bc.info.yml\";s:28:\"testing_missing_dependencies\";s:80:\"core/profiles/testing_missing_dependencies/testing_missing_dependencies.info.yml\";s:20:\"testing_multilingual\";s:64:\"core/profiles/testing_multilingual/testing_multilingual.info.yml\";s:33:\"testing_multilingual_with_english\";s:90:\"core/profiles/testing_multilingual_with_english/testing_multilingual_with_english.info.yml\";}'),

('state','system.theme.files','a:7:{s:6:\"bartik\";s:34:\"core/themes/bartik/bartik.info.yml\";s:6:\"classy\";s:34:\"core/themes/classy/classy.info.yml\";s:6:\"rhythm\";s:36:\"themes/custom/rhythm/rhythm.info.yml\";s:10:\"rhythm_sub\";s:44:\"themes/custom/rhythm_sub/rhythm_sub.info.yml\";s:5:\"seven\";s:32:\"core/themes/seven/seven.info.yml\";s:6:\"stable\";s:34:\"core/themes/stable/stable.info.yml\";s:5:\"stark\";s:32:\"core/themes/stark/stark.info.yml\";}'),

('state','system.theme_engine.files','a:1:{s:4:\"twig\";s:38:\"core/themes/engines/twig/twig.info.yml\";}'),

('state','twig_extension_hash_prefix','a:2:{s:19:\"twig_extension_hash\";s:43:\"iqI6uio6uw0dXpgkjMkxJ6Wjz-XcDsi-jc3pkNLGCPE\";s:17:\"twig_cache_prefix\";s:13:\"5da2e62a5a6c8\";}'),

('state','update.last_check','i:1570954921;'),

('state','views.view_route_names','a:71:{s:13:\"watchdog.page\";s:14:\"dblog.overview\";s:24:\"user_admin_people.page_1\";s:22:\"entity.user.collection\";s:20:\"taxonomy_term.page_1\";s:30:\"entity.taxonomy_term.canonical\";s:14:\"content.page_1\";s:20:\"system.admin_content\";s:22:\"commerce_stores.page_1\";s:32:\"entity.commerce_store.collection\";s:24:\"commerce_products.page_1\";s:34:\"entity.commerce_product.collection\";s:22:\"commerce_orders.page_1\";s:32:\"entity.commerce_order.collection\";s:23:\"comment.page_unapproved\";s:22:\"comment.admin_approval\";s:22:\"comment.page_published\";s:13:\"comment.admin\";s:20:\"block_content.page_1\";s:31:\"entity.block_content.collection\";s:21:\"blog_fullwidth.page_1\";s:26:\"view.blog_fullwidth.page_1\";s:16:\"blog_grid.page_1\";s:21:\"view.blog_grid.page_1\";s:16:\"blog_grid.page_2\";s:21:\"view.blog_grid.page_2\";s:16:\"blog_grid.page_3\";s:21:\"view.blog_grid.page_3\";s:16:\"blog_grid.page_4\";s:21:\"view.blog_grid.page_4\";s:19:\"blog_masonry.page_1\";s:24:\"view.blog_masonry.page_1\";s:19:\"blog_masonry.page_2\";s:24:\"view.blog_masonry.page_2\";s:19:\"blog_masonry.page_3\";s:24:\"view.blog_masonry.page_3\";s:20:\"blog_timeline.page_1\";s:25:\"view.blog_timeline.page_1\";s:21:\"commerce_carts.page_1\";s:26:\"view.commerce_carts.page_1\";s:31:\"commerce_user_orders.order_page\";s:36:\"view.commerce_user_orders.order_page\";s:12:\"files.page_1\";s:17:\"view.files.page_1\";s:12:\"files.page_2\";s:17:\"view.files.page_2\";s:16:\"frontpage.feed_1\";s:21:\"view.frontpage.feed_1\";s:16:\"frontpage.page_1\";s:21:\"view.frontpage.page_1\";s:14:\"gallery.page_1\";s:19:\"view.gallery.page_1\";s:14:\"gallery.page_2\";s:19:\"view.gallery.page_2\";s:14:\"gallery.page_3\";s:19:\"view.gallery.page_3\";s:14:\"gallery.page_4\";s:19:\"view.gallery.page_4\";s:14:\"gallery.page_5\";s:19:\"view.gallery.page_5\";s:22:\"portfolio_boxed.page_1\";s:27:\"view.portfolio_boxed.page_1\";s:23:\"portfolio_boxed.page_10\";s:28:\"view.portfolio_boxed.page_10\";s:23:\"portfolio_boxed.page_11\";s:28:\"view.portfolio_boxed.page_11\";s:23:\"portfolio_boxed.page_12\";s:28:\"view.portfolio_boxed.page_12\";s:23:\"portfolio_boxed.page_13\";s:28:\"view.portfolio_boxed.page_13\";s:23:\"portfolio_boxed.page_14\";s:28:\"view.portfolio_boxed.page_14\";s:23:\"portfolio_boxed.page_15\";s:28:\"view.portfolio_boxed.page_15\";s:23:\"portfolio_boxed.page_16\";s:28:\"view.portfolio_boxed.page_16\";s:23:\"portfolio_boxed.page_17\";s:28:\"view.portfolio_boxed.page_17\";s:23:\"portfolio_boxed.page_18\";s:28:\"view.portfolio_boxed.page_18\";s:23:\"portfolio_boxed.page_19\";s:28:\"view.portfolio_boxed.page_19\";s:22:\"portfolio_boxed.page_2\";s:27:\"view.portfolio_boxed.page_2\";s:23:\"portfolio_boxed.page_20\";s:28:\"view.portfolio_boxed.page_20\";s:23:\"portfolio_boxed.page_21\";s:28:\"view.portfolio_boxed.page_21\";s:23:\"portfolio_boxed.page_22\";s:28:\"view.portfolio_boxed.page_22\";s:23:\"portfolio_boxed.page_23\";s:28:\"view.portfolio_boxed.page_23\";s:23:\"portfolio_boxed.page_24\";s:28:\"view.portfolio_boxed.page_24\";s:23:\"portfolio_boxed.page_25\";s:28:\"view.portfolio_boxed.page_25\";s:23:\"portfolio_boxed.page_26\";s:28:\"view.portfolio_boxed.page_26\";s:23:\"portfolio_boxed.page_27\";s:28:\"view.portfolio_boxed.page_27\";s:23:\"portfolio_boxed.page_28\";s:28:\"view.portfolio_boxed.page_28\";s:23:\"portfolio_boxed.page_29\";s:28:\"view.portfolio_boxed.page_29\";s:22:\"portfolio_boxed.page_3\";s:27:\"view.portfolio_boxed.page_3\";s:23:\"portfolio_boxed.page_30\";s:28:\"view.portfolio_boxed.page_30\";s:23:\"portfolio_boxed.page_31\";s:28:\"view.portfolio_boxed.page_31\";s:23:\"portfolio_boxed.page_32\";s:28:\"view.portfolio_boxed.page_32\";s:23:\"portfolio_boxed.page_33\";s:28:\"view.portfolio_boxed.page_33\";s:23:\"portfolio_boxed.page_34\";s:28:\"view.portfolio_boxed.page_34\";s:23:\"portfolio_boxed.page_35\";s:28:\"view.portfolio_boxed.page_35\";s:22:\"portfolio_boxed.page_4\";s:27:\"view.portfolio_boxed.page_4\";s:22:\"portfolio_boxed.page_5\";s:27:\"view.portfolio_boxed.page_5\";s:22:\"portfolio_boxed.page_6\";s:27:\"view.portfolio_boxed.page_6\";s:22:\"portfolio_boxed.page_7\";s:27:\"view.portfolio_boxed.page_7\";s:22:\"portfolio_boxed.page_8\";s:27:\"view.portfolio_boxed.page_8\";s:22:\"portfolio_boxed.page_9\";s:27:\"view.portfolio_boxed.page_9\";s:25:\"portfolio_parallax.page_1\";s:30:\"view.portfolio_parallax.page_1\";s:22:\"portfolio_promo.page_1\";s:27:\"view.portfolio_promo.page_1\";s:17:\"shop_columns.page\";s:22:\"view.shop_columns.page\";s:19:\"shop_columns.page_1\";s:24:\"view.shop_columns.page_1\";s:19:\"shop_columns.page_2\";s:24:\"view.shop_columns.page_2\";s:20:\"taxonomy_term.feed_1\";s:25:\"view.taxonomy_term.feed_1\";}'),

('state','webform.element.message','a:0:{}'),

('state','webform.version','s:7:\"8.x-5.4\";'),

('state','webform.webform.subscribe','a:1:{s:11:\"next_serial\";i:2;}'),

('state','webform_help_notifications','a:1:{s:7:\"warning\";a:2:{s:19:\"webform_update_8119\";s:316:\"<strong>ATTENTION DEVELOPERS!!!</strong> The webform submission form\'s  BASE_FORM_ID and FORM_ID have changed.<br/>Please make sure to update all webform related <code>hook_form_BASE_FORM_ID_alter()</code> and <code>hook_form_FORM_ID_alter()</code> hooks. <a href=\"https://www.drupal.org/node/2959264\">Learn more</a>\";s:19:\"webform_update_8139\";a:2:{s:4:\"list\";a:3:{s:6:\"#theme\";s:9:\"item_list\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:155:\"IMPORTANT! Elements, containers, and pages that are hidden using conditional logic will now have their submission data cleared when a webform is submitted.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#items\";a:3:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:103:\"Please make sure to test any webform that contains conditionally hidden elements, containers, or pages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:79:\"Any element that is conditionally hidden will have its submission data cleared.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:140:\"Existing submissions that have conditionally hidden elements will have the element\'s submission data cleared when the submission is updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:4:\"link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Learn more\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":12:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";N;s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:1:{s:8:\"external\";b:1;}s:11:\"\0*\0external\";b:1;s:11:\"\0*\0unrouted\";b:1;s:6:\"\0*\0uri\";s:35:\"https://www.drupal.org/node/2956589\";s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}}}}}}'),

('system.schema','address','i:8104;'),

('system.schema','admin_toolbar','i:8001;'),

('system.schema','admin_toolbar_tools','i:8000;'),

('system.schema','block','s:4:\"8003\";'),

('system.schema','block_content','i:8600;'),

('system.schema','breakpoint','i:8000;'),

('system.schema','ckeditor','i:8000;'),

('system.schema','color','i:8000;'),

('system.schema','comment','i:8701;'),

('system.schema','commerce','i:8000;'),

('system.schema','commerce_cart','i:8000;'),

('system.schema','commerce_checkout','i:8000;'),

('system.schema','commerce_ext','i:8000;'),

('system.schema','commerce_log','i:8000;'),

('system.schema','commerce_order','i:8206;'),

('system.schema','commerce_payment','i:8203;'),

('system.schema','commerce_payment_example','i:8000;'),

('system.schema','commerce_price','i:8000;'),

('system.schema','commerce_product','i:8207;'),

('system.schema','commerce_promotion','i:8203;'),

('system.schema','commerce_store','i:8202;'),

('system.schema','commerce_variation_cart_form','i:8000;'),

('system.schema','config','i:8000;'),

('system.schema','config_update','i:8000;'),

('system.schema','contact','i:8000;'),

('system.schema','contextual','i:8000;'),

('system.schema','ctools','i:8000;'),

('system.schema','datetime','i:8000;'),

('system.schema','dblog','i:8600;'),

('system.schema','dropzonejs','i:8001;'),

('system.schema','dropzonejs_eb_widget','i:8202;'),

('system.schema','editor','s:4:\"8001\";'),

('system.schema','embed','i:8000;'),

('system.schema','entity','i:8000;'),

('system.schema','entity_browser','i:8201;'),

('system.schema','entity_embed','i:8004;'),

('system.schema','entity_reference_revisions','i:8000;'),

('system.schema','field','i:8500;'),

('system.schema','field_group','i:8301;'),

('system.schema','field_ui','i:8000;'),

('system.schema','file','i:8700;'),

('system.schema','file_browser','i:8005;'),

('system.schema','filter','i:8000;'),

('system.schema','fivestar','i:8000;'),

('system.schema','hal','i:8501;'),

('system.schema','help','i:8000;'),

('system.schema','image','i:8201;'),

('system.schema','inline_entity_form','i:8000;'),

('system.schema','language','s:4:\"8001\";'),

('system.schema','link','i:8000;'),

('system.schema','menu_link_content','i:8601;'),

('system.schema','menu_ui','i:8000;'),

('system.schema','nd_visualshortcodes','i:8000;'),

('system.schema','nikadevs_cms','i:8005;'),

('system.schema','node','i:8700;'),

('system.schema','options','i:8000;'),

('system.schema','path','s:4:\"8200\";'),

('system.schema','pathauto','i:8107;'),

('system.schema','profile','i:8010;'),

('system.schema','rest','i:8401;'),

('system.schema','rhythm_cms','i:8500;'),

('system.schema','rhythm_shortcodes','i:8000;'),

('system.schema','search','i:8000;'),

('system.schema','serialization','i:8401;'),

('system.schema','shortcode','i:8000;'),

('system.schema','shortcut','i:8000;'),

('system.schema','standard','i:8000;'),

('system.schema','state_machine','i:8000;'),

('system.schema','system','i:8702;'),

('system.schema','taxonomy','i:8702;'),

('system.schema','tb_megamenu','s:4:\"8001\";'),

('system.schema','text','i:8000;'),

('system.schema','token','i:8000;'),

('system.schema','toolbar','i:8000;'),

('system.schema','tour','i:8000;'),

('system.schema','update','s:4:\"8001\";'),

('system.schema','user','s:4:\"8100\";'),

('system.schema','views','i:8500;'),

('system.schema','views_ui','i:8000;'),

('system.schema','votingapi','i:8302;'),

('system.schema','webform','i:8172;'),

('system.schema','webform_node','i:8000;'),

('system.schema','webform_ui','i:8000;');

/*Table structure for table `key_value_expire` */

DROP TABLE IF EXISTS `key_value_expire`;

CREATE TABLE `key_value_expire` (
  `collection` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'A named collection of key and value pairs.',
  `name` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The key of the key/value pair.',
  `value` longblob NOT NULL COMMENT 'The value of the key/value pair.',
  `expire` int(11) NOT NULL DEFAULT '2147483647' COMMENT 'The time since Unix epoch in seconds when this item expires. Defaults to the maximum possible time.',
  PRIMARY KEY (`collection`,`name`),
  KEY `all` (`name`,`collection`,`expire`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Generic key/value storage table with an expiration.';

/*Data for the table `key_value_expire` */

insert  into `key_value_expire`(`collection`,`name`,`value`,`expire`) values 

('entity_browser','0d9b7ad4afcdd85fea7f8771fc6800b6511670e3','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:67108864;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1533056192),

('entity_browser','11beacd9a562a26d0809f234d1de401c6ed4203f','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503585040),

('entity_browser','14e126b39a736a57ac7c69eefb18e2013ae08ab6','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503324157),

('entity_browser','15ae76ead61da597219ff6b18a4ecce8fb227dd3','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503585879),

('entity_browser','15e5d49de8a300a70039ddb8eadc231ff8a594ac','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503324209),

('entity_browser','16bc5df3311c615cc16b83e68db1c55f6144de87','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503455035),

('entity_browser','1bde20f9a4a002658bec78c2af562eca9b50b290','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503433887),

('entity_browser','20760c4981ec605a5e401d64aa30184b1f2afd14','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503421596),

('entity_browser','20d3336f83b8e1046e19c4822969b9dd68266874','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503431993),

('entity_browser','21f193380a8fcd5d3116c3061a7247d5e7951b15','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503338728),

('entity_browser','25939f09dda9fda751149e7c7a0dd91fa1112bb4','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503332219),

('entity_browser','26b6774d54d0f1225e80eead6f1b13aa93115cf7','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503324195),

('entity_browser','284d007e88883a78c157b3238949912590cf26b2','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503323791),

('entity_browser','2baa4c98880bc416f2f5ff513476f80d28122754','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:67108864;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1533054001),

('entity_browser','3897b9d48178a870d88d8776e8547697fa8622cc','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:2:{i:0;O:23:\"Drupal\\file\\Entity\\File\":26:{s:9:\"\0*\0values\";a:11:{s:3:\"fid\";a:1:{s:9:\"x-default\";s:2:\"20\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"feb8c270-779e-4fa9-8c0a-d911228aa1b8\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:8:\"filename\";a:1:{s:9:\"x-default\";s:17:\"projects-12_0.jpg\";}s:3:\"uri\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:26:\"public://projects-12_0.jpg\";}}}s:8:\"filemime\";a:1:{s:9:\"x-default\";s:10:\"image/jpeg\";}s:8:\"filesize\";a:1:{s:9:\"x-default\";s:5:\"43088\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1480371914\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1480371914\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:5:{s:6:\"bundle\";s:4:\"file\";s:2:\"id\";s:2:\"20\";s:5:\"label\";s:17:\"projects-12_0.jpg\";s:8:\"langcode\";s:2:\"en\";s:4:\"uuid\";s:36:\"feb8c270-779e-4fa9-8c0a-d911228aa1b8\";}s:25:\"\0*\0translatableEntityKeys\";a:1:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:33:\"\0*\0revisionTranslationAffectedKey\";s:29:\"revision_translation_affected\";s:37:\"\0*\0enforceRevisionTranslationAffected\";a:0:{}s:15:\"\0*\0entityTypeId\";s:4:\"file\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:23:\"Drupal\\file\\Entity\\File\":26:{s:9:\"\0*\0values\";a:11:{s:3:\"fid\";a:1:{s:9:\"x-default\";s:2:\"19\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"61e3a4aa-70f2-407d-a4e7-164c824d3620\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:8:\"filename\";a:1:{s:9:\"x-default\";s:15:\"projects-11.jpg\";}s:3:\"uri\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:24:\"public://projects-11.jpg\";}}}s:8:\"filemime\";a:1:{s:9:\"x-default\";s:10:\"image/jpeg\";}s:8:\"filesize\";a:1:{s:9:\"x-default\";s:5:\"38101\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1480371914\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1480371914\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:5:{s:6:\"bundle\";s:4:\"file\";s:2:\"id\";s:2:\"19\";s:5:\"label\";s:15:\"projects-11.jpg\";s:8:\"langcode\";s:2:\"en\";s:4:\"uuid\";s:36:\"61e3a4aa-70f2-407d-a4e7-164c824d3620\";}s:25:\"\0*\0translatableEntityKeys\";a:1:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:33:\"\0*\0revisionTranslationAffectedKey\";s:29:\"revision_translation_affected\";s:37:\"\0*\0enforceRevisionTranslationAffected\";a:0:{}s:15:\"\0*\0entityTypeId\";s:4:\"file\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:67108864;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1526994082),

('entity_browser','3aa7109dc5a8a56b0256a9257db67434343d01d5','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503072826),

('entity_browser','3c1b887c6ca8996bc7fbe01fd83ef7cefaf076bd','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503075115),

('entity_browser','430549d77823f70ad929346704cf27ae79243a11','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503434985),

('entity_browser','43673bddc9400aaf987b295ded5485ce1744bd67','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503431993),

('entity_browser','446d81709046b560249a42ec3ecd1e882458d0fe','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503506805),

('entity_browser','5a541ac039d81ea5c81413b35ce477ab5011deda','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503075045),

('entity_browser','5b60855843bb62b64aa49da8583bbba81dd13ac1','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503431993),

('entity_browser','5e22b4eceeb0cc89c9b3a607488e8d2daf0520b2','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503506821),

('entity_browser','68842daf49ad13b3e18c540ffe9bc60177eabb3d','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503075477),

('entity_browser','6f89f568333fb3e2c1291c8cbd6c79eb426de760','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503433918),

('entity_browser','72872a154a0233de0a3fb2a00af69ff2ef82ce65','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503344412),

('entity_browser','7bbc924c4e5a5f9157c29b8cc724b01966884241','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503073996),

('entity_browser','7c6ce9b6b2332d74be9cc4af8ca5ba4070e005fb','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503421596),

('entity_browser','7e5f01cd95bd7de966cba92c0b2f9367a1267e24','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503421596),

('entity_browser','85e2661326dd3a38414940ae4c0da4136497e5f1','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503435810),

('entity_browser','904de4f3d0ffe965acf434ddb0a8e0838330379f','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503072534),

('entity_browser','92d53a396e00d28aa2b4e42ef0b22c5ec77e0849','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503073284),

('entity_browser','93c2170a1cc185eadbb315a5da3a2c8074d8d015','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503323848),

('entity_browser','94760d9dee5d9eb4819e24ed23ddaf1d1a3871f6','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503324209),

('entity_browser','9883aa8f5e53cf470b2470dfb675439a0e371764','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:67108864;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1533056256),

('entity_browser','9bdc57dce706aeb870ff0b5d60b486215a2b9df6','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503028954),

('entity_browser','9e5b32fa55eab84f787412550acf346cb6fae5e2','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503323973),

('entity_browser','a31b937bbf201c188c730dfdb322e6b9be3788cc','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503344771),

('entity_browser','a37225d707d306f4c70d51a5a58e9e780bf2d28c','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503323712),

('entity_browser','a7a0a9551149bb9bf37b838e044921db392dc4a2','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503332138),

('entity_browser','a7fcb4ab3818345a6c1d2b75e1210aea15eafe2a','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503347429),

('entity_browser','a8ae9c892a9eaf615787dd5701f428696281b682','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503347474),

('entity_browser','a9a68f4879116dd778baba4468513234000f8d0c','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503502973),

('entity_browser','ab69e77ec82b7181e837e9e44143af9044e9bf89','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503073177),

('entity_browser','aba4857a41784fe1d54035b01661f8cbb346ce53','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503581473),

('entity_browser','ae6c096815d69be82626216630108ddcf784253e','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503331924),

('entity_browser','b0c8556eec312f05179c5807d7e38f7678d052a0','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503075354),

('entity_browser','b663b61ae05879611b74b8c17d25ad411e8e0001','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503433918),

('entity_browser','b7b47b674fe5cc508ef672fe949a56fe2176ff99','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503344412),

('entity_browser','b7e6306e4f27c8947589cd4fa489bc2dd01b73d6','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503323579),

('entity_browser','bcc1e8bf8d21eada04c42c43ac27ad85105538cf','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503324209),

('entity_browser','bdcb81c130ee76aab8bfd5642d8bde47ea810838','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503332231),

('entity_browser','bf45aa4221ab0313ec8ac35133302419f8ac37ba','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503344505),

('entity_browser','c02e8f430183d09e66ce8295c1dbfba7908be153','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503323712),

('entity_browser','c0789af9ad37a591094744adb80e39e2c68ac259','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503075567),

('entity_browser','c33fe75ea9944fe5c1d8d33397bc4d5e34cb5289','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503074198),

('entity_browser','c3e067cd2c0e2c72f7c89830b3ce61fe3b8e9dfd','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503324160),

('entity_browser','c5f019d8c89158e8c2f4fa3a32a13b1e2a10d7c1','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503073232),

('entity_browser','c87fd0652c3ff78c5434974c732d5f94420569de','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503074873),

('entity_browser','cc14a91f816366bba29cd006be27fa987715f69d','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503331914),

('entity_browser','d3428377142a1e736206c518e348edbad9128d93','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503072730),

('entity_browser','d72c82c774f1ead4885c5e482ddaa3a691df68f7','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503075379),

('entity_browser','d99814f3b6d854f794e9c265a5cd2308178a65d7','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503345123),

('entity_browser','dbf7567894ff53932c8b94ad642f44cba6e82a88','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503347137),

('entity_browser','e2fc83632ad0c275e0a0e2e122666772e47a26cf','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:67108864;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1533055245),

('entity_browser','e43f6dbcf740f822d04c96a69372d62b39999c01','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503324094),

('entity_browser','e6ee0ca24ff36aef63ea2a5fcce07c136def4677','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:67108864;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1533055896),

('entity_browser','e79b025708c5bc6673e0615acc771e460c25ff6d','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503581456),

('entity_browser','e86a57d672aaaab275b9e16b9d9d815668839c50','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503074086),

('entity_browser','eb54bb0c4ef71c8068c0ca5636fbd788fa906d9b','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503344771),

('entity_browser','ee86927f10441ee375f0948fc9e7ab9682152aa2','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503344797),

('entity_browser','eec7f45ce39b5548b991a243e93692584857f5a9','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503344847),

('entity_browser','f5936bb0c8c6caf089b5df5c3e456db143a56302','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503075193),

('entity_browser','f8464908e936b11b90bd9ac895cf436ff6f00c88','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503344412),

('entity_browser','ff98187260507e32b63400bdb3dd5c8217949fec','a:3:{s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:17:\"selected_entities\";a:0:{}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}}',1503073271),

('form','form--CXVOpTUNUrdnhz_2DMCAtiwIegwJxtY2KazikGDn6I','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:3\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:47:53.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"39\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"294555b9-3cc5-4a85-b9f9-5be52efc76ff\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:7:\"Digital\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053356\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"39\";s:4:\"uuid\";s:36:\"294555b9-3cc5-4a85-b9f9-5be52efc76ff\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:7:\"Digital\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:515;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:3:\"und\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:515;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:569;s:14:\"#default_value\";s:36:\"/product/g-star-polo-applique-jersey\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"22\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/3\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:3:\"und\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:569;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:701;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"G-Star Polo Applique Jersey\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:701;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503310503\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:763;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:5:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"3158\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"94.750000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053515\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503310324\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"66\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"240\";s:6:\"height\";s:3:\"320\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:10:\"150.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";i:0;s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";i:0;}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:3:\"und\";s:14:\"#default_value\";r:970;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503310324\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 13:12\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"3\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"und\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"G-Star Polo Applique Jersey\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053273\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503310324\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"39\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"3\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:3:\"und\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:13:\"Not specified\";s:5:\"\0*\0id\";s:3:\"und\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:3;s:9:\"\0*\0locked\";b:1;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form--CXVOpTUNUrdnhz_2DMCAtiwIegwJxtY2KazikGDn6I\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form--CXVOpTUNUrdnhz_2DMCAtiwIegwJxtY2KazikGDn6I\";s:3:\"#id\";s:48:\"form--CXVOpTUNUrdnhz_2DMCAtiwIegwJxtY2KazikGDn6I\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--2iLnvrB11zY\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--Igl7eMeDeSc\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--ZifjmiSpnFo\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503332138),

('form','form--LsSsqh0_0RjtgcKnSaqNtnoDHcyPuPsJI_UnjpOGzo','a:26:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:19:\"editor-image-dialog\";}s:20:\"data-drupal-selector\";s:19:\"editor-image-dialog\";}s:5:\"#tree\";b:1;s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:27:\"editor/drupal.editor.dialog\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#prefix\";s:35:\"<div id=\"editor-image-dialog-form\">\";s:7:\"#suffix\";s:6:\"</div>\";s:3:\"fid\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:12:\"managed_file\";s:16:\"#upload_location\";s:22:\"public://inline-images\";s:14:\"#default_value\";N;s:18:\"#upload_validators\";a:3:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"gif png jpg jpeg\";}s:18:\"file_validate_size\";a:1:{i:0;d:0;}s:30:\"file_validate_image_resolution\";a:1:{i:0;i:0;}}s:9:\"#required\";b:1;}s:10:\"attributes\";a:2:{s:3:\"src\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URL\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:0:\"\";s:10:\"#maxlength\";i:2048;s:9:\"#required\";b:0;s:7:\"#access\";b:0;}s:3:\"alt\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Alternative text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#placeholder\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Short description for the visually impaired\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:9:\"#required\";b:1;s:15:\"#required_error\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:181:\"Alternative text is required.<br />(Only in rare cases should this be left empty. To create empty alternative text, enter <code>\"\"</code> — two double quotes without any content).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:0:\"\";s:10:\"#maxlength\";i:2048;}}s:7:\"actions\";a:2:{s:5:\"#type\";s:7:\"actions\";s:10:\"save_modal\";a:4:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:12:\"::submitForm\";s:5:\"event\";s:5:\"click\";}}}s:8:\"#form_id\";s:19:\"editor_image_dialog\";s:9:\"#build_id\";s:48:\"form--LsSsqh0_0RjtgcKnSaqNtnoDHcyPuPsJI_UnjpOGzo\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:6:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form--LsSsqh0_0RjtgcKnSaqNtnoDHcyPuPsJI_UnjpOGzo\";s:3:\"#id\";s:48:\"form--LsSsqh0_0RjtgcKnSaqNtnoDHcyPuPsJI_UnjpOGzo\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}s:11:\"#attributes\";a:1:{s:12:\"autocomplete\";s:3:\"off\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:48:\"edit-editor-image-dialog-form-token--d7hvySyGWAI\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:19:\"editor_image_dialog\";s:3:\"#id\";s:37:\"edit-editor-image-dialog--udQC0h4i-yc\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:32:\"editor-image-dialog--AacmCl5x4V8\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:19:\"editor_image_dialog\";}s:12:\"#cache_token\";s:43:\"DpU41RlLsRE2pOD2vGpXScNRWpIyOP7ZfvAuCmGdfjk\";}',1531753483),

('form','form-0RHehFaysKaJXq32WW_MMCL5472YnfeD--77nnRCw9E','a:29:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:55:\"commerce-order-item-add-to-cart-form-commerce-product-4\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:55:\"commerce-order-item-add-to-cart-form-commerce-product-4\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--yf78e5EcSAY\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--yf78e5EcSAY\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--yf78e5EcSAY\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--yf78e5EcSAY\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";s:9:\"#build_id\";s:48:\"form-0RHehFaysKaJXq32WW_MMCL5472YnfeD--77nnRCw9E\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:6:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-0RHehFaysKaJXq32WW_MMCL5472YnfeD--77nnRCw9E\";s:3:\"#id\";s:48:\"form-0RHehFaysKaJXq32WW_MMCL5472YnfeD--77nnRCw9E\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}s:11:\"#attributes\";a:1:{s:12:\"autocomplete\";s:3:\"off\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";s:3:\"#id\";s:73:\"edit-commerce-order-item-add-to-cart-form-commerce-product-4--pyVWNHcB3vU\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:68:\"commerce-order-item-add-to-cart-form-commerce-product-4--71ebB1QARzo\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1510520664),

('form','form-1IBGnKqwoqQe0zVEO0x6wqNtkd5Y1ddD4D8oBTFd0yI','a:29:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--919I3jCB4OI\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--919I3jCB4OI\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--919I3jCB4OI\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--919I3jCB4OI\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-1IBGnKqwoqQe0zVEO0x6wqNtkd5Y1ddD4D8oBTFd0yI\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-1IBGnKqwoqQe0zVEO0x6wqNtkd5Y1ddD4D8oBTFd0yI\";s:3:\"#id\";s:48:\"form-1IBGnKqwoqQe0zVEO0x6wqNtkd5Y1ddD4D8oBTFd0yI\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--JEH95IOIpps\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--HdZ4cZwEjtA\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1503428792),

('form','form-1PDPfRFeZ7o-cprsEwyhFSB2Kt04kicsL7btJZdm31Q','a:26:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:19:\"editor-image-dialog\";}s:20:\"data-drupal-selector\";s:19:\"editor-image-dialog\";}s:5:\"#tree\";b:1;s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:27:\"editor/drupal.editor.dialog\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#prefix\";s:35:\"<div id=\"editor-image-dialog-form\">\";s:7:\"#suffix\";s:6:\"</div>\";s:3:\"fid\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:12:\"managed_file\";s:16:\"#upload_location\";s:22:\"public://inline-images\";s:14:\"#default_value\";N;s:18:\"#upload_validators\";a:3:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"gif png jpg jpeg\";}s:18:\"file_validate_size\";a:1:{i:0;d:0;}s:30:\"file_validate_image_resolution\";a:1:{i:0;i:0;}}s:9:\"#required\";b:1;}s:10:\"attributes\";a:2:{s:3:\"src\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URL\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:0:\"\";s:10:\"#maxlength\";i:2048;s:9:\"#required\";b:0;s:7:\"#access\";b:0;}s:3:\"alt\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Alternative text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#placeholder\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Short description for the visually impaired\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:9:\"#required\";b:1;s:15:\"#required_error\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:181:\"Alternative text is required.<br />(Only in rare cases should this be left empty. To create empty alternative text, enter <code>\"\"</code> — two double quotes without any content).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:0:\"\";s:10:\"#maxlength\";i:2048;}}s:7:\"actions\";a:2:{s:5:\"#type\";s:7:\"actions\";s:10:\"save_modal\";a:4:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:12:\"::submitForm\";s:5:\"event\";s:5:\"click\";}}}s:8:\"#form_id\";s:19:\"editor_image_dialog\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:9:\"#build_id\";s:48:\"form-1PDPfRFeZ7o-cprsEwyhFSB2Kt04kicsL7btJZdm31Q\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-1PDPfRFeZ7o-cprsEwyhFSB2Kt04kicsL7btJZdm31Q\";s:3:\"#id\";s:48:\"form-1PDPfRFeZ7o-cprsEwyhFSB2Kt04kicsL7btJZdm31Q\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:48:\"edit-editor-image-dialog-form-token--Kg3LiQM_r30\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:19:\"editor_image_dialog\";s:3:\"#id\";s:37:\"edit-editor-image-dialog--32Fi5l6Vukc\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:32:\"editor-image-dialog--beBHMAkKQ-s\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:19:\"editor_image_dialog\";}s:12:\"#cache_token\";s:43:\"7zSG8KOvzIyajdU96VkCi7718ZFZxCBA8BEl5nvBqlw\";}',1497902686),

('form','form-2GcthApgNfGpPeUOzwxcb79paIrBdtYmvmUhySBwNdY','a:34:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:74:\"config:core.entity_view_display.commerce_product_variation.product.product\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:7:\"#fields\";a:15:{i:0;s:8:\"langcode\";i:1;s:10:\"product_id\";i:2;s:3:\"sku\";i:3;s:5:\"title\";i:4;s:5:\"price\";i:5;s:15:\"attribute_color\";i:6;s:14:\"attribute_size\";i:7;s:17:\"field_description\";i:8;s:12:\"field_images\";i:9;s:12:\"field_length\";i:10;s:15:\"field_old_price\";i:11;s:28:\"field_right_side_description\";i:12;s:15:\"field_sale_text\";i:13;s:23:\"field_short_description\";i:14;s:11:\"field_waist\";}s:6:\"#extra\";a:1:{i:0;s:28:\"commerce_variation_cart_form\";}s:6:\"fields\";a:22:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":13:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:41:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:39:\"commerce_plugin_item:commerce_condition\";a:15:{s:11:\"plugin_type\";s:18:\"commerce_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:226;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"file_uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"file_uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"File URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"An entity field containing a file URI, and a computed root-relative file URL.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"file_uri\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:46:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileUriItem\";s:8:\"provider\";s:4:\"file\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:37:\"Drupal\\pathauto\\PathautoFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:28:\"Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"17ba37a5-f96b-4674-9546-6ecfdf98e091\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:13:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:56:\"core.entity_view_mode.commerce_product_variation.product\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:59:\"field.field.commerce_product_variation.product.field_length\";i:7;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:8;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:9;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:10;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:11;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:12;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:3:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:5:\"image\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.product\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"product\";s:10:\"\0*\0content\";a:4:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"field_images\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:10:\"image_link\";s:7:\"content\";}s:20:\"third_party_settings\";a:0:{}}s:15:\"field_old_price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"2\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:12:{s:15:\"attribute_color\";b:1;s:14:\"attribute_size\";b:1;s:17:\"field_description\";b:1;s:12:\"field_length\";b:1;s:28:\"field_right_side_description\";b:1;s:15:\"field_sale_text\";b:1;s:23:\"field_short_description\";b:1;s:11:\"field_waist\";b:1;s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;s:3:\"sku\";b:1;s:5:\"title\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:12:\"\0*\0messenger\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1228;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1228;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1228;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1228;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1228;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1228;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"product_id\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1356;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1356;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"product_id\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1356;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1356;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1356;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1356;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"sku\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1496;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1496;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"sku\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1496;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1496;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1496;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1496;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:5:\"title\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1624;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1624;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"title\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1624;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1624;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1624;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1591;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1624;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:5:\"price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1749;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1749;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1749;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1749;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1749;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:25:\"commerce_price_calculated\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Calculated\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_price_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"commerce_price_plain\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Plain\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1749;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"attribute_color\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Color\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"attribute_color\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"attribute_color\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1451;s:28:\"entity_reference_entity_view\";r:1455;s:26:\"entity_reference_entity_id\";r:1459;s:22:\"entity_reference_label\";r:1463;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"attribute_color\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:14:\"attribute_size\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Size\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"attribute_size\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"attribute_size\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1451;s:28:\"entity_reference_entity_view\";r:1455;s:26:\"entity_reference_entity_id\";r:1459;s:22:\"entity_reference_label\";r:1463;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"attribute_size\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:17:\"field_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:11:\"Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:17:\"field_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"text_trimmed\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Trimmed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:12:\"field_images\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:5:\"image\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Images\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_images\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1451;s:24:\"rhythm_cms_images_slider\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rhythm CMS: Image Slider\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"image_url\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"URL to image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"image\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:5:\"image\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Image style: @style\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@style\";s:22:\"Product Main (360x459)\";}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Linked to content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_images_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:12:\"field_length\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Length\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_length\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1591;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"field_old_price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Old Price\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_old_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:25:\"commerce_price_calculated\";r:1844;s:22:\"commerce_price_default\";r:1848;s:20:\"commerce_price_plain\";r:1852;}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_old_price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_old_price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:28:\"field_right_side_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:22:\"Right Side Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"field_right_side_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";r:2267;s:12:\"text_trimmed\";r:2271;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"field_sale_text\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Sale text\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_sale_text\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1591;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:23:\"field_short_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"basic_string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:17:\"Short Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:23:\"field_short_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:12:\"basic_string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:11:\"field_waist\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Waist\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_waist\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1591;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:28:\"commerce_variation_cart_form\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:11:\"extra_field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:1:{s:10:\"rowHandler\";s:5:\"field\";}s:10:\"human_name\";a:1:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3256;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"3\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Parents for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3256;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"commerce_variation_cart_form\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3256;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:10:\"empty_cell\";a:1:{s:7:\"#markup\";s:6:\"&nbsp;\";}s:6:\"plugin\";a:1:{s:4:\"type\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:7:\"visible\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}}s:16:\"settings_summary\";a:1:{s:7:\"combine\";a:3:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Combine order items containing the same product variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:1:\"1\";}}s:13:\"settings_edit\";a:0:{}}s:15:\"#parent_options\";a:0:{}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-2GcthApgNfGpPeUOzwxcb79paIrBdtYmvmUhySBwNdY\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:6:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-2GcthApgNfGpPeUOzwxcb79paIrBdtYmvmUhySBwNdY\";s:3:\"#id\";s:48:\"form-2GcthApgNfGpPeUOzwxcb79paIrBdtYmvmUhySBwNdY\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}s:11:\"#attributes\";a:1:{s:12:\"autocomplete\";s:3:\"off\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--oRElo9x7TWc\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--MvO30qmJ2yg\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--JWEF2drXaB0\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:16:\"#entity_builders\";a:1:{i:0;s:71:\"commerce_variation_cart_form_form_entity_view_display_edit_form_builder\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1115;s:12:\"#cache_token\";s:43:\"QAKcqB1P-t_INT2JBl1aiu3LzG74XEUJhlpnQYInqU4\";}',1521045707),

('form','form-2h3H-J-xk8WTeINFnIVMOBjo6knYU1I7JCnpDyK0clo','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--4fjmBq-AqR0\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--4fjmBq-AqR0\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--4fjmBq-AqR0\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--4fjmBq-AqR0\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-2h3H-J-xk8WTeINFnIVMOBjo6knYU1I7JCnpDyK0clo\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-2h3H-J-xk8WTeINFnIVMOBjo6knYU1I7JCnpDyK0clo\";s:3:\"#id\";s:48:\"form-2h3H-J-xk8WTeINFnIVMOBjo6knYU1I7JCnpDyK0clo\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--eAI7lD4t7B4\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--MzEtDLrF9tY\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--knb5vMil4l8\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503596319),

('form','form-2vKLUHI6wtq3zzyI828LQNcgHhrAz8XLMPtK57GmZsk','a:33:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-form-display-edit-form\";i:1;s:24:\"entity-form-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-form-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:74:\"config:core.entity_form_display.commerce_product_variation.product.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:7:\"#fields\";a:18:{i:0;s:8:\"langcode\";i:1;s:3:\"uid\";i:2;s:3:\"sku\";i:3;s:5:\"price\";i:4;s:6:\"status\";i:5;s:7:\"created\";i:6;s:15:\"attribute_color\";i:7;s:14:\"attribute_size\";i:8;s:11:\"field_color\";i:9;s:17:\"field_description\";i:10;s:12:\"field_images\";i:11;s:12:\"field_length\";i:12;s:15:\"field_old_price\";i:13;s:28:\"field_right_side_description\";i:14;s:15:\"field_sale_text\";i:15;s:23:\"field_short_description\";i:16;s:10:\"field_size\";i:17;s:11:\"field_waist\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:25:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:5:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Widget\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityFormDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"form\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:224;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:224;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:224;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"7ead05bb-48d9-4c0d-8503-3978179228c2\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:14:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:35:\"entity_browser.browser.browse_files\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:58:\"field.field.commerce_product_variation.product.field_color\";i:5;s:64:\"field.field.commerce_product_variation.product.field_description\";i:6;s:59:\"field.field.commerce_product_variation.product.field_images\";i:7;s:59:\"field.field.commerce_product_variation.product.field_length\";i:8;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:9;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:10;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:11;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:12;s:57:\"field.field.commerce_product_variation.product.field_size\";i:13;s:58:\"field.field.commerce_product_variation.product.field_waist\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:14:\"entity_browser\";i:2;s:11:\"field_group\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:11:\"field_group\";a:1:{s:16:\"group_properties\";a:6:{s:8:\"children\";a:4:{i:0;s:10:\"field_size\";i:1;s:11:\"field_color\";i:2;s:11:\"field_waist\";i:3;s:12:\"field_length\";}s:11:\"parent_name\";s:0:\"\";s:6:\"weight\";i:6;s:11:\"format_type\";s:7:\"details\";s:15:\"format_settings\";a:4:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:4:\"open\";b:1;s:15:\"required_fields\";b:1;}s:5:\"label\";s:10:\"Properties\";}}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:16:{s:15:\"attribute_color\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:1;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"attribute_size\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"field_color\";a:5:{s:6:\"weight\";s:2:\"22\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:5:{s:6:\"weight\";s:1:\"9\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:5:{s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:17:\"field_widget_edit\";b:1;s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:5:{s:6:\"weight\";s:2:\"24\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:5:{s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:5:{s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:5:{s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:5:{s:6:\"weight\";s:1:\"8\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"string_textarea\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:5:{s:6:\"weight\";s:2:\"21\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:5:{s:6:\"weight\";s:2:\"23\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:5:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:3:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:27:\"plugin.manager.field.widget\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"language_select\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1341;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1341;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1341;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1341;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"language_select\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Language select\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1341;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"uid\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:29:\"entity_reference_autocomplete\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1450;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1450;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"uid\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1450;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1450;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:8:{s:26:\"inline_entity_form_complex\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Inline entity form - Complex\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:25:\"inline_entity_form_simple\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Inline entity form - Simple\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"options_select\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Select list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"options_buttons\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Check boxes/radio buttons\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:34:\"entity_reference_autocomplete_tags\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Autocomplete (Tags style)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:29:\"entity_reference_autocomplete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Autocomplete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_entity_select\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Entity select\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:31:\"entity_browser_entity_reference\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1450;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"sku\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1587;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1587;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"sku\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1587;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1587;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Textfield\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1587;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:3:\"sku\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:17:\"sku_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"price\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1733;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1733;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1733;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1733;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:22:\"commerce_price_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1733;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:6:\"status\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"boolean_checkbox\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1842;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"3\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1842;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"status\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"status\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1842;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1842;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:16:\"boolean_checkbox\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Single on/off checkbox\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"options_buttons\";r:1538;}s:14:\"#default_value\";s:16:\"boolean_checkbox\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"status\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1842;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Use field label: @display_label\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@display_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Yes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:6:\"status\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:20:\"status_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:6:\"status\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:7:\"created\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:18:\"datetime_timestamp\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1992;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1992;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:7:\"created\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1992;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1992;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:18:\"datetime_timestamp\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Datetime Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1992;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"attribute_color\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:29:\"entity_reference_autocomplete\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Color\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:1;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"attribute_color\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"attribute_color\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:8:{s:26:\"inline_entity_form_complex\";r:1526;s:25:\"inline_entity_form_simple\";r:1530;s:14:\"options_select\";r:1534;s:15:\"options_buttons\";r:1538;s:34:\"entity_reference_autocomplete_tags\";r:1542;s:29:\"entity_reference_autocomplete\";r:1546;s:22:\"commerce_entity_select\";r:1550;s:31:\"entity_browser_entity_reference\";r:1554;}s:14:\"#default_value\";s:14:\"options_select\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"attribute_color\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:14:\"attribute_size\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:29:\"entity_reference_autocomplete\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Size\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:2;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"attribute_size\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"attribute_size\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:8:{s:26:\"inline_entity_form_complex\";r:1526;s:25:\"inline_entity_form_simple\";r:1530;s:14:\"options_select\";r:1534;s:15:\"options_buttons\";r:1538;s:34:\"entity_reference_autocomplete_tags\";r:1542;s:29:\"entity_reference_autocomplete\";r:1546;s:22:\"commerce_entity_select\";r:1550;s:31:\"entity_browser_entity_reference\";r:1554;}s:14:\"#default_value\";s:14:\"options_select\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"attribute_size\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:11:\"field_color\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Color\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"22\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:16:\"group_properties\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_color\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1663;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_color\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_color_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:17:\"field_description\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:13:\"text_textarea\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:11:\"Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"9\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:17:\"field_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:13:\"text_textarea\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Text area (multiple rows)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:13:\"text_textarea\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Number of rows: @rows\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@rows\";i:5;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:17:\"field_description\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:31:\"field_description_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:12:\"field_images\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:11:\"image_image\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Images\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"4\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_images\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:11:\"image_image\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"entity_browser_file\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:19:\"entity_browser_file\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:3:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Preview image style: @style\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@style\";s:20:\"Thumbnail (100×100)\";}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Entity browser: @browser\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@browser\";s:17:\"Browser for files\";}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Selection mode: @selection_mode\";s:12:\"\0*\0arguments\";a:1:{s:15:\"@selection_mode\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Append to selection\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_images_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:12:\"field_length\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Length\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"24\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:16:\"group_properties\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_length\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1663;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_length\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_length_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"field_old_price\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Old Price\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_old_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:22:\"commerce_price_default\";r:1809;}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:28:\"field_right_side_description\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:13:\"text_textarea\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:22:\"Right Side Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"10\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"field_right_side_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:13:\"text_textarea\";r:2534;}s:14:\"#default_value\";s:13:\"text_textarea\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Number of rows: @rows\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@rows\";i:5;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:28:\"field_right_side_description\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:42:\"field_right_side_description_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"field_sale_text\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Sale text\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_sale_text\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1663;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_sale_text\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_sale_text_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:23:\"field_short_description\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"string_textarea\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:17:\"Short Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"8\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:23:\"field_short_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"string_textarea\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Text area (multiple rows)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:15:\"string_textarea\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Number of rows: @rows\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@rows\";i:5;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:23:\"field_short_description\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:37:\"field_short_description_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:10:\"field_size\";a:9:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Size\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"21\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:16:\"group_properties\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_size\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1663;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:59:\"Widget settings: <span class=\"plugin-name\">Textfield</span>\";}s:8:\"settings\";a:2:{s:4:\"size\";a:5:{s:5:\"#type\";s:6:\"number\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Size of textfield\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:60;s:9:\"#required\";b:1;s:4:\"#min\";i:1;}s:11:\"placeholder\";a:4:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Placeholder\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:0:\"\";s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:149:\"Text that will be shown inside the field until a value is entered. This hint is usually a sample value or a brief description of the expected format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"field_size\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:33:\"field_size_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"field_size\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:33:\"field_size_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"field_waist\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:114;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Waist\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"23\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:16:\"group_properties\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_waist\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1663;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_waist\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_waist_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"#parent_options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:16:\"group_properties\";a:10:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:11:\"field-group\";}s:2:\"id\";s:16:\"group-properties\";}s:9:\"#row_type\";s:5:\"group\";s:16:\"#region_callback\";s:39:\"field_group_display_overview_row_region\";s:12:\"#js_settings\";a:1:{s:10:\"rowHandler\";s:5:\"group\";}s:10:\"human_name\";a:3:{s:7:\"#markup\";s:10:\"Properties\";s:7:\"#prefix\";s:26:\"<span class=\"group-label\">\";s:7:\"#suffix\";s:7:\"</span>\";}s:6:\"weight\";a:4:{s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";i:6;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:6:{s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:14:\"#default_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:16:\"group_properties\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:16:\"group_properties\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"format\";a:1:{s:4:\"type\";a:4:{s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:9:\"accordion\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Accordion\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"accordion_item\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Accordion Item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"details\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Details\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"fieldset\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Fieldset\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"html_element\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"HTML element\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"tab\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Tab\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"tabs\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tabs\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:7:\"details\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"field-group-type\";}}}}s:16:\"settings_summary\";a:2:{s:7:\"#markup\";s:80:\"<div class=\"field-plugin-summary\">Default state open<br />Mark as required</div>\";s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;a:2:{i:0;r:114;i:1;s:15:\"multistepSubmit\";}}s:5:\"#ajax\";a:3:{s:8:\"callback\";a:2:{i:0;r:114;i:1;s:13:\"multistepAjax\";}s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:16:\"group_properties\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:36:\"group_properties_group_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:16:\"group_properties\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:123:\"</div><a href=\"/admin/commerce/config/product-variation-types/product/edit/form-display/group_properties/delete\">delete</a>\";}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_form_display_edit_form\";s:9:\"#build_id\";s:48:\"form-2vKLUHI6wtq3zzyI828LQNcgHhrAz8XLMPtK57GmZsk\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-2vKLUHI6wtq3zzyI828LQNcgHhrAz8XLMPtK57GmZsk\";s:3:\"#id\";s:48:\"form-2vKLUHI6wtq3zzyI828LQNcgHhrAz8XLMPtK57GmZsk\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-form-display-edit-form-form-token--LDUfbfepcBs\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_form_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-form-display-edit-form--U8VNAS_Q-0M\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-form-display-edit-form--yGmxGx83K1w\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_form_display_edit_form\";i:1;s:24:\"entity_form_display_form\";}s:12:\"#fieldgroups\";a:1:{i:0;s:16:\"group_properties\";}s:8:\"#context\";r:1130;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503347159),

('form','form-3e9AivfNFf7-bxcCqP8IHsa4i3ZvrAREP5KtaoiGFT0','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:150;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:150;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:514;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:514;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:568;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:568;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:700;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:700;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503323088\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:762;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:969;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:4:{s:5:\"#type\";s:6:\"weight\";s:6:\"#delta\";i:50;s:14:\"#default_value\";s:1:\"1\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"ief-entity-delta\";}}}s:7:\"actions\";a:4:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:21:\"ief-entity-operations\";}}s:15:\"ief_entity_edit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:58:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-edit-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:4:\"edit\";}s:17:\"ief_entity_remove\";a:9:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Remove\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:60:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-remove-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:6:\"remove\";s:7:\"#access\";b:1;}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302248\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 10:57\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-3e9AivfNFf7-bxcCqP8IHsa4i3ZvrAREP5KtaoiGFT0\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-3e9AivfNFf7-bxcCqP8IHsa4i3ZvrAREP5KtaoiGFT0\";s:3:\"#id\";s:48:\"form-3e9AivfNFf7-bxcCqP8IHsa4i3ZvrAREP5KtaoiGFT0\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--pT0xaK4-oEc\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--ThOb3cYAvrg\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--6EL2TG-pnws\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503344771),

('form','form-3R587Wd7EevVwvz33sdetmdHw-6Qel_KdSkbzdsBh3k','a:33:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_view_display.commerce_product.product_display.teaser\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:16:\"commerce_product\";s:7:\"#bundle\";s:15:\"product_display\";s:7:\"#fields\";a:10:{i:0;s:8:\"langcode\";i:1;s:3:\"uid\";i:2;s:5:\"title\";i:3;s:7:\"created\";i:4;s:14:\"field_category\";i:5;s:12:\"field_rating\";i:6;s:13:\"field_reviews\";i:7;s:10:\"field_tags\";i:8;s:6:\"stores\";i:9;s:10:\"variations\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:16:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":13:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:41:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:39:\"commerce_plugin_item:commerce_condition\";a:15:{s:11:\"plugin_type\";s:18:\"commerce_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:220;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"file_uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"file_uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"File URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"An entity field containing a file URI, and a computed root-relative file URL.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"file_uri\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:46:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileUriItem\";s:8:\"provider\";s:4:\"file\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:37:\"Drupal\\pathauto\\PathautoFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:28:\"Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"025ac682-e1c1-45ec-8ee9-bff4d42a193c\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"core.entity_view_mode.commerce_product.teaser\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"\0*\0id\";s:39:\"commerce_product.product_display.teaser\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:6:\"teaser\";s:10:\"\0*\0content\";a:2:{s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:2:\"-5\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:8:{s:7:\"created\";b:1;s:14:\"field_category\";b:1;s:12:\"field_rating\";b:1;s:13:\"field_reviews\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:12:\"\0*\0messenger\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"uid\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"uid\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"author\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:5:\"title\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"-5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"title\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"title\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"title_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:7:\"created\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:9:\"timestamp\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:7:\"created\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:13:\"timestamp_ago\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Time ago\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"timestamp\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:14:\"field_category\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:8:\"Category\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"field_category\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:26:\"rhythm_cms_images_one_main\";r:1414;s:29:\"entity_reference_rss_category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"RSS category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";r:1422;s:26:\"entity_reference_entity_id\";r:1426;s:22:\"entity_reference_label\";r:1430;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:12:\"field_rating\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:14:\"fivestar_stars\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Rating\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_rating\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:14:\"fivestar_stars\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"As stars\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"fivestar_percentage\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Percentage (i.e. 92)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"fivestar_rating\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Rating (i.e. 4.2/5)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:13:\"field_reviews\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"comment_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:7:\"Reviews\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:13:\"field_reviews\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"comment_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"field_tags\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Tags\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_tags\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:26:\"rhythm_cms_images_one_main\";r:1414;s:29:\"entity_reference_rss_category\";r:1841;s:28:\"entity_reference_entity_view\";r:1422;s:26:\"entity_reference_entity_id\";r:1426;s:22:\"entity_reference_label\";r:1430;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:6:\"stores\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Stores\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"stores\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1414;s:28:\"entity_reference_entity_view\";r:1422;s:26:\"entity_reference_entity_id\";r:1426;s:22:\"entity_reference_label\";r:1430;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"variations\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:10:\"Variations\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"variations\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:6:{s:26:\"rhythm_cms_images_one_main\";r:1414;s:28:\"entity_reference_entity_view\";r:1422;s:26:\"entity_reference_entity_id\";r:1426;s:22:\"entity_reference_label\";r:1430;s:20:\"commerce_add_to_cart\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:36:\"commerce_product_attributes_overview\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Product attributes overview\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:20:\"commerce_add_to_cart\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Combine order items containing the same product variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"variations\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"variations_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"#parent_options\";a:0:{}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-3R587Wd7EevVwvz33sdetmdHw-6Qel_KdSkbzdsBh3k\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:6:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-3R587Wd7EevVwvz33sdetmdHw-6Qel_KdSkbzdsBh3k\";s:3:\"#id\";s:48:\"form-3R587Wd7EevVwvz33sdetmdHw-6Qel_KdSkbzdsBh3k\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}s:11:\"#attributes\";a:1:{s:12:\"autocomplete\";s:3:\"off\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--Egf5jDTb0D8\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--CDxDLmUMHxg\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--MH_guOQIVPo\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1109;s:12:\"#cache_token\";s:43:\"QAKcqB1P-t_INT2JBl1aiu3LzG74XEUJhlpnQYInqU4\";}',1521222790),

('form','form-4eKsgot8tdBy7UdwlE5FwibzCrZw4qGThLvEGjWl0xE','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--qcpb-m2IcqA\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--qcpb-m2IcqA\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--qcpb-m2IcqA\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--qcpb-m2IcqA\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-4eKsgot8tdBy7UdwlE5FwibzCrZw4qGThLvEGjWl0xE\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-4eKsgot8tdBy7UdwlE5FwibzCrZw4qGThLvEGjWl0xE\";s:3:\"#id\";s:48:\"form-4eKsgot8tdBy7UdwlE5FwibzCrZw4qGThLvEGjWl0xE\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--KxZl9i4EeV0\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--O9icPDW5QKs\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--kq3IHmNe7f8\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503434366),

('form','form-6GfrJDsZjlNzWjxJBLD__E4lPO4Tg0izGnMVX7tMKyM','a:29:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--mo5IUUoz2PA\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--mo5IUUoz2PA\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--mo5IUUoz2PA\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--mo5IUUoz2PA\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-6GfrJDsZjlNzWjxJBLD__E4lPO4Tg0izGnMVX7tMKyM\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-6GfrJDsZjlNzWjxJBLD__E4lPO4Tg0izGnMVX7tMKyM\";s:3:\"#id\";s:48:\"form-6GfrJDsZjlNzWjxJBLD__E4lPO4Tg0izGnMVX7tMKyM\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--4FwUoM6zkUs\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--kS8tUEoI0I4\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1504026420),

('form','form-7kOBYCaQBYTq0NvdT3XjV1RRKzjx7S42f3KlqG0Xk1Y','a:35:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:74:\"config:core.entity_view_display.commerce_product_variation.product.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:7:\"#fields\";a:15:{i:0;s:8:\"langcode\";i:1;s:10:\"product_id\";i:2;s:3:\"sku\";i:3;s:5:\"title\";i:4;s:5:\"price\";i:5;s:11:\"field_color\";i:6;s:17:\"field_description\";i:7;s:12:\"field_images\";i:8;s:12:\"field_length\";i:9;s:15:\"field_old_price\";i:10;s:28:\"field_right_side_description\";i:11;s:15:\"field_sale_text\";i:12;s:23:\"field_short_description\";i:13;s:10:\"field_size\";i:14;s:11:\"field_waist\";}s:6:\"#extra\";a:1:{i:0;s:28:\"commerce_variation_cart_form\";}s:6:\"fields\";a:22:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:226;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:226;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:226;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"bc5d6188-cefe-4350-a39e-4005f7f36258\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:12:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:58:\"field.field.commerce_product_variation.product.field_color\";i:2;s:64:\"field.field.commerce_product_variation.product.field_description\";i:3;s:59:\"field.field.commerce_product_variation.product.field_images\";i:4;s:59:\"field.field.commerce_product_variation.product.field_length\";i:5;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:6;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:7;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:8;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:9;s:57:\"field.field.commerce_product_variation.product.field_size\";i:10;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:11;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:10:\"rhythm_cms\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:14:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:2:\"13\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:11:\"field_color\";a:6:{s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";s:1:\"2\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:5:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:17:\"image_style_small\";s:19:\"product_small_68x86\";s:3:\"col\";s:1:\"3\";s:4:\"zoom\";i:0;s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";s:1:\"7\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";s:1:\"5\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";s:1:\"6\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";s:1:\"8\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:6:{s:6:\"weight\";s:1:\"9\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:2:{s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"product_id\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"product_id\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"sku\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"3\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"sku\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:3:\"sku\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:17:\"sku_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"title\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"title\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"title\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"title_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:20:\"commerce_price_plain\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Plain\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_price_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:25:\"commerce_price_calculated\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Calculated price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:11:\"field_color\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Color\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"10\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_color\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_color\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_color_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:17:\"field_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:11:\"Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"4\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:17:\"field_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"text_trimmed\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Trimmed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"text_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:12:\"field_images\";a:10:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:5:\"image\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Images\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_images\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:24:\"rhythm_cms_images_slider\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rhythm CMS: Image Slider\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"rhythm_cms_images_one_main\";r:1537;s:9:\"image_url\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"URL to image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"image\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:26:\"rhythm_cms_images_one_main\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:77:\"Format settings: <span class=\"plugin-name\">Rhythm CMS: Images One Main</span>\";}s:8:\"settings\";a:4:{s:11:\"image_style\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Image Style for Main Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:14:\"#default_value\";s:20:\"product_main_360x459\";s:13:\"#empty_option\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"None (original image)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:23:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:25:\"file_entity_browser_small\";s:35:\"File Entity Browser small thumbnail\";s:29:\"file_entity_browser_thumbnail\";s:29:\"File Entity Browser thumbnail\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:5:\"large\";s:16:\"Large (480×480)\";s:15:\"md_slider_thumb\";s:15:\"MD Slider Thumb\";s:6:\"medium\";s:17:\"Medium (220×220)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";s:15:\"product_263x335\";s:17:\"Product (263x335)\";s:13:\"product_70x70\";s:15:\"Product (70x70)\";s:20:\"product_main_360x459\";s:22:\"Product Main (360x459)\";s:19:\"product_small_68x86\";s:21:\"Product Small (68x86)\";s:12:\"slider_pager\";s:12:\"Slider Pager\";s:9:\"thumbnail\";s:20:\"Thumbnail (100×100)\";}s:12:\"#description\";a:4:{s:5:\"#type\";s:4:\"link\";s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:29:\"entity.image_style.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Configure Image Styles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;}}s:17:\"image_style_small\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Image Style for Small Images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:14:\"#default_value\";s:19:\"product_small_68x86\";s:13:\"#empty_option\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"None (original image)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:23:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:25:\"file_entity_browser_small\";s:35:\"File Entity Browser small thumbnail\";s:29:\"file_entity_browser_thumbnail\";s:29:\"File Entity Browser thumbnail\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:5:\"large\";s:16:\"Large (480×480)\";s:15:\"md_slider_thumb\";s:15:\"MD Slider Thumb\";s:6:\"medium\";s:17:\"Medium (220×220)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";s:15:\"product_263x335\";s:17:\"Product (263x335)\";s:13:\"product_70x70\";s:15:\"Product (70x70)\";s:20:\"product_main_360x459\";s:22:\"Product Main (360x459)\";s:19:\"product_small_68x86\";s:21:\"Product Small (68x86)\";s:12:\"slider_pager\";s:12:\"Slider Pager\";s:9:\"thumbnail\";s:20:\"Thumbnail (100×100)\";}s:12:\"#description\";a:4:{s:5:\"#type\";s:4:\"link\";s:4:\"#url\";r:2500;s:6:\"#title\";r:2512;s:7:\"#access\";b:1;}}s:3:\"col\";a:4:{s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:4:{i:2;i:2;i:3;i:3;i:4;i:4;i:6;i:6;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Columns Count for Small Images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:1:\"3\";}s:4:\"zoom\";a:3:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add Zoom feature\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";b:1;}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:35:\"field_images_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:35:\"field_images_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}}}s:12:\"field_length\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Length\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"12\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_length\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_length\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_length_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"field_old_price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Old Price\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"7\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_old_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:20:\"commerce_price_plain\";r:1980;s:22:\"commerce_price_default\";r:1984;s:25:\"commerce_price_calculated\";r:1988;}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_old_price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_old_price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:28:\"field_right_side_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:22:\"Right Side Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"field_right_side_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";r:2300;s:12:\"text_trimmed\";r:2304;}s:14:\"#default_value\";s:12:\"text_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"field_sale_text\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Sale text\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"6\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_sale_text\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_sale_text\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_sale_text_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:23:\"field_short_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"basic_string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:17:\"Short Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"8\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:23:\"field_short_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:12:\"basic_string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"basic_string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"field_size\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Size\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"9\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_size\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"field_size\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"field_size_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:11:\"field_waist\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Waist\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"11\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_waist\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_waist\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_waist_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:28:\"commerce_variation_cart_form\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:11:\"extra_field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:1:{s:10:\"rowHandler\";s:5:\"field\";}s:10:\"human_name\";a:1:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3634;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"13\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Parents for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3634;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"commerce_variation_cart_form\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3634;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:10:\"empty_cell\";a:1:{s:7:\"#markup\";s:6:\"&nbsp;\";}s:6:\"plugin\";a:1:{s:4:\"type\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:7:\"visible\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}}s:16:\"settings_summary\";a:1:{s:7:\"combine\";a:3:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Combine order items containing the same product variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:1:\"1\";}}s:13:\"settings_edit\";a:0:{}}s:15:\"#parent_options\";a:0:{}}s:5:\"modes\";a:4:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Custom display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"display_modes_custom\";a:4:{s:5:\"#type\";s:10:\"checkboxes\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"Use custom display settings for the following @display_context modes\";s:12:\"\0*\0arguments\";a:1:{s:16:\"@display_context\";s:4:\"view\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:4:{s:4:\"cart\";s:4:\"Cart\";s:7:\"product\";s:7:\"Product\";s:7:\"summary\";s:7:\"Summary\";s:5:\"token\";s:5:\"Token\";}s:14:\"#default_value\";a:2:{i:0;s:4:\"cart\";i:1;s:7:\"product\";}}s:18:\"display_modes_link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Manage view modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:34:\"entity.entity_view_mode.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-7kOBYCaQBYTq0NvdT3XjV1RRKzjx7S42f3KlqG0Xk1Y\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-7kOBYCaQBYTq0NvdT3XjV1RRKzjx7S42f3KlqG0Xk1Y\";s:3:\"#id\";s:48:\"form-7kOBYCaQBYTq0NvdT3XjV1RRKzjx7S42f3KlqG0Xk1Y\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--jtVnSIfA9-c\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--Ljeqb7czSmc\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--98ZInsTQuV8\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:16:\"#entity_builders\";a:1:{i:0;s:71:\"commerce_variation_cart_form_form_entity_view_display_edit_form_builder\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1132;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503337825),

('form','form-9wGCzuNBdkWmF9qseaUkQ9SaI4m4SeZaFx-jokHI7mk','a:26:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:19:\"editor-image-dialog\";}s:20:\"data-drupal-selector\";s:19:\"editor-image-dialog\";}s:5:\"#tree\";b:1;s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:27:\"editor/drupal.editor.dialog\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#prefix\";s:35:\"<div id=\"editor-image-dialog-form\">\";s:7:\"#suffix\";s:6:\"</div>\";s:3:\"fid\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:12:\"managed_file\";s:16:\"#upload_location\";s:22:\"public://inline-images\";s:14:\"#default_value\";N;s:18:\"#upload_validators\";a:3:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"gif png jpg jpeg\";}s:18:\"file_validate_size\";a:1:{i:0;d:0;}s:30:\"file_validate_image_resolution\";a:1:{i:0;i:0;}}s:9:\"#required\";b:1;}s:10:\"attributes\";a:2:{s:3:\"src\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URL\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:0:\"\";s:10:\"#maxlength\";i:2048;s:9:\"#required\";b:0;s:7:\"#access\";b:0;}s:3:\"alt\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Alternative text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#placeholder\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Short description for the visually impaired\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:9:\"#required\";b:1;s:15:\"#required_error\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:181:\"Alternative text is required.<br />(Only in rare cases should this be left empty. To create empty alternative text, enter <code>\"\"</code> — two double quotes without any content).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:0:\"\";s:10:\"#maxlength\";i:2048;}}s:7:\"actions\";a:2:{s:5:\"#type\";s:7:\"actions\";s:10:\"save_modal\";a:4:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:12:\"::submitForm\";s:5:\"event\";s:5:\"click\";}}}s:8:\"#form_id\";s:19:\"editor_image_dialog\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:9:\"#build_id\";s:48:\"form-9wGCzuNBdkWmF9qseaUkQ9SaI4m4SeZaFx-jokHI7mk\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-9wGCzuNBdkWmF9qseaUkQ9SaI4m4SeZaFx-jokHI7mk\";s:3:\"#id\";s:48:\"form-9wGCzuNBdkWmF9qseaUkQ9SaI4m4SeZaFx-jokHI7mk\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:48:\"edit-editor-image-dialog-form-token--w7Y1OWsW4dc\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:19:\"editor_image_dialog\";s:3:\"#id\";s:37:\"edit-editor-image-dialog--G019lADzjGo\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:32:\"editor-image-dialog--uC3MzQOhpW4\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:19:\"editor_image_dialog\";}s:12:\"#cache_token\";s:43:\"7zSG8KOvzIyajdU96VkCi7718ZFZxCBA8BEl5nvBqlw\";}',1497902660),

('form','form-9xg8hgXFal9rJ5cXFLJqKgKj42eBa7QC_3Bj_HhnqDE','a:34:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:72:\"config:core.entity_view_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:16:\"commerce_product\";s:7:\"#bundle\";s:15:\"product_display\";s:7:\"#fields\";a:9:{i:0;s:8:\"langcode\";i:1;s:3:\"uid\";i:2;s:7:\"created\";i:3;s:14:\"field_category\";i:4;s:12:\"field_rating\";i:5;s:13:\"field_reviews\";i:6;s:10:\"field_tags\";i:7;s:6:\"stores\";i:8;s:10:\"variations\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:15:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:219;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:219;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:219;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"09d511c6-2622-4997-b678-90c8ff763aed\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"core.entity_view_display.comment.default_reviews.default\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:8:\"fivestar\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:6:{s:14:\"field_category\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:12:\"field_rating\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:40:\"modules/fivestar/widgets/basic/basic.css\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"fivestar_stars\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:6:{s:6:\"weight\";s:2:\"14\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:6:{s:6:\"weight\";s:2:\"13\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:10:\"variations\";a:6:{s:4:\"type\";s:28:\"entity_reference_entity_view\";s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:4:\"link\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:4:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"uid\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"uid\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:6:\"author\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:7:\"created\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:9:\"timestamp\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1505;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1505;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:7:\"created\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1505;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1505;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1505;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:13:\"timestamp_ago\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Time ago\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"timestamp\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1505;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:14:\"field_category\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:8:\"Category\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"12\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"field_category\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:29:\"entity_reference_rss_category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"RSS category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";r:1464;s:26:\"entity_reference_entity_id\";r:1468;s:22:\"entity_reference_label\";r:1472;}s:14:\"#default_value\";s:22:\"entity_reference_label\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Link to the referenced entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:14:\"field_category\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:28:\"field_category_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:12:\"field_rating\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:14:\"fivestar_stars\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Rating\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"11\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_rating\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:14:\"fivestar_stars\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"As stars\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"fivestar_percentage\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Percentage (i.e. 92)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"fivestar_rating\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Rating (i.e. 4.2/5)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:14:\"fivestar_stars\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_rating\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_rating_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:13:\"field_reviews\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"comment_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:7:\"Reviews\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"14\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:13:\"field_reviews\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"comment_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:15:\"comment_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Comment view mode: @mode\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@mode\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:13:\"field_reviews\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:27:\"field_reviews_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:10:\"field_tags\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Tags\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"13\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_tags\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:29:\"entity_reference_rss_category\";r:1729;s:28:\"entity_reference_entity_view\";r:1464;s:26:\"entity_reference_entity_id\";r:1468;s:22:\"entity_reference_label\";r:1472;}s:14:\"#default_value\";s:22:\"entity_reference_label\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Link to the referenced entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"field_tags\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"field_tags_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:6:\"stores\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Stores\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"stores\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:28:\"entity_reference_entity_view\";r:1464;s:26:\"entity_reference_entity_id\";r:1468;s:22:\"entity_reference_label\";r:1472;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"variations\";a:10:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:10:\"Variations\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"10\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"variations\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:28:\"entity_reference_entity_view\";r:1464;s:26:\"entity_reference_entity_id\";r:1468;s:22:\"entity_reference_label\";r:1472;s:20:\"commerce_add_to_cart\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:36:\"commerce_product_attributes_overview\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Product attributes overview\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:28:\"entity_reference_entity_view\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:65:\"Format settings: <span class=\"plugin-name\">Rendered entity</span>\";}s:8:\"settings\";a:1:{s:9:\"view_mode\";a:5:{s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:4:{s:7:\"default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"cart\";s:4:\"Cart\";s:7:\"summary\";s:7:\"Summary\";s:5:\"token\";s:5:\"Token\";}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:7:\"default\";s:9:\"#required\";b:1;}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"variations\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:33:\"variations_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"variations\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:33:\"variations_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}}}s:15:\"#parent_options\";a:0:{}}s:5:\"modes\";a:4:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Custom display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"display_modes_custom\";a:4:{s:5:\"#type\";s:10:\"checkboxes\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"Use custom display settings for the following @display_context modes\";s:12:\"\0*\0arguments\";a:1:{s:16:\"@display_context\";s:4:\"view\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:1:{s:5:\"token\";s:5:\"Token\";}s:14:\"#default_value\";a:0:{}}s:18:\"display_modes_link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Manage view modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:34:\"entity.entity_view_mode.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-9xg8hgXFal9rJ5cXFLJqKgKj42eBa7QC_3Bj_HhnqDE\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-9xg8hgXFal9rJ5cXFLJqKgKj42eBa7QC_3Bj_HhnqDE\";s:3:\"#id\";s:48:\"form-9xg8hgXFal9rJ5cXFLJqKgKj42eBa7QC_3Bj_HhnqDE\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--n1klsan1z5A\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--z07kDwboPjE\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--4XL-I-aDz2E\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1125;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503325135),

('form','form-A2DngDQyJ3ULKIap6pquG2gmahE7svITzSKdbfg9T9M','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:150;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:150;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:514;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:514;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:568;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:568;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:700;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:700;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503302531\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:762;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:969;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:21:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"1\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:1148;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:1;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:1;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302248\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 10:57\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:4:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}s:5:\"query\";a:1:{s:11:\"destination\";s:24:\"/admin/commerce/products\";}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-A2DngDQyJ3ULKIap6pquG2gmahE7svITzSKdbfg9T9M\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-A2DngDQyJ3ULKIap6pquG2gmahE7svITzSKdbfg9T9M\";s:3:\"#id\";s:48:\"form-A2DngDQyJ3ULKIap6pquG2gmahE7svITzSKdbfg9T9M\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--moDNf3npCGs\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--JGKNSt9Yn7U\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--NJCw9GSCC3w\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503324209),

('form','form-aATv6vy-NVWooEPAhCx92K3xAKUfCPQlfJGVNpkT8kc','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:150;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:150;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:2;s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:514;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:514;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:568;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:568;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:700;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:700;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503301979\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:762;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:19:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:43:\"Religion Jersey Polo Shirts - Medium, White\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:1001:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:43:\"Religion Jersey Polo Shirts - Medium, White\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:969;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:17:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:42:\"Religion Jersey Polo Shirts - Large, Green\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:42:\"Religion Jersey Polo Shirts - Large, Green\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:4:{s:5:\"#type\";s:6:\"weight\";s:6:\"#delta\";i:50;s:14:\"#default_value\";s:1:\"1\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"ief-entity-delta\";}}}s:7:\"actions\";a:4:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:21:\"ief-entity-operations\";}}s:15:\"ief_entity_edit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:58:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-edit-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:4:\"edit\";}s:17:\"ief_entity_remove\";a:9:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Remove\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:60:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-remove-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:6:\"remove\";s:7:\"#access\";b:1;}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503053967\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/18/2017 - 13:59\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:4:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053967\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}s:5:\"query\";a:1:{s:11:\"destination\";s:24:\"/admin/commerce/products\";}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-aATv6vy-NVWooEPAhCx92K3xAKUfCPQlfJGVNpkT8kc\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-aATv6vy-NVWooEPAhCx92K3xAKUfCPQlfJGVNpkT8kc\";s:3:\"#id\";s:48:\"form-aATv6vy-NVWooEPAhCx92K3xAKUfCPQlfJGVNpkT8kc\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--AET-pKRbLJo\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--5K-GofSS6mk\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--GuOSYTRKuD8\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503323712),

('form','form-Apa8gElu7h7mtmYdf5eaFF0N56tFAsiyMX5Deaw3Qqo','a:24:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:40:\"commerce-checkout-flow-multistep-default\";i:1;s:22:\"commerce-checkout-flow\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:40:\"commerce-checkout-flow-multistep-default\";}s:5:\"#tree\";b:1;s:8:\"#step_id\";s:17:\"order_information\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#theme\";a:1:{i:0;s:22:\"commerce_checkout_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:22:\"commerce_checkout/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:7:\"#access\";b:1;s:4:\"next\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Continue to review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:7:\"#suffix\";O:25:\"Drupal\\Core\\GeneratedLink\":5:{s:16:\"\0*\0generatedLink\";s:39:\"<a href=\"/checkout/8/login\">Go back</a>\";s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0attachments\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:6:{i:0;s:9:\"btn-small\";i:1;s:8:\"btn-gray\";i:2;s:3:\"btn\";i:3;s:7:\"btn-mod\";i:4;s:9:\"btn-round\";i:5;s:11:\"form-submit\";}}}}s:19:\"contact_information\";a:5:{s:8:\"#parents\";a:1:{i:0;s:19:\"contact_information\";}s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Contact information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"email\";a:4:{s:5:\"#type\";s:5:\"email\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";N;s:9:\"#required\";b:1;}s:13:\"email_confirm\";a:4:{s:5:\"#type\";s:5:\"email\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Confirm email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";N;s:9:\"#required\";b:1;}}s:19:\"payment_information\";a:8:{s:8:\"#parents\";a:1:{i:0;s:19:\"payment_information\";}s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Payment information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#wrapper_id\";s:40:\"payment-information-wrapper--fQJrZns4YFE\";s:7:\"#prefix\";s:51:\"<div id=\"payment-information-wrapper--fQJrZns4YFE\">\";s:7:\"#suffix\";s:6:\"</div>\";s:14:\"payment_method\";a:7:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Payment method\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:1:{s:23:\"payment_gateway_example\";s:7:\"Example\";}s:14:\"#default_value\";s:23:\"payment_gateway_example\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:40:\"payment-information-wrapper--fQJrZns4YFE\";}s:7:\"#access\";b:0;s:23:\"payment_gateway_example\";a:1:{s:16:\"#payment_gateway\";s:23:\"payment_gateway_example\";}}s:19:\"billing_information\";a:4:{s:5:\"#type\";s:23:\"commerce_profile_select\";s:14:\"#default_value\";O:29:\"Drupal\\profile\\Entity\\Profile\":25:{s:9:\"\0*\0values\";a:10:{s:11:\"revision_id\";a:1:{s:9:\"x-default\";a:0:{}}s:10:\"profile_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"06a7fefb-2360-48ed-b316-e9ef16438b98\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:8:\"customer\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"0\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}}s:10:\"is_default\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1505330110;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1505330110;}}}s:7:\"address\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:2:{s:6:\"bundle\";s:8:\"customer\";s:8:\"revision\";N;}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:7:\"profile\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#default_country\";s:2:\"US\";s:20:\"#available_countries\";a:1:{i:0;s:2:\"CA\";}}}s:7:\"sidebar\";a:1:{s:13:\"order_summary\";a:4:{s:8:\"#parents\";a:2:{i:0;s:7:\"sidebar\";i:1;s:13:\"order_summary\";}s:5:\"#type\";s:9:\"container\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Order summary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"view\";a:5:{s:5:\"#type\";s:4:\"view\";s:5:\"#name\";s:31:\"commerce_checkout_order_summary\";s:11:\"#display_id\";s:7:\"default\";s:10:\"#arguments\";a:1:{i:0;s:1:\"8\";}s:6:\"#embed\";b:1;}}}s:8:\"#form_id\";s:40:\"commerce_checkout_flow_multistep_default\";s:9:\"#build_id\";s:48:\"form-Apa8gElu7h7mtmYdf5eaFF0N56tFAsiyMX5Deaw3Qqo\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-Apa8gElu7h7mtmYdf5eaFF0N56tFAsiyMX5Deaw3Qqo\";s:3:\"#id\";s:48:\"form-Apa8gElu7h7mtmYdf5eaFF0N56tFAsiyMX5Deaw3Qqo\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:40:\"commerce_checkout_flow_multistep_default\";s:3:\"#id\";s:58:\"edit-commerce-checkout-flow-multistep-default--SLAl8nUIR7E\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:53:\"commerce-checkout-flow-multistep-default--saVg2nvmklM\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}}',1505351710),

('form','form-avu70oK7twg5sBfEib360skXFN6NJTcNHbT_arrY6k8','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--WvtmgKq_4kc\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--WvtmgKq_4kc\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--WvtmgKq_4kc\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--WvtmgKq_4kc\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-avu70oK7twg5sBfEib360skXFN6NJTcNHbT_arrY6k8\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-avu70oK7twg5sBfEib360skXFN6NJTcNHbT_arrY6k8\";s:3:\"#id\";s:48:\"form-avu70oK7twg5sBfEib360skXFN6NJTcNHbT_arrY6k8\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--SfC8230U580\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--iQhaxQOU-t8\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--GE6ZuBslrm8\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503429686),

('form','form-B9ST9BLjT4b1OJTBFJgrYkNcqRqSwvdQ29nETMz3zUQ','a:26:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:40:\"commerce-checkout-flow-multistep-default\";i:1;s:22:\"commerce-checkout-flow\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:40:\"commerce-checkout-flow-multistep-default\";}s:5:\"#tree\";b:1;s:8:\"#step_id\";s:17:\"order_information\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#theme\";a:1:{i:0;s:22:\"commerce_checkout_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:22:\"commerce_checkout/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:7:\"#access\";b:1;s:4:\"next\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Continue to review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:6:{i:0;s:9:\"btn-small\";i:1;s:8:\"btn-gray\";i:2;s:3:\"btn\";i:3;s:7:\"btn-mod\";i:4;s:9:\"btn-round\";i:5;s:11:\"form-submit\";}}}}s:19:\"payment_information\";a:8:{s:8:\"#parents\";a:1:{i:0;s:19:\"payment_information\";}s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Payment information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#wrapper_id\";s:40:\"payment-information-wrapper--3VB0g2koB-E\";s:7:\"#prefix\";s:51:\"<div id=\"payment-information-wrapper--3VB0g2koB-E\">\";s:7:\"#suffix\";s:6:\"</div>\";s:14:\"payment_method\";a:7:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Payment method\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:1:{s:23:\"payment_gateway_example\";s:7:\"Example\";}s:14:\"#default_value\";s:23:\"payment_gateway_example\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:40:\"payment-information-wrapper--3VB0g2koB-E\";}s:7:\"#access\";b:0;s:23:\"payment_gateway_example\";a:1:{s:16:\"#payment_gateway\";s:23:\"payment_gateway_example\";}}s:19:\"billing_information\";a:4:{s:5:\"#type\";s:23:\"commerce_profile_select\";s:14:\"#default_value\";O:29:\"Drupal\\profile\\Entity\\Profile\":25:{s:9:\"\0*\0values\";a:10:{s:11:\"revision_id\";a:1:{s:9:\"x-default\";a:0:{}}s:10:\"profile_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"266f5fd1-ece4-4a5a-bcc1-60f5ae8fd2da\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:8:\"customer\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}}s:10:\"is_default\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503490053;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503490053;}}}s:7:\"address\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:2:{s:6:\"bundle\";s:8:\"customer\";s:8:\"revision\";N;}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:7:\"profile\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#default_country\";s:2:\"US\";s:20:\"#available_countries\";a:1:{i:0;s:2:\"CA\";}}}s:7:\"sidebar\";a:1:{s:13:\"order_summary\";a:4:{s:8:\"#parents\";a:2:{i:0;s:7:\"sidebar\";i:1;s:13:\"order_summary\";}s:5:\"#type\";s:9:\"container\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Order summary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"view\";a:5:{s:5:\"#type\";s:4:\"view\";s:5:\"#name\";s:31:\"commerce_checkout_order_summary\";s:11:\"#display_id\";s:7:\"default\";s:10:\"#arguments\";a:1:{i:0;s:1:\"1\";}s:6:\"#embed\";b:1;}}}s:8:\"#form_id\";s:40:\"commerce_checkout_flow_multistep_default\";s:9:\"#build_id\";s:48:\"form-B9ST9BLjT4b1OJTBFJgrYkNcqRqSwvdQ29nETMz3zUQ\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-B9ST9BLjT4b1OJTBFJgrYkNcqRqSwvdQ29nETMz3zUQ\";s:3:\"#id\";s:48:\"form-B9ST9BLjT4b1OJTBFJgrYkNcqRqSwvdQ29nETMz3zUQ\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_OyQ1_vZi4P0YDPB22kq-Yc_V3UgBo1d1Is9pgEsoUA4\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:69:\"edit-commerce-checkout-flow-multistep-default-form-token--LCA1HVpOpHc\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_OyQ1_vZi4P0YDPB22kq-Yc_V3UgBo1d1Is9pgEsoUA4\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_OyQ1_vZi4P0YDPB22kq-Yc_V3UgBo1d1Is9pgEsoUA4\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_OyQ1_vZi4P0YDPB22kq-Yc_V3UgBo1d1Is9pgEsoUA4\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:40:\"commerce_checkout_flow_multistep_default\";s:3:\"#id\";s:58:\"edit-commerce-checkout-flow-multistep-default--GTHBoGBt9UY\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:53:\"commerce-checkout-flow-multistep-default--nLwhRXsgaQE\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503511653),

('form','form-BE1FlxFX_7fUjGlRqNagkLWwT3S2OA7GuKo4124Qk8I','a:34:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:64:\"config:core.entity_view_display.commerce_product.default.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:16:\"commerce_product\";s:7:\"#bundle\";s:7:\"default\";s:7:\"#fields\";a:7:{i:0;s:8:\"langcode\";i:1;s:3:\"uid\";i:2;s:5:\"title\";i:3;s:7:\"created\";i:4;s:4:\"body\";i:5;s:6:\"stores\";i:6;s:10:\"variations\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:13:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":13:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:41:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:39:\"commerce_plugin_item:commerce_condition\";a:15:{s:11:\"plugin_type\";s:18:\"commerce_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:28:\"commerce_plugin_item_default\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:218;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:28:\"commerce_plugin_item_default\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"file_uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"file_uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"File URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"An entity field containing a file URI, and a computed root-relative file URL.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"file_uri\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:46:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileUriItem\";s:8:\"provider\";s:4:\"file\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:37:\"Drupal\\pathauto\\PathautoFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:28:\"Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"ef55e6d3-d8b2-467a-bf69-a02b0aed8740\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:46:\"commerce_product.commerce_product_type.default\";i:1;s:41:\"field.field.commerce_product.default.body\";i:2;s:43:\"field.field.commerce_product.default.stores\";i:3;s:47:\"field.field.commerce_product.default.variations\";}s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:4:\"text\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"gT03TFcuSod4d9uPQNs_gqK1F1QZ0Ray5CBYW0BNLnk\";}s:5:\"\0*\0id\";s:32:\"commerce_product.default.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:3:{s:4:\"body\";a:6:{s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";s:1:\"1\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:2:\"-5\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:4:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:18:\"\0*\0_entityStorages\";a:0:{}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:12:\"\0*\0messenger\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1191;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"uid\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:107;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"uid\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"author\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1319;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:5:\"title\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:107;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"-5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"title\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1463;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"title\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"title_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:7:\"created\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:107;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:9:\"timestamp\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:7:\"created\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:13:\"timestamp_ago\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Time ago\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"timestamp\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1616;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:4:\"body\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:107;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Body\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Body\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Body\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:4:\"body\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:4:\"body\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Body\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Body\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Body\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:12:\"text_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:23:\"text_summary_or_trimmed\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Summary or trimmed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"text_trimmed\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Trimmed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"text_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:4:\"body\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Body\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:6:\"stores\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:107;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Stores\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"stores\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1414;s:28:\"entity_reference_entity_view\";r:1422;s:26:\"entity_reference_entity_id\";r:1426;s:22:\"entity_reference_label\";r:1430;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"variations\";a:10:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:107;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:10:\"Variations\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"variations\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:6:{s:26:\"rhythm_cms_images_one_main\";r:1414;s:28:\"entity_reference_entity_view\";r:1422;s:26:\"entity_reference_entity_id\";r:1426;s:22:\"entity_reference_label\";r:1430;s:20:\"commerce_add_to_cart\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:36:\"commerce_product_attributes_overview\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Product attributes overview\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:20:\"commerce_add_to_cart\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:66:\"Format settings: <span class=\"plugin-name\">Add to cart form</span>\";}s:8:\"settings\";a:1:{s:7:\"combine\";a:4:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Combine order items containing the same product variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:130:\"The order item type, referenced product variation, and data from fields exposed on the Add to Cart form must all match to combine.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";b:1;}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"variations\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:33:\"variations_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"variations\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:33:\"variations_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}}}s:15:\"#parent_options\";a:0:{}}s:5:\"modes\";a:4:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Custom display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"display_modes_custom\";a:4:{s:5:\"#type\";s:10:\"checkboxes\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"Use custom display settings for the following @display_context modes\";s:12:\"\0*\0arguments\";a:1:{s:16:\"@display_context\";s:4:\"view\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:2:{s:6:\"teaser\";s:6:\"Teaser\";s:5:\"token\";s:5:\"Token\";}s:14:\"#default_value\";a:0:{}}s:18:\"display_modes_link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Manage view modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":12:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:34:\"entity.entity_view_mode.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-BE1FlxFX_7fUjGlRqNagkLWwT3S2OA7GuKo4124Qk8I\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:6:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-BE1FlxFX_7fUjGlRqNagkLWwT3S2OA7GuKo4124Qk8I\";s:3:\"#id\";s:48:\"form-BE1FlxFX_7fUjGlRqNagkLWwT3S2OA7GuKo4124Qk8I\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}s:11:\"#attributes\";a:1:{s:12:\"autocomplete\";s:3:\"off\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--h-2IMKcKuY8\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--oOIQahnZtIs\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--CGKk5wVrJjY\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1105;s:12:\"#cache_token\";s:43:\"fnJ1Q2XncYp8P0dAIbcexnsT-uy-tGZhoWkkmJDFsGc\";}',1558276574),

('form','form-BkJGTcS_8m9o51AXd6stRm0FaqNldubN1is4u3fH-Go','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--14WDY2JyRO0\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--14WDY2JyRO0\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--14WDY2JyRO0\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--14WDY2JyRO0\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-BkJGTcS_8m9o51AXd6stRm0FaqNldubN1is4u3fH-Go\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-BkJGTcS_8m9o51AXd6stRm0FaqNldubN1is4u3fH-Go\";s:3:\"#id\";s:48:\"form-BkJGTcS_8m9o51AXd6stRm0FaqNldubN1is4u3fH-Go\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--zGI2GnSkJwE\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--EvQaUfAV8TU\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--5zBkw5kXfas\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503428683),

('form','form-bpNd71gweH42D3XoY7NhMfthhe1D2-U00vJEC_QYV3I','a:31:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-form-display-edit-form\";i:1;s:24:\"entity-form-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-form-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:74:\"config:core.entity_form_display.commerce_product_variation.product.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:7:\"#fields\";a:14:{i:0;s:8:\"langcode\";i:1;s:3:\"uid\";i:2;s:3:\"sku\";i:3;s:5:\"price\";i:4;s:6:\"status\";i:5;s:7:\"created\";i:6;s:15:\"attribute_color\";i:7;s:14:\"attribute_size\";i:8;s:17:\"field_description\";i:9;s:12:\"field_images\";i:10;s:15:\"field_old_price\";i:11;s:28:\"field_right_side_description\";i:12;s:15:\"field_sale_text\";i:13;s:23:\"field_short_description\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:19:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:5:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Widget\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityFormDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"form\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:220;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:220;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:220;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"list_integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"list_string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:43:\"Drupal\\path\\Plugin\\Field\\FieldType\\PathItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"text_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:17:\"text_with_summary\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"7ead05bb-48d9-4c0d-8503-3978179228c2\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:10:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:35:\"entity_browser.browser.browse_files\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:7;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:8;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:9;s:70:\"field.field.commerce_product_variation.product.field_short_description\";}s:6:\"module\";a:3:{i:0;s:14:\"commerce_price\";i:1;s:14:\"entity_browser\";i:2;s:4:\"text\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:12:{s:15:\"attribute_color\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";s:1:\"7\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"attribute_size\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";s:1:\"6\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:5:{s:6:\"weight\";s:1:\"9\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:5:{s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:17:\"field_widget_edit\";b:1;s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:5:{s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:5:{s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:5:{s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:5:{s:6:\"weight\";s:1:\"8\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"string_textarea\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:5:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:3:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:27:\"plugin.manager.field.widget\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"language_select\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1274;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1274;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1274;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1274;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"language_select\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Language select\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1274;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"uid\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:29:\"entity_reference_autocomplete\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1383;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1383;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"uid\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1383;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1383;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:8:{s:26:\"inline_entity_form_complex\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Inline entity form - Complex\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:25:\"inline_entity_form_simple\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Inline entity form - Simple\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"options_select\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Select list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"options_buttons\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Check boxes/radio buttons\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:34:\"entity_reference_autocomplete_tags\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Autocomplete (Tags style)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:29:\"entity_reference_autocomplete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Autocomplete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_entity_select\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Entity select\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:31:\"entity_browser_entity_reference\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1383;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"sku\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1520;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1520;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"sku\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1520;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1520;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Textfield\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1520;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:3:\"sku\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:17:\"sku_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"price\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1666;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1666;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1666;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1666;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:22:\"commerce_price_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1666;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:6:\"status\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"boolean_checkbox\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"3\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"status\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"status\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:16:\"boolean_checkbox\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Single on/off checkbox\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"options_buttons\";r:1471;}s:14:\"#default_value\";s:16:\"boolean_checkbox\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"status\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Use field label: @display_label\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@display_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Yes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:6:\"status\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:20:\"status_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:6:\"status\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:7:\"created\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:18:\"datetime_timestamp\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1925;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1925;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:7:\"created\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1925;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1925;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:18:\"datetime_timestamp\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Datetime Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1925;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"attribute_color\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:29:\"entity_reference_autocomplete\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Color\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"7\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"attribute_color\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"attribute_color\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:8:{s:26:\"inline_entity_form_complex\";r:1459;s:25:\"inline_entity_form_simple\";r:1463;s:14:\"options_select\";r:1467;s:15:\"options_buttons\";r:1471;s:34:\"entity_reference_autocomplete_tags\";r:1475;s:29:\"entity_reference_autocomplete\";r:1479;s:22:\"commerce_entity_select\";r:1483;s:31:\"entity_browser_entity_reference\";r:1487;}s:14:\"#default_value\";s:14:\"options_select\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"attribute_color\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:14:\"attribute_size\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:29:\"entity_reference_autocomplete\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Size\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"6\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"attribute_size\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"attribute_size\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:8:{s:26:\"inline_entity_form_complex\";r:1459;s:25:\"inline_entity_form_simple\";r:1463;s:14:\"options_select\";r:1467;s:15:\"options_buttons\";r:1471;s:34:\"entity_reference_autocomplete_tags\";r:1475;s:29:\"entity_reference_autocomplete\";r:1479;s:22:\"commerce_entity_select\";r:1483;s:31:\"entity_browser_entity_reference\";r:1487;}s:14:\"#default_value\";s:14:\"options_select\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"attribute_size\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:17:\"field_description\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:13:\"text_textarea\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:11:\"Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"9\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:17:\"field_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:13:\"text_textarea\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Text area (multiple rows)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:13:\"text_textarea\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Number of rows: @rows\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@rows\";i:5;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:17:\"field_description\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:31:\"field_description_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:12:\"field_images\";a:9:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:11:\"image_image\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Images\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"4\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_images\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:11:\"image_image\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"entity_browser_file\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:19:\"entity_browser_file\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:64:\"Widget settings: <span class=\"plugin-name\">Entity browser</span>\";}s:8:\"settings\";a:9:{s:14:\"entity_browser\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:14:\"#default_value\";s:12:\"browse_files\";s:8:\"#options\";a:2:{s:12:\"browse_files\";s:17:\"Browser for files\";s:18:\"browse_files_modal\";s:25:\"Browser for files (modal)\";}}s:20:\"field_widget_display\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Entity display plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:14:\"#default_value\";N;s:8:\"#options\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Entity label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"thumbnail\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Image thumbnail\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"rendered_entity\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;O:64:\"Drupal\\entity_browser\\Plugin\\Field\\FieldWidget\\FileBrowserWidget\":9:{s:8:\"\0*\0items\";N;s:18:\"\0*\0fieldDefinition\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:47:\"commerce_product_variation.product.field_images\";s:13:\"\0*\0field_name\";s:12:\"field_images\";s:13:\"\0*\0field_type\";s:5:\"image\";s:14:\"\0*\0entity_type\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:8:\"\0*\0label\";s:6:\"Images\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:1;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:47:\"commerce_product_variation.product.field_images\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"7300e286-d57c-4fc2-9bb8-458dbc70ea43\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:53:\"field.storage.commerce_product_variation.field_images\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}}s:11:\"\0*\0settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:17:\"field_widget_edit\";b:1;s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:21:\"\0*\0thirdPartySettings\";a:0:{}s:24:\"\0*\0defaultSettingsMerged\";b:1;s:11:\"\0*\0pluginId\";s:19:\"entity_browser_file\";s:19:\"\0*\0pluginDefinition\";a:6:{s:11:\"field_types\";a:2:{i:0;s:4:\"file\";i:1;s:5:\"image\";}s:15:\"multiple_values\";b:1;s:2:\"id\";s:19:\"entity_browser_file\";s:5:\"label\";r:2475;s:8:\"provider\";s:14:\"entity_browser\";s:5:\"class\";s:64:\"Drupal\\entity_browser\\Plugin\\Field\\FieldWidget\\FileBrowserWidget\";}s:16:\"\0*\0configuration\";a:0:{}s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"displayRepository\";s:25:\"entity_display.repository\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:19:\"fieldDisplayManager\";s:50:\"plugin.manager.entity_browser.field_widget_display\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}i:1;s:18:\"updateSettingsAjax\";}s:7:\"wrapper\";s:56:\"field-field-images-display-settings-wrapper--kO8CTFFKSio\";}s:7:\"#access\";b:0;}s:17:\"field_widget_edit\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Display Edit button\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:14:\"#default_value\";b:1;s:7:\"#access\";b:0;}s:19:\"field_widget_remove\";a:3:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Display Remove button\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:14:\"#default_value\";b:1;}s:4:\"open\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"Show widget details as open by default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:110:\"If marked, the fieldset container that wraps the browser on the entity form will be loaded initially expanded.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:14:\"#default_value\";b:0;}s:14:\"selection_mode\";a:5:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Selection mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:139:\"Determines how selection in entity browser will be handled. Will selection be appended/prepended or it will be replaced in case of editing.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:3:{s:16:\"selection_append\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Append to selection\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"selection_prepend\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Prepend selection\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"selection_edit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Edit selection\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:16:\"selection_append\";}s:29:\"field_widget_display_settings\";a:6:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Entity display plugin configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#tree\";b:1;s:7:\"#prefix\";s:67:\"<div id=\"field-field-images-display-settings-wrapper--kO8CTFFKSio\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#access\";b:0;}s:9:\"view_mode\";a:5:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"File view mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:14:\"#default_value\";s:7:\"default\";s:8:\"#options\";a:1:{s:7:\"default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:7:\"#access\";b:0;}s:19:\"preview_image_style\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Preview image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:19:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:25:\"file_entity_browser_small\";s:35:\"File Entity Browser small thumbnail\";s:29:\"file_entity_browser_thumbnail\";s:29:\"File Entity Browser thumbnail\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:5:\"large\";s:16:\"Large (480×480)\";s:15:\"md_slider_thumb\";s:15:\"MD Slider Thumb\";s:6:\"medium\";s:17:\"Medium (220×220)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";s:12:\"slider_pager\";s:12:\"Slider Pager\";s:9:\"thumbnail\";s:20:\"Thumbnail (100×100)\";}s:14:\"#default_value\";s:9:\"thumbnail\";s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:109:\"The preview image will be shown while editing the content. Only relevant if using the default file view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:15;s:7:\"#access\";b:1;}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:35:\"field_images_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:35:\"field_images_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}}}s:15:\"field_old_price\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Old Price\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_old_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:22:\"commerce_price_default\";r:1742;}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:28:\"field_right_side_description\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:13:\"text_textarea\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:22:\"Right Side Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"10\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"field_right_side_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:13:\"text_textarea\";r:2327;}s:14:\"#default_value\";s:13:\"text_textarea\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Number of rows: @rows\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@rows\";i:5;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:28:\"field_right_side_description\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:42:\"field_right_side_description_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"field_sale_text\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Sale text\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_sale_text\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1596;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_sale_text\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_sale_text_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:23:\"field_short_description\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:110;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"string_textarea\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:17:\"Short Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"8\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";s:7:\"content\";s:6:\"hidden\";s:6:\"hidden\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:23:\"field_short_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"string_textarea\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Text area (multiple rows)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:15:\"string_textarea\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Number of rows: @rows\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@rows\";i:5;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:23:\"field_short_description\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:37:\"field_short_description_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:2:{i:0;s:12:\"::submitForm\";i:1;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:24:\"field_ui/drupal.field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_form_display_edit_form\";s:9:\"#build_id\";s:48:\"form-bpNd71gweH42D3XoY7NhMfthhe1D2-U00vJEC_QYV3I\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-bpNd71gweH42D3XoY7NhMfthhe1D2-U00vJEC_QYV3I\";s:3:\"#id\";s:48:\"form-bpNd71gweH42D3XoY7NhMfthhe1D2-U00vJEC_QYV3I\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-form-display-edit-form-form-token--_8b4bJLNwSI\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_form_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-form-display-edit-form--p9gqyLcPZ0I\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-form-display-edit-form--R_IjEgv-j7E\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_form_display_edit_form\";i:1;s:24:\"entity_form_display_form\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503028150),

('form','form-bSdeDI92HOBmYyUAOnLcbb5momGBm2umaXFcI14Edwg','a:29:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--F_gVpbSyXQo\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--F_gVpbSyXQo\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--F_gVpbSyXQo\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--F_gVpbSyXQo\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-bSdeDI92HOBmYyUAOnLcbb5momGBm2umaXFcI14Edwg\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-bSdeDI92HOBmYyUAOnLcbb5momGBm2umaXFcI14Edwg\";s:3:\"#id\";s:48:\"form-bSdeDI92HOBmYyUAOnLcbb5momGBm2umaXFcI14Edwg\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--XfLDncaEIQY\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--RPg2KfvIfPk\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1503450845),

('form','form-btuy-Za5Q436jQg1iQd4lrIrTYPczb-i9azZnRSyE6w','a:26:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:19:\"editor-image-dialog\";}s:20:\"data-drupal-selector\";s:19:\"editor-image-dialog\";}s:5:\"#tree\";b:1;s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:27:\"editor/drupal.editor.dialog\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#prefix\";s:35:\"<div id=\"editor-image-dialog-form\">\";s:7:\"#suffix\";s:6:\"</div>\";s:3:\"fid\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:12:\"managed_file\";s:16:\"#upload_location\";s:22:\"public://inline-images\";s:14:\"#default_value\";N;s:18:\"#upload_validators\";a:3:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"gif png jpg jpeg\";}s:18:\"file_validate_size\";a:1:{i:0;d:0;}s:30:\"file_validate_image_resolution\";a:1:{i:0;i:0;}}s:9:\"#required\";b:1;}s:10:\"attributes\";a:2:{s:3:\"src\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URL\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:0:\"\";s:10:\"#maxlength\";i:2048;s:9:\"#required\";b:0;s:7:\"#access\";b:0;}s:3:\"alt\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Alternative text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#placeholder\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Short description for the visually impaired\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:9:\"#required\";b:1;s:15:\"#required_error\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:181:\"Alternative text is required.<br />(Only in rare cases should this be left empty. To create empty alternative text, enter <code>\"\"</code> — two double quotes without any content).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:0:\"\";s:10:\"#maxlength\";i:2048;}}s:7:\"actions\";a:2:{s:5:\"#type\";s:7:\"actions\";s:10:\"save_modal\";a:4:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:12:\"::submitForm\";s:5:\"event\";s:5:\"click\";}}}s:8:\"#form_id\";s:19:\"editor_image_dialog\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:9:\"#build_id\";s:48:\"form-btuy-Za5Q436jQg1iQd4lrIrTYPczb-i9azZnRSyE6w\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-btuy-Za5Q436jQg1iQd4lrIrTYPczb-i9azZnRSyE6w\";s:3:\"#id\";s:48:\"form-btuy-Za5Q436jQg1iQd4lrIrTYPczb-i9azZnRSyE6w\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:48:\"edit-editor-image-dialog-form-token--sPu-lg5Ckys\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:19:\"editor_image_dialog\";s:3:\"#id\";s:37:\"edit-editor-image-dialog--bgn3M3L2NWY\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:32:\"editor-image-dialog--WdI3oapTdgQ\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:19:\"editor_image_dialog\";}s:12:\"#cache_token\";s:43:\"7zSG8KOvzIyajdU96VkCi7718ZFZxCBA8BEl5nvBqlw\";}',1497902640),

('form','form-BWJKRVAHDRWhBFLpy9MYBf9fTjBIS5bhyab0N-C2xH4','a:26:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:19:\"editor-image-dialog\";}s:20:\"data-drupal-selector\";s:19:\"editor-image-dialog\";}s:5:\"#tree\";b:1;s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:27:\"editor/drupal.editor.dialog\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#prefix\";s:35:\"<div id=\"editor-image-dialog-form\">\";s:7:\"#suffix\";s:6:\"</div>\";s:3:\"fid\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:12:\"managed_file\";s:16:\"#upload_location\";s:22:\"public://inline-images\";s:14:\"#default_value\";N;s:18:\"#upload_validators\";a:3:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"gif png jpg jpeg\";}s:18:\"file_validate_size\";a:1:{i:0;d:0;}s:30:\"file_validate_image_resolution\";a:1:{i:0;i:0;}}s:9:\"#required\";b:1;}s:10:\"attributes\";a:2:{s:3:\"src\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URL\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:80:\"http://local.rhythm.nikadevs.com/sites/rhythm.nikadevs.com/files/user-avatar.png\";s:10:\"#maxlength\";i:2048;s:9:\"#required\";b:0;s:7:\"#access\";b:0;}s:3:\"alt\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Alternative text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#placeholder\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Short description for the visually impaired\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:9:\"#required\";b:1;s:15:\"#required_error\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:181:\"Alternative text is required.<br />(Only in rare cases should this be left empty. To create empty alternative text, enter <code>\"\"</code> — two double quotes without any content).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:2:\"\"\"\";s:10:\"#maxlength\";i:2048;}}s:7:\"actions\";a:2:{s:5:\"#type\";s:7:\"actions\";s:10:\"save_modal\";a:4:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:12:\"::submitForm\";s:5:\"event\";s:5:\"click\";}}}s:8:\"#form_id\";s:19:\"editor_image_dialog\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:9:\"#build_id\";s:48:\"form-BWJKRVAHDRWhBFLpy9MYBf9fTjBIS5bhyab0N-C2xH4\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-BWJKRVAHDRWhBFLpy9MYBf9fTjBIS5bhyab0N-C2xH4\";s:3:\"#id\";s:48:\"form-BWJKRVAHDRWhBFLpy9MYBf9fTjBIS5bhyab0N-C2xH4\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:48:\"edit-editor-image-dialog-form-token--9tOR7ILujh8\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:19:\"editor_image_dialog\";s:3:\"#id\";s:37:\"edit-editor-image-dialog--kXgxwMKtiwU\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:32:\"editor-image-dialog--5JvNGK3wGA4\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:19:\"editor_image_dialog\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503590935),

('form','form-dPdWs1unF1y_VjBy2601jUcz19CSso1bOjhJbyBsxPU','a:30:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:55:\"commerce-order-item-add-to-cart-form-commerce-product-4\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:55:\"commerce-order-item-add-to-cart-form-commerce-product-4\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"total_price\";b:1;s:11:\"adjustments\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--OeZ-DyXtpLI\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--OeZ-DyXtpLI\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--OeZ-DyXtpLI\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--OeZ-DyXtpLI\";}}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:6:\"footer\";a:4:{s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:99;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:26:\"entity-content-form-footer\";}}s:9:\"#optional\";b:1;}s:7:\"actions\";a:2:{s:6:\"submit\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"button--add-to-cart\";}}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";s:9:\"#build_id\";s:48:\"form-dPdWs1unF1y_VjBy2601jUcz19CSso1bOjhJbyBsxPU\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:6:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-dPdWs1unF1y_VjBy2601jUcz19CSso1bOjhJbyBsxPU\";s:3:\"#id\";s:48:\"form-dPdWs1unF1y_VjBy2601jUcz19CSso1bOjhJbyBsxPU\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}s:11:\"#attributes\";a:1:{s:12:\"autocomplete\";s:3:\"off\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";s:3:\"#id\";s:73:\"edit-commerce-order-item-add-to-cart-form-commerce-product-4--GzFBa68kddc\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:68:\"commerce-order-item-add-to-cart-form-commerce-product-4--VMqBNLAp4o0\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1558276360),

('form','form-e2GY-ffS8gDtYs4VyOrru1X_X46g8RYbKrYnUxyL0Lg','a:25:{s:11:\"#attributes\";a:3:{s:5:\"class\";a:4:{i:0;s:32:\"entity-browser-browse-files-form\";i:1;s:19:\"entity-browser-form\";i:2;s:25:\"dropzonejs-disable-submit\";i:3;s:17:\"file-browser-form\";}s:24:\"data-entity-browser-uuid\";s:40:\"a7a0a9551149bb9bf37b838e044921db392dc4a2\";s:20:\"data-drupal-selector\";s:32:\"entity-browser-browse-files-form\";}s:14:\"#browser_parts\";a:3:{s:15:\"widget_selector\";s:15:\"widget_selector\";s:6:\"widget\";s:6:\"widget\";s:17:\"selection_display\";s:17:\"selection_display\";}s:15:\"widget_selector\";a:3:{s:49:\"tab_selector_735d146c-a4b2-4327-a057-d109e0905e05\";a:9:{s:5:\"#type\";s:6:\"button\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:3:\"tab\";}}s:6:\"#value\";s:12:\"Upload files\";s:9:\"#disabled\";b:1;s:25:\"#executes_submit_callback\";b:1;s:24:\"#limit_validation_errors\";a:1:{i:0;a:1:{i:0;s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";}}s:7:\"#submit\";a:0:{}s:5:\"#name\";s:49:\"tab_selector_735d146c-a4b2-4327-a057-d109e0905e05\";s:10:\"#widget_id\";s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";}s:49:\"tab_selector_a4ad947c-9669-497c-9988-24351955a02f\";a:9:{s:5:\"#type\";s:6:\"button\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:3:\"tab\";}}s:6:\"#value\";s:13:\"Files listing\";s:9:\"#disabled\";b:0;s:25:\"#executes_submit_callback\";b:1;s:24:\"#limit_validation_errors\";a:1:{i:0;a:1:{i:0;s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";}}s:7:\"#submit\";a:0:{}s:5:\"#name\";s:49:\"tab_selector_a4ad947c-9669-497c-9988-24351955a02f\";s:10:\"#widget_id\";s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:19:\"entity_browser/tabs\";}}}s:6:\"widget\";a:3:{s:9:\"#attached\";a:2:{s:14:\"drupalSettings\";a:1:{s:21:\"entity_browser_widget\";a:1:{s:11:\"auto_select\";b:0;}}s:7:\"library\";a:2:{i:0;s:17:\"dropzonejs/widget\";i:1;s:27:\"dropzonejs_eb_widget/common\";}}s:7:\"actions\";a:2:{s:5:\"#type\";s:7:\"actions\";s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";s:15:\"Select entities\";s:22:\"#eb_widget_main_submit\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:24:\"is-entity-browser-submit\";}}s:12:\"#button_type\";s:7:\"primary\";}}s:6:\"upload\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"File upload\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:10:\"dropzonejs\";s:9:\"#required\";b:1;s:21:\"#dropzone_description\";s:39:\"Click or drop files here to upload them\";s:13:\"#max_filesize\";s:4:\"100M\";s:11:\"#extensions\";s:52:\"jpg jpeg gif png txt doc xls pdf ppt pps odt ods odp\";s:10:\"#max_files\";i:0;}}s:17:\"selection_display\";a:7:{s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:33:\"entity_browser/multi_step_display\";}}s:8:\"selected\";a:4:{s:15:\"#theme_wrappers\";a:1:{i:0;s:9:\"container\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:13:\"entities-list\";}}s:5:\"#tree\";b:1;s:10:\"items_67_0\";a:5:{s:15:\"#theme_wrappers\";a:1:{i:0;s:9:\"container\";}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:14:\"item-container\";}s:14:\"data-entity-id\";s:2:\"67\";}s:7:\"display\";a:5:{s:6:\"#theme\";s:11:\"image_style\";s:11:\"#style_name\";s:25:\"file_entity_browser_small\";s:6:\"#title\";s:13:\"dance_now.jpg\";s:4:\"#alt\";s:13:\"dance_now.jpg\";s:4:\"#uri\";s:30:\"public://2017-08/dance_now.jpg\";}s:13:\"remove_button\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Remove\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\entity_browser\\Plugin\\EntityBrowser\\SelectionDisplay\\MultiStepDisplay\";i:1;s:16:\"removeItemSubmit\";}}s:5:\"#name\";s:11:\"remove_67_0\";s:11:\"#attributes\";a:3:{s:5:\"class\";a:1:{i:0;s:37:\"entity-browser-remove-selected-entity\";}s:11:\"data-row-id\";i:0;s:18:\"data-remove-entity\";s:8:\"items_67\";}}s:6:\"weight\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";i:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:6:\"weight\";}}}}}s:21:\"ajax_commands_handler\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:5:\"#name\";s:21:\"ajax_commands_handler\";s:3:\"#id\";s:21:\"ajax_commands_handler\";s:11:\"#attributes\";a:1:{s:2:\"id\";s:21:\"ajax_commands_handler\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";a:2:{i:0;s:76:\"Drupal\\entity_browser\\Plugin\\EntityBrowser\\SelectionDisplay\\MultiStepDisplay\";i:1;s:17:\"handleAjaxCommand\";}s:7:\"wrapper\";s:13:\"edit-selected\";s:5:\"event\";s:19:\"execute_js_commands\";s:8:\"progress\";a:1:{s:4:\"type\";s:10:\"fullscreen\";}}}s:12:\"use_selected\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Use selected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:12:\"use_selected\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"entity-browser-use-selected\";}}s:7:\"#access\";b:1;}s:14:\"show_selection\";a:4:{s:5:\"#type\";s:6:\"button\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Show selected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:29:\"entity-browser-show-selection\";}}s:7:\"#access\";b:1;}s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";s:20:\"file-browser-actions\";}}s:9:\"#attached\";a:2:{s:7:\"library\";a:3:{i:0;s:29:\"entity_browser/entity_browser\";i:1;s:17:\"file_browser/view\";i:2;s:25:\"file_browser/dropzone_css\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:32:\"entity_browser_browse_files_form\";s:9:\"#build_id\";s:48:\"form-e2GY-ffS8gDtYs4VyOrru1X_X46g8RYbKrYnUxyL0Lg\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-e2GY-ffS8gDtYs4VyOrru1X_X46g8RYbKrYnUxyL0Lg\";s:3:\"#id\";s:48:\"form-e2GY-ffS8gDtYs4VyOrru1X_X46g8RYbKrYnUxyL0Lg\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_tMllwp5XOMcQ4wSKh7GXaefQU_WvVdmYdmBJR9Y5u_U\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:48:\"edit-entity-browser-browse-files-form-form-token\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_tMllwp5XOMcQ4wSKh7GXaefQU_WvVdmYdmBJR9Y5u_U\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_tMllwp5XOMcQ4wSKh7GXaefQU_WvVdmYdmBJR9Y5u_U\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_tMllwp5XOMcQ4wSKh7GXaefQU_WvVdmYdmBJR9Y5u_U\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:32:\"entity_browser_browse_files_form\";s:3:\"#id\";s:37:\"edit-entity-browser-browse-files-form\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:32:\"entity-browser-browse-files-form\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:32:\"entity_browser_browse_files_form\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503332162),

('form','form-EpkW2ahlTnShMJzMfghuIyhM7xK5VOY3vhLwN3k4p6M','a:35:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:74:\"config:core.entity_view_display.commerce_product_variation.product.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:7:\"#fields\";a:15:{i:0;s:8:\"langcode\";i:1;s:10:\"product_id\";i:2;s:3:\"sku\";i:3;s:5:\"title\";i:4;s:5:\"price\";i:5;s:11:\"field_color\";i:6;s:17:\"field_description\";i:7;s:12:\"field_images\";i:8;s:12:\"field_length\";i:9;s:15:\"field_old_price\";i:10;s:28:\"field_right_side_description\";i:11;s:15:\"field_sale_text\";i:12;s:23:\"field_short_description\";i:13;s:10:\"field_size\";i:14;s:11:\"field_waist\";}s:6:\"#extra\";a:1:{i:0;s:28:\"commerce_variation_cart_form\";}s:6:\"fields\";a:22:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:225;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:225;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:225;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"bc5d6188-cefe-4350-a39e-4005f7f36258\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:11:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:58:\"field.field.commerce_product_variation.product.field_color\";i:2;s:64:\"field.field.commerce_product_variation.product.field_description\";i:3;s:59:\"field.field.commerce_product_variation.product.field_images\";i:4;s:59:\"field.field.commerce_product_variation.product.field_length\";i:5;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:6;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:7;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:8;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:9;s:57:\"field.field.commerce_product_variation.product.field_size\";i:10;s:58:\"field.field.commerce_product_variation.product.field_waist\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:5:\"image\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:14:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:2:\"13\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:11:\"field_color\";a:6:{s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";s:1:\"2\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:4:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";s:17:\"image_style_small\";s:0:\"\";s:3:\"col\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";s:1:\"7\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";s:1:\"5\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";s:1:\"6\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";s:1:\"8\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:6:{s:6:\"weight\";s:1:\"9\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:2:{s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1311;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1311;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1311;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1311;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1311;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1311;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"product_id\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"product_id\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"sku\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1579;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"3\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1579;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"sku\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1579;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1579;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1579;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1579;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:3:\"sku\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:17:\"sku_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"title\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1732;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1732;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"title\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1732;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1732;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1732;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1674;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1732;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"title\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"title_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1882;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1882;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1882;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1882;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1882;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:20:\"commerce_price_plain\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Plain\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_price_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:25:\"commerce_price_calculated\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Calculated price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1882;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:11:\"field_color\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Color\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"10\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_color\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1674;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_color\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_color_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:17:\"field_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:11:\"Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"4\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:17:\"field_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"text_trimmed\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Trimmed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"text_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:12:\"field_images\";a:10:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:5:\"image\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Images\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_images\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:24:\"rhythm_cms_images_slider\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rhythm CMS: Image Slider\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"rhythm_cms_images_one_main\";r:1534;s:9:\"image_url\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"URL to image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"image\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:26:\"rhythm_cms_images_one_main\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:77:\"Format settings: <span class=\"plugin-name\">Rhythm CMS: Images One Main</span>\";}s:8:\"settings\";a:3:{s:11:\"image_style\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Image Style for Main Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:14:\"#default_value\";s:0:\"\";s:13:\"#empty_option\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"None (original image)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:19:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:25:\"file_entity_browser_small\";s:35:\"File Entity Browser small thumbnail\";s:29:\"file_entity_browser_thumbnail\";s:29:\"File Entity Browser thumbnail\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:5:\"large\";s:16:\"Large (480×480)\";s:15:\"md_slider_thumb\";s:15:\"MD Slider Thumb\";s:6:\"medium\";s:17:\"Medium (220×220)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";s:12:\"slider_pager\";s:12:\"Slider Pager\";s:9:\"thumbnail\";s:20:\"Thumbnail (100×100)\";}s:12:\"#description\";a:4:{s:5:\"#type\";s:4:\"link\";s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:29:\"entity.image_style.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Configure Image Styles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;}}s:17:\"image_style_small\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Image Style for Small Images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:14:\"#default_value\";s:0:\"\";s:13:\"#empty_option\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"None (original image)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:19:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:25:\"file_entity_browser_small\";s:35:\"File Entity Browser small thumbnail\";s:29:\"file_entity_browser_thumbnail\";s:29:\"File Entity Browser thumbnail\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:5:\"large\";s:16:\"Large (480×480)\";s:15:\"md_slider_thumb\";s:15:\"MD Slider Thumb\";s:6:\"medium\";s:17:\"Medium (220×220)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";s:12:\"slider_pager\";s:12:\"Slider Pager\";s:9:\"thumbnail\";s:20:\"Thumbnail (100×100)\";}s:12:\"#description\";a:4:{s:5:\"#type\";s:4:\"link\";s:4:\"#url\";r:2493;s:6:\"#title\";r:2505;s:7:\"#access\";b:1;}}s:3:\"col\";a:4:{s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:4:{i:2;i:2;i:3;i:3;i:4;i:4;i:6;i:6;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Columns Count for Small Images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:3;}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:35:\"field_images_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:35:\"field_images_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}}}s:12:\"field_length\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Length\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"12\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_length\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1674;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_length\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_length_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"field_old_price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Old Price\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"7\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_old_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:20:\"commerce_price_plain\";r:1977;s:22:\"commerce_price_default\";r:1981;s:25:\"commerce_price_calculated\";r:1985;}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_old_price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_old_price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:28:\"field_right_side_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:22:\"Right Side Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"field_right_side_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";r:2297;s:12:\"text_trimmed\";r:2301;}s:14:\"#default_value\";s:12:\"text_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"field_sale_text\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Sale text\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"6\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_sale_text\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1674;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_sale_text\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_sale_text_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:23:\"field_short_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"basic_string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:17:\"Short Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"8\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:23:\"field_short_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:12:\"basic_string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"basic_string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"field_size\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Size\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"9\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_size\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1674;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"field_size\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"field_size_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:11:\"field_waist\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Waist\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"11\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_waist\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1674;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_waist\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_waist_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:28:\"commerce_variation_cart_form\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:11:\"extra_field\";s:16:\"#region_callback\";a:2:{i:0;r:115;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:1:{s:10:\"rowHandler\";s:5:\"field\";}s:10:\"human_name\";a:1:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"13\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Parents for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"commerce_variation_cart_form\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3616;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:10:\"empty_cell\";a:1:{s:7:\"#markup\";s:6:\"&nbsp;\";}s:6:\"plugin\";a:1:{s:4:\"type\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:7:\"visible\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}}s:16:\"settings_summary\";a:1:{s:7:\"combine\";a:3:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Combine order items containing the same product variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:1:\"1\";}}s:13:\"settings_edit\";a:0:{}}s:15:\"#parent_options\";a:0:{}}s:5:\"modes\";a:4:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Custom display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"display_modes_custom\";a:4:{s:5:\"#type\";s:10:\"checkboxes\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"Use custom display settings for the following @display_context modes\";s:12:\"\0*\0arguments\";a:1:{s:16:\"@display_context\";s:4:\"view\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:4:{s:4:\"cart\";s:4:\"Cart\";s:7:\"product\";s:7:\"Product\";s:7:\"summary\";s:7:\"Summary\";s:5:\"token\";s:5:\"Token\";}s:14:\"#default_value\";a:2:{i:0;s:4:\"cart\";i:1;s:7:\"product\";}}s:18:\"display_modes_link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Manage view modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:34:\"entity.entity_view_mode.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-EpkW2ahlTnShMJzMfghuIyhM7xK5VOY3vhLwN3k4p6M\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-EpkW2ahlTnShMJzMfghuIyhM7xK5VOY3vhLwN3k4p6M\";s:3:\"#id\";s:48:\"form-EpkW2ahlTnShMJzMfghuIyhM7xK5VOY3vhLwN3k4p6M\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--GnDUr8Y_Q4s\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--W2l5pVO7ABI\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--PvQ586oeSIk\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:16:\"#entity_builders\";a:1:{i:0;s:71:\"commerce_variation_cart_form_form_entity_view_display_edit_form_builder\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1131;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503327846),

('form','form-eske2IICmrHl_8wXanE9JeiwBlroV1qgRDGGiFwHek4','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--rZfCu3at0oc\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--rZfCu3at0oc\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--rZfCu3at0oc\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--rZfCu3at0oc\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-eske2IICmrHl_8wXanE9JeiwBlroV1qgRDGGiFwHek4\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-eske2IICmrHl_8wXanE9JeiwBlroV1qgRDGGiFwHek4\";s:3:\"#id\";s:48:\"form-eske2IICmrHl_8wXanE9JeiwBlroV1qgRDGGiFwHek4\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--ldVBfahsRXk\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--H_MNejUXGLI\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--L-2URIFEpbU\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503435764),

('form','form-fCCC_P0aKC1g5q_lO2adxGu6n978KhRHDbEEQr9UnPU','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:515;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:515;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:569;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:569;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:701;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:701;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503323088\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:763;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:970;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:4:{s:5:\"#type\";s:6:\"weight\";s:6:\"#delta\";i:50;s:14:\"#default_value\";s:1:\"1\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"ief-entity-delta\";}}}s:7:\"actions\";a:4:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:21:\"ief-entity-operations\";}}s:15:\"ief_entity_edit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:58:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-edit-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:4:\"edit\";}s:17:\"ief_entity_remove\";a:9:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Remove\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:60:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-remove-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:6:\"remove\";s:7:\"#access\";b:1;}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302248\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 10:57\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-fCCC_P0aKC1g5q_lO2adxGu6n978KhRHDbEEQr9UnPU\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-fCCC_P0aKC1g5q_lO2adxGu6n978KhRHDbEEQr9UnPU\";s:3:\"#id\";s:48:\"form-fCCC_P0aKC1g5q_lO2adxGu6n978KhRHDbEEQr9UnPU\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--RkqsbO9bbx0\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--LprbjXCdQPk\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--Em1-Wjec0oY\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503344797),

('form','form-fFKtcGOW4LQOyxuZK54ShiFUlTb5Jk22ZkBCBaCICxU','a:35:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:74:\"config:core.entity_view_display.commerce_product_variation.product.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:7:\"#fields\";a:16:{i:0;s:8:\"langcode\";i:1;s:10:\"product_id\";i:2;s:3:\"sku\";i:3;s:5:\"title\";i:4;s:5:\"price\";i:5;s:14:\"qty_increments\";i:6;s:15:\"attribute_color\";i:7;s:14:\"attribute_size\";i:8;s:17:\"field_description\";i:9;s:12:\"field_images\";i:10;s:12:\"field_length\";i:11;s:15:\"field_old_price\";i:12;s:28:\"field_right_side_description\";i:13;s:15:\"field_sale_text\";i:14;s:23:\"field_short_description\";i:15;s:11:\"field_waist\";}s:6:\"#extra\";a:1:{i:0;s:28:\"commerce_variation_cart_form\";}s:6:\"fields\";a:23:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:227;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:227;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:227;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"bc5d6188-cefe-4350-a39e-4005f7f36258\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:12:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:2;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:3;s:64:\"field.field.commerce_product_variation.product.field_description\";i:4;s:59:\"field.field.commerce_product_variation.product.field_images\";i:5;s:59:\"field.field.commerce_product_variation.product.field_length\";i:6;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:7;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:8;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:9;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:10;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:11;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:10:\"rhythm_cms\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:15:{s:15:\"attribute_color\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";s:1:\"2\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:14:\"attribute_size\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:2:\"13\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:17:\"field_description\";a:6:{s:6:\"weight\";s:1:\"6\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:5:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:17:\"image_style_small\";s:19:\"product_small_68x86\";s:3:\"col\";s:1:\"3\";s:4:\"zoom\";s:1:\"1\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";s:1:\"9\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";s:1:\"7\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";s:1:\"8\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"5\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:10:\"product_id\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";s:2:\"14\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:2:{s:8:\"langcode\";b:1;s:14:\"qty_increments\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1323;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1323;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1323;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1323;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1323;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1323;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"product_id\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1451;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"14\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1451;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"product_id\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1451;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1451;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1451;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"entity_reference_label\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1451;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Link to the referenced entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"product_id\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"product_id_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:3:\"sku\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1627;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1627;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"sku\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1627;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1627;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1627;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1627;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:3:\"sku\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:17:\"sku_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"title\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1780;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1780;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"title\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1780;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1780;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1780;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1722;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1780;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"title\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"title_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1930;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"3\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1930;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1930;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1930;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1930;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:20:\"commerce_price_plain\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Plain\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_price_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:25:\"commerce_price_calculated\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Calculated price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1930;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:14:\"qty_increments\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:14:\"number_decimal\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Quantity increments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:2106;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:2106;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"qty_increments\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"qty_increments\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:2106;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:2106;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:2106;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:18:\"number_unformatted\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Unformatted\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"number_decimal\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"qty_increments\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:2106;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"attribute_color\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Color\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"attribute_color\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"attribute_color\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1546;s:28:\"entity_reference_entity_view\";r:1550;s:22:\"entity_reference_label\";r:1554;s:26:\"entity_reference_entity_id\";r:1558;}s:14:\"#default_value\";s:22:\"entity_reference_label\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"attribute_color\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Link to the referenced entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"attribute_color\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"attribute_color_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"attribute_color\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:14:\"attribute_size\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Size\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"attribute_size\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"attribute_size\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1546;s:28:\"entity_reference_entity_view\";r:1550;s:22:\"entity_reference_label\";r:1554;s:26:\"entity_reference_entity_id\";r:1558;}s:14:\"#default_value\";s:22:\"entity_reference_label\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"attribute_size\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Link to the referenced entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:14:\"attribute_size\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:28:\"attribute_size_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:14:\"attribute_size\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:17:\"field_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:11:\"Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"6\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:17:\"field_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"text_trimmed\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Trimmed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"text_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:12:\"field_images\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:5:\"image\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Images\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"4\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_images\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:24:\"rhythm_cms_images_slider\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rhythm CMS: Image Slider\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"rhythm_cms_images_one_main\";r:1546;s:9:\"image_url\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"URL to image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"image\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:26:\"rhythm_cms_images_one_main\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:4:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Image style: @style\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@style\";s:22:\"Product Main (360x459)\";}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Image small style: @style\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@style\";s:21:\"Product Small (68x86)\";}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Columns count for small image: @cols\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@cols\";s:1:\"3\";}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Zoom enabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_images_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:12:\"field_length\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Length\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"12\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_length\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1722;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_length\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_length_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"field_old_price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Old Price\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"9\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_old_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:20:\"commerce_price_plain\";r:2025;s:22:\"commerce_price_default\";r:2029;s:25:\"commerce_price_calculated\";r:2033;}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_old_price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_old_price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:28:\"field_right_side_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:22:\"Right Side Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"7\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"field_right_side_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";r:2652;s:12:\"text_trimmed\";r:2656;}s:14:\"#default_value\";s:12:\"text_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"field_sale_text\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Sale text\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"8\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_sale_text\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1722;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_sale_text\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_sale_text_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:23:\"field_short_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"basic_string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:17:\"Short Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"10\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:23:\"field_short_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:12:\"basic_string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"basic_string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:11:\"field_waist\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Waist\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"11\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_waist\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1722;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_waist\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_waist_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:28:\"commerce_variation_cart_form\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:11:\"extra_field\";s:16:\"#region_callback\";a:2:{i:0;r:117;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:1:{s:10:\"rowHandler\";s:5:\"field\";}s:10:\"human_name\";a:1:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3726;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"13\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Parents for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3726;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"commerce_variation_cart_form\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3726;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:10:\"empty_cell\";a:1:{s:7:\"#markup\";s:6:\"&nbsp;\";}s:6:\"plugin\";a:1:{s:4:\"type\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:7:\"visible\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}}s:16:\"settings_summary\";a:1:{s:7:\"combine\";a:3:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Combine order items containing the same product variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:1:\"1\";}}s:13:\"settings_edit\";a:0:{}}s:15:\"#parent_options\";a:0:{}}s:5:\"modes\";a:4:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Custom display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"display_modes_custom\";a:4:{s:5:\"#type\";s:10:\"checkboxes\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"Use custom display settings for the following @display_context modes\";s:12:\"\0*\0arguments\";a:1:{s:16:\"@display_context\";s:4:\"view\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:4:{s:4:\"cart\";s:4:\"Cart\";s:7:\"product\";s:7:\"Product\";s:7:\"summary\";s:7:\"Summary\";s:5:\"token\";s:5:\"Token\";}s:14:\"#default_value\";a:2:{i:0;s:4:\"cart\";i:1;s:7:\"product\";}}s:18:\"display_modes_link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Manage view modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:34:\"entity.entity_view_mode.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-fFKtcGOW4LQOyxuZK54ShiFUlTb5Jk22ZkBCBaCICxU\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-fFKtcGOW4LQOyxuZK54ShiFUlTb5Jk22ZkBCBaCICxU\";s:3:\"#id\";s:48:\"form-fFKtcGOW4LQOyxuZK54ShiFUlTb5Jk22ZkBCBaCICxU\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--ADvKChvkwlk\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--yEfW2IqMImE\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--o6plIDa2bB8\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:16:\"#entity_builders\";a:1:{i:0;s:71:\"commerce_variation_cart_form_form_entity_view_display_edit_form_builder\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1133;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503431006),

('form','form-fGvrCSOQ5VdI1jetEinXKtWAacO7NCoxBItNv34xsjg','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--h1QdZN7rqdU\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--h1QdZN7rqdU\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--h1QdZN7rqdU\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--h1QdZN7rqdU\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-fGvrCSOQ5VdI1jetEinXKtWAacO7NCoxBItNv34xsjg\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-fGvrCSOQ5VdI1jetEinXKtWAacO7NCoxBItNv34xsjg\";s:3:\"#id\";s:48:\"form-fGvrCSOQ5VdI1jetEinXKtWAacO7NCoxBItNv34xsjg\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--rSVJIQm4HMc\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--8G5GsNWn8rw\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--y9E7th_gW6c\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503436196),

('form','form-GebYDNe78c6Wh6VqZt4sDXnLEbrsZQAxmjAseUbFg9E','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--8tbuNlnD920\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--8tbuNlnD920\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--8tbuNlnD920\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--8tbuNlnD920\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-GebYDNe78c6Wh6VqZt4sDXnLEbrsZQAxmjAseUbFg9E\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-GebYDNe78c6Wh6VqZt4sDXnLEbrsZQAxmjAseUbFg9E\";s:3:\"#id\";s:48:\"form-GebYDNe78c6Wh6VqZt4sDXnLEbrsZQAxmjAseUbFg9E\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--MAtejstURB4\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--jyqnIqPT8cQ\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--06941l4EoXE\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503438124),

('form','form-glV3Y6G1gtVzNkPgTQJNllYPujZXqGie-gVpXCVkDmo','a:24:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:25:\"config-single-export-form\";}s:20:\"data-drupal-selector\";s:25:\"config-single-export-form\";}s:11:\"config_type\";a:5:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Configuration type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:46:{s:13:\"system.simple\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Simple configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"action\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"base_field_override\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Base field override\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"block\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_checkout_flow\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Checkout flow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"comment_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"contact_form\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:25:\"language_content_settings\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Content Language Settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"node_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"commerce_currency\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Currency\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:18:\"block_content_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"date_format\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Date format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"embed_button\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Embed button\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"entity_browser\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"entity_form_display\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"entity_view_display\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity view display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"features_bundle\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Features bundle\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"field_config\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"field_storage_config\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Field storage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"entity_form_mode\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"image_style\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:21:\"configurable_language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"menu\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:24:\"commerce_order_item_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Order item type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"commerce_order_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Order type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"pathauto_pattern\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Pathauto pattern\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:24:\"commerce_payment_gateway\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment gateway\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"commerce_product_attribute\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Product attribute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:21:\"commerce_product_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Product type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:31:\"commerce_product_variation_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Product variation type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"profile_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Profile type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"rest_resource_config\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"REST resource configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"user_role\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"search_page\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Search page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"shortcut_set\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"commerce_store_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Store type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"taxonomy_vocabulary\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Taxonomy vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"tb_megamenu\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"TB Mega Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"editor\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"filter_format\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"tour\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"View\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:16:\"entity_view_mode\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"vote_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Vote Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"webform\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"webform_options\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Webform options\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";N;s:5:\"#ajax\";a:2:{s:8:\"callback\";s:25:\"::updateConfigurationType\";s:7:\"wrapper\";s:24:\"edit-config-type-wrapper\";}}s:11:\"config_name\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Configuration name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:44:{s:0:\"\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"- Select -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"archive\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Archive\";s:3:\"@id\";s:7:\"archive\";}s:10:\"\0*\0options\";a:0:{}}s:13:\"block_content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:20:\"Custom block library\";s:3:\"@id\";s:13:\"block_content\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"blog_fullwidth\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:14:\"Blog Fullwidth\";s:3:\"@id\";s:14:\"blog_fullwidth\";}s:10:\"\0*\0options\";a:0:{}}s:9:\"blog_grid\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:9:\"Blog Grid\";s:3:\"@id\";s:9:\"blog_grid\";}s:10:\"\0*\0options\";a:0:{}}s:12:\"blog_masonry\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:12:\"Blog Masonry\";s:3:\"@id\";s:12:\"blog_masonry\";}s:10:\"\0*\0options\";a:0:{}}s:13:\"blog_timeline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:13:\"Blog TimeLine\";s:3:\"@id\";s:13:\"blog_timeline\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"comment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:8:\"Comments\";s:3:\"@id\";s:7:\"comment\";}s:10:\"\0*\0options\";a:0:{}}s:15:\"comments_recent\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:15:\"Recent comments\";s:3:\"@id\";s:15:\"comments_recent\";}s:10:\"\0*\0options\";a:0:{}}s:17:\"commerce_activity\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:8:\"Activity\";s:3:\"@id\";s:17:\"commerce_activity\";}s:10:\"\0*\0options\";a:0:{}}s:19:\"commerce_cart_block\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:10:\"Cart block\";s:3:\"@id\";s:19:\"commerce_cart_block\";}s:10:\"\0*\0options\";a:0:{}}s:18:\"commerce_cart_form\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:9:\"Cart form\";s:3:\"@id\";s:18:\"commerce_cart_form\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"commerce_carts\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Carts\";s:3:\"@id\";s:14:\"commerce_carts\";}s:10:\"\0*\0options\";a:0:{}}s:31:\"commerce_checkout_order_summary\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:22:\"Checkout Order Summary\";s:3:\"@id\";s:31:\"commerce_checkout_order_summary\";}s:10:\"\0*\0options\";a:0:{}}s:25:\"commerce_order_item_table\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:11:\"Order items\";s:3:\"@id\";s:25:\"commerce_order_item_table\";}s:10:\"\0*\0options\";a:0:{}}s:15:\"commerce_orders\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:6:\"Orders\";s:3:\"@id\";s:15:\"commerce_orders\";}s:10:\"\0*\0options\";a:0:{}}s:17:\"commerce_products\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:8:\"Products\";s:3:\"@id\";s:17:\"commerce_products\";}s:10:\"\0*\0options\";a:0:{}}s:15:\"commerce_stores\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:6:\"Stores\";s:3:\"@id\";s:15:\"commerce_stores\";}s:10:\"\0*\0options\";a:0:{}}s:20:\"commerce_user_orders\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:11:\"User orders\";s:3:\"@id\";s:20:\"commerce_user_orders\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Content\";s:3:\"@id\";s:7:\"content\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"content_recent\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:14:\"Recent content\";s:3:\"@id\";s:14:\"content_recent\";}s:10:\"\0*\0options\";a:0:{}}s:19:\"file_entity_browser\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:19:\"File Entity Browser\";s:3:\"@id\";s:19:\"file_entity_browser\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"files\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Files\";s:3:\"@id\";s:5:\"files\";}s:10:\"\0*\0options\";a:0:{}}s:9:\"frontpage\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:9:\"Frontpage\";s:3:\"@id\";s:9:\"frontpage\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"gallery\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Gallery\";s:3:\"@id\";s:7:\"gallery\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"glossary\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:8:\"Glossary\";s:3:\"@id\";s:8:\"glossary\";}s:10:\"\0*\0options\";a:0:{}}s:15:\"portfolio_boxed\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:9:\"Portfolio\";s:3:\"@id\";s:15:\"portfolio_boxed\";}s:10:\"\0*\0options\";a:0:{}}s:18:\"portfolio_parallax\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:18:\"Portfolio Parallax\";s:3:\"@id\";s:18:\"portfolio_parallax\";}s:10:\"\0*\0options\";a:0:{}}s:15:\"portfolio_promo\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:15:\"Portfolio Promo\";s:3:\"@id\";s:15:\"portfolio_promo\";}s:10:\"\0*\0options\";a:0:{}}s:16:\"products_archive\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:16:\"Products archive\";s:3:\"@id\";s:16:\"products_archive\";}s:10:\"\0*\0options\";a:0:{}}s:21:\"products_best_sellers\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:21:\"Products best sellers\";s:3:\"@id\";s:21:\"products_best_sellers\";}s:10:\"\0*\0options\";a:0:{}}s:17:\"products_comments\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:17:\"Products comments\";s:3:\"@id\";s:17:\"products_comments\";}s:10:\"\0*\0options\";a:0:{}}s:13:\"products_tags\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:13:\"Products Tags\";s:3:\"@id\";s:13:\"products_tags\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"profiles\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:8:\"Profiles\";s:3:\"@id\";s:8:\"profiles\";}s:10:\"\0*\0options\";a:0:{}}s:16:\"related_products\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:16:\"Related Products\";s:3:\"@id\";s:16:\"related_products\";}s:10:\"\0*\0options\";a:0:{}}s:16:\"related_projects\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:16:\"Related Projects\";s:3:\"@id\";s:16:\"related_projects\";}s:10:\"\0*\0options\";a:0:{}}s:15:\"shop_categories\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:15:\"Shop Categories\";s:3:\"@id\";s:15:\"shop_categories\";}s:10:\"\0*\0options\";a:0:{}}s:12:\"shop_columns\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:12:\"Shop Columns\";s:3:\"@id\";s:12:\"shop_columns\";}s:10:\"\0*\0options\";a:0:{}}s:13:\"taxonomy_term\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:13:\"Taxonomy term\";s:3:\"@id\";s:13:\"taxonomy_term\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"team\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Team\";s:3:\"@id\";s:4:\"team\";}s:10:\"\0*\0options\";a:0:{}}s:17:\"user_admin_people\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:6:\"People\";s:3:\"@id\";s:17:\"user_admin_people\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"watchdog\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:8:\"Watchdog\";s:3:\"@id\";s:8:\"watchdog\";}s:10:\"\0*\0options\";a:0:{}}s:9:\"who_s_new\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:9:\"Who\'s new\";s:3:\"@id\";s:9:\"who_s_new\";}s:10:\"\0*\0options\";a:0:{}}s:12:\"who_s_online\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label (@id)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:18:\"Who\'s online block\";s:3:\"@id\";s:12:\"who_s_online\";}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";N;s:7:\"#prefix\";s:35:\"<div id=\"edit-config-type-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:5:\"#ajax\";a:2:{s:8:\"callback\";s:14:\"::updateExport\";s:7:\"wrapper\";s:19:\"edit-export-wrapper\";}}s:6:\"export\";a:5:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Here is your configuration:\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"textarea\";s:5:\"#rows\";i:24;s:7:\"#prefix\";s:30:\"<div id=\"edit-export-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}s:8:\"#form_id\";s:25:\"config_single_export_form\";s:9:\"#build_id\";s:48:\"form-glV3Y6G1gtVzNkPgTQJNllYPujZXqGie-gVpXCVkDmo\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:6:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-glV3Y6G1gtVzNkPgTQJNllYPujZXqGie-gVpXCVkDmo\";s:3:\"#id\";s:48:\"form-glV3Y6G1gtVzNkPgTQJNllYPujZXqGie-gVpXCVkDmo\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}s:11:\"#attributes\";a:1:{s:12:\"autocomplete\";s:3:\"off\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_dlW8N1c3vkZC3VRfWiIxcm1cNDud2O3uwpLXng_FW4E\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:54:\"edit-config-single-export-form-form-token--TCix2Af_cUo\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_dlW8N1c3vkZC3VRfWiIxcm1cNDud2O3uwpLXng_FW4E\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_dlW8N1c3vkZC3VRfWiIxcm1cNDud2O3uwpLXng_FW4E\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_dlW8N1c3vkZC3VRfWiIxcm1cNDud2O3uwpLXng_FW4E\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:25:\"config_single_export_form\";s:3:\"#id\";s:43:\"edit-config-single-export-form--JR9mP6taP9g\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:38:\"config-single-export-form--LGsgUxH1rZ0\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:25:\"config_single_export_form\";}s:12:\"#cache_token\";s:43:\"QAKcqB1P-t_INT2JBl1aiu3LzG74XEUJhlpnQYInqU4\";}',1520011082),

('form','form-GZdQR_LWA2KiKHzkY26Mi-8n0VNTss90V-aInZQEtpU','a:34:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:63:\"config:core.entity_view_display.comment.default_reviews.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:7:\"comment\";s:7:\"#bundle\";s:15:\"default_reviews\";s:7:\"#fields\";a:5:{i:0;s:8:\"langcode\";i:1;s:13:\"field_comment\";i:2;s:11:\"field_email\";i:3;s:12:\"field_rating\";i:4;s:15:\"field_your_name\";}s:6:\"#extra\";a:1:{i:0;s:5:\"links\";}s:6:\"fields\";a:12:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:216;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:216;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:216;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"4ae6a983-0864-4215-aad3-544647c26b53\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:5:{i:0;s:28:\"comment.type.default_reviews\";i:1;s:49:\"field.field.comment.default_reviews.field_comment\";i:2;s:47:\"field.field.comment.default_reviews.field_email\";i:3;s:48:\"field.field.comment.default_reviews.field_rating\";i:4;s:51:\"field.field.comment.default_reviews.field_your_name\";}s:6:\"module\";a:1:{i:0;s:8:\"fivestar\";}}s:5:\"\0*\0id\";s:31:\"comment.default_reviews.default\";s:19:\"\0*\0targetEntityType\";s:7:\"comment\";s:9:\"\0*\0bundle\";s:15:\"default_reviews\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:5:{s:13:\"field_comment\";a:6:{s:6:\"weight\";s:3:\"103\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_email\";a:6:{s:6:\"weight\";s:3:\"101\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:12:\"field_rating\";a:6:{s:6:\"weight\";s:3:\"104\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:44:\"modules/fivestar/widgets/minimal/minimal.css\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"fivestar_stars\";s:6:\"region\";s:7:\"content\";}s:15:\"field_your_name\";a:6:{s:6:\"weight\";s:3:\"102\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";s:3:\"100\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:1:{s:8:\"langcode\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1212;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1212;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1212;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1212;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1212;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1212;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:13:\"field_comment\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:106;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"basic_string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:7:\"Comment\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Comment\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:3:\"103\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Comment\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_comment\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:13:\"field_comment\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Comment\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Comment\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Comment\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:12:\"basic_string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"basic_string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_comment\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Comment\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:11:\"field_email\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:106;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"basic_string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Email\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Email\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:3:\"101\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Email\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_email\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_email\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Email\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Email\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Email\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"basic_string\";r:1432;s:12:\"email_mailto\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"basic_string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_email\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Email\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:12:\"field_rating\";a:10:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:106;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:14:\"fivestar_stars\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Rating\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:3:\"104\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_rating\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:14:\"fivestar_stars\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"As stars\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"fivestar_percentage\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Percentage (i.e. 92)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"fivestar_rating\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Rating (i.e. 4.2/5)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:14:\"fivestar_stars\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:58:\"Format settings: <span class=\"plugin-name\">As stars</span>\";}s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";a:6:{s:5:\"#type\";s:6:\"radios\";s:8:\"#options\";a:8:{s:40:\"modules/fivestar/widgets/small/small.css\";s:5:\"Small\";s:42:\"modules/fivestar/widgets/oxygen/oxygen.css\";s:6:\"Oxygen\";s:44:\"modules/fivestar/widgets/outline/outline.css\";s:7:\"Outline\";s:44:\"modules/fivestar/widgets/minimal/minimal.css\";s:7:\"Minimal\";s:42:\"modules/fivestar/widgets/hearts/hearts.css\";s:6:\"Hearts\";s:42:\"modules/fivestar/widgets/flames/flames.css\";s:6:\"Flames\";s:40:\"modules/fivestar/widgets/craft/craft.css\";s:5:\"Craft\";s:40:\"modules/fivestar/widgets/basic/basic.css\";s:5:\"Basic\";}s:14:\"#default_value\";s:44:\"modules/fivestar/widgets/minimal/minimal.css\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:16:\"fivestar-widgets\";i:1;s:8:\"clearfix\";}}s:11:\"#pre_render\";a:1:{i:0;a:2:{i:0;O:58:\"Drupal\\fivestar\\Plugin\\Field\\FieldFormatter\\StarsFormatter\":11:{s:18:\"\0*\0fieldDefinition\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:36:\"comment.default_reviews.field_rating\";s:13:\"\0*\0field_name\";s:12:\"field_rating\";s:13:\"\0*\0field_type\";s:8:\"fivestar\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:9:\"\0*\0bundle\";s:15:\"default_reviews\";s:8:\"\0*\0label\";s:6:\"Rating\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:11:\"rated_while\";s:7:\"viewing\";s:6:\"target\";s:0:\"\";}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:36:\"comment.default_reviews.field_rating\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"574ef56c-fdbf-4cf3-85a1-1917d7fa0034\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:28:\"comment.type.default_reviews\";i:1;s:34:\"field.storage.comment.field_rating\";}s:6:\"module\";a:1:{i:0;s:8:\"fivestar\";}}}s:11:\"\0*\0settings\";a:1:{s:15:\"fivestar_widget\";s:44:\"modules/fivestar/widgets/minimal/minimal.css\";}s:8:\"\0*\0label\";s:5:\"above\";s:11:\"\0*\0viewMode\";s:7:\"default\";s:21:\"\0*\0thirdPartySettings\";a:0:{}s:24:\"\0*\0defaultSettingsMerged\";b:0;s:11:\"\0*\0pluginId\";s:14:\"fivestar_stars\";s:19:\"\0*\0pluginDefinition\";a:6:{s:11:\"field_types\";a:1:{i:0;s:8:\"fivestar\";}s:2:\"id\";s:14:\"fivestar_stars\";s:5:\"label\";r:1684;s:6:\"weight\";i:1;s:5:\"class\";s:58:\"Drupal\\fivestar\\Plugin\\Field\\FieldFormatter\\StarsFormatter\";s:8:\"provider\";s:8:\"fivestar\";}s:16:\"\0*\0configuration\";a:0:{}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;s:14:\"previewsExpand\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:23:\"fivestar/fivestar.admin\";}}}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_rating\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:35:\"field_rating_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_rating\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:35:\"field_rating_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}}}s:15:\"field_your_name\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:106;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Your name\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Your name\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:3:\"102\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Your name\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_your_name\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_your_name\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Your name\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Your name\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Your name\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_your_name\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Your name\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_your_name\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_your_name_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_your_name\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"links\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:11:\"extra_field\";s:16:\"#region_callback\";a:2:{i:0;r:106;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:1:{s:10:\"rowHandler\";s:5:\"field\";}s:10:\"human_name\";a:1:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:2011;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:3:\"100\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Parents for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:2011;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"links\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"links\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:2011;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:10:\"empty_cell\";a:1:{s:7:\"#markup\";s:6:\"&nbsp;\";}s:6:\"plugin\";a:1:{s:4:\"type\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:7:\"visible\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"links\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"#parent_options\";a:0:{}}s:5:\"modes\";a:4:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Custom display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"display_modes_custom\";a:4:{s:5:\"#type\";s:10:\"checkboxes\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"Use custom display settings for the following @display_context modes\";s:12:\"\0*\0arguments\";a:1:{s:16:\"@display_context\";s:4:\"view\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:2:{s:4:\"full\";s:12:\"Full comment\";s:5:\"token\";s:5:\"Token\";}s:14:\"#default_value\";a:0:{}}s:18:\"display_modes_link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Manage view modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:34:\"entity.entity_view_mode.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-GZdQR_LWA2KiKHzkY26Mi-8n0VNTss90V-aInZQEtpU\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-GZdQR_LWA2KiKHzkY26Mi-8n0VNTss90V-aInZQEtpU\";s:3:\"#id\";s:48:\"form-GZdQR_LWA2KiKHzkY26Mi-8n0VNTss90V-aInZQEtpU\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--2PY-nDaTVTE\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--JaBHGa5jVkg\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--YyKHQRCcWps\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1122;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503087990),

('form','form-hP2tKvkRU3GQZvSrXp1xh_4K4ph4NmMB09WOO-Kiy-8','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:515;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:515;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:569;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:569;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:701;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:701;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503325472\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:763;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:25:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:0:{}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:970;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:0:{}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:4:{s:5:\"#type\";s:6:\"weight\";s:6:\"#delta\";i:50;s:14:\"#default_value\";s:1:\"1\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"ief-entity-delta\";}}}s:7:\"actions\";a:4:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:21:\"ief-entity-operations\";}}s:15:\"ief_entity_edit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:58:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-edit-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:4:\"edit\";}s:17:\"ief_entity_remove\";a:9:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Remove\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:60:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-remove-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:6:\"remove\";s:7:\"#access\";b:1;}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302248\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 10:57\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-hP2tKvkRU3GQZvSrXp1xh_4K4ph4NmMB09WOO-Kiy-8\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-hP2tKvkRU3GQZvSrXp1xh_4K4ph4NmMB09WOO-Kiy-8\";s:3:\"#id\";s:48:\"form-hP2tKvkRU3GQZvSrXp1xh_4K4ph4NmMB09WOO-Kiy-8\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--3X6lWORdU-Q\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--3ryNzI2DcKc\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--7P4iDfMB1h0\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503347137),

('form','form-hwHP1OcbgGBzMFFlUY4Q4iF-a-LyVM8sQMe3EQy58xw','a:28:{s:16:\"#show_operations\";b:0;s:7:\"#prefix\";s:32:\"<div id=\"features-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:4:\"info\";a:13:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"General Information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#tree\";b:0;s:7:\"#weight\";i:2;s:7:\"#prefix\";s:31:\"<div id=\'features-export-info\'>\";s:7:\"#suffix\";s:6:\"</div>\";s:4:\"name\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";s:122:\"Example: Image gallery (Do not begin name with numbers.)<br/>The namespace \"rhythm_\" will be prepended to the machine name\";s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:0:\"\";}s:12:\"machine_name\";a:6:{s:5:\"#type\";s:12:\"machine_name\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Machine-readable name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";s:172:\"Example: image_gallery May only contain lowercase letters, numbers and underscores.<br/>NOTE: Do NOT include the namespace prefix \"rhythm_\"; it will be added automatically.\";s:9:\"#required\";b:1;s:14:\"#default_value\";s:0:\"\";s:13:\"#machine_name\";a:2:{s:6:\"source\";a:2:{i:0;s:4:\"info\";i:1;s:4:\"name\";}s:6:\"exists\";a:2:{i:0;O:40:\"Drupal\\features_ui\\Form\\FeaturesEditForm\":15:{s:10:\"\0*\0package\";O:23:\"Drupal\\features\\Package\":19:{s:14:\"\0*\0machineName\";s:0:\"\";s:7:\"\0*\0name\";s:0:\"\";s:14:\"\0*\0description\";s:0:\"\";s:10:\"\0*\0version\";s:0:\"\";s:7:\"\0*\0core\";s:3:\"8.x\";s:7:\"\0*\0type\";s:6:\"module\";s:9:\"\0*\0themes\";a:0:{}s:9:\"\0*\0bundle\";s:0:\"\";s:11:\"\0*\0excluded\";a:0:{}s:11:\"\0*\0required\";b:0;s:7:\"\0*\0info\";a:0:{}s:15:\"\0*\0dependencies\";a:3:{i:0;s:5:\"block\";i:1;s:4:\"node\";i:2;s:5:\"views\";}s:9:\"\0*\0status\";i:0;s:8:\"\0*\0state\";i:0;s:12:\"\0*\0directory\";N;s:8:\"\0*\0files\";a:0:{}s:12:\"\0*\0extension\";N;s:9:\"\0*\0config\";a:1:{i:0;s:49:\"block.block.views_block__related_projects_block_1\";}s:13:\"\0*\0configOrig\";a:0:{}}s:9:\"\0*\0bundle\";s:6:\"rhythm\";s:12:\"\0*\0oldBundle\";s:7:\"default\";s:11:\"\0*\0excluded\";a:0:{}s:11:\"\0*\0required\";a:0:{}s:12:\"\0*\0conflicts\";a:17:{s:13:\"system_simple\";a:9:{s:14:\"embed.settings\";s:14:\"embed.settings\";s:21:\"entity_embed.settings\";s:21:\"entity_embed.settings\";s:13:\"file.settings\";s:13:\"file.settings\";s:28:\"nd_visualshortcodes.settings\";s:28:\"nd_visualshortcodes.settings\";s:14:\"seven.settings\";s:14:\"seven.settings\";s:12:\"system.image\";s:12:\"system.image\";s:15:\"system.image.gd\";s:15:\"system.image.gd\";s:17:\"taxonomy.settings\";s:17:\"taxonomy.settings\";s:14:\"views.settings\";s:14:\"views.settings\";}s:19:\"base_field_override\";a:5:{s:25:\"node.gallery_item.promote\";s:22:\"Promoted to front page\";s:20:\"node.nd_blog.promote\";s:22:\"Promoted to front page\";s:22:\"node.nd_person.promote\";s:22:\"Promoted to front page\";s:25:\"node.nd_portfolio.promote\";s:22:\"Promoted to front page\";s:17:\"node.page.promote\";s:22:\"Promoted to front page\";}s:5:\"block\";a:2:{s:32:\"views_block__products_tags_block\";s:4:\"Tags\";s:34:\"views_block__shop_categories_block\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"@view: @display\";s:12:\"\0*\0arguments\";a:2:{s:5:\"@view\";s:15:\"Shop Categories\";s:8:\"@display\";s:15:\"Shop Categories\";}s:10:\"\0*\0options\";a:0:{}}}s:25:\"language_content_settings\";a:3:{s:17:\"node.gallery_item\";s:17:\"node.gallery_item\";s:14:\"node.nd_person\";s:14:\"node.nd_person\";s:21:\"taxonomy_term.gallery\";s:21:\"taxonomy_term.gallery\";}s:9:\"node_type\";a:5:{s:12:\"gallery_item\";s:12:\"Gallery Item\";s:7:\"nd_blog\";s:4:\"Blog\";s:9:\"nd_person\";s:6:\"Person\";s:12:\"nd_portfolio\";s:9:\"Portfolio\";s:4:\"page\";s:10:\"Basic page\";}s:18:\"block_content_type\";a:1:{s:5:\"basic\";s:11:\"Basic block\";}s:19:\"entity_form_display\";a:10:{s:27:\"block_content.basic.default\";s:27:\"block_content.basic.default\";s:23:\"comment.comment.default\";s:23:\"comment.comment.default\";s:20:\"node.article.default\";s:20:\"node.article.default\";s:25:\"node.gallery_item.default\";s:25:\"node.gallery_item.default\";s:20:\"node.nd_blog.default\";s:20:\"node.nd_blog.default\";s:22:\"node.nd_person.default\";s:22:\"node.nd_person.default\";s:25:\"node.nd_portfolio.default\";s:25:\"node.nd_portfolio.default\";s:17:\"node.page.default\";s:17:\"node.page.default\";s:20:\"node.webform.default\";s:20:\"node.webform.default\";s:17:\"user.user.default\";s:17:\"user.user.default\";}s:19:\"entity_view_display\";a:19:{s:27:\"block_content.basic.default\";s:27:\"block_content.basic.default\";s:23:\"comment.comment.default\";s:23:\"comment.comment.default\";s:20:\"node.article.default\";s:20:\"node.article.default\";s:16:\"node.article.rss\";s:16:\"node.article.rss\";s:19:\"node.article.teaser\";s:19:\"node.article.teaser\";s:25:\"node.gallery_item.default\";s:25:\"node.gallery_item.default\";s:24:\"node.gallery_item.teaser\";s:24:\"node.gallery_item.teaser\";s:20:\"node.nd_blog.default\";s:20:\"node.nd_blog.default\";s:19:\"node.nd_blog.teaser\";s:19:\"node.nd_blog.teaser\";s:22:\"node.nd_person.default\";s:22:\"node.nd_person.default\";s:21:\"node.nd_person.teaser\";s:21:\"node.nd_person.teaser\";s:25:\"node.nd_portfolio.default\";s:25:\"node.nd_portfolio.default\";s:24:\"node.nd_portfolio.teaser\";s:24:\"node.nd_portfolio.teaser\";s:17:\"node.page.default\";s:17:\"node.page.default\";s:16:\"node.page.teaser\";s:16:\"node.page.teaser\";s:20:\"node.webform.default\";s:20:\"node.webform.default\";s:19:\"node.webform.teaser\";s:19:\"node.webform.teaser\";s:17:\"user.user.compact\";s:17:\"user.user.compact\";s:17:\"user.user.default\";s:17:\"user.user.default\";}s:12:\"field_config\";a:30:{s:24:\"block_content.basic.body\";s:4:\"Body\";s:29:\"comment.comment.field_comment\";s:7:\"Comment\";s:27:\"comment.comment.field_email\";s:5:\"Email\";s:17:\"node.article.body\";s:4:\"Body\";s:20:\"node.article.comment\";s:8:\"Comments\";s:24:\"node.article.field_image\";s:5:\"Image\";s:23:\"node.article.field_tags\";s:4:\"Tags\";s:31:\"node.gallery_item.field_gallery\";s:7:\"Gallery\";s:29:\"node.gallery_item.field_image\";s:5:\"Image\";s:17:\"node.nd_blog.body\";s:4:\"Body\";s:32:\"node.nd_blog.field_blog_category\";s:13:\"Blog Category\";s:27:\"node.nd_blog.field_comments\";s:8:\"Comments\";s:25:\"node.nd_blog.field_images\";s:6:\"Images\";s:28:\"node.nd_blog.field_lead_text\";s:9:\"Lead Text\";s:31:\"node.nd_blog.field_second_title\";s:12:\"Second Title\";s:23:\"node.nd_blog.field_tags\";s:4:\"Tags\";s:19:\"node.nd_person.body\";s:4:\"Body\";s:26:\"node.nd_person.field_image\";s:5:\"Image\";s:29:\"node.nd_person.field_position\";s:8:\"Position\";s:33:\"node.nd_person.field_social_links\";s:12:\"Social Links\";s:22:\"node.nd_portfolio.body\";s:4:\"Body\";s:32:\"node.nd_portfolio.field_category\";s:8:\"Category\";s:35:\"node.nd_portfolio.field_description\";s:11:\"Description\";s:30:\"node.nd_portfolio.field_images\";s:6:\"Images\";s:42:\"node.nd_portfolio.field_portfolio_category\";s:18:\"Portfolio Category\";s:31:\"node.nd_portfolio.field_project\";s:7:\"Project\";s:36:\"node.nd_portfolio.field_project_link\";s:12:\"Project Link\";s:14:\"node.page.body\";s:4:\"Body\";s:17:\"node.webform.body\";s:4:\"Body\";s:22:\"user.user.user_picture\";s:7:\"Picture\";}s:20:\"field_storage_config\";a:22:{s:18:\"block_content.body\";s:18:\"block_content.body\";s:20:\"comment.comment_body\";s:20:\"comment.comment_body\";s:21:\"comment.field_comment\";s:21:\"comment.field_comment\";s:19:\"comment.field_email\";s:19:\"comment.field_email\";s:9:\"node.body\";s:9:\"node.body\";s:12:\"node.comment\";s:12:\"node.comment\";s:24:\"node.field_blog_category\";s:24:\"node.field_blog_category\";s:19:\"node.field_category\";s:19:\"node.field_category\";s:19:\"node.field_comments\";s:19:\"node.field_comments\";s:22:\"node.field_description\";s:22:\"node.field_description\";s:18:\"node.field_gallery\";s:18:\"node.field_gallery\";s:16:\"node.field_image\";s:16:\"node.field_image\";s:17:\"node.field_images\";s:17:\"node.field_images\";s:20:\"node.field_lead_text\";s:20:\"node.field_lead_text\";s:29:\"node.field_portfolio_category\";s:29:\"node.field_portfolio_category\";s:19:\"node.field_position\";s:19:\"node.field_position\";s:18:\"node.field_project\";s:18:\"node.field_project\";s:23:\"node.field_project_link\";s:23:\"node.field_project_link\";s:23:\"node.field_second_title\";s:23:\"node.field_second_title\";s:23:\"node.field_social_links\";s:23:\"node.field_social_links\";s:15:\"node.field_tags\";s:15:\"node.field_tags\";s:17:\"user.user_picture\";s:17:\"user.user_picture\";}s:11:\"image_style\";a:12:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";}s:4:\"menu\";a:1:{s:8:\"one-page\";s:8:\"One Page\";}s:19:\"taxonomy_vocabulary\";a:6:{s:13:\"blog_category\";s:13:\"Blog Category\";s:8:\"category\";s:8:\"Category\";s:7:\"gallery\";s:7:\"Gallery\";s:18:\"portfolio_category\";s:18:\"Portfolio Category\";s:7:\"project\";s:7:\"Project\";s:4:\"tags\";s:4:\"Tags\";}s:6:\"editor\";a:3:{s:10:\"basic_html\";s:10:\"Basic HTML\";s:8:\"ckeditor\";s:8:\"CKeditor\";s:9:\"full_html\";s:9:\"Full HTML\";}s:13:\"filter_format\";a:5:{s:10:\"basic_html\";s:10:\"Basic HTML\";s:8:\"ckeditor\";s:8:\"CKeditor\";s:9:\"full_html\";s:9:\"Full HTML\";s:10:\"shortcodes\";s:10:\"Shortcodes\";s:17:\"visual_shortcodes\";s:17:\"Visual Shortcodes\";}s:4:\"view\";a:12:{s:14:\"blog_fullwidth\";s:14:\"Blog Fullwidth\";s:9:\"blog_grid\";s:9:\"Blog Grid\";s:12:\"blog_masonry\";s:12:\"Blog Masonry\";s:13:\"blog_timeline\";s:13:\"Blog TimeLine\";s:7:\"gallery\";s:7:\"Gallery\";s:15:\"portfolio_boxed\";s:9:\"Portfolio\";s:18:\"portfolio_parallax\";s:18:\"Portfolio Parallax\";s:15:\"portfolio_promo\";s:15:\"Portfolio Promo\";s:13:\"products_tags\";s:13:\"Products Tags\";s:16:\"related_projects\";s:16:\"Related Projects\";s:15:\"shop_categories\";s:15:\"Shop Categories\";s:4:\"team\";s:4:\"Team\";}s:7:\"webform\";a:3:{s:7:\"contact\";s:7:\"Contact\";s:9:\"contact_1\";s:9:\"Contact 1\";s:9:\"subscribe\";s:9:\"Subscribe\";}}s:17:\"\0*\0allowConflicts\";b:0;s:10:\"\0*\0missing\";a:0:{}s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:15:\"featuresManager\";s:16:\"features.manager\";s:8:\"assigner\";s:17:\"features_assigner\";s:9:\"generator\";s:18:\"features_generator\";s:12:\"configRevert\";s:22:\"features.config_update\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:13:\"featureExists\";}}}s:11:\"description\";a:5:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:87:\"Provide a short description of what users should expect when they install your feature.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"textarea\";s:5:\"#rows\";i:3;s:14:\"#default_value\";s:0:\"\";}s:7:\"package\";a:5:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Bundle\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:3:{s:7:\"default\";s:7:\"Default\";s:8:\"nikadevs\";s:8:\"NikaDevs\";s:6:\"rhythm\";s:6:\"Rhythm\";}s:14:\"#default_value\";s:6:\"rhythm\";s:5:\"#ajax\";a:2:{s:8:\"callback\";s:14:\"::updateBundle\";s:7:\"wrapper\";s:20:\"features-export-info\";}}s:7:\"version\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Version\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Examples: 8.x-1.0, 8.x-1.0-beta1\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:9:\"#required\";b:0;s:14:\"#default_value\";s:0:\"\";s:5:\"#size\";i:30;}s:9:\"directory\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"Path to export package using Write action, relative to root directory.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:9:\"#required\";b:0;s:14:\"#default_value\";s:43:\"profiles/Rhythm Demo Install/modules/custom\";s:5:\"#size\";i:30;}s:11:\"require_all\";a:4:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Mark all config as required\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";b:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:88:\"Required config will be assigned to this feature regardless of other assignment plugins.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:9:\"conflicts\";a:6:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Allow conflicts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";b:0;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Allow configuration to be exported to more than one feature.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:8;s:5:\"#ajax\";a:2:{s:8:\"callback\";s:12:\"::updateForm\";s:7:\"wrapper\";s:21:\"features-edit-wrapper\";}}s:7:\"actions\";a:4:{s:5:\"#type\";s:7:\"actions\";s:5:\"#tree\";b:1;s:7:\"archive\";a:4:{s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:7:\"archive\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"@name\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Download Archive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"title\";s:76:\"Generate packages and optional profile as a compressed archive for download.\";}}s:5:\"write\";a:4:{s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:5:\"write\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"@name\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Write\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"title\";s:55:\"Write packages and optional profile to the file system.\";}}}s:6:\"export\";a:50:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Components\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:95:\"Expand each component section and select which items should be included in this feature export.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#tree\";b:0;s:7:\"#prefix\";s:34:\"<div id=\'features-export-wrapper\'>\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#weight\";i:1;s:23:\"features_filter_wrapper\";a:8:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Filters\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#tree\";b:0;s:7:\"#prefix\";s:52:\"<div id=\'features-filter\' class=\'element-invisible\'>\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#weight\";i:-10;s:15:\"features_filter\";a:5:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#hidden\";b:1;s:14:\"#default_value\";s:0:\"\";s:7:\"#suffix\";s:48:\"<span class=\'features-filter-clear\'>Clear</span>\";}s:8:\"checkall\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:14:\"#default_value\";b:0;s:7:\"#hidden\";b:1;s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Select all\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"features-checkall\";}}}}s:13:\"system_simple\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Simple configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:29;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:60:\"<div class=\'features-export-parent component-system_simple\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:26:\"edit-sources-system-simple\";s:8:\"#options\";a:29:{s:23:\"commerce_store.settings\";s:23:\"commerce_store.settings\";s:16:\"contact.settings\";s:16:\"contact.settings\";s:36:\"core.menu.static_menu_link_overrides\";s:36:\"core.menu.static_menu_link_overrides\";s:14:\"dblog.settings\";s:14:\"dblog.settings\";s:14:\"devel.settings\";s:14:\"devel.settings\";s:19:\"dropzonejs.settings\";s:19:\"dropzonejs.settings\";s:17:\"features.settings\";s:17:\"features.settings\";s:12:\"hal.settings\";s:12:\"hal.settings\";s:17:\"language.mappings\";s:17:\"language.mappings\";s:20:\"language.negotiation\";s:20:\"language.negotiation\";s:14:\"language.types\";s:14:\"language.types\";s:16:\"menu_ui.settings\";s:16:\"menu_ui.settings\";s:17:\"pathauto.settings\";s:17:\"pathauto.settings\";s:13:\"rest.settings\";s:13:\"rest.settings\";s:15:\"rhythm.settings\";s:15:\"rhythm.settings\";s:19:\"rhythm_sub.settings\";s:19:\"rhythm_sub.settings\";s:15:\"search.settings\";s:15:\"search.settings\";s:22:\"serialization.settings\";s:22:\"serialization.settings\";s:11:\"system.cron\";s:11:\"system.cron\";s:11:\"system.mail\";s:11:\"system.mail\";s:10:\"system.rss\";s:10:\"system.rss\";s:12:\"system.theme\";s:12:\"system.theme\";s:19:\"system.theme.global\";s:19:\"system.theme.global\";s:13:\"text.settings\";s:13:\"text.settings\";s:10:\"user.flood\";s:10:\"user.flood\";s:9:\"user.mail\";s:9:\"user.mail\";s:13:\"user.settings\";s:13:\"user.settings\";s:18:\"votingapi.settings\";s:18:\"votingapi.settings\";s:16:\"webform.settings\";s:16:\"webform.settings\";}s:14:\"#default_value\";a:29:{s:23:\"commerce_store.settings\";s:0:\"\";s:16:\"contact.settings\";s:0:\"\";s:36:\"core.menu.static_menu_link_overrides\";s:0:\"\";s:14:\"dblog.settings\";s:0:\"\";s:14:\"devel.settings\";s:0:\"\";s:19:\"dropzonejs.settings\";s:0:\"\";s:17:\"features.settings\";s:0:\"\";s:12:\"hal.settings\";s:0:\"\";s:17:\"language.mappings\";s:0:\"\";s:20:\"language.negotiation\";s:0:\"\";s:14:\"language.types\";s:0:\"\";s:16:\"menu_ui.settings\";s:0:\"\";s:17:\"pathauto.settings\";s:0:\"\";s:13:\"rest.settings\";s:0:\"\";s:15:\"rhythm.settings\";s:0:\"\";s:19:\"rhythm_sub.settings\";s:0:\"\";s:15:\"search.settings\";s:0:\"\";s:22:\"serialization.settings\";s:0:\"\";s:11:\"system.cron\";s:0:\"\";s:11:\"system.mail\";s:0:\"\";s:10:\"system.rss\";s:0:\"\";s:12:\"system.theme\";s:0:\"\";s:19:\"system.theme.global\";s:0:\"\";s:13:\"text.settings\";s:0:\"\";s:10:\"user.flood\";s:0:\"\";s:9:\"user.mail\";s:0:\"\";s:13:\"user.settings\";s:0:\"\";s:18:\"votingapi.settings\";s:0:\"\";s:16:\"webform.settings\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:6:\"action\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:27;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:53:\"<div class=\'features-export-parent component-action\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:19:\"edit-sources-action\";s:8:\"#options\";a:27:{s:22:\"comment_publish_action\";s:74:\"Publish comment  <span class=\"config-name\">(comment_publish_action)</span>\";s:19:\"comment_save_action\";s:68:\"Save comment  <span class=\"config-name\">(comment_save_action)</span>\";s:24:\"comment_unpublish_action\";s:78:\"Unpublish comment  <span class=\"config-name\">(comment_unpublish_action)</span>\";s:28:\"commerce_order_delete_action\";s:77:\"Delete order  <span class=\"config-name\">(commerce_order_delete_action)</span>\";s:30:\"commerce_product_delete_action\";s:81:\"Delete product  <span class=\"config-name\">(commerce_product_delete_action)</span>\";s:24:\"commerce_publish_product\";s:76:\"Publish product  <span class=\"config-name\">(commerce_publish_product)</span>\";s:28:\"commerce_store_delete_action\";s:77:\"Delete store  <span class=\"config-name\">(commerce_store_delete_action)</span>\";s:26:\"commerce_unpublish_product\";s:80:\"Unpublish product  <span class=\"config-name\">(commerce_unpublish_product)</span>\";s:18:\"node_delete_action\";s:69:\"Delete content  <span class=\"config-name\">(node_delete_action)</span>\";s:23:\"node_make_sticky_action\";s:79:\"Make content sticky  <span class=\"config-name\">(node_make_sticky_action)</span>\";s:25:\"node_make_unsticky_action\";s:83:\"Make content unsticky  <span class=\"config-name\">(node_make_unsticky_action)</span>\";s:19:\"node_promote_action\";s:85:\"Promote content to front page  <span class=\"config-name\">(node_promote_action)</span>\";s:19:\"node_publish_action\";s:71:\"Publish content  <span class=\"config-name\">(node_publish_action)</span>\";s:16:\"node_save_action\";s:65:\"Save content  <span class=\"config-name\">(node_save_action)</span>\";s:21:\"node_unpromote_action\";s:88:\"Remove content from front page  <span class=\"config-name\">(node_unpromote_action)</span>\";s:21:\"node_unpublish_action\";s:75:\"Unpublish content  <span class=\"config-name\">(node_unpublish_action)</span>\";s:26:\"pathauto_update_alias_node\";s:79:\"Update URL alias  <span class=\"config-name\">(pathauto_update_alias_node)</span>\";s:26:\"pathauto_update_alias_user\";s:79:\"Update URL alias  <span class=\"config-name\">(pathauto_update_alias_user)</span>\";s:21:\"profile_delete_action\";s:81:\"Delete selected profile  <span class=\"config-name\">(profile_delete_action)</span>\";s:22:\"profile_publish_action\";s:83:\"Publish selected profile  <span class=\"config-name\">(profile_publish_action)</span>\";s:24:\"profile_unpublish_action\";s:87:\"Unpublish selected profile  <span class=\"config-name\">(profile_unpublish_action)</span>\";s:22:\"user_block_user_action\";s:85:\"Block the selected user(s)  <span class=\"config-name\">(user_block_user_action)</span>\";s:23:\"user_cancel_user_action\";s:95:\"Cancel the selected user account(s)  <span class=\"config-name\">(user_cancel_user_action)</span>\";s:24:\"user_unblock_user_action\";s:89:\"Unblock the selected user(s)  <span class=\"config-name\">(user_unblock_user_action)</span>\";s:32:\"webform_submission_delete_action\";s:86:\"Delete submission  <span class=\"config-name\">(webform_submission_delete_action)</span>\";s:37:\"webform_submission_make_sticky_action\";s:94:\"Star/Flag submission  <span class=\"config-name\">(webform_submission_make_sticky_action)</span>\";s:39:\"webform_submission_make_unsticky_action\";s:100:\"Unstar/unflag submission  <span class=\"config-name\">(webform_submission_make_unsticky_action)</span>\";}s:14:\"#default_value\";a:27:{s:22:\"comment_publish_action\";s:0:\"\";s:19:\"comment_save_action\";s:0:\"\";s:24:\"comment_unpublish_action\";s:0:\"\";s:28:\"commerce_order_delete_action\";s:0:\"\";s:30:\"commerce_product_delete_action\";s:0:\"\";s:24:\"commerce_publish_product\";s:0:\"\";s:28:\"commerce_store_delete_action\";s:0:\"\";s:26:\"commerce_unpublish_product\";s:0:\"\";s:18:\"node_delete_action\";s:0:\"\";s:23:\"node_make_sticky_action\";s:0:\"\";s:25:\"node_make_unsticky_action\";s:0:\"\";s:19:\"node_promote_action\";s:0:\"\";s:19:\"node_publish_action\";s:0:\"\";s:16:\"node_save_action\";s:0:\"\";s:21:\"node_unpromote_action\";s:0:\"\";s:21:\"node_unpublish_action\";s:0:\"\";s:26:\"pathauto_update_alias_node\";s:0:\"\";s:26:\"pathauto_update_alias_user\";s:0:\"\";s:21:\"profile_delete_action\";s:0:\"\";s:22:\"profile_publish_action\";s:0:\"\";s:24:\"profile_unpublish_action\";s:0:\"\";s:22:\"user_block_user_action\";s:0:\"\";s:23:\"user_cancel_user_action\";s:0:\"\";s:24:\"user_unblock_user_action\";s:0:\"\";s:32:\"webform_submission_delete_action\";s:0:\"\";s:37:\"webform_submission_make_sticky_action\";s:0:\"\";s:39:\"webform_submission_make_unsticky_action\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:19:\"base_field_override\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Base field override\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:66:\"<div class=\'features-export-parent component-base_field_override\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:32:\"edit-sources-base-field-override\";s:8:\"#options\";a:1:{s:20:\"node.webform.promote\";s:79:\"Promoted to front page  <span class=\"config-name\">(node.webform.promote)</span>\";}s:14:\"#default_value\";a:1:{s:20:\"node.webform.promote\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:5:\"block\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:126;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:52:\"<div class=\'features-export-parent component-block\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:18:\"edit-sources-block\";s:8:\"#options\";a:126:{s:4:\"cart\";s:54:\"Shopping cart  <span class=\"config-name\">(cart)</span>\";s:6:\"footer\";s:49:\"Footer  <span class=\"config-name\">(footer)</span>\";s:11:\"gmapcontact\";s:61:\"Gmap: Contact  <span class=\"config-name\">(gmapcontact)</span>\";s:14:\"gmapcontacttop\";s:68:\"Gmap: Contact Top  <span class=\"config-name\">(gmapcontacttop)</span>\";s:18:\"headeragencyheader\";s:76:\"Header: Agency Header  <span class=\"config-name\">(headeragencyheader)</span>\";s:24:\"headerbgvideofullscreen1\";s:90:\"Header: BG Video FullScreen 1  <span class=\"config-name\">(headerbgvideofullscreen1)</span>\";s:31:\"headerbgvideofullscreen1onepage\";s:107:\"Header: BG Video FullScreen 1 - OnePage  <span class=\"config-name\">(headerbgvideofullscreen1onepage)</span>\";s:24:\"headerbgvideofullscreen2\";s:90:\"Header: BG Video FullScreen 2  <span class=\"config-name\">(headerbgvideofullscreen2)</span>\";s:31:\"headerbgvideofullscreen2onepage\";s:107:\"Header: BG Video FullScreen 2 - OnePage  <span class=\"config-name\">(headerbgvideofullscreen2onepage)</span>\";s:22:\"headerbgvideofullwidth\";s:85:\"Header: BG Video Fullwidth  <span class=\"config-name\">(headerbgvideofullwidth)</span>\";s:29:\"headerbgvideofullwidthonepage\";s:102:\"Header: BG Video Fullwidth - OnePage  <span class=\"config-name\">(headerbgvideofullwidthonepage)</span>\";s:14:\"headerdarkmain\";s:67:\"Header Dark MAIN  <span class=\"config-name\">(headerdarkmain)</span>\";s:21:\"headerdarktransparent\";s:81:\"Header Dark Transparent  <span class=\"config-name\">(headerdarktransparent)</span>\";s:20:\"headerfullwidthimage\";s:80:\"Header: Fullwidth Image  <span class=\"config-name\">(headerfullwidthimage)</span>\";s:27:\"headerfullwidthimageonepage\";s:97:\"Header: Fullwidth Image - OnePage  <span class=\"config-name\">(headerfullwidthimageonepage)</span>\";s:20:\"headerimageparallax1\";s:81:\"Header: Image Parallax 1  <span class=\"config-name\">(headerimageparallax1)</span>\";s:27:\"headerimageparallax1onepage\";s:98:\"Header: Image Parallax 1 - OnePage  <span class=\"config-name\">(headerimageparallax1onepage)</span>\";s:20:\"headerimageparallax2\";s:81:\"Header: Image Parallax 2  <span class=\"config-name\">(headerimageparallax2)</span>\";s:27:\"headerimageparallax2onepage\";s:98:\"Header: Image Parallax 2 - Onepage  <span class=\"config-name\">(headerimageparallax2onepage)</span>\";s:20:\"headerimageparallax3\";s:81:\"Header: Image Parallax 3  <span class=\"config-name\">(headerimageparallax3)</span>\";s:27:\"headerimageparallax3onepage\";s:98:\"Header: Image Parallax 3 - OnePage  <span class=\"config-name\">(headerimageparallax3onepage)</span>\";s:20:\"headerimageparallax4\";s:81:\"Header: Image Parallax 4  <span class=\"config-name\">(headerimageparallax4)</span>\";s:27:\"headerimageparallax4onepage\";s:98:\"Header: Image Parallax 4 - OnePage  <span class=\"config-name\">(headerimageparallax4onepage)</span>\";s:20:\"headerimageparallax5\";s:81:\"Header: Image Parallax 5  <span class=\"config-name\">(headerimageparallax5)</span>\";s:27:\"headerimageparallax5onepage\";s:98:\"Header: Image Parallax 5 - OnePage  <span class=\"config-name\">(headerimageparallax5onepage)</span>\";s:14:\"headermaindemo\";s:68:\"Header: Main Demo  <span class=\"config-name\">(headermaindemo)</span>\";s:21:\"headermaindemoonepage\";s:85:\"Header: Main Demo - OnePage  <span class=\"config-name\">(headermaindemoonepage)</span>\";s:23:\"headermaindemoonepage_2\";s:87:\"Header: Main Demo - OnePage  <span class=\"config-name\">(headermaindemoonepage_2)</span>\";s:22:\"headersliderbackground\";s:84:\"Header: Slider Background  <span class=\"config-name\">(headersliderbackground)</span>\";s:29:\"headersliderbackgroundonepage\";s:101:\"Header: Slider Background - OnePage  <span class=\"config-name\">(headersliderbackgroundonepage)</span>\";s:22:\"headersliderfullscreen\";s:84:\"Header: Slider Fullscreen  <span class=\"config-name\">(headersliderfullscreen)</span>\";s:29:\"headersliderfullscreenonepage\";s:101:\"Header: Slider Fullscreen - OnePage  <span class=\"config-name\">(headersliderfullscreenonepage)</span>\";s:21:\"headersliderfullwidth\";s:82:\"Header: Slider Fullwidth  <span class=\"config-name\">(headersliderfullwidth)</span>\";s:28:\"headersliderfullwidthonepage\";s:99:\"Header: Slider Fullwidth - OnePage  <span class=\"config-name\">(headersliderfullwidthonepage)</span>\";s:22:\"headersliderzoomeffect\";s:85:\"Header: Slider Zoom Effect  <span class=\"config-name\">(headersliderzoomeffect)</span>\";s:29:\"headersliderzoomeffectonepage\";s:102:\"Header: Slider Zoom Effect - OnePage  <span class=\"config-name\">(headersliderzoomeffectonepage)</span>\";s:24:\"headerspecialphotography\";s:88:\"Header: Special Photography  <span class=\"config-name\">(headerspecialphotography)</span>\";s:31:\"headerspecialphotographyonepage\";s:105:\"Header: Special Photography - OnePage  <span class=\"config-name\">(headerspecialphotographyonepage)</span>\";s:17:\"headertextrotator\";s:74:\"Header: Text Rotator  <span class=\"config-name\">(headertextrotator)</span>\";s:24:\"headertextrotatoronepage\";s:91:\"Header: Text Rotator - OnePage  <span class=\"config-name\">(headertextrotatoronepage)</span>\";s:11:\"headerwhite\";s:60:\"Header White  <span class=\"config-name\">(headerwhite)</span>\";s:22:\"headerwhitetransparent\";s:83:\"Header White Transparent  <span class=\"config-name\">(headerwhitetransparent)</span>\";s:20:\"headerwithplaybutton\";s:81:\"Header: With Play Button  <span class=\"config-name\">(headerwithplaybutton)</span>\";s:27:\"headerwithplaybuttononepage\";s:98:\"Header: With Play Button - OnePage  <span class=\"config-name\">(headerwithplaybuttononepage)</span>\";s:16:\"languageswitcher\";s:70:\"Language switcher  <span class=\"config-name\">(languageswitcher)</span>\";s:15:\"relatedprojects\";s:68:\"Related Projects  <span class=\"config-name\">(relatedprojects)</span>\";s:20:\"rhythmproductsfilter\";s:72:\"Filter by Price  <span class=\"config-name\">(rhythmproductsfilter)</span>\";s:21:\"rhythmprojectnextprev\";s:83:\"Rhythm: Project Next Prev  <span class=\"config-name\">(rhythmprojectnextprev)</span>\";s:19:\"rhythm_account_menu\";s:73:\"User account menu  <span class=\"config-name\">(rhythm_account_menu)</span>\";s:15:\"rhythm_branding\";s:65:\"Site branding  <span class=\"config-name\">(rhythm_branding)</span>\";s:18:\"rhythm_breadcrumbs\";s:66:\"Breadcrumbs  <span class=\"config-name\">(rhythm_breadcrumbs)</span>\";s:14:\"rhythm_content\";s:68:\"Main page content  <span class=\"config-name\">(rhythm_content)</span>\";s:13:\"rhythm_footer\";s:61:\"Footer menu  <span class=\"config-name\">(rhythm_footer)</span>\";s:11:\"rhythm_help\";s:52:\"Help  <span class=\"config-name\">(rhythm_help)</span>\";s:20:\"rhythm_local_actions\";s:78:\"Primary admin actions  <span class=\"config-name\">(rhythm_local_actions)</span>\";s:18:\"rhythm_local_tasks\";s:59:\"Tabs  <span class=\"config-name\">(rhythm_local_tasks)</span>\";s:16:\"rhythm_main_menu\";s:68:\"Main navigation  <span class=\"config-name\">(rhythm_main_menu)</span>\";s:15:\"rhythm_messages\";s:67:\"Status messages  <span class=\"config-name\">(rhythm_messages)</span>\";s:17:\"rhythm_page_title\";s:64:\"Page title  <span class=\"config-name\">(rhythm_page_title)</span>\";s:14:\"rhythm_powered\";s:68:\"Powered by Drupal  <span class=\"config-name\">(rhythm_powered)</span>\";s:13:\"rhythm_search\";s:56:\"Search  <span class=\"config-name\">(rhythm_search)</span>\";s:23:\"rhythm_sub_account_menu\";s:77:\"User account menu  <span class=\"config-name\">(rhythm_sub_account_menu)</span>\";s:19:\"rhythm_sub_branding\";s:69:\"Site branding  <span class=\"config-name\">(rhythm_sub_branding)</span>\";s:18:\"rhythm_sub_content\";s:72:\"Main page content  <span class=\"config-name\">(rhythm_sub_content)</span>\";s:17:\"rhythm_sub_footer\";s:60:\"Footer  <span class=\"config-name\">(rhythm_sub_footer)</span>\";s:22:\"rhythm_sub_gmapcontact\";s:72:\"Gmap: Contact  <span class=\"config-name\">(rhythm_sub_gmapcontact)</span>\";s:25:\"rhythm_sub_gmapcontacttop\";s:79:\"Gmap: Contact Top  <span class=\"config-name\">(rhythm_sub_gmapcontacttop)</span>\";s:29:\"rhythm_sub_headeragencyheader\";s:87:\"Header: Agency Header  <span class=\"config-name\">(rhythm_sub_headeragencyheader)</span>\";s:35:\"rhythm_sub_headerbgvideofullscreen1\";s:101:\"Header: BG Video FullScreen 1  <span class=\"config-name\">(rhythm_sub_headerbgvideofullscreen1)</span>\";s:42:\"rhythm_sub_headerbgvideofullscreen1onepage\";s:118:\"Header: BG Video FullScreen 1 - OnePage  <span class=\"config-name\">(rhythm_sub_headerbgvideofullscreen1onepage)</span>\";s:35:\"rhythm_sub_headerbgvideofullscreen2\";s:101:\"Header: BG Video FullScreen 2  <span class=\"config-name\">(rhythm_sub_headerbgvideofullscreen2)</span>\";s:42:\"rhythm_sub_headerbgvideofullscreen2onepage\";s:118:\"Header: BG Video FullScreen 2 - OnePage  <span class=\"config-name\">(rhythm_sub_headerbgvideofullscreen2onepage)</span>\";s:33:\"rhythm_sub_headerbgvideofullwidth\";s:96:\"Header: BG Video Fullwidth  <span class=\"config-name\">(rhythm_sub_headerbgvideofullwidth)</span>\";s:40:\"rhythm_sub_headerbgvideofullwidthonepage\";s:113:\"Header: BG Video Fullwidth - OnePage  <span class=\"config-name\">(rhythm_sub_headerbgvideofullwidthonepage)</span>\";s:25:\"rhythm_sub_headerdarkmain\";s:78:\"Header Dark MAIN  <span class=\"config-name\">(rhythm_sub_headerdarkmain)</span>\";s:32:\"rhythm_sub_headerdarktransparent\";s:92:\"Header Dark Transparent  <span class=\"config-name\">(rhythm_sub_headerdarktransparent)</span>\";s:31:\"rhythm_sub_headerfullwidthimage\";s:91:\"Header: Fullwidth Image  <span class=\"config-name\">(rhythm_sub_headerfullwidthimage)</span>\";s:38:\"rhythm_sub_headerfullwidthimageonepage\";s:108:\"Header: Fullwidth Image - OnePage  <span class=\"config-name\">(rhythm_sub_headerfullwidthimageonepage)</span>\";s:31:\"rhythm_sub_headerimageparallax1\";s:92:\"Header: Image Parallax 1  <span class=\"config-name\">(rhythm_sub_headerimageparallax1)</span>\";s:38:\"rhythm_sub_headerimageparallax1onepage\";s:109:\"Header: Image Parallax 1 - OnePage  <span class=\"config-name\">(rhythm_sub_headerimageparallax1onepage)</span>\";s:31:\"rhythm_sub_headerimageparallax2\";s:92:\"Header: Image Parallax 2  <span class=\"config-name\">(rhythm_sub_headerimageparallax2)</span>\";s:38:\"rhythm_sub_headerimageparallax2onepage\";s:109:\"Header: Image Parallax 2 - Onepage  <span class=\"config-name\">(rhythm_sub_headerimageparallax2onepage)</span>\";s:31:\"rhythm_sub_headerimageparallax3\";s:92:\"Header: Image Parallax 3  <span class=\"config-name\">(rhythm_sub_headerimageparallax3)</span>\";s:38:\"rhythm_sub_headerimageparallax3onepage\";s:109:\"Header: Image Parallax 3 - OnePage  <span class=\"config-name\">(rhythm_sub_headerimageparallax3onepage)</span>\";s:31:\"rhythm_sub_headerimageparallax4\";s:92:\"Header: Image Parallax 4  <span class=\"config-name\">(rhythm_sub_headerimageparallax4)</span>\";s:38:\"rhythm_sub_headerimageparallax4onepage\";s:109:\"Header: Image Parallax 4 - OnePage  <span class=\"config-name\">(rhythm_sub_headerimageparallax4onepage)</span>\";s:31:\"rhythm_sub_headerimageparallax5\";s:92:\"Header: Image Parallax 5  <span class=\"config-name\">(rhythm_sub_headerimageparallax5)</span>\";s:38:\"rhythm_sub_headerimageparallax5onepage\";s:109:\"Header: Image Parallax 5 - OnePage  <span class=\"config-name\">(rhythm_sub_headerimageparallax5onepage)</span>\";s:25:\"rhythm_sub_headermaindemo\";s:79:\"Header: Main Demo  <span class=\"config-name\">(rhythm_sub_headermaindemo)</span>\";s:32:\"rhythm_sub_headermaindemoonepage\";s:96:\"Header: Main Demo - OnePage  <span class=\"config-name\">(rhythm_sub_headermaindemoonepage)</span>\";s:34:\"rhythm_sub_headermaindemoonepage_2\";s:98:\"Header: Main Demo - OnePage  <span class=\"config-name\">(rhythm_sub_headermaindemoonepage_2)</span>\";s:33:\"rhythm_sub_headersliderbackground\";s:95:\"Header: Slider Background  <span class=\"config-name\">(rhythm_sub_headersliderbackground)</span>\";s:40:\"rhythm_sub_headersliderbackgroundonepage\";s:112:\"Header: Slider Background - OnePage  <span class=\"config-name\">(rhythm_sub_headersliderbackgroundonepage)</span>\";s:33:\"rhythm_sub_headersliderfullscreen\";s:95:\"Header: Slider Fullscreen  <span class=\"config-name\">(rhythm_sub_headersliderfullscreen)</span>\";s:40:\"rhythm_sub_headersliderfullscreenonepage\";s:112:\"Header: Slider Fullscreen - OnePage  <span class=\"config-name\">(rhythm_sub_headersliderfullscreenonepage)</span>\";s:32:\"rhythm_sub_headersliderfullwidth\";s:93:\"Header: Slider Fullwidth  <span class=\"config-name\">(rhythm_sub_headersliderfullwidth)</span>\";s:39:\"rhythm_sub_headersliderfullwidthonepage\";s:110:\"Header: Slider Fullwidth - OnePage  <span class=\"config-name\">(rhythm_sub_headersliderfullwidthonepage)</span>\";s:33:\"rhythm_sub_headersliderzoomeffect\";s:96:\"Header: Slider Zoom Effect  <span class=\"config-name\">(rhythm_sub_headersliderzoomeffect)</span>\";s:40:\"rhythm_sub_headersliderzoomeffectonepage\";s:113:\"Header: Slider Zoom Effect - OnePage  <span class=\"config-name\">(rhythm_sub_headersliderzoomeffectonepage)</span>\";s:35:\"rhythm_sub_headerspecialphotography\";s:99:\"Header: Special Photography  <span class=\"config-name\">(rhythm_sub_headerspecialphotography)</span>\";s:42:\"rhythm_sub_headerspecialphotographyonepage\";s:116:\"Header: Special Photography - OnePage  <span class=\"config-name\">(rhythm_sub_headerspecialphotographyonepage)</span>\";s:28:\"rhythm_sub_headertextrotator\";s:85:\"Header: Text Rotator  <span class=\"config-name\">(rhythm_sub_headertextrotator)</span>\";s:35:\"rhythm_sub_headertextrotatoronepage\";s:102:\"Header: Text Rotator - OnePage  <span class=\"config-name\">(rhythm_sub_headertextrotatoronepage)</span>\";s:22:\"rhythm_sub_headerwhite\";s:71:\"Header White  <span class=\"config-name\">(rhythm_sub_headerwhite)</span>\";s:33:\"rhythm_sub_headerwhitetransparent\";s:94:\"Header White Transparent  <span class=\"config-name\">(rhythm_sub_headerwhitetransparent)</span>\";s:31:\"rhythm_sub_headerwithplaybutton\";s:92:\"Header: With Play Button  <span class=\"config-name\">(rhythm_sub_headerwithplaybutton)</span>\";s:38:\"rhythm_sub_headerwithplaybuttononepage\";s:109:\"Header: With Play Button - OnePage  <span class=\"config-name\">(rhythm_sub_headerwithplaybuttononepage)</span>\";s:27:\"rhythm_sub_languageswitcher\";s:81:\"Language switcher  <span class=\"config-name\">(rhythm_sub_languageswitcher)</span>\";s:26:\"rhythm_sub_relatedprojects\";s:79:\"Related Projects  <span class=\"config-name\">(rhythm_sub_relatedprojects)</span>\";s:12:\"rhythm_tools\";s:54:\"Tools  <span class=\"config-name\">(rhythm_tools)</span>\";s:17:\"seven_breadcrumbs\";s:65:\"Breadcrumbs  <span class=\"config-name\">(seven_breadcrumbs)</span>\";s:13:\"seven_content\";s:67:\"Main page content  <span class=\"config-name\">(seven_content)</span>\";s:10:\"seven_help\";s:51:\"Help  <span class=\"config-name\">(seven_help)</span>\";s:19:\"seven_local_actions\";s:77:\"Primary admin actions  <span class=\"config-name\">(seven_local_actions)</span>\";s:11:\"seven_login\";s:58:\"User login  <span class=\"config-name\">(seven_login)</span>\";s:14:\"seven_messages\";s:66:\"Status messages  <span class=\"config-name\">(seven_messages)</span>\";s:16:\"seven_page_title\";s:63:\"Page title  <span class=\"config-name\">(seven_page_title)</span>\";s:25:\"seven_primary_local_tasks\";s:74:\"Primary tabs  <span class=\"config-name\">(seven_primary_local_tasks)</span>\";s:27:\"seven_secondary_local_tasks\";s:78:\"Secondary tabs  <span class=\"config-name\">(seven_secondary_local_tasks)</span>\";s:12:\"shop4columns\";s:63:\"Shop 4 Columns  <span class=\"config-name\">(shop4columns)</span>\";s:4:\"tabs\";s:45:\"Tabs  <span class=\"config-name\">(tabs)</span>\";s:10:\"textwidget\";s:58:\"Text Widget  <span class=\"config-name\">(textwidget)</span>\";s:40:\"views_block__products_best_sellers_block\";s:98:\"Products best sellers  <span class=\"config-name\">(views_block__products_best_sellers_block)</span>\";s:38:\"views_block__products_comments_block_1\";s:83:\"Comments  <span class=\"config-name\">(views_block__products_comments_block_1)</span>\";s:37:\"views_block__related_products_block_1\";s:90:\"Related Products  <span class=\"config-name\">(views_block__related_products_block_1)</span>\";s:16:\"wanttoworkwithus\";s:74:\"Want to work with us?  <span class=\"config-name\">(wanttoworkwithus)</span>\";}s:14:\"#default_value\";a:126:{s:4:\"cart\";s:0:\"\";s:6:\"footer\";s:0:\"\";s:11:\"gmapcontact\";s:0:\"\";s:14:\"gmapcontacttop\";s:0:\"\";s:18:\"headeragencyheader\";s:0:\"\";s:24:\"headerbgvideofullscreen1\";s:0:\"\";s:31:\"headerbgvideofullscreen1onepage\";s:0:\"\";s:24:\"headerbgvideofullscreen2\";s:0:\"\";s:31:\"headerbgvideofullscreen2onepage\";s:0:\"\";s:22:\"headerbgvideofullwidth\";s:0:\"\";s:29:\"headerbgvideofullwidthonepage\";s:0:\"\";s:14:\"headerdarkmain\";s:0:\"\";s:21:\"headerdarktransparent\";s:0:\"\";s:20:\"headerfullwidthimage\";s:0:\"\";s:27:\"headerfullwidthimageonepage\";s:0:\"\";s:20:\"headerimageparallax1\";s:0:\"\";s:27:\"headerimageparallax1onepage\";s:0:\"\";s:20:\"headerimageparallax2\";s:0:\"\";s:27:\"headerimageparallax2onepage\";s:0:\"\";s:20:\"headerimageparallax3\";s:0:\"\";s:27:\"headerimageparallax3onepage\";s:0:\"\";s:20:\"headerimageparallax4\";s:0:\"\";s:27:\"headerimageparallax4onepage\";s:0:\"\";s:20:\"headerimageparallax5\";s:0:\"\";s:27:\"headerimageparallax5onepage\";s:0:\"\";s:14:\"headermaindemo\";s:0:\"\";s:21:\"headermaindemoonepage\";s:0:\"\";s:23:\"headermaindemoonepage_2\";s:0:\"\";s:22:\"headersliderbackground\";s:0:\"\";s:29:\"headersliderbackgroundonepage\";s:0:\"\";s:22:\"headersliderfullscreen\";s:0:\"\";s:29:\"headersliderfullscreenonepage\";s:0:\"\";s:21:\"headersliderfullwidth\";s:0:\"\";s:28:\"headersliderfullwidthonepage\";s:0:\"\";s:22:\"headersliderzoomeffect\";s:0:\"\";s:29:\"headersliderzoomeffectonepage\";s:0:\"\";s:24:\"headerspecialphotography\";s:0:\"\";s:31:\"headerspecialphotographyonepage\";s:0:\"\";s:17:\"headertextrotator\";s:0:\"\";s:24:\"headertextrotatoronepage\";s:0:\"\";s:11:\"headerwhite\";s:0:\"\";s:22:\"headerwhitetransparent\";s:0:\"\";s:20:\"headerwithplaybutton\";s:0:\"\";s:27:\"headerwithplaybuttononepage\";s:0:\"\";s:16:\"languageswitcher\";s:0:\"\";s:15:\"relatedprojects\";s:0:\"\";s:20:\"rhythmproductsfilter\";s:0:\"\";s:21:\"rhythmprojectnextprev\";s:0:\"\";s:19:\"rhythm_account_menu\";s:0:\"\";s:15:\"rhythm_branding\";s:0:\"\";s:18:\"rhythm_breadcrumbs\";s:0:\"\";s:14:\"rhythm_content\";s:0:\"\";s:13:\"rhythm_footer\";s:0:\"\";s:11:\"rhythm_help\";s:0:\"\";s:20:\"rhythm_local_actions\";s:0:\"\";s:18:\"rhythm_local_tasks\";s:0:\"\";s:16:\"rhythm_main_menu\";s:0:\"\";s:15:\"rhythm_messages\";s:0:\"\";s:17:\"rhythm_page_title\";s:0:\"\";s:14:\"rhythm_powered\";s:0:\"\";s:13:\"rhythm_search\";s:0:\"\";s:23:\"rhythm_sub_account_menu\";s:0:\"\";s:19:\"rhythm_sub_branding\";s:0:\"\";s:18:\"rhythm_sub_content\";s:0:\"\";s:17:\"rhythm_sub_footer\";s:0:\"\";s:22:\"rhythm_sub_gmapcontact\";s:0:\"\";s:25:\"rhythm_sub_gmapcontacttop\";s:0:\"\";s:29:\"rhythm_sub_headeragencyheader\";s:0:\"\";s:35:\"rhythm_sub_headerbgvideofullscreen1\";s:0:\"\";s:42:\"rhythm_sub_headerbgvideofullscreen1onepage\";s:0:\"\";s:35:\"rhythm_sub_headerbgvideofullscreen2\";s:0:\"\";s:42:\"rhythm_sub_headerbgvideofullscreen2onepage\";s:0:\"\";s:33:\"rhythm_sub_headerbgvideofullwidth\";s:0:\"\";s:40:\"rhythm_sub_headerbgvideofullwidthonepage\";s:0:\"\";s:25:\"rhythm_sub_headerdarkmain\";s:0:\"\";s:32:\"rhythm_sub_headerdarktransparent\";s:0:\"\";s:31:\"rhythm_sub_headerfullwidthimage\";s:0:\"\";s:38:\"rhythm_sub_headerfullwidthimageonepage\";s:0:\"\";s:31:\"rhythm_sub_headerimageparallax1\";s:0:\"\";s:38:\"rhythm_sub_headerimageparallax1onepage\";s:0:\"\";s:31:\"rhythm_sub_headerimageparallax2\";s:0:\"\";s:38:\"rhythm_sub_headerimageparallax2onepage\";s:0:\"\";s:31:\"rhythm_sub_headerimageparallax3\";s:0:\"\";s:38:\"rhythm_sub_headerimageparallax3onepage\";s:0:\"\";s:31:\"rhythm_sub_headerimageparallax4\";s:0:\"\";s:38:\"rhythm_sub_headerimageparallax4onepage\";s:0:\"\";s:31:\"rhythm_sub_headerimageparallax5\";s:0:\"\";s:38:\"rhythm_sub_headerimageparallax5onepage\";s:0:\"\";s:25:\"rhythm_sub_headermaindemo\";s:0:\"\";s:32:\"rhythm_sub_headermaindemoonepage\";s:0:\"\";s:34:\"rhythm_sub_headermaindemoonepage_2\";s:0:\"\";s:33:\"rhythm_sub_headersliderbackground\";s:0:\"\";s:40:\"rhythm_sub_headersliderbackgroundonepage\";s:0:\"\";s:33:\"rhythm_sub_headersliderfullscreen\";s:0:\"\";s:40:\"rhythm_sub_headersliderfullscreenonepage\";s:0:\"\";s:32:\"rhythm_sub_headersliderfullwidth\";s:0:\"\";s:39:\"rhythm_sub_headersliderfullwidthonepage\";s:0:\"\";s:33:\"rhythm_sub_headersliderzoomeffect\";s:0:\"\";s:40:\"rhythm_sub_headersliderzoomeffectonepage\";s:0:\"\";s:35:\"rhythm_sub_headerspecialphotography\";s:0:\"\";s:42:\"rhythm_sub_headerspecialphotographyonepage\";s:0:\"\";s:28:\"rhythm_sub_headertextrotator\";s:0:\"\";s:35:\"rhythm_sub_headertextrotatoronepage\";s:0:\"\";s:22:\"rhythm_sub_headerwhite\";s:0:\"\";s:33:\"rhythm_sub_headerwhitetransparent\";s:0:\"\";s:31:\"rhythm_sub_headerwithplaybutton\";s:0:\"\";s:38:\"rhythm_sub_headerwithplaybuttononepage\";s:0:\"\";s:27:\"rhythm_sub_languageswitcher\";s:0:\"\";s:26:\"rhythm_sub_relatedprojects\";s:0:\"\";s:12:\"rhythm_tools\";s:0:\"\";s:17:\"seven_breadcrumbs\";s:0:\"\";s:13:\"seven_content\";s:0:\"\";s:10:\"seven_help\";s:0:\"\";s:19:\"seven_local_actions\";s:0:\"\";s:11:\"seven_login\";s:0:\"\";s:14:\"seven_messages\";s:0:\"\";s:16:\"seven_page_title\";s:0:\"\";s:25:\"seven_primary_local_tasks\";s:0:\"\";s:27:\"seven_secondary_local_tasks\";s:0:\"\";s:12:\"shop4columns\";s:0:\"\";s:4:\"tabs\";s:0:\"\";s:10:\"textwidget\";s:0:\"\";s:40:\"views_block__products_best_sellers_block\";s:0:\"\";s:38:\"views_block__products_comments_block_1\";s:0:\"\";s:37:\"views_block__related_products_block_1\";s:0:\"\";s:16:\"wanttoworkwithus\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:50:\"<div class=\'component-list features-export-list \'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:1:{s:37:\"views_block__related_projects_block_1\";s:90:\"Related Projects  <span class=\"config-name\">(views_block__related_projects_block_1)</span>\";}s:14:\"#default_value\";a:1:{s:37:\"views_block__related_projects_block_1\";s:37:\"views_block__related_projects_block_1\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:22:\"commerce_checkout_flow\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Checkout flow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:69:\"<div class=\'features-export-parent component-commerce_checkout_flow\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:35:\"edit-sources-commerce-checkout-flow\";s:8:\"#options\";a:1:{s:7:\"default\";s:51:\"Default  <span class=\"config-name\">(default)</span>\";}s:14:\"#default_value\";a:1:{s:7:\"default\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:12:\"comment_type\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:59:\"<div class=\'features-export-parent component-comment_type\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:25:\"edit-sources-comment-type\";s:8:\"#options\";a:2:{s:7:\"comment\";s:60:\"Default comments  <span class=\"config-name\">(comment)</span>\";s:15:\"default_reviews\";s:67:\"Default reviews  <span class=\"config-name\">(default_reviews)</span>\";}s:14:\"#default_value\";a:2:{s:7:\"comment\";s:0:\"\";s:15:\"default_reviews\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:12:\"contact_form\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:59:\"<div class=\'features-export-parent component-contact_form\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:25:\"edit-sources-contact-form\";s:8:\"#options\";a:2:{s:8:\"feedback\";s:61:\"Website feedback  <span class=\"config-name\">(feedback)</span>\";s:8:\"personal\";s:66:\"Personal contact form  <span class=\"config-name\">(personal)</span>\";}s:14:\"#default_value\";a:2:{s:8:\"feedback\";s:0:\"\";s:8:\"personal\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:25:\"language_content_settings\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Content Language Settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:3;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:72:\"<div class=\'features-export-parent component-language_content_settings\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:38:\"edit-sources-language-content-settings\";s:8:\"#options\";a:3:{s:32:\"commerce_product.product_display\";s:32:\"commerce_product.product_display\";s:34:\"commerce_product_variation.product\";s:34:\"commerce_product_variation.product\";s:12:\"node.webform\";s:12:\"node.webform\";}s:14:\"#default_value\";a:3:{s:32:\"commerce_product.product_display\";s:0:\"\";s:34:\"commerce_product_variation.product\";s:0:\"\";s:12:\"node.webform\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:9:\"node_type\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:56:\"<div class=\'features-export-parent component-node_type\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:22:\"edit-sources-node-type\";s:8:\"#options\";a:2:{s:7:\"article\";s:51:\"Article  <span class=\"config-name\">(article)</span>\";s:7:\"webform\";s:51:\"Webform  <span class=\"config-name\">(webform)</span>\";}s:14:\"#default_value\";a:2:{s:7:\"article\";s:0:\"\";s:7:\"webform\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:17:\"commerce_currency\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Currency\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:64:\"<div class=\'features-export-parent component-commerce_currency\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:30:\"edit-sources-commerce-currency\";s:8:\"#options\";a:1:{s:3:\"USD\";s:49:\"US Dollar  <span class=\"config-name\">(USD)</span>\";}s:14:\"#default_value\";a:1:{s:3:\"USD\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:11:\"date_format\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Date format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:11;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:58:\"<div class=\'features-export-parent component-date_format\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:24:\"edit-sources-date-format\";s:8:\"#options\";a:11:{s:8:\"fallback\";s:65:\"Fallback date format  <span class=\"config-name\">(fallback)</span>\";s:9:\"html_date\";s:55:\"HTML Date  <span class=\"config-name\">(html_date)</span>\";s:13:\"html_datetime\";s:63:\"HTML Datetime  <span class=\"config-name\">(html_datetime)</span>\";s:10:\"html_month\";s:57:\"HTML Month  <span class=\"config-name\">(html_month)</span>\";s:9:\"html_time\";s:55:\"HTML Time  <span class=\"config-name\">(html_time)</span>\";s:9:\"html_week\";s:55:\"HTML Week  <span class=\"config-name\">(html_week)</span>\";s:9:\"html_year\";s:55:\"HTML Year  <span class=\"config-name\">(html_year)</span>\";s:18:\"html_yearless_date\";s:73:\"HTML Yearless date  <span class=\"config-name\">(html_yearless_date)</span>\";s:4:\"long\";s:58:\"Default long date  <span class=\"config-name\">(long)</span>\";s:6:\"medium\";s:62:\"Default medium date  <span class=\"config-name\">(medium)</span>\";s:5:\"short\";s:60:\"Default short date  <span class=\"config-name\">(short)</span>\";}s:14:\"#default_value\";a:11:{s:8:\"fallback\";s:0:\"\";s:9:\"html_date\";s:0:\"\";s:13:\"html_datetime\";s:0:\"\";s:10:\"html_month\";s:0:\"\";s:9:\"html_time\";s:0:\"\";s:9:\"html_week\";s:0:\"\";s:9:\"html_year\";s:0:\"\";s:18:\"html_yearless_date\";s:0:\"\";s:4:\"long\";s:0:\"\";s:6:\"medium\";s:0:\"\";s:5:\"short\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:12:\"embed_button\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Embed button\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:59:\"<div class=\'features-export-parent component-embed_button\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:25:\"edit-sources-embed-button\";s:8:\"#options\";a:2:{s:12:\"file_browser\";s:61:\"File Browser  <span class=\"config-name\">(file_browser)</span>\";s:4:\"node\";s:45:\"Node  <span class=\"config-name\">(node)</span>\";}s:14:\"#default_value\";a:2:{s:12:\"file_browser\";s:0:\"\";s:4:\"node\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:14:\"entity_browser\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:61:\"<div class=\'features-export-parent component-entity_browser\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:27:\"edit-sources-entity-browser\";s:8:\"#options\";a:2:{s:12:\"browse_files\";s:66:\"Browser for files  <span class=\"config-name\">(browse_files)</span>\";s:18:\"browse_files_modal\";s:80:\"Browser for files (modal)  <span class=\"config-name\">(browse_files_modal)</span>\";}s:14:\"#default_value\";a:2:{s:12:\"browse_files\";s:0:\"\";s:18:\"browse_files_modal\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:19:\"entity_form_display\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:10;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:66:\"<div class=\'features-export-parent component-entity_form_display\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:32:\"edit-sources-entity-form-display\";s:8:\"#options\";a:10:{s:31:\"comment.default_reviews.default\";s:31:\"comment.default_reviews.default\";s:30:\"commerce_order.default.default\";s:30:\"commerce_order.default.default\";s:39:\"commerce_order_item.default.add_to_cart\";s:39:\"commerce_order_item.default.add_to_cart\";s:35:\"commerce_order_item.default.default\";s:35:\"commerce_order_item.default.default\";s:47:\"commerce_order_item.default.variation_cart_form\";s:47:\"commerce_order_item.default.variation_cart_form\";s:32:\"commerce_product.default.default\";s:32:\"commerce_product.default.default\";s:40:\"commerce_product.product_display.default\";s:40:\"commerce_product.product_display.default\";s:42:\"commerce_product_variation.default.default\";s:42:\"commerce_product_variation.default.default\";s:42:\"commerce_product_variation.product.default\";s:42:\"commerce_product_variation.product.default\";s:24:\"profile.customer.default\";s:24:\"profile.customer.default\";}s:14:\"#default_value\";a:10:{s:31:\"comment.default_reviews.default\";s:0:\"\";s:30:\"commerce_order.default.default\";s:0:\"\";s:39:\"commerce_order_item.default.add_to_cart\";s:0:\"\";s:35:\"commerce_order_item.default.default\";s:0:\"\";s:47:\"commerce_order_item.default.variation_cart_form\";s:0:\"\";s:32:\"commerce_product.default.default\";s:0:\"\";s:40:\"commerce_product.product_display.default\";s:0:\"\";s:42:\"commerce_product_variation.default.default\";s:0:\"\";s:42:\"commerce_product_variation.product.default\";s:0:\"\";s:24:\"profile.customer.default\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:19:\"entity_view_display\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity view display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:14;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:66:\"<div class=\'features-export-parent component-entity_view_display\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:32:\"edit-sources-entity-view-display\";s:8:\"#options\";a:14:{s:31:\"comment.default_reviews.default\";s:31:\"comment.default_reviews.default\";s:30:\"commerce_order.default.default\";s:30:\"commerce_order.default.default\";s:27:\"commerce_order.default.user\";s:27:\"commerce_order.default.user\";s:35:\"commerce_order_item.default.default\";s:35:\"commerce_order_item.default.default\";s:32:\"commerce_product.default.default\";s:32:\"commerce_product.default.default\";s:40:\"commerce_product.product_display.default\";s:40:\"commerce_product.product_display.default\";s:39:\"commerce_product.product_display.teaser\";s:39:\"commerce_product.product_display.teaser\";s:39:\"commerce_product_variation.default.cart\";s:39:\"commerce_product_variation.default.cart\";s:42:\"commerce_product_variation.default.summary\";s:42:\"commerce_product_variation.default.summary\";s:39:\"commerce_product_variation.product.cart\";s:39:\"commerce_product_variation.product.cart\";s:42:\"commerce_product_variation.product.default\";s:42:\"commerce_product_variation.product.default\";s:42:\"commerce_product_variation.product.product\";s:42:\"commerce_product_variation.product.product\";s:29:\"commerce_store.online.default\";s:29:\"commerce_store.online.default\";s:24:\"profile.customer.default\";s:24:\"profile.customer.default\";}s:14:\"#default_value\";a:14:{s:31:\"comment.default_reviews.default\";s:0:\"\";s:30:\"commerce_order.default.default\";s:0:\"\";s:27:\"commerce_order.default.user\";s:0:\"\";s:35:\"commerce_order_item.default.default\";s:0:\"\";s:32:\"commerce_product.default.default\";s:0:\"\";s:40:\"commerce_product.product_display.default\";s:0:\"\";s:39:\"commerce_product.product_display.teaser\";s:0:\"\";s:39:\"commerce_product_variation.default.cart\";s:0:\"\";s:42:\"commerce_product_variation.default.summary\";s:0:\"\";s:39:\"commerce_product_variation.product.cart\";s:0:\"\";s:42:\"commerce_product_variation.product.default\";s:0:\"\";s:42:\"commerce_product_variation.product.product\";s:0:\"\";s:29:\"commerce_store.online.default\";s:0:\"\";s:24:\"profile.customer.default\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:15:\"features_bundle\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Features bundle\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:3;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:62:\"<div class=\'features-export-parent component-features_bundle\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:28:\"edit-sources-features-bundle\";s:8:\"#options\";a:3:{s:7:\"default\";s:51:\"Default  <span class=\"config-name\">(default)</span>\";s:8:\"nikadevs\";s:53:\"NikaDevs  <span class=\"config-name\">(nikadevs)</span>\";s:6:\"rhythm\";s:49:\"Rhythm  <span class=\"config-name\">(rhythm)</span>\";}s:14:\"#default_value\";a:3:{s:7:\"default\";s:0:\"\";s:8:\"nikadevs\";s:0:\"\";s:6:\"rhythm\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:12:\"field_config\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:26;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:59:\"<div class=\'features-export-parent component-field_config\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:25:\"edit-sources-field-config\";s:8:\"#options\";a:26:{s:37:\"comment.default_reviews.field_comment\";s:81:\"Comment  <span class=\"config-name\">(comment.default_reviews.field_comment)</span>\";s:35:\"comment.default_reviews.field_email\";s:77:\"Email  <span class=\"config-name\">(comment.default_reviews.field_email)</span>\";s:36:\"comment.default_reviews.field_rating\";s:79:\"Rating  <span class=\"config-name\">(comment.default_reviews.field_rating)</span>\";s:34:\"commerce_order.default.order_items\";s:82:\"Order items  <span class=\"config-name\">(commerce_order.default.order_items)</span>\";s:29:\"commerce_product.default.body\";s:70:\"Body  <span class=\"config-name\">(commerce_product.default.body)</span>\";s:31:\"commerce_product.default.stores\";s:74:\"Stores  <span class=\"config-name\">(commerce_product.default.stores)</span>\";s:35:\"commerce_product.default.variations\";s:82:\"Variations  <span class=\"config-name\">(commerce_product.default.variations)</span>\";s:47:\"commerce_product.product_display.field_category\";s:92:\"Category  <span class=\"config-name\">(commerce_product.product_display.field_category)</span>\";s:45:\"commerce_product.product_display.field_rating\";s:88:\"Rating  <span class=\"config-name\">(commerce_product.product_display.field_rating)</span>\";s:46:\"commerce_product.product_display.field_reviews\";s:90:\"Reviews  <span class=\"config-name\">(commerce_product.product_display.field_reviews)</span>\";s:43:\"commerce_product.product_display.field_tags\";s:84:\"Tags  <span class=\"config-name\">(commerce_product.product_display.field_tags)</span>\";s:39:\"commerce_product.product_display.stores\";s:82:\"Stores  <span class=\"config-name\">(commerce_product.product_display.stores)</span>\";s:43:\"commerce_product.product_display.variations\";s:90:\"Variations  <span class=\"config-name\">(commerce_product.product_display.variations)</span>\";s:50:\"commerce_product_variation.product.attribute_color\";s:92:\"Color  <span class=\"config-name\">(commerce_product_variation.product.attribute_color)</span>\";s:49:\"commerce_product_variation.product.attribute_size\";s:90:\"Size  <span class=\"config-name\">(commerce_product_variation.product.attribute_size)</span>\";s:52:\"commerce_product_variation.product.field_description\";s:100:\"Description  <span class=\"config-name\">(commerce_product_variation.product.field_description)</span>\";s:47:\"commerce_product_variation.product.field_images\";s:90:\"Images  <span class=\"config-name\">(commerce_product_variation.product.field_images)</span>\";s:47:\"commerce_product_variation.product.field_length\";s:90:\"Length  <span class=\"config-name\">(commerce_product_variation.product.field_length)</span>\";s:50:\"commerce_product_variation.product.field_old_price\";s:96:\"Old Price  <span class=\"config-name\">(commerce_product_variation.product.field_old_price)</span>\";s:63:\"commerce_product_variation.product.field_right_side_description\";s:122:\"Right Side Description  <span class=\"config-name\">(commerce_product_variation.product.field_right_side_description)</span>\";s:50:\"commerce_product_variation.product.field_sale_text\";s:96:\"Sale text  <span class=\"config-name\">(commerce_product_variation.product.field_sale_text)</span>\";s:58:\"commerce_product_variation.product.field_short_description\";s:112:\"Short Description  <span class=\"config-name\">(commerce_product_variation.product.field_short_description)</span>\";s:46:\"commerce_product_variation.product.field_waist\";s:88:\"Waist  <span class=\"config-name\">(commerce_product_variation.product.field_waist)</span>\";s:20:\"node.webform.webform\";s:61:\"Form  <span class=\"config-name\">(node.webform.webform)</span>\";s:24:\"profile.customer.address\";s:68:\"Address  <span class=\"config-name\">(profile.customer.address)</span>\";s:28:\"user.user.commerce_remote_id\";s:74:\"Remote ID  <span class=\"config-name\">(user.user.commerce_remote_id)</span>\";}s:14:\"#default_value\";a:26:{s:37:\"comment.default_reviews.field_comment\";s:0:\"\";s:35:\"comment.default_reviews.field_email\";s:0:\"\";s:36:\"comment.default_reviews.field_rating\";s:0:\"\";s:34:\"commerce_order.default.order_items\";s:0:\"\";s:29:\"commerce_product.default.body\";s:0:\"\";s:31:\"commerce_product.default.stores\";s:0:\"\";s:35:\"commerce_product.default.variations\";s:0:\"\";s:47:\"commerce_product.product_display.field_category\";s:0:\"\";s:45:\"commerce_product.product_display.field_rating\";s:0:\"\";s:46:\"commerce_product.product_display.field_reviews\";s:0:\"\";s:43:\"commerce_product.product_display.field_tags\";s:0:\"\";s:39:\"commerce_product.product_display.stores\";s:0:\"\";s:43:\"commerce_product.product_display.variations\";s:0:\"\";s:50:\"commerce_product_variation.product.attribute_color\";s:0:\"\";s:49:\"commerce_product_variation.product.attribute_size\";s:0:\"\";s:52:\"commerce_product_variation.product.field_description\";s:0:\"\";s:47:\"commerce_product_variation.product.field_images\";s:0:\"\";s:47:\"commerce_product_variation.product.field_length\";s:0:\"\";s:50:\"commerce_product_variation.product.field_old_price\";s:0:\"\";s:63:\"commerce_product_variation.product.field_right_side_description\";s:0:\"\";s:50:\"commerce_product_variation.product.field_sale_text\";s:0:\"\";s:58:\"commerce_product_variation.product.field_short_description\";s:0:\"\";s:46:\"commerce_product_variation.product.field_waist\";s:0:\"\";s:20:\"node.webform.webform\";s:0:\"\";s:24:\"profile.customer.address\";s:0:\"\";s:28:\"user.user.commerce_remote_id\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:20:\"field_storage_config\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Field storage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:22;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:67:\"<div class=\'features-export-parent component-field_storage_config\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:33:\"edit-sources-field-storage-config\";s:8:\"#options\";a:22:{s:20:\"comment.field_rating\";s:20:\"comment.field_rating\";s:26:\"commerce_order.order_items\";s:26:\"commerce_order.order_items\";s:21:\"commerce_product.body\";s:21:\"commerce_product.body\";s:31:\"commerce_product.field_category\";s:31:\"commerce_product.field_category\";s:29:\"commerce_product.field_rating\";s:29:\"commerce_product.field_rating\";s:30:\"commerce_product.field_reviews\";s:30:\"commerce_product.field_reviews\";s:27:\"commerce_product.field_tags\";s:27:\"commerce_product.field_tags\";s:23:\"commerce_product.stores\";s:23:\"commerce_product.stores\";s:27:\"commerce_product.variations\";s:27:\"commerce_product.variations\";s:42:\"commerce_product_variation.attribute_color\";s:42:\"commerce_product_variation.attribute_color\";s:41:\"commerce_product_variation.attribute_size\";s:41:\"commerce_product_variation.attribute_size\";s:44:\"commerce_product_variation.field_description\";s:44:\"commerce_product_variation.field_description\";s:39:\"commerce_product_variation.field_images\";s:39:\"commerce_product_variation.field_images\";s:39:\"commerce_product_variation.field_length\";s:39:\"commerce_product_variation.field_length\";s:42:\"commerce_product_variation.field_old_price\";s:42:\"commerce_product_variation.field_old_price\";s:55:\"commerce_product_variation.field_right_side_description\";s:55:\"commerce_product_variation.field_right_side_description\";s:42:\"commerce_product_variation.field_sale_text\";s:42:\"commerce_product_variation.field_sale_text\";s:50:\"commerce_product_variation.field_short_description\";s:50:\"commerce_product_variation.field_short_description\";s:38:\"commerce_product_variation.field_waist\";s:38:\"commerce_product_variation.field_waist\";s:12:\"node.webform\";s:12:\"node.webform\";s:15:\"profile.address\";s:15:\"profile.address\";s:23:\"user.commerce_remote_id\";s:23:\"user.commerce_remote_id\";}s:14:\"#default_value\";a:22:{s:20:\"comment.field_rating\";s:0:\"\";s:26:\"commerce_order.order_items\";s:0:\"\";s:21:\"commerce_product.body\";s:0:\"\";s:31:\"commerce_product.field_category\";s:0:\"\";s:29:\"commerce_product.field_rating\";s:0:\"\";s:30:\"commerce_product.field_reviews\";s:0:\"\";s:27:\"commerce_product.field_tags\";s:0:\"\";s:23:\"commerce_product.stores\";s:0:\"\";s:27:\"commerce_product.variations\";s:0:\"\";s:42:\"commerce_product_variation.attribute_color\";s:0:\"\";s:41:\"commerce_product_variation.attribute_size\";s:0:\"\";s:44:\"commerce_product_variation.field_description\";s:0:\"\";s:39:\"commerce_product_variation.field_images\";s:0:\"\";s:39:\"commerce_product_variation.field_length\";s:0:\"\";s:42:\"commerce_product_variation.field_old_price\";s:0:\"\";s:55:\"commerce_product_variation.field_right_side_description\";s:0:\"\";s:42:\"commerce_product_variation.field_sale_text\";s:0:\"\";s:50:\"commerce_product_variation.field_short_description\";s:0:\"\";s:38:\"commerce_product_variation.field_waist\";s:0:\"\";s:12:\"node.webform\";s:0:\"\";s:15:\"profile.address\";s:0:\"\";s:23:\"user.commerce_remote_id\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:16:\"entity_form_mode\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:3;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:63:\"<div class=\'features-export-parent component-entity_form_mode\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:29:\"edit-sources-entity-form-mode\";s:8:\"#options\";a:3:{s:31:\"commerce_order_item.add_to_cart\";s:79:\"Add to cart  <span class=\"config-name\">(commerce_order_item.add_to_cart)</span>\";s:39:\"commerce_order_item.variation_cart_form\";s:95:\"Variation cart form  <span class=\"config-name\">(commerce_order_item.variation_cart_form)</span>\";s:13:\"user.register\";s:58:\"Register  <span class=\"config-name\">(user.register)</span>\";}s:14:\"#default_value\";a:3:{s:31:\"commerce_order_item.add_to_cart\";s:0:\"\";s:39:\"commerce_order_item.variation_cart_form\";s:0:\"\";s:13:\"user.register\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:11:\"image_style\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:11;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:58:\"<div class=\'features-export-parent component-image_style\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:24:\"edit-sources-image-style\";s:8:\"#options\";a:11:{s:25:\"file_entity_browser_small\";s:97:\"File Entity Browser small thumbnail  <span class=\"config-name\">(file_entity_browser_small)</span>\";s:29:\"file_entity_browser_thumbnail\";s:95:\"File Entity Browser thumbnail  <span class=\"config-name\">(file_entity_browser_thumbnail)</span>\";s:5:\"large\";s:58:\"Large (480×480)  <span class=\"config-name\">(large)</span>\";s:15:\"md_slider_thumb\";s:67:\"MD Slider Thumb  <span class=\"config-name\">(md_slider_thumb)</span>\";s:6:\"medium\";s:60:\"Medium (220×220)  <span class=\"config-name\">(medium)</span>\";s:15:\"product_263x335\";s:69:\"Product (263x335)  <span class=\"config-name\">(product_263x335)</span>\";s:13:\"product_70x70\";s:65:\"Product (70x70)  <span class=\"config-name\">(product_70x70)</span>\";s:20:\"product_main_360x459\";s:79:\"Product Main (360x459)  <span class=\"config-name\">(product_main_360x459)</span>\";s:19:\"product_small_68x86\";s:77:\"Product Small (68x86)  <span class=\"config-name\">(product_small_68x86)</span>\";s:12:\"slider_pager\";s:61:\"Slider Pager  <span class=\"config-name\">(slider_pager)</span>\";s:9:\"thumbnail\";s:66:\"Thumbnail (100×100)  <span class=\"config-name\">(thumbnail)</span>\";}s:14:\"#default_value\";a:11:{s:25:\"file_entity_browser_small\";s:0:\"\";s:29:\"file_entity_browser_thumbnail\";s:0:\"\";s:5:\"large\";s:0:\"\";s:15:\"md_slider_thumb\";s:0:\"\";s:6:\"medium\";s:0:\"\";s:15:\"product_263x335\";s:0:\"\";s:13:\"product_70x70\";s:0:\"\";s:20:\"product_main_360x459\";s:0:\"\";s:19:\"product_small_68x86\";s:0:\"\";s:12:\"slider_pager\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:21:\"configurable_language\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:5;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:68:\"<div class=\'features-export-parent component-configurable_language\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:34:\"edit-sources-configurable-language\";s:8:\"#options\";a:5:{s:2:\"de\";s:45:\"German  <span class=\"config-name\">(de)</span>\";s:2:\"en\";s:46:\"English  <span class=\"config-name\">(en)</span>\";s:2:\"fr\";s:45:\"French  <span class=\"config-name\">(fr)</span>\";s:3:\"und\";s:53:\"Not specified  <span class=\"config-name\">(und)</span>\";s:3:\"zxx\";s:54:\"Not applicable  <span class=\"config-name\">(zxx)</span>\";}s:14:\"#default_value\";a:5:{s:2:\"de\";s:0:\"\";s:2:\"en\";s:0:\"\";s:2:\"fr\";s:0:\"\";s:3:\"und\";s:0:\"\";s:3:\"zxx\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:4:\"menu\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:6;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:51:\"<div class=\'features-export-parent component-menu\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:17:\"edit-sources-menu\";s:8:\"#options\";a:6:{s:7:\"account\";s:61:\"User account menu  <span class=\"config-name\">(account)</span>\";s:5:\"admin\";s:56:\"Administration  <span class=\"config-name\">(admin)</span>\";s:5:\"devel\";s:53:\"Development  <span class=\"config-name\">(devel)</span>\";s:6:\"footer\";s:49:\"Footer  <span class=\"config-name\">(footer)</span>\";s:4:\"main\";s:56:\"Main navigation  <span class=\"config-name\">(main)</span>\";s:5:\"tools\";s:47:\"Tools  <span class=\"config-name\">(tools)</span>\";}s:14:\"#default_value\";a:6:{s:7:\"account\";s:0:\"\";s:5:\"admin\";s:0:\"\";s:5:\"devel\";s:0:\"\";s:6:\"footer\";s:0:\"\";s:4:\"main\";s:0:\"\";s:5:\"tools\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:24:\"commerce_order_item_type\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Order item type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:71:\"<div class=\'features-export-parent component-commerce_order_item_type\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:37:\"edit-sources-commerce-order-item-type\";s:8:\"#options\";a:1:{s:7:\"default\";s:51:\"Default  <span class=\"config-name\">(default)</span>\";}s:14:\"#default_value\";a:1:{s:7:\"default\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:19:\"commerce_order_type\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Order type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:66:\"<div class=\'features-export-parent component-commerce_order_type\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:32:\"edit-sources-commerce-order-type\";s:8:\"#options\";a:1:{s:7:\"default\";s:51:\"Default  <span class=\"config-name\">(default)</span>\";}s:14:\"#default_value\";a:1:{s:7:\"default\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:16:\"pathauto_pattern\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Pathauto pattern\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:63:\"<div class=\'features-export-parent component-pathauto_pattern\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:29:\"edit-sources-pathauto-pattern\";s:8:\"#options\";a:2:{s:7:\"content\";s:51:\"Content  <span class=\"config-name\">(content)</span>\";s:15:\"product_display\";s:67:\"Product Display  <span class=\"config-name\">(product_display)</span>\";}s:14:\"#default_value\";a:2:{s:7:\"content\";s:0:\"\";s:15:\"product_display\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:24:\"commerce_payment_gateway\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment gateway\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:71:\"<div class=\'features-export-parent component-commerce_payment_gateway\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:37:\"edit-sources-commerce-payment-gateway\";s:8:\"#options\";a:1:{s:23:\"payment_gateway_example\";s:83:\"Payment gateway Example  <span class=\"config-name\">(payment_gateway_example)</span>\";}s:14:\"#default_value\";a:1:{s:23:\"payment_gateway_example\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:26:\"commerce_product_attribute\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Product attribute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:73:\"<div class=\'features-export-parent component-commerce_product_attribute\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:39:\"edit-sources-commerce-product-attribute\";s:8:\"#options\";a:2:{s:5:\"color\";s:47:\"Color  <span class=\"config-name\">(color)</span>\";s:4:\"size\";s:45:\"Size  <span class=\"config-name\">(size)</span>\";}s:14:\"#default_value\";a:2:{s:5:\"color\";s:0:\"\";s:4:\"size\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:21:\"commerce_product_type\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Product type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:68:\"<div class=\'features-export-parent component-commerce_product_type\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:34:\"edit-sources-commerce-product-type\";s:8:\"#options\";a:2:{s:7:\"default\";s:51:\"Default  <span class=\"config-name\">(default)</span>\";s:15:\"product_display\";s:67:\"Product Display  <span class=\"config-name\">(product_display)</span>\";}s:14:\"#default_value\";a:2:{s:7:\"default\";s:0:\"\";s:15:\"product_display\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:31:\"commerce_product_variation_type\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Product variation type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:78:\"<div class=\'features-export-parent component-commerce_product_variation_type\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:44:\"edit-sources-commerce-product-variation-type\";s:8:\"#options\";a:2:{s:7:\"default\";s:51:\"Default  <span class=\"config-name\">(default)</span>\";s:7:\"product\";s:51:\"Product  <span class=\"config-name\">(product)</span>\";}s:14:\"#default_value\";a:2:{s:7:\"default\";s:0:\"\";s:7:\"product\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:12:\"profile_type\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Profile type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:59:\"<div class=\'features-export-parent component-profile_type\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:25:\"edit-sources-profile-type\";s:8:\"#options\";a:1:{s:8:\"customer\";s:53:\"Customer  <span class=\"config-name\">(customer)</span>\";}s:14:\"#default_value\";a:1:{s:8:\"customer\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:9:\"user_role\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:3;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:56:\"<div class=\'features-export-parent component-user_role\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:22:\"edit-sources-user-role\";s:8:\"#options\";a:3:{s:9:\"anonymous\";s:60:\"Anonymous user  <span class=\"config-name\">(anonymous)</span>\";s:13:\"authenticated\";s:68:\"Authenticated user  <span class=\"config-name\">(authenticated)</span>\";s:13:\"administrator\";s:63:\"Administrator  <span class=\"config-name\">(administrator)</span>\";}s:14:\"#default_value\";a:3:{s:9:\"anonymous\";s:0:\"\";s:13:\"authenticated\";s:0:\"\";s:13:\"administrator\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:11:\"search_page\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Search page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:2;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:58:\"<div class=\'features-export-parent component-search_page\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:24:\"edit-sources-search-page\";s:8:\"#options\";a:2:{s:11:\"node_search\";s:55:\"Content  <span class=\"config-name\">(node_search)</span>\";s:11:\"user_search\";s:53:\"Users  <span class=\"config-name\">(user_search)</span>\";}s:14:\"#default_value\";a:2:{s:11:\"node_search\";s:0:\"\";s:11:\"user_search\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:12:\"shortcut_set\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:59:\"<div class=\'features-export-parent component-shortcut_set\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:25:\"edit-sources-shortcut-set\";s:8:\"#options\";a:1:{s:7:\"default\";s:51:\"Default  <span class=\"config-name\">(default)</span>\";}s:14:\"#default_value\";a:1:{s:7:\"default\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:19:\"commerce_store_type\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Store type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:66:\"<div class=\'features-export-parent component-commerce_store_type\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:32:\"edit-sources-commerce-store-type\";s:8:\"#options\";a:1:{s:6:\"online\";s:49:\"Online  <span class=\"config-name\">(online)</span>\";}s:14:\"#default_value\";a:1:{s:6:\"online\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:13:\"filter_format\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:3;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:60:\"<div class=\'features-export-parent component-filter_format\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:26:\"edit-sources-filter-format\";s:8:\"#options\";a:3:{s:18:\"dynamic_shortcodes\";s:73:\"Dynamic Shortcodes  <span class=\"config-name\">(dynamic_shortcodes)</span>\";s:10:\"plain_text\";s:57:\"Plain text  <span class=\"config-name\">(plain_text)</span>\";s:15:\"restricted_html\";s:67:\"Restricted HTML  <span class=\"config-name\">(restricted_html)</span>\";}s:14:\"#default_value\";a:3:{s:18:\"dynamic_shortcodes\";s:0:\"\";s:10:\"plain_text\";s:0:\"\";s:15:\"restricted_html\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:4:\"tour\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:4;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:51:\"<div class=\'features-export-parent component-tour\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:17:\"edit-sources-tour\";s:8:\"#options\";a:4:{s:8:\"language\";s:53:\"Language  <span class=\"config-name\">(language)</span>\";s:12:\"language-add\";s:65:\"Adding languages  <span class=\"config-name\">(language-add)</span>\";s:13:\"language-edit\";s:67:\"Editing languages  <span class=\"config-name\">(language-edit)</span>\";s:8:\"views-ui\";s:59:\"View edit page  <span class=\"config-name\">(views-ui)</span>\";}s:14:\"#default_value\";a:4:{s:8:\"language\";s:0:\"\";s:12:\"language-add\";s:0:\"\";s:13:\"language-edit\";s:0:\"\";s:8:\"views-ui\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:4:\"view\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"View\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:6:\"@count\";i:29;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:51:\"<div class=\'features-export-parent component-view\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:17:\"edit-sources-view\";s:8:\"#options\";a:29:{s:7:\"archive\";s:51:\"Archive  <span class=\"config-name\">(archive)</span>\";s:13:\"block_content\";s:70:\"Custom block library  <span class=\"config-name\">(block_content)</span>\";s:15:\"comments_recent\";s:67:\"Recent comments  <span class=\"config-name\">(comments_recent)</span>\";s:17:\"commerce_activity\";s:62:\"Activity  <span class=\"config-name\">(commerce_activity)</span>\";s:14:\"commerce_carts\";s:56:\"Carts  <span class=\"config-name\">(commerce_carts)</span>\";s:19:\"commerce_cart_block\";s:66:\"Cart block  <span class=\"config-name\">(commerce_cart_block)</span>\";s:18:\"commerce_cart_form\";s:64:\"Cart form  <span class=\"config-name\">(commerce_cart_form)</span>\";s:31:\"commerce_checkout_order_summary\";s:90:\"Checkout Order Summary  <span class=\"config-name\">(commerce_checkout_order_summary)</span>\";s:15:\"commerce_orders\";s:58:\"Orders  <span class=\"config-name\">(commerce_orders)</span>\";s:25:\"commerce_order_item_table\";s:73:\"Order items  <span class=\"config-name\">(commerce_order_item_table)</span>\";s:17:\"commerce_products\";s:62:\"Products  <span class=\"config-name\">(commerce_products)</span>\";s:15:\"commerce_stores\";s:58:\"Stores  <span class=\"config-name\">(commerce_stores)</span>\";s:20:\"commerce_user_orders\";s:68:\"User orders  <span class=\"config-name\">(commerce_user_orders)</span>\";s:7:\"content\";s:51:\"Content  <span class=\"config-name\">(content)</span>\";s:14:\"content_recent\";s:65:\"Recent content  <span class=\"config-name\">(content_recent)</span>\";s:5:\"files\";s:47:\"Files  <span class=\"config-name\">(files)</span>\";s:19:\"file_entity_browser\";s:75:\"File Entity Browser  <span class=\"config-name\">(file_entity_browser)</span>\";s:9:\"frontpage\";s:55:\"Frontpage  <span class=\"config-name\">(frontpage)</span>\";s:8:\"glossary\";s:53:\"Glossary  <span class=\"config-name\">(glossary)</span>\";s:16:\"products_archive\";s:69:\"Products archive  <span class=\"config-name\">(products_archive)</span>\";s:21:\"products_best_sellers\";s:79:\"Products best sellers  <span class=\"config-name\">(products_best_sellers)</span>\";s:17:\"products_comments\";s:71:\"Products comments  <span class=\"config-name\">(products_comments)</span>\";s:8:\"profiles\";s:53:\"Profiles  <span class=\"config-name\">(profiles)</span>\";s:16:\"related_products\";s:69:\"Related Products  <span class=\"config-name\">(related_products)</span>\";s:12:\"shop_columns\";s:61:\"Shop Columns  <span class=\"config-name\">(shop_columns)</span>\";s:13:\"taxonomy_term\";s:63:\"Taxonomy term  <span class=\"config-name\">(taxonomy_term)</span>\";s:17:\"user_admin_people\";s:60:\"People  <span class=\"config-name\">(user_admin_people)</span>\";s:9:\"who_s_new\";s:60:\"Who&#039;s new  <span class=\"config-name\">(who_s_new)</span>\";s:12:\"who_s_online\";s:72:\"Who&#039;s online block  <span class=\"config-name\">(who_s_online)</span>\";}s:14:\"#default_value\";a:29:{s:7:\"archive\";s:0:\"\";s:13:\"block_content\";s:0:\"\";s:15:\"comments_recent\";s:0:\"\";s:17:\"commerce_activity\";s:0:\"\";s:14:\"commerce_carts\";s:0:\"\";s:19:\"commerce_cart_block\";s:0:\"\";s:18:\"commerce_cart_form\";s:0:\"\";s:31:\"commerce_checkout_order_summary\";s:0:\"\";s:15:\"commerce_orders\";s:0:\"\";s:25:\"commerce_order_item_table\";s:0:\"\";s:17:\"commerce_products\";s:0:\"\";s:15:\"commerce_stores\";s:0:\"\";s:20:\"commerce_user_orders\";s:0:\"\";s:7:\"content\";s:0:\"\";s:14:\"content_recent\";s:0:\"\";s:5:\"files\";s:0:\"\";s:19:\"file_entity_browser\";s:0:\"\";s:9:\"frontpage\";s:0:\"\";s:8:\"glossary\";s:0:\"\";s:16:\"products_archive\";s:0:\"\";s:21:\"products_best_sellers\";s:0:\"\";s:17:\"products_comments\";s:0:\"\";s:8:\"profiles\";s:0:\"\";s:16:\"related_products\";s:0:\"\";s:12:\"shop_columns\";s:0:\"\";s:13:\"taxonomy_term\";s:0:\"\";s:17:\"user_admin_people\";s:0:\"\";s:9:\"who_s_new\";s:0:\"\";s:12:\"who_s_online\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:16:\"entity_view_mode\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:43;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:63:\"<div class=\'features-export-parent component-entity_view_mode\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:29:\"edit-sources-entity-view-mode\";s:8:\"#options\";a:43:{s:11:\"block.token\";s:53:\"Token  <span class=\"config-name\">(block.token)</span>\";s:18:\"block_content.full\";s:59:\"Full  <span class=\"config-name\">(block_content.full)</span>\";s:19:\"block_content.token\";s:61:\"Token  <span class=\"config-name\">(block_content.token)</span>\";s:12:\"comment.full\";s:61:\"Full comment  <span class=\"config-name\">(comment.full)</span>\";s:13:\"comment.token\";s:55:\"Token  <span class=\"config-name\">(comment.token)</span>\";s:18:\"commerce_log.token\";s:60:\"Token  <span class=\"config-name\">(commerce_log.token)</span>\";s:20:\"commerce_order.token\";s:62:\"Token  <span class=\"config-name\">(commerce_order.token)</span>\";s:19:\"commerce_order.user\";s:60:\"User  <span class=\"config-name\">(commerce_order.user)</span>\";s:25:\"commerce_order_item.token\";s:67:\"Token  <span class=\"config-name\">(commerce_order_item.token)</span>\";s:22:\"commerce_payment.token\";s:64:\"Token  <span class=\"config-name\">(commerce_payment.token)</span>\";s:29:\"commerce_payment_method.token\";s:71:\"Token  <span class=\"config-name\">(commerce_payment_method.token)</span>\";s:23:\"commerce_product.teaser\";s:66:\"Teaser  <span class=\"config-name\">(commerce_product.teaser)</span>\";s:22:\"commerce_product.token\";s:64:\"Token  <span class=\"config-name\">(commerce_product.token)</span>\";s:44:\"commerce_product_attribute_value.add_to_cart\";s:97:\"Add to Cart Form  <span class=\"config-name\">(commerce_product_attribute_value.add_to_cart)</span>\";s:38:\"commerce_product_attribute_value.token\";s:80:\"Token  <span class=\"config-name\">(commerce_product_attribute_value.token)</span>\";s:31:\"commerce_product_variation.cart\";s:72:\"Cart  <span class=\"config-name\">(commerce_product_variation.cart)</span>\";s:34:\"commerce_product_variation.product\";s:78:\"Product  <span class=\"config-name\">(commerce_product_variation.product)</span>\";s:34:\"commerce_product_variation.summary\";s:78:\"Summary  <span class=\"config-name\">(commerce_product_variation.summary)</span>\";s:32:\"commerce_product_variation.token\";s:74:\"Token  <span class=\"config-name\">(commerce_product_variation.token)</span>\";s:24:\"commerce_promotion.token\";s:66:\"Token  <span class=\"config-name\">(commerce_promotion.token)</span>\";s:31:\"commerce_promotion_coupon.token\";s:73:\"Token  <span class=\"config-name\">(commerce_promotion_coupon.token)</span>\";s:20:\"commerce_store.token\";s:62:\"Token  <span class=\"config-name\">(commerce_store.token)</span>\";s:21:\"contact_message.token\";s:63:\"Token  <span class=\"config-name\">(contact_message.token)</span>\";s:10:\"file.token\";s:52:\"Token  <span class=\"config-name\">(file.token)</span>\";s:23:\"menu_link_content.token\";s:65:\"Token  <span class=\"config-name\">(menu_link_content.token)</span>\";s:9:\"node.full\";s:58:\"Full content  <span class=\"config-name\">(node.full)</span>\";s:8:\"node.rss\";s:48:\"RSS  <span class=\"config-name\">(node.rss)</span>\";s:17:\"node.search_index\";s:66:\"Search index  <span class=\"config-name\">(node.search_index)</span>\";s:18:\"node.search_result\";s:87:\"Search result highlighting input  <span class=\"config-name\">(node.search_result)</span>\";s:11:\"node.teaser\";s:54:\"Teaser  <span class=\"config-name\">(node.teaser)</span>\";s:10:\"node.token\";s:52:\"Token  <span class=\"config-name\">(node.token)</span>\";s:13:\"profile.token\";s:55:\"Token  <span class=\"config-name\">(profile.token)</span>\";s:14:\"shortcut.token\";s:56:\"Token  <span class=\"config-name\">(shortcut.token)</span>\";s:18:\"taxonomy_term.full\";s:73:\"Taxonomy term page  <span class=\"config-name\">(taxonomy_term.full)</span>\";s:19:\"taxonomy_term.token\";s:61:\"Token  <span class=\"config-name\">(taxonomy_term.token)</span>\";s:10:\"tour.token\";s:52:\"Token  <span class=\"config-name\">(tour.token)</span>\";s:12:\"user.compact\";s:56:\"Compact  <span class=\"config-name\">(user.compact)</span>\";s:9:\"user.full\";s:58:\"User account  <span class=\"config-name\">(user.full)</span>\";s:10:\"user.token\";s:52:\"Token  <span class=\"config-name\">(user.token)</span>\";s:10:\"vote.token\";s:52:\"Token  <span class=\"config-name\">(vote.token)</span>\";s:17:\"vote_result.token\";s:59:\"Token  <span class=\"config-name\">(vote_result.token)</span>\";s:13:\"webform.token\";s:55:\"Token  <span class=\"config-name\">(webform.token)</span>\";s:24:\"webform_submission.token\";s:66:\"Token  <span class=\"config-name\">(webform_submission.token)</span>\";}s:14:\"#default_value\";a:43:{s:11:\"block.token\";s:0:\"\";s:18:\"block_content.full\";s:0:\"\";s:19:\"block_content.token\";s:0:\"\";s:12:\"comment.full\";s:0:\"\";s:13:\"comment.token\";s:0:\"\";s:18:\"commerce_log.token\";s:0:\"\";s:20:\"commerce_order.token\";s:0:\"\";s:19:\"commerce_order.user\";s:0:\"\";s:25:\"commerce_order_item.token\";s:0:\"\";s:22:\"commerce_payment.token\";s:0:\"\";s:29:\"commerce_payment_method.token\";s:0:\"\";s:23:\"commerce_product.teaser\";s:0:\"\";s:22:\"commerce_product.token\";s:0:\"\";s:44:\"commerce_product_attribute_value.add_to_cart\";s:0:\"\";s:38:\"commerce_product_attribute_value.token\";s:0:\"\";s:31:\"commerce_product_variation.cart\";s:0:\"\";s:34:\"commerce_product_variation.product\";s:0:\"\";s:34:\"commerce_product_variation.summary\";s:0:\"\";s:32:\"commerce_product_variation.token\";s:0:\"\";s:24:\"commerce_promotion.token\";s:0:\"\";s:31:\"commerce_promotion_coupon.token\";s:0:\"\";s:20:\"commerce_store.token\";s:0:\"\";s:21:\"contact_message.token\";s:0:\"\";s:10:\"file.token\";s:0:\"\";s:23:\"menu_link_content.token\";s:0:\"\";s:9:\"node.full\";s:0:\"\";s:8:\"node.rss\";s:0:\"\";s:17:\"node.search_index\";s:0:\"\";s:18:\"node.search_result\";s:0:\"\";s:11:\"node.teaser\";s:0:\"\";s:10:\"node.token\";s:0:\"\";s:13:\"profile.token\";s:0:\"\";s:14:\"shortcut.token\";s:0:\"\";s:18:\"taxonomy_term.full\";s:0:\"\";s:19:\"taxonomy_term.token\";s:0:\"\";s:10:\"tour.token\";s:0:\"\";s:12:\"user.compact\";s:0:\"\";s:9:\"user.full\";s:0:\"\";s:10:\"user.token\";s:0:\"\";s:10:\"vote.token\";s:0:\"\";s:17:\"vote_result.token\";s:0:\"\";s:13:\"webform.token\";s:0:\"\";s:24:\"webform_submission.token\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:9:\"vote_type\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Vote Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:1;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:56:\"<div class=\'features-export-parent component-vote_type\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:22:\"edit-sources-vote-type\";s:8:\"#options\";a:1:{s:4:\"vote\";s:52:\"Normal vote  <span class=\"config-name\">(vote)</span>\";}s:14:\"#default_value\";a:1:{s:4:\"vote\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:15:\"webform_options\";a:8:{s:7:\"#markup\";s:0:\"\";s:5:\"#tree\";b:1;s:7:\"sources\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:12:\"\0*\0arguments\";a:2:{s:10:\"@component\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Webform options\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@count\";i:28;}s:6:\"string\";s:56:\"@component (<span class=\"component-count\">@count</span>)\";}s:5:\"#tree\";b:1;s:5:\"#open\";b:0;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"features-export-component\";}}s:7:\"#prefix\";s:62:\"<div class=\'features-export-parent component-webform_options\'>\";s:8:\"selected\";a:7:{s:5:\"#type\";s:10:\"checkboxes\";s:3:\"#id\";s:28:\"edit-sources-webform-options\";s:8:\"#options\";a:28:{s:13:\"country_codes\";s:63:\"Country codes  <span class=\"config-name\">(country_codes)</span>\";s:13:\"country_names\";s:63:\"Country names  <span class=\"config-name\">(country_names)</span>\";s:16:\"creditcard_codes\";s:70:\"Credit card codes  <span class=\"config-name\">(creditcard_codes)</span>\";s:4:\"days\";s:45:\"Days  <span class=\"config-name\">(days)</span>\";s:9:\"education\";s:55:\"Education  <span class=\"config-name\">(education)</span>\";s:17:\"employment_status\";s:71:\"Employment status  <span class=\"config-name\">(employment_status)</span>\";s:9:\"ethnicity\";s:55:\"Ethnicity  <span class=\"config-name\">(ethnicity)</span>\";s:6:\"gender\";s:49:\"Gender  <span class=\"config-name\">(gender)</span>\";s:8:\"industry\";s:53:\"Industry  <span class=\"config-name\">(industry)</span>\";s:9:\"languages\";s:55:\"Languages  <span class=\"config-name\">(languages)</span>\";s:16:\"likert_agreement\";s:70:\"Likert: Agreement  <span class=\"config-name\">(likert_agreement)</span>\";s:17:\"likert_comparison\";s:72:\"Likert: Comparison  <span class=\"config-name\">(likert_comparison)</span>\";s:17:\"likert_importance\";s:72:\"Likert: Importance  <span class=\"config-name\">(likert_importance)</span>\";s:14:\"likert_quality\";s:66:\"Likert: Quality  <span class=\"config-name\">(likert_quality)</span>\";s:19:\"likert_satisfaction\";s:76:\"Likert: Satisfaction  <span class=\"config-name\">(likert_satisfaction)</span>\";s:16:\"likert_ten_scale\";s:70:\"Likert: Ten Scale  <span class=\"config-name\">(likert_ten_scale)</span>\";s:16:\"likert_would_you\";s:70:\"Likert: Would You  <span class=\"config-name\">(likert_would_you)</span>\";s:14:\"marital_status\";s:65:\"Marital status  <span class=\"config-name\">(marital_status)</span>\";s:6:\"months\";s:49:\"Months  <span class=\"config-name\">(months)</span>\";s:12:\"relationship\";s:61:\"Relationship  <span class=\"config-name\">(relationship)</span>\";s:4:\"size\";s:45:\"Size  <span class=\"config-name\">(size)</span>\";s:11:\"state_codes\";s:59:\"State codes  <span class=\"config-name\">(state_codes)</span>\";s:11:\"state_names\";s:59:\"State names  <span class=\"config-name\">(state_names)</span>\";s:20:\"state_province_codes\";s:77:\"State/Province codes  <span class=\"config-name\">(state_province_codes)</span>\";s:20:\"state_province_names\";s:77:\"State/Province names  <span class=\"config-name\">(state_province_names)</span>\";s:10:\"time_zones\";s:57:\"Time zones  <span class=\"config-name\">(time_zones)</span>\";s:6:\"titles\";s:49:\"Titles  <span class=\"config-name\">(titles)</span>\";s:6:\"yes_no\";s:49:\"Yes/No  <span class=\"config-name\">(yes_no)</span>\";}s:14:\"#default_value\";a:28:{s:13:\"country_codes\";s:0:\"\";s:13:\"country_names\";s:0:\"\";s:16:\"creditcard_codes\";s:0:\"\";s:4:\"days\";s:0:\"\";s:9:\"education\";s:0:\"\";s:17:\"employment_status\";s:0:\"\";s:9:\"ethnicity\";s:0:\"\";s:6:\"gender\";s:0:\"\";s:8:\"industry\";s:0:\"\";s:9:\"languages\";s:0:\"\";s:16:\"likert_agreement\";s:0:\"\";s:17:\"likert_comparison\";s:0:\"\";s:17:\"likert_importance\";s:0:\"\";s:14:\"likert_quality\";s:0:\"\";s:19:\"likert_satisfaction\";s:0:\"\";s:16:\"likert_ten_scale\";s:0:\"\";s:16:\"likert_would_you\";s:0:\"\";s:14:\"marital_status\";s:0:\"\";s:6:\"months\";s:0:\"\";s:12:\"relationship\";s:0:\"\";s:4:\"size\";s:0:\"\";s:11:\"state_codes\";s:0:\"\";s:11:\"state_names\";s:0:\"\";s:20:\"state_province_codes\";s:0:\"\";s:20:\"state_province_names\";s:0:\"\";s:10:\"time_zones\";s:0:\"\";s:6:\"titles\";s:0:\"\";s:6:\"yes_no\";s:0:\"\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"component-select\";}}s:7:\"#prefix\";s:31:\"<span class=\'component-select\'>\";s:7:\"#suffix\";s:7:\"</span>\";}}s:11:\"before-list\";a:1:{s:7:\"#markup\";s:71:\"<div class=\'component-list features-export-list features-export-empty\'>\";}s:8:\"included\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-included\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-included\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:8:\"detected\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"component-detected\";}}s:7:\"#prefix\";s:33:\"<span class=\'component-detected\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:5:\"added\";a:6:{s:5:\"#type\";s:10:\"checkboxes\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";a:0:{}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"component-added\";}}s:7:\"#prefix\";s:30:\"<span class=\'component-added\'>\";s:7:\"#suffix\";s:7:\"</span>\";}s:10:\"after-list\";a:1:{s:7:\"#markup\";s:12:\"</div></div>\";}}s:16:\"features_missing\";a:4:{s:6:\"#theme\";s:9:\"item_list\";s:6:\"#items\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Configuration missing from active site:\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#suffix\";s:92:\"<div class=\"description\">Import the feature to create the missing config listed above.</div>\";}s:15:\"features_legend\";a:6:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Legend\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#tree\";b:0;s:7:\"#prefix\";s:26:\"<div id=\'features-legend\'>\";s:7:\"#suffix\";s:6:\"</div>\";s:6:\"legend\";a:1:{s:7:\"#markup\";s:193:\"<span class=\'component-included\'>Normal</span> <span class=\'component-added\'>Added</span> <span class=\'component-detected\'>Auto detected</span> <span class=\'component-conflict\'>Conflict</span> \";}}}s:9:\"#attached\";a:3:{s:7:\"library\";a:1:{i:0;s:36:\"features_ui/drupal.features_ui.admin\";}s:14:\"drupalSettings\";a:1:{s:8:\"features\";a:4:{s:8:\"excluded\";a:0:{}s:8:\"required\";a:0:{}s:9:\"conflicts\";a:17:{s:13:\"system_simple\";a:9:{s:14:\"embed.settings\";s:14:\"embed.settings\";s:21:\"entity_embed.settings\";s:21:\"entity_embed.settings\";s:13:\"file.settings\";s:13:\"file.settings\";s:28:\"nd_visualshortcodes.settings\";s:28:\"nd_visualshortcodes.settings\";s:14:\"seven.settings\";s:14:\"seven.settings\";s:12:\"system.image\";s:12:\"system.image\";s:15:\"system.image.gd\";s:15:\"system.image.gd\";s:17:\"taxonomy.settings\";s:17:\"taxonomy.settings\";s:14:\"views.settings\";s:14:\"views.settings\";}s:19:\"base_field_override\";a:5:{s:25:\"node.gallery_item.promote\";s:22:\"Promoted to front page\";s:20:\"node.nd_blog.promote\";s:22:\"Promoted to front page\";s:22:\"node.nd_person.promote\";s:22:\"Promoted to front page\";s:25:\"node.nd_portfolio.promote\";s:22:\"Promoted to front page\";s:17:\"node.page.promote\";s:22:\"Promoted to front page\";}s:5:\"block\";a:2:{s:32:\"views_block__products_tags_block\";s:4:\"Tags\";s:34:\"views_block__shop_categories_block\";r:85;}s:25:\"language_content_settings\";a:3:{s:17:\"node.gallery_item\";s:17:\"node.gallery_item\";s:14:\"node.nd_person\";s:14:\"node.nd_person\";s:21:\"taxonomy_term.gallery\";s:21:\"taxonomy_term.gallery\";}s:9:\"node_type\";a:5:{s:12:\"gallery_item\";s:12:\"Gallery Item\";s:7:\"nd_blog\";s:4:\"Blog\";s:9:\"nd_person\";s:6:\"Person\";s:12:\"nd_portfolio\";s:9:\"Portfolio\";s:4:\"page\";s:10:\"Basic page\";}s:18:\"block_content_type\";a:1:{s:5:\"basic\";s:11:\"Basic block\";}s:19:\"entity_form_display\";a:10:{s:27:\"block_content.basic.default\";s:27:\"block_content.basic.default\";s:23:\"comment.comment.default\";s:23:\"comment.comment.default\";s:20:\"node.article.default\";s:20:\"node.article.default\";s:25:\"node.gallery_item.default\";s:25:\"node.gallery_item.default\";s:20:\"node.nd_blog.default\";s:20:\"node.nd_blog.default\";s:22:\"node.nd_person.default\";s:22:\"node.nd_person.default\";s:25:\"node.nd_portfolio.default\";s:25:\"node.nd_portfolio.default\";s:17:\"node.page.default\";s:17:\"node.page.default\";s:20:\"node.webform.default\";s:20:\"node.webform.default\";s:17:\"user.user.default\";s:17:\"user.user.default\";}s:19:\"entity_view_display\";a:19:{s:27:\"block_content.basic.default\";s:27:\"block_content.basic.default\";s:23:\"comment.comment.default\";s:23:\"comment.comment.default\";s:20:\"node.article.default\";s:20:\"node.article.default\";s:16:\"node.article.rss\";s:16:\"node.article.rss\";s:19:\"node.article.teaser\";s:19:\"node.article.teaser\";s:25:\"node.gallery_item.default\";s:25:\"node.gallery_item.default\";s:24:\"node.gallery_item.teaser\";s:24:\"node.gallery_item.teaser\";s:20:\"node.nd_blog.default\";s:20:\"node.nd_blog.default\";s:19:\"node.nd_blog.teaser\";s:19:\"node.nd_blog.teaser\";s:22:\"node.nd_person.default\";s:22:\"node.nd_person.default\";s:21:\"node.nd_person.teaser\";s:21:\"node.nd_person.teaser\";s:25:\"node.nd_portfolio.default\";s:25:\"node.nd_portfolio.default\";s:24:\"node.nd_portfolio.teaser\";s:24:\"node.nd_portfolio.teaser\";s:17:\"node.page.default\";s:17:\"node.page.default\";s:16:\"node.page.teaser\";s:16:\"node.page.teaser\";s:20:\"node.webform.default\";s:20:\"node.webform.default\";s:19:\"node.webform.teaser\";s:19:\"node.webform.teaser\";s:17:\"user.user.compact\";s:17:\"user.user.compact\";s:17:\"user.user.default\";s:17:\"user.user.default\";}s:12:\"field_config\";a:30:{s:24:\"block_content.basic.body\";s:4:\"Body\";s:29:\"comment.comment.field_comment\";s:7:\"Comment\";s:27:\"comment.comment.field_email\";s:5:\"Email\";s:17:\"node.article.body\";s:4:\"Body\";s:20:\"node.article.comment\";s:8:\"Comments\";s:24:\"node.article.field_image\";s:5:\"Image\";s:23:\"node.article.field_tags\";s:4:\"Tags\";s:31:\"node.gallery_item.field_gallery\";s:7:\"Gallery\";s:29:\"node.gallery_item.field_image\";s:5:\"Image\";s:17:\"node.nd_blog.body\";s:4:\"Body\";s:32:\"node.nd_blog.field_blog_category\";s:13:\"Blog Category\";s:27:\"node.nd_blog.field_comments\";s:8:\"Comments\";s:25:\"node.nd_blog.field_images\";s:6:\"Images\";s:28:\"node.nd_blog.field_lead_text\";s:9:\"Lead Text\";s:31:\"node.nd_blog.field_second_title\";s:12:\"Second Title\";s:23:\"node.nd_blog.field_tags\";s:4:\"Tags\";s:19:\"node.nd_person.body\";s:4:\"Body\";s:26:\"node.nd_person.field_image\";s:5:\"Image\";s:29:\"node.nd_person.field_position\";s:8:\"Position\";s:33:\"node.nd_person.field_social_links\";s:12:\"Social Links\";s:22:\"node.nd_portfolio.body\";s:4:\"Body\";s:32:\"node.nd_portfolio.field_category\";s:8:\"Category\";s:35:\"node.nd_portfolio.field_description\";s:11:\"Description\";s:30:\"node.nd_portfolio.field_images\";s:6:\"Images\";s:42:\"node.nd_portfolio.field_portfolio_category\";s:18:\"Portfolio Category\";s:31:\"node.nd_portfolio.field_project\";s:7:\"Project\";s:36:\"node.nd_portfolio.field_project_link\";s:12:\"Project Link\";s:14:\"node.page.body\";s:4:\"Body\";s:17:\"node.webform.body\";s:4:\"Body\";s:22:\"user.user.user_picture\";s:7:\"Picture\";}s:20:\"field_storage_config\";a:22:{s:18:\"block_content.body\";s:18:\"block_content.body\";s:20:\"comment.comment_body\";s:20:\"comment.comment_body\";s:21:\"comment.field_comment\";s:21:\"comment.field_comment\";s:19:\"comment.field_email\";s:19:\"comment.field_email\";s:9:\"node.body\";s:9:\"node.body\";s:12:\"node.comment\";s:12:\"node.comment\";s:24:\"node.field_blog_category\";s:24:\"node.field_blog_category\";s:19:\"node.field_category\";s:19:\"node.field_category\";s:19:\"node.field_comments\";s:19:\"node.field_comments\";s:22:\"node.field_description\";s:22:\"node.field_description\";s:18:\"node.field_gallery\";s:18:\"node.field_gallery\";s:16:\"node.field_image\";s:16:\"node.field_image\";s:17:\"node.field_images\";s:17:\"node.field_images\";s:20:\"node.field_lead_text\";s:20:\"node.field_lead_text\";s:29:\"node.field_portfolio_category\";s:29:\"node.field_portfolio_category\";s:19:\"node.field_position\";s:19:\"node.field_position\";s:18:\"node.field_project\";s:18:\"node.field_project\";s:23:\"node.field_project_link\";s:23:\"node.field_project_link\";s:23:\"node.field_second_title\";s:23:\"node.field_second_title\";s:23:\"node.field_social_links\";s:23:\"node.field_social_links\";s:15:\"node.field_tags\";s:15:\"node.field_tags\";s:17:\"user.user_picture\";s:17:\"user.user_picture\";}s:11:\"image_style\";a:12:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";}s:4:\"menu\";a:1:{s:8:\"one-page\";s:8:\"One Page\";}s:19:\"taxonomy_vocabulary\";a:6:{s:13:\"blog_category\";s:13:\"Blog Category\";s:8:\"category\";s:8:\"Category\";s:7:\"gallery\";s:7:\"Gallery\";s:18:\"portfolio_category\";s:18:\"Portfolio Category\";s:7:\"project\";s:7:\"Project\";s:4:\"tags\";s:4:\"Tags\";}s:6:\"editor\";a:3:{s:10:\"basic_html\";s:10:\"Basic HTML\";s:8:\"ckeditor\";s:8:\"CKeditor\";s:9:\"full_html\";s:9:\"Full HTML\";}s:13:\"filter_format\";a:5:{s:10:\"basic_html\";s:10:\"Basic HTML\";s:8:\"ckeditor\";s:8:\"CKeditor\";s:9:\"full_html\";s:9:\"Full HTML\";s:10:\"shortcodes\";s:10:\"Shortcodes\";s:17:\"visual_shortcodes\";s:17:\"Visual Shortcodes\";}s:4:\"view\";a:12:{s:14:\"blog_fullwidth\";s:14:\"Blog Fullwidth\";s:9:\"blog_grid\";s:9:\"Blog Grid\";s:12:\"blog_masonry\";s:12:\"Blog Masonry\";s:13:\"blog_timeline\";s:13:\"Blog TimeLine\";s:7:\"gallery\";s:7:\"Gallery\";s:15:\"portfolio_boxed\";s:9:\"Portfolio\";s:18:\"portfolio_parallax\";s:18:\"Portfolio Parallax\";s:15:\"portfolio_promo\";s:15:\"Portfolio Promo\";s:13:\"products_tags\";s:13:\"Products Tags\";s:16:\"related_projects\";s:16:\"Related Projects\";s:15:\"shop_categories\";s:15:\"Shop Categories\";s:4:\"team\";s:4:\"Team\";}s:7:\"webform\";a:3:{s:7:\"contact\";s:7:\"Contact\";s:9:\"contact_1\";s:9:\"Contact 1\";s:9:\"subscribe\";s:9:\"Subscribe\";}}s:10:\"autodetect\";b:1;}}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:18:\"features_edit_form\";s:9:\"#build_id\";s:48:\"form-hwHP1OcbgGBzMFFlUY4Q4iF-a-LyVM8sQMe3EQy58xw\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-hwHP1OcbgGBzMFFlUY4Q4iF-a-LyVM8sQMe3EQy58xw\";s:3:\"#id\";s:48:\"form-hwHP1OcbgGBzMFFlUY4Q4iF-a-LyVM8sQMe3EQy58xw\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_Jc6OeqaQ8XI1cpLo4nijE1-rSJJscDBT-WODtLzDGVY\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:47:\"edit-features-edit-form-form-token--rlTM90psZzU\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_Jc6OeqaQ8XI1cpLo4nijE1-rSJJscDBT-WODtLzDGVY\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_Jc6OeqaQ8XI1cpLo4nijE1-rSJJscDBT-WODtLzDGVY\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_Jc6OeqaQ8XI1cpLo4nijE1-rSJJscDBT-WODtLzDGVY\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:18:\"features_edit_form\";s:3:\"#id\";s:36:\"edit-features-edit-form--7654Ylep15U\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:31:\"features-edit-form--yLU5YoB_07c\";s:11:\"#attributes\";a:1:{s:20:\"data-drupal-selector\";s:18:\"features-edit-form\";}s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:18:\"features_edit_form\";}s:12:\"#cache_token\";s:43:\"tbUV7K1XgTauxiwiFChxnTUAhDGQMbZhXD3x70gTUTY\";}',1503957254),

('form','form-hWOPaH51S21tfJSMPt9wHaT0yEtJ2tdE4E4BxNDTZq8','a:24:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:11:\"views-admin\";}s:20:\"data-drupal-selector\";s:13:\"view-add-form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:23:\"views_ui/views_ui.admin\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:4:\"name\";a:7:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"View basic information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:18:\"fieldset-no-legend\";}}s:5:\"label\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"#required\";b:1;s:5:\"#size\";i:32;s:14:\"#default_value\";s:0:\"\";s:10:\"#maxlength\";i:255;}s:2:\"id\";a:4:{s:5:\"#type\";s:12:\"machine_name\";s:10:\"#maxlength\";i:128;s:13:\"#machine_name\";a:2:{s:6:\"exists\";s:28:\"\\Drupal\\views\\Views::getView\";s:6:\"source\";a:2:{i:0;s:4:\"name\";i:1;s:5:\"label\";}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:111:\"A unique machine-readable name for this View. It must only contain lowercase letters, numbers, and underscores.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:18:\"description_enable\";a:2:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:11:\"description\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Provide description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:5:\"#size\";i:64;s:14:\"#default_value\";s:0:\"\";s:7:\"#states\";a:1:{s:7:\"visible\";a:1:{s:33:\":input[name=\"description_enable\"]\";a:1:{s:7:\"checked\";b:1;}}}}}s:8:\"displays\";a:4:{s:4:\"show\";a:9:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"View settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#tree\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:10:\"wizard_key\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Show\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:23:{s:7:\"comment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"watchdog\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Log entries\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"file_managed\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Files\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"node\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"node_revision\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Content revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"taxonomy_term\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Taxonomy terms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"users\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:37:\"standard:block_content_field_revision\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@entity_type revisions\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:25:\"standard:profile_revision\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@entity_type revisions\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Profile\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:34:\"standard:commerce_promotion_coupon\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Coupon\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:33:\"standard:block_content_field_data\";r:113;s:21:\"standard:commerce_log\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Log\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:23:\"standard:commerce_order\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Order\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"standard:commerce_order_item\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Order item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:25:\"standard:commerce_payment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:36:\"standard:commerce_product_field_data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:52:\"standard:commerce_product_attribute_value_field_data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Product attribute value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:46:\"standard:commerce_product_variation_field_data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Product variation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"standard:profile\";r:121;s:38:\"standard:commerce_promotion_field_data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Promotion\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:34:\"standard:commerce_store_field_data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Store\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:23:\"standard:votingapi_vote\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Vote\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:27:\"standard:webform_submission\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Webform submission\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:36:\"standard:commerce_product_field_data\";s:5:\"#ajax\";a:2:{s:8:\"callback\";s:25:\"views_ui_ajax_update_form\";s:7:\"wrapper\";s:26:\"edit-view-displays-wrapper\";}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:26:\"edit-view-displays-wrapper\";s:11:\"trigger_key\";s:10:\"wizard_key\";s:15:\"refresh_parents\";a:1:{i:0;s:8:\"displays\";}}}s:25:\"wizard_key_trigger_update\";a:7:{s:5:\"#type\";s:6:\"submit\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"js-hide\";}}s:7:\"#submit\";a:1:{i:0;s:20:\"views_ui_nojs_submit\";}s:8:\"#process\";a:3:{i:0;s:31:\"views_ui_add_limited_validation\";i:1;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:13:\"processButton\";}i:2;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:15:\"processAjaxForm\";}}s:12:\"#after_build\";a:1:{i:0;s:25:\"views_ui_add_ajax_wrapper\";}s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Update \"@title\" choice\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Show\";}s:10:\"\0*\0options\";a:0:{}}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:26:\"edit-view-displays-wrapper\";s:11:\"trigger_key\";s:10:\"wizard_key\";s:15:\"refresh_parents\";a:1:{i:0;s:8:\"displays\";}}}s:4:\"type\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"of type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:3:{s:3:\"all\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"All\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"default\";s:7:\"Default\";s:15:\"product_display\";s:15:\"Product Display\";}s:14:\"#default_value\";s:15:\"product_display\";s:5:\"#ajax\";a:2:{s:8:\"callback\";s:25:\"views_ui_ajax_update_form\";s:7:\"wrapper\";s:26:\"edit-view-displays-wrapper\";}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:26:\"edit-view-displays-wrapper\";s:11:\"trigger_key\";s:4:\"type\";s:15:\"refresh_parents\";a:1:{i:0;s:8:\"displays\";}}}s:19:\"type_trigger_update\";a:7:{s:5:\"#type\";s:6:\"submit\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"js-hide\";}}s:7:\"#submit\";a:1:{i:0;s:20:\"views_ui_nojs_submit\";}s:8:\"#process\";a:3:{i:0;s:31:\"views_ui_add_limited_validation\";i:1;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:13:\"processButton\";}i:2;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:15:\"processAjaxForm\";}}s:12:\"#after_build\";a:1:{i:0;s:25:\"views_ui_add_ajax_wrapper\";}s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Update \"@title\" choice\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"of type\";}s:10:\"\0*\0options\";a:0:{}}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:26:\"edit-view-displays-wrapper\";s:11:\"trigger_key\";s:4:\"type\";s:15:\"refresh_parents\";a:1:{i:0;s:8:\"displays\";}}}s:4:\"sort\";a:4:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"sorted by\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:1:{s:4:\"none\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Unsorted\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:4:\"none\";}}s:4:\"page\";a:6:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:16:\"views-attachment\";i:1;s:18:\"fieldset-no-legend\";}}s:5:\"#tree\";b:1;s:6:\"create\";a:5:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Create a page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:6:\"strong\";}}s:14:\"#default_value\";b:0;s:3:\"#id\";s:16:\"edit-page-create\";}s:7:\"options\";a:15:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"options-set\";}}s:7:\"#states\";a:1:{s:7:\"visible\";a:1:{s:27:\":input[name=\"page[create]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:7:\"#prefix\";s:33:\"<div><div id=\"edit-page-wrapper\">\";s:7:\"#suffix\";s:12:\"</div></div>\";s:8:\"#parents\";a:1:{i:0;s:4:\"page\";}s:5:\"title\";a:3:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Page title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:10:\"#maxlength\";i:255;}s:4:\"path\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:13:\"#field_prefix\";s:0:\"\";s:10:\"#maxlength\";i:254;}s:5:\"style\";a:8:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Page display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:16:\"container-inline\";i:1;s:18:\"fieldset-no-legend\";}}s:12:\"style_plugin\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Display format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:5:{s:4:\"grid\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Grid\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"html_list\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"HTML List\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"nd_portfolio_filter\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Portfolio Filter\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"table\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Table\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Unformatted list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:7:\"default\";s:5:\"#ajax\";a:2:{s:8:\"callback\";s:25:\"views_ui_ajax_update_form\";s:7:\"wrapper\";s:39:\"edit-view-displays-page-options-wrapper\";}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:39:\"edit-view-displays-page-options-wrapper\";s:11:\"trigger_key\";s:12:\"style_plugin\";s:15:\"refresh_parents\";a:3:{i:0;s:8:\"displays\";i:1;s:4:\"page\";i:2;s:7:\"options\";}}}s:27:\"style_plugin_trigger_update\";a:7:{s:5:\"#type\";s:6:\"submit\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"js-hide\";}}s:7:\"#submit\";a:1:{i:0;s:20:\"views_ui_nojs_submit\";}s:8:\"#process\";a:3:{i:0;s:31:\"views_ui_add_limited_validation\";i:1;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:13:\"processButton\";}i:2;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:15:\"processAjaxForm\";}}s:12:\"#after_build\";a:1:{i:0;s:25:\"views_ui_add_ajax_wrapper\";}s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Update \"@title\" choice\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:14:\"Display format\";}s:10:\"\0*\0options\";a:0:{}}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:39:\"edit-view-displays-page-options-wrapper\";s:11:\"trigger_key\";s:12:\"style_plugin\";s:15:\"refresh_parents\";a:3:{i:0;s:8:\"displays\";i:1;s:4:\"page\";i:2;s:7:\"options\";}}}s:10:\"row_plugin\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"of\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:3:{s:6:\"fields\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:23:\"entity:commerce_product\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"search_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Search results\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:7:\"#access\";b:1;s:14:\"#default_value\";s:6:\"fields\";s:5:\"#ajax\";a:2:{s:8:\"callback\";s:25:\"views_ui_ajax_update_form\";s:7:\"wrapper\";s:57:\"edit-view-displays-page-options-style-row_options-wrapper\";}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:57:\"edit-view-displays-page-options-style-row_options-wrapper\";s:11:\"trigger_key\";s:10:\"row_plugin\";s:15:\"refresh_parents\";a:5:{i:0;s:8:\"displays\";i:1;s:4:\"page\";i:2;s:7:\"options\";i:3;s:5:\"style\";i:4;s:11:\"row_options\";}}}s:25:\"row_plugin_trigger_update\";a:8:{s:5:\"#type\";s:6:\"submit\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"js-hide\";}}s:7:\"#submit\";a:1:{i:0;s:20:\"views_ui_nojs_submit\";}s:8:\"#process\";a:3:{i:0;s:31:\"views_ui_add_limited_validation\";i:1;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:13:\"processButton\";}i:2;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:15:\"processAjaxForm\";}}s:12:\"#after_build\";a:1:{i:0;s:25:\"views_ui_add_ajax_wrapper\";}s:7:\"#access\";b:1;s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Update \"@title\" choice\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:2:\"of\";}s:10:\"\0*\0options\";a:0:{}}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:57:\"edit-view-displays-page-options-style-row_options-wrapper\";s:11:\"trigger_key\";s:10:\"row_plugin\";s:15:\"refresh_parents\";a:5:{i:0;s:8:\"displays\";i:1;s:4:\"page\";i:2;s:7:\"options\";i:3;s:5:\"style\";i:4;s:11:\"row_options\";}}}s:11:\"row_options\";a:1:{s:15:\"#theme_wrappers\";a:1:{i:0;s:9:\"container\";}}}s:14:\"items_per_page\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Items to display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"number\";s:14:\"#default_value\";i:10;s:4:\"#min\";i:0;}s:5:\"pager\";a:3:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Use a pager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:14:\"#default_value\";b:1;}s:4:\"link\";a:3:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Create a menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:3:\"#id\";s:14:\"edit-page-link\";}s:15:\"link_properties\";a:6:{s:5:\"#type\";s:9:\"container\";s:7:\"#states\";a:1:{s:7:\"visible\";a:1:{s:25:\":input[name=\"page[link]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:7:\"#prefix\";s:44:\"<div id=\"edit-page-link-properties-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:9:\"menu_name\";a:3:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"admin\";s:14:\"Administration\";s:5:\"devel\";s:11:\"Development\";s:6:\"footer\";s:6:\"Footer\";s:4:\"main\";s:15:\"Main navigation\";s:8:\"one-page\";s:8:\"One Page\";s:5:\"tools\";s:5:\"Tools\";s:7:\"account\";s:17:\"User account menu\";}}s:5:\"title\";a:2:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Link text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";}}s:4:\"feed\";a:3:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Include an RSS feed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:3:\"#id\";s:14:\"edit-page-feed\";}s:15:\"feed_properties\";a:6:{s:5:\"#type\";s:9:\"container\";s:7:\"#states\";a:1:{s:7:\"visible\";a:1:{s:25:\":input[name=\"page[feed]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:7:\"#prefix\";s:44:\"<div id=\"edit-page-feed-properties-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:4:\"path\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Feed path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:13:\"#field_prefix\";s:0:\"\";s:10:\"#maxlength\";i:254;}s:10:\"row_plugin\";a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Feed row style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:3:{s:10:\"rss_fields\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"opml_fields\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"OPML fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"search_view\";r:415;}s:14:\"#default_value\";s:10:\"rss_fields\";s:7:\"#access\";b:1;s:7:\"#states\";a:1:{s:7:\"visible\";a:1:{s:25:\":input[name=\"page[feed]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:7:\"#prefix\";s:55:\"<div id=\"edit-page-feed-properties-row-plugin-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}}}s:5:\"block\";a:6:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Block settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:16:\"views-attachment\";i:1;s:18:\"fieldset-no-legend\";}}s:5:\"#tree\";b:1;s:6:\"create\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Create a block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:6:\"strong\";}}s:3:\"#id\";s:17:\"edit-block-create\";}s:7:\"options\";a:10:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"options-set\";}}s:7:\"#states\";a:1:{s:7:\"visible\";a:1:{s:28:\":input[name=\"block[create]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:7:\"#prefix\";s:29:\"<div id=\"edit-block-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:8:\"#parents\";a:1:{i:0;s:5:\"block\";}s:5:\"title\";a:3:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Block title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:10:\"#maxlength\";i:255;}s:5:\"style\";a:8:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Block display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:16:\"container-inline\";i:1;s:18:\"fieldset-no-legend\";}}s:12:\"style_plugin\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Display format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:5:{s:4:\"grid\";r:340;s:9:\"html_list\";r:344;s:19:\"nd_portfolio_filter\";r:348;s:5:\"table\";r:352;s:7:\"default\";r:356;}s:14:\"#default_value\";s:9:\"html_list\";s:5:\"#ajax\";a:2:{s:8:\"callback\";s:25:\"views_ui_ajax_update_form\";s:7:\"wrapper\";s:40:\"edit-view-displays-block-options-wrapper\";}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:40:\"edit-view-displays-block-options-wrapper\";s:11:\"trigger_key\";s:12:\"style_plugin\";s:15:\"refresh_parents\";a:3:{i:0;s:8:\"displays\";i:1;s:5:\"block\";i:2;s:7:\"options\";}}}s:27:\"style_plugin_trigger_update\";a:7:{s:5:\"#type\";s:6:\"submit\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"js-hide\";}}s:7:\"#submit\";a:1:{i:0;s:20:\"views_ui_nojs_submit\";}s:8:\"#process\";a:3:{i:0;s:31:\"views_ui_add_limited_validation\";i:1;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:13:\"processButton\";}i:2;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:15:\"processAjaxForm\";}}s:12:\"#after_build\";a:1:{i:0;s:25:\"views_ui_add_ajax_wrapper\";}s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Update \"@title\" choice (@number)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@title\";s:14:\"Display format\";s:7:\"@number\";i:2;}s:10:\"\0*\0options\";a:0:{}}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:40:\"edit-view-displays-block-options-wrapper\";s:11:\"trigger_key\";s:12:\"style_plugin\";s:15:\"refresh_parents\";a:3:{i:0;s:8:\"displays\";i:1;s:5:\"block\";i:2;s:7:\"options\";}}}s:10:\"row_plugin\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"of\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:3:{s:6:\"fields\";r:407;s:23:\"entity:commerce_product\";r:411;s:11:\"search_view\";r:415;}s:7:\"#access\";b:1;s:14:\"#default_value\";s:6:\"fields\";s:5:\"#ajax\";a:2:{s:8:\"callback\";s:25:\"views_ui_ajax_update_form\";s:7:\"wrapper\";s:58:\"edit-view-displays-block-options-style-row_options-wrapper\";}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:58:\"edit-view-displays-block-options-style-row_options-wrapper\";s:11:\"trigger_key\";s:10:\"row_plugin\";s:15:\"refresh_parents\";a:5:{i:0;s:8:\"displays\";i:1;s:5:\"block\";i:2;s:7:\"options\";i:3;s:5:\"style\";i:4;s:11:\"row_options\";}}}s:25:\"row_plugin_trigger_update\";a:8:{s:5:\"#type\";s:6:\"submit\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"js-hide\";}}s:7:\"#submit\";a:1:{i:0;s:20:\"views_ui_nojs_submit\";}s:8:\"#process\";a:3:{i:0;s:31:\"views_ui_add_limited_validation\";i:1;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:13:\"processButton\";}i:2;a:2:{i:0;s:33:\"Drupal\\Core\\Render\\Element\\Submit\";i:1;s:15:\"processAjaxForm\";}}s:12:\"#after_build\";a:1:{i:0;s:25:\"views_ui_add_ajax_wrapper\";}s:7:\"#access\";b:1;s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Update \"@title\" choice (@number)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@title\";s:2:\"of\";s:7:\"@number\";i:2;}s:10:\"\0*\0options\";a:0:{}}s:19:\"#views_ui_ajax_data\";a:3:{s:7:\"wrapper\";s:58:\"edit-view-displays-block-options-style-row_options-wrapper\";s:11:\"trigger_key\";s:10:\"row_plugin\";s:15:\"refresh_parents\";a:5:{i:0;s:8:\"displays\";i:1;s:5:\"block\";i:2;s:7:\"options\";i:3;s:5:\"style\";i:4;s:11:\"row_options\";}}}s:11:\"row_options\";a:1:{s:15:\"#theme_wrappers\";a:1:{i:0;s:9:\"container\";}}}s:14:\"items_per_page\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Items per block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"number\";s:14:\"#default_value\";i:5;s:4:\"#min\";i:0;}s:5:\"pager\";a:3:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Use a pager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:14:\"#default_value\";b:0;}}}s:11:\"rest_export\";a:6:{s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"REST export settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:16:\"views-attachment\";i:1;s:18:\"fieldset-no-legend\";}}s:5:\"#tree\";b:1;s:6:\"create\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Provide a REST export\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:8:\"checkbox\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:6:\"strong\";}}s:3:\"#id\";s:23:\"edit-rest-export-create\";}s:7:\"options\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"options-set\";}}s:7:\"#states\";a:1:{s:7:\"visible\";a:1:{s:34:\":input[name=\"rest_export[create]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:7:\"#prefix\";s:35:\"<div id=\"edit-rest-export-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:8:\"#parents\";a:1:{i:0;s:11:\"rest_export\";}s:4:\"path\";a:4:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"REST export path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:13:\"#field_prefix\";s:0:\"\";s:10:\"#maxlength\";i:254;}}}}s:7:\"actions\";a:3:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Save and edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;a:2:{i:0;O:27:\"Drupal\\views_ui\\ViewAddForm\":11:{s:12:\"\0*\0displayID\";N;s:12:\"\0*\0operation\";s:3:\"add\";s:9:\"\0*\0entity\";O:24:\"Drupal\\views\\Entity\\View\":24:{s:13:\"\0*\0base_table\";s:4:\"node\";s:5:\"\0*\0id\";N;s:8:\"\0*\0label\";N;s:14:\"\0*\0description\";s:0:\"\";s:6:\"\0*\0tag\";s:0:\"\";s:7:\"\0*\0core\";s:3:\"8.x\";s:10:\"\0*\0display\";a:1:{s:7:\"default\";a:5:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:0:{}}}s:13:\"\0*\0base_field\";s:3:\"nid\";s:9:\"\0*\0module\";s:5:\"views\";s:13:\"\0*\0originalId\";N;s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"27a0280e-0f3d-4cb8-a8b2-330739e507a4\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:4:\"view\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:0:{}}s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"wizardManager\";s:27:\"plugin.manager.views.wizard\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:10:\"submitForm\";}}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:6:\"cancel\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:8:\"::cancel\";}s:24:\"#limit_validation_errors\";a:0:{}s:7:\"#weight\";i:10;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:13:\"view_add_form\";s:9:\"#build_id\";s:48:\"form-hWOPaH51S21tfJSMPt9wHaT0yEtJ2tdE4E4BxNDTZq8\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-hWOPaH51S21tfJSMPt9wHaT0yEtJ2tdE4E4BxNDTZq8\";s:3:\"#id\";s:48:\"form-hWOPaH51S21tfJSMPt9wHaT0yEtJ2tdE4E4BxNDTZq8\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_kG4OgQZKT6IbQ5t_RsQh_AG-f3dGAgDIN7VfwRc-5yI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:42:\"edit-view-add-form-form-token--1l7OYpzAU6k\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_kG4OgQZKT6IbQ5t_RsQh_AG-f3dGAgDIN7VfwRc-5yI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_kG4OgQZKT6IbQ5t_RsQh_AG-f3dGAgDIN7VfwRc-5yI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_kG4OgQZKT6IbQ5t_RsQh_AG-f3dGAgDIN7VfwRc-5yI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:13:\"view_add_form\";s:3:\"#id\";s:31:\"edit-view-add-form--b3fTyWDDTQA\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:26:\"view-add-form--N20pa7tLqNU\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:13:\"view_add_form\";i:1;s:9:\"view_form\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503591560),

('form','form-In8xcbtCc4U29dHh20Mpl4_L_Ngyj5N6_FSuhA6iUGE','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:150;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:150;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:514;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:514;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:568;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:568;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:700;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:700;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503399966\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:762;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";s:9:\"Black, XL\";s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325829\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"12\";}}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"22\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:1001:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:966;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";s:8:\"White, L\";s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:21:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:38:\"Religion Jersey Polo Shirts - White, L\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"13\";}}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"21\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:38:\"Religion Jersey Polo Shirts - White, L\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"1\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:1142;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:1;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:1;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503325874\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 17:31\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503325874\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-In8xcbtCc4U29dHh20Mpl4_L_Ngyj5N6_FSuhA6iUGE\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-In8xcbtCc4U29dHh20Mpl4_L_Ngyj5N6_FSuhA6iUGE\";s:3:\"#id\";s:48:\"form-In8xcbtCc4U29dHh20Mpl4_L_Ngyj5N6_FSuhA6iUGE\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--sWX8KbFh1Z0\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--SdE_pNezj94\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--lEttl7l436c\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503421596),

('form','form-Islec8tmqEZ9Y79zLDu5UD0XsP_zESnvLDRx8rrCAQ8','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:2\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:33:16.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:1:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:459;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:3:\"und\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:459;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:513;s:14:\"#default_value\";s:34:\"/product/polo-shirt-floral-sleeves\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"21\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/2\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:3:\"und\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:513;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:645;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:30:\"Polo Shirt With Floral Sleeves\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:645;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503302531\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:707;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:5:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:21:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"2\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"fd167796-b7c9-47bb-876a-2f13f6ebc9c8\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"2\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"3159\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:30:\"Polo Shirt With Floral Sleeves\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"85.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503052598\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302494\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"2\";s:4:\"uuid\";s:36:\"fd167796-b7c9-47bb-876a-2f13f6ebc9c8\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:30:\"Polo Shirt With Floral Sleeves\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";i:0;s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";i:0;}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:3:\"und\";s:14:\"#default_value\";r:914;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302494\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 11:01\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"2\";}s:10:\"\0*\0options\";a:4:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"2\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7f537ff0-30a0-477c-a55f-a3bf836a1c10\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"und\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:30:\"Polo Shirt With Floral Sleeves\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503052396\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302494\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"2\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"2\";s:4:\"uuid\";s:36:\"7f537ff0-30a0-477c-a55f-a3bf836a1c10\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:30:\"Polo Shirt With Floral Sleeves\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:3:\"und\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:13:\"Not specified\";s:5:\"\0*\0id\";s:3:\"und\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:3;s:9:\"\0*\0locked\";b:1;}s:5:\"query\";a:1:{s:11:\"destination\";s:24:\"/admin/commerce/products\";}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-Islec8tmqEZ9Y79zLDu5UD0XsP_zESnvLDRx8rrCAQ8\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-Islec8tmqEZ9Y79zLDu5UD0XsP_zESnvLDRx8rrCAQ8\";s:3:\"#id\";s:48:\"form-Islec8tmqEZ9Y79zLDu5UD0XsP_zESnvLDRx8rrCAQ8\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--v1uF-mcf2rk\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--6L6ex0YVg4c\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--pxLd1uMDGOc\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503324157),

('form','form-iVuQ3x0T9DbG5uzNUizYb7P6L9hKje-Xyk33OLl0X2o','a:33:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-form-display-edit-form\";i:1;s:24:\"entity-form-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-form-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:74:\"config:core.entity_form_display.commerce_product_variation.product.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:7:\"#fields\";a:17:{i:0;s:8:\"langcode\";i:1;s:3:\"uid\";i:2;s:3:\"sku\";i:3;s:5:\"price\";i:4;s:6:\"status\";i:5;s:7:\"created\";i:6;s:20:\"attribute_parameters\";i:7;s:11:\"field_color\";i:8;s:17:\"field_description\";i:9;s:12:\"field_images\";i:10;s:12:\"field_length\";i:11;s:15:\"field_old_price\";i:12;s:28:\"field_right_side_description\";i:13;s:15:\"field_sale_text\";i:14;s:23:\"field_short_description\";i:15;s:10:\"field_size\";i:16;s:11:\"field_waist\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:24:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:5:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Widget\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityFormDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"form\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:223;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:223;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:223;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"7ead05bb-48d9-4c0d-8503-3978179228c2\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:13:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:35:\"entity_browser.browser.browse_files\";i:2;s:67:\"field.field.commerce_product_variation.product.attribute_parameters\";i:3;s:58:\"field.field.commerce_product_variation.product.field_color\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:59:\"field.field.commerce_product_variation.product.field_length\";i:7;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:8;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:9;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:10;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:11;s:57:\"field.field.commerce_product_variation.product.field_size\";i:12;s:58:\"field.field.commerce_product_variation.product.field_waist\";}s:6:\"module\";a:5:{i:0;s:14:\"commerce_price\";i:1;s:14:\"entity_browser\";i:2;s:11:\"field_group\";i:3;s:18:\"inline_entity_form\";i:4;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:11:\"field_group\";a:1:{s:16:\"group_properties\";a:6:{s:8:\"children\";a:4:{i:0;s:10:\"field_size\";i:1;s:11:\"field_color\";i:2;s:11:\"field_waist\";i:3;s:12:\"field_length\";}s:11:\"parent_name\";s:0:\"\";s:6:\"weight\";i:6;s:11:\"format_type\";s:7:\"details\";s:15:\"format_settings\";a:4:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:4:\"open\";b:1;s:15:\"required_fields\";b:1;}s:5:\"label\";s:10:\"Properties\";}}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:15:{s:20:\"attribute_parameters\";a:5:{s:4:\"type\";s:25:\"inline_entity_form_simple\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:4:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:3:\"Aaa\";s:12:\"label_plural\";s:3:\"Bbb\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"field_color\";a:5:{s:6:\"weight\";s:2:\"22\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:5:{s:6:\"weight\";s:1:\"9\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:5:{s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:17:\"field_widget_edit\";b:1;s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:5:{s:6:\"weight\";s:2:\"24\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:5:{s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:5:{s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:5:{s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:5:{s:6:\"weight\";s:1:\"8\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"string_textarea\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:5:{s:6:\"weight\";s:2:\"21\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:5:{s:6:\"weight\";s:2:\"23\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:5:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:3:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:27:\"plugin.manager.field.widget\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"language_select\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1338;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1338;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1338;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1338;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"language_select\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Language select\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1338;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"uid\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:29:\"entity_reference_autocomplete\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1447;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1447;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"uid\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1447;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1447;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:8:{s:26:\"inline_entity_form_complex\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Inline entity form - Complex\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:25:\"inline_entity_form_simple\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Inline entity form - Simple\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"options_select\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Select list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"options_buttons\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Check boxes/radio buttons\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:34:\"entity_reference_autocomplete_tags\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Autocomplete (Tags style)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:29:\"entity_reference_autocomplete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Autocomplete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_entity_select\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Entity select\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:31:\"entity_browser_entity_reference\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1447;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"sku\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1584;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1584;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"sku\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1584;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1584;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Textfield\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1584;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:3:\"sku\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:17:\"sku_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"price\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1730;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1730;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1730;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1730;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:22:\"commerce_price_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1730;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:6:\"status\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"boolean_checkbox\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1839;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"3\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1839;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"status\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"status\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1839;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1839;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:16:\"boolean_checkbox\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Single on/off checkbox\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"options_buttons\";r:1535;}s:14:\"#default_value\";s:16:\"boolean_checkbox\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"status\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1839;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Use field label: @display_label\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@display_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Yes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:6:\"status\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:20:\"status_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:6:\"status\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:7:\"created\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:18:\"datetime_timestamp\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1989;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1989;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:7:\"created\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1989;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1989;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:18:\"datetime_timestamp\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Datetime Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1989;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:20:\"attribute_parameters\";a:9:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:29:\"entity_reference_autocomplete\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:10:\"Parameters\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Parameters\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Parameters\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:20:\"attribute_parameters\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:20:\"attribute_parameters\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Parameters\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Parameters\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:8:{s:26:\"inline_entity_form_complex\";r:1523;s:25:\"inline_entity_form_simple\";r:1527;s:14:\"options_select\";r:1531;s:15:\"options_buttons\";r:1535;s:34:\"entity_reference_autocomplete_tags\";r:1539;s:29:\"entity_reference_autocomplete\";r:1543;s:22:\"commerce_entity_select\";r:1547;s:31:\"entity_browser_entity_reference\";r:1551;}s:14:\"#default_value\";s:25:\"inline_entity_form_simple\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:20:\"attribute_parameters\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:20:\"attribute_parameters\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:77:\"Widget settings: <span class=\"plugin-name\">Inline entity form - Simple</span>\";}s:8:\"settings\";a:4:{s:9:\"form_mode\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:7:\"default\";s:8:\"#options\";a:1:{s:7:\"default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:9:\"#required\";b:1;}s:15:\"override_labels\";a:3:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Override labels\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";b:1;}s:14:\"label_singular\";a:4:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Singular label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:3:\"Aaa\";s:7:\"#states\";a:1:{s:7:\"visible\";a:1:{s:90:\":input[name=\"fields[attribute_parameters][settings_edit_form][settings][override_labels]\"]\";a:1:{s:7:\"checked\";b:1;}}}}s:12:\"label_plural\";a:4:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Plural label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:3:\"Bbb\";s:7:\"#states\";a:1:{s:7:\"visible\";a:1:{s:90:\":input[name=\"fields[attribute_parameters][settings_edit_form][settings][override_labels]\"]\";a:1:{s:7:\"checked\";b:1;}}}}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:20:\"attribute_parameters\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:43:\"attribute_parameters_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:20:\"attribute_parameters\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:43:\"attribute_parameters_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:20:\"attribute_parameters\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Parameters\";}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"field_color\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Color\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"22\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:16:\"group_properties\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_color\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1660;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_color\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_color_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:17:\"field_description\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:13:\"text_textarea\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:11:\"Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"9\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:17:\"field_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:13:\"text_textarea\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Text area (multiple rows)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:13:\"text_textarea\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Number of rows: @rows\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@rows\";i:5;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:17:\"field_description\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:31:\"field_description_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:12:\"field_images\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:11:\"image_image\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Images\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"4\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_images\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:11:\"image_image\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"entity_browser_file\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:19:\"entity_browser_file\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:3:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Preview image style: @style\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@style\";s:20:\"Thumbnail (100×100)\";}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Entity browser: @browser\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@browser\";s:17:\"Browser for files\";}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Selection mode: @selection_mode\";s:12:\"\0*\0arguments\";a:1:{s:15:\"@selection_mode\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Append to selection\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_images_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:12:\"field_length\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Length\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"24\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:16:\"group_properties\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_length\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1660;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_length\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_length_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"field_old_price\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Old Price\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_old_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:22:\"commerce_price_default\";r:1806;}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:28:\"field_right_side_description\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:13:\"text_textarea\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:22:\"Right Side Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"10\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"field_right_side_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:13:\"text_textarea\";r:2514;}s:14:\"#default_value\";s:13:\"text_textarea\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Number of rows: @rows\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@rows\";i:5;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:28:\"field_right_side_description\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:42:\"field_right_side_description_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"field_sale_text\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Sale text\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_sale_text\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1660;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_sale_text\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_sale_text_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:23:\"field_short_description\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"string_textarea\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:17:\"Short Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"8\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:23:\"field_short_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"string_textarea\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Text area (multiple rows)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:15:\"string_textarea\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Number of rows: @rows\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@rows\";i:5;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:23:\"field_short_description\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:37:\"field_short_description_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:10:\"field_size\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Size\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"21\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:16:\"group_properties\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_size\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1660;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"field_size\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"field_size_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:11:\"field_waist\";a:11:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:113;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:16:\"string_textfield\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Waist\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"23\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:16:\"group_properties\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_waist\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:16:\"string_textfield\";r:1660;}s:14:\"#default_value\";s:16:\"string_textfield\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Textfield size: @size\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@size\";i:60;}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_waist\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_waist_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"#parent_options\";a:1:{s:16:\"group_properties\";s:10:\"Properties\";}s:16:\"group_properties\";a:10:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:11:\"field-group\";}s:2:\"id\";s:16:\"group-properties\";}s:9:\"#row_type\";s:5:\"group\";s:16:\"#region_callback\";s:39:\"field_group_display_overview_row_region\";s:12:\"#js_settings\";a:1:{s:10:\"rowHandler\";s:5:\"group\";}s:10:\"human_name\";a:3:{s:7:\"#markup\";s:10:\"Properties\";s:7:\"#prefix\";s:26:\"<span class=\"group-label\">\";s:7:\"#suffix\";s:7:\"</span>\";}s:6:\"weight\";a:4:{s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";i:6;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:6:{s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:14:\"#default_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:16:\"group_properties\";i:2;s:6:\"parent\";}}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:16:\"group_properties\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"format\";a:1:{s:4:\"type\";a:4:{s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:9:\"accordion\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Accordion\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"accordion_item\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Accordion Item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"details\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Details\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"fieldset\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Fieldset\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"html_element\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"HTML element\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"tab\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Tab\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"tabs\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tabs\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:7:\"details\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"field-group-type\";}}}}s:16:\"settings_summary\";a:2:{s:7:\"#markup\";s:80:\"<div class=\"field-plugin-summary\">Default state open<br />Mark as required</div>\";s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;a:2:{i:0;r:113;i:1;s:15:\"multistepSubmit\";}}s:5:\"#ajax\";a:3:{s:8:\"callback\";a:2:{i:0;r:113;i:1;s:13:\"multistepAjax\";}s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:16:\"group_properties\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:36:\"group_properties_group_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:16:\"group_properties\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:123:\"</div><a href=\"/admin/commerce/config/product-variation-types/product/edit/form-display/group_properties/delete\">delete</a>\";}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_form_display_edit_form\";s:9:\"#build_id\";s:48:\"form-iVuQ3x0T9DbG5uzNUizYb7P6L9hKje-Xyk33OLl0X2o\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-iVuQ3x0T9DbG5uzNUizYb7P6L9hKje-Xyk33OLl0X2o\";s:3:\"#id\";s:48:\"form-iVuQ3x0T9DbG5uzNUizYb7P6L9hKje-Xyk33OLl0X2o\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-form-display-edit-form-form-token--AGsuX7A9SEE\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_WyiknlIgCcooIgmyXMx0oKEk6Tx_D8wbTwTDvdA1ttg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_form_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-form-display-edit-form--UhHWwN9FQZw\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-form-display-edit-form--RKok7o73HI4\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_form_display_edit_form\";i:1;s:24:\"entity_form_display_form\";}s:12:\"#fieldgroups\";a:1:{i:0;s:16:\"group_properties\";}s:8:\"#context\";r:1129;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503344522),

('form','form-J6nePn_eHT3SLJD-Qeq8eORGSogks1aKVTut3mCIB1U','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:515;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:515;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:569;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:569;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:701;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:701;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503323308\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:763;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:970;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:4:{s:5:\"#type\";s:6:\"weight\";s:6:\"#delta\";i:50;s:14:\"#default_value\";s:1:\"1\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"ief-entity-delta\";}}}s:7:\"actions\";a:4:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:21:\"ief-entity-operations\";}}s:15:\"ief_entity_edit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:58:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-edit-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:4:\"edit\";}s:17:\"ief_entity_remove\";a:9:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Remove\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:60:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-remove-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:6:\"remove\";s:7:\"#access\";b:1;}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302248\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 10:57\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-J6nePn_eHT3SLJD-Qeq8eORGSogks1aKVTut3mCIB1U\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-J6nePn_eHT3SLJD-Qeq8eORGSogks1aKVTut3mCIB1U\";s:3:\"#id\";s:48:\"form-J6nePn_eHT3SLJD-Qeq8eORGSogks1aKVTut3mCIB1U\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--Kd7wHm1oDDs\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--nSg0e0YkBjI\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--XRe-sQ_Q7K4\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503345123),

('form','form-KIpsGYH4QJwwrj5A3uAGXkYPv9c28yHF1aYyndZz7oY','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--Kv6sm2bImlA\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--Kv6sm2bImlA\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--Kv6sm2bImlA\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--Kv6sm2bImlA\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-KIpsGYH4QJwwrj5A3uAGXkYPv9c28yHF1aYyndZz7oY\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-KIpsGYH4QJwwrj5A3uAGXkYPv9c28yHF1aYyndZz7oY\";s:3:\"#id\";s:48:\"form-KIpsGYH4QJwwrj5A3uAGXkYPv9c28yHF1aYyndZz7oY\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--cpjsGzdFoAI\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--6Xd-OZjKHKk\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--nWV5iK-yDwA\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503429826),

('form','form-KjrcVC_hI-oiLiByZq_BF-xkX1Av2l3HtB0U1pZGjoo','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:2;s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:515;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:515;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:569;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:569;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:701;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:701;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503301542\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:763;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:19:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:43:\"Religion Jersey Polo Shirts - Medium, White\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:1001:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:43:\"Religion Jersey Polo Shirts - Medium, White\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:970;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:17:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:42:\"Religion Jersey Polo Shirts - Large, Green\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:42:\"Religion Jersey Polo Shirts - Large, Green\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:4:{s:5:\"#type\";s:6:\"weight\";s:6:\"#delta\";i:50;s:14:\"#default_value\";s:1:\"1\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"ief-entity-delta\";}}}s:7:\"actions\";a:4:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:21:\"ief-entity-operations\";}}s:15:\"ief_entity_edit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:58:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-edit-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:4:\"edit\";}s:17:\"ief_entity_remove\";a:9:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Remove\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:60:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-remove-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:6:\"remove\";s:7:\"#access\";b:1;}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503053967\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/18/2017 - 13:59\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:4:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053967\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}s:5:\"query\";a:1:{s:11:\"destination\";s:24:\"/admin/commerce/products\";}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-KjrcVC_hI-oiLiByZq_BF-xkX1Av2l3HtB0U1pZGjoo\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-KjrcVC_hI-oiLiByZq_BF-xkX1Av2l3HtB0U1pZGjoo\";s:3:\"#id\";s:48:\"form-KjrcVC_hI-oiLiByZq_BF-xkX1Av2l3HtB0U1pZGjoo\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--vYFmjzONKDw\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form---PMkNGS7acM\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--ROyoF3_qZW8\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503323579),

('form','form-KPGWS6ijS5dNBRWMbt7RpzF-5YCnX8cDdqi1M9dgOhg','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--dGfk8v2reWc\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--dGfk8v2reWc\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--dGfk8v2reWc\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--dGfk8v2reWc\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-KPGWS6ijS5dNBRWMbt7RpzF-5YCnX8cDdqi1M9dgOhg\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-KPGWS6ijS5dNBRWMbt7RpzF-5YCnX8cDdqi1M9dgOhg\";s:3:\"#id\";s:48:\"form-KPGWS6ijS5dNBRWMbt7RpzF-5YCnX8cDdqi1M9dgOhg\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--_ScHWjmJ2-I\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--NEfnpGgNKcE\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--WiuZTGPkJbw\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503348521),

('form','form-lHycbVzke8HCaJRfq-WEQLIqBd-eRCMD3toA3NmXhrA','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--UmBaVW006rE\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--UmBaVW006rE\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--UmBaVW006rE\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--UmBaVW006rE\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-lHycbVzke8HCaJRfq-WEQLIqBd-eRCMD3toA3NmXhrA\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-lHycbVzke8HCaJRfq-WEQLIqBd-eRCMD3toA3NmXhrA\";s:3:\"#id\";s:48:\"form-lHycbVzke8HCaJRfq-WEQLIqBd-eRCMD3toA3NmXhrA\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--V7q5DhxozU8\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--NKQgRpUYB8M\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--HWzxULd5-Vs\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503428747),

('form','form-Lzu0q9PjSP34OVR-L_9VaQ90nfD-Ipb-1Nz6C37V8Ew','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--Y8dFgS1tWYM\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--Y8dFgS1tWYM\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--Y8dFgS1tWYM\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--Y8dFgS1tWYM\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-Lzu0q9PjSP34OVR-L_9VaQ90nfD-Ipb-1Nz6C37V8Ew\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-Lzu0q9PjSP34OVR-L_9VaQ90nfD-Ipb-1Nz6C37V8Ew\";s:3:\"#id\";s:48:\"form-Lzu0q9PjSP34OVR-L_9VaQ90nfD-Ipb-1Nz6C37V8Ew\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--UWCuIxCcBvs\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--Gov5Tyl9W_U\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--y9pQLsgUB_A\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503432181),

('form','form-MHyF_N6w2x7Jk_vyjjcuddGTWhYSPHo6-NDqMaD8Mew','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--246B0k-pwGM\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--246B0k-pwGM\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--246B0k-pwGM\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--246B0k-pwGM\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-MHyF_N6w2x7Jk_vyjjcuddGTWhYSPHo6-NDqMaD8Mew\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-MHyF_N6w2x7Jk_vyjjcuddGTWhYSPHo6-NDqMaD8Mew\";s:3:\"#id\";s:48:\"form-MHyF_N6w2x7Jk_vyjjcuddGTWhYSPHo6-NDqMaD8Mew\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--hLo_gIUy8Ys\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--AlZ-1r4a6TU\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--3SBYI8j9hnI\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503435938),

('form','form-MMZq3QHcrBRNg7ZO7hpRCgilSXjs84-3OT17KIonsQs','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--t1cCQNT33dc\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--t1cCQNT33dc\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--t1cCQNT33dc\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--t1cCQNT33dc\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-MMZq3QHcrBRNg7ZO7hpRCgilSXjs84-3OT17KIonsQs\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-MMZq3QHcrBRNg7ZO7hpRCgilSXjs84-3OT17KIonsQs\";s:3:\"#id\";s:48:\"form-MMZq3QHcrBRNg7ZO7hpRCgilSXjs84-3OT17KIonsQs\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--TQR0b7w2yCY\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--p_OXfYztKMU\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--JmgZ4-m7UbE\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503437771),

('form','form-muogwBGxIAJIlD8fdRxJQBT2_WZaH2GYD3WnOq9x1Go','a:29:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--YAIqrowmKho\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--YAIqrowmKho\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--YAIqrowmKho\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--YAIqrowmKho\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-muogwBGxIAJIlD8fdRxJQBT2_WZaH2GYD3WnOq9x1Go\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-muogwBGxIAJIlD8fdRxJQBT2_WZaH2GYD3WnOq9x1Go\";s:3:\"#id\";s:48:\"form-muogwBGxIAJIlD8fdRxJQBT2_WZaH2GYD3WnOq9x1Go\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--1VRv7x5Q5BA\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--_h8f6POvvOg\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1503428865),

('form','form-nkielTvksvis4pWlLPz-flitiRIj0w5hONNfGieqRhc','a:35:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:74:\"config:core.entity_view_display.commerce_product_variation.product.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:7:\"#fields\";a:15:{i:0;s:8:\"langcode\";i:1;s:10:\"product_id\";i:2;s:3:\"sku\";i:3;s:5:\"title\";i:4;s:5:\"price\";i:5;s:11:\"field_color\";i:6;s:17:\"field_description\";i:7;s:12:\"field_images\";i:8;s:12:\"field_length\";i:9;s:15:\"field_old_price\";i:10;s:28:\"field_right_side_description\";i:11;s:15:\"field_sale_text\";i:12;s:23:\"field_short_description\";i:13;s:10:\"field_size\";i:14;s:11:\"field_waist\";}s:6:\"#extra\";a:1:{i:0;s:28:\"commerce_variation_cart_form\";}s:6:\"fields\";a:22:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:226;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:226;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:226;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"bc5d6188-cefe-4350-a39e-4005f7f36258\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:12:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:58:\"field.field.commerce_product_variation.product.field_color\";i:2;s:64:\"field.field.commerce_product_variation.product.field_description\";i:3;s:59:\"field.field.commerce_product_variation.product.field_images\";i:4;s:59:\"field.field.commerce_product_variation.product.field_length\";i:5;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:6;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:7;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:8;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:9;s:57:\"field.field.commerce_product_variation.product.field_size\";i:10;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:11;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:10:\"rhythm_cms\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:14:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:2:\"13\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:11:\"field_color\";a:6:{s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";s:1:\"2\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:5:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:17:\"image_style_small\";s:19:\"product_small_68x86\";s:3:\"col\";s:1:\"3\";s:4:\"zoom\";i:0;s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";s:1:\"7\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";s:1:\"5\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";s:1:\"6\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";s:1:\"8\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:6:{s:6:\"weight\";s:1:\"9\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:2:{s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1314;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"product_id\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"product_id\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"product_id\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1442;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"sku\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"3\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"sku\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1582;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:3:\"sku\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:17:\"sku_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:3:\"sku\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"title\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"title\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1735;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"title\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"title_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:5:\"price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:20:\"commerce_price_plain\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Plain\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_price_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:25:\"commerce_price_calculated\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Calculated price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1885;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:11:\"field_color\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Color\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"10\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_color\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Color\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_color\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_color_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_color\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:17:\"field_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:11:\"Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"4\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:17:\"field_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"text_trimmed\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Trimmed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"text_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:17:\"field_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:11:\"Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:12:\"field_images\";a:10:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:5:\"image\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Images\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_images\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:24:\"rhythm_cms_images_slider\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rhythm CMS: Image Slider\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"rhythm_cms_images_one_main\";r:1537;s:9:\"image_url\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"URL to image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"image\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:26:\"rhythm_cms_images_one_main\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:77:\"Format settings: <span class=\"plugin-name\">Rhythm CMS: Images One Main</span>\";}s:8:\"settings\";a:4:{s:11:\"image_style\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Image Style for Main Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:14:\"#default_value\";s:20:\"product_main_360x459\";s:13:\"#empty_option\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"None (original image)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:23:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:25:\"file_entity_browser_small\";s:35:\"File Entity Browser small thumbnail\";s:29:\"file_entity_browser_thumbnail\";s:29:\"File Entity Browser thumbnail\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:5:\"large\";s:16:\"Large (480×480)\";s:15:\"md_slider_thumb\";s:15:\"MD Slider Thumb\";s:6:\"medium\";s:17:\"Medium (220×220)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";s:15:\"product_263x335\";s:17:\"Product (263x335)\";s:13:\"product_70x70\";s:15:\"Product (70x70)\";s:20:\"product_main_360x459\";s:22:\"Product Main (360x459)\";s:19:\"product_small_68x86\";s:21:\"Product Small (68x86)\";s:12:\"slider_pager\";s:12:\"Slider Pager\";s:9:\"thumbnail\";s:20:\"Thumbnail (100×100)\";}s:12:\"#description\";a:4:{s:5:\"#type\";s:4:\"link\";s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:29:\"entity.image_style.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Configure Image Styles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;}}s:17:\"image_style_small\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Image Style for Small Images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:6:\"select\";s:14:\"#default_value\";s:19:\"product_small_68x86\";s:13:\"#empty_option\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"None (original image)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:23:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:25:\"file_entity_browser_small\";s:35:\"File Entity Browser small thumbnail\";s:29:\"file_entity_browser_thumbnail\";s:29:\"File Entity Browser thumbnail\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:5:\"large\";s:16:\"Large (480×480)\";s:15:\"md_slider_thumb\";s:15:\"MD Slider Thumb\";s:6:\"medium\";s:17:\"Medium (220×220)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";s:15:\"product_263x335\";s:17:\"Product (263x335)\";s:13:\"product_70x70\";s:15:\"Product (70x70)\";s:20:\"product_main_360x459\";s:22:\"Product Main (360x459)\";s:19:\"product_small_68x86\";s:21:\"Product Small (68x86)\";s:12:\"slider_pager\";s:12:\"Slider Pager\";s:9:\"thumbnail\";s:20:\"Thumbnail (100×100)\";}s:12:\"#description\";a:4:{s:5:\"#type\";s:4:\"link\";s:4:\"#url\";r:2500;s:6:\"#title\";r:2512;s:7:\"#access\";b:1;}}s:3:\"col\";a:4:{s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:4:{i:2;i:2;i:3;i:3;i:4;i:4;i:6;i:6;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Columns Count for Small Images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:1:\"3\";}s:4:\"zoom\";a:3:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add Zoom feature\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";b:1;}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:35:\"field_images_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_images\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:35:\"field_images_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_images\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Images\";}s:10:\"\0*\0options\";a:0:{}}}}s:12:\"field_length\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Length\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"12\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_length\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Length\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_length\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_length_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_length\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"field_old_price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Old Price\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"7\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_old_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:20:\"commerce_price_plain\";r:1980;s:22:\"commerce_price_default\";r:1984;s:25:\"commerce_price_calculated\";r:1988;}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Old Price\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_old_price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_old_price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_old_price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:28:\"field_right_side_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"text_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:22:\"Right Side Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"field_right_side_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:12:\"text_default\";r:2300;s:12:\"text_trimmed\";r:2304;}s:14:\"#default_value\";s:12:\"text_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"field_right_side_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:22:\"Right Side Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:15:\"field_sale_text\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:9:\"Sale text\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"6\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"field_sale_text\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:9:\"Sale text\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:15:\"field_sale_text\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:29:\"field_sale_text_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:15:\"field_sale_text\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:23:\"field_short_description\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:12:\"basic_string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:17:\"Short Description\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"8\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:23:\"field_short_description\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:12:\"basic_string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:12:\"basic_string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:23:\"field_short_description\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:17:\"Short Description\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"field_size\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Size\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"9\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_size\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Size\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"field_size\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"field_size_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_size\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:11:\"field_waist\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:5:\"Waist\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"11\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"field_waist\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";r:1677;}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:5:\"Waist\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"field_waist\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"field_waist_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"field_waist\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:28:\"commerce_variation_cart_form\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:11:\"extra_field\";s:16:\"#region_callback\";a:2:{i:0;r:116;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:1:{s:10:\"rowHandler\";s:5:\"field\";}s:10:\"human_name\";a:1:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3634;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"13\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Parents for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3634;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:28:\"commerce_variation_cart_form\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:3634;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:10:\"empty_cell\";a:1:{s:7:\"#markup\";s:6:\"&nbsp;\";}s:6:\"plugin\";a:1:{s:4:\"type\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:7:\"visible\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}}s:16:\"settings_summary\";a:1:{s:7:\"combine\";a:3:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Combine order items containing the same product variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:1:\"1\";}}s:13:\"settings_edit\";a:0:{}}s:15:\"#parent_options\";a:0:{}}s:5:\"modes\";a:4:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Custom display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"display_modes_custom\";a:4:{s:5:\"#type\";s:10:\"checkboxes\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"Use custom display settings for the following @display_context modes\";s:12:\"\0*\0arguments\";a:1:{s:16:\"@display_context\";s:4:\"view\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:4:{s:4:\"cart\";s:4:\"Cart\";s:7:\"product\";s:7:\"Product\";s:7:\"summary\";s:7:\"Summary\";s:5:\"token\";s:5:\"Token\";}s:14:\"#default_value\";a:2:{i:0;s:4:\"cart\";i:1;s:7:\"product\";}}s:18:\"display_modes_link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Manage view modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:34:\"entity.entity_view_mode.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-nkielTvksvis4pWlLPz-flitiRIj0w5hONNfGieqRhc\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-nkielTvksvis4pWlLPz-flitiRIj0w5hONNfGieqRhc\";s:3:\"#id\";s:48:\"form-nkielTvksvis4pWlLPz-flitiRIj0w5hONNfGieqRhc\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--QRI6W2UN-a4\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--QFhSRtuiHoc\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--xXpn3_ekZdc\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:16:\"#entity_builders\";a:1:{i:0;s:71:\"commerce_variation_cart_form_form_entity_view_display_edit_form_builder\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1132;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503337847),

('form','form-OhgjwZRZJS3kQ4iu4mNZ45d1Pzqu9KBukcqvYwa1lfw','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--kefaWcpFoNk\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--kefaWcpFoNk\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--kefaWcpFoNk\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--kefaWcpFoNk\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-OhgjwZRZJS3kQ4iu4mNZ45d1Pzqu9KBukcqvYwa1lfw\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-OhgjwZRZJS3kQ4iu4mNZ45d1Pzqu9KBukcqvYwa1lfw\";s:3:\"#id\";s:48:\"form-OhgjwZRZJS3kQ4iu4mNZ45d1Pzqu9KBukcqvYwa1lfw\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--8yFRsuKSduc\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--sgL8xyh9a4U\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--Dp0uZnG1UBY\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503436133),

('form','form-O_oyFE-AW0LB-gmLhcCjFbIjKAD5-npKMp8ejZIzwL4','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:3\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:47:53.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"39\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"294555b9-3cc5-4a85-b9f9-5be52efc76ff\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:7:\"Digital\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053356\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"39\";s:4:\"uuid\";s:36:\"294555b9-3cc5-4a85-b9f9-5be52efc76ff\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:7:\"Digital\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:515;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:3:\"und\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:515;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:569;s:14:\"#default_value\";s:36:\"/product/g-star-polo-applique-jersey\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"22\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/3\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:3:\"und\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:569;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:701;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"G-Star Polo Applique Jersey\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:701;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503302531\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:763;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:5:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"3158\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"94.750000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053515\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302373\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:2:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:10:\"150.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";i:0;s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";i:0;}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:3:\"und\";s:14:\"#default_value\";r:970;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302373\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 10:59\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"3\";}s:10:\"\0*\0options\";a:4:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"und\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"G-Star Polo Applique Jersey\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053273\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302373\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"39\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"3\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:3:\"und\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:13:\"Not specified\";s:5:\"\0*\0id\";s:3:\"und\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:3;s:9:\"\0*\0locked\";b:1;}s:5:\"query\";a:1:{s:11:\"destination\";s:24:\"/admin/commerce/products\";}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-O_oyFE-AW0LB-gmLhcCjFbIjKAD5-npKMp8ejZIzwL4\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-O_oyFE-AW0LB-gmLhcCjFbIjKAD5-npKMp8ejZIzwL4\";s:3:\"#id\";s:48:\"form-O_oyFE-AW0LB-gmLhcCjFbIjKAD5-npKMp8ejZIzwL4\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--YQbIK1VVRGE\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--6vGJgTIYwYw\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--cPAt7U-DuLU\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503324160),

('form','form-p3OLmma77IvF7RmdWMVNB2ZK-pbr5_1pYCgENLJFhkI','a:29:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--dsLid8nKh6Q\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--dsLid8nKh6Q\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--dsLid8nKh6Q\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--dsLid8nKh6Q\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-p3OLmma77IvF7RmdWMVNB2ZK-pbr5_1pYCgENLJFhkI\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-p3OLmma77IvF7RmdWMVNB2ZK-pbr5_1pYCgENLJFhkI\";s:3:\"#id\";s:48:\"form-p3OLmma77IvF7RmdWMVNB2ZK-pbr5_1pYCgENLJFhkI\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--43t5TEawy3M\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--8MQrZ4qNx9Y\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1503450250),

('form','form-PF6kb4UnGi34hyuJKwEuoftn-8m_6NreAq5RMxOsX_E','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--R1MtH9lW84E\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--R1MtH9lW84E\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--R1MtH9lW84E\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--R1MtH9lW84E\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-PF6kb4UnGi34hyuJKwEuoftn-8m_6NreAq5RMxOsX_E\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-PF6kb4UnGi34hyuJKwEuoftn-8m_6NreAq5RMxOsX_E\";s:3:\"#id\";s:48:\"form-PF6kb4UnGi34hyuJKwEuoftn-8m_6NreAq5RMxOsX_E\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--KIjzFOuXsd4\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--Q56Iw8UKJM0\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--0HzQVG7xiUM\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503451536),

('form','form-Phz3-STw6NpkNP0gUmy9jpaF8YBmJ7DY9xNKRd25-Ro','a:34:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:72:\"config:core.entity_view_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:16:\"commerce_product\";s:7:\"#bundle\";s:15:\"product_display\";s:7:\"#fields\";a:9:{i:0;s:8:\"langcode\";i:1;s:3:\"uid\";i:2;s:7:\"created\";i:3;s:14:\"field_category\";i:4;s:12:\"field_rating\";i:5;s:13:\"field_reviews\";i:6;s:10:\"field_tags\";i:7;s:6:\"stores\";i:8;s:10:\"variations\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:15:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:219;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:219;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:219;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"09d511c6-2622-4997-b678-90c8ff763aed\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"core.entity_view_display.comment.default_reviews.default\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:3:{i:0;s:7:\"comment\";i:1;s:16:\"commerce_product\";i:2;s:8:\"fivestar\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:6:{s:14:\"field_category\";a:6:{s:6:\"weight\";s:1:\"2\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:12:\"field_rating\";a:6:{s:6:\"weight\";s:1:\"0\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:40:\"modules/fivestar/widgets/basic/basic.css\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"fivestar_stars\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:6:{s:6:\"weight\";s:1:\"3\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:4:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1237;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"uid\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"uid\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:6:\"author\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1365;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:7:\"created\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:9:\"timestamp\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1509;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1509;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:7:\"created\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1509;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1509;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1509;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:13:\"timestamp_ago\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Time ago\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"timestamp\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1509;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:14:\"field_category\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:8:\"Category\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"field_category\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:29:\"entity_reference_rss_category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"RSS category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"rhythm_cms_images_one_main\";r:1464;s:28:\"entity_reference_entity_view\";r:1468;s:22:\"entity_reference_label\";r:1472;s:26:\"entity_reference_entity_id\";r:1476;}s:14:\"#default_value\";s:22:\"entity_reference_label\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Link to the referenced entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:14:\"field_category\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:28:\"field_category_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:12:\"field_rating\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:14:\"fivestar_stars\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Rating\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_rating\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:14:\"fivestar_stars\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"As stars\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"fivestar_percentage\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Percentage (i.e. 92)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"fivestar_rating\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Rating (i.e. 4.2/5)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:14:\"fivestar_stars\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:12:\"field_rating\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:26:\"field_rating_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:13:\"field_reviews\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"comment_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:7:\"Reviews\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"4\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:13:\"field_reviews\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"comment_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:15:\"comment_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Comment view mode: @mode\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@mode\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:13:\"field_reviews\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:27:\"field_reviews_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:10:\"field_tags\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Tags\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"3\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_tags\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"inline\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:29:\"entity_reference_rss_category\";r:1733;s:26:\"rhythm_cms_images_one_main\";r:1464;s:28:\"entity_reference_entity_view\";r:1468;s:22:\"entity_reference_label\";r:1472;s:26:\"entity_reference_entity_id\";r:1476;}s:14:\"#default_value\";s:22:\"entity_reference_label\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Link to the referenced entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"field_tags\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"field_tags_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:6:\"stores\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Stores\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"stores\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1464;s:28:\"entity_reference_entity_view\";r:1468;s:22:\"entity_reference_label\";r:1472;s:26:\"entity_reference_entity_id\";r:1476;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"variations\";a:10:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:10:\"Variations\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"variations\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:6:{s:26:\"rhythm_cms_images_one_main\";r:1464;s:28:\"entity_reference_entity_view\";r:1468;s:22:\"entity_reference_label\";r:1472;s:26:\"entity_reference_entity_id\";r:1476;s:20:\"commerce_add_to_cart\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:36:\"commerce_product_attributes_overview\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Product attributes overview\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:20:\"commerce_add_to_cart\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:66:\"Format settings: <span class=\"plugin-name\">Add to cart form</span>\";}s:8:\"settings\";a:1:{s:7:\"combine\";a:4:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Combine order items containing the same product variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:130:\"The order item type, referenced product variation, and data from fields exposed on the Add to Cart form must all match to combine.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";b:1;}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"variations\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:33:\"variations_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"variations\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:33:\"variations_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}}}s:15:\"#parent_options\";a:0:{}}s:5:\"modes\";a:4:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Custom display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"display_modes_custom\";a:4:{s:5:\"#type\";s:10:\"checkboxes\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"Use custom display settings for the following @display_context modes\";s:12:\"\0*\0arguments\";a:1:{s:16:\"@display_context\";s:4:\"view\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:1:{s:5:\"token\";s:5:\"Token\";}s:14:\"#default_value\";a:0:{}}s:18:\"display_modes_link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Manage view modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:34:\"entity.entity_view_mode.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-Phz3-STw6NpkNP0gUmy9jpaF8YBmJ7DY9xNKRd25-Ro\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-Phz3-STw6NpkNP0gUmy9jpaF8YBmJ7DY9xNKRd25-Ro\";s:3:\"#id\";s:48:\"form-Phz3-STw6NpkNP0gUmy9jpaF8YBmJ7DY9xNKRd25-Ro\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--NK_2TNQR3ZU\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--0AskPV_TS_k\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--HaoXdQrOqKo\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1125;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503430973),

('form','form-PO-4hopQvJB9CvCxzO-ILZpLS1ziMyIvoan0Jfndq7c','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:515;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:515;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:569;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:569;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:701;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:701;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503322861\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:763;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:970;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:4:{s:5:\"#type\";s:6:\"weight\";s:6:\"#delta\";i:50;s:14:\"#default_value\";s:1:\"1\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"ief-entity-delta\";}}}s:7:\"actions\";a:4:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:21:\"ief-entity-operations\";}}s:15:\"ief_entity_edit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:58:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-edit-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:4:\"edit\";}s:17:\"ief_entity_remove\";a:9:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Remove\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:60:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-remove-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:6:\"remove\";s:7:\"#access\";b:1;}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302248\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 10:57\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-PO-4hopQvJB9CvCxzO-ILZpLS1ziMyIvoan0Jfndq7c\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-PO-4hopQvJB9CvCxzO-ILZpLS1ziMyIvoan0Jfndq7c\";s:3:\"#id\";s:48:\"form-PO-4hopQvJB9CvCxzO-ILZpLS1ziMyIvoan0Jfndq7c\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--T2Zk0MN1ggM\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--lcMIvqVC160\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--pm-uw4x_-Qk\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503344505),

('form','form-qqPaEnsPW0kgTuxC8u798VNxYCpJw3IAG6bveF8uXL8','a:29:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--UkUVYG_58ns\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--UkUVYG_58ns\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--UkUVYG_58ns\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--UkUVYG_58ns\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-qqPaEnsPW0kgTuxC8u798VNxYCpJw3IAG6bveF8uXL8\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-qqPaEnsPW0kgTuxC8u798VNxYCpJw3IAG6bveF8uXL8\";s:3:\"#id\";s:48:\"form-qqPaEnsPW0kgTuxC8u798VNxYCpJw3IAG6bveF8uXL8\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--YRMOv7n_kUg\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--RKuetXkpppU\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1503451181),

('form','form-Qx7gOrLMaFt65VWU7HLmMHEVfLV3tAjpTrzb-If7fHA','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--XNNlnFJvvQA\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--XNNlnFJvvQA\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--XNNlnFJvvQA\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--XNNlnFJvvQA\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-Qx7gOrLMaFt65VWU7HLmMHEVfLV3tAjpTrzb-If7fHA\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-Qx7gOrLMaFt65VWU7HLmMHEVfLV3tAjpTrzb-If7fHA\";s:3:\"#id\";s:48:\"form-Qx7gOrLMaFt65VWU7HLmMHEVfLV3tAjpTrzb-If7fHA\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--Lt1gA6qPXa4\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--_0KvYyfblFE\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--MusclXssMh4\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503429930),

('form','form-rlHzZnbIBnmfOeqkQZ9mQBx51p7CX-iOWcB8HPtmYLY','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--Jl1ME54hmA0\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--Jl1ME54hmA0\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--Jl1ME54hmA0\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--Jl1ME54hmA0\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-rlHzZnbIBnmfOeqkQZ9mQBx51p7CX-iOWcB8HPtmYLY\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-rlHzZnbIBnmfOeqkQZ9mQBx51p7CX-iOWcB8HPtmYLY\";s:3:\"#id\";s:48:\"form-rlHzZnbIBnmfOeqkQZ9mQBx51p7CX-iOWcB8HPtmYLY\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--wwlu-_7EDlY\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--XUQ8kFPp5rU\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--_o3Ip-fNud0\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503429059),

('form','form-RuLxIh4ypDcYFYjRNhMxIgeXHi722x2CPUSizlORj_U','a:28:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--M4HjJdjHsz0\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--M4HjJdjHsz0\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:14:\"attribute_size\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:2:{i:2;s:6:\"Medium\";i:3;s:5:\"Large\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:1:\"3\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--M4HjJdjHsz0\";}}s:15:\"attribute_color\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:1:{i:7;s:5:\"Green\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:1:\"7\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--M4HjJdjHsz0\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-RuLxIh4ypDcYFYjRNhMxIgeXHi722x2CPUSizlORj_U\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-RuLxIh4ypDcYFYjRNhMxIgeXHi722x2CPUSizlORj_U\";s:3:\"#id\";s:48:\"form-RuLxIh4ypDcYFYjRNhMxIgeXHi722x2CPUSizlORj_U\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--O7LrBlXijzw\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--AKvPz9m7RMM\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--SOZw7PWNxwE\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503075641),

('form','form-T4cUFEVkYlxvvkMJOnl-c2kkLi0woJ8lgwUVbM6dtz4','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:3\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:47:53.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"39\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"294555b9-3cc5-4a85-b9f9-5be52efc76ff\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:7:\"Digital\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053356\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"39\";s:4:\"uuid\";s:36:\"294555b9-3cc5-4a85-b9f9-5be52efc76ff\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:7:\"Digital\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:515;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:3:\"und\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:515;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:569;s:14:\"#default_value\";s:36:\"/product/g-star-polo-applique-jersey\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"22\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/3\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:3:\"und\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:569;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:701;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"G-Star Polo Applique Jersey\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:701;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503433306\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:763;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:5:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"3158\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"94.750000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053515\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503317128\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"66\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"240\";s:6:\"height\";s:3:\"320\";}i:3;a:5:{s:9:\"target_id\";s:2:\"67\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"240\";s:6:\"height\";s:3:\"320\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:10:\"150.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"Sale\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:0:{}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";i:0;s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";i:0;}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:3:\"und\";s:14:\"#default_value\";r:970;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503317128\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 15:05\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"3\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"und\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"G-Star Polo Applique Jersey\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053273\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503317128\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"39\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"3\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:3:\"und\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:13:\"Not specified\";s:5:\"\0*\0id\";s:3:\"und\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:3;s:9:\"\0*\0locked\";b:1;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-T4cUFEVkYlxvvkMJOnl-c2kkLi0woJ8lgwUVbM6dtz4\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-T4cUFEVkYlxvvkMJOnl-c2kkLi0woJ8lgwUVbM6dtz4\";s:3:\"#id\";s:48:\"form-T4cUFEVkYlxvvkMJOnl-c2kkLi0woJ8lgwUVbM6dtz4\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--hbVARW9lhIc\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--l3YhQy_pz9M\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--F5V82d4MCj4\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503455035),

('form','form-TlOSv391S-nCLrhbG4ibS_QnP30bE3nvly8WfmLYpr4','a:26:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:19:\"editor-image-dialog\";}s:20:\"data-drupal-selector\";s:19:\"editor-image-dialog\";}s:5:\"#tree\";b:1;s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:27:\"editor/drupal.editor.dialog\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#prefix\";s:35:\"<div id=\"editor-image-dialog-form\">\";s:7:\"#suffix\";s:6:\"</div>\";s:3:\"fid\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:12:\"managed_file\";s:16:\"#upload_location\";s:22:\"public://inline-images\";s:14:\"#default_value\";N;s:18:\"#upload_validators\";a:3:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"gif png jpg jpeg\";}s:18:\"file_validate_size\";a:1:{i:0;d:0;}s:30:\"file_validate_image_resolution\";a:1:{i:0;i:0;}}s:9:\"#required\";b:1;}s:10:\"attributes\";a:2:{s:3:\"src\";a:6:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URL\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:80:\"http://local.rhythm.nikadevs.com/sites/rhythm.nikadevs.com/files/user-avatar.png\";s:10:\"#maxlength\";i:2048;s:9:\"#required\";b:0;s:7:\"#access\";b:0;}s:3:\"alt\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Alternative text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#placeholder\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Short description for the visually impaired\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:9:\"textfield\";s:9:\"#required\";b:1;s:15:\"#required_error\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:181:\"Alternative text is required.<br />(Only in rare cases should this be left empty. To create empty alternative text, enter <code>\"\"</code> — two double quotes without any content).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:2:\"\"\"\";s:10:\"#maxlength\";i:2048;}}s:7:\"actions\";a:2:{s:5:\"#type\";s:7:\"actions\";s:10:\"save_modal\";a:4:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:12:\"::submitForm\";s:5:\"event\";s:5:\"click\";}}}s:8:\"#form_id\";s:19:\"editor_image_dialog\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:9:\"#build_id\";s:48:\"form-TlOSv391S-nCLrhbG4ibS_QnP30bE3nvly8WfmLYpr4\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-TlOSv391S-nCLrhbG4ibS_QnP30bE3nvly8WfmLYpr4\";s:3:\"#id\";s:48:\"form-TlOSv391S-nCLrhbG4ibS_QnP30bE3nvly8WfmLYpr4\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:48:\"edit-editor-image-dialog-form-token--9lqq7wl3LW4\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_K44hCNoxpGG2xaOE9p_4L-o522F-VWv-Zt0aQJRrNJI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:19:\"editor_image_dialog\";s:3:\"#id\";s:37:\"edit-editor-image-dialog--Y1B-zTjyDpU\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:32:\"editor-image-dialog--86A6IF3AGio\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:19:\"editor_image_dialog\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503590933),

('form','form-TSHweCSqeRY1vB8UXIelp3gn49cadqujBysT4JHrlbU','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--2uC24OSHiDY\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--2uC24OSHiDY\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--2uC24OSHiDY\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--2uC24OSHiDY\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-TSHweCSqeRY1vB8UXIelp3gn49cadqujBysT4JHrlbU\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-TSHweCSqeRY1vB8UXIelp3gn49cadqujBysT4JHrlbU\";s:3:\"#id\";s:48:\"form-TSHweCSqeRY1vB8UXIelp3gn49cadqujBysT4JHrlbU\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token---V3E_IgZ1H8\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--LQJZ7lRiok4\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--gX2FB6SINdg\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503428499),

('form','form-tXqAWiXuv_QdiUMFFVb-DWNzjM6kW0VdIH_iHbYg6fE','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--moVLf7EO6Z0\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--moVLf7EO6Z0\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--moVLf7EO6Z0\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--moVLf7EO6Z0\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-tXqAWiXuv_QdiUMFFVb-DWNzjM6kW0VdIH_iHbYg6fE\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-tXqAWiXuv_QdiUMFFVb-DWNzjM6kW0VdIH_iHbYg6fE\";s:3:\"#id\";s:48:\"form-tXqAWiXuv_QdiUMFFVb-DWNzjM6kW0VdIH_iHbYg6fE\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--HgchXbUoXVs\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--UWqIPkxA7nw\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--Izw82CQbEF8\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503435849),

('form','form-uaCg2oF2aqfUR_s_-KTXcwYOji4gf-vwC9dheZF9dQ8','a:28:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:32:\"commerce-checkout-flow-edit-form\";i:1;s:27:\"commerce-checkout-flow-form\";}s:20:\"data-drupal-selector\";s:32:\"commerce-checkout-flow-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:55:\"config:commerce_checkout.commerce_checkout_flow.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:5:\"#tree\";b:1;s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:23:\"commerce_checkout/admin\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:5:\"label\";a:5:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"#maxlength\";i:255;s:14:\"#default_value\";s:7:\"Default\";s:9:\"#required\";b:1;}s:2:\"id\";a:4:{s:5:\"#type\";s:12:\"machine_name\";s:14:\"#default_value\";s:7:\"default\";s:13:\"#machine_name\";a:1:{s:6:\"exists\";s:51:\"\\Drupal\\commerce_checkout\\Entity\\CheckoutFlow::load\";}s:9:\"#disabled\";b:1;}s:6:\"plugin\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:1:{s:17:\"multistep_default\";s:19:\"Multistep - Default\";}s:14:\"#default_value\";s:17:\"multistep_default\";s:9:\"#required\";b:1;s:9:\"#disabled\";b:1;}s:13:\"configuration\";a:3:{s:8:\"#parents\";a:1:{i:0;s:13:\"configuration\";}s:25:\"display_checkout_progress\";a:4:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Display checkout progress\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Used by the checkout progress block to determine visibility.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";b:1;}s:5:\"panes\";a:28:{s:5:\"#type\";s:5:\"table\";s:7:\"#header\";a:4:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Pane\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Step\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:2;}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:22:\"checkout-pane-overview\";}s:2:\"id\";s:22:\"checkout-pane-overview\";}s:7:\"#prefix\";s:54:\"<div id=\"checkout-pane-overview-wrapper--L0dOvk5jl6Q\">\";s:7:\"#suffix\";s:6:\"</div>\";s:11:\"#wrapper_id\";s:43:\"checkout-pane-overview-wrapper--L0dOvk5jl6Q\";s:10:\"#tabledrag\";a:2:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:11:\"pane-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:4:\"self\";s:5:\"group\";s:9:\"pane-step\";s:8:\"subgroup\";s:9:\"pane-step\";s:6:\"source\";s:7:\"pane-id\";}}s:12:\"region-login\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:12:\"region-title\";}s:11:\"no_striping\";b:1;}s:5:\"title\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:20:\"region-login-message\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:14:\"region-message\";i:1;s:20:\"region-login-message\";i:2;s:16:\"region-populated\";}s:11:\"no_striping\";b:1;}s:7:\"message\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"No pane is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:5:\"login\";a:6:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Login or continue as guest\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:138;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:0;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"pane-weight\";}}}s:12:\"step_wrapper\";a:3:{s:8:\"#parents\";a:3:{i:0;s:13:\"configuration\";i:1;s:5:\"panes\";i:2;s:5:\"login\";}s:7:\"step_id\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Checkout step for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:138;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:7:{s:5:\"login\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"order_information\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"review\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"payment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"complete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"_sidebar\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Sidebar\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"_disabled\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:5:\"login\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-pane-step\";i:1;s:9:\"pane-step\";}}}s:7:\"pane_id\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"login\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"pane-id\";}}}}s:21:\"configuration_summary\";a:4:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Guest checkout: Allowed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#prefix\";s:40:\"<div class=\"pane-configuration-summary\">\";s:7:\"#suffix\";s:6:\"</div>\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"pane-configuration-summary-cell\";}}}s:18:\"configuration_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:15:\"multistepSubmit\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:13:\"multistepAjax\";}s:7:\"wrapper\";s:43:\"checkout-pane-overview-wrapper--L0dOvk5jl6Q\";}s:8:\"#pane_id\";s:5:\"login\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"login_configuration_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:23:\"pane-configuration-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:0:{}s:7:\"#prefix\";s:45:\"<div class=\"pane-configuration-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:24:\"region-order_information\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:12:\"region-title\";}s:11:\"no_striping\";b:1;}s:5:\"title\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:32:\"region-order_information-message\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:14:\"region-message\";i:1;s:32:\"region-order_information-message\";i:2;s:16:\"region-populated\";}s:11:\"no_striping\";b:1;}s:7:\"message\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"No pane is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:19:\"contact_information\";a:6:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Contact information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:276;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:1;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"pane-weight\";}}}s:12:\"step_wrapper\";a:3:{s:8:\"#parents\";a:3:{i:0;s:13:\"configuration\";i:1;s:5:\"panes\";i:2;s:19:\"contact_information\";}s:7:\"step_id\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Checkout step for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:276;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:7:{s:5:\"login\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"order_information\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"review\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"payment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"complete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"_sidebar\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Sidebar\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"_disabled\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:17:\"order_information\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-pane-step\";i:1;s:9:\"pane-step\";}}}s:7:\"pane_id\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:19:\"contact_information\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"pane-id\";}}}}s:21:\"configuration_summary\";a:4:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Require double entry of email: Yes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#prefix\";s:40:\"<div class=\"pane-configuration-summary\">\";s:7:\"#suffix\";s:6:\"</div>\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"pane-configuration-summary-cell\";}}}s:18:\"configuration_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:15:\"multistepSubmit\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:13:\"multistepAjax\";}s:7:\"wrapper\";s:43:\"checkout-pane-overview-wrapper--L0dOvk5jl6Q\";}s:8:\"#pane_id\";s:19:\"contact_information\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:38:\"contact_information_configuration_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:23:\"pane-configuration-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:0:{}s:7:\"#prefix\";s:45:\"<div class=\"pane-configuration-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:19:\"payment_information\";a:6:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Payment information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:388;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:10;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"pane-weight\";}}}s:12:\"step_wrapper\";a:3:{s:8:\"#parents\";a:3:{i:0;s:13:\"configuration\";i:1;s:5:\"panes\";i:2;s:19:\"payment_information\";}s:7:\"step_id\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Checkout step for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:388;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:7:{s:5:\"login\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"order_information\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"review\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"payment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"complete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"_sidebar\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Sidebar\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"_disabled\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:17:\"order_information\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-pane-step\";i:1;s:9:\"pane-step\";}}}s:7:\"pane_id\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:19:\"payment_information\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"pane-id\";}}}}s:21:\"configuration_summary\";a:0:{}s:18:\"configuration_edit\";a:0:{}}s:13:\"region-review\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:12:\"region-title\";}s:11:\"no_striping\";b:1;}s:5:\"title\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:21:\"region-review-message\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:14:\"region-message\";i:1;s:21:\"region-review-message\";i:2;s:16:\"region-populated\";}s:11:\"no_striping\";b:1;}s:7:\"message\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"No pane is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:6:\"review\";a:6:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:493;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:3;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"pane-weight\";}}}s:12:\"step_wrapper\";a:3:{s:8:\"#parents\";a:3:{i:0;s:13:\"configuration\";i:1;s:5:\"panes\";i:2;s:6:\"review\";}s:7:\"step_id\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Checkout step for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:493;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:7:{s:5:\"login\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"order_information\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"review\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"payment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"complete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"_sidebar\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Sidebar\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"_disabled\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"review\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-pane-step\";i:1;s:9:\"pane-step\";}}}s:7:\"pane_id\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"review\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"pane-id\";}}}}s:21:\"configuration_summary\";a:0:{}s:18:\"configuration_edit\";a:0:{}}s:14:\"region-payment\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:12:\"region-title\";}s:11:\"no_striping\";b:1;}s:5:\"title\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:22:\"region-payment-message\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:14:\"region-message\";i:1;s:22:\"region-payment-message\";i:2;s:16:\"region-populated\";}s:11:\"no_striping\";b:1;}s:7:\"message\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"No pane is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:15:\"payment_process\";a:6:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment process\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:598;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:10;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"pane-weight\";}}}s:12:\"step_wrapper\";a:3:{s:8:\"#parents\";a:3:{i:0;s:13:\"configuration\";i:1;s:5:\"panes\";i:2;s:15:\"payment_process\";}s:7:\"step_id\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Checkout step for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:598;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:7:{s:5:\"login\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"order_information\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"review\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"payment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"complete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"_sidebar\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Sidebar\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"_disabled\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"payment\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-pane-step\";i:1;s:9:\"pane-step\";}}}s:7:\"pane_id\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:15:\"payment_process\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"pane-id\";}}}}s:21:\"configuration_summary\";a:4:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Transaction mode: Authorize and capture\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#prefix\";s:40:\"<div class=\"pane-configuration-summary\">\";s:7:\"#suffix\";s:6:\"</div>\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"pane-configuration-summary-cell\";}}}s:18:\"configuration_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:15:\"multistepSubmit\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:13:\"multistepAjax\";}s:7:\"wrapper\";s:43:\"checkout-pane-overview-wrapper--L0dOvk5jl6Q\";}s:8:\"#pane_id\";s:15:\"payment_process\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:34:\"payment_process_configuration_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:23:\"pane-configuration-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:0:{}s:7:\"#prefix\";s:45:\"<div class=\"pane-configuration-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"region-complete\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:12:\"region-title\";}s:11:\"no_striping\";b:1;}s:5:\"title\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:23:\"region-complete-message\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:14:\"region-message\";i:1;s:23:\"region-complete-message\";i:2;s:16:\"region-populated\";}s:11:\"no_striping\";b:1;}s:7:\"message\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"No pane is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:18:\"completion_message\";a:6:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Completion message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:736;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:4;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"pane-weight\";}}}s:12:\"step_wrapper\";a:3:{s:8:\"#parents\";a:3:{i:0;s:13:\"configuration\";i:1;s:5:\"panes\";i:2;s:18:\"completion_message\";}s:7:\"step_id\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Checkout step for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:736;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:7:{s:5:\"login\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"order_information\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"review\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"payment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"complete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"_sidebar\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Sidebar\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"_disabled\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:8:\"complete\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-pane-step\";i:1;s:9:\"pane-step\";}}}s:7:\"pane_id\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:18:\"completion_message\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"pane-id\";}}}}s:21:\"configuration_summary\";a:0:{}s:18:\"configuration_edit\";a:0:{}}s:15:\"region-_sidebar\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:12:\"region-title\";}s:11:\"no_striping\";b:1;}s:5:\"title\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Sidebar\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:23:\"region-_sidebar-message\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:14:\"region-message\";i:1;s:23:\"region-_sidebar-message\";i:2;s:16:\"region-populated\";}s:11:\"no_striping\";b:1;}s:7:\"message\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"No pane is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:13:\"order_summary\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:26:\"pane-configuration-editing\";}}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Order summary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:842;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:5;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"pane-weight\";}}}s:12:\"step_wrapper\";a:3:{s:8:\"#parents\";a:3:{i:0;s:13:\"configuration\";i:1;s:5:\"panes\";i:2;s:13:\"order_summary\";}s:7:\"step_id\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Checkout step for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:842;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:7:{s:5:\"login\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"order_information\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"review\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"payment\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"complete\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"_sidebar\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Sidebar\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"_disabled\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:8:\"_sidebar\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-pane-step\";i:1;s:9:\"pane-step\";}}}s:7:\"pane_id\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:13:\"order_summary\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:7:\"pane-id\";}}}}s:13:\"configuration\";a:8:{s:8:\"#parents\";a:4:{i:0;s:13:\"configuration\";i:1;s:5:\"panes\";i:2;s:13:\"order_summary\";i:3;s:13:\"configuration\";}s:5:\"#type\";s:9:\"container\";s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:2;}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:28:\"pane-configuration-edit-form\";}}s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:29:\"validatePaneConfigurationForm\";}}s:8:\"#pane_id\";s:13:\"order_summary\";s:4:\"view\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"View\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:1:{s:31:\"commerce_checkout_order_summary\";s:22:\"Checkout Order Summary\";}s:14:\"#default_value\";s:31:\"commerce_checkout_order_summary\";s:9:\"#required\";b:1;}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:4:\"save\";a:8:{s:7:\"#submit\";a:1:{i:0;a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:15:\"multistepSubmit\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:13:\"multistepAjax\";}s:7:\"wrapper\";s:43:\"checkout-pane-overview-wrapper--L0dOvk5jl6Q\";}s:8:\"#pane_id\";s:13:\"order_summary\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:39:\"order_summary_pane_configuration_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:6:\"cancel\";a:8:{s:7:\"#submit\";a:1:{i:0;a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:15:\"multistepSubmit\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";i:1;s:13:\"multistepAjax\";}s:7:\"wrapper\";s:43:\"checkout-pane-overview-wrapper--L0dOvk5jl6Q\";}s:8:\"#pane_id\";s:13:\"order_summary\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:36:\"order_summary_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:0:{}}}}}s:16:\"region-_disabled\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:12:\"region-title\";}s:11:\"no_striping\";b:1;}s:5:\"title\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}s:24:\"region-_disabled-message\";a:2:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:14:\"region-message\";i:1;s:24:\"region-_disabled-message\";i:2;s:12:\"region-empty\";}s:11:\"no_striping\";b:1;}s:7:\"message\";a:2:{s:7:\"#markup\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"No pane is disabled.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"#wrapper_attributes\";a:1:{s:7:\"colspan\";i:5;}}}}}s:7:\"actions\";a:3:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:2:{i:0;s:12:\"::submitForm\";i:1;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:41:\"entity.commerce_checkout_flow.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:22:\"commerce_checkout_flow\";s:7:\"default\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:22:\"commerce_checkout_flow\";s:6:\"entity\";O:44:\"Drupal\\commerce_checkout\\Entity\\CheckoutFlow\":23:{s:5:\"\0*\0id\";s:7:\"default\";s:8:\"\0*\0label\";s:7:\"Default\";s:9:\"\0*\0plugin\";s:17:\"multistep_default\";s:16:\"\0*\0configuration\";a:2:{s:25:\"display_checkout_progress\";b:1;s:5:\"panes\";a:6:{s:5:\"login\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:19:\"contact_information\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:19:\"billing_information\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:2;}s:6:\"review\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:18:\"completion_message\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:13:\"order_summary\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}}}s:13:\"\0*\0originalId\";s:7:\"default\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"e7bf6f91-1296-40c6-972a-21d0afb97b61\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wwkDVBiXUqSzRifJbb71ajFBklJdNJ_DgS67IF-_qgY\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:22:\"commerce_checkout_flow\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:0:{}s:7:\"actions\";a:1:{s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:13:\"form_build_id\";s:48:\"form-Kmt3G_sJtQzeeMQHu_cRTf6QSmcFKx1yCapQd_qzZkg\";s:10:\"form_token\";s:43:\"4YgDqmbj0KnPfvUiBJImG98N4UsQ-TiJTt0_ZgwaZHQ\";s:7:\"form_id\";s:32:\"commerce_checkout_flow_edit_form\";}s:8:\"language\";N;}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"#button_type\";s:6:\"danger\";s:7:\"#weight\";i:10;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:32:\"commerce_checkout_flow_edit_form\";s:9:\"#build_id\";s:48:\"form-uaCg2oF2aqfUR_s_-KTXcwYOji4gf-vwC9dheZF9dQ8\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-uaCg2oF2aqfUR_s_-KTXcwYOji4gf-vwC9dheZF9dQ8\";s:3:\"#id\";s:48:\"form-uaCg2oF2aqfUR_s_-KTXcwYOji4gf-vwC9dheZF9dQ8\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_b7CAD7lF0CypETluGrDpfynUU1flTu8DdF2_PZTM2sg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:61:\"edit-commerce-checkout-flow-edit-form-form-token--wEgLZmVBHT8\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_b7CAD7lF0CypETluGrDpfynUU1flTu8DdF2_PZTM2sg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_b7CAD7lF0CypETluGrDpfynUU1flTu8DdF2_PZTM2sg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_b7CAD7lF0CypETluGrDpfynUU1flTu8DdF2_PZTM2sg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:32:\"commerce_checkout_flow_edit_form\";s:3:\"#id\";s:50:\"edit-commerce-checkout-flow-edit-form--lK_ca8PRhJo\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:45:\"commerce-checkout-flow-edit-form--vGrptm0mIV0\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:32:\"commerce_checkout_flow_edit_form\";i:1;s:27:\"commerce_checkout_flow_form\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503509473),

('form','form-uR2-Unpw4iYe265dky9l6RwQnZe7itN3L4LItEoAZS0','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:150;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:150;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:514;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:514;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:568;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:568;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:700;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:700;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503322673\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:762;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:969;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"1\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:1150;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:1;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:1;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302248\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 10:57\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-uR2-Unpw4iYe265dky9l6RwQnZe7itN3L4LItEoAZS0\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-uR2-Unpw4iYe265dky9l6RwQnZe7itN3L4LItEoAZS0\";s:3:\"#id\";s:48:\"form-uR2-Unpw4iYe265dky9l6RwQnZe7itN3L4LItEoAZS0\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--xyZHpgSVp3A\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--5-qJEaZqhRg\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--VfZeJXoj9hg\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503344412),

('form','form-UvNfQwUfDv-1zk_T0wieWjfzz8yOKNJ0Gc9ed3Iu2Fw','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--3eqbqxIhx8Q\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--3eqbqxIhx8Q\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--3eqbqxIhx8Q\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--3eqbqxIhx8Q\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-UvNfQwUfDv-1zk_T0wieWjfzz8yOKNJ0Gc9ed3Iu2Fw\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-UvNfQwUfDv-1zk_T0wieWjfzz8yOKNJ0Gc9ed3Iu2Fw\";s:3:\"#id\";s:48:\"form-UvNfQwUfDv-1zk_T0wieWjfzz8yOKNJ0Gc9ed3Iu2Fw\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--XWTY0ldHSyI\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--j34-LlTRfP4\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--a6mistemfLo\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503429581),

('form','form-V8_fMjMcWTijdZi319oXFHq7m3YVMmhRBCXGAkKr_ic','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form---0nYoUedCsw\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form---0nYoUedCsw\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form---0nYoUedCsw\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form---0nYoUedCsw\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-V8_fMjMcWTijdZi319oXFHq7m3YVMmhRBCXGAkKr_ic\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-V8_fMjMcWTijdZi319oXFHq7m3YVMmhRBCXGAkKr_ic\";s:3:\"#id\";s:48:\"form-V8_fMjMcWTijdZi319oXFHq7m3YVMmhRBCXGAkKr_ic\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--lT51qbGVeX0\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--NghaYtzcHak\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--YDLVYAR_AzI\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503429445),

('form','form-vIsHira9gPoe20yQPVsipOMcjeCXfnSTZbkFR6PS0R0','a:29:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--6W1DejWkBOM\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--6W1DejWkBOM\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--6W1DejWkBOM\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--6W1DejWkBOM\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-vIsHira9gPoe20yQPVsipOMcjeCXfnSTZbkFR6PS0R0\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-vIsHira9gPoe20yQPVsipOMcjeCXfnSTZbkFR6PS0R0\";s:3:\"#id\";s:48:\"form-vIsHira9gPoe20yQPVsipOMcjeCXfnSTZbkFR6PS0R0\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--C6HKEEQyfAc\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--0-aLr0jlvzQ\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1505222810),

('form','form-vy3dGN4nOaKUh0a9k2poN044A3w46P209JIGzQgqgig','a:25:{s:11:\"#attributes\";a:3:{s:5:\"class\";a:4:{i:0;s:32:\"entity-browser-browse-files-form\";i:1;s:19:\"entity-browser-form\";i:2;s:25:\"dropzonejs-disable-submit\";i:3;s:17:\"file-browser-form\";}s:24:\"data-entity-browser-uuid\";s:40:\"9bdc57dce706aeb870ff0b5d60b486215a2b9df6\";s:20:\"data-drupal-selector\";s:32:\"entity-browser-browse-files-form\";}s:14:\"#browser_parts\";a:3:{s:15:\"widget_selector\";s:15:\"widget_selector\";s:6:\"widget\";s:6:\"widget\";s:17:\"selection_display\";s:17:\"selection_display\";}s:15:\"widget_selector\";a:3:{s:49:\"tab_selector_735d146c-a4b2-4327-a057-d109e0905e05\";a:9:{s:5:\"#type\";s:6:\"button\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:3:\"tab\";}}s:6:\"#value\";s:12:\"Upload files\";s:9:\"#disabled\";b:1;s:25:\"#executes_submit_callback\";b:1;s:24:\"#limit_validation_errors\";a:1:{i:0;a:1:{i:0;s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";}}s:7:\"#submit\";a:0:{}s:5:\"#name\";s:49:\"tab_selector_735d146c-a4b2-4327-a057-d109e0905e05\";s:10:\"#widget_id\";s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";}s:49:\"tab_selector_a4ad947c-9669-497c-9988-24351955a02f\";a:9:{s:5:\"#type\";s:6:\"button\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:3:\"tab\";}}s:6:\"#value\";s:13:\"Files listing\";s:9:\"#disabled\";b:0;s:25:\"#executes_submit_callback\";b:1;s:24:\"#limit_validation_errors\";a:1:{i:0;a:1:{i:0;s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";}}s:7:\"#submit\";a:0:{}s:5:\"#name\";s:49:\"tab_selector_a4ad947c-9669-497c-9988-24351955a02f\";s:10:\"#widget_id\";s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:19:\"entity_browser/tabs\";}}}s:6:\"widget\";a:3:{s:9:\"#attached\";a:2:{s:14:\"drupalSettings\";a:1:{s:21:\"entity_browser_widget\";a:1:{s:11:\"auto_select\";b:0;}}s:7:\"library\";a:2:{i:0;s:17:\"dropzonejs/widget\";i:1;s:27:\"dropzonejs_eb_widget/common\";}}s:7:\"actions\";a:2:{s:5:\"#type\";s:7:\"actions\";s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";s:15:\"Select entities\";s:22:\"#eb_widget_main_submit\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:24:\"is-entity-browser-submit\";}}s:12:\"#button_type\";s:7:\"primary\";}}s:6:\"upload\";a:7:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"File upload\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#type\";s:10:\"dropzonejs\";s:9:\"#required\";b:1;s:21:\"#dropzone_description\";s:39:\"Click or drop files here to upload them\";s:13:\"#max_filesize\";s:4:\"100M\";s:11:\"#extensions\";s:52:\"jpg jpeg gif png txt doc xls pdf ppt pps odt ods odp\";s:10:\"#max_files\";i:1;}}s:17:\"selection_display\";a:7:{s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:33:\"entity_browser/multi_step_display\";}}s:8:\"selected\";a:3:{s:15:\"#theme_wrappers\";a:1:{i:0;s:9:\"container\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:13:\"entities-list\";}}s:5:\"#tree\";b:1;}s:21:\"ajax_commands_handler\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:5:\"#name\";s:21:\"ajax_commands_handler\";s:3:\"#id\";s:21:\"ajax_commands_handler\";s:11:\"#attributes\";a:1:{s:2:\"id\";s:21:\"ajax_commands_handler\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";a:2:{i:0;s:76:\"Drupal\\entity_browser\\Plugin\\EntityBrowser\\SelectionDisplay\\MultiStepDisplay\";i:1;s:17:\"handleAjaxCommand\";}s:7:\"wrapper\";s:13:\"edit-selected\";s:5:\"event\";s:19:\"execute_js_commands\";s:8:\"progress\";a:1:{s:4:\"type\";s:10:\"fullscreen\";}}}s:12:\"use_selected\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Use selected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:12:\"use_selected\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"entity-browser-use-selected\";}}s:7:\"#access\";b:0;}s:14:\"show_selection\";a:4:{s:5:\"#type\";s:6:\"button\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Show selected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:29:\"entity-browser-show-selection\";}}s:7:\"#access\";b:0;}s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";s:20:\"file-browser-actions\";}}s:9:\"#attached\";a:2:{s:7:\"library\";a:3:{i:0;s:29:\"entity_browser/entity_browser\";i:1;s:17:\"file_browser/view\";i:2;s:25:\"file_browser/dropzone_css\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:32:\"entity_browser_browse_files_form\";s:9:\"#build_id\";s:48:\"form-vy3dGN4nOaKUh0a9k2poN044A3w46P209JIGzQgqgig\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-vy3dGN4nOaKUh0a9k2poN044A3w46P209JIGzQgqgig\";s:3:\"#id\";s:48:\"form-vy3dGN4nOaKUh0a9k2poN044A3w46P209JIGzQgqgig\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:6:\"#token\";s:66:\"form_token_placeholder_tMllwp5XOMcQ4wSKh7GXaefQU_WvVdmYdmBJR9Y5u_U\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:48:\"edit-entity-browser-browse-files-form-form-token\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_tMllwp5XOMcQ4wSKh7GXaefQU_WvVdmYdmBJR9Y5u_U\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_tMllwp5XOMcQ4wSKh7GXaefQU_WvVdmYdmBJR9Y5u_U\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_tMllwp5XOMcQ4wSKh7GXaefQU_WvVdmYdmBJR9Y5u_U\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:32:\"entity_browser_browse_files_form\";s:3:\"#id\";s:37:\"edit-entity-browser-browse-files-form\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:32:\"entity-browser-browse-files-form\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:1:{i:0;s:32:\"entity_browser_browse_files_form\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503029616),

('form','form-wUzz0wtnF1Pzjf2mhqAeR-K--KmgIKX-RpgY-s-kiG0','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:150;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:150;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:514;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:514;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:568;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:568;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:700;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:700;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503410367\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:762;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";s:9:\"Black, XL\";s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325829\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"12\";}}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"22\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:1001:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:966;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";s:8:\"White, L\";s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:21:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:38:\"Religion Jersey Polo Shirts - White, L\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"13\";}}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"21\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:38:\"Religion Jersey Polo Shirts - White, L\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"1\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:1142;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:1;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:1;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503325874\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 17:31\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503325874\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-wUzz0wtnF1Pzjf2mhqAeR-K--KmgIKX-RpgY-s-kiG0\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-wUzz0wtnF1Pzjf2mhqAeR-K--KmgIKX-RpgY-s-kiG0\";s:3:\"#id\";s:48:\"form-wUzz0wtnF1Pzjf2mhqAeR-K--KmgIKX-RpgY-s-kiG0\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--tu9gaQHSibo\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--c5VObPGLzN8\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--nmChnuQCGoc\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503431993),

('form','form-x3m-MO7pqs3Smpg-CX0pCBMjit-uCCnKnpAKKoFI7NQ','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--RJ4jhoBZ6RY\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--RJ4jhoBZ6RY\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--RJ4jhoBZ6RY\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--RJ4jhoBZ6RY\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-x3m-MO7pqs3Smpg-CX0pCBMjit-uCCnKnpAKKoFI7NQ\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-x3m-MO7pqs3Smpg-CX0pCBMjit-uCCnKnpAKKoFI7NQ\";s:3:\"#id\";s:48:\"form-x3m-MO7pqs3Smpg-CX0pCBMjit-uCCnKnpAKKoFI7NQ\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--YTTWvldE3cM\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--HBRNV0qsImo\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--49qwO-0WmYY\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503429025),

('form','form-x3qSX41We7Wxkmxhtavam6ZsLwdLiJhBL7NRUf-xvZI','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--bu-wDTwiY30\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--bu-wDTwiY30\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--bu-wDTwiY30\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--bu-wDTwiY30\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-x3qSX41We7Wxkmxhtavam6ZsLwdLiJhBL7NRUf-xvZI\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-x3qSX41We7Wxkmxhtavam6ZsLwdLiJhBL7NRUf-xvZI\";s:3:\"#id\";s:48:\"form-x3qSX41We7Wxkmxhtavam6ZsLwdLiJhBL7NRUf-xvZI\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--OtOyftOK1Fo\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--V65AcjsoX0s\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--J9yI4DJ_glA\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503429294),

('form','form-xU_t3HRw-y-IUmUTRciQJfdC4NEZAa-t56zh4Cq1I40','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--f2TW0KaKf54\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--f2TW0KaKf54\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--f2TW0KaKf54\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--f2TW0KaKf54\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-xU_t3HRw-y-IUmUTRciQJfdC4NEZAa-t56zh4Cq1I40\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-xU_t3HRw-y-IUmUTRciQJfdC4NEZAa-t56zh4Cq1I40\";s:3:\"#id\";s:48:\"form-xU_t3HRw-y-IUmUTRciQJfdC4NEZAa-t56zh4Cq1I40\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--yvD5WOeBa68\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--N6ezSaGEdrQ\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--FcbstHfOtQU\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503428590),

('form','form-yBF-LxSankdVn1gtVu85_uoZXSfLaBXw03YCBi7KNRU','a:29:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:55:\"commerce-order-item-add-to-cart-form-commerce-product-4\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:55:\"commerce-order-item-add-to-cart-form-commerce-product-4\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--k6xJ7lfS28U\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--k6xJ7lfS28U\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--k6xJ7lfS28U\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--k6xJ7lfS28U\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";s:9:\"#build_id\";s:48:\"form-yBF-LxSankdVn1gtVu85_uoZXSfLaBXw03YCBi7KNRU\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:6:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-yBF-LxSankdVn1gtVu85_uoZXSfLaBXw03YCBi7KNRU\";s:3:\"#id\";s:48:\"form-yBF-LxSankdVn1gtVu85_uoZXSfLaBXw03YCBi7KNRU\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}s:11:\"#attributes\";a:1:{s:12:\"autocomplete\";s:3:\"off\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";s:3:\"#id\";s:73:\"edit-commerce-order-item-add-to-cart-form-commerce-product-4--1IvcZEEyDXw\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:68:\"commerce-order-item-add-to-cart-form-commerce-product-4--Rkj3kvWPZvU\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}}',1514858151),

('form','form-yOW_ixmA3uWRcooWR5tGjgyCQeHXVnlqJC-hLIaeYBk','a:33:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_view_display.commerce_product.product_display.teaser\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:16:\"commerce_product\";s:7:\"#bundle\";s:15:\"product_display\";s:7:\"#fields\";a:10:{i:0;s:8:\"langcode\";i:1;s:3:\"uid\";i:2;s:5:\"title\";i:3;s:7:\"created\";i:4;s:14:\"field_category\";i:5;s:12:\"field_rating\";i:6;s:13:\"field_reviews\";i:7;s:10:\"field_tags\";i:8;s:6:\"stores\";i:9;s:10:\"variations\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:16:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:40:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:39:\"commerce_plugin_item:commerce_condition\";a:15:{s:11:\"plugin_type\";s:18:\"commerce_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:220;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"025ac682-e1c1-45ec-8ee9-bff4d42a193c\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"core.entity_view_mode.commerce_product.teaser\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"\0*\0id\";s:39:\"commerce_product.product_display.teaser\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:6:\"teaser\";s:10:\"\0*\0content\";a:2:{s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:2:\"-5\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:8:{s:7:\"created\";b:1;s:14:\"field_category\";b:1;s:12:\"field_rating\";b:1;s:13:\"field_reviews\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1167;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1167;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1167;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1167;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1167;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1167;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"uid\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1295;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1295;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"uid\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1295;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1295;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1295;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"author\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1295;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:5:\"title\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:6:\"string\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:2:\"-5\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:5:\"title\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:6:\"string\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"string\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1439;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:5:\"title\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:19:\"title_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:5:\"title\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:7:\"created\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:9:\"timestamp\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1592;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1592;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:7:\"created\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1592;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1592;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1592;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:13:\"timestamp_ago\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Time ago\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"timestamp\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1592;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:14:\"field_category\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:8:\"Category\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"field_category\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:26:\"rhythm_cms_images_one_main\";r:1390;s:29:\"entity_reference_rss_category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"RSS category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";r:1398;s:26:\"entity_reference_entity_id\";r:1402;s:22:\"entity_reference_label\";r:1406;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:12:\"field_rating\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:14:\"fivestar_stars\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Rating\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_rating\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:14:\"fivestar_stars\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"As stars\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"fivestar_percentage\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Percentage (i.e. 92)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"fivestar_rating\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Rating (i.e. 4.2/5)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:13:\"field_reviews\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"comment_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:7:\"Reviews\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:13:\"field_reviews\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"comment_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"field_tags\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Tags\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_tags\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:26:\"rhythm_cms_images_one_main\";r:1390;s:29:\"entity_reference_rss_category\";r:1817;s:28:\"entity_reference_entity_view\";r:1398;s:26:\"entity_reference_entity_id\";r:1402;s:22:\"entity_reference_label\";r:1406;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:6:\"stores\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Stores\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"stores\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1390;s:28:\"entity_reference_entity_view\";r:1398;s:26:\"entity_reference_entity_id\";r:1402;s:22:\"entity_reference_label\";r:1406;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"variations\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:109;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:10:\"Variations\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"variations\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:6:{s:26:\"rhythm_cms_images_one_main\";r:1390;s:28:\"entity_reference_entity_view\";r:1398;s:26:\"entity_reference_entity_id\";r:1402;s:22:\"entity_reference_label\";r:1406;s:20:\"commerce_add_to_cart\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:36:\"commerce_product_attributes_overview\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Product attributes overview\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:20:\"commerce_add_to_cart\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Combine order items containing the same product variation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"variations\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"variations_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"#parent_options\";a:0:{}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-yOW_ixmA3uWRcooWR5tGjgyCQeHXVnlqJC-hLIaeYBk\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:6:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-yOW_ixmA3uWRcooWR5tGjgyCQeHXVnlqJC-hLIaeYBk\";s:3:\"#id\";s:48:\"form-yOW_ixmA3uWRcooWR5tGjgyCQeHXVnlqJC-hLIaeYBk\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}s:11:\"#attributes\";a:1:{s:12:\"autocomplete\";s:3:\"off\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--h4UbVBWp23I\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--xHD-ApW6P-4\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--m_x1-YldtMw\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1086;s:12:\"#cache_token\";s:43:\"QAKcqB1P-t_INT2JBl1aiu3LzG74XEUJhlpnQYInqU4\";}',1520009888),

('form','form-yP-nqcZtBavQp0TtppuNXoQwq4-eO8UD5B9dnuv4ZIo','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--JRJtKg3wqC8\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--JRJtKg3wqC8\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--JRJtKg3wqC8\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--JRJtKg3wqC8\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-yP-nqcZtBavQp0TtppuNXoQwq4-eO8UD5B9dnuv4ZIo\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-yP-nqcZtBavQp0TtppuNXoQwq4-eO8UD5B9dnuv4ZIo\";s:3:\"#id\";s:48:\"form-yP-nqcZtBavQp0TtppuNXoQwq4-eO8UD5B9dnuv4ZIo\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--nIOQo6o3jxg\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--F9b1fBxf1Is\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--WKHinGH0bfE\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503435960),

('form','form-yQt6hEIaDel1L_PxCLpLwV5qxkQG553aht9AcBe7ASU','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--eR_rwjyekDI\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--eR_rwjyekDI\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"5\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"13\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--eR_rwjyekDI\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:21;s:1:\"L\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"21\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--eR_rwjyekDI\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-yQt6hEIaDel1L_PxCLpLwV5qxkQG553aht9AcBe7ASU\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-yQt6hEIaDel1L_PxCLpLwV5qxkQG553aht9AcBe7ASU\";s:3:\"#id\";s:48:\"form-yQt6hEIaDel1L_PxCLpLwV5qxkQG553aht9AcBe7ASU\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--z_BaiyLtGrY\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--kXr_BNOJTZs\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--i2Wd_dnDI3E\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503348022),

('form','form-YwPU5vgg806KVi_rKR6gIq46bp9aPLGxpjkWhxKcb6Q','a:34:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:67:\"config:core.entity_view_display.commerce_order_item.default.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:7:\"#bundle\";s:7:\"default\";s:7:\"#fields\";a:5:{i:0;s:16:\"purchased_entity\";i:1;s:8:\"quantity\";i:2;s:10:\"unit_price\";i:3;s:11:\"adjustments\";i:4;s:11:\"total_price\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:11:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:16:\"purchased_entity\";a:10:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";i:2;s:29:\"field-plugin-settings-editing\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:216;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:216;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:216;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"a226e650-6b0a-4142-adda-4a2184843f1e\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:14:\"commerce_price\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"YvPk7-s7bZEOuxWBbu1G5wo4qc-OOnZpmCwPUdhp40o\";}s:5:\"\0*\0id\";s:35:\"commerce_order_item.default.default\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:5:{s:16:\"purchased_entity\";a:6:{s:4:\"type\";s:28:\"entity_reference_entity_view\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"product\";s:4:\"link\";b:0;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:8:\"quantity\";a:6:{s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";i:1;s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:11:\"total_price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:10:\"unit_price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:2;s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:1:{s:11:\"adjustments\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";b:0;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1227;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1227;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:16:\"purchased_entity\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:16:\"purchased_entity\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1227;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1227;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:4:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1227;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:28:\"entity_reference_entity_view\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:16:\"purchased_entity\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:7:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:31:\"field-plugin-settings-edit-form\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:16:\"purchased_entity\";i:2;s:18:\"settings_edit_form\";}s:5:\"label\";a:1:{s:7:\"#markup\";s:65:\"Format settings: <span class=\"plugin-name\">Rendered entity</span>\";}s:8:\"settings\";a:1:{s:9:\"view_mode\";a:5:{s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:5:{s:7:\"default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"cart\";s:4:\"Cart\";s:7:\"product\";s:7:\"Product\";s:7:\"summary\";s:7:\"Summary\";s:5:\"token\";s:5:\"Token\";}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";s:7:\"product\";s:9:\"#required\";b:1;}}s:20:\"third_party_settings\";a:0:{}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:13:\"save_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:16:\"purchased_entity\";s:5:\"#type\";s:6:\"submit\";s:12:\"#button_type\";s:7:\"primary\";s:5:\"#name\";s:39:\"purchased_entity_plugin_settings_update\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"update\";}s:15:\"cancel_settings\";a:8:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:16:\"purchased_entity\";s:5:\"#type\";s:6:\"submit\";s:5:\"#name\";s:39:\"purchased_entity_plugin_settings_cancel\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cancel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:6:\"cancel\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:16:\"purchased_entity\";i:2;s:4:\"type\";}}}}}s:16:\"#cell_attributes\";a:1:{s:7:\"colspan\";i:3;}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1227;}s:10:\"\0*\0options\";a:0:{}}}}s:8:\"quantity\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:106;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:14:\"number_decimal\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Quantity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1434;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"1\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1434;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"quantity\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"quantity\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1434;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1434;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1434;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:18:\"number_unformatted\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Unformatted\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"number_decimal\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:14:\"number_decimal\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"quantity\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1434;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;s:7:\"1234.12\";i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Display with prefix and suffix.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:8:\"quantity\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:22:\"quantity_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:8:\"quantity\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:10:\"unit_price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:106;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Unit price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1603;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1603;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"unit_price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"unit_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1603;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1603;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1603;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:20:\"commerce_price_plain\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Plain\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"commerce_price_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"unit_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1603;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"unit_price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"unit_price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"unit_price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:11:\"adjustments\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:106;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";N;}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Adjustments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"adjustments\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"adjustments\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"adjustments\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1775;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:11:\"total_price\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:106;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"commerce_price_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Total price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1899;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";i:3;s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1899;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"total_price\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:11:\"total_price\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1899;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1899;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1899;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:20:\"commerce_price_plain\";r:1698;s:22:\"commerce_price_default\";r:1702;}s:14:\"#default_value\";s:22:\"commerce_price_default\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:11:\"total_price\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1899;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:2:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Do not strip trailing zeroes after the decimal point.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the currency symbol.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:11:\"total_price\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:25:\"total_price_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:11:\"total_price\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"#parent_options\";a:0:{}}s:5:\"modes\";a:4:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Custom display settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:20:\"display_modes_custom\";a:4:{s:5:\"#type\";s:10:\"checkboxes\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"Use custom display settings for the following @display_context modes\";s:12:\"\0*\0arguments\";a:1:{s:16:\"@display_context\";s:4:\"view\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:1:{s:5:\"token\";s:5:\"Token\";}s:14:\"#default_value\";a:0:{}}s:18:\"display_modes_link\";a:3:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Manage view modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:34:\"entity.entity_view_mode.collection\";s:18:\"\0*\0routeParameters\";a:0:{}s:10:\"\0*\0options\";a:0:{}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-YwPU5vgg806KVi_rKR6gIq46bp9aPLGxpjkWhxKcb6Q\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-YwPU5vgg806KVi_rKR6gIq46bp9aPLGxpjkWhxKcb6Q\";s:3:\"#id\";s:48:\"form-YwPU5vgg806KVi_rKR6gIq46bp9aPLGxpjkWhxKcb6Q\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token--m1I2pREuuQ4\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--7fgZBbOrXfY\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--oGrRLHjpsLk\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1122;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503510242),

('form','form-ZRDIwXEfh2h-2jddWDCZCN7Sfaj8ZzHiCCODExShqzU','a:33:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:29:\"entity-view-display-edit-form\";i:1;s:24:\"entity-view-display-form\";}s:20:\"data-drupal-selector\";s:29:\"entity-view-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_view_display.commerce_product.product_display.teaser\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:1:{i:0;s:13:\"::processForm\";}s:12:\"#after_build\";a:1:{i:0;s:12:\"::afterBuild\";}s:12:\"#entity_type\";s:16:\"commerce_product\";s:7:\"#bundle\";s:15:\"product_display\";s:7:\"#fields\";a:9:{i:0;s:8:\"langcode\";i:1;s:3:\"uid\";i:2;s:7:\"created\";i:3;s:14:\"field_category\";i:4;s:12:\"field_rating\";i:5;s:13:\"field_reviews\";i:6;s:10:\"field_tags\";i:7;s:6:\"stores\";i:8;s:10:\"variations\";}s:6:\"#extra\";a:0:{}s:6:\"fields\";a:15:{s:5:\"#type\";s:14:\"field_ui_table\";s:7:\"#header\";a:6:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:3;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:4;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:5;a:2:{s:4:\"data\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"colspan\";i:3;}}s:8:\"#regions\";a:2:{s:7:\"content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"invisible\";b:1;s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"No field is displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"hidden\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}s:7:\"message\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"No field is hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:17:\"field-ui-overview\";}s:2:\"id\";s:22:\"field-display-overview\";}s:10:\"#tabledrag\";a:3:{i:0;a:3:{s:6:\"action\";s:5:\"order\";s:12:\"relationship\";s:7:\"sibling\";s:5:\"group\";s:12:\"field-weight\";}i:1;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-parent\";s:8:\"subgroup\";s:12:\"field-parent\";s:6:\"source\";s:10:\"field-name\";}i:2;a:5:{s:6:\"action\";s:5:\"match\";s:12:\"relationship\";s:6:\"parent\";s:5:\"group\";s:12:\"field-region\";s:8:\"subgroup\";s:12:\"field-region\";s:6:\"source\";s:10:\"field-name\";}}s:8:\"langcode\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:218;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:218;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:218;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"025ac682-e1c1-45ec-8ee9-bff4d42a193c\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"core.entity_view_mode.commerce_product.teaser\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"\0*\0id\";s:39:\"commerce_product.product_display.teaser\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:6:\"teaser\";s:10:\"\0*\0content\";a:2:{s:10:\"variations\";a:6:{s:4:\"type\";s:28:\"entity_reference_entity_view\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"product\";s:4:\"link\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:8:{s:7:\"created\";b:1;s:14:\"field_category\";b:1;s:12:\"field_rating\";b:1;s:13:\"field_reviews\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:8:\"language\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1206;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1206;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:8:\"langcode\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1206;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1206;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1206;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:8:\"language\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:8:\"langcode\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1206;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:3:\"uid\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:108;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1334;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1334;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:3:\"uid\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1334;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1334;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1334;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:6:\"author\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"rhythm_cms_images_one_main\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Rhythm CMS: Images One Main\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:28:\"entity_reference_entity_view\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"entity_reference_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"entity_reference_entity_id\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:3:\"uid\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1334;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:7:\"created\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:108;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:9:\"timestamp\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1478;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1478;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:7:\"created\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1478;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1478;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1478;}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:13:\"timestamp_ago\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Time ago\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"timestamp\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Default\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:7:\"created\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";r:1478;}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:14:\"field_category\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:108;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:8:\"Category\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:14:\"field_category\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:29:\"entity_reference_rss_category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"RSS category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:26:\"rhythm_cms_images_one_main\";r:1433;s:28:\"entity_reference_entity_view\";r:1437;s:22:\"entity_reference_label\";r:1441;s:26:\"entity_reference_entity_id\";r:1445;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:14:\"field_category\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:8:\"Category\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:12:\"field_rating\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:108;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:14:\"fivestar_stars\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Rating\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:12:\"field_rating\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:3:{s:14:\"fivestar_stars\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"As stars\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"fivestar_percentage\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Percentage (i.e. 92)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"fivestar_rating\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Rating (i.e. 4.2/5)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:12:\"field_rating\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Rating\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:13:\"field_reviews\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:108;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:15:\"comment_default\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:7:\"Reviews\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:13:\"field_reviews\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:1:{s:15:\"comment_default\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:13:\"field_reviews\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:7:\"Reviews\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"field_tags\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:108;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:4:\"Tags\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"field_tags\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:5:{s:29:\"entity_reference_rss_category\";r:1702;s:26:\"rhythm_cms_images_one_main\";r:1433;s:28:\"entity_reference_entity_view\";r:1437;s:22:\"entity_reference_label\";r:1441;s:26:\"entity_reference_entity_id\";r:1445;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"field_tags\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:6:\"stores\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:108;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:6:\"Stores\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:6:\"stores\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:6:\"hidden\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:5:\"above\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:26:\"rhythm_cms_images_one_main\";r:1433;s:28:\"entity_reference_entity_view\";r:1437;s:22:\"entity_reference_label\";r:1441;s:26:\"entity_reference_entity_id\";r:1445;}s:14:\"#default_value\";s:6:\"hidden\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:6:\"stores\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:6:\"Stores\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:0:{}s:13:\"settings_edit\";a:0:{}}s:10:\"variations\";a:12:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:9:\"draggable\";i:1;s:14:\"tabledrag-leaf\";}}s:9:\"#row_type\";s:5:\"field\";s:16:\"#region_callback\";a:2:{i:0;r:108;i:1;s:12:\"getRowRegion\";}s:12:\"#js_settings\";a:2:{s:10:\"rowHandler\";s:5:\"field\";s:13:\"defaultPlugin\";s:22:\"entity_reference_label\";}s:10:\"human_name\";a:1:{s:11:\"#plain_text\";s:10:\"Variations\";}s:6:\"weight\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Weight for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"0\";s:5:\"#size\";i:3;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-weight\";}}}s:14:\"parent_wrapper\";a:2:{s:6:\"parent\";a:8:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:0:{}s:12:\"#empty_value\";s:0:\"\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:15:\"js-field-parent\";i:1;s:12:\"field-parent\";}}s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:6:\"parent\";}s:14:\"#default_value\";s:0:\"\";}s:11:\"hidden_name\";a:3:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"variations\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:10:\"field-name\";}}}}s:6:\"region\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Region for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:2:{s:7:\"content\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Disabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:6:\"Plural\";}}}s:14:\"#default_value\";s:7:\"content\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"field-region\";}}}s:5:\"label\";a:5:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Label display for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:4:{s:5:\"above\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Above\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"inline\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Inline\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"hidden\";s:10:\"- Hidden -\";s:15:\"visually_hidden\";s:19:\"- Visually Hidden -\";}s:14:\"#default_value\";s:6:\"hidden\";}s:6:\"plugin\";a:3:{s:4:\"type\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Plugin for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:8:\"#options\";a:6:{s:26:\"rhythm_cms_images_one_main\";r:1433;s:28:\"entity_reference_entity_view\";r:1437;s:22:\"entity_reference_label\";r:1441;s:26:\"entity_reference_entity_id\";r:1445;s:20:\"commerce_add_to_cart\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add to cart form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:36:\"commerce_product_attributes_overview\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Product attributes overview\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:14:\"#default_value\";s:28:\"entity_reference_entity_view\";s:8:\"#parents\";a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"field-plugin-type\";}}}s:18:\"settings_edit_form\";a:0:{}s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Formatter for @title\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@title\";s:10:\"Variations\";}s:10:\"\0*\0options\";a:0:{}}}s:16:\"settings_summary\";a:4:{s:5:\"#type\";s:15:\"inline_template\";s:9:\"#template\";s:73:\"<div class=\"field-plugin-summary\">{{ summary|safe_join(\"<br />\") }}</div>\";s:8:\"#context\";a:1:{s:7:\"summary\";a:1:{i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Rendered as @mode\";s:12:\"\0*\0arguments\";a:1:{s:5:\"@mode\";s:7:\"Product\";}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"#cell_attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:25:\"field-plugin-summary-cell\";}}}s:13:\"settings_edit\";a:11:{s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:3:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";}s:11:\"#field_name\";s:10:\"variations\";s:5:\"#type\";s:12:\"image_button\";s:5:\"#name\";s:24:\"variations_settings_edit\";s:4:\"#src\";s:30:\"core/misc/icons/787878/cog.svg\";s:11:\"#attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:26:\"field-plugin-settings-edit\";}s:3:\"alt\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"#op\";s:4:\"edit\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:6:\"fields\";i:1;s:10:\"variations\";i:2;s:4:\"type\";}}s:7:\"#prefix\";s:48:\"<div class=\"field-plugin-settings-edit-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";}}s:15:\"#parent_options\";a:0:{}}s:12:\"refresh_rows\";a:1:{s:5:\"#type\";s:6:\"hidden\";}s:7:\"refresh\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refresh\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"#op\";s:13:\"refresh_table\";s:7:\"#submit\";a:1:{i:0;s:17:\"::multistepSubmit\";}s:5:\"#ajax\";a:4:{s:8:\"callback\";s:15:\"::multistepAjax\";s:7:\"wrapper\";s:30:\"field-display-overview-wrapper\";s:6:\"effect\";s:4:\"fade\";s:8:\"progress\";s:4:\"none\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:15:\"visually-hidden\";}}}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;s:33:\"field_group_field_overview_submit\";i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:2:{i:0;s:24:\"field_ui/drupal.field_ui\";i:1;s:20:\"field_group/field_ui\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:8:\"#form_id\";s:29:\"entity_view_display_edit_form\";s:9:\"#build_id\";s:48:\"form-ZRDIwXEfh2h-2jddWDCZCN7Sfaj8ZzHiCCODExShqzU\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-ZRDIwXEfh2h-2jddWDCZCN7Sfaj8ZzHiCCODExShqzU\";s:3:\"#id\";s:48:\"form-ZRDIwXEfh2h-2jddWDCZCN7Sfaj8ZzHiCCODExShqzU\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:58:\"edit-entity-view-display-edit-form-form-token---urCqj0b9lA\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_8iXtXs9FFqC7FW0oC3I-HEOzb5JY-8OrpycuY-jHPLA\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:29:\"entity_view_display_edit_form\";s:3:\"#id\";s:47:\"edit-entity-view-display-edit-form--riKheKlo3bg\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"entity-view-display-edit-form--nD0gd65pVGU\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:29:\"entity_view_display_edit_form\";i:1;s:24:\"entity_view_display_form\";}s:12:\"#fieldgroups\";a:0:{}s:8:\"#context\";r:1124;s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503520181),

('form','form-zuwHiZe0BA3L0OrmSzx_pvIm9RDclKbAGZOpuZrnI2g','a:24:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:40:\"commerce-checkout-flow-multistep-default\";i:1;s:22:\"commerce-checkout-flow\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:40:\"commerce-checkout-flow-multistep-default\";}s:5:\"#tree\";b:1;s:8:\"#step_id\";s:17:\"order_information\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#theme\";a:1:{i:0;s:22:\"commerce_checkout_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:22:\"commerce_checkout/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:7:\"#access\";b:1;s:4:\"next\";a:6:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Continue to review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:7:\"#suffix\";O:25:\"Drupal\\Core\\GeneratedLink\":5:{s:16:\"\0*\0generatedLink\";s:39:\"<a href=\"/checkout/4/login\">Go back</a>\";s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0attachments\";a:0:{}}s:11:\"#attributes\";a:1:{s:5:\"class\";a:6:{i:0;s:9:\"btn-small\";i:1;s:8:\"btn-gray\";i:2;s:3:\"btn\";i:3;s:7:\"btn-mod\";i:4;s:9:\"btn-round\";i:5;s:11:\"form-submit\";}}}}s:19:\"contact_information\";a:5:{s:8:\"#parents\";a:1:{i:0;s:19:\"contact_information\";}s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Contact information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"email\";a:4:{s:5:\"#type\";s:5:\"email\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";N;s:9:\"#required\";b:1;}s:13:\"email_confirm\";a:4:{s:5:\"#type\";s:5:\"email\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Confirm email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";N;s:9:\"#required\";b:1;}}s:19:\"payment_information\";a:8:{s:8:\"#parents\";a:1:{i:0;s:19:\"payment_information\";}s:5:\"#type\";s:8:\"fieldset\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Payment information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"#wrapper_id\";s:40:\"payment-information-wrapper--4c9YpvEVbYA\";s:7:\"#prefix\";s:51:\"<div id=\"payment-information-wrapper--4c9YpvEVbYA\">\";s:7:\"#suffix\";s:6:\"</div>\";s:14:\"payment_method\";a:7:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Payment method\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"#options\";a:1:{s:23:\"payment_gateway_example\";s:7:\"Example\";}s:14:\"#default_value\";s:23:\"payment_gateway_example\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:40:\"payment-information-wrapper--4c9YpvEVbYA\";}s:7:\"#access\";b:0;s:23:\"payment_gateway_example\";a:1:{s:16:\"#payment_gateway\";s:23:\"payment_gateway_example\";}}s:19:\"billing_information\";a:4:{s:5:\"#type\";s:23:\"commerce_profile_select\";s:14:\"#default_value\";O:29:\"Drupal\\profile\\Entity\\Profile\":25:{s:9:\"\0*\0values\";a:10:{s:11:\"revision_id\";a:1:{s:9:\"x-default\";a:0:{}}s:10:\"profile_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"17b78d54-0395-494e-abc6-643ab49899f6\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:8:\"customer\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"0\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}}s:10:\"is_default\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1504286397;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1504286397;}}}s:7:\"address\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:2:{s:6:\"bundle\";s:8:\"customer\";s:8:\"revision\";N;}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:7:\"profile\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#default_country\";s:2:\"US\";s:20:\"#available_countries\";a:1:{i:0;s:2:\"CA\";}}}s:7:\"sidebar\";a:1:{s:13:\"order_summary\";a:4:{s:8:\"#parents\";a:2:{i:0;s:7:\"sidebar\";i:1;s:13:\"order_summary\";}s:5:\"#type\";s:9:\"container\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Order summary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"view\";a:5:{s:5:\"#type\";s:4:\"view\";s:5:\"#name\";s:31:\"commerce_checkout_order_summary\";s:11:\"#display_id\";s:7:\"default\";s:10:\"#arguments\";a:1:{i:0;s:1:\"4\";}s:6:\"#embed\";b:1;}}}s:8:\"#form_id\";s:40:\"commerce_checkout_flow_multistep_default\";s:9:\"#build_id\";s:48:\"form-zuwHiZe0BA3L0OrmSzx_pvIm9RDclKbAGZOpuZrnI2g\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-zuwHiZe0BA3L0OrmSzx_pvIm9RDclKbAGZOpuZrnI2g\";s:3:\"#id\";s:48:\"form-zuwHiZe0BA3L0OrmSzx_pvIm9RDclKbAGZOpuZrnI2g\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#cache\";a:1:{s:8:\"contexts\";a:1:{i:0;s:24:\"user.roles:authenticated\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:40:\"commerce_checkout_flow_multistep_default\";s:3:\"#id\";s:58:\"edit-commerce-checkout-flow-multistep-default--eqQRkKl8qY0\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:53:\"commerce-checkout-flow-multistep-default--XcpWPvtLieY\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}}',1504307997),

('form','form-_IHzfY0gd1vXaUdCnvVB2jhy1GS0bg4c__WoypgJkgs','a:47:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:2:{i:0;s:42:\"commerce-product-product-display-edit-form\";i:1;s:21:\"commerce-product-form\";}s:20:\"data-drupal-selector\";s:42:\"commerce-product-product-display-edit-form\";}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:2:{i:0;s:18:\"commerce_product:4\";i:1;s:72:\"config:core.entity_form_display.commerce_product.product_display.default\";}s:7:\"max-age\";i:-1;}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:7:\"created\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:15:\"created_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-created\";i:1;s:19:\"field--name-created\";i:2;s:32:\"field--widget-datetime-timestamp\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:151;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:8:\"datetime\";s:14:\"#default_value\";O:35:\"Drupal\\Core\\Datetime\\DrupalDateTime\":11:{s:25:\"\0*\0formatTranslationCache\";N;s:15:\"\0*\0inputTimeRaw\";s:0:\"\";s:20:\"\0*\0inputTimeAdjusted\";s:0:\"\";s:19:\"\0*\0inputTimeZoneRaw\";s:0:\"\";s:24:\"\0*\0inputTimeZoneAdjusted\";s:0:\"\";s:17:\"\0*\0inputFormatRaw\";s:0:\"\";s:22:\"\0*\0inputFormatAdjusted\";s:0:\"\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0errors\";a:0:{}s:17:\"\0*\0dateTimeObject\";O:8:\"DateTime\":3:{s:4:\"date\";s:26:\"2017-08-18 13:53:13.000000\";s:13:\"timezone_type\";i:3;s:8:\"timezone\";s:13:\"Europe/Moscow\";}s:20:\"\0*\0stringTranslation\";N;}s:16:\"#date_year_range\";s:9:\"1902:2037\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:7:\"created\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:151;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:38:\"The time when the product was created.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:69:\"Drupal\\Core\\Datetime\\Plugin\\Field\\FieldWidget\\TimestampDatetimeWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:7:\"created\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:7;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:14:\"field_category\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:22:\"field_category_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:26:\"field--name-field-category\";i:2;s:28:\"field--widget-options-select\";}}s:6:\"widget\";a:16:{s:6:\"#title\";s:8:\"Category\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:15:\"validateElement\";}}s:11:\"#key_column\";s:9:\"target_id\";s:5:\"#type\";s:6:\"select\";s:8:\"#options\";a:7:{s:5:\"_none\";s:8:\"- None -\";i:28;s:8:\"Branding\";i:29;s:6:\"Design\";i:30;s:7:\"Fashion\";i:36;s:12:\"Fashion wear\";i:31;s:11:\"Polo Shirts\";i:32;s:12:\"Sport Shirts\";}s:14:\"#default_value\";a:1:{i:0;s:2:\"36\";}s:9:\"#multiple\";b:1;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:62:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\OptionsSelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:14:\"field_category\";s:8:\"#parents\";a:1:{i:0;s:14:\"field_category\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:3;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:66:\"config:field.field.commerce_product.product_display.field_category\";i:1;s:52:\"config:field.storage.commerce_product.field_category\";}s:7:\"max-age\";i:-1;}}s:13:\"field_reviews\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:21:\"field_reviews_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:19:\"field--type-comment\";i:1;s:25:\"field--name-field-reviews\";i:2;s:29:\"field--widget-comment-default\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";s:7:\"Reviews\";s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:6:\"status\";a:8:{s:5:\"#type\";s:6:\"radios\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:9:\"invisible\";s:14:\"#default_value\";s:1:\"2\";s:8:\"#options\";a:3:{i:2;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Open\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:1;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Closed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}i:0;O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Hidden\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:2;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Users with the \"Post comments\" permission can post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:1;a:1:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Users cannot post comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}i:0;a:2:{s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Comments are hidden from view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:0;}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"field_reviews\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";s:7:\"Reviews\";s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:53:\"Drupal\\comment\\Plugin\\Field\\FieldWidget\\CommentWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:13:\"field_reviews\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:9;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:65:\"config:field.field.commerce_product.product_display.field_reviews\";i:1;s:51:\"config:field.storage.commerce_product.field_reviews\";}s:7:\"max-age\";i:-1;}}s:10:\"field_tags\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"field_tags_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-field-tags\";i:2;s:48:\"field--widget-entity-reference-autocomplete-tags\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:16:{s:6:\"#title\";s:4:\"Tags\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:13:\"taxonomy_term\";s:18:\"#selection_handler\";s:21:\"default:taxonomy_term\";s:19:\"#selection_settings\";a:5:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;s:18:\"auto_create_bundle\";s:0:\"\";s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";a:2:{i:0;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"37\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051552\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"37\";s:4:\"uuid\";s:36:\"db3e03dc-a063-45da-9c37-41b0575ada27\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"Branding\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}i:1;O:27:\"Drupal\\taxonomy\\Entity\\Term\":24:{s:9:\"\0*\0values\";a:9:{s:3:\"tid\";a:1:{s:9:\"x-default\";s:2:\"38\";}s:3:\"vid\";a:1:{s:9:\"x-default\";s:4:\"tags\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:4:\"name\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:11:\"description\";a:1:{s:9:\"x-default\";a:2:{s:5:\"value\";N;s:6:\"format\";N;}}s:6:\"weight\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503051567\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"tags\";s:2:\"id\";s:2:\"38\";s:4:\"uuid\";s:36:\"7440647c-2bb4-47e3-b21a-580e7ad8a0bc\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"Clean\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:13:\"taxonomy_term\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:5:\"#tags\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:80:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteTagsWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:10:\"field_tags\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:10:\"field_tags\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:4;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.field_tags\";i:1;s:48:\"config:field.storage.commerce_product.field_tags\";}s:7:\"max-age\";i:-1;}}s:8:\"langcode\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"langcode_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"field--type-language\";i:1;s:20:\"field--name-langcode\";i:2;s:29:\"field--widget-language-select\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:10:{s:6:\"#title\";r:515;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:15:\"language_select\";s:14:\"#default_value\";s:2:\"en\";s:10:\"#languages\";i:3;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:8:\"langcode\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:515;s:12:\"#description\";s:0:\"\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:63:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\LanguageSelectWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:8:\"langcode\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:4:\"path\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:12:\"path_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:16:\"field--type-path\";i:1;s:16:\"field--name-path\";i:2;s:18:\"field--widget-path\";}}s:6:\"widget\";a:13:{i:0;a:13:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:17:\"#element_validate\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:19:\"validateFormElement\";}}s:5:\"alias\";a:8:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";r:569;s:14:\"#default_value\";s:36:\"/product/religion-jersey-polo-shirts\";s:9:\"#required\";b:0;s:10:\"#maxlength\";i:255;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"The alternative URL for this product. Use a relative path. For example, \"/my-product\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#states\";a:1:{s:8:\"disabled\";a:1:{s:31:\"input[name=\"path[0][pathauto]\"]\";a:1:{s:7:\"checked\";b:1;}}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:15:\"pathauto/widget\";}}}s:3:\"pid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"23\";}s:6:\"source\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:10:\"/product/4\";}s:8:\"langcode\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:2:\"en\";}s:8:\"pathauto\";a:5:{s:5:\"#type\";s:8:\"checkbox\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Generate automatic URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#default_value\";i:1;s:12:\"#description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Uncheck this to create a custom alias below. <a href=\"@admin_link\">Configure URL alias patterns.</a>\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@admin_link\";s:34:\"/admin/config/search/path/patterns\";}s:10:\"\0*\0options\";a:0:{}}s:7:\"#weight\";i:-1;}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:4:\"path\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:569;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:22:\"The product URL alias.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:30:\"Drupal\\pathauto\\PathautoWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:4:\"path\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:8;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:13:\"path_settings\";}s:6:\"stores\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:14:\"stores_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:18:\"field--name-stores\";i:2;s:36:\"field--widget-commerce-entity-select\";}}s:6:\"widget\";a:6:{s:9:\"target_id\";a:13:{s:6:\"#title\";s:6:\"Stores\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:22:\"commerce_entity_select\";s:12:\"#target_type\";s:14:\"commerce_store\";s:9:\"#multiple\";b:1;s:14:\"#default_value\";a:1:{i:0;s:1:\"1\";}s:23:\"#autocomplete_threshold\";i:7;s:18:\"#autocomplete_size\";i:60;s:25:\"#autocomplete_placeholder\";s:0:\"\";}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:59:\"Drupal\\commerce\\Plugin\\Field\\FieldWidget\\EntitySelectWidget\";i:1;s:10:\"afterBuild\";}}s:11:\"#field_name\";s:6:\"stores\";s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:6:\"stores\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:6;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:58:\"config:field.field.commerce_product.product_display.stores\";i:1;s:44:\"config:field.storage.commerce_product.stores\";}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:19:\"visibility_settings\";}s:5:\"title\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:13:\"title_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:18:\"field--type-string\";i:1;s:17:\"field--name-title\";i:2;s:30:\"field--widget-string-textfield\";}}s:6:\"widget\";a:13:{i:0;a:8:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:13:{s:6:\"#title\";r:701;s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:27:\"Religion Jersey Polo Shirts\";s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:12:\"js-text-full\";i:1;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:5:\"title\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:701;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:18:\"The product title.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:64:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\StringTextfieldWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:5:\"title\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:1;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:3:\"uid\";a:8:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:11:\"uid_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:15:\"field--name-uid\";i:2;s:43:\"field--widget-entity-reference-autocomplete\";}}s:6:\"widget\";a:13:{i:0;a:2:{s:9:\"target_id\";a:16:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:19:\"entity_autocomplete\";s:12:\"#target_type\";s:4:\"user\";s:18:\"#selection_handler\";s:7:\"default\";s:19:\"#selection_settings\";a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}s:19:\"#validate_reference\";b:0;s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";O:23:\"Drupal\\user\\Entity\\User\":24:{s:9:\"\0*\0values\";a:18:{s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:18:\"preferred_langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:24:\"preferred_admin_langcode\";a:1:{s:9:\"x-default\";N;}s:4:\"name\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"Admin\";}}}s:4:\"pass\";a:1:{s:9:\"x-default\";s:55:\"$S$EhGnUMd.8TB1res/YFWR71jZaEXbVcwKIlVCxDP7xfDfSU7lInf2\";}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:8:\"timezone\";a:1:{s:9:\"x-default\";s:13:\"Europe/Moscow\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1478015440\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1502463162\";}s:6:\"access\";a:1:{s:9:\"x-default\";s:10:\"1503323088\";}s:5:\"login\";a:1:{s:9:\"x-default\";s:10:\"1502821848\";}s:4:\"init\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"roles\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:13:\"administrator\";}}}s:12:\"user_picture\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:1:\"8\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:2:\"85\";s:6:\"height\";s:2:\"85\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:4:\"user\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"cd4ab506-5336-4ccc-bc2b-1fd970c6686a\";}s:25:\"\0*\0translatableEntityKeys\";a:2:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"user\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:5:\"#size\";i:60;s:12:\"#placeholder\";s:0:\"\";}s:12:\"#description\";s:0:\"\";}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:3:\"uid\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:0;s:6:\"#title\";r:763;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:19:\"The product author.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:76:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldWidget\\EntityReferenceAutocompleteWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:3:\"uid\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:5;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}s:6:\"#group\";s:6:\"author\";}s:10:\"variations\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:18:\"variations_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:22:\"field--name-variations\";i:2;s:40:\"field--widget-inline-entity-form-complex\";}}s:6:\"widget\";a:21:{s:5:\"#type\";s:8:\"fieldset\";s:5:\"#tree\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:70:\"<div id=\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:9:\"#ief_root\";b:1;s:12:\"#translating\";b:0;s:12:\"#field_title\";s:10:\"Variations\";s:12:\"#after_build\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:25:\"removeTranslatabilityClue\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:10:\"afterBuild\";}}s:6:\"#title\";s:10:\"Variations\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:25:\"inline_entity_form/widget\";}}s:17:\"#element_validate\";a:2:{i:0;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:16:\"updateRowWeights\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:13:\"requiredField\";}}s:8:\"entities\";a:6:{s:5:\"#tree\";b:1;s:6:\"#theme\";s:31:\"inline_entity_form_entity_table\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:13:\"#table_fields\";a:3:{s:5:\"label\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:1;}s:5:\"price\";a:3:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:10;}s:6:\"status\";a:4:{s:4:\"type\";s:5:\"field\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:100;s:15:\"display_options\";a:1:{s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Inactive\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}}i:0;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"0\";s:5:\"title\";a:0:{}s:5:\"delta\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"0\";}s:4:\"form\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:8:\"ief-form\";i:1;s:12:\"ief-form-row\";}}s:18:\"inline_entity_form\";a:13:{s:5:\"#type\";s:18:\"inline_entity_form\";s:12:\"#entity_type\";s:26:\"commerce_product_variation\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#langcode\";s:2:\"en\";s:14:\"#default_value\";r:970;s:3:\"#op\";s:4:\"edit\";s:10:\"#form_mode\";s:7:\"default\";s:12:\"#save_entity\";b:0;s:14:\"#ief_row_delta\";i:0;s:8:\"#parents\";a:6:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:18:\"inline_entity_form\";i:3;s:8:\"entities\";i:4;i:0;i:5;s:4:\"form\";}s:11:\"#ief_labels\";a:2:{s:8:\"singular\";s:9:\"variation\";s:6:\"plural\";s:10:\"variations\";}s:7:\"#ief_id\";s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";s:8:\"#process\";a:3:{i:0;a:2:{i:0;s:51:\"\\Drupal\\inline_entity_form\\Element\\InlineEntityForm\";i:1;s:17:\"processEntityForm\";}i:1;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:21:\"addIefSubmitCallbacks\";}i:2;a:2:{i:0;s:74:\"Drupal\\inline_entity_form\\Plugin\\Field\\FieldWidget\\InlineEntityFormComplex\";i:1;s:22:\"buildEntityFormActions\";}}}}}i:1;a:7:{s:6:\"#label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"N/A\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"#needs_save\";b:0;s:7:\"#weight\";s:1:\"1\";s:5:\"title\";a:0:{}s:5:\"delta\";a:4:{s:5:\"#type\";s:6:\"weight\";s:6:\"#delta\";i:50;s:14:\"#default_value\";s:1:\"1\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"ief-entity-delta\";}}}s:7:\"actions\";a:4:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:21:\"ief-entity-operations\";}}s:15:\"ief_entity_edit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:58:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-edit-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:4:\"edit\";}s:17:\"ief_entity_remove\";a:9:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Remove\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:60:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-entity-remove-1\";s:24:\"#limit_validation_errors\";a:0:{}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:32:\"inline_entity_form_open_row_form\";}s:14:\"#ief_row_delta\";i:1;s:13:\"#ief_row_form\";s:6:\"remove\";s:7:\"#access\";b:1;}}}}s:7:\"actions\";a:5:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:16:\"container-inline\";}}s:5:\"#type\";s:9:\"container\";s:7:\"#weight\";i:100;s:6:\"bundle\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:7:\"product\";}s:7:\"ief_add\";a:7:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Add new @type_singular\";s:12:\"\0*\0arguments\";a:1:{s:14:\"@type_singular\";s:9:\"variation\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"#name\";s:48:\"ief-5a3955af46ce08a39e261b16b82ffca38fc21e15-add\";s:24:\"#limit_validation_errors\";a:1:{i:0;a:3:{i:0;s:10:\"variations\";i:1;s:4:\"form\";i:2;s:7:\"actions\";}}s:5:\"#ajax\";a:2:{s:8:\"callback\";s:30:\"inline_entity_form_get_element\";s:7:\"wrapper\";s:59:\"inline-entity-form-5a3955af46ce08a39e261b16b82ffca38fc21e15\";}s:7:\"#submit\";a:1:{i:0;s:28:\"inline_entity_form_open_form\";}s:9:\"#ief_form\";s:3:\"add\";}}s:11:\"#field_name\";s:10:\"variations\";s:8:\"#parents\";a:1:{i:0;s:10:\"variations\";}}s:7:\"#access\";b:1;s:7:\"#weight\";i:2;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:4:\"tags\";a:2:{i:0;s:62:\"config:field.field.commerce_product.product_display.variations\";i:1;s:48:\"config:field.storage.commerce_product.variations\";}s:7:\"max-age\";i:-1;}}s:16:\"#entity_builders\";a:2:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";s:13:\"update_status\";a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:12:\"updateStatus\";}}s:5:\"#tree\";b:1;s:6:\"#theme\";a:1:{i:0;s:21:\"commerce_product_form\";}s:9:\"#attached\";a:2:{s:7:\"library\";a:1:{i:0;s:21:\"commerce_product/form\";}s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"changed\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:14:\"#default_value\";s:10:\"1503302248\";}s:4:\"meta\";a:7:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"entity-meta__header\";}}s:5:\"#type\";s:9:\"container\";s:6:\"#group\";s:8:\"advanced\";s:7:\"#weight\";i:-100;s:9:\"published\";a:5:{s:5:\"#type\";s:8:\"html_tag\";s:4:\"#tag\";s:2:\"h3\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";s:18:\"entity-meta__title\";}}s:7:\"changed\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:23:\"entity-meta__last-saved\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:59:\"<h4 class=\"label inline\">Last saved</h4> 08/21/2017 - 10:57\";}s:6:\"author\";a:3:{s:5:\"#type\";s:4:\"item\";s:19:\"#wrapper_attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"author\";i:1;s:16:\"container-inline\";}}s:7:\"#markup\";s:42:\"<h4 class=\"label inline\">Author</h4> Admin\";}}s:8:\"advanced\";a:3:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:11:\"entity-meta\";}}s:7:\"#weight\";i:99;}s:19:\"visibility_settings\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Visibility settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:1;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:27:\"product-visibility-settings\";}}s:7:\"#weight\";i:30;}s:13:\"path_settings\";a:8:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"URL path settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"#open\";b:0;s:6:\"#group\";s:8:\"advanced\";s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"path-form\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:16:\"path/drupal.path\";}}s:7:\"#weight\";i:60;}s:6:\"author\";a:7:{s:5:\"#type\";s:7:\"details\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Authoring information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"#group\";s:8:\"advanced\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:19:\"product-form-author\";}}s:9:\"#attached\";a:1:{s:7:\"library\";a:1:{i:0;s:40:\"commerce_product/drupal.commerce_product\";}}s:7:\"#weight\";i:90;s:9:\"#optional\";b:1;}s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";i:1;s:27:\"hideEmptyVisibilitySettings\";}}s:7:\"actions\";a:5:{s:6:\"submit\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:7:\"#access\";b:0;s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:7:\"publish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Save and keep published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:1;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:0;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:9:\"unpublish\";a:8:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Save and unpublish\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:3:{i:0;a:2:{i:0;s:39:\"Drupal\\inline_entity_form\\ElementSubmit\";i:1;s:7:\"trigger\";}i:1;s:12:\"::submitForm\";i:2;s:6:\"::save\";}s:17:\"#published_status\";b:0;s:11:\"#dropbutton\";s:4:\"save\";s:7:\"#weight\";i:10;s:19:\"#ief_submit_trigger\";b:1;s:23:\"#ief_submit_trigger_all\";b:1;}s:6:\"delete\";a:7:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#access\";b:1;s:11:\"#attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:6:\"button\";i:1;s:14:\"button--danger\";}}s:4:\"#url\";O:15:\"Drupal\\Core\\Url\":11:{s:15:\"\0*\0urlGenerator\";N;s:15:\"\0*\0urlAssembler\";N;s:16:\"\0*\0accessManager\";N;s:12:\"\0*\0routeName\";s:35:\"entity.commerce_product.delete_form\";s:18:\"\0*\0routeParameters\";a:1:{s:16:\"commerce_product\";s:1:\"4\";}s:10:\"\0*\0options\";a:3:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:8:\"language\";O:29:\"Drupal\\Core\\Language\\Language\":5:{s:7:\"\0*\0name\";s:7:\"English\";s:5:\"\0*\0id\";s:2:\"en\";s:12:\"\0*\0direction\";s:3:\"ltr\";s:9:\"\0*\0weight\";i:0;s:9:\"\0*\0locked\";b:0;}}s:11:\"\0*\0external\";b:0;s:11:\"\0*\0unrouted\";b:0;s:6:\"\0*\0uri\";N;s:15:\"\0*\0internalPath\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:7:\"#weight\";i:100;s:12:\"#button_type\";s:6:\"danger\";}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:42:\"commerce_product_product_display_edit_form\";s:9:\"#build_id\";s:48:\"form-_IHzfY0gd1vXaUdCnvVB2jhy1GS0bg4c__WoypgJkgs\";s:5:\"#type\";s:4:\"form\";s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-_IHzfY0gd1vXaUdCnvVB2jhy1GS0bg4c__WoypgJkgs\";s:3:\"#id\";s:48:\"form-_IHzfY0gd1vXaUdCnvVB2jhy1GS0bg4c__WoypgJkgs\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:71:\"edit-commerce-product-product-display-edit-form-form-token--gqQMUsw7-ks\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_otIkxSvL8XfbPONF3DaDorGsfJz4VoER4R_Z_sIP2OI\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_product_product_display_edit_form\";s:3:\"#id\";s:60:\"edit-commerce-product-product-display-edit-form--UVOMdJcbU2g\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:55:\"commerce-product-product-display-edit-form--dTe_i6Nssb0\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:16:\"commerce_product\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:28:\"#ief_element_submit_attached\";b:1;s:19:\"#ief_element_submit\";a:1:{i:0;a:2:{i:0;s:38:\"Drupal\\inline_entity_form\\WidgetSubmit\";i:1;s:8:\"doSubmit\";}}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503344847),

('form','form-_xVVn_XBR1fGJ5Hvm9WMaeCBeXVr-G5u14ESF2Lf9AU','a:32:{s:11:\"#attributes\";a:2:{s:5:\"class\";a:3:{i:0;s:46:\"commerce-order-item-default-add-to-cart-1-form\";i:1;s:36:\"commerce-order-item-add-to-cart-form\";i:2;s:4:\"form\";}s:20:\"data-drupal-selector\";s:46:\"commerce-order-item-default-add-to-cart-1-form\";}s:8:\"#process\";a:2:{i:0;s:13:\"::processForm\";i:1;a:2:{i:0;O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}i:1;s:11:\"processForm\";}}s:8:\"#parents\";a:0:{}s:11:\"#wrapper_id\";s:46:\"commerce-product-add-to-cart-form--R4elGTXO-BU\";s:7:\"#prefix\";s:57:\"<div id=\"commerce-product-add-to-cart-form--R4elGTXO-BU\">\";s:7:\"#suffix\";s:6:\"</div>\";s:16:\"purchased_entity\";a:7:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:24:\"purchased_entity_wrapper\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:28:\"field--type-entity-reference\";i:1;s:28:\"field--name-purchased-entity\";i:2;s:51:\"field--widget-commerce-product-variation-attributes\";}}s:6:\"widget\";a:13:{i:0;a:9:{s:6:\"#title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Purchased entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"#title_display\";s:6:\"before\";s:12:\"#description\";s:0:\"\";s:14:\"#field_parents\";a:0:{}s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"variation\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"4\";}s:10:\"attributes\";a:5:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:17:\"attribute-widgets\";}}s:15:\"attribute_color\";a:6:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:5:\"Color\";s:8:\"#options\";a:2:{i:12;s:5:\"Black\";i:13;s:5:\"White\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"12\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--R4elGTXO-BU\";}}s:14:\"attribute_size\";a:7:{s:5:\"#type\";s:6:\"select\";s:6:\"#title\";s:4:\"Size\";s:8:\"#options\";a:1:{i:22;s:2:\"XL\";}s:9:\"#required\";b:1;s:14:\"#default_value\";s:2:\"22\";s:5:\"#ajax\";a:2:{s:8:\"callback\";a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:11:\"ajaxRefresh\";}s:7:\"wrapper\";s:46:\"commerce-product-add-to-cart-form--R4elGTXO-BU\";}s:9:\"#disabled\";b:1;}s:12:\"#description\";s:0:\"\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:16:\"purchased_entity\";s:12:\"#cardinality\";i:1;s:21:\"#cardinality_multiple\";b:0;s:9:\"#required\";b:1;s:6:\"#title\";r:79;s:12:\"#description\";O:37:\"Drupal\\Core\\Field\\FieldFilteredMarkup\":1:{s:9:\"\0*\0string\";s:21:\"The purchased entity.\";}s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;a:2:{i:0;s:81:\"Drupal\\commerce_product\\Plugin\\Field\\FieldWidget\\ProductVariationAttributesWidget\";i:1;s:10:\"afterBuild\";}}s:14:\"#field_parents\";a:0:{}s:8:\"#parents\";a:1:{i:0;s:16:\"purchased_entity\";}s:5:\"#tree\";b:1;}s:7:\"#access\";b:1;s:7:\"#weight\";i:0;s:6:\"#cache\";a:3:{s:8:\"contexts\";a:0:{}s:4:\"tags\";a:0:{}s:7:\"max-age\";i:-1;}}s:6:\"#cache\";a:3:{s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:24:\"user.roles:authenticated\";}s:4:\"tags\";a:1:{i:0;s:71:\"config:core.entity_form_display.commerce_order_item.default.add_to_cart\";}s:7:\"max-age\";i:-1;}s:16:\"#entity_builders\";a:1:{s:20:\"update_form_langcode\";s:20:\"::updateFormLangcode\";}s:7:\"actions\";a:2:{s:6:\"submit\";a:5:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add to cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:12:\"#button_type\";s:7:\"primary\";s:7:\"#weight\";i:5;}s:5:\"#type\";s:7:\"actions\";}s:8:\"#form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:9:\"#build_id\";s:48:\"form-_xVVn_XBR1fGJ5Hvm9WMaeCBeXVr-G5u14ESF2Lf9AU\";s:5:\"#type\";s:4:\"form\";s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:40:\"form_builder:renderPlaceholderFormAction\";i:1;a:0:{}}}}}s:7:\"#action\";s:55:\"form_action_p_pvdeGsVG5zNF_XLGPTvYSKCf43t8qZYSwcfZl2uzM\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-_xVVn_XBR1fGJ5Hvm9WMaeCBeXVr-G5u14ESF2Lf9AU\";s:3:\"#id\";s:48:\"form-_xVVn_XBR1fGJ5Hvm9WMaeCBeXVr-G5u14ESF2Lf9AU\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:10:\"form_token\";a:6:{s:3:\"#id\";s:75:\"edit-commerce-order-item-default-add-to-cart-1-form-form-token--9RMjUDXLHrc\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}s:9:\"#attached\";a:1:{s:12:\"placeholders\";a:1:{s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";a:1:{s:13:\"#lazy_builder\";a:2:{i:0;s:39:\"form_builder:renderFormTokenPlaceholder\";i:1;a:1:{i:0;s:66:\"form_token_placeholder_z4iPINJD-N66aOCJgL_YHqiHT3rnhUmaZBIaG3LLdEg\";}}}}}s:6:\"#cache\";a:1:{s:7:\"max-age\";i:0;}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";s:3:\"#id\";s:64:\"edit-commerce-order-item-default-add-to-cart-1-form--dqhhqCxbS74\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:59:\"commerce-order-item-default-add-to-cart-1-form--zFBQLCw0v3E\";s:7:\"#method\";s:4:\"post\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:16:\"#defaults_loaded\";b:1;s:5:\"#tree\";b:0;s:9:\"#validate\";a:1:{i:0;s:14:\"::validateForm\";}s:7:\"#submit\";a:1:{i:0;s:12:\"::submitForm\";}s:6:\"#theme\";a:2:{i:0;s:46:\"commerce_order_item_default_add_to_cart_1_form\";i:1;s:36:\"commerce_order_item_add_to_cart_form\";}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}s:12:\"#entity_type\";s:19:\"commerce_order_item\";s:11:\"#pre_render\";a:1:{i:0;s:27:\"field_group_form_pre_render\";}s:12:\"#cache_token\";s:43:\"rjhIlhln6FMfnCrecPDUY2fv6P9uS9LRO-owpxaAofk\";}',1503429740),

('form_state','form--CXVOpTUNUrdnhz_2DMCAtiwIegwJxtY2KazikGDn6I','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"und\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"G-Star Polo Applique Jersey\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053273\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503310324\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"39\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"3\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:3:\"und\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:1:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"3158\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"94.750000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053515\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503310324\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"66\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"240\";s:6:\"height\";s:3:\"320\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:10:\"150.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";i:0;s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503332138),

('form_state','form--LsSsqh0_0RjtgcKnSaqNtnoDHcyPuPsJI_UnjpOGzo','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:1:{i:0;O:27:\"Drupal\\editor\\Entity\\Editor\":20:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:9:\"\0*\0editor\";s:8:\"ckeditor\";s:11:\"\0*\0settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:5:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:2:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";}}i:1;a:2:{s:4:\"name\";s:5:\"Links\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:2:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";}}i:4;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:1:{i:0;s:6:\"Source\";}}}}}s:7:\"plugins\";a:2:{s:8:\"language\";a:1:{s:13:\"language_list\";s:2:\"un\";}s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:15:\"\0*\0image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";N;s:6:\"height\";N;}}s:15:\"\0*\0filterFormat\";O:33:\"Drupal\\filter\\Entity\\FilterFormat\":20:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:7:\"\0*\0name\";s:8:\"CKeditor\";s:9:\"\0*\0weight\";i:-9;s:8:\"\0*\0roles\";N;s:10:\"\0*\0filters\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"24aa033e-b666-403d-bb7c-d4bb14e01318\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:13:\"filter_format\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:6:\"editor\";i:1;s:12:\"entity_embed\";i:2;s:9:\"shortcode\";}}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"af9b5cee-8d4c-4a99-bb39-42fe2ce351d5\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:6:\"editor\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:1:{s:19:\"editorPluginManager\";s:21:\"plugin.manager.editor\";}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:22:\"filter.format.ckeditor\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}}}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:36:\"Drupal\\editor\\Form\\EditorImageDialog\":10:{s:14:\"\0*\0fileStorage\";O:23:\"Drupal\\file\\FileStorage\":19:{s:15:\"\0*\0tableMapping\";N;s:14:\"\0*\0revisionKey\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";b:0;s:12:\"\0*\0baseTable\";s:12:\"file_managed\";s:16:\"\0*\0revisionTable\";N;s:12:\"\0*\0dataTable\";N;s:20:\"\0*\0revisionDataTable\";N;s:16:\"\0*\0storageSchema\";N;s:12:\"\0*\0temporary\";b:0;s:12:\"\0*\0bundleKey\";s:0:\"\";s:11:\"\0*\0entities\";a:0:{}s:15:\"\0*\0entityTypeId\";s:4:\"file\";s:13:\"\0*\0entityType\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":40:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:4:\"file\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0handlers\";a:6:{s:7:\"storage\";s:23:\"Drupal\\file\\FileStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\file\\FileStorageSchema\";s:6:\"access\";s:36:\"Drupal\\file\\FileAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\file\\FileViewsData\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"file_managed\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"file_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:4:\"file\";}s:8:\"\0*\0class\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0provider\";s:4:\"file\";s:20:\"\0*\0stringTranslation\";N;}s:8:\"\0*\0idKey\";s:3:\"fid\";s:10:\"\0*\0uuidKey\";s:4:\"uuid\";s:14:\"\0*\0uuidService\";N;s:14:\"\0*\0entityClass\";s:23:\"Drupal\\file\\Entity\\File\";s:14:\"\0*\0_serviceIds\";a:6:{s:8:\"database\";s:8:\"database\";s:15:\"languageManager\";s:16:\"language_manager\";s:13:\"entityManager\";s:14:\"entity.manager\";s:12:\"cacheBackend\";s:12:\"cache.entity\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:12:\"\0*\0messenger\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:19:\"editor_image_dialog\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";b:1;s:7:\"storage\";a:1:{s:13:\"image_element\";a:4:{s:3:\"src\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1531753483),

('form_state','form-0RHehFaysKaJXq32WW_MMCL5472YnfeD--77nnRCw9E','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":11:{s:9:\"\0*\0formId\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:14:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"26970f65-8507-40f6-9a41-b41d0e24d069\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:21:\"overridden_unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1510499064;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1510499064;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"currentStore\";s:28:\"commerce_store.current_store\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503564727\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"28\";}i:1;a:1:{s:9:\"target_id\";s:2:\"31\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:6:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}s:4:\"view\";O:27:\"Drupal\\views\\ViewExecutable\":1:{s:20:\"\0*\0serializationData\";a:11:{s:7:\"storage\";s:12:\"shop_columns\";s:10:\"views_data\";s:16:\"views.views_data\";s:14:\"route_provider\";s:21:\"router.route_provider\";s:15:\"current_display\";s:6:\"page_1\";s:4:\"args\";a:0:{}s:12:\"current_page\";N;s:13:\"exposed_input\";a:4:{s:7:\"sort_by\";s:13:\"price__number\";s:10:\"sort_order\";s:4:\"DESC\";s:9:\"ajax_form\";s:1:\"1\";s:15:\"_wrapper_format\";s:4:\"html\";}s:17:\"exposed_raw_input\";a:2:{s:7:\"sort_by\";s:13:\"price__number\";s:10:\"sort_order\";s:4:\"DESC\";}s:12:\"exposed_data\";a:6:{s:6:\"submit\";s:5:\"Apply\";s:7:\"sort_by\";s:13:\"price__number\";s:10:\"sort_order\";s:4:\"DESC\";s:13:\"form_build_id\";s:48:\"form-VJNZst0f0ofQIjXb21l39apceOXsgO37ER9lqIeHnUY\";s:7:\"form_id\";s:18:\"views_exposed_form\";s:0:\"\";s:5:\"Apply\";}s:6:\"dom_id\";s:64:\"50357a3537d7d346d3d88c385d821d261dec462ecf12f4b837c676fe0c336ca4\";s:8:\"executed\";b:1;}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:9:\"published\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:6:\"teaser\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1510520664),

('form_state','form-1IBGnKqwoqQe0zVEO0x6wqNtkd5Y1ddD4D8oBTFd0yI','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"5831cfaf-e083-452d-abeb-99a5e2921ac0\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407192;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407192;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503428792),

('form_state','form-1PDPfRFeZ7o-cprsEwyhFSB2Kt04kicsL7btJZdm31Q','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:1:{i:0;O:27:\"Drupal\\editor\\Entity\\Editor\":20:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:9:\"\0*\0editor\";s:8:\"ckeditor\";s:11:\"\0*\0settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:5:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:2:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";}}i:1;a:2:{s:4:\"name\";s:5:\"Links\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:2:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";}}i:4;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:1:{i:0;s:6:\"Source\";}}}}}s:7:\"plugins\";a:2:{s:8:\"language\";a:1:{s:13:\"language_list\";s:2:\"un\";}s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:15:\"\0*\0image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";N;s:6:\"height\";N;}}s:15:\"\0*\0filterFormat\";O:33:\"Drupal\\filter\\Entity\\FilterFormat\":21:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:7:\"\0*\0name\";s:8:\"CKeditor\";s:9:\"\0*\0weight\";i:-9;s:8:\"\0*\0roles\";N;s:10:\"\0*\0filters\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:19:\"\0*\0filterCollection\";O:36:\"Drupal\\filter\\FilterPluginCollection\":7:{s:14:\"\0*\0definitions\";a:13:{s:21:\"editor_file_reference\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:84:\"Ensures that the latest versions of images uploaded via a Text Editor are displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Track images uploaded via a Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:12:\"entity_embed\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Embeds entities using data attributes: data-entity-type, data-entity-uuid, and data-view-mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Display embedded entities\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:12:\"filter_align\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:90:\"Uses a <code>data-align</code> attribute on <code>&lt;img&gt;</code> tags to align images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_align\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Align images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAlign\";s:8:\"provider\";s:6:\"filter\";}s:12:\"filter_autop\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_autop\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:87:\"Convert line breaks into HTML (i.e. <code>&lt;br&gt;</code> and <code>&lt;p&gt;</code>)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAutoP\";s:8:\"provider\";s:6:\"filter\";}s:14:\"filter_caption\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Uses a <code>data-caption</code> attribute on <code>&lt;img&gt;</code> tags to caption images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:14:\"filter_caption\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Caption images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:41:\"Drupal\\filter\\Plugin\\Filter\\FilterCaption\";s:8:\"provider\";s:6:\"filter\";}s:11:\"filter_html\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Limit allowed HTML tags and correct faulty HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"filter_htmlcorrector\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:20:\"filter_htmlcorrector\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Correct faulty and chopped off HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:47:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlCorrector\";s:8:\"provider\";s:6:\"filter\";}s:18:\"filter_html_escape\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:18:\"filter_html_escape\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Display any HTML as plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:44:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlEscape\";s:8:\"provider\";s:6:\"filter\";}s:24:\"filter_html_image_secure\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:119:\"Disallows usage of &lt;img&gt; tag sources that are not hosted on this site by replacing them with a placeholder image.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Restrict images to this site\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:10:\"filter_url\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}s:2:\"id\";s:10:\"filter_url\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Convert URLs into links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:37:\"Drupal\\filter\\Plugin\\Filter\\FilterUrl\";s:8:\"provider\";s:6:\"filter\";}s:17:\"dynamicshortcodes\";a:11:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Shortcodes which shouldn\'t be cached.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:17:\"dynamicshortcodes\";s:6:\"module\";s:19:\"nd_visualshortcodes\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Dynamic Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"cache\";b:0;s:5:\"class\";s:58:\"Drupal\\nd_visualshortcodes\\Plugin\\Filter\\Dynamicshortcodes\";s:8:\"provider\";s:19:\"nd_visualshortcodes\";}s:9:\"shortcode\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides WP like shortcodes to text formats.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:19:\"shortcode_corrector\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"Trying to correct the html around shortcodes. Enable only if you using wysiwyg editor.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:19:\"shortcode_corrector\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Shortcodes - html corrector\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:49:\"Drupal\\shortcode\\Plugin\\Filter\\ShortcodeCorrector\";s:8:\"provider\";s:9:\"shortcode\";}}s:17:\"\0*\0configurations\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:12:\"\0*\0pluginKey\";s:2:\"id\";s:16:\"\0*\0originalOrder\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";}s:18:\"\0*\0pluginInstances\";a:5:{s:21:\"editor_file_reference\";O:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\":9:{s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:21:\"editor_file_reference\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:13:\"entityManager\";s:14:\"entity.manager\";}}s:12:\"entity_embed\";O:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\":9:{s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:12:\"entity_embed\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:3:{s:8:\"renderer\";s:8:\"renderer\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:7:\"builder\";s:20:\"entity_embed.builder\";}}s:11:\"filter_html\";O:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\":10:{s:15:\"\0*\0restrictions\";N;s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:11:\"\0*\0pluginId\";s:11:\"filter_html\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:24:\"filter_html_image_secure\";O:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\":9:{s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:24:\"filter_html_image_secure\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"shortcode\";O:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\":9:{s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:11:\"\0*\0pluginId\";s:9:\"shortcode\";s:19:\"\0*\0pluginDefinition\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:16:\"\0*\0configuration\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:14:\"\0*\0instanceIDs\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";}s:14:\"\0*\0_serviceIds\";a:1:{s:7:\"manager\";s:21:\"plugin.manager.filter\";}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"24aa033e-b666-403d-bb7c-d4bb14e01318\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:13:\"filter_format\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:6:\"editor\";i:1;s:12:\"entity_embed\";i:2;s:9:\"shortcode\";}}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"af9b5cee-8d4c-4a99-bb39-42fe2ce351d5\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:6:\"editor\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:1:{s:19:\"editorPluginManager\";s:21:\"plugin.manager.editor\";}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:22:\"filter.format.ckeditor\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}}}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:36:\"Drupal\\editor\\Form\\EditorImageDialog\":9:{s:14:\"\0*\0fileStorage\";O:23:\"Drupal\\file\\FileStorage\":18:{s:15:\"\0*\0tableMapping\";N;s:14:\"\0*\0revisionKey\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";b:0;s:12:\"\0*\0baseTable\";s:12:\"file_managed\";s:16:\"\0*\0revisionTable\";N;s:12:\"\0*\0dataTable\";N;s:20:\"\0*\0revisionDataTable\";N;s:16:\"\0*\0storageSchema\";N;s:12:\"\0*\0bundleKey\";s:0:\"\";s:11:\"\0*\0entities\";a:0:{}s:15:\"\0*\0entityTypeId\";s:4:\"file\";s:13:\"\0*\0entityType\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:4:\"file\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:23:\"Drupal\\file\\FileStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\file\\FileStorageSchema\";s:6:\"access\";s:36:\"Drupal\\file\\FileAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\file\\FileViewsData\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"file_managed\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"file_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0provider\";s:4:\"file\";s:20:\"\0*\0stringTranslation\";N;}s:8:\"\0*\0idKey\";s:3:\"fid\";s:10:\"\0*\0uuidKey\";s:4:\"uuid\";s:14:\"\0*\0uuidService\";N;s:14:\"\0*\0entityClass\";s:23:\"Drupal\\file\\Entity\\File\";s:14:\"\0*\0_serviceIds\";a:6:{s:8:\"database\";s:8:\"database\";s:15:\"languageManager\";s:16:\"language_manager\";s:13:\"entityManager\";s:14:\"entity.manager\";s:12:\"cacheBackend\";s:12:\"cache.entity\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:19:\"editor_image_dialog\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:0;s:16:\"has_file_element\";b:1;s:7:\"storage\";a:1:{s:13:\"image_element\";a:4:{s:3:\"src\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1497902686),

('form_state','form-2GcthApgNfGpPeUOzwxcb79paIrBdtYmvmUhySBwNdY','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":13:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:41:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:39:\"commerce_plugin_item:commerce_condition\";a:15:{s:11:\"plugin_type\";s:18:\"commerce_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:120;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"file_uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"file_uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"File URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"An entity field containing a file URI, and a computed root-relative file URL.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"file_uri\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:46:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileUriItem\";s:8:\"provider\";s:4:\"file\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:37:\"Drupal\\pathauto\\PathautoFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:28:\"Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"17ba37a5-f96b-4674-9546-6ecfdf98e091\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:13:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:56:\"core.entity_view_mode.commerce_product_variation.product\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:59:\"field.field.commerce_product_variation.product.field_length\";i:7;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:8;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:9;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:10;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:11;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:12;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:3:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:5:\"image\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.product\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"product\";s:10:\"\0*\0content\";a:4:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"field_images\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:10:\"image_link\";s:7:\"content\";}s:20:\"third_party_settings\";a:0:{}}s:15:\"field_old_price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"2\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:12:{s:15:\"attribute_color\";b:1;s:14:\"attribute_size\";b:1;s:17:\"field_description\";b:1;s:12:\"field_length\";b:1;s:28:\"field_right_side_description\";b:1;s:15:\"field_sale_text\";b:1;s:23:\"field_short_description\";b:1;s:11:\"field_waist\";b:1;s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;s:3:\"sku\";b:1;s:5:\"title\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:12:\"\0*\0messenger\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"product\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";N;}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1521045707),

('form_state','form-2h3H-J-xk8WTeINFnIVMOBjo6knYU1I7JCnpDyK0clo','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"4b4f7c0e-8edd-42e4-96d7-d3080ecfb80f\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503574462;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503574462;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503564727\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"28\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"31\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:7:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503596319),

('form_state','form-2vKLUHI6wtq3zzyI828LQNcgHhrAz8XLMPtK57GmZsk','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityFormDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"form\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"7ead05bb-48d9-4c0d-8503-3978179228c2\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:14:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:35:\"entity_browser.browser.browse_files\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:58:\"field.field.commerce_product_variation.product.field_color\";i:5;s:64:\"field.field.commerce_product_variation.product.field_description\";i:6;s:59:\"field.field.commerce_product_variation.product.field_images\";i:7;s:59:\"field.field.commerce_product_variation.product.field_length\";i:8;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:9;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:10;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:11;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:12;s:57:\"field.field.commerce_product_variation.product.field_size\";i:13;s:58:\"field.field.commerce_product_variation.product.field_waist\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:14:\"entity_browser\";i:2;s:11:\"field_group\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:11:\"field_group\";a:1:{s:16:\"group_properties\";a:6:{s:8:\"children\";a:4:{i:0;s:10:\"field_size\";i:1;s:11:\"field_color\";i:2;s:11:\"field_waist\";i:3;s:12:\"field_length\";}s:11:\"parent_name\";s:0:\"\";s:6:\"weight\";i:6;s:11:\"format_type\";s:7:\"details\";s:15:\"format_settings\";a:4:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:4:\"open\";b:1;s:15:\"required_fields\";b:1;}s:5:\"label\";s:10:\"Properties\";}}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:16:{s:15:\"attribute_color\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:1;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"attribute_size\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"field_color\";a:5:{s:6:\"weight\";s:2:\"22\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:5:{s:6:\"weight\";s:1:\"9\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:5:{s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:17:\"field_widget_edit\";b:1;s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:5:{s:6:\"weight\";s:2:\"24\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:5:{s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:5:{s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:5:{s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:5:{s:6:\"weight\";s:1:\"8\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"string_textarea\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:5:{s:6:\"weight\";s:2:\"21\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:5:{s:6:\"weight\";s:2:\"23\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:5:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:3:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:27:\"plugin.manager.field.widget\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_form_display_form\";s:7:\"form_id\";s:29:\"entity_form_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:4:{s:23:\"entity_form_initialized\";b:1;s:11:\"field_group\";a:1:{s:16:\"group_properties\";O:8:\"stdClass\":11:{s:8:\"children\";a:4:{i:0;s:10:\"field_size\";i:1;s:11:\"field_color\";i:2;s:11:\"field_waist\";i:3;s:12:\"field_length\";}s:11:\"parent_name\";s:0:\"\";s:6:\"weight\";i:6;s:11:\"format_type\";s:7:\"details\";s:15:\"format_settings\";a:4:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:4:\"open\";b:1;s:15:\"required_fields\";b:1;}s:5:\"label\";s:10:\"Properties\";s:10:\"group_name\";s:16:\"group_properties\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:7:\"context\";s:4:\"form\";s:4:\"mode\";s:7:\"default\";}}s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"form\";s:6:\"groups\";a:1:{s:16:\"group_properties\";O:8:\"stdClass\":11:{s:8:\"children\";a:4:{i:0;s:10:\"field_size\";i:1;s:11:\"field_color\";i:2;s:11:\"field_waist\";i:3;s:12:\"field_length\";}s:11:\"parent_name\";s:0:\"\";s:6:\"weight\";i:6;s:11:\"format_type\";s:7:\"details\";s:15:\"format_settings\";a:4:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:4:\"open\";b:1;s:15:\"required_fields\";b:1;}s:5:\"label\";s:10:\"Properties\";s:10:\"group_name\";s:16:\"group_properties\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:7:\"context\";s:4:\"form\";s:4:\"mode\";s:7:\"default\";}}s:7:\"parents\";a:4:{s:10:\"field_size\";s:16:\"group_properties\";s:11:\"field_color\";s:16:\"group_properties\";s:11:\"field_waist\";s:16:\"group_properties\";s:12:\"field_length\";s:16:\"group_properties\";}}s:20:\"plugin_settings_edit\";s:10:\"field_size\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503347159),

('form_state','form-3e9AivfNFf7-bxcCqP8IHsa4i3ZvrAREP5KtaoiGFT0','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:7:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:2:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}s:10:\"variations\";a:1:{s:4:\"form\";a:1:{s:18:\"inline_entity_form\";a:1:{s:8:\"entities\";a:1:{i:0;a:1:{s:4:\"form\";a:1:{s:7:\"#fields\";a:15:{s:20:\"attribute_parameters\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:20:\"attribute_parameters\";i:7;s:6:\"widget\";}}s:11:\"field_color\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_color\";i:7;s:6:\"widget\";}}s:17:\"field_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:17:\"field_description\";i:7;s:6:\"widget\";}}s:12:\"field_images\";a:2:{s:11:\"items_count\";i:4;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_images\";i:7;s:6:\"widget\";}}s:12:\"field_length\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_length\";i:7;s:6:\"widget\";}}s:15:\"field_old_price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_old_price\";i:7;s:6:\"widget\";}}s:28:\"field_right_side_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:28:\"field_right_side_description\";i:7;s:6:\"widget\";}}s:15:\"field_sale_text\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_sale_text\";i:7;s:6:\"widget\";}}s:23:\"field_short_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:23:\"field_short_description\";i:7;s:6:\"widget\";}}s:10:\"field_size\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:10:\"field_size\";i:7;s:6:\"widget\";}}s:11:\"field_waist\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_waist\";i:7;s:6:\"widget\";}}s:5:\"price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"price\";i:7;s:6:\"widget\";}}s:3:\"sku\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:3:\"sku\";i:7;s:6:\"widget\";}}s:6:\"status\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:6:\"status\";i:7;s:6:\"widget\";}}s:5:\"title\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"title\";i:7;s:6:\"widget\";}}}}}}}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";N;s:10:\"needs_save\";b:0;}}}}s:21:\"entity_browser_widget\";a:1:{s:49:\"534712e5-05cc-42b8-a371-bb7af482f33f:field_images\";a:4:{i:0;s:2:\"62\";i:1;s:2:\"63\";i:2;s:2:\"64\";i:3;s:2:\"65\";}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503344771),

('form_state','form-3R587Wd7EevVwvz33sdetmdHw-6Qel_KdSkbzdsBh3k','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":13:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:41:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:39:\"commerce_plugin_item:commerce_condition\";a:15:{s:11:\"plugin_type\";s:18:\"commerce_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:120;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"file_uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"file_uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"File URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"An entity field containing a file URI, and a computed root-relative file URL.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"file_uri\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:46:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileUriItem\";s:8:\"provider\";s:4:\"file\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:37:\"Drupal\\pathauto\\PathautoFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:28:\"Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"025ac682-e1c1-45ec-8ee9-bff4d42a193c\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"core.entity_view_mode.commerce_product.teaser\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"\0*\0id\";s:39:\"commerce_product.product_display.teaser\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:6:\"teaser\";s:10:\"\0*\0content\";a:2:{s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:2:\"-5\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:8:{s:7:\"created\";b:1;s:14:\"field_category\";b:1;s:12:\"field_rating\";b:1;s:13:\"field_reviews\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:12:\"\0*\0messenger\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:6:\"teaser\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";N;}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1521222790),

('form_state','form-4eKsgot8tdBy7UdwlE5FwibzCrZw4qGThLvEGjWl0xE','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"bb2c76d4-06a6-4575-b650-ca6eedfb9743\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503412766;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503412766;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503412318\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503434366),

('form_state','form-6GfrJDsZjlNzWjxJBLD__E4lPO4Tg0izGnMVX7tMKyM','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"067d0d33-7916-4599-a362-7e8544e4908d\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1504004815;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1504004815;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503564727\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"28\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"31\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:7:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1504026420),

('form_state','form-7kOBYCaQBYTq0NvdT3XjV1RRKzjx7S42f3KlqG0Xk1Y','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"bc5d6188-cefe-4350-a39e-4005f7f36258\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:12:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:58:\"field.field.commerce_product_variation.product.field_color\";i:2;s:64:\"field.field.commerce_product_variation.product.field_description\";i:3;s:59:\"field.field.commerce_product_variation.product.field_images\";i:4;s:59:\"field.field.commerce_product_variation.product.field_length\";i:5;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:6;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:7;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:8;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:9;s:57:\"field.field.commerce_product_variation.product.field_size\";i:10;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:11;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:10:\"rhythm_cms\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:14:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:2:\"13\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:11:\"field_color\";a:6:{s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";s:1:\"2\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:5:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:17:\"image_style_small\";s:19:\"product_small_68x86\";s:3:\"col\";s:1:\"3\";s:4:\"zoom\";i:0;s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";s:1:\"7\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";s:1:\"5\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";s:1:\"6\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";s:1:\"8\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:6:{s:6:\"weight\";s:1:\"9\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:2:{s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";s:12:\"field_images\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503337825),

('form_state','form-9wGCzuNBdkWmF9qseaUkQ9SaI4m4SeZaFx-jokHI7mk','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:1:{i:0;O:27:\"Drupal\\editor\\Entity\\Editor\":20:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:9:\"\0*\0editor\";s:8:\"ckeditor\";s:11:\"\0*\0settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:5:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:2:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";}}i:1;a:2:{s:4:\"name\";s:5:\"Links\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:2:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";}}i:4;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:1:{i:0;s:6:\"Source\";}}}}}s:7:\"plugins\";a:2:{s:8:\"language\";a:1:{s:13:\"language_list\";s:2:\"un\";}s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:15:\"\0*\0image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";N;s:6:\"height\";N;}}s:15:\"\0*\0filterFormat\";O:33:\"Drupal\\filter\\Entity\\FilterFormat\":21:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:7:\"\0*\0name\";s:8:\"CKeditor\";s:9:\"\0*\0weight\";i:-9;s:8:\"\0*\0roles\";N;s:10:\"\0*\0filters\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:19:\"\0*\0filterCollection\";O:36:\"Drupal\\filter\\FilterPluginCollection\":7:{s:14:\"\0*\0definitions\";a:13:{s:21:\"editor_file_reference\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:84:\"Ensures that the latest versions of images uploaded via a Text Editor are displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Track images uploaded via a Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:12:\"entity_embed\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Embeds entities using data attributes: data-entity-type, data-entity-uuid, and data-view-mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Display embedded entities\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:12:\"filter_align\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:90:\"Uses a <code>data-align</code> attribute on <code>&lt;img&gt;</code> tags to align images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_align\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Align images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAlign\";s:8:\"provider\";s:6:\"filter\";}s:12:\"filter_autop\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_autop\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:87:\"Convert line breaks into HTML (i.e. <code>&lt;br&gt;</code> and <code>&lt;p&gt;</code>)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAutoP\";s:8:\"provider\";s:6:\"filter\";}s:14:\"filter_caption\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Uses a <code>data-caption</code> attribute on <code>&lt;img&gt;</code> tags to caption images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:14:\"filter_caption\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Caption images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:41:\"Drupal\\filter\\Plugin\\Filter\\FilterCaption\";s:8:\"provider\";s:6:\"filter\";}s:11:\"filter_html\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Limit allowed HTML tags and correct faulty HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"filter_htmlcorrector\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:20:\"filter_htmlcorrector\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Correct faulty and chopped off HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:47:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlCorrector\";s:8:\"provider\";s:6:\"filter\";}s:18:\"filter_html_escape\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:18:\"filter_html_escape\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Display any HTML as plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:44:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlEscape\";s:8:\"provider\";s:6:\"filter\";}s:24:\"filter_html_image_secure\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:119:\"Disallows usage of &lt;img&gt; tag sources that are not hosted on this site by replacing them with a placeholder image.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Restrict images to this site\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:10:\"filter_url\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}s:2:\"id\";s:10:\"filter_url\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Convert URLs into links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:37:\"Drupal\\filter\\Plugin\\Filter\\FilterUrl\";s:8:\"provider\";s:6:\"filter\";}s:17:\"dynamicshortcodes\";a:11:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Shortcodes which shouldn\'t be cached.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:17:\"dynamicshortcodes\";s:6:\"module\";s:19:\"nd_visualshortcodes\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Dynamic Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"cache\";b:0;s:5:\"class\";s:58:\"Drupal\\nd_visualshortcodes\\Plugin\\Filter\\Dynamicshortcodes\";s:8:\"provider\";s:19:\"nd_visualshortcodes\";}s:9:\"shortcode\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides WP like shortcodes to text formats.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:19:\"shortcode_corrector\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"Trying to correct the html around shortcodes. Enable only if you using wysiwyg editor.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:19:\"shortcode_corrector\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Shortcodes - html corrector\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:49:\"Drupal\\shortcode\\Plugin\\Filter\\ShortcodeCorrector\";s:8:\"provider\";s:9:\"shortcode\";}}s:17:\"\0*\0configurations\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:12:\"\0*\0pluginKey\";s:2:\"id\";s:16:\"\0*\0originalOrder\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";}s:18:\"\0*\0pluginInstances\";a:5:{s:21:\"editor_file_reference\";O:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\":9:{s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:21:\"editor_file_reference\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:13:\"entityManager\";s:14:\"entity.manager\";}}s:12:\"entity_embed\";O:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\":9:{s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:12:\"entity_embed\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:3:{s:8:\"renderer\";s:8:\"renderer\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:7:\"builder\";s:20:\"entity_embed.builder\";}}s:11:\"filter_html\";O:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\":10:{s:15:\"\0*\0restrictions\";N;s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:11:\"\0*\0pluginId\";s:11:\"filter_html\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:24:\"filter_html_image_secure\";O:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\":9:{s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:24:\"filter_html_image_secure\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"shortcode\";O:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\":9:{s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:11:\"\0*\0pluginId\";s:9:\"shortcode\";s:19:\"\0*\0pluginDefinition\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:16:\"\0*\0configuration\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:14:\"\0*\0instanceIDs\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";}s:14:\"\0*\0_serviceIds\";a:1:{s:7:\"manager\";s:21:\"plugin.manager.filter\";}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"24aa033e-b666-403d-bb7c-d4bb14e01318\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:13:\"filter_format\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:6:\"editor\";i:1;s:12:\"entity_embed\";i:2;s:9:\"shortcode\";}}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"af9b5cee-8d4c-4a99-bb39-42fe2ce351d5\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:6:\"editor\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:1:{s:19:\"editorPluginManager\";s:21:\"plugin.manager.editor\";}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:22:\"filter.format.ckeditor\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}}}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:36:\"Drupal\\editor\\Form\\EditorImageDialog\":9:{s:14:\"\0*\0fileStorage\";O:23:\"Drupal\\file\\FileStorage\":18:{s:15:\"\0*\0tableMapping\";N;s:14:\"\0*\0revisionKey\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";b:0;s:12:\"\0*\0baseTable\";s:12:\"file_managed\";s:16:\"\0*\0revisionTable\";N;s:12:\"\0*\0dataTable\";N;s:20:\"\0*\0revisionDataTable\";N;s:16:\"\0*\0storageSchema\";N;s:12:\"\0*\0bundleKey\";s:0:\"\";s:11:\"\0*\0entities\";a:0:{}s:15:\"\0*\0entityTypeId\";s:4:\"file\";s:13:\"\0*\0entityType\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:4:\"file\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:23:\"Drupal\\file\\FileStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\file\\FileStorageSchema\";s:6:\"access\";s:36:\"Drupal\\file\\FileAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\file\\FileViewsData\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"file_managed\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"file_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0provider\";s:4:\"file\";s:20:\"\0*\0stringTranslation\";N;}s:8:\"\0*\0idKey\";s:3:\"fid\";s:10:\"\0*\0uuidKey\";s:4:\"uuid\";s:14:\"\0*\0uuidService\";N;s:14:\"\0*\0entityClass\";s:23:\"Drupal\\file\\Entity\\File\";s:14:\"\0*\0_serviceIds\";a:6:{s:8:\"database\";s:8:\"database\";s:15:\"languageManager\";s:16:\"language_manager\";s:13:\"entityManager\";s:14:\"entity.manager\";s:12:\"cacheBackend\";s:12:\"cache.entity\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:19:\"editor_image_dialog\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:0;s:16:\"has_file_element\";b:1;s:7:\"storage\";a:1:{s:13:\"image_element\";a:4:{s:3:\"src\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1497902660),

('form_state','form-9xg8hgXFal9rJ5cXFLJqKgKj42eBa7QC_3Bj_HhnqDE','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"09d511c6-2622-4997-b678-90c8ff763aed\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"core.entity_view_display.comment.default_reviews.default\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:8:\"fivestar\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:6:{s:14:\"field_category\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:12:\"field_rating\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:40:\"modules/fivestar/widgets/basic/basic.css\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"fivestar_stars\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:6:{s:6:\"weight\";s:2:\"14\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:6:{s:6:\"weight\";s:2:\"13\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:10:\"variations\";a:6:{s:4:\"type\";s:28:\"entity_reference_entity_view\";s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:4:\"link\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:4:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";s:10:\"variations\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503325135),

('form_state','form-A2DngDQyJ3ULKIap6pquG2gmahE7svITzSKdbfg9T9M','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:7:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:2:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}s:10:\"variations\";a:1:{s:4:\"form\";a:1:{s:18:\"inline_entity_form\";a:1:{s:8:\"entities\";a:1:{i:0;a:1:{s:4:\"form\";a:1:{s:7:\"#fields\";a:14:{s:11:\"field_color\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_color\";i:7;s:6:\"widget\";}}s:17:\"field_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:17:\"field_description\";i:7;s:6:\"widget\";}}s:12:\"field_images\";a:2:{s:11:\"items_count\";i:4;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_images\";i:7;s:6:\"widget\";}}s:12:\"field_length\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_length\";i:7;s:6:\"widget\";}}s:15:\"field_old_price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_old_price\";i:7;s:6:\"widget\";}}s:28:\"field_right_side_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:28:\"field_right_side_description\";i:7;s:6:\"widget\";}}s:15:\"field_sale_text\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_sale_text\";i:7;s:6:\"widget\";}}s:23:\"field_short_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:23:\"field_short_description\";i:7;s:6:\"widget\";}}s:10:\"field_size\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:10:\"field_size\";i:7;s:6:\"widget\";}}s:11:\"field_waist\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_waist\";i:7;s:6:\"widget\";}}s:5:\"price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"price\";i:7;s:6:\"widget\";}}s:3:\"sku\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:3:\"sku\";i:7;s:6:\"widget\";}}s:6:\"status\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:6:\"status\";i:7;s:6:\"widget\";}}s:5:\"title\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"title\";i:7;s:6:\"widget\";}}}}}}}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:21:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}}}}s:21:\"entity_browser_widget\";a:1:{s:49:\"534712e5-05cc-42b8-a371-bb7af482f33f:field_images\";a:4:{i:0;s:2:\"62\";i:1;s:2:\"63\";i:2;s:2:\"64\";i:3;s:2:\"65\";}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503324209),

('form_state','form-aATv6vy-NVWooEPAhCx92K3xAKUfCPQlfJGVNpkT8kc','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053967\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:7:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:2:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}s:10:\"variations\";a:1:{s:4:\"form\";a:1:{s:18:\"inline_entity_form\";a:1:{s:8:\"entities\";a:1:{i:0;a:1:{s:4:\"form\";a:1:{s:7:\"#fields\";a:14:{s:11:\"field_color\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_color\";i:7;s:6:\"widget\";}}s:17:\"field_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:17:\"field_description\";i:7;s:6:\"widget\";}}s:12:\"field_images\";a:2:{s:11:\"items_count\";i:4;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_images\";i:7;s:6:\"widget\";}}s:12:\"field_length\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_length\";i:7;s:6:\"widget\";}}s:15:\"field_old_price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_old_price\";i:7;s:6:\"widget\";}}s:28:\"field_right_side_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:28:\"field_right_side_description\";i:7;s:6:\"widget\";}}s:15:\"field_sale_text\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_sale_text\";i:7;s:6:\"widget\";}}s:23:\"field_short_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:23:\"field_short_description\";i:7;s:6:\"widget\";}}s:10:\"field_size\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:10:\"field_size\";i:7;s:6:\"widget\";}}s:11:\"field_waist\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_waist\";i:7;s:6:\"widget\";}}s:5:\"price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"price\";i:7;s:6:\"widget\";}}s:3:\"sku\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:3:\"sku\";i:7;s:6:\"widget\";}}s:6:\"status\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:6:\"status\";i:7;s:6:\"widget\";}}s:5:\"title\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"title\";i:7;s:6:\"widget\";}}}}}}}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:19:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:43:\"Religion Jersey Polo Shirts - Medium, White\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:1001:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:43:\"Religion Jersey Polo Shirts - Medium, White\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:17:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:42:\"Religion Jersey Polo Shirts - Large, Green\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:42:\"Religion Jersey Polo Shirts - Large, Green\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";N;s:10:\"needs_save\";b:0;}}}}s:21:\"entity_browser_widget\";a:1:{s:49:\"534712e5-05cc-42b8-a371-bb7af482f33f:field_images\";a:4:{i:0;s:2:\"62\";i:1;s:2:\"63\";i:2;s:2:\"64\";i:3;s:2:\"65\";}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503323712),

('form_state','form-Apa8gElu7h7mtmYdf5eaFF0N56tFAsiyMX5Deaw3Qqo','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:1:{i:0;s:17:\"order_information\";}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\":7:{s:8:\"\0*\0panes\";a:7:{s:5:\"login\";O:59:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Login\":8:{s:11:\"\0*\0clientIp\";s:14:\"77.167.232.192\";s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";O:34:\"Drupal\\commerce_order\\Entity\\Order\":24:{s:9:\"\0*\0values\";a:22:{s:8:\"order_id\";a:1:{s:9:\"x-default\";s:1:\"8\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"default\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"5d222162-2be4-4264-bd11-ede83f7a55e3\";}s:12:\"order_number\";a:1:{s:9:\"x-default\";N;}s:8:\"store_id\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"0\";}}}s:4:\"mail\";a:1:{s:9:\"x-default\";a:0:{}}s:10:\"ip_address\";a:1:{s:9:\"x-default\";s:14:\"77.167.232.192\";}s:15:\"billing_profile\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:9:\"target_id\";N;s:18:\"target_revision_id\";N;}}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"94.750000\";s:13:\"currency_code\";s:3:\"USD\";}}s:5:\"state\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"draft\";}}}s:4:\"data\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1505330083\";}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1505330097\";}}}s:6:\"placed\";a:1:{s:9:\"x-default\";N;}s:9:\"completed\";a:1:{s:9:\"x-default\";N;}s:4:\"cart\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:13:\"checkout_flow\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:13:\"checkout_step\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:17:\"order_information\";}}}s:15:\"payment_gateway\";a:1:{s:9:\"x-default\";a:0:{}}s:14:\"payment_method\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"order_items\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"21\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"default\";s:2:\"id\";s:1:\"8\";s:4:\"uuid\";s:36:\"5d222162-2be4-4264-bd11-ede83f7a55e3\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:14:\"commerce_order\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"\0*\0pluginId\";s:5:\"login\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:5:\"login\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Login or continue as guest\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:108;s:12:\"default_step\";s:5:\"login\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:59:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Login\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:4:{s:21:\"credentialsCheckFlood\";s:32:\"commerce.credentials_check_flood\";s:11:\"currentUser\";s:12:\"current_user\";s:8:\"userAuth\";s:9:\"user.auth\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:19:\"contact_information\";O:72:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\ContactInformation\":6:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:19:\"contact_information\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:19:\"contact_information\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Contact information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:134;s:12:\"default_step\";s:17:\"order_information\";s:15:\"wrapper_element\";s:8:\"fieldset\";s:5:\"class\";s:72:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\ContactInformation\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:14:\"\0*\0_serviceIds\";a:2:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:6:\"review\";O:60:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Review\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:6:\"review\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:6:\"review\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:156;s:12:\"default_step\";s:6:\"review\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:60:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Review\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:18:\"completion_message\";O:71:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\CompletionMessage\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:18:\"completion_message\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:18:\"completion_message\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Completion message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:177;s:12:\"default_step\";s:8:\"complete\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:71:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\CompletionMessage\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:13:\"order_summary\";O:66:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\OrderSummary\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:13:\"order_summary\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:13:\"order_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Order summary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:198;s:12:\"default_step\";s:8:\"_sidebar\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:66:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\OrderSummary\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:19:\"payment_information\";O:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\":6:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:19:\"payment_information\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:19:\"payment_information\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Payment information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:220;s:12:\"default_step\";s:17:\"order_information\";s:15:\"wrapper_element\";s:8:\"fieldset\";s:5:\"class\";s:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\";s:8:\"provider\";s:16:\"commerce_payment\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:10;}s:14:\"\0*\0_serviceIds\";a:2:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:15:\"payment_process\";O:67:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentProcess\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:15:\"payment_process\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:15:\"payment_process\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment process\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:241;s:12:\"default_step\";s:7:\"payment\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:67:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentProcess\";s:8:\"provider\";s:16:\"commerce_payment\";}s:16:\"\0*\0configuration\";a:3:{s:7:\"capture\";b:1;s:4:\"step\";s:7:\"payment\";s:6:\"weight\";i:10;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}}s:15:\"\0*\0visibleSteps\";a:5:{s:5:\"login\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"previous_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Go back\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:0;}s:17:\"order_information\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:1;s:14:\"previous_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Go back\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"review\";a:4:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"next_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Continue to review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"previous_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Go back\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:1;}s:7:\"payment\";a:4:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"next_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Pay and complete purchase\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:0;s:6:\"hidden\";b:1;}s:8:\"complete\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"next_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Pay and complete purchase\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:0;}}s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:17:\"multistep_default\";s:19:\"\0*\0pluginDefinition\";a:4:{s:2:\"id\";s:17:\"multistep_default\";s:5:\"label\";s:19:\"Multistep - Default\";s:5:\"class\";s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:25:\"display_checkout_progress\";b:1;s:5:\"panes\";a:6:{s:5:\"login\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:19:\"contact_information\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:19:\"billing_information\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:2;}s:6:\"review\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:18:\"completion_message\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:13:\"order_summary\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}}}s:14:\"\0*\0_serviceIds\";a:4:{s:11:\"paneManager\";s:37:\"plugin.manager.commerce_checkout_pane\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:15:\"eventDispatcher\";s:16:\"event_dispatcher\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:12:\"base_form_id\";s:22:\"commerce_checkout_flow\";s:7:\"form_id\";s:40:\"commerce_checkout_flow_multistep_default\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:1:{s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:19:\"payment_information\";a:1:{s:19:\"billing_information\";a:1:{s:7:\"#fields\";a:1:{s:7:\"address\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:4:{i:0;s:19:\"payment_information\";i:1;s:19:\"billing_information\";i:2;s:7:\"address\";i:3;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1505351710),

('form_state','form-avu70oK7twg5sBfEib360skXFN6NJTcNHbT_arrY6k8','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"6c46b8e2-122f-477b-995e-d5b009abb69c\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503408038;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503408038;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503429686),

('form_state','form-B9ST9BLjT4b1OJTBFJgrYkNcqRqSwvdQ29nETMz3zUQ','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:1:{i:0;s:17:\"order_information\";}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\":7:{s:8:\"\0*\0panes\";a:7:{s:5:\"login\";O:59:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Login\":8:{s:11:\"\0*\0clientIp\";s:9:\"127.0.0.1\";s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";O:34:\"Drupal\\commerce_order\\Entity\\Order\":24:{s:9:\"\0*\0values\";a:22:{s:8:\"order_id\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"default\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"9416e06c-6dad-438a-a7da-1c159236a657\";}s:12:\"order_number\";a:1:{s:9:\"x-default\";N;}s:8:\"store_id\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:4:\"mail\";a:1:{s:9:\"x-default\";s:21:\"4elove4ekfs@gmail.com\";}s:10:\"ip_address\";a:1:{s:9:\"x-default\";s:9:\"127.0.0.1\";}s:15:\"billing_profile\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:9:\"target_id\";N;s:18:\"target_revision_id\";N;}}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:10:\"120.740000\";s:13:\"currency_code\";s:3:\"USD\";}}s:5:\"state\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"draft\";}}}s:4:\"data\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503408306\";}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503489982\";}}}s:6:\"placed\";a:1:{s:9:\"x-default\";N;}s:9:\"completed\";a:1:{s:9:\"x-default\";N;}s:4:\"cart\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:13:\"checkout_flow\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:13:\"checkout_step\";a:1:{s:9:\"x-default\";a:0:{}}s:15:\"payment_gateway\";a:1:{s:9:\"x-default\";a:0:{}}s:14:\"payment_method\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"order_items\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"3\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"default\";s:2:\"id\";s:1:\"1\";s:4:\"uuid\";s:36:\"9416e06c-6dad-438a-a7da-1c159236a657\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:14:\"commerce_order\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"\0*\0pluginId\";s:5:\"login\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:5:\"login\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Login or continue as guest\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:108;s:12:\"default_step\";s:5:\"login\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:59:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Login\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:4:{s:21:\"credentialsCheckFlood\";s:32:\"commerce.credentials_check_flood\";s:11:\"currentUser\";s:12:\"current_user\";s:8:\"userAuth\";s:9:\"user.auth\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:19:\"contact_information\";O:72:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\ContactInformation\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:19:\"contact_information\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:19:\"contact_information\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Contact information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:134;s:12:\"default_step\";s:17:\"order_information\";s:15:\"wrapper_element\";s:8:\"fieldset\";s:5:\"class\";s:72:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\ContactInformation\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:6:\"review\";O:60:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Review\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:6:\"review\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:6:\"review\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:156;s:12:\"default_step\";s:6:\"review\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:60:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Review\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:18:\"completion_message\";O:71:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\CompletionMessage\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:18:\"completion_message\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:18:\"completion_message\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Completion message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:177;s:12:\"default_step\";s:8:\"complete\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:71:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\CompletionMessage\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:13:\"order_summary\";O:66:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\OrderSummary\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:13:\"order_summary\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:13:\"order_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Order summary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:198;s:12:\"default_step\";s:8:\"_sidebar\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:66:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\OrderSummary\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:15:\"payment_process\";O:67:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentProcess\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:15:\"payment_process\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:15:\"payment_process\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment process\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:220;s:12:\"default_step\";s:7:\"payment\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:67:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentProcess\";s:8:\"provider\";s:16:\"commerce_payment\";}s:16:\"\0*\0configuration\";a:3:{s:7:\"capture\";b:1;s:4:\"step\";s:7:\"payment\";s:6:\"weight\";i:10;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:19:\"payment_information\";O:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\":6:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:19:\"payment_information\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:19:\"payment_information\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Payment information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:242;s:12:\"default_step\";s:17:\"order_information\";s:15:\"wrapper_element\";s:8:\"fieldset\";s:5:\"class\";s:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\";s:8:\"provider\";s:16:\"commerce_payment\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:10;}s:14:\"\0*\0_serviceIds\";a:2:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}}s:15:\"\0*\0visibleSteps\";a:4:{s:17:\"order_information\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:1;s:14:\"previous_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Go back\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"review\";a:4:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"next_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Continue to review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"previous_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Go back\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:1;}s:7:\"payment\";a:4:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"next_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Pay and complete purchase\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:0;s:6:\"hidden\";b:1;}s:8:\"complete\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"next_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Pay and complete purchase\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:0;}}s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:17:\"multistep_default\";s:19:\"\0*\0pluginDefinition\";a:4:{s:2:\"id\";s:17:\"multistep_default\";s:5:\"label\";s:19:\"Multistep - Default\";s:5:\"class\";s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:25:\"display_checkout_progress\";b:1;s:5:\"panes\";a:6:{s:5:\"login\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:19:\"contact_information\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:19:\"billing_information\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:2;}s:6:\"review\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:18:\"completion_message\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:13:\"order_summary\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}}}s:14:\"\0*\0_serviceIds\";a:4:{s:11:\"paneManager\";s:37:\"plugin.manager.commerce_checkout_pane\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:15:\"eventDispatcher\";s:16:\"event_dispatcher\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:12:\"base_form_id\";s:22:\"commerce_checkout_flow\";s:7:\"form_id\";s:40:\"commerce_checkout_flow_multistep_default\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:1:{s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:19:\"payment_information\";a:1:{s:19:\"billing_information\";a:1:{s:7:\"#fields\";a:1:{s:7:\"address\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:4:{i:0;s:19:\"payment_information\";i:1;s:19:\"billing_information\";i:2;s:7:\"address\";i:3;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503511653),

('form_state','form-BE1FlxFX_7fUjGlRqNagkLWwT3S2OA7GuKo4124Qk8I','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":13:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:41:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:39:\"commerce_plugin_item:commerce_condition\";a:15:{s:11:\"plugin_type\";s:18:\"commerce_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:28:\"commerce_plugin_item_default\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:120;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:28:\"commerce_plugin_item_default\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"file_uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"file_uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"File URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"An entity field containing a file URI, and a computed root-relative file URL.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"file_uri\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:46:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileUriItem\";s:8:\"provider\";s:4:\"file\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:37:\"Drupal\\pathauto\\PathautoFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:28:\"Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"ef55e6d3-d8b2-467a-bf69-a02b0aed8740\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:46:\"commerce_product.commerce_product_type.default\";i:1;s:41:\"field.field.commerce_product.default.body\";i:2;s:43:\"field.field.commerce_product.default.stores\";i:3;s:47:\"field.field.commerce_product.default.variations\";}s:6:\"module\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:4:\"text\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"gT03TFcuSod4d9uPQNs_gqK1F1QZ0Ray5CBYW0BNLnk\";}s:5:\"\0*\0id\";s:32:\"commerce_product.default.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:3:{s:4:\"body\";a:6:{s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";s:1:\"1\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:2:\"-5\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:4:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:18:\"\0*\0_entityStorages\";a:0:{}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:12:\"\0*\0messenger\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:7:\"default\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";s:10:\"variations\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1558276574),

('form_state','form-BkJGTcS_8m9o51AXd6stRm0FaqNldubN1is4u3fH-Go','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"4a329cca-7286-43a8-9008-643f962e57eb\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407083;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407083;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503428683),

('form_state','form-bpNd71gweH42D3XoY7NhMfthhe1D2-U00vJEC_QYV3I','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityFormDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"form\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:115;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:115;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:115;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"list_integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"list_string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:43:\"Drupal\\path\\Plugin\\Field\\FieldType\\PathItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"text_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:17:\"text_with_summary\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"7ead05bb-48d9-4c0d-8503-3978179228c2\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:10:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:35:\"entity_browser.browser.browse_files\";i:2;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:3;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:7;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:8;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:9;s:70:\"field.field.commerce_product_variation.product.field_short_description\";}s:6:\"module\";a:3:{i:0;s:14:\"commerce_price\";i:1;s:14:\"entity_browser\";i:2;s:4:\"text\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:12:{s:15:\"attribute_color\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";s:1:\"7\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"attribute_size\";a:5:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";s:1:\"6\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:5:{s:6:\"weight\";s:1:\"9\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:5:{s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:17:\"field_widget_edit\";b:1;s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:5:{s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:5:{s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:5:{s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:5:{s:6:\"weight\";s:1:\"8\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"string_textarea\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:5:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:3:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:27:\"plugin.manager.field.widget\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_form_display_form\";s:7:\"form_id\";s:29:\"entity_form_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:2:{s:23:\"entity_form_initialized\";b:1;s:20:\"plugin_settings_edit\";s:12:\"field_images\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503028150),

('form_state','form-bSdeDI92HOBmYyUAOnLcbb5momGBm2umaXFcI14Edwg','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"a174c2cb-3558-4a86-a556-e829eeb38c42\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503429182;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503429182;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:7:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503450845),

('form_state','form-btuy-Za5Q436jQg1iQd4lrIrTYPczb-i9azZnRSyE6w','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:1:{i:0;O:27:\"Drupal\\editor\\Entity\\Editor\":20:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:9:\"\0*\0editor\";s:8:\"ckeditor\";s:11:\"\0*\0settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:5:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:2:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";}}i:1;a:2:{s:4:\"name\";s:5:\"Links\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:2:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";}}i:4;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:1:{i:0;s:6:\"Source\";}}}}}s:7:\"plugins\";a:2:{s:8:\"language\";a:1:{s:13:\"language_list\";s:2:\"un\";}s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:15:\"\0*\0image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";N;s:6:\"height\";N;}}s:15:\"\0*\0filterFormat\";O:33:\"Drupal\\filter\\Entity\\FilterFormat\":21:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:7:\"\0*\0name\";s:8:\"CKeditor\";s:9:\"\0*\0weight\";i:-9;s:8:\"\0*\0roles\";N;s:10:\"\0*\0filters\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:19:\"\0*\0filterCollection\";O:36:\"Drupal\\filter\\FilterPluginCollection\":7:{s:14:\"\0*\0definitions\";a:13:{s:21:\"editor_file_reference\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:84:\"Ensures that the latest versions of images uploaded via a Text Editor are displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Track images uploaded via a Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:12:\"entity_embed\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Embeds entities using data attributes: data-entity-type, data-entity-uuid, and data-view-mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Display embedded entities\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:12:\"filter_align\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:90:\"Uses a <code>data-align</code> attribute on <code>&lt;img&gt;</code> tags to align images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_align\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Align images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAlign\";s:8:\"provider\";s:6:\"filter\";}s:12:\"filter_autop\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_autop\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:87:\"Convert line breaks into HTML (i.e. <code>&lt;br&gt;</code> and <code>&lt;p&gt;</code>)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAutoP\";s:8:\"provider\";s:6:\"filter\";}s:14:\"filter_caption\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Uses a <code>data-caption</code> attribute on <code>&lt;img&gt;</code> tags to caption images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:14:\"filter_caption\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Caption images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:41:\"Drupal\\filter\\Plugin\\Filter\\FilterCaption\";s:8:\"provider\";s:6:\"filter\";}s:11:\"filter_html\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Limit allowed HTML tags and correct faulty HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"filter_htmlcorrector\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:20:\"filter_htmlcorrector\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Correct faulty and chopped off HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:47:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlCorrector\";s:8:\"provider\";s:6:\"filter\";}s:18:\"filter_html_escape\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:18:\"filter_html_escape\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Display any HTML as plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:44:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlEscape\";s:8:\"provider\";s:6:\"filter\";}s:24:\"filter_html_image_secure\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:119:\"Disallows usage of &lt;img&gt; tag sources that are not hosted on this site by replacing them with a placeholder image.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Restrict images to this site\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:10:\"filter_url\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}s:2:\"id\";s:10:\"filter_url\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Convert URLs into links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:37:\"Drupal\\filter\\Plugin\\Filter\\FilterUrl\";s:8:\"provider\";s:6:\"filter\";}s:17:\"dynamicshortcodes\";a:11:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Shortcodes which shouldn\'t be cached.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:17:\"dynamicshortcodes\";s:6:\"module\";s:19:\"nd_visualshortcodes\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Dynamic Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"cache\";b:0;s:5:\"class\";s:58:\"Drupal\\nd_visualshortcodes\\Plugin\\Filter\\Dynamicshortcodes\";s:8:\"provider\";s:19:\"nd_visualshortcodes\";}s:9:\"shortcode\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides WP like shortcodes to text formats.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:19:\"shortcode_corrector\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"Trying to correct the html around shortcodes. Enable only if you using wysiwyg editor.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:19:\"shortcode_corrector\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Shortcodes - html corrector\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:49:\"Drupal\\shortcode\\Plugin\\Filter\\ShortcodeCorrector\";s:8:\"provider\";s:9:\"shortcode\";}}s:17:\"\0*\0configurations\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:12:\"\0*\0pluginKey\";s:2:\"id\";s:16:\"\0*\0originalOrder\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";}s:18:\"\0*\0pluginInstances\";a:5:{s:21:\"editor_file_reference\";O:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\":9:{s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:21:\"editor_file_reference\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:13:\"entityManager\";s:14:\"entity.manager\";}}s:12:\"entity_embed\";O:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\":9:{s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:12:\"entity_embed\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:3:{s:8:\"renderer\";s:8:\"renderer\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:7:\"builder\";s:20:\"entity_embed.builder\";}}s:11:\"filter_html\";O:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\":10:{s:15:\"\0*\0restrictions\";N;s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:11:\"\0*\0pluginId\";s:11:\"filter_html\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:24:\"filter_html_image_secure\";O:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\":9:{s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:24:\"filter_html_image_secure\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"shortcode\";O:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\":9:{s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:11:\"\0*\0pluginId\";s:9:\"shortcode\";s:19:\"\0*\0pluginDefinition\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:16:\"\0*\0configuration\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:14:\"\0*\0instanceIDs\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";}s:14:\"\0*\0_serviceIds\";a:1:{s:7:\"manager\";s:21:\"plugin.manager.filter\";}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"24aa033e-b666-403d-bb7c-d4bb14e01318\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:13:\"filter_format\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:6:\"editor\";i:1;s:12:\"entity_embed\";i:2;s:9:\"shortcode\";}}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"af9b5cee-8d4c-4a99-bb39-42fe2ce351d5\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:6:\"editor\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:1:{s:19:\"editorPluginManager\";s:21:\"plugin.manager.editor\";}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:22:\"filter.format.ckeditor\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}}}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:36:\"Drupal\\editor\\Form\\EditorImageDialog\":9:{s:14:\"\0*\0fileStorage\";O:23:\"Drupal\\file\\FileStorage\":18:{s:15:\"\0*\0tableMapping\";N;s:14:\"\0*\0revisionKey\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";b:0;s:12:\"\0*\0baseTable\";s:12:\"file_managed\";s:16:\"\0*\0revisionTable\";N;s:12:\"\0*\0dataTable\";N;s:20:\"\0*\0revisionDataTable\";N;s:16:\"\0*\0storageSchema\";N;s:12:\"\0*\0bundleKey\";s:0:\"\";s:11:\"\0*\0entities\";a:0:{}s:15:\"\0*\0entityTypeId\";s:4:\"file\";s:13:\"\0*\0entityType\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:4:\"file\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:23:\"Drupal\\file\\FileStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\file\\FileStorageSchema\";s:6:\"access\";s:36:\"Drupal\\file\\FileAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\file\\FileViewsData\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"file_managed\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"file_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0provider\";s:4:\"file\";s:20:\"\0*\0stringTranslation\";N;}s:8:\"\0*\0idKey\";s:3:\"fid\";s:10:\"\0*\0uuidKey\";s:4:\"uuid\";s:14:\"\0*\0uuidService\";N;s:14:\"\0*\0entityClass\";s:23:\"Drupal\\file\\Entity\\File\";s:14:\"\0*\0_serviceIds\";a:6:{s:8:\"database\";s:8:\"database\";s:15:\"languageManager\";s:16:\"language_manager\";s:13:\"entityManager\";s:14:\"entity.manager\";s:12:\"cacheBackend\";s:12:\"cache.entity\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:19:\"editor_image_dialog\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:0;s:16:\"has_file_element\";b:1;s:7:\"storage\";a:1:{s:13:\"image_element\";a:4:{s:3:\"src\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1497902640),

('form_state','form-BWJKRVAHDRWhBFLpy9MYBf9fTjBIS5bhyab0N-C2xH4','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:1:{i:0;O:27:\"Drupal\\editor\\Entity\\Editor\":20:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:9:\"\0*\0editor\";s:8:\"ckeditor\";s:11:\"\0*\0settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:5:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:2:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";}}i:1;a:2:{s:4:\"name\";s:5:\"Links\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:2:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";}}i:4;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:1:{i:0;s:6:\"Source\";}}}}}s:7:\"plugins\";a:2:{s:8:\"language\";a:1:{s:13:\"language_list\";s:2:\"un\";}s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:15:\"\0*\0image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";N;s:6:\"height\";N;}}s:15:\"\0*\0filterFormat\";O:33:\"Drupal\\filter\\Entity\\FilterFormat\":21:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:7:\"\0*\0name\";s:8:\"CKeditor\";s:9:\"\0*\0weight\";i:-9;s:8:\"\0*\0roles\";N;s:10:\"\0*\0filters\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:19:\"\0*\0filterCollection\";O:36:\"Drupal\\filter\\FilterPluginCollection\":7:{s:14:\"\0*\0definitions\";a:13:{s:21:\"editor_file_reference\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:84:\"Ensures that the latest versions of images uploaded via a Text Editor are displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Track images uploaded via a Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:12:\"entity_embed\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Embeds entities using data attributes: data-entity-type, data-entity-uuid, and data-view-mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Display embedded entities\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:12:\"filter_align\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:90:\"Uses a <code>data-align</code> attribute on <code>&lt;img&gt;</code> tags to align images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_align\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Align images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAlign\";s:8:\"provider\";s:6:\"filter\";}s:12:\"filter_autop\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_autop\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:87:\"Convert line breaks into HTML (i.e. <code>&lt;br&gt;</code> and <code>&lt;p&gt;</code>)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAutoP\";s:8:\"provider\";s:6:\"filter\";}s:14:\"filter_caption\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Uses a <code>data-caption</code> attribute on <code>&lt;img&gt;</code> tags to caption images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:14:\"filter_caption\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Caption images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:41:\"Drupal\\filter\\Plugin\\Filter\\FilterCaption\";s:8:\"provider\";s:6:\"filter\";}s:11:\"filter_html\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Limit allowed HTML tags and correct faulty HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"filter_htmlcorrector\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:20:\"filter_htmlcorrector\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Correct faulty and chopped off HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:47:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlCorrector\";s:8:\"provider\";s:6:\"filter\";}s:18:\"filter_html_escape\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:18:\"filter_html_escape\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Display any HTML as plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:44:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlEscape\";s:8:\"provider\";s:6:\"filter\";}s:24:\"filter_html_image_secure\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:119:\"Disallows usage of &lt;img&gt; tag sources that are not hosted on this site by replacing them with a placeholder image.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Restrict images to this site\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:10:\"filter_url\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}s:2:\"id\";s:10:\"filter_url\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Convert URLs into links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:37:\"Drupal\\filter\\Plugin\\Filter\\FilterUrl\";s:8:\"provider\";s:6:\"filter\";}s:17:\"dynamicshortcodes\";a:11:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Shortcodes which shouldn\'t be cached.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:17:\"dynamicshortcodes\";s:6:\"module\";s:19:\"nd_visualshortcodes\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Dynamic Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"cache\";b:0;s:5:\"class\";s:58:\"Drupal\\nd_visualshortcodes\\Plugin\\Filter\\Dynamicshortcodes\";s:8:\"provider\";s:19:\"nd_visualshortcodes\";}s:9:\"shortcode\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides WP like shortcodes to text formats.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:19:\"shortcode_corrector\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"Trying to correct the html around shortcodes. Enable only if you using wysiwyg editor.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:19:\"shortcode_corrector\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Shortcodes - html corrector\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:49:\"Drupal\\shortcode\\Plugin\\Filter\\ShortcodeCorrector\";s:8:\"provider\";s:9:\"shortcode\";}}s:17:\"\0*\0configurations\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:12:\"\0*\0pluginKey\";s:2:\"id\";s:16:\"\0*\0originalOrder\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";}s:18:\"\0*\0pluginInstances\";a:5:{s:21:\"editor_file_reference\";O:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\":9:{s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:21:\"editor_file_reference\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:13:\"entityManager\";s:14:\"entity.manager\";}}s:12:\"entity_embed\";O:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\":9:{s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:12:\"entity_embed\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:3:{s:8:\"renderer\";s:8:\"renderer\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:7:\"builder\";s:20:\"entity_embed.builder\";}}s:11:\"filter_html\";O:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\":10:{s:15:\"\0*\0restrictions\";N;s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:11:\"\0*\0pluginId\";s:11:\"filter_html\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:24:\"filter_html_image_secure\";O:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\":9:{s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:24:\"filter_html_image_secure\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"shortcode\";O:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\":9:{s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:11:\"\0*\0pluginId\";s:9:\"shortcode\";s:19:\"\0*\0pluginDefinition\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:16:\"\0*\0configuration\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:14:\"\0*\0instanceIDs\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";}s:14:\"\0*\0_serviceIds\";a:1:{s:7:\"manager\";s:21:\"plugin.manager.filter\";}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"24aa033e-b666-403d-bb7c-d4bb14e01318\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:13:\"filter_format\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:6:\"editor\";i:1;s:12:\"entity_embed\";i:2;s:9:\"shortcode\";}}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"af9b5cee-8d4c-4a99-bb39-42fe2ce351d5\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:6:\"editor\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:1:{s:19:\"editorPluginManager\";s:21:\"plugin.manager.editor\";}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:22:\"filter.format.ckeditor\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}}}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:36:\"Drupal\\editor\\Form\\EditorImageDialog\":9:{s:14:\"\0*\0fileStorage\";O:23:\"Drupal\\file\\FileStorage\":18:{s:15:\"\0*\0tableMapping\";N;s:14:\"\0*\0revisionKey\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";b:0;s:12:\"\0*\0baseTable\";s:12:\"file_managed\";s:16:\"\0*\0revisionTable\";N;s:12:\"\0*\0dataTable\";N;s:20:\"\0*\0revisionDataTable\";N;s:16:\"\0*\0storageSchema\";N;s:12:\"\0*\0bundleKey\";s:0:\"\";s:11:\"\0*\0entities\";a:0:{}s:15:\"\0*\0entityTypeId\";s:4:\"file\";s:13:\"\0*\0entityType\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:4:\"file\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0handlers\";a:6:{s:7:\"storage\";s:23:\"Drupal\\file\\FileStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\file\\FileStorageSchema\";s:6:\"access\";s:36:\"Drupal\\file\\FileAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\file\\FileViewsData\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"file_managed\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"file_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:4:\"file\";}s:8:\"\0*\0class\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0provider\";s:4:\"file\";s:20:\"\0*\0stringTranslation\";N;}s:8:\"\0*\0idKey\";s:3:\"fid\";s:10:\"\0*\0uuidKey\";s:4:\"uuid\";s:14:\"\0*\0uuidService\";N;s:14:\"\0*\0entityClass\";s:23:\"Drupal\\file\\Entity\\File\";s:14:\"\0*\0_serviceIds\";a:6:{s:8:\"database\";s:8:\"database\";s:15:\"languageManager\";s:16:\"language_manager\";s:13:\"entityManager\";s:14:\"entity.manager\";s:12:\"cacheBackend\";s:12:\"cache.entity\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:19:\"editor_image_dialog\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:0;s:16:\"has_file_element\";b:1;s:7:\"storage\";a:1:{s:13:\"image_element\";a:4:{s:3:\"src\";s:80:\"http://local.rhythm.nikadevs.com/sites/rhythm.nikadevs.com/files/user-avatar.png\";s:3:\"alt\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503590935),

('form_state','form-dPdWs1unF1y_VjBy2601jUcz19CSso1bOjhJbyBsxPU','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":13:{s:9:\"\0*\0formId\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":27:{s:9:\"\0*\0values\";a:15:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"77579cad-af21-43c3-9a8e-5131089d3d74\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:21:\"overridden_unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:23:\"uses_legacy_adjustments\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1558254752;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1558254752;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:33:\"\0*\0revisionTranslationAffectedKey\";s:29:\"revision_translation_affected\";s:37:\"\0*\0enforceRevisionTranslationAffected\";a:0:{}s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:13:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"currentStore\";s:28:\"commerce_store.current_store\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:16:\"entityRepository\";s:17:\"entity.repository\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:18:\"\0*\0_entityStorages\";a:0:{}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:12:\"\0*\0messenger\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":27:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503564727\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"28\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:1:{i:0;s:16:\"taxonomy_term:28\";}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"31\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:1:{i:0;s:16:\"taxonomy_term:31\";}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:7:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:1:{i:0;s:16:\"taxonomy_term:37\";}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:1:{i:0;s:16:\"taxonomy_term:38\";}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:4:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";s:8:\"revision\";N;}s:25:\"\0*\0translatableEntityKeys\";a:6:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:9:\"published\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"owner\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:33:\"\0*\0revisionTranslationAffectedKey\";s:29:\"revision_translation_affected\";s:37:\"\0*\0enforceRevisionTranslationAffected\";a:0:{}s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"total_price\";b:1;s:11:\"adjustments\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1558276360),

('form_state','form-e2GY-ffS8gDtYs4VyOrru1X_X46g8RYbKrYnUxyL0Lg','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:44:\"Drupal\\entity_browser\\Form\\EntityBrowserForm\":9:{s:16:\"\0*\0entityBrowser\";O:42:\"Drupal\\entity_browser\\Entity\\EntityBrowser\":26:{s:4:\"name\";s:12:\"browse_files\";s:5:\"label\";s:17:\"Browser for files\";s:7:\"display\";s:6:\"iframe\";s:21:\"display_configuration\";a:4:{s:5:\"width\";s:4:\"100%\";s:6:\"height\";s:3:\"768\";s:9:\"link_text\";s:12:\"Select files\";s:9:\"auto_open\";b:1;}s:10:\"\0*\0widgets\";a:2:{s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";a:5:{s:8:\"settings\";a:4:{s:4:\"view\";s:19:\"file_entity_browser\";s:12:\"view_display\";s:16:\"entity_browser_1\";s:11:\"submit_text\";s:15:\"Select entities\";s:11:\"auto_select\";b:1;}s:4:\"uuid\";s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";s:6:\"weight\";i:1;s:5:\"label\";s:13:\"Files listing\";s:2:\"id\";s:4:\"view\";}s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";a:5:{s:8:\"settings\";a:6:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:20:\"dropzone_description\";s:39:\"Click or drop files here to upload them\";s:12:\"max_filesize\";s:4:\"100M\";s:10:\"extensions\";s:52:\"jpg jpeg gif png txt doc xls pdf ppt pps odt ods odp\";s:11:\"submit_text\";s:15:\"Select entities\";s:11:\"auto_select\";b:0;}s:4:\"uuid\";s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";s:6:\"weight\";i:0;s:5:\"label\";s:12:\"Upload files\";s:2:\"id\";s:10:\"dropzonejs\";}}s:17:\"selection_display\";s:18:\"multi_step_display\";s:31:\"selection_display_configuration\";a:5:{s:11:\"entity_type\";s:4:\"file\";s:7:\"display\";s:9:\"thumbnail\";s:16:\"display_settings\";a:1:{s:11:\"image_style\";s:25:\"file_entity_browser_small\";}s:11:\"select_text\";s:12:\"Use selected\";s:16:\"selection_hidden\";b:0;}s:15:\"widget_selector\";s:4:\"tabs\";s:29:\"widget_selector_configuration\";a:0:{}s:31:\"\0*\0additional_widget_parameters\";a:1:{s:10:\"path_parts\";a:4:{i:0;s:0:\"\";i:1;s:7:\"product\";i:2;s:1:\"3\";i:3;s:4:\"edit\";}}s:13:\"\0*\0form_class\";s:45:\"\\Drupal\\entity_browser\\Form\\EntityBrowserForm\";s:13:\"\0*\0originalId\";s:12:\"browse_files\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"5352b42f-b8a4-478b-91bc-c875de12c35d\";s:11:\"\0*\0langcode\";s:3:\"und\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1Y-fC4LxFu8Rg3SCSaYMZMXRAvMtueQ3JQIiKuna8hM\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:14:\"entity_browser\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:12:\"file_browser\";}}s:6:\"module\";a:2:{i:0;s:20:\"dropzonejs_eb_widget\";i:1;s:5:\"views\";}}}s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:3:{s:13:\"uuidGenerator\";s:4:\"uuid\";s:16:\"selectionStorage\";s:32:\"entity_browser.selection_storage\";s:12:\"requestStack\";s:13:\"request_stack\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:20:\"\0*\0stringTranslation\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:32:\"entity_browser_browse_files_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:4:{s:23:\"entity_form_initialized\";b:1;s:14:\"entity_browser\";a:5:{s:13:\"instance_uuid\";s:40:\"a7a0a9551149bb9bf37b838e044921db392dc4a2\";s:17:\"selected_entities\";a:1:{i:0;O:23:\"Drupal\\file\\Entity\\File\":24:{s:9:\"\0*\0values\";a:11:{s:3:\"fid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"67\";}}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"d5668069-cbae-4715-8c5b-5026b78d6850\";}}}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:8:\"filename\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"dance_now.jpg\";}}}s:3:\"uri\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:30:\"public://2017-08/dance_now.jpg\";}}}s:8:\"filemime\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"image/jpeg\";}}}s:8:\"filesize\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:18542;}}}s:6:\"status\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503310562;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503310562;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:4:{s:6:\"bundle\";s:4:\"file\";s:2:\"id\";s:2:\"67\";s:8:\"revision\";N;s:5:\"label\";s:13:\"dance_now.jpg\";}s:25:\"\0*\0translatableEntityKeys\";a:1:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:4:\"file\";s:15:\"\0*\0enforceIsNew\";b:0;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:-1;}}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:19:\"selection_completed\";b:0;}s:29:\"entity_browser_current_widget\";s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";s:10:\"dropzonejs\";a:2:{s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";a:1:{s:5:\"files\";a:0:{}}s:14:\"added_entities\";a:1:{i:0;r:100;}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503332162),

('form_state','form-EpkW2ahlTnShMJzMfghuIyhM7xK5VOY3vhLwN3k4p6M','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"bc5d6188-cefe-4350-a39e-4005f7f36258\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:11:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:58:\"field.field.commerce_product_variation.product.field_color\";i:2;s:64:\"field.field.commerce_product_variation.product.field_description\";i:3;s:59:\"field.field.commerce_product_variation.product.field_images\";i:4;s:59:\"field.field.commerce_product_variation.product.field_length\";i:5;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:6;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:7;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:8;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:9;s:57:\"field.field.commerce_product_variation.product.field_size\";i:10;s:58:\"field.field.commerce_product_variation.product.field_waist\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:5:\"image\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:14:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:2:\"13\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:11:\"field_color\";a:6:{s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";s:1:\"2\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:4:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";s:17:\"image_style_small\";s:0:\"\";s:3:\"col\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";s:1:\"7\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";s:1:\"5\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";s:1:\"6\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";s:1:\"8\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:6:{s:6:\"weight\";s:1:\"9\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:2:{s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";s:12:\"field_images\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503327846),

('form_state','form-eske2IICmrHl_8wXanE9JeiwBlroV1qgRDGGiFwHek4','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"8c5514c8-1094-475c-acad-36802c3d9c55\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414151;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414151;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503413385\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503435764),

('form_state','form-fCCC_P0aKC1g5q_lO2adxGu6n978KhRHDbEEQr9UnPU','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";N;s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503344797),

('form_state','form-fFKtcGOW4LQOyxuZK54ShiFUlTb5Jk22ZkBCBaCICxU','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"bc5d6188-cefe-4350-a39e-4005f7f36258\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:12:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:62:\"field.field.commerce_product_variation.product.attribute_color\";i:2;s:61:\"field.field.commerce_product_variation.product.attribute_size\";i:3;s:64:\"field.field.commerce_product_variation.product.field_description\";i:4;s:59:\"field.field.commerce_product_variation.product.field_images\";i:5;s:59:\"field.field.commerce_product_variation.product.field_length\";i:6;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:7;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:8;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:9;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:10;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:11;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:10:\"rhythm_cms\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:15:{s:15:\"attribute_color\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";s:1:\"2\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:14:\"attribute_size\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:2:\"13\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:17:\"field_description\";a:6:{s:6:\"weight\";s:1:\"6\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:5:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:17:\"image_style_small\";s:19:\"product_small_68x86\";s:3:\"col\";s:1:\"3\";s:4:\"zoom\";s:1:\"1\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";s:1:\"9\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";s:1:\"7\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";s:1:\"8\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"5\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:10:\"product_id\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";s:2:\"14\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:2:{s:8:\"langcode\";b:1;s:14:\"qty_increments\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:2:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503431006),

('form_state','form-fGvrCSOQ5VdI1jetEinXKtWAacO7NCoxBItNv34xsjg','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"d5d10cb4-3ad5-4efa-a712-73b3575924e9\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414596;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414596;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503436196),

('form_state','form-GebYDNe78c6Wh6VqZt4sDXnLEbrsZQAxmjAseUbFg9E','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"ddf0f222-a332-4e0a-92d9-14d2b2f7f3ca\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503416524;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503416524;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503438124),

('form_state','form-glV3Y6G1gtVzNkPgTQJNllYPujZXqGie-gVpXCVkDmo','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:2:{i:0;N;i:1;N;}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:41:\"Drupal\\config\\Form\\ConfigSingleExportForm\":9:{s:14:\"\0*\0definitions\";a:45:{s:5:\"block\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:2:{i:0;s:5:\"theme\";i:1;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:8:{i:0;s:2:\"id\";i:1;s:5:\"theme\";i:2;s:6:\"region\";i:3;s:6:\"weight\";i:4;s:8:\"provider\";i:5;s:6:\"plugin\";i:6;s:8:\"settings\";i:7;s:10:\"visibility\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:5:\"block\";s:16:\"\0*\0originalClass\";s:25:\"Drupal\\block\\Entity\\Block\";s:11:\"\0*\0handlers\";a:6:{s:6:\"access\";s:38:\"Drupal\\block\\BlockAccessControlHandler\";s:12:\"view_builder\";s:29:\"Drupal\\block\\BlockViewBuilder\";s:12:\"list_builder\";s:29:\"Drupal\\block\\BlockListBuilder\";s:4:\"form\";a:2:{s:7:\"default\";s:22:\"Drupal\\block\\BlockForm\";s:6:\"delete\";s:33:\"Drupal\\block\\Form\\BlockDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:44:\"/admin/structure/block/manage/{block}/delete\";s:9:\"edit-form\";s:37:\"/admin/structure/block/manage/{block}\";s:6:\"enable\";s:44:\"/admin/structure/block/manage/{block}/enable\";s:7:\"disable\";s:45:\"/admin/structure/block/manage/{block}/disable\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:17:\"config:block_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:5:\"block\";}s:8:\"\0*\0class\";s:25:\"Drupal\\block\\Entity\\Block\";s:11:\"\0*\0provider\";s:5:\"block\";s:20:\"\0*\0stringTranslation\";N;}s:18:\"block_content_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:8:\"revision\";i:3;s:11:\"description\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:18:\"block_content_type\";s:16:\"\0*\0originalClass\";s:44:\"Drupal\\block_content\\Entity\\BlockContentType\";s:11:\"\0*\0handlers\";a:5:{s:4:\"form\";a:4:{s:7:\"default\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:3:\"add\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:4:\"edit\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:6:\"delete\";s:52:\"Drupal\\block_content\\Form\\BlockContentTypeDeleteForm\";}s:12:\"list_builder\";s:48:\"Drupal\\block_content\\BlockContentTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:11:\"delete-form\";s:71:\"/admin/structure/block/block-content/manage/{block_content_type}/delete\";s:9:\"edit-form\";s:64:\"/admin/structure/block/block-content/manage/{block_content_type}\";s:10:\"collection\";s:42:\"/admin/structure/block/block-content/types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:13:\"block_content\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:30:\"config:block_content_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:18:\"block_content_type\";}s:8:\"\0*\0class\";s:44:\"Drupal\\block_content\\Entity\\BlockContentType\";s:11:\"\0*\0provider\";s:13:\"block_content\";s:20:\"\0*\0stringTranslation\";N;}s:12:\"comment_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:21:\"target_entity_type_id\";i:3;s:11:\"description\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"comment_type\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\comment\\Entity\\CommentType\";s:11:\"\0*\0handlers\";a:5:{s:4:\"form\";a:4:{s:7:\"default\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:3:\"add\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:4:\"edit\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:6:\"delete\";s:41:\"Drupal\\comment\\Form\\CommentTypeDeleteForm\";}s:12:\"list_builder\";s:37:\"Drupal\\comment\\CommentTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:24:\"administer comment types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:53:\"/admin/structure/comment/manage/{comment_type}/delete\";s:9:\"edit-form\";s:46:\"/admin/structure/comment/manage/{comment_type}\";s:8:\"add-form\";s:34:\"/admin/structure/comment/types/add\";s:10:\"collection\";s:30:\"/admin/structure/comment/types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:7:\"comment\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"comment types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count comment type\";s:6:\"plural\";s:20:\"@count comment types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:comment_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:12:\"comment_type\";}s:8:\"\0*\0class\";s:33:\"Drupal\\comment\\Entity\\CommentType\";s:11:\"\0*\0provider\";s:7:\"comment\";s:20:\"\0*\0stringTranslation\";N;}s:22:\"commerce_checkout_flow\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:22:\"commerce_checkout_flow\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"plugin\";i:3;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:22:\"commerce_checkout_flow\";s:16:\"\0*\0originalClass\";s:44:\"Drupal\\commerce_checkout\\Entity\\CheckoutFlow\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:48:\"Drupal\\commerce_checkout\\CheckoutFlowListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:46:\"Drupal\\commerce_checkout\\Form\\CheckoutFlowForm\";s:4:\"edit\";s:46:\"Drupal\\commerce_checkout\\Form\\CheckoutFlowForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:33:\"administer commerce_checkout_flow\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:8:\"add-form\";s:41:\"/admin/commerce/config/checkout-flows/add\";s:9:\"edit-form\";s:69:\"/admin/commerce/config/checkout-flows/manage/{commerce_checkout_flow}\";s:11:\"delete-form\";s:76:\"/admin/commerce/config/checkout-flows/manage/{commerce_checkout_flow}/delete\";s:10:\"collection\";s:37:\"/admin/commerce/config/checkout-flows\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Checkout flow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Checkout flows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"checkout flow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"checkout flows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:20:\"@count checkout flow\";s:6:\"plural\";s:21:\"@count checkout flows\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:34:\"config:commerce_checkout_flow_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:22:\"commerce_checkout_flow\";}s:8:\"\0*\0class\";s:44:\"Drupal\\commerce_checkout\\Entity\\CheckoutFlow\";s:11:\"\0*\0provider\";s:17:\"commerce_checkout\";s:20:\"\0*\0stringTranslation\";N;}s:24:\"commerce_order_item_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:24:\"commerce_order_item_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:5:\"label\";i:1;s:2:\"id\";i:2;s:21:\"purchasableEntityType\";i:3;s:9:\"orderType\";i:4;s:6:\"traits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:24:\"commerce_order_item_type\";s:16:\"\0*\0originalClass\";s:42:\"Drupal\\commerce_order\\Entity\\OrderItemType\";s:11:\"\0*\0handlers\";a:6:{s:4:\"form\";a:3:{s:3:\"add\";s:44:\"Drupal\\commerce_order\\Form\\OrderItemTypeForm\";s:4:\"edit\";s:44:\"Drupal\\commerce_order\\Form\\OrderItemTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:12:\"list_builder\";s:46:\"Drupal\\commerce_order\\OrderItemTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:30:\"administer commerce_order_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:8:\"add-form\";s:43:\"/admin/commerce/config/order-item-types/add\";s:9:\"edit-form\";s:71:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit\";s:11:\"delete-form\";s:73:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/delete\";s:10:\"collection\";s:39:\"/admin/commerce/config/order-item-types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:19:\"commerce_order_item\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Order item type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Order item types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"order item type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"order item types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:22:\"@count order item type\";s:6:\"plural\";s:23:\"@count order item types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:36:\"config:commerce_order_item_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:24:\"commerce_order_item_type\";}s:8:\"\0*\0class\";s:42:\"Drupal\\commerce_order\\Entity\\OrderItemType\";s:11:\"\0*\0provider\";s:14:\"commerce_order\";s:20:\"\0*\0stringTranslation\";N;}s:19:\"commerce_order_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:19:\"commerce_order_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:8:{i:0;s:5:\"label\";i:1;s:2:\"id\";i:2;s:8:\"workflow\";i:3;s:6:\"traits\";i:4;s:12:\"refresh_mode\";i:5;s:17:\"refresh_frequency\";i:6;s:11:\"sendReceipt\";i:7;s:10:\"receiptBcc\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:19:\"commerce_order_type\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\commerce_order\\Entity\\OrderType\";s:11:\"\0*\0handlers\";a:6:{s:4:\"form\";a:3:{s:3:\"add\";s:40:\"Drupal\\commerce_order\\Form\\OrderTypeForm\";s:4:\"edit\";s:40:\"Drupal\\commerce_order\\Form\\OrderTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:12:\"list_builder\";s:42:\"Drupal\\commerce_order\\OrderTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:30:\"administer commerce_order_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:8:\"add-form\";s:38:\"/admin/commerce/config/order-types/add\";s:9:\"edit-form\";s:61:\"/admin/commerce/config/order-types/{commerce_order_type}/edit\";s:11:\"delete-form\";s:63:\"/admin/commerce/config/order-types/{commerce_order_type}/delete\";s:10:\"collection\";s:34:\"/admin/commerce/config/order-types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:14:\"commerce_order\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Order type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Order types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"order type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"order types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:17:\"@count order type\";s:6:\"plural\";s:18:\"@count order types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:commerce_order_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:19:\"commerce_order_type\";}s:8:\"\0*\0class\";s:38:\"Drupal\\commerce_order\\Entity\\OrderType\";s:11:\"\0*\0provider\";s:14:\"commerce_order\";s:20:\"\0*\0stringTranslation\";N;}s:24:\"commerce_payment_gateway\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:24:\"commerce_payment_gateway\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:8:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"weight\";i:3;s:6:\"status\";i:4;s:6:\"plugin\";i:5;s:13:\"configuration\";i:6;s:10:\"conditions\";i:7;s:17:\"conditionOperator\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:24:\"commerce_payment_gateway\";s:16:\"\0*\0originalClass\";s:45:\"Drupal\\commerce_payment\\Entity\\PaymentGateway\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:49:\"Drupal\\commerce_payment\\PaymentGatewayListBuilder\";s:7:\"storage\";s:45:\"Drupal\\commerce_payment\\PaymentGatewayStorage\";s:4:\"form\";a:3:{s:3:\"add\";s:47:\"Drupal\\commerce_payment\\Form\\PaymentGatewayForm\";s:4:\"edit\";s:47:\"Drupal\\commerce_payment\\Form\\PaymentGatewayForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:35:\"administer commerce_payment_gateway\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:8:\"add-form\";s:43:\"/admin/commerce/config/payment-gateways/add\";s:9:\"edit-form\";s:73:\"/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}\";s:11:\"delete-form\";s:80:\"/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}/delete\";s:10:\"collection\";s:39:\"/admin/commerce/config/payment-gateways\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment gateway\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Payment gateways\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"payment gateway\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"payment gateways\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:22:\"@count payment gateway\";s:6:\"plural\";s:23:\"@count payment gateways\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:36:\"config:commerce_payment_gateway_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:24:\"commerce_payment_gateway\";}s:8:\"\0*\0class\";s:45:\"Drupal\\commerce_payment\\Entity\\PaymentGateway\";s:11:\"\0*\0provider\";s:16:\"commerce_payment\";s:20:\"\0*\0stringTranslation\";N;}s:17:\"commerce_currency\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:17:\"commerce_currency\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:12:\"currencyCode\";i:1;s:4:\"name\";i:2;s:11:\"numericCode\";i:3;s:6:\"symbol\";i:4;s:14:\"fractionDigits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:12:\"currencyCode\";s:5:\"label\";s:4:\"name\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:17:\"commerce_currency\";s:16:\"\0*\0originalClass\";s:37:\"Drupal\\commerce_price\\Entity\\Currency\";s:11:\"\0*\0handlers\";a:6:{s:4:\"form\";a:3:{s:3:\"add\";s:39:\"Drupal\\commerce_price\\Form\\CurrencyForm\";s:4:\"edit\";s:39:\"Drupal\\commerce_price\\Form\\CurrencyForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:43:\"Drupal\\commerce_price\\CurrencyRouteProvider\";}s:12:\"list_builder\";s:41:\"Drupal\\commerce_price\\CurrencyListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:28:\"administer commerce_currency\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:8:\"add-form\";s:44:\"/admin/commerce/config/currencies/add-custom\";s:9:\"edit-form\";s:53:\"/admin/commerce/config/currencies/{commerce_currency}\";s:11:\"delete-form\";s:60:\"/admin/commerce/config/currencies/{commerce_currency}/delete\";s:10:\"collection\";s:33:\"/admin/commerce/config/currencies\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Currency\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Currencies\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"currency\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"currencies\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:15:\"@count currency\";s:6:\"plural\";s:17:\"@count currencies\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:29:\"config:commerce_currency_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:17:\"commerce_currency\";}s:8:\"\0*\0class\";s:37:\"Drupal\\commerce_price\\Entity\\Currency\";s:11:\"\0*\0provider\";s:14:\"commerce_price\";s:20:\"\0*\0stringTranslation\";N;}s:26:\"commerce_product_attribute\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:26:\"commerce_product_attribute\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:3:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:11:\"elementType\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:26:\"commerce_product_attribute\";s:16:\"\0*\0originalClass\";s:47:\"Drupal\\commerce_product\\Entity\\ProductAttribute\";s:11:\"\0*\0handlers\";a:7:{s:6:\"access\";s:42:\"Drupal\\commerce\\EntityAccessControlHandler\";s:19:\"permission_provider\";s:40:\"Drupal\\commerce\\EntityPermissionProvider\";s:12:\"list_builder\";s:51:\"Drupal\\commerce_product\\ProductAttributeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:49:\"Drupal\\commerce_product\\Form\\ProductAttributeForm\";s:4:\"edit\";s:49:\"Drupal\\commerce_product\\Form\\ProductAttributeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce_product\\Form\\ProductAttributeDeleteForm\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:37:\"administer commerce_product_attribute\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:8:\"add-form\";s:38:\"/admin/commerce/product-attributes/add\";s:9:\"edit-form\";s:70:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}\";s:11:\"delete-form\";s:77:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/delete\";s:10:\"collection\";s:34:\"/admin/commerce/product-attributes\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:32:\"commerce_product_attribute_value\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Product attribute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Product attributes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"product attribute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"product attributes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:24:\"@count product attribute\";s:6:\"plural\";s:25:\"@count product attributes\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:38:\"config:commerce_product_attribute_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:26:\"commerce_product_attribute\";}s:8:\"\0*\0class\";s:47:\"Drupal\\commerce_product\\Entity\\ProductAttribute\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:20:\"\0*\0stringTranslation\";N;}s:21:\"commerce_product_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:21:\"commerce_product_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:11:\"description\";i:3;s:13:\"variationType\";i:4;s:21:\"injectVariationFields\";i:5;s:6:\"traits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:21:\"commerce_product_type\";s:16:\"\0*\0originalClass\";s:42:\"Drupal\\commerce_product\\Entity\\ProductType\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:46:\"Drupal\\commerce_product\\ProductTypeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:44:\"Drupal\\commerce_product\\Form\\ProductTypeForm\";s:4:\"edit\";s:44:\"Drupal\\commerce_product\\Form\\ProductTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:32:\"administer commerce_product_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:8:\"add-form\";s:40:\"/admin/commerce/config/product-types/add\";s:9:\"edit-form\";s:65:\"/admin/commerce/config/product-types/{commerce_product_type}/edit\";s:11:\"delete-form\";s:67:\"/admin/commerce/config/product-types/{commerce_product_type}/delete\";s:10:\"collection\";s:36:\"/admin/commerce/config/product-types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:16:\"commerce_product\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Product type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Product types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"product type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"product types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count product type\";s:6:\"plural\";s:20:\"@count product types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:33:\"config:commerce_product_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:21:\"commerce_product_type\";}s:8:\"\0*\0class\";s:42:\"Drupal\\commerce_product\\Entity\\ProductType\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:20:\"\0*\0stringTranslation\";N;}s:31:\"commerce_product_variation_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:31:\"commerce_product_variation_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:13:\"orderItemType\";i:3;s:13:\"generateTitle\";i:4;s:6:\"traits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:31:\"commerce_product_variation_type\";s:16:\"\0*\0originalClass\";s:51:\"Drupal\\commerce_product\\Entity\\ProductVariationType\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:55:\"Drupal\\commerce_product\\ProductVariationTypeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:53:\"Drupal\\commerce_product\\Form\\ProductVariationTypeForm\";s:4:\"edit\";s:53:\"Drupal\\commerce_product\\Form\\ProductVariationTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:32:\"administer commerce_product_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:8:\"add-form\";s:50:\"/admin/commerce/config/product-variation-types/add\";s:9:\"edit-form\";s:85:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit\";s:11:\"delete-form\";s:87:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/delete\";s:10:\"collection\";s:46:\"/admin/commerce/config/product-variation-types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:26:\"commerce_product_variation\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Product variation type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Product variation types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"product variation type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"product variation types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:29:\"@count product variation type\";s:6:\"plural\";s:30:\"@count product variation types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:43:\"config:commerce_product_variation_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:31:\"commerce_product_variation_type\";}s:8:\"\0*\0class\";s:51:\"Drupal\\commerce_product\\Entity\\ProductVariationType\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:20:\"\0*\0stringTranslation\";N;}s:19:\"commerce_store_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:19:\"commerce_store_type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"uuid\";i:3;s:11:\"description\";i:4;s:6:\"traits\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:19:\"commerce_store_type\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\commerce_store\\Entity\\StoreType\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:42:\"Drupal\\commerce_store\\StoreTypeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:40:\"Drupal\\commerce_store\\Form\\StoreTypeForm\";s:4:\"edit\";s:40:\"Drupal\\commerce_store\\Form\\StoreTypeForm\";s:6:\"delete\";s:55:\"Drupal\\commerce\\Form\\CommerceBundleEntityDeleteFormBase\";}s:14:\"route_provider\";a:1:{s:7:\"default\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:30:\"administer commerce_store_type\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:8:\"add-form\";s:38:\"/admin/commerce/config/store-types/add\";s:9:\"edit-form\";s:61:\"/admin/commerce/config/store-types/{commerce_store_type}/edit\";s:11:\"delete-form\";s:63:\"/admin/commerce/config/store-types/{commerce_store_type}/delete\";s:10:\"collection\";s:34:\"/admin/commerce/config/store-types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:14:\"commerce_store\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Store type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Store types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"store type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"store types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:17:\"@count store type\";s:6:\"plural\";s:18:\"@count store types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:commerce_store_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:19:\"commerce_store_type\";}s:8:\"\0*\0class\";s:38:\"Drupal\\commerce_store\\Entity\\StoreType\";s:11:\"\0*\0provider\";s:14:\"commerce_store\";s:20:\"\0*\0stringTranslation\";N;}s:12:\"contact_form\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:4:\"form\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:7:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:10:\"recipients\";i:3;s:5:\"reply\";i:4;s:6:\"weight\";i:5;s:7:\"message\";i:6;s:8:\"redirect\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"contact_form\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\contact\\Entity\\ContactForm\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:46:\"Drupal\\contact\\ContactFormAccessControlHandler\";s:12:\"list_builder\";s:37:\"Drupal\\contact\\ContactFormListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:34:\"Drupal\\contact\\ContactFormEditForm\";s:4:\"edit\";s:34:\"Drupal\\contact\\ContactFormEditForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:24:\"administer contact forms\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:53:\"/admin/structure/contact/manage/{contact_form}/delete\";s:9:\"edit-form\";s:46:\"/admin/structure/contact/manage/{contact_form}\";s:10:\"collection\";s:24:\"/admin/structure/contact\";s:9:\"canonical\";s:23:\"/contact/{contact_form}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:15:\"contact_message\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:contact_form_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:12:\"contact_form\";}s:8:\"\0*\0class\";s:33:\"Drupal\\contact\\Entity\\ContactForm\";s:11:\"\0*\0provider\";s:7:\"contact\";s:20:\"\0*\0stringTranslation\";N;}s:6:\"editor\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:6:\"format\";i:1;s:6:\"editor\";i:2;s:8:\"settings\";i:3;s:12:\"image_upload\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:6:\"format\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:6:\"editor\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\editor\\Entity\\Editor\";s:11:\"\0*\0handlers\";a:3:{s:6:\"access\";s:40:\"Drupal\\editor\\EditorAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"config:editor_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:6:\"editor\";}s:8:\"\0*\0class\";s:27:\"Drupal\\editor\\Entity\\Editor\";s:11:\"\0*\0provider\";s:6:\"editor\";s:20:\"\0*\0stringTranslation\";N;}s:12:\"embed_button\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:6:\"button\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:5:\"label\";i:1;s:2:\"id\";i:2;s:7:\"type_id\";i:3;s:13:\"type_settings\";i:4;s:9:\"icon_uuid\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"embed_button\";s:16:\"\0*\0originalClass\";s:31:\"Drupal\\embed\\Entity\\EmbedButton\";s:11:\"\0*\0handlers\";a:5:{s:4:\"form\";a:3:{s:3:\"add\";s:33:\"Drupal\\embed\\Form\\EmbedButtonForm\";s:4:\"edit\";s:33:\"Drupal\\embed\\Form\\EmbedButtonForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:12:\"list_builder\";s:35:\"Drupal\\embed\\EmbedButtonListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:24:\"administer embed buttons\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"edit-form\";s:56:\"/admin/config/content/embed/button/manage/{embed_button}\";s:11:\"delete-form\";s:63:\"/admin/config/content/embed/button/manage/{embed_button}/delete\";s:10:\"collection\";s:27:\"/admin/config/content/embed\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Embed button\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:embed_button_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:12:\"embed_button\";}s:8:\"\0*\0class\";s:31:\"Drupal\\embed\\Entity\\EmbedButton\";s:11:\"\0*\0provider\";s:5:\"embed\";s:20:\"\0*\0stringTranslation\";N;}s:14:\"entity_browser\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:7:\"browser\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:9:{i:0;s:4:\"name\";i:1;s:5:\"label\";i:2;s:7:\"display\";i:3;s:21:\"display_configuration\";i:4;s:17:\"selection_display\";i:5;s:31:\"selection_display_configuration\";i:6;s:15:\"widget_selector\";i:7;s:29:\"widget_selector_configuration\";i:8;s:7:\"widgets\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:4:\"name\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:14:\"entity_browser\";s:16:\"\0*\0originalClass\";s:42:\"Drupal\\entity_browser\\Entity\\EntityBrowser\";s:11:\"\0*\0handlers\";a:6:{s:4:\"form\";a:2:{s:14:\"entity_browser\";s:44:\"Drupal\\entity_browser\\Form\\EntityBrowserForm\";s:6:\"delete\";s:50:\"Drupal\\entity_browser\\Form\\EntityBrowserDeleteForm\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:12:\"list_builder\";s:58:\"Drupal\\entity_browser\\Controllers\\EntityBrowserListBuilder\";s:6:\"wizard\";a:2:{s:3:\"add\";s:51:\"Drupal\\entity_browser\\Wizard\\EntityBrowserWizardAdd\";s:4:\"edit\";s:48:\"Drupal\\entity_browser\\Wizard\\EntityBrowserWizard\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:26:\"administer entity browsers\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:9:\"canonical\";s:58:\"/admin/config/content/entity_browser/{machine_name}/{step}\";s:10:\"collection\";s:36:\"/admin/config/content/entity_browser\";s:9:\"edit-form\";s:58:\"/admin/config/content/entity_browser/{machine_name}/{step}\";s:11:\"delete-form\";s:60:\"/admin/config/content/entity_browser/{entity_browser}/delete\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Entity browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:26:\"config:entity_browser_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:14:\"entity_browser\";}s:8:\"\0*\0class\";s:42:\"Drupal\\entity_browser\\Entity\\EntityBrowser\";s:11:\"\0*\0provider\";s:14:\"entity_browser\";s:20:\"\0*\0stringTranslation\";N;}s:15:\"features_bundle\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:6:\"bundle\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:4:\"name\";i:1;s:12:\"machine_name\";i:2;s:11:\"description\";i:3;s:11:\"assignments\";i:4;s:12:\"profile_name\";i:5;s:10:\"is_profile\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:12:\"machine_name\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:15:\"features_bundle\";s:16:\"\0*\0originalClass\";s:37:\"Drupal\\features\\Entity\\FeaturesBundle\";s:11:\"\0*\0handlers\";a:3:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Features bundle\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:27:\"config:features_bundle_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:15:\"features_bundle\";}s:8:\"\0*\0class\";s:37:\"Drupal\\features\\Entity\\FeaturesBundle\";s:11:\"\0*\0provider\";s:8:\"features\";s:20:\"\0*\0stringTranslation\";N;}s:12:\"field_config\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:5:\"field\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:6:\"bundle\";i:4;s:5:\"label\";i:5;s:11:\"description\";i:6;s:8:\"required\";i:7;s:12:\"translatable\";i:8;s:13:\"default_value\";i:9;s:22:\"default_value_callback\";i:10;s:8:\"settings\";i:11;s:10:\"field_type\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"field_config\";s:16:\"\0*\0originalClass\";s:31:\"Drupal\\field\\Entity\\FieldConfig\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:44:\"Drupal\\field\\FieldConfigAccessControlHandler\";s:7:\"storage\";s:31:\"Drupal\\field\\FieldConfigStorage\";s:4:\"form\";a:2:{s:4:\"edit\";s:40:\"Drupal\\field_ui\\Form\\FieldConfigEditForm\";s:6:\"delete\";s:42:\"Drupal\\field_ui\\Form\\FieldConfigDeleteForm\";}s:12:\"list_builder\";s:38:\"Drupal\\field_ui\\FieldConfigListBuilder\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:field_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:12:\"field_config\";}s:8:\"\0*\0class\";s:31:\"Drupal\\field\\Entity\\FieldConfig\";s:11:\"\0*\0provider\";s:5:\"field\";s:20:\"\0*\0stringTranslation\";N;}s:20:\"field_storage_config\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:7:\"storage\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:4:\"type\";i:4;s:8:\"settings\";i:5;s:6:\"module\";i:6;s:6:\"locked\";i:7;s:11:\"cardinality\";i:8;s:12:\"translatable\";i:9;s:7:\"indexes\";i:10;s:22:\"persist_with_no_fields\";i:11;s:14:\"custom_storage\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:20:\"field_storage_config\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\field\\Entity\\FieldStorageConfig\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:51:\"Drupal\\field\\FieldStorageConfigAccessControlHandler\";s:7:\"storage\";s:38:\"Drupal\\field\\FieldStorageConfigStorage\";s:4:\"form\";a:1:{s:4:\"edit\";s:47:\"Drupal\\field_ui\\Form\\FieldStorageConfigEditForm\";}s:12:\"list_builder\";s:45:\"Drupal\\field_ui\\FieldStorageConfigListBuilder\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:1:{s:10:\"collection\";s:21:\"/admin/reports/fields\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Field storage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:32:\"config:field_storage_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:20:\"field_storage_config\";}s:8:\"\0*\0class\";s:38:\"Drupal\\field\\Entity\\FieldStorageConfig\";s:11:\"\0*\0provider\";s:5:\"field\";s:20:\"\0*\0stringTranslation\";N;}s:13:\"filter_format\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:6:\"format\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:4:\"name\";i:1;s:6:\"format\";i:2;s:6:\"weight\";i:3;s:5:\"roles\";i:4;s:7:\"filters\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:6:\"format\";s:5:\"label\";s:4:\"name\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:13:\"filter_format\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\filter\\Entity\\FilterFormat\";s:11:\"\0*\0handlers\";a:5:{s:4:\"form\";a:3:{s:3:\"add\";s:33:\"Drupal\\filter\\FilterFormatAddForm\";s:4:\"edit\";s:34:\"Drupal\\filter\\FilterFormatEditForm\";s:7:\"disable\";s:36:\"Drupal\\filter\\Form\\FilterDisableForm\";}s:12:\"list_builder\";s:37:\"Drupal\\filter\\FilterFormatListBuilder\";s:6:\"access\";s:46:\"Drupal\\filter\\FilterFormatAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:18:\"administer filters\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:2:{s:9:\"edit-form\";s:52:\"/admin/config/content/formats/manage/{filter_format}\";s:7:\"disable\";s:60:\"/admin/config/content/formats/manage/{filter_format}/disable\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:25:\"config:filter_format_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:13:\"filter_format\";}s:8:\"\0*\0class\";s:33:\"Drupal\\filter\\Entity\\FilterFormat\";s:11:\"\0*\0provider\";s:6:\"filter\";s:20:\"\0*\0stringTranslation\";N;}s:11:\"image_style\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:5:\"style\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:3:{i:0;s:4:\"name\";i:1;s:5:\"label\";i:2;s:7:\"effects\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:4:\"name\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"image_style\";s:16:\"\0*\0originalClass\";s:30:\"Drupal\\image\\Entity\\ImageStyle\";s:11:\"\0*\0handlers\";a:5:{s:4:\"form\";a:4:{s:3:\"add\";s:35:\"Drupal\\image\\Form\\ImageStyleAddForm\";s:4:\"edit\";s:36:\"Drupal\\image\\Form\\ImageStyleEditForm\";s:6:\"delete\";s:38:\"Drupal\\image\\Form\\ImageStyleDeleteForm\";s:5:\"flush\";s:37:\"Drupal\\image\\Form\\ImageStyleFlushForm\";}s:12:\"list_builder\";s:34:\"Drupal\\image\\ImageStyleListBuilder\";s:7:\"storage\";s:30:\"Drupal\\image\\ImageStyleStorage\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:23:\"administer image styles\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:10:\"flush-form\";s:59:\"/admin/config/media/image-styles/manage/{image_style}/flush\";s:9:\"edit-form\";s:53:\"/admin/config/media/image-styles/manage/{image_style}\";s:11:\"delete-form\";s:60:\"/admin/config/media/image-styles/manage/{image_style}/delete\";s:10:\"collection\";s:32:\"/admin/config/media/image-styles\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:image_style_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:11:\"image_style\";}s:8:\"\0*\0class\";s:30:\"Drupal\\image\\Entity\\ImageStyle\";s:11:\"\0*\0provider\";s:5:\"image\";s:20:\"\0*\0stringTranslation\";N;}s:21:\"configurable_language\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:6:\"entity\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"weight\";s:6:\"weight\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:21:\"configurable_language\";s:16:\"\0*\0originalClass\";s:43:\"Drupal\\language\\Entity\\ConfigurableLanguage\";s:11:\"\0*\0handlers\";a:5:{s:12:\"list_builder\";s:35:\"Drupal\\language\\LanguageListBuilder\";s:6:\"access\";s:44:\"Drupal\\language\\LanguageAccessControlHandler\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\language\\Form\\LanguageAddForm\";s:4:\"edit\";s:37:\"Drupal\\language\\Form\\LanguageEditForm\";s:6:\"delete\";s:39:\"Drupal\\language\\Form\\LanguageDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:20:\"administer languages\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:11:\"delete-form\";s:62:\"/admin/config/regional/language/delete/{configurable_language}\";s:9:\"edit-form\";s:60:\"/admin/config/regional/language/edit/{configurable_language}\";s:10:\"collection\";s:31:\"/admin/config/regional/language\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:33:\"config:configurable_language_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:21:\"configurable_language\";}s:8:\"\0*\0class\";s:43:\"Drupal\\language\\Entity\\ConfigurableLanguage\";s:11:\"\0*\0provider\";s:8:\"language\";s:20:\"\0*\0stringTranslation\";N;}s:25:\"language_content_settings\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:16:\"content_settings\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:25:\"language_content_settings\";s:16:\"\0*\0originalClass\";s:46:\"Drupal\\language\\Entity\\ContentLanguageSettings\";s:11:\"\0*\0handlers\";a:3:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:20:\"administer languages\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Content Language Settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:8:\"rendered\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:25:\"language_content_settings\";}s:8:\"\0*\0class\";s:46:\"Drupal\\language\\Entity\\ContentLanguageSettings\";s:11:\"\0*\0provider\";s:8:\"language\";s:20:\"\0*\0stringTranslation\";N;}s:9:\"node_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:7:{i:0;s:4:\"name\";i:1;s:4:\"type\";i:2;s:11:\"description\";i:3;s:4:\"help\";i:4;s:12:\"new_revision\";i:5;s:12:\"preview_mode\";i:6;s:17:\"display_submitted\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:4:\"type\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"node_type\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\node\\Entity\\NodeType\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:40:\"Drupal\\node\\NodeTypeAccessControlHandler\";s:4:\"form\";a:3:{s:3:\"add\";s:24:\"Drupal\\node\\NodeTypeForm\";s:4:\"edit\";s:24:\"Drupal\\node\\NodeTypeForm\";s:6:\"delete\";s:38:\"Drupal\\node\\Form\\NodeTypeDeleteConfirm\";}s:12:\"list_builder\";s:31:\"Drupal\\node\\NodeTypeListBuilder\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:24:\"administer content types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"edit-form\";s:41:\"/admin/structure/types/manage/{node_type}\";s:11:\"delete-form\";s:48:\"/admin/structure/types/manage/{node_type}/delete\";s:10:\"collection\";s:22:\"/admin/structure/types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:4:\"node\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:node_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:9:\"node_type\";}s:8:\"\0*\0class\";s:27:\"Drupal\\node\\Entity\\NodeType\";s:11:\"\0*\0provider\";s:4:\"node\";s:20:\"\0*\0stringTranslation\";N;}s:12:\"profile_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:10:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:12:\"registration\";i:3;s:8:\"multiple\";i:4;s:5:\"roles\";i:5;s:6:\"weight\";i:6;s:6:\"status\";i:7;s:8:\"langcode\";i:8;s:13:\"use_revisions\";i:9;s:11:\"description\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"profile_type\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\profile\\Entity\\ProfileType\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:37:\"Drupal\\profile\\ProfileTypeListBuilder\";s:4:\"form\";a:4:{s:7:\"default\";s:35:\"Drupal\\profile\\Form\\ProfileTypeForm\";s:3:\"add\";s:35:\"Drupal\\profile\\Form\\ProfileTypeForm\";s:4:\"edit\";s:35:\"Drupal\\profile\\Form\\ProfileTypeForm\";s:6:\"delete\";s:41:\"Drupal\\profile\\Form\\ProfileTypeDeleteForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:24:\"administer profile types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:8:\"add-form\";s:33:\"/admin/config/people/profiles/add\";s:11:\"delete-form\";s:58:\"/admin/config/people/profiles/manage/{profile_type}/delete\";s:9:\"edit-form\";s:51:\"/admin/config/people/profiles/manage/{profile_type}\";s:10:\"admin-form\";s:51:\"/admin/config/people/profiles/manage/{profile_type}\";s:10:\"collection\";s:29:\"/admin/config/people/profiles\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:7:\"profile\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Profile type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:profile_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:12:\"profile_type\";}s:8:\"\0*\0class\";s:33:\"Drupal\\profile\\Entity\\ProfileType\";s:11:\"\0*\0provider\";s:7:\"profile\";s:20:\"\0*\0stringTranslation\";N;}s:20:\"rest_resource_config\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:8:\"resource\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:9:\"plugin_id\";i:2;s:11:\"granularity\";i:3;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:20:\"rest_resource_config\";s:16:\"\0*\0originalClass\";s:37:\"Drupal\\rest\\Entity\\RestResourceConfig\";s:11:\"\0*\0handlers\";a:3:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:25:\"administer rest resources\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";s:18:\"getLabelFromPlugin\";s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"REST resource configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:32:\"config:rest_resource_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:20:\"rest_resource_config\";}s:8:\"\0*\0class\";s:37:\"Drupal\\rest\\Entity\\RestResourceConfig\";s:11:\"\0*\0provider\";s:4:\"rest\";s:20:\"\0*\0stringTranslation\";N;}s:11:\"search_page\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:4:\"page\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"path\";i:3;s:6:\"weight\";i:4;s:6:\"plugin\";i:5;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"search_page\";s:16:\"\0*\0originalClass\";s:31:\"Drupal\\search\\Entity\\SearchPage\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:44:\"Drupal\\search\\SearchPageAccessControlHandler\";s:12:\"list_builder\";s:35:\"Drupal\\search\\SearchPageListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\search\\Form\\SearchPageAddForm\";s:4:\"edit\";s:37:\"Drupal\\search\\Form\\SearchPageEditForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:17:\"administer search\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:9:\"edit-form\";s:47:\"/admin/config/search/pages/manage/{search_page}\";s:11:\"delete-form\";s:54:\"/admin/config/search/pages/manage/{search_page}/delete\";s:6:\"enable\";s:54:\"/admin/config/search/pages/manage/{search_page}/enable\";s:7:\"disable\";s:55:\"/admin/config/search/pages/manage/{search_page}/disable\";s:11:\"set-default\";s:59:\"/admin/config/search/pages/manage/{search_page}/set-default\";s:10:\"collection\";s:26:\"/admin/config/search/pages\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Search page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:search_page_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:11:\"search_page\";}s:8:\"\0*\0class\";s:31:\"Drupal\\search\\Entity\\SearchPage\";s:11:\"\0*\0provider\";s:6:\"search\";s:20:\"\0*\0stringTranslation\";N;}s:12:\"shortcut_set\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:3:\"set\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:2:{i:0;s:2:\"id\";i:1;s:5:\"label\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"shortcut_set\";s:16:\"\0*\0originalClass\";s:34:\"Drupal\\shortcut\\Entity\\ShortcutSet\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:34:\"Drupal\\shortcut\\ShortcutSetStorage\";s:6:\"access\";s:47:\"Drupal\\shortcut\\ShortcutSetAccessControlHandler\";s:12:\"list_builder\";s:38:\"Drupal\\shortcut\\ShortcutSetListBuilder\";s:4:\"form\";a:5:{s:7:\"default\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:3:\"add\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:4:\"edit\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:9:\"customize\";s:33:\"Drupal\\shortcut\\Form\\SetCustomize\";s:6:\"delete\";s:42:\"Drupal\\shortcut\\Form\\ShortcutSetDeleteForm\";}s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:14:\"customize-form\";s:69:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/customize\";s:11:\"delete-form\";s:66:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/delete\";s:9:\"edit-form\";s:59:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}\";s:10:\"collection\";s:37:\"/admin/config/user-interface/shortcut\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:8:\"shortcut\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:shortcut_set_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:12:\"shortcut_set\";}s:8:\"\0*\0class\";s:34:\"Drupal\\shortcut\\Entity\\ShortcutSet\";s:11:\"\0*\0provider\";s:8:\"shortcut\";s:20:\"\0*\0stringTranslation\";N;}s:6:\"action\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"type\";i:3;s:6:\"plugin\";i:4;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:6:\"action\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\system\\Entity\\Action\";s:11:\"\0*\0handlers\";a:3:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:18:\"administer actions\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"config:action_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:6:\"action\";}s:8:\"\0*\0class\";s:27:\"Drupal\\system\\Entity\\Action\";s:11:\"\0*\0provider\";s:6:\"system\";s:20:\"\0*\0stringTranslation\";N;}s:4:\"menu\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:11:\"description\";i:3;s:6:\"locked\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"menu\";s:16:\"\0*\0originalClass\";s:25:\"Drupal\\system\\Entity\\Menu\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:38:\"Drupal\\system\\MenuAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";s:4:\"form\";a:3:{s:3:\"add\";s:23:\"Drupal\\menu_ui\\MenuForm\";s:4:\"edit\";s:23:\"Drupal\\menu_ui\\MenuForm\";s:6:\"delete\";s:34:\"Drupal\\menu_ui\\Form\\MenuDeleteForm\";}s:12:\"list_builder\";s:30:\"Drupal\\menu_ui\\MenuListBuilder\";}s:19:\"\0*\0admin_permission\";s:15:\"administer menu\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:8:\"add-form\";s:25:\"/admin/structure/menu/add\";s:11:\"delete-form\";s:42:\"/admin/structure/menu/manage/{menu}/delete\";s:9:\"edit-form\";s:35:\"/admin/structure/menu/manage/{menu}\";s:13:\"add-link-form\";s:39:\"/admin/structure/menu/manage/{menu}/add\";s:10:\"collection\";s:21:\"/admin/structure/menu\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:menu_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:4:\"menu\";}s:8:\"\0*\0class\";s:25:\"Drupal\\system\\Entity\\Menu\";s:11:\"\0*\0provider\";s:6:\"system\";s:20:\"\0*\0stringTranslation\";N;}s:19:\"taxonomy_vocabulary\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:10:\"vocabulary\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:4:\"name\";i:1;s:3:\"vid\";i:2;s:11:\"description\";i:3;s:9:\"hierarchy\";i:4;s:6:\"weight\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:6:\"weight\";s:6:\"weight\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"taxonomy_vocabulary\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\taxonomy\\Entity\\Vocabulary\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:33:\"Drupal\\taxonomy\\VocabularyStorage\";s:12:\"list_builder\";s:37:\"Drupal\\taxonomy\\VocabularyListBuilder\";s:4:\"form\";a:3:{s:7:\"default\";s:30:\"Drupal\\taxonomy\\VocabularyForm\";s:5:\"reset\";s:40:\"Drupal\\taxonomy\\Form\\VocabularyResetForm\";s:6:\"delete\";s:41:\"Drupal\\taxonomy\\Form\\VocabularyDeleteForm\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:19:\"administer taxonomy\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:58:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/add\";s:11:\"delete-form\";s:61:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/delete\";s:10:\"reset-form\";s:60:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/reset\";s:13:\"overview-form\";s:63:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview\";s:9:\"edit-form\";s:54:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}\";s:10:\"collection\";s:25:\"/admin/structure/taxonomy\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:13:\"taxonomy_term\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Taxonomy vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:taxonomy_vocabulary_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:10:\"vocabulary\";}s:8:\"\0*\0class\";s:33:\"Drupal\\taxonomy\\Entity\\Vocabulary\";s:11:\"\0*\0provider\";s:8:\"taxonomy\";s:20:\"\0*\0stringTranslation\";N;}s:11:\"tb_megamenu\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:11:\"menu_config\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:4:\"menu\";s:4:\"menu\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"tb_megamenu\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\tb_megamenu\\Entity\\MegaMenuConfig\";s:11:\"\0*\0handlers\";a:5:{s:12:\"list_builder\";s:42:\"Drupal\\tb_megamenu\\Controller\\MegaMenuList\";s:4:\"form\";a:3:{s:3:\"add\";s:35:\"Drupal\\tb_megamenu\\Form\\MegaMenuAdd\";s:4:\"edit\";s:35:\"Drupal\\tb_megamenu\\Form\\MegaMenuAdd\";s:6:\"delete\";s:38:\"Drupal\\tb_megamenu\\Form\\MegaMenuDelete\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:2:{s:9:\"edit-form\";s:42:\"/admin/structure/tb-megamenu/{tb_megamenu}\";s:11:\"delete-form\";s:49:\"/admin/structure/tb-megamenu/{tb_megamenu}/delete\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"TB Mega Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:tb_megamenu_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:11:\"tb_megamenu\";}s:8:\"\0*\0class\";s:40:\"Drupal\\tb_megamenu\\Entity\\MegaMenuConfig\";s:11:\"\0*\0provider\";s:11:\"tb_megamenu\";s:20:\"\0*\0stringTranslation\";N;}s:4:\"tour\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:2:{i:0;s:19:\"routes.*.route_name\";i:1;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"module\";i:3;s:6:\"routes\";i:4;s:4:\"tips\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"tour\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\tour\\Entity\\Tour\";s:11:\"\0*\0handlers\";a:4:{s:12:\"view_builder\";s:27:\"Drupal\\tour\\TourViewBuilder\";s:6:\"access\";s:36:\"Drupal\\tour\\TourAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:tour_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:4:\"tour\";}s:8:\"\0*\0class\";s:23:\"Drupal\\tour\\Entity\\Tour\";s:11:\"\0*\0provider\";s:4:\"tour\";s:20:\"\0*\0stringTranslation\";N;}s:9:\"user_role\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:4:\"role\";s:15:\"\0*\0static_cache\";b:1;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"weight\";i:3;s:8:\"is_admin\";i:4;s:11:\"permissions\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:6:\"weight\";s:6:\"weight\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"user_role\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\user\\Entity\\Role\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:23:\"Drupal\\user\\RoleStorage\";s:6:\"access\";s:36:\"Drupal\\user\\RoleAccessControlHandler\";s:12:\"list_builder\";s:27:\"Drupal\\user\\RoleListBuilder\";s:4:\"form\";a:2:{s:7:\"default\";s:20:\"Drupal\\user\\RoleForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:22:\"administer permissions\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:45:\"/admin/people/roles/manage/{user_role}/delete\";s:9:\"edit-form\";s:38:\"/admin/people/roles/manage/{user_role}\";s:21:\"edit-permissions-form\";s:37:\"/admin/people/permissions/{user_role}\";s:10:\"collection\";s:19:\"/admin/people/roles\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:user_role_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:9:\"user_role\";}s:8:\"\0*\0class\";s:23:\"Drupal\\user\\Entity\\Role\";s:11:\"\0*\0provider\";s:4:\"user\";s:20:\"\0*\0stringTranslation\";N;}s:9:\"vote_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"vote_type\";s:16:\"\0*\0originalClass\";s:32:\"Drupal\\votingapi\\Entity\\VoteType\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:45:\"Drupal\\votingapi\\VoteTypeAccessControlHandler\";s:4:\"form\";a:3:{s:3:\"add\";s:29:\"Drupal\\votingapi\\VoteTypeForm\";s:4:\"edit\";s:29:\"Drupal\\votingapi\\VoteTypeForm\";s:6:\"delete\";s:43:\"Drupal\\votingapi\\Form\\VoteTypeDeleteConfirm\";}s:12:\"list_builder\";s:36:\"Drupal\\votingapi\\VoteTypeListBuilder\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:21:\"administer vote types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"edit-form\";s:39:\"/admin/structure/vote-types/{vote_type}\";s:11:\"delete-form\";s:46:\"/admin/structure/vote-types/{vote_type}/delete\";s:10:\"collection\";s:27:\"/admin/structure/vote-types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:4:\"vote\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Vote Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:vote_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:9:\"vote_type\";}s:8:\"\0*\0class\";s:32:\"Drupal\\votingapi\\Entity\\VoteType\";s:11:\"\0*\0provider\";s:9:\"votingapi\";s:20:\"\0*\0stringTranslation\";N;}s:7:\"webform\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:3:{i:0;s:6:\"status\";i:1;s:8:\"template\";i:2;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:17:{i:0;s:6:\"status\";i:1;s:4:\"open\";i:2;s:5:\"close\";i:3;s:3:\"uid\";i:4;s:8:\"template\";i:5;s:2:\"id\";i:6;s:4:\"uuid\";i:7;s:5:\"title\";i:8;s:11:\"description\";i:9;s:8:\"category\";i:10;s:8:\"elements\";i:11;s:3:\"css\";i:12;s:10:\"javascript\";i:13;s:8:\"settings\";i:14;s:6:\"access\";i:15;s:8:\"handlers\";i:16;s:20:\"third_party_settings\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"title\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:7:\"webform\";s:16:\"\0*\0originalClass\";s:29:\"Drupal\\webform\\Entity\\Webform\";s:11:\"\0*\0handlers\";a:6:{s:7:\"storage\";s:36:\"\\Drupal\\webform\\WebformEntityStorage\";s:12:\"view_builder\";s:39:\"Drupal\\webform\\WebformEntityViewBuilder\";s:12:\"list_builder\";s:39:\"Drupal\\webform\\WebformEntityListBuilder\";s:6:\"access\";s:48:\"Drupal\\webform\\WebformEntityAccessControlHandler\";s:4:\"form\";a:13:{s:3:\"add\";s:35:\"Drupal\\webform\\WebformEntityAddForm\";s:9:\"duplicate\";s:35:\"Drupal\\webform\\WebformEntityAddForm\";s:6:\"delete\";s:38:\"Drupal\\webform\\WebformEntityDeleteForm\";s:4:\"edit\";s:45:\"Drupal\\webform_ui\\WebformUiEntityElementsForm\";s:8:\"settings\";s:62:\"Drupal\\webform\\EntitySettings\\WebformEntitySettingsGeneralForm\";s:13:\"settings_form\";s:59:\"Drupal\\webform\\EntitySettings\\WebformEntitySettingsFormForm\";s:20:\"settings_submissions\";s:66:\"Drupal\\webform\\EntitySettings\\WebformEntitySettingsSubmissionsForm\";s:21:\"settings_confirmation\";s:67:\"Drupal\\webform\\EntitySettings\\WebformEntitySettingsConfirmationForm\";s:15:\"settings_assets\";s:61:\"Drupal\\webform\\EntitySettings\\WebformEntitySettingsAssetsForm\";s:15:\"settings_access\";s:61:\"Drupal\\webform\\EntitySettings\\WebformEntitySettingsAccessForm\";s:8:\"handlers\";s:40:\"Drupal\\webform\\WebformEntityHandlersForm\";s:6:\"source\";s:40:\"Drupal\\webform\\WebformEntityElementsForm\";s:10:\"quick_edit\";s:45:\"Drupal\\webform_ui\\WebformUiEntityElementsForm\";}s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:18:\"administer webform\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:21:{s:9:\"canonical\";s:18:\"/webform/{webform}\";s:11:\"submissions\";s:30:\"/webform/{webform}/submissions\";s:8:\"add-form\";s:18:\"/webform/{webform}\";s:9:\"edit-form\";s:50:\"/admin/structure/webform/manage/{webform}/elements\";s:9:\"test-form\";s:23:\"/webform/{webform}/test\";s:14:\"duplicate-form\";s:51:\"/admin/structure/webform/manage/{webform}/duplicate\";s:11:\"delete-form\";s:48:\"/admin/structure/webform/manage/{webform}/delete\";s:11:\"export-form\";s:48:\"/admin/structure/webform/manage/{webform}/export\";s:8:\"settings\";s:50:\"/admin/structure/webform/manage/{webform}/settings\";s:13:\"settings-form\";s:55:\"/admin/structure/webform/manage/{webform}/settings/form\";s:20:\"settings-submissions\";s:62:\"/admin/structure/webform/manage/{webform}/settings/submissions\";s:21:\"settings-confirmation\";s:63:\"/admin/structure/webform/manage/{webform}/settings/confirmation\";s:15:\"settings-assets\";s:57:\"/admin/structure/webform/manage/{webform}/settings/assets\";s:15:\"settings-access\";s:57:\"/admin/structure/webform/manage/{webform}/settings/access\";s:8:\"handlers\";s:50:\"/admin/structure/webform/manage/{webform}/handlers\";s:19:\"results-submissions\";s:61:\"/admin/structure/webform/manage/{webform}/results/submissions\";s:14:\"results-export\";s:58:\"/admin/structure/webform/manage/{webform}/results/download\";s:11:\"results-log\";s:53:\"/admin/structure/webform/manage/{webform}/results/log\";s:13:\"results-clear\";s:55:\"/admin/structure/webform/manage/{webform}/results/clear\";s:10:\"collection\";s:24:\"/admin/structure/webform\";s:10:\"references\";s:52:\"/admin/structure/webform/manage/{webform}/references\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:18:\"webform_submission\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:19:\"config:webform_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:7:\"webform\";}s:8:\"\0*\0class\";s:29:\"Drupal\\webform\\Entity\\Webform\";s:11:\"\0*\0provider\";s:7:\"webform\";s:20:\"\0*\0stringTranslation\";N;}s:15:\"webform_options\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:4:\"uuid\";i:2;s:5:\"label\";i:3;s:8:\"category\";i:4;s:6:\"likert\";i:5;s:7:\"options\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:15:\"webform_options\";s:16:\"\0*\0originalClass\";s:36:\"Drupal\\webform\\Entity\\WebformOptions\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:37:\"\\Drupal\\webform\\WebformOptionsStorage\";s:6:\"access\";s:49:\"Drupal\\webform\\WebformOptionsAccessControlHandler\";s:12:\"list_builder\";s:40:\"Drupal\\webform\\WebformOptionsListBuilder\";s:4:\"form\";a:5:{s:3:\"add\";s:38:\"Drupal\\webform_ui\\WebformUiOptionsForm\";s:4:\"edit\";s:38:\"Drupal\\webform_ui\\WebformUiOptionsForm\";s:9:\"duplicate\";s:38:\"Drupal\\webform_ui\\WebformUiOptionsForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";s:6:\"source\";s:33:\"Drupal\\webform\\WebformOptionsForm\";}s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:18:\"administer webform\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:8:\"add-form\";s:43:\"/admin/structure/webform/config/options/add\";s:9:\"edit-form\";s:69:\"/admin/structure/webform/config/options/manage/{webform_options}/edit\";s:14:\"duplicate-form\";s:74:\"/admin/structure/webform/config/options/manage/{webform_options}/duplicate\";s:11:\"delete-form\";s:71:\"/admin/structure/webform/config/options/manage/{webform_options}/delete\";s:10:\"collection\";s:46:\"/admin/structure/webform/config/options/manage\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Webform options\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:27:\"config:webform_options_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:15:\"webform_options\";}s:8:\"\0*\0class\";s:36:\"Drupal\\webform\\Entity\\WebformOptions\";s:11:\"\0*\0provider\";s:7:\"webform\";s:20:\"\0*\0stringTranslation\";N;}s:16:\"pathauto_pattern\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:7:\"pattern\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:3:{i:0;s:4:\"type\";i:1;s:6:\"status\";i:2;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:8:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"type\";i:3;s:7:\"pattern\";i:4;s:18:\"selection_criteria\";i:5;s:15:\"selection_logic\";i:6;s:6:\"weight\";i:7;s:13:\"relationships\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:16:\"pathauto_pattern\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\pathauto\\Entity\\PathautoPattern\";s:11:\"\0*\0handlers\";a:6:{s:12:\"list_builder\";s:42:\"Drupal\\pathauto\\PathautoPatternListBuilder\";s:4:\"form\";a:4:{s:7:\"default\";s:36:\"Drupal\\pathauto\\Form\\PatternEditForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";s:6:\"enable\";s:38:\"Drupal\\pathauto\\Form\\PatternEnableForm\";s:7:\"disable\";s:39:\"Drupal\\pathauto\\Form\\PatternDisableForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:51:\"Drupal\\Core\\Entity\\Routing\\DefaultHtmlRouteProvider\";}s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:19:\"administer pathauto\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:10:\"collection\";s:34:\"/admin/config/search/path/patterns\";s:9:\"edit-form\";s:53:\"/admin/config/search/path/patterns/{pathauto_pattern}\";s:11:\"delete-form\";s:60:\"/admin/config/search/path/patterns/{pathauto_pattern}/delete\";s:6:\"enable\";s:60:\"/admin/config/search/path/patterns/{pathauto_pattern}/enable\";s:7:\"disable\";s:61:\"/admin/config/search/path/patterns/{pathauto_pattern}/disable\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Pathauto pattern\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:pathauto_pattern_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:16:\"pathauto_pattern\";}s:8:\"\0*\0class\";s:38:\"Drupal\\pathauto\\Entity\\PathautoPattern\";s:11:\"\0*\0provider\";s:8:\"pathauto\";s:20:\"\0*\0stringTranslation\";N;}s:4:\"view\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:9:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"module\";i:3;s:11:\"description\";i:4;s:3:\"tag\";i:5;s:10:\"base_table\";i:6;s:10:\"base_field\";i:7;s:4:\"core\";i:8;s:7:\"display\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"view\";s:16:\"\0*\0originalClass\";s:24:\"Drupal\\views\\Entity\\View\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";s:4:\"form\";a:6:{s:4:\"edit\";s:28:\"Drupal\\views_ui\\ViewEditForm\";s:3:\"add\";s:27:\"Drupal\\views_ui\\ViewAddForm\";s:7:\"preview\";s:31:\"Drupal\\views_ui\\ViewPreviewForm\";s:9:\"duplicate\";s:33:\"Drupal\\views_ui\\ViewDuplicateForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";s:10:\"break_lock\";s:34:\"Drupal\\views_ui\\Form\\BreakLockForm\";}s:12:\"list_builder\";s:31:\"Drupal\\views_ui\\ViewListBuilder\";}s:19:\"\0*\0admin_permission\";s:16:\"administer views\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:9:{s:9:\"edit-form\";s:34:\"/admin/structure/views/view/{view}\";s:17:\"edit-display-form\";s:52:\"/admin/structure/views/view/{view}/edit/{display_id}\";s:12:\"preview-form\";s:55:\"/admin/structure/views/view/{view}/preview/{display_id}\";s:14:\"duplicate-form\";s:44:\"/admin/structure/views/view/{view}/duplicate\";s:11:\"delete-form\";s:41:\"/admin/structure/views/view/{view}/delete\";s:6:\"enable\";s:41:\"/admin/structure/views/view/{view}/enable\";s:7:\"disable\";s:42:\"/admin/structure/views/view/{view}/disable\";s:15:\"break-lock-form\";s:45:\"/admin/structure/views/view/{view}/break-lock\";s:10:\"collection\";s:22:\"/admin/structure/views\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"View\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:view_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:4:\"view\";}s:8:\"\0*\0class\";s:24:\"Drupal\\views\\Entity\\View\";s:11:\"\0*\0provider\";s:5:\"views\";s:20:\"\0*\0stringTranslation\";N;}s:11:\"date_format\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"locked\";i:3;s:7:\"pattern\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"date_format\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\Core\\Datetime\\Entity\\DateFormat\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:44:\"Drupal\\system\\DateFormatAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\system\\Form\\DateFormatAddForm\";s:4:\"edit\";s:37:\"Drupal\\system\\Form\\DateFormatEditForm\";s:6:\"delete\";s:39:\"Drupal\\system\\Form\\DateFormatDeleteForm\";}s:12:\"list_builder\";s:35:\"Drupal\\system\\DateFormatListBuilder\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"edit-form\";s:61:\"/admin/config/regional/date-time/formats/manage/{date_format}\";s:11:\"delete-form\";s:68:\"/admin/config/regional/date-time/formats/manage/{date_format}/delete\";s:10:\"collection\";s:40:\"/admin/config/regional/date-time/formats\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Date format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:8:\"rendered\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:11:\"date_format\";}s:8:\"\0*\0class\";s:38:\"Drupal\\Core\\Datetime\\Entity\\DateFormat\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}s:19:\"entity_form_display\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:4:\"mode\";i:4;s:7:\"content\";i:5;s:6:\"hidden\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"entity_form_display\";s:16:\"\0*\0originalClass\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:4:\"form\";a:1:{s:4:\"edit\";s:46:\"Drupal\\field_ui\\Form\\EntityFormDisplayEditForm\";}s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:entity_form_display_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:19:\"entity_form_display\";}s:8:\"\0*\0class\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}s:16:\"entity_form_mode\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:16:\"targetEntityType\";i:3;s:5:\"cache\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:16:\"entity_form_mode\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityFormMode\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:12:\"list_builder\";s:41:\"Drupal\\field_ui\\EntityFormModeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:42:\"Drupal\\field_ui\\Form\\EntityFormModeAddForm\";s:4:\"edit\";s:46:\"Drupal\\field_ui\\Form\\EntityDisplayModeEditForm\";s:6:\"delete\";s:48:\"Drupal\\field_ui\\Form\\EntityDisplayModeDeleteForm\";}s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:24:\"administer display modes\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:68:\"/admin/structure/display-modes/form/manage/{entity_form_mode}/delete\";s:9:\"edit-form\";s:61:\"/admin/structure/display-modes/form/manage/{entity_form_mode}\";s:8:\"add-form\";s:56:\"/admin/structure/display-modes/form/add/{entity_type_id}\";s:10:\"collection\";s:35:\"/admin/structure/display-modes/form\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:entity_form_mode_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:16:\"entity_form_mode\";}s:8:\"\0*\0class\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityFormMode\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}s:19:\"entity_view_display\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:4:\"mode\";i:4;s:7:\"content\";i:5;s:6:\"hidden\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"entity_view_display\";s:16:\"\0*\0originalClass\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:4:\"form\";a:1:{s:4:\"edit\";s:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\";}s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity view display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:entity_view_display_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:19:\"entity_view_display\";}s:8:\"\0*\0class\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}s:16:\"entity_view_mode\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:16:\"targetEntityType\";i:3;s:5:\"cache\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:16:\"entity_view_mode\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityViewMode\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:12:\"list_builder\";s:44:\"Drupal\\field_ui\\EntityDisplayModeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:45:\"Drupal\\field_ui\\Form\\EntityDisplayModeAddForm\";s:4:\"edit\";s:46:\"Drupal\\field_ui\\Form\\EntityDisplayModeEditForm\";s:6:\"delete\";s:48:\"Drupal\\field_ui\\Form\\EntityDisplayModeDeleteForm\";}s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:24:\"administer display modes\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:68:\"/admin/structure/display-modes/view/manage/{entity_view_mode}/delete\";s:9:\"edit-form\";s:61:\"/admin/structure/display-modes/view/manage/{entity_view_mode}\";s:8:\"add-form\";s:56:\"/admin/structure/display-modes/view/add/{entity_type_id}\";s:10:\"collection\";s:35:\"/admin/structure/display-modes/view\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:entity_view_mode_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:16:\"entity_view_mode\";}s:8:\"\0*\0class\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityViewMode\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}s:19:\"base_field_override\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":41:{s:16:\"\0*\0config_prefix\";s:19:\"base_field_override\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:6:\"bundle\";i:4;s:5:\"label\";i:5;s:11:\"description\";i:6;s:8:\"required\";i:7;s:12:\"translatable\";i:8;s:13:\"default_value\";i:9;s:22:\"default_value_callback\";i:10;s:8:\"settings\";i:11;s:10:\"field_type\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"base_field_override\";s:16:\"\0*\0originalClass\";s:42:\"Drupal\\Core\\Field\\Entity\\BaseFieldOverride\";s:11:\"\0*\0handlers\";a:3:{s:7:\"storage\";s:42:\"Drupal\\Core\\Field\\BaseFieldOverrideStorage\";s:6:\"access\";s:55:\"Drupal\\Core\\Field\\BaseFieldOverrideAccessControlHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Base field override\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:base_field_override_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:19:\"base_field_override\";}s:8:\"\0*\0class\";s:42:\"Drupal\\Core\\Field\\Entity\\BaseFieldOverride\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}}s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:3:{s:13:\"entityManager\";s:14:\"entity.manager\";s:13:\"configStorage\";s:14:\"config.storage\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:25:\"config_single_export_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:0:{}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1520011082),

('form_state','form-GZdQR_LWA2KiKHzkY26Mi-8n0VNTss90V-aInZQEtpU','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"4ae6a983-0864-4215-aad3-544647c26b53\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:5:{i:0;s:28:\"comment.type.default_reviews\";i:1;s:49:\"field.field.comment.default_reviews.field_comment\";i:2;s:47:\"field.field.comment.default_reviews.field_email\";i:3;s:48:\"field.field.comment.default_reviews.field_rating\";i:4;s:51:\"field.field.comment.default_reviews.field_your_name\";}s:6:\"module\";a:1:{i:0;s:8:\"fivestar\";}}s:5:\"\0*\0id\";s:31:\"comment.default_reviews.default\";s:19:\"\0*\0targetEntityType\";s:7:\"comment\";s:9:\"\0*\0bundle\";s:15:\"default_reviews\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:5:{s:13:\"field_comment\";a:6:{s:6:\"weight\";s:3:\"103\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_email\";a:6:{s:6:\"weight\";s:3:\"101\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:12:\"field_rating\";a:6:{s:6:\"weight\";s:3:\"104\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:44:\"modules/fivestar/widgets/minimal/minimal.css\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"fivestar_stars\";s:6:\"region\";s:7:\"content\";}s:15:\"field_your_name\";a:6:{s:6:\"weight\";s:3:\"102\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";s:3:\"100\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:1:{s:8:\"langcode\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:15:\"default_reviews\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";s:12:\"field_rating\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503087990),

('form_state','form-hP2tKvkRU3GQZvSrXp1xh_4K4ph4NmMB09WOO-Kiy-8','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:25:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:0:{}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:0:{}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";N;s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503347137),

('form_state','form-hwHP1OcbgGBzMFFlUY4Q4iF-a-LyVM8sQMe3EQy58xw','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:1:{i:0;s:0:\"\";}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\features_ui\\Form\\FeaturesEditForm\":15:{s:10:\"\0*\0package\";O:23:\"Drupal\\features\\Package\":19:{s:14:\"\0*\0machineName\";s:0:\"\";s:7:\"\0*\0name\";s:0:\"\";s:14:\"\0*\0description\";s:0:\"\";s:10:\"\0*\0version\";s:0:\"\";s:7:\"\0*\0core\";s:3:\"8.x\";s:7:\"\0*\0type\";s:6:\"module\";s:9:\"\0*\0themes\";a:0:{}s:9:\"\0*\0bundle\";s:0:\"\";s:11:\"\0*\0excluded\";a:0:{}s:11:\"\0*\0required\";b:0;s:7:\"\0*\0info\";a:0:{}s:15:\"\0*\0dependencies\";a:3:{i:0;s:5:\"block\";i:1;s:4:\"node\";i:2;s:5:\"views\";}s:9:\"\0*\0status\";i:0;s:8:\"\0*\0state\";i:0;s:12:\"\0*\0directory\";N;s:8:\"\0*\0files\";a:0:{}s:12:\"\0*\0extension\";N;s:9:\"\0*\0config\";a:1:{i:0;s:49:\"block.block.views_block__related_projects_block_1\";}s:13:\"\0*\0configOrig\";a:0:{}}s:9:\"\0*\0bundle\";s:6:\"rhythm\";s:12:\"\0*\0oldBundle\";s:7:\"default\";s:11:\"\0*\0excluded\";a:0:{}s:11:\"\0*\0required\";a:0:{}s:12:\"\0*\0conflicts\";a:17:{s:13:\"system_simple\";a:9:{s:14:\"embed.settings\";s:14:\"embed.settings\";s:21:\"entity_embed.settings\";s:21:\"entity_embed.settings\";s:13:\"file.settings\";s:13:\"file.settings\";s:28:\"nd_visualshortcodes.settings\";s:28:\"nd_visualshortcodes.settings\";s:14:\"seven.settings\";s:14:\"seven.settings\";s:12:\"system.image\";s:12:\"system.image\";s:15:\"system.image.gd\";s:15:\"system.image.gd\";s:17:\"taxonomy.settings\";s:17:\"taxonomy.settings\";s:14:\"views.settings\";s:14:\"views.settings\";}s:19:\"base_field_override\";a:5:{s:25:\"node.gallery_item.promote\";s:22:\"Promoted to front page\";s:20:\"node.nd_blog.promote\";s:22:\"Promoted to front page\";s:22:\"node.nd_person.promote\";s:22:\"Promoted to front page\";s:25:\"node.nd_portfolio.promote\";s:22:\"Promoted to front page\";s:17:\"node.page.promote\";s:22:\"Promoted to front page\";}s:5:\"block\";a:2:{s:32:\"views_block__products_tags_block\";s:4:\"Tags\";s:34:\"views_block__shop_categories_block\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"@view: @display\";s:12:\"\0*\0arguments\";a:2:{s:5:\"@view\";s:15:\"Shop Categories\";s:8:\"@display\";s:15:\"Shop Categories\";}s:10:\"\0*\0options\";a:0:{}}}s:25:\"language_content_settings\";a:3:{s:17:\"node.gallery_item\";s:17:\"node.gallery_item\";s:14:\"node.nd_person\";s:14:\"node.nd_person\";s:21:\"taxonomy_term.gallery\";s:21:\"taxonomy_term.gallery\";}s:9:\"node_type\";a:5:{s:12:\"gallery_item\";s:12:\"Gallery Item\";s:7:\"nd_blog\";s:4:\"Blog\";s:9:\"nd_person\";s:6:\"Person\";s:12:\"nd_portfolio\";s:9:\"Portfolio\";s:4:\"page\";s:10:\"Basic page\";}s:18:\"block_content_type\";a:1:{s:5:\"basic\";s:11:\"Basic block\";}s:19:\"entity_form_display\";a:10:{s:27:\"block_content.basic.default\";s:27:\"block_content.basic.default\";s:23:\"comment.comment.default\";s:23:\"comment.comment.default\";s:20:\"node.article.default\";s:20:\"node.article.default\";s:25:\"node.gallery_item.default\";s:25:\"node.gallery_item.default\";s:20:\"node.nd_blog.default\";s:20:\"node.nd_blog.default\";s:22:\"node.nd_person.default\";s:22:\"node.nd_person.default\";s:25:\"node.nd_portfolio.default\";s:25:\"node.nd_portfolio.default\";s:17:\"node.page.default\";s:17:\"node.page.default\";s:20:\"node.webform.default\";s:20:\"node.webform.default\";s:17:\"user.user.default\";s:17:\"user.user.default\";}s:19:\"entity_view_display\";a:19:{s:27:\"block_content.basic.default\";s:27:\"block_content.basic.default\";s:23:\"comment.comment.default\";s:23:\"comment.comment.default\";s:20:\"node.article.default\";s:20:\"node.article.default\";s:16:\"node.article.rss\";s:16:\"node.article.rss\";s:19:\"node.article.teaser\";s:19:\"node.article.teaser\";s:25:\"node.gallery_item.default\";s:25:\"node.gallery_item.default\";s:24:\"node.gallery_item.teaser\";s:24:\"node.gallery_item.teaser\";s:20:\"node.nd_blog.default\";s:20:\"node.nd_blog.default\";s:19:\"node.nd_blog.teaser\";s:19:\"node.nd_blog.teaser\";s:22:\"node.nd_person.default\";s:22:\"node.nd_person.default\";s:21:\"node.nd_person.teaser\";s:21:\"node.nd_person.teaser\";s:25:\"node.nd_portfolio.default\";s:25:\"node.nd_portfolio.default\";s:24:\"node.nd_portfolio.teaser\";s:24:\"node.nd_portfolio.teaser\";s:17:\"node.page.default\";s:17:\"node.page.default\";s:16:\"node.page.teaser\";s:16:\"node.page.teaser\";s:20:\"node.webform.default\";s:20:\"node.webform.default\";s:19:\"node.webform.teaser\";s:19:\"node.webform.teaser\";s:17:\"user.user.compact\";s:17:\"user.user.compact\";s:17:\"user.user.default\";s:17:\"user.user.default\";}s:12:\"field_config\";a:30:{s:24:\"block_content.basic.body\";s:4:\"Body\";s:29:\"comment.comment.field_comment\";s:7:\"Comment\";s:27:\"comment.comment.field_email\";s:5:\"Email\";s:17:\"node.article.body\";s:4:\"Body\";s:20:\"node.article.comment\";s:8:\"Comments\";s:24:\"node.article.field_image\";s:5:\"Image\";s:23:\"node.article.field_tags\";s:4:\"Tags\";s:31:\"node.gallery_item.field_gallery\";s:7:\"Gallery\";s:29:\"node.gallery_item.field_image\";s:5:\"Image\";s:17:\"node.nd_blog.body\";s:4:\"Body\";s:32:\"node.nd_blog.field_blog_category\";s:13:\"Blog Category\";s:27:\"node.nd_blog.field_comments\";s:8:\"Comments\";s:25:\"node.nd_blog.field_images\";s:6:\"Images\";s:28:\"node.nd_blog.field_lead_text\";s:9:\"Lead Text\";s:31:\"node.nd_blog.field_second_title\";s:12:\"Second Title\";s:23:\"node.nd_blog.field_tags\";s:4:\"Tags\";s:19:\"node.nd_person.body\";s:4:\"Body\";s:26:\"node.nd_person.field_image\";s:5:\"Image\";s:29:\"node.nd_person.field_position\";s:8:\"Position\";s:33:\"node.nd_person.field_social_links\";s:12:\"Social Links\";s:22:\"node.nd_portfolio.body\";s:4:\"Body\";s:32:\"node.nd_portfolio.field_category\";s:8:\"Category\";s:35:\"node.nd_portfolio.field_description\";s:11:\"Description\";s:30:\"node.nd_portfolio.field_images\";s:6:\"Images\";s:42:\"node.nd_portfolio.field_portfolio_category\";s:18:\"Portfolio Category\";s:31:\"node.nd_portfolio.field_project\";s:7:\"Project\";s:36:\"node.nd_portfolio.field_project_link\";s:12:\"Project Link\";s:14:\"node.page.body\";s:4:\"Body\";s:17:\"node.webform.body\";s:4:\"Body\";s:22:\"user.user.user_picture\";s:7:\"Picture\";}s:20:\"field_storage_config\";a:22:{s:18:\"block_content.body\";s:18:\"block_content.body\";s:20:\"comment.comment_body\";s:20:\"comment.comment_body\";s:21:\"comment.field_comment\";s:21:\"comment.field_comment\";s:19:\"comment.field_email\";s:19:\"comment.field_email\";s:9:\"node.body\";s:9:\"node.body\";s:12:\"node.comment\";s:12:\"node.comment\";s:24:\"node.field_blog_category\";s:24:\"node.field_blog_category\";s:19:\"node.field_category\";s:19:\"node.field_category\";s:19:\"node.field_comments\";s:19:\"node.field_comments\";s:22:\"node.field_description\";s:22:\"node.field_description\";s:18:\"node.field_gallery\";s:18:\"node.field_gallery\";s:16:\"node.field_image\";s:16:\"node.field_image\";s:17:\"node.field_images\";s:17:\"node.field_images\";s:20:\"node.field_lead_text\";s:20:\"node.field_lead_text\";s:29:\"node.field_portfolio_category\";s:29:\"node.field_portfolio_category\";s:19:\"node.field_position\";s:19:\"node.field_position\";s:18:\"node.field_project\";s:18:\"node.field_project\";s:23:\"node.field_project_link\";s:23:\"node.field_project_link\";s:23:\"node.field_second_title\";s:23:\"node.field_second_title\";s:23:\"node.field_social_links\";s:23:\"node.field_social_links\";s:15:\"node.field_tags\";s:15:\"node.field_tags\";s:17:\"user.user_picture\";s:17:\"user.user_picture\";}s:11:\"image_style\";a:12:{s:14:\"blog_1140x642_\";s:15:\"Blog (1140x642)\";s:13:\"blog_360x195_\";s:14:\"Blog (360x195)\";s:15:\"gallery_165x106\";s:17:\"Gallery (165x106)\";s:16:\"gallery_263x169_\";s:17:\"Gallery (263x169)\";s:16:\"gallery_360x232_\";s:17:\"Gallery (360x232)\";s:15:\"gallery_555x357\";s:17:\"Gallery (555x357)\";s:16:\"gallery_800x533_\";s:17:\"Gallery (800x533)\";s:15:\"person_360x438_\";s:16:\"Person (360x438)\";s:18:\"portfolio_570x367_\";s:19:\"Portfolio (570x367)\";s:19:\"portfolio_650xauto_\";s:20:\"Portfolio (650xauto)\";s:18:\"portfolio_653x368_\";s:19:\"Portfolio (653x368)\";s:18:\"portfolio_952x_613\";s:19:\"Portfolio (952x613)\";}s:4:\"menu\";a:1:{s:8:\"one-page\";s:8:\"One Page\";}s:19:\"taxonomy_vocabulary\";a:6:{s:13:\"blog_category\";s:13:\"Blog Category\";s:8:\"category\";s:8:\"Category\";s:7:\"gallery\";s:7:\"Gallery\";s:18:\"portfolio_category\";s:18:\"Portfolio Category\";s:7:\"project\";s:7:\"Project\";s:4:\"tags\";s:4:\"Tags\";}s:6:\"editor\";a:3:{s:10:\"basic_html\";s:10:\"Basic HTML\";s:8:\"ckeditor\";s:8:\"CKeditor\";s:9:\"full_html\";s:9:\"Full HTML\";}s:13:\"filter_format\";a:5:{s:10:\"basic_html\";s:10:\"Basic HTML\";s:8:\"ckeditor\";s:8:\"CKeditor\";s:9:\"full_html\";s:9:\"Full HTML\";s:10:\"shortcodes\";s:10:\"Shortcodes\";s:17:\"visual_shortcodes\";s:17:\"Visual Shortcodes\";}s:4:\"view\";a:12:{s:14:\"blog_fullwidth\";s:14:\"Blog Fullwidth\";s:9:\"blog_grid\";s:9:\"Blog Grid\";s:12:\"blog_masonry\";s:12:\"Blog Masonry\";s:13:\"blog_timeline\";s:13:\"Blog TimeLine\";s:7:\"gallery\";s:7:\"Gallery\";s:15:\"portfolio_boxed\";s:9:\"Portfolio\";s:18:\"portfolio_parallax\";s:18:\"Portfolio Parallax\";s:15:\"portfolio_promo\";s:15:\"Portfolio Promo\";s:13:\"products_tags\";s:13:\"Products Tags\";s:16:\"related_projects\";s:16:\"Related Projects\";s:15:\"shop_categories\";s:15:\"Shop Categories\";s:4:\"team\";s:4:\"Team\";}s:7:\"webform\";a:3:{s:7:\"contact\";s:7:\"Contact\";s:9:\"contact_1\";s:9:\"Contact 1\";s:9:\"subscribe\";s:9:\"Subscribe\";}}s:17:\"\0*\0allowConflicts\";b:0;s:10:\"\0*\0missing\";a:0:{}s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:15:\"featuresManager\";s:16:\"features.manager\";s:8:\"assigner\";s:17:\"features_assigner\";s:9:\"generator\";s:18:\"features_generator\";s:12:\"configRevert\";s:22:\"features.config_update\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:18:\"features_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:0:{}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503957254),

('form_state','form-hWOPaH51S21tfJSMPt9wHaT0yEtJ2tdE4E4BxNDTZq8','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:1:{i:0;N;}s:5:\"files\";a:1:{s:18:\"views_ui:admin.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:8:\"views_ui\";s:4:\"name\";s:5:\"admin\";}}s:15:\"callback_object\";O:27:\"Drupal\\views_ui\\ViewAddForm\":11:{s:12:\"\0*\0displayID\";N;s:12:\"\0*\0operation\";s:3:\"add\";s:9:\"\0*\0entity\";O:24:\"Drupal\\views\\Entity\\View\":24:{s:13:\"\0*\0base_table\";s:4:\"node\";s:5:\"\0*\0id\";N;s:8:\"\0*\0label\";N;s:14:\"\0*\0description\";s:0:\"\";s:6:\"\0*\0tag\";s:0:\"\";s:7:\"\0*\0core\";s:3:\"8.x\";s:10:\"\0*\0display\";a:1:{s:7:\"default\";a:5:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:0:{}}}s:13:\"\0*\0base_field\";s:3:\"nid\";s:9:\"\0*\0module\";s:5:\"views\";s:13:\"\0*\0originalId\";N;s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"27a0280e-0f3d-4cb8-a8b2-330739e507a4\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:4:\"view\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:0:{}}s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"wizardManager\";s:27:\"plugin.manager.views.wizard\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:9:\"view_form\";s:7:\"form_id\";s:13:\"view_add_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:4:{s:23:\"entity_form_initialized\";b:1;s:4:\"view\";r:13;s:6:\"wizard\";a:7:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:6:\"wizard\";s:14:\"register_theme\";b:1;s:2:\"id\";s:8:\"standard\";s:10:\"base_table\";s:27:\"commerce_product_field_data\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:41:\"Drupal\\views\\Plugin\\views\\wizard\\Standard\";}s:15:\"wizard_instance\";O:41:\"Drupal\\views\\Plugin\\views\\wizard\\Standard\":21:{s:13:\"\0*\0base_table\";s:27:\"commerce_product_field_data\";s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:13:\"\0*\0entityType\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:10:\"product_id\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:16:\"commerce_product\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\commerce_product\\Entity\\Product\";s:11:\"\0*\0handlers\";a:11:{s:5:\"event\";s:42:\"Drupal\\commerce_product\\Event\\ProductEvent\";s:7:\"storage\";s:44:\"Drupal\\commerce\\CommerceContentEntityStorage\";s:6:\"access\";s:42:\"Drupal\\commerce\\EntityAccessControlHandler\";s:19:\"permission_provider\";s:40:\"Drupal\\commerce\\EntityPermissionProvider\";s:12:\"view_builder\";s:42:\"Drupal\\commerce_product\\ProductViewBuilder\";s:12:\"list_builder\";s:42:\"Drupal\\commerce_product\\ProductListBuilder\";s:10:\"views_data\";s:28:\"Drupal\\views\\EntityViewsData\";s:4:\"form\";a:4:{s:7:\"default\";s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";s:3:\"add\";s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";s:4:\"edit\";s:40:\"Drupal\\commerce_product\\Form\\ProductForm\";s:6:\"delete\";s:42:\"Drupal\\Core\\Entity\\ContentEntityDeleteForm\";}s:14:\"route_provider\";a:2:{s:7:\"default\";s:49:\"Drupal\\Core\\Entity\\Routing\\AdminHtmlRouteProvider\";s:15:\"delete-multiple\";s:49:\"Drupal\\entity\\Routing\\DeleteMultipleRouteProvider\";}s:11:\"translation\";s:49:\"Drupal\\commerce_product\\ProductTranslationHandler\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";s:27:\"administer commerce_product\";s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:11:{s:9:\"canonical\";s:27:\"/product/{commerce_product}\";s:8:\"add-page\";s:12:\"/product/add\";s:8:\"add-form\";s:36:\"/product/add/{commerce_product_type}\";s:9:\"edit-form\";s:32:\"/product/{commerce_product}/edit\";s:11:\"delete-form\";s:34:\"/product/{commerce_product}/delete\";s:20:\"delete-multiple-form\";s:31:\"/admin/commerce/products/delete\";s:10:\"collection\";s:24:\"/admin/commerce/products\";s:10:\"devel-load\";s:42:\"/devel/commerce_product/{commerce_product}\";s:12:\"devel-render\";s:49:\"/devel/commerce_product/{commerce_product}/render\";s:16:\"devel-definition\";s:53:\"/devel/commerce_product/{commerce_product}/definition\";s:11:\"token-devel\";s:39:\"/product/{commerce_product}/devel/token\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:21:\"commerce_product_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Product type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:16:\"commerce_product\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:27:\"commerce_product_field_data\";s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Products\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"products\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:14:\"@count product\";s:6:\"plural\";s:15:\"@count products\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:38:\"entity.commerce_product_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"commerce_product_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:2:{s:9:\"fieldable\";b:1;s:10:\"token_type\";s:16:\"commerce_product\";}s:8:\"\0*\0class\";s:38:\"Drupal\\commerce_product\\Entity\\Product\";s:11:\"\0*\0provider\";s:16:\"commerce_product\";s:20:\"\0*\0stringTranslation\";N;}s:18:\"\0*\0validated_views\";a:1:{s:64:\"029b117f2f411cc96a1ba5269fdc7da72cad5a47c905c6038b493a5ab632dff3\";O:22:\"Drupal\\views_ui\\ViewUI\":14:{s:7:\"editing\";b:0;s:15:\"changed_display\";N;s:11:\"render_time\";N;s:4:\"lock\";N;s:7:\"changed\";N;s:17:\"temporary_options\";N;s:5:\"stack\";N;s:12:\"live_preview\";N;s:13:\"renderPreview\";b:0;s:10:\"\0*\0storage\";O:24:\"Drupal\\views\\Entity\\View\":24:{s:13:\"\0*\0base_table\";s:27:\"commerce_product_field_data\";s:5:\"\0*\0id\";s:7:\"archive\";s:8:\"\0*\0label\";s:7:\"Archive\";s:14:\"\0*\0description\";s:0:\"\";s:6:\"\0*\0tag\";s:0:\"\";s:7:\"\0*\0core\";s:3:\"8.x\";s:10:\"\0*\0display\";a:2:{s:7:\"default\";a:5:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:16:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Apply\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Reset\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"exposed_sorts_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Sort by\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Asc\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"sort_desc_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Desc\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";s:2:\"10\";s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";s:0:\"\";s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Items per page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"- All -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"offset\";b:0;s:12:\"offset_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Offset\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:4:\"tags\";a:4:{s:8:\"previous\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"‹ Previous\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"next\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Next ›\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"first\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"« First\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"last\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Last »\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:8:\"quantity\";i:9;}}s:5:\"style\";a:1:{s:4:\"type\";s:9:\"html_list\";}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:1:{s:5:\"title\";a:37:{s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:5:\"title\";s:2:\"id\";s:5:\"title\";s:11:\"entity_type\";N;s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;}}s:7:\"filters\";a:1:{s:4:\"type\";a:7:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:27:\"commerce_product_field_data\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:15:\"product_display\";s:15:\"product_display\";}s:11:\"entity_type\";s:16:\"commerce_product\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:22:\"commerce_entity_bundle\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:15:\"Monthly archive\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}}}s:7:\"block_1\";a:5:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}}}s:13:\"\0*\0base_field\";s:3:\"nid\";s:9:\"\0*\0module\";s:5:\"views\";s:13:\"\0*\0originalId\";s:7:\"archive\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"e7e3de6b-8e20-4061-bb5c-4505c1734beb\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:4:\"view\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:0:{}}s:20:\"\0*\0additionalQueries\";N;s:33:\"\0Drupal\\views_ui\\ViewUI\0isSyncing\";b:0;s:38:\"\0Drupal\\views_ui\\ViewUI\0isUninstalling\";b:0;s:10:\"entityType\";s:4:\"view\";}}s:16:\"\0*\0createdColumn\";N;s:10:\"\0*\0filters\";a:0:{}s:8:\"\0*\0sorts\";a:0:{}s:17:\"\0*\0availableSorts\";a:0:{}s:18:\"\0*\0filter_defaults\";a:3:{s:2:\"id\";N;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:7:\"options\";a:0:{}s:4:\"view\";N;s:14:\"displayHandler\";N;s:10:\"definition\";a:7:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:6:\"wizard\";s:14:\"register_theme\";b:1;s:2:\"id\";s:8:\"standard\";s:10:\"base_table\";s:27:\"commerce_product_field_data\";s:5:\"title\";r:73;s:5:\"class\";s:41:\"Drupal\\views\\Plugin\\views\\wizard\\Standard\";}s:14:\"\0*\0usesOptions\";b:0;s:11:\"\0*\0renderer\";N;s:11:\"\0*\0pluginId\";s:36:\"standard:commerce_product_field_data\";s:19:\"\0*\0pluginDefinition\";a:7:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:6:\"wizard\";s:14:\"register_theme\";b:1;s:2:\"id\";s:8:\"standard\";s:10:\"base_table\";s:27:\"commerce_product_field_data\";s:5:\"title\";r:73;s:5:\"class\";s:41:\"Drupal\\views\\Plugin\\views\\wizard\\Standard\";}s:16:\"\0*\0configuration\";a:0:{}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"bundleInfoService\";s:23:\"entity_type.bundle.info\";}s:15:\"\0*\0urlGenerator\";N;}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503591560),

('form_state','form-In8xcbtCc4U29dHh20Mpl4_L_Ngyj5N6_FSuhA6iUGE','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503325874\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:7:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:2:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}s:10:\"variations\";a:1:{s:4:\"form\";a:1:{s:18:\"inline_entity_form\";a:1:{s:8:\"entities\";a:1:{i:0;a:1:{s:4:\"form\";a:1:{s:7:\"#fields\";a:14:{s:15:\"attribute_color\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"attribute_color\";i:7;s:6:\"widget\";}}s:14:\"attribute_size\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:14:\"attribute_size\";i:7;s:6:\"widget\";}}s:17:\"field_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:17:\"field_description\";i:7;s:6:\"widget\";}}s:12:\"field_images\";a:2:{s:11:\"items_count\";i:4;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_images\";i:7;s:6:\"widget\";}}s:12:\"field_length\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_length\";i:7;s:6:\"widget\";}}s:15:\"field_old_price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_old_price\";i:7;s:6:\"widget\";}}s:28:\"field_right_side_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:28:\"field_right_side_description\";i:7;s:6:\"widget\";}}s:15:\"field_sale_text\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_sale_text\";i:7;s:6:\"widget\";}}s:23:\"field_short_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:23:\"field_short_description\";i:7;s:6:\"widget\";}}s:11:\"field_waist\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_waist\";i:7;s:6:\"widget\";}}s:5:\"price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"price\";i:7;s:6:\"widget\";}}s:3:\"sku\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:3:\"sku\";i:7;s:6:\"widget\";}}s:6:\"status\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:6:\"status\";i:7;s:6:\"widget\";}}s:5:\"title\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"title\";i:7;s:6:\"widget\";}}}}}}}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325829\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"12\";}}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"22\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:1001:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:21:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:38:\"Religion Jersey Polo Shirts - White, L\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"13\";}}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"21\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:38:\"Religion Jersey Polo Shirts - White, L\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}}}}s:21:\"entity_browser_widget\";a:1:{s:49:\"534712e5-05cc-42b8-a371-bb7af482f33f:field_images\";a:4:{i:0;s:2:\"62\";i:1;s:2:\"63\";i:2;s:2:\"64\";i:3;s:2:\"65\";}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503421596),

('form_state','form-Islec8tmqEZ9Y79zLDu5UD0XsP_zESnvLDRx8rrCAQ8','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"2\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"7f537ff0-30a0-477c-a55f-a3bf836a1c10\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"und\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:30:\"Polo Shirt With Floral Sleeves\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503052396\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302494\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"2\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"2\";s:4:\"uuid\";s:36:\"7f537ff0-30a0-477c-a55f-a3bf836a1c10\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:30:\"Polo Shirt With Floral Sleeves\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:3:\"und\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:1:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:21:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"2\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"fd167796-b7c9-47bb-876a-2f13f6ebc9c8\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"2\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"3159\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:30:\"Polo Shirt With Floral Sleeves\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"85.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503052598\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302494\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:1:{i:0;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"2\";s:4:\"uuid\";s:36:\"fd167796-b7c9-47bb-876a-2f13f6ebc9c8\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:30:\"Polo Shirt With Floral Sleeves\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";i:0;s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503324157),

('form_state','form-iVuQ3x0T9DbG5uzNUizYb7P6L9hKje-Xyk33OLl0X2o','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityFormDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"form\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"7ead05bb-48d9-4c0d-8503-3978179228c2\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:13:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:35:\"entity_browser.browser.browse_files\";i:2;s:67:\"field.field.commerce_product_variation.product.attribute_parameters\";i:3;s:58:\"field.field.commerce_product_variation.product.field_color\";i:4;s:64:\"field.field.commerce_product_variation.product.field_description\";i:5;s:59:\"field.field.commerce_product_variation.product.field_images\";i:6;s:59:\"field.field.commerce_product_variation.product.field_length\";i:7;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:8;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:9;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:10;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:11;s:57:\"field.field.commerce_product_variation.product.field_size\";i:12;s:58:\"field.field.commerce_product_variation.product.field_waist\";}s:6:\"module\";a:5:{i:0;s:14:\"commerce_price\";i:1;s:14:\"entity_browser\";i:2;s:11:\"field_group\";i:3;s:18:\"inline_entity_form\";i:4;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:11:\"field_group\";a:1:{s:16:\"group_properties\";a:6:{s:8:\"children\";a:4:{i:0;s:10:\"field_size\";i:1;s:11:\"field_color\";i:2;s:11:\"field_waist\";i:3;s:12:\"field_length\";}s:11:\"parent_name\";s:0:\"\";s:6:\"weight\";i:6;s:11:\"format_type\";s:7:\"details\";s:15:\"format_settings\";a:4:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:4:\"open\";b:1;s:15:\"required_fields\";b:1;}s:5:\"label\";s:10:\"Properties\";}}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:15:{s:20:\"attribute_parameters\";a:5:{s:4:\"type\";s:25:\"inline_entity_form_simple\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:4:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:3:\"Aaa\";s:12:\"label_plural\";s:3:\"Bbb\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:11:\"field_color\";a:5:{s:6:\"weight\";s:2:\"22\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:5:{s:6:\"weight\";s:1:\"9\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:5:{s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:7:{s:14:\"entity_browser\";s:12:\"browse_files\";s:19:\"field_widget_remove\";b:1;s:14:\"selection_mode\";s:16:\"selection_append\";s:19:\"preview_image_style\";s:9:\"thumbnail\";s:17:\"field_widget_edit\";b:1;s:4:\"open\";b:0;s:9:\"view_mode\";s:7:\"default\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:19:\"entity_browser_file\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:5:{s:6:\"weight\";s:2:\"24\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:5:{s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:5:{s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:13:\"text_textarea\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:5:{s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:5:{s:6:\"weight\";s:1:\"8\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"string_textarea\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:5:{s:6:\"weight\";s:2:\"21\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:5:{s:6:\"weight\";s:2:\"23\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:5:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:3:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:27:\"plugin.manager.field.widget\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_form_display_form\";s:7:\"form_id\";s:29:\"entity_form_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:4:{s:23:\"entity_form_initialized\";b:1;s:11:\"field_group\";a:1:{s:16:\"group_properties\";O:8:\"stdClass\":11:{s:8:\"children\";a:4:{i:0;s:10:\"field_size\";i:1;s:11:\"field_color\";i:2;s:11:\"field_waist\";i:3;s:12:\"field_length\";}s:11:\"parent_name\";s:0:\"\";s:6:\"weight\";i:6;s:11:\"format_type\";s:7:\"details\";s:15:\"format_settings\";a:4:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:4:\"open\";b:1;s:15:\"required_fields\";b:1;}s:5:\"label\";s:10:\"Properties\";s:10:\"group_name\";s:16:\"group_properties\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:7:\"context\";s:4:\"form\";s:4:\"mode\";s:7:\"default\";}}s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"form\";s:6:\"groups\";a:1:{s:16:\"group_properties\";O:8:\"stdClass\":11:{s:8:\"children\";a:4:{i:0;s:10:\"field_size\";i:1;s:11:\"field_color\";i:2;s:11:\"field_waist\";i:3;s:12:\"field_length\";}s:11:\"parent_name\";s:0:\"\";s:6:\"weight\";i:6;s:11:\"format_type\";s:7:\"details\";s:15:\"format_settings\";a:4:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:4:\"open\";b:1;s:15:\"required_fields\";b:1;}s:5:\"label\";s:10:\"Properties\";s:10:\"group_name\";s:16:\"group_properties\";s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:7:\"context\";s:4:\"form\";s:4:\"mode\";s:7:\"default\";}}s:7:\"parents\";a:4:{s:10:\"field_size\";s:16:\"group_properties\";s:11:\"field_color\";s:16:\"group_properties\";s:11:\"field_waist\";s:16:\"group_properties\";s:12:\"field_length\";s:16:\"group_properties\";}}s:20:\"plugin_settings_edit\";s:20:\"attribute_parameters\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503344522),

('form_state','form-J6nePn_eHT3SLJD-Qeq8eORGSogks1aKVTut3mCIB1U','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";N;s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503345123),

('form_state','form-KIpsGYH4QJwwrj5A3uAGXkYPv9c28yHF1aYyndZz7oY','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"2b01ff10-2a4f-4cae-b5cd-fd5beb2241e3\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503408191;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503408191;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503429826),

('form_state','form-KjrcVC_hI-oiLiByZq_BF-xkX1Av2l3HtB0U1pZGjoo','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053967\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:19:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:43:\"Religion Jersey Polo Shirts - Medium, White\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:1001:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:43:\"Religion Jersey Polo Shirts - Medium, White\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:17:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:42:\"Religion Jersey Polo Shirts - Large, Green\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:42:\"Religion Jersey Polo Shirts - Large, Green\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";N;s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503323579),

('form_state','form-KPGWS6ijS5dNBRWMbt7RpzF-5YCnX8cDdqi1M9dgOhg','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"f9e02418-e17e-45f5-bf06-29885d8dc0e9\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503326916;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503326916;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503348521),

('form_state','form-lHycbVzke8HCaJRfq-WEQLIqBd-eRCMD3toA3NmXhrA','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"d391351c-318a-490b-a690-c7a0a4fe6647\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407115;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407115;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503428747),

('form_state','form-Lzu0q9PjSP34OVR-L_9VaQ90nfD-Ipb-1Nz6C37V8Ew','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"077945ba-7224-4d67-844d-50cb18187e48\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503410403;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503410403;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503432181),

('form_state','form-MHyF_N6w2x7Jk_vyjjcuddGTWhYSPHo6-NDqMaD8Mew','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"a21119d6-9f1e-49ef-b388-b329138bc07f\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414338;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414338;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503435938),

('form_state','form-MMZq3QHcrBRNg7ZO7hpRCgilSXjs84-3OT17KIonsQs','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"073ce064-c8d5-4df5-bcc6-549db3e723b8\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503416171;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503416171;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503437771),

('form_state','form-muogwBGxIAJIlD8fdRxJQBT2_WZaH2GYD3WnOq9x1Go','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"ba1d7409-a51b-4fa9-8724-8d6dd5700bdd\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407265;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407265;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503428865),

('form_state','form-nkielTvksvis4pWlLPz-flitiRIj0w5hONNfGieqRhc','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"bc5d6188-cefe-4350-a39e-4005f7f36258\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:12:{i:0;s:56:\"commerce_product.commerce_product_variation_type.product\";i:1;s:58:\"field.field.commerce_product_variation.product.field_color\";i:2;s:64:\"field.field.commerce_product_variation.product.field_description\";i:3;s:59:\"field.field.commerce_product_variation.product.field_images\";i:4;s:59:\"field.field.commerce_product_variation.product.field_length\";i:5;s:62:\"field.field.commerce_product_variation.product.field_old_price\";i:6;s:75:\"field.field.commerce_product_variation.product.field_right_side_description\";i:7;s:62:\"field.field.commerce_product_variation.product.field_sale_text\";i:8;s:70:\"field.field.commerce_product_variation.product.field_short_description\";i:9;s:57:\"field.field.commerce_product_variation.product.field_size\";i:10;s:58:\"field.field.commerce_product_variation.product.field_waist\";i:11;s:32:\"image.style.product_main_360x459\";}s:6:\"module\";a:4:{i:0;s:14:\"commerce_price\";i:1;s:28:\"commerce_variation_cart_form\";i:2;s:10:\"rhythm_cms\";i:3;s:4:\"text\";}}s:23:\"\0*\0third_party_settings\";a:1:{s:28:\"commerce_variation_cart_form\";a:1:{s:7:\"combine\";s:1:\"1\";}}s:5:\"\0*\0id\";s:42:\"commerce_product_variation.product.default\";s:19:\"\0*\0targetEntityType\";s:26:\"commerce_product_variation\";s:9:\"\0*\0bundle\";s:7:\"product\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:14:{s:28:\"commerce_variation_cart_form\";a:4:{s:6:\"weight\";s:2:\"13\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:11:\"field_color\";a:6:{s:6:\"weight\";s:2:\"10\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:17:\"field_description\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:12:\"field_images\";a:6:{s:6:\"weight\";s:1:\"2\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:5:{s:11:\"image_style\";s:20:\"product_main_360x459\";s:17:\"image_style_small\";s:19:\"product_small_68x86\";s:3:\"col\";s:1:\"3\";s:4:\"zoom\";i:0;s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:26:\"rhythm_cms_images_one_main\";s:6:\"region\";s:7:\"content\";}s:12:\"field_length\";a:6:{s:6:\"weight\";s:2:\"12\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:15:\"field_old_price\";a:6:{s:6:\"weight\";s:1:\"7\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"region\";s:7:\"content\";}s:28:\"field_right_side_description\";a:6:{s:6:\"weight\";s:1:\"5\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"text_default\";s:6:\"region\";s:7:\"content\";}s:15:\"field_sale_text\";a:6:{s:6:\"weight\";s:1:\"6\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:23:\"field_short_description\";a:6:{s:6:\"weight\";s:1:\"8\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:12:\"basic_string\";s:6:\"region\";s:7:\"content\";}s:10:\"field_size\";a:6:{s:6:\"weight\";s:1:\"9\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:11:\"field_waist\";a:6:{s:6:\"weight\";s:2:\"11\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:5:\"price\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:3:\"sku\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"3\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:2:{s:8:\"langcode\";b:1;s:10:\"product_id\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:20:\"third_party_settings\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:7:\"product\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";s:12:\"field_images\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503337847),

('form_state','form-OhgjwZRZJS3kQ4iu4mNZ45d1Pzqu9KBukcqvYwa1lfw','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"81be815f-615a-4298-b9fd-031cc71c5a35\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414533;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414533;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503436133),

('form_state','form-O_oyFE-AW0LB-gmLhcCjFbIjKAD5-npKMp8ejZIzwL4','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"und\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"G-Star Polo Applique Jersey\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053273\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302373\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"39\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"3\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:3:\"und\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:1:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"3158\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"94.750000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053515\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302373\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:2:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:10:\"150.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";i:0;s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503324160),

('form_state','form-p3OLmma77IvF7RmdWMVNB2ZK-pbr5_1pYCgENLJFhkI','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"87c0b7fc-e929-454e-b2b6-21e00cf72d25\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503428650;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503428650;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:7:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503450250),

('form_state','form-PF6kb4UnGi34hyuJKwEuoftn-8m_6NreAq5RMxOsX_E','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"80c08c4a-41ca-423e-9e41-89aed06be9af\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503429911;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503429911;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:7:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503451536),

('form_state','form-Phz3-STw6NpkNP0gUmy9jpaF8YBmJ7DY9xNKRd25-Ro','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"09d511c6-2622-4997-b678-90c8ff763aed\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"core.entity_view_display.comment.default_reviews.default\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:3:{i:0;s:7:\"comment\";i:1;s:16:\"commerce_product\";i:2;s:8:\"fivestar\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:6:{s:14:\"field_category\";a:6:{s:6:\"weight\";s:1:\"2\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:12:\"field_rating\";a:6:{s:6:\"weight\";s:1:\"0\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:15:\"fivestar_widget\";s:40:\"modules/fivestar/widgets/basic/basic.css\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"fivestar_stars\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:6:{s:6:\"weight\";s:1:\"4\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:6:{s:6:\"weight\";s:1:\"3\";s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";s:1:\"1\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:4:{s:7:\"created\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";s:10:\"variations\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503430973),

('form_state','form-PO-4hopQvJB9CvCxzO-ILZpLS1ziMyIvoan0Jfndq7c','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";N;s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503344505),

('form_state','form-qqPaEnsPW0kgTuxC8u798VNxYCpJw3IAG6bveF8uXL8','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"43b84ecb-47cf-41a8-8420-15d0d06cd447\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503429554;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503429554;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:7:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503451181),

('form_state','form-Qx7gOrLMaFt65VWU7HLmMHEVfLV3tAjpTrzb-If7fHA','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"7de32e1e-3f57-4da8-b2a1-a769d44d3d9c\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503408325;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503408325;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503429930),

('form_state','form-rlHzZnbIBnmfOeqkQZ9mQBx51p7CX-iOWcB8HPtmYLY','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"aa8dfd0d-f40c-4500-807a-6df68899a272\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407450;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407450;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503429059),

('form_state','form-RuLxIh4ypDcYFYjRNhMxIgeXHi722x2CPUSizlORj_U','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"0375e9bb-77f4-47c9-8c26-11850601320c\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:43:\"Religion Jersey Polo Shirts - Medium, White\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503054019;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503054019;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:15:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503075641),

('form_state','form-T4cUFEVkYlxvvkMJOnl-c2kkLi0woJ8lgwUVbM6dtz4','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:3:\"und\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"G-Star Polo Applique Jersey\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053273\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503317128\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"39\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"3\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"3237b124-e433-4715-a727-90ba893091a2\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:3:\"und\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:1:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"3158\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"94.750000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053515\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503317128\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"66\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"240\";s:6:\"height\";s:3:\"320\";}i:3;a:5:{s:9:\"target_id\";s:2:\"67\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"240\";s:6:\"height\";s:3:\"320\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:10:\"150.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"Sale\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:0:{}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"fbdf1734-88ca-4428-9cd6-b49bfd16ac77\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"G-Star Polo Applique Jersey\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";i:0;s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503455035),

('form_state','form-TlOSv391S-nCLrhbG4ibS_QnP30bE3nvly8WfmLYpr4','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:1:{i:0;O:27:\"Drupal\\editor\\Entity\\Editor\":20:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:9:\"\0*\0editor\";s:8:\"ckeditor\";s:11:\"\0*\0settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:5:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:2:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";}}i:1;a:2:{s:4:\"name\";s:5:\"Links\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:2:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";}}i:4;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:1:{i:0;s:6:\"Source\";}}}}}s:7:\"plugins\";a:2:{s:8:\"language\";a:1:{s:13:\"language_list\";s:2:\"un\";}s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:15:\"\0*\0image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";N;s:6:\"height\";N;}}s:15:\"\0*\0filterFormat\";O:33:\"Drupal\\filter\\Entity\\FilterFormat\":21:{s:9:\"\0*\0format\";s:8:\"ckeditor\";s:7:\"\0*\0name\";s:8:\"CKeditor\";s:9:\"\0*\0weight\";i:-9;s:8:\"\0*\0roles\";N;s:10:\"\0*\0filters\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:19:\"\0*\0filterCollection\";O:36:\"Drupal\\filter\\FilterPluginCollection\":7:{s:14:\"\0*\0definitions\";a:13:{s:21:\"editor_file_reference\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:84:\"Ensures that the latest versions of images uploaded via a Text Editor are displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Track images uploaded via a Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:12:\"entity_embed\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Embeds entities using data attributes: data-entity-type, data-entity-uuid, and data-view-mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Display embedded entities\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:12:\"filter_align\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:90:\"Uses a <code>data-align</code> attribute on <code>&lt;img&gt;</code> tags to align images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_align\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Align images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAlign\";s:8:\"provider\";s:6:\"filter\";}s:12:\"filter_autop\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"filter_autop\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:87:\"Convert line breaks into HTML (i.e. <code>&lt;br&gt;</code> and <code>&lt;p&gt;</code>)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:39:\"Drupal\\filter\\Plugin\\Filter\\FilterAutoP\";s:8:\"provider\";s:6:\"filter\";}s:14:\"filter_caption\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"Uses a <code>data-caption</code> attribute on <code>&lt;img&gt;</code> tags to caption images.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:14:\"filter_caption\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Caption images\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:2;s:5:\"class\";s:41:\"Drupal\\filter\\Plugin\\Filter\\FilterCaption\";s:8:\"provider\";s:6:\"filter\";}s:11:\"filter_html\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Limit allowed HTML tags and correct faulty HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"filter_htmlcorrector\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:20:\"filter_htmlcorrector\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Correct faulty and chopped off HTML\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:47:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlCorrector\";s:8:\"provider\";s:6:\"filter\";}s:18:\"filter_html_escape\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:18:\"filter_html_escape\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Display any HTML as plain text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:1;s:5:\"class\";s:44:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlEscape\";s:8:\"provider\";s:6:\"filter\";}s:24:\"filter_html_image_secure\";a:9:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:119:\"Disallows usage of &lt;img&gt; tag sources that are not hosted on this site by replacing them with a placeholder image.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Restrict images to this site\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:10:\"filter_url\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}s:2:\"id\";s:10:\"filter_url\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Convert URLs into links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:37:\"Drupal\\filter\\Plugin\\Filter\\FilterUrl\";s:8:\"provider\";s:6:\"filter\";}s:17:\"dynamicshortcodes\";a:11:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Shortcodes which shouldn\'t be cached.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:17:\"dynamicshortcodes\";s:6:\"module\";s:19:\"nd_visualshortcodes\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Dynamic Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"cache\";b:0;s:5:\"class\";s:58:\"Drupal\\nd_visualshortcodes\\Plugin\\Filter\\Dynamicshortcodes\";s:8:\"provider\";s:19:\"nd_visualshortcodes\";}s:9:\"shortcode\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides WP like shortcodes to text formats.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:19:\"shortcode_corrector\";a:10:{s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"Trying to correct the html around shortcodes. Enable only if you using wysiwyg editor.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:19:\"shortcode_corrector\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Shortcodes - html corrector\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";i:0;s:5:\"class\";s:49:\"Drupal\\shortcode\\Plugin\\Filter\\ShortcodeCorrector\";s:8:\"provider\";s:9:\"shortcode\";}}s:17:\"\0*\0configurations\";a:5:{s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:12:\"entity_embed\";a:5:{s:2:\"id\";s:12:\"entity_embed\";s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:9:\"shortcode\";a:5:{s:2:\"id\";s:9:\"shortcode\";s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}}s:12:\"\0*\0pluginKey\";s:2:\"id\";s:16:\"\0*\0originalOrder\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";}s:18:\"\0*\0pluginInstances\";a:5:{s:21:\"editor_file_reference\";O:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\":9:{s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:21:\"editor_file_reference\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:99;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:21:\"editor_file_reference\";s:5:\"title\";r:107;s:4:\"type\";i:2;s:5:\"class\";s:47:\"Drupal\\editor\\Plugin\\Filter\\EditorFileReference\";s:8:\"provider\";s:6:\"editor\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:13:\"entityManager\";s:14:\"entity.manager\";}}s:12:\"entity_embed\";O:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\":9:{s:8:\"provider\";s:12:\"entity_embed\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:12:\"entity_embed\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:115;s:6:\"weight\";i:0;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:12:\"entity_embed\";s:5:\"title\";r:123;s:4:\"type\";i:2;s:5:\"class\";s:51:\"Drupal\\entity_embed\\Plugin\\Filter\\EntityEmbedFilter\";s:8:\"provider\";s:12:\"entity_embed\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:3:{s:8:\"renderer\";s:8:\"renderer\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:7:\"builder\";s:20:\"entity_embed.builder\";}}s:11:\"filter_html\";O:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\":10:{s:15:\"\0*\0restrictions\";N;s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:11:\"\0*\0pluginId\";s:11:\"filter_html\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:166:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type=\'1 A I\'> <li> <dl> <dt> <dd> <h2 id=\'jump-*\'> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:6:\"status\";b:0;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:197:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <img src alt data-entity-type data-entity-uuid>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}s:2:\"id\";s:11:\"filter_html\";s:5:\"title\";r:184;s:4:\"type\";i:1;s:5:\"class\";s:38:\"Drupal\\filter\\Plugin\\Filter\\FilterHtml\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:24:\"filter_html_image_secure\";O:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\":9:{s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:11:\"\0*\0pluginId\";s:24:\"filter_html_image_secure\";s:19:\"\0*\0pluginDefinition\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:16:\"\0*\0configuration\";a:9:{s:11:\"description\";r:218;s:6:\"weight\";i:9;s:6:\"status\";b:1;s:8:\"settings\";a:0:{}s:2:\"id\";s:24:\"filter_html_image_secure\";s:5:\"title\";r:226;s:4:\"type\";i:3;s:5:\"class\";s:49:\"Drupal\\filter\\Plugin\\Filter\\FilterHtmlImageSecure\";s:8:\"provider\";s:6:\"filter\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"shortcode\";O:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\":9:{s:8:\"provider\";s:9:\"shortcode\";s:6:\"status\";b:0;s:6:\"weight\";i:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:11:\"\0*\0pluginId\";s:9:\"shortcode\";s:19:\"\0*\0pluginDefinition\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:0:{}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:16:\"\0*\0configuration\";a:10:{s:11:\"description\";r:266;s:6:\"weight\";i:0;s:6:\"status\";b:0;s:8:\"settings\";a:9:{s:6:\"button\";s:1:\"1\";s:5:\"clear\";s:1:\"1\";s:7:\"dropcap\";s:1:\"1\";s:9:\"highlight\";s:1:\"1\";s:3:\"img\";s:1:\"1\";s:4:\"item\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"quote\";s:1:\"1\";s:6:\"random\";s:1:\"1\";}s:2:\"id\";s:9:\"shortcode\";s:6:\"module\";s:9:\"shortcode\";s:5:\"title\";r:275;s:4:\"type\";i:0;s:5:\"class\";s:40:\"Drupal\\shortcode\\Plugin\\Filter\\Shortcode\";s:8:\"provider\";s:9:\"shortcode\";}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:0:{}}}s:14:\"\0*\0instanceIDs\";a:5:{s:21:\"editor_file_reference\";s:21:\"editor_file_reference\";s:12:\"entity_embed\";s:12:\"entity_embed\";s:24:\"filter_html_image_secure\";s:24:\"filter_html_image_secure\";s:11:\"filter_html\";s:11:\"filter_html\";s:9:\"shortcode\";s:9:\"shortcode\";}s:14:\"\0*\0_serviceIds\";a:1:{s:7:\"manager\";s:21:\"plugin.manager.filter\";}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"24aa033e-b666-403d-bb7c-d4bb14e01318\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:13:\"filter_format\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:6:\"editor\";i:1;s:12:\"entity_embed\";i:2;s:9:\"shortcode\";}}}s:13:\"\0*\0originalId\";s:8:\"ckeditor\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"af9b5cee-8d4c-4a99-bb39-42fe2ce351d5\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:6:\"editor\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:1:{s:19:\"editorPluginManager\";s:21:\"plugin.manager.editor\";}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:22:\"filter.format.ckeditor\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}}}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:36:\"Drupal\\editor\\Form\\EditorImageDialog\":9:{s:14:\"\0*\0fileStorage\";O:23:\"Drupal\\file\\FileStorage\":18:{s:15:\"\0*\0tableMapping\";N;s:14:\"\0*\0revisionKey\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";b:0;s:12:\"\0*\0baseTable\";s:12:\"file_managed\";s:16:\"\0*\0revisionTable\";N;s:12:\"\0*\0dataTable\";N;s:20:\"\0*\0revisionDataTable\";N;s:16:\"\0*\0storageSchema\";N;s:12:\"\0*\0bundleKey\";s:0:\"\";s:11:\"\0*\0entities\";a:0:{}s:15:\"\0*\0entityTypeId\";s:4:\"file\";s:13:\"\0*\0entityType\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":37:{s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";}s:5:\"\0*\0id\";s:4:\"file\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0handlers\";a:6:{s:7:\"storage\";s:23:\"Drupal\\file\\FileStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\file\\FileStorageSchema\";s:6:\"access\";s:36:\"Drupal\\file\\FileAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\file\\FileViewsData\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:11:\"inline_form\";s:48:\"\\Drupal\\inline_entity_form\\Form\\EntityInlineForm\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"file_managed\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"file_list\";}s:14:\"\0*\0constraints\";a:1:{s:13:\"EntityChanged\";N;}s:13:\"\0*\0additional\";a:1:{s:10:\"token_type\";s:4:\"file\";}s:8:\"\0*\0class\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0provider\";s:4:\"file\";s:20:\"\0*\0stringTranslation\";N;}s:8:\"\0*\0idKey\";s:3:\"fid\";s:10:\"\0*\0uuidKey\";s:4:\"uuid\";s:14:\"\0*\0uuidService\";N;s:14:\"\0*\0entityClass\";s:23:\"Drupal\\file\\Entity\\File\";s:14:\"\0*\0_serviceIds\";a:6:{s:8:\"database\";s:8:\"database\";s:15:\"languageManager\";s:16:\"language_manager\";s:13:\"entityManager\";s:14:\"entity.manager\";s:12:\"cacheBackend\";s:12:\"cache.entity\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:19:\"editor_image_dialog\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:0;s:16:\"has_file_element\";b:1;s:7:\"storage\";a:1:{s:13:\"image_element\";a:4:{s:3:\"src\";s:80:\"http://local.rhythm.nikadevs.com/sites/rhythm.nikadevs.com/files/user-avatar.png\";s:3:\"alt\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503590933),

('form_state','form-TSHweCSqeRY1vB8UXIelp3gn49cadqujBysT4JHrlbU','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"c2441a30-55f4-42dd-b406-a54d7191071f\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503406876;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503406876;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503428499),

('form_state','form-tXqAWiXuv_QdiUMFFVb-DWNzjM6kW0VdIH_iHbYg6fE','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"a085ae3e-705f-4ec4-9e86-39e75a9551f3\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414249;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414249;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503435849),

('form_state','form-uaCg2oF2aqfUR_s_-KTXcwYOji4gf-vwC9dheZF9dQ8','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:46:\"Drupal\\commerce_checkout\\Form\\CheckoutFlowForm\":9:{s:12:\"\0*\0operation\";s:4:\"edit\";s:9:\"\0*\0entity\";O:44:\"Drupal\\commerce_checkout\\Entity\\CheckoutFlow\":23:{s:5:\"\0*\0id\";s:7:\"default\";s:8:\"\0*\0label\";s:7:\"Default\";s:9:\"\0*\0plugin\";s:17:\"multistep_default\";s:16:\"\0*\0configuration\";a:2:{s:25:\"display_checkout_progress\";b:1;s:5:\"panes\";a:6:{s:5:\"login\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:19:\"contact_information\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:19:\"billing_information\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:2;}s:6:\"review\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:18:\"completion_message\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:13:\"order_summary\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}}}s:13:\"\0*\0originalId\";s:7:\"default\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"e7bf6f91-1296-40c6-972a-21d0afb97b61\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wwkDVBiXUqSzRifJbb71ajFBklJdNJ_DgS67IF-_qgY\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:22:\"commerce_checkout_flow\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:0:{}s:7:\"actions\";a:1:{s:6:\"submit\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Save\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:13:\"form_build_id\";s:48:\"form-Kmt3G_sJtQzeeMQHu_cRTf6QSmcFKx1yCapQd_qzZkg\";s:10:\"form_token\";s:43:\"4YgDqmbj0KnPfvUiBJImG98N4UsQ-TiJTt0_ZgwaZHQ\";s:7:\"form_id\";s:32:\"commerce_checkout_flow_edit_form\";}s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:37:\"plugin.manager.commerce_checkout_flow\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:27:\"commerce_checkout_flow_form\";s:7:\"form_id\";s:32:\"commerce_checkout_flow_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:5:\"panes\";a:7:{s:5:\"login\";O:59:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Login\":7:{s:11:\"\0*\0clientIp\";s:9:\"127.0.0.1\";s:15:\"\0*\0checkoutFlow\";O:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\":7:{s:8:\"\0*\0panes\";a:7:{s:5:\"login\";r:84;s:19:\"contact_information\";O:72:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\ContactInformation\":6:{s:15:\"\0*\0checkoutFlow\";r:86;s:8:\"\0*\0order\";N;s:11:\"\0*\0pluginId\";s:19:\"contact_information\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:19:\"contact_information\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Contact information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:95;s:12:\"default_step\";s:17:\"order_information\";s:15:\"wrapper_element\";s:8:\"fieldset\";s:5:\"class\";s:72:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\ContactInformation\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:14:\"\0*\0_serviceIds\";a:2:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:6:\"review\";O:60:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Review\":7:{s:15:\"\0*\0checkoutFlow\";r:86;s:8:\"\0*\0order\";N;s:11:\"\0*\0pluginId\";s:6:\"review\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:6:\"review\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:117;s:12:\"default_step\";s:6:\"review\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:60:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Review\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:18:\"completion_message\";O:71:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\CompletionMessage\":7:{s:15:\"\0*\0checkoutFlow\";r:86;s:8:\"\0*\0order\";N;s:11:\"\0*\0pluginId\";s:18:\"completion_message\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:18:\"completion_message\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Completion message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:138;s:12:\"default_step\";s:8:\"complete\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:71:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\CompletionMessage\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:13:\"order_summary\";O:66:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\OrderSummary\":6:{s:15:\"\0*\0checkoutFlow\";r:86;s:8:\"\0*\0order\";N;s:11:\"\0*\0pluginId\";s:13:\"order_summary\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:13:\"order_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Order summary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:159;s:12:\"default_step\";s:8:\"_sidebar\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:66:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\OrderSummary\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}s:14:\"\0*\0_serviceIds\";a:2:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:15:\"payment_process\";O:67:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentProcess\":6:{s:15:\"\0*\0checkoutFlow\";r:86;s:8:\"\0*\0order\";N;s:11:\"\0*\0pluginId\";s:15:\"payment_process\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:15:\"payment_process\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment process\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:181;s:12:\"default_step\";s:7:\"payment\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:67:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentProcess\";s:8:\"provider\";s:16:\"commerce_payment\";}s:16:\"\0*\0configuration\";a:3:{s:7:\"capture\";b:1;s:4:\"step\";s:7:\"payment\";s:6:\"weight\";i:10;}s:14:\"\0*\0_serviceIds\";a:2:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:19:\"payment_information\";O:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\":7:{s:15:\"\0*\0checkoutFlow\";r:86;s:8:\"\0*\0order\";N;s:11:\"\0*\0pluginId\";s:19:\"payment_information\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:19:\"payment_information\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Payment information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:203;s:12:\"default_step\";s:17:\"order_information\";s:15:\"wrapper_element\";s:8:\"fieldset\";s:5:\"class\";s:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\";s:8:\"provider\";s:16:\"commerce_payment\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:10;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}}s:15:\"\0*\0visibleSteps\";a:0:{}s:8:\"\0*\0order\";N;s:11:\"\0*\0pluginId\";s:17:\"multistep_default\";s:19:\"\0*\0pluginDefinition\";a:4:{s:2:\"id\";s:17:\"multistep_default\";s:5:\"label\";s:19:\"Multistep - Default\";s:5:\"class\";s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:25:\"display_checkout_progress\";b:1;s:5:\"panes\";a:6:{s:5:\"login\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:19:\"contact_information\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:19:\"billing_information\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:2;}s:6:\"review\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:18:\"completion_message\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:13:\"order_summary\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}}}s:14:\"\0*\0_serviceIds\";a:4:{s:11:\"paneManager\";s:37:\"plugin.manager.commerce_checkout_pane\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:15:\"eventDispatcher\";s:16:\"event_dispatcher\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:8:\"\0*\0order\";N;s:11:\"\0*\0pluginId\";s:5:\"login\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:5:\"login\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Login or continue as guest\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:260;s:12:\"default_step\";s:5:\"login\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:59:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Login\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:14:\"\0*\0_serviceIds\";a:5:{s:21:\"credentialsCheckFlood\";s:32:\"commerce.credentials_check_flood\";s:11:\"currentUser\";s:12:\"current_user\";s:8:\"userAuth\";s:9:\"user.auth\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:19:\"contact_information\";r:89;s:6:\"review\";r:111;s:18:\"completion_message\";r:132;s:13:\"order_summary\";r:153;s:15:\"payment_process\";r:175;s:19:\"payment_information\";r:197;}s:23:\"pane_configuration_edit\";s:13:\"order_summary\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503509473),

('form_state','form-uR2-Unpw4iYe265dky9l6RwQnZe7itN3L4LItEoAZS0','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:7:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:2:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}s:10:\"variations\";a:1:{s:4:\"form\";a:1:{s:18:\"inline_entity_form\";a:1:{s:8:\"entities\";a:1:{i:1;a:1:{s:4:\"form\";a:2:{s:7:\"#fields\";a:15:{s:20:\"attribute_parameters\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:20:\"attribute_parameters\";i:7;s:6:\"widget\";}}s:11:\"field_color\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_color\";i:7;s:6:\"widget\";}}s:17:\"field_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:17:\"field_description\";i:7;s:6:\"widget\";}}s:12:\"field_images\";a:2:{s:11:\"items_count\";i:3;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_images\";i:7;s:6:\"widget\";}}s:12:\"field_length\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_length\";i:7;s:6:\"widget\";}}s:15:\"field_old_price\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_old_price\";i:7;s:6:\"widget\";}}s:28:\"field_right_side_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:28:\"field_right_side_description\";i:7;s:6:\"widget\";}}s:15:\"field_sale_text\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_sale_text\";i:7;s:6:\"widget\";}}s:23:\"field_short_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:23:\"field_short_description\";i:7;s:6:\"widget\";}}s:10:\"field_size\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:10:\"field_size\";i:7;s:6:\"widget\";}}s:11:\"field_waist\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_waist\";i:7;s:6:\"widget\";}}s:5:\"price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"price\";i:7;s:6:\"widget\";}}s:3:\"sku\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:3:\"sku\";i:7;s:6:\"widget\";}}s:6:\"status\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:6:\"status\";i:7;s:6:\"widget\";}}s:5:\"title\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"title\";i:7;s:6:\"widget\";}}}s:20:\"attribute_parameters\";a:1:{i:0;a:1:{s:18:\"inline_entity_form\";a:1:{s:7:\"#fields\";a:4:{s:11:\"field_color\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:12:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:20:\"attribute_parameters\";i:7;s:6:\"widget\";i:8;i:0;i:9;s:18:\"inline_entity_form\";i:10;s:11:\"field_color\";i:11;s:6:\"widget\";}}s:10:\"field_size\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:12:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:20:\"attribute_parameters\";i:7;s:6:\"widget\";i:8;i:0;i:9;s:18:\"inline_entity_form\";i:10;s:10:\"field_size\";i:11;s:6:\"widget\";}}s:8:\"langcode\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:12:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:20:\"attribute_parameters\";i:7;s:6:\"widget\";i:8;i:0;i:9;s:18:\"inline_entity_form\";i:10;s:8:\"langcode\";i:11;s:6:\"widget\";}}s:4:\"name\";a:2:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:12:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:1;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:20:\"attribute_parameters\";i:7;s:6:\"widget\";i:8;i:0;i:9;s:18:\"inline_entity_form\";i:10;s:4:\"name\";i:11;s:6:\"widget\";}}}}}}}}}}}}}}s:18:\"inline_entity_form\";a:2:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}}}s:40:\"c15dd846e48e9ac121c700f6059358afbf71a942\";a:0:{}}s:21:\"entity_browser_widget\";a:1:{s:49:\"05d2849e-88a1-4363-aab0-582ab908f846:field_images\";a:3:{i:0;s:2:\"63\";i:1;s:2:\"64\";i:2;s:2:\"62\";}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503344412),

('form_state','form-UvNfQwUfDv-1zk_T0wieWjfzz8yOKNJ0Gc9ed3Iu2Fw','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"447e280f-55e9-4f6d-bb4a-9a8bbb7df9c5\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407981;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407981;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503429581),

('form_state','form-V8_fMjMcWTijdZi319oXFHq7m3YVMmhRBCXGAkKr_ic','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"cd4be44f-cc64-4982-9f33-9d1c6b343e33\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407840;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407840;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503429445),

('form_state','form-vIsHira9gPoe20yQPVsipOMcjeCXfnSTZbkFR6PS0R0','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"6e9c70d2-ead0-4ab4-ae21-bf00c76c862b\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1505201195;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1505201195;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503564727\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"28\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"31\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:7:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1505222810),

('form_state','form-vy3dGN4nOaKUh0a9k2poN044A3w46P209JIGzQgqgig','a:9:{s:10:\"build_info\";a:4:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:44:\"Drupal\\entity_browser\\Form\\EntityBrowserForm\":9:{s:16:\"\0*\0entityBrowser\";O:42:\"Drupal\\entity_browser\\Entity\\EntityBrowser\":26:{s:4:\"name\";s:12:\"browse_files\";s:5:\"label\";s:17:\"Browser for files\";s:7:\"display\";s:6:\"iframe\";s:21:\"display_configuration\";a:4:{s:5:\"width\";s:4:\"100%\";s:6:\"height\";s:3:\"768\";s:9:\"link_text\";s:12:\"Select files\";s:9:\"auto_open\";b:1;}s:10:\"\0*\0widgets\";a:2:{s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";a:5:{s:8:\"settings\";a:4:{s:4:\"view\";s:19:\"file_entity_browser\";s:12:\"view_display\";s:16:\"entity_browser_1\";s:11:\"submit_text\";s:15:\"Select entities\";s:11:\"auto_select\";b:1;}s:4:\"uuid\";s:36:\"a4ad947c-9669-497c-9988-24351955a02f\";s:6:\"weight\";i:1;s:5:\"label\";s:13:\"Files listing\";s:2:\"id\";s:4:\"view\";}s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";a:5:{s:8:\"settings\";a:6:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:20:\"dropzone_description\";s:39:\"Click or drop files here to upload them\";s:12:\"max_filesize\";s:4:\"100M\";s:10:\"extensions\";s:52:\"jpg jpeg gif png txt doc xls pdf ppt pps odt ods odp\";s:11:\"submit_text\";s:15:\"Select entities\";s:11:\"auto_select\";b:0;}s:4:\"uuid\";s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";s:6:\"weight\";i:0;s:5:\"label\";s:12:\"Upload files\";s:2:\"id\";s:10:\"dropzonejs\";}}s:17:\"selection_display\";s:18:\"multi_step_display\";s:31:\"selection_display_configuration\";a:5:{s:11:\"entity_type\";s:4:\"file\";s:7:\"display\";s:9:\"thumbnail\";s:16:\"display_settings\";a:1:{s:11:\"image_style\";s:25:\"file_entity_browser_small\";}s:11:\"select_text\";s:12:\"Use selected\";s:16:\"selection_hidden\";b:0;}s:15:\"widget_selector\";s:4:\"tabs\";s:29:\"widget_selector_configuration\";a:0:{}s:31:\"\0*\0additional_widget_parameters\";a:1:{s:10:\"path_parts\";a:4:{i:0;s:0:\"\";i:1;s:7:\"product\";i:2;s:3:\"add\";i:3;s:15:\"product_display\";}}s:13:\"\0*\0form_class\";s:45:\"\\Drupal\\entity_browser\\Form\\EntityBrowserForm\";s:13:\"\0*\0originalId\";s:12:\"browse_files\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"5352b42f-b8a4-478b-91bc-c875de12c35d\";s:11:\"\0*\0langcode\";s:3:\"und\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1Y-fC4LxFu8Rg3SCSaYMZMXRAvMtueQ3JQIiKuna8hM\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:14:\"entity_browser\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:12:\"file_browser\";}}s:6:\"module\";a:2:{i:0;s:20:\"dropzonejs_eb_widget\";i:1;s:5:\"views\";}}}s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:3:{s:13:\"uuidGenerator\";s:4:\"uuid\";s:16:\"selectionStorage\";s:32:\"entity_browser.selection_storage\";s:12:\"requestStack\";s:13:\"request_stack\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:20:\"\0*\0stringTranslation\";N;s:15:\"\0*\0urlGenerator\";N;}s:7:\"form_id\";s:32:\"entity_browser_browse_files_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:14:\"entity_browser\";a:5:{s:13:\"instance_uuid\";s:40:\"9bdc57dce706aeb870ff0b5d60b486215a2b9df6\";s:17:\"selected_entities\";a:0:{}s:10:\"validators\";a:3:{s:11:\"entity_type\";a:1:{s:4:\"type\";s:4:\"file\";}s:4:\"file\";a:1:{s:10:\"validators\";a:1:{s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:11:\"cardinality\";a:1:{s:11:\"cardinality\";i:1;}}s:14:\"widget_context\";a:2:{s:15:\"upload_location\";s:40:\"public://[date:custom:Y]-[date:custom:m]\";s:17:\"upload_validators\";a:2:{s:18:\"file_validate_size\";a:1:{i:0;d:209715200;}s:24:\"file_validate_extensions\";a:1:{i:0;s:16:\"png gif jpg jpeg\";}}}s:19:\"selection_completed\";b:0;}s:29:\"entity_browser_current_widget\";s:36:\"735d146c-a4b2-4327-a057-d109e0905e05\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503029616),

('form_state','form-wUzz0wtnF1Pzjf2mhqAeR-K--KmgIKX-RpgY-s-kiG0','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503325874\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:7:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:2:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}s:10:\"variations\";a:1:{s:4:\"form\";a:1:{s:18:\"inline_entity_form\";a:1:{s:8:\"entities\";a:1:{i:0;a:1:{s:4:\"form\";a:1:{s:7:\"#fields\";a:14:{s:15:\"attribute_color\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"attribute_color\";i:7;s:6:\"widget\";}}s:14:\"attribute_size\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:14:\"attribute_size\";i:7;s:6:\"widget\";}}s:17:\"field_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:17:\"field_description\";i:7;s:6:\"widget\";}}s:12:\"field_images\";a:2:{s:11:\"items_count\";i:4;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_images\";i:7;s:6:\"widget\";}}s:12:\"field_length\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:12:\"field_length\";i:7;s:6:\"widget\";}}s:15:\"field_old_price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_old_price\";i:7;s:6:\"widget\";}}s:28:\"field_right_side_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:28:\"field_right_side_description\";i:7;s:6:\"widget\";}}s:15:\"field_sale_text\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:15:\"field_sale_text\";i:7;s:6:\"widget\";}}s:23:\"field_short_description\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:23:\"field_short_description\";i:7;s:6:\"widget\";}}s:11:\"field_waist\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:11:\"field_waist\";i:7;s:6:\"widget\";}}s:5:\"price\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"price\";i:7;s:6:\"widget\";}}s:3:\"sku\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:3:\"sku\";i:7;s:6:\"widget\";}}s:6:\"status\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:6:\"status\";i:7;s:6:\"widget\";}}s:5:\"title\";a:2:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:8:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";i:2;s:8:\"entities\";i:3;i:0;i:4;s:4:\"form\";i:5;s:18:\"inline_entity_form\";i:6;s:5:\"title\";i:7;s:6:\"widget\";}}}}}}}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:23:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325829\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"12\";}}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"22\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:1001:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\">&nbsp;</i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:21:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:38:\"Religion Jersey Polo Shirts - White, L\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:15:\"attribute_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"13\";}}}s:14:\"attribute_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"21\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:38:\"Religion Jersey Polo Shirts - White, L\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}}}}s:21:\"entity_browser_widget\";a:1:{s:49:\"534712e5-05cc-42b8-a371-bb7af482f33f:field_images\";a:4:{i:0;s:2:\"62\";i:1;s:2:\"63\";i:2;s:2:\"64\";i:3;s:2:\"65\";}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503431993),

('form_state','form-x3m-MO7pqs3Smpg-CX0pCBMjit-uCCnKnpAKKoFI7NQ','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"88b20b29-0565-4072-933f-ac33da1fcafc\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407289;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407289;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503429025),

('form_state','form-x3qSX41We7Wxkmxhtavam6ZsLwdLiJhBL7NRUf-xvZI','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"5378661f-d582-404d-af3f-c5bad4d1987d\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407562;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503407562;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503429294),

('form_state','form-xU_t3HRw-y-IUmUTRciQJfdC4NEZAa-t56zh4Cq1I40','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"9f229ca2-afe5-4675-a873-8b464866abb4\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503406961;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503406961;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503428590),

('form_state','form-yBF-LxSankdVn1gtVu85_uoZXSfLaBXw03YCBi7KNRU','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":11:{s:9:\"\0*\0formId\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:14:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"3dd64444-12dc-4d19-9277-dfcdbcf1052c\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:21:\"overridden_unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1514836551;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1514836551;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"currentStore\";s:28:\"commerce_store.current_store\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:55:\"commerce_order_item_add_to_cart_form_commerce_product_4\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503564727\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"28\";}i:1;a:1:{s:9:\"target_id\";s:2:\"31\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:6:{s:6:\"status\";s:1:\"2\";s:3:\"cid\";s:1:\"9\";s:22:\"last_comment_timestamp\";s:10:\"1503423895\";s:17:\"last_comment_name\";s:0:\"\";s:16:\"last_comment_uid\";s:1:\"1\";s:13:\"comment_count\";s:1:\"3\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}s:4:\"view\";O:27:\"Drupal\\views\\ViewExecutable\":1:{s:20:\"\0*\0serializationData\";a:11:{s:7:\"storage\";s:12:\"shop_columns\";s:10:\"views_data\";s:16:\"views.views_data\";s:14:\"route_provider\";s:21:\"router.route_provider\";s:15:\"current_display\";s:4:\"page\";s:4:\"args\";a:0:{}s:12:\"current_page\";N;s:13:\"exposed_input\";a:2:{s:9:\"ajax_form\";s:1:\"1\";s:15:\"_wrapper_format\";s:4:\"html\";}s:17:\"exposed_raw_input\";a:2:{s:7:\"sort_by\";s:13:\"price__number\";s:10:\"sort_order\";s:3:\"ASC\";}s:12:\"exposed_data\";a:6:{s:6:\"submit\";s:5:\"Apply\";s:7:\"sort_by\";s:13:\"price__number\";s:10:\"sort_order\";s:3:\"ASC\";s:13:\"form_build_id\";s:48:\"form-IW8nsKpsu5qZEE7L38QN1UE9KXG2i3kyX4y1PGrs72w\";s:7:\"form_id\";s:18:\"views_exposed_form\";s:0:\"\";s:5:\"Apply\";}s:6:\"dom_id\";s:64:\"2248d88b78400fc6102e11dbd407276790fb73759694382887a138615ca5a88e\";s:8:\"executed\";b:1;}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:9:\"published\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:6:\"teaser\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1514858151),

('form_state','form-yOW_ixmA3uWRcooWR5tGjgyCQeHXVnlqJC-hLIaeYBk','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:40:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:39:\"commerce_plugin_item:commerce_condition\";a:15:{s:11:\"plugin_type\";s:18:\"commerce_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:120;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"025ac682-e1c1-45ec-8ee9-bff4d42a193c\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"core.entity_view_mode.commerce_product.teaser\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"\0*\0id\";s:39:\"commerce_product.product_display.teaser\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:6:\"teaser\";s:10:\"\0*\0content\";a:2:{s:10:\"variations\";a:6:{s:4:\"type\";s:20:\"commerce_add_to_cart\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";s:2:\"-5\";s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:8:{s:7:\"created\";b:1;s:14:\"field_category\";b:1;s:12:\"field_rating\";b:1;s:13:\"field_reviews\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:6:\"teaser\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";N;}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1520009888),

('form_state','form-yP-nqcZtBavQp0TtppuNXoQwq4-eO8UD5B9dnuv4ZIo','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"3025b438-6b52-4095-a1d1-49328073ae19\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414360;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503414360;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503414210\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503435960),

('form_state','form-yQt6hEIaDel1L_PxCLpLwV5qxkQG553aht9AcBe7ASU','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"e3b9ab0f-a45b-44b7-9611-0150b3e4416a\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503326404;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503326404;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"5\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503348022),

('form_state','form-YwPU5vgg806KVi_rKR6gIq46bp9aPLGxpjkWhxKcb6Q','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":11:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"a226e650-6b0a-4142-adda-4a2184843f1e\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:14:\"commerce_price\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"YvPk7-s7bZEOuxWBbu1G5wo4qc-OOnZpmCwPUdhp40o\";}s:5:\"\0*\0id\";s:35:\"commerce_order_item.default.default\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:5:{s:16:\"purchased_entity\";a:6:{s:4:\"type\";s:28:\"entity_reference_entity_view\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"product\";s:4:\"link\";b:0;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:8:\"quantity\";a:6:{s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";i:1;s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:11:\"total_price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:10:\"unit_price\";a:6:{s:4:\"type\";s:22:\"commerce_price_default\";s:6:\"weight\";i:2;s:8:\"settings\";a:2:{s:21:\"strip_trailing_zeroes\";b:0;s:21:\"display_currency_code\";b:0;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:1:{s:11:\"adjustments\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";b:0;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:6:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:13:\"configFactory\";s:14:\"config.factory\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:3:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:7:\"default\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:7:\"default\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";s:16:\"purchased_entity\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503510242),

('form_state','form-ZRDIwXEfh2h-2jddWDCZCN7Sfaj8ZzHiCCODExShqzU','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:1:{s:33:\"field_group:includes/field_ui.inc\";a:3:{s:4:\"type\";s:3:\"inc\";s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:17:\"includes/field_ui\";}}s:15:\"callback_object\";O:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\":12:{s:17:\"\0*\0displayContext\";s:4:\"view\";s:13:\"\0*\0fieldTypes\";a:42:{s:7:\"address\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"address\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a postal address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"address_default\";s:17:\"default_formatter\";s:15:\"address_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\AddressItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"address_country\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:15:\"address_country\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"An entity field containing a country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:23:\"address_country_default\";s:17:\"default_formatter\";s:23:\"address_country_default\";s:5:\"class\";s:49:\"Drupal\\address\\Plugin\\Field\\FieldType\\CountryItem\";s:8:\"provider\";s:7:\"address\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"address_zone\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Address\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"address_zone\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a zone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:51:\"\\Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItemList\";s:14:\"default_widget\";s:20:\"address_zone_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:46:\"Drupal\\address\\Plugin\\Field\\FieldType\\ZoneItem\";s:8:\"provider\";s:7:\"address\";}s:7:\"comment\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:30:\"commerce_plugin_item:condition\";a:15:{s:11:\"plugin_type\";s:9:\"condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Conditions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores configuration for a plugin.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:27:\"commerce_plugin_item:action\";a:15:{s:11:\"plugin_type\";s:6:\"action\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:45:\"commerce_plugin_item:commerce_promotion_offer\";a:15:{s:11:\"plugin_type\";s:24:\"commerce_promotion_offer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Promotion offer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:49:\"commerce_plugin_item:commerce_promotion_condition\";a:15:{s:11:\"plugin_type\";s:28:\"commerce_promotion_condition\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Promotion condition\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Plugin\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:20:\"commerce_plugin_item\";s:11:\"description\";r:119;s:14:\"default_widget\";s:22:\"commerce_plugin_select\";s:17:\"default_formatter\";s:6:\"string\";s:7:\"deriver\";s:57:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItemDeriver\";s:5:\"class\";s:49:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\PluginItem\";s:8:\"provider\";s:8:\"commerce\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"commerce_remote_id\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"commerce_remote_id\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Remote ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Stores remote IDs.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:0:\"\";s:17:\"default_formatter\";s:0:\"\";s:10:\"list_class\";s:61:\"\\Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdFieldItemList\";s:5:\"class\";s:51:\"Drupal\\commerce\\Plugin\\Field\\FieldType\\RemoteIdItem\";s:8:\"provider\";s:8:\"commerce\";}s:19:\"commerce_adjustment\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:19:\"commerce_adjustment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Adjustment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Stores adjustments to the parent entity\'s price.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:64:\"\\Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItemList\";s:14:\"default_widget\";s:27:\"commerce_adjustment_default\";s:5:\"class\";s:59:\"Drupal\\commerce_order\\Plugin\\Field\\FieldType\\AdjustmentItem\";s:8:\"provider\";s:14:\"commerce_order\";}s:14:\"commerce_price\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:14:\"commerce_price\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Stores a decimal number and a three letter currency code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:22:\"commerce_price_default\";s:17:\"default_formatter\";s:22:\"commerce_price_default\";s:5:\"class\";s:54:\"Drupal\\commerce_price\\Plugin\\Field\\FieldType\\PriceItem\";s:8:\"provider\";s:14:\"commerce_price\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"datetime\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:26:\"entity_reference_revisions\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:26:\"entity_reference_revisions\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Entity reference revisions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"An entity field containing an entity reference to a specific revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:85:\"Drupal\\entity_reference_revisions\\Plugin\\Field\\FieldType\\EntityReferenceRevisionsItem\";s:10:\"list_class\";s:72:\"\\Drupal\\entity_reference_revisions\\EntityReferenceRevisionsFieldItemList\";s:17:\"default_formatter\";s:38:\"entity_reference_revisions_entity_view\";s:14:\"default_widget\";s:39:\"entity_reference_revisions_autocomplete\";s:8:\"provider\";s:26:\"entity_reference_revisions\";}s:4:\"file\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"fivestar\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Fivestar Rating\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Store a rating for this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"fivestar_stars\";s:17:\"default_formatter\";s:14:\"fivestar_stars\";s:5:\"class\";s:51:\"Drupal\\fivestar\\Plugin\\Field\\FieldType\\FivestarItem\";s:8:\"provider\";s:8:\"fivestar\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"image\";a:16:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_integer\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:11:\"list_string\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:4:\"path\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:5:\"class\";s:29:\"\\Drupal\\pathauto\\PathautoItem\";s:8:\"provider\";s:4:\"path\";}s:5:\"state\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"state\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"State\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Stores the current workflow state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\state_machine\\Plugin\\Field\\FieldType\\StateItem\";s:8:\"provider\";s:13:\"state_machine\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:7:\"webform\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"webform\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Webform\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"A webform containing default submission values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:31:\"webform_entity_reference_select\";s:17:\"default_formatter\";s:36:\"webform_entity_reference_entity_view\";s:10:\"list_class\";s:74:\"\\Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceFieldItemList\";s:5:\"class\";s:64:\"Drupal\\webform\\Plugin\\Field\\FieldType\\WebformEntityReferenceItem\";s:8:\"provider\";s:7:\"webform\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:79:\"\\Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem::getAllowedLanguageCodes\";}}}}s:5:\"class\";s:36:\"\\Drupal\\language\\DefaultLanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}s:9:\"\0*\0entity\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"025ac682-e1c1-45ec-8ee9-bff4d42a193c\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:8:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:45:\"core.entity_view_mode.commerce_product.teaser\";i:2;s:59:\"field.field.commerce_product.product_display.field_category\";i:3;s:57:\"field.field.commerce_product.product_display.field_rating\";i:4;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:5;s:55:\"field.field.commerce_product.product_display.field_tags\";i:6;s:51:\"field.field.commerce_product.product_display.stores\";i:7;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:5:\"\0*\0id\";s:39:\"commerce_product.product_display.teaser\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:6:\"teaser\";s:10:\"\0*\0content\";a:2:{s:10:\"variations\";a:6:{s:4:\"type\";s:28:\"entity_reference_entity_view\";s:6:\"weight\";s:1:\"0\";s:6:\"region\";s:7:\"content\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"product\";s:4:\"link\";b:0;}s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}}}s:9:\"\0*\0hidden\";a:8:{s:7:\"created\";b:1;s:14:\"field_category\";b:1;s:12:\"field_rating\";b:1;s:13:\"field_reviews\";b:1;s:10:\"field_tags\";b:1;s:8:\"langcode\";b:1;s:6:\"stores\";b:1;s:3:\"uid\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_view_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:12:\"\0*\0operation\";s:4:\"edit\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:5:{s:13:\"pluginManager\";s:30:\"plugin.manager.field.formatter\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:13:\"entityManager\";s:14:\"entity.manager\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:24:\"entity_view_display_form\";s:7:\"form_id\";s:29:\"entity_view_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:4:{s:23:\"entity_form_initialized\";b:1;s:18:\"field_group_params\";O:8:\"stdClass\":7:{s:11:\"entity_type\";s:16:\"commerce_product\";s:6:\"bundle\";s:15:\"product_display\";s:15:\"region_callback\";s:39:\"field_group_display_overview_row_region\";s:4:\"mode\";s:6:\"teaser\";s:7:\"context\";s:4:\"view\";s:6:\"groups\";a:0:{}s:7:\"parents\";a:0:{}}s:20:\"plugin_settings_edit\";N;s:22:\"plugin_settings_update\";N;}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503520181),

('form_state','form-zuwHiZe0BA3L0OrmSzx_pvIm9RDclKbAGZOpuZrnI2g','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:1:{i:0;s:17:\"order_information\";}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\":7:{s:8:\"\0*\0panes\";a:7:{s:5:\"login\";O:59:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Login\":8:{s:11:\"\0*\0clientIp\";s:11:\"114.4.82.96\";s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";O:34:\"Drupal\\commerce_order\\Entity\\Order\":24:{s:9:\"\0*\0values\";a:22:{s:8:\"order_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"default\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"a4f9cdf2-ca4b-4f9b-a2ec-e9a184c0442c\";}s:12:\"order_number\";a:1:{s:9:\"x-default\";N;}s:8:\"store_id\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"0\";}}}s:4:\"mail\";a:1:{s:9:\"x-default\";a:0:{}}s:10:\"ip_address\";a:1:{s:9:\"x-default\";s:11:\"114.4.82.96\";}s:15:\"billing_profile\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:9:\"target_id\";N;s:18:\"target_revision_id\";N;}}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:5:\"state\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"draft\";}}}s:4:\"data\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1504286272\";}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1504286344\";}}}s:6:\"placed\";a:1:{s:9:\"x-default\";N;}s:9:\"completed\";a:1:{s:9:\"x-default\";N;}s:4:\"cart\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:13:\"checkout_flow\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:13:\"checkout_step\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:17:\"order_information\";}}}s:15:\"payment_gateway\";a:1:{s:9:\"x-default\";a:0:{}}s:14:\"payment_method\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"order_items\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"15\";}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"default\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"a4f9cdf2-ca4b-4f9b-a2ec-e9a184c0442c\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:14:\"commerce_order\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:11:\"\0*\0pluginId\";s:5:\"login\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:5:\"login\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Login or continue as guest\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:108;s:12:\"default_step\";s:5:\"login\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:59:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Login\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:4:{s:21:\"credentialsCheckFlood\";s:32:\"commerce.credentials_check_flood\";s:11:\"currentUser\";s:12:\"current_user\";s:8:\"userAuth\";s:9:\"user.auth\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:19:\"contact_information\";O:72:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\ContactInformation\":6:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:19:\"contact_information\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:19:\"contact_information\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Contact information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:134;s:12:\"default_step\";s:17:\"order_information\";s:15:\"wrapper_element\";s:8:\"fieldset\";s:5:\"class\";s:72:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\ContactInformation\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:14:\"\0*\0_serviceIds\";a:2:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:6:\"review\";O:60:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Review\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:6:\"review\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:6:\"review\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:156;s:12:\"default_step\";s:6:\"review\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:60:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\Review\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:18:\"completion_message\";O:71:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\CompletionMessage\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:18:\"completion_message\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:18:\"completion_message\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Completion message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:177;s:12:\"default_step\";s:8:\"complete\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:71:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\CompletionMessage\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:13:\"order_summary\";O:66:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\OrderSummary\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:13:\"order_summary\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:13:\"order_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Order summary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:198;s:12:\"default_step\";s:8:\"_sidebar\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:66:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutPane\\OrderSummary\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}s:19:\"payment_information\";O:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\":6:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:19:\"payment_information\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:19:\"payment_information\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Payment information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:220;s:12:\"default_step\";s:17:\"order_information\";s:15:\"wrapper_element\";s:8:\"fieldset\";s:5:\"class\";s:71:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentInformation\";s:8:\"provider\";s:16:\"commerce_payment\";}s:16:\"\0*\0configuration\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:10;}s:14:\"\0*\0_serviceIds\";a:2:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:15:\"payment_process\";O:67:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentProcess\":7:{s:15:\"\0*\0checkoutFlow\";r:6;s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:15:\"payment_process\";s:19:\"\0*\0pluginDefinition\";a:7:{s:2:\"id\";s:15:\"payment_process\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Payment process\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"admin_label\";r:241;s:12:\"default_step\";s:7:\"payment\";s:15:\"wrapper_element\";s:9:\"container\";s:5:\"class\";s:67:\"Drupal\\commerce_payment\\Plugin\\Commerce\\CheckoutPane\\PaymentProcess\";s:8:\"provider\";s:16:\"commerce_payment\";}s:16:\"\0*\0configuration\";a:3:{s:7:\"capture\";b:1;s:4:\"step\";s:7:\"payment\";s:6:\"weight\";i:10;}s:20:\"\0*\0stringTranslation\";N;s:14:\"\0*\0_serviceIds\";a:1:{s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";}}}s:15:\"\0*\0visibleSteps\";a:5:{s:5:\"login\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"previous_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Go back\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:0;}s:17:\"order_information\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:1;s:14:\"previous_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Go back\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"review\";a:4:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"next_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Continue to review\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"previous_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Go back\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:1;}s:7:\"payment\";a:4:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"next_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Pay and complete purchase\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:0;s:6:\"hidden\";b:1;}s:8:\"complete\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Complete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"next_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Pay and complete purchase\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"has_sidebar\";b:0;}}s:8:\"\0*\0order\";r:11;s:11:\"\0*\0pluginId\";s:17:\"multistep_default\";s:19:\"\0*\0pluginDefinition\";a:4:{s:2:\"id\";s:17:\"multistep_default\";s:5:\"label\";s:19:\"Multistep - Default\";s:5:\"class\";s:70:\"Drupal\\commerce_checkout\\Plugin\\Commerce\\CheckoutFlow\\MultistepDefault\";s:8:\"provider\";s:17:\"commerce_checkout\";}s:16:\"\0*\0configuration\";a:2:{s:25:\"display_checkout_progress\";b:1;s:5:\"panes\";a:6:{s:5:\"login\";a:4:{s:20:\"allow_guest_checkout\";b:1;s:18:\"allow_registration\";b:0;s:4:\"step\";s:5:\"login\";s:6:\"weight\";i:0;}s:19:\"contact_information\";a:3:{s:12:\"double_entry\";b:1;s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:1;}s:19:\"billing_information\";a:2:{s:4:\"step\";s:17:\"order_information\";s:6:\"weight\";i:2;}s:6:\"review\";a:2:{s:4:\"step\";s:6:\"review\";s:6:\"weight\";i:3;}s:18:\"completion_message\";a:2:{s:4:\"step\";s:8:\"complete\";s:6:\"weight\";i:4;}s:13:\"order_summary\";a:3:{s:4:\"view\";s:31:\"commerce_checkout_order_summary\";s:4:\"step\";s:8:\"_sidebar\";s:6:\"weight\";i:5;}}}s:14:\"\0*\0_serviceIds\";a:4:{s:11:\"paneManager\";s:37:\"plugin.manager.commerce_checkout_pane\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:15:\"eventDispatcher\";s:16:\"event_dispatcher\";s:17:\"stringTranslation\";s:18:\"string_translation\";}}s:12:\"base_form_id\";s:22:\"commerce_checkout_flow\";s:7:\"form_id\";s:40:\"commerce_checkout_flow_multistep_default\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:1:{s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:19:\"payment_information\";a:1:{s:19:\"billing_information\";a:1:{s:7:\"#fields\";a:1:{s:7:\"address\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:4:{i:0;s:19:\"payment_information\";i:1;s:19:\"billing_information\";i:2;s:7:\"address\";i:3;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1504307997),

('form_state','form-_IHzfY0gd1vXaUdCnvVB2jhy1GS0bg4c__WoypgJkgs','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:40:\"Drupal\\commerce_product\\Form\\ProductForm\":9:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:17:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:2:\"en\";}}}s:3:\"uid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503053593\";}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:10:\"1503302248\";}}}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:2:\"36\";}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:6:\"status\";s:1:\"2\";}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:2:\"37\";}i:1;a:1:{s:9:\"target_id\";s:2:\"38\";}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}i:1;a:1:{s:9:\"target_id\";s:1:\"5\";}}}s:4:\"path\";a:1:{s:9:\"x-default\";a:1:{i:0;a:0:{}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:4:\"edit\";s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:8:{s:13:\"dateFormatter\";s:14:\"date.formatter\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:12:\"requestStack\";s:13:\"request_stack\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:21:\"commerce_product_form\";s:7:\"form_id\";s:42:\"commerce_product_product_display_edit_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:6:{s:23:\"entity_default_langcode\";s:2:\"en\";s:8:\"langcode\";s:2:\"en\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":13:{s:7:\"\0*\0uuid\";s:36:\"ff8f6f87-1629-45b7-a4b4-5edc1972c792\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:59:\"field.field.commerce_product.product_display.field_category\";i:2;s:57:\"field.field.commerce_product.product_display.field_rating\";i:3;s:58:\"field.field.commerce_product.product_display.field_reviews\";i:4;s:55:\"field.field.commerce_product.product_display.field_tags\";i:5;s:51:\"field.field.commerce_product.product_display.stores\";i:6;s:55:\"field.field.commerce_product.product_display.variations\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:8:\"commerce\";i:2;s:18:\"inline_entity_form\";i:3;s:4:\"path\";}}s:5:\"\0*\0id\";s:40:\"commerce_product.product_display.default\";s:19:\"\0*\0targetEntityType\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:7:\"\0*\0mode\";s:7:\"default\";s:10:\"\0*\0content\";a:10:{s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:7;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:14:\"field_category\";a:5:{s:6:\"weight\";i:3;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"options_select\";s:6:\"region\";s:7:\"content\";}s:13:\"field_reviews\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:10:\"field_tags\";a:5:{s:6:\"weight\";i:4;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:8;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:6:\"stores\";a:5:{s:4:\"type\";s:22:\"commerce_entity_select\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:22:\"autocomplete_threshold\";i:7;s:17:\"autocomplete_size\";i:60;s:24:\"autocomplete_placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"variations\";a:5:{s:4:\"type\";s:26:\"inline_entity_form_complex\";s:6:\"weight\";i:2;s:8:\"settings\";a:7:{s:9:\"form_mode\";s:7:\"default\";s:15:\"override_labels\";b:1;s:14:\"label_singular\";s:9:\"variation\";s:12:\"label_plural\";s:10:\"variations\";s:9:\"allow_new\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";s:14:\"allow_existing\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:2:{s:12:\"field_rating\";b:1;s:6:\"status\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:13:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:2:\"id\";i:5;s:16:\"targetEntityType\";i:6;s:6:\"bundle\";i:7;s:4:\"mode\";i:8;s:7:\"content\";i:9;s:6:\"hidden\";i:10;s:12:\"entityTypeId\";i:11;s:12:\"enforceIsNew\";i:12;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:10:{s:7:\"created\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:7:\"created\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:14:\"field_category\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:14:\"field_category\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:13:\"field_reviews\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:13:\"field_reviews\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"field_tags\";a:3:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"field_tags\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:2:{i:0;i:0;i:1;i:1;}}s:8:\"langcode\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:8:\"langcode\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:4:\"path\";a:3:{s:11:\"items_count\";i:0;s:13:\"array_parents\";a:2:{i:0;s:4:\"path\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:6:\"stores\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:6:\"stores\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:5:\"title\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:5:\"title\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:3:\"uid\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}s:10:\"variations\";a:2:{s:11:\"items_count\";i:2;s:13:\"array_parents\";a:2:{i:0;s:10:\"variations\";i:1;s:6:\"widget\";}}}}}s:18:\"inline_entity_form\";a:1:{s:40:\"5a3955af46ce08a39e261b16b82ffca38fc21e15\";a:4:{s:8:\"instance\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":30:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:43:\"commerce_product.product_display.variations\";s:13:\"\0*\0field_name\";s:10:\"variations\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:16:\"commerce_product\";s:9:\"\0*\0bundle\";s:15:\"product_display\";s:8:\"\0*\0label\";s:10:\"Variations\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:34:\"default:commerce_product_variation\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{i:0;s:7:\"product\";}}}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";N;s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:43:\"commerce_product.product_display.variations\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b0ad8cd1-ef92-4171-9613-2a02edfcaa4d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:0:{}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:28:\"languages:language_interface\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:54:\"commerce_product.commerce_product_type.product_display\";i:1;s:56:\"commerce_product.commerce_product_variation_type.product\";i:2;s:41:\"field.storage.commerce_product.variations\";}}}s:4:\"form\";N;s:6:\"delete\";a:0:{}s:8:\"entities\";a:2:{i:0;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:24:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2134\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053779\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:13:\"Black & White\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:867:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:4:{i:0;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:3;a:5:{s:9:\"target_id\";s:2:\"65\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"50cm\";}}}s:15:\"field_old_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"50.000000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:975:\"<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-paper-plane-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-clock-o\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\n<div class=\"alt-service-wrap\">\n    <div class=\"alt-service-item\">\n        <div class=\"alt-service-icon\">\n            <i class=\"fa fa-gift\">&nbsp;</i>\n        </div>\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\n    </div>\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:15:\"field_sale_text\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"SALE\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"25cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"534712e5-05cc-42b8-a371-bb7af482f33f\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"0\";s:4:\"form\";s:4:\"edit\";s:10:\"needs_save\";b:0;}i:1;a:4:{s:6:\"entity\";O:47:\"Drupal\\commerce_product\\Entity\\ProductVariation\":24:{s:9:\"\0*\0values\";a:22:{s:12:\"variation_id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:7:\"product\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:3:\"sku\";a:1:{s:9:\"x-default\";s:4:\"2135\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:5:\"price\";a:1:{s:9:\"x-default\";a:2:{s:6:\"number\";s:9:\"28.990000\";s:13:\"currency_code\";s:3:\"USD\";}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053967\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503302248\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:11:\"field_color\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:11:\"Gray & Blue\";}}}s:17:\"field_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:868:\"[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.</p><p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus.</p>[/html]\r\n \";s:6:\"format\";s:10:\"shortcodes\";}}}s:12:\"field_images\";a:1:{s:9:\"x-default\";a:3:{i:0;a:5:{s:9:\"target_id\";s:2:\"63\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:1;a:5:{s:9:\"target_id\";s:2:\"64\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}i:2;a:5:{s:9:\"target_id\";s:2:\"62\";s:3:\"alt\";s:7:\"Product\";s:5:\"title\";s:0:\"\";s:5:\"width\";s:3:\"370\";s:6:\"height\";s:3:\"472\";}}}s:12:\"field_length\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"55cm\";}}}s:28:\"field_right_side_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:983:\"<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-paper-plane-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">Free Shipping</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-clock-o\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">14 days moneyback</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\r\n<div class=\"alt-service-wrap\">\r\n    <div class=\"alt-service-item\">\r\n        <div class=\"alt-service-icon\">\r\n            <i class=\"fa fa-gift\"></i>\r\n        </div>\r\n        <h3 class=\"alt-services-title font-alt\">100% Original</h3>\r\n        Vivamus neque orci, ultricies blandit ultricies vel, semper..\r\n    </div>\r\n</div>\";s:6:\"format\";s:10:\"shortcodes\";}}}s:23:\"field_short_description\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:187:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum et dui id dui suscipit pharetra vitae quis urna. Ut scelerisque quam quis erat tincidunt, vel vehicula turpis bibendum.\";}}}s:10:\"field_size\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:21:\"Small, Medium & Large\";}}}s:11:\"field_waist\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"30cm\";}}}s:20:\"attribute_parameters\";a:1:{s:9:\"x-default\";a:0:{}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:7:\"product\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"05d2849e-88a1-4363-aab0-582ab908f846\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:5:\"label\";a:1:{s:9:\"x-default\";s:27:\"Religion Jersey Polo Shirts\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:26:\"commerce_product_variation\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:6:\"weight\";s:1:\"1\";s:4:\"form\";N;s:10:\"needs_save\";b:0;}}}}}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503344847),

('form_state','form-_xVVn_XBR1fGJ5Hvm9WMaeCBeXVr-G5u14ESF2Lf9AU','a:9:{s:10:\"build_info\";a:5:{s:4:\"args\";a:0:{}s:5:\"files\";a:0:{}s:15:\"callback_object\";O:39:\"Drupal\\commerce_cart\\Form\\AddToCartForm\":10:{s:9:\"\0*\0entity\";O:38:\"Drupal\\commerce_order\\Entity\\OrderItem\":24:{s:9:\"\0*\0values\";a:13:{s:13:\"order_item_id\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"uuid\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:36:\"c2510307-de3a-45b0-803f-9bb795f8c417\";}}}s:4:\"type\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:7:\"default\";}}}s:8:\"order_id\";a:1:{s:9:\"x-default\";a:0:{}}s:16:\"purchased_entity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"4\";}}}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";s:39:\"Religion Jersey Polo Shirts - Black, XL\";}}}s:8:\"quantity\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1;}}}s:10:\"unit_price\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"number\";s:9:\"25.990000\";s:13:\"currency_code\";s:3:\"USD\";}}}s:11:\"adjustments\";a:1:{s:9:\"x-default\";a:0:{}}s:11:\"total_price\";a:1:{s:9:\"x-default\";a:0:{}}s:4:\"data\";a:1:{s:9:\"x-default\";a:0:{}}s:7:\"created\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503408140;}}}s:7:\"changed\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:5:\"value\";i:1503408140;}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:0:\"\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:3:\"und\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:2;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:1;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:1:{s:6:\"bundle\";s:7:\"default\";}s:25:\"\0*\0translatableEntityKeys\";a:0:{}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:19:\"commerce_order_item\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:12:\"\0*\0operation\";s:11:\"add_to_cart\";s:15:\"\0*\0requestStack\";N;s:16:\"\0*\0configFactory\";N;s:13:\"\0*\0routeMatch\";N;s:14:\"\0*\0_serviceIds\";a:12:{s:11:\"cartManager\";s:26:\"commerce_cart.cart_manager\";s:12:\"cartProvider\";s:27:\"commerce_cart.cart_provider\";s:17:\"orderTypeResolver\";s:40:\"commerce_order.chain_order_type_resolver\";s:12:\"storeContext\";s:28:\"commerce_store.store_context\";s:18:\"chainPriceResolver\";s:35:\"commerce_price.chain_price_resolver\";s:11:\"currentUser\";s:12:\"current_user\";s:13:\"entityManager\";s:14:\"entity.manager\";s:20:\"entityTypeBundleInfo\";s:23:\"entity_type.bundle.info\";s:4:\"time\";s:13:\"datetime.time\";s:13:\"moduleHandler\";s:14:\"module_handler\";s:17:\"entityTypeManager\";s:19:\"entity_type.manager\";s:17:\"stringTranslation\";s:18:\"string_translation\";}s:16:\"\0*\0linkGenerator\";N;s:16:\"\0*\0loggerFactory\";N;s:22:\"\0*\0redirectDestination\";N;s:15:\"\0*\0urlGenerator\";N;}s:12:\"base_form_id\";s:36:\"commerce_order_item_add_to_cart_form\";s:7:\"form_id\";s:46:\"commerce_order_item_default_add_to_cart_1_form\";}s:8:\"response\";N;s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:13:\"process_input\";b:1;s:16:\"has_file_element\";N;s:7:\"storage\";a:9:{s:7:\"product\";O:38:\"Drupal\\commerce_product\\Entity\\Product\":24:{s:9:\"\0*\0values\";a:16:{s:10:\"product_id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:4:\"type\";a:1:{s:9:\"x-default\";s:15:\"product_display\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:3:\"uid\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:5:\"value\";s:27:\"Religion Jersey Polo Shirts\";s:11:\"_attributes\";a:0:{}}}}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:7:\"created\";a:1:{s:9:\"x-default\";s:10:\"1503053593\";}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1503325874\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:14:\"field_category\";a:1:{s:9:\"x-default\";a:1:{i:0;a:4:{s:9:\"target_id\";s:2:\"36\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:12:\"field_rating\";a:1:{s:9:\"x-default\";a:1:{i:0;a:3:{s:6:\"rating\";s:3:\"100\";s:6:\"target\";N;s:11:\"_attributes\";a:0:{}}}}s:13:\"field_reviews\";a:1:{s:9:\"x-default\";a:1:{i:0;a:2:{s:6:\"status\";s:1:\"2\";s:11:\"_attributes\";a:0:{}}}}s:10:\"field_tags\";a:1:{s:9:\"x-default\";a:2:{i:0;a:4:{s:9:\"target_id\";s:2:\"37\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}i:1;a:4:{s:9:\"target_id\";s:2:\"38\";s:11:\"_attributes\";a:0:{}s:7:\"_loaded\";b:1;s:19:\"_accessCacheability\";O:35:\"Drupal\\Core\\Cache\\CacheableMetadata\":3:{s:16:\"\0*\0cacheContexts\";a:1:{i:0;s:16:\"user.permissions\";}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;}}}}s:6:\"stores\";a:1:{s:9:\"x-default\";a:1:{i:0;a:1:{s:9:\"target_id\";s:1:\"1\";}}}s:10:\"variations\";a:1:{s:9:\"x-default\";a:2:{i:0;a:2:{s:9:\"target_id\";s:1:\"4\";s:11:\"_attributes\";a:0:{}}i:1;a:2:{s:9:\"target_id\";s:1:\"5\";s:11:\"_attributes\";a:0:{}}}}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:3:{s:6:\"bundle\";s:15:\"product_display\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"475cd204-99c8-43f0-9b34-ca6f8a652fdc\";}s:25:\"\0*\0translatableEntityKeys\";a:4:{s:5:\"label\";a:0:{}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:6:\"status\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:15:\"\0*\0entityTypeId\";s:16:\"commerce_product\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}}s:9:\"view_mode\";s:4:\"full\";s:8:\"settings\";a:1:{s:7:\"combine\";b:1;}s:23:\"entity_default_langcode\";s:3:\"und\";s:8:\"langcode\";s:3:\"und\";s:12:\"form_display\";O:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\":14:{s:7:\"\0*\0uuid\";s:36:\"4fe7e568-ffc5-4e38-b116-b1635176d69f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:9:\"\0*\0status\";b:1;s:15:\"\0*\0dependencies\";a:3:{s:6:\"config\";a:2:{i:0;s:47:\"commerce_order.commerce_order_item_type.default\";i:1;s:53:\"core.entity_form_mode.commerce_order_item.add_to_cart\";}s:8:\"enforced\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"commerce_cart\";i:1;s:16:\"commerce_product\";}}s:6:\"module\";a:1:{i:0;s:16:\"commerce_product\";}}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dEAP3rR9rAW6OwN2i5jskLxvkOBHsclejItF8RL_KVQ\";}s:5:\"\0*\0id\";s:39:\"commerce_order_item.default.add_to_cart\";s:19:\"\0*\0targetEntityType\";s:19:\"commerce_order_item\";s:9:\"\0*\0bundle\";s:7:\"default\";s:7:\"\0*\0mode\";s:11:\"add_to_cart\";s:10:\"\0*\0content\";a:1:{s:16:\"purchased_entity\";a:5:{s:4:\"type\";s:37:\"commerce_product_variation_attributes\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:9:\"\0*\0hidden\";a:7:{s:7:\"created\";b:1;s:8:\"quantity\";b:1;s:6:\"status\";b:1;s:3:\"uid\";b:1;s:10:\"unit_price\";b:1;s:11:\"adjustments\";b:1;s:11:\"total_price\";b:1;}s:15:\"\0*\0entityTypeId\";s:19:\"entity_form_display\";s:15:\"\0*\0enforceIsNew\";N;s:15:\"_serializedKeys\";a:14:{i:0;s:4:\"uuid\";i:1;s:8:\"langcode\";i:2;s:6:\"status\";i:3;s:12:\"dependencies\";i:4;s:5:\"_core\";i:5;s:2:\"id\";i:6;s:16:\"targetEntityType\";i:7;s:6:\"bundle\";i:8;s:4:\"mode\";i:9;s:7:\"content\";i:10;s:6:\"hidden\";i:11;s:12:\"entityTypeId\";i:12;s:12:\"enforceIsNew\";i:13;s:15:\"_serializedKeys\";}}s:23:\"entity_form_initialized\";b:1;s:13:\"field_storage\";a:1:{s:8:\"#parents\";a:1:{s:7:\"#fields\";a:1:{s:16:\"purchased_entity\";a:3:{s:11:\"items_count\";i:1;s:13:\"array_parents\";a:2:{i:0;s:16:\"purchased_entity\";i:1;s:6:\"widget\";}s:15:\"original_deltas\";a:1:{i:0;i:0;}}}}}s:18:\"selected_variation\";s:1:\"4\";}s:5:\"cache\";b:1;s:8:\"no_cache\";N;}',1503429740),

('update','update_project_data','a:25:{s:6:\"drupal\";a:15:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Block\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.7.8\";s:7:\"project\";s:6:\"drupal\";s:16:\"_info_file_ctime\";i:1570954004;s:9:\"datestamp\";i:0;}s:9:\"datestamp\";i:0;s:8:\"includes\";a:39:{s:5:\"block\";s:5:\"Block\";s:13:\"block_content\";s:12:\"Custom Block\";s:10:\"breakpoint\";s:10:\"Breakpoint\";s:8:\"ckeditor\";s:8:\"CKEditor\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:6:\"config\";s:21:\"Configuration Manager\";s:7:\"contact\";s:7:\"Contact\";s:10:\"contextual\";s:16:\"Contextual Links\";s:8:\"datetime\";s:8:\"Datetime\";s:5:\"dblog\";s:16:\"Database Logging\";s:6:\"editor\";s:11:\"Text Editor\";s:5:\"field\";s:5:\"Field\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:3:\"hal\";s:3:\"HAL\";s:4:\"help\";s:4:\"Help\";s:5:\"image\";s:5:\"Image\";s:8:\"language\";s:8:\"Language\";s:4:\"link\";s:4:\"Link\";s:17:\"menu_link_content\";s:17:\"Custom Menu Links\";s:7:\"menu_ui\";s:7:\"Menu UI\";s:4:\"node\";s:4:\"Node\";s:7:\"options\";s:7:\"Options\";s:4:\"path\";s:4:\"Path\";s:4:\"rest\";s:20:\"RESTful Web Services\";s:6:\"search\";s:6:\"Search\";s:13:\"serialization\";s:13:\"Serialization\";s:8:\"shortcut\";s:8:\"Shortcut\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:7:\"toolbar\";s:7:\"Toolbar\";s:4:\"tour\";s:4:\"Tour\";s:6:\"update\";s:14:\"Update Manager\";s:4:\"user\";s:4:\"User\";s:5:\"views\";s:5:\"Views\";s:8:\"views_ui\";s:8:\"Views UI\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:5:\"8.7.8\";s:14:\"existing_major\";s:1:\"8\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Drupal core\";s:4:\"link\";s:37:\"https://www.drupal.org/project/drupal\";s:14:\"latest_version\";s:5:\"8.7.8\";s:8:\"releases\";a:1:{s:5:\"8.7.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.8\";s:7:\"version\";s:5:\"8.7.8\";s:3:\"tag\";s:5:\"8.7.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.8.tar.gz\";s:4:\"date\";s:10:\"1570044484\";s:6:\"mdhash\";s:32:\"f281eb14d8aabf0c3e78dd519ca4b640\";s:8:\"filesize\";s:8:\"17882836\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:5:\"8.7.8\";s:6:\"status\";i:5;}s:7:\"address\";a:15:{s:4:\"name\";s:7:\"address\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Address\";s:7:\"package\";s:11:\"Field types\";s:7:\"version\";s:7:\"8.x-1.7\";s:7:\"project\";s:7:\"address\";s:9:\"datestamp\";i:1559642892;s:16:\"_info_file_ctime\";i:1561188441;}s:9:\"datestamp\";i:1559642892;s:8:\"includes\";a:1:{s:7:\"address\";s:7:\"Address\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.7\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:7:\"Address\";s:4:\"link\";s:38:\"https://www.drupal.org/project/address\";s:14:\"latest_version\";s:7:\"8.x-1.7\";s:8:\"releases\";a:1:{s:7:\"8.x-1.7\";a:14:{s:4:\"name\";s:15:\"address 8.x-1.7\";s:7:\"version\";s:7:\"8.x-1.7\";s:3:\"tag\";s:7:\"8.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/address/releases/8.x-1.7\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/address-8.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1559642884\";s:6:\"mdhash\";s:32:\"51b1362edb763c5a3600fa78ce33bf67\";s:8:\"filesize\";s:5:\"60153\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.7\";s:6:\"status\";i:5;}s:13:\"admin_toolbar\";a:16:{s:4:\"name\";s:13:\"admin_toolbar\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Admin Toolbar\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:8:\"8.x-1.27\";s:7:\"project\";s:13:\"admin_toolbar\";s:9:\"datestamp\";i:1558552277;s:16:\"_info_file_ctime\";i:1561188444;}s:9:\"datestamp\";i:1558552277;s:8:\"includes\";a:2:{s:13:\"admin_toolbar\";s:13:\"Admin Toolbar\";s:19:\"admin_toolbar_tools\";s:25:\"Admin Toolbar Extra Tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:8:\"8.x-1.27\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Admin Toolbar\";s:4:\"link\";s:44:\"https://www.drupal.org/project/admin_toolbar\";s:4:\"also\";a:1:{i:2;s:13:\"8.x-2.0-beta2\";}s:8:\"releases\";a:2:{s:13:\"8.x-2.0-beta2\";a:15:{s:4:\"name\";s:27:\"admin_toolbar 8.x-2.0-beta2\";s:7:\"version\";s:13:\"8.x-2.0-beta2\";s:3:\"tag\";s:13:\"8.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-2.0-beta2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1567506785\";s:6:\"mdhash\";s:32:\"86581597bc42b7c2bb7a4412451586b2\";s:8:\"filesize\";s:5:\"38487\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:8:\"8.x-1.27\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.27\";s:7:\"version\";s:8:\"8.x-1.27\";s:3:\"tag\";s:8:\"8.x-1.27\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"27\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.27\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.27.tar.gz\";s:4:\"date\";s:10:\"1558552081\";s:6:\"mdhash\";s:32:\"4764c3adcb55fb765ab2f4fb47a1496f\";s:8:\"filesize\";s:5:\"32351\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:14:\"latest_version\";s:8:\"8.x-1.27\";s:11:\"recommended\";s:8:\"8.x-1.27\";s:6:\"status\";i:5;}s:8:\"commerce\";a:15:{s:4:\"name\";s:8:\"commerce\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Commerce\";s:7:\"package\";s:8:\"Commerce\";s:7:\"version\";s:8:\"8.x-2.14\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";i:1567123389;s:16:\"_info_file_ctime\";i:1569482253;}s:9:\"datestamp\";i:1567123389;s:8:\"includes\";a:11:{s:8:\"commerce\";s:8:\"Commerce\";s:13:\"commerce_cart\";s:13:\"Commerce Cart\";s:17:\"commerce_checkout\";s:17:\"Commerce Checkout\";s:12:\"commerce_log\";s:12:\"Commerce Log\";s:14:\"commerce_order\";s:14:\"Commerce Order\";s:16:\"commerce_payment\";s:16:\"Commerce Payment\";s:24:\"commerce_payment_example\";s:24:\"Commerce Payment Example\";s:14:\"commerce_price\";s:14:\"Commerce Price\";s:16:\"commerce_product\";s:16:\"Commerce Product\";s:18:\"commerce_promotion\";s:18:\"Commerce Promotion\";s:14:\"commerce_store\";s:14:\"Commerce Store\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:8:\"8.x-2.14\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:15:\"Drupal Commerce\";s:4:\"link\";s:39:\"https://www.drupal.org/project/commerce\";s:14:\"latest_version\";s:8:\"8.x-2.14\";s:8:\"releases\";a:1:{s:8:\"8.x-2.14\";a:14:{s:4:\"name\";s:17:\"commerce 8.x-2.14\";s:7:\"version\";s:8:\"8.x-2.14\";s:3:\"tag\";s:8:\"8.x-2.14\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/8.x-2.14\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.14.tar.gz\";s:4:\"date\";s:10:\"1567123385\";s:6:\"mdhash\";s:32:\"312b94029707c99e9bb7e74906bcd44f\";s:8:\"filesize\";s:6:\"585830\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"8.x-2.14\";s:6:\"status\";i:5;}s:28:\"commerce_variation_cart_form\";a:15:{s:4:\"name\";s:28:\"commerce_variation_cart_form\";s:4:\"info\";a:6:{s:4:\"name\";s:28:\"Commerce Variation Cart Form\";s:7:\"package\";s:8:\"Commerce\";s:7:\"version\";s:7:\"8.x-1.1\";s:7:\"project\";s:28:\"commerce_variation_cart_form\";s:9:\"datestamp\";i:1540849084;s:16:\"_info_file_ctime\";i:1561188471;}s:9:\"datestamp\";i:1540849084;s:8:\"includes\";a:1:{s:28:\"commerce_variation_cart_form\";s:28:\"Commerce Variation Cart Form\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:28:\"Commerce Variation Cart Form\";s:4:\"link\";s:59:\"https://www.drupal.org/project/commerce_variation_cart_form\";s:14:\"latest_version\";s:7:\"8.x-1.1\";s:8:\"releases\";a:1:{s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:36:\"commerce_variation_cart_form 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/commerce_variation_cart_form/releases/8.x-1.1\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/commerce_variation_cart_form-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1540849081\";s:6:\"mdhash\";s:32:\"f9ff8cfa9377dd2d61814907eb387269\";s:8:\"filesize\";s:5:\"11269\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.1\";s:6:\"status\";i:5;}s:13:\"config_update\";a:15:{s:4:\"name\";s:13:\"config_update\";s:4:\"info\";a:6:{s:4:\"name\";s:25:\"Configuration Update Base\";s:7:\"version\";s:7:\"8.x-1.6\";s:7:\"project\";s:13:\"config_update\";s:9:\"datestamp\";i:1545090489;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1561188479;}s:9:\"datestamp\";i:1545090489;s:8:\"includes\";a:1:{s:13:\"config_update\";s:25:\"Configuration Update Base\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.6\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:28:\"Configuration Update Manager\";s:4:\"link\";s:44:\"https://www.drupal.org/project/config_update\";s:14:\"latest_version\";s:7:\"8.x-1.6\";s:8:\"releases\";a:1:{s:7:\"8.x-1.6\";a:14:{s:4:\"name\";s:21:\"config_update 8.x-1.6\";s:7:\"version\";s:7:\"8.x-1.6\";s:3:\"tag\";s:7:\"8.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/config_update/releases/8.x-1.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/config_update-8.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1545090480\";s:6:\"mdhash\";s:32:\"00cbe9042443c598b2e59c1d2e258020\";s:8:\"filesize\";s:5:\"37717\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.6\";s:6:\"status\";i:5;}s:6:\"ctools\";a:15:{s:4:\"name\";s:6:\"ctools\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Chaos Tools\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"8.x-3.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";i:1550728390;s:16:\"_info_file_ctime\";i:1561188488;}s:9:\"datestamp\";i:1550728390;s:8:\"includes\";a:1:{s:6:\"ctools\";s:11:\"Chaos Tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-3.2\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:25:\"Chaos Tool Suite (ctools)\";s:4:\"link\";s:37:\"https://www.drupal.org/project/ctools\";s:14:\"latest_version\";s:7:\"8.x-3.2\";s:8:\"releases\";a:1:{s:7:\"8.x-3.2\";a:14:{s:4:\"name\";s:14:\"ctools 8.x-3.2\";s:7:\"version\";s:7:\"8.x-3.2\";s:3:\"tag\";s:7:\"8.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/8.x-3.2\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1550728386\";s:6:\"mdhash\";s:32:\"57c8584c28731d511771431b2149c55a\";s:8:\"filesize\";s:5:\"76830\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-3.2\";s:6:\"status\";i:5;}s:10:\"dropzonejs\";a:15:{s:4:\"name\";s:10:\"dropzonejs\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"dropzonejs\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:14:\"8.x-2.0-alpha4\";s:7:\"project\";s:10:\"dropzonejs\";s:9:\"datestamp\";i:1555407787;s:16:\"_info_file_ctime\";i:1561188504;}s:9:\"datestamp\";i:1555407787;s:8:\"includes\";a:2:{s:10:\"dropzonejs\";s:10:\"dropzonejs\";s:20:\"dropzonejs_eb_widget\";s:32:\"DropzoneJS entity browser widget\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:14:\"8.x-2.0-alpha4\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"dropzonejs\";s:4:\"link\";s:41:\"https://www.drupal.org/project/dropzonejs\";s:14:\"latest_version\";s:14:\"8.x-2.0-alpha4\";s:8:\"releases\";a:1:{s:14:\"8.x-2.0-alpha4\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-2.0-alpha4\";s:7:\"version\";s:14:\"8.x-2.0-alpha4\";s:3:\"tag\";s:14:\"8.x-2.0-alpha4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-2.0-alpha4\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-2.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1555407785\";s:6:\"mdhash\";s:32:\"6f931e9d9a21c40763395615552937b2\";s:8:\"filesize\";s:5:\"33871\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:14:\"8.x-2.0-alpha4\";s:6:\"status\";i:5;}s:5:\"embed\";a:15:{s:4:\"name\";s:5:\"embed\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Embed\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:5:\"embed\";s:9:\"datestamp\";i:1490755690;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1561188506;}s:9:\"datestamp\";i:1490755690;s:8:\"includes\";a:1:{s:5:\"embed\";s:5:\"Embed\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.0\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:5:\"Embed\";s:4:\"link\";s:36:\"https://www.drupal.org/project/embed\";s:14:\"latest_version\";s:7:\"8.x-1.0\";s:8:\"releases\";a:1:{s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:13:\"embed 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/embed/releases/8.x-1.0\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/embed-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1490755685\";s:6:\"mdhash\";s:32:\"3f6b11099638096943de23c78614f769\";s:8:\"filesize\";s:5:\"28909\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.0\";s:6:\"status\";i:5;}s:6:\"entity\";a:15:{s:4:\"name\";s:6:\"entity\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Entity\";s:7:\"version\";s:11:\"8.x-1.0-rc3\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";i:1559579890;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1561188450;}s:9:\"datestamp\";i:1559579890;s:8:\"includes\";a:1:{s:6:\"entity\";s:6:\"Entity\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:11:\"8.x-1.0-rc3\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Entity API\";s:4:\"link\";s:37:\"https://www.drupal.org/project/entity\";s:14:\"latest_version\";s:11:\"8.x-1.0-rc3\";s:8:\"releases\";a:1:{s:11:\"8.x-1.0-rc3\";a:15:{s:4:\"name\";s:18:\"entity 8.x-1.0-rc3\";s:7:\"version\";s:11:\"8.x-1.0-rc3\";s:3:\"tag\";s:11:\"8.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-1.0-rc3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1559579884\";s:6:\"mdhash\";s:32:\"e766dc9300a894a2ef3a44ee3446dc0f\";s:8:\"filesize\";s:5:\"58627\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:11:\"8.x-1.0-rc3\";s:6:\"status\";i:5;}s:14:\"entity_browser\";a:15:{s:4:\"name\";s:14:\"entity_browser\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Entity Browser\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:7:\"8.x-2.2\";s:7:\"project\";s:14:\"entity_browser\";s:9:\"datestamp\";i:1562240594;s:16:\"_info_file_ctime\";i:1569482259;}s:9:\"datestamp\";i:1562240594;s:8:\"includes\";a:1:{s:14:\"entity_browser\";s:14:\"Entity Browser\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-2.2\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:14:\"Entity Browser\";s:4:\"link\";s:45:\"https://www.drupal.org/project/entity_browser\";s:14:\"latest_version\";s:7:\"8.x-2.2\";s:8:\"releases\";a:1:{s:7:\"8.x-2.2\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-2.2\";s:7:\"version\";s:7:\"8.x-2.2\";s:3:\"tag\";s:7:\"8.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-2.2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1562240585\";s:6:\"mdhash\";s:32:\"1060e1b7b5888b47c6753a7ee6c9f261\";s:8:\"filesize\";s:6:\"146692\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-2.2\";s:6:\"status\";i:5;}s:12:\"entity_embed\";a:15:{s:4:\"name\";s:12:\"entity_embed\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"Entity Embed\";s:7:\"package\";s:7:\"Filters\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:12:\"entity_embed\";s:9:\"datestamp\";i:1561765985;s:16:\"_info_file_ctime\";i:1570954768;}s:9:\"datestamp\";i:1561765985;s:8:\"includes\";a:1:{s:12:\"entity_embed\";s:12:\"Entity Embed\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.0\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:12:\"Entity Embed\";s:4:\"link\";s:43:\"https://www.drupal.org/project/entity_embed\";s:14:\"latest_version\";s:7:\"8.x-1.0\";s:8:\"releases\";a:1:{s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:20:\"entity_embed 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1561765981\";s:6:\"mdhash\";s:32:\"2fa88b1fb68f68013f0d9327ecfe6741\";s:8:\"filesize\";s:5:\"82291\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.0\";s:6:\"status\";i:5;}s:26:\"entity_reference_revisions\";a:15:{s:4:\"name\";s:26:\"entity_reference_revisions\";s:4:\"info\";a:6:{s:4:\"name\";s:26:\"Entity Reference Revisions\";s:7:\"package\";s:11:\"Field types\";s:7:\"version\";s:7:\"8.x-1.7\";s:7:\"project\";s:26:\"entity_reference_revisions\";s:9:\"datestamp\";i:1570284190;s:16:\"_info_file_ctime\";i:1570954076;}s:9:\"datestamp\";i:1570284190;s:8:\"includes\";a:1:{s:26:\"entity_reference_revisions\";s:26:\"Entity Reference Revisions\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.7\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:26:\"Entity Reference Revisions\";s:4:\"link\";s:57:\"https://www.drupal.org/project/entity_reference_revisions\";s:14:\"latest_version\";s:7:\"8.x-1.7\";s:8:\"releases\";a:1:{s:7:\"8.x-1.7\";a:14:{s:4:\"name\";s:34:\"entity_reference_revisions 8.x-1.7\";s:7:\"version\";s:7:\"8.x-1.7\";s:3:\"tag\";s:7:\"8.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.7\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1570284187\";s:6:\"mdhash\";s:32:\"3faf914f92235891bac7ffaa58e55845\";s:8:\"filesize\";s:5:\"50642\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.7\";s:6:\"status\";i:5;}s:11:\"field_group\";a:15:{s:4:\"name\";s:11:\"field_group\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Field Group\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:11:\"8.x-3.0-rc1\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";i:1558647188;s:16:\"_info_file_ctime\";i:1570954765;}s:9:\"datestamp\";i:1558647188;s:8:\"includes\";a:1:{s:11:\"field_group\";s:11:\"Field Group\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:11:\"8.x-3.0-rc1\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Field Group\";s:4:\"link\";s:42:\"https://www.drupal.org/project/field_group\";s:14:\"latest_version\";s:11:\"8.x-3.0-rc1\";s:8:\"releases\";a:1:{s:11:\"8.x-3.0-rc1\";a:15:{s:4:\"name\";s:23:\"field_group 8.x-3.0-rc1\";s:7:\"version\";s:11:\"8.x-3.0-rc1\";s:3:\"tag\";s:11:\"8.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/8.x-3.0-rc1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-8.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1558647185\";s:6:\"mdhash\";s:32:\"984d39ea4b57b22834b80a807b5a29fe\";s:8:\"filesize\";s:5:\"54992\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:11:\"8.x-3.0-rc1\";s:6:\"status\";i:5;}s:12:\"file_browser\";a:15:{s:4:\"name\";s:12:\"file_browser\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"File Browser\";s:7:\"version\";s:7:\"8.x-1.2\";s:7:\"project\";s:12:\"file_browser\";s:9:\"datestamp\";i:1569940088;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1570954771;}s:9:\"datestamp\";i:1569940088;s:8:\"includes\";a:1:{s:12:\"file_browser\";s:12:\"File Browser\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:19:\"File Entity Browser\";s:4:\"link\";s:43:\"https://www.drupal.org/project/file_browser\";s:14:\"latest_version\";s:7:\"8.x-1.2\";s:8:\"releases\";a:1:{s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:20:\"file_browser 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/file_browser/releases/8.x-1.2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/file_browser-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1569940086\";s:6:\"mdhash\";s:32:\"93fb5980e3533dde73a94ea4bf2808b3\";s:8:\"filesize\";s:5:\"26468\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.2\";s:6:\"status\";i:5;}s:18:\"inline_entity_form\";a:15:{s:4:\"name\";s:18:\"inline_entity_form\";s:4:\"info\";a:6:{s:4:\"name\";s:18:\"Inline Entity Form\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:7:\"project\";s:18:\"inline_entity_form\";s:9:\"datestamp\";i:1568446687;s:16:\"_info_file_ctime\";i:1569482230;}s:9:\"datestamp\";i:1568446687;s:8:\"includes\";a:1:{s:18:\"inline_entity_form\";s:18:\"Inline Entity Form\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:11:\"8.x-1.0-rc2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:18:\"Inline Entity Form\";s:4:\"link\";s:49:\"https://www.drupal.org/project/inline_entity_form\";s:14:\"latest_version\";s:11:\"8.x-1.0-rc2\";s:8:\"releases\";a:1:{s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:30:\"inline_entity_form 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1568446684\";s:6:\"mdhash\";s:32:\"38963cefde9297ca1d29ecd2fe3cb8af\";s:8:\"filesize\";s:5:\"52831\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:11:\"8.x-1.0-rc2\";s:6:\"status\";i:5;}s:8:\"pathauto\";a:15:{s:4:\"name\";s:8:\"pathauto\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Pathauto\";s:7:\"version\";s:7:\"8.x-1.5\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";i:1570828089;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1570954033;}s:9:\"datestamp\";i:1570828089;s:8:\"includes\";a:1:{s:8:\"pathauto\";s:8:\"Pathauto\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Pathauto\";s:4:\"link\";s:39:\"https://www.drupal.org/project/pathauto\";s:14:\"latest_version\";s:7:\"8.x-1.5\";s:8:\"releases\";a:1:{s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:16:\"pathauto 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/8.x-1.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1570828084\";s:6:\"mdhash\";s:32:\"b782ac3aead58b688b6ce2ac9702f8c8\";s:8:\"filesize\";s:5:\"72836\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.5\";s:6:\"status\";i:5;}s:7:\"profile\";a:15:{s:4:\"name\";s:7:\"profile\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Profile\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:7:\"profile\";s:9:\"datestamp\";i:1567008312;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1569482228;}s:9:\"datestamp\";i:1567008312;s:8:\"includes\";a:1:{s:7:\"profile\";s:7:\"Profile\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.0\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:7:\"Profile\";s:4:\"link\";s:38:\"https://www.drupal.org/project/profile\";s:14:\"latest_version\";s:7:\"8.x-1.0\";s:8:\"releases\";a:1:{s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:15:\"profile 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/profile/releases/8.x-1.0\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1567007888\";s:6:\"mdhash\";s:32:\"6904fa1fac9c6b51b4b44cf8cd149588\";s:8:\"filesize\";s:5:\"43976\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.0\";s:6:\"status\";i:5;}s:9:\"shortcode\";a:15:{s:4:\"name\";s:9:\"shortcode\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Shortcode\";s:7:\"package\";s:13:\"Input filters\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";i:1543219089;s:16:\"_info_file_ctime\";i:1561188502;}s:9:\"datestamp\";i:1543219089;s:8:\"includes\";a:1:{s:9:\"shortcode\";s:9:\"Shortcode\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:11:\"8.x-1.0-rc2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:9:\"Shortcode\";s:4:\"link\";s:40:\"https://www.drupal.org/project/shortcode\";s:14:\"latest_version\";s:11:\"8.x-1.0-rc2\";s:8:\"releases\";a:1:{s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:21:\"shortcode 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/shortcode/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/shortcode-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1543219084\";s:6:\"mdhash\";s:32:\"bba2c3405ea5fa9f2e01f4f562b043e4\";s:8:\"filesize\";s:5:\"21978\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:11:\"8.x-1.0-rc2\";s:6:\"status\";i:5;}s:13:\"state_machine\";a:15:{s:4:\"name\";s:13:\"state_machine\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"State Machine\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:7:\"project\";s:13:\"state_machine\";s:9:\"datestamp\";i:1542122587;s:16:\"_info_file_ctime\";i:1561188448;}s:9:\"datestamp\";i:1542122587;s:8:\"includes\";a:1:{s:13:\"state_machine\";s:13:\"State Machine\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:11:\"8.x-1.0-rc1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"State Machine\";s:4:\"link\";s:44:\"https://www.drupal.org/project/state_machine\";s:14:\"latest_version\";s:11:\"8.x-1.0-rc1\";s:8:\"releases\";a:1:{s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:25:\"state_machine 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/state_machine/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/state_machine-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1542122580\";s:6:\"mdhash\";s:32:\"1226d0bedbb21e5b0bd20ed152bea503\";s:8:\"filesize\";s:5:\"28718\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:11:\"8.x-1.0-rc1\";s:6:\"status\";i:5;}s:11:\"tb_megamenu\";a:17:{s:4:\"name\";s:11:\"tb_megamenu\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"TB Mega Menu\";s:7:\"package\";s:2:\"TB\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:7:\"project\";s:11:\"tb_megamenu\";s:9:\"datestamp\";i:1512972188;s:16:\"_info_file_ctime\";i:1538388817;}s:9:\"datestamp\";i:1512972188;s:8:\"includes\";a:1:{s:11:\"tb_megamenu\";s:12:\"TB Mega Menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:11:\"8.x-1.x-dev\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:3:\"dev\";s:5:\"title\";s:12:\"TB Mega Menu\";s:4:\"link\";s:42:\"https://www.drupal.org/project/tb_megamenu\";s:14:\"latest_version\";s:11:\"8.x-1.x-dev\";s:8:\"releases\";a:1:{s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"tb_megamenu 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/tb_megamenu/releases/8.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/tb_megamenu-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1512972185\";s:6:\"mdhash\";s:32:\"861fb268e45d6b1a85af1d552906c561\";s:8:\"filesize\";s:5:\"76214\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}s:11:\"dev_version\";s:11:\"8.x-1.x-dev\";s:11:\"recommended\";s:11:\"8.x-1.x-dev\";s:10:\"latest_dev\";s:11:\"8.x-1.x-dev\";s:6:\"status\";i:5;}s:5:\"token\";a:15:{s:4:\"name\";s:5:\"token\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Token\";s:7:\"version\";s:7:\"8.x-1.5\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";i:1537557488;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1561188486;}s:9:\"datestamp\";i:1537557488;s:8:\"includes\";a:1:{s:5:\"token\";s:5:\"Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:5:\"Token\";s:4:\"link\";s:36:\"https://www.drupal.org/project/token\";s:14:\"latest_version\";s:7:\"8.x-1.5\";s:8:\"releases\";a:1:{s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:13:\"token 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/8.x-1.5\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1537557481\";s:6:\"mdhash\";s:32:\"09660453693e0da015aea0afbaee7176\";s:8:\"filesize\";s:5:\"77551\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.5\";s:6:\"status\";i:5;}s:9:\"votingapi\";a:15:{s:4:\"name\";s:9:\"votingapi\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Voting API\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";i:1540711685;s:16:\"_info_file_ctime\";i:1561188493;}s:9:\"datestamp\";i:1540711685;s:8:\"includes\";a:1:{s:9:\"votingapi\";s:10:\"Voting API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:13:\"8.x-3.0-beta1\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Voting API\";s:4:\"link\";s:40:\"https://www.drupal.org/project/votingapi\";s:14:\"latest_version\";s:13:\"8.x-3.0-beta1\";s:8:\"releases\";a:1:{s:13:\"8.x-3.0-beta1\";a:15:{s:4:\"name\";s:23:\"votingapi 8.x-3.0-beta1\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:3:\"tag\";s:13:\"8.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/votingapi/releases/8.x-3.0-beta1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/votingapi-8.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1540711680\";s:6:\"mdhash\";s:32:\"d5f8f4eaf68fb0dfc7c1287f4846dbb7\";s:8:\"filesize\";s:5:\"35731\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:13:\"8.x-3.0-beta1\";s:6:\"status\";i:5;}s:7:\"webform\";a:15:{s:4:\"name\";s:7:\"webform\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"Webform Node\";s:7:\"package\";s:7:\"Webform\";s:7:\"version\";s:7:\"8.x-5.4\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";i:1566209294;s:16:\"_info_file_ctime\";i:1569482288;}s:9:\"datestamp\";i:1566209294;s:8:\"includes\";a:3:{s:12:\"webform_node\";s:12:\"Webform Node\";s:10:\"webform_ui\";s:10:\"Webform UI\";s:7:\"webform\";s:7:\"Webform\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-5.4\";s:14:\"existing_major\";s:1:\"5\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:7:\"Webform\";s:4:\"link\";s:38:\"https://www.drupal.org/project/webform\";s:14:\"latest_version\";s:11:\"8.x-5.5-rc2\";s:8:\"releases\";a:2:{s:11:\"8.x-5.5-rc2\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.5-rc2\";s:7:\"version\";s:11:\"8.x-5.5-rc2\";s:3:\"tag\";s:11:\"8.x-5.5-rc2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.5-rc2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.5-rc2.tar.gz\";s:4:\"date\";s:10:\"1570176784\";s:6:\"mdhash\";s:32:\"6148891f84d66007c72a9584afd021be\";s:8:\"filesize\";s:7:\"5483619\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"8.x-5.4\";a:14:{s:4:\"name\";s:15:\"webform 8.x-5.4\";s:7:\"version\";s:7:\"8.x-5.4\";s:3:\"tag\";s:7:\"8.x-5.4\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/8.x-5.4\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-8.x-5.4.tar.gz\";s:4:\"date\";s:10:\"1566209286\";s:6:\"mdhash\";s:32:\"0c9a7c815494a6e4543224a56c0ea4d9\";s:8:\"filesize\";s:7:\"6269596\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-5.4\";s:6:\"status\";i:5;}s:8:\"NikaDevs\";a:11:{s:4:\"name\";s:8:\"NikaDevs\";s:4:\"info\";a:6:{s:4:\"name\";s:23:\"NikaDevs Main Functions\";s:7:\"package\";s:8:\"NikaDevs\";s:7:\"version\";s:7:\"8.x-1.2\";s:7:\"project\";s:8:\"NikaDevs\";s:16:\"_info_file_ctime\";i:1538388166;s:9:\"datestamp\";i:0;}s:9:\"datestamp\";i:0;s:8:\"includes\";a:3:{s:12:\"nikadevs_cms\";s:23:\"NikaDevs Main Functions\";s:10:\"rhythm_cms\";s:22:\"Rhythm theme Functions\";s:17:\"rhythm_shortcodes\";s:23:\"Rhythm theme Shortcodes\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"No available releases found\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}',1570958811),

('update','update_project_projects','a:25:{s:6:\"drupal\";a:6:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Block\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.7.8\";s:7:\"project\";s:6:\"drupal\";s:16:\"_info_file_ctime\";i:1570954004;s:9:\"datestamp\";i:0;}s:9:\"datestamp\";i:0;s:8:\"includes\";a:39:{s:5:\"block\";s:5:\"Block\";s:13:\"block_content\";s:12:\"Custom Block\";s:10:\"breakpoint\";s:10:\"Breakpoint\";s:8:\"ckeditor\";s:8:\"CKEditor\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:6:\"config\";s:21:\"Configuration Manager\";s:7:\"contact\";s:7:\"Contact\";s:10:\"contextual\";s:16:\"Contextual Links\";s:8:\"datetime\";s:8:\"Datetime\";s:5:\"dblog\";s:16:\"Database Logging\";s:6:\"editor\";s:11:\"Text Editor\";s:5:\"field\";s:5:\"Field\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:3:\"hal\";s:3:\"HAL\";s:4:\"help\";s:4:\"Help\";s:5:\"image\";s:5:\"Image\";s:8:\"language\";s:8:\"Language\";s:4:\"link\";s:4:\"Link\";s:17:\"menu_link_content\";s:17:\"Custom Menu Links\";s:7:\"menu_ui\";s:7:\"Menu UI\";s:4:\"node\";s:4:\"Node\";s:7:\"options\";s:7:\"Options\";s:4:\"path\";s:4:\"Path\";s:4:\"rest\";s:20:\"RESTful Web Services\";s:6:\"search\";s:6:\"Search\";s:13:\"serialization\";s:13:\"Serialization\";s:8:\"shortcut\";s:8:\"Shortcut\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:7:\"toolbar\";s:7:\"Toolbar\";s:4:\"tour\";s:4:\"Tour\";s:6:\"update\";s:14:\"Update Manager\";s:4:\"user\";s:4:\"User\";s:5:\"views\";s:5:\"Views\";s:8:\"views_ui\";s:8:\"Views UI\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;}s:7:\"address\";a:6:{s:4:\"name\";s:7:\"address\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Address\";s:7:\"package\";s:11:\"Field types\";s:7:\"version\";s:7:\"8.x-1.7\";s:7:\"project\";s:7:\"address\";s:9:\"datestamp\";i:1559642892;s:16:\"_info_file_ctime\";i:1561188441;}s:9:\"datestamp\";i:1559642892;s:8:\"includes\";a:1:{s:7:\"address\";s:7:\"Address\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:13:\"admin_toolbar\";a:6:{s:4:\"name\";s:13:\"admin_toolbar\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Admin Toolbar\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:8:\"8.x-1.27\";s:7:\"project\";s:13:\"admin_toolbar\";s:9:\"datestamp\";i:1558552277;s:16:\"_info_file_ctime\";i:1561188444;}s:9:\"datestamp\";i:1558552277;s:8:\"includes\";a:2:{s:13:\"admin_toolbar\";s:13:\"Admin Toolbar\";s:19:\"admin_toolbar_tools\";s:25:\"Admin Toolbar Extra Tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:8:\"commerce\";a:6:{s:4:\"name\";s:8:\"commerce\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Commerce\";s:7:\"package\";s:8:\"Commerce\";s:7:\"version\";s:8:\"8.x-2.14\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";i:1567123389;s:16:\"_info_file_ctime\";i:1569482253;}s:9:\"datestamp\";i:1567123389;s:8:\"includes\";a:11:{s:8:\"commerce\";s:8:\"Commerce\";s:13:\"commerce_cart\";s:13:\"Commerce Cart\";s:17:\"commerce_checkout\";s:17:\"Commerce Checkout\";s:12:\"commerce_log\";s:12:\"Commerce Log\";s:14:\"commerce_order\";s:14:\"Commerce Order\";s:16:\"commerce_payment\";s:16:\"Commerce Payment\";s:24:\"commerce_payment_example\";s:24:\"Commerce Payment Example\";s:14:\"commerce_price\";s:14:\"Commerce Price\";s:16:\"commerce_product\";s:16:\"Commerce Product\";s:18:\"commerce_promotion\";s:18:\"Commerce Promotion\";s:14:\"commerce_store\";s:14:\"Commerce Store\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:28:\"commerce_variation_cart_form\";a:6:{s:4:\"name\";s:28:\"commerce_variation_cart_form\";s:4:\"info\";a:6:{s:4:\"name\";s:28:\"Commerce Variation Cart Form\";s:7:\"package\";s:8:\"Commerce\";s:7:\"version\";s:7:\"8.x-1.1\";s:7:\"project\";s:28:\"commerce_variation_cart_form\";s:9:\"datestamp\";i:1540849084;s:16:\"_info_file_ctime\";i:1561188471;}s:9:\"datestamp\";i:1540849084;s:8:\"includes\";a:1:{s:28:\"commerce_variation_cart_form\";s:28:\"Commerce Variation Cart Form\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:13:\"config_update\";a:6:{s:4:\"name\";s:13:\"config_update\";s:4:\"info\";a:6:{s:4:\"name\";s:25:\"Configuration Update Base\";s:7:\"version\";s:7:\"8.x-1.6\";s:7:\"project\";s:13:\"config_update\";s:9:\"datestamp\";i:1545090489;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1561188479;}s:9:\"datestamp\";i:1545090489;s:8:\"includes\";a:1:{s:13:\"config_update\";s:25:\"Configuration Update Base\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:6:\"ctools\";a:6:{s:4:\"name\";s:6:\"ctools\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Chaos Tools\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"8.x-3.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";i:1550728390;s:16:\"_info_file_ctime\";i:1561188488;}s:9:\"datestamp\";i:1550728390;s:8:\"includes\";a:1:{s:6:\"ctools\";s:11:\"Chaos Tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:10:\"dropzonejs\";a:6:{s:4:\"name\";s:10:\"dropzonejs\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"dropzonejs\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:14:\"8.x-2.0-alpha4\";s:7:\"project\";s:10:\"dropzonejs\";s:9:\"datestamp\";i:1555407787;s:16:\"_info_file_ctime\";i:1561188504;}s:9:\"datestamp\";i:1555407787;s:8:\"includes\";a:2:{s:10:\"dropzonejs\";s:10:\"dropzonejs\";s:20:\"dropzonejs_eb_widget\";s:32:\"DropzoneJS entity browser widget\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:5:\"embed\";a:6:{s:4:\"name\";s:5:\"embed\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Embed\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:5:\"embed\";s:9:\"datestamp\";i:1490755690;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1561188506;}s:9:\"datestamp\";i:1490755690;s:8:\"includes\";a:1:{s:5:\"embed\";s:5:\"Embed\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:6:\"entity\";a:6:{s:4:\"name\";s:6:\"entity\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Entity\";s:7:\"version\";s:11:\"8.x-1.0-rc3\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";i:1559579890;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1561188450;}s:9:\"datestamp\";i:1559579890;s:8:\"includes\";a:1:{s:6:\"entity\";s:6:\"Entity\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:14:\"entity_browser\";a:6:{s:4:\"name\";s:14:\"entity_browser\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Entity Browser\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:7:\"8.x-2.2\";s:7:\"project\";s:14:\"entity_browser\";s:9:\"datestamp\";i:1562240594;s:16:\"_info_file_ctime\";i:1569482259;}s:9:\"datestamp\";i:1562240594;s:8:\"includes\";a:1:{s:14:\"entity_browser\";s:14:\"Entity Browser\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:12:\"entity_embed\";a:6:{s:4:\"name\";s:12:\"entity_embed\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"Entity Embed\";s:7:\"package\";s:7:\"Filters\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:12:\"entity_embed\";s:9:\"datestamp\";i:1561765985;s:16:\"_info_file_ctime\";i:1570954768;}s:9:\"datestamp\";i:1561765985;s:8:\"includes\";a:1:{s:12:\"entity_embed\";s:12:\"Entity Embed\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:26:\"entity_reference_revisions\";a:6:{s:4:\"name\";s:26:\"entity_reference_revisions\";s:4:\"info\";a:6:{s:4:\"name\";s:26:\"Entity Reference Revisions\";s:7:\"package\";s:11:\"Field types\";s:7:\"version\";s:7:\"8.x-1.7\";s:7:\"project\";s:26:\"entity_reference_revisions\";s:9:\"datestamp\";i:1570284190;s:16:\"_info_file_ctime\";i:1570954076;}s:9:\"datestamp\";i:1570284190;s:8:\"includes\";a:1:{s:26:\"entity_reference_revisions\";s:26:\"Entity Reference Revisions\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:11:\"field_group\";a:6:{s:4:\"name\";s:11:\"field_group\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Field Group\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:11:\"8.x-3.0-rc1\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";i:1558647188;s:16:\"_info_file_ctime\";i:1570954765;}s:9:\"datestamp\";i:1558647188;s:8:\"includes\";a:1:{s:11:\"field_group\";s:11:\"Field Group\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:12:\"file_browser\";a:6:{s:4:\"name\";s:12:\"file_browser\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"File Browser\";s:7:\"version\";s:7:\"8.x-1.2\";s:7:\"project\";s:12:\"file_browser\";s:9:\"datestamp\";i:1569940088;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1570954771;}s:9:\"datestamp\";i:1569940088;s:8:\"includes\";a:1:{s:12:\"file_browser\";s:12:\"File Browser\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:18:\"inline_entity_form\";a:6:{s:4:\"name\";s:18:\"inline_entity_form\";s:4:\"info\";a:6:{s:4:\"name\";s:18:\"Inline Entity Form\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:7:\"project\";s:18:\"inline_entity_form\";s:9:\"datestamp\";i:1568446687;s:16:\"_info_file_ctime\";i:1569482230;}s:9:\"datestamp\";i:1568446687;s:8:\"includes\";a:1:{s:18:\"inline_entity_form\";s:18:\"Inline Entity Form\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:8:\"pathauto\";a:6:{s:4:\"name\";s:8:\"pathauto\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Pathauto\";s:7:\"version\";s:7:\"8.x-1.5\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";i:1570828089;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1570954033;}s:9:\"datestamp\";i:1570828089;s:8:\"includes\";a:1:{s:8:\"pathauto\";s:8:\"Pathauto\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:7:\"profile\";a:6:{s:4:\"name\";s:7:\"profile\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Profile\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:7:\"profile\";s:9:\"datestamp\";i:1567008312;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1569482228;}s:9:\"datestamp\";i:1567008312;s:8:\"includes\";a:1:{s:7:\"profile\";s:7:\"Profile\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:9:\"shortcode\";a:6:{s:4:\"name\";s:9:\"shortcode\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Shortcode\";s:7:\"package\";s:13:\"Input filters\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";i:1543219089;s:16:\"_info_file_ctime\";i:1561188502;}s:9:\"datestamp\";i:1543219089;s:8:\"includes\";a:1:{s:9:\"shortcode\";s:9:\"Shortcode\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:13:\"state_machine\";a:6:{s:4:\"name\";s:13:\"state_machine\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"State Machine\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:7:\"project\";s:13:\"state_machine\";s:9:\"datestamp\";i:1542122587;s:16:\"_info_file_ctime\";i:1561188448;}s:9:\"datestamp\";i:1542122587;s:8:\"includes\";a:1:{s:13:\"state_machine\";s:13:\"State Machine\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:11:\"tb_megamenu\";a:6:{s:4:\"name\";s:11:\"tb_megamenu\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"TB Mega Menu\";s:7:\"package\";s:2:\"TB\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:7:\"project\";s:11:\"tb_megamenu\";s:9:\"datestamp\";i:1512972188;s:16:\"_info_file_ctime\";i:1538388817;}s:9:\"datestamp\";i:1512972188;s:8:\"includes\";a:1:{s:11:\"tb_megamenu\";s:12:\"TB Mega Menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:5:\"token\";a:6:{s:4:\"name\";s:5:\"token\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Token\";s:7:\"version\";s:7:\"8.x-1.5\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";i:1537557488;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1561188486;}s:9:\"datestamp\";i:1537557488;s:8:\"includes\";a:1:{s:5:\"token\";s:5:\"Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:9:\"votingapi\";a:6:{s:4:\"name\";s:9:\"votingapi\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Voting API\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";i:1540711685;s:16:\"_info_file_ctime\";i:1561188493;}s:9:\"datestamp\";i:1540711685;s:8:\"includes\";a:1:{s:9:\"votingapi\";s:10:\"Voting API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:7:\"webform\";a:6:{s:4:\"name\";s:7:\"webform\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"Webform Node\";s:7:\"package\";s:7:\"Webform\";s:7:\"version\";s:7:\"8.x-5.4\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";i:1566209294;s:16:\"_info_file_ctime\";i:1569482288;}s:9:\"datestamp\";i:1566209294;s:8:\"includes\";a:3:{s:12:\"webform_node\";s:12:\"Webform Node\";s:10:\"webform_ui\";s:10:\"Webform UI\";s:7:\"webform\";s:7:\"Webform\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:8:\"NikaDevs\";a:6:{s:4:\"name\";s:8:\"NikaDevs\";s:4:\"info\";a:6:{s:4:\"name\";s:23:\"NikaDevs Main Functions\";s:7:\"package\";s:8:\"NikaDevs\";s:7:\"version\";s:7:\"8.x-1.2\";s:7:\"project\";s:8:\"NikaDevs\";s:16:\"_info_file_ctime\";i:1538388166;s:9:\"datestamp\";i:0;}s:9:\"datestamp\";i:0;s:8:\"includes\";a:3:{s:12:\"nikadevs_cms\";s:23:\"NikaDevs Main Functions\";s:10:\"rhythm_cms\";s:22:\"Rhythm theme Functions\";s:17:\"rhythm_shortcodes\";s:23:\"Rhythm theme Shortcodes\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}}',1570958811),

('update_available_releases','address','a:12:{s:5:\"title\";s:7:\"Address\";s:10:\"short_name\";s:7:\"address\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:38:\"https://www.drupal.org/project/address\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:17:{s:7:\"8.x-1.7\";a:14:{s:4:\"name\";s:15:\"address 8.x-1.7\";s:7:\"version\";s:7:\"8.x-1.7\";s:3:\"tag\";s:7:\"8.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/address/releases/8.x-1.7\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/address-8.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1559642884\";s:6:\"mdhash\";s:32:\"51b1362edb763c5a3600fa78ce33bf67\";s:8:\"filesize\";s:5:\"60153\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.6\";a:14:{s:4:\"name\";s:15:\"address 8.x-1.6\";s:7:\"version\";s:7:\"8.x-1.6\";s:3:\"tag\";s:7:\"8.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/address/releases/8.x-1.6\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/address-8.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1554334685\";s:6:\"mdhash\";s:32:\"8d716e5939aa951adaf4e2f50fbb7827\";s:8:\"filesize\";s:5:\"59667\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:15:\"address 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/address/releases/8.x-1.5\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/address-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1554332581\";s:6:\"mdhash\";s:32:\"4438715d1f08b9d54b03913c51159b42\";s:8:\"filesize\";s:5:\"59489\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:15:\"address 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/address/releases/8.x-1.4\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/address-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1527081784\";s:6:\"mdhash\";s:32:\"d5a7f35d820472b83a0a3dd0394a0ba3\";s:8:\"filesize\";s:5:\"57484\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.3\";a:14:{s:4:\"name\";s:15:\"address 8.x-1.3\";s:7:\"version\";s:7:\"8.x-1.3\";s:3:\"tag\";s:7:\"8.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/address/releases/8.x-1.3\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/address-8.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1511382784\";s:6:\"mdhash\";s:32:\"96183dba813f7b0ec24dc7e3ca6866db\";s:8:\"filesize\";s:5:\"55150\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:15:\"address 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/address/releases/8.x-1.2\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/address-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1505896144\";s:6:\"mdhash\";s:32:\"e5a45c1f6a93455040b2d3add8e79487\";s:8:\"filesize\";s:5:\"54353\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:15:\"address 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/address/releases/8.x-1.1\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/address-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1499893143\";s:6:\"mdhash\";s:32:\"b59a5ea14142ab02c9952597a6bb0c2a\";s:8:\"filesize\";s:5:\"54144\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:15:\"address 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/address/releases/8.x-1.0\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/address-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1495109886\";s:6:\"mdhash\";s:32:\"efa846d6554451b8d1dd74457aa726e5\";s:8:\"filesize\";s:5:\"53869\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.0-rc4\";a:15:{s:4:\"name\";s:19:\"address 8.x-1.0-rc4\";s:7:\"version\";s:11:\"8.x-1.0-rc4\";s:3:\"tag\";s:11:\"8.x-1.0-rc4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/address/releases/8.x-1.0-rc4\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/address-8.x-1.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1486736883\";s:6:\"mdhash\";s:32:\"72cfaea5ef73ddb4965b1cdd13c79d0c\";s:8:\"filesize\";s:5:\"51805\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc3\";a:15:{s:4:\"name\";s:19:\"address 8.x-1.0-rc3\";s:7:\"version\";s:11:\"8.x-1.0-rc3\";s:3:\"tag\";s:11:\"8.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/address/releases/8.x-1.0-rc3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/address-8.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1477581243\";s:6:\"mdhash\";s:32:\"12d6dbd2db2100ac83a88ff6ba75addd\";s:8:\"filesize\";s:5:\"51173\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:19:\"address 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/address/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/address-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1475679239\";s:6:\"mdhash\";s:32:\"7213e6f529b13917350a473563f62e41\";s:8:\"filesize\";s:5:\"51168\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:19:\"address 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/address/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/address-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1475059439\";s:6:\"mdhash\";s:32:\"bb6720b6658953d2370ebda3f7bfdb9d\";s:8:\"filesize\";s:5:\"49281\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta4\";a:15:{s:4:\"name\";s:21:\"address 8.x-1.0-beta4\";s:7:\"version\";s:13:\"8.x-1.0-beta4\";s:3:\"tag\";s:13:\"8.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/address/releases/8.x-1.0-beta4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/address-8.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1474548544\";s:6:\"mdhash\";s:32:\"3eba1c2efc313e45ea8ffd2cf4942749\";s:8:\"filesize\";s:5:\"51409\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta3\";a:15:{s:4:\"name\";s:21:\"address 8.x-1.0-beta3\";s:7:\"version\";s:13:\"8.x-1.0-beta3\";s:3:\"tag\";s:13:\"8.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/address/releases/8.x-1.0-beta3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/address-8.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1464896939\";s:6:\"mdhash\";s:32:\"841f45e372d19edecc4820cf15fbe9e4\";s:8:\"filesize\";s:5:\"50374\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta2\";a:15:{s:4:\"name\";s:21:\"address 8.x-1.0-beta2\";s:7:\"version\";s:13:\"8.x-1.0-beta2\";s:3:\"tag\";s:13:\"8.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/address/releases/8.x-1.0-beta2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/address-8.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1447452853\";s:6:\"mdhash\";s:32:\"6b70b8afbe2ad1831667bd38cda1d23e\";s:8:\"filesize\";s:5:\"45508\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:21:\"address 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/address/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/address-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1444922040\";s:6:\"mdhash\";s:32:\"14c05529e65fda47dacac34c5ed1742d\";s:8:\"filesize\";s:5:\"44913\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:19:\"address 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/address/releases/8.x-1.x-dev\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/address-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1561211585\";s:6:\"mdhash\";s:32:\"effeef6c0187589ef2fa47372d7cf3d2\";s:8:\"filesize\";s:5:\"60170\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952920;}',1571039320),

('update_available_releases','admin_toolbar','a:12:{s:5:\"title\";s:13:\"Admin Toolbar\";s:10:\"short_name\";s:13:\"admin_toolbar\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/admin_toolbar\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:32:{s:13:\"8.x-2.0-beta2\";a:15:{s:4:\"name\";s:27:\"admin_toolbar 8.x-2.0-beta2\";s:7:\"version\";s:13:\"8.x-2.0-beta2\";s:3:\"tag\";s:13:\"8.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-2.0-beta2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1567506785\";s:6:\"mdhash\";s:32:\"86581597bc42b7c2bb7a4412451586b2\";s:8:\"filesize\";s:5:\"38487\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta1\";a:15:{s:4:\"name\";s:27:\"admin_toolbar 8.x-2.0-beta1\";s:7:\"version\";s:13:\"8.x-2.0-beta1\";s:3:\"tag\";s:13:\"8.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-2.0-beta1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1562269081\";s:6:\"mdhash\";s:32:\"c51f18c8a63c4ab5c7c0ce8e815ca95f\";s:8:\"filesize\";s:5:\"38669\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:8:\"8.x-1.27\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.27\";s:7:\"version\";s:8:\"8.x-1.27\";s:3:\"tag\";s:8:\"8.x-1.27\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"27\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.27\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.27.tar.gz\";s:4:\"date\";s:10:\"1558552081\";s:6:\"mdhash\";s:32:\"4764c3adcb55fb765ab2f4fb47a1496f\";s:8:\"filesize\";s:5:\"32351\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.26\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.26\";s:7:\"version\";s:8:\"8.x-1.26\";s:3:\"tag\";s:8:\"8.x-1.26\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"26\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.26\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.26.tar.gz\";s:4:\"date\";s:10:\"1549218480\";s:6:\"mdhash\";s:32:\"a526bc964f8255a322ab00877860d919\";s:8:\"filesize\";s:5:\"29239\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.25\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.25\";s:7:\"version\";s:8:\"8.x-1.25\";s:3:\"tag\";s:8:\"8.x-1.25\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"25\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.25\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.25.tar.gz\";s:4:\"date\";s:10:\"1542915180\";s:6:\"mdhash\";s:32:\"c72eb4fffddff21ece965fcca4f287f3\";s:8:\"filesize\";s:5:\"29030\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.24\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.24\";s:7:\"version\";s:8:\"8.x-1.24\";s:3:\"tag\";s:8:\"8.x-1.24\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.24\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.24.tar.gz\";s:4:\"date\";s:10:\"1527522480\";s:6:\"mdhash\";s:32:\"90f0c3552293b49a5d5c83ea2c0d7ed9\";s:8:\"filesize\";s:5:\"28647\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.23\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.23\";s:7:\"version\";s:8:\"8.x-1.23\";s:3:\"tag\";s:8:\"8.x-1.23\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"23\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.23\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.23.tar.gz\";s:4:\"date\";s:10:\"1517936581\";s:6:\"mdhash\";s:32:\"e41453b57d5c4a674f1e0b3ef32e5f43\";s:8:\"filesize\";s:5:\"27642\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.22\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.22\";s:7:\"version\";s:8:\"8.x-1.22\";s:3:\"tag\";s:8:\"8.x-1.22\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.22\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.22.tar.gz\";s:4:\"date\";s:10:\"1514888585\";s:6:\"mdhash\";s:32:\"577c1c22202d7a96b4111be0a5345a6d\";s:8:\"filesize\";s:5:\"27919\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.21\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.21\";s:7:\"version\";s:8:\"8.x-1.21\";s:3:\"tag\";s:8:\"8.x-1.21\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.21\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.21.tar.gz\";s:4:\"date\";s:10:\"1511190785\";s:6:\"mdhash\";s:32:\"18fa6c2ee3188e88decb0f87f3d63017\";s:8:\"filesize\";s:5:\"28430\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.20\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.20\";s:7:\"version\";s:8:\"8.x-1.20\";s:3:\"tag\";s:8:\"8.x-1.20\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.20\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.20.tar.gz\";s:4:\"date\";s:10:\"1505199844\";s:6:\"mdhash\";s:32:\"9aea30bce87ba104ae5866cea15be36a\";s:8:\"filesize\";s:5:\"20056\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.19\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.19\";s:7:\"version\";s:8:\"8.x-1.19\";s:3:\"tag\";s:8:\"8.x-1.19\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.19\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.19.tar.gz\";s:4:\"date\";s:10:\"1491487683\";s:6:\"mdhash\";s:32:\"285aa36877c62fd0ef7fdd13e0f374f6\";s:8:\"filesize\";s:5:\"17480\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.18\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.18\";s:7:\"version\";s:8:\"8.x-1.18\";s:3:\"tag\";s:8:\"8.x-1.18\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.18\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.18.tar.gz\";s:4:\"date\";s:10:\"1480614184\";s:6:\"mdhash\";s:32:\"1d8c9725b32542175c061e90a46ae136\";s:8:\"filesize\";s:5:\"17333\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.17\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.17\";s:7:\"version\";s:8:\"8.x-1.17\";s:3:\"tag\";s:8:\"8.x-1.17\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.17\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.17.tar.gz\";s:4:\"date\";s:10:\"1472585039\";s:6:\"mdhash\";s:32:\"7927faff05a639b9f060f3ac9d876325\";s:8:\"filesize\";s:5:\"17298\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.16\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.16\";s:7:\"version\";s:8:\"8.x-1.16\";s:3:\"tag\";s:8:\"8.x-1.16\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.16\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.16.tar.gz\";s:4:\"date\";s:10:\"1469715839\";s:6:\"mdhash\";s:32:\"ed4987fe25797d0eb3169e0796edad4c\";s:8:\"filesize\";s:5:\"56888\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.15\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.15\";s:7:\"version\";s:8:\"8.x-1.15\";s:3:\"tag\";s:8:\"8.x-1.15\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.15\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.15.tar.gz\";s:4:\"date\";s:10:\"1464016832\";s:6:\"mdhash\";s:32:\"be65f31814b05a7206a055ec3a770cac\";s:8:\"filesize\";s:5:\"56304\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.14\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.14\";s:7:\"version\";s:8:\"8.x-1.14\";s:3:\"tag\";s:8:\"8.x-1.14\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.14\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.14.tar.gz\";s:4:\"date\";s:10:\"1454942939\";s:6:\"mdhash\";s:32:\"a6279a5c0abef11bbaffed25ee2ff64c\";s:8:\"filesize\";s:5:\"55563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.13\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.13\";s:7:\"version\";s:8:\"8.x-1.13\";s:3:\"tag\";s:8:\"8.x-1.13\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.13\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.13.tar.gz\";s:4:\"date\";s:10:\"1454405939\";s:6:\"mdhash\";s:32:\"105229e87e356865adb7230c5f6a0c71\";s:8:\"filesize\";s:5:\"55578\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.12\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.12\";s:7:\"version\";s:8:\"8.x-1.12\";s:3:\"tag\";s:8:\"8.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.12\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1454402339\";s:6:\"mdhash\";s:32:\"e95e8b66c6a9764bdf0a298fc57cf647\";s:8:\"filesize\";s:5:\"54209\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.11\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.11\";s:7:\"version\";s:8:\"8.x-1.11\";s:3:\"tag\";s:8:\"8.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.11\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1449833341\";s:6:\"mdhash\";s:32:\"42d44819ed5814df82424bae93673ec8\";s:8:\"filesize\";s:5:\"53738\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.10\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.10\";s:7:\"version\";s:8:\"8.x-1.10\";s:3:\"tag\";s:8:\"8.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.10\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1445350439\";s:6:\"mdhash\";s:32:\"8f9ece0f632a05f4fd27cf5d5625d584\";s:8:\"filesize\";s:5:\"53195\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.9\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.9\";s:7:\"version\";s:7:\"8.x-1.9\";s:3:\"tag\";s:7:\"8.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.9\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1438248239\";s:6:\"mdhash\";s:32:\"df66ec9d7f5a883d254959dafe20b2cc\";s:8:\"filesize\";s:5:\"53178\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.8\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.8\";s:7:\"version\";s:7:\"8.x-1.8\";s:3:\"tag\";s:7:\"8.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.8\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1437400139\";s:6:\"mdhash\";s:32:\"6c02ba9325a609f21f8ff5d9d81ac43d\";s:8:\"filesize\";s:5:\"55024\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.7\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.7\";s:7:\"version\";s:7:\"8.x-1.7\";s:3:\"tag\";s:7:\"8.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1434972483\";s:6:\"mdhash\";s:32:\"f67f8e5bb956a265b36cc630972bbbbc\";s:8:\"filesize\";s:5:\"55033\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.6\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.6\";s:7:\"version\";s:7:\"8.x-1.6\";s:3:\"tag\";s:7:\"8.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1433331481\";s:6:\"mdhash\";s:32:\"75d94008fd65df0285a0a8a77bdf43ca\";s:8:\"filesize\";s:5:\"54544\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1433329681\";s:6:\"mdhash\";s:32:\"917b4da157022c27304e3f5d14acc196\";s:8:\"filesize\";s:5:\"54555\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1432141381\";s:6:\"mdhash\";s:32:\"009fbd126930d4743dc7b8e666bdfe2d\";s:8:\"filesize\";s:5:\"54164\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.3\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.3\";s:7:\"version\";s:7:\"8.x-1.3\";s:3:\"tag\";s:7:\"8.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1432129285\";s:6:\"mdhash\";s:32:\"ceba69c98e70a4554ee328cdcba0f167\";s:8:\"filesize\";s:5:\"54186\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1432129285\";s:6:\"mdhash\";s:32:\"53d90b123cc2e5c44f5233b91fdb6cf0\";s:8:\"filesize\";s:5:\"54184\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1432048381\";s:6:\"mdhash\";s:32:\"251d1ba9c6bf596ceefaaaab12f5ab2a\";s:8:\"filesize\";s:5:\"54382\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1431018181\";s:6:\"mdhash\";s:32:\"f3612aa4b0e10f9a064f01babfc1c0b5\";s:8:\"filesize\";s:5:\"51544\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"8.x-2.x-dev\";a:14:{s:4:\"name\";s:25:\"admin_toolbar 8.x-2.x-dev\";s:7:\"version\";s:11:\"8.x-2.x-dev\";s:3:\"tag\";s:7:\"8.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-2.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1567701485\";s:6:\"mdhash\";s:32:\"c526a1adf467c71cdda592a05f3587ef\";s:8:\"filesize\";s:5:\"32406\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"admin_toolbar 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1567701780\";s:6:\"mdhash\";s:32:\"9f4bf7b2402dd065fd72a408a2feedb4\";s:8:\"filesize\";s:5:\"27197\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1570952920;}',1571039320),

('update_available_releases','commerce','a:12:{s:5:\"title\";s:15:\"Drupal Commerce\";s:10:\"short_name\";s:8:\"commerce\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/commerce\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:30:{s:8:\"8.x-2.14\";a:14:{s:4:\"name\";s:17:\"commerce 8.x-2.14\";s:7:\"version\";s:8:\"8.x-2.14\";s:3:\"tag\";s:8:\"8.x-2.14\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/8.x-2.14\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.14.tar.gz\";s:4:\"date\";s:10:\"1567123385\";s:6:\"mdhash\";s:32:\"312b94029707c99e9bb7e74906bcd44f\";s:8:\"filesize\";s:6:\"585830\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-2.13\";a:14:{s:4:\"name\";s:17:\"commerce 8.x-2.13\";s:7:\"version\";s:8:\"8.x-2.13\";s:3:\"tag\";s:8:\"8.x-2.13\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/8.x-2.13\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.13.tar.gz\";s:4:\"date\";s:10:\"1554337681\";s:6:\"mdhash\";s:32:\"78df343b0ebaf25ff6eef2408e406f37\";s:8:\"filesize\";s:6:\"557803\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-2.12\";a:14:{s:4:\"name\";s:17:\"commerce 8.x-2.12\";s:7:\"version\";s:8:\"8.x-2.12\";s:3:\"tag\";s:8:\"8.x-2.12\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/8.x-2.12\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.12.tar.gz\";s:4:\"date\";s:10:\"1550007780\";s:6:\"mdhash\";s:32:\"5bb98febc1b662bfb05040c8233d987b\";s:8:\"filesize\";s:6:\"554755\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-2.11\";a:14:{s:4:\"name\";s:17:\"commerce 8.x-2.11\";s:7:\"version\";s:8:\"8.x-2.11\";s:3:\"tag\";s:8:\"8.x-2.11\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/8.x-2.11\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.11.tar.gz\";s:4:\"date\";s:10:\"1541002980\";s:6:\"mdhash\";s:32:\"a37ea9b0b871c0ea3b08f9063b5cfc9d\";s:8:\"filesize\";s:6:\"532311\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-2.10\";a:14:{s:4:\"name\";s:17:\"commerce 8.x-2.10\";s:7:\"version\";s:8:\"8.x-2.10\";s:3:\"tag\";s:8:\"8.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/8.x-2.10\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1539610080\";s:6:\"mdhash\";s:32:\"fef48a1cd6da5be6d7198ada3163368a\";s:8:\"filesize\";s:6:\"529161\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.9\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.9\";s:7:\"version\";s:7:\"8.x-2.9\";s:3:\"tag\";s:7:\"8.x-2.9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.9\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.9.tar.gz\";s:4:\"date\";s:10:\"1535555880\";s:6:\"mdhash\";s:32:\"8605ffdb03364890a9c82555415cb7c1\";s:8:\"filesize\";s:6:\"512486\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.8\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.8\";s:7:\"version\";s:7:\"8.x-2.8\";s:3:\"tag\";s:7:\"8.x-2.8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.8\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.8.tar.gz\";s:4:\"date\";s:10:\"1531841621\";s:6:\"mdhash\";s:32:\"516720a4fc8817c9eb907f5bcc2eada5\";s:8:\"filesize\";s:6:\"506615\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.7\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.7\";s:7:\"version\";s:7:\"8.x-2.7\";s:3:\"tag\";s:7:\"8.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.7\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1527529080\";s:6:\"mdhash\";s:32:\"ab1b35932289359c48b7a99423751cf5\";s:8:\"filesize\";s:6:\"487265\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.6\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.6\";s:7:\"version\";s:7:\"8.x-2.6\";s:3:\"tag\";s:7:\"8.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.6\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1523023380\";s:6:\"mdhash\";s:32:\"90d6c738e1d25c5a8460fa6c8a5aee17\";s:8:\"filesize\";s:6:\"481300\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.5\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.5\";s:7:\"version\";s:7:\"8.x-2.5\";s:3:\"tag\";s:7:\"8.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1521118684\";s:6:\"mdhash\";s:32:\"29f09dceecda3d97305d3c85c8c05cc3\";s:8:\"filesize\";s:6:\"469721\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.4\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.4\";s:7:\"version\";s:7:\"8.x-2.4\";s:3:\"tag\";s:7:\"8.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1518472380\";s:6:\"mdhash\";s:32:\"d377107f25e3f2ec75fabcb18c6fb255\";s:8:\"filesize\";s:6:\"462499\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.3\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.3\";s:7:\"version\";s:7:\"8.x-2.3\";s:3:\"tag\";s:7:\"8.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1515610085\";s:6:\"mdhash\";s:32:\"edde7ade15ae8b40f4de3d442fe87f31\";s:8:\"filesize\";s:6:\"452652\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.2\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.2\";s:7:\"version\";s:7:\"8.x-2.2\";s:3:\"tag\";s:7:\"8.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1512585785\";s:6:\"mdhash\";s:32:\"c7811f121ea9446bca29420fd9153e80\";s:8:\"filesize\";s:6:\"448668\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.1\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.1\";s:7:\"version\";s:7:\"8.x-2.1\";s:3:\"tag\";s:7:\"8.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1509734284\";s:6:\"mdhash\";s:32:\"aae2388b14c4efd0705ccb4e1c843d5a\";s:8:\"filesize\";s:6:\"441821\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.0\";a:14:{s:4:\"name\";s:16:\"commerce 8.x-2.0\";s:7:\"version\";s:7:\"8.x-2.0\";s:3:\"tag\";s:7:\"8.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/8.x-2.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1505910843\";s:6:\"mdhash\";s:32:\"7c91ca1fc8473fe31676fc9fea3f558e\";s:8:\"filesize\";s:6:\"438537\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-2.0-rc3\";a:15:{s:4:\"name\";s:20:\"commerce 8.x-2.0-rc3\";s:7:\"version\";s:11:\"8.x-2.0-rc3\";s:3:\"tag\";s:11:\"8.x-2.0-rc3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-rc3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1505561044\";s:6:\"mdhash\";s:32:\"ad7fee0c9df2a47477e25b0d979357b0\";s:8:\"filesize\";s:6:\"438621\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-2.0-rc2\";a:15:{s:4:\"name\";s:20:\"commerce 8.x-2.0-rc2\";s:7:\"version\";s:11:\"8.x-2.0-rc2\";s:3:\"tag\";s:11:\"8.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1504208045\";s:6:\"mdhash\";s:32:\"3833b3775c06adb6928b51186d5dec84\";s:8:\"filesize\";s:6:\"430594\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-2.0-rc1\";a:15:{s:4:\"name\";s:20:\"commerce 8.x-2.0-rc1\";s:7:\"version\";s:11:\"8.x-2.0-rc1\";s:3:\"tag\";s:11:\"8.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1499899442\";s:6:\"mdhash\";s:32:\"4deae3c1e3cad1d51091eeaf62d3e3ac\";s:8:\"filesize\";s:6:\"420069\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta7\";a:15:{s:4:\"name\";s:22:\"commerce 8.x-2.0-beta7\";s:7:\"version\";s:13:\"8.x-2.0-beta7\";s:3:\"tag\";s:13:\"8.x-2.0-beta7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-beta7\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1494330484\";s:6:\"mdhash\";s:32:\"a527e7961cda3d2f9154e56f9a6c78c9\";s:8:\"filesize\";s:6:\"394343\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta6\";a:15:{s:4:\"name\";s:22:\"commerce 8.x-2.0-beta6\";s:7:\"version\";s:13:\"8.x-2.0-beta6\";s:3:\"tag\";s:13:\"8.x-2.0-beta6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-beta6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1489757884\";s:6:\"mdhash\";s:32:\"9a602fe619c9bb337c84744ea2680f4b\";s:8:\"filesize\";s:6:\"360612\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta5\";a:15:{s:4:\"name\";s:22:\"commerce 8.x-2.0-beta5\";s:7:\"version\";s:13:\"8.x-2.0-beta5\";s:3:\"tag\";s:13:\"8.x-2.0-beta5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-beta5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1482792184\";s:6:\"mdhash\";s:32:\"0ee4122770ab0a88062010a604d4a5ed\";s:8:\"filesize\";s:6:\"332626\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta4\";a:15:{s:4:\"name\";s:22:\"commerce 8.x-2.0-beta4\";s:7:\"version\";s:13:\"8.x-2.0-beta4\";s:3:\"tag\";s:13:\"8.x-2.0-beta4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-beta4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1480550583\";s:6:\"mdhash\";s:32:\"ee00ac6dfeb567f21321e0c9b472c75f\";s:8:\"filesize\";s:6:\"313886\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta3\";a:15:{s:4:\"name\";s:22:\"commerce 8.x-2.0-beta3\";s:7:\"version\";s:13:\"8.x-2.0-beta3\";s:3:\"tag\";s:13:\"8.x-2.0-beta3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-beta3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1477964040\";s:6:\"mdhash\";s:32:\"b0b50428d1659fbef9649228066ada77\";s:8:\"filesize\";s:6:\"307139\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta2\";a:15:{s:4:\"name\";s:22:\"commerce 8.x-2.0-beta2\";s:7:\"version\";s:13:\"8.x-2.0-beta2\";s:3:\"tag\";s:13:\"8.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1475773739\";s:6:\"mdhash\";s:32:\"b7f154de237cf36117a36d1de4b1443d\";s:8:\"filesize\";s:6:\"300120\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta1\";a:15:{s:4:\"name\";s:22:\"commerce 8.x-2.0-beta1\";s:7:\"version\";s:13:\"8.x-2.0-beta1\";s:3:\"tag\";s:13:\"8.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1475069339\";s:6:\"mdhash\";s:32:\"0200cf26c6591e2a712990300ae46c37\";s:8:\"filesize\";s:6:\"298587\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-2.0-alpha4\";a:15:{s:4:\"name\";s:23:\"commerce 8.x-2.0-alpha4\";s:7:\"version\";s:14:\"8.x-2.0-alpha4\";s:3:\"tag\";s:14:\"8.x-2.0-alpha4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-alpha4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1461882839\";s:6:\"mdhash\";s:32:\"2aad7571ff8edf2fd2d584407e23b366\";s:8:\"filesize\";s:6:\"182579\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-2.0-alpha3\";a:15:{s:4:\"name\";s:23:\"commerce 8.x-2.0-alpha3\";s:7:\"version\";s:14:\"8.x-2.0-alpha3\";s:3:\"tag\";s:14:\"8.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1456940339\";s:6:\"mdhash\";s:32:\"21bc07a0a5ead3e84af8459b0a470008\";s:8:\"filesize\";s:6:\"148261\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-2.0-alpha2\";a:15:{s:4:\"name\";s:23:\"commerce 8.x-2.0-alpha2\";s:7:\"version\";s:14:\"8.x-2.0-alpha2\";s:3:\"tag\";s:14:\"8.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1453477139\";s:6:\"mdhash\";s:32:\"0f07a502008280f3501e5ffc45d2e84f\";s:8:\"filesize\";s:6:\"129715\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-2.0-alpha1\";a:15:{s:4:\"name\";s:23:\"commerce 8.x-2.0-alpha1\";s:7:\"version\";s:14:\"8.x-2.0-alpha1\";s:3:\"tag\";s:14:\"8.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce/releases/8.x-2.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1451060939\";s:6:\"mdhash\";s:32:\"8ec9c5c65400816c9b4b05f9b0719756\";s:8:\"filesize\";s:6:\"117914\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.x-2.x-dev\";a:14:{s:4:\"name\";s:20:\"commerce 8.x-2.x-dev\";s:7:\"version\";s:11:\"8.x-2.x-dev\";s:3:\"tag\";s:7:\"8.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/commerce/releases/8.x-2.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/commerce-8.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570800485\";s:6:\"mdhash\";s:32:\"26612a96c6feba4a574697c7f300d535\";s:8:\"filesize\";s:6:\"621277\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952920;}',1571039320),

('update_available_releases','commerce_quantity_increments','a:12:{s:5:\"title\";s:28:\"Commerce Quantity Increments\";s:10:\"short_name\";s:28:\"commerce_quantity_increments\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:59:\"https://www.drupal.org/project/commerce_quantity_increments\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:5:{s:13:\"8.x-2.0-beta2\";a:15:{s:4:\"name\";s:42:\"commerce_quantity_increments 8.x-2.0-beta2\";s:7:\"version\";s:13:\"8.x-2.0-beta2\";s:3:\"tag\";s:13:\"8.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:82:\"https://www.drupal.org/project/commerce_quantity_increments/releases/8.x-2.0-beta2\";s:13:\"download_link\";s:87:\"https://ftp.drupal.org/files/projects/commerce_quantity_increments-8.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1476713639\";s:6:\"mdhash\";s:32:\"8f71f9f09ae4426bd10a2f4efc6055ab\";s:8:\"filesize\";s:4:\"9470\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:13:\"8.x-2.0-beta1\";a:15:{s:4:\"name\";s:42:\"commerce_quantity_increments 8.x-2.0-beta1\";s:7:\"version\";s:13:\"8.x-2.0-beta1\";s:3:\"tag\";s:13:\"8.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:82:\"https://www.drupal.org/project/commerce_quantity_increments/releases/8.x-2.0-beta1\";s:13:\"download_link\";s:87:\"https://ftp.drupal.org/files/projects/commerce_quantity_increments-8.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1476345839\";s:6:\"mdhash\";s:32:\"4c452bdca98b544316b397e8a630cba1\";s:8:\"filesize\";s:4:\"9454\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:14:\"8.x-2.0-alpha2\";a:15:{s:4:\"name\";s:43:\"commerce_quantity_increments 8.x-2.0-alpha2\";s:7:\"version\";s:14:\"8.x-2.0-alpha2\";s:3:\"tag\";s:14:\"8.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:83:\"https://www.drupal.org/project/commerce_quantity_increments/releases/8.x-2.0-alpha2\";s:13:\"download_link\";s:88:\"https://ftp.drupal.org/files/projects/commerce_quantity_increments-8.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1473937739\";s:6:\"mdhash\";s:32:\"b0d9f6b04d449965fd1af8ff7fa9c1d0\";s:8:\"filesize\";s:4:\"9464\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:14:\"8.x-2.0-alpha1\";a:15:{s:4:\"name\";s:43:\"commerce_quantity_increments 8.x-2.0-alpha1\";s:7:\"version\";s:14:\"8.x-2.0-alpha1\";s:3:\"tag\";s:14:\"8.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:83:\"https://www.drupal.org/project/commerce_quantity_increments/releases/8.x-2.0-alpha1\";s:13:\"download_link\";s:88:\"https://ftp.drupal.org/files/projects/commerce_quantity_increments-8.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1461779911\";s:6:\"mdhash\";s:32:\"900f723dd4cce6affc874b080b8cbad3\";s:8:\"filesize\";s:4:\"9308\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"8.x-2.x-dev\";a:14:{s:4:\"name\";s:40:\"commerce_quantity_increments 8.x-2.x-dev\";s:7:\"version\";s:11:\"8.x-2.x-dev\";s:3:\"tag\";s:7:\"8.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:80:\"https://www.drupal.org/project/commerce_quantity_increments/releases/8.x-2.x-dev\";s:13:\"download_link\";s:85:\"https://ftp.drupal.org/files/projects/commerce_quantity_increments-8.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1485981183\";s:6:\"mdhash\";s:32:\"053b7587d44522d06852d30357b4b10b\";s:8:\"filesize\";s:4:\"9465\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1507111525;}',1507197925),

('update_available_releases','commerce_variation_cart_form','a:12:{s:5:\"title\";s:28:\"Commerce Variation Cart Form\";s:10:\"short_name\";s:28:\"commerce_variation_cart_form\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:59:\"https://www.drupal.org/project/commerce_variation_cart_form\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:4:{s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:36:\"commerce_variation_cart_form 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/commerce_variation_cart_form/releases/8.x-1.1\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/commerce_variation_cart_form-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1540849081\";s:6:\"mdhash\";s:32:\"f9ff8cfa9377dd2d61814907eb387269\";s:8:\"filesize\";s:5:\"11269\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:36:\"commerce_variation_cart_form 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/commerce_variation_cart_form/releases/8.x-1.0\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/commerce_variation_cart_form-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1489697583\";s:6:\"mdhash\";s:32:\"fd2285f0cf3c176f3ce4c73afa5ea844\";s:8:\"filesize\";s:5:\"10269\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:42:\"commerce_variation_cart_form 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:82:\"https://www.drupal.org/project/commerce_variation_cart_form/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:87:\"https://ftp.drupal.org/files/projects/commerce_variation_cart_form-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1484084283\";s:6:\"mdhash\";s:32:\"99837669caa71e5031826166ee683f5f\";s:8:\"filesize\";s:5:\"10270\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:40:\"commerce_variation_cart_form 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:80:\"https://www.drupal.org/project/commerce_variation_cart_form/releases/8.x-1.x-dev\";s:13:\"download_link\";s:85:\"https://ftp.drupal.org/files/projects/commerce_variation_cart_form-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1569284584\";s:6:\"mdhash\";s:32:\"5e64486425220a5dac36e9c21162474e\";s:8:\"filesize\";s:5:\"11270\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952920;}',1571039320),

('update_available_releases','config_update','a:12:{s:5:\"title\";s:28:\"Configuration Update Manager\";s:10:\"short_name\";s:13:\"config_update\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/config_update\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:8:{s:7:\"8.x-1.6\";a:14:{s:4:\"name\";s:21:\"config_update 8.x-1.6\";s:7:\"version\";s:7:\"8.x-1.6\";s:3:\"tag\";s:7:\"8.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/config_update/releases/8.x-1.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/config_update-8.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1545090480\";s:6:\"mdhash\";s:32:\"00cbe9042443c598b2e59c1d2e258020\";s:8:\"filesize\";s:5:\"37717\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:21:\"config_update 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/config_update/releases/8.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/config_update-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1512514384\";s:6:\"mdhash\";s:32:\"62557c80c84c63aa8ce2924af93f8fa4\";s:8:\"filesize\";s:5:\"32372\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:21:\"config_update 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/config_update/releases/8.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/config_update-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1505755744\";s:6:\"mdhash\";s:32:\"2e29385b00e02402b9dfebded0537e34\";s:8:\"filesize\";s:5:\"30802\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.3\";a:14:{s:4:\"name\";s:21:\"config_update 8.x-1.3\";s:7:\"version\";s:7:\"8.x-1.3\";s:3:\"tag\";s:7:\"8.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/config_update/releases/8.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/config_update-8.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1484770683\";s:6:\"mdhash\";s:32:\"147d7a66a90072851a181d6cb1b82e69\";s:8:\"filesize\";s:5:\"28372\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:21:\"config_update 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/config_update/releases/8.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/config_update-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1477674962\";s:6:\"mdhash\";s:32:\"53a89222b0311b4803ebeff4fc9943b9\";s:8:\"filesize\";s:5:\"24944\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:21:\"config_update 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/config_update/releases/8.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/config_update-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1457466839\";s:6:\"mdhash\";s:32:\"216336e554731e2444d325b54a56e9ae\";s:8:\"filesize\";s:5:\"24812\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:21:\"config_update 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/config_update/releases/8.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/config_update-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1448913239\";s:6:\"mdhash\";s:32:\"40f0d7e63ebf679864d97fe7c83f0121\";s:8:\"filesize\";s:5:\"24402\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"config_update 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/config_update/releases/8.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/config_update-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1563564485\";s:6:\"mdhash\";s:32:\"4ef6af3e116ff015e85e91f1b5132306\";s:8:\"filesize\";s:5:\"41063\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1570952920;}',1571039320),

('update_available_releases','contribute','a:12:{s:5:\"title\";s:10:\"Contribute\";s:10:\"short_name\";s:10:\"contribute\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/contribute\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:9:{s:13:\"8.x-5.0-beta3\";a:15:{s:4:\"name\";s:24:\"contribute 8.x-5.0-beta3\";s:7:\"version\";s:13:\"8.x-5.0-beta3\";s:3:\"tag\";s:13:\"8.x-5.0-beta3\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/contribute/releases/8.x-5.0-beta3\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/contribute-8.x-5.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1515761285\";s:6:\"mdhash\";s:32:\"ca58cb94241ea28fdc5416a7e6ef565b\";s:8:\"filesize\";s:5:\"21102\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"8.x-5.0-beta2\";a:15:{s:4:\"name\";s:24:\"contribute 8.x-5.0-beta2\";s:7:\"version\";s:13:\"8.x-5.0-beta2\";s:3:\"tag\";s:13:\"8.x-5.0-beta2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/contribute/releases/8.x-5.0-beta2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/contribute-8.x-5.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1515732485\";s:6:\"mdhash\";s:32:\"c24db41b800527c9842cd544badf4c05\";s:8:\"filesize\";s:5:\"20482\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta7\";a:15:{s:4:\"name\";s:24:\"contribute 8.x-1.0-beta7\";s:7:\"version\";s:13:\"8.x-1.0-beta7\";s:3:\"tag\";s:13:\"8.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/contribute/releases/8.x-1.0-beta7\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/contribute-8.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1518634080\";s:6:\"mdhash\";s:32:\"d5d95ef57de6f724d98f894c2408afc1\";s:8:\"filesize\";s:5:\"23468\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta6\";a:15:{s:4:\"name\";s:24:\"contribute 8.x-1.0-beta6\";s:7:\"version\";s:13:\"8.x-1.0-beta6\";s:3:\"tag\";s:13:\"8.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/contribute/releases/8.x-1.0-beta6\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/contribute-8.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1518459480\";s:6:\"mdhash\";s:32:\"5c27bd80a6ed703af44bd787439d8555\";s:8:\"filesize\";s:5:\"38669\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta5\";a:15:{s:4:\"name\";s:24:\"contribute 8.x-1.0-beta5\";s:7:\"version\";s:13:\"8.x-1.0-beta5\";s:3:\"tag\";s:13:\"8.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/contribute/releases/8.x-1.0-beta5\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/contribute-8.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1516102985\";s:6:\"mdhash\";s:32:\"5101b7fac4c8308494a8f3900444bfb4\";s:8:\"filesize\";s:5:\"21507\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta4\";a:15:{s:4:\"name\";s:24:\"contribute 8.x-1.0-beta4\";s:7:\"version\";s:13:\"8.x-1.0-beta4\";s:3:\"tag\";s:13:\"8.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/contribute/releases/8.x-1.0-beta4\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/contribute-8.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1516060384\";s:6:\"mdhash\";s:32:\"d6cf5462da95b20ce9d44577126ef94f\";s:8:\"filesize\";s:5:\"21495\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta3\";a:15:{s:4:\"name\";s:24:\"contribute 8.x-1.0-beta3\";s:7:\"version\";s:13:\"8.x-1.0-beta3\";s:3:\"tag\";s:13:\"8.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/contribute/releases/8.x-1.0-beta3\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/contribute-8.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1515761285\";s:6:\"mdhash\";s:32:\"2bbdeeb3e1189dd7f34dbaf0fab2110d\";s:8:\"filesize\";s:5:\"21099\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:24:\"contribute 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/contribute/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/contribute-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1515697684\";s:6:\"mdhash\";s:32:\"ac9fb76f007fa58ec5f1084875fe7af1\";s:8:\"filesize\";s:5:\"20480\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"contribute 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/contribute/releases/8.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/contribute-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1526415780\";s:6:\"mdhash\";s:32:\"dec462db6d017706ee4e2ccc34feb336\";s:8:\"filesize\";s:5:\"23524\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1530001887;}',1530088287),

('update_available_releases','ctools','a:12:{s:5:\"title\";s:25:\"Chaos Tool Suite (ctools)\";s:10:\"short_name\";s:6:\"ctools\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/ctools\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:17:{s:7:\"8.x-3.2\";a:14:{s:4:\"name\";s:14:\"ctools 8.x-3.2\";s:7:\"version\";s:7:\"8.x-3.2\";s:3:\"tag\";s:7:\"8.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/8.x-3.2\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1550728386\";s:6:\"mdhash\";s:32:\"57c8584c28731d511771431b2149c55a\";s:8:\"filesize\";s:5:\"76830\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-3.1\";a:14:{s:4:\"name\";s:14:\"ctools 8.x-3.1\";s:7:\"version\";s:7:\"8.x-3.1\";s:3:\"tag\";s:7:\"8.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/8.x-3.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1549603381\";s:6:\"mdhash\";s:32:\"16f82fe483a20f8be3922902934c9d1f\";s:8:\"filesize\";s:5:\"76814\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-3.0\";a:14:{s:4:\"name\";s:14:\"ctools 8.x-3.0\";s:7:\"version\";s:7:\"8.x-3.0\";s:3:\"tag\";s:7:\"8.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/8.x-3.0\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1493401742\";s:6:\"mdhash\";s:32:\"a234f3c5b8565122c9d7e9898836cca5\";s:8:\"filesize\";s:5:\"67620\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"8.x-3.0-beta2\";a:15:{s:4:\"name\";s:20:\"ctools 8.x-3.0-beta2\";s:7:\"version\";s:13:\"8.x-3.0-beta2\";s:3:\"tag\";s:13:\"8.x-3.0-beta2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-beta2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1492545842\";s:6:\"mdhash\";s:32:\"153f10636cb12bec3dd194105a929394\";s:8:\"filesize\";s:5:\"67637\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta1\";a:15:{s:4:\"name\";s:20:\"ctools 8.x-3.0-beta1\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:3:\"tag\";s:13:\"8.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-beta1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1490677984\";s:6:\"mdhash\";s:32:\"5c5d7a95711796524c0dfca3a2275094\";s:8:\"filesize\";s:5:\"66613\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha27\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha27\";s:7:\"version\";s:15:\"8.x-3.0-alpha27\";s:3:\"tag\";s:15:\"8.x-3.0-alpha27\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha27\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha27\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha27.tar.gz\";s:4:\"date\";s:10:\"1471723439\";s:6:\"mdhash\";s:32:\"45e76add4da1c53af3e8e6708939499b\";s:8:\"filesize\";s:5:\"66407\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha26\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha26\";s:7:\"version\";s:15:\"8.x-3.0-alpha26\";s:3:\"tag\";s:15:\"8.x-3.0-alpha26\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha26\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha26\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha26.tar.gz\";s:4:\"date\";s:10:\"1462560839\";s:6:\"mdhash\";s:32:\"0cee1e5499c5715e143224b67bca3327\";s:8:\"filesize\";s:5:\"66197\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha25\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha25\";s:7:\"version\";s:15:\"8.x-3.0-alpha25\";s:3:\"tag\";s:15:\"8.x-3.0-alpha25\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha25\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha25\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha25.tar.gz\";s:4:\"date\";s:10:\"1459542839\";s:6:\"mdhash\";s:32:\"2f2e283e71df2c050c5f54c0ddefb872\";s:8:\"filesize\";s:5:\"66079\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha24\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha24\";s:7:\"version\";s:15:\"8.x-3.0-alpha24\";s:3:\"tag\";s:15:\"8.x-3.0-alpha24\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha24\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha24.tar.gz\";s:4:\"date\";s:10:\"1459129741\";s:6:\"mdhash\";s:32:\"fdd23f073f0fe4bbe8aa34ea609e6ad4\";s:8:\"filesize\";s:5:\"66066\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha23\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha23\";s:7:\"version\";s:15:\"8.x-3.0-alpha23\";s:3:\"tag\";s:15:\"8.x-3.0-alpha23\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha23\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha23\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha23.tar.gz\";s:4:\"date\";s:10:\"1454702339\";s:6:\"mdhash\";s:32:\"206a72b20ab1f54bb0f02c0a77576c12\";s:8:\"filesize\";s:5:\"55982\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha22\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha22\";s:7:\"version\";s:15:\"8.x-3.0-alpha22\";s:3:\"tag\";s:15:\"8.x-3.0-alpha22\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha22\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha22.tar.gz\";s:4:\"date\";s:10:\"1454448839\";s:6:\"mdhash\";s:32:\"57785807fef77cfb9d0c3eff3e4ea401\";s:8:\"filesize\";s:5:\"50239\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha21\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha21\";s:7:\"version\";s:15:\"8.x-3.0-alpha21\";s:3:\"tag\";s:15:\"8.x-3.0-alpha21\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha21\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha21.tar.gz\";s:4:\"date\";s:10:\"1452350939\";s:6:\"mdhash\";s:32:\"9372f5f7e8268cdaffbec5ca9a042b76\";s:8:\"filesize\";s:5:\"40150\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha20\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha20\";s:7:\"version\";s:15:\"8.x-3.0-alpha20\";s:3:\"tag\";s:15:\"8.x-3.0-alpha20\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha20\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha20.tar.gz\";s:4:\"date\";s:10:\"1450374240\";s:6:\"mdhash\";s:32:\"219ce8b21a047015169988aad5f6a578\";s:8:\"filesize\";s:5:\"40034\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha19\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha19\";s:7:\"version\";s:15:\"8.x-3.0-alpha19\";s:3:\"tag\";s:15:\"8.x-3.0-alpha19\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha19\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha19.tar.gz\";s:4:\"date\";s:10:\"1447863840\";s:6:\"mdhash\";s:32:\"a13ab80f7091ff78e022e8add3f2758d\";s:8:\"filesize\";s:5:\"37298\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:15:\"8.x-3.0-alpha18\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha18\";s:7:\"version\";s:15:\"8.x-3.0-alpha18\";s:3:\"tag\";s:15:\"8.x-3.0-alpha18\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha18\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha18.tar.gz\";s:4:\"date\";s:10:\"1446661740\";s:6:\"mdhash\";s:32:\"debd99609473bd8574fd3c413b7165d1\";s:8:\"filesize\";s:5:\"30076\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-3.0-alpha17\";a:15:{s:4:\"name\";s:22:\"ctools 8.x-3.0-alpha17\";s:7:\"version\";s:15:\"8.x-3.0-alpha17\";s:3:\"tag\";s:15:\"8.x-3.0-alpha17\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ctools/releases/8.x-3.0-alpha17\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.0-alpha17.tar.gz\";s:4:\"date\";s:10:\"1444426739\";s:6:\"mdhash\";s:32:\"00c49ae0fbd331e4e45ac85d1479000f\";s:8:\"filesize\";s:5:\"29171\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-3.x-dev\";a:14:{s:4:\"name\";s:18:\"ctools 8.x-3.x-dev\";s:7:\"version\";s:11:\"8.x-3.x-dev\";s:3:\"tag\";s:7:\"8.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/ctools/releases/8.x-3.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/ctools-8.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1569902885\";s:6:\"mdhash\";s:32:\"0d988974367369002b6fb8660312db9f\";s:8:\"filesize\";s:5:\"77258\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952920;}',1571039320),

('update_available_releases','default_content','a:12:{s:5:\"title\";s:22:\"Default Content for D8\";s:10:\"short_name\";s:15:\"default_content\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/default_content\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:8:{s:14:\"8.x-1.0-alpha7\";a:15:{s:4:\"name\";s:30:\"default_content 8.x-1.0-alpha7\";s:7:\"version\";s:14:\"8.x-1.0-alpha7\";s:3:\"tag\";s:14:\"8.x-1.0-alpha7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/default_content/releases/8.x-1.0-alpha7\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/default_content-8.x-1.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1508448545\";s:6:\"mdhash\";s:32:\"cea1e2305e07ffcb3677195eeeda6f80\";s:8:\"filesize\";s:5:\"21601\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha6\";a:15:{s:4:\"name\";s:30:\"default_content 8.x-1.0-alpha6\";s:7:\"version\";s:14:\"8.x-1.0-alpha6\";s:3:\"tag\";s:14:\"8.x-1.0-alpha6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/default_content/releases/8.x-1.0-alpha6\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/default_content-8.x-1.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1493675943\";s:6:\"mdhash\";s:32:\"f242ab55e852a71d5196b09c13f14dc6\";s:8:\"filesize\";s:5:\"21145\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha5\";a:15:{s:4:\"name\";s:30:\"default_content 8.x-1.0-alpha5\";s:7:\"version\";s:14:\"8.x-1.0-alpha5\";s:3:\"tag\";s:14:\"8.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/default_content/releases/8.x-1.0-alpha5\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/default_content-8.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1491843242\";s:6:\"mdhash\";s:32:\"46740336b269de40e3382638f6a1558c\";s:8:\"filesize\";s:5:\"19640\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha4\";a:15:{s:4:\"name\";s:30:\"default_content 8.x-1.0-alpha4\";s:7:\"version\";s:14:\"8.x-1.0-alpha4\";s:3:\"tag\";s:14:\"8.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/default_content/releases/8.x-1.0-alpha4\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/default_content-8.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1487293084\";s:6:\"mdhash\";s:32:\"cd33795c09eb77f0b8abe6fd02f7428e\";s:8:\"filesize\";s:5:\"19835\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:30:\"default_content 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/default_content/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/default_content-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1473976439\";s:6:\"mdhash\";s:32:\"f110cdb6b15fa41ee44f3c72e0086bd9\";s:8:\"filesize\";s:5:\"19443\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:30:\"default_content 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/default_content/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/default_content-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1443759240\";s:6:\"mdhash\";s:32:\"2a9c711ffb5e3252cae8c57bdbd61c8f\";s:8:\"filesize\";s:5:\"23784\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:30:\"default_content 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/default_content/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/default_content-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1443746640\";s:6:\"mdhash\";s:32:\"d3ebfb4c3caf49f04f85e596533c6159\";s:8:\"filesize\";s:5:\"23832\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:27:\"default_content 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/default_content/releases/8.x-1.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/default_content-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1520901180\";s:6:\"mdhash\";s:32:\"0520c9bdfb551241e8a3fd50d976775a\";s:8:\"filesize\";s:5:\"23186\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1530001886;}',1530088286),

('update_available_releases','devel','a:12:{s:5:\"title\";s:5:\"Devel\";s:10:\"short_name\";s:5:\"devel\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:36:\"https://www.drupal.org/project/devel\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:6:{s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:13:\"devel 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/8.x-1.0\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1502732044\";s:6:\"mdhash\";s:32:\"7e66dfa095003c3fe3ffff51bc9e7ac3\";s:8:\"filesize\";s:6:\"231010\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:17:\"devel 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/devel/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1492989244\";s:6:\"mdhash\";s:32:\"3fb7787ae517aee72b2b50c152a8fea7\";s:8:\"filesize\";s:6:\"224806\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:17:\"devel 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/devel/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1484837884\";s:6:\"mdhash\";s:32:\"fbe2662a425e20b16dd2b505fbc64ede\";s:8:\"filesize\";s:6:\"223924\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:19:\"devel 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/devel/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1480796583\";s:6:\"mdhash\";s:32:\"f5500c66cb0deb4ebaf6cdb82b68dc1d\";s:8:\"filesize\";s:6:\"209615\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:20:\"devel 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/devel/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1466777163\";s:6:\"mdhash\";s:32:\"88747fd4b074c0440cfe9c53b3f4f801\";s:8:\"filesize\";s:6:\"224157\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:17:\"devel 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/devel/releases/8.x-1.x-dev\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/devel-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1506605044\";s:6:\"mdhash\";s:32:\"da2f1ed55f875bc8fb994a84674b5af8\";s:8:\"filesize\";s:6:\"230714\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1507111524;}',1507197924),

('update_available_releases','dropzonejs','a:12:{s:5:\"title\";s:10:\"dropzonejs\";s:10:\"short_name\";s:10:\"dropzonejs\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/dropzonejs\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:15:{s:14:\"8.x-2.0-alpha4\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-2.0-alpha4\";s:7:\"version\";s:14:\"8.x-2.0-alpha4\";s:3:\"tag\";s:14:\"8.x-2.0-alpha4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-2.0-alpha4\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-2.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1555407785\";s:6:\"mdhash\";s:32:\"6f931e9d9a21c40763395615552937b2\";s:8:\"filesize\";s:5:\"33871\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-2.0-alpha3\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-2.0-alpha3\";s:7:\"version\";s:14:\"8.x-2.0-alpha3\";s:3:\"tag\";s:14:\"8.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-2.0-alpha3\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1513265285\";s:6:\"mdhash\";s:32:\"4bef2b5d5524a18090941f7a628604cb\";s:8:\"filesize\";s:5:\"33760\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-2.0-alpha2\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-2.0-alpha2\";s:7:\"version\";s:14:\"8.x-2.0-alpha2\";s:3:\"tag\";s:14:\"8.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-2.0-alpha2\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1509024243\";s:6:\"mdhash\";s:32:\"fdf9b491eacf1dd40024165f7285ae4c\";s:8:\"filesize\";s:5:\"33706\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-2.0-alpha1\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-2.0-alpha1\";s:7:\"version\";s:14:\"8.x-2.0-alpha1\";s:3:\"tag\";s:14:\"8.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-2.0-alpha1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1507619644\";s:6:\"mdhash\";s:32:\"7bbb42d812664c56149ba3b22dceaeb5\";s:8:\"filesize\";s:5:\"32180\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-1.0-alpha9\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-1.0-alpha9\";s:7:\"version\";s:14:\"8.x-1.0-alpha9\";s:3:\"tag\";s:14:\"8.x-1.0-alpha9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.0-alpha9\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.0-alpha9.tar.gz\";s:4:\"date\";s:10:\"1553860381\";s:6:\"mdhash\";s:32:\"6449641d2c8d5e6e3552870b8e6822b8\";s:8:\"filesize\";s:5:\"33412\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-1.0-alpha8\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-1.0-alpha8\";s:7:\"version\";s:14:\"8.x-1.0-alpha8\";s:3:\"tag\";s:14:\"8.x-1.0-alpha8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.0-alpha8\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.0-alpha8.tar.gz\";s:4:\"date\";s:10:\"1508835844\";s:6:\"mdhash\";s:32:\"486bc65b8d30edc0314b14cd840a46e5\";s:8:\"filesize\";s:5:\"33406\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-1.0-alpha7\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-1.0-alpha7\";s:7:\"version\";s:14:\"8.x-1.0-alpha7\";s:3:\"tag\";s:14:\"8.x-1.0-alpha7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.0-alpha7\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1495200183\";s:6:\"mdhash\";s:32:\"3eb751d4abe6fa845df12ac9a9365b47\";s:8:\"filesize\";s:5:\"32045\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-1.0-alpha6\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-1.0-alpha6\";s:7:\"version\";s:14:\"8.x-1.0-alpha6\";s:3:\"tag\";s:14:\"8.x-1.0-alpha6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.0-alpha6\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1490199183\";s:6:\"mdhash\";s:32:\"e0081993e633e38aac844c854999587f\";s:8:\"filesize\";s:5:\"31821\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-1.0-alpha5\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-1.0-alpha5\";s:7:\"version\";s:14:\"8.x-1.0-alpha5\";s:3:\"tag\";s:14:\"8.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.0-alpha5\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1487593983\";s:6:\"mdhash\";s:32:\"c5019b016499a485559ff88afc1edd85\";s:8:\"filesize\";s:5:\"31791\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-1.0-alpha4\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-1.0-alpha4\";s:7:\"version\";s:14:\"8.x-1.0-alpha4\";s:3:\"tag\";s:14:\"8.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.0-alpha4\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1487251383\";s:6:\"mdhash\";s:32:\"f4567cfe1b3b11d80dd7837dcb8c34fa\";s:8:\"filesize\";s:5:\"31200\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1478516039\";s:6:\"mdhash\";s:32:\"376a1cb93ed59bf06187f84b1fb2cf38\";s:8:\"filesize\";s:5:\"29021\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1470169139\";s:6:\"mdhash\";s:32:\"55ae802a7fe774adf07fa23a44ca0fec\";s:8:\"filesize\";s:5:\"26120\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:25:\"dropzonejs 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1458737041\";s:6:\"mdhash\";s:32:\"728720052d26e7cb79926d3602465a92\";s:8:\"filesize\";s:5:\"24283\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"8.x-2.x-dev\";a:14:{s:4:\"name\";s:22:\"dropzonejs 8.x-2.x-dev\";s:7:\"version\";s:11:\"8.x-2.x-dev\";s:3:\"tag\";s:7:\"8.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/dropzonejs/releases/8.x-2.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570537685\";s:6:\"mdhash\";s:32:\"e8394b8ec34702d4fa7c03ff73bd1670\";s:8:\"filesize\";s:5:\"33973\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"dropzonejs 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/dropzonejs/releases/8.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/dropzonejs-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1553860081\";s:6:\"mdhash\";s:32:\"22fd500cb94eaaef4f36c7a9412defb8\";s:8:\"filesize\";s:5:\"33420\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','drupal','a:12:{s:5:\"title\";s:11:\"Drupal core\";s:10:\"short_name\";s:6:\"drupal\";s:4:\"type\";s:12:\"project_core\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"8\";s:16:\"supported_majors\";s:1:\"8\";s:13:\"default_major\";s:1:\"8\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/drupal\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:159:{s:5:\"8.7.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.8\";s:7:\"version\";s:5:\"8.7.8\";s:3:\"tag\";s:5:\"8.7.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.8.tar.gz\";s:4:\"date\";s:10:\"1570044484\";s:6:\"mdhash\";s:32:\"f281eb14d8aabf0c3e78dd519ca4b640\";s:8:\"filesize\";s:8:\"17882836\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.7.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.7\";s:7:\"version\";s:5:\"8.7.7\";s:3:\"tag\";s:5:\"8.7.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.7.tar.gz\";s:4:\"date\";s:10:\"1567593185\";s:6:\"mdhash\";s:32:\"eda95eb4c6567049c661818ffe800d11\";s:8:\"filesize\";s:8:\"17873760\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.7.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.6\";s:7:\"version\";s:5:\"8.7.6\";s:3:\"tag\";s:5:\"8.7.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.6.tar.gz\";s:4:\"date\";s:10:\"1565206385\";s:6:\"mdhash\";s:32:\"484530915cbf6d96cb03379e3dda018e\";s:8:\"filesize\";s:8:\"17866782\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.7.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.5\";s:7:\"version\";s:5:\"8.7.5\";s:3:\"tag\";s:5:\"8.7.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.5.tar.gz\";s:4:\"date\";s:10:\"1563380885\";s:6:\"mdhash\";s:32:\"39cc326d9db1b4acce9b8716193189fd\";s:8:\"filesize\";s:8:\"17843250\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.7.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.4\";s:7:\"version\";s:5:\"8.7.4\";s:3:\"tag\";s:5:\"8.7.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.4.tar.gz\";s:4:\"date\";s:10:\"1562225587\";s:6:\"mdhash\";s:32:\"5bd5db96c8a4d017e940a43285f5166b\";s:8:\"filesize\";s:8:\"17843961\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.7.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.3\";s:7:\"version\";s:5:\"8.7.3\";s:3:\"tag\";s:5:\"8.7.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.3.tar.gz\";s:4:\"date\";s:10:\"1559762581\";s:6:\"mdhash\";s:32:\"bba896a1ed2fbe4a1744d82c036fcfc4\";s:8:\"filesize\";s:8:\"17825116\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.7.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.2\";s:7:\"version\";s:5:\"8.7.2\";s:3:\"tag\";s:5:\"8.7.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.2.tar.gz\";s:4:\"date\";s:10:\"1558597086\";s:6:\"mdhash\";s:32:\"f637a19f7d087e9f68e39470fd151a1d\";s:8:\"filesize\";s:8:\"17824323\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.7.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.1\";s:7:\"version\";s:5:\"8.7.1\";s:3:\"tag\";s:5:\"8.7.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.1.tar.gz\";s:4:\"date\";s:10:\"1557335588\";s:6:\"mdhash\";s:32:\"2cf2a1c93ea785c6ff91d29aebef2697\";s:8:\"filesize\";s:8:\"17811529\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.7.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.7.0\";s:7:\"version\";s:5:\"8.7.0\";s:3:\"tag\";s:5:\"8.7.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.7.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.7.0.tar.gz\";s:4:\"date\";s:10:\"1556737085\";s:6:\"mdhash\";s:32:\"f6135e49de6bc5b1f259ef3e76580dd0\";s:8:\"filesize\";s:8:\"17810235\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.7.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.7.0-rc1\";s:7:\"version\";s:9:\"8.7.0-rc1\";s:3:\"tag\";s:9:\"8.7.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.7.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.7.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1555603385\";s:6:\"mdhash\";s:32:\"b7477fa073172b87aba05c4c719110d1\";s:8:\"filesize\";s:8:\"17813252\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:4:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";i:3;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.7.0-beta2\";a:16:{s:4:\"name\";s:18:\"drupal 8.7.0-beta2\";s:7:\"version\";s:11:\"8.7.0-beta2\";s:3:\"tag\";s:11:\"8.7.0-beta2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.7.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.7.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1554684784\";s:6:\"mdhash\";s:32:\"5db26859ef816c440e2b1cf80bf65f31\";s:8:\"filesize\";s:8:\"17824386\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.7.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.7.0-beta1\";s:7:\"version\";s:11:\"8.7.0-beta1\";s:3:\"tag\";s:11:\"8.7.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.7.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.7.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1553881681\";s:6:\"mdhash\";s:32:\"fbcc7fe39bea4350ee36b3c3a3ec6e85\";s:8:\"filesize\";s:8:\"17820849\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.7.0-alpha2\";a:16:{s:4:\"name\";s:19:\"drupal 8.7.0-alpha2\";s:7:\"version\";s:12:\"8.7.0-alpha2\";s:3:\"tag\";s:12:\"8.7.0-alpha2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.7.0-alpha2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.7.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1553106180\";s:6:\"mdhash\";s:32:\"f465c5341a8b885aa18e7ddb7b02be37\";s:8:\"filesize\";s:8:\"17525832\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:12:\"8.7.0-alpha1\";a:16:{s:4:\"name\";s:19:\"drupal 8.7.0-alpha1\";s:7:\"version\";s:12:\"8.7.0-alpha1\";s:3:\"tag\";s:12:\"8.7.0-alpha1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.7.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.7.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1552602484\";s:6:\"mdhash\";s:32:\"9b1e011a63b60255f5029331c0eb0d19\";s:8:\"filesize\";s:8:\"17516533\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:6:\"8.6.17\";a:15:{s:4:\"name\";s:13:\"drupal 8.6.17\";s:7:\"version\";s:6:\"8.6.17\";s:3:\"tag\";s:6:\"8.6.17\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.6.17\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.6.17.tar.gz\";s:4:\"date\";s:10:\"1560756785\";s:6:\"mdhash\";s:32:\"9018a2d11381aeb0e269ca696fed9ac5\";s:8:\"filesize\";s:8:\"17149513\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.6.16\";a:15:{s:4:\"name\";s:13:\"drupal 8.6.16\";s:7:\"version\";s:6:\"8.6.16\";s:3:\"tag\";s:6:\"8.6.16\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.6.16\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.6.16.tar.gz\";s:4:\"date\";s:10:\"1557335588\";s:6:\"mdhash\";s:32:\"a0683ae0b0ea99845a6bf45383671cb9\";s:8:\"filesize\";s:8:\"17151378\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.6.15\";a:15:{s:4:\"name\";s:13:\"drupal 8.6.15\";s:7:\"version\";s:6:\"8.6.15\";s:3:\"tag\";s:6:\"8.6.15\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.6.15\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.6.15.tar.gz\";s:4:\"date\";s:10:\"1555533181\";s:6:\"mdhash\";s:32:\"85ae6b9f7309cc8564331fd77369dffd\";s:8:\"filesize\";s:8:\"17137689\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.6.14\";a:15:{s:4:\"name\";s:13:\"drupal 8.6.14\";s:7:\"version\";s:6:\"8.6.14\";s:3:\"tag\";s:6:\"8.6.14\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.6.14\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.6.14.tar.gz\";s:4:\"date\";s:10:\"1554688384\";s:6:\"mdhash\";s:32:\"04cf60554a5036c7a69c652e669461c3\";s:8:\"filesize\";s:8:\"17136296\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.6.13\";a:15:{s:4:\"name\";s:13:\"drupal 8.6.13\";s:7:\"version\";s:6:\"8.6.13\";s:3:\"tag\";s:6:\"8.6.13\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.6.13\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.6.13.tar.gz\";s:4:\"date\";s:10:\"1553099584\";s:6:\"mdhash\";s:32:\"ded84151ebda80826f18e924dab03edd\";s:8:\"filesize\";s:8:\"17137449\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.6.12\";a:15:{s:4:\"name\";s:13:\"drupal 8.6.12\";s:7:\"version\";s:6:\"8.6.12\";s:3:\"tag\";s:6:\"8.6.12\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.6.12\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.6.12.tar.gz\";s:4:\"date\";s:10:\"1552601584\";s:6:\"mdhash\";s:32:\"0bc838e3e3155141a9496481c382c182\";s:8:\"filesize\";s:8:\"17131830\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.6.11\";a:15:{s:4:\"name\";s:13:\"drupal 8.6.11\";s:7:\"version\";s:6:\"8.6.11\";s:3:\"tag\";s:6:\"8.6.11\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.6.11\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.6.11.tar.gz\";s:4:\"date\";s:10:\"1552511584\";s:6:\"mdhash\";s:32:\"9c2b33438b29df0395ff751b78cd1655\";s:8:\"filesize\";s:8:\"17134623\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.6.10\";a:15:{s:4:\"name\";s:13:\"drupal 8.6.10\";s:7:\"version\";s:6:\"8.6.10\";s:3:\"tag\";s:6:\"8.6.10\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.6.10\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.6.10.tar.gz\";s:4:\"date\";s:10:\"1550691784\";s:6:\"mdhash\";s:32:\"5aee2dacfb525f146fc28b4535066d1c\";s:8:\"filesize\";s:8:\"16858107\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.9\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.9\";s:7:\"version\";s:5:\"8.6.9\";s:3:\"tag\";s:5:\"8.6.9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.9\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.9.tar.gz\";s:4:\"date\";s:10:\"1549628580\";s:6:\"mdhash\";s:32:\"9455aeacf1faf24b3a12890a50198a5e\";s:8:\"filesize\";s:8:\"16857833\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.8\";s:7:\"version\";s:5:\"8.6.8\";s:3:\"tag\";s:5:\"8.6.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.8.tar.gz\";s:4:\"date\";s:10:\"1549466580\";s:6:\"mdhash\";s:32:\"5c8f5107e3831f6e6f55f17486dee5d2\";s:8:\"filesize\";s:8:\"16611985\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.7\";s:7:\"version\";s:5:\"8.6.7\";s:3:\"tag\";s:5:\"8.6.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.7.tar.gz\";s:4:\"date\";s:10:\"1547682180\";s:6:\"mdhash\";s:32:\"cd3d0c9ad1d9e976eb589a963e427388\";s:8:\"filesize\";s:8:\"16478439\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.6\";s:7:\"version\";s:5:\"8.6.6\";s:3:\"tag\";s:5:\"8.6.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.6.tar.gz\";s:4:\"date\";s:10:\"1547663557\";s:6:\"mdhash\";s:32:\"bdabe7ae149890555e176ba492b7b250\";s:8:\"filesize\";s:8:\"16478660\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.5\";s:7:\"version\";s:5:\"8.6.5\";s:3:\"tag\";s:5:\"8.6.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.5.tar.gz\";s:4:\"date\";s:10:\"1546467485\";s:6:\"mdhash\";s:32:\"3db4ab3674ae38d1b15d5faac3b10ff0\";s:8:\"filesize\";s:8:\"16465640\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.4\";s:7:\"version\";s:5:\"8.6.4\";s:3:\"tag\";s:5:\"8.6.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.4.tar.gz\";s:4:\"date\";s:10:\"1544011681\";s:6:\"mdhash\";s:32:\"455722dcf2c051232e6f9299725d11a3\";s:8:\"filesize\";s:8:\"16401179\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.3\";s:7:\"version\";s:5:\"8.6.3\";s:3:\"tag\";s:5:\"8.6.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.3.tar.gz\";s:4:\"date\";s:10:\"1541602684\";s:6:\"mdhash\";s:32:\"3a3b8e4326b493ed6c29188db40031ff\";s:8:\"filesize\";s:8:\"16372220\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.2\";s:7:\"version\";s:5:\"8.6.2\";s:3:\"tag\";s:5:\"8.6.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.2.tar.gz\";s:4:\"date\";s:10:\"1539816180\";s:6:\"mdhash\";s:32:\"46a42d70047dafd4b05e3dd050cea887\";s:8:\"filesize\";s:8:\"16240694\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.1\";s:7:\"version\";s:5:\"8.6.1\";s:3:\"tag\";s:5:\"8.6.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.1.tar.gz\";s:4:\"date\";s:10:\"1536585780\";s:6:\"mdhash\";s:32:\"fad034b129695c5066e892cd7cb02a11\";s:8:\"filesize\";s:8:\"16236559\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.0\";s:7:\"version\";s:5:\"8.6.0\";s:3:\"tag\";s:5:\"8.6.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.0.tar.gz\";s:4:\"date\";s:10:\"1536186480\";s:6:\"mdhash\";s:32:\"6d457c7e478574a5125f608f3d6b7fa5\";s:8:\"filesize\";s:8:\"16233161\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.6.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.6.0-rc1\";s:7:\"version\";s:9:\"8.6.0-rc1\";s:3:\"tag\";s:9:\"8.6.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.6.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.6.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1534532580\";s:6:\"mdhash\";s:32:\"5e842303187242e79b766a36160c0389\";s:8:\"filesize\";s:8:\"16230072\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.6.0-beta2\";a:16:{s:4:\"name\";s:18:\"drupal 8.6.0-beta2\";s:7:\"version\";s:11:\"8.6.0-beta2\";s:3:\"tag\";s:11:\"8.6.0-beta2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.6.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.6.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1533298080\";s:6:\"mdhash\";s:32:\"2387284145e34a19fc45e03c258a2831\";s:8:\"filesize\";s:8:\"16209911\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.6.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.6.0-beta1\";s:7:\"version\";s:11:\"8.6.0-beta1\";s:3:\"tag\";s:11:\"8.6.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.6.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.6.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1533270485\";s:6:\"mdhash\";s:32:\"3d70ae568dd8f7100082b8c58bc8d1fe\";s:8:\"filesize\";s:8:\"16209123\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.6.0-alpha1\";a:16:{s:4:\"name\";s:19:\"drupal 8.6.0-alpha1\";s:7:\"version\";s:12:\"8.6.0-alpha1\";s:3:\"tag\";s:12:\"8.6.0-alpha1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.6.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.6.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1532033881\";s:6:\"mdhash\";s:32:\"15cda0cacdf2287dfa44649d3fc590ef\";s:8:\"filesize\";s:8:\"16089229\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:6:\"8.5.15\";a:15:{s:4:\"name\";s:13:\"drupal 8.5.15\";s:7:\"version\";s:6:\"8.5.15\";s:3:\"tag\";s:6:\"8.5.15\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.5.15\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.5.15.tar.gz\";s:4:\"date\";s:10:\"1555533181\";s:6:\"mdhash\";s:32:\"7a4ba499132c834e5d33bccae5ac1430\";s:8:\"filesize\";s:8:\"15828193\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.5.14\";a:15:{s:4:\"name\";s:13:\"drupal 8.5.14\";s:7:\"version\";s:6:\"8.5.14\";s:3:\"tag\";s:6:\"8.5.14\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.5.14\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.5.14.tar.gz\";s:4:\"date\";s:10:\"1553099584\";s:6:\"mdhash\";s:32:\"9f3035984039e0a5de0ce899722b9941\";s:8:\"filesize\";s:8:\"15828327\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.5.13\";a:15:{s:4:\"name\";s:13:\"drupal 8.5.13\";s:7:\"version\";s:6:\"8.5.13\";s:3:\"tag\";s:6:\"8.5.13\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.5.13\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.5.13.tar.gz\";s:4:\"date\";s:10:\"1552601584\";s:6:\"mdhash\";s:32:\"31fc4a473b2096284969ff2d2590323e\";s:8:\"filesize\";s:8:\"15824763\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.5.12\";a:15:{s:4:\"name\";s:13:\"drupal 8.5.12\";s:7:\"version\";s:6:\"8.5.12\";s:3:\"tag\";s:6:\"8.5.12\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.5.12\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.5.12.tar.gz\";s:4:\"date\";s:10:\"1552511584\";s:6:\"mdhash\";s:32:\"91b4b708c231b098a52b15501ac3c4cf\";s:8:\"filesize\";s:8:\"15823223\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.5.11\";a:15:{s:4:\"name\";s:13:\"drupal 8.5.11\";s:7:\"version\";s:6:\"8.5.11\";s:3:\"tag\";s:6:\"8.5.11\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.5.11\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.5.11.tar.gz\";s:4:\"date\";s:10:\"1550691784\";s:6:\"mdhash\";s:32:\"356333785c71215d2e3ec0d4a4e018df\";s:8:\"filesize\";s:8:\"15817672\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:6:\"8.5.10\";a:15:{s:4:\"name\";s:13:\"drupal 8.5.10\";s:7:\"version\";s:6:\"8.5.10\";s:3:\"tag\";s:6:\"8.5.10\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.5.10\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.5.10.tar.gz\";s:4:\"date\";s:10:\"1547682180\";s:6:\"mdhash\";s:32:\"39e2b451d6bc6f58c4eeb09ad26ad965\";s:8:\"filesize\";s:8:\"15819118\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.9\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.9\";s:7:\"version\";s:5:\"8.5.9\";s:3:\"tag\";s:5:\"8.5.9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.9\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.9.tar.gz\";s:4:\"date\";s:10:\"1547663557\";s:6:\"mdhash\";s:32:\"ab7feda97f750c8997154c04ee7b1c5b\";s:8:\"filesize\";s:8:\"15810671\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.8\";s:7:\"version\";s:5:\"8.5.8\";s:3:\"tag\";s:5:\"8.5.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.8.tar.gz\";s:4:\"date\";s:10:\"1539816180\";s:6:\"mdhash\";s:32:\"9642e018a0b0ed7bd8a3472fa0b64ccd\";s:8:\"filesize\";s:8:\"15794648\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.7\";s:7:\"version\";s:5:\"8.5.7\";s:3:\"tag\";s:5:\"8.5.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.7.tar.gz\";s:4:\"date\";s:10:\"1536187080\";s:6:\"mdhash\";s:32:\"a5f35336995ed209a917a4370e0c34d7\";s:8:\"filesize\";s:8:\"15797062\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.6\";s:7:\"version\";s:5:\"8.5.6\";s:3:\"tag\";s:5:\"8.5.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.6.tar.gz\";s:4:\"date\";s:10:\"1533156780\";s:6:\"mdhash\";s:32:\"1e789adb03cf2a82a9c3bced67c02328\";s:8:\"filesize\";s:8:\"15789509\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.5\";s:7:\"version\";s:5:\"8.5.5\";s:3:\"tag\";s:5:\"8.5.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.5.tar.gz\";s:4:\"date\";s:10:\"1530738820\";s:6:\"mdhash\";s:32:\"4fee1348bbac85cae82d6634e7296b9f\";s:8:\"filesize\";s:8:\"15786935\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.4\";s:7:\"version\";s:5:\"8.5.4\";s:3:\"tag\";s:5:\"8.5.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.4.tar.gz\";s:4:\"date\";s:10:\"1528319584\";s:6:\"mdhash\";s:32:\"4237ee4c5384bd90ed8dc4fa0ed3bb0c\";s:8:\"filesize\";s:8:\"15779939\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.3\";s:7:\"version\";s:5:\"8.5.3\";s:3:\"tag\";s:5:\"8.5.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.3.tar.gz\";s:4:\"date\";s:10:\"1524672780\";s:6:\"mdhash\";s:32:\"aedc6598b71c5393d30242b8e14385e5\";s:8:\"filesize\";s:8:\"15527015\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.2\";s:7:\"version\";s:5:\"8.5.2\";s:3:\"tag\";s:5:\"8.5.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.2.tar.gz\";s:4:\"date\";s:10:\"1524073147\";s:6:\"mdhash\";s:32:\"c85c6ec800100d458fad6b9469e2fd8b\";s:8:\"filesize\";s:8:\"15527091\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.1\";s:7:\"version\";s:5:\"8.5.1\";s:3:\"tag\";s:5:\"8.5.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.1.tar.gz\";s:4:\"date\";s:10:\"1522263480\";s:6:\"mdhash\";s:32:\"23e18afbdd031d0cd7c519c4e9baff71\";s:8:\"filesize\";s:8:\"15537139\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.0\";s:7:\"version\";s:5:\"8.5.0\";s:3:\"tag\";s:5:\"8.5.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.0.tar.gz\";s:4:\"date\";s:10:\"1520457780\";s:6:\"mdhash\";s:32:\"5679d3fa188fb80368ee46ab40acdb6b\";s:8:\"filesize\";s:8:\"15535794\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.5.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.5.0-rc1\";s:7:\"version\";s:9:\"8.5.0-rc1\";s:3:\"tag\";s:9:\"8.5.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.5.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.5.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1519234680\";s:6:\"mdhash\";s:32:\"21048fe325b090df60620e5882ed39ab\";s:8:\"filesize\";s:8:\"15563019\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.5.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.5.0-beta1\";s:7:\"version\";s:11:\"8.5.0-beta1\";s:3:\"tag\";s:11:\"8.5.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.5.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.5.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1518211380\";s:6:\"mdhash\";s:32:\"981177d250839fdf325001c12b4e20ba\";s:8:\"filesize\";s:8:\"15545344\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.5.0-alpha1\";a:16:{s:4:\"name\";s:19:\"drupal 8.5.0-alpha1\";s:7:\"version\";s:12:\"8.5.0-alpha1\";s:3:\"tag\";s:12:\"8.5.0-alpha1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.5.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.5.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1516320484\";s:6:\"mdhash\";s:32:\"415dda1360f95c376870d2a3786483c7\";s:8:\"filesize\";s:8:\"13783860\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:5:\"8.4.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.8\";s:7:\"version\";s:5:\"8.4.8\";s:3:\"tag\";s:5:\"8.4.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.8.tar.gz\";s:4:\"date\";s:10:\"1524672780\";s:6:\"mdhash\";s:32:\"f922c5fead1e05ecf155cfd63983fcf1\";s:8:\"filesize\";s:8:\"13381772\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.7\";s:7:\"version\";s:5:\"8.4.7\";s:3:\"tag\";s:5:\"8.4.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.7.tar.gz\";s:4:\"date\";s:10:\"1524073147\";s:6:\"mdhash\";s:32:\"965b59360079fab9020fffce8c09a994\";s:8:\"filesize\";s:8:\"13381183\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.6\";s:7:\"version\";s:5:\"8.4.6\";s:3:\"tag\";s:5:\"8.4.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.6.tar.gz\";s:4:\"date\";s:10:\"1522263480\";s:6:\"mdhash\";s:32:\"e4b17dc542724f6298435dca81a84f8d\";s:8:\"filesize\";s:8:\"13413996\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.5\";s:7:\"version\";s:5:\"8.4.5\";s:3:\"tag\";s:5:\"8.4.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.5.tar.gz\";s:4:\"date\";s:10:\"1519234680\";s:6:\"mdhash\";s:32:\"e866ae73a2ce13eb803cd24c68ef94c7\";s:8:\"filesize\";s:8:\"13414036\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.4\";s:7:\"version\";s:5:\"8.4.4\";s:3:\"tag\";s:5:\"8.4.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.4.tar.gz\";s:4:\"date\";s:10:\"1515021185\";s:6:\"mdhash\";s:32:\"cfce3fb9293d8fe146f4c000505cb9b6\";s:8:\"filesize\";s:8:\"13410566\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.3\";s:7:\"version\";s:5:\"8.4.3\";s:3:\"tag\";s:5:\"8.4.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.3.tar.gz\";s:4:\"date\";s:10:\"1512600784\";s:6:\"mdhash\";s:32:\"55a53cb43284b3d710a2742d458fc1da\";s:8:\"filesize\";s:8:\"13399420\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.2\";s:7:\"version\";s:5:\"8.4.2\";s:3:\"tag\";s:5:\"8.4.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.2.tar.gz\";s:4:\"date\";s:10:\"1509719885\";s:6:\"mdhash\";s:32:\"a2b294d82ce751f93ba600f2de7884f4\";s:8:\"filesize\";s:8:\"13393043\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.1\";s:7:\"version\";s:5:\"8.4.1\";s:3:\"tag\";s:5:\"8.4.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.1.tar.gz\";s:4:\"date\";s:10:\"1509562384\";s:6:\"mdhash\";s:32:\"1c1db36ac5217f315bf9c03d64529f10\";s:8:\"filesize\";s:8:\"13407476\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.0\";s:7:\"version\";s:5:\"8.4.0\";s:3:\"tag\";s:5:\"8.4.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.0.tar.gz\";s:4:\"date\";s:10:\"1507146244\";s:6:\"mdhash\";s:32:\"074795a2f5fc0b599a7dcfb9d1fb03f5\";s:8:\"filesize\";s:8:\"13379442\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.4.0-rc2\";a:16:{s:4:\"name\";s:16:\"drupal 8.4.0-rc2\";s:7:\"version\";s:9:\"8.4.0-rc2\";s:3:\"tag\";s:9:\"8.4.0-rc2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.4.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.4.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1505911444\";s:6:\"mdhash\";s:32:\"50730355dd1a82d988e484c2b4eff422\";s:8:\"filesize\";s:8:\"13377433\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.4.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.4.0-rc1\";s:7:\"version\";s:9:\"8.4.0-rc1\";s:3:\"tag\";s:9:\"8.4.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.4.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.4.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1504733043\";s:6:\"mdhash\";s:32:\"28f7b802ddf81f6a5f50a1400766d913\";s:8:\"filesize\";s:8:\"13353640\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.4.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.4.0-beta1\";s:7:\"version\";s:11:\"8.4.0-beta1\";s:3:\"tag\";s:11:\"8.4.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.4.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.4.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1502992144\";s:6:\"mdhash\";s:32:\"8df2388ddd79d63d4b506463c1e173f8\";s:8:\"filesize\";s:8:\"13334632\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.4.0-alpha1\";a:16:{s:4:\"name\";s:19:\"drupal 8.4.0-alpha1\";s:7:\"version\";s:12:\"8.4.0-alpha1\";s:3:\"tag\";s:12:\"8.4.0-alpha1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.4.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.4.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1501790944\";s:6:\"mdhash\";s:32:\"540c951999e8cac74d1d5ff70a81157f\";s:8:\"filesize\";s:8:\"13153571\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:5:\"8.3.9\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.9\";s:7:\"version\";s:5:\"8.3.9\";s:3:\"tag\";s:5:\"8.3.9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.9\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.9.tar.gz\";s:4:\"date\";s:10:\"1522263480\";s:6:\"mdhash\";s:32:\"b53f505b0243d608b6a6550ae664bc75\";s:8:\"filesize\";s:8:\"12743287\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.8\";s:7:\"version\";s:5:\"8.3.8\";s:3:\"tag\";s:5:\"8.3.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.8.tar.gz\";s:4:\"date\";s:10:\"1520881985\";s:6:\"mdhash\";s:32:\"94cc223abff93a33762041a1fb2f7c3a\";s:8:\"filesize\";s:8:\"12741296\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.7\";s:7:\"version\";s:5:\"8.3.7\";s:3:\"tag\";s:5:\"8.3.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.7.tar.gz\";s:4:\"date\";s:10:\"1502903903\";s:6:\"mdhash\";s:32:\"e7b1f382d6bd2b18d4b4aca01d335bc0\";s:8:\"filesize\";s:8:\"12739663\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.6\";s:7:\"version\";s:5:\"8.3.6\";s:3:\"tag\";s:5:\"8.3.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.6.tar.gz\";s:4:\"date\";s:10:\"1501688043\";s:6:\"mdhash\";s:32:\"de7ceedf9391c4b52c1c5a7f66809129\";s:8:\"filesize\";s:8:\"12735564\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.5\";s:7:\"version\";s:5:\"8.3.5\";s:3:\"tag\";s:5:\"8.3.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.5.tar.gz\";s:4:\"date\";s:10:\"1499274843\";s:6:\"mdhash\";s:32:\"23832fcfe0c6398727d24e582042f149\";s:8:\"filesize\";s:8:\"12734016\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.4\";s:7:\"version\";s:5:\"8.3.4\";s:3:\"tag\";s:5:\"8.3.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.4.tar.gz\";s:4:\"date\";s:10:\"1498069442\";s:6:\"mdhash\";s:32:\"243a2e10032abaf55c10a96555315727\";s:8:\"filesize\";s:8:\"12721299\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.3\";s:7:\"version\";s:5:\"8.3.3\";s:3:\"tag\";s:5:\"8.3.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.3.tar.gz\";s:4:\"date\";s:10:\"1496858041\";s:6:\"mdhash\";s:32:\"eafff06bbe636b526ab17c064fdc5422\";s:8:\"filesize\";s:8:\"12718563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.2\";s:7:\"version\";s:5:\"8.3.2\";s:3:\"tag\";s:5:\"8.3.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.2.tar.gz\";s:4:\"date\";s:10:\"1493834585\";s:6:\"mdhash\";s:32:\"d1fce1ec78ca1bcde4a346f4c06531b4\";s:8:\"filesize\";s:8:\"12698347\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.1\";s:7:\"version\";s:5:\"8.3.1\";s:3:\"tag\";s:5:\"8.3.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.1.tar.gz\";s:4:\"date\";s:10:\"1492622946\";s:6:\"mdhash\";s:32:\"0287dcda619e440f6d41b1cc48a81e56\";s:8:\"filesize\";s:8:\"12663939\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.0\";s:7:\"version\";s:5:\"8.3.0\";s:3:\"tag\";s:5:\"8.3.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.0.tar.gz\";s:4:\"date\";s:10:\"1491439084\";s:6:\"mdhash\";s:32:\"1dcce599eddba07eb00e8879937525c3\";s:8:\"filesize\";s:8:\"12665617\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.3.0-rc2\";a:16:{s:4:\"name\";s:16:\"drupal 8.3.0-rc2\";s:7:\"version\";s:9:\"8.3.0-rc2\";s:3:\"tag\";s:9:\"8.3.0-rc2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.3.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.3.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1489613583\";s:6:\"mdhash\";s:32:\"3bcddc9a48801f7035c7cb0e6f02f6d0\";s:8:\"filesize\";s:8:\"12320512\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.3.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.3.0-rc1\";s:7:\"version\";s:9:\"8.3.0-rc1\";s:3:\"tag\";s:9:\"8.3.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.3.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1488383284\";s:6:\"mdhash\";s:32:\"0acd6c49d5626cd47077eb2650a409cb\";s:8:\"filesize\";s:8:\"12324498\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.3.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.3.0-beta1\";s:7:\"version\";s:11:\"8.3.0-beta1\";s:3:\"tag\";s:11:\"8.3.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.3.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1487175783\";s:6:\"mdhash\";s:32:\"7c5b312098fd5573d6e1420cfe86275e\";s:8:\"filesize\";s:8:\"12283857\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.3.0-alpha1\";a:16:{s:4:\"name\";s:19:\"drupal 8.3.0-alpha1\";s:7:\"version\";s:12:\"8.3.0-alpha1\";s:3:\"tag\";s:12:\"8.3.0-alpha1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.3.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1485968583\";s:6:\"mdhash\";s:32:\"601f931d5a3281214917e3eabfd86408\";s:8:\"filesize\";s:8:\"12249792\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:5:\"8.2.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.8\";s:7:\"version\";s:5:\"8.2.8\";s:3:\"tag\";s:5:\"8.2.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.8.tar.gz\";s:4:\"date\";s:10:\"1492622852\";s:6:\"mdhash\";s:32:\"039507247f3712c3fb022805eb13faf4\";s:8:\"filesize\";s:8:\"12092176\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.7\";s:7:\"version\";s:5:\"8.2.7\";s:3:\"tag\";s:5:\"8.2.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.7.tar.gz\";s:4:\"date\";s:10:\"1489609638\";s:6:\"mdhash\";s:32:\"10b1669f750a9996096e76059c157b9a\";s:8:\"filesize\";s:8:\"12090872\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.6\";s:7:\"version\";s:5:\"8.2.6\";s:3:\"tag\";s:5:\"8.2.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.6.tar.gz\";s:4:\"date\";s:10:\"1485975485\";s:6:\"mdhash\";s:32:\"57526a827771ea8a06db1792f1602a85\";s:8:\"filesize\";s:8:\"12091847\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.5\";s:7:\"version\";s:5:\"8.2.5\";s:3:\"tag\";s:5:\"8.2.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.5.tar.gz\";s:4:\"date\";s:10:\"1483529942\";s:6:\"mdhash\";s:32:\"4bfd35c34ce1b4ba5bac2d18e0d6b5c9\";s:8:\"filesize\";s:8:\"12064201\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.4\";s:7:\"version\";s:5:\"8.2.4\";s:3:\"tag\";s:5:\"8.2.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.4.tar.gz\";s:4:\"date\";s:10:\"1481136784\";s:6:\"mdhash\";s:32:\"288aa9978b5027e26f20df93b6295f6c\";s:8:\"filesize\";s:8:\"12051590\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.3\";s:7:\"version\";s:5:\"8.2.3\";s:3:\"tag\";s:5:\"8.2.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.3.tar.gz\";s:4:\"date\";s:10:\"1479322439\";s:6:\"mdhash\";s:32:\"683ddc33077bb1f7cc795607d114144e\";s:8:\"filesize\";s:8:\"12129681\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.2\";s:7:\"version\";s:5:\"8.2.2\";s:3:\"tag\";s:5:\"8.2.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.2.tar.gz\";s:4:\"date\";s:10:\"1478106542\";s:6:\"mdhash\";s:32:\"63d69922376a69068efb46ab4059dc34\";s:8:\"filesize\";s:8:\"12900949\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.1\";s:7:\"version\";s:5:\"8.2.1\";s:3:\"tag\";s:5:\"8.2.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.1.tar.gz\";s:4:\"date\";s:10:\"1476181439\";s:6:\"mdhash\";s:32:\"ad5ab19697ee0f7d786184ceaa7ddf6a\";s:8:\"filesize\";s:8:\"12871054\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.0\";s:7:\"version\";s:5:\"8.2.0\";s:3:\"tag\";s:5:\"8.2.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.0.tar.gz\";s:4:\"date\";s:10:\"1475660639\";s:6:\"mdhash\";s:32:\"5d0c57d2fd6338d60a5e311acc188b44\";s:8:\"filesize\";s:8:\"12867786\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.2.0-rc2\";a:16:{s:4:\"name\";s:16:\"drupal 8.2.0-rc2\";s:7:\"version\";s:9:\"8.2.0-rc2\";s:3:\"tag\";s:9:\"8.2.0-rc2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.2.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1474484358\";s:6:\"mdhash\";s:32:\"e6e7d9bb669fd82a8dd730ef0e47377d\";s:8:\"filesize\";s:8:\"12873257\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.2.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.2.0-rc1\";s:7:\"version\";s:9:\"8.2.0-rc1\";s:3:\"tag\";s:9:\"8.2.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.2.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1473285089\";s:6:\"mdhash\";s:32:\"c1f7f5f0d3cf742f97799497fd56af3e\";s:8:\"filesize\";s:8:\"12854953\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.2.0-beta3\";a:16:{s:4:\"name\";s:18:\"drupal 8.2.0-beta3\";s:7:\"version\";s:11:\"8.2.0-beta3\";s:3:\"tag\";s:11:\"8.2.0-beta3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.2.0-beta3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1472222475\";s:6:\"mdhash\";s:32:\"be99e1bc4050587b5cf414a9ab947356\";s:8:\"filesize\";s:8:\"12847824\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.2.0-beta2\";a:16:{s:4:\"name\";s:18:\"drupal 8.2.0-beta2\";s:7:\"version\";s:11:\"8.2.0-beta2\";s:3:\"tag\";s:11:\"8.2.0-beta2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.2.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1471710839\";s:6:\"mdhash\";s:32:\"973a20c9b0673cee724befe9762dd7c2\";s:8:\"filesize\";s:8:\"12826433\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.2.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.2.0-beta1\";s:7:\"version\";s:11:\"8.2.0-beta1\";s:3:\"tag\";s:11:\"8.2.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.2.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1470230639\";s:6:\"mdhash\";s:32:\"35fed9378c738d6bf420399f56e740c9\";s:8:\"filesize\";s:8:\"12751366\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:6:\"8.1.10\";a:15:{s:4:\"name\";s:13:\"drupal 8.1.10\";s:7:\"version\";s:6:\"8.1.10\";s:3:\"tag\";s:6:\"8.1.10\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.1.10\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.1.10.tar.gz\";s:4:\"date\";s:10:\"1474478939\";s:6:\"mdhash\";s:32:\"ce373a1a7a075ff9035b1c95f54170a4\";s:8:\"filesize\";s:8:\"12651446\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.9\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.9\";s:7:\"version\";s:5:\"8.1.9\";s:3:\"tag\";s:5:\"8.1.9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.9\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.9.tar.gz\";s:4:\"date\";s:10:\"1473276313\";s:6:\"mdhash\";s:32:\"4de7c001ecbd5c27e5837c97e40facc2\";s:8:\"filesize\";s:8:\"12648210\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.8\";s:7:\"version\";s:5:\"8.1.8\";s:3:\"tag\";s:5:\"8.1.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.8.tar.gz\";s:4:\"date\";s:10:\"1470233647\";s:6:\"mdhash\";s:32:\"7c00b318590a22f2df7a18cf70df06dc\";s:8:\"filesize\";s:8:\"12634223\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.7\";s:7:\"version\";s:5:\"8.1.7\";s:3:\"tag\";s:5:\"8.1.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.7.tar.gz\";s:4:\"date\";s:10:\"1468855358\";s:6:\"mdhash\";s:32:\"19e95079e50dd3c19222b91ef1b57036\";s:8:\"filesize\";s:8:\"12601662\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.6\";s:7:\"version\";s:5:\"8.1.6\";s:3:\"tag\";s:5:\"8.1.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.6.tar.gz\";s:4:\"date\";s:10:\"1468242539\";s:6:\"mdhash\";s:32:\"f3fdd2f9266938c2c7afc091e8d6e6d1\";s:8:\"filesize\";s:8:\"12595889\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.5\";s:7:\"version\";s:5:\"8.1.5\";s:3:\"tag\";s:5:\"8.1.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.5.tar.gz\";s:4:\"date\";s:10:\"1467884639\";s:6:\"mdhash\";s:32:\"0b30a3711d922c5348d6119e5124243b\";s:8:\"filesize\";s:8:\"12596430\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.4\";s:7:\"version\";s:5:\"8.1.4\";s:3:\"tag\";s:5:\"8.1.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.4.tar.gz\";s:4:\"date\";s:10:\"1467810839\";s:6:\"mdhash\";s:32:\"8c07b855ffd028124eb8848526abf4d9\";s:8:\"filesize\";s:8:\"12595731\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.3\";s:7:\"version\";s:5:\"8.1.3\";s:3:\"tag\";s:5:\"8.1.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.3.tar.gz\";s:4:\"date\";s:10:\"1466021480\";s:6:\"mdhash\";s:32:\"f2eef421c2a0610b32519f8f2e094b7c\";s:8:\"filesize\";s:8:\"12552870\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.2\";s:7:\"version\";s:5:\"8.1.2\";s:3:\"tag\";s:5:\"8.1.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.2.tar.gz\";s:4:\"date\";s:10:\"1464824339\";s:6:\"mdhash\";s:32:\"91fdfbd1c28512e41f2a61bf69214900\";s:8:\"filesize\";s:8:\"12553455\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.1\";s:7:\"version\";s:5:\"8.1.1\";s:3:\"tag\";s:5:\"8.1.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.1.tar.gz\";s:4:\"date\";s:10:\"1462361039\";s:6:\"mdhash\";s:32:\"529f3d72964c612695f68e0a6078b8ae\";s:8:\"filesize\";s:8:\"12533960\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.0\";s:7:\"version\";s:5:\"8.1.0\";s:3:\"tag\";s:5:\"8.1.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.0.tar.gz\";s:4:\"date\";s:10:\"1461118190\";s:6:\"mdhash\";s:32:\"a6bf3c366ba9ee5e0af3f2a80e274240\";s:8:\"filesize\";s:8:\"12520120\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.1.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.1.0-rc1\";s:7:\"version\";s:9:\"8.1.0-rc1\";s:3:\"tag\";s:9:\"8.1.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.1.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1459976639\";s:6:\"mdhash\";s:32:\"337de1b28e915e865a5385818ca82603\";s:8:\"filesize\";s:8:\"12459083\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.1.0-beta2\";a:16:{s:4:\"name\";s:18:\"drupal 8.1.0-beta2\";s:7:\"version\";s:11:\"8.1.0-beta2\";s:3:\"tag\";s:11:\"8.1.0-beta2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.1.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1458699840\";s:6:\"mdhash\";s:32:\"e916a10fb2dedaf3ebd88ddc010031be\";s:8:\"filesize\";s:8:\"12426385\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.1.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.1.0-beta1\";s:7:\"version\";s:11:\"8.1.0-beta1\";s:3:\"tag\";s:11:\"8.1.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.1.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1456975758\";s:6:\"mdhash\";s:32:\"3dc3b2354c54e35070052a175b957da0\";s:8:\"filesize\";s:8:\"11906519\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:5:\"8.0.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.6\";s:7:\"version\";s:5:\"8.0.6\";s:3:\"tag\";s:5:\"8.0.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.6.tar.gz\";s:4:\"date\";s:10:\"1459900439\";s:6:\"mdhash\";s:32:\"952c14d46f0b02bcb29de5c3349c19ee\";s:8:\"filesize\";s:8:\"11782652\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.5\";s:7:\"version\";s:5:\"8.0.5\";s:3:\"tag\";s:5:\"8.0.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.5.tar.gz\";s:4:\"date\";s:10:\"1456914839\";s:6:\"mdhash\";s:32:\"c13a69b0f99d70ecb6415d77f484bc7f\";s:8:\"filesize\";s:8:\"11770913\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.4\";s:7:\"version\";s:5:\"8.0.4\";s:3:\"tag\";s:5:\"8.0.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.4.tar.gz\";s:4:\"date\";s:10:\"1456341749\";s:6:\"mdhash\";s:32:\"7516dd4c18415020f80f000035e970ce\";s:8:\"filesize\";s:8:\"11746172\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.3\";s:7:\"version\";s:5:\"8.0.3\";s:3:\"tag\";s:5:\"8.0.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.3.tar.gz\";s:4:\"date\";s:10:\"1454489043\";s:6:\"mdhash\";s:32:\"7d5f5278a870b8f4a29cda4fe915d619\";s:8:\"filesize\";s:8:\"11741502\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.2\";s:7:\"version\";s:5:\"8.0.2\";s:3:\"tag\";s:5:\"8.0.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.2.tar.gz\";s:4:\"date\";s:10:\"1452119939\";s:6:\"mdhash\";s:32:\"9c39dec82c6d1a6d2004c30b11fb052e\";s:8:\"filesize\";s:8:\"11720487\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.1\";s:7:\"version\";s:5:\"8.0.1\";s:3:\"tag\";s:5:\"8.0.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.1.tar.gz\";s:4:\"date\";s:10:\"1449066839\";s:6:\"mdhash\";s:32:\"423cc4d28da066d099986ac0844f6abb\";s:8:\"filesize\";s:8:\"11697695\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.0\";s:7:\"version\";s:5:\"8.0.0\";s:3:\"tag\";s:5:\"8.0.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.0.tar.gz\";s:4:\"date\";s:10:\"1447941840\";s:6:\"mdhash\";s:32:\"92ce9a54fa926b58032a4e39b0f9a9f1\";s:8:\"filesize\";s:8:\"11692820\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.0.0-rc4\";a:16:{s:4:\"name\";s:16:\"drupal 8.0.0-rc4\";s:7:\"version\";s:9:\"8.0.0-rc4\";s:3:\"tag\";s:9:\"8.0.0-rc4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.0-rc4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1447413840\";s:6:\"mdhash\";s:32:\"33a4738989e4b571176e47d26443cb26\";s:8:\"filesize\";s:8:\"11687995\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.0.0-rc3\";a:16:{s:4:\"name\";s:16:\"drupal 8.0.0-rc3\";s:7:\"version\";s:9:\"8.0.0-rc3\";s:3:\"tag\";s:9:\"8.0.0-rc3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.0-rc3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1446633239\";s:6:\"mdhash\";s:32:\"dedd68b8f39002d64fe64a0c5085e573\";s:8:\"filesize\";s:8:\"11557156\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.0.0-rc2\";a:16:{s:4:\"name\";s:16:\"drupal 8.0.0-rc2\";s:7:\"version\";s:9:\"8.0.0-rc2\";s:3:\"tag\";s:9:\"8.0.0-rc2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1445468639\";s:6:\"mdhash\";s:32:\"66f0032af1350410a502f3a8cde5ab3f\";s:8:\"filesize\";s:8:\"10728216\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.0.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.0.0-rc1\";s:7:\"version\";s:9:\"8.0.0-rc1\";s:3:\"tag\";s:9:\"8.0.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1444253039\";s:6:\"mdhash\";s:32:\"58841f02728a85c105ce988e5605e4e5\";s:8:\"filesize\";s:8:\"11498104\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta16\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta16\";s:7:\"version\";s:12:\"8.0.0-beta16\";s:3:\"tag\";s:12:\"8.0.0-beta16\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta16\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta16.tar.gz\";s:4:\"date\";s:10:\"1443746640\";s:6:\"mdhash\";s:32:\"3204db355d8163616f10263074285aee\";s:8:\"filesize\";s:8:\"11433695\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta15\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta15\";s:7:\"version\";s:12:\"8.0.0-beta15\";s:3:\"tag\";s:12:\"8.0.0-beta15\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta15\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta15.tar.gz\";s:4:\"date\";s:10:\"1441357140\";s:6:\"mdhash\";s:32:\"727e700eab75395663d6c5dbd20fe6ee\";s:8:\"filesize\";s:8:\"11273890\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta14\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta14\";s:7:\"version\";s:12:\"8.0.0-beta14\";s:3:\"tag\";s:12:\"8.0.0-beta14\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta14\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta14.tar.gz\";s:4:\"date\";s:10:\"1438593539\";s:6:\"mdhash\";s:32:\"ace8bfa17488faf80b6181cf9fb8035a\";s:8:\"filesize\";s:8:\"10493263\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta13\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta13\";s:7:\"version\";s:12:\"8.0.0-beta13\";s:3:\"tag\";s:12:\"8.0.0-beta13\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta13\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta13.tar.gz\";s:4:\"date\";s:10:\"1438194539\";s:6:\"mdhash\";s:32:\"1e872066cc6bf8c072341740825ff141\";s:8:\"filesize\";s:8:\"10481509\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta12\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta12\";s:7:\"version\";s:12:\"8.0.0-beta12\";s:3:\"tag\";s:12:\"8.0.0-beta12\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta12\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta12.tar.gz\";s:4:\"date\";s:10:\"1435601583\";s:6:\"mdhash\";s:32:\"7714744da283b70c14a2aa7fbb50eeeb\";s:8:\"filesize\";s:8:\"10662165\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta11\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta11\";s:7:\"version\";s:12:\"8.0.0-beta11\";s:3:\"tag\";s:12:\"8.0.0-beta11\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta11\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta11.tar.gz\";s:4:\"date\";s:10:\"1432758481\";s:6:\"mdhash\";s:32:\"885500fef1a692d0598daa27134a440a\";s:8:\"filesize\";s:8:\"10500627\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta10\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta10\";s:7:\"version\";s:12:\"8.0.0-beta10\";s:3:\"tag\";s:12:\"8.0.0-beta10\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta10\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta10.tar.gz\";s:4:\"date\";s:10:\"1430314681\";s:6:\"mdhash\";s:32:\"cfe68b642776818a9df71211495fbb44\";s:8:\"filesize\";s:8:\"10296679\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta9\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta9\";s:7:\"version\";s:11:\"8.0.0-beta9\";s:3:\"tag\";s:11:\"8.0.0-beta9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta9\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1427299981\";s:6:\"mdhash\";s:32:\"109172962c779f26528f697604695bec\";s:8:\"filesize\";s:8:\"10044027\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta7\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta7\";s:7:\"version\";s:11:\"8.0.0-beta7\";s:3:\"tag\";s:11:\"8.0.0-beta7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta7\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1424875381\";s:6:\"mdhash\";s:32:\"b730108fbdd33ffe57fb94e94d293ebe\";s:8:\"filesize\";s:7:\"9694970\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta6\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta6\";s:7:\"version\";s:11:\"8.0.0-beta6\";s:3:\"tag\";s:11:\"8.0.0-beta6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta6\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1422443800\";s:6:\"mdhash\";s:32:\"b2470e3e2ab4fa6adce0e9152d6ad4b9\";s:8:\"filesize\";s:7:\"9562882\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta4\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta4\";s:7:\"version\";s:11:\"8.0.0-beta4\";s:3:\"tag\";s:11:\"8.0.0-beta4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta4\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1418825280\";s:6:\"mdhash\";s:32:\"66cf899e456bd27b7ff9beaf61dcf45f\";s:8:\"filesize\";s:7:\"9555745\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta3\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta3\";s:7:\"version\";s:11:\"8.0.0-beta3\";s:3:\"tag\";s:11:\"8.0.0-beta3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1415797380\";s:6:\"mdhash\";s:32:\"89eb46c597eb9c8ef7423783aef7f340\";s:8:\"filesize\";s:7:\"9445245\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta2\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta2\";s:7:\"version\";s:11:\"8.0.0-beta2\";s:3:\"tag\";s:11:\"8.0.0-beta2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1413394161\";s:6:\"mdhash\";s:32:\"5130f44ed3c0b3fa709eb1d92e7def33\";s:8:\"filesize\";s:7:\"9480603\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta1\";s:7:\"version\";s:11:\"8.0.0-beta1\";s:3:\"tag\";s:11:\"8.0.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1412147030\";s:6:\"mdhash\";s:32:\"9efea37c74bed8208133dc1aae76e53f\";s:8:\"filesize\";s:7:\"9389838\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.0.0-alpha15\";a:16:{s:4:\"name\";s:20:\"drupal 8.0.0-alpha15\";s:7:\"version\";s:13:\"8.0.0-alpha15\";s:3:\"tag\";s:13:\"8.0.0-alpha15\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/drupal/releases/8.0.0-alpha15\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-alpha15.tar.gz\";s:4:\"date\";s:10:\"1411139628\";s:6:\"mdhash\";s:32:\"a5ea2deb1776a3703315e90772d9ec58\";s:8:\"filesize\";s:7:\"9344566\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:13:\"8.0.0-alpha14\";a:16:{s:4:\"name\";s:20:\"drupal 8.0.0-alpha14\";s:7:\"version\";s:13:\"8.0.0-alpha14\";s:3:\"tag\";s:13:\"8.0.0-alpha14\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/drupal/releases/8.0.0-alpha14\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-alpha14.tar.gz\";s:4:\"date\";s:10:\"1407344628\";s:6:\"mdhash\";s:32:\"9d71afdd0ce541f2ff5ca2fbbca00df7\";s:8:\"filesize\";s:7:\"9172832\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.0-alpha13\";a:15:{s:4:\"name\";s:18:\"drupal 8.0-alpha13\";s:7:\"version\";s:11:\"8.0-alpha13\";s:3:\"tag\";s:11:\"8.0-alpha13\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0-alpha13\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha13.tar.gz\";s:4:\"date\";s:10:\"1404296627\";s:6:\"mdhash\";s:32:\"6fb0325f937b870fbfab2f9526dd6e14\";s:8:\"filesize\";s:7:\"9089848\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.0-alpha12\";a:15:{s:4:\"name\";s:18:\"drupal 8.0-alpha12\";s:7:\"version\";s:11:\"8.0-alpha12\";s:3:\"tag\";s:11:\"8.0-alpha12\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0-alpha12\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha12.tar.gz\";s:4:\"date\";s:10:\"1401293627\";s:6:\"mdhash\";s:32:\"fdf022c5375e77c59bd35a61e6ec68e5\";s:8:\"filesize\";s:7:\"8792935\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.0-alpha11\";a:15:{s:4:\"name\";s:18:\"drupal 8.0-alpha11\";s:7:\"version\";s:11:\"8.0-alpha11\";s:3:\"tag\";s:11:\"8.0-alpha11\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0-alpha11\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha11.tar.gz\";s:4:\"date\";s:10:\"1398249227\";s:6:\"mdhash\";s:32:\"3b1a74ec242b145c7a6fa0fe5070a4ee\";s:8:\"filesize\";s:7:\"8613989\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.0-alpha10\";a:15:{s:4:\"name\";s:18:\"drupal 8.0-alpha10\";s:7:\"version\";s:11:\"8.0-alpha10\";s:3:\"tag\";s:11:\"8.0-alpha10\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0-alpha10\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha10.tar.gz\";s:4:\"date\";s:10:\"1395231556\";s:6:\"mdhash\";s:32:\"b542bd467beeb7ea3c63c8f0027a3439\";s:8:\"filesize\";s:7:\"8109552\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha9\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha9\";s:7:\"version\";s:10:\"8.0-alpha9\";s:3:\"tag\";s:10:\"8.0-alpha9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha9\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha9.tar.gz\";s:4:\"date\";s:10:\"1392806005\";s:6:\"mdhash\";s:32:\"cb5af8f8fe865a7f834b99d421e23839\";s:8:\"filesize\";s:7:\"8105277\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha8\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha8\";s:7:\"version\";s:10:\"8.0-alpha8\";s:3:\"tag\";s:10:\"8.0-alpha8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha8\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha8.tar.gz\";s:4:\"date\";s:10:\"1390393105\";s:6:\"mdhash\";s:32:\"5c970df83a2f4027b0377fbcf890eb79\";s:8:\"filesize\";s:7:\"8037378\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha7\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha7\";s:7:\"version\";s:10:\"8.0-alpha7\";s:3:\"tag\";s:10:\"8.0-alpha7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha7\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1387399705\";s:6:\"mdhash\";s:32:\"49228c4537941eb1f63f5bf0eb742d1f\";s:8:\"filesize\";s:7:\"7913974\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha6\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha6\";s:7:\"version\";s:10:\"8.0-alpha6\";s:3:\"tag\";s:10:\"8.0-alpha6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha6\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1385153305\";s:6:\"mdhash\";s:32:\"6fb6eb93826c9f75cbc2bf62fa61f28d\";s:8:\"filesize\";s:7:\"7914981\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha5\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha5\";s:7:\"version\";s:10:\"8.0-alpha5\";s:3:\"tag\";s:10:\"8.0-alpha5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha5\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1384850305\";s:6:\"mdhash\";s:32:\"4b3c1a6ab88a68ca17482035dbde8f4f\";s:8:\"filesize\";s:7:\"7883692\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha4\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha4\";s:7:\"version\";s:10:\"8.0-alpha4\";s:3:\"tag\";s:10:\"8.0-alpha4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha4\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1382092313\";s:6:\"mdhash\";s:32:\"793447ac11e240b1f1743adf33239ed6\";s:8:\"filesize\";s:7:\"7804215\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha3\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha3\";s:7:\"version\";s:10:\"8.0-alpha3\";s:3:\"tag\";s:10:\"8.0-alpha3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1378303307\";s:6:\"mdhash\";s:32:\"c786a027b87428fef5ddd7a946dcf07c\";s:8:\"filesize\";s:7:\"7647641\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha2\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha2\";s:7:\"version\";s:10:\"8.0-alpha2\";s:3:\"tag\";s:10:\"8.0-alpha2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1372069563\";s:6:\"mdhash\";s:32:\"01f5589dcfd851c7d65c040f455bad19\";s:8:\"filesize\";s:7:\"7319631\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:9:\"8.9.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.9.x-dev\";s:7:\"version\";s:9:\"8.9.x-dev\";s:3:\"tag\";s:5:\"8.9.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"9\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.9.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.9.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570890785\";s:6:\"mdhash\";s:32:\"deead930d13e225bf10098e036e17bff\";s:8:\"filesize\";s:8:\"23682807\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:9:\"8.8.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.8.x-dev\";s:7:\"version\";s:9:\"8.8.x-dev\";s:3:\"tag\";s:5:\"8.8.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"8\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.8.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.8.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570890785\";s:6:\"mdhash\";s:32:\"42748f546b708187bd66b4da0d2f4820\";s:8:\"filesize\";s:8:\"23684700\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:9:\"8.7.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.7.x-dev\";s:7:\"version\";s:9:\"8.7.x-dev\";s:3:\"tag\";s:5:\"8.7.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.7.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.7.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570759388\";s:6:\"mdhash\";s:32:\"fce1a9cf1571f31a12d62b79a022992d\";s:8:\"filesize\";s:8:\"22582383\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:9:\"8.6.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.6.x-dev\";s:7:\"version\";s:9:\"8.6.x-dev\";s:3:\"tag\";s:5:\"8.6.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.6.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.6.x-dev.tar.gz\";s:4:\"date\";s:10:\"1560756485\";s:6:\"mdhash\";s:32:\"e501e808c186dd049cee9cafc3f8c8d0\";s:8:\"filesize\";s:8:\"21483357\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:9:\"8.5.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.5.x-dev\";s:7:\"version\";s:9:\"8.5.x-dev\";s:3:\"tag\";s:5:\"8.5.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.5.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.5.x-dev.tar.gz\";s:4:\"date\";s:10:\"1555533181\";s:6:\"mdhash\";s:32:\"fb71a0c0efb8f06551e9736fb49c20be\";s:8:\"filesize\";s:8:\"20032673\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.4.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.4.x-dev\";s:7:\"version\";s:9:\"8.4.x-dev\";s:3:\"tag\";s:5:\"8.4.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.4.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.4.x-dev.tar.gz\";s:4:\"date\";s:10:\"1533047880\";s:6:\"mdhash\";s:32:\"5e310607e224d9264504cdd05c5fb0b1\";s:8:\"filesize\";s:8:\"14600045\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.3.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.3.x-dev\";s:7:\"version\";s:9:\"8.3.x-dev\";s:3:\"tag\";s:5:\"8.3.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.3.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1522263480\";s:6:\"mdhash\";s:32:\"439e0b9754d00d2026c98f3d3b852b1e\";s:8:\"filesize\";s:8:\"13923638\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.2.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.2.x-dev\";s:7:\"version\";s:9:\"8.2.x-dev\";s:3:\"tag\";s:5:\"8.2.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.2.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1492624982\";s:6:\"mdhash\";s:32:\"f9fc5edc65b138c8bc12e8335f092cde\";s:8:\"filesize\";s:8:\"12873229\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.1.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.1.x-dev\";s:7:\"version\";s:9:\"8.1.x-dev\";s:3:\"tag\";s:5:\"8.1.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.1.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1474478393\";s:6:\"mdhash\";s:32:\"72a40cdf2595fd9d60414df63639f3e8\";s:8:\"filesize\";s:8:\"12654097\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.0.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.0.x-dev\";s:7:\"version\";s:9:\"8.0.x-dev\";s:3:\"tag\";s:5:\"8.0.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.x-dev.tar.gz\";s:4:\"date\";s:10:\"1459900439\";s:6:\"mdhash\";s:32:\"8265a5c9ac0b4f1d90ae55c2f389265d\";s:8:\"filesize\";s:8:\"11792185\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1570954567;}',1571040967),

('update_available_releases','embed','a:12:{s:5:\"title\";s:5:\"Embed\";s:10:\"short_name\";s:5:\"embed\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:36:\"https://www.drupal.org/project/embed\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:5:{s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:13:\"embed 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/embed/releases/8.x-1.0\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/embed-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1490755685\";s:6:\"mdhash\";s:32:\"3f6b11099638096943de23c78614f769\";s:8:\"filesize\";s:5:\"28909\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.0-rc3\";a:15:{s:4:\"name\";s:17:\"embed 8.x-1.0-rc3\";s:7:\"version\";s:11:\"8.x-1.0-rc3\";s:3:\"tag\";s:11:\"8.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/embed/releases/8.x-1.0-rc3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/embed-8.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1468176563\";s:6:\"mdhash\";s:32:\"4dbc3c7cc0f0d27e931d01f741245860\";s:8:\"filesize\";s:5:\"29060\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:17:\"embed 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/embed/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/embed-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1460597940\";s:6:\"mdhash\";s:32:\"e2a98c82ef4dc82aa2d14e2df1ef433f\";s:8:\"filesize\";s:5:\"27646\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:17:\"embed 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/embed/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/embed-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1460389740\";s:6:\"mdhash\";s:32:\"6cdff0f6670f320e3f1b54e67d314283\";s:8:\"filesize\";s:5:\"27640\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:17:\"embed 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/embed/releases/8.x-1.x-dev\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/embed-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1490770984\";s:6:\"mdhash\";s:32:\"78004930baa1742c65115e3aad921294\";s:8:\"filesize\";s:5:\"28966\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','entity','a:12:{s:5:\"title\";s:10:\"Entity API\";s:10:\"short_name\";s:6:\"entity\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/entity\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:14:{s:11:\"8.x-1.0-rc3\";a:15:{s:4:\"name\";s:18:\"entity 8.x-1.0-rc3\";s:7:\"version\";s:11:\"8.x-1.0-rc3\";s:3:\"tag\";s:11:\"8.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-1.0-rc3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1559579884\";s:6:\"mdhash\";s:32:\"e766dc9300a894a2ef3a44ee3446dc0f\";s:8:\"filesize\";s:5:\"58627\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:18:\"entity 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1553254684\";s:6:\"mdhash\";s:32:\"9023e171b77455860dc677882d240309\";s:8:\"filesize\";s:5:\"58475\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:18:\"entity 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1539272580\";s:6:\"mdhash\";s:32:\"e8531123563e45cee816f4e3ac8a39c3\";s:8:\"filesize\";s:5:\"50152\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta4\";a:15:{s:4:\"name\";s:20:\"entity 8.x-1.0-beta4\";s:7:\"version\";s:13:\"8.x-1.0-beta4\";s:3:\"tag\";s:13:\"8.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/8.x-1.0-beta4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1528452184\";s:6:\"mdhash\";s:32:\"874c0a5c1915275c637f6692cba316d7\";s:8:\"filesize\";s:5:\"38765\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"8.x-1.0-beta3\";a:15:{s:4:\"name\";s:20:\"entity 8.x-1.0-beta3\";s:7:\"version\";s:13:\"8.x-1.0-beta3\";s:3:\"tag\";s:13:\"8.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/8.x-1.0-beta3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1520958485\";s:6:\"mdhash\";s:32:\"216df1d41d4efa5502baac08155ad208\";s:8:\"filesize\";s:5:\"38749\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta2\";a:15:{s:4:\"name\";s:20:\"entity 8.x-1.0-beta2\";s:7:\"version\";s:13:\"8.x-1.0-beta2\";s:3:\"tag\";s:13:\"8.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/8.x-1.0-beta2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1520873280\";s:6:\"mdhash\";s:32:\"d6fb195f0c94f39c9e3fdb5960e8edfe\";s:8:\"filesize\";s:5:\"37165\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:20:\"entity 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1505895844\";s:6:\"mdhash\";s:32:\"2c218cdcc59a996f3b3289869c61dfcc\";s:8:\"filesize\";s:5:\"35871\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha4\";a:15:{s:4:\"name\";s:21:\"entity 8.x-1.0-alpha4\";s:7:\"version\";s:14:\"8.x-1.0-alpha4\";s:3:\"tag\";s:14:\"8.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/8.x-1.0-alpha4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1481194983\";s:6:\"mdhash\";s:32:\"2dad14c347eed3694cf931921c912022\";s:8:\"filesize\";s:5:\"27365\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:21:\"entity 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1461748139\";s:6:\"mdhash\";s:32:\"0083ff3d127f2508345d0dfd6c7a323a\";s:8:\"filesize\";s:5:\"22815\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:21:\"entity 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1459289340\";s:6:\"mdhash\";s:32:\"9600a45053b0b564a18b92014e179182\";s:8:\"filesize\";s:5:\"22313\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:21:\"entity 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1452761939\";s:6:\"mdhash\";s:32:\"284cceace9420bd1e1f384649fec221d\";s:8:\"filesize\";s:5:\"22735\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:7:\"8.x-0.1\";a:14:{s:4:\"name\";s:14:\"entity 8.x-0.1\";s:7:\"version\";s:7:\"8.x-0.1\";s:3:\"tag\";s:7:\"8.x-0.1\";s:13:\"version_major\";s:1:\"0\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/8.x-0.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-8.x-0.1.tar.gz\";s:4:\"date\";s:10:\"1459284240\";s:6:\"mdhash\";s:32:\"3b03c9e33064bdbf0e0b7d4512fc95ff\";s:8:\"filesize\";s:5:\"32843\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:18:\"entity 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-1.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1559565485\";s:6:\"mdhash\";s:32:\"54ea7632691e68747ecb2e6b56a84bf6\";s:8:\"filesize\";s:5:\"58647\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-0.x-dev\";a:14:{s:4:\"name\";s:18:\"entity 8.x-0.x-dev\";s:7:\"version\";s:11:\"8.x-0.x-dev\";s:3:\"tag\";s:7:\"8.x-0.x\";s:13:\"version_major\";s:1:\"0\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-0.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-0.x-dev.tar.gz\";s:4:\"date\";s:10:\"1459283939\";s:6:\"mdhash\";s:32:\"f26553bcc0e221151d4bba1ac675696a\";s:8:\"filesize\";s:5:\"32852\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','entity_browser','a:12:{s:5:\"title\";s:14:\"Entity Browser\";s:10:\"short_name\";s:14:\"entity_browser\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:45:\"https://www.drupal.org/project/entity_browser\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:35:{s:7:\"8.x-2.2\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-2.2\";s:7:\"version\";s:7:\"8.x-2.2\";s:3:\"tag\";s:7:\"8.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-2.2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1562240585\";s:6:\"mdhash\";s:32:\"1060e1b7b5888b47c6753a7ee6c9f261\";s:8:\"filesize\";s:6:\"146692\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.1\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-2.1\";s:7:\"version\";s:7:\"8.x-2.1\";s:3:\"tag\";s:7:\"8.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-2.1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1550236984\";s:6:\"mdhash\";s:32:\"340bfd98e93a015ada70c4334b80ed68\";s:8:\"filesize\";s:6:\"130108\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-2.0\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-2.0\";s:7:\"version\";s:7:\"8.x-2.0\";s:3:\"tag\";s:7:\"8.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-2.0\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1536328684\";s:6:\"mdhash\";s:32:\"fc6df5e419a4f15e00c836cb1950ff12\";s:8:\"filesize\";s:6:\"130218\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:14:\"8.x-2.0-alpha3\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-2.0-alpha3\";s:7:\"version\";s:14:\"8.x-2.0-alpha3\";s:3:\"tag\";s:14:\"8.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-2.0-alpha3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1528141081\";s:6:\"mdhash\";s:32:\"e84a78dbded63ffcc42d3c4107f8c479\";s:8:\"filesize\";s:6:\"129942\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-2.0-alpha2\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-2.0-alpha2\";s:7:\"version\";s:14:\"8.x-2.0-alpha2\";s:3:\"tag\";s:14:\"8.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-2.0-alpha2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1512118387\";s:6:\"mdhash\";s:32:\"8480b82885b7390fb60a1fcb4f00927f\";s:8:\"filesize\";s:6:\"127738\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-2.0-alpha1\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-2.0-alpha1\";s:7:\"version\";s:14:\"8.x-2.0-alpha1\";s:3:\"tag\";s:14:\"8.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-2.0-alpha1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1507712945\";s:6:\"mdhash\";s:32:\"a51837629919862ad3f09ef1b7c44741\";s:8:\"filesize\";s:6:\"126340\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"8.x-1.8\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-1.8\";s:7:\"version\";s:7:\"8.x-1.8\";s:3:\"tag\";s:7:\"8.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.8\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1562241181\";s:6:\"mdhash\";s:32:\"0b3fbb5be23faf6dbb10e5e9100a94c2\";s:8:\"filesize\";s:6:\"145406\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.7\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-1.7\";s:7:\"version\";s:7:\"8.x-1.7\";s:3:\"tag\";s:7:\"8.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.7\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1550237884\";s:6:\"mdhash\";s:32:\"72682d8d0550579dc7e55aecc119fc1a\";s:8:\"filesize\";s:6:\"128777\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.6\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-1.6\";s:7:\"version\";s:7:\"8.x-1.6\";s:3:\"tag\";s:7:\"8.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1536328684\";s:6:\"mdhash\";s:32:\"ee02ff896609b3256ae56a43aa6f8480\";s:8:\"filesize\";s:6:\"129066\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1528140780\";s:6:\"mdhash\";s:32:\"abbf890c562da5d8d00fbcef588c0925\";s:8:\"filesize\";s:6:\"128680\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1512033785\";s:6:\"mdhash\";s:32:\"0dcc2807ad4fdb9a9940b10a95ad904f\";s:8:\"filesize\";s:6:\"125193\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.3\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-1.3\";s:7:\"version\";s:7:\"8.x-1.3\";s:3:\"tag\";s:7:\"8.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1505838844\";s:6:\"mdhash\";s:32:\"ce5d973b98b7be5c9bb97362ccff78d4\";s:8:\"filesize\";s:6:\"125256\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1505808844\";s:6:\"mdhash\";s:32:\"f181ba9ac8b693e94232346a3ecac0b6\";s:8:\"filesize\";s:6:\"125281\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1502200443\";s:6:\"mdhash\";s:32:\"0db7cacaefa6c97acb97ffff8a196648\";s:8:\"filesize\";s:6:\"123451\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:22:\"entity_browser 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1492678144\";s:6:\"mdhash\";s:32:\"0b16ad66f7323f6b50a20372aa324858\";s:8:\"filesize\";s:6:\"123359\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:26:\"entity_browser 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1487581984\";s:6:\"mdhash\";s:32:\"8e1f3a44cef830497a5652d69d4d1291\";s:8:\"filesize\";s:6:\"122105\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:26:\"entity_browser 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1486242784\";s:6:\"mdhash\";s:32:\"31c2818cc7bcb34ba414af973fcebc29\";s:8:\"filesize\";s:6:\"121328\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta4\";a:15:{s:4:\"name\";s:28:\"entity_browser 8.x-1.0-beta4\";s:7:\"version\";s:13:\"8.x-1.0-beta4\";s:3:\"tag\";s:13:\"8.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-beta4\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1484816284\";s:6:\"mdhash\";s:32:\"ae26116a425c991b8d5596d4fbfcd1f5\";s:8:\"filesize\";s:6:\"118196\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta3\";a:15:{s:4:\"name\";s:28:\"entity_browser 8.x-1.0-beta3\";s:7:\"version\";s:13:\"8.x-1.0-beta3\";s:3:\"tag\";s:13:\"8.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-beta3\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1484252583\";s:6:\"mdhash\";s:32:\"24e8a98065fc3643570a373ca56922bb\";s:8:\"filesize\";s:6:\"110790\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta2\";a:15:{s:4:\"name\";s:28:\"entity_browser 8.x-1.0-beta2\";s:7:\"version\";s:13:\"8.x-1.0-beta2\";s:3:\"tag\";s:13:\"8.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-beta2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1480323780\";s:6:\"mdhash\";s:32:\"adde6bc489fbdf1a4faeb17029b7e1a0\";s:8:\"filesize\";s:6:\"109191\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:28:\"entity_browser 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1479253139\";s:6:\"mdhash\";s:32:\"1ea7798c710c28c1e29ce653a8fd2e56\";s:8:\"filesize\";s:6:\"108065\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:15:\"8.x-1.0-alpha12\";a:15:{s:4:\"name\";s:30:\"entity_browser 8.x-1.0-alpha12\";s:7:\"version\";s:15:\"8.x-1.0-alpha12\";s:3:\"tag\";s:15:\"8.x-1.0-alpha12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha12\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha12.tar.gz\";s:4:\"date\";s:10:\"1479067140\";s:6:\"mdhash\";s:32:\"020164172c1e4b769e881ac522aeb0f3\";s:8:\"filesize\";s:6:\"106869\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-1.0-alpha11\";a:15:{s:4:\"name\";s:30:\"entity_browser 8.x-1.0-alpha11\";s:7:\"version\";s:15:\"8.x-1.0-alpha11\";s:3:\"tag\";s:15:\"8.x-1.0-alpha11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha11\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha11.tar.gz\";s:4:\"date\";s:10:\"1478642039\";s:6:\"mdhash\";s:32:\"c10892a1c48b72b82c4c90823c5abd2e\";s:8:\"filesize\";s:6:\"102662\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:15:\"8.x-1.0-alpha10\";a:15:{s:4:\"name\";s:30:\"entity_browser 8.x-1.0-alpha10\";s:7:\"version\";s:15:\"8.x-1.0-alpha10\";s:3:\"tag\";s:15:\"8.x-1.0-alpha10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha10\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha10.tar.gz\";s:4:\"date\";s:10:\"1477571940\";s:6:\"mdhash\";s:32:\"b1f4d017b25b0d89a5a431c99d5e3869\";s:8:\"filesize\";s:5:\"97360\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha9\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-1.0-alpha9\";s:7:\"version\";s:14:\"8.x-1.0-alpha9\";s:3:\"tag\";s:14:\"8.x-1.0-alpha9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha9\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha9.tar.gz\";s:4:\"date\";s:10:\"1473842039\";s:6:\"mdhash\";s:32:\"9eedd687432a956e45344705cd3c6a68\";s:8:\"filesize\";s:5:\"93221\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha8\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-1.0-alpha8\";s:7:\"version\";s:14:\"8.x-1.0-alpha8\";s:3:\"tag\";s:14:\"8.x-1.0-alpha8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha8\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha8.tar.gz\";s:4:\"date\";s:10:\"1472759639\";s:6:\"mdhash\";s:32:\"39ca77c14128821e4726de8c81077633\";s:8:\"filesize\";s:5:\"92952\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha7\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-1.0-alpha7\";s:7:\"version\";s:14:\"8.x-1.0-alpha7\";s:3:\"tag\";s:14:\"8.x-1.0-alpha7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha7\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1470170039\";s:6:\"mdhash\";s:32:\"203aafa33c5d2c5e0edc92c779c1bca7\";s:8:\"filesize\";s:5:\"85981\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha6\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-1.0-alpha6\";s:7:\"version\";s:14:\"8.x-1.0-alpha6\";s:3:\"tag\";s:14:\"8.x-1.0-alpha6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha6\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1468359239\";s:6:\"mdhash\";s:32:\"463b76a420ff0498840bd8d26d1dcf20\";s:8:\"filesize\";s:5:\"71427\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha5\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-1.0-alpha5\";s:7:\"version\";s:14:\"8.x-1.0-alpha5\";s:3:\"tag\";s:14:\"8.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha5\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1467362639\";s:6:\"mdhash\";s:32:\"2adbf5e3e8a0141077ec54c86768fea2\";s:8:\"filesize\";s:5:\"70271\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha4\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-1.0-alpha4\";s:7:\"version\";s:14:\"8.x-1.0-alpha4\";s:3:\"tag\";s:14:\"8.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha4\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1466178323\";s:6:\"mdhash\";s:32:\"4c8340b0bc0065891f376b1975391e57\";s:8:\"filesize\";s:5:\"69706\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1464714015\";s:6:\"mdhash\";s:32:\"8450bb0da14f9a5fa1c86cb00baa182a\";s:8:\"filesize\";s:5:\"67567\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1455881639\";s:6:\"mdhash\";s:32:\"d35f76b02528c9fcfc1bb7015af0b545\";s:8:\"filesize\";s:5:\"62218\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:29:\"entity_browser 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1448126043\";s:6:\"mdhash\";s:32:\"3524f0566bcd0568b0edb7dd06649059\";s:8:\"filesize\";s:5:\"50317\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-2.x-dev\";a:14:{s:4:\"name\";s:26:\"entity_browser 8.x-2.x-dev\";s:7:\"version\";s:11:\"8.x-2.x-dev\";s:3:\"tag\";s:7:\"8.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/entity_browser/releases/8.x-2.x-dev\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570360086\";s:6:\"mdhash\";s:32:\"f3d3b06c73e29da292a41deb0b666b14\";s:8:\"filesize\";s:6:\"150853\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:26:\"entity_browser 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/entity_browser/releases/8.x-1.x-dev\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/entity_browser-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570360086\";s:6:\"mdhash\";s:32:\"4d6022ea9575f57b6e7e417bb8a2abab\";s:8:\"filesize\";s:6:\"149554\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','entity_embed','a:12:{s:5:\"title\";s:12:\"Entity Embed\";s:10:\"short_name\";s:12:\"entity_embed\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:43:\"https://www.drupal.org/project/entity_embed\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:20:\"entity_embed 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1561765981\";s:6:\"mdhash\";s:32:\"2fa88b1fb68f68013f0d9327ecfe6741\";s:8:\"filesize\";s:5:\"82291\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:24:\"entity_embed 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1560529385\";s:6:\"mdhash\";s:32:\"a98cc53f1ffebc3701b9044fd81f44ca\";s:8:\"filesize\";s:5:\"75465\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:24:\"entity_embed 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1560008285\";s:6:\"mdhash\";s:32:\"92ac04aa453be06fbb81df58fbe9ef79\";s:8:\"filesize\";s:5:\"71309\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta3\";a:15:{s:4:\"name\";s:26:\"entity_embed 8.x-1.0-beta3\";s:7:\"version\";s:13:\"8.x-1.0-beta3\";s:3:\"tag\";s:13:\"8.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0-beta3\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1556906881\";s:6:\"mdhash\";s:32:\"0db91e316f8abae3acfde10a2c4196e5\";s:8:\"filesize\";s:5:\"55212\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta2\";a:15:{s:4:\"name\";s:26:\"entity_embed 8.x-1.0-beta2\";s:7:\"version\";s:13:\"8.x-1.0-beta2\";s:3:\"tag\";s:13:\"8.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0-beta2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1476698339\";s:6:\"mdhash\";s:32:\"dba45864654c42d823728c196aed9bb2\";s:8:\"filesize\";s:5:\"50492\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:26:\"entity_embed 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1473360539\";s:6:\"mdhash\";s:32:\"dcbe96584a5e3e518384cb05aa88761a\";s:8:\"filesize\";s:5:\"50515\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:27:\"entity_embed 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1470170039\";s:6:\"mdhash\";s:32:\"f1fbd0f9a10030f9a38973eb91d80093\";s:8:\"filesize\";s:5:\"50596\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:27:\"entity_embed 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1467721139\";s:6:\"mdhash\";s:32:\"3059e5b3f9f005bf8f9f846d0b4d64d0\";s:8:\"filesize\";s:5:\"47974\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:27:\"entity_embed 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1460651755\";s:6:\"mdhash\";s:32:\"9ef4f30260e6f695661fa75f3d44e3f6\";s:8:\"filesize\";s:5:\"45195\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:24:\"entity_embed 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/entity_embed/releases/8.x-1.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/entity_embed-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1565792887\";s:6:\"mdhash\";s:32:\"ed83254b25f98dd19df506babd4b79bc\";s:8:\"filesize\";s:5:\"82604\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570954920;}',1571041320),

('update_available_releases','entity_reference_revisions','a:12:{s:5:\"title\";s:26:\"Entity Reference Revisions\";s:10:\"short_name\";s:26:\"entity_reference_revisions\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:57:\"https://www.drupal.org/project/entity_reference_revisions\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:13:{s:7:\"8.x-1.7\";a:14:{s:4:\"name\";s:34:\"entity_reference_revisions 8.x-1.7\";s:7:\"version\";s:7:\"8.x-1.7\";s:3:\"tag\";s:7:\"8.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.7\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1570284187\";s:6:\"mdhash\";s:32:\"3faf914f92235891bac7ffaa58e55845\";s:8:\"filesize\";s:5:\"50642\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.6\";a:14:{s:4:\"name\";s:34:\"entity_reference_revisions 8.x-1.6\";s:7:\"version\";s:7:\"8.x-1.6\";s:3:\"tag\";s:7:\"8.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.6\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1539588781\";s:6:\"mdhash\";s:32:\"efa5eb92ac80b73d6bdaff338ce860b2\";s:8:\"filesize\";s:5:\"41809\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:34:\"entity_reference_revisions 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.5\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1527241084\";s:6:\"mdhash\";s:32:\"6d49d9ee815eb836c07fb259186c58b4\";s:8:\"filesize\";s:5:\"39015\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:34:\"entity_reference_revisions 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.4\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1515143885\";s:6:\"mdhash\";s:32:\"3f19762713ffb5c0665b9ae39f457c00\";s:8:\"filesize\";s:5:\"35685\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.3\";a:14:{s:4:\"name\";s:34:\"entity_reference_revisions 8.x-1.3\";s:7:\"version\";s:7:\"8.x-1.3\";s:3:\"tag\";s:7:\"8.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.3\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1495814284\";s:6:\"mdhash\";s:32:\"e8b5ba2a3a3762325f6d038150084659\";s:8:\"filesize\";s:5:\"34506\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:34:\"entity_reference_revisions 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.2\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1485790085\";s:6:\"mdhash\";s:32:\"7ae765c1f3c70e0bcc9319948bd69a90\";s:8:\"filesize\";s:5:\"33777\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:34:\"entity_reference_revisions 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.1\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1485526384\";s:6:\"mdhash\";s:32:\"770bcb1130357f5641894f469bb60856\";s:8:\"filesize\";s:5:\"33693\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:34:\"entity_reference_revisions 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.0\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1469725439\";s:6:\"mdhash\";s:32:\"391bb3f132a357e2f519bdfd18166f5a\";s:8:\"filesize\";s:5:\"28196\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.0-rc7\";a:15:{s:4:\"name\";s:38:\"entity_reference_revisions 8.x-1.0-rc7\";s:7:\"version\";s:11:\"8.x-1.0-rc7\";s:3:\"tag\";s:11:\"8.x-1.0-rc7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:78:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.0-rc7\";s:13:\"download_link\";s:83:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.0-rc7.tar.gz\";s:4:\"date\";s:10:\"1464727139\";s:6:\"mdhash\";s:32:\"c183185d5bf717d5379d837844fcba7f\";s:8:\"filesize\";s:5:\"27680\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc6\";a:15:{s:4:\"name\";s:38:\"entity_reference_revisions 8.x-1.0-rc6\";s:7:\"version\";s:11:\"8.x-1.0-rc6\";s:3:\"tag\";s:11:\"8.x-1.0-rc6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:78:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.0-rc6\";s:13:\"download_link\";s:83:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.0-rc6.tar.gz\";s:4:\"date\";s:10:\"1460582040\";s:6:\"mdhash\";s:32:\"0e0ccfbf0fd627600eb8f6268a00f633\";s:8:\"filesize\";s:5:\"24811\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc4\";a:15:{s:4:\"name\";s:38:\"entity_reference_revisions 8.x-1.0-rc4\";s:7:\"version\";s:11:\"8.x-1.0-rc4\";s:3:\"tag\";s:11:\"8.x-1.0-rc4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:78:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.0-rc4\";s:13:\"download_link\";s:83:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1447766339\";s:6:\"mdhash\";s:32:\"cfb4a1898a92f941b678792a75f63a4b\";s:8:\"filesize\";s:5:\"22178\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:38:\"entity_reference_revisions 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:78:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:83:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1444419239\";s:6:\"mdhash\";s:32:\"523835c0ebf1bdde3e45d1d0eb23cdba\";s:8:\"filesize\";s:5:\"22196\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:38:\"entity_reference_revisions 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:78:\"https://www.drupal.org/project/entity_reference_revisions/releases/8.x-1.x-dev\";s:13:\"download_link\";s:83:\"https://ftp.drupal.org/files/projects/entity_reference_revisions-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570280887\";s:6:\"mdhash\";s:32:\"c4b73b56a58c67d387069726e5439d24\";s:8:\"filesize\";s:5:\"50651\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570954568;}',1571040968),

('update_available_releases','examples','a:12:{s:5:\"title\";s:23:\"Examples for Developers\";s:10:\"short_name\";s:8:\"examples\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/examples\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:1:{s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"examples 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/examples/releases/8.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/examples-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1506102244\";s:6:\"mdhash\";s:32:\"1d324524324a0cbf80ff865f16ddb158\";s:8:\"filesize\";s:6:\"177777\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1507111524;}',1507197924),

('update_available_releases','features','a:12:{s:5:\"title\";s:8:\"Features\";s:10:\"short_name\";s:8:\"features\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:3:\"3,4\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/features\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:27:{s:7:\"8.x-3.8\";a:14:{s:4:\"name\";s:16:\"features 8.x-3.8\";s:7:\"version\";s:7:\"8.x-3.8\";s:3:\"tag\";s:7:\"8.x-3.8\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/8.x-3.8\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-8.x-3.8.tar.gz\";s:4:\"date\";s:10:\"1536512284\";s:6:\"mdhash\";s:32:\"47c3a646eeac4fd9e8ebabbf0cddfdfd\";s:8:\"filesize\";s:6:\"109500\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-3.7\";a:14:{s:4:\"name\";s:16:\"features 8.x-3.7\";s:7:\"version\";s:7:\"8.x-3.7\";s:3:\"tag\";s:7:\"8.x-3.7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/8.x-3.7\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-8.x-3.7.tar.gz\";s:4:\"date\";s:10:\"1519763284\";s:6:\"mdhash\";s:32:\"2297bff90f737d2bde36e27f19418aa1\";s:8:\"filesize\";s:6:\"108869\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-3.6\";a:14:{s:4:\"name\";s:16:\"features 8.x-3.6\";s:7:\"version\";s:7:\"8.x-3.6\";s:3:\"tag\";s:7:\"8.x-3.6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/8.x-3.6\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-8.x-3.6.tar.gz\";s:4:\"date\";s:10:\"1519703584\";s:6:\"mdhash\";s:32:\"ac073d2a7e8865d60dd1530d78fb2fa5\";s:8:\"filesize\";s:6:\"109420\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-3.5\";a:14:{s:4:\"name\";s:16:\"features 8.x-3.5\";s:7:\"version\";s:7:\"8.x-3.5\";s:3:\"tag\";s:7:\"8.x-3.5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/8.x-3.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-8.x-3.5.tar.gz\";s:4:\"date\";s:10:\"1488908583\";s:6:\"mdhash\";s:32:\"c405a7a6720c53e013802cc31972fb81\";s:8:\"filesize\";s:6:\"100137\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"8.x-3.4\";a:14:{s:4:\"name\";s:16:\"features 8.x-3.4\";s:7:\"version\";s:7:\"8.x-3.4\";s:3:\"tag\";s:7:\"8.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/8.x-3.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-8.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1488296285\";s:6:\"mdhash\";s:32:\"0ba86841bdeea0ab0a44b21a9676e267\";s:8:\"filesize\";s:6:\"100160\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-3.3\";a:14:{s:4:\"name\";s:16:\"features 8.x-3.3\";s:7:\"version\";s:7:\"8.x-3.3\";s:3:\"tag\";s:7:\"8.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/8.x-3.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-8.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1487861884\";s:6:\"mdhash\";s:32:\"00f58c6bc40af9d89fed1eeb69fa64ca\";s:8:\"filesize\";s:6:\"100163\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-3.2\";a:14:{s:4:\"name\";s:16:\"features 8.x-3.2\";s:7:\"version\";s:7:\"8.x-3.2\";s:3:\"tag\";s:7:\"8.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/8.x-3.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-8.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1481513884\";s:6:\"mdhash\";s:32:\"e320f360a329ba0fd6be36c75c2b555f\";s:8:\"filesize\";s:5:\"97520\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-3.1\";a:14:{s:4:\"name\";s:16:\"features 8.x-3.1\";s:7:\"version\";s:7:\"8.x-3.1\";s:3:\"tag\";s:7:\"8.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/8.x-3.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-8.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1479430142\";s:6:\"mdhash\";s:32:\"82d06d765ebbfc393ef3cbeed8f96932\";s:8:\"filesize\";s:5:\"97124\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-3.0\";a:14:{s:4:\"name\";s:16:\"features 8.x-3.0\";s:7:\"version\";s:7:\"8.x-3.0\";s:3:\"tag\";s:7:\"8.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/8.x-3.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-8.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1478188444\";s:6:\"mdhash\";s:32:\"1a198d980b1f36b137ed4deefee756a8\";s:8:\"filesize\";s:5:\"97012\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-3.0-rc1\";a:15:{s:4:\"name\";s:20:\"features 8.x-3.0-rc1\";s:7:\"version\";s:11:\"8.x-3.0-rc1\";s:3:\"tag\";s:11:\"8.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/8.x-3.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1475180939\";s:6:\"mdhash\";s:32:\"ff919d449de8cb89c5fdc7d14b39405b\";s:8:\"filesize\";s:5:\"96403\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta9\";a:15:{s:4:\"name\";s:22:\"features 8.x-3.0-beta9\";s:7:\"version\";s:13:\"8.x-3.0-beta9\";s:3:\"tag\";s:13:\"8.x-3.0-beta9\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/8.x-3.0-beta9\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1473884039\";s:6:\"mdhash\";s:32:\"d8a85a166fbcce49958a1ed16ccbd449\";s:8:\"filesize\";s:5:\"95860\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta8\";a:15:{s:4:\"name\";s:22:\"features 8.x-3.0-beta8\";s:7:\"version\";s:13:\"8.x-3.0-beta8\";s:3:\"tag\";s:13:\"8.x-3.0-beta8\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/8.x-3.0-beta8\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1472847263\";s:6:\"mdhash\";s:32:\"8edb2731e0bb854a916b5bb96fae6036\";s:8:\"filesize\";s:5:\"93173\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta7\";a:15:{s:4:\"name\";s:22:\"features 8.x-3.0-beta7\";s:7:\"version\";s:13:\"8.x-3.0-beta7\";s:3:\"tag\";s:13:\"8.x-3.0-beta7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/8.x-3.0-beta7\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1470336647\";s:6:\"mdhash\";s:32:\"61928ab8fd6891f8eaf4a2dfc6d67609\";s:8:\"filesize\";s:5:\"91652\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta6\";a:15:{s:4:\"name\";s:22:\"features 8.x-3.0-beta6\";s:7:\"version\";s:13:\"8.x-3.0-beta6\";s:3:\"tag\";s:13:\"8.x-3.0-beta6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/8.x-3.0-beta6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1467982823\";s:6:\"mdhash\";s:32:\"4c0ea4b552b42393697b62e789c57980\";s:8:\"filesize\";s:5:\"91116\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta5\";a:15:{s:4:\"name\";s:22:\"features 8.x-3.0-beta5\";s:7:\"version\";s:13:\"8.x-3.0-beta5\";s:3:\"tag\";s:13:\"8.x-3.0-beta5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/8.x-3.0-beta5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1465484039\";s:6:\"mdhash\";s:32:\"8629c3fc79b74b98d43faa44ef0526af\";s:8:\"filesize\";s:5:\"91247\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta4\";a:15:{s:4:\"name\";s:22:\"features 8.x-3.0-beta4\";s:7:\"version\";s:13:\"8.x-3.0-beta4\";s:3:\"tag\";s:13:\"8.x-3.0-beta4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/8.x-3.0-beta4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1465398164\";s:6:\"mdhash\";s:32:\"cb8b2258792f4d55058382815c5fd2ae\";s:8:\"filesize\";s:5:\"91249\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta3\";a:15:{s:4:\"name\";s:22:\"features 8.x-3.0-beta3\";s:7:\"version\";s:13:\"8.x-3.0-beta3\";s:3:\"tag\";s:13:\"8.x-3.0-beta3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/8.x-3.0-beta3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1460059242\";s:6:\"mdhash\";s:32:\"a41d874cbbbf5ce5d846fd74200646d2\";s:8:\"filesize\";s:5:\"91179\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta2\";a:15:{s:4:\"name\";s:22:\"features 8.x-3.0-beta2\";s:7:\"version\";s:13:\"8.x-3.0-beta2\";s:3:\"tag\";s:13:\"8.x-3.0-beta2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/8.x-3.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1459967939\";s:6:\"mdhash\";s:32:\"d8a2e9af81106a5c234e1996f1d29653\";s:8:\"filesize\";s:5:\"91108\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta1\";a:15:{s:4:\"name\";s:22:\"features 8.x-3.0-beta1\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:3:\"tag\";s:13:\"8.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/8.x-3.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1459551539\";s:6:\"mdhash\";s:32:\"ecb2da21d0d098557018290ec6a5de96\";s:8:\"filesize\";s:5:\"91024\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha6\";a:15:{s:4:\"name\";s:23:\"features 8.x-3.0-alpha6\";s:7:\"version\";s:14:\"8.x-3.0-alpha6\";s:3:\"tag\";s:14:\"8.x-3.0-alpha6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/8.x-3.0-alpha6\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1454018939\";s:6:\"mdhash\";s:32:\"8932081c1eb334a165937ad7192b1a28\";s:8:\"filesize\";s:5:\"86341\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha5\";a:15:{s:4:\"name\";s:23:\"features 8.x-3.0-alpha5\";s:7:\"version\";s:14:\"8.x-3.0-alpha5\";s:3:\"tag\";s:14:\"8.x-3.0-alpha5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/8.x-3.0-alpha5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1449083939\";s:6:\"mdhash\";s:32:\"cd5c34cf5532c15fc92f8990bc7bc171\";s:8:\"filesize\";s:5:\"77370\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha4\";a:15:{s:4:\"name\";s:23:\"features 8.x-3.0-alpha4\";s:7:\"version\";s:14:\"8.x-3.0-alpha4\";s:3:\"tag\";s:14:\"8.x-3.0-alpha4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/8.x-3.0-alpha4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1445441339\";s:6:\"mdhash\";s:32:\"a0ddcfcd60b2ce8b20b1665298111d04\";s:8:\"filesize\";s:5:\"71805\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha3\";a:15:{s:4:\"name\";s:23:\"features 8.x-3.0-alpha3\";s:7:\"version\";s:14:\"8.x-3.0-alpha3\";s:3:\"tag\";s:14:\"8.x-3.0-alpha3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/8.x-3.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1442257439\";s:6:\"mdhash\";s:32:\"74e4a221870d4acec29ea825c305f47d\";s:8:\"filesize\";s:5:\"66164\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha2\";a:15:{s:4:\"name\";s:23:\"features 8.x-3.0-alpha2\";s:7:\"version\";s:14:\"8.x-3.0-alpha2\";s:3:\"tag\";s:14:\"8.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/8.x-3.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1437153239\";s:6:\"mdhash\";s:32:\"2134568b0670f32cdaa8cd4e794049e6\";s:8:\"filesize\";s:5:\"65229\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha1\";a:15:{s:4:\"name\";s:23:\"features 8.x-3.0-alpha1\";s:7:\"version\";s:14:\"8.x-3.0-alpha1\";s:3:\"tag\";s:14:\"8.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/8.x-3.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-8.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1428943813\";s:6:\"mdhash\";s:32:\"d1e061c6fa91a1e6c397fae8eafbef12\";s:8:\"filesize\";s:5:\"61377\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-4.x-dev\";a:14:{s:4:\"name\";s:20:\"features 8.x-4.x-dev\";s:7:\"version\";s:11:\"8.x-4.x-dev\";s:3:\"tag\";s:7:\"8.x-4.x\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/8.x-4.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-8.x-4.x-dev.tar.gz\";s:4:\"date\";s:10:\"1547945580\";s:6:\"mdhash\";s:32:\"56cf1c1317f9ddc754e091af1bede2f7\";s:8:\"filesize\";s:6:\"109516\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-3.x-dev\";a:14:{s:4:\"name\";s:20:\"features 8.x-3.x-dev\";s:7:\"version\";s:11:\"8.x-3.x-dev\";s:3:\"tag\";s:7:\"8.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/8.x-3.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-8.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1536511681\";s:6:\"mdhash\";s:32:\"9f03f39bb24933374142c9ce6ba8fd05\";s:8:\"filesize\";s:6:\"109504\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1548061109;}',1548147509),

('update_available_releases','field_group','a:12:{s:5:\"title\";s:11:\"Field Group\";s:10:\"short_name\";s:11:\"field_group\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/field_group\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:9:{s:11:\"8.x-3.0-rc1\";a:15:{s:4:\"name\";s:23:\"field_group 8.x-3.0-rc1\";s:7:\"version\";s:11:\"8.x-3.0-rc1\";s:3:\"tag\";s:11:\"8.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/8.x-3.0-rc1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-8.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1558647185\";s:6:\"mdhash\";s:32:\"984d39ea4b57b22834b80a807b5a29fe\";s:8:\"filesize\";s:5:\"54992\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta1\";a:15:{s:4:\"name\";s:25:\"field_group 8.x-3.0-beta1\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:3:\"tag\";s:13:\"8.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/field_group/releases/8.x-3.0-beta1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/field_group-8.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1510352284\";s:6:\"mdhash\";s:32:\"0fd62aa5b480ce8800eda23b82963167\";s:8:\"filesize\";s:5:\"50677\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:19:\"field_group 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/8.x-1.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1510352885\";s:6:\"mdhash\";s:32:\"fc9871d94520eaa673e6abb548516105\";s:8:\"filesize\";s:5:\"49821\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.0-rc6\";a:15:{s:4:\"name\";s:23:\"field_group 8.x-1.0-rc6\";s:7:\"version\";s:11:\"8.x-1.0-rc6\";s:3:\"tag\";s:11:\"8.x-1.0-rc6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/8.x-1.0-rc6\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-8.x-1.0-rc6.tar.gz\";s:4:\"date\";s:10:\"1480365484\";s:6:\"mdhash\";s:32:\"dff71a7fa26650aaea19a34c340b8560\";s:8:\"filesize\";s:5:\"49297\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc5\";a:15:{s:4:\"name\";s:23:\"field_group 8.x-1.0-rc5\";s:7:\"version\";s:11:\"8.x-1.0-rc5\";s:3:\"tag\";s:11:\"8.x-1.0-rc5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/8.x-1.0-rc5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-8.x-1.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1480288380\";s:6:\"mdhash\";s:32:\"9bb8d121ce6cc134804b8ce881a84bf5\";s:8:\"filesize\";s:5:\"49312\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc4\";a:15:{s:4:\"name\";s:23:\"field_group 8.x-1.0-rc4\";s:7:\"version\";s:11:\"8.x-1.0-rc4\";s:3:\"tag\";s:11:\"8.x-1.0-rc4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/8.x-1.0-rc4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-8.x-1.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1449771240\";s:6:\"mdhash\";s:32:\"e34c190d0f7b9191f4b712f93f3dd9a5\";s:8:\"filesize\";s:5:\"42795\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc3\";a:15:{s:4:\"name\";s:23:\"field_group 8.x-1.0-rc3\";s:7:\"version\";s:11:\"8.x-1.0-rc3\";s:3:\"tag\";s:11:\"8.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/8.x-1.0-rc3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-8.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1447385940\";s:6:\"mdhash\";s:32:\"cc97db2bf15a4ca4f876546f50b46efd\";s:8:\"filesize\";s:5:\"42833\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.x-dev\";a:14:{s:4:\"name\";s:23:\"field_group 8.x-3.x-dev\";s:7:\"version\";s:11:\"8.x-3.x-dev\";s:3:\"tag\";s:7:\"8.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/8.x-3.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-8.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570894385\";s:6:\"mdhash\";s:32:\"fc3275db9939b98491ac3055eecbc853\";s:8:\"filesize\";s:5:\"57039\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"field_group 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/8.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570214888\";s:6:\"mdhash\";s:32:\"4a3020b7d112a136747a9c6517d0e1dd\";s:8:\"filesize\";s:5:\"50052\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570954921;}',1571041321),

('update_available_releases','file_browser','a:12:{s:5:\"title\";s:19:\"File Entity Browser\";s:10:\"short_name\";s:12:\"file_browser\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:43:\"https://www.drupal.org/project/file_browser\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:8:{s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:20:\"file_browser 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/file_browser/releases/8.x-1.2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/file_browser-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1569940086\";s:6:\"mdhash\";s:32:\"93fb5980e3533dde73a94ea4bf2808b3\";s:8:\"filesize\";s:5:\"26468\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:20:\"file_browser 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/file_browser/releases/8.x-1.1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/file_browser-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1493226843\";s:6:\"mdhash\";s:32:\"a78fe3a0f2f373b465b1862c5a6d465c\";s:8:\"filesize\";s:5:\"23701\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:20:\"file_browser 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/file_browser/releases/8.x-1.0\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/file_browser-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1492994042\";s:6:\"mdhash\";s:32:\"f63768a5b1778c783c3038c2abaa3cc0\";s:8:\"filesize\";s:5:\"23536\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:14:\"8.x-1.0-alpha4\";a:15:{s:4:\"name\";s:27:\"file_browser 8.x-1.0-alpha4\";s:7:\"version\";s:14:\"8.x-1.0-alpha4\";s:3:\"tag\";s:14:\"8.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/file_browser/releases/8.x-1.0-alpha4\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/file_browser-8.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1485822183\";s:6:\"mdhash\";s:32:\"cb473c348aa047db4de08b05f84ec1cd\";s:8:\"filesize\";s:5:\"21186\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:27:\"file_browser 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/file_browser/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/file_browser-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1480354680\";s:6:\"mdhash\";s:32:\"6bb82e902fb5bb330300e86149c4c2f0\";s:8:\"filesize\";s:5:\"20828\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:27:\"file_browser 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/file_browser/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/file_browser-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1479227093\";s:6:\"mdhash\";s:32:\"ed0904ae44d9ed476656a2144c784fa8\";s:8:\"filesize\";s:5:\"20821\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:27:\"file_browser 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/file_browser/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/file_browser-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1470191039\";s:6:\"mdhash\";s:32:\"9f22230e77fbd931d4aa2725d5ee8d9d\";s:8:\"filesize\";s:5:\"20821\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:24:\"file_browser 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/file_browser/releases/8.x-1.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/file_browser-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1569939784\";s:6:\"mdhash\";s:32:\"bc9f54f22cecc7cb6758709e27d9f7f7\";s:8:\"filesize\";s:5:\"26482\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570954921;}',1571041321),

('update_available_releases','inline_entity_form','a:11:{s:5:\"title\";s:18:\"Inline Entity Form\";s:10:\"short_name\";s:18:\"inline_entity_form\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:49:\"https://www.drupal.org/project/inline_entity_form\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:30:\"inline_entity_form 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1568446684\";s:6:\"mdhash\";s:32:\"38963cefde9297ca1d29ecd2fe3cb8af\";s:8:\"filesize\";s:5:\"52831\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:30:\"inline_entity_form 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1527030784\";s:6:\"mdhash\";s:32:\"48a330ddadc412318883b30f478f8d99\";s:8:\"filesize\";s:5:\"51148\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:32:\"inline_entity_form 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1477868343\";s:6:\"mdhash\";s:32:\"592b9b9bb058524d47903cf14404c924\";s:8:\"filesize\";s:5:\"51128\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha6\";a:15:{s:4:\"name\";s:33:\"inline_entity_form 8.x-1.0-alpha6\";s:7:\"version\";s:14:\"8.x-1.0-alpha6\";s:3:\"tag\";s:14:\"8.x-1.0-alpha6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-alpha6\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1461165839\";s:6:\"mdhash\";s:32:\"ba938dec8dd3c1f66c21c0c6806af9b3\";s:8:\"filesize\";s:5:\"47146\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha5\";a:15:{s:4:\"name\";s:33:\"inline_entity_form 8.x-1.0-alpha5\";s:7:\"version\";s:14:\"8.x-1.0-alpha5\";s:3:\"tag\";s:14:\"8.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-alpha5\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1456785539\";s:6:\"mdhash\";s:32:\"1d6033300082a52f28fde10e372156b3\";s:8:\"filesize\";s:5:\"44101\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha4\";a:15:{s:4:\"name\";s:33:\"inline_entity_form 8.x-1.0-alpha4\";s:7:\"version\";s:14:\"8.x-1.0-alpha4\";s:3:\"tag\";s:14:\"8.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-alpha4\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1455831839\";s:6:\"mdhash\";s:32:\"628107ab80fbff693729a0db4b429d62\";s:8:\"filesize\";s:5:\"43922\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:33:\"inline_entity_form 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1451036639\";s:6:\"mdhash\";s:32:\"45f5adb7c8c07418983796447a835246\";s:8:\"filesize\";s:5:\"38901\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:33:\"inline_entity_form 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1444926539\";s:6:\"mdhash\";s:32:\"bcaa366f357d360af696270a3af99e58\";s:8:\"filesize\";s:5:\"35708\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:33:\"inline_entity_form 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1436609939\";s:6:\"mdhash\";s:32:\"df616bb64d8af424e5a6c910ec4cbe0c\";s:8:\"filesize\";s:5:\"32998\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:30:\"inline_entity_form 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/inline_entity_form/releases/8.x-1.x-dev\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/inline_entity_form-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1559233986\";s:6:\"mdhash\";s:32:\"2c6063eddcb63ba5745a524464d559ee\";s:8:\"filesize\";s:5:\"52841\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','NikaDevs','a:1:{s:10:\"last_fetch\";i:1570952922;}',1571039322),

('update_available_releases','pathauto','a:12:{s:5:\"title\";s:8:\"Pathauto\";s:10:\"short_name\";s:8:\"pathauto\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/pathauto\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:13:{s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:16:\"pathauto 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/8.x-1.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1570828084\";s:6:\"mdhash\";s:32:\"b782ac3aead58b688b6ce2ac9702f8c8\";s:8:\"filesize\";s:5:\"72836\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:16:\"pathauto 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/8.x-1.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1554239887\";s:6:\"mdhash\";s:32:\"55dd10c9e281601b8107bd338afaf983\";s:8:\"filesize\";s:5:\"72061\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.3\";a:14:{s:4:\"name\";s:16:\"pathauto 8.x-1.3\";s:7:\"version\";s:7:\"8.x-1.3\";s:3:\"tag\";s:7:\"8.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/8.x-1.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1536407884\";s:6:\"mdhash\";s:32:\"8594bc8a835a4cacc1950a77340937ba\";s:8:\"filesize\";s:5:\"67818\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:16:\"pathauto 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/8.x-1.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1524421084\";s:6:\"mdhash\";s:32:\"04b2d6a9ddf5d860b38b7acf545458b6\";s:8:\"filesize\";s:5:\"67104\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:16:\"pathauto 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/8.x-1.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1520092685\";s:6:\"mdhash\";s:32:\"ab98fb9d69cc9cc7a90a05902877701f\";s:8:\"filesize\";s:5:\"66990\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:16:\"pathauto 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/8.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1493468044\";s:6:\"mdhash\";s:32:\"b4ba0ca14f5812cb2f5bfba8ae0a7729\";s:8:\"filesize\";s:5:\"64185\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:20:\"pathauto 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/pathauto/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1485702484\";s:6:\"mdhash\";s:32:\"09cfb45706be9c3e0dabfd7094c96c62\";s:8:\"filesize\";s:5:\"64195\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta2\";a:15:{s:4:\"name\";s:22:\"pathauto 8.x-1.0-beta2\";s:7:\"version\";s:13:\"8.x-1.0-beta2\";s:3:\"tag\";s:13:\"8.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/pathauto/releases/8.x-1.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1484781483\";s:6:\"mdhash\";s:32:\"08828ca7871b53ec82f795fcec178612\";s:8:\"filesize\";s:5:\"63183\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:22:\"pathauto 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/pathauto/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1474313339\";s:6:\"mdhash\";s:32:\"85259b46446e4b61f05ca166cf0b43e1\";s:8:\"filesize\";s:5:\"62163\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:23:\"pathauto 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/pathauto/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1461007694\";s:6:\"mdhash\";s:32:\"90e44d8612ce516b9d4199bc31b8e9b1\";s:8:\"filesize\";s:5:\"60627\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:23:\"pathauto 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/pathauto/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1456529339\";s:6:\"mdhash\";s:32:\"b05b1ed1a1ca215da12945549544150d\";s:8:\"filesize\";s:5:\"54396\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:23:\"pathauto 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/pathauto/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1453413539\";s:6:\"mdhash\";s:32:\"4f36c1116e5d7612da66100323447770\";s:8:\"filesize\";s:5:\"53687\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"pathauto 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/pathauto/releases/8.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/pathauto-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1567711380\";s:6:\"mdhash\";s:32:\"fb117f5b86dc08ec0e401ac365b78a2d\";s:8:\"filesize\";s:5:\"72842\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570954568;}',1571040968),

('update_available_releases','profile','a:12:{s:5:\"title\";s:7:\"Profile\";s:10:\"short_name\";s:7:\"profile\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:38:\"https://www.drupal.org/project/profile\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:16:{s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:15:\"profile 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/profile/releases/8.x-1.0\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1567007888\";s:6:\"mdhash\";s:32:\"6904fa1fac9c6b51b4b44cf8cd149588\";s:8:\"filesize\";s:5:\"43976\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.0-rc6\";a:15:{s:4:\"name\";s:19:\"profile 8.x-1.0-rc6\";s:7:\"version\";s:11:\"8.x-1.0-rc6\";s:3:\"tag\";s:11:\"8.x-1.0-rc6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/profile/releases/8.x-1.0-rc6\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-rc6.tar.gz\";s:4:\"date\";s:10:\"1562966885\";s:6:\"mdhash\";s:32:\"9a9eb896c87da325f81a7a85b03c0e5d\";s:8:\"filesize\";s:5:\"44926\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc5\";a:15:{s:4:\"name\";s:19:\"profile 8.x-1.0-rc5\";s:7:\"version\";s:11:\"8.x-1.0-rc5\";s:3:\"tag\";s:11:\"8.x-1.0-rc5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/profile/releases/8.x-1.0-rc5\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1559926985\";s:6:\"mdhash\";s:32:\"84b884592096f5c296ee7821bf7d424c\";s:8:\"filesize\";s:5:\"43790\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc4\";a:15:{s:4:\"name\";s:19:\"profile 8.x-1.0-rc4\";s:7:\"version\";s:11:\"8.x-1.0-rc4\";s:3:\"tag\";s:11:\"8.x-1.0-rc4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/profile/releases/8.x-1.0-rc4\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1552407486\";s:6:\"mdhash\";s:32:\"865e90a2c80c862c37892fc21e25c475\";s:8:\"filesize\";s:5:\"42977\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc3\";a:15:{s:4:\"name\";s:19:\"profile 8.x-1.0-rc3\";s:7:\"version\";s:11:\"8.x-1.0-rc3\";s:3:\"tag\";s:11:\"8.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/profile/releases/8.x-1.0-rc3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1552121886\";s:6:\"mdhash\";s:32:\"055a9db366bd389ffb01b814c13a2623\";s:8:\"filesize\";s:5:\"43044\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:19:\"profile 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/profile/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1551998880\";s:6:\"mdhash\";s:32:\"4a3f143e29304c286c6934c1d62fc8b8\";s:8:\"filesize\";s:5:\"43002\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:19:\"profile 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/profile/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1505830145\";s:6:\"mdhash\";s:32:\"1621863fdb439ee03d4721280c96d0e5\";s:8:\"filesize\";s:5:\"40813\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:21:\"profile 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/profile/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1497287643\";s:6:\"mdhash\";s:32:\"d422fcbf1193239261544971fcd0cc13\";s:8:\"filesize\";s:5:\"39239\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha7\";a:15:{s:4:\"name\";s:22:\"profile 8.x-1.0-alpha7\";s:7:\"version\";s:14:\"8.x-1.0-alpha7\";s:3:\"tag\";s:14:\"8.x-1.0-alpha7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/profile/releases/8.x-1.0-alpha7\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1493902084\";s:6:\"mdhash\";s:32:\"6486ac0981c32d7e93dac98a17c03158\";s:8:\"filesize\";s:5:\"38373\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha6\";a:15:{s:4:\"name\";s:22:\"profile 8.x-1.0-alpha6\";s:7:\"version\";s:14:\"8.x-1.0-alpha6\";s:3:\"tag\";s:14:\"8.x-1.0-alpha6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/profile/releases/8.x-1.0-alpha6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1493741883\";s:6:\"mdhash\";s:32:\"1c40af9f5820a65499c3e8a570e60d17\";s:8:\"filesize\";s:5:\"38033\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha5\";a:15:{s:4:\"name\";s:22:\"profile 8.x-1.0-alpha5\";s:7:\"version\";s:14:\"8.x-1.0-alpha5\";s:3:\"tag\";s:14:\"8.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/profile/releases/8.x-1.0-alpha5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1471873739\";s:6:\"mdhash\";s:32:\"0df82070fc567379b924052cb148b1ad\";s:8:\"filesize\";s:5:\"38983\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha4\";a:15:{s:4:\"name\";s:22:\"profile 8.x-1.0-alpha4\";s:7:\"version\";s:14:\"8.x-1.0-alpha4\";s:3:\"tag\";s:14:\"8.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/profile/releases/8.x-1.0-alpha4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1459302242\";s:6:\"mdhash\";s:32:\"b0ff4cafff858f55ad07238a342135a2\";s:8:\"filesize\";s:5:\"38617\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:22:\"profile 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/profile/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1457045939\";s:6:\"mdhash\";s:32:\"1c91658271cf5e515e426113f3416efe\";s:8:\"filesize\";s:5:\"38607\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:22:\"profile 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/profile/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1453421039\";s:6:\"mdhash\";s:32:\"3c2b61e3b96d258dc87d5ca5b1a66323\";s:8:\"filesize\";s:5:\"35139\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:22:\"profile 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/profile/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/profile-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1451039639\";s:6:\"mdhash\";s:32:\"44ecb7c424d2cd420e9f1bb470e872c5\";s:8:\"filesize\";s:5:\"33423\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:19:\"profile 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/profile/releases/8.x-1.x-dev\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/profile-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1566642488\";s:6:\"mdhash\";s:32:\"18d3ffc3414b95bd9630bde7c719c994\";s:8:\"filesize\";s:5:\"43991\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','shortcode','a:12:{s:5:\"title\";s:9:\"Shortcode\";s:10:\"short_name\";s:9:\"shortcode\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/shortcode\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:5:{s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:21:\"shortcode 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/shortcode/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/shortcode-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1543219084\";s:6:\"mdhash\";s:32:\"bba2c3405ea5fa9f2e01f4f562b043e4\";s:8:\"filesize\";s:5:\"21978\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:21:\"shortcode 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/shortcode/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/shortcode-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1487350082\";s:6:\"mdhash\";s:32:\"5b2ccdecb5c512840b17a40376fbc45a\";s:8:\"filesize\";s:5:\"21176\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:24:\"shortcode 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/shortcode/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/shortcode-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1477248540\";s:6:\"mdhash\";s:32:\"70475627be2c6fb4406f394bdc240936\";s:8:\"filesize\";s:5:\"21231\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:24:\"shortcode 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/shortcode/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/shortcode-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1467427740\";s:6:\"mdhash\";s:32:\"76c3321d2bb2215c44fd27e5339f665d\";s:8:\"filesize\";s:5:\"20934\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:21:\"shortcode 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/shortcode/releases/8.x-1.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/shortcode-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1543218180\";s:6:\"mdhash\";s:32:\"eed2189ffcadb8ea5ee56afe280830ad\";s:8:\"filesize\";s:5:\"21988\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','state_machine','a:12:{s:5:\"title\";s:13:\"State Machine\";s:10:\"short_name\";s:13:\"state_machine\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/state_machine\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:5:{s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:25:\"state_machine 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/state_machine/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/state_machine-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1542122580\";s:6:\"mdhash\";s:32:\"1226d0bedbb21e5b0bd20ed152bea503\";s:8:\"filesize\";s:5:\"28718\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta3\";a:15:{s:4:\"name\";s:27:\"state_machine 8.x-1.0-beta3\";s:7:\"version\";s:13:\"8.x-1.0-beta3\";s:3:\"tag\";s:13:\"8.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/state_machine/releases/8.x-1.0-beta3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/state_machine-8.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1477868939\";s:6:\"mdhash\";s:32:\"5dcfd09ed0716962690e297bfe1397b3\";s:8:\"filesize\";s:5:\"24647\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta2\";a:15:{s:4:\"name\";s:27:\"state_machine 8.x-1.0-beta2\";s:7:\"version\";s:13:\"8.x-1.0-beta2\";s:3:\"tag\";s:13:\"8.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/state_machine/releases/8.x-1.0-beta2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/state_machine-8.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1457387742\";s:6:\"mdhash\";s:32:\"8497ff5485db7ef7ee8ff574527bb686\";s:8:\"filesize\";s:5:\"22012\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:27:\"state_machine 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/state_machine/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/state_machine-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1451039339\";s:6:\"mdhash\";s:32:\"f2e1d07565463958d6fd2e733c5d0825\";s:8:\"filesize\";s:5:\"20571\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"state_machine 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/state_machine/releases/8.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/state_machine-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1542229980\";s:6:\"mdhash\";s:32:\"dcb5ca506a306ddcbf152ea416fc3a03\";s:8:\"filesize\";s:5:\"28740\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','tb_megamenu','a:11:{s:5:\"title\";s:12:\"TB Mega Menu\";s:10:\"short_name\";s:11:\"tb_megamenu\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/tb_megamenu\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:1:{s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"tb_megamenu 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/tb_megamenu/releases/8.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/tb_megamenu-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1512972185\";s:6:\"mdhash\";s:32:\"861fb268e45d6b1a85af1d552906c561\";s:8:\"filesize\";s:5:\"76214\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','token','a:12:{s:5:\"title\";s:5:\"Token\";s:10:\"short_name\";s:5:\"token\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:36:\"https://www.drupal.org/project/token\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:13:\"token 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/8.x-1.5\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1537557481\";s:6:\"mdhash\";s:32:\"09660453693e0da015aea0afbaee7176\";s:8:\"filesize\";s:5:\"77551\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:13:\"token 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/8.x-1.4\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1536408480\";s:6:\"mdhash\";s:32:\"1c708495cdabc018d2baa78dc84e1987\";s:8:\"filesize\";s:5:\"77310\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.3\";a:14:{s:4:\"name\";s:13:\"token 8.x-1.3\";s:7:\"version\";s:7:\"8.x-1.3\";s:3:\"tag\";s:7:\"8.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/8.x-1.3\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-8.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1527232684\";s:6:\"mdhash\";s:32:\"bcddb4947e936a30c3579eb410bb61ca\";s:8:\"filesize\";s:5:\"75320\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:13:\"token 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/8.x-1.2\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1527112080\";s:6:\"mdhash\";s:32:\"6865d3cc3d8bc48c857610622f4723a9\";s:8:\"filesize\";s:5:\"75065\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:13:\"token 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/8.x-1.1\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1513810384\";s:6:\"mdhash\";s:32:\"0123d0ded2e6fc8ff095b347cbd9b897\";s:8:\"filesize\";s:5:\"74131\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:13:\"token 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/8.x-1.0\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1493466843\";s:6:\"mdhash\";s:32:\"507216a6735e8cba6e76f2caecea67e6\";s:8:\"filesize\";s:5:\"73525\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:17:\"token 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/token/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/token-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1483290542\";s:6:\"mdhash\";s:32:\"1509afebc93a7adc917a0b052a210686\";s:8:\"filesize\";s:5:\"73096\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta2\";a:15:{s:4:\"name\";s:19:\"token 8.x-1.0-beta2\";s:7:\"version\";s:13:\"8.x-1.0-beta2\";s:3:\"tag\";s:13:\"8.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/token/releases/8.x-1.0-beta2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/token-8.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1474367039\";s:6:\"mdhash\";s:32:\"b214b074188be25e9d2044e5c89a4c2b\";s:8:\"filesize\";s:5:\"72158\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:19:\"token 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/token/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/token-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1470864453\";s:6:\"mdhash\";s:32:\"a5c266342747e037b942f8c3bcd682fd\";s:8:\"filesize\";s:5:\"70476\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:20:\"token 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/token/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/token-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1453363739\";s:6:\"mdhash\";s:32:\"44a1371f002e6185eb362d669652b6cb\";s:8:\"filesize\";s:5:\"55373\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:20:\"token 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/token/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/token-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1450961339\";s:6:\"mdhash\";s:32:\"e64b92dc49534270d1bec3c428a357fa\";s:8:\"filesize\";s:5:\"48043\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:17:\"token 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/token/releases/8.x-1.x-dev\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/token-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1564603388\";s:6:\"mdhash\";s:32:\"92f371c3758bf24c44edd3f2ebad8d13\";s:8:\"filesize\";s:5:\"77451\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952921;}',1571039321),

('update_available_releases','votingapi','a:11:{s:5:\"title\";s:10:\"Voting API\";s:10:\"short_name\";s:9:\"votingapi\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/votingapi\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:9:{s:13:\"8.x-3.0-beta1\";a:15:{s:4:\"name\";s:23:\"votingapi 8.x-3.0-beta1\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:3:\"tag\";s:13:\"8.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/votingapi/releases/8.x-3.0-beta1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/votingapi-8.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1540711680\";s:6:\"mdhash\";s:32:\"d5f8f4eaf68fb0dfc7c1287f4846dbb7\";s:8:\"filesize\";s:5:\"35731\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha7\";a:15:{s:4:\"name\";s:24:\"votingapi 8.x-3.0-alpha7\";s:7:\"version\";s:14:\"8.x-3.0-alpha7\";s:3:\"tag\";s:14:\"8.x-3.0-alpha7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/votingapi/releases/8.x-3.0-alpha7\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/votingapi-8.x-3.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1526809984\";s:6:\"mdhash\";s:32:\"1fce0c10bb4a71fdc641a4f22dfb21cd\";s:8:\"filesize\";s:5:\"35259\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha6\";a:15:{s:4:\"name\";s:24:\"votingapi 8.x-3.0-alpha6\";s:7:\"version\";s:14:\"8.x-3.0-alpha6\";s:3:\"tag\";s:14:\"8.x-3.0-alpha6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/votingapi/releases/8.x-3.0-alpha6\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/votingapi-8.x-3.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1522602480\";s:6:\"mdhash\";s:32:\"0e2e8ae4602ebb42baf1ac22c4b2fe30\";s:8:\"filesize\";s:5:\"33954\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha5\";a:15:{s:4:\"name\";s:24:\"votingapi 8.x-3.0-alpha5\";s:7:\"version\";s:14:\"8.x-3.0-alpha5\";s:3:\"tag\";s:14:\"8.x-3.0-alpha5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/votingapi/releases/8.x-3.0-alpha5\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/votingapi-8.x-3.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1520019784\";s:6:\"mdhash\";s:32:\"50fb2680d59cc4517600de52fae69de5\";s:8:\"filesize\";s:5:\"32554\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha4\";a:15:{s:4:\"name\";s:24:\"votingapi 8.x-3.0-alpha4\";s:7:\"version\";s:14:\"8.x-3.0-alpha4\";s:3:\"tag\";s:14:\"8.x-3.0-alpha4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/votingapi/releases/8.x-3.0-alpha4\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/votingapi-8.x-3.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1519796285\";s:6:\"mdhash\";s:32:\"492cf44de55378d28cc439ae57ccfdeb\";s:8:\"filesize\";s:5:\"32543\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha3\";a:15:{s:4:\"name\";s:24:\"votingapi 8.x-3.0-alpha3\";s:7:\"version\";s:14:\"8.x-3.0-alpha3\";s:3:\"tag\";s:14:\"8.x-3.0-alpha3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/votingapi/releases/8.x-3.0-alpha3\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/votingapi-8.x-3.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1519207984\";s:6:\"mdhash\";s:32:\"cd7e09ac5e85563b730ab415d50989dd\";s:8:\"filesize\";s:5:\"32200\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-3.0-alpha2\";a:15:{s:4:\"name\";s:24:\"votingapi 8.x-3.0-alpha2\";s:7:\"version\";s:14:\"8.x-3.0-alpha2\";s:3:\"tag\";s:14:\"8.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/votingapi/releases/8.x-3.0-alpha2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/votingapi-8.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1466178323\";s:6:\"mdhash\";s:32:\"1b8fe31db74501b56a83ae0f5df3f42d\";s:8:\"filesize\";s:5:\"32075\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:24:\"votingapi 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/votingapi/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/votingapi-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1462815239\";s:6:\"mdhash\";s:32:\"583c780b72b201915c075bd609c65dd9\";s:8:\"filesize\";s:5:\"32071\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.x-dev\";a:14:{s:4:\"name\";s:21:\"votingapi 8.x-3.x-dev\";s:7:\"version\";s:11:\"8.x-3.x-dev\";s:3:\"tag\";s:7:\"8.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/votingapi/releases/8.x-3.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/votingapi-8.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1558310285\";s:6:\"mdhash\";s:32:\"82e9847f67a89fa1daa4a3f207404142\";s:8:\"filesize\";s:5:\"36218\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1570952922;}',1571039322),

('update_available_releases','webform','a:12:{s:5:\"title\";s:7:\"Webform\";s:10:\"short_name\";s:7:\"webform\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"5\";s:16:\"supported_majors\";s:1:\"5\";s:13:\"default_major\";s:1:\"5\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:38:\"https://www.drupal.org/project/webform\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:78:{s:11:\"8.x-5.5-rc2\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.5-rc2\";s:7:\"version\";s:11:\"8.x-5.5-rc2\";s:3:\"tag\";s:11:\"8.x-5.5-rc2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.5-rc2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.5-rc2.tar.gz\";s:4:\"date\";s:10:\"1570176784\";s:6:\"mdhash\";s:32:\"6148891f84d66007c72a9584afd021be\";s:8:\"filesize\";s:7:\"5483619\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.5-rc1\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.5-rc1\";s:7:\"version\";s:11:\"8.x-5.5-rc1\";s:3:\"tag\";s:11:\"8.x-5.5-rc1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.5-rc1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.5-rc1.tar.gz\";s:4:\"date\";s:10:\"1569445386\";s:6:\"mdhash\";s:32:\"5f27efab361089ff073a216684033df4\";s:8:\"filesize\";s:7:\"5376314\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.5-beta2\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.5-beta2\";s:7:\"version\";s:13:\"8.x-5.5-beta2\";s:3:\"tag\";s:13:\"8.x-5.5-beta2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.5-beta2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.5-beta2.tar.gz\";s:4:\"date\";s:10:\"1568992985\";s:6:\"mdhash\";s:32:\"d35b42c00a047f9610741e735210755c\";s:8:\"filesize\";s:7:\"5374389\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.5-beta1\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.5-beta1\";s:7:\"version\";s:13:\"8.x-5.5-beta1\";s:3:\"tag\";s:13:\"8.x-5.5-beta1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.5-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.5-beta1.tar.gz\";s:4:\"date\";s:10:\"1567698485\";s:6:\"mdhash\";s:32:\"3c83009eba4f3630d3cdd41a7dbed778\";s:8:\"filesize\";s:7:\"5315654\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-5.4\";a:14:{s:4:\"name\";s:15:\"webform 8.x-5.4\";s:7:\"version\";s:7:\"8.x-5.4\";s:3:\"tag\";s:7:\"8.x-5.4\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/8.x-5.4\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-8.x-5.4.tar.gz\";s:4:\"date\";s:10:\"1566209286\";s:6:\"mdhash\";s:32:\"0c9a7c815494a6e4543224a56c0ea4d9\";s:8:\"filesize\";s:7:\"6269596\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"8.x-5.4-beta1\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.4-beta1\";s:7:\"version\";s:13:\"8.x-5.4-beta1\";s:3:\"tag\";s:13:\"8.x-5.4-beta1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"4\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.4-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.4-beta1.tar.gz\";s:4:\"date\";s:10:\"1565332985\";s:6:\"mdhash\";s:32:\"4a027338bafd15d442bee330317f2abb\";s:8:\"filesize\";s:7:\"6249220\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-5.3\";a:14:{s:4:\"name\";s:15:\"webform 8.x-5.3\";s:7:\"version\";s:7:\"8.x-5.3\";s:3:\"tag\";s:7:\"8.x-5.3\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/8.x-5.3\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-8.x-5.3.tar.gz\";s:4:\"date\";s:10:\"1563460085\";s:6:\"mdhash\";s:32:\"0924eb42df53cb903cddd521241c2fa6\";s:8:\"filesize\";s:7:\"6232970\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-5.3-rc3\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.3-rc3\";s:7:\"version\";s:11:\"8.x-5.3-rc3\";s:3:\"tag\";s:11:\"8.x-5.3-rc3\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.3-rc3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.3-rc3.tar.gz\";s:4:\"date\";s:10:\"1562013184\";s:6:\"mdhash\";s:32:\"25e4e3e21b28d30b0a0d28fb831fe907\";s:8:\"filesize\";s:7:\"6189771\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.3-rc2\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.3-rc2\";s:7:\"version\";s:11:\"8.x-5.3-rc2\";s:3:\"tag\";s:11:\"8.x-5.3-rc2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.3-rc2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.3-rc2.tar.gz\";s:4:\"date\";s:10:\"1561474385\";s:6:\"mdhash\";s:32:\"2aaffc3d736ed11992c0d3fb3bec7740\";s:8:\"filesize\";s:7:\"6180087\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.3-rc1\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.3-rc1\";s:7:\"version\";s:11:\"8.x-5.3-rc1\";s:3:\"tag\";s:11:\"8.x-5.3-rc1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.3-rc1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.3-rc1.tar.gz\";s:4:\"date\";s:10:\"1559676185\";s:6:\"mdhash\";s:32:\"56fe738e0a292c3e87541a5ee07591ea\";s:8:\"filesize\";s:7:\"6135936\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.3-beta3\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.3-beta3\";s:7:\"version\";s:13:\"8.x-5.3-beta3\";s:3:\"tag\";s:13:\"8.x-5.3-beta3\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.3-beta3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.3-beta3.tar.gz\";s:4:\"date\";s:10:\"1558032481\";s:6:\"mdhash\";s:32:\"c1d659c64635e902f7fbdaca767253ca\";s:8:\"filesize\";s:7:\"5768024\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.3-beta2\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.3-beta2\";s:7:\"version\";s:13:\"8.x-5.3-beta2\";s:3:\"tag\";s:13:\"8.x-5.3-beta2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.3-beta2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.3-beta2.tar.gz\";s:4:\"date\";s:10:\"1557417193\";s:6:\"mdhash\";s:32:\"f0050d6971a683c43f92ad02d26d9761\";s:8:\"filesize\";s:7:\"5761294\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.3-beta1\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.3-beta1\";s:7:\"version\";s:13:\"8.x-5.3-beta1\";s:3:\"tag\";s:13:\"8.x-5.3-beta1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.3-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.3-beta1.tar.gz\";s:4:\"date\";s:10:\"1556736481\";s:6:\"mdhash\";s:32:\"07daa132762bdb2e7cad489a8f77d7bb\";s:8:\"filesize\";s:7:\"5758366\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-5.2\";a:14:{s:4:\"name\";s:15:\"webform 8.x-5.2\";s:7:\"version\";s:7:\"8.x-5.2\";s:3:\"tag\";s:7:\"8.x-5.2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/8.x-5.2\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-8.x-5.2.tar.gz\";s:4:\"date\";s:10:\"1553768585\";s:6:\"mdhash\";s:32:\"3e245dcc275fcfc50348fcea9bdfa8ab\";s:8:\"filesize\";s:7:\"5732988\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-5.2-rc3\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.2-rc3\";s:7:\"version\";s:11:\"8.x-5.2-rc3\";s:3:\"tag\";s:11:\"8.x-5.2-rc3\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"2\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.2-rc3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.2-rc3.tar.gz\";s:4:\"date\";s:10:\"1552733285\";s:6:\"mdhash\";s:32:\"b0de324ef82aae33240303d38d1e4912\";s:8:\"filesize\";s:7:\"5728332\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.2-rc2\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.2-rc2\";s:7:\"version\";s:11:\"8.x-5.2-rc2\";s:3:\"tag\";s:11:\"8.x-5.2-rc2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"2\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.2-rc2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.2-rc2.tar.gz\";s:4:\"date\";s:10:\"1551880385\";s:6:\"mdhash\";s:32:\"386b274ed1001283036f0ea5552bc6de\";s:8:\"filesize\";s:7:\"5699873\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.2-rc1\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.2-rc1\";s:7:\"version\";s:11:\"8.x-5.2-rc1\";s:3:\"tag\";s:11:\"8.x-5.2-rc1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"2\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.2-rc1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.2-rc1.tar.gz\";s:4:\"date\";s:10:\"1551829980\";s:6:\"mdhash\";s:32:\"f8ddb847306331a23feba28f5b1f66bc\";s:8:\"filesize\";s:7:\"5697323\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.2-beta1\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.2-beta1\";s:7:\"version\";s:13:\"8.x-5.2-beta1\";s:3:\"tag\";s:13:\"8.x-5.2-beta1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"2\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.2-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.2-beta1.tar.gz\";s:4:\"date\";s:10:\"1548435780\";s:6:\"mdhash\";s:32:\"2ccfe4c5cc7dd90625bb405807f308c3\";s:8:\"filesize\";s:7:\"5677765\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-5.1\";a:14:{s:4:\"name\";s:15:\"webform 8.x-5.1\";s:7:\"version\";s:7:\"8.x-5.1\";s:3:\"tag\";s:7:\"8.x-5.1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/8.x-5.1\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-8.x-5.1.tar.gz\";s:4:\"date\";s:10:\"1546458480\";s:6:\"mdhash\";s:32:\"644821b10a68ae3a0a151880e81cdf80\";s:8:\"filesize\";s:7:\"5667083\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-5.0\";a:14:{s:4:\"name\";s:15:\"webform 8.x-5.0\";s:7:\"version\";s:7:\"8.x-5.0\";s:3:\"tag\";s:7:\"8.x-5.0\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/8.x-5.0\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0.tar.gz\";s:4:\"date\";s:10:\"1545656285\";s:6:\"mdhash\";s:32:\"8561e654638d27ec3f0c1395889abf6c\";s:8:\"filesize\";s:7:\"5666780\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:12:\"8.x-5.0-rc31\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc31\";s:7:\"version\";s:12:\"8.x-5.0-rc31\";s:3:\"tag\";s:12:\"8.x-5.0-rc31\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc31\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc31\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc31.tar.gz\";s:4:\"date\";s:10:\"1545138180\";s:6:\"mdhash\";s:32:\"d8eb8954429974fa3a1cb52b68fbfd17\";s:8:\"filesize\";s:7:\"5663976\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc30\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc30\";s:7:\"version\";s:12:\"8.x-5.0-rc30\";s:3:\"tag\";s:12:\"8.x-5.0-rc30\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc30\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc30\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc30.tar.gz\";s:4:\"date\";s:10:\"1544990880\";s:6:\"mdhash\";s:32:\"7e0ec05574b4c79eeaf080e1e9e515f2\";s:8:\"filesize\";s:7:\"5663011\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc29\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc29\";s:7:\"version\";s:12:\"8.x-5.0-rc29\";s:3:\"tag\";s:12:\"8.x-5.0-rc29\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc29\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc29\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc29.tar.gz\";s:4:\"date\";s:10:\"1544223180\";s:6:\"mdhash\";s:32:\"1b0b8d05d6e2730b792c9db07bf27a51\";s:8:\"filesize\";s:7:\"5659168\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc28\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc28\";s:7:\"version\";s:12:\"8.x-5.0-rc28\";s:3:\"tag\";s:12:\"8.x-5.0-rc28\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc28\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc28\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc28.tar.gz\";s:4:\"date\";s:10:\"1544218081\";s:6:\"mdhash\";s:32:\"466e8e966bfd9dafd6b804ac80d72589\";s:8:\"filesize\";s:7:\"5659129\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc27\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc27\";s:7:\"version\";s:12:\"8.x-5.0-rc27\";s:3:\"tag\";s:12:\"8.x-5.0-rc27\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc27\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc27\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc27.tar.gz\";s:4:\"date\";s:10:\"1543520280\";s:6:\"mdhash\";s:32:\"ef51054e502fbd1465ce46dc4fa0ebec\";s:8:\"filesize\";s:7:\"5648599\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc26\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc26\";s:7:\"version\";s:12:\"8.x-5.0-rc26\";s:3:\"tag\";s:12:\"8.x-5.0-rc26\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc26\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc26\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc26.tar.gz\";s:4:\"date\";s:10:\"1541466481\";s:6:\"mdhash\";s:32:\"df8d2804a7bf1f3d98e39b231c00d235\";s:8:\"filesize\";s:7:\"5616527\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc25\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc25\";s:7:\"version\";s:12:\"8.x-5.0-rc25\";s:3:\"tag\";s:12:\"8.x-5.0-rc25\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc25\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc25\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc25.tar.gz\";s:4:\"date\";s:10:\"1541452980\";s:6:\"mdhash\";s:32:\"baab463464d9fb518d509ec96f5c7180\";s:8:\"filesize\";s:7:\"5616491\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc24\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc24\";s:7:\"version\";s:12:\"8.x-5.0-rc24\";s:3:\"tag\";s:12:\"8.x-5.0-rc24\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc24\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc24.tar.gz\";s:4:\"date\";s:10:\"1540255380\";s:6:\"mdhash\";s:32:\"cd670e8f68d245f4569113da9342b510\";s:8:\"filesize\";s:7:\"5608551\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc23\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc23\";s:7:\"version\";s:12:\"8.x-5.0-rc23\";s:3:\"tag\";s:12:\"8.x-5.0-rc23\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc23\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc23\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc23.tar.gz\";s:4:\"date\";s:10:\"1540052580\";s:6:\"mdhash\";s:32:\"af2171e077b5cf536fe5396f98ad7a14\";s:8:\"filesize\";s:7:\"5605580\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc22\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc22\";s:7:\"version\";s:12:\"8.x-5.0-rc22\";s:3:\"tag\";s:12:\"8.x-5.0-rc22\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc22\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc22.tar.gz\";s:4:\"date\";s:10:\"1538482685\";s:6:\"mdhash\";s:32:\"3797f90a03540138d85f55fc2b42c38c\";s:8:\"filesize\";s:7:\"5590122\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc21\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc21\";s:7:\"version\";s:12:\"8.x-5.0-rc21\";s:3:\"tag\";s:12:\"8.x-5.0-rc21\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc21\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc21.tar.gz\";s:4:\"date\";s:10:\"1536405484\";s:6:\"mdhash\";s:32:\"4f2f5c4bc3055403a21f15225b5d15ce\";s:8:\"filesize\";s:7:\"5579264\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc20\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc20\";s:7:\"version\";s:12:\"8.x-5.0-rc20\";s:3:\"tag\";s:12:\"8.x-5.0-rc20\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc20\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc20.tar.gz\";s:4:\"date\";s:10:\"1536336480\";s:6:\"mdhash\";s:32:\"6302f167e1c2cf737201719be25d1b84\";s:8:\"filesize\";s:7:\"5578357\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc19\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc19\";s:7:\"version\";s:12:\"8.x-5.0-rc19\";s:3:\"tag\";s:12:\"8.x-5.0-rc19\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc19\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc19.tar.gz\";s:4:\"date\";s:10:\"1536257580\";s:6:\"mdhash\";s:32:\"7d8f886e2899d8f207a841e99d3e0ec1\";s:8:\"filesize\";s:7:\"5577527\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc18\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc18\";s:7:\"version\";s:12:\"8.x-5.0-rc18\";s:3:\"tag\";s:12:\"8.x-5.0-rc18\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc18\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc18.tar.gz\";s:4:\"date\";s:10:\"1533682980\";s:6:\"mdhash\";s:32:\"07849f6a01fa5bed7b7b52b7c33b9ddf\";s:8:\"filesize\";s:7:\"5518284\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc17\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc17\";s:7:\"version\";s:12:\"8.x-5.0-rc17\";s:3:\"tag\";s:12:\"8.x-5.0-rc17\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc17\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc17.tar.gz\";s:4:\"date\";s:10:\"1533563280\";s:6:\"mdhash\";s:32:\"d75636ccea6b3863e5000922776e672f\";s:8:\"filesize\";s:7:\"5519193\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc16\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc16\";s:7:\"version\";s:12:\"8.x-5.0-rc16\";s:3:\"tag\";s:12:\"8.x-5.0-rc16\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc16\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc16.tar.gz\";s:4:\"date\";s:10:\"1530298420\";s:6:\"mdhash\";s:32:\"abb10a2931c9ac14d01c7c5bb3c07d76\";s:8:\"filesize\";s:7:\"5495720\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc15\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc15\";s:7:\"version\";s:12:\"8.x-5.0-rc15\";s:3:\"tag\";s:12:\"8.x-5.0-rc15\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc15\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc15.tar.gz\";s:4:\"date\";s:10:\"1528795685\";s:6:\"mdhash\";s:32:\"b051f71926f84a4b0b92a2577878188d\";s:8:\"filesize\";s:7:\"5479816\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc14\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc14\";s:7:\"version\";s:12:\"8.x-5.0-rc14\";s:3:\"tag\";s:12:\"8.x-5.0-rc14\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc14\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc14.tar.gz\";s:4:\"date\";s:10:\"1528277284\";s:6:\"mdhash\";s:32:\"26dfb6bed9da67fcb22e09a985801c76\";s:8:\"filesize\";s:7:\"5477828\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc13\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc13\";s:7:\"version\";s:12:\"8.x-5.0-rc13\";s:3:\"tag\";s:12:\"8.x-5.0-rc13\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc13\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc13.tar.gz\";s:4:\"date\";s:10:\"1528137480\";s:6:\"mdhash\";s:32:\"ff7a56181a93633fcf3dc9cd93995caa\";s:8:\"filesize\";s:7:\"5470939\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc12\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc12\";s:7:\"version\";s:12:\"8.x-5.0-rc12\";s:3:\"tag\";s:12:\"8.x-5.0-rc12\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc12\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc12.tar.gz\";s:4:\"date\";s:10:\"1524706684\";s:6:\"mdhash\";s:32:\"a89043089a93c479ff57669857c28243\";s:8:\"filesize\";s:7:\"5460636\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc11\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc11\";s:7:\"version\";s:12:\"8.x-5.0-rc11\";s:3:\"tag\";s:12:\"8.x-5.0-rc11\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc11\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc11.tar.gz\";s:4:\"date\";s:10:\"1524229380\";s:6:\"mdhash\";s:32:\"831b1d6ce670ab3dec57f510ca2be249\";s:8:\"filesize\";s:7:\"5455972\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.x-5.0-rc10\";a:15:{s:4:\"name\";s:20:\"webform 8.x-5.0-rc10\";s:7:\"version\";s:12:\"8.x-5.0-rc10\";s:3:\"tag\";s:12:\"8.x-5.0-rc10\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:4:\"rc10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc10\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc10.tar.gz\";s:4:\"date\";s:10:\"1523291284\";s:6:\"mdhash\";s:32:\"3377ae46e8c33f91ba89c78c154aa933\";s:8:\"filesize\";s:7:\"5454841\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.0-rc9\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.0-rc9\";s:7:\"version\";s:11:\"8.x-5.0-rc9\";s:3:\"tag\";s:11:\"8.x-5.0-rc9\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc9\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc9.tar.gz\";s:4:\"date\";s:10:\"1523115484\";s:6:\"mdhash\";s:32:\"701f1d109f6c63c4495c1b982349d98e\";s:8:\"filesize\";s:7:\"5454736\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.0-rc8\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.0-rc8\";s:7:\"version\";s:11:\"8.x-5.0-rc8\";s:3:\"tag\";s:11:\"8.x-5.0-rc8\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc8\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc8.tar.gz\";s:4:\"date\";s:10:\"1522698184\";s:6:\"mdhash\";s:32:\"17e59188152b176c6e5dfea3f852221f\";s:8:\"filesize\";s:7:\"5452731\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.0-rc7\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.0-rc7\";s:7:\"version\";s:11:\"8.x-5.0-rc7\";s:3:\"tag\";s:11:\"8.x-5.0-rc7\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc7\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc7.tar.gz\";s:4:\"date\";s:10:\"1521829380\";s:6:\"mdhash\";s:32:\"b76d4c9e2eae03453dcd2e572c93c8bb\";s:8:\"filesize\";s:7:\"5445998\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.0-rc6\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.0-rc6\";s:7:\"version\";s:11:\"8.x-5.0-rc6\";s:3:\"tag\";s:11:\"8.x-5.0-rc6\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc6\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc6.tar.gz\";s:4:\"date\";s:10:\"1521230880\";s:6:\"mdhash\";s:32:\"0c231fe6fbab0656eb7500cf0140cc27\";s:8:\"filesize\";s:7:\"5437294\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.0-rc5\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.0-rc5\";s:7:\"version\";s:11:\"8.x-5.0-rc5\";s:3:\"tag\";s:11:\"8.x-5.0-rc5\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc5\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1521041284\";s:6:\"mdhash\";s:32:\"c2ccbf18748a480c198f34f6310e4085\";s:8:\"filesize\";s:7:\"5437103\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.0-rc4\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.0-rc4\";s:7:\"version\";s:11:\"8.x-5.0-rc4\";s:3:\"tag\";s:11:\"8.x-5.0-rc4\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc4\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1520964784\";s:6:\"mdhash\";s:32:\"d48c280bcbbee273482af72a47c658af\";s:8:\"filesize\";s:7:\"5436540\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.0-rc3\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.0-rc3\";s:7:\"version\";s:11:\"8.x-5.0-rc3\";s:3:\"tag\";s:11:\"8.x-5.0-rc3\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1517746080\";s:6:\"mdhash\";s:32:\"00a8136e4c4c1acac6f72f9a2c01a9ea\";s:8:\"filesize\";s:7:\"4520563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.0-rc2\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.0-rc2\";s:7:\"version\";s:11:\"8.x-5.0-rc2\";s:3:\"tag\";s:11:\"8.x-5.0-rc2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1517359384\";s:6:\"mdhash\";s:32:\"a78c21b6a97fbcb5a5d645bfb8122e38\";s:8:\"filesize\";s:7:\"4517733\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-5.0-rc1\";a:15:{s:4:\"name\";s:19:\"webform 8.x-5.0-rc1\";s:7:\"version\";s:11:\"8.x-5.0-rc1\";s:3:\"tag\";s:11:\"8.x-5.0-rc1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.0-rc1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1514196484\";s:6:\"mdhash\";s:32:\"f4e0b6826e92abe23146d627b5c43514\";s:8:\"filesize\";s:7:\"4495112\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta25\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta25\";s:7:\"version\";s:14:\"8.x-5.0-beta25\";s:3:\"tag\";s:14:\"8.x-5.0-beta25\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta25\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta25\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta25.tar.gz\";s:4:\"date\";s:10:\"1513003985\";s:6:\"mdhash\";s:32:\"ee2579db921ce7298c4072f0183de56b\";s:8:\"filesize\";s:7:\"4489217\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta24\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta24\";s:7:\"version\";s:14:\"8.x-5.0-beta24\";s:3:\"tag\";s:14:\"8.x-5.0-beta24\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta24\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta24.tar.gz\";s:4:\"date\";s:10:\"1510867685\";s:6:\"mdhash\";s:32:\"88cf2e929ea887a2f4bdb65018afdc2b\";s:8:\"filesize\";s:7:\"4471027\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta23\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta23\";s:7:\"version\";s:14:\"8.x-5.0-beta23\";s:3:\"tag\";s:14:\"8.x-5.0-beta23\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta23\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta23\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta23.tar.gz\";s:4:\"date\";s:10:\"1509673984\";s:6:\"mdhash\";s:32:\"22cd4c606456cfdc4100ee757cbfd5c6\";s:8:\"filesize\";s:7:\"4470971\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta22\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta22\";s:7:\"version\";s:14:\"8.x-5.0-beta22\";s:3:\"tag\";s:14:\"8.x-5.0-beta22\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta22\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta22.tar.gz\";s:4:\"date\";s:10:\"1509576185\";s:6:\"mdhash\";s:32:\"1663223e4aa971e98d57b3384a18668b\";s:8:\"filesize\";s:7:\"4470919\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta21\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta21\";s:7:\"version\";s:14:\"8.x-5.0-beta21\";s:3:\"tag\";s:14:\"8.x-5.0-beta21\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta21\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta21.tar.gz\";s:4:\"date\";s:10:\"1509363484\";s:6:\"mdhash\";s:32:\"b559860f2336a6ea02e834246da1d60c\";s:8:\"filesize\";s:7:\"4465356\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta20\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta20\";s:7:\"version\";s:14:\"8.x-5.0-beta20\";s:3:\"tag\";s:14:\"8.x-5.0-beta20\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta20\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta20.tar.gz\";s:4:\"date\";s:10:\"1509357785\";s:6:\"mdhash\";s:32:\"d349bca0227ed1fff3fc8eac4656fea3\";s:8:\"filesize\";s:7:\"4465428\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta19\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta19\";s:7:\"version\";s:14:\"8.x-5.0-beta19\";s:3:\"tag\";s:14:\"8.x-5.0-beta19\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta19\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta19.tar.gz\";s:4:\"date\";s:10:\"1506634743\";s:6:\"mdhash\";s:32:\"af801f4fe313cf3d53e773821971bd19\";s:8:\"filesize\";s:7:\"4433231\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta18\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta18\";s:7:\"version\";s:14:\"8.x-5.0-beta18\";s:3:\"tag\";s:14:\"8.x-5.0-beta18\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta18\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta18.tar.gz\";s:4:\"date\";s:10:\"1505244243\";s:6:\"mdhash\";s:32:\"941d4614f95f1d5c39d186c617e8a1c0\";s:8:\"filesize\";s:7:\"4321060\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta17\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta17\";s:7:\"version\";s:14:\"8.x-5.0-beta17\";s:3:\"tag\";s:14:\"8.x-5.0-beta17\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta17\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta17.tar.gz\";s:4:\"date\";s:10:\"1505089745\";s:6:\"mdhash\";s:32:\"2a5dccd63ad9b345db354a6919af19d4\";s:8:\"filesize\";s:7:\"4320052\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta16\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta16\";s:7:\"version\";s:14:\"8.x-5.0-beta16\";s:3:\"tag\";s:14:\"8.x-5.0-beta16\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta16\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta16.tar.gz\";s:4:\"date\";s:10:\"1502154844\";s:6:\"mdhash\";s:32:\"969cd6687ac2a23b821c1aaa8b818700\";s:8:\"filesize\";s:7:\"4290321\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta15\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta15\";s:7:\"version\";s:14:\"8.x-5.0-beta15\";s:3:\"tag\";s:14:\"8.x-5.0-beta15\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta15\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta15.tar.gz\";s:4:\"date\";s:10:\"1498873444\";s:6:\"mdhash\";s:32:\"7b1f881211b117f862fbbdfd5ebf18c5\";s:8:\"filesize\";s:7:\"4215344\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta14\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta14\";s:7:\"version\";s:14:\"8.x-5.0-beta14\";s:3:\"tag\";s:14:\"8.x-5.0-beta14\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta14\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta14.tar.gz\";s:4:\"date\";s:10:\"1498698843\";s:6:\"mdhash\";s:32:\"7260adb91f70167304ada86c7480cd75\";s:8:\"filesize\";s:7:\"4212598\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta13\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta13\";s:7:\"version\";s:14:\"8.x-5.0-beta13\";s:3:\"tag\";s:14:\"8.x-5.0-beta13\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta13\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta13.tar.gz\";s:4:\"date\";s:10:\"1496265842\";s:6:\"mdhash\";s:32:\"b4cc1c48ad05e37758a78b08490e304b\";s:8:\"filesize\";s:7:\"4139713\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta12\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta12\";s:7:\"version\";s:14:\"8.x-5.0-beta12\";s:3:\"tag\";s:14:\"8.x-5.0-beta12\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta12\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta12.tar.gz\";s:4:\"date\";s:10:\"1492798443\";s:6:\"mdhash\";s:32:\"15ec3e76a065e8951395225200d6e8b6\";s:8:\"filesize\";s:7:\"4106460\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta11\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta11\";s:7:\"version\";s:14:\"8.x-5.0-beta11\";s:3:\"tag\";s:14:\"8.x-5.0-beta11\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta11\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta11.tar.gz\";s:4:\"date\";s:10:\"1491471183\";s:6:\"mdhash\";s:32:\"cafa3975a780da6b32d58340d735e606\";s:8:\"filesize\";s:7:\"4070397\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-5.0-beta10\";a:15:{s:4:\"name\";s:22:\"webform 8.x-5.0-beta10\";s:7:\"version\";s:14:\"8.x-5.0-beta10\";s:3:\"tag\";s:14:\"8.x-5.0-beta10\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta10\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta10.tar.gz\";s:4:\"date\";s:10:\"1491362286\";s:6:\"mdhash\";s:32:\"d5e3381cbc4e768ff330d10e1e547b00\";s:8:\"filesize\";s:7:\"4070173\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.0-beta9\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.0-beta9\";s:7:\"version\";s:13:\"8.x-5.0-beta9\";s:3:\"tag\";s:13:\"8.x-5.0-beta9\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta9\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1488753784\";s:6:\"mdhash\";s:32:\"1d45e27382626d3e424820c000919138\";s:8:\"filesize\";s:7:\"4018499\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.0-beta8\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.0-beta8\";s:7:\"version\";s:13:\"8.x-5.0-beta8\";s:3:\"tag\";s:13:\"8.x-5.0-beta8\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta8\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1488739683\";s:6:\"mdhash\";s:32:\"8dc1082812ad998da67186b623370c7e\";s:8:\"filesize\";s:7:\"4018511\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.0-beta7\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.0-beta7\";s:7:\"version\";s:13:\"8.x-5.0-beta7\";s:3:\"tag\";s:13:\"8.x-5.0-beta7\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1487143684\";s:6:\"mdhash\";s:32:\"b4c0b8d1a9aef0c98c45c146a72b67a3\";s:8:\"filesize\";s:7:\"3994093\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.0-beta6\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.0-beta6\";s:7:\"version\";s:13:\"8.x-5.0-beta6\";s:3:\"tag\";s:13:\"8.x-5.0-beta6\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1487025483\";s:6:\"mdhash\";s:32:\"d8e49959ca6f2da4965135e8017bffbc\";s:8:\"filesize\";s:7:\"3994048\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.0-beta5\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.0-beta5\";s:7:\"version\";s:13:\"8.x-5.0-beta5\";s:3:\"tag\";s:13:\"8.x-5.0-beta5\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1485776283\";s:6:\"mdhash\";s:32:\"b027a90461bce6a17abd45b33d5c346c\";s:8:\"filesize\";s:7:\"4050994\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.0-beta4\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.0-beta4\";s:7:\"version\";s:13:\"8.x-5.0-beta4\";s:3:\"tag\";s:13:\"8.x-5.0-beta4\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1482752282\";s:6:\"mdhash\";s:32:\"925be8705623c072217f94de1da7e20d\";s:8:\"filesize\";s:7:\"4041755\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.0-beta3\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.0-beta3\";s:7:\"version\";s:13:\"8.x-5.0-beta3\";s:3:\"tag\";s:13:\"8.x-5.0-beta3\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1482316383\";s:6:\"mdhash\";s:32:\"ad5a190d3e23c8df89d90b6342dc5556\";s:8:\"filesize\";s:7:\"4042972\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.0-beta2\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.0-beta2\";s:7:\"version\";s:13:\"8.x-5.0-beta2\";s:3:\"tag\";s:13:\"8.x-5.0-beta2\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1481192283\";s:6:\"mdhash\";s:32:\"4f703db47349505462d4290e225c40aa\";s:8:\"filesize\";s:7:\"4020308\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-5.0-beta1\";a:15:{s:4:\"name\";s:21:\"webform 8.x-5.0-beta1\";s:7:\"version\";s:13:\"8.x-5.0-beta1\";s:3:\"tag\";s:13:\"8.x-5.0-beta1\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/8.x-5.0-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-8.x-5.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1481140089\";s:6:\"mdhash\";s:32:\"bcaecb1f16fc54e905a9a552f7f3a4d1\";s:8:\"filesize\";s:7:\"4033378\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-5.x-dev\";a:14:{s:4:\"name\";s:19:\"webform 8.x-5.x-dev\";s:7:\"version\";s:11:\"8.x-5.x-dev\";s:3:\"tag\";s:7:\"8.x-5.x\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-5.x-dev\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-5.x-dev.tar.gz\";s:4:\"date\";s:10:\"1570828688\";s:6:\"mdhash\";s:32:\"80b7809b27b99211369321123b57d764\";s:8:\"filesize\";s:7:\"5483983\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-4.x-dev\";a:14:{s:4:\"name\";s:19:\"webform 8.x-4.x-dev\";s:7:\"version\";s:11:\"8.x-4.x-dev\";s:3:\"tag\";s:7:\"8.x-4.x\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/8.x-4.x-dev\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-8.x-4.x-dev.tar.gz\";s:4:\"date\";s:10:\"1480317483\";s:6:\"mdhash\";s:32:\"6946235357878e46cf27ce1300f6a0d0\";s:8:\"filesize\";s:4:\"6960\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1570952922;}',1571039322);

/*Table structure for table `menu_link_content` */

DROP TABLE IF EXISTS `menu_link_content`;

CREATE TABLE `menu_link_content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `revision_id` int(10) unsigned DEFAULT NULL,
  `bundle` varchar(32) CHARACTER SET ascii NOT NULL,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `menu_link_content_field__uuid__value` (`uuid`),
  UNIQUE KEY `menu_link_content__revision_id` (`revision_id`)
) ENGINE=InnoDB AUTO_INCREMENT=151 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for menu_link_content entities.';

/*Data for the table `menu_link_content` */

insert  into `menu_link_content`(`id`,`revision_id`,`bundle`,`uuid`,`langcode`) values 

(1,1,'menu_link_content','89fbca33-fb65-4e6c-91ba-9a25d68514bc','en'),

(2,2,'menu_link_content','5cdb5b2b-389c-47b0-8140-19bcaee5eb6b','en'),

(3,3,'menu_link_content','29958b9c-166f-47a0-ad23-1a1934a31d4c','en'),

(4,4,'menu_link_content','ac9a45ab-a3e4-4771-9d12-016c19b8cd87','en'),

(5,5,'menu_link_content','92dae41b-bd24-4890-b442-1c209567d7ff','en'),

(6,6,'menu_link_content','961ccfdb-fc32-416f-b479-33645b457808','en'),

(7,7,'menu_link_content','a3ee399f-9674-40b8-a77b-af91a5415b33','en'),

(8,8,'menu_link_content','ffbafeb5-13ce-4a9e-aebb-517a82b75abf','en'),

(9,9,'menu_link_content','be27f22d-c5ff-4994-92d5-a3185bc2c43e','en'),

(10,10,'menu_link_content','bf32227d-9747-40a2-92f2-76f9a59cac2d','en'),

(11,11,'menu_link_content','fdde11a8-2a92-4936-91e9-4b802ab31b5b','en'),

(12,12,'menu_link_content','0c8d517f-c88c-429b-808c-99be0d64142c','en'),

(13,13,'menu_link_content','37367b13-a605-42e8-9472-0e5788a65542','en'),

(14,14,'menu_link_content','46d6164c-bf4c-4e3b-8a63-f3a0bb29becb','en'),

(15,15,'menu_link_content','59c760df-faa4-4c04-a71d-6ebed8addc3b','en'),

(16,16,'menu_link_content','9300ca4c-bce1-4990-8f18-f2e888c2fb04','en'),

(17,17,'menu_link_content','36321b57-7fe6-4eac-a535-bfdbfb32f86f','en'),

(18,18,'menu_link_content','1d8b7d03-1fbd-47d7-ac61-14b66ae230cc','en'),

(19,19,'menu_link_content','40656ee6-77d0-4bdc-8d5b-89bfb1846fd7','en'),

(20,20,'menu_link_content','bbdf5868-dc3c-4d40-bf02-ed5a98de6baa','en'),

(22,22,'menu_link_content','2dd67deb-b273-48e1-897e-3c0bcbcf5718','en'),

(23,23,'menu_link_content','32567f5e-6902-41e1-87a2-140840992d0f','en'),

(24,24,'menu_link_content','c065ff63-c661-41e5-afdc-f27d0815c3b0','en'),

(26,26,'menu_link_content','60c6e846-93d3-4d9f-89f5-98a254894a66','en'),

(27,27,'menu_link_content','7a4cb156-8ec2-434f-8f59-7bad246535dc','en'),

(28,28,'menu_link_content','743658b6-30d0-4736-aa24-bbe727e981f8','en'),

(29,29,'menu_link_content','bf270903-a251-43ce-b89c-526df226d233','en'),

(30,30,'menu_link_content','bde03df4-5838-4fea-bb45-0a5ba212e6e7','en'),

(31,31,'menu_link_content','fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb','en'),

(32,32,'menu_link_content','c9aa1e7a-a176-4c07-9695-f9094a6f3962','en'),

(33,33,'menu_link_content','bf873034-5b24-4c7d-b866-99804a20c5f6','en'),

(34,34,'menu_link_content','8a7af66c-92d3-49a8-943a-27fecb926b5a','en'),

(35,35,'menu_link_content','4f236593-06cc-4d7d-87aa-b5a394eaa67f','en'),

(36,36,'menu_link_content','09d313ce-a46e-4904-9fc9-2c3fd86f49d8','en'),

(37,37,'menu_link_content','ff7b7d33-e0fa-4e19-8826-2cefa9c972b2','en'),

(38,38,'menu_link_content','314f69c9-6761-46c8-8f7f-eba5ba26b421','en'),

(39,39,'menu_link_content','7a67997c-7b80-46b1-820b-a1b9c57535e5','en'),

(40,40,'menu_link_content','4adcc82e-4225-4b54-ae75-1874f637e3d6','en'),

(41,41,'menu_link_content','733a539d-3c2a-45fd-a73b-bb5063207240','en'),

(42,42,'menu_link_content','3d302ce2-fcbc-427c-b63e-7dd13fd3d705','en'),

(43,43,'menu_link_content','367c68ba-1ef2-4e41-bf74-7688e5904093','en'),

(44,44,'menu_link_content','e91489b9-2232-4827-8e2e-2668769f7665','en'),

(45,45,'menu_link_content','71554a3f-b4c2-4cf1-acd0-f3e91727b086','en'),

(46,46,'menu_link_content','34c07aab-b309-4699-b861-a6c292e165d2','en'),

(47,47,'menu_link_content','c1470211-9873-446f-9797-6089dffdee4f','en'),

(48,48,'menu_link_content','c73021cd-900f-469b-9491-07e016d521aa','en'),

(49,49,'menu_link_content','86580bef-aa20-4a1b-a234-30eeb1f64b8d','en'),

(50,50,'menu_link_content','b329caef-882c-4fb4-88d6-5c0e956c3230','en'),

(51,51,'menu_link_content','6d235af9-aa59-4a1f-86f4-f7cf95990571','en'),

(52,52,'menu_link_content','7ac5c97e-66e5-44ba-9701-3a4250b7b1d9','en'),

(62,62,'menu_link_content','16141053-6ad4-4886-8a35-c406aac8e9e4','en'),

(63,63,'menu_link_content','776125fa-b4d7-4344-bf41-1ea5892e91ef','en'),

(64,64,'menu_link_content','d2a5e366-81b2-4334-84c8-31557554f0e1','en'),

(65,65,'menu_link_content','f24ed196-0a8b-471e-95d8-177e20a9e9ba','en'),

(66,66,'menu_link_content','a669b9ca-166c-45ba-8e77-1faad3feb3eb','en'),

(67,67,'menu_link_content','d9f4d184-1bcf-483a-ac64-9a287afa146b','en'),

(68,68,'menu_link_content','861d0785-e6ed-4109-969a-c8aa12644e81','en'),

(69,69,'menu_link_content','c4129e2d-44f0-4687-a510-ad45c568bce1','en'),

(70,70,'menu_link_content','d4d5b6bd-9b29-4eb5-9acf-f87af995214c','en'),

(71,71,'menu_link_content','691ba057-a9fe-4a02-9bc4-105aa7e3d5f4','en'),

(73,73,'menu_link_content','fe3cc388-c8c1-4e13-91e2-c6d26d4f10e3','en'),

(74,74,'menu_link_content','9483d07a-5aa5-41a3-8ad6-456f80f78ac3','en'),

(75,75,'menu_link_content','506ee439-af38-47ef-a5e4-59c275e58937','en'),

(76,76,'menu_link_content','ce38002a-7dec-4a04-89f3-91f46b47858a','en'),

(77,77,'menu_link_content','48eb8cfb-67f8-44a4-b680-a154f132796c','en'),

(78,78,'menu_link_content','d0a9cd75-588f-4e44-98a6-d3b4bfbd80b2','en'),

(79,79,'menu_link_content','c74a5095-9a45-49ae-8da3-0be2e4717b32','en'),

(80,80,'menu_link_content','4dc6c8de-d27e-484f-8968-01b208414702','en'),

(81,81,'menu_link_content','ba223303-602f-4245-9b65-1c11d81c46f2','en'),

(84,84,'menu_link_content','eb3345f8-d32e-449f-a28d-3384b6b4ac96','en'),

(85,85,'menu_link_content','6b2a820d-9368-4a7f-8b42-465f88d3e1bb','en'),

(86,86,'menu_link_content','222834a3-6345-46a6-bebb-10e7a1a11a3b','en'),

(87,87,'menu_link_content','236c28f7-a0d8-437d-bcd1-8b5adb13c8d1','en'),

(88,88,'menu_link_content','6cd87830-2d5d-42e6-bd6c-85af56f90c99','en'),

(89,89,'menu_link_content','c287b16f-42a0-4a74-90ff-aacec6433bf0','en'),

(90,90,'menu_link_content','610c8dac-92d7-4a5b-89fb-f3214b8c8a09','en'),

(91,91,'menu_link_content','f63d2556-8199-4e69-9967-d99e0d4591b4','en'),

(93,93,'menu_link_content','491a5e02-691d-4f41-b6c2-e9513ae049ce','en'),

(94,94,'menu_link_content','ad36f87b-f542-454b-9685-2da56272071d','en'),

(95,95,'menu_link_content','58547176-ac14-452d-9bab-fe6204fcd2ea','en'),

(96,96,'menu_link_content','c5f9385e-3b46-4f25-b2a0-1b22b4df4c2d','en'),

(97,97,'menu_link_content','d03a8906-685a-4fa6-b4bb-e753de92fff6','en'),

(98,98,'menu_link_content','76e447c9-6d4f-4814-8a67-83d92a294ba4','en'),

(99,99,'menu_link_content','137a5d20-1c92-46b1-adc8-6986ef4ba061','en'),

(100,100,'menu_link_content','a8ebb28d-2a08-4f46-bc41-c7d2e380e341','en'),

(101,101,'menu_link_content','12b26d04-ea1a-467a-b0d3-72733ba93a88','en'),

(102,102,'menu_link_content','2999ccf3-e949-47dc-911a-51ce4f0b1f4b','en'),

(103,103,'menu_link_content','6df35863-66bf-4822-b031-aea60d06ef46','en'),

(104,104,'menu_link_content','92a230bd-a998-4bd2-b5ef-4266cb0e45a4','en'),

(105,105,'menu_link_content','cebaa43c-205f-4f89-b0fc-6ff322ecfd39','en'),

(106,106,'menu_link_content','3fa83a2b-7b51-4597-9cbe-70ba8d569b58','en'),

(107,107,'menu_link_content','7cd859fa-e56c-460a-b258-fbdb90e4d2b6','en'),

(108,108,'menu_link_content','d953421d-2381-48a2-8ec6-b3556e193d27','en'),

(109,109,'menu_link_content','e1b2f94e-df9b-4de0-994d-896fea2a566c','en'),

(110,110,'menu_link_content','76dce2dd-4bbe-48ce-be35-01e61c904ba0','en'),

(111,111,'menu_link_content','7c682988-9e8a-4380-aeba-a2bc289d04b1','en'),

(112,112,'menu_link_content','0de6635d-abe6-46ad-a198-30427b7ef1a5','en'),

(113,113,'menu_link_content','fd17614d-d7f1-4ba4-a132-ae8a0b4113b6','en'),

(114,114,'menu_link_content','e7e67b14-7d3a-48e2-aa6f-1efbd14a7cce','en'),

(115,115,'menu_link_content','6d3a98ea-8ac7-47f3-a41b-f95903b6b944','en'),

(116,116,'menu_link_content','bdf3d8d7-7e39-4761-9517-525862ece922','en'),

(117,117,'menu_link_content','f0751b8b-ca71-400c-8ed4-8f17ff2e9b04','en'),

(118,118,'menu_link_content','19579bde-904c-4869-bcc0-d577fca81c00','en'),

(119,119,'menu_link_content','0cb1c61d-8003-44c3-b0b3-436b7965c92d','en'),

(120,120,'menu_link_content','54d0a093-232c-4a42-807c-99e5f261c476','en'),

(121,121,'menu_link_content','d36bda57-2f21-43c6-acf0-1028c0dfc419','en'),

(122,122,'menu_link_content','4cc45e07-f95f-43c4-911b-d611e55bffed','en'),

(123,123,'menu_link_content','63af3b84-3b40-4e78-ae2a-6a82bed21ce0','en'),

(124,124,'menu_link_content','8de4bf5b-4d62-49dc-a8f3-17312f378b96','en'),

(125,125,'menu_link_content','e8b2b5e6-1fd0-4879-add1-d64f65071e52','en'),

(126,126,'menu_link_content','c2758267-44c1-47cc-ad2f-9ed26b5a7b66','en'),

(127,127,'menu_link_content','d70e25d4-48f8-4d30-ad1b-140b19b8d86d','en'),

(128,128,'menu_link_content','0c2acf13-be99-400e-a516-3eeb0250a939','en'),

(129,129,'menu_link_content','7f9d4c9f-e68c-45e9-bba3-b8a7606a6e44','en'),

(130,130,'menu_link_content','6079aec3-9b0f-44ac-b956-f456e93598ef','en'),

(131,131,'menu_link_content','5fe360b7-8317-4fb0-82c7-c96816ce453c','en'),

(132,132,'menu_link_content','27fbc9d4-80f5-4766-aa51-033eb100c01e','en'),

(133,133,'menu_link_content','75001a20-1143-4b16-a9a0-52cb6cdb7a37','en'),

(134,134,'menu_link_content','91cfd1c4-b40e-488c-9c60-8e7390a84b68','en'),

(135,135,'menu_link_content','0c806bda-6622-44ad-acd3-ea6039e259de','en'),

(136,136,'menu_link_content','63d22618-b4fe-4342-8655-821ad8640798','en'),

(137,137,'menu_link_content','cbd74fb9-4e21-48a4-8255-cf16a114b84b','en'),

(138,138,'menu_link_content','4326f5db-5e0d-44dc-9a52-5dc744ef772d','en'),

(139,139,'menu_link_content','dd84e93e-078f-45c7-a7e6-a0797fc4cb89','en'),

(140,140,'menu_link_content','63c6495e-8c2e-45f4-b372-b542fc123fdb','en'),

(141,141,'menu_link_content','018d37e6-b392-4228-8943-7c3f433d837d','en'),

(142,142,'menu_link_content','a046d288-c42b-45a6-b22d-c4e7e341e473','en'),

(143,143,'menu_link_content','8795dfe3-3f26-42dc-b987-3e9353df3831','en'),

(144,144,'menu_link_content','f9df1e47-273b-4684-81e4-da37304c140d','en'),

(145,145,'menu_link_content','65a0627d-7961-40e4-b2f1-93280c2f0a20','en'),

(146,146,'menu_link_content','192ee9a4-4616-4135-9de9-ad3f469f1c22','en'),

(147,147,'menu_link_content','34b6823d-aaf3-4b00-ab45-fdb544c8a354','en'),

(148,148,'menu_link_content','86a4b73a-822d-4a11-95f4-efdcb5e34973','en'),

(149,149,'menu_link_content','37310cde-bf20-4b44-bf35-ad1befa88b75','en'),

(150,150,'menu_link_content','f1a1def5-badc-404a-a5a7-4b7c80e06deb','en');

/*Table structure for table `menu_link_content_data` */

DROP TABLE IF EXISTS `menu_link_content_data`;

CREATE TABLE `menu_link_content_data` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `bundle` varchar(32) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `menu_name` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `link__uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `link__title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `link__options` longblob COMMENT 'Serialized array of options for the link.',
  `external` tinyint(4) DEFAULT NULL,
  `rediscover` tinyint(4) DEFAULT NULL,
  `weight` int(11) DEFAULT NULL,
  `expanded` tinyint(4) DEFAULT NULL,
  `enabled` tinyint(4) NOT NULL,
  `parent` varchar(255) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`id`,`langcode`),
  KEY `menu_link_content__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `menu_link_content__revision_id` (`revision_id`),
  KEY `menu_link_content_field__link__uri` (`link__uri`(30)),
  KEY `menu_link_content__enabled_bundle` (`enabled`,`bundle`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for menu_link_content entities.';

/*Data for the table `menu_link_content_data` */

insert  into `menu_link_content_data`(`id`,`revision_id`,`bundle`,`langcode`,`title`,`description`,`menu_name`,`link__uri`,`link__title`,`link__options`,`external`,`rediscover`,`weight`,`expanded`,`enabled`,`parent`,`changed`,`default_langcode`,`revision_translation_affected`) values 

(1,1,'menu_link_content','en','Blog',NULL,'main','internal:/blog-fullwidth','','a:0:{}',0,1,-46,1,1,NULL,1485799719,1,1),

(2,2,'menu_link_content','en','Classic',NULL,'main','internal:/blog-fullwidth','','a:0:{}',0,1,-50,1,1,'menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc',1480936876,1,1),

(3,3,'menu_link_content','en','Blog Grid',NULL,'main','internal:/blog-2-columns','','a:0:{}',0,1,-48,1,1,'menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc',1480938015,1,1),

(4,4,'menu_link_content','en','Blog Masonry',NULL,'main','internal:/blog-masonry-2-columns','','a:0:{}',0,1,-47,1,1,'menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc',1480938015,1,1),

(5,5,'menu_link_content','en','Single ',NULL,'main','internal:/node/6','','a:0:{}',0,1,-46,1,1,'menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc',1480938015,1,1),

(6,6,'menu_link_content','en','FullWidth',NULL,'main','internal:/node/6','','a:0:{}',0,1,-50,0,1,'menu_link_content:92dae41b-bd24-4890-b442-1c209567d7ff',1480938015,1,1),

(7,7,'menu_link_content','en','Accordions',NULL,'main','entity:node/34',NULL,'a:0:{}',0,0,-50,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1480938086,1,1),

(8,8,'menu_link_content','en','Bar (Progress)',NULL,'main','entity:node/35',NULL,'a:0:{}',0,0,-49,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1480938086,1,1),

(9,9,'menu_link_content','en','Buttons',NULL,'main','entity:node/36',NULL,'a:0:{}',0,0,-48,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1480938086,1,1),

(10,10,'menu_link_content','en','Features Box',NULL,'main','entity:node/37',NULL,'a:0:{}',0,0,-47,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1481653776,1,1),

(11,11,'menu_link_content','en','Grid',NULL,'main','entity:node/38',NULL,'a:0:{}',0,0,-46,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1481653776,1,1),

(12,12,'menu_link_content','en','Icons Et-Line',NULL,'main','entity:node/39',NULL,'a:0:{}',0,0,-45,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(13,13,'menu_link_content','en','Icons Font Awesome',NULL,'main','entity:node/40',NULL,'a:0:{}',0,0,-44,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(14,14,'menu_link_content','en','Messages',NULL,'main','entity:node/41',NULL,'a:0:{}',0,0,-43,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(15,15,'menu_link_content','en','Page Titles',NULL,'main','entity:node/42',NULL,'a:0:{}',0,0,-42,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(16,16,'menu_link_content','en','Sliders',NULL,'main','entity:node/43',NULL,'a:0:{}',0,0,-41,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(17,17,'menu_link_content','en','Tabs',NULL,'main','entity:node/44',NULL,'a:0:{}',0,0,-40,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(18,18,'menu_link_content','en','Typography',NULL,'main','entity:node/45',NULL,'a:0:{}',0,0,-39,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(19,19,'menu_link_content','en','Video & Sound',NULL,'main','entity:node/46',NULL,'a:0:{}',0,0,-38,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(20,20,'menu_link_content','en','Header Dark',NULL,'main','entity:node/47',NULL,'a:0:{}',0,0,-35,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(22,22,'menu_link_content','en','Header Dark Transparent',NULL,'main','entity:node/48',NULL,'a:0:{}',0,0,-37,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(23,23,'menu_link_content','en','Pricing 1',NULL,'main','entity:node/49',NULL,'a:0:{}',0,0,15,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(24,24,'menu_link_content','en','Pricing 2',NULL,'main','entity:node/50',NULL,'a:0:{}',0,0,16,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(26,26,'menu_link_content','en','Elements',NULL,'main','internal:/node/34','','a:0:{}',0,1,-48,1,1,NULL,1485799719,1,1),

(27,27,'menu_link_content','en','Portfolio',NULL,'main','internal:/portfolio-boxed','','a:0:{}',0,1,-47,1,1,NULL,1485799719,1,1),

(28,28,'menu_link_content','en','Pages',NULL,'main','internal:/node/49','','a:0:{}',0,1,-49,1,1,NULL,1480938170,1,1),

(29,29,'menu_link_content','en','Header White',NULL,'main','entity:node/54',NULL,'a:0:{}',0,0,-34,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(30,30,'menu_link_content','en','Header White Transparent',NULL,'main','entity:node/55',NULL,'a:0:{}',0,0,-36,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1,1),

(31,31,'menu_link_content','en','Boxed',NULL,'main','internal:/portfolio-boxed','','a:0:{}',0,1,-73,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1,1),

(32,32,'menu_link_content','en','Boxed (Gutter)',NULL,'main','internal:/portfolio-boxed-gutter-2-columns','','a:0:{}',0,1,-72,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1,1),

(33,33,'menu_link_content','en','Boxed (Titles)',NULL,'main','internal:/portfolio-boxed-title-2-columns','','a:0:{}',0,1,-71,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1,1),

(34,34,'menu_link_content','en','Wide',NULL,'main','internal:/portfolio-boxed-wide-2-columns','','a:0:{}',0,1,-70,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1,1),

(35,35,'menu_link_content','en','Wide (Gutter)',NULL,'main','internal:/portfolio-gutter-wide-2-columns','','a:0:{}',0,1,-69,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1,1),

(36,36,'menu_link_content','en','Wide (Titles)',NULL,'main','internal:/portfolio-title-wide-2-columns','','a:0:{}',0,1,-68,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1,1),

(37,37,'menu_link_content','en','Masonry',NULL,'main','internal:/portfolio-masonry-2-columns','','a:0:{}',0,1,0,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481049885,1,1),

(38,38,'menu_link_content','en','Single Project',NULL,'main','entity:node/16',NULL,'a:0:{}',0,0,0,0,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481152669,1,1),

(39,39,'menu_link_content','en','Team 1',NULL,'main','entity:node/61',NULL,'a:0:{}',0,0,11,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(40,40,'menu_link_content','en','Team 2',NULL,'main','entity:node/62',NULL,'a:0:{}',0,0,12,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(41,41,'menu_link_content','en','About Us 1',NULL,'main','entity:node/63',NULL,'a:0:{}',0,0,3,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(42,42,'menu_link_content','en','About Us 2',NULL,'main','entity:node/64',NULL,'a:0:{}',0,0,4,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(43,43,'menu_link_content','en','About Us 3',NULL,'main','entity:node/65',NULL,'a:0:{}',0,0,5,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(44,44,'menu_link_content','en','Services 1',NULL,'main','entity:node/66',NULL,'a:0:{}',0,0,6,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(45,45,'menu_link_content','en','Services 2',NULL,'main','entity:node/67',NULL,'a:0:{}',0,0,7,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(46,46,'menu_link_content','en','Services 3',NULL,'main','entity:node/68',NULL,'a:0:{}',0,0,8,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(47,47,'menu_link_content','en','Clients',NULL,'main','entity:node/69',NULL,'a:0:{}',0,0,9,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(48,48,'menu_link_content','en','Landing Page',NULL,'main','entity:node/70',NULL,'a:0:{}',0,0,10,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(49,49,'menu_link_content','en','FAQ 1',NULL,'main','entity:node/71',NULL,'a:0:{}',0,0,13,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(50,50,'menu_link_content','en','FAQ 2',NULL,'main','entity:node/72',NULL,'a:0:{}',0,0,14,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(51,51,'menu_link_content','en','Contact 1',NULL,'main','entity:node/74',NULL,'a:0:{}',0,0,17,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(52,52,'menu_link_content','en','Contact 2',NULL,'main','entity:node/75',NULL,'a:0:{}',0,0,18,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1,1),

(62,62,'menu_link_content','en','Page not found',NULL,'main','entity:node/95',NULL,'a:0:{}',0,0,27,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1565849702,1,1),

(63,63,'menu_link_content','en','Maintenance Page',NULL,'main','entity:node/96',NULL,'a:0:{}',0,0,26,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1565849702,1,1),

(64,64,'menu_link_content','en','Login / Register',NULL,'main','internal:/user','','a:0:{}',0,1,24,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1565849641,1,1),

(65,65,'menu_link_content','en','Main Demo',NULL,'main','entity:node/97',NULL,'a:0:{}',0,0,26,0,1,'standard.front_page',1485799088,1,1),

(66,66,'menu_link_content','en','Image Parallax 1',NULL,'main','internal:/home/1','','a:0:{}',0,1,27,0,1,'standard.front_page',1485799088,1,1),

(67,67,'menu_link_content','en','Image Parallax 2',NULL,'main','internal:/home/2','','a:0:{}',0,1,28,0,1,'standard.front_page',1485799088,1,1),

(68,68,'menu_link_content','en','Image Parallax 3',NULL,'main','internal:/home/3','','a:0:{}',0,1,29,0,1,'standard.front_page',1485799088,1,1),

(69,69,'menu_link_content','en','Image Parallax 4',NULL,'main','internal:/home/4','','a:0:{}',0,1,30,0,1,'standard.front_page',1485799088,1,1),

(70,70,'menu_link_content','en','Image Parallax 5',NULL,'main','internal:/home/5','','a:0:{}',0,1,31,0,1,'standard.front_page',1485799088,1,1),

(71,71,'menu_link_content','en','FullWidth Image',NULL,'main','internal:/home/6','','a:0:{}',0,1,32,0,1,'standard.front_page',1485799088,1,1),

(73,73,'menu_link_content','en','Text Rotator',NULL,'main','internal:/home/7','','a:0:{}',0,1,33,0,1,'standard.front_page',1485799088,1,1),

(74,74,'menu_link_content','en','Slider FullScreen',NULL,'main','internal:/home/8','','a:0:{}',0,1,34,0,1,'standard.front_page',1485799088,1,1),

(75,75,'menu_link_content','en','Slider Zoom Effect',NULL,'main','internal:/home/9','','a:0:{}',0,1,35,0,1,'standard.front_page',1485799088,1,1),

(76,76,'menu_link_content','en','Slider FullWidth',NULL,'main','internal:/home/10','','a:0:{}',0,1,36,0,1,'standard.front_page',1485799088,1,1),

(77,77,'menu_link_content','en','Slider Background',NULL,'main','internal:/home/11','','a:0:{}',0,1,37,0,1,'standard.front_page',1485799088,1,1),

(78,78,'menu_link_content','en','With Play Button',NULL,'main','internal:/home/12','','a:0:{}',0,1,38,0,1,'standard.front_page',1485799088,1,1),

(79,79,'menu_link_content','en','BG Video FullWidth',NULL,'main','internal:/home/13','','a:0:{}',0,1,39,0,1,'standard.front_page',1485799088,1,1),

(80,80,'menu_link_content','en','BG Video FullScreen 1',NULL,'main','internal:/home/14','','a:0:{}',0,1,40,0,1,'standard.front_page',1485799088,1,1),

(81,81,'menu_link_content','en','BG Video FullScreen 2',NULL,'main','internal:/home/15','','a:0:{}',0,1,41,0,1,'standard.front_page',1485799088,1,1),

(84,84,'menu_link_content','en','Agency Header',NULL,'main','internal:/home/16','','a:0:{}',0,1,42,0,1,'standard.front_page',1485799088,1,1),

(85,85,'menu_link_content','en','Photography with fullscreen menu',NULL,'main','entity:node/101',NULL,'a:0:{}',0,0,43,0,1,'standard.front_page',1485799088,1,1),

(86,86,'menu_link_content','en','Home',NULL,'one-page','internal:#home','','a:0:{}',0,1,-50,0,1,NULL,1484927826,1,1),

(87,87,'menu_link_content','en','About',NULL,'one-page','internal:#about','','a:0:{}',0,1,-49,0,1,NULL,1484927826,1,1),

(88,88,'menu_link_content','en','Services',NULL,'one-page','internal:#services','','a:0:{}',0,1,-48,0,1,NULL,1484927826,1,1),

(89,89,'menu_link_content','en','Portfolio',NULL,'one-page','internal:#portfolio','','a:0:{}',0,1,-47,0,1,NULL,1484927826,1,1),

(90,90,'menu_link_content','en','News',NULL,'one-page','internal:#news','','a:0:{}',0,1,-46,0,1,NULL,1484927826,1,1),

(91,91,'menu_link_content','en','Contacts',NULL,'one-page','internal:#contacts','','a:0:{}',0,1,-45,0,1,NULL,1484927826,1,1),

(93,93,'menu_link_content','en','All Demos',NULL,'one-page','internal:/','','a:0:{}',0,1,-44,0,1,NULL,1484927826,1,1),

(94,94,'menu_link_content','en','Main Demo',NULL,'main','internal:/onepage/0','','a:0:{}',0,1,44,0,1,'standard.front_page',1485799088,1,1),

(95,95,'menu_link_content','en','Image Parallax 1',NULL,'main','internal:/onepage/1','','a:0:{}',0,1,45,0,1,'standard.front_page',1485799088,1,1),

(96,96,'menu_link_content','en','Image Parallax 2',NULL,'main','internal:/onepage/2','','a:0:{}',0,1,46,0,1,'standard.front_page',1485799088,1,1),

(97,97,'menu_link_content','en','Image Parallax 3',NULL,'main','internal:/onepage/3','','a:0:{}',0,1,47,0,1,'standard.front_page',1485799088,1,1),

(98,98,'menu_link_content','en','Image Parallax 4',NULL,'main','internal:/onepage/4','','a:0:{}',0,1,48,0,1,'standard.front_page',1485799088,1,1),

(99,99,'menu_link_content','en','Image Parallax 5',NULL,'main','internal:/onepage/5','','a:0:{}',0,1,49,0,1,'standard.front_page',1485799088,1,1),

(100,100,'menu_link_content','en','FullWidth Image',NULL,'main','internal:/onepage/6','','a:0:{}',0,1,50,0,1,'standard.front_page',1485799088,1,1),

(101,101,'menu_link_content','en','Text Rotator',NULL,'main','internal:/onepage/7','','a:0:{}',0,1,51,0,1,'standard.front_page',1485799088,1,1),

(102,102,'menu_link_content','en','Slider FullScreen',NULL,'main','internal:/onepage/8','','a:0:{}',0,1,52,0,1,'standard.front_page',1485799088,1,1),

(103,103,'menu_link_content','en','Slider Zoom Effect',NULL,'main','internal:/onepage/9','','a:0:{}',0,1,53,0,1,'standard.front_page',1485799088,1,1),

(104,104,'menu_link_content','en','Slider FullWidth',NULL,'main','internal:/onepage/10','','a:0:{}',0,1,54,0,1,'standard.front_page',1485799088,1,1),

(105,105,'menu_link_content','en','Slider Background',NULL,'main','internal:/onepage/11','','a:0:{}',0,1,55,0,1,'standard.front_page',1485799088,1,1),

(106,106,'menu_link_content','en','With Play Button',NULL,'main','internal:/onepage/12','','a:0:{}',0,1,56,0,1,'standard.front_page',1485799088,1,1),

(107,107,'menu_link_content','en','BG Video FullWidth',NULL,'main','internal:/onepage/13','','a:0:{}',0,1,57,0,1,'standard.front_page',1485799088,1,1),

(108,108,'menu_link_content','en','BG Video FullScreen 1',NULL,'main','internal:/onepage/14','','a:0:{}',0,1,58,0,1,'standard.front_page',1485799088,1,1),

(109,109,'menu_link_content','en','BG Video FullScreen 2',NULL,'main','internal:/onepage/15','','a:0:{}',0,1,59,0,1,'standard.front_page',1485799088,1,1),

(110,110,'menu_link_content','en','Agency Header',NULL,'main','internal:/onepage/16','','a:0:{}',0,1,60,0,1,'standard.front_page',1485799088,1,1),

(111,111,'menu_link_content','en','Photography with fullscreen menu',NULL,'main','internal:/onepage/17','','a:0:{}',0,1,61,0,1,'standard.front_page',1485799088,1,1),

(112,112,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-boxed','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553188,1,1),

(113,113,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-boxed-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553204,1,1),

(114,114,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-boxed-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553213,1,1),

(115,115,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-boxed-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553220,1,1),

(116,116,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-boxed-5-columns-black','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553231,1,1),

(117,117,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-boxed-gutter-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553253,1,1),

(118,118,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-boxed-gutter-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553263,1,1),

(119,119,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-boxed-gutter-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553270,1,1),

(120,120,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-boxed-gutter-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553278,1,1),

(121,121,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-boxed-gutter-5-black-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553300,1,1),

(122,122,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-boxed-title-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553317,1,1),

(123,123,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-boxed-title-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553326,1,1),

(124,124,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-boxed-title-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553336,1,1),

(125,125,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-boxed-title-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553344,1,1),

(126,126,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-boxed-title-5-columns-black','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553357,1,1),

(127,127,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-boxed-wide-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553373,1,1),

(128,128,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-boxed-wide-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553381,1,1),

(129,129,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-boxed-wide-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553388,1,1),

(130,130,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-boxed-wide-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553396,1,1),

(131,131,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-boxed-wide-5-columns-dark','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553408,1,1),

(132,132,'menu_link_content','en','2 Columns',NULL,'main','internal:/rhythm/portfolio-gutter-wide-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553428,1,1),

(133,133,'menu_link_content','en','3 Columns',NULL,'main','internal:/rhythm/portfolio-gutter-wide-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553437,1,1),

(134,134,'menu_link_content','en','4 Columns',NULL,'main','internal:/rhythm/portfolio-gutter-wide-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553447,1,1),

(135,135,'menu_link_content','en','5 Columns',NULL,'main','internal:/rhythm/portfolio-gutter-wide-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553457,1,1),

(136,136,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-gutter-wide-5-columns-dark','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553470,1,1),

(137,137,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-title-wide-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553501,1,1),

(138,138,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-title-wide-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553512,1,1),

(139,139,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-title-wide-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553519,1,1),

(140,140,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-title-wide-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553526,1,1),

(141,141,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-title-wide-5-columns-dark','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553537,1,1),

(142,142,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-masonry-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553552,1,1),

(143,143,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-masonry-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553560,1,1),

(144,144,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-masonry-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553570,1,1),

(145,145,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-masonry-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553580,1,1),

(146,146,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-masonry-5-columns-dark','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553592,1,1),

(147,147,'menu_link_content','en','Shop',NULL,'main','entity:node/107',NULL,'a:0:{}',0,0,-44,0,1,NULL,1503047489,1,1),

(148,148,'menu_link_content','en','Shopping Cart',NULL,'main','internal:/cart','','a:0:{}',0,1,5,0,1,'menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354',1503578059,1,1),

(149,149,'menu_link_content','en','Single Product',NULL,'main','internal:/product/4','','a:0:{}',0,1,4,0,1,'menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354',1503578059,1,1),

(150,150,'menu_link_content','en','Logout',NULL,'main','internal:/user/logout','','a:0:{}',0,1,25,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1565849702,1,1);

/*Table structure for table `menu_link_content_field_revision` */

DROP TABLE IF EXISTS `menu_link_content_field_revision`;

CREATE TABLE `menu_link_content_field_revision` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `link__uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `link__title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `link__options` longblob COMMENT 'Serialized array of options for the link.',
  `external` tinyint(4) DEFAULT NULL,
  `enabled` tinyint(4) NOT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`revision_id`,`langcode`),
  KEY `menu_link_content__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `menu_link_content_field__link__uri` (`link__uri`(30))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The revision data table for menu_link_content entities.';

/*Data for the table `menu_link_content_field_revision` */

insert  into `menu_link_content_field_revision`(`id`,`revision_id`,`langcode`,`title`,`description`,`link__uri`,`link__title`,`link__options`,`external`,`enabled`,`changed`,`default_langcode`,`revision_translation_affected`) values 

(1,1,'en','Blog',NULL,'internal:/blog-fullwidth','','a:0:{}',0,1,1485799719,1,1),

(2,2,'en','Classic',NULL,'internal:/blog-fullwidth','','a:0:{}',0,1,1480936876,1,1),

(3,3,'en','Blog Grid',NULL,'internal:/blog-2-columns','','a:0:{}',0,1,1480938015,1,1),

(4,4,'en','Blog Masonry',NULL,'internal:/blog-masonry-2-columns','','a:0:{}',0,1,1480938015,1,1),

(5,5,'en','Single ',NULL,'internal:/node/6','','a:0:{}',0,1,1480938015,1,1),

(6,6,'en','FullWidth',NULL,'internal:/node/6','','a:0:{}',0,1,1480938015,1,1),

(7,7,'en','Accordions',NULL,'entity:node/34',NULL,'a:0:{}',0,1,1480938086,1,1),

(8,8,'en','Bar (Progress)',NULL,'entity:node/35',NULL,'a:0:{}',0,1,1480938086,1,1),

(9,9,'en','Buttons',NULL,'entity:node/36',NULL,'a:0:{}',0,1,1480938086,1,1),

(10,10,'en','Features Box',NULL,'entity:node/37',NULL,'a:0:{}',0,1,1481653776,1,1),

(11,11,'en','Grid',NULL,'entity:node/38',NULL,'a:0:{}',0,1,1481653776,1,1),

(12,12,'en','Icons Et-Line',NULL,'entity:node/39',NULL,'a:0:{}',0,1,1485799253,1,1),

(13,13,'en','Icons Font Awesome',NULL,'entity:node/40',NULL,'a:0:{}',0,1,1485799253,1,1),

(14,14,'en','Messages',NULL,'entity:node/41',NULL,'a:0:{}',0,1,1485799253,1,1),

(15,15,'en','Page Titles',NULL,'entity:node/42',NULL,'a:0:{}',0,1,1485799253,1,1),

(16,16,'en','Sliders',NULL,'entity:node/43',NULL,'a:0:{}',0,1,1485799253,1,1),

(17,17,'en','Tabs',NULL,'entity:node/44',NULL,'a:0:{}',0,1,1485799253,1,1),

(18,18,'en','Typography',NULL,'entity:node/45',NULL,'a:0:{}',0,1,1485799253,1,1),

(19,19,'en','Video & Sound',NULL,'entity:node/46',NULL,'a:0:{}',0,1,1485799253,1,1),

(20,20,'en','Header Dark',NULL,'entity:node/47',NULL,'a:0:{}',0,1,1485799253,1,1),

(22,22,'en','Header Dark Transparent',NULL,'entity:node/48',NULL,'a:0:{}',0,1,1485799253,1,1),

(23,23,'en','Pricing 1',NULL,'entity:node/49',NULL,'a:0:{}',0,1,1485799253,1,1),

(24,24,'en','Pricing 2',NULL,'entity:node/50',NULL,'a:0:{}',0,1,1485799253,1,1),

(26,26,'en','Elements',NULL,'internal:/node/34','','a:0:{}',0,1,1485799719,1,1),

(27,27,'en','Portfolio',NULL,'internal:/portfolio-boxed','','a:0:{}',0,1,1485799719,1,1),

(28,28,'en','Pages',NULL,'internal:/node/49','','a:0:{}',0,1,1480938170,1,1),

(29,29,'en','Header White',NULL,'entity:node/54',NULL,'a:0:{}',0,1,1485799253,1,1),

(30,30,'en','Header White Transparent',NULL,'entity:node/55',NULL,'a:0:{}',0,1,1485799253,1,1),

(31,31,'en','Boxed',NULL,'internal:/portfolio-boxed','','a:0:{}',0,1,1481048566,1,1),

(32,32,'en','Boxed (Gutter)',NULL,'internal:/portfolio-boxed-gutter-2-columns','','a:0:{}',0,1,1481048566,1,1),

(33,33,'en','Boxed (Titles)',NULL,'internal:/portfolio-boxed-title-2-columns','','a:0:{}',0,1,1481048566,1,1),

(34,34,'en','Wide',NULL,'internal:/portfolio-boxed-wide-2-columns','','a:0:{}',0,1,1481048566,1,1),

(35,35,'en','Wide (Gutter)',NULL,'internal:/portfolio-gutter-wide-2-columns','','a:0:{}',0,1,1481048566,1,1),

(36,36,'en','Wide (Titles)',NULL,'internal:/portfolio-title-wide-2-columns','','a:0:{}',0,1,1481048566,1,1),

(37,37,'en','Masonry',NULL,'internal:/portfolio-masonry-2-columns','','a:0:{}',0,1,1481049885,1,1),

(38,38,'en','Single Project',NULL,'entity:node/16',NULL,'a:0:{}',0,1,1481152669,1,1),

(39,39,'en','Team 1',NULL,'entity:node/61',NULL,'a:0:{}',0,1,1485799253,1,1),

(40,40,'en','Team 2',NULL,'entity:node/62',NULL,'a:0:{}',0,1,1485799253,1,1),

(41,41,'en','About Us 1',NULL,'entity:node/63',NULL,'a:0:{}',0,1,1485799253,1,1),

(42,42,'en','About Us 2',NULL,'entity:node/64',NULL,'a:0:{}',0,1,1485799253,1,1),

(43,43,'en','About Us 3',NULL,'entity:node/65',NULL,'a:0:{}',0,1,1485799253,1,1),

(44,44,'en','Services 1',NULL,'entity:node/66',NULL,'a:0:{}',0,1,1485799253,1,1),

(45,45,'en','Services 2',NULL,'entity:node/67',NULL,'a:0:{}',0,1,1485799253,1,1),

(46,46,'en','Services 3',NULL,'entity:node/68',NULL,'a:0:{}',0,1,1485799253,1,1),

(47,47,'en','Clients',NULL,'entity:node/69',NULL,'a:0:{}',0,1,1485799253,1,1),

(48,48,'en','Landing Page',NULL,'entity:node/70',NULL,'a:0:{}',0,1,1485799253,1,1),

(49,49,'en','FAQ 1',NULL,'entity:node/71',NULL,'a:0:{}',0,1,1485799253,1,1),

(50,50,'en','FAQ 2',NULL,'entity:node/72',NULL,'a:0:{}',0,1,1485799253,1,1),

(51,51,'en','Contact 1',NULL,'entity:node/74',NULL,'a:0:{}',0,1,1485799253,1,1),

(52,52,'en','Contact 2',NULL,'entity:node/75',NULL,'a:0:{}',0,1,1485799253,1,1),

(62,62,'en','Page not found',NULL,'entity:node/95',NULL,'a:0:{}',0,1,1565849702,1,1),

(63,63,'en','Maintenance Page',NULL,'entity:node/96',NULL,'a:0:{}',0,1,1565849702,1,1),

(64,64,'en','Login / Register',NULL,'internal:/user','','a:0:{}',0,1,1565849641,1,1),

(65,65,'en','Main Demo',NULL,'entity:node/97',NULL,'a:0:{}',0,1,1485799088,1,1),

(66,66,'en','Image Parallax 1',NULL,'internal:/home/1','','a:0:{}',0,1,1485799088,1,1),

(67,67,'en','Image Parallax 2',NULL,'internal:/home/2','','a:0:{}',0,1,1485799088,1,1),

(68,68,'en','Image Parallax 3',NULL,'internal:/home/3','','a:0:{}',0,1,1485799088,1,1),

(69,69,'en','Image Parallax 4',NULL,'internal:/home/4','','a:0:{}',0,1,1485799088,1,1),

(70,70,'en','Image Parallax 5',NULL,'internal:/home/5','','a:0:{}',0,1,1485799088,1,1),

(71,71,'en','FullWidth Image',NULL,'internal:/home/6','','a:0:{}',0,1,1485799088,1,1),

(73,73,'en','Text Rotator',NULL,'internal:/home/7','','a:0:{}',0,1,1485799088,1,1),

(74,74,'en','Slider FullScreen',NULL,'internal:/home/8','','a:0:{}',0,1,1485799088,1,1),

(75,75,'en','Slider Zoom Effect',NULL,'internal:/home/9','','a:0:{}',0,1,1485799088,1,1),

(76,76,'en','Slider FullWidth',NULL,'internal:/home/10','','a:0:{}',0,1,1485799088,1,1),

(77,77,'en','Slider Background',NULL,'internal:/home/11','','a:0:{}',0,1,1485799088,1,1),

(78,78,'en','With Play Button',NULL,'internal:/home/12','','a:0:{}',0,1,1485799088,1,1),

(79,79,'en','BG Video FullWidth',NULL,'internal:/home/13','','a:0:{}',0,1,1485799088,1,1),

(80,80,'en','BG Video FullScreen 1',NULL,'internal:/home/14','','a:0:{}',0,1,1485799088,1,1),

(81,81,'en','BG Video FullScreen 2',NULL,'internal:/home/15','','a:0:{}',0,1,1485799088,1,1),

(84,84,'en','Agency Header',NULL,'internal:/home/16','','a:0:{}',0,1,1485799088,1,1),

(85,85,'en','Photography with fullscreen menu',NULL,'entity:node/101',NULL,'a:0:{}',0,1,1485799088,1,1),

(86,86,'en','Home',NULL,'internal:#home','','a:0:{}',0,1,1484927826,1,1),

(87,87,'en','About',NULL,'internal:#about','','a:0:{}',0,1,1484927826,1,1),

(88,88,'en','Services',NULL,'internal:#services','','a:0:{}',0,1,1484927826,1,1),

(89,89,'en','Portfolio',NULL,'internal:#portfolio','','a:0:{}',0,1,1484927826,1,1),

(90,90,'en','News',NULL,'internal:#news','','a:0:{}',0,1,1484927826,1,1),

(91,91,'en','Contacts',NULL,'internal:#contacts','','a:0:{}',0,1,1484927826,1,1),

(93,93,'en','All Demos',NULL,'internal:/','','a:0:{}',0,1,1484927826,1,1),

(94,94,'en','Main Demo',NULL,'internal:/onepage/0','','a:0:{}',0,1,1485799088,1,1),

(95,95,'en','Image Parallax 1',NULL,'internal:/onepage/1','','a:0:{}',0,1,1485799088,1,1),

(96,96,'en','Image Parallax 2',NULL,'internal:/onepage/2','','a:0:{}',0,1,1485799088,1,1),

(97,97,'en','Image Parallax 3',NULL,'internal:/onepage/3','','a:0:{}',0,1,1485799088,1,1),

(98,98,'en','Image Parallax 4',NULL,'internal:/onepage/4','','a:0:{}',0,1,1485799088,1,1),

(99,99,'en','Image Parallax 5',NULL,'internal:/onepage/5','','a:0:{}',0,1,1485799088,1,1),

(100,100,'en','FullWidth Image',NULL,'internal:/onepage/6','','a:0:{}',0,1,1485799088,1,1),

(101,101,'en','Text Rotator',NULL,'internal:/onepage/7','','a:0:{}',0,1,1485799088,1,1),

(102,102,'en','Slider FullScreen',NULL,'internal:/onepage/8','','a:0:{}',0,1,1485799088,1,1),

(103,103,'en','Slider Zoom Effect',NULL,'internal:/onepage/9','','a:0:{}',0,1,1485799088,1,1),

(104,104,'en','Slider FullWidth',NULL,'internal:/onepage/10','','a:0:{}',0,1,1485799088,1,1),

(105,105,'en','Slider Background',NULL,'internal:/onepage/11','','a:0:{}',0,1,1485799088,1,1),

(106,106,'en','With Play Button',NULL,'internal:/onepage/12','','a:0:{}',0,1,1485799088,1,1),

(107,107,'en','BG Video FullWidth',NULL,'internal:/onepage/13','','a:0:{}',0,1,1485799088,1,1),

(108,108,'en','BG Video FullScreen 1',NULL,'internal:/onepage/14','','a:0:{}',0,1,1485799088,1,1),

(109,109,'en','BG Video FullScreen 2',NULL,'internal:/onepage/15','','a:0:{}',0,1,1485799088,1,1),

(110,110,'en','Agency Header',NULL,'internal:/onepage/16','','a:0:{}',0,1,1485799088,1,1),

(111,111,'en','Photography with fullscreen menu',NULL,'internal:/onepage/17','','a:0:{}',0,1,1485799088,1,1),

(112,112,'en','2 Columns',NULL,'internal:/portfolio-boxed','','a:0:{}',0,1,1486553188,1,1),

(113,113,'en','3 Columns',NULL,'internal:/portfolio-boxed-3-columns','','a:0:{}',0,1,1486553204,1,1),

(114,114,'en','4 Columns',NULL,'internal:/portfolio-boxed-4-columns','','a:0:{}',0,1,1486553213,1,1),

(115,115,'en','5 Columns',NULL,'internal:/portfolio-boxed-5-columns','','a:0:{}',0,1,1486553220,1,1),

(116,116,'en','Black Hover',NULL,'internal:/portfolio-boxed-5-columns-black','','a:0:{}',0,1,1486553231,1,1),

(117,117,'en','2 Columns',NULL,'internal:/portfolio-boxed-gutter-2-columns','','a:0:{}',0,1,1486553253,1,1),

(118,118,'en','3 Columns',NULL,'internal:/portfolio-boxed-gutter-3-columns','','a:0:{}',0,1,1486553263,1,1),

(119,119,'en','4 Columns',NULL,'internal:/portfolio-boxed-gutter-4-columns','','a:0:{}',0,1,1486553270,1,1),

(120,120,'en','5 Columns',NULL,'internal:/portfolio-boxed-gutter-5-columns','','a:0:{}',0,1,1486553278,1,1),

(121,121,'en','Black Hover',NULL,'internal:/portfolio-boxed-gutter-5-black-columns','','a:0:{}',0,1,1486553300,1,1),

(122,122,'en','2 Columns',NULL,'internal:/portfolio-boxed-title-2-columns','','a:0:{}',0,1,1486553317,1,1),

(123,123,'en','3 Columns',NULL,'internal:/portfolio-boxed-title-3-columns','','a:0:{}',0,1,1486553326,1,1),

(124,124,'en','4 Columns',NULL,'internal:/portfolio-boxed-title-4-columns','','a:0:{}',0,1,1486553336,1,1),

(125,125,'en','5 Columns',NULL,'internal:/portfolio-boxed-title-5-columns','','a:0:{}',0,1,1486553344,1,1),

(126,126,'en','Black Hover',NULL,'internal:/portfolio-boxed-title-5-columns-black','','a:0:{}',0,1,1486553357,1,1),

(127,127,'en','2 Columns',NULL,'internal:/portfolio-boxed-wide-2-columns','','a:0:{}',0,1,1486553373,1,1),

(128,128,'en','3 Columns',NULL,'internal:/portfolio-boxed-wide-3-columns','','a:0:{}',0,1,1486553381,1,1),

(129,129,'en','4 Columns',NULL,'internal:/portfolio-boxed-wide-4-columns','','a:0:{}',0,1,1486553388,1,1),

(130,130,'en','5 Columns',NULL,'internal:/portfolio-boxed-wide-5-columns','','a:0:{}',0,1,1486553396,1,1),

(131,131,'en','Black Hover',NULL,'internal:/portfolio-boxed-wide-5-columns-dark','','a:0:{}',0,1,1486553408,1,1),

(132,132,'en','2 Columns',NULL,'internal:/rhythm/portfolio-gutter-wide-2-columns','','a:0:{}',0,1,1486553428,1,1),

(133,133,'en','3 Columns',NULL,'internal:/rhythm/portfolio-gutter-wide-3-columns','','a:0:{}',0,1,1486553437,1,1),

(134,134,'en','4 Columns',NULL,'internal:/rhythm/portfolio-gutter-wide-4-columns','','a:0:{}',0,1,1486553447,1,1),

(135,135,'en','5 Columns',NULL,'internal:/rhythm/portfolio-gutter-wide-5-columns','','a:0:{}',0,1,1486553457,1,1),

(136,136,'en','Black Hover',NULL,'internal:/portfolio-gutter-wide-5-columns-dark','','a:0:{}',0,1,1486553470,1,1),

(137,137,'en','2 Columns',NULL,'internal:/portfolio-title-wide-2-columns','','a:0:{}',0,1,1486553501,1,1),

(138,138,'en','3 Columns',NULL,'internal:/portfolio-title-wide-3-columns','','a:0:{}',0,1,1486553512,1,1),

(139,139,'en','4 Columns',NULL,'internal:/portfolio-title-wide-4-columns','','a:0:{}',0,1,1486553519,1,1),

(140,140,'en','5 Columns',NULL,'internal:/portfolio-title-wide-5-columns','','a:0:{}',0,1,1486553526,1,1),

(141,141,'en','Black Hover',NULL,'internal:/portfolio-title-wide-5-columns-dark','','a:0:{}',0,1,1486553537,1,1),

(142,142,'en','2 Columns',NULL,'internal:/portfolio-masonry-2-columns','','a:0:{}',0,1,1486553552,1,1),

(143,143,'en','3 Columns',NULL,'internal:/portfolio-masonry-3-columns','','a:0:{}',0,1,1486553560,1,1),

(144,144,'en','4 Columns',NULL,'internal:/portfolio-masonry-4-columns','','a:0:{}',0,1,1486553570,1,1),

(145,145,'en','5 Columns',NULL,'internal:/portfolio-masonry-5-columns','','a:0:{}',0,1,1486553580,1,1),

(146,146,'en','Black Hover',NULL,'internal:/portfolio-masonry-5-columns-dark','','a:0:{}',0,1,1486553592,1,1),

(147,147,'en','Shop',NULL,'entity:node/107',NULL,'a:0:{}',0,1,1503047489,1,1),

(148,148,'en','Shopping Cart',NULL,'internal:/cart','','a:0:{}',0,1,1503578059,1,1),

(149,149,'en','Single Product',NULL,'internal:/product/4','','a:0:{}',0,1,1503578059,1,1),

(150,150,'en','Logout',NULL,'internal:/user/logout','','a:0:{}',0,1,1565849702,1,1);

/*Table structure for table `menu_link_content_revision` */

DROP TABLE IF EXISTS `menu_link_content_revision`;

CREATE TABLE `menu_link_content_revision` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `revision_default` tinyint(4) DEFAULT NULL,
  `revision_user` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `revision_created` int(11) DEFAULT NULL,
  `revision_log_message` longtext,
  PRIMARY KEY (`revision_id`),
  KEY `menu_link_content__id` (`id`),
  KEY `menu_link_content__ef029a1897` (`revision_user`)
) ENGINE=InnoDB AUTO_INCREMENT=151 DEFAULT CHARSET=utf8mb4 COMMENT='The revision table for menu_link_content entities.';

/*Data for the table `menu_link_content_revision` */

insert  into `menu_link_content_revision`(`id`,`revision_id`,`langcode`,`revision_default`,`revision_user`,`revision_created`,`revision_log_message`) values 

(1,1,'en',1,NULL,NULL,NULL),

(2,2,'en',1,NULL,NULL,NULL),

(3,3,'en',1,NULL,NULL,NULL),

(4,4,'en',1,NULL,NULL,NULL),

(5,5,'en',1,NULL,NULL,NULL),

(6,6,'en',1,NULL,NULL,NULL),

(7,7,'en',1,NULL,NULL,NULL),

(8,8,'en',1,NULL,NULL,NULL),

(9,9,'en',1,NULL,NULL,NULL),

(10,10,'en',1,NULL,NULL,NULL),

(11,11,'en',1,NULL,NULL,NULL),

(12,12,'en',1,NULL,NULL,NULL),

(13,13,'en',1,NULL,NULL,NULL),

(14,14,'en',1,NULL,NULL,NULL),

(15,15,'en',1,NULL,NULL,NULL),

(16,16,'en',1,NULL,NULL,NULL),

(17,17,'en',1,NULL,NULL,NULL),

(18,18,'en',1,NULL,NULL,NULL),

(19,19,'en',1,NULL,NULL,NULL),

(20,20,'en',1,NULL,NULL,NULL),

(22,22,'en',1,NULL,NULL,NULL),

(23,23,'en',1,NULL,NULL,NULL),

(24,24,'en',1,NULL,NULL,NULL),

(26,26,'en',1,NULL,NULL,NULL),

(27,27,'en',1,NULL,NULL,NULL),

(28,28,'en',1,NULL,NULL,NULL),

(29,29,'en',1,NULL,NULL,NULL),

(30,30,'en',1,NULL,NULL,NULL),

(31,31,'en',1,NULL,NULL,NULL),

(32,32,'en',1,NULL,NULL,NULL),

(33,33,'en',1,NULL,NULL,NULL),

(34,34,'en',1,NULL,NULL,NULL),

(35,35,'en',1,NULL,NULL,NULL),

(36,36,'en',1,NULL,NULL,NULL),

(37,37,'en',1,NULL,NULL,NULL),

(38,38,'en',1,NULL,NULL,NULL),

(39,39,'en',1,NULL,NULL,NULL),

(40,40,'en',1,NULL,NULL,NULL),

(41,41,'en',1,NULL,NULL,NULL),

(42,42,'en',1,NULL,NULL,NULL),

(43,43,'en',1,NULL,NULL,NULL),

(44,44,'en',1,NULL,NULL,NULL),

(45,45,'en',1,NULL,NULL,NULL),

(46,46,'en',1,NULL,NULL,NULL),

(47,47,'en',1,NULL,NULL,NULL),

(48,48,'en',1,NULL,NULL,NULL),

(49,49,'en',1,NULL,NULL,NULL),

(50,50,'en',1,NULL,NULL,NULL),

(51,51,'en',1,NULL,NULL,NULL),

(52,52,'en',1,NULL,NULL,NULL),

(62,62,'en',1,NULL,NULL,NULL),

(63,63,'en',1,NULL,NULL,NULL),

(64,64,'en',1,NULL,NULL,NULL),

(65,65,'en',1,NULL,NULL,NULL),

(66,66,'en',1,NULL,NULL,NULL),

(67,67,'en',1,NULL,NULL,NULL),

(68,68,'en',1,NULL,NULL,NULL),

(69,69,'en',1,NULL,NULL,NULL),

(70,70,'en',1,NULL,NULL,NULL),

(71,71,'en',1,NULL,NULL,NULL),

(73,73,'en',1,NULL,NULL,NULL),

(74,74,'en',1,NULL,NULL,NULL),

(75,75,'en',1,NULL,NULL,NULL),

(76,76,'en',1,NULL,NULL,NULL),

(77,77,'en',1,NULL,NULL,NULL),

(78,78,'en',1,NULL,NULL,NULL),

(79,79,'en',1,NULL,NULL,NULL),

(80,80,'en',1,NULL,NULL,NULL),

(81,81,'en',1,NULL,NULL,NULL),

(84,84,'en',1,NULL,NULL,NULL),

(85,85,'en',1,NULL,NULL,NULL),

(86,86,'en',1,NULL,NULL,NULL),

(87,87,'en',1,NULL,NULL,NULL),

(88,88,'en',1,NULL,NULL,NULL),

(89,89,'en',1,NULL,NULL,NULL),

(90,90,'en',1,NULL,NULL,NULL),

(91,91,'en',1,NULL,NULL,NULL),

(93,93,'en',1,NULL,NULL,NULL),

(94,94,'en',1,NULL,NULL,NULL),

(95,95,'en',1,NULL,NULL,NULL),

(96,96,'en',1,NULL,NULL,NULL),

(97,97,'en',1,NULL,NULL,NULL),

(98,98,'en',1,NULL,NULL,NULL),

(99,99,'en',1,NULL,NULL,NULL),

(100,100,'en',1,NULL,NULL,NULL),

(101,101,'en',1,NULL,NULL,NULL),

(102,102,'en',1,NULL,NULL,NULL),

(103,103,'en',1,NULL,NULL,NULL),

(104,104,'en',1,NULL,NULL,NULL),

(105,105,'en',1,NULL,NULL,NULL),

(106,106,'en',1,NULL,NULL,NULL),

(107,107,'en',1,NULL,NULL,NULL),

(108,108,'en',1,NULL,NULL,NULL),

(109,109,'en',1,NULL,NULL,NULL),

(110,110,'en',1,NULL,NULL,NULL),

(111,111,'en',1,NULL,NULL,NULL),

(112,112,'en',1,NULL,NULL,NULL),

(113,113,'en',1,NULL,NULL,NULL),

(114,114,'en',1,NULL,NULL,NULL),

(115,115,'en',1,NULL,NULL,NULL),

(116,116,'en',1,NULL,NULL,NULL),

(117,117,'en',1,NULL,NULL,NULL),

(118,118,'en',1,NULL,NULL,NULL),

(119,119,'en',1,NULL,NULL,NULL),

(120,120,'en',1,NULL,NULL,NULL),

(121,121,'en',1,NULL,NULL,NULL),

(122,122,'en',1,NULL,NULL,NULL),

(123,123,'en',1,NULL,NULL,NULL),

(124,124,'en',1,NULL,NULL,NULL),

(125,125,'en',1,NULL,NULL,NULL),

(126,126,'en',1,NULL,NULL,NULL),

(127,127,'en',1,NULL,NULL,NULL),

(128,128,'en',1,NULL,NULL,NULL),

(129,129,'en',1,NULL,NULL,NULL),

(130,130,'en',1,NULL,NULL,NULL),

(131,131,'en',1,NULL,NULL,NULL),

(132,132,'en',1,NULL,NULL,NULL),

(133,133,'en',1,NULL,NULL,NULL),

(134,134,'en',1,NULL,NULL,NULL),

(135,135,'en',1,NULL,NULL,NULL),

(136,136,'en',1,NULL,NULL,NULL),

(137,137,'en',1,NULL,NULL,NULL),

(138,138,'en',1,NULL,NULL,NULL),

(139,139,'en',1,NULL,NULL,NULL),

(140,140,'en',1,NULL,NULL,NULL),

(141,141,'en',1,NULL,NULL,NULL),

(142,142,'en',1,NULL,NULL,NULL),

(143,143,'en',1,NULL,NULL,NULL),

(144,144,'en',1,NULL,NULL,NULL),

(145,145,'en',1,NULL,NULL,NULL),

(146,146,'en',1,NULL,NULL,NULL),

(147,147,'en',1,NULL,NULL,NULL),

(148,148,'en',1,NULL,NULL,NULL),

(149,149,'en',1,NULL,NULL,NULL),

(150,150,'en',1,NULL,1565849669,NULL);

/*Table structure for table `menu_tree` */

DROP TABLE IF EXISTS `menu_tree`;

CREATE TABLE `menu_tree` (
  `menu_name` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The menu name. All links with the same menu name (such as ''tools'') are part of the same menu.',
  `mlid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The menu link ID (mlid) is the integer primary key.',
  `id` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'Unique machine name: the plugin ID.',
  `parent` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The plugin ID for the parent of this link.',
  `route_name` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The machine name of a defined Symfony Route this menu item represents.',
  `route_param_key` varchar(255) DEFAULT NULL COMMENT 'An encoded string of route parameters for loading by route.',
  `route_parameters` longblob COMMENT 'Serialized array of route parameters of this menu link.',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT 'The external path this link points to (when not using a route).',
  `title` longblob COMMENT 'The serialized title for the link. May be a TranslatableMarkup.',
  `description` longblob COMMENT 'The serialized description of this link - used for admin pages and title attribute. May be a TranslatableMarkup.',
  `class` text COMMENT 'The class for this link plugin.',
  `options` longblob COMMENT 'A serialized array of URL options, such as a query string or HTML attributes.',
  `provider` varchar(50) CHARACTER SET ascii NOT NULL DEFAULT 'system' COMMENT 'The name of the module that generated this link.',
  `enabled` smallint(6) NOT NULL DEFAULT '1' COMMENT 'A flag for whether the link should be rendered in menus. (0 = a disabled menu item that may be shown on admin screens, 1 = a normal, visible link)',
  `discovered` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag for whether the link was discovered, so can be purged on rebuild',
  `expanded` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag for whether this link should be rendered as expanded in menus - expanded links always have their child links displayed, instead of only when the link is in the active trail (1 = expanded, 0 = not expanded)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Link weight among links in the same menu at the same depth.',
  `metadata` longblob COMMENT 'A serialized array of data that may be used by the plugin instance.',
  `has_children` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag indicating whether any enabled links have this link as a parent (1 = enabled children exist, 0 = no enabled children).',
  `depth` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The depth relative to the top level. A link with empty parent will have depth == 1.',
  `p1` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The first mlid in the materialized path. If N = depth, then pN must equal the mlid. If depth > 1 then p(N-1) must equal the parent link mlid. All pX where X > depth must equal zero. The columns p1 .. p9 are also called the parents.',
  `p2` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The second mlid in the materialized path. See p1.',
  `p3` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The third mlid in the materialized path. See p1.',
  `p4` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fourth mlid in the materialized path. See p1.',
  `p5` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fifth mlid in the materialized path. See p1.',
  `p6` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sixth mlid in the materialized path. See p1.',
  `p7` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The seventh mlid in the materialized path. See p1.',
  `p8` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The eighth mlid in the materialized path. See p1.',
  `p9` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The ninth mlid in the materialized path. See p1.',
  `form_class` varchar(255) DEFAULT NULL COMMENT 'meh',
  PRIMARY KEY (`mlid`),
  UNIQUE KEY `id` (`id`),
  KEY `menu_parents` (`menu_name`,`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`,`p9`),
  KEY `menu_parent_expand_child` (`menu_name`,`expanded`,`has_children`,`parent`(16)),
  KEY `route_values` (`route_name`(32),`route_param_key`(16))
) ENGINE=InnoDB AUTO_INCREMENT=694 DEFAULT CHARSET=utf8mb4 COMMENT='Contains the menu tree hierarchy.';

/*Data for the table `menu_tree` */

insert  into `menu_tree`(`menu_name`,`mlid`,`id`,`parent`,`route_name`,`route_param_key`,`route_parameters`,`url`,`title`,`description`,`class`,`options`,`provider`,`enabled`,`discovered`,`expanded`,`weight`,`metadata`,`has_children`,`depth`,`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`,`p9`,`form_class`) values 

('admin',1,'system.admin','','system.admin','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Administration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,9,'a:0:{}',1,1,1,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',2,'system.admin_content','system.admin','system.admin_content','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Find and manage content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-10,'a:0:{}',1,2,1,2,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',3,'system.admin_structure','system.admin','system.admin_structure','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Structure\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Administer blocks, content types, menus, etc.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-8,'a:0:{}',1,2,1,3,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',4,'system.themes_page','system.admin','system.themes_page','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Appearance\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Select and configure themes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-6,'a:0:{}',1,2,1,4,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',5,'system.modules_list','system.admin','system.modules_list','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Extend\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"Add and enable modules to extend site functionality.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-2,'a:0:{}',1,2,1,5,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',6,'system.admin_config','system.admin','system.admin_config','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Administer settings.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,0,'a:0:{}',1,2,1,6,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',7,'system.admin_config_media','system.admin_config','system.admin_config_media','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Media\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-10,'a:0:{}',1,3,1,6,7,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',8,'system.file_system_settings','system.admin_config_media','system.file_system_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"File system\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"Configure the location of uploaded files and how they are accessed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,0,'a:0:{}',0,4,1,6,7,8,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',9,'system.image_toolkit_settings','system.admin_config_media','system.image_toolkit_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Image toolkit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,20,'a:0:{}',0,4,1,6,7,9,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',10,'system.admin_config_services','system.admin_config','system.admin_config_services','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Web services\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,0,'a:0:{}',1,3,1,6,10,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',11,'system.rss_feeds_settings','system.admin_config_services','system.rss_feeds_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"RSS publishing\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:115:\"Configure the site description, the number of items per feed, and whether feeds should be titles/teasers/full-text.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,0,'a:0:{}',0,4,1,6,10,11,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',12,'system.admin_config_development','system.admin_config','system.admin_config_development','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Development\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Configure and use development tools.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-10,'a:0:{}',1,3,1,6,12,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',13,'system.site_maintenance_mode','system.admin_config_development','system.site_maintenance_mode','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Maintenance mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"Take the site offline for updates and other maintenance tasks.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-10,'a:0:{}',0,4,1,6,12,13,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',14,'system.performance_settings','system.admin_config_development','system.performance_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Performance\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Configure caching and bandwidth optimization.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-20,'a:0:{}',0,4,1,6,12,14,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',15,'system.logging_settings','system.admin_config_development','system.logging_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Logging and errors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:61:\"Configure the display of error messages and database logging.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-15,'a:0:{}',0,4,1,6,12,15,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',16,'system.admin_config_regional','system.admin_config','system.admin_config_regional','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Regional and language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"Configure regional settings, localization, and translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-5,'a:0:{}',1,3,1,6,16,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',17,'system.regional_settings','system.admin_config_regional','system.regional_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Regional settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Configure the locale and timezone settings.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-20,'a:0:{}',0,4,1,6,16,17,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',18,'entity.date_format.collection','system.admin_config_regional','entity.date_format.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Date and time formats\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Configure how dates and times are displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-9,'a:0:{}',0,4,1,6,16,18,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',19,'system.admin_config_search','system.admin_config','system.admin_config_search','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Search and metadata\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:64:\"Configure site search, metadata, and search engine optimization.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-10,'a:0:{}',1,3,1,6,19,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',20,'system.admin_config_system','system.admin_config','system.admin_config_system','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"Configure basic site settings, actions, and cron.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-20,'a:0:{}',1,3,1,6,20,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',21,'system.site_information_settings','system.admin_config_system','system.site_information_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Basic site settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"Change site name, email address, slogan, default front page, and error pages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-20,'a:0:{}',0,4,1,6,20,21,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',22,'system.cron_settings','system.admin_config_system','system.cron_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Cron\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"Manage automatic site maintenance tasks.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,20,'a:0:{}',0,4,1,6,20,22,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',23,'system.admin_config_ui','system.admin_config','system.admin_config_ui','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"User interface\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Configure the administrative user interface.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-15,'a:0:{}',1,3,1,6,23,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',24,'system.admin_config_workflow','system.admin_config','system.admin_config_workflow','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Manage the content workflow.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,5,'a:0:{}',0,3,1,6,24,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',25,'system.admin_config_content','system.admin_config','system.admin_config_content','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Content authoring\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Configure content formatting and authoring.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,-15,'a:0:{}',1,3,1,6,25,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',26,'system.admin_reports','system.admin','system.admin_reports','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Reports\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"View reports, updates, and errors.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,5,'a:0:{}',1,2,1,26,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',27,'system.status','system.admin_reports','system.status','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Status report\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Get a status report about your site\'s operation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','system',1,1,0,0,'a:0:{}',0,3,1,26,27,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',28,'user.admin_index','system.admin_config','user.admin_index','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"People\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Configure user accounts.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','user',1,1,0,-20,'a:0:{}',1,3,1,6,28,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',29,'entity.user.admin_form','user.admin_index','entity.user.admin_form','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Account settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:105:\"Configure default user account settings, including fields, registration requirements, and email messages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','user',1,1,0,-10,'a:0:{}',1,4,1,6,28,29,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',30,'entity.user.collection','system.admin','entity.user.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"People\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Manage user accounts, roles, and permissions.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','user',1,1,0,4,'a:0:{}',1,2,1,30,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('account',31,'user.page','','user.page','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"My account\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','user',1,1,0,-10,'a:0:{}',0,1,31,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('account',32,'user.logout','','','','a:0:{}','','s:0:\"\";','s:0:\"\";','Drupal\\user\\Plugin\\Menu\\LoginLogoutMenuLink','a:0:{}','user',1,1,0,10,'a:0:{}',0,1,32,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',33,'standard.front_page','','<front>','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Home\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','standard',1,1,0,-50,'a:0:{}',1,1,33,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('tools',34,'filter.tips_all','','filter.tips_all','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Compose tips\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','filter',0,1,0,0,'a:0:{}',0,1,34,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',35,'filter.admin_overview','system.admin_config_content','filter.admin_overview','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Text formats and editors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:78:\"Select and configure text editors, and how content is filtered when displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','filter',1,1,0,0,'a:0:{}',0,4,1,6,25,35,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',36,'block.admin_display','system.admin_structure','block.admin_display','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Block layout\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','block',1,1,0,0,'a:0:{}',1,3,1,3,36,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('tools',37,'node.add_page','','node.add_page','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','node',1,1,0,0,'a:0:{}',0,1,37,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',38,'entity.node_type.collection','system.admin_structure','entity.node_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Content types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:71:\"Create and manage fields, forms, and display settings for your content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','node',1,1,0,0,'a:0:{}',1,3,1,3,38,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',39,'comment.admin','system.admin_content','comment.admin','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"List and edit site comments and the comment approval queue.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','comment',1,1,0,0,'a:0:{}',1,3,1,2,39,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',40,'entity.comment_type.collection','system.admin_structure','entity.comment_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Comment types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Manage form and displays settings of comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','comment',1,1,0,0,'a:0:{}',1,3,1,3,40,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',41,'config.sync','system.admin_config_development','config.sync','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Configuration synchronization\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Import and export your configuration.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','config',1,1,0,0,'a:0:{}',1,4,1,6,12,41,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',42,'entity.contact_form.collection','system.admin_structure','entity.contact_form.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Contact forms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Create and manage contact forms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','contact',1,1,0,0,'a:0:{}',1,3,1,3,42,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('footer',43,'contact.site_page','','contact.site_page','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Contact\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','contact',1,1,0,0,'a:0:{}',0,1,43,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',44,'dblog.overview','system.admin_reports','dblog.overview','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Recent log messages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"View events that have recently been logged.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','dblog',1,1,0,-1,'a:0:{}',1,3,1,26,44,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',45,'dblog.page_not_found','system.admin_reports','dblog.page_not_found','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Top \'page not found\' errors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"View \'page not found\' errors (404s).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','dblog',1,1,0,0,'a:0:{}',0,3,1,26,45,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',46,'dblog.access_denied','system.admin_reports','dblog.access_denied','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Top \'access denied\' errors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"View \'access denied\' errors (403s).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','dblog',1,1,0,0,'a:0:{}',0,3,1,26,46,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',47,'field_ui.display_mode','system.admin_structure','field_ui.display_mode','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Display modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:65:\"Configure what displays are available for your content and forms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','field_ui',1,1,0,0,'a:0:{}',1,3,1,3,47,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',48,'entity.entity_view_mode.collection','field_ui.display_mode','entity.entity_view_mode.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"View modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Manage custom view modes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','field_ui',1,1,0,0,'a:0:{}',1,4,1,3,47,48,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',49,'entity.entity_form_mode.collection','field_ui.display_mode','entity.entity_form_mode.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Form modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Manage custom form modes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','field_ui',1,1,0,0,'a:0:{}',1,4,1,3,47,49,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',50,'entity.field_storage_config.collection','system.admin_reports','entity.field_storage_config.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Field list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Overview of fields on all entity types.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','field_ui',1,1,0,0,'a:0:{}',1,3,1,26,50,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',51,'entity.taxonomy_vocabulary.collection','system.admin_structure','entity.taxonomy_vocabulary.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Taxonomy\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"Manage tagging, categorization, and classification of your content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','taxonomy',1,1,0,0,'a:0:{}',1,3,1,3,51,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',52,'help.main','system.admin','help.main','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Help\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Reference for usage, configuration, and modules.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','help',1,1,0,9,'a:0:{}',0,2,1,52,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',53,'entity.image_style.collection','system.admin_config_media','entity.image_style.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Image styles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:78:\"Configure styles that can be used for resizing or adjusting images on display.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','image',1,1,0,0,'a:0:{}',0,4,1,6,7,53,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',54,'entity.menu.collection','system.admin_structure','entity.menu.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Menus\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Manage menus and menu links.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','menu_ui',1,1,0,0,'a:0:{}',1,3,1,3,54,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',55,'path.admin_overview','system.admin_config_search','path.admin_overview','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"URL aliases\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Add custom URLs to existing paths.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','path',1,1,0,-5,'a:0:{}',1,4,1,6,19,55,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('tools',56,'search.view','','search.view','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','search',0,1,0,0,'a:0:{}',0,1,56,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',57,'entity.search_page.collection','system.admin_config_search','entity.search_page.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Search pages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Configure search pages and search indexing options.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','search',1,1,0,-10,'a:0:{}',0,4,1,6,19,57,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',58,'dblog.search','system.admin_reports','dblog.search','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Top search phrases\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"View most popular search phrases.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','',1,1,0,0,'a:0:{}',0,3,1,26,58,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',59,'entity.shortcut_set.collection','system.admin_config_ui','entity.shortcut_set.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Shortcuts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Add and modify shortcut sets.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','shortcut',1,1,0,0,'a:0:{}',0,4,1,6,23,59,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',60,'entity.view.collection','system.admin_structure','entity.view.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Manage customized lists of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','views_ui',1,1,0,0,'a:0:{}',1,3,1,3,60,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',61,'views_ui.reports_plugins','system.admin_reports','views_ui.reports_plugins','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Views plugins\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"Overview of plugins used in all views.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','views_ui',1,1,0,0,'a:0:{}',0,3,1,26,61,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',62,'update.status','system.admin_reports','update.status','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Available updates\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:82:\"Get a status report about available updates for your installed modules and themes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','update',1,1,0,-50,'a:0:{}',1,3,1,26,62,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',96,'entity.embed_button.collection','system.admin_config_content','entity.embed_button.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Text editor embed buttons\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Manage text editor embed buttons.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','embed',1,1,0,10,'a:0:{}',1,4,1,6,25,96,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',97,'entity.entity_browser.collection','system.admin_config_content','entity.entity_browser.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Entity browsers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Manage entity browsers.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','entity_browser',1,1,0,0,'a:0:{}',0,4,1,6,25,97,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',98,'admin_toolbar_tools.help','system.admin','<front>','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Tools\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-100,'a:0:{}',1,2,1,98,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',99,'system.admin_index','admin_toolbar_tools.help','system.admin_index','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Index\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-100,'a:0:{}',0,3,1,98,99,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',100,'system.run_cron','admin_toolbar_tools.help','admin_toolbar.run.cron','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Run cron\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-8,'a:0:{}',0,3,1,98,100,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',101,'system.db_update','admin_toolbar_tools.help','system.db_update','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Run updates\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-6,'a:0:{}',0,3,1,98,101,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',102,'admin_toolbar_tools.flush','admin_toolbar_tools.help','admin_toolbar_tools.flush','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Flush all caches\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-9,'a:0:{}',1,3,1,98,102,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',103,'admin_toolbar_tools.cssjs','admin_toolbar_tools.flush','admin_toolbar_tools.cssjs','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Flush CSS and Javascript\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,98,102,103,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',104,'admin_toolbar_tools.plugin','admin_toolbar_tools.flush','admin_toolbar_tools.plugin','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Flush plugins cache\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,98,102,104,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',105,'admin_toolbar_tools.flush_static','admin_toolbar_tools.flush','admin_toolbar_tools.flush_static','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Flush static cache\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,98,102,105,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',106,'admin_toolbar_tools.flush_menu','admin_toolbar_tools.flush','admin_toolbar_tools.flush_menu','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Flush routing and links cache\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,98,102,106,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',107,'admin_toolbar_tools.flush_rendercache','admin_toolbar_tools.flush','admin_toolbar_tools.flush_rendercache','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Flush render cache\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,98,102,107,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',122,'node.add.article','admin_toolbar_tools.add_content','node.add','node_type=article','a:1:{s:9:\"node_type\";s:7:\"article\";}','','s:7:\"Article\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,2,649,122,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',123,'node.add.nd_blog','admin_toolbar_tools.add_content','node.add','node_type=nd_blog','a:1:{s:9:\"node_type\";s:7:\"nd_blog\";}','','s:4:\"Blog\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,2,649,123,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',124,'node.add.page','admin_toolbar_tools.add_content','node.add','node_type=page','a:1:{s:9:\"node_type\";s:4:\"page\";}','','s:10:\"Basic page\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,2,649,124,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',125,'block_content.add_page','block.admin_display','block_content.add_page','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-100,'a:0:{}',0,4,1,3,36,125,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',126,'entity.block_content.collection','block.admin_display','entity.block_content.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Custom block library\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,3,36,126,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',127,'entity.block_content_type.collection','block.admin_display','entity.block_content_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,36,127,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',128,'entity.block_content_type.edit_form.basic','entity.block_content_type.collection','entity.block_content_type.edit_form','block_content_type=basic','a:1:{s:18:\"block_content_type\";s:5:\"basic\";}','','s:11:\"Basic block\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,5,1,3,36,127,128,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',129,'entity.block_content.field_ui_fieldsbasic','entity.block_content_type.edit_form.basic','entity.block_content.field_ui_fields','block_content_type=basic','a:1:{s:18:\"block_content_type\";s:5:\"basic\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,6,1,3,36,127,128,129,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',130,'entity.entity_form_display.block_content.defaultbasic','entity.block_content_type.edit_form.basic','entity.entity_form_display.block_content.default','block_content_type=basic','a:1:{s:18:\"block_content_type\";s:5:\"basic\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,6,1,3,36,127,128,130,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',131,'entity.entity_view_display.block_content.default.basic','entity.block_content_type.edit_form.basic','entity.entity_view_display.block_content.default','block_content_type=basic','a:1:{s:18:\"block_content_type\";s:5:\"basic\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,6,1,3,36,127,128,131,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',133,'entity.block_content_type.delete_form.basic','entity.block_content_type.edit_form.basic','entity.block_content_type.delete_form','block_content_type=basic','a:1:{s:18:\"block_content_type\";s:5:\"basic\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,6,1,3,36,127,128,133,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',134,'entity.comment_type.edit_form.comment','entity.comment_type.collection','entity.comment_type.edit_form','comment_type=comment','a:1:{s:12:\"comment_type\";s:7:\"comment\";}','','s:16:\"Default comments\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,40,134,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',135,'entity.comment.field_ui_fieldscomment','entity.comment_type.edit_form.comment','entity.comment.field_ui_fields','comment_type=comment','a:1:{s:12:\"comment_type\";s:7:\"comment\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,40,134,135,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',136,'entity.entity_form_display.comment.defaultcomment','entity.comment_type.edit_form.comment','entity.entity_form_display.comment.default','comment_type=comment','a:1:{s:12:\"comment_type\";s:7:\"comment\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,40,134,136,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',137,'entity.entity_view_display.comment.default.comment','entity.comment_type.edit_form.comment','entity.entity_view_display.comment.default','comment_type=comment','a:1:{s:12:\"comment_type\";s:7:\"comment\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,40,134,137,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',139,'entity.comment_type.delete_form.comment','entity.comment_type.edit_form.comment','entity.comment_type.delete_form','comment_type=comment','a:1:{s:12:\"comment_type\";s:7:\"comment\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,40,134,139,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',140,'entity.contact_form.edit_form.feedback','entity.contact_form.collection','entity.contact_form.edit_form','contact_form=feedback','a:1:{s:12:\"contact_form\";s:8:\"feedback\";}','','s:16:\"Website feedback\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,42,140,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',141,'entity.contact_message.field_ui_fieldsfeedback','entity.contact_form.edit_form.feedback','entity.contact_message.field_ui_fields','contact_form=feedback','a:1:{s:12:\"contact_form\";s:8:\"feedback\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,42,140,141,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',142,'entity.entity_form_display.contact_message.defaultfeedback','entity.contact_form.edit_form.feedback','entity.entity_form_display.contact_message.default','contact_form=feedback','a:1:{s:12:\"contact_form\";s:8:\"feedback\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,42,140,142,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',143,'entity.entity_view_display.contact_message.default.feedback','entity.contact_form.edit_form.feedback','entity.entity_view_display.contact_message.default','contact_form=feedback','a:1:{s:12:\"contact_form\";s:8:\"feedback\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,42,140,143,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',145,'entity.contact_form.delete_form.feedback','entity.contact_form.edit_form.feedback','entity.contact_form.delete_form','contact_form=feedback','a:1:{s:12:\"contact_form\";s:8:\"feedback\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,42,140,145,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',146,'entity.contact_form.edit_form.personal','entity.contact_form.collection','entity.contact_form.edit_form','contact_form=personal','a:1:{s:12:\"contact_form\";s:8:\"personal\";}','','s:21:\"Personal contact form\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,42,146,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',147,'entity.contact_message.field_ui_fieldspersonal','entity.contact_form.edit_form.personal','entity.contact_message.field_ui_fields','contact_form=personal','a:1:{s:12:\"contact_form\";s:8:\"personal\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,42,146,147,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',148,'entity.entity_form_display.contact_message.defaultpersonal','entity.contact_form.edit_form.personal','entity.entity_form_display.contact_message.default','contact_form=personal','a:1:{s:12:\"contact_form\";s:8:\"personal\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,42,146,148,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',149,'entity.entity_view_display.contact_message.default.personal','entity.contact_form.edit_form.personal','entity.entity_view_display.contact_message.default','contact_form=personal','a:1:{s:12:\"contact_form\";s:8:\"personal\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,42,146,149,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',151,'entity.contact_form.delete_form.personal','entity.contact_form.edit_form.personal','entity.contact_form.delete_form','contact_form=personal','a:1:{s:12:\"contact_form\";s:8:\"personal\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,42,146,151,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',152,'contact.form_add','entity.contact_form.collection','contact.form_add','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-5,'a:0:{}',0,4,1,3,42,152,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',153,'field_ui.entity_view_mode_add','entity.entity_view_mode.collection','field_ui.entity_view_mode_add','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Add new view mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,47,48,153,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',154,'field_ui.entity_form_mode_add','entity.entity_form_mode.collection','field_ui.entity_form_mode_add','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Add new form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,47,49,154,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',155,'entity.menu.add_form','entity.menu.collection','entity.menu.add_form','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Add menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-50,'a:0:{}',0,4,1,3,54,155,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',156,'entity.menu.edit_form.admin','entity.menu.collection','entity.menu.edit_form','menu=admin','a:1:{s:4:\"menu\";s:5:\"admin\";}','','s:14:\"Administration\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,54,156,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',157,'entity.menu.delete_form.admin','entity.menu.edit_form.admin','entity.menu.delete_form','menu=admin','a:1:{s:4:\"menu\";s:5:\"admin\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,156,157,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',159,'entity.menu.add_link_form.admin','entity.menu.edit_form.admin','entity.menu.add_link_form','menu=admin','a:1:{s:4:\"menu\";s:5:\"admin\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Add link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,156,159,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',164,'entity.menu.edit_form.footer','entity.menu.collection','entity.menu.edit_form','menu=footer','a:1:{s:4:\"menu\";s:6:\"footer\";}','','s:6:\"Footer\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,54,164,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',165,'entity.menu.delete_form.footer','entity.menu.edit_form.footer','entity.menu.delete_form','menu=footer','a:1:{s:4:\"menu\";s:6:\"footer\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,164,165,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',167,'entity.menu.add_link_form.footer','entity.menu.edit_form.footer','entity.menu.add_link_form','menu=footer','a:1:{s:4:\"menu\";s:6:\"footer\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Add link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,164,167,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',168,'entity.menu.edit_form.main','entity.menu.collection','entity.menu.edit_form','menu=main','a:1:{s:4:\"menu\";s:4:\"main\";}','','s:15:\"Main navigation\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,54,168,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',169,'entity.menu.delete_form.main','entity.menu.edit_form.main','entity.menu.delete_form','menu=main','a:1:{s:4:\"menu\";s:4:\"main\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,168,169,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',171,'entity.menu.add_link_form.main','entity.menu.edit_form.main','entity.menu.add_link_form','menu=main','a:1:{s:4:\"menu\";s:4:\"main\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Add link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,168,171,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',172,'entity.menu.edit_form.tools','entity.menu.collection','entity.menu.edit_form','menu=tools','a:1:{s:4:\"menu\";s:5:\"tools\";}','','s:5:\"Tools\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,54,172,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',173,'entity.menu.delete_form.tools','entity.menu.edit_form.tools','entity.menu.delete_form','menu=tools','a:1:{s:4:\"menu\";s:5:\"tools\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,172,173,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',175,'entity.menu.add_link_form.tools','entity.menu.edit_form.tools','entity.menu.add_link_form','menu=tools','a:1:{s:4:\"menu\";s:5:\"tools\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Add link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,172,175,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',176,'entity.menu.edit_form.account','entity.menu.collection','entity.menu.edit_form','menu=account','a:1:{s:4:\"menu\";s:7:\"account\";}','','s:17:\"User account menu\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,54,176,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',177,'entity.menu.delete_form.account','entity.menu.edit_form.account','entity.menu.delete_form','menu=account','a:1:{s:4:\"menu\";s:7:\"account\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,176,177,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',179,'entity.menu.add_link_form.account','entity.menu.edit_form.account','entity.menu.add_link_form','menu=account','a:1:{s:4:\"menu\";s:7:\"account\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Add link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,176,179,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',180,'entity.node_type.edit_form.article','entity.node_type.collection','entity.node_type.edit_form','node_type=article','a:1:{s:9:\"node_type\";s:7:\"article\";}','','s:7:\"Article\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,38,180,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',181,'entity.node.field_ui_fieldsarticle','entity.node_type.edit_form.article','entity.node.field_ui_fields','node_type=article','a:1:{s:9:\"node_type\";s:7:\"article\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,38,180,181,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',182,'entity.entity_form_display.node.defaultarticle','entity.node_type.edit_form.article','entity.entity_form_display.node.default','node_type=article','a:1:{s:9:\"node_type\";s:7:\"article\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,38,180,182,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',183,'entity.entity_view_display.node.default.article','entity.node_type.edit_form.article','entity.entity_view_display.node.default','node_type=article','a:1:{s:9:\"node_type\";s:7:\"article\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,38,180,183,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',185,'entity.node_type.delete_form.article','entity.node_type.edit_form.article','entity.node_type.delete_form','node_type=article','a:1:{s:9:\"node_type\";s:7:\"article\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,38,180,185,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',186,'entity.node_type.edit_form.nd_blog','entity.node_type.collection','entity.node_type.edit_form','node_type=nd_blog','a:1:{s:9:\"node_type\";s:7:\"nd_blog\";}','','s:4:\"Blog\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,38,186,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',187,'entity.node.field_ui_fieldsnd_blog','entity.node_type.edit_form.nd_blog','entity.node.field_ui_fields','node_type=nd_blog','a:1:{s:9:\"node_type\";s:7:\"nd_blog\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,38,186,187,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',188,'entity.entity_form_display.node.defaultnd_blog','entity.node_type.edit_form.nd_blog','entity.entity_form_display.node.default','node_type=nd_blog','a:1:{s:9:\"node_type\";s:7:\"nd_blog\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,38,186,188,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',189,'entity.entity_view_display.node.default.nd_blog','entity.node_type.edit_form.nd_blog','entity.entity_view_display.node.default','node_type=nd_blog','a:1:{s:9:\"node_type\";s:7:\"nd_blog\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,38,186,189,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',191,'entity.node_type.delete_form.nd_blog','entity.node_type.edit_form.nd_blog','entity.node_type.delete_form','node_type=nd_blog','a:1:{s:9:\"node_type\";s:7:\"nd_blog\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,38,186,191,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',192,'entity.node_type.edit_form.page','entity.node_type.collection','entity.node_type.edit_form','node_type=page','a:1:{s:9:\"node_type\";s:4:\"page\";}','','s:10:\"Basic page\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,38,192,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',193,'entity.node.field_ui_fieldspage','entity.node_type.edit_form.page','entity.node.field_ui_fields','node_type=page','a:1:{s:9:\"node_type\";s:4:\"page\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,38,192,193,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',194,'entity.entity_form_display.node.defaultpage','entity.node_type.edit_form.page','entity.entity_form_display.node.default','node_type=page','a:1:{s:9:\"node_type\";s:4:\"page\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,38,192,194,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',195,'entity.entity_view_display.node.default.page','entity.node_type.edit_form.page','entity.entity_view_display.node.default','node_type=page','a:1:{s:9:\"node_type\";s:4:\"page\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,38,192,195,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',197,'entity.node_type.delete_form.page','entity.node_type.edit_form.page','entity.node_type.delete_form','node_type=page','a:1:{s:9:\"node_type\";s:4:\"page\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,38,192,197,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',198,'node.type_add','entity.node_type.collection','node.type_add','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-5,'a:0:{}',0,4,1,3,38,198,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',199,'entity.taxonomy_vocabulary.edit_form.blog_category','entity.taxonomy_vocabulary.overview_form.blog_category','entity.taxonomy_vocabulary.edit_form','taxonomy_vocabulary=blog_category','a:1:{s:19:\"taxonomy_vocabulary\";s:13:\"blog_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,51,478,199,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',200,'entity.taxonomy_term.field_ui_fieldsblog_category','entity.taxonomy_vocabulary.overview_form.blog_category','entity.taxonomy_term.field_ui_fields','taxonomy_vocabulary=blog_category','a:1:{s:19:\"taxonomy_vocabulary\";s:13:\"blog_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,51,478,200,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',201,'entity.entity_form_display.taxonomy_term.defaultblog_category','entity.taxonomy_vocabulary.overview_form.blog_category','entity.entity_form_display.taxonomy_term.default','taxonomy_vocabulary=blog_category','a:1:{s:19:\"taxonomy_vocabulary\";s:13:\"blog_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,51,478,201,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',202,'entity.entity_view_display.taxonomy_term.default.blog_category','entity.taxonomy_vocabulary.overview_form.blog_category','entity.entity_view_display.taxonomy_term.default','taxonomy_vocabulary=blog_category','a:1:{s:19:\"taxonomy_vocabulary\";s:13:\"blog_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,51,478,202,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',204,'entity.taxonomy_vocabulary.delete_form.blog_category','entity.taxonomy_vocabulary.overview_form.blog_category','entity.taxonomy_vocabulary.delete_form','taxonomy_vocabulary=blog_category','a:1:{s:19:\"taxonomy_vocabulary\";s:13:\"blog_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,51,478,204,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',205,'entity.taxonomy_vocabulary.edit_form.tags','entity.taxonomy_vocabulary.overview_form.tags','entity.taxonomy_vocabulary.edit_form','taxonomy_vocabulary=tags','a:1:{s:19:\"taxonomy_vocabulary\";s:4:\"tags\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,51,483,205,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',206,'entity.taxonomy_term.field_ui_fieldstags','entity.taxonomy_vocabulary.overview_form.tags','entity.taxonomy_term.field_ui_fields','taxonomy_vocabulary=tags','a:1:{s:19:\"taxonomy_vocabulary\";s:4:\"tags\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,51,483,206,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',207,'entity.entity_form_display.taxonomy_term.defaulttags','entity.taxonomy_vocabulary.overview_form.tags','entity.entity_form_display.taxonomy_term.default','taxonomy_vocabulary=tags','a:1:{s:19:\"taxonomy_vocabulary\";s:4:\"tags\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,51,483,207,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',208,'entity.entity_view_display.taxonomy_term.default.tags','entity.taxonomy_vocabulary.overview_form.tags','entity.entity_view_display.taxonomy_term.default','taxonomy_vocabulary=tags','a:1:{s:19:\"taxonomy_vocabulary\";s:4:\"tags\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,51,483,208,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',210,'entity.taxonomy_vocabulary.delete_form.tags','entity.taxonomy_vocabulary.overview_form.tags','entity.taxonomy_vocabulary.delete_form','taxonomy_vocabulary=tags','a:1:{s:19:\"taxonomy_vocabulary\";s:4:\"tags\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,51,483,210,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',211,'entity.taxonomy_vocabulary.add_form','entity.taxonomy_vocabulary.collection','entity.taxonomy_vocabulary.add_form','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Add vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-5,'a:0:{}',0,4,1,3,51,211,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',215,'system.theme_settings_theme.seven','','system.theme_settings_theme','theme=seven','a:1:{s:5:\"theme\";s:5:\"seven\";}','','s:5:\"Seven\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,1,215,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',216,'update.theme_install_','system.themes_page','update.theme_install','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Install new theme\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,3,1,4,216,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',217,'update.theme_update_','system.themes_page','update.theme_update','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,3,1,4,217,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',218,'system.modules_uninstall','system.modules_list','system.modules_uninstall','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Uninstall module\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,3,1,5,218,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',219,'update.module_update','system.modules_list','update.module_update','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,3,1,5,219,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',220,'update.module_install','system.modules_list','update.module_install','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Install new module\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,3,1,5,220,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',221,'entity.user.field_ui_fields_','entity.user.admin_form','entity.user.field_ui_fields','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,6,28,29,221,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',222,'entity.entity_form_display.user.default_','entity.user.admin_form','entity.entity_form_display.user.default','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,6,28,29,222,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',223,'entity.entity_view_display.user.default_','entity.user.admin_form','entity.entity_view_display.user.default','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,6,28,29,223,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',224,'user.admin_create','entity.user.collection','user.admin_create','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Add a new user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,3,1,30,224,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',225,'user.admin_permissions','entity.user.collection','user.admin_permissions','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Permissions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,3,1,30,225,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',226,'entity.user_role.collection','entity.user.collection','entity.user_role.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Roles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,3,1,30,226,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',227,'user.role_add','entity.user_role.collection','user.role_add','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Add a new role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-5,'a:0:{}',0,4,1,30,226,227,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',228,'entity.user_role.edit_form.anonymous','entity.user_role.collection','entity.user_role.edit_form','user_role=anonymous','a:1:{s:9:\"user_role\";s:9:\"anonymous\";}','','s:14:\"Anonymous user\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,30,226,228,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',229,'entity.user_role.edit_permissions_form.anonymous','entity.user_role.edit_form.anonymous','entity.user_role.edit_permissions_form','user_role=anonymous','a:1:{s:9:\"user_role\";s:9:\"anonymous\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Edit permissions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,30,226,228,229,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',230,'entity.user_role.delete_form.anonymous','entity.user_role.edit_form.anonymous','entity.user_role.delete_form','user_role=anonymous','a:1:{s:9:\"user_role\";s:9:\"anonymous\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,30,226,228,230,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',232,'entity.user_role.edit_form.authenticated','entity.user_role.collection','entity.user_role.edit_form','user_role=authenticated','a:1:{s:9:\"user_role\";s:13:\"authenticated\";}','','s:18:\"Authenticated user\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,30,226,232,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',233,'entity.user_role.edit_permissions_form.authenticated','entity.user_role.edit_form.authenticated','entity.user_role.edit_permissions_form','user_role=authenticated','a:1:{s:9:\"user_role\";s:13:\"authenticated\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Edit permissions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,30,226,232,233,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',234,'entity.user_role.delete_form.authenticated','entity.user_role.edit_form.authenticated','entity.user_role.delete_form','user_role=authenticated','a:1:{s:9:\"user_role\";s:13:\"authenticated\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,30,226,232,234,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',236,'entity.user_role.edit_form.administrator','entity.user_role.collection','entity.user_role.edit_form','user_role=administrator','a:1:{s:9:\"user_role\";s:13:\"administrator\";}','','s:13:\"Administrator\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,30,226,236,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',237,'entity.user_role.edit_permissions_form.administrator','entity.user_role.edit_form.administrator','entity.user_role.edit_permissions_form','user_role=administrator','a:1:{s:9:\"user_role\";s:13:\"administrator\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Edit permissions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,30,226,236,237,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',238,'entity.user_role.delete_form.administrator','entity.user_role.edit_form.administrator','entity.user_role.delete_form','user_role=administrator','a:1:{s:9:\"user_role\";s:13:\"administrator\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,30,226,236,238,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',240,'system.theme_settings_theme.rhythm','','system.theme_settings_theme','theme=rhythm','a:1:{s:5:\"theme\";s:6:\"rhythm\";}','','s:6:\"Rhythm\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,1,240,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',241,'views_view:views.blog_grid.page_1','menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c','view.blog_grid.page_1','','a:0:{}','','s:9:\"2 Columns\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,-50,'a:2:{s:7:\"view_id\";s:9:\"blog_grid\";s:10:\"display_id\";s:6:\"page_1\";}',0,3,243,245,241,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',242,'views_view:views.blog_fullwidth.page_1','menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc','view.blog_fullwidth.page_1','','a:0:{}','','s:14:\"Blog Fullwidth\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,-49,'a:2:{s:7:\"view_id\";s:14:\"blog_fullwidth\";s:10:\"display_id\";s:6:\"page_1\";}',0,2,243,242,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',243,'menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc','','view.blog_fullwidth.page_1','','a:0:{}','','s:4:\"Blog\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-46,'a:1:{s:9:\"entity_id\";s:1:\"1\";}',1,1,243,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',244,'menu_link_content:5cdb5b2b-389c-47b0-8140-19bcaee5eb6b','menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc','view.blog_fullwidth.page_1','','a:0:{}','','s:7:\"Classic\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-50,'a:1:{s:9:\"entity_id\";s:1:\"2\";}',0,2,243,244,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',245,'menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c','menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc','view.blog_grid.page_1','','a:0:{}','','s:9:\"Blog Grid\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-48,'a:1:{s:9:\"entity_id\";s:1:\"3\";}',1,2,243,245,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',246,'views_view:views.blog_grid.page_2','menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c','view.blog_grid.page_2','','a:0:{}','','s:9:\"3 Columns\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,-49,'a:2:{s:7:\"view_id\";s:9:\"blog_grid\";s:10:\"display_id\";s:6:\"page_2\";}',0,3,243,245,246,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',247,'views_view:views.blog_grid.page_3','menu_link_content:29958b9c-166f-47a0-ad23-1a1934a31d4c','view.blog_grid.page_3','','a:0:{}','','s:9:\"4 Columns\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,-48,'a:2:{s:7:\"view_id\";s:9:\"blog_grid\";s:10:\"display_id\";s:6:\"page_3\";}',0,3,243,245,247,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',248,'views_view:views.blog_masonry.page_1','menu_link_content:ac9a45ab-a3e4-4771-9d12-016c19b8cd87','view.blog_masonry.page_1','','a:0:{}','','s:9:\"2 Columns\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,-50,'a:2:{s:7:\"view_id\";s:12:\"blog_masonry\";s:10:\"display_id\";s:6:\"page_1\";}',0,3,243,251,248,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',249,'views_view:views.blog_masonry.page_2','menu_link_content:ac9a45ab-a3e4-4771-9d12-016c19b8cd87','view.blog_masonry.page_2','','a:0:{}','','s:9:\"3 Columns\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,-49,'a:2:{s:7:\"view_id\";s:12:\"blog_masonry\";s:10:\"display_id\";s:6:\"page_2\";}',0,3,243,251,249,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',250,'views_view:views.blog_masonry.page_3','menu_link_content:ac9a45ab-a3e4-4771-9d12-016c19b8cd87','view.blog_masonry.page_3','','a:0:{}','','s:9:\"4 Columns\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,-48,'a:2:{s:7:\"view_id\";s:12:\"blog_masonry\";s:10:\"display_id\";s:6:\"page_3\";}',0,3,243,251,250,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',251,'menu_link_content:ac9a45ab-a3e4-4771-9d12-016c19b8cd87','menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc','view.blog_masonry.page_1','','a:0:{}','','s:12:\"Blog Masonry\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-47,'a:1:{s:9:\"entity_id\";s:1:\"4\";}',1,2,243,251,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',256,'menu_link_content:92dae41b-bd24-4890-b442-1c209567d7ff','menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc','entity.node.canonical','node=6','a:1:{s:4:\"node\";s:1:\"6\";}','','s:7:\"Single \";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-46,'a:1:{s:9:\"entity_id\";s:1:\"5\";}',1,2,243,256,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',257,'menu_link_content:961ccfdb-fc32-416f-b479-33645b457808','menu_link_content:92dae41b-bd24-4890-b442-1c209567d7ff','entity.node.canonical','node=6','a:1:{s:4:\"node\";s:1:\"6\";}','','s:9:\"FullWidth\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,-50,'a:1:{s:9:\"entity_id\";s:1:\"6\";}',0,3,243,256,257,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',258,'node.add.nd_portfolio','admin_toolbar_tools.add_content','node.add','node_type=nd_portfolio','a:1:{s:9:\"node_type\";s:12:\"nd_portfolio\";}','','s:9:\"Portfolio\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,2,649,258,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',259,'entity.node_type.edit_form.nd_portfolio','entity.node_type.collection','entity.node_type.edit_form','node_type=nd_portfolio','a:1:{s:9:\"node_type\";s:12:\"nd_portfolio\";}','','s:9:\"Portfolio\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,38,259,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',260,'entity.node.field_ui_fieldsnd_portfolio','entity.node_type.edit_form.nd_portfolio','entity.node.field_ui_fields','node_type=nd_portfolio','a:1:{s:9:\"node_type\";s:12:\"nd_portfolio\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,38,259,260,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',261,'entity.entity_form_display.node.defaultnd_portfolio','entity.node_type.edit_form.nd_portfolio','entity.entity_form_display.node.default','node_type=nd_portfolio','a:1:{s:9:\"node_type\";s:12:\"nd_portfolio\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,38,259,261,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',262,'entity.entity_view_display.node.default.nd_portfolio','entity.node_type.edit_form.nd_portfolio','entity.entity_view_display.node.default','node_type=nd_portfolio','a:1:{s:9:\"node_type\";s:12:\"nd_portfolio\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,38,259,262,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',264,'entity.node_type.delete_form.nd_portfolio','entity.node_type.edit_form.nd_portfolio','entity.node_type.delete_form','node_type=nd_portfolio','a:1:{s:9:\"node_type\";s:12:\"nd_portfolio\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,38,259,264,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',265,'entity.taxonomy_vocabulary.edit_form.project','entity.taxonomy_vocabulary.overview_form.project','entity.taxonomy_vocabulary.edit_form','taxonomy_vocabulary=project','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"project\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,51,482,265,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',266,'entity.taxonomy_term.field_ui_fieldsproject','entity.taxonomy_vocabulary.overview_form.project','entity.taxonomy_term.field_ui_fields','taxonomy_vocabulary=project','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"project\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,51,482,266,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',267,'entity.entity_form_display.taxonomy_term.defaultproject','entity.taxonomy_vocabulary.overview_form.project','entity.entity_form_display.taxonomy_term.default','taxonomy_vocabulary=project','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"project\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,51,482,267,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',268,'entity.entity_view_display.taxonomy_term.default.project','entity.taxonomy_vocabulary.overview_form.project','entity.entity_view_display.taxonomy_term.default','taxonomy_vocabulary=project','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"project\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,51,482,268,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',270,'entity.taxonomy_vocabulary.delete_form.project','entity.taxonomy_vocabulary.overview_form.project','entity.taxonomy_vocabulary.delete_form','taxonomy_vocabulary=project','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"project\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,51,482,270,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',271,'entity.taxonomy_vocabulary.edit_form.portfolio_category','entity.taxonomy_vocabulary.overview_form.portfolio_category','entity.taxonomy_vocabulary.edit_form','taxonomy_vocabulary=portfolio_category','a:1:{s:19:\"taxonomy_vocabulary\";s:18:\"portfolio_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,51,481,271,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',272,'entity.taxonomy_term.field_ui_fieldsportfolio_category','entity.taxonomy_vocabulary.overview_form.portfolio_category','entity.taxonomy_term.field_ui_fields','taxonomy_vocabulary=portfolio_category','a:1:{s:19:\"taxonomy_vocabulary\";s:18:\"portfolio_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,51,481,272,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',273,'entity.entity_form_display.taxonomy_term.defaultportfolio_category','entity.taxonomy_vocabulary.overview_form.portfolio_category','entity.entity_form_display.taxonomy_term.default','taxonomy_vocabulary=portfolio_category','a:1:{s:19:\"taxonomy_vocabulary\";s:18:\"portfolio_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,51,481,273,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',274,'entity.entity_view_display.taxonomy_term.default.portfolio_category','entity.taxonomy_vocabulary.overview_form.portfolio_category','entity.entity_view_display.taxonomy_term.default','taxonomy_vocabulary=portfolio_category','a:1:{s:19:\"taxonomy_vocabulary\";s:18:\"portfolio_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,51,481,274,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',276,'entity.taxonomy_vocabulary.delete_form.portfolio_category','entity.taxonomy_vocabulary.overview_form.portfolio_category','entity.taxonomy_vocabulary.delete_form','taxonomy_vocabulary=portfolio_category','a:1:{s:19:\"taxonomy_vocabulary\";s:18:\"portfolio_category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,51,481,276,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',277,'entity.taxonomy_vocabulary.edit_form.category','entity.taxonomy_vocabulary.overview_form.category','entity.taxonomy_vocabulary.edit_form','taxonomy_vocabulary=category','a:1:{s:19:\"taxonomy_vocabulary\";s:8:\"category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,51,479,277,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',278,'entity.taxonomy_term.field_ui_fieldscategory','entity.taxonomy_vocabulary.overview_form.category','entity.taxonomy_term.field_ui_fields','taxonomy_vocabulary=category','a:1:{s:19:\"taxonomy_vocabulary\";s:8:\"category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,51,479,278,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',279,'entity.entity_form_display.taxonomy_term.defaultcategory','entity.taxonomy_vocabulary.overview_form.category','entity.entity_form_display.taxonomy_term.default','taxonomy_vocabulary=category','a:1:{s:19:\"taxonomy_vocabulary\";s:8:\"category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,51,479,279,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',280,'entity.entity_view_display.taxonomy_term.default.category','entity.taxonomy_vocabulary.overview_form.category','entity.entity_view_display.taxonomy_term.default','taxonomy_vocabulary=category','a:1:{s:19:\"taxonomy_vocabulary\";s:8:\"category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,51,479,280,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',282,'entity.taxonomy_vocabulary.delete_form.category','entity.taxonomy_vocabulary.overview_form.category','entity.taxonomy_vocabulary.delete_form','taxonomy_vocabulary=category','a:1:{s:19:\"taxonomy_vocabulary\";s:8:\"category\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,51,479,282,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',284,'menu_link_content:a3ee399f-9674-40b8-a77b-af91a5415b33','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=34','a:1:{s:4:\"node\";s:2:\"34\";}','','s:10:\"Accordions\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-50,'a:1:{s:9:\"entity_id\";s:1:\"7\";}',0,2,303,284,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',285,'menu_link_content:ffbafeb5-13ce-4a9e-aebb-517a82b75abf','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=35','a:1:{s:4:\"node\";s:2:\"35\";}','','s:14:\"Bar (Progress)\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-49,'a:1:{s:9:\"entity_id\";s:1:\"8\";}',0,2,303,285,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',286,'menu_link_content:be27f22d-c5ff-4994-92d5-a3185bc2c43e','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=36','a:1:{s:4:\"node\";s:2:\"36\";}','','s:7:\"Buttons\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-48,'a:1:{s:9:\"entity_id\";s:1:\"9\";}',0,2,303,286,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',287,'menu_link_content:bf32227d-9747-40a2-92f2-76f9a59cac2d','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=37','a:1:{s:4:\"node\";s:2:\"37\";}','','s:12:\"Features Box\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-47,'a:1:{s:9:\"entity_id\";s:2:\"10\";}',0,2,303,287,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',288,'menu_link_content:fdde11a8-2a92-4936-91e9-4b802ab31b5b','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=38','a:1:{s:4:\"node\";s:2:\"38\";}','','s:4:\"Grid\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-46,'a:1:{s:9:\"entity_id\";s:2:\"11\";}',0,2,303,288,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',289,'menu_link_content:0c8d517f-c88c-429b-808c-99be0d64142c','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=39','a:1:{s:4:\"node\";s:2:\"39\";}','','s:13:\"Icons Et-Line\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-45,'a:1:{s:9:\"entity_id\";s:2:\"12\";}',0,2,303,289,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',290,'menu_link_content:37367b13-a605-42e8-9472-0e5788a65542','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=40','a:1:{s:4:\"node\";s:2:\"40\";}','','s:18:\"Icons Font Awesome\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-44,'a:1:{s:9:\"entity_id\";s:2:\"13\";}',0,2,303,290,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',291,'menu_link_content:46d6164c-bf4c-4e3b-8a63-f3a0bb29becb','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=41','a:1:{s:4:\"node\";s:2:\"41\";}','','s:8:\"Messages\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-43,'a:1:{s:9:\"entity_id\";s:2:\"14\";}',0,2,303,291,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',292,'menu_link_content:59c760df-faa4-4c04-a71d-6ebed8addc3b','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=42','a:1:{s:4:\"node\";s:2:\"42\";}','','s:11:\"Page Titles\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-42,'a:1:{s:9:\"entity_id\";s:2:\"15\";}',0,2,303,292,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',293,'menu_link_content:9300ca4c-bce1-4990-8f18-f2e888c2fb04','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=43','a:1:{s:4:\"node\";s:2:\"43\";}','','s:7:\"Sliders\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-41,'a:1:{s:9:\"entity_id\";s:2:\"16\";}',0,2,303,293,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',294,'menu_link_content:36321b57-7fe6-4eac-a535-bfdbfb32f86f','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=44','a:1:{s:4:\"node\";s:2:\"44\";}','','s:4:\"Tabs\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-40,'a:1:{s:9:\"entity_id\";s:2:\"17\";}',0,2,303,294,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',295,'menu_link_content:1d8b7d03-1fbd-47d7-ac61-14b66ae230cc','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=45','a:1:{s:4:\"node\";s:2:\"45\";}','','s:10:\"Typography\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-39,'a:1:{s:9:\"entity_id\";s:2:\"18\";}',0,2,303,295,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',296,'menu_link_content:40656ee6-77d0-4bdc-8d5b-89bfb1846fd7','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=46','a:1:{s:4:\"node\";s:2:\"46\";}','','s:13:\"Video & Sound\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-38,'a:1:{s:9:\"entity_id\";s:2:\"19\";}',0,2,303,296,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',297,'menu_link_content:bbdf5868-dc3c-4d40-bf02-ed5a98de6baa','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=47','a:1:{s:4:\"node\";s:2:\"47\";}','','s:11:\"Header Dark\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-35,'a:1:{s:9:\"entity_id\";s:2:\"20\";}',0,2,303,297,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',299,'menu_link_content:2dd67deb-b273-48e1-897e-3c0bcbcf5718','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=48','a:1:{s:4:\"node\";s:2:\"48\";}','','s:23:\"Header Dark Transparent\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-37,'a:1:{s:9:\"entity_id\";s:2:\"22\";}',0,2,303,299,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',300,'menu_link_content:32567f5e-6902-41e1-87a2-140840992d0f','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=49','a:1:{s:4:\"node\";s:2:\"49\";}','','s:9:\"Pricing 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,15,'a:1:{s:9:\"entity_id\";s:2:\"23\";}',0,2,305,300,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',301,'menu_link_content:c065ff63-c661-41e5-afdc-f27d0815c3b0','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=50','a:1:{s:4:\"node\";s:2:\"50\";}','','s:9:\"Pricing 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,16,'a:1:{s:9:\"entity_id\";s:2:\"24\";}',0,2,305,301,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',303,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','','entity.node.canonical','node=34','a:1:{s:4:\"node\";s:2:\"34\";}','','s:8:\"Elements\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-48,'a:1:{s:9:\"entity_id\";s:2:\"26\";}',1,1,303,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',304,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','','view.portfolio_boxed.page_1','','a:0:{}','','s:9:\"Portfolio\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-47,'a:1:{s:9:\"entity_id\";s:2:\"27\";}',1,1,304,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',305,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','','entity.node.canonical','node=49','a:1:{s:4:\"node\";s:2:\"49\";}','','s:5:\"Pages\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-49,'a:1:{s:9:\"entity_id\";s:2:\"28\";}',1,1,305,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',306,'menu_link_content:bf270903-a251-43ce-b89c-526df226d233','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=54','a:1:{s:4:\"node\";s:2:\"54\";}','','s:12:\"Header White\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-34,'a:1:{s:9:\"entity_id\";s:2:\"29\";}',0,2,303,306,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',307,'menu_link_content:bde03df4-5838-4fea-bb45-0a5ba212e6e7','menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66','entity.node.canonical','node=55','a:1:{s:4:\"node\";s:2:\"55\";}','','s:24:\"Header White Transparent\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-36,'a:1:{s:9:\"entity_id\";s:2:\"30\";}',0,2,303,307,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',308,'entity.configurable_language.collection','system.admin_config_regional','entity.configurable_language.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Languages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"Configure languages for content, interface, and configuration.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','language',1,1,0,0,'a:0:{}',1,4,1,6,16,308,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',309,'language.content_settings_page','system.admin_config_regional','language.content_settings_page','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Content language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Configure language support for content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','language',1,1,0,10,'a:0:{}',0,4,1,6,16,309,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',310,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','view.portfolio_boxed.page_1','','a:0:{}','','s:5:\"Boxed\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-73,'a:1:{s:9:\"entity_id\";s:2:\"31\";}',1,2,304,310,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',315,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','view.portfolio_boxed.page_5','','a:0:{}','','s:14:\"Boxed (Gutter)\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-72,'a:1:{s:9:\"entity_id\";s:2:\"32\";}',1,2,304,315,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',322,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','view.portfolio_boxed.page_11','','a:0:{}','','s:14:\"Boxed (Titles)\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-71,'a:1:{s:9:\"entity_id\";s:2:\"33\";}',1,2,304,322,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',332,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','view.portfolio_boxed.page_16','','a:0:{}','','s:4:\"Wide\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-70,'a:1:{s:9:\"entity_id\";s:2:\"34\";}',1,2,304,332,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',338,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','view.portfolio_boxed.page_21','','a:0:{}','','s:13:\"Wide (Gutter)\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-69,'a:1:{s:9:\"entity_id\";s:2:\"35\";}',1,2,304,338,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',344,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','view.portfolio_boxed.page_26','','a:0:{}','','s:13:\"Wide (Titles)\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,-68,'a:1:{s:9:\"entity_id\";s:2:\"36\";}',1,2,304,344,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',346,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','view.portfolio_boxed.page_31','','a:0:{}','','s:7:\"Masonry\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,1,0,'a:1:{s:9:\"entity_id\";s:2:\"37\";}',1,2,304,346,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',351,'views_view:views.portfolio_parallax.page_1','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','view.portfolio_parallax.page_1','','a:0:{}','','s:18:\"Portfolio Parallax\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,0,'a:2:{s:7:\"view_id\";s:18:\"portfolio_parallax\";s:10:\"display_id\";s:6:\"page_1\";}',0,2,304,351,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',352,'views_view:views.portfolio_promo.page_1','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','view.portfolio_promo.page_1','','a:0:{}','','s:15:\"Portfolio Promo\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,0,'a:2:{s:7:\"view_id\";s:15:\"portfolio_promo\";s:10:\"display_id\";s:6:\"page_1\";}',0,2,304,352,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',353,'menu_link_content:314f69c9-6761-46c8-8f7f-eba5ba26b421','menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc','entity.node.canonical','node=16','a:1:{s:4:\"node\";s:2:\"16\";}','','s:14:\"Single Project\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,0,'a:1:{s:9:\"entity_id\";s:2:\"38\";}',0,2,304,353,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',354,'node.add.nd_person','admin_toolbar_tools.add_content','node.add','node_type=nd_person','a:1:{s:9:\"node_type\";s:9:\"nd_person\";}','','s:6:\"Person\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,2,649,354,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',355,'entity.node_type.edit_form.nd_person','entity.node_type.collection','entity.node_type.edit_form','node_type=nd_person','a:1:{s:9:\"node_type\";s:9:\"nd_person\";}','','s:6:\"Person\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,38,355,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',356,'entity.node.field_ui_fieldsnd_person','entity.node_type.edit_form.nd_person','entity.node.field_ui_fields','node_type=nd_person','a:1:{s:9:\"node_type\";s:9:\"nd_person\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,38,355,356,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',357,'entity.entity_form_display.node.defaultnd_person','entity.node_type.edit_form.nd_person','entity.entity_form_display.node.default','node_type=nd_person','a:1:{s:9:\"node_type\";s:9:\"nd_person\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,38,355,357,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',358,'entity.entity_view_display.node.default.nd_person','entity.node_type.edit_form.nd_person','entity.entity_view_display.node.default','node_type=nd_person','a:1:{s:9:\"node_type\";s:9:\"nd_person\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,38,355,358,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',360,'entity.node_type.delete_form.nd_person','entity.node_type.edit_form.nd_person','entity.node_type.delete_form','node_type=nd_person','a:1:{s:9:\"node_type\";s:9:\"nd_person\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,38,355,360,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',361,'menu_link_content:7a67997c-7b80-46b1-820b-a1b9c57535e5','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=61','a:1:{s:4:\"node\";s:2:\"61\";}','','s:6:\"Team 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,11,'a:1:{s:9:\"entity_id\";s:2:\"39\";}',0,2,305,361,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',362,'menu_link_content:4adcc82e-4225-4b54-ae75-1874f637e3d6','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=62','a:1:{s:4:\"node\";s:2:\"62\";}','','s:6:\"Team 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,12,'a:1:{s:9:\"entity_id\";s:2:\"40\";}',0,2,305,362,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',363,'menu_link_content:733a539d-3c2a-45fd-a73b-bb5063207240','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=63','a:1:{s:4:\"node\";s:2:\"63\";}','','s:10:\"About Us 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,3,'a:1:{s:9:\"entity_id\";s:2:\"41\";}',0,2,305,363,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',364,'menu_link_content:3d302ce2-fcbc-427c-b63e-7dd13fd3d705','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=64','a:1:{s:4:\"node\";s:2:\"64\";}','','s:10:\"About Us 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,4,'a:1:{s:9:\"entity_id\";s:2:\"42\";}',0,2,305,364,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',365,'menu_link_content:367c68ba-1ef2-4e41-bf74-7688e5904093','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=65','a:1:{s:4:\"node\";s:2:\"65\";}','','s:10:\"About Us 3\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,5,'a:1:{s:9:\"entity_id\";s:2:\"43\";}',0,2,305,365,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',366,'menu_link_content:e91489b9-2232-4827-8e2e-2668769f7665','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=66','a:1:{s:4:\"node\";s:2:\"66\";}','','s:10:\"Services 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,6,'a:1:{s:9:\"entity_id\";s:2:\"44\";}',0,2,305,366,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',367,'menu_link_content:71554a3f-b4c2-4cf1-acd0-f3e91727b086','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=67','a:1:{s:4:\"node\";s:2:\"67\";}','','s:10:\"Services 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,7,'a:1:{s:9:\"entity_id\";s:2:\"45\";}',0,2,305,367,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',368,'menu_link_content:34c07aab-b309-4699-b861-a6c292e165d2','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=68','a:1:{s:4:\"node\";s:2:\"68\";}','','s:10:\"Services 3\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,8,'a:1:{s:9:\"entity_id\";s:2:\"46\";}',0,2,305,368,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',369,'menu_link_content:c1470211-9873-446f-9797-6089dffdee4f','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=69','a:1:{s:4:\"node\";s:2:\"69\";}','','s:7:\"Clients\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,9,'a:1:{s:9:\"entity_id\";s:2:\"47\";}',0,2,305,369,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',370,'menu_link_content:c73021cd-900f-469b-9491-07e016d521aa','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=70','a:1:{s:4:\"node\";s:2:\"70\";}','','s:12:\"Landing Page\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,10,'a:1:{s:9:\"entity_id\";s:2:\"48\";}',0,2,305,370,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',371,'menu_link_content:86580bef-aa20-4a1b-a234-30eeb1f64b8d','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=71','a:1:{s:4:\"node\";s:2:\"71\";}','','s:5:\"FAQ 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,13,'a:1:{s:9:\"entity_id\";s:2:\"49\";}',0,2,305,371,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',372,'menu_link_content:b329caef-882c-4fb4-88d6-5c0e956c3230','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=72','a:1:{s:4:\"node\";s:2:\"72\";}','','s:5:\"FAQ 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,14,'a:1:{s:9:\"entity_id\";s:2:\"50\";}',0,2,305,372,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',373,'node.add.webform','admin_toolbar_tools.add_content','node.add','node_type=webform','a:1:{s:9:\"node_type\";s:7:\"webform\";}','','s:7:\"Webform\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,2,649,373,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',374,'entity.node_type.edit_form.webform','entity.node_type.collection','entity.node_type.edit_form','node_type=webform','a:1:{s:9:\"node_type\";s:7:\"webform\";}','','s:7:\"Webform\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,38,374,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',375,'entity.node.field_ui_fieldswebform','entity.node_type.edit_form.webform','entity.node.field_ui_fields','node_type=webform','a:1:{s:9:\"node_type\";s:7:\"webform\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,38,374,375,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',376,'entity.entity_form_display.node.defaultwebform','entity.node_type.edit_form.webform','entity.entity_form_display.node.default','node_type=webform','a:1:{s:9:\"node_type\";s:7:\"webform\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,38,374,376,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',377,'entity.entity_view_display.node.default.webform','entity.node_type.edit_form.webform','entity.entity_view_display.node.default','node_type=webform','a:1:{s:9:\"node_type\";s:7:\"webform\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,38,374,377,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',379,'entity.node_type.delete_form.webform','entity.node_type.edit_form.webform','entity.node_type.delete_form','node_type=webform','a:1:{s:9:\"node_type\";s:7:\"webform\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,38,374,379,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',380,'entity.webform.collection','system.admin_structure','entity.webform.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Webforms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Create webforms and manage submissions.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','webform',1,1,0,0,'a:0:{}',1,3,1,3,380,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',381,'menu_link_content:6d235af9-aa59-4a1f-86f4-f7cf95990571','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=74','a:1:{s:4:\"node\";s:2:\"74\";}','','s:9:\"Contact 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,17,'a:1:{s:9:\"entity_id\";s:2:\"51\";}',0,2,305,381,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',382,'menu_link_content:7ac5c97e-66e5-44ba-9701-3a4250b7b1d9','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=75','a:1:{s:4:\"node\";s:2:\"75\";}','','s:9:\"Contact 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,18,'a:1:{s:9:\"entity_id\";s:2:\"52\";}',0,2,305,382,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',383,'node.add.gallery_item','admin_toolbar_tools.add_content','node.add','node_type=gallery_item','a:1:{s:9:\"node_type\";s:12:\"gallery_item\";}','','s:12:\"Gallery Item\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,2,649,383,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',384,'entity.node_type.edit_form.gallery_item','entity.node_type.collection','entity.node_type.edit_form','node_type=gallery_item','a:1:{s:9:\"node_type\";s:12:\"gallery_item\";}','','s:12:\"Gallery Item\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,38,384,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',385,'entity.node.field_ui_fieldsgallery_item','entity.node_type.edit_form.gallery_item','entity.node.field_ui_fields','node_type=gallery_item','a:1:{s:9:\"node_type\";s:12:\"gallery_item\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,38,384,385,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',386,'entity.entity_form_display.node.defaultgallery_item','entity.node_type.edit_form.gallery_item','entity.entity_form_display.node.default','node_type=gallery_item','a:1:{s:9:\"node_type\";s:12:\"gallery_item\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,38,384,386,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',387,'entity.entity_view_display.node.default.gallery_item','entity.node_type.edit_form.gallery_item','entity.entity_view_display.node.default','node_type=gallery_item','a:1:{s:9:\"node_type\";s:12:\"gallery_item\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,38,384,387,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',389,'entity.node_type.delete_form.gallery_item','entity.node_type.edit_form.gallery_item','entity.node_type.delete_form','node_type=gallery_item','a:1:{s:9:\"node_type\";s:12:\"gallery_item\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,38,384,389,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',390,'entity.taxonomy_vocabulary.edit_form.gallery','entity.taxonomy_vocabulary.overview_form.gallery','entity.taxonomy_vocabulary.edit_form','taxonomy_vocabulary=gallery','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"gallery\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Edit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,51,480,390,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',391,'entity.taxonomy_term.field_ui_fieldsgallery','entity.taxonomy_vocabulary.overview_form.gallery','entity.taxonomy_term.field_ui_fields','taxonomy_vocabulary=gallery','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"gallery\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,51,480,391,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',392,'entity.entity_form_display.taxonomy_term.defaultgallery','entity.taxonomy_vocabulary.overview_form.gallery','entity.entity_form_display.taxonomy_term.default','taxonomy_vocabulary=gallery','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"gallery\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,51,480,392,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',393,'entity.entity_view_display.taxonomy_term.default.gallery','entity.taxonomy_vocabulary.overview_form.gallery','entity.entity_view_display.taxonomy_term.default','taxonomy_vocabulary=gallery','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"gallery\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,51,480,393,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',395,'entity.taxonomy_vocabulary.delete_form.gallery','entity.taxonomy_vocabulary.overview_form.gallery','entity.taxonomy_vocabulary.delete_form','taxonomy_vocabulary=gallery','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"gallery\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,51,480,395,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',396,'views_view:views.gallery.page_1','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','view.gallery.page_1','','a:0:{}','','s:13:\"Gallery Col 1\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,19,'a:2:{s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_1\";}',0,2,305,396,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',397,'views_view:views.gallery.page_2','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','view.gallery.page_2','','a:0:{}','','s:13:\"Gallery Col 2\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,20,'a:2:{s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_2\";}',0,2,305,397,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',398,'views_view:views.gallery.page_3','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','view.gallery.page_3','','a:0:{}','','s:13:\"Gallery Col 3\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,21,'a:2:{s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_3\";}',0,2,305,398,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',399,'views_view:views.gallery.page_4','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','view.gallery.page_4','','a:0:{}','','s:13:\"Gallery Col 4\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,22,'a:2:{s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_4\";}',0,2,305,399,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',400,'views_view:views.gallery.page_5','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','view.gallery.page_5','','a:0:{}','','s:13:\"Gallery Col 6\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,23,'a:2:{s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_5\";}',0,2,305,400,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',410,'menu_link_content:16141053-6ad4-4886-8a35-c406aac8e9e4','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=95','a:1:{s:4:\"node\";s:2:\"95\";}','','s:14:\"Page not found\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,27,'a:1:{s:9:\"entity_id\";s:2:\"62\";}',0,2,305,410,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',411,'menu_link_content:776125fa-b4d7-4344-bf41-1ea5892e91ef','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','entity.node.canonical','node=96','a:1:{s:4:\"node\";s:2:\"96\";}','','s:16:\"Maintenance Page\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,26,'a:1:{s:9:\"entity_id\";s:2:\"63\";}',0,2,305,411,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',412,'menu_link_content:d2a5e366-81b2-4334-84c8-31557554f0e1','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','user.page','','a:0:{}','','s:16:\"Login / Register\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,24,'a:1:{s:9:\"entity_id\";s:2:\"64\";}',0,2,305,412,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',413,'menu_link_content:f24ed196-0a8b-471e-95d8-177e20a9e9ba','standard.front_page','entity.node.canonical','node=97','a:1:{s:4:\"node\";s:2:\"97\";}','','s:9:\"Main Demo\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,26,'a:1:{s:9:\"entity_id\";s:2:\"65\";}',0,2,33,413,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',415,'nd_visualshortcodes.settings','system.admin_config_content','nd_visualshortcodes.settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Visual shortcodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Visual shortcodes settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','nd_visualshortcodes',1,1,0,0,'a:0:{}',0,4,1,6,25,415,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',416,'menu_link_content:a669b9ca-166c-45ba-8e77-1faad3feb3eb','standard.front_page','rhythm_cms_home','type=1','a:1:{s:4:\"type\";s:1:\"1\";}','','s:16:\"Image Parallax 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,27,'a:1:{s:9:\"entity_id\";s:2:\"66\";}',0,2,33,416,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',417,'menu_link_content:d9f4d184-1bcf-483a-ac64-9a287afa146b','standard.front_page','rhythm_cms_home','type=2','a:1:{s:4:\"type\";s:1:\"2\";}','','s:16:\"Image Parallax 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,28,'a:1:{s:9:\"entity_id\";s:2:\"67\";}',0,2,33,417,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',418,'menu_link_content:861d0785-e6ed-4109-969a-c8aa12644e81','standard.front_page','rhythm_cms_home','type=3','a:1:{s:4:\"type\";s:1:\"3\";}','','s:16:\"Image Parallax 3\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,29,'a:1:{s:9:\"entity_id\";s:2:\"68\";}',0,2,33,418,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',419,'menu_link_content:c4129e2d-44f0-4687-a510-ad45c568bce1','standard.front_page','rhythm_cms_home','type=4','a:1:{s:4:\"type\";s:1:\"4\";}','','s:16:\"Image Parallax 4\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,30,'a:1:{s:9:\"entity_id\";s:2:\"69\";}',0,2,33,419,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',420,'menu_link_content:d4d5b6bd-9b29-4eb5-9acf-f87af995214c','standard.front_page','rhythm_cms_home','type=5','a:1:{s:4:\"type\";s:1:\"5\";}','','s:16:\"Image Parallax 5\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,31,'a:1:{s:9:\"entity_id\";s:2:\"70\";}',0,2,33,420,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',421,'menu_link_content:691ba057-a9fe-4a02-9bc4-105aa7e3d5f4','standard.front_page','rhythm_cms_home','type=6','a:1:{s:4:\"type\";s:1:\"6\";}','','s:15:\"FullWidth Image\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,32,'a:1:{s:9:\"entity_id\";s:2:\"71\";}',0,2,33,421,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',423,'menu_link_content:fe3cc388-c8c1-4e13-91e2-c6d26d4f10e3','standard.front_page','rhythm_cms_home','type=7','a:1:{s:4:\"type\";s:1:\"7\";}','','s:12:\"Text Rotator\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,33,'a:1:{s:9:\"entity_id\";s:2:\"73\";}',0,2,33,423,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',424,'menu_link_content:9483d07a-5aa5-41a3-8ad6-456f80f78ac3','standard.front_page','rhythm_cms_home','type=8','a:1:{s:4:\"type\";s:1:\"8\";}','','s:17:\"Slider FullScreen\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,34,'a:1:{s:9:\"entity_id\";s:2:\"74\";}',0,2,33,424,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',425,'menu_link_content:506ee439-af38-47ef-a5e4-59c275e58937','standard.front_page','rhythm_cms_home','type=9','a:1:{s:4:\"type\";s:1:\"9\";}','','s:18:\"Slider Zoom Effect\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,35,'a:1:{s:9:\"entity_id\";s:2:\"75\";}',0,2,33,425,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',426,'menu_link_content:ce38002a-7dec-4a04-89f3-91f46b47858a','standard.front_page','rhythm_cms_home','type=10','a:1:{s:4:\"type\";s:2:\"10\";}','','s:16:\"Slider FullWidth\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,36,'a:1:{s:9:\"entity_id\";s:2:\"76\";}',0,2,33,426,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',427,'menu_link_content:48eb8cfb-67f8-44a4-b680-a154f132796c','standard.front_page','rhythm_cms_home','type=11','a:1:{s:4:\"type\";s:2:\"11\";}','','s:17:\"Slider Background\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,37,'a:1:{s:9:\"entity_id\";s:2:\"77\";}',0,2,33,427,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',428,'menu_link_content:d0a9cd75-588f-4e44-98a6-d3b4bfbd80b2','standard.front_page','rhythm_cms_home','type=12','a:1:{s:4:\"type\";s:2:\"12\";}','','s:16:\"With Play Button\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,38,'a:1:{s:9:\"entity_id\";s:2:\"78\";}',0,2,33,428,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',429,'menu_link_content:c74a5095-9a45-49ae-8da3-0be2e4717b32','standard.front_page','rhythm_cms_home','type=13','a:1:{s:4:\"type\";s:2:\"13\";}','','s:18:\"BG Video FullWidth\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,39,'a:1:{s:9:\"entity_id\";s:2:\"79\";}',0,2,33,429,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',430,'menu_link_content:4dc6c8de-d27e-484f-8968-01b208414702','standard.front_page','rhythm_cms_home','type=14','a:1:{s:4:\"type\";s:2:\"14\";}','','s:21:\"BG Video FullScreen 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,40,'a:1:{s:9:\"entity_id\";s:2:\"80\";}',0,2,33,430,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',431,'menu_link_content:ba223303-602f-4245-9b65-1c11d81c46f2','standard.front_page','rhythm_cms_home','type=15','a:1:{s:4:\"type\";s:2:\"15\";}','','s:21:\"BG Video FullScreen 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,41,'a:1:{s:9:\"entity_id\";s:2:\"81\";}',0,2,33,431,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',434,'menu_link_content:eb3345f8-d32e-449f-a28d-3384b6b4ac96','standard.front_page','rhythm_cms_home','type=16','a:1:{s:4:\"type\";s:2:\"16\";}','','s:13:\"Agency Header\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,42,'a:1:{s:9:\"entity_id\";s:2:\"84\";}',0,2,33,434,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',435,'menu_link_content:6b2a820d-9368-4a7f-8b42-465f88d3e1bb','standard.front_page','entity.node.canonical','node=101','a:1:{s:4:\"node\";s:3:\"101\";}','','s:32:\"Photography with fullscreen menu\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,43,'a:1:{s:9:\"entity_id\";s:2:\"85\";}',0,2,33,435,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('one-page',436,'menu_link_content:222834a3-6345-46a6-bebb-10e7a1a11a3b','','<none>','','a:0:{}','','s:4:\"Home\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:8:\"fragment\";s:4:\"home\";}','menu_link_content',1,1,0,-50,'a:1:{s:9:\"entity_id\";s:2:\"86\";}',0,1,436,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('one-page',437,'menu_link_content:236c28f7-a0d8-437d-bcd1-8b5adb13c8d1','','<none>','','a:0:{}','','s:5:\"About\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:8:\"fragment\";s:5:\"about\";}','menu_link_content',1,1,0,-49,'a:1:{s:9:\"entity_id\";s:2:\"87\";}',0,1,437,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('one-page',438,'menu_link_content:6cd87830-2d5d-42e6-bd6c-85af56f90c99','','<none>','','a:0:{}','','s:8:\"Services\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:8:\"fragment\";s:8:\"services\";}','menu_link_content',1,1,0,-48,'a:1:{s:9:\"entity_id\";s:2:\"88\";}',0,1,438,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('one-page',439,'menu_link_content:c287b16f-42a0-4a74-90ff-aacec6433bf0','','<none>','','a:0:{}','','s:9:\"Portfolio\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:8:\"fragment\";s:9:\"portfolio\";}','menu_link_content',1,1,0,-47,'a:1:{s:9:\"entity_id\";s:2:\"89\";}',0,1,439,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('one-page',440,'menu_link_content:610c8dac-92d7-4a5b-89fb-f3214b8c8a09','','<none>','','a:0:{}','','s:4:\"News\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:8:\"fragment\";s:4:\"news\";}','menu_link_content',1,1,0,-46,'a:1:{s:9:\"entity_id\";s:2:\"90\";}',0,1,440,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('one-page',441,'menu_link_content:f63d2556-8199-4e69-9967-d99e0d4591b4','','<none>','','a:0:{}','','s:8:\"Contacts\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:8:\"fragment\";s:8:\"contacts\";}','menu_link_content',1,1,0,-45,'a:1:{s:9:\"entity_id\";s:2:\"91\";}',0,1,441,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('one-page',443,'menu_link_content:491a5e02-691d-4f41-b6c2-e9513ae049ce','','<front>','','a:0:{}','','s:9:\"All Demos\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,1,0,-44,'a:1:{s:9:\"entity_id\";s:2:\"93\";}',0,1,443,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',444,'entity.menu.edit_form.one-page','entity.menu.collection','entity.menu.edit_form','menu=one-page','a:1:{s:4:\"menu\";s:8:\"one-page\";}','','s:8:\"One Page\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,54,444,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',445,'entity.menu.delete_form.one-page','entity.menu.edit_form.one-page','entity.menu.delete_form','menu=one-page','a:1:{s:4:\"menu\";s:8:\"one-page\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,444,445,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',447,'entity.menu.add_link_form.one-page','entity.menu.edit_form.one-page','entity.menu.add_link_form','menu=one-page','a:1:{s:4:\"menu\";s:8:\"one-page\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Add link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,3,54,444,447,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',448,'menu_link_content:ad36f87b-f542-454b-9685-2da56272071d','standard.front_page','rhythm_cms_onepage','type=0','a:1:{s:4:\"type\";s:1:\"0\";}','','s:9:\"Main Demo\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,44,'a:1:{s:9:\"entity_id\";s:2:\"94\";}',0,2,33,448,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',449,'menu_link_content:58547176-ac14-452d-9bab-fe6204fcd2ea','standard.front_page','rhythm_cms_onepage','type=1','a:1:{s:4:\"type\";s:1:\"1\";}','','s:16:\"Image Parallax 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,45,'a:1:{s:9:\"entity_id\";s:2:\"95\";}',0,2,33,449,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',450,'menu_link_content:c5f9385e-3b46-4f25-b2a0-1b22b4df4c2d','standard.front_page','rhythm_cms_onepage','type=2','a:1:{s:4:\"type\";s:1:\"2\";}','','s:16:\"Image Parallax 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,46,'a:1:{s:9:\"entity_id\";s:2:\"96\";}',0,2,33,450,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',451,'menu_link_content:d03a8906-685a-4fa6-b4bb-e753de92fff6','standard.front_page','rhythm_cms_onepage','type=3','a:1:{s:4:\"type\";s:1:\"3\";}','','s:16:\"Image Parallax 3\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,47,'a:1:{s:9:\"entity_id\";s:2:\"97\";}',0,2,33,451,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',452,'menu_link_content:76e447c9-6d4f-4814-8a67-83d92a294ba4','standard.front_page','rhythm_cms_onepage','type=4','a:1:{s:4:\"type\";s:1:\"4\";}','','s:16:\"Image Parallax 4\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,48,'a:1:{s:9:\"entity_id\";s:2:\"98\";}',0,2,33,452,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',453,'menu_link_content:137a5d20-1c92-46b1-adc8-6986ef4ba061','standard.front_page','rhythm_cms_onepage','type=5','a:1:{s:4:\"type\";s:1:\"5\";}','','s:16:\"Image Parallax 5\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,49,'a:1:{s:9:\"entity_id\";s:2:\"99\";}',0,2,33,453,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',454,'menu_link_content:a8ebb28d-2a08-4f46-bc41-c7d2e380e341','standard.front_page','rhythm_cms_onepage','type=6','a:1:{s:4:\"type\";s:1:\"6\";}','','s:15:\"FullWidth Image\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,50,'a:1:{s:9:\"entity_id\";s:3:\"100\";}',0,2,33,454,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',455,'menu_link_content:12b26d04-ea1a-467a-b0d3-72733ba93a88','standard.front_page','rhythm_cms_onepage','type=7','a:1:{s:4:\"type\";s:1:\"7\";}','','s:12:\"Text Rotator\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,51,'a:1:{s:9:\"entity_id\";s:3:\"101\";}',0,2,33,455,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',456,'menu_link_content:2999ccf3-e949-47dc-911a-51ce4f0b1f4b','standard.front_page','rhythm_cms_onepage','type=8','a:1:{s:4:\"type\";s:1:\"8\";}','','s:17:\"Slider FullScreen\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,52,'a:1:{s:9:\"entity_id\";s:3:\"102\";}',0,2,33,456,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',457,'menu_link_content:6df35863-66bf-4822-b031-aea60d06ef46','standard.front_page','rhythm_cms_onepage','type=9','a:1:{s:4:\"type\";s:1:\"9\";}','','s:18:\"Slider Zoom Effect\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,53,'a:1:{s:9:\"entity_id\";s:3:\"103\";}',0,2,33,457,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',458,'menu_link_content:92a230bd-a998-4bd2-b5ef-4266cb0e45a4','standard.front_page','rhythm_cms_onepage','type=10','a:1:{s:4:\"type\";s:2:\"10\";}','','s:16:\"Slider FullWidth\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,54,'a:1:{s:9:\"entity_id\";s:3:\"104\";}',0,2,33,458,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',459,'menu_link_content:cebaa43c-205f-4f89-b0fc-6ff322ecfd39','standard.front_page','rhythm_cms_onepage','type=11','a:1:{s:4:\"type\";s:2:\"11\";}','','s:17:\"Slider Background\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,55,'a:1:{s:9:\"entity_id\";s:3:\"105\";}',0,2,33,459,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',460,'menu_link_content:3fa83a2b-7b51-4597-9cbe-70ba8d569b58','standard.front_page','rhythm_cms_onepage','type=12','a:1:{s:4:\"type\";s:2:\"12\";}','','s:16:\"With Play Button\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,56,'a:1:{s:9:\"entity_id\";s:3:\"106\";}',0,2,33,460,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',461,'menu_link_content:7cd859fa-e56c-460a-b258-fbdb90e4d2b6','standard.front_page','rhythm_cms_onepage','type=13','a:1:{s:4:\"type\";s:2:\"13\";}','','s:18:\"BG Video FullWidth\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,57,'a:1:{s:9:\"entity_id\";s:3:\"107\";}',0,2,33,461,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',462,'menu_link_content:d953421d-2381-48a2-8ec6-b3556e193d27','standard.front_page','rhythm_cms_onepage','type=14','a:1:{s:4:\"type\";s:2:\"14\";}','','s:21:\"BG Video FullScreen 1\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,58,'a:1:{s:9:\"entity_id\";s:3:\"108\";}',0,2,33,462,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',463,'menu_link_content:e1b2f94e-df9b-4de0-994d-896fea2a566c','standard.front_page','rhythm_cms_onepage','type=15','a:1:{s:4:\"type\";s:2:\"15\";}','','s:21:\"BG Video FullScreen 2\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,59,'a:1:{s:9:\"entity_id\";s:3:\"109\";}',0,2,33,463,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',464,'menu_link_content:76dce2dd-4bbe-48ce-be35-01e61c904ba0','standard.front_page','rhythm_cms_onepage','type=16','a:1:{s:4:\"type\";s:2:\"16\";}','','s:13:\"Agency Header\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,60,'a:1:{s:9:\"entity_id\";s:3:\"110\";}',0,2,33,464,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',465,'menu_link_content:7c682988-9e8a-4380-aeba-a2bc289d04b1','standard.front_page','rhythm_cms_onepage','type=17','a:1:{s:4:\"type\";s:2:\"17\";}','','s:32:\"Photography with fullscreen menu\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,61,'a:1:{s:9:\"entity_id\";s:3:\"111\";}',0,2,33,465,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',467,'views_view:views.blog_timeline.page_1','menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc','view.blog_timeline.page_1','','a:0:{}','','s:13:\"Blog TimeLine\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,-49,'a:2:{s:7:\"view_id\";s:13:\"blog_timeline\";s:10:\"display_id\";s:6:\"page_1\";}',0,2,243,467,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('admin',478,'entity.taxonomy_vocabulary.overview_form.blog_category','entity.taxonomy_vocabulary.collection','entity.taxonomy_vocabulary.overview_form','taxonomy_vocabulary=blog_category','a:1:{s:19:\"taxonomy_vocabulary\";s:13:\"blog_category\";}','','s:13:\"Blog Category\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,51,478,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',479,'entity.taxonomy_vocabulary.overview_form.category','entity.taxonomy_vocabulary.collection','entity.taxonomy_vocabulary.overview_form','taxonomy_vocabulary=category','a:1:{s:19:\"taxonomy_vocabulary\";s:8:\"category\";}','','s:8:\"Category\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,51,479,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',480,'entity.taxonomy_vocabulary.overview_form.gallery','entity.taxonomy_vocabulary.collection','entity.taxonomy_vocabulary.overview_form','taxonomy_vocabulary=gallery','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"gallery\";}','','s:7:\"Gallery\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,51,480,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',481,'entity.taxonomy_vocabulary.overview_form.portfolio_category','entity.taxonomy_vocabulary.collection','entity.taxonomy_vocabulary.overview_form','taxonomy_vocabulary=portfolio_category','a:1:{s:19:\"taxonomy_vocabulary\";s:18:\"portfolio_category\";}','','s:18:\"Portfolio Category\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,51,481,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',482,'entity.taxonomy_vocabulary.overview_form.project','entity.taxonomy_vocabulary.collection','entity.taxonomy_vocabulary.overview_form','taxonomy_vocabulary=project','a:1:{s:19:\"taxonomy_vocabulary\";s:7:\"project\";}','','s:7:\"Project\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,51,482,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',483,'entity.taxonomy_vocabulary.overview_form.tags','entity.taxonomy_vocabulary.collection','entity.taxonomy_vocabulary.overview_form','taxonomy_vocabulary=tags','a:1:{s:19:\"taxonomy_vocabulary\";s:4:\"tags\";}','','s:4:\"Tags\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,51,483,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',484,'system.theme_settings_theme.rhythm_sub','','system.theme_settings_theme','theme=rhythm_sub','a:1:{s:5:\"theme\";s:10:\"rhythm_sub\";}','','s:16:\"Rhythm Sub-Theme\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,1,484,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',486,'menu_link_content:0de6635d-abe6-46ad-a198-30427b7ef1a5','menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb','view.portfolio_boxed.page_1','','a:0:{}','','s:9:\"2 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"112\";}',0,3,304,310,486,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',487,'menu_link_content:fd17614d-d7f1-4ba4-a132-ae8a0b4113b6','menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb','view.portfolio_boxed.page_2','','a:0:{}','','s:9:\"3 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"113\";}',0,3,304,310,487,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',488,'menu_link_content:e7e67b14-7d3a-48e2-aa6f-1efbd14a7cce','menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb','view.portfolio_boxed.page_3','','a:0:{}','','s:9:\"4 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"114\";}',0,3,304,310,488,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',489,'menu_link_content:6d3a98ea-8ac7-47f3-a41b-f95903b6b944','menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb','view.portfolio_boxed.page_4','','a:0:{}','','s:9:\"5 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"115\";}',0,3,304,310,489,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',490,'menu_link_content:bdf3d8d7-7e39-4761-9517-525862ece922','menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb','view.portfolio_boxed.page_9','','a:0:{}','','s:11:\"Black Hover\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"116\";}',0,3,304,310,490,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',491,'menu_link_content:f0751b8b-ca71-400c-8ed4-8f17ff2e9b04','menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962','view.portfolio_boxed.page_5','','a:0:{}','','s:9:\"2 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"117\";}',0,3,304,315,491,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',492,'menu_link_content:19579bde-904c-4869-bcc0-d577fca81c00','menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962','view.portfolio_boxed.page_6','','a:0:{}','','s:9:\"3 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"118\";}',0,3,304,315,492,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',493,'menu_link_content:0cb1c61d-8003-44c3-b0b3-436b7965c92d','menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962','view.portfolio_boxed.page_7','','a:0:{}','','s:9:\"4 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"119\";}',0,3,304,315,493,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',494,'menu_link_content:54d0a093-232c-4a42-807c-99e5f261c476','menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962','view.portfolio_boxed.page_8','','a:0:{}','','s:9:\"5 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"120\";}',0,3,304,315,494,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',495,'menu_link_content:d36bda57-2f21-43c6-acf0-1028c0dfc419','menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962','view.portfolio_boxed.page_10','','a:0:{}','','s:11:\"Black Hover\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"121\";}',0,3,304,315,495,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',496,'menu_link_content:4cc45e07-f95f-43c4-911b-d611e55bffed','menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6','view.portfolio_boxed.page_11','','a:0:{}','','s:9:\"2 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"122\";}',0,3,304,322,496,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',497,'menu_link_content:63af3b84-3b40-4e78-ae2a-6a82bed21ce0','menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6','view.portfolio_boxed.page_12','','a:0:{}','','s:9:\"3 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"123\";}',0,3,304,322,497,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',498,'menu_link_content:8de4bf5b-4d62-49dc-a8f3-17312f378b96','menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6','view.portfolio_boxed.page_13','','a:0:{}','','s:9:\"4 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"124\";}',0,3,304,322,498,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',499,'menu_link_content:e8b2b5e6-1fd0-4879-add1-d64f65071e52','menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6','view.portfolio_boxed.page_14','','a:0:{}','','s:9:\"5 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"125\";}',0,3,304,322,499,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',500,'menu_link_content:c2758267-44c1-47cc-ad2f-9ed26b5a7b66','menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6','view.portfolio_boxed.page_15','','a:0:{}','','s:11:\"Black Hover\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"126\";}',0,3,304,322,500,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',501,'menu_link_content:d70e25d4-48f8-4d30-ad1b-140b19b8d86d','menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a','view.portfolio_boxed.page_16','','a:0:{}','','s:9:\"2 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"127\";}',0,3,304,332,501,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',502,'menu_link_content:0c2acf13-be99-400e-a516-3eeb0250a939','menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a','view.portfolio_boxed.page_17','','a:0:{}','','s:9:\"3 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"128\";}',0,3,304,332,502,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',503,'menu_link_content:7f9d4c9f-e68c-45e9-bba3-b8a7606a6e44','menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a','view.portfolio_boxed.page_18','','a:0:{}','','s:9:\"4 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"129\";}',0,3,304,332,503,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',504,'menu_link_content:6079aec3-9b0f-44ac-b956-f456e93598ef','menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a','view.portfolio_boxed.page_19','','a:0:{}','','s:9:\"5 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"130\";}',0,3,304,332,504,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',505,'menu_link_content:5fe360b7-8317-4fb0-82c7-c96816ce453c','menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a','view.portfolio_boxed.page_20','','a:0:{}','','s:11:\"Black Hover\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"131\";}',0,3,304,332,505,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',506,'menu_link_content:27fbc9d4-80f5-4766-aa51-033eb100c01e','menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',NULL,'','a:0:{}','base:rhythm/portfolio-gutter-wide-2-columns','s:9:\"2 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"132\";}',0,3,304,338,506,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',507,'menu_link_content:75001a20-1143-4b16-a9a0-52cb6cdb7a37','menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',NULL,'','a:0:{}','base:rhythm/portfolio-gutter-wide-3-columns','s:9:\"3 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"133\";}',0,3,304,338,507,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',508,'menu_link_content:91cfd1c4-b40e-488c-9c60-8e7390a84b68','menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',NULL,'','a:0:{}','base:rhythm/portfolio-gutter-wide-4-columns','s:9:\"4 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"134\";}',0,3,304,338,508,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',509,'menu_link_content:0c806bda-6622-44ad-acd3-ea6039e259de','menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',NULL,'','a:0:{}','base:rhythm/portfolio-gutter-wide-5-columns','s:9:\"5 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"135\";}',0,3,304,338,509,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',510,'menu_link_content:63d22618-b4fe-4342-8655-821ad8640798','menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f','view.portfolio_boxed.page_25','','a:0:{}','','s:11:\"Black Hover\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"136\";}',0,3,304,338,510,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',511,'menu_link_content:cbd74fb9-4e21-48a4-8255-cf16a114b84b','menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8','view.portfolio_boxed.page_26','','a:0:{}','','s:9:\"2 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"137\";}',0,3,304,344,511,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',512,'menu_link_content:4326f5db-5e0d-44dc-9a52-5dc744ef772d','menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8','view.portfolio_boxed.page_27','','a:0:{}','','s:9:\"3 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"138\";}',0,3,304,344,512,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',513,'menu_link_content:dd84e93e-078f-45c7-a7e6-a0797fc4cb89','menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8','view.portfolio_boxed.page_28','','a:0:{}','','s:9:\"4 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"139\";}',0,3,304,344,513,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',514,'menu_link_content:63c6495e-8c2e-45f4-b372-b542fc123fdb','menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8','view.portfolio_boxed.page_29','','a:0:{}','','s:9:\"5 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"140\";}',0,3,304,344,514,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',515,'menu_link_content:018d37e6-b392-4228-8943-7c3f433d837d','menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8','view.portfolio_boxed.page_30','','a:0:{}','','s:11:\"Black Hover\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"141\";}',0,3,304,344,515,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',516,'menu_link_content:a046d288-c42b-45a6-b22d-c4e7e341e473','menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2','view.portfolio_boxed.page_31','','a:0:{}','','s:9:\"2 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"142\";}',0,3,304,346,516,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',517,'menu_link_content:8795dfe3-3f26-42dc-b987-3e9353df3831','menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2','view.portfolio_boxed.page_32','','a:0:{}','','s:9:\"3 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"143\";}',0,3,304,346,517,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',518,'menu_link_content:f9df1e47-273b-4684-81e4-da37304c140d','menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2','view.portfolio_boxed.page_33','','a:0:{}','','s:9:\"4 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"144\";}',0,3,304,346,518,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',519,'menu_link_content:65a0627d-7961-40e4-b2f1-93280c2f0a20','menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2','view.portfolio_boxed.page_34','','a:0:{}','','s:9:\"5 Columns\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"145\";}',0,3,304,346,519,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',520,'menu_link_content:192ee9a4-4616-4135-9de9-ad3f469f1c22','menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2','view.portfolio_boxed.page_35','','a:0:{}','','s:11:\"Black Hover\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,0,'a:1:{s:9:\"entity_id\";s:3:\"146\";}',0,3,304,346,520,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',522,'admin_toolbar_tools.user.logout','admin_toolbar_tools.help','user.logout','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Logout\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,10,'a:0:{}',0,3,1,98,522,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',523,'commerce.admin_commerce','system.admin','commerce.admin_commerce','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Commerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Administer and configure your Commerce store.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce',1,1,0,-9,'a:0:{}',1,2,1,523,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',524,'commerce.configuration','commerce.admin_commerce','commerce.configuration','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Configure your store settings and structure.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce',1,1,0,10,'a:0:{}',1,3,1,523,524,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',525,'entity.commerce_checkout_flow.collection','commerce_order.configuration','entity.commerce_checkout_flow.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Checkout flows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Configure your checkout forms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_checkout',1,1,0,0,'a:0:{}',0,5,1,523,524,646,525,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',526,'entity.commerce_order_type.collection','commerce_order.configuration','entity.commerce_order_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Order types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Manage fields, form and display settings for your orders.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_order',1,1,0,-10,'a:0:{}',1,5,1,523,524,646,526,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',527,'entity.commerce_order_type.edit_form.default','entity.commerce_order_type.collection','entity.commerce_order_type.edit_form','commerce_order_type=default','a:1:{s:19:\"commerce_order_type\";s:7:\"default\";}','','s:7:\"Default\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,6,1,523,524,646,526,527,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',528,'entity.commerce_order.field_ui_fieldsdefault','entity.commerce_order_type.edit_form.default','entity.commerce_order.field_ui_fields','commerce_order_type=default','a:1:{s:19:\"commerce_order_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,7,1,523,524,646,526,527,528,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',529,'entity.entity_form_display.commerce_order.defaultdefault','entity.commerce_order_type.edit_form.default','entity.entity_form_display.commerce_order.default','commerce_order_type=default','a:1:{s:19:\"commerce_order_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,7,1,523,524,646,526,527,529,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',530,'entity.entity_view_display.commerce_order.default.default','entity.commerce_order_type.edit_form.default','entity.entity_view_display.commerce_order.default','commerce_order_type=default','a:1:{s:19:\"commerce_order_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,7,1,523,524,646,526,527,530,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',532,'entity.commerce_order_type.delete_form.default','entity.commerce_order_type.edit_form.default','entity.commerce_order_type.delete_form','commerce_order_type=default','a:1:{s:19:\"commerce_order_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,7,1,523,524,646,526,527,532,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',533,'entity.commerce_order_item_type.collection','commerce_order.configuration','entity.commerce_order_item_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Order item types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:87:\"Manage fields, Add to Cart forms, other form and display settings for your order items.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_order',1,1,0,-5,'a:0:{}',1,5,1,523,524,646,533,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',534,'entity.commerce_order_item_type.edit_form.default','entity.commerce_order_item_type.collection','entity.commerce_order_item_type.edit_form','commerce_order_item_type=default','a:1:{s:24:\"commerce_order_item_type\";s:7:\"default\";}','','s:7:\"Default\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,6,1,523,524,646,533,534,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',535,'entity.commerce_order_item.field_ui_fieldsdefault','entity.commerce_order_item_type.edit_form.default','entity.commerce_order_item.field_ui_fields','commerce_order_item_type=default','a:1:{s:24:\"commerce_order_item_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,7,1,523,524,646,533,534,535,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',536,'entity.entity_form_display.commerce_order_item.defaultdefault','entity.commerce_order_item_type.edit_form.default','entity.entity_form_display.commerce_order_item.default','commerce_order_item_type=default','a:1:{s:24:\"commerce_order_item_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,7,1,523,524,646,533,534,536,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',537,'entity.entity_view_display.commerce_order_item.default.default','entity.commerce_order_item_type.edit_form.default','entity.entity_view_display.commerce_order_item.default','commerce_order_item_type=default','a:1:{s:24:\"commerce_order_item_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,7,1,523,524,646,533,534,537,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',539,'entity.commerce_order_item_type.delete_form.default','entity.commerce_order_item_type.edit_form.default','entity.commerce_order_item_type.delete_form','commerce_order_item_type=default','a:1:{s:24:\"commerce_order_item_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,7,1,523,524,646,533,534,539,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',540,'entity.commerce_payment_gateway.collection','commerce_payment.configuration','entity.commerce_payment_gateway.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Payment gateways\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Configure the gateways you take payment through.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_payment',1,1,0,0,'a:0:{}',0,5,1,523,524,647,540,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',541,'entity.commerce_currency.collection','commerce.store_configuration','entity.commerce_currency.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Currencies\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Manage your currencies.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_price',1,1,0,-20,'a:0:{}',0,5,1,523,524,645,541,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',542,'entity.commerce_product_type.collection','commerce_product.configuration','entity.commerce_product_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Product types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"Manage fields, form and display settings for your products.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_product',1,1,0,0,'a:0:{}',1,5,1,523,524,648,542,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',543,'entity.commerce_product_type.edit_form.default','entity.commerce_product_type.collection','entity.commerce_product_type.edit_form','commerce_product_type=default','a:1:{s:21:\"commerce_product_type\";s:7:\"default\";}','','s:7:\"Default\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,6,1,523,524,648,542,543,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',544,'entity.commerce_product.field_ui_fieldsdefault','entity.commerce_product_type.edit_form.default','entity.commerce_product.field_ui_fields','commerce_product_type=default','a:1:{s:21:\"commerce_product_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,7,1,523,524,648,542,543,544,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',545,'entity.entity_form_display.commerce_product.defaultdefault','entity.commerce_product_type.edit_form.default','entity.entity_form_display.commerce_product.default','commerce_product_type=default','a:1:{s:21:\"commerce_product_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,7,1,523,524,648,542,543,545,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',546,'entity.entity_view_display.commerce_product.default.default','entity.commerce_product_type.edit_form.default','entity.entity_view_display.commerce_product.default','commerce_product_type=default','a:1:{s:21:\"commerce_product_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,7,1,523,524,648,542,543,546,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',548,'entity.commerce_product_type.delete_form.default','entity.commerce_product_type.edit_form.default','entity.commerce_product_type.delete_form','commerce_product_type=default','a:1:{s:21:\"commerce_product_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,7,1,523,524,648,542,543,548,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',549,'entity.commerce_product_variation_type.collection','commerce_product.configuration','entity.commerce_product_variation_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Product variation types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"Manage fields, form and display settings for your product variations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_product',1,1,0,0,'a:0:{}',1,5,1,523,524,648,549,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',550,'entity.commerce_product_variation_type.edit_form.default','entity.commerce_product_variation_type.collection','entity.commerce_product_variation_type.edit_form','commerce_product_variation_type=default','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"default\";}','','s:7:\"Default\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,6,1,523,524,648,549,550,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',551,'entity.commerce_product_variation.field_ui_fieldsdefault','entity.commerce_product_variation_type.edit_form.default','entity.commerce_product_variation.field_ui_fields','commerce_product_variation_type=default','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,7,1,523,524,648,549,550,551,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',552,'entity.entity_form_display.commerce_product_variation.defaultdefault','entity.commerce_product_variation_type.edit_form.default','entity.entity_form_display.commerce_product_variation.default','commerce_product_variation_type=default','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,7,1,523,524,648,549,550,552,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',553,'entity.entity_view_display.commerce_product_variation.default.default','entity.commerce_product_variation_type.edit_form.default','entity.entity_view_display.commerce_product_variation.default','commerce_product_variation_type=default','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,7,1,523,524,648,549,550,553,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',555,'entity.commerce_product_variation_type.delete_form.default','entity.commerce_product_variation_type.edit_form.default','entity.commerce_product_variation_type.delete_form','commerce_product_variation_type=default','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"default\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,7,1,523,524,648,549,550,555,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',556,'entity.commerce_store_type.collection','commerce.store_configuration','entity.commerce_store_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Store types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Manage fields, form and display settings for your stores.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_store',1,1,0,-5,'a:0:{}',1,5,1,523,524,645,556,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',557,'entity.commerce_store_type.edit_form.online','entity.commerce_store_type.collection','entity.commerce_store_type.edit_form','commerce_store_type=online','a:1:{s:19:\"commerce_store_type\";s:6:\"online\";}','','s:6:\"Online\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,6,1,523,524,645,556,557,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',558,'entity.commerce_store.field_ui_fieldsonline','entity.commerce_store_type.edit_form.online','entity.commerce_store.field_ui_fields','commerce_store_type=online','a:1:{s:19:\"commerce_store_type\";s:6:\"online\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,7,1,523,524,645,556,557,558,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',559,'entity.entity_form_display.commerce_store.defaultonline','entity.commerce_store_type.edit_form.online','entity.entity_form_display.commerce_store.default','commerce_store_type=online','a:1:{s:19:\"commerce_store_type\";s:6:\"online\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,7,1,523,524,645,556,557,559,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',560,'entity.entity_view_display.commerce_store.default.online','entity.commerce_store_type.edit_form.online','entity.entity_view_display.commerce_store.default','commerce_store_type=online','a:1:{s:19:\"commerce_store_type\";s:6:\"online\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,7,1,523,524,645,556,557,560,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',562,'entity.commerce_store_type.delete_form.online','entity.commerce_store_type.edit_form.online','entity.commerce_store_type.delete_form','commerce_store_type=online','a:1:{s:19:\"commerce_store_type\";s:6:\"online\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,7,1,523,524,645,556,557,562,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',563,'entity.commerce_order.collection','commerce.admin_commerce','entity.commerce_order.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Orders\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage your orders.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_order',1,1,0,0,'a:0:{}',1,3,1,523,563,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',564,'entity.commerce_product.collection','commerce.admin_commerce','entity.commerce_product.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Products\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Manage your products.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_product',1,1,0,0,'a:0:{}',0,3,1,523,564,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',565,'entity.commerce_product_attribute.collection','commerce.admin_commerce','entity.commerce_product_attribute.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Product attributes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Manage your product attributes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_product',1,1,0,0,'a:0:{}',1,3,1,523,565,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',566,'entity.commerce_promotion.collection','commerce.admin_commerce','entity.commerce_promotion.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Promotions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Manage your promotions.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_promotion',1,1,0,0,'a:0:{}',0,3,1,523,566,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',567,'entity.commerce_store.collection','commerce.store_configuration','entity.commerce_store.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Stores\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage your stores.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_store',1,1,0,-10,'a:0:{}',0,5,1,523,524,645,567,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',568,'entity.profile.collection','entity.user.collection','entity.profile.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Profiles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Manage user profiles.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','profile',1,1,0,0,'a:0:{}',0,3,1,30,568,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',569,'entity.profile_type.edit_form.customer','entity.profile_type.collection','entity.profile_type.edit_form','profile_type=customer','a:1:{s:12:\"profile_type\";s:8:\"customer\";}','','s:8:\"Customer\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,5,1,6,28,650,569,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',570,'entity.profile.field_ui_fieldscustomer','entity.profile_type.edit_form.customer','entity.profile.field_ui_fields','profile_type=customer','a:1:{s:12:\"profile_type\";s:8:\"customer\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,6,1,6,28,650,569,570,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',571,'entity.entity_form_display.profile.defaultcustomer','entity.profile_type.edit_form.customer','entity.entity_form_display.profile.default','profile_type=customer','a:1:{s:12:\"profile_type\";s:8:\"customer\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,6,1,6,28,650,569,571,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',572,'entity.entity_view_display.profile.default.customer','entity.profile_type.edit_form.customer','entity.entity_view_display.profile.default','profile_type=customer','a:1:{s:12:\"profile_type\";s:8:\"customer\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,6,1,6,28,650,569,572,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',574,'entity.profile_type.delete_form.customer','entity.profile_type.edit_form.customer','entity.profile_type.delete_form','profile_type=customer','a:1:{s:12:\"profile_type\";s:8:\"customer\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,6,1,6,28,650,569,574,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',575,'entity.commerce_product_variation_type.edit_form.product','entity.commerce_product_variation_type.collection','entity.commerce_product_variation_type.edit_form','commerce_product_variation_type=product','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"product\";}','','s:7:\"Product\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,6,1,523,524,648,549,575,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',576,'entity.commerce_product_variation.field_ui_fieldsproduct','entity.commerce_product_variation_type.edit_form.product','entity.commerce_product_variation.field_ui_fields','commerce_product_variation_type=product','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"product\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,7,1,523,524,648,549,575,576,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',577,'entity.entity_form_display.commerce_product_variation.defaultproduct','entity.commerce_product_variation_type.edit_form.product','entity.entity_form_display.commerce_product_variation.default','commerce_product_variation_type=product','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"product\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,7,1,523,524,648,549,575,577,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',578,'entity.entity_view_display.commerce_product_variation.default.product','entity.commerce_product_variation_type.edit_form.product','entity.entity_view_display.commerce_product_variation.default','commerce_product_variation_type=product','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"product\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,7,1,523,524,648,549,575,578,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',580,'entity.commerce_product_variation_type.delete_form.product','entity.commerce_product_variation_type.edit_form.product','entity.commerce_product_variation_type.delete_form','commerce_product_variation_type=product','a:1:{s:31:\"commerce_product_variation_type\";s:7:\"product\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,7,1,523,524,648,549,575,580,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',581,'entity.commerce_product_type.edit_form.product_display','entity.commerce_product_type.collection','entity.commerce_product_type.edit_form','commerce_product_type=product_display','a:1:{s:21:\"commerce_product_type\";s:15:\"product_display\";}','','s:15:\"Product Display\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,6,1,523,524,648,542,581,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',582,'entity.commerce_product.field_ui_fieldsproduct_display','entity.commerce_product_type.edit_form.product_display','entity.commerce_product.field_ui_fields','commerce_product_type=product_display','a:1:{s:21:\"commerce_product_type\";s:15:\"product_display\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,7,1,523,524,648,542,581,582,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',583,'entity.entity_form_display.commerce_product.defaultproduct_display','entity.commerce_product_type.edit_form.product_display','entity.entity_form_display.commerce_product.default','commerce_product_type=product_display','a:1:{s:21:\"commerce_product_type\";s:15:\"product_display\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,7,1,523,524,648,542,581,583,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',584,'entity.entity_view_display.commerce_product.default.product_display','entity.commerce_product_type.edit_form.product_display','entity.entity_view_display.commerce_product.default','commerce_product_type=product_display','a:1:{s:21:\"commerce_product_type\";s:15:\"product_display\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,7,1,523,524,648,542,581,584,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',586,'entity.commerce_product_type.delete_form.product_display','entity.commerce_product_type.edit_form.product_display','entity.commerce_product_type.delete_form','commerce_product_type=product_display','a:1:{s:21:\"commerce_product_type\";s:15:\"product_display\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,7,1,523,524,648,542,581,586,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',605,'entity.vote_type.collection','system.admin_structure','entity.vote_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vote Types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Manage Vote Types.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','votingapi',1,1,0,0,'a:0:{}',0,3,1,3,605,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',606,'votingapi.admin_settings','system.admin_config_search','votingapi.admin_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Voting API Settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Configure Voting API.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','votingapi',1,1,0,0,'a:0:{}',0,4,1,6,19,606,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',607,'menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354','','entity.node.canonical','node=107','a:1:{s:4:\"node\";s:3:\"107\";}','','s:4:\"Shop\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:0:{}','menu_link_content',1,0,0,-44,'a:1:{s:9:\"entity_id\";s:3:\"147\";}',1,1,607,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',608,'menu_link_content:86a4b73a-822d-4a11-95f4-efdcb5e34973','menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354','commerce_cart.page','','a:0:{}','','s:13:\"Shopping Cart\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,5,'a:1:{s:9:\"entity_id\";s:3:\"148\";}',0,2,607,608,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',609,'entity.comment_type.edit_form.default_reviews','entity.comment_type.collection','entity.comment_type.edit_form','comment_type=default_reviews','a:1:{s:12:\"comment_type\";s:15:\"default_reviews\";}','','s:15:\"Default reviews\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,3,40,609,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',610,'entity.comment.field_ui_fieldsdefault_reviews','entity.comment_type.edit_form.default_reviews','entity.comment.field_ui_fields','comment_type=default_reviews','a:1:{s:12:\"comment_type\";s:15:\"default_reviews\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,3,40,609,610,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',611,'entity.entity_form_display.comment.defaultdefault_reviews','entity.comment_type.edit_form.default_reviews','entity.entity_form_display.comment.default','comment_type=default_reviews','a:1:{s:12:\"comment_type\";s:15:\"default_reviews\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,3,40,609,611,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',612,'entity.entity_view_display.comment.default.default_reviews','entity.comment_type.edit_form.default_reviews','entity.entity_view_display.comment.default','comment_type=default_reviews','a:1:{s:12:\"comment_type\";s:15:\"default_reviews\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,3,40,609,612,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',614,'entity.comment_type.delete_form.default_reviews','entity.comment_type.edit_form.default_reviews','entity.comment_type.delete_form','comment_type=default_reviews','a:1:{s:12:\"comment_type\";s:15:\"default_reviews\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,3,40,609,614,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',621,'entity.commerce_product_attribute.edit_form.color','entity.commerce_product_attribute.collection','entity.commerce_product_attribute.edit_form','commerce_product_attribute=color','a:1:{s:26:\"commerce_product_attribute\";s:5:\"color\";}','','s:5:\"Color\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,523,565,621,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',622,'entity.commerce_product_attribute_value.field_ui_fieldscolor','entity.commerce_product_attribute.edit_form.color','entity.commerce_product_attribute_value.field_ui_fields','commerce_product_attribute=color','a:1:{s:26:\"commerce_product_attribute\";s:5:\"color\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,523,565,621,622,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',623,'entity.entity_form_display.commerce_product_attribute_value.defaultcolor','entity.commerce_product_attribute.edit_form.color','entity.entity_form_display.commerce_product_attribute_value.default','commerce_product_attribute=color','a:1:{s:26:\"commerce_product_attribute\";s:5:\"color\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,523,565,621,623,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',624,'entity.entity_view_display.commerce_product_attribute_value.default.color','entity.commerce_product_attribute.edit_form.color','entity.entity_view_display.commerce_product_attribute_value.default','commerce_product_attribute=color','a:1:{s:26:\"commerce_product_attribute\";s:5:\"color\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,523,565,621,624,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',626,'entity.commerce_product_attribute.delete_form.color','entity.commerce_product_attribute.edit_form.color','entity.commerce_product_attribute.delete_form','commerce_product_attribute=color','a:1:{s:26:\"commerce_product_attribute\";s:5:\"color\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,523,565,621,626,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',627,'entity.commerce_product_attribute.edit_form.size','entity.commerce_product_attribute.collection','entity.commerce_product_attribute.edit_form','commerce_product_attribute=size','a:1:{s:26:\"commerce_product_attribute\";s:4:\"size\";}','','s:4:\"Size\";','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',1,4,1,523,565,627,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',628,'entity.commerce_product_attribute_value.field_ui_fieldssize','entity.commerce_product_attribute.edit_form.size','entity.commerce_product_attribute_value.field_ui_fields','commerce_product_attribute=size','a:1:{s:26:\"commerce_product_attribute\";s:4:\"size\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Manage fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,523,565,627,628,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',629,'entity.entity_form_display.commerce_product_attribute_value.defaultsize','entity.commerce_product_attribute.edit_form.size','entity.entity_form_display.commerce_product_attribute_value.default','commerce_product_attribute=size','a:1:{s:26:\"commerce_product_attribute\";s:4:\"size\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Manage form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,523,565,627,629,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',630,'entity.entity_view_display.commerce_product_attribute_value.default.size','entity.commerce_product_attribute.edit_form.size','entity.entity_view_display.commerce_product_attribute_value.default','commerce_product_attribute=size','a:1:{s:26:\"commerce_product_attribute\";s:4:\"size\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Manage display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,3,'a:0:{}',0,5,1,523,565,627,630,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',632,'entity.commerce_product_attribute.delete_form.size','entity.commerce_product_attribute.edit_form.size','entity.commerce_product_attribute.delete_form','commerce_product_attribute=size','a:1:{s:26:\"commerce_product_attribute\";s:4:\"size\";}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Delete\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,5,'a:0:{}',0,5,1,523,565,627,632,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',633,'menu_link_content:37310cde-bf20-4b44-bf35-ad1befa88b75','menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354','entity.commerce_product.canonical','commerce_product=4','a:1:{s:16:\"commerce_product\";s:1:\"4\";}','','s:14:\"Single Product\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,4,'a:1:{s:9:\"entity_id\";s:3:\"149\";}',0,2,607,633,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('main',641,'views_view:views.shop_columns.page','menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354','view.shop_columns.page','','a:0:{}','','s:9:\"2 Columns\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,1,'a:2:{s:7:\"view_id\";s:12:\"shop_columns\";s:10:\"display_id\";s:4:\"page\";}',0,2,607,641,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',642,'views_view:views.shop_columns.page_1','menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354','view.shop_columns.page_1','','a:0:{}','','s:9:\"3 Columns\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,2,'a:2:{s:7:\"view_id\";s:12:\"shop_columns\";s:10:\"display_id\";s:6:\"page_1\";}',0,2,607,642,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('main',643,'views_view:views.shop_columns.page_2','menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354','view.shop_columns.page_2','','a:0:{}','','s:9:\"4 Columns\";','s:0:\"\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink','a:0:{}','views',1,1,0,3,'a:2:{s:7:\"view_id\";s:12:\"shop_columns\";s:10:\"display_id\";s:6:\"page_2\";}',0,2,607,643,0,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),

('admin',644,'tb_megamenu.admin','system.admin_structure','entity.tb_megamenu.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"TB Mega Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"List of megamenu items\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','tb_megamenu',1,1,0,0,'a:0:{}',0,3,1,3,644,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',645,'commerce.store_configuration','commerce.configuration','commerce.store_configuration','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Store\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce',1,1,0,-20,'a:0:{}',1,4,1,523,524,645,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',646,'commerce_order.configuration','commerce.configuration','commerce_order.configuration','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Orders\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_order',1,1,0,-5,'a:0:{}',1,4,1,523,524,646,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',647,'commerce_payment.configuration','commerce.configuration','commerce_payment.configuration','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Payment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_payment',1,1,0,-10,'a:0:{}',1,4,1,523,524,647,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',648,'commerce_product.configuration','commerce.configuration','commerce_product.configuration','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Products\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','commerce_product',1,1,0,-15,'a:0:{}',1,4,1,523,524,648,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',649,'admin_toolbar_tools.add_content','system.admin_content','node.add_page','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','node',1,1,0,0,'a:0:{}',1,3,1,2,649,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',650,'entity.profile_type.collection','user.admin_index','entity.profile_type.collection','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Profile types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Manage profile types, including fields.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','profile',1,1,0,0,'a:0:{}',1,4,1,6,28,650,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',651,'admin_toolbar_tools.flush_views','admin_toolbar_tools.flush','admin_toolbar_tools.flush_views','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Flush views cache\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,98,102,651,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',683,'admin_toolbar_tools.views_ui.add','entity.view.collection','views_ui.add','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Add new view\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,-5,'a:0:{}',0,4,1,3,60,683,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',684,'admin_toolbar_tools.system.theme_settings','system.themes_page','system.theme_settings','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,3,1,4,684,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',685,'admin_toolbar_tools.config.import','config.sync','config.import_full','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Import\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,1,'a:0:{}',0,5,1,6,12,41,685,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',686,'admin_toolbar_tools.config.export','config.sync','config.export_full','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Export\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,2,'a:0:{}',0,5,1,6,12,41,686,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',687,'admin_toolbar_tools.language.negotiation','entity.configurable_language.collection','language.negotiation','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Detection and selection\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,5,1,6,16,308,687,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',688,'admin_toolbar_tools.views_ui.field_list','entity.field_storage_config.collection','views_ui.reports_fields','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Used in views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,26,50,688,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',689,'admin_toolbar_tools.flush_twig','admin_toolbar_tools.flush','admin_toolbar_tools.flush_twig','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Flush twig cache\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,4,1,98,102,689,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',690,'admin_toolbar_tools.view.files','system.admin_content','view.files.page_1','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Files\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','s:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','admin_toolbar_tools',1,1,0,0,'a:0:{}',0,3,1,2,690,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('admin',691,'webform.reports_plugins','system.admin_reports','webform.reports_plugins.elements','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Webform plugins\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Overview of plugins used by the Webform module.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','webform',1,1,0,0,'a:0:{}',0,3,1,26,691,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),

('main',692,'menu_link_content:f1a1def5-badc-404a-a5a7-4b7c80e06deb','menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8','user.logout','','a:0:{}','','s:6:\"Logout\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent','a:1:{s:5:\"query\";a:0:{}}','menu_link_content',1,1,0,25,'a:1:{s:9:\"entity_id\";s:3:\"150\";}',0,2,305,692,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),

('admin',693,'entity_reference_revisions.delete_orphans','system.admin_config_system','entity_reference_revisions.delete_orphans','','a:0:{}','','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Delete orphaned composite entities\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:90:\"Delete revisions of entities that are no longer used in Entity Reference Revisions fields.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault','a:0:{}','entity_reference_revisions',1,1,0,30,'a:0:{}',0,4,1,6,20,693,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm');

/*Table structure for table `nd_visualshortcodes_saved` */

DROP TABLE IF EXISTS `nd_visualshortcodes_saved`;

CREATE TABLE `nd_visualshortcodes_saved` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The unique ID for this particular shortcode.',
  `name` varchar(128) NOT NULL DEFAULT '',
  `code` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Saved shortcodes.';

/*Data for the table `nd_visualshortcodes_saved` */

/*Table structure for table `node` */

DROP TABLE IF EXISTS `node`;

CREATE TABLE `node` (
  `nid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `vid` int(10) unsigned DEFAULT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`nid`),
  UNIQUE KEY `node_field__uuid__value` (`uuid`),
  UNIQUE KEY `node__vid` (`vid`),
  KEY `node_field__type__target_id` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=108 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for node entities.';

/*Data for the table `node` */

insert  into `node`(`nid`,`vid`,`type`,`uuid`,`langcode`) values 

(2,2,'nd_blog','5fa476e9-4026-45ca-a795-00662e10551d','en'),

(3,3,'nd_blog','e5caf650-5937-495e-b2fd-1012f545a8f1','en'),

(4,4,'nd_blog','cd71f16c-807f-465c-a3c8-600eca5cac59','en'),

(5,5,'nd_blog','1d03a4ea-2c53-4be9-be46-6f21e71834c5','en'),

(6,6,'nd_blog','ed1c6ac6-b26a-4eef-b6c0-30a1bfc0ba95','en'),

(7,7,'nd_blog','402ced60-4042-453d-8fa5-6369b0c791b1','en'),

(8,8,'nd_blog','ed1492ca-efca-40cc-b405-0c29e5910428','en'),

(9,9,'nd_blog','6924cdf2-92a1-4361-a2a5-63de930a3526','en'),

(10,10,'nd_portfolio','879a6a88-fa1a-49f4-9b01-d8e64de9aebb','en'),

(11,11,'nd_portfolio','579b17d8-b6d5-4fe2-93e5-33aec0c7f0e4','en'),

(12,12,'nd_portfolio','efe048ea-a744-480f-90ec-cd951d0b9f95','en'),

(13,13,'nd_portfolio','9dd8e553-d33b-4adb-a1aa-51a2d122d406','en'),

(14,14,'nd_portfolio','5b8addab-0b3c-4ccb-b2cf-b4e3f89aa95e','en'),

(15,15,'nd_portfolio','d82959f7-df23-47f5-8096-779a2bd69c7d','en'),

(16,16,'nd_portfolio','06aa80f6-5c50-4769-ae14-371763f5637f','en'),

(17,17,'nd_portfolio','787fafba-fd9a-441f-95f9-fd33a9f785b4','en'),

(18,18,'nd_portfolio','43e07148-bac8-4b37-8ece-6b2a61f0fd42','en'),

(19,19,'nd_portfolio','af2695f5-be82-453b-8dd1-4f4f1082cd25','en'),

(20,20,'nd_portfolio','f9e3fb98-ce56-4dc6-9162-84c0c68c49c4','en'),

(21,21,'nd_portfolio','696a1e60-5cf4-481b-ac84-372b174eb35a','en'),

(22,22,'nd_portfolio','3bede1ff-1ab5-4e0e-8b46-e5da9201aded','en'),

(23,23,'nd_portfolio','0c7ce82e-5803-4e61-8af4-dd2d19d39bfa','en'),

(24,24,'nd_portfolio','77efc13d-caa2-40c6-8d16-b30486dbc9ec','en'),

(25,25,'nd_portfolio','7b3b656d-346a-472c-b295-67f4cc8d234d','en'),

(26,26,'nd_portfolio','9a9fd657-df0f-4e03-9010-4aeaf42fd6d9','en'),

(27,27,'nd_portfolio','814f1487-33fd-4fba-b677-f20dcacba432','en'),

(28,28,'nd_portfolio','fb7a22b6-825b-4a59-aa70-7a90b2b0f892','en'),

(29,29,'nd_portfolio','9b21802c-1b1f-4490-a169-d92f1c37a7cf','en'),

(30,30,'nd_portfolio','7055b2ec-213b-4011-9a62-d34eea45c77f','en'),

(31,31,'nd_portfolio','6d9afc26-87b0-4392-aee2-17ffdad3a433','en'),

(32,32,'nd_portfolio','8bf71114-ff73-4a89-a35c-28ddea4b9014','en'),

(33,33,'nd_portfolio','43ddfea5-2f39-42cc-b1bb-49751f3d0085','en'),

(34,41,'page','0d48ce37-7369-4c7b-b103-41a9040d9464','en'),

(35,42,'page','37259c59-d6c4-4290-8401-cb0b3efd1fb1','en'),

(36,43,'page','ea5a772d-a4d7-4d6c-82b4-d57302406288','en'),

(37,44,'page','f643fac4-3cbe-4a44-be78-5924846e16b6','en'),

(38,45,'page','79919595-a4dc-403c-bbec-af5263596bcc','en'),

(39,46,'page','5d819c3d-a4fe-4ef8-9d02-4d749329eb85','en'),

(40,47,'page','816e9be3-9f87-4096-b576-2c54a5c0399b','en'),

(41,48,'page','8c76cdc1-be1e-4813-af21-5640f5bb9517','en'),

(42,49,'page','41b5473a-98e0-42ea-b9ae-172289186a30','en'),

(43,50,'page','f5ca97b9-4f96-4e04-ae1c-f6cac15576c5','en'),

(44,51,'page','87295754-04fe-4f31-a6a5-f62714fd2ab4','en'),

(45,52,'page','307214cd-55be-42e2-ba4a-3b1fbb1c4aa6','en'),

(46,53,'page','9b5afc7a-9da1-4488-98c7-e8d6003b6916','en'),

(47,54,'page','8d79c51f-2e9a-47de-b9e5-462be4a567d8','en'),

(48,55,'page','acb4430d-752e-43e7-98bb-0a5eaa42269e','en'),

(49,56,'page','c62e2881-524f-4f04-83fb-2b6d1f21f73d','en'),

(50,57,'page','12924159-ec0e-4969-b8d4-5bd668b8aec9','en'),

(54,61,'page','24e1b88d-784d-4f05-8883-222495d2caef','en'),

(55,62,'page','b21745a6-d39a-4b6d-962c-8b56971d0596','en'),

(56,63,'nd_portfolio','6b1cda51-3fb8-4ff1-8e34-e0851c7b1960','en'),

(57,64,'nd_person','3a3359f6-0e6c-4df7-ade4-5ef3527ce4ca','en'),

(58,65,'nd_person','f7d099fd-b7b1-47bc-921b-4e3497ea8349','en'),

(59,66,'nd_person','2c26e21a-4a1f-4ed2-b6e3-3b4b05c09adb','en'),

(60,67,'nd_person','7561c70d-919d-49cd-8dd2-9f28f043721c','en'),

(61,68,'page','9d4d1a90-e3a3-4d00-b3ce-3f9f6d590047','en'),

(62,69,'page','6e2f7994-6bd4-4c85-8b7b-355910788479','en'),

(63,70,'page','81618984-1bf1-4937-89c5-7dbdceb14bd3','en'),

(64,71,'page','4246640e-4e63-4e58-8cde-bc6e63794ab7','en'),

(65,72,'page','3aac32e5-23e6-4824-816d-3be38952b6d0','en'),

(66,73,'page','8390d0b3-44ba-4a3b-b889-fcf5c78d4652','en'),

(67,74,'page','dcc51004-38da-4e70-8c88-3ff471a3b42e','en'),

(68,75,'page','2e519922-efe3-4fc0-8ad6-89b856cfb6f5','en'),

(69,76,'page','c65bc4de-f3a1-4b0a-9fa4-3e5d00d314b9','en'),

(70,77,'page','3929acea-333b-4f14-a03a-91ff4c316fef','en'),

(71,78,'page','cd4150c7-2d0a-4527-9901-85581e5d7461','en'),

(72,79,'page','cdb0cd5b-abd6-4ad1-9b6c-6e0ae4e38ed1','en'),

(73,80,'webform','17ef62e3-5b2c-4119-aea0-acb31e6bfd7f','en'),

(74,81,'page','9e5433a4-c2a3-4ba6-ac14-25193f6c6cda','en'),

(75,82,'page','bbd50e6e-0700-4879-90c4-9fb465bcc4ef','en'),

(76,83,'gallery_item','8c72b640-a997-439d-9cb2-0cfd9daa9fde','en'),

(77,84,'gallery_item','6e0ca936-00bc-482d-b0d9-8ec410f0f3d1','en'),

(78,85,'gallery_item','8da051af-2eb0-41ac-95d3-cc08bf9a1cfb','en'),

(79,86,'gallery_item','d37b4a40-9265-4f0b-975d-618d777a8a0f','en'),

(80,87,'gallery_item','064d30ae-665b-419d-80df-3622ccf59c4d','en'),

(81,88,'gallery_item','1250ca5c-d126-4adb-8659-c1e300136a3b','en'),

(82,89,'gallery_item','e15bd05f-6ef0-45c6-ab4b-a8ee71e6a839','en'),

(83,90,'gallery_item','57a91c74-d7ee-479f-a4eb-15351aef984e','en'),

(84,91,'gallery_item','916fbf66-50f7-4f23-8e22-1f7d4d0b9752','en'),

(85,92,'gallery_item','c0987c22-6171-4974-bf8d-3b5bb048aed1','en'),

(86,93,'gallery_item','4c2dc989-56c8-44c3-b005-358e5e52aba6','en'),

(87,94,'gallery_item','81c1fc38-d7d0-4373-b043-f1567768c577','en'),

(88,95,'gallery_item','80ea17ec-780b-4371-8e4b-1d010266c6f2','en'),

(89,96,'gallery_item','37277234-fa3c-41bb-82dc-4fac845c61c8','en'),

(90,97,'gallery_item','40da6255-ce89-4daa-a5a1-82e31b4ac53a','en'),

(91,98,'gallery_item','9c2e477e-0292-4162-93d2-f68b6e19d8fc','en'),

(92,99,'gallery_item','47c34ff0-2237-41d4-add9-4e132a3d25c7','en'),

(93,100,'gallery_item','957b7662-ff0d-4abc-ae16-6ceb86eda59d','en'),

(94,101,'gallery_item','83db2800-02b3-438a-ae2f-3a8f0ec74cdf','en'),

(95,102,'page','f55790a1-9315-419a-93e8-e81b51de38c3','en'),

(96,103,'page','bf8d01f9-b49b-4b2f-bfec-c03fd6597602','en'),

(97,104,'page','f1ab983a-f4be-4f62-ba21-434e564b76c1','en'),

(98,105,'webform','94127080-d518-488d-9095-f0551a668808','en'),

(99,106,'gallery_item','177c9df4-162e-468f-b7b4-d70a456c3442','en'),

(100,107,'page','7594a4c9-b7e7-4c17-83c1-24271d2ff17e','en'),

(101,108,'page','2e3ae0b9-2bc3-41e2-b551-968c1c61b94c','en'),

(102,109,'page','d9038104-0d99-43e3-beac-5d2c114bff9a','en'),

(103,110,'page','290af5c7-6713-4382-a98b-d879e070c3a3','en'),

(107,114,'page','1fd8bc46-1469-4d32-abc5-0e65a6cc3e16','en');

/*Table structure for table `node__body` */

DROP TABLE IF EXISTS `node__body`;

CREATE TABLE `node__body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext NOT NULL,
  `body_summary` longtext,
  `body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field body.';

/*Data for the table `node__body` */

insert  into `node__body`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`body_value`,`body_summary`,`body_format`) values 

('nd_blog',0,2,2,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<p>&nbsp;SOMEONE FAMOUS IN&nbsp;<cite>SOURCE TITLE</cite></p>\r\n</blockquote>\r\n\r\n<p>Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul>\r\n	<li>First item of the list</li>\r\n	<li>Second item of the list</li>\r\n	<li>Third item of the list</li>\r\n</ul>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','basic_html'),

('nd_blog',0,3,3,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<p>&nbsp;SOMEONE FAMOUS IN&nbsp;<cite>SOURCE TITLE</cite></p>\r\n</blockquote>\r\n\r\n<p>Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul>\r\n	<li>First item of the list</li>\r\n	<li>Second item of the list</li>\r\n	<li>Third item of the list</li>\r\n</ul>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary: Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','basic_html'),

('nd_blog',0,4,4,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<p>&nbsp;SOMEONE FAMOUS IN&nbsp;<cite>SOURCE TITLE</cite></p>\r\n</blockquote>\r\n\r\n<p>Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul>\r\n	<li>First item of the list</li>\r\n	<li>Second item of the list</li>\r\n	<li>Third item of the list</li>\r\n</ul>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary: Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','ckeditor'),

('nd_blog',0,5,5,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<p>&nbsp;SOMEONE FAMOUS IN&nbsp;<cite>SOURCE TITLE</cite></p>\r\n</blockquote>\r\n\r\n<p>Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul>\r\n	<li>First item of the list</li>\r\n	<li>Second item of the list</li>\r\n	<li>Third item of the list</li>\r\n</ul>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary: Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','ckeditor'),

('nd_blog',0,6,6,'en',0,'<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote style=\"box-sizing: border-box; padding: 0px; margin: 3em 0px; font-size: 17.5px; border: none; line-height: 1.7; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; background-image: none; background-attachment: initial; background-size: initial; background-origin: initial; background-clip: initial; background-position: initial; background-repeat: initial;\">\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 1em; font-size: 24px; line-height: 1.6;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<footer style=\"box-sizing: border-box; font-size: 11px; line-height: 1.42857143; text-transform: uppercase; letter-spacing: 2px;\">&nbsp;SOMEONE FAMOUS IN&nbsp;<cite style=\"box-sizing: border-box;\" title=\"Source Title\">SOURCE TITLE</cite></footer>\r\n</blockquote>\r\n\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\" style=\"box-sizing: border-box; color: rgb(17, 17, 17); -webkit-tap-highlight-color: transparent; background-color: transparent;\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul style=\"box-sizing: border-box; margin: 0px 0px 1.5em; -webkit-tap-highlight-color: transparent; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">\r\n	<li style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent;\">First item of the list</li>\r\n	<li style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent;\">Second item of the list</li>\r\n	<li style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent;\">Third item of the list</li>\r\n</ul>\r\n\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary: Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','ckeditor'),

('nd_blog',0,7,7,'en',0,'[nd_video url=\"https://www.youtube.com/watch?v=w2JUhDd0CAA\" different_values=\"0\"] [/nd_video]','','shortcodes'),

('nd_blog',0,8,8,'en',0,'<p>Suspendisse accumsan interdum tellus, eu imperdiet lacus consectetur sed. Aliquam in ligula ac lacus blandit commodo vel luctus quam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Cras eu ultrices mauris.</p>\r\n','','ckeditor'),

('nd_blog',0,9,9,'en',0,'[nd_quote different_values=\"0\" type=\"blog-item-q\" class=\"ui-sortable-handle\"]\r\n[html format=\"full_html\" different_values=\"0\"]<p>Curabitur iaculis, ligula facilisis volutpat suscipit, sapien felis tempor, consequat vitae velit</p>[/html]\r\n[/nd_quote]\r\n ','','shortcodes'),

('nd_portfolio',0,10,10,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,11,11,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,12,12,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,13,13,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,14,14,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,15,15,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,16,16,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,17,17,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,18,18,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,19,19,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,20,20,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,21,21,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,22,22,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,23,23,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,24,24,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,25,25,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,26,26,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,27,27,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,28,28,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,29,29,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,30,30,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,31,31,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,32,32,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,33,33,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('page',0,34,41,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\" multiple_active=\"1\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,35,42,'en',0,'[nd_bg different_values=\"0\" banner=\"0\" slider=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_chartpie stroke_color=\"bc1616\" donut=\"0\" different_values=\"0\"]\r\n[nd_chartpieitem title=\"Teach Profile\" value=\"30\" value_color=\"ea052c\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Blocks\" value=\"30\" value_color=\"8b0202\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Us 3\" value=\"40\" value_color=\"f42424\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[/nd_chartpie]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_chartpie stroke_color=\"bc1616\" donut=\"1\" different_values=\"0\"]\r\n[nd_chartpieitem title=\"Teach Profile\" value=\"20\" value_color=\"b72425\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Blocks\" value=\"30\" value_color=\"890000\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Us 3\" value=\"40\" value_color=\"fb2122\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Us 3\" value=\"10\" value_color=\"fc0000\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[/nd_chartpie]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg different_values=\"0\" banner=\"0\" slider=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_counter title=\"Current Year\" icon=\"fa fa-calendar\" number=\"2017\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg different_values=\"0\" banner=\"0\" slider=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_progress type=\"Thin Line\" different_values=\"0\" frames=\"10\" duration=\"2000\" percent=\"85\" title=\"Brending\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Thin Line\" title=\"Design\" percent=\"80\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Thin Line\" title=\"Development\" percent=\"85\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Thin Line\" title=\"Photography\" percent=\"75\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_bg different_values=\"0\" extra_classes=\"page-section\" banner=\"0\" slider=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[col tablet=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_progress type=\"Wide Line\" title=\"Branding\" percent=\"80\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Wide Line\" title=\"Design\" percent=\"85\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Wide Line\" title=\"Development\" percent=\"75\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Wide Line\" title=\"Photography\" percent=\"70\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/nd_container]\r\n[/nd_bg]\r\n ','','shortcodes'),

('page',0,36,43,'en',0,'[nd_bg banner=\"0\" slider=\"0\" extra_classes=\"page-section\" different_values=\"0\" bg_repeat=\"repeat\" no_paddings=\"0\" bg_texture=\"0\" full_height=\"0\" full_width_container=\"0\" full_width=\"1\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_title extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" different_values=\"0\" title=\"Buttons on white\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col wide=\"3\" desktop=\"3\" tablet=\"6\" different_values=\"0\" style_margin_bottom=\"40\"]\r\n[nd_button block=\"1\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"large\" border=\"0\"]\r\n[/nd_button]\r\n[nd_button different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"medium\" block=\"1\" border=\"0\"]\r\n[/nd_button]\r\n[nd_button different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"small\" block=\"1\"]\r\n[/nd_button]\r\n[nd_button different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" block=\"1\" border=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[col wide=\"3\" desktop=\"3\" tablet=\"6\" different_values=\"0\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" block=\"1\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"large\" border=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"medium\" block=\"1\" border=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"small\" block=\"1\" border=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" block=\"1\" border=\"1\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" size=\"large\" color=\"dark\" text=\"Button\" invert=\"0\"]\r\n[/nd_button]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" size=\"medium\" color=\"dark\" text=\"Button\"]\r\n[/nd_button]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" size=\"small\" color=\"dark\" text=\"Button\"]\r\n[/nd_button]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" color=\"dark\" text=\"Button\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"dark\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"dark\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"dark\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" color=\"dark\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg extra_classes=\"page-section\" different_values=\"0\" bg_repeat=\"repeat\" no_paddings=\"0\" bg_texture=\"0\" full_height=\"0\" full_width_container=\"0\" full_width=\"1\" color=\"bg-dark-lighter\" slider=\"0\" banner=\"0\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Buttons on dark\" size=\"h2\" extra_classes=\"section-title mb-70 mb-sm-40\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\" button_type=\"border\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\" button_type=\"border\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\" button_type=\"border\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\" button_type=\"border\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button icon=\"fa fa-usd\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-glass\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-heart\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-envelope\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" icon=\"fa fa-usd\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" icon=\"fa fa-glass\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" icon=\"fa fa-heart\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" icon=\"fa fa-envelope\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button icon=\"fa fa-usd\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-glass\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-heart\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-envelope\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"0\" button_type=\"glass\"]\r\n[/nd_button]\r\n[nd_button invert=\"0\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\" button_type=\"glass\"]\r\n[/nd_button]\r\n[nd_button invert=\"0\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\" button_type=\"glass\"]\r\n[/nd_button]\r\n[nd_button invert=\"0\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\" icon_position=\"beside\" button_type=\"glass\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n ','','shortcodes'),

('page',0,37,44,'en',0,'[nd_container different_values=\"0\"]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-camera\" text=\"photography\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Cras luctus interdum sodales. Quisque quis odio dui. Sedes sit amet neque malesuada, lobortis commodo magna ntesque pharetra metus vivera sagittis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-tools-2\" text=\"development\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Fusce aliquet quam eget neque ultrices elementum. Nulla posuere felis id arcu blandit sagittis. Eleifender vestibulum purus, sit amet vulputate risus.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-anchor\" text=\"support\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. Praesent sed nisi eleifend, fermentum orci sit amet, iaculis libero interdum.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_feature type=\"benefit\" different_values=\"0\" icon=\"fa fa-paper-plane-o\" text=\"Ideas\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]Donec pulvinar rutrum mi, sit amet viverra justo hendrerit eget.[/html]\r\n[/nd_feature]\r\n[nd_feature type=\"benefit\" different_values=\"0\" icon=\"fa fa-cogs\" text=\"Discussions\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]Mauris tincidunt augue interdum phasellus luctus commodo.[/html]\r\n[/nd_feature]\r\n[nd_feature type=\"benefit\" different_values=\"0\" icon=\"fa fa-tencent-weibo\" text=\"Design\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]Sed sed dictum nibh. Vivamus semper eros nec consequat.[/html]\r\n[/nd_feature]\r\n[nd_feature type=\"benefit\" different_values=\"0\" icon=\"fa fa-life-ring\" text=\"Development\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]Donec pulvinar rutrum mi, sit amet viverra justo hendrerit eget.[/html]\r\n[/nd_feature]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"100\" style_margin_bottom=\"100\"]\r\n[/nd_hr]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row extra_classes=\"multi-columns-row\" different_values=\"0\"]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-service\" text=\"Branding\" icon=\"fa fa-paper-plane-o\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-service\" text=\"Web Design\" icon=\"fa fa-cogs\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Vivamus neque orci, ultricies blandit ultricies vel, semper interdum elit, non placerat suscipit.[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-service\" text=\"Logo Design\" icon=\"fa fa-tencent-weibo\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-service\" text=\"Support\" icon=\"fa fa-life-ring\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Semper interdum ultricies elit, non placerat nisi suscipit . Morbi dignissim nunc at risus convallis[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row extra_classes=\"alt-features-grid\" different_values=\"0\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-features\" text=\"Work process\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit.In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-features\" text=\"1. Discussion\" different_values=\"0\" icon=\"icon-chat\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-features\" text=\"2. Making\" different_values=\"0\" icon=\"icon-browser\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-features\" text=\"3. Production\" different_values=\"0\" icon=\"icon-heart\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,38,45,'en',0,'[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_text_n_tooltip second_text=\" consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" tooltip_popup=\"Title text here\" tooltip=\"tooltip top\" first_text=\"Lorem ipsum dolor sit amet, \" title_size=\"H5\" title=\"One half\" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_text_n_tooltip title=\"One half\" title_size=\"H5\" first_text=\"Lorem ipsum dolor \" tooltip=\"tooltip bottom\" tooltip_popup=\"Title text here\" second_text=\" sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[/row]\r\n[nd_hr different_values=\"0\" style_padding_top=\"40\" style_padding_bottom=\"40\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"4\"]\r\n[nd_text_n_tooltip title=\"One third\" title_size=\"H5\" first_text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"4\"]\r\n[nd_text_n_tooltip title=\"One third\" title_size=\"H5\" first_text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"4\"]\r\n[nd_text_n_tooltip title=\"One third\" title_size=\"H5\" first_text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[/row]\r\n[nd_hr different_values=\"0\" style_padding_top=\"40\" style_padding_bottom=\"40\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"3\"]\r\n[nd_text_n_tooltip different_values=\"0\" first_text=\"Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" title_size=\"H5\" title=\"One fourth\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"3\"]\r\n[nd_text_n_tooltip different_values=\"0\" first_text=\"Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" title_size=\"H5\" title=\"One fourth\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"3\"]\r\n[nd_text_n_tooltip different_values=\"0\" first_text=\"Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" title_size=\"H5\" title=\"One fourth\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"3\"]\r\n[nd_text_n_tooltip different_values=\"0\" first_text=\"Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" title_size=\"H5\" title=\"One fourth\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,39,46,'en',0,'<div class=\"row\">\r\n                        <div class=\"col-md-8 col-md-offset-2 mb-30\">\r\n                            \r\n                            <div class=\"section-text align-center\">\r\n                                \r\n                                <p>\r\n                                    You can use a set of <a href=\"http://www.elegantthemes.com/blog/resources/how-to-use-and-embed-an-icon-font-on-your-website\" target=\"_blank\">100+ ET-Line Icons</a>\r\n                                </p>\r\n                                \r\n                                <div class=\"row\">\r\n                                    <div class=\"col-md-8 col-md-offset-2\">\r\n                                        \r\n                                        <div class=\"highlight\">\r\n                                            <pre><code class=\"html\">&lt;span class=\"icon-heart\"&gt;&lt;/span&gt; icon-heart</code></pre>\r\n                                        </div>\r\n                                        \r\n                                        <p>\r\n                                            <strong class=\"small\">Result:</strong>\r\n                                            &nbsp;<span class=\"icon-heart\"></span>\r\n                                            fa-heart\r\n                                        </p>\r\n                                        \r\n                                    </div>\r\n                                </div>\r\n                            </div>\r\n                            \r\n                        </div>\r\n                    </div>\r\n<div class=\"et-examples\">\r\n                        \r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-mobile\"></span>&nbsp;icon-mobile</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-laptop\"></span>&nbsp;icon-laptop</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-desktop\"></span>&nbsp;icon-desktop</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-tablet\"></span>&nbsp;icon-tablet</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-phone\"></span>&nbsp;icon-phone</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-document\"></span>&nbsp;icon-document</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-documents\"></span>&nbsp;icon-documents</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-search\"></span>&nbsp;icon-search</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-clipboard\"></span>&nbsp;icon-clipboard</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-newspaper\"></span>&nbsp;icon-newspaper</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-notebook\"></span>&nbsp;icon-notebook</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-book-open\"></span>&nbsp;icon-book-open</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-browser\"></span>&nbsp;icon-browser</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-calendar\"></span>&nbsp;icon-calendar</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-presentation\"></span>&nbsp;icon-presentation</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-picture\"></span>&nbsp;icon-picture</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-pictures\"></span>&nbsp;icon-pictures</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-video\"></span>&nbsp;icon-video</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-camera\"></span>&nbsp;icon-camera</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-printer\"></span>&nbsp;icon-printer</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-toolbox\"></span>&nbsp;icon-toolbox</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-briefcase\"></span>&nbsp;icon-briefcase</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-wallet\"></span>&nbsp;icon-wallet</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-gift\"></span>&nbsp;icon-gift</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-bargraph\"></span>&nbsp;icon-bargraph</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-grid\"></span>&nbsp;icon-grid</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-expand\"></span>&nbsp;icon-expand</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-focus\"></span>&nbsp;icon-focus</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-edit\"></span>&nbsp;icon-edit</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-adjustments\"></span>&nbsp;icon-adjustments</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-ribbon\"></span>&nbsp;icon-ribbon</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-hourglass\"></span>&nbsp;icon-hourglass</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-lock\"></span>&nbsp;icon-lock</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-megaphone\"></span>&nbsp;icon-megaphone</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-shield\"></span>&nbsp;icon-shield</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-trophy\"></span>&nbsp;icon-trophy</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-flag\"></span>&nbsp;icon-flag</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-map\"></span>&nbsp;icon-map</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-puzzle\"></span>&nbsp;icon-puzzle</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-basket\"></span>&nbsp;icon-basket</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-envelope\"></span>&nbsp;icon-envelope</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-streetsign\"></span>&nbsp;icon-streetsign</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-telescope\"></span>&nbsp;icon-telescope</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-gears\"></span>&nbsp;icon-gears</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-key\"></span>&nbsp;icon-key</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-paperclip\"></span>&nbsp;icon-paperclip</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-attachment\"></span>&nbsp;icon-attachment</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-pricetags\"></span>&nbsp;icon-pricetags</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-lightbulb\"></span>&nbsp;icon-lightbulb</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-layers\"></span>&nbsp;icon-layers</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-pencil\"></span>&nbsp;icon-pencil</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-tools\"></span>&nbsp;icon-tools</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-tools-2\"></span>&nbsp;icon-tools-2</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-scissors\"></span>&nbsp;icon-scissors</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-paintbrush\"></span>&nbsp;icon-paintbrush</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-magnifying-glass\"></span>&nbsp;icon-magnifying-glass</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-circle-compass\"></span>&nbsp;icon-circle-compass</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-linegraph\"></span>&nbsp;icon-linegraph</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-mic\"></span>&nbsp;icon-mic</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-strategy\"></span>&nbsp;icon-strategy</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-beaker\"></span>&nbsp;icon-beaker</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-caution\"></span>&nbsp;icon-caution</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-recycle\"></span>&nbsp;icon-recycle</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-anchor\"></span>&nbsp;icon-anchor</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-profile-male\"></span>&nbsp;icon-profile-male</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-profile-female\"></span>&nbsp;icon-profile-female</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-bike\"></span>&nbsp;icon-bike</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-wine\"></span>&nbsp;icon-wine</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-hotairballoon\"></span>&nbsp;icon-hotairballoon</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-globe\"></span>&nbsp;icon-globe</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-genius\"></span>&nbsp;icon-genius</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-map-pin\"></span>&nbsp;icon-map-pin</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-dial\"></span>&nbsp;icon-dial</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-chat\"></span>&nbsp;icon-chat</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-heart\"></span>&nbsp;icon-heart</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-cloud\"></span>&nbsp;icon-cloud</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-upload\"></span>&nbsp;icon-upload</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-download\"></span>&nbsp;icon-download</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-target\"></span>&nbsp;icon-target</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-hazardous\"></span>&nbsp;icon-hazardous</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-piechart\"></span>&nbsp;icon-piechart</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-speedometer\"></span>&nbsp;icon-speedometer</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-global\"></span>&nbsp;icon-global</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-compass\"></span>&nbsp;icon-compass</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-lifesaver\"></span>&nbsp;icon-lifesaver</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-clock\"></span>&nbsp;icon-clock</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-aperture\"></span>&nbsp;icon-aperture</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-quote\"></span>&nbsp;icon-quote</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-scope\"></span>&nbsp;icon-scope</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-alarmclock\"></span>&nbsp;icon-alarmclock</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-refresh\"></span>&nbsp;icon-refresh</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-happy\"></span>&nbsp;icon-happy</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-sad\"></span>&nbsp;icon-sad</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-facebook\"></span>&nbsp;icon-facebook</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-twitter\"></span>&nbsp;icon-twitter</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-googleplus\"></span>&nbsp;icon-googleplus</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-rss\"></span>&nbsp;icon-rss</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-tumblr\"></span>&nbsp;icon-tumblr</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-linkedin\"></span>&nbsp;icon-linkedin</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-dribbble\"></span>&nbsp;icon-dribbble</span>\r\n                            \r\n                    </div>','','shortcodes'),

('page',0,40,47,'en',0,'<div class=\"row\">\r\n                        <div class=\"col-md-8 col-md-offset-2 mb-30\">\r\n                            \r\n                            <div class=\"section-text align-center\">\r\n                                \r\n                                <p>\r\n                                    You can use a set of <a href=\"http://fontawesome.io/icons/\" target=\"_blank\">400+ icons from Font Awesome</a>\r\n                                </p>\r\n                                \r\n                                <div class=\"row\">\r\n                                    <div class=\"col-md-8 col-md-offset-2\">\r\n                                        \r\n                                        <div class=\"highlight\">\r\n                                            <pre><code class=\"html\">&lt;i class=\"fa fa-heart\"&gt;&lt;/i&gt; fa-heart</code></pre>\r\n                                        </div>\r\n                                        \r\n                                        <p>\r\n                                            <strong class=\"small\">Result:</strong>\r\n                                            &nbsp;<i class=\"fa fa-heart\"></i>\r\n                                            fa-heart\r\n                                        </p>\r\n                                        \r\n                                    </div>\r\n                                </div>\r\n                            </div>\r\n                            \r\n                        </div>\r\n                    </div>\r\n<div class=\"row fa-examples\">\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-adjust<span class=\"muted\">[&amp;#xf042;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-adn<span class=\"muted\">[&amp;#xf170;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-align-center<span class=\"muted\">[&amp;#xf037;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-align-justify<span class=\"muted\">[&amp;#xf039;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-align-left<span class=\"muted\">[&amp;#xf036;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-align-right<span class=\"muted\">[&amp;#xf038;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ambulance<span class=\"muted\">[&amp;#xf0f9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-anchor<span class=\"muted\">[&amp;#xf13d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-android<span class=\"muted\">[&amp;#xf17b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-double-down<span class=\"muted\">[&amp;#xf103;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-double-left<span class=\"muted\">[&amp;#xf100;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-double-right<span class=\"muted\">[&amp;#xf101;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-double-up<span class=\"muted\">[&amp;#xf102;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-down<span class=\"muted\">[&amp;#xf107;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-left<span class=\"muted\">[&amp;#xf104;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-right<span class=\"muted\">[&amp;#xf105;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-up<span class=\"muted\">[&amp;#xf106;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-apple<span class=\"muted\">[&amp;#xf179;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-archive<span class=\"muted\">[&amp;#xf187;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-down<span class=\"muted\">[&amp;#xf0ab;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-left<span class=\"muted\">[&amp;#xf0a8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-o-down<span class=\"muted\">[&amp;#xf01a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-o-left<span class=\"muted\">[&amp;#xf190;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-o-right<span class=\"muted\">[&amp;#xf18e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-o-up<span class=\"muted\">[&amp;#xf01b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-right<span class=\"muted\">[&amp;#xf0a9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-up<span class=\"muted\">[&amp;#xf0aa;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-down<span class=\"muted\">[&amp;#xf063;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-left<span class=\"muted\">[&amp;#xf060;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-right<span class=\"muted\">[&amp;#xf061;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-up<span class=\"muted\">[&amp;#xf062;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrows<span class=\"muted\">[&amp;#xf047;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrows-alt<span class=\"muted\">[&amp;#xf0b2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrows-h<span class=\"muted\">[&amp;#xf07e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrows-v<span class=\"muted\">[&amp;#xf07d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-asterisk<span class=\"muted\">[&amp;#xf069;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-automobile<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1b9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-backward<span class=\"muted\">[&amp;#xf04a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ban<span class=\"muted\">[&amp;#xf05e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bank<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf19c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bar-chart-o<span class=\"muted\">[&amp;#xf080;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-barcode<span class=\"muted\">[&amp;#xf02a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bars<span class=\"muted\">[&amp;#xf0c9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-beer<span class=\"muted\">[&amp;#xf0fc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-behance<span class=\"muted\">[&amp;#xf1b4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-behance-square<span class=\"muted\">[&amp;#xf1b5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bell<span class=\"muted\">[&amp;#xf0f3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bell-o<span class=\"muted\">[&amp;#xf0a2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bitbucket<span class=\"muted\">[&amp;#xf171;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bitbucket-square<span class=\"muted\">[&amp;#xf172;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bitcoin<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf15a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bold<span class=\"muted\">[&amp;#xf032;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bolt<span class=\"muted\">[&amp;#xf0e7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bomb<span class=\"muted\">[&amp;#xf1e2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-book<span class=\"muted\">[&amp;#xf02d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bookmark<span class=\"muted\">[&amp;#xf02e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bookmark-o<span class=\"muted\">[&amp;#xf097;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-briefcase<span class=\"muted\">[&amp;#xf0b1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-btc<span class=\"muted\">[&amp;#xf15a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bug<span class=\"muted\">[&amp;#xf188;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-building<span class=\"muted\">[&amp;#xf1ad;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-building-o<span class=\"muted\">[&amp;#xf0f7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bullhorn<span class=\"muted\">[&amp;#xf0a1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bullseye<span class=\"muted\">[&amp;#xf140;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cab<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1ba;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-calendar<span class=\"muted\">[&amp;#xf073;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-calendar-o<span class=\"muted\">[&amp;#xf133;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-camera<span class=\"muted\">[&amp;#xf030;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-camera-retro<span class=\"muted\">[&amp;#xf083;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-car<span class=\"muted\">[&amp;#xf1b9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-down<span class=\"muted\">[&amp;#xf0d7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-left<span class=\"muted\">[&amp;#xf0d9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-right<span class=\"muted\">[&amp;#xf0da;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-square-o-down<span class=\"muted\">[&amp;#xf150;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-square-o-left<span class=\"muted\">[&amp;#xf191;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-square-o-right<span class=\"muted\">[&amp;#xf152;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-square-o-up<span class=\"muted\">[&amp;#xf151;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-up<span class=\"muted\">[&amp;#xf0d8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-certificate<span class=\"muted\">[&amp;#xf0a3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chain<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chain-broken<span class=\"muted\">[&amp;#xf127;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check<span class=\"muted\">[&amp;#xf00c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check-circle<span class=\"muted\">[&amp;#xf058;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check-circle-o<span class=\"muted\">[&amp;#xf05d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check-square<span class=\"muted\">[&amp;#xf14a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check-square-o<span class=\"muted\">[&amp;#xf046;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-circle-down<span class=\"muted\">[&amp;#xf13a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-circle-left<span class=\"muted\">[&amp;#xf137;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-circle-right<span class=\"muted\">[&amp;#xf138;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-circle-up<span class=\"muted\">[&amp;#xf139;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-down<span class=\"muted\">[&amp;#xf078;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-left<span class=\"muted\">[&amp;#xf053;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-right<span class=\"muted\">[&amp;#xf054;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-up<span class=\"muted\">[&amp;#xf077;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-child<span class=\"muted\">[&amp;#xf1ae;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-circle<span class=\"muted\">[&amp;#xf111;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-circle-o<span class=\"muted\">[&amp;#xf10c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-circle-o-notch<span class=\"muted\">[&amp;#xf1ce;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-circle-thin<span class=\"muted\">[&amp;#xf1db;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-clipboard<span class=\"muted\">[&amp;#xf0ea;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-clock-o<span class=\"muted\">[&amp;#xf017;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cloud<span class=\"muted\">[&amp;#xf0c2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cloud-download<span class=\"muted\">[&amp;#xf0ed;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cloud-upload<span class=\"muted\">[&amp;#xf0ee;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cny<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf157;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-code<span class=\"muted\">[&amp;#xf121;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-code-fork<span class=\"muted\">[&amp;#xf126;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-codepen<span class=\"muted\">[&amp;#xf1cb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-coffee<span class=\"muted\">[&amp;#xf0f4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cog<span class=\"muted\">[&amp;#xf013;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cogs<span class=\"muted\">[&amp;#xf085;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-columns<span class=\"muted\">[&amp;#xf0db;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-comment<span class=\"muted\">[&amp;#xf075;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-comment-o<span class=\"muted\">[&amp;#xf0e5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-comments<span class=\"muted\">[&amp;#xf086;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-comments-o<span class=\"muted\">[&amp;#xf0e6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-compass<span class=\"muted\">[&amp;#xf14e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-compress<span class=\"muted\">[&amp;#xf066;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-copy<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-credit-card<span class=\"muted\">[&amp;#xf09d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-crop<span class=\"muted\">[&amp;#xf125;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-crosshairs<span class=\"muted\">[&amp;#xf05b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-css3<span class=\"muted\">[&amp;#xf13c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cube<span class=\"muted\">[&amp;#xf1b2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cubes<span class=\"muted\">[&amp;#xf1b3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cut<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cutlery<span class=\"muted\">[&amp;#xf0f5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dashboard<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0e4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-database<span class=\"muted\">[&amp;#xf1c0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dedent<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf03b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-delicious<span class=\"muted\">[&amp;#xf1a5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-desktop<span class=\"muted\">[&amp;#xf108;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-deviantart<span class=\"muted\">[&amp;#xf1bd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-digg<span class=\"muted\">[&amp;#xf1a6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dollar<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf155;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dot-circle-o<span class=\"muted\">[&amp;#xf192;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-download<span class=\"muted\">[&amp;#xf019;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dribbble<span class=\"muted\">[&amp;#xf17d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dropbox<span class=\"muted\">[&amp;#xf16b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-drupal<span class=\"muted\">[&amp;#xf1a9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-edit<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf044;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eject<span class=\"muted\">[&amp;#xf052;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ellipsis-h<span class=\"muted\">[&amp;#xf141;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ellipsis-v<span class=\"muted\">[&amp;#xf142;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-empire<span class=\"muted\">[&amp;#xf1d1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-envelope<span class=\"muted\">[&amp;#xf0e0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-envelope-o<span class=\"muted\">[&amp;#xf003;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-envelope-square<span class=\"muted\">[&amp;#xf199;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eraser<span class=\"muted\">[&amp;#xf12d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eur<span class=\"muted\">[&amp;#xf153;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-euro<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf153;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-exchange<span class=\"muted\">[&amp;#xf0ec;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-exclamation<span class=\"muted\">[&amp;#xf12a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-exclamation-circle<span class=\"muted\">[&amp;#xf06a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-exclamation-triangle<span class=\"muted\">[&amp;#xf071;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-expand<span class=\"muted\">[&amp;#xf065;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-external-link<span class=\"muted\">[&amp;#xf08e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-external-link-square<span class=\"muted\">[&amp;#xf14c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eye<span class=\"muted\">[&amp;#xf06e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eye-slash<span class=\"muted\">[&amp;#xf070;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-facebook<span class=\"muted\">[&amp;#xf09a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-facebook-square<span class=\"muted\">[&amp;#xf082;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fast-backward<span class=\"muted\">[&amp;#xf049;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fast-forward<span class=\"muted\">[&amp;#xf050;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fax<span class=\"muted\">[&amp;#xf1ac;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-female<span class=\"muted\">[&amp;#xf182;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fighter-jet<span class=\"muted\">[&amp;#xf0fb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file<span class=\"muted\">[&amp;#xf15b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-archive-o<span class=\"muted\">[&amp;#xf1c6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-audio-o<span class=\"muted\">[&amp;#xf1c7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-code-o<span class=\"muted\">[&amp;#xf1c9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-excel-o<span class=\"muted\">[&amp;#xf1c3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-image-o<span class=\"muted\">[&amp;#xf1c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-movie-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-o<span class=\"muted\">[&amp;#xf016;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-pdf-o<span class=\"muted\">[&amp;#xf1c1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-photo-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-picture-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-powerpoint-o<span class=\"muted\">[&amp;#xf1c4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-sound-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-text<span class=\"muted\">[&amp;#xf15c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-text-o<span class=\"muted\">[&amp;#xf0f6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-video-o<span class=\"muted\">[&amp;#xf1c8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-word-o<span class=\"muted\">[&amp;#xf1c2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-zip-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-files-o<span class=\"muted\">[&amp;#xf0c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-film<span class=\"muted\">[&amp;#xf008;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-filter<span class=\"muted\">[&amp;#xf0b0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fire<span class=\"muted\">[&amp;#xf06d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fire-extinguisher<span class=\"muted\">[&amp;#xf134;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flag<span class=\"muted\">[&amp;#xf024;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flag-checkered<span class=\"muted\">[&amp;#xf11e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flag-o<span class=\"muted\">[&amp;#xf11d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flash<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0e7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flask<span class=\"muted\">[&amp;#xf0c3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flickr<span class=\"muted\">[&amp;#xf16e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-floppy-o<span class=\"muted\">[&amp;#xf0c7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-folder<span class=\"muted\">[&amp;#xf07b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-folder-o<span class=\"muted\">[&amp;#xf114;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-folder-open<span class=\"muted\">[&amp;#xf07c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-folder-open-o<span class=\"muted\">[&amp;#xf115;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-font<span class=\"muted\">[&amp;#xf031;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-forward<span class=\"muted\">[&amp;#xf04e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-foursquare<span class=\"muted\">[&amp;#xf180;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-frown-o<span class=\"muted\">[&amp;#xf119;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gamepad<span class=\"muted\">[&amp;#xf11b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gavel<span class=\"muted\">[&amp;#xf0e3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gbp<span class=\"muted\">[&amp;#xf154;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ge<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gear<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf013;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gears<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf085;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gift<span class=\"muted\">[&amp;#xf06b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-git<span class=\"muted\">[&amp;#xf1d3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-git-square<span class=\"muted\">[&amp;#xf1d2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-github<span class=\"muted\">[&amp;#xf09b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-github-alt<span class=\"muted\">[&amp;#xf113;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-github-square<span class=\"muted\">[&amp;#xf092;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gittip<span class=\"muted\">[&amp;#xf184;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-glass<span class=\"muted\">[&amp;#xf000;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-globe<span class=\"muted\">[&amp;#xf0ac;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-google<span class=\"muted\">[&amp;#xf1a0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-google-plus<span class=\"muted\">[&amp;#xf0d5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-google-plus-square<span class=\"muted\">[&amp;#xf0d4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-graduation-cap<span class=\"muted\">[&amp;#xf19d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-group<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-h-square<span class=\"muted\">[&amp;#xf0fd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hacker-news<span class=\"muted\">[&amp;#xf1d4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hand-o-down<span class=\"muted\">[&amp;#xf0a7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hand-o-left<span class=\"muted\">[&amp;#xf0a5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hand-o-right<span class=\"muted\">[&amp;#xf0a4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hand-o-up<span class=\"muted\">[&amp;#xf0a6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hdd-o<span class=\"muted\">[&amp;#xf0a0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-header<span class=\"muted\">[&amp;#xf1dc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-headphones<span class=\"muted\">[&amp;#xf025;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-heart<span class=\"muted\">[&amp;#xf004;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-heart-o<span class=\"muted\">[&amp;#xf08a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-history<span class=\"muted\">[&amp;#xf1da;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-home<span class=\"muted\">[&amp;#xf015;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hospital-o<span class=\"muted\">[&amp;#xf0f8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-html5<span class=\"muted\">[&amp;#xf13b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-image<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf03e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-inbox<span class=\"muted\">[&amp;#xf01c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-indent<span class=\"muted\">[&amp;#xf03c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-info<span class=\"muted\">[&amp;#xf129;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-info-circle<span class=\"muted\">[&amp;#xf05a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-inr<span class=\"muted\">[&amp;#xf156;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-instagram<span class=\"muted\">[&amp;#xf16d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-institution<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf19c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-italic<span class=\"muted\">[&amp;#xf033;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-joomla<span class=\"muted\">[&amp;#xf1aa;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-jpy<span class=\"muted\">[&amp;#xf157;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-jsfiddle<span class=\"muted\">[&amp;#xf1cc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-key<span class=\"muted\">[&amp;#xf084;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-keyboard-o<span class=\"muted\">[&amp;#xf11c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-krw<span class=\"muted\">[&amp;#xf159;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-language<span class=\"muted\">[&amp;#xf1ab;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-laptop<span class=\"muted\">[&amp;#xf109;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-leaf<span class=\"muted\">[&amp;#xf06c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-legal<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0e3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-lemon-o<span class=\"muted\">[&amp;#xf094;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-level-down<span class=\"muted\">[&amp;#xf149;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-level-up<span class=\"muted\">[&amp;#xf148;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-life-bouy<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-life-ring<span class=\"muted\">[&amp;#xf1cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-life-saver<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-lightbulb-o<span class=\"muted\">[&amp;#xf0eb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-link<span class=\"muted\">[&amp;#xf0c1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-linkedin<span class=\"muted\">[&amp;#xf0e1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-linkedin-square<span class=\"muted\">[&amp;#xf08c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-linux<span class=\"muted\">[&amp;#xf17c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-list<span class=\"muted\">[&amp;#xf03a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-list-alt<span class=\"muted\">[&amp;#xf022;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-list-ol<span class=\"muted\">[&amp;#xf0cb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-list-ul<span class=\"muted\">[&amp;#xf0ca;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-location-arrow<span class=\"muted\">[&amp;#xf124;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-lock<span class=\"muted\">[&amp;#xf023;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-long-arrow-down<span class=\"muted\">[&amp;#xf175;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-long-arrow-left<span class=\"muted\">[&amp;#xf177;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-long-arrow-right<span class=\"muted\">[&amp;#xf178;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-long-arrow-up<span class=\"muted\">[&amp;#xf176;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-magic<span class=\"muted\">[&amp;#xf0d0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-magnet<span class=\"muted\">[&amp;#xf076;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mail-forward<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf064;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mail-reply<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf112;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mail-reply-all<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf122;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-male<span class=\"muted\">[&amp;#xf183;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-map-marker<span class=\"muted\">[&amp;#xf041;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-maxcdn<span class=\"muted\">[&amp;#xf136;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-medkit<span class=\"muted\">[&amp;#xf0fa;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-meh-o<span class=\"muted\">[&amp;#xf11a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-microphone<span class=\"muted\">[&amp;#xf130;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-microphone-slash<span class=\"muted\">[&amp;#xf131;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-minus<span class=\"muted\">[&amp;#xf068;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-minus-circle<span class=\"muted\">[&amp;#xf056;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-minus-square<span class=\"muted\">[&amp;#xf146;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-minus-square-o<span class=\"muted\">[&amp;#xf147;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mobile<span class=\"muted\">[&amp;#xf10b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mobile-phone<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf10b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-money<span class=\"muted\">[&amp;#xf0d6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-moon-o<span class=\"muted\">[&amp;#xf186;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mortar-board<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf19d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-music<span class=\"muted\">[&amp;#xf001;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-navicon<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-openid<span class=\"muted\">[&amp;#xf19b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-outdent<span class=\"muted\">[&amp;#xf03b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pagelines<span class=\"muted\">[&amp;#xf18c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paper-plane<span class=\"muted\">[&amp;#xf1d8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paper-plane-o<span class=\"muted\">[&amp;#xf1d9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paperclip<span class=\"muted\">[&amp;#xf0c6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paragraph<span class=\"muted\">[&amp;#xf1dd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paste<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0ea;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pause<span class=\"muted\">[&amp;#xf04c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paw<span class=\"muted\">[&amp;#xf1b0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pencil<span class=\"muted\">[&amp;#xf040;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pencil-square<span class=\"muted\">[&amp;#xf14b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pencil-square-o<span class=\"muted\">[&amp;#xf044;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-phone<span class=\"muted\">[&amp;#xf095;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-phone-square<span class=\"muted\">[&amp;#xf098;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-photo<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf03e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-picture-o<span class=\"muted\">[&amp;#xf03e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pied-piper<span class=\"muted\">[&amp;#xf1a7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pied-piper-alt<span class=\"muted\">[&amp;#xf1a8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pied-piper-square<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1a7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pinterest<span class=\"muted\">[&amp;#xf0d2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pinterest-square<span class=\"muted\">[&amp;#xf0d3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plane<span class=\"muted\">[&amp;#xf072;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-play<span class=\"muted\">[&amp;#xf04b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-play-circle<span class=\"muted\">[&amp;#xf144;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-play-circle-o<span class=\"muted\">[&amp;#xf01d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plus<span class=\"muted\">[&amp;#xf067;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plus-circle<span class=\"muted\">[&amp;#xf055;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plus-square<span class=\"muted\">[&amp;#xf0fe;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plus-square-o<span class=\"muted\">[&amp;#xf196;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-power-off<span class=\"muted\">[&amp;#xf011;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-print<span class=\"muted\">[&amp;#xf02f;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-puzzle-piece<span class=\"muted\">[&amp;#xf12e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-qq<span class=\"muted\">[&amp;#xf1d6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-qrcode<span class=\"muted\">[&amp;#xf029;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-question<span class=\"muted\">[&amp;#xf128;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-question-circle<span class=\"muted\">[&amp;#xf059;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-quote-left<span class=\"muted\">[&amp;#xf10d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-quote-right<span class=\"muted\">[&amp;#xf10e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ra<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-random<span class=\"muted\">[&amp;#xf074;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rebel<span class=\"muted\">[&amp;#xf1d0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-recycle<span class=\"muted\">[&amp;#xf1b8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reddit<span class=\"muted\">[&amp;#xf1a1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reddit-square<span class=\"muted\">[&amp;#xf1a2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-refresh<span class=\"muted\">[&amp;#xf021;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-renren<span class=\"muted\">[&amp;#xf18b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reorder<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-repeat<span class=\"muted\">[&amp;#xf01e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reply<span class=\"muted\">[&amp;#xf112;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reply-all<span class=\"muted\">[&amp;#xf122;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-retweet<span class=\"muted\">[&amp;#xf079;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rmb<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf157;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-road<span class=\"muted\">[&amp;#xf018;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rocket<span class=\"muted\">[&amp;#xf135;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rotate-left<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0e2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rotate-right<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf01e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rouble<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf158;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rss<span class=\"muted\">[&amp;#xf09e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rss-square<span class=\"muted\">[&amp;#xf143;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rub<span class=\"muted\">[&amp;#xf158;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ruble<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf158;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rupee<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf156;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-save<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-scissors<span class=\"muted\">[&amp;#xf0c4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-search<span class=\"muted\">[&amp;#xf002;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-search-minus<span class=\"muted\">[&amp;#xf010;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-search-plus<span class=\"muted\">[&amp;#xf00e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-send<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-send-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share<span class=\"muted\">[&amp;#xf064;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share-alt<span class=\"muted\">[&amp;#xf1e0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share-alt-square<span class=\"muted\">[&amp;#xf1e1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share-square<span class=\"muted\">[&amp;#xf14d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share-square-o<span class=\"muted\">[&amp;#xf045;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-shield<span class=\"muted\">[&amp;#xf132;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-shopping-cart<span class=\"muted\">[&amp;#xf07a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sign-in<span class=\"muted\">[&amp;#xf090;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sign-out<span class=\"muted\">[&amp;#xf08b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-signal<span class=\"muted\">[&amp;#xf012;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sitemap<span class=\"muted\">[&amp;#xf0e8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-skype<span class=\"muted\">[&amp;#xf17e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-slack<span class=\"muted\">[&amp;#xf198;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sliders<span class=\"muted\">[&amp;#xf1de;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-smile-o<span class=\"muted\">[&amp;#xf118;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort<span class=\"muted\">[&amp;#xf0dc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-alpha-asc<span class=\"muted\">[&amp;#xf15d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-alpha-desc<span class=\"muted\">[&amp;#xf15e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-amount-asc<span class=\"muted\">[&amp;#xf160;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-amount-desc<span class=\"muted\">[&amp;#xf161;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-asc<span class=\"muted\">[&amp;#xf0de;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-desc<span class=\"muted\">[&amp;#xf0dd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-down<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0dd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-numeric-asc<span class=\"muted\">[&amp;#xf162;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-numeric-desc<span class=\"muted\">[&amp;#xf163;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-up<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0de;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-soundcloud<span class=\"muted\">[&amp;#xf1be;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-space-shuttle<span class=\"muted\">[&amp;#xf197;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-spinner<span class=\"muted\">[&amp;#xf110;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-spoon<span class=\"muted\">[&amp;#xf1b1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-spotify<span class=\"muted\">[&amp;#xf1bc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-square<span class=\"muted\">[&amp;#xf0c8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-square-o<span class=\"muted\">[&amp;#xf096;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stack-exchange<span class=\"muted\">[&amp;#xf18d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stack-overflow<span class=\"muted\">[&amp;#xf16c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star<span class=\"muted\">[&amp;#xf005;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-half<span class=\"muted\">[&amp;#xf089;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-half-empty<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf123;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-half-full<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf123;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-half-o<span class=\"muted\">[&amp;#xf123;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-o<span class=\"muted\">[&amp;#xf006;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-steam<span class=\"muted\">[&amp;#xf1b6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-steam-square<span class=\"muted\">[&amp;#xf1b7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-step-backward<span class=\"muted\">[&amp;#xf048;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-step-forward<span class=\"muted\">[&amp;#xf051;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stethoscope<span class=\"muted\">[&amp;#xf0f1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stop<span class=\"muted\">[&amp;#xf04d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-strikethrough<span class=\"muted\">[&amp;#xf0cc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stumbleupon<span class=\"muted\">[&amp;#xf1a4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stumbleupon-circle<span class=\"muted\">[&amp;#xf1a3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-subscript<span class=\"muted\">[&amp;#xf12c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-suitcase<span class=\"muted\">[&amp;#xf0f2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sun-o<span class=\"muted\">[&amp;#xf185;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-superscript<span class=\"muted\">[&amp;#xf12b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-support<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-table<span class=\"muted\">[&amp;#xf0ce;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tablet<span class=\"muted\">[&amp;#xf10a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tachometer<span class=\"muted\">[&amp;#xf0e4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tag<span class=\"muted\">[&amp;#xf02b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tags<span class=\"muted\">[&amp;#xf02c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tasks<span class=\"muted\">[&amp;#xf0ae;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-taxi<span class=\"muted\">[&amp;#xf1ba;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tencent-weibo<span class=\"muted\">[&amp;#xf1d5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-terminal<span class=\"muted\">[&amp;#xf120;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-text-height<span class=\"muted\">[&amp;#xf034;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-text-width<span class=\"muted\">[&amp;#xf035;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-th<span class=\"muted\">[&amp;#xf00a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-th-large<span class=\"muted\">[&amp;#xf009;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-th-list<span class=\"muted\">[&amp;#xf00b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumb-tack<span class=\"muted\">[&amp;#xf08d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumbs-down<span class=\"muted\">[&amp;#xf165;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumbs-o-down<span class=\"muted\">[&amp;#xf088;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumbs-o-up<span class=\"muted\">[&amp;#xf087;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumbs-up<span class=\"muted\">[&amp;#xf164;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ticket<span class=\"muted\">[&amp;#xf145;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-times<span class=\"muted\">[&amp;#xf00d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-times-circle<span class=\"muted\">[&amp;#xf057;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-times-circle-o<span class=\"muted\">[&amp;#xf05c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tint<span class=\"muted\">[&amp;#xf043;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-toggle-down<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf150;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-toggle-left<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf191;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-toggle-right<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf152;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-toggle-up<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf151;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-trash-o<span class=\"muted\">[&amp;#xf014;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tree<span class=\"muted\">[&amp;#xf1bb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-trello<span class=\"muted\">[&amp;#xf181;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-trophy<span class=\"muted\">[&amp;#xf091;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-truck<span class=\"muted\">[&amp;#xf0d1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-try<span class=\"muted\">[&amp;#xf195;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tumblr<span class=\"muted\">[&amp;#xf173;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tumblr-square<span class=\"muted\">[&amp;#xf174;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-turkish-lira<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf195;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-twitter<span class=\"muted\">[&amp;#xf099;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-twitter-square<span class=\"muted\">[&amp;#xf081;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-umbrella<span class=\"muted\">[&amp;#xf0e9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-underline<span class=\"muted\">[&amp;#xf0cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-undo<span class=\"muted\">[&amp;#xf0e2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-university<span class=\"muted\">[&amp;#xf19c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-unlink<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf127;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-unlock<span class=\"muted\">[&amp;#xf09c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-unlock-alt<span class=\"muted\">[&amp;#xf13e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-unsorted<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0dc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-upload<span class=\"muted\">[&amp;#xf093;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-usd<span class=\"muted\">[&amp;#xf155;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-user<span class=\"muted\">[&amp;#xf007;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-user-md<span class=\"muted\">[&amp;#xf0f0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-users<span class=\"muted\">[&amp;#xf0c0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-video-camera<span class=\"muted\">[&amp;#xf03d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-vimeo-square<span class=\"muted\">[&amp;#xf194;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-vine<span class=\"muted\">[&amp;#xf1ca;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-vk<span class=\"muted\">[&amp;#xf189;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-volume-down<span class=\"muted\">[&amp;#xf027;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-volume-off<span class=\"muted\">[&amp;#xf026;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-volume-up<span class=\"muted\">[&amp;#xf028;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-warning<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf071;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-wechat<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-weibo<span class=\"muted\">[&amp;#xf18a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-weixin<span class=\"muted\">[&amp;#xf1d7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-wheelchair<span class=\"muted\">[&amp;#xf193;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-windows<span class=\"muted\">[&amp;#xf17a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-won<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf159;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-wordpress<span class=\"muted\">[&amp;#xf19a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-wrench<span class=\"muted\">[&amp;#xf0ad;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-xing<span class=\"muted\">[&amp;#xf168;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-xing-square<span class=\"muted\">[&amp;#xf169;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-yahoo<span class=\"muted\">[&amp;#xf19e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-yen<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf157;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-youtube<span class=\"muted\">[&amp;#xf167;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-youtube-play<span class=\"muted\">[&amp;#xf16a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-youtube-square<span class=\"muted\">[&amp;#xf166;]</span>\r\n                        </div>\r\n                    </div>','','shortcodes'),

('page',0,41,48,'en',0,'[row different_values=\"0\"]\r\n[col different_values=\"0\" extra_classes=\"col-md-offset-2\" desktop=\"8\"]\r\n[nd_message different_values=\"0\" message_type=\"alert info\" text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\"]\r\n[/nd_message]\r\n[nd_message different_values=\"0\" message_type=\"alert success\" text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\"]\r\n[/nd_message]\r\n[nd_message different_values=\"0\" message_type=\"alert notice\" text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\"]\r\n[/nd_message]\r\n[nd_message different_values=\"0\" message_type=\"alert error\" text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\"]\r\n[/nd_message]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,42,49,'en',0,'[nd_header type=\"bg-gray-lighter\" size=\"small-section\" breadcrumbs=\"1\" title=\"Page titles\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-gray\" size=\"small-section\" breadcrumbs=\"1\" title=\"Title Gray\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-lighter\" size=\"small-section\" breadcrumbs=\"1\" title=\"Title Dark 1\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark\" size=\"small-section\" breadcrumbs=\"1\" title=\"Title Dark 2\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-alfa-30\" size=\"small-section\" fid=\"3\" breadcrumbs=\"1\" title=\"Title with image\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-alfa-30\" size=\"page-section\" fid=\"4\" breadcrumbs=\"1\" title=\"Title large\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-gray-lighter\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-gray\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-lighter\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-alfa-50\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\" fid=\"5\"]\r\n[/nd_header]\r\n ','','shortcodes'),

('page',0,43,50,'en',0,'[nd_bg slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" desktop=\"7\"]\r\n[nd_slider different_values=\"0\" slide_autoplay=\"5000\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"2\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"3\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[col extra_classes=\"col-lg-offset-1\" wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col extra_classes=\"col-lg-offset-1\" wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" desktop=\"7\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"2\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"3\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg slider=\"0\" different_values=\"0\" fid=\"4\" color=\"bg-dark-alfa-70\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_slider slide_anim=\"wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" different_values=\"0\" icon=\"icon-hotairballoon\" text=\"We\'re Creative\" color=\"white\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]We find the best ideas for you[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-clock\" text=\"We\'re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\" extra_classes=\"features-descr\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-lightbulb\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-wine\" text=\"We\'re Creative\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We find the best ideas for you</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-tools\" text=\"We’re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-gears\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-browser\" text=\"We\'re Creative\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We find the best ideas for you</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-wallet\" text=\"We\'re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-document\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-gray\" different_values=\"0\" fid=\"2\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\" full_height=\"0\" scroll_icon=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"4\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"5\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"6\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_slider different_values=\"0\" slide_anim=\"fullwidth\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"7\" different_values=\"0\"]\r\n[nd_image type=\"0\" fid=\"23\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\"]\r\n[/nd_image]\r\n[/col]\r\n[col desktop=\"5\" wide=\"4\" extra_classes=\"col-lg-offset-1\" different_values=\"0\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"View online\" link=\"#\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"7\" different_values=\"0\"]\r\n[nd_image type=\"0\" fid=\"17\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\"]\r\n[/nd_image]\r\n[/col]\r\n[col desktop=\"5\" wide=\"4\" extra_classes=\"col-lg-offset-1\" different_values=\"0\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"View online\" link=\"#\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"5\" wide=\"4\" different_values=\"0\"]\r\n[nd_title title=\"Mega creative\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut. Phasellus facilisis mauris vel velit molestie pellentesqu accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"View online\" link=\"#\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[col extra_classes=\"col-lg-offset-1\" desktop=\"7\" different_values=\"0\"]\r\n[nd_video url=\"http://player.vimeo.com/video/37066208?title=0&amp;byline=0&amp;portrait=0&amp;color=ffffff\" different_values=\"0\"]\r\n[/nd_video]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('page',0,44,51,'en',0,'[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_title different_values=\"0\" extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" title=\"Standard tabs\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" extra_classes=\"col-sm-offset-2\" tablet=\"8\"]\r\n[nd_tabs centered=\"0\" transparent=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"First\" active=\"1\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Second\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Nam porta elementum tortor, eget tempor orci ullamcorper eget. Aliquam fermentum sem non vulputate dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Nulla at porttitor massa. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Third\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Pellentesque sed vehicula velit, vitae vulputate velit. Morbi nec porta augue, et dignissim enim. Vivamus suscipit, lorem vitae rhoncus pharetra, erat nisl scelerisque magna, ut mollis dui eros eget libero. Vivamus ut ornare tellus. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_title different_values=\"0\" extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" title=\"Minimal tabs\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" extra_classes=\"col-sm-offset-2\" tablet=\"8\"]\r\n[nd_tabs type=\"minimal\" centered=\"1\" transparent=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"First\" active=\"1\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Second\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Nam porta elementum tortor, eget tempor orci ullamcorper eget. Aliquam fermentum sem non vulputate dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Nulla at porttitor massa. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Third\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Pellentesque sed vehicula velit, vitae vulputate velit. Morbi nec porta augue, et dignissim enim. Vivamus suscipit, lorem vitae rhoncus pharetra, erat nisl scelerisque magna, ut mollis dui eros eget libero. Vivamus ut ornare tellus. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,45,52,'en',0,'[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" title=\"Formating\" styled=\"0\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[html different_values=\"0\" extra_classes=\"text\" format=\"nd_ckeditor\"]<h5 class=\"uppercase mb-30\">Paragraph</h5><p> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Consectetur adipiscing elit. Integer posuere erat a ante. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. </p>[/html]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_quote type=\"footer\" cite=\" Source Title\" different_values=\"0\" footer=\"Someone famous in\" testimonial=\"0\" style_margin_top=\"52\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"20\" style_margin_bottom=\"60\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" extra_classes=\"text\" different_values=\"0\"]<h5 class=\"uppercase mb-30\">	List UL</h5><ul><li>First item</li><li>Second item</li><li>Third item<ul><li>First item</li><li>Second item</li><li>Third item</li></ul></li><li>Fourth item</li><li>Fives item</li></ul>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" extra_classes=\"text\" different_values=\"0\"]<h5 class=\"uppercase mb-30\">List OL</h5><ol><li>First item</li><li>Second item</li><li>Third item<ol><li>First item</li><li>Second item</li><li>Third item</li></ol></li><li>Fourth item</li><li>Fives item</li></ol>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" extra_classes=\"text\" different_values=\"0\"]<h5 class=\"uppercase mb-30\">Emphasis</h5><p><small> This line of text is meant to be treated as fine print. </small></p><p><strong>Rendered as bold text</strong></p><p><em>Rendered as italicized text</em></p><p><span class=\"serif\">Rendered as italicized text</span></p>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" title=\"Headings\" styled=\"0\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" extra_classes=\"align-center\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" size=\"h1\" title=\"Heading 1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h2\" title=\"Heading 2\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h3\" title=\"Heading 3\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h4\" title=\"Heading 4\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h5\" title=\"Heading 5\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h6\" title=\"Heading 6\"]\r\n[/nd_title]\r\n[/col]\r\n[col tablet=\"4\" extra_classes=\"align-center\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" size=\"h1\" title=\"Heading 1\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h2\" title=\"Heading 2\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h3\" title=\"Heading 3\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h4\" title=\"Heading 4\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h5\" title=\"Heading 5\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h6\" title=\"Heading 6\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[/col]\r\n[col tablet=\"4\" extra_classes=\"align-center\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" size=\"h1\" title=\"Heading 1\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h2\" title=\"Heading 2\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h3\" title=\"Heading 3\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h4\" title=\"Heading 4\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h5\" title=\"Heading 5\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h6\" title=\"Heading 6\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,46,53,'en',0,'[nd_bg extra_classes=\"page-section\" different_values=\"0\" slider=\"0\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_video url=\"http://player.vimeo.com/video/79876010?title=0&amp;byline=0&amp;portrait=0&amp;color=ffffff\" different_values=\"0\" width=\"1170\" height=\"658\"]\r\n[/nd_video]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_video url=\"http://www.youtube.com/embed/JuyB7NO0EYY\" different_values=\"0\" width=\"640\" height=\"360\"]\r\n[/nd_video]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\" style_padding_bottom=\"140\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<iframe width=\"100%\" height=\"166\" scrolling=\"no\" frameborder=\"no\" src=\"https://w.soundcloud.com/player/?url=https%3A//api.soundcloud.com/tracks/3752929&amp;color=111111&amp;auto_play=false&amp;hide_related=false&amp;show_comments=true&amp;show_user=true&amp;show_reposts=false\"></iframe>[/html]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,47,54,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed neque velit, ultrices in vulputate vitae, volutpat iaculis velit. In congue dolor a ligula cursus aliquam. Aliquam id malesuada metus. Donec ultricies lorem augue, ac fringilla felis aliquet et. Integer a rutrum dui, id varius neque. Donec orci massa, porttitor sit amet velit non, interdum feugiat lacus. Fusce tincidunt id erat at consequat. Cras vel aliquet mauris, ac tempor lorem. Donec faucibus sodales eros sed pretium. Praesent ut scelerisque lectus, ut feugiat mi.</p><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus. Curabitur vel vestibulum ipsum, convallis cursus nisl. Mauris scelerisque gravida faucibus. Morbi vitae sapien nibh. Integer libero orci, ullamcorper in tincidunt at, molestie quis ipsum.</p>[/html]\r\n ','','shortcodes'),

('page',0,48,55,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed neque velit, ultrices in vulputate vitae, volutpat iaculis velit. In congue dolor a ligula cursus aliquam. Aliquam id malesuada metus. Donec ultricies lorem augue, ac fringilla felis aliquet et. Integer a rutrum dui, id varius neque. Donec orci massa, porttitor sit amet velit non, interdum feugiat lacus. Fusce tincidunt id erat at consequat. Cras vel aliquet mauris, ac tempor lorem. Donec faucibus sodales eros sed pretium. Praesent ut scelerisque lectus, ut feugiat mi.</p><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus. Curabitur vel vestibulum ipsum, convallis cursus nisl. Mauris scelerisque gravida faucibus. Morbi vitae sapien nibh. Integer libero orci, ullamcorper in tincidunt at, molestie quis ipsum.</p>[/html]\r\n ','','shortcodes'),

('page',0,49,56,'en',0,'[row different_values=\"0\" extra_classes=\"mb-70 mb-xs-40\"]\r\n[col extra_classes=\"col-md-offset-2\" different_values=\"0\" desktop=\"8\"]\r\n[html different_values=\"0\" extra_classes=\"section-text align-center\" format=\"nd_ckeditor\"]Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum.[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\" extra_classes=\"multi-columns-row\"]\r\n[col tablet=\"4\" different_values=\"0\" desktop=\"4\" wide=\"4\"]\r\n[nd_pricing_table different_values=\"0\" button=\"Buy Now\" period=\"per month\" sign=\"$\" price=\"199\" title=\"Start\" icon=\"fa fa-paper-plane-o\" link=\"/node/48\" active=\"0\"]\r\n[nd_pricing_item different_values=\"0\" description=\"1 Gb Storage\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"3 Domain Names\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"5 FTP Users\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"Free Support\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\" desktop=\"4\" wide=\"4\"]\r\n[nd_pricing_table active=\"1\" different_values=\"0\" button=\"Buy Now\" period=\"month\" sign=\"$\" price=\"239\" title=\"Standard\" icon=\"fa fa-gift\"]\r\n[nd_pricing_item different_values=\"0\" description=\"3 Gb Storage\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"5 Domain Names\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"7 FTP Users\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"Free Support\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\" desktop=\"4\" wide=\"4\"]\r\n[nd_pricing_table different_values=\"0\" button=\"Buy Now\" period=\"month\" sign=\"$\" price=\"399\" title=\"Optima\" icon=\"fa fa-desktop\"]\r\n[nd_pricing_item different_values=\"0\" description=\"5 Gb Storage\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"9 Domain Names\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"15 FTP Users\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"Free Support\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,50,57,'en',0,'[row different_values=\"0\" style_padding_bottom=\"70\"]\r\n[col desktop=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[html format=\"nd_ckeditor\" extra_classes=\"section-text align-center\" different_values=\"0\"]Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum.[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col desktop=\"3\" different_values=\"0\" tablet=\"6\"]\r\n[nd_pricing_table icon=\"fa fa-paper-plane-o\" title=\"Start\" price=\"199\" sign=\"$\" period=\"month\" button=\"Buy Now\" different_values=\"0\"]\r\n[nd_pricing_item description=\"1 Gb Storage\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"3 Domain Names\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"5 FTP Users\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Free Support\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col desktop=\"3\" different_values=\"0\" tablet=\"6\"]\r\n[nd_pricing_table icon=\"fa fa-gift\" title=\"Standard\" price=\"239\" sign=\"$\" period=\"month\" button=\"Buy Now\" different_values=\"0\"]\r\n[nd_pricing_item description=\"3 Gb Storage\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"5 Domain Names\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"7 FTP Users\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Free Support\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col desktop=\"3\" different_values=\"0\" tablet=\"6\"]\r\n[nd_pricing_table icon=\"fa fa-desktop\" title=\"Optima\" price=\"399\" sign=\"$\" period=\"month\" button=\"Buy Now\" different_values=\"0\"]\r\n[nd_pricing_item description=\"5 Gb Storage\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"9 Domain Names\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"15 FTP Users\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Free Support\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col desktop=\"3\" different_values=\"0\" tablet=\"6\"]\r\n[nd_pricing_table icon=\"fa fa-suitcase\" title=\"Vip\" price=\"579\" sign=\"$\" period=\"month\" button=\"Buy Now\" different_values=\"0\"]\r\n[nd_pricing_item description=\"15 Gb Storage\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Unlimit Domain Names\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Unlimit FTP Users\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Free Support\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,54,61,'en',0,'<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed neque velit, ultrices in vulputate vitae, volutpat iaculis velit. In congue dolor a ligula cursus aliquam. Aliquam id malesuada metus. Donec ultricies lorem augue, ac fringilla felis aliquet et. Integer a rutrum dui, id varius neque. Donec orci massa, porttitor sit amet velit non, interdum feugiat lacus. Fusce tincidunt id erat at consequat. Cras vel aliquet mauris, ac tempor lorem. Donec faucibus sodales eros sed pretium. Praesent ut scelerisque lectus, ut feugiat mi.</p>\r\n\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus. Curabitur vel vestibulum ipsum, convallis cursus nisl. Mauris scelerisque gravida faucibus. Morbi vitae sapien nibh. Integer libero orci, ullamcorper in tincidunt at, molestie quis ipsum.</p>\r\n','','ckeditor'),

('page',0,55,62,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed neque velit, ultrices in vulputate vitae, volutpat iaculis velit. In congue dolor a ligula cursus aliquam. Aliquam id malesuada metus. Donec ultricies lorem augue, ac fringilla felis aliquet et. Integer a rutrum dui, id varius neque. Donec orci massa, porttitor sit amet velit non, interdum feugiat lacus. Fusce tincidunt id erat at consequat. Cras vel aliquet mauris, ac tempor lorem. Donec faucibus sodales eros sed pretium. Praesent ut scelerisque lectus, ut feugiat mi.</p>\r\n\r\n<p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus. Curabitur vel vestibulum ipsum, convallis cursus nisl. Mauris scelerisque gravida faucibus. Morbi vitae sapien nibh. Integer libero orci, ullamcorper in tincidunt at, molestie quis ipsum.</p>\r\n','','ckeditor'),

('nd_portfolio',0,56,63,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_person',0,57,64,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<h4 class=\"font-alt normal\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: normal; line-height: 1.4; color: rgb(119, 119, 119); margin-top: 10px; margin-bottom: 1.3em; font-size: 18px; text-transform: uppercase; letter-spacing: 0.2em; text-align: center;\">	HI TO ALL!</h4><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px; text-align: center;\">Adipiscing elit curabitur eu&nbsp;adipiscing lacus eu&nbsp;adipiscing lacus, a&nbsp;iaculis diam.</p>[/html]\r\n ','','shortcodes'),

('nd_person',0,58,65,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<h4 class=\"font-alt normal\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: normal; line-height: 1.4; color: rgb(119, 119, 119); margin-top: 10px; margin-bottom: 1.3em; font-size: 18px; text-transform: uppercase; letter-spacing: 0.2em; text-align: center;\">	HI TO ALL!</h4><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px; text-align: center;\">Adipiscing elit curabitur eu&nbsp;adipiscing lacus eu&nbsp;adipiscing lacus, a&nbsp;iaculis diam.</p>[/html]\r\n ','','shortcodes'),

('nd_person',0,59,66,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<h4 class=\"font-alt normal\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: normal; line-height: 1.4; color: rgb(119, 119, 119); margin-top: 10px; margin-bottom: 1.3em; font-size: 18px; text-transform: uppercase; letter-spacing: 0.2em; text-align: center;\">	HI TO ALL!</h4><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px; text-align: center;\">Adipiscing elit curabitur eu&nbsp;adipiscing lacus eu&nbsp;adipiscing lacus, a&nbsp;iaculis diam.</p>[/html]\r\n ','','shortcodes'),

('nd_person',0,60,67,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<h4 class=\"font-alt normal\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: normal; line-height: 1.4; color: rgb(119, 119, 119); margin-top: 10px; margin-bottom: 1.3em; font-size: 18px; text-transform: uppercase; letter-spacing: 0.2em; text-align: center;\">	HI TO ALL!</h4><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px; text-align: center;\">Adipiscing elit curabitur eu&nbsp;adipiscing lacus eu&nbsp;adipiscing lacus, a&nbsp;iaculis diam.</p>[/html]\r\n ','','shortcodes'),

('page',0,61,68,'en',0,'[nd_container different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<h2 class=\"section-title font-alt mb-70 mb-sm-40 rtecenter\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: 400; line-height: 1.4; color: rgb(17, 17, 17); margin-top: 20px; margin-bottom: 70px; font-size: 18px; text-transform: uppercase; letter-spacing: 0.5em;\">	OUR CREATIVE MINDS</h2><div class=\"row\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; margin-left: -15px; margin-right: -15px; color: rgb(17, 17, 17); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px;\">	<div class=\"col-md-8 col-md-offset-2\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; position: relative; min-height: 1px; padding-left: 15px; padding-right: 15px; float: left; width: 780px; margin-left: 195px;\">		<div class=\"section-text align-center mb-70 mb-xs-40 rtecenter\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; font-size: 15px; color: rgb(119, 119, 119); line-height: 1.7; margin-bottom: 70px;\">			Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</div>	</div></div>[/html]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_2\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\" alignment=\" align-center\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,62,69,'en',0,'[nd_container different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<h2 class=\"section-title font-alt mb-70 mb-sm-40 rtecenter\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: 400; line-height: 1.4; color: rgb(17, 17, 17); margin-top: 20px; margin-bottom: 70px; font-size: 18px; text-transform: uppercase; letter-spacing: 0.5em;\">	OUR CREATIVE MINDS</h2><div class=\"row\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; margin-left: -15px; margin-right: -15px; color: rgb(17, 17, 17); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px;\">	<div class=\"col-md-8 col-md-offset-2\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; position: relative; min-height: 1px; padding-left: 15px; padding-right: 15px; float: left; width: 780px; margin-left: 195px;\">		<div class=\"section-text align-center mb-70 mb-xs-40 rtecenter\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; font-size: 15px; color: rgb(119, 119, 119); line-height: 1.7; margin-bottom: 70px;\">			Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</div>	</div></div>[/html]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_1\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\" alignment=\" align-center\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,63,70,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\" style_margin_top=\"-5\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>It doesn’t matter how many times I have to click, as long as each click is a mindless, unambiguous choice.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_2\" different_values=\"0\" style_padding_top=\"40\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\" style_margin_top=\"140\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\"]\r\n[row style_padding_top=\"20\" style_padding_bottom=\"20\" different_values=\"0\"]\r\n[col tablet=\"10\" extra_classes=\"col-md-offset-1\" different_values=\"0\"]\r\n[nd_slider slide_anim=\"small_wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"63\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"64\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"65\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"66\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"67\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,64,71,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\" extra_classes=\"wow fadeIn\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_progress title=\"Branding\" percent=\"90\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"Design\" percent=\"80\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"Development\" percent=\"85\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/row]\r\n[nd_div style_padding_left=\"20\" style_padding_right=\"20\" style_padding_top=\"40\" style_padding_bottom=\"40\" different_values=\"0\" style_margin_top=\"60\" extra_style=\"border: 1px solid rgba(0,0,0, .09);\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"PROJECTS DONE\" icon=\"fa fa-briefcase\" number=\"320\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"HAPPY CLIENTS\" icon=\"fa fa-heart\" number=\"150\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"COFFEE CUPS\" icon=\"fa fa-coffee\" number=\"933\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"GREAT IDEAS\" icon=\"fa fa-lightbulb-o\" number=\"975\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[/row]\r\n[/nd_div]\r\n[/nd_container]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\" style_margin_top=\"140\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\"]\r\n[row style_padding_top=\"20\" style_padding_bottom=\"20\" different_values=\"0\"]\r\n[col tablet=\"10\" extra_classes=\"col-md-offset-1\" different_values=\"0\"]\r\n[nd_slider slide_anim=\"small_wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"63\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"64\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"65\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"66\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"67\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_padding_top=\"120\"]\r\n[nd_title title=\"OUR TEAM\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" text_align=\"center\" different_values=\"0\"]<p>In auctor ex id urna faucibus porttitor. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_1\" different_values=\"0\" style_padding_top=\"40\" animation=\"fadeInUp\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"130\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,65,72,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_title title=\"WHO WE ARE?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam.</p><p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_progress title=\"Branding\" percent=\"90\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"Design\" percent=\"80\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"Development\" percent=\"85\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"PHOTO\" percent=\"75\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/row]\r\n[nd_div style_padding_left=\"20\" style_padding_right=\"20\" style_padding_top=\"40\" style_padding_bottom=\"40\" different_values=\"0\" style_margin_top=\"60\" extra_style=\"border: 1px solid rgba(0,0,0, .09);\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"PROJECTS DONE\" icon=\"fa fa-briefcase\" number=\"320\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"HAPPY CLIENTS\" icon=\"fa fa-heart\" number=\"150\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"COFFEE CUPS\" icon=\"fa fa-coffee\" number=\"933\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"GREAT IDEAS\" icon=\"fa fa-lightbulb-o\" number=\"975\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[/row]\r\n[/nd_div]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_1\" different_values=\"0\" style_padding_top=\"70\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\" style_margin_top=\"140\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\"]\r\n[row style_padding_top=\"20\" style_padding_bottom=\"20\" different_values=\"0\"]\r\n[col tablet=\"10\" extra_classes=\"col-md-offset-1\" different_values=\"0\"]\r\n[nd_slider slide_anim=\"small_wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"63\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"64\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"65\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"66\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"67\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\" style_padding_top=\"140\"]\r\n[nd_title title=\"OUR STORY\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-sm-offset-2\" different_values=\"0\"]\r\n[nd_tabs type=\"minimal\" centered=\"1\" different_values=\"0\"]\r\n[nd_tab title=\"Mission\" active=\"1\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim.</p>[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Vision\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim.</p>[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Ideas\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim.</p>[/html]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,66,73,'en',0,'[nd_container different_values=\"0\"]\r\n[nd_tabs type=\"alt\" centered=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"Branding\" icon=\"icon-strategy\" icon_type=\"big\" active=\"1\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>It doesn’t matter how many times I have to click, as long as each click is a mindless, unambiguous choice.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"WEB DESIGN\" icon=\"icon-desktop\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"graphic design\" icon=\"icon-tools\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Development\" icon=\"icon-gears\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Photography\" icon=\"icon-camera\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/nd_container]\r\n[nd_bg banner=\"0\" fid=\"44\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" style_margin_top=\"120\" full_height=\"0\" scroll_icon=\"0\" style_padding_top=\"0\" style_padding_bottom=\"0\" video_sound=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"45\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,67,74,'en',0,'[nd_container different_values=\"0\"]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-camera\" text=\"photography\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Cras luctus interdum sodales. Quisque quis odio dui. Sedes sit amet neque malesuada, lobortis commodo magna ntesque pharetra metus vivera sagittis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-tools-2\" text=\"development\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Fusce aliquet quam eget neque ultrices elementum. Nulla posuere felis id arcu blandit sagittis. Eleifender vestibulum purus, sit amet vulputate risus.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-anchor\" text=\"support\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. Praesent sed nisi eleifend, fermentum orci sit amet, iaculis libero interdum.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_bg banner=\"1\" fid=\"55\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" style_margin_top=\"140\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"56\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_title title=\"WORK PROCESS\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam. Aliquam elementum tellus non erat porttitor mollis. Morbi viverra sollicitudin nisl eu sodales.</p><p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions multiple_active=\"0\" different_values=\"0\"]\r\n[nd_accordion title=\"1. Discussion\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"2. Design\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"3. Development\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,68,75,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"3\" different_values=\"0\" style_margin_top=\"70\"]\r\n[nd_title title=\"WORK PROCESS\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. DISCUSSION\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. MAKING\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. PRODUCTION\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"30\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_image fid=\"58\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" style_margin_bottom=\"23\"]\r\n[/nd_image]\r\n[nd_title title=\"DIGITAL BRANDING\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"6\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_image fid=\"59\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" style_margin_bottom=\"23\"]\r\n[/nd_image]\r\n[nd_title title=\"DESIGN &amp; DEVELOPMENT\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"6\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_image fid=\"60\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" style_margin_bottom=\"23\"]\r\n[/nd_image]\r\n[nd_title title=\"MARKETING\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"6\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_bg banner=\"1\" fid=\"55\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" style_margin_top=\"140\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"56\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam. Aliquam elementum tellus non erat porttitor mollis. Morbi viverra sollicitudin nisl eu sodales.</p><p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions multiple_active=\"0\" different_values=\"0\"]\r\n[nd_accordion title=\" We are professionals\" different_values=\"0\" icon=\"fa fa-users\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\" We are punctual\" different_values=\"0\" icon=\"fa fa-clock-o\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"We are friendly\" different_values=\"0\" icon=\"fa fa-heart\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,69,76,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\" style_margin_bottom=\"-10\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" text_align=\"center\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque efficitur nulla orci, in sollicitudin mauris viverra<br>	id. Donec est lectus, eleifend vitae rutrum eu, porta sed nisl. Nunc vehicula enim eget risus faucibus, id<br>	interdum nisi commodo. Nunc eget massa eget ipsum mattis iaculis ut in urna.</p>[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"68\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"HIPSTER INC.\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"69\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"OTHER COMPANY\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"70\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"71\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"DIGITAL STUFF\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"72\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"BIGSTREAM INC.\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"73\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"RHYTHM AND PARTNERS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\" style_margin_top=\"140\" full_height=\"0\" scroll_icon=\"0\" style_padding_top=\"140\" style_padding_bottom=\"140\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\"]\r\n[row style_padding_top=\"20\" style_padding_bottom=\"20\" different_values=\"0\"]\r\n[col tablet=\"10\" extra_classes=\"col-md-offset-1\" different_values=\"0\"]\r\n[nd_slider slide_anim=\"small_wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"63\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"64\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"65\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"66\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"67\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,70,77,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\" text_align=\"center\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[nd_quote different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</p>[/html]\r\n[/nd_quote]\r\n[nd_div different_values=\"0\"]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" different_values=\"0\" style_margin_right=\"7\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"BUY NOW\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE PROVIDE BEST DIGITAL SERVICES\" size=\"h3\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row different_values=\"0\" text_align=\"center\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" style_margin_bottom=\"70\" different_values=\"0\" text_align=\"center\"]<p><span style=\"font-size:15px;\">Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</span></p>[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"BRANDING\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-gift\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"WEB DESIGN\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-desktop\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"LOGO DESIGN\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-bug\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"ILLUSTRATIONS\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-heart\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col desktop=\"6\" wide=\"6\" different_values=\"0\" extra_classes=\"hidden-xs hidden-sm\'\"]\r\n[nd_image fid=\"49\" different_values=\"0\"]\r\n[/nd_image]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"DEVELOPMENT\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-cogs\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"PHOTOGRAPHY\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-camera\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"MARKETING\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-area-chart\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"SUPPORT\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-life-ring\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" desktop=\"7\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"17\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"47\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[col extra_classes=\"col-lg-offset-1\" wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_bg extra_classes=\"text\" different_values=\"0\" slider=\"0\" banner=\"0\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_bg extra_classes=\"text\" different_values=\"0\" slider=\"0\" banner=\"0\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n[/col]\r\n[col different_values=\"0\" desktop=\"7\" extra_classes=\"col-lg-offset-1\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"17\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"76\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,71,78,'en',0,'[row different_values=\"0\" style_padding_bottom=\"120\"]\r\n[col extra_classes=\" col-md-offset-2\" different_values=\"0\" tablet=\"8\"]\r\n[nd_accordions different_values=\"0\"]\r\n[nd_accordion title=\"WHAT DO YOU MEAN BY AN END PRODUCT?\" active=\"1\" different_values=\"0\"]\r\n[html format=\"ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"I HAVE BOUGHT A PRODUCT THAT HAS FILES MISSING, WHAT DO I DO?\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"DO I NEED TO BUY A LICENCE FOR EACH SITE?\" active=\"1\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"IS MY LICENSE TRANSFERABLE?\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"CAN I INCORPORATE ADVERTISING IN MY END PRODUCT WITH A REGULAR LICENCE?\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Do I need a separate license each time I use an item in a series?\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,72,79,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/rhythm_search\" different_values=\"0\" style_padding_bottom = \"50\"]\r\n[/nd_block]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" style_margin_bottom=\"100\" text_align=\"center\"]<p>Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"WHAT DO YOU MEAN BY AN END PRODUCT?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"I HAVE BOUGHT A PRODUCT THAT HAS FILES MISSING, WHAT DO I DO?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"DO I NEED TO BUY A LICENCE FOR EACH SITE?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"IS MY LICENSE TRANSFERABLE?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"CAN I INCORPORATE ADVERTISING IN MY END PRODUCT WITH A REGULAR LICENCE?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,74,81,'en',0,'[nd_title title=\"HAVE A QUESTIONS?\" size=\"h2\" styled=\"0\" uppercase=\"0\" extra_classes=\"section-title font-alt mb-70 mb-sm-40\" different_values=\"0\" alignment=\" align-center\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Call Us\" icon=\"fa fa-phone\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]+61 3 8376 6284[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-map-marker\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]245 Quigley Blvd, Ste K[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-envelope\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"mailto:support@bestlooker.pro\">support@bestlooker.pro</a>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[nd_node admin_url=\"node/73/edit\" different_values=\"0\"]\r\n[/nd_node]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,75,82,'en',0,'[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" style_margin_bottom=\"70\" text_align=\"center\"]<p>Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</p>[/html]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Call Us\" icon=\"fa fa-phone\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]+61 3 8376 6284[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-map-marker\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]245 Quigley Blvd, Ste K[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-envelope\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"mailto:support@bestlooker.pro\">support@bestlooker.pro</a>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[nd_node admin_url=\"node/73/edit\" different_values=\"0\"]\r\n[/nd_node]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,95,102,'en',0,'<p>THE PAGE YOU WERE LOOKING FOR COULD NOT BE FOUND.</p>\r\n','','basic_html'),

('page',0,96,103,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus mi urna, vehicula aliquam dapibus ornare, semper semper nisl.</p>\r\n','','basic_html'),

('page',0,97,104,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\" style_margin_bottom=\"60\"]\r\n[col tablet=\"6\" different_values=\"0\" animation=\"fadeInLeft\"]\r\n[nd_title title=\"ABOUT STUDIO\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\" animation=\"fadeInRight\"]\r\n[html format=\"nd_ckeditor\" text_align=\"right\" different_values=\"0\"]<p><a class=\"section-more right\" href=\"#\">MORE ABOUT US <i class=\"fa fa-angle-right\"></i></a></p>[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_progress title=\"BRANDING\" percent=\"90\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"DESIGN\" percent=\"80\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"DEVELOPMENT\" percent=\"85\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"section-text\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"section-text\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"SERVICES\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_tabs type=\"alt\" centered=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"Branding\" icon=\"icon-strategy\" icon_type=\"big\" active=\"1\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>It doesn’t matter how many times I have to click, as long as each click is a mindless, unambiguous choice.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"WEB DESIGN\" icon=\"icon-desktop\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"graphic design\" icon=\"icon-tools\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Development\" icon=\"icon-gears\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Photography\" icon=\"icon-camera\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" text_align=\"center\"]<p><a class=\"section-more font-alt\" href=\"#about\">View all services </a></p>[/html]\r\n[/nd_container]\r\n[nd_bg banner=\"0\" fid=\"44\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" full_height=\"0\" scroll_icon=\"0\" style_margin_top=\"70\" style_padding_top=\"0\" style_padding_bottom=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"45\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg banner=\"0\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\" color=\"black\" id=\"about\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-camera\" text=\"photography\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Cras luctus interdum sodales. Quisque quis odio dui. Sedes sit amet neque malesuada, lobortis commodo magna ntesque pharetra metus vivera sagittis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-tools-2\" text=\"development\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Fusce aliquet quam eget neque ultrices elementum. Nulla posuere felis id arcu blandit sagittis. Eleifender vestibulum purus, sit amet vulputate risus.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-anchor\" text=\"support\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. Praesent sed nisi eleifend, fermentum orci sit amet, iaculis libero interdum.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"46\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_margin_top=\"140\"]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" desktop=\"7\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"48\" image_style=\"portfolio_650xauto_\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"47\" image_style=\"portfolio_650xauto_\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[col extra_classes=\"col-lg-offset-1\" wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_padding_bottom=\"140\"]\r\n[row different_values=\"0\"]\r\n[col wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" desktop=\"7\" extra_classes=\"col-lg-offset-1\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"49\" image_style=\"portfolio_650xauto_\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"48\" image_style=\"portfolio_650xauto_\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_bg slider=\"0\" different_values=\"0\" fid=\"50\" color=\"bg-dark-alfa-70\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_slider slide_anim=\"wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" different_values=\"0\" icon=\"icon-hotairballoon\" text=\"We\'re Creative\" color=\"white\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]We find the best ideas for you[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-clock\" text=\"We\'re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\" extra_classes=\"features-descr\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-lightbulb\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-wine\" text=\"We\'re Creative\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We find the best ideas for you</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-tools\" text=\"We’re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-gears\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-browser\" text=\"We\'re Creative\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We find the best ideas for you</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-wallet\" text=\"We\'re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-document\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container style_padding_top=\"140\" style_padding_bottom=\"140\" different_values=\"0\"]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col phone=\"6\" different_values=\"0\"]\r\n[nd_title title=\"latest news\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[col phone=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"/blog\" class=\"section-more right\">ALL NEWS IN OUR BLOG <i class=\"fa fa-angle-right\"></i></a>[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/blog_grid/edit/page_4\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" style_padding_top=\"70\" style_padding_bottom=\"70\"]\r\n[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" extra_classes=\"col-md-offset-3\" different_values=\"0\"]\r\n[nd_title title=\"STAY INFORMED WITH OUR NEWSLETTER\" size=\"h4\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_node admin_url=\"node/98/edit\" different_values=\"0\" style_margin_bottom=\"-15\"]\r\n[/nd_node]\r\n[html format=\"html\" different_values=\"0\" text_align=\"center\"]<div class=\"form-tip\"> <i class=\"fa fa-info-circle\"></i> Please trust us, we will never send you spam </div>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[nd_title title=\"FIND US\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Call Us\" icon=\"fa fa-phone\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]+61 3 8376 6284[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-map-marker\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]245 Quigley Blvd, Ste K[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-envelope\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"mailto:support@bestlooker.pro\">support@bestlooker.pro</a>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,100,107,'en',0,'[nd_div vertical_align=\"0\" different_values=\"0\"]\r\n[/nd_div]\r\n ','','shortcodes'),

('page',0,101,108,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"FREELANCE PHOTOGRAPHERS\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" extra_classes=\"section-title\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"section-text\" style_margin_bottom=\"70\"]<p>In auctor ex id urna faucibus porttitor. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[nd_image fid=\"85\" align=\"center\" different_values=\"0\" width=\"170\" height=\"55\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,102,109,'en',0,'[nd_container different_values=\"0\" id=\"about\"]\r\n[row different_values=\"0\" style_margin_bottom=\"60\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_title title=\"ABOUT STUDIO\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" text_align=\"right\" different_values=\"0\"]<p><a class=\"section-more right\" href=\"#\">MORE ABOUT US <i class=\"fa fa-angle-right\"></i></a></p>[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote type=\"footer\" footer=\"LOUIS KAHN\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Design is not making beauty, beauty emerges from selection, affinities, integration, love.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_1\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" id=\"services\"]\r\n[nd_title title=\"SERVICES\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_tabs type=\"alt\" centered=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"Branding\" icon=\"icon-strategy\" icon_type=\"big\" active=\"1\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>It doesn’t matter how many times I have to click, as long as each click is a mindless, unambiguous choice.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"WEB DESIGN\" icon=\"icon-desktop\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"graphic design\" icon=\"icon-tools\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Development\" icon=\"icon-gears\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Photography\" icon=\"icon-camera\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/nd_container]\r\n[nd_bg banner=\"0\" fid=\"44\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" full_height=\"0\" scroll_icon=\"0\" style_margin_top=\"70\" style_padding_top=\"0\" style_padding_bottom=\"0\" video_sound=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"45\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\" style_padding_bottom=\"70\" id=\"portfolio\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[nd_title title=\"Portfolio\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" text_align=\"center\" different_values=\"0\"]<p>In auctor ex id urna faucibus porttitor. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_view admin_url=\"admin/structure/views/view/portfolio_boxed/edit/block_1\" different_values=\"0\"]\r\n[/nd_view]\r\n[nd_bg color=\"bg-dark\" slider=\"0\" banner=\"0\" full_height=\"0\" scroll_icon=\"0\" different_values=\"0\" style_padding_top=\"70\" style_padding_bottom=\"70\" text_align=\"center\"]\r\n[nd_title title=\"LIKE OUR CREATIVE WORKS?\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"START PROJECT\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n[nd_bg banner=\"0\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-camera\" text=\"photography\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Cras luctus interdum sodales. Quisque quis odio dui. Sedes sit amet neque malesuada, lobortis commodo magna ntesque pharetra metus vivera sagittis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-tools-2\" text=\"development\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Fusce aliquet quam eget neque ultrices elementum. Nulla posuere felis id arcu blandit sagittis. Eleifender vestibulum purus, sit amet vulputate risus.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-anchor\" text=\"support\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. Praesent sed nisi eleifend, fermentum orci sit amet, iaculis libero interdum.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container style_padding_top=\"140\" style_padding_bottom=\"140\" different_values=\"0\" id=\"news\"]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col phone=\"6\" different_values=\"0\"]\r\n[nd_title title=\"latest news\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[col phone=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"/blog\" class=\"section-more right\">ALL NEWS IN OUR BLOG <i class=\"fa fa-angle-right\"></i></a>[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/blog_grid/edit/block_1\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" style_padding_bottom=\"70\" full_height=\"0\" scroll_icon=\"0\"]\r\n[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" extra_classes=\"col-md-offset-3\" different_values=\"0\"]\r\n[nd_title title=\"STAY INFORMED WITH OUR NEWSLETTER\" size=\"h4\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_node admin_url=\"node/117/edit\" different_values=\"0\" style_margin_bottom=\"-15\"]\r\n[/nd_node]\r\n[html format=\"html\" different_values=\"0\" text_align=\"center\"]<div class=\"form-tip\"> <i class=\"fa fa-info-circle\"></i> Please trust us, we will never send you spam </div>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\" id=\"contacts\"]\r\n[nd_title title=\"contact\" size=\"h2\" styled=\"0\" uppercase=\"0\" extra_classes=\"section-title font-alt mb-70 mb-sm-40\" different_values=\"0\" alignment=\" align-center\" color=\"black\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Call Us\" icon=\"fa fa-phone\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]+61 3 8376 6284[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-map-marker\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]245 Quigley Blvd, Ste K[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-envelope\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"mailto:support@bestlooker.pro\">support@bestlooker.pro</a>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[nd_node admin_url=\"node/106/edit\" different_values=\"0\"]\r\n[/nd_node]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,103,110,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"FREELANCE PHOTOGRAPHERS\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" extra_classes=\"section-title\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"section-text\" style_margin_bottom=\"70\"]<p>In auctor ex id urna faucibus porttitor. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[nd_image fid=\"85\" align=\"center\" different_values=\"0\" width=\"170\" height=\"55\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n ','','shortcodes');

/*Table structure for table `node__comment` */

DROP TABLE IF EXISTS `node__comment`;

CREATE TABLE `node__comment` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field comment.';

/*Data for the table `node__comment` */

/*Table structure for table `node__field_blog_category` */

DROP TABLE IF EXISTS `node__field_blog_category`;

CREATE TABLE `node__field_blog_category` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_blog_category_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_blog_category_target_id` (`field_blog_category_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_blog_category.';

/*Data for the table `node__field_blog_category` */

insert  into `node__field_blog_category`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_blog_category_target_id`) values 

('nd_blog',0,2,2,'en',0,5),

('nd_blog',0,2,2,'en',1,3),

('nd_blog',0,2,2,'en',2,4),

('nd_blog',0,3,3,'en',0,2),

('nd_blog',0,3,3,'en',1,9),

('nd_blog',0,3,3,'en',2,8),

('nd_blog',0,4,4,'en',0,1),

('nd_blog',0,4,4,'en',1,2),

('nd_blog',0,4,4,'en',2,9),

('nd_blog',0,5,5,'en',0,4),

('nd_blog',0,5,5,'en',1,1),

('nd_blog',0,5,5,'en',2,2),

('nd_blog',0,6,6,'en',0,4),

('nd_blog',0,6,6,'en',1,1),

('nd_blog',0,7,7,'en',0,4),

('nd_blog',0,7,7,'en',1,1),

('nd_blog',0,8,8,'en',0,8),

('nd_blog',0,8,8,'en',1,7),

('nd_blog',0,9,9,'en',0,8),

('nd_blog',0,9,9,'en',1,7);

/*Table structure for table `node__field_category` */

DROP TABLE IF EXISTS `node__field_category`;

CREATE TABLE `node__field_category` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_category_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_category_target_id` (`field_category_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_category.';

/*Data for the table `node__field_category` */

insert  into `node__field_category`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_category_target_id`) values 

('nd_portfolio',0,10,10,'en',0,29),

('nd_portfolio',0,10,10,'en',1,30),

('nd_portfolio',0,11,11,'en',0,28),

('nd_portfolio',0,11,11,'en',1,29),

('nd_portfolio',0,12,12,'en',0,28),

('nd_portfolio',0,12,12,'en',1,29),

('nd_portfolio',0,13,13,'en',0,28),

('nd_portfolio',0,13,13,'en',1,29),

('nd_portfolio',0,14,14,'en',0,31),

('nd_portfolio',0,14,14,'en',1,32),

('nd_portfolio',0,15,15,'en',0,28),

('nd_portfolio',0,16,16,'en',0,28),

('nd_portfolio',0,17,17,'en',0,30),

('nd_portfolio',0,18,18,'en',0,30),

('nd_portfolio',0,19,19,'en',0,28),

('nd_portfolio',0,20,20,'en',0,30),

('nd_portfolio',0,21,21,'en',0,30),

('nd_portfolio',0,22,22,'en',0,28),

('nd_portfolio',0,23,23,'en',0,28),

('nd_portfolio',0,24,24,'en',0,30),

('nd_portfolio',0,25,25,'en',0,30),

('nd_portfolio',0,26,26,'en',0,30),

('nd_portfolio',0,27,27,'en',0,29),

('nd_portfolio',0,28,28,'en',0,28),

('nd_portfolio',0,29,29,'en',0,30),

('nd_portfolio',0,30,30,'en',0,28),

('nd_portfolio',0,31,31,'en',0,28),

('nd_portfolio',0,32,32,'en',0,31),

('nd_portfolio',0,33,33,'en',0,31),

('nd_portfolio',0,56,63,'en',0,28);

/*Table structure for table `node__field_comments` */

DROP TABLE IF EXISTS `node__field_comments`;

CREATE TABLE `node__field_comments` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_comments_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_comments.';

/*Data for the table `node__field_comments` */

insert  into `node__field_comments`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_comments_status`) values 

('nd_blog',0,4,4,'en',0,2),

('nd_blog',0,5,5,'en',0,2),

('nd_blog',0,6,6,'en',0,2),

('nd_blog',0,7,7,'en',0,2),

('nd_blog',0,8,8,'en',0,2),

('nd_blog',0,9,9,'en',0,2);

/*Table structure for table `node__field_description` */

DROP TABLE IF EXISTS `node__field_description`;

CREATE TABLE `node__field_description` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_description_value` longtext NOT NULL,
  `field_description_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_description_format` (`field_description_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_description.';

/*Data for the table `node__field_description` */

insert  into `node__field_description`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_description_value`,`field_description_format`) values 

('nd_portfolio',0,10,10,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,11,11,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,12,12,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,13,13,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,14,14,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,15,15,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,16,16,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,17,17,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,18,18,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,19,19,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,20,20,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,21,21,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,22,22,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,23,23,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,24,24,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,25,25,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,26,26,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,27,27,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,28,28,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,29,29,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,30,30,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,31,31,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,32,32,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,33,33,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,56,63,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes');

/*Table structure for table `node__field_gallery` */

DROP TABLE IF EXISTS `node__field_gallery`;

CREATE TABLE `node__field_gallery` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_gallery_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_gallery_target_id` (`field_gallery_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_gallery.';

/*Data for the table `node__field_gallery` */

insert  into `node__field_gallery`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_gallery_target_id`) values 

('gallery_item',0,76,83,'en',0,33),

('gallery_item',0,77,84,'en',0,33),

('gallery_item',0,78,85,'en',0,33),

('gallery_item',0,79,86,'en',0,33),

('gallery_item',0,80,87,'en',0,33),

('gallery_item',0,80,87,'en',1,34),

('gallery_item',0,81,88,'en',0,34),

('gallery_item',0,82,89,'en',0,33),

('gallery_item',0,83,90,'en',0,33),

('gallery_item',0,84,91,'en',0,33),

('gallery_item',0,85,92,'en',0,33),

('gallery_item',0,86,93,'en',0,35),

('gallery_item',0,87,94,'en',0,35),

('gallery_item',0,88,95,'en',0,35),

('gallery_item',0,89,96,'en',0,35),

('gallery_item',0,90,97,'en',0,35),

('gallery_item',0,91,98,'en',0,35),

('gallery_item',0,92,99,'en',0,35),

('gallery_item',0,93,100,'en',0,35),

('gallery_item',0,99,106,'en',0,33);

/*Table structure for table `node__field_image` */

DROP TABLE IF EXISTS `node__field_image`;

CREATE TABLE `node__field_image` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_image_target_id` (`field_image_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_image.';

/*Data for the table `node__field_image` */

insert  into `node__field_image`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_image_target_id`,`field_image_alt`,`field_image_title`,`field_image_width`,`field_image_height`) values 

('nd_person',0,57,64,'en',0,28,'A','',370,450),

('nd_person',0,58,65,'en',0,29,'B','',370,450),

('nd_person',0,59,66,'en',0,27,'A','',370,450),

('nd_person',0,60,67,'en',0,30,'B','',370,450),

('gallery_item',0,76,83,'en',0,31,'A','',1920,1280),

('gallery_item',0,77,84,'en',0,32,'B','',1920,1280),

('gallery_item',0,78,85,'en',0,33,'A','',1920,1280),

('gallery_item',0,79,86,'en',0,34,'a','',1920,1278),

('gallery_item',0,80,87,'en',0,35,'a','',1920,1280),

('gallery_item',0,81,88,'en',0,36,'f','',1920,1280),

('gallery_item',0,82,89,'en',0,37,'r','',1920,1280),

('gallery_item',0,83,90,'en',0,38,'s','',1920,1280),

('gallery_item',0,84,91,'en',0,39,'q','',1920,1279),

('gallery_item',0,85,92,'en',0,40,'d','',1920,1280),

('gallery_item',0,86,93,'en',0,20,'f','',650,418),

('gallery_item',0,87,94,'en',0,25,'s','',1920,1080),

('gallery_item',0,88,95,'en',0,21,'s','',650,418),

('gallery_item',0,89,96,'en',0,18,'v','',650,418),

('gallery_item',0,90,97,'en',0,15,'v','',650,418),

('gallery_item',0,91,98,'en',0,19,'b','',650,418),

('gallery_item',0,92,99,'en',0,31,'d','',1920,1280),

('gallery_item',0,93,100,'en',0,32,'f','',1920,1280),

('gallery_item',0,94,101,'en',0,33,'f','',1920,1280),

('gallery_item',0,99,106,'en',0,45,'a','',529,439);

/*Table structure for table `node__field_images` */

DROP TABLE IF EXISTS `node__field_images`;

CREATE TABLE `node__field_images` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_images_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_images_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_images_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_images_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_images_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_images_target_id` (`field_images_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_images.';

/*Data for the table `node__field_images` */

insert  into `node__field_images`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_images_target_id`,`field_images_alt`,`field_images_title`,`field_images_width`,`field_images_height`) values 

('nd_blog',0,2,2,'en',0,2,'Alt','',2280,1284),

('nd_blog',0,2,2,'en',1,3,'Alt','',2280,1284),

('nd_blog',0,2,2,'en',2,4,'Alt','',2280,1284),

('nd_blog',0,3,3,'en',0,6,'Alt','',2280,1284),

('nd_blog',0,3,3,'en',1,2,'Alt','',2280,1284),

('nd_blog',0,4,4,'en',0,2,'Alt','',2280,1284),

('nd_blog',0,4,4,'en',1,3,'Alt','',2280,1284),

('nd_blog',0,5,5,'en',0,7,'A','',2280,1284),

('nd_blog',0,5,5,'en',1,2,'A','',2280,1284),

('nd_blog',0,5,5,'en',2,3,'B','',2280,1284),

('nd_blog',0,6,6,'en',0,5,'a','',2280,1284),

('nd_blog',0,6,6,'en',1,2,'b','',2280,1284),

('nd_blog',0,6,6,'en',2,3,'c','',2280,1284),

('nd_portfolio',0,10,10,'en',0,9,'A','',650,418),

('nd_portfolio',0,10,10,'en',1,9,'A','',650,418),

('nd_portfolio',0,10,10,'en',2,10,'B','',650,418),

('nd_portfolio',0,10,10,'en',3,10,'B','',650,418),

('nd_portfolio',0,11,11,'en',0,11,'A','',650,418),

('nd_portfolio',0,11,11,'en',1,11,'A','',650,418),

('nd_portfolio',0,11,11,'en',2,12,'B','',650,418),

('nd_portfolio',0,11,11,'en',3,12,'B','',650,418),

('nd_portfolio',0,11,11,'en',4,15,'C','',650,418),

('nd_portfolio',0,11,11,'en',5,15,'C','',650,418),

('nd_portfolio',0,12,12,'en',0,14,'A','',650,418),

('nd_portfolio',0,12,12,'en',1,11,'A','',650,418),

('nd_portfolio',0,13,13,'en',0,17,'A','',650,418),

('nd_portfolio',0,13,13,'en',1,17,'A','',650,418),

('nd_portfolio',0,13,13,'en',2,18,'B','',650,418),

('nd_portfolio',0,13,13,'en',3,18,'B','',650,418),

('nd_portfolio',0,14,14,'en',0,19,'C','',650,418),

('nd_portfolio',0,14,14,'en',1,19,'C','',650,418),

('nd_portfolio',0,14,14,'en',2,20,'D','',650,418),

('nd_portfolio',0,14,14,'en',3,20,'D','',650,418),

('nd_portfolio',0,15,15,'en',0,21,'A','',650,418),

('nd_portfolio',0,15,15,'en',1,21,'A','',650,418),

('nd_portfolio',0,16,16,'en',0,20,'F','',650,418),

('nd_portfolio',0,16,16,'en',1,19,'D','',650,418),

('nd_portfolio',0,17,17,'en',0,20,'F','',650,418),

('nd_portfolio',0,17,17,'en',1,17,'f','',650,418),

('nd_portfolio',0,18,18,'en',0,17,'b','',650,418),

('nd_portfolio',0,18,18,'en',1,18,'d','',650,418),

('nd_portfolio',0,19,19,'en',0,18,'f','',650,418),

('nd_portfolio',0,19,19,'en',1,15,'f','',650,418),

('nd_portfolio',0,20,20,'en',0,15,'t','',650,418),

('nd_portfolio',0,20,20,'en',1,16,'y','',650,418),

('nd_portfolio',0,21,21,'en',0,16,'d','',650,418),

('nd_portfolio',0,21,21,'en',1,13,'b','',650,418),

('nd_portfolio',0,22,22,'en',0,13,'h','',650,418),

('nd_portfolio',0,22,22,'en',1,14,'h','',650,418),

('nd_portfolio',0,23,23,'en',0,14,'a','',650,418),

('nd_portfolio',0,23,23,'en',1,11,'b','',650,418),

('nd_portfolio',0,24,24,'en',0,11,'t','',650,418),

('nd_portfolio',0,24,24,'en',1,12,'y','',650,418),

('nd_portfolio',0,25,25,'en',0,9,'g','',650,418),

('nd_portfolio',0,25,25,'en',1,10,'f','',650,418),

('nd_portfolio',0,26,26,'en',0,10,'t','',650,418),

('nd_portfolio',0,26,26,'en',1,7,'f','',2280,1284),

('nd_portfolio',0,27,27,'en',0,21,'a','',650,418),

('nd_portfolio',0,27,27,'en',1,19,'b','',650,418),

('nd_portfolio',0,28,28,'en',0,19,'r','',650,418),

('nd_portfolio',0,28,28,'en',1,20,'d','',650,418),

('nd_portfolio',0,29,29,'en',0,20,'a','',650,418),

('nd_portfolio',0,29,29,'en',1,17,'g','',650,418),

('nd_portfolio',0,30,30,'en',0,17,'t','',650,418),

('nd_portfolio',0,30,30,'en',1,18,'f','',650,418),

('nd_portfolio',0,31,31,'en',0,18,'t','',650,418),

('nd_portfolio',0,31,31,'en',1,15,'t','',650,418),

('nd_portfolio',0,32,32,'en',0,16,'t','',650,418),

('nd_portfolio',0,32,32,'en',1,13,'y','',650,418),

('nd_portfolio',0,33,33,'en',0,13,'y','',650,418),

('nd_portfolio',0,33,33,'en',1,14,'h','',650,418),

('nd_portfolio',0,56,63,'en',0,26,'A','',1800,2315);

/*Table structure for table `node__field_lead_text` */

DROP TABLE IF EXISTS `node__field_lead_text`;

CREATE TABLE `node__field_lead_text` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_lead_text_value` longtext NOT NULL,
  `field_lead_text_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_lead_text_format` (`field_lead_text_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_lead_text.';

/*Data for the table `node__field_lead_text` */

insert  into `node__field_lead_text`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_lead_text_value`,`field_lead_text_format`) values 

('nd_blog',0,2,2,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','basic_html'),

('nd_blog',0,3,3,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','ckeditor'),

('nd_blog',0,4,4,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','ckeditor'),

('nd_blog',0,5,5,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','ckeditor'),

('nd_blog',0,6,6,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','ckeditor');

/*Table structure for table `node__field_portfolio_category` */

DROP TABLE IF EXISTS `node__field_portfolio_category`;

CREATE TABLE `node__field_portfolio_category` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_portfolio_category_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_portfolio_category_target_id` (`field_portfolio_category_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_portfolio_category.';

/*Data for the table `node__field_portfolio_category` */

insert  into `node__field_portfolio_category`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_portfolio_category_target_id`) values 

('nd_portfolio',0,10,10,'en',0,26),

('nd_portfolio',0,10,10,'en',1,27),

('nd_portfolio',0,11,11,'en',0,25),

('nd_portfolio',0,11,11,'en',1,24),

('nd_portfolio',0,12,12,'en',0,25),

('nd_portfolio',0,12,12,'en',1,24),

('nd_portfolio',0,13,13,'en',0,25),

('nd_portfolio',0,13,13,'en',1,24),

('nd_portfolio',0,14,14,'en',0,22),

('nd_portfolio',0,14,14,'en',1,23),

('nd_portfolio',0,15,15,'en',0,26),

('nd_portfolio',0,15,15,'en',1,27),

('nd_portfolio',0,16,16,'en',0,26),

('nd_portfolio',0,16,16,'en',1,27),

('nd_portfolio',0,17,17,'en',0,25),

('nd_portfolio',0,18,18,'en',0,25),

('nd_portfolio',0,19,19,'en',0,23),

('nd_portfolio',0,19,19,'en',1,25),

('nd_portfolio',0,20,20,'en',0,27),

('nd_portfolio',0,21,21,'en',0,26),

('nd_portfolio',0,22,22,'en',0,26),

('nd_portfolio',0,23,23,'en',0,25),

('nd_portfolio',0,24,24,'en',0,26),

('nd_portfolio',0,25,25,'en',0,26),

('nd_portfolio',0,26,26,'en',0,26),

('nd_portfolio',0,27,27,'en',0,26),

('nd_portfolio',0,28,28,'en',0,26),

('nd_portfolio',0,29,29,'en',0,22),

('nd_portfolio',0,30,30,'en',0,26),

('nd_portfolio',0,31,31,'en',0,26),

('nd_portfolio',0,32,32,'en',0,26),

('nd_portfolio',0,33,33,'en',0,26),

('nd_portfolio',0,56,63,'en',0,26),

('nd_portfolio',0,56,63,'en',1,27);

/*Table structure for table `node__field_position` */

DROP TABLE IF EXISTS `node__field_position`;

CREATE TABLE `node__field_position` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_position_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_position.';

/*Data for the table `node__field_position` */

insert  into `node__field_position`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_position_value`) values 

('nd_person',0,57,64,'en',0,'Creative Director'),

('nd_person',0,58,65,'en',0,'Web Director'),

('nd_person',0,59,66,'en',0,'Designer'),

('nd_person',0,60,67,'en',0,'CEO');

/*Table structure for table `node__field_project` */

DROP TABLE IF EXISTS `node__field_project`;

CREATE TABLE `node__field_project` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_project_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_project_target_id` (`field_project_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_project.';

/*Data for the table `node__field_project` */

insert  into `node__field_project`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_project_target_id`) values 

('nd_portfolio',0,10,10,'en',0,16),

('nd_portfolio',0,10,10,'en',1,17),

('nd_portfolio',0,11,11,'en',0,17),

('nd_portfolio',0,11,11,'en',1,19),

('nd_portfolio',0,12,12,'en',0,17),

('nd_portfolio',0,12,12,'en',1,19),

('nd_portfolio',0,13,13,'en',0,17),

('nd_portfolio',0,13,13,'en',1,19),

('nd_portfolio',0,14,14,'en',0,21),

('nd_portfolio',0,14,14,'en',1,16),

('nd_portfolio',0,15,15,'en',0,17),

('nd_portfolio',0,16,16,'en',0,20),

('nd_portfolio',0,17,17,'en',0,21),

('nd_portfolio',0,18,18,'en',0,18),

('nd_portfolio',0,19,19,'en',0,20),

('nd_portfolio',0,20,20,'en',0,16),

('nd_portfolio',0,21,21,'en',0,21),

('nd_portfolio',0,22,22,'en',0,17),

('nd_portfolio',0,23,23,'en',0,16),

('nd_portfolio',0,24,24,'en',0,21),

('nd_portfolio',0,25,25,'en',0,16),

('nd_portfolio',0,26,26,'en',0,20),

('nd_portfolio',0,27,27,'en',0,16),

('nd_portfolio',0,28,28,'en',0,16),

('nd_portfolio',0,29,29,'en',0,16),

('nd_portfolio',0,30,30,'en',0,17),

('nd_portfolio',0,31,31,'en',0,16),

('nd_portfolio',0,32,32,'en',0,17),

('nd_portfolio',0,33,33,'en',0,16),

('nd_portfolio',0,56,63,'en',0,17);

/*Table structure for table `node__field_project_link` */

DROP TABLE IF EXISTS `node__field_project_link`;

CREATE TABLE `node__field_project_link` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_project_link_uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `field_project_link_title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `field_project_link_options` longblob COMMENT 'Serialized array of options for the link.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_project_link_uri` (`field_project_link_uri`(30))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_project_link.';

/*Data for the table `node__field_project_link` */

insert  into `node__field_project_link`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_project_link_uri`,`field_project_link_title`,`field_project_link_options`) values 

('nd_portfolio',0,10,10,'en',0,'internal:/node/67','View Online','a:0:{}'),

('nd_portfolio',0,11,11,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,12,12,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,13,13,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,14,14,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,15,15,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,16,16,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,17,17,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,18,18,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,19,19,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,20,20,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,21,21,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,22,22,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,23,23,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,24,24,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,25,25,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,26,26,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,27,27,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,28,28,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,29,29,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,30,30,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,31,31,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,32,32,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,33,33,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,56,63,'en',0,'internal:/','Visit Project','a:0:{}');

/*Table structure for table `node__field_second_title` */

DROP TABLE IF EXISTS `node__field_second_title`;

CREATE TABLE `node__field_second_title` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_second_title_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_second_title.';

/*Data for the table `node__field_second_title` */

insert  into `node__field_second_title`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_second_title_value`) values 

('nd_blog',0,2,2,'en',0,'Here is the big headline for your blog post'),

('nd_blog',0,3,3,'en',0,'Here is the big headline for your blog post'),

('nd_blog',0,4,4,'en',0,'Here is the big headline for your blog post'),

('nd_blog',0,5,5,'en',0,'Here is the big headline for your blog post'),

('nd_blog',0,6,6,'en',0,'Here is the big headline for your blog post');

/*Table structure for table `node__field_social_links` */

DROP TABLE IF EXISTS `node__field_social_links`;

CREATE TABLE `node__field_social_links` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_social_links_uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `field_social_links_title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `field_social_links_options` longblob COMMENT 'Serialized array of options for the link.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_social_links_uri` (`field_social_links_uri`(30))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_social_links.';

/*Data for the table `node__field_social_links` */

insert  into `node__field_social_links`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_social_links_uri`,`field_social_links_title`,`field_social_links_options`) values 

('nd_person',0,57,64,'en',0,'http://facebook.com/nikadevs','fa fa-facebook','a:0:{}'),

('nd_person',0,57,64,'en',1,'http://twitter.com/nikadevs','fa fa-twitter','a:0:{}'),

('nd_person',0,57,64,'en',2,'http://themeforest.com','fa fa-pinterest','a:0:{}'),

('nd_person',0,58,65,'en',0,'http://facebook.com/nikadevs','fa fa-facebook','a:0:{}'),

('nd_person',0,58,65,'en',1,'http://twitter.com/nikadevs','fa fa-twitter','a:0:{}'),

('nd_person',0,59,66,'en',0,'http://twitter.com/nikadevs','fa fa-twitter','a:0:{}'),

('nd_person',0,59,66,'en',1,'http://facebook.com/nikadevs','fa fa-facebook','a:0:{}'),

('nd_person',0,60,67,'en',0,'http://facebook.com/nikadevs','fa fa-facebook','a:0:{}'),

('nd_person',0,60,67,'en',1,'http://twitter.com/nikadevs','fa fa-twitter','a:0:{}');

/*Table structure for table `node__field_tags` */

DROP TABLE IF EXISTS `node__field_tags`;

CREATE TABLE `node__field_tags` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_tags_target_id` (`field_tags_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_tags.';

/*Data for the table `node__field_tags` */

insert  into `node__field_tags`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_tags_target_id`) values 

('nd_blog',0,3,3,'en',0,10),

('nd_blog',0,3,3,'en',1,12),

('nd_blog',0,3,3,'en',2,15),

('nd_blog',0,4,4,'en',0,10),

('nd_blog',0,5,5,'en',0,12),

('nd_blog',0,6,6,'en',0,12);

/*Table structure for table `node__webform` */

DROP TABLE IF EXISTS `node__webform`;

CREATE TABLE `node__webform` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `webform_target_id` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the webform entity.',
  `webform_default_data` text COMMENT 'Default submission data.',
  `webform_status` varchar(20) DEFAULT NULL COMMENT 'Flag to control whether this webform should be open, closed, or scheduled for new submissions.',
  `webform_open` varchar(20) DEFAULT NULL COMMENT 'The open date/time.',
  `webform_close` varchar(20) DEFAULT NULL COMMENT 'The close date/time.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `webform_target_id` (`webform_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field webform.';

/*Data for the table `node__webform` */

insert  into `node__webform`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`webform_target_id`,`webform_default_data`,`webform_status`,`webform_open`,`webform_close`) values 

('webform',0,73,80,'en',0,'contact_1','','open',NULL,NULL),

('webform',0,98,105,'en',0,'subscribe','','open',NULL,NULL);

/*Table structure for table `node_access` */

DROP TABLE IF EXISTS `node_access`;

CREATE TABLE `node_access` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record affects.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language.langcode of this node.',
  `fallback` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether this record should be used as a fallback if a language condition is not provided.',
  `gid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The grant ID a user must possess in the specified realm to gain this row''s privileges on the node.',
  `realm` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The realm in which the user must possess the grant ID. Modules can define one or more realms by implementing hook_node_grants().',
  `grant_view` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can view this node.',
  `grant_update` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can edit this node.',
  `grant_delete` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can delete this node.',
  PRIMARY KEY (`nid`,`gid`,`realm`,`langcode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Identifies which realm/grant pairs a user must possess in…';

/*Data for the table `node_access` */

insert  into `node_access`(`nid`,`langcode`,`fallback`,`gid`,`realm`,`grant_view`,`grant_update`,`grant_delete`) values 

(0,'',1,0,'all',1,0,0);

/*Table structure for table `node_field_data` */

DROP TABLE IF EXISTS `node_field_data`;

CREATE TABLE `node_field_data` (
  `nid` int(10) unsigned NOT NULL,
  `vid` int(10) unsigned NOT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `title` varchar(255) NOT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `status` tinyint(4) NOT NULL,
  `created` int(11) NOT NULL,
  `changed` int(11) NOT NULL,
  `promote` tinyint(4) NOT NULL,
  `sticky` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`nid`,`langcode`),
  KEY `node__id__default_langcode__langcode` (`nid`,`default_langcode`,`langcode`),
  KEY `node__vid` (`vid`),
  KEY `node_field__type__target_id` (`type`),
  KEY `node_field__created` (`created`),
  KEY `node_field__changed` (`changed`),
  KEY `node__frontpage` (`promote`,`status`,`sticky`,`created`),
  KEY `node__status_type` (`status`,`type`,`nid`),
  KEY `node__title_type` (`title`(191),`type`(4)),
  KEY `node_field__uid__target_id` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for node entities.';

/*Data for the table `node_field_data` */

insert  into `node_field_data`(`nid`,`vid`,`type`,`langcode`,`title`,`uid`,`status`,`created`,`changed`,`promote`,`sticky`,`revision_translation_affected`,`default_langcode`) values 

(2,2,'nd_blog','en','Design Trends in 2015 year',1,1,1479930877,1480024165,0,0,1,1),

(3,3,'nd_blog','en','Style in Web Design and Logo',1,1,1479935645,1480024255,0,0,1,1),

(4,4,'nd_blog','en','HIPSTER’S STYLE IN WEB DESIGN AND LOGO',1,1,1480286083,1480286158,0,0,1,1),

(5,5,'nd_blog','en','MINIMALISTIC DESIGN FOREVER',1,1,1480286238,1480286424,0,0,1,1),

(6,6,'nd_blog','en','NEW WEB DESIGN TRENDS IN 2015 YEAR',1,1,1480286668,1480291120,0,0,1,1),

(7,7,'nd_blog','en','Video Post Only',1,1,1480287436,1485274011,0,0,1,1),

(8,8,'nd_blog','en','POST WITH TEXT ONLY',1,1,1480288167,1480288187,0,0,1,1),

(9,9,'nd_blog','en','Quote post only',1,1,1480288193,1485213524,0,0,1,1),

(10,10,'nd_portfolio','en','Creative Project',1,1,1480353947,1480371784,0,0,1,1),

(11,11,'nd_portfolio','en','Awesome Stuff',1,1,1480370156,1480371825,0,0,1,1),

(12,12,'nd_portfolio','en','Creative Project',1,1,1480370156,1480371772,0,0,1,1),

(13,13,'nd_portfolio','en','Portrait',1,1,1480370156,1480371854,0,0,1,1),

(14,14,'nd_portfolio','en','Vase 3d',1,1,1480370156,1480371923,0,0,1,1),

(15,15,'nd_portfolio','en','Boy in T-Shirt',1,1,1480370156,1480371944,0,0,1,1),

(16,16,'nd_portfolio','en','Model',1,1,1480370156,1481152669,0,0,1,1),

(17,17,'nd_portfolio','en','Space',1,1,1480370156,1480372867,0,0,1,1),

(18,18,'nd_portfolio','en','Young Man',1,1,1480370156,1480372901,0,0,1,1),

(19,19,'nd_portfolio','en','Tablet',1,1,1480370156,1480372921,0,0,1,1),

(20,20,'nd_portfolio','en','Awesome Stuff',1,1,1480370156,1480372942,0,0,1,1),

(21,21,'nd_portfolio','en','Another Project',1,1,1480370156,1480372974,0,0,1,1),

(22,22,'nd_portfolio','en','Young Man',1,1,1480370156,1480373001,0,0,1,1),

(23,23,'nd_portfolio','en','Tablet',1,1,1480370156,1480373023,0,0,1,1),

(24,24,'nd_portfolio','en','Young Man',1,1,1480370156,1480373044,0,0,1,1),

(25,25,'nd_portfolio','en','Boy in T-Shirt',1,1,1480370156,1480373067,0,0,1,1),

(26,26,'nd_portfolio','en','Model',1,1,1480370156,1480373100,0,0,1,1),

(27,27,'nd_portfolio','en','Space',1,1,1480370156,1480373120,0,0,1,1),

(28,28,'nd_portfolio','en','Model',1,1,1480370156,1480373155,0,0,1,1),

(29,29,'nd_portfolio','en','Portrait',1,1,1480370156,1480373175,0,0,1,1),

(30,30,'nd_portfolio','en','Vase 3d',1,1,1480370156,1480373195,0,0,1,1),

(31,31,'nd_portfolio','en','Creative Project',1,1,1480370156,1480373223,0,0,1,1),

(32,32,'nd_portfolio','en','Young Man',1,1,1480370156,1480373242,0,0,1,1),

(33,33,'nd_portfolio','en','Another Project',1,1,1480370156,1480373265,0,0,1,1),

(34,41,'page','en','Accordions',1,1,1480453954,1480805639,0,0,1,1),

(35,42,'page','en','Bar (Progress)',1,1,1480458820,1485602880,0,0,1,1),

(36,43,'page','en','Buttons',1,1,1480460092,1480805840,0,0,1,1),

(37,44,'page','en','Features Box',1,1,1480845255,1480845283,0,0,1,1),

(38,45,'page','en','Grid',1,1,1480845611,1480845629,0,0,1,1),

(39,46,'page','en','Icons Et-Line',1,1,1480846267,1480846291,0,0,1,1),

(40,47,'page','en','Icons Font Awesome',1,1,1480846304,1480846324,0,0,1,1),

(41,48,'page','en','Messages',1,1,1480846897,1480846909,0,0,1,1),

(42,49,'page','en','Page Titles',1,1,1480847999,1480848220,0,0,1,1),

(43,50,'page','en','Sliders',1,1,1480853429,1506588741,0,0,1,1),

(44,51,'page','en','Tabs',1,1,1480871683,1480871696,0,0,1,1),

(45,52,'page','en','Typography',1,1,1480871738,1480871749,0,0,1,1),

(46,53,'page','en','Video & Sound',1,1,1480872062,1480872074,0,0,1,1),

(47,54,'page','en','Header',1,1,1480889735,1480889752,0,0,1,1),

(48,55,'page','en','Header Dark Transparent',1,1,1480890245,1480890268,0,0,1,1),

(49,56,'page','en','Pricing 1',1,1,1480890754,1480892886,0,0,1,1),

(50,57,'page','en','Pricing 2',1,1,1480892998,1480893011,0,0,1,1),

(54,61,'page','en','Header White',1,1,1480942321,1480942368,0,0,1,1),

(55,62,'page','en','Header White Transparent',1,1,1480942709,1480942721,0,0,1,1),

(56,63,'nd_portfolio','en','Awesome Stuff',1,1,1481049607,1481146628,0,0,1,1),

(57,64,'nd_person','en','Emma Connor',1,1,1481227740,1481228801,0,0,1,1),

(58,65,'nd_person','en','Steve Anders',1,1,1481227740,1481228937,0,0,1,1),

(59,66,'nd_person','en','Marta Laning',1,1,1481227740,1481228836,0,0,1,1),

(60,67,'nd_person','en','Thomas Rhythm',1,1,1481227740,1481229093,0,0,1,1),

(61,68,'page','en','Team 1',1,1,1481587530,1481587750,0,0,1,1),

(62,69,'page','en','Team 2',1,1,1481587803,1481587831,0,0,1,1),

(63,70,'page','en','About Us 1',1,1,1481645824,1481645894,0,0,1,1),

(64,71,'page','en','About Us 2',1,1,1481645974,1481646075,0,0,1,1),

(65,72,'page','en','About Us 3',1,1,1481646115,1481646150,0,0,1,1),

(66,73,'page','en','Services 1',1,1,1481646488,1485804706,0,0,1,1),

(67,74,'page','en','Services 2',1,1,1481646522,1481646537,0,0,1,1),

(68,75,'page','en','Services 3',1,1,1481646542,1481646651,0,0,1,1),

(69,76,'page','en','Clients',1,1,1481646694,1481646707,0,0,1,1),

(70,77,'page','en','Landing Page',1,1,1481646843,1507618849,0,0,1,1),

(71,78,'page','en','FAQ 1',1,1,1481646866,1535622682,0,0,1,1),

(72,79,'page','en','FAQ 2',1,1,1481646905,1481646991,0,0,1,1),

(73,80,'webform','en','Contact 1 form',1,1,1481647974,1481647993,0,0,1,1),

(74,81,'page','en','Contact 1',1,1,1481648270,1481648290,0,0,1,1),

(75,82,'page','en','Contact 2',1,1,1481648564,1481648589,0,0,1,1),

(76,83,'gallery_item','en','Young Man',1,1,1481650769,1481650798,0,0,1,1),

(77,84,'gallery_item','en','Boy in T-Shirt',1,1,1481650807,1481650827,0,0,1,1),

(78,85,'gallery_item','en','Awesome Photo',1,1,1481650832,1481650850,0,0,1,1),

(79,86,'gallery_item','en','Creative Project',1,1,1481650938,1481650961,0,0,1,1),

(80,87,'gallery_item','en','Young Man',1,1,1481650966,1481650982,0,0,1,1),

(81,88,'gallery_item','en','Boy in T-Shirt',1,1,1481650987,1481651002,0,0,1,1),

(82,89,'gallery_item','en','Young Man',1,1,1481651008,1481651023,0,0,1,1),

(83,90,'gallery_item','en','Model',1,1,1481651028,1481651047,0,0,1,1),

(84,91,'gallery_item','en','Creative Project',1,1,1481651051,1481651067,0,0,1,1),

(85,92,'gallery_item','en','Creative Project',1,1,1481651072,1481651090,0,0,1,1),

(86,93,'gallery_item','en','Another Project',1,1,1481651121,1481651144,0,0,1,1),

(87,94,'gallery_item','en','Awesome Photo',1,1,1481651150,1481651170,0,0,1,1),

(88,95,'gallery_item','en','Awesome Stuff',1,1,1481651178,1481651218,0,0,1,1),

(89,96,'gallery_item','en','Boy in T-Shirt',1,1,1481651224,1481651250,0,0,1,1),

(90,97,'gallery_item','en','Creative Project',1,1,1481651255,1481651272,0,0,1,1),

(91,98,'gallery_item','en','Vase 3d',1,1,1481651278,1481651297,0,0,1,1),

(92,99,'gallery_item','en','Young Man',1,1,1481651334,1481651350,0,0,1,1),

(93,100,'gallery_item','en','Another Project',1,1,1481651356,1481651372,0,0,1,1),

(94,101,'gallery_item','en','Awesome Photo',1,1,1481651377,1481651393,0,0,1,1),

(95,102,'page','en','Page not found',1,1,1481654500,1481654575,0,0,1,1),

(96,103,'page','en','Maintenance Page',1,1,1481654600,1481654627,0,0,1,1),

(97,104,'page','en','Main Demo',1,1,1481655418,1492592311,0,0,1,1),

(98,105,'webform','en','Subscribe Inline',1,1,1481661323,1481661407,0,0,1,1),

(99,106,'gallery_item','en','d',1,1,1481906370,1481906463,0,0,1,1),

(100,107,'page','en','Test',1,1,1483031955,1483032955,0,0,1,1),

(101,108,'page','en','Special Photographer Portfolio',1,1,1484911552,1484911597,0,0,1,1),

(102,109,'page','en','One Page',1,1,1484927968,1485802805,0,0,1,1),

(103,110,'page','en','Special Photographer Portfolio OnePage',1,1,1485211873,1485211887,0,0,1,1),

(107,114,'page','en','Shop',1,1,1503047450,1503047489,0,0,1,1);

/*Table structure for table `node_field_revision` */

DROP TABLE IF EXISTS `node_field_revision`;

CREATE TABLE `node_field_revision` (
  `nid` int(10) unsigned NOT NULL,
  `vid` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `status` tinyint(4) NOT NULL,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `promote` tinyint(4) DEFAULT NULL,
  `sticky` tinyint(4) DEFAULT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`vid`,`langcode`),
  KEY `node__id__default_langcode__langcode` (`nid`,`default_langcode`,`langcode`),
  KEY `node_field__uid__target_id` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The revision data table for node entities.';

/*Data for the table `node_field_revision` */

insert  into `node_field_revision`(`nid`,`vid`,`langcode`,`title`,`uid`,`status`,`created`,`changed`,`promote`,`sticky`,`revision_translation_affected`,`default_langcode`) values 

(2,2,'en','Design Trends in 2015 year',1,1,1479930877,1480024165,0,0,1,1),

(3,3,'en','Style in Web Design and Logo',1,1,1479935645,1480024255,0,0,1,1),

(4,4,'en','HIPSTER’S STYLE IN WEB DESIGN AND LOGO',1,1,1480286083,1480286158,0,0,1,1),

(5,5,'en','MINIMALISTIC DESIGN FOREVER',1,1,1480286238,1480286424,0,0,1,1),

(6,6,'en','NEW WEB DESIGN TRENDS IN 2015 YEAR',1,1,1480286668,1480291120,0,0,1,1),

(7,7,'en','Video Post Only',1,1,1480287436,1485274011,0,0,1,1),

(8,8,'en','POST WITH TEXT ONLY',1,1,1480288167,1480288187,0,0,1,1),

(9,9,'en','Quote post only',1,1,1480288193,1485213524,0,0,1,1),

(10,10,'en','Creative Project',1,1,1480353947,1480371784,0,0,1,1),

(11,11,'en','Awesome Stuff',1,1,1480370156,1480371825,0,0,1,1),

(12,12,'en','Creative Project',1,1,1480370156,1480371772,0,0,1,1),

(13,13,'en','Portrait',1,1,1480370156,1480371854,0,0,1,1),

(14,14,'en','Vase 3d',1,1,1480370156,1480371923,0,0,1,1),

(15,15,'en','Boy in T-Shirt',1,1,1480370156,1480371944,0,0,1,1),

(16,16,'en','Model',1,1,1480370156,1481152669,0,0,1,1),

(17,17,'en','Space',1,1,1480370156,1480372867,0,0,1,1),

(18,18,'en','Young Man',1,1,1480370156,1480372901,0,0,1,1),

(19,19,'en','Tablet',1,1,1480370156,1480372921,0,0,1,1),

(20,20,'en','Awesome Stuff',1,1,1480370156,1480372942,0,0,1,1),

(21,21,'en','Another Project',1,1,1480370156,1480372974,0,0,1,1),

(22,22,'en','Young Man',1,1,1480370156,1480373001,0,0,1,1),

(23,23,'en','Tablet',1,1,1480370156,1480373023,0,0,1,1),

(24,24,'en','Young Man',1,1,1480370156,1480373044,0,0,1,1),

(25,25,'en','Boy in T-Shirt',1,1,1480370156,1480373067,0,0,1,1),

(26,26,'en','Model',1,1,1480370156,1480373100,0,0,1,1),

(27,27,'en','Space',1,1,1480370156,1480373120,0,0,1,1),

(28,28,'en','Model',1,1,1480370156,1480373155,0,0,1,1),

(29,29,'en','Portrait',1,1,1480370156,1480373175,0,0,1,1),

(30,30,'en','Vase 3d',1,1,1480370156,1480373195,0,0,1,1),

(31,31,'en','Creative Project',1,1,1480370156,1480373223,0,0,1,1),

(32,32,'en','Young Man',1,1,1480370156,1480373242,0,0,1,1),

(33,33,'en','Another Project',1,1,1480370156,1480373265,0,0,1,1),

(34,34,'en','Accordions',1,1,1480453954,1480454001,0,0,1,1),

(34,35,'en','Accordions',1,1,1480453954,1480454662,0,0,1,1),

(34,36,'en','Accordions',1,1,1480453954,1480454741,0,0,1,1),

(34,37,'en','Accordions',1,1,1480453954,1480454757,0,0,1,1),

(34,38,'en','Accordions',1,1,1480453954,1480454764,0,0,1,1),

(35,39,'en','Bar (Progress)',1,1,1480458820,1480458836,0,0,1,1),

(36,40,'en','Buttons',1,1,1480460092,1480460105,0,0,1,1),

(34,41,'en','Accordions',1,1,1480453954,1480805639,0,0,1,1),

(35,42,'en','Bar (Progress)',1,1,1480458820,1485602880,0,0,1,1),

(36,43,'en','Buttons',1,1,1480460092,1480805840,0,0,1,1),

(37,44,'en','Features Box',1,1,1480845255,1480845283,0,0,1,1),

(38,45,'en','Grid',1,1,1480845611,1480845629,0,0,1,1),

(39,46,'en','Icons Et-Line',1,1,1480846267,1480846291,0,0,1,1),

(40,47,'en','Icons Font Awesome',1,1,1480846304,1480846324,0,0,1,1),

(41,48,'en','Messages',1,1,1480846897,1480846909,0,0,1,1),

(42,49,'en','Page Titles',1,1,1480847999,1480848220,0,0,1,1),

(43,50,'en','Sliders',1,1,1480853429,1506588741,0,0,1,1),

(44,51,'en','Tabs',1,1,1480871683,1480871696,0,0,1,1),

(45,52,'en','Typography',1,1,1480871738,1480871749,0,0,1,1),

(46,53,'en','Video & Sound',1,1,1480872062,1480872074,0,0,1,1),

(47,54,'en','Header',1,1,1480889735,1480889752,0,0,1,1),

(48,55,'en','Header Dark Transparent',1,1,1480890245,1480890268,0,0,1,1),

(49,56,'en','Pricing 1',1,1,1480890754,1480892886,0,0,1,1),

(50,57,'en','Pricing 2',1,1,1480892998,1480893011,0,0,1,1),

(54,61,'en','Header White',1,1,1480942321,1480942368,0,0,1,1),

(55,62,'en','Header White Transparent',1,1,1480942709,1480942721,0,0,1,1),

(56,63,'en','Awesome Stuff',1,1,1481049607,1481146628,0,0,1,1),

(57,64,'en','Emma Connor',1,1,1481227740,1481228801,0,0,1,1),

(58,65,'en','Steve Anders',1,1,1481227740,1481228937,0,0,1,1),

(59,66,'en','Marta Laning',1,1,1481227740,1481228836,0,0,1,1),

(60,67,'en','Thomas Rhythm',1,1,1481227740,1481229093,0,0,1,1),

(61,68,'en','Team 1',1,1,1481587530,1481587750,0,0,1,1),

(62,69,'en','Team 2',1,1,1481587803,1481587831,0,0,1,1),

(63,70,'en','About Us 1',1,1,1481645824,1481645894,0,0,1,1),

(64,71,'en','About Us 2',1,1,1481645974,1481646075,0,0,1,1),

(65,72,'en','About Us 3',1,1,1481646115,1481646150,0,0,1,1),

(66,73,'en','Services 1',1,1,1481646488,1485804706,0,0,1,1),

(67,74,'en','Services 2',1,1,1481646522,1481646537,0,0,1,1),

(68,75,'en','Services 3',1,1,1481646542,1481646651,0,0,1,1),

(69,76,'en','Clients',1,1,1481646694,1481646707,0,0,1,1),

(70,77,'en','Landing Page',1,1,1481646843,1507618849,0,0,1,1),

(71,78,'en','FAQ 1',1,1,1481646866,1535622682,0,0,1,1),

(72,79,'en','FAQ 2',1,1,1481646905,1481646991,0,0,1,1),

(73,80,'en','Contact 1 form',1,1,1481647974,1481647993,0,0,1,1),

(74,81,'en','Contact 1',1,1,1481648270,1481648290,0,0,1,1),

(75,82,'en','Contact 2',1,1,1481648564,1481648589,0,0,1,1),

(76,83,'en','Young Man',1,1,1481650769,1481650798,0,0,1,1),

(77,84,'en','Boy in T-Shirt',1,1,1481650807,1481650827,0,0,1,1),

(78,85,'en','Awesome Photo',1,1,1481650832,1481650850,0,0,1,1),

(79,86,'en','Creative Project',1,1,1481650938,1481650961,0,0,1,1),

(80,87,'en','Young Man',1,1,1481650966,1481650982,0,0,1,1),

(81,88,'en','Boy in T-Shirt',1,1,1481650987,1481651002,0,0,1,1),

(82,89,'en','Young Man',1,1,1481651008,1481651023,0,0,1,1),

(83,90,'en','Model',1,1,1481651028,1481651047,0,0,1,1),

(84,91,'en','Creative Project',1,1,1481651051,1481651067,0,0,1,1),

(85,92,'en','Creative Project',1,1,1481651072,1481651090,0,0,1,1),

(86,93,'en','Another Project',1,1,1481651121,1481651144,0,0,1,1),

(87,94,'en','Awesome Photo',1,1,1481651150,1481651170,0,0,1,1),

(88,95,'en','Awesome Stuff',1,1,1481651178,1481651218,0,0,1,1),

(89,96,'en','Boy in T-Shirt',1,1,1481651224,1481651250,0,0,1,1),

(90,97,'en','Creative Project',1,1,1481651255,1481651272,0,0,1,1),

(91,98,'en','Vase 3d',1,1,1481651278,1481651297,0,0,1,1),

(92,99,'en','Young Man',1,1,1481651334,1481651350,0,0,1,1),

(93,100,'en','Another Project',1,1,1481651356,1481651372,0,0,1,1),

(94,101,'en','Awesome Photo',1,1,1481651377,1481651393,0,0,1,1),

(95,102,'en','Page not found',1,1,1481654500,1481654575,0,0,1,1),

(96,103,'en','Maintenance Page',1,1,1481654600,1481654627,0,0,1,1),

(97,104,'en','Main Demo',1,1,1481655418,1492592311,0,0,1,1),

(98,105,'en','Subscribe Inline',1,1,1481661323,1481661407,0,0,1,1),

(99,106,'en','d',1,1,1481906370,1481906463,0,0,1,1),

(100,107,'en','Test',1,1,1483031955,1483032955,0,0,1,1),

(101,108,'en','Special Photographer Portfolio',1,1,1484911552,1484911597,0,0,1,1),

(102,109,'en','One Page',1,1,1484927968,1485802805,0,0,1,1),

(103,110,'en','Special Photographer Portfolio OnePage',1,1,1485211873,1485211887,0,0,1,1),

(107,114,'en','Shop',1,1,1503047450,1503047489,0,0,1,1);

/*Table structure for table `node_revision` */

DROP TABLE IF EXISTS `node_revision`;

CREATE TABLE `node_revision` (
  `nid` int(10) unsigned NOT NULL,
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `revision_timestamp` int(11) DEFAULT NULL,
  `revision_uid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `revision_log` longtext,
  `revision_default` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`vid`),
  KEY `node__nid` (`nid`),
  KEY `node_field__langcode` (`langcode`),
  KEY `node_field__revision_uid__target_id` (`revision_uid`)
) ENGINE=InnoDB AUTO_INCREMENT=115 DEFAULT CHARSET=utf8mb4 COMMENT='The revision table for node entities.';

/*Data for the table `node_revision` */

insert  into `node_revision`(`nid`,`vid`,`langcode`,`revision_timestamp`,`revision_uid`,`revision_log`,`revision_default`) values 

(2,2,'en',1479930925,1,NULL,1),

(3,3,'en',1479935804,1,NULL,1),

(4,4,'en',1480286127,1,NULL,1),

(5,5,'en',1480286311,1,NULL,1),

(6,6,'en',1480286700,1,NULL,1),

(7,7,'en',1480287497,1,NULL,1),

(8,8,'en',1480288187,1,NULL,1),

(9,9,'en',1480288235,1,NULL,1),

(10,10,'en',1480369385,1,NULL,1),

(11,11,'en',1480370237,1,NULL,1),

(12,12,'en',1480370336,1,NULL,1),

(13,13,'en',1480370373,1,NULL,1),

(14,14,'en',1480370386,1,NULL,1),

(15,15,'en',1480370401,1,NULL,1),

(16,16,'en',1480370552,1,NULL,1),

(17,17,'en',1480370565,1,NULL,1),

(18,18,'en',1480370588,1,NULL,1),

(19,19,'en',1480370603,1,NULL,1),

(20,20,'en',1480370622,1,NULL,1),

(21,21,'en',1480371046,1,NULL,1),

(22,22,'en',1480371121,1,NULL,1),

(23,23,'en',1480371131,1,NULL,1),

(24,24,'en',1480371146,1,NULL,1),

(25,25,'en',1480371157,1,NULL,1),

(26,26,'en',1480371171,1,NULL,1),

(27,27,'en',1480371181,1,NULL,1),

(28,28,'en',1480371422,1,NULL,1),

(29,29,'en',1480371431,1,NULL,1),

(30,30,'en',1480371442,1,NULL,1),

(31,31,'en',1480371453,1,NULL,1),

(32,32,'en',1480371472,1,NULL,1),

(33,33,'en',1480371480,1,NULL,1),

(34,34,'en',1480454001,1,NULL,1),

(34,35,'en',1480454662,1,NULL,1),

(34,36,'en',1480454741,1,NULL,1),

(34,37,'en',1480454757,1,NULL,1),

(34,38,'en',1480454764,1,NULL,1),

(35,39,'en',1480458836,1,NULL,1),

(36,40,'en',1480460105,1,NULL,1),

(34,41,'en',1480805639,1,NULL,1),

(35,42,'en',1480805652,1,NULL,1),

(36,43,'en',1480805840,1,NULL,1),

(37,44,'en',1480845283,1,NULL,1),

(38,45,'en',1480845629,1,NULL,1),

(39,46,'en',1480846291,1,NULL,1),

(40,47,'en',1480846324,1,NULL,1),

(41,48,'en',1480846909,1,NULL,1),

(42,49,'en',1480848027,1,NULL,1),

(43,50,'en',1480853509,1,NULL,1),

(44,51,'en',1480871696,1,NULL,1),

(45,52,'en',1480871749,1,NULL,1),

(46,53,'en',1480872074,1,NULL,1),

(47,54,'en',1480889752,1,NULL,1),

(48,55,'en',1480890268,1,NULL,1),

(49,56,'en',1480892392,1,NULL,1),

(50,57,'en',1480893011,1,NULL,1),

(54,61,'en',1480942368,1,NULL,1),

(55,62,'en',1480942721,1,NULL,1),

(56,63,'en',1481049627,1,NULL,1),

(57,64,'en',1481227764,1,NULL,1),

(58,65,'en',1481228512,1,NULL,1),

(59,66,'en',1481228573,1,NULL,1),

(60,67,'en',1481228716,1,NULL,1),

(61,68,'en',1481587559,1,NULL,1),

(62,69,'en',1481587831,1,NULL,1),

(63,70,'en',1481645894,1,NULL,1),

(64,71,'en',1481646075,1,NULL,1),

(65,72,'en',1481646150,1,NULL,1),

(66,73,'en',1481646507,1,NULL,1),

(67,74,'en',1481646537,1,NULL,1),

(68,75,'en',1481646651,1,NULL,1),

(69,76,'en',1481646707,1,NULL,1),

(70,77,'en',1481646854,1,NULL,1),

(71,78,'en',1481646885,1,NULL,1),

(72,79,'en',1481646965,1,NULL,1),

(73,80,'en',1481647993,1,NULL,1),

(74,81,'en',1481648290,1,NULL,1),

(75,82,'en',1481648589,1,NULL,1),

(76,83,'en',1481650795,1,NULL,1),

(77,84,'en',1481650818,1,NULL,1),

(78,85,'en',1481650846,1,NULL,1),

(79,86,'en',1481650959,1,NULL,1),

(80,87,'en',1481650977,1,NULL,1),

(81,88,'en',1481650998,1,NULL,1),

(82,89,'en',1481651019,1,NULL,1),

(83,90,'en',1481651043,1,NULL,1),

(84,91,'en',1481651064,1,NULL,1),

(85,92,'en',1481651087,1,NULL,1),

(86,93,'en',1481651139,1,NULL,1),

(87,94,'en',1481651167,1,NULL,1),

(88,95,'en',1481651215,1,NULL,1),

(89,96,'en',1481651247,1,NULL,1),

(90,97,'en',1481651269,1,NULL,1),

(91,98,'en',1481651295,1,NULL,1),

(92,99,'en',1481651348,1,NULL,1),

(93,100,'en',1481651370,1,NULL,1),

(94,101,'en',1481651391,1,NULL,1),

(95,102,'en',1481654575,1,NULL,1),

(96,103,'en',1481654627,1,NULL,1),

(97,104,'en',1481655435,1,NULL,1),

(98,105,'en',1481661407,1,NULL,1),

(99,106,'en',1481906415,1,NULL,1),

(100,107,'en',1483032882,1,NULL,1),

(101,108,'en',1484911597,1,NULL,1),

(102,109,'en',1484928067,1,NULL,1),

(103,110,'en',1485211887,1,NULL,1),

(107,114,'en',1503047489,1,NULL,1);

/*Table structure for table `node_revision__body` */

DROP TABLE IF EXISTS `node_revision__body`;

CREATE TABLE `node_revision__body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext NOT NULL,
  `body_summary` longtext,
  `body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field body.';

/*Data for the table `node_revision__body` */

insert  into `node_revision__body`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`body_value`,`body_summary`,`body_format`) values 

('nd_blog',0,2,2,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<p>&nbsp;SOMEONE FAMOUS IN&nbsp;<cite>SOURCE TITLE</cite></p>\r\n</blockquote>\r\n\r\n<p>Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul>\r\n	<li>First item of the list</li>\r\n	<li>Second item of the list</li>\r\n	<li>Third item of the list</li>\r\n</ul>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','basic_html'),

('nd_blog',0,3,3,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<p>&nbsp;SOMEONE FAMOUS IN&nbsp;<cite>SOURCE TITLE</cite></p>\r\n</blockquote>\r\n\r\n<p>Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul>\r\n	<li>First item of the list</li>\r\n	<li>Second item of the list</li>\r\n	<li>Third item of the list</li>\r\n</ul>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary: Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','basic_html'),

('nd_blog',0,4,4,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<p>&nbsp;SOMEONE FAMOUS IN&nbsp;<cite>SOURCE TITLE</cite></p>\r\n</blockquote>\r\n\r\n<p>Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul>\r\n	<li>First item of the list</li>\r\n	<li>Second item of the list</li>\r\n	<li>Third item of the list</li>\r\n</ul>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary: Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','ckeditor'),

('nd_blog',0,5,5,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<p>&nbsp;SOMEONE FAMOUS IN&nbsp;<cite>SOURCE TITLE</cite></p>\r\n</blockquote>\r\n\r\n<p>Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul>\r\n	<li>First item of the list</li>\r\n	<li>Second item of the list</li>\r\n	<li>Third item of the list</li>\r\n</ul>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary: Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','ckeditor'),

('nd_blog',0,6,6,'en',0,'<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<blockquote style=\"box-sizing: border-box; padding: 0px; margin: 3em 0px; font-size: 17.5px; border: none; line-height: 1.7; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; background-image: none; background-attachment: initial; background-size: initial; background-origin: initial; background-clip: initial; background-position: initial; background-repeat: initial;\">\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 1em; font-size: 24px; line-height: 1.6;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a&nbsp;ante.</p>\r\n\r\n<footer style=\"box-sizing: border-box; font-size: 11px; line-height: 1.42857143; text-transform: uppercase; letter-spacing: 2px;\">&nbsp;SOMEONE FAMOUS IN&nbsp;<cite style=\"box-sizing: border-box;\" title=\"Source Title\">SOURCE TITLE</cite></footer>\r\n</blockquote>\r\n\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">Praesent ultricies ut ipsum non laoreet. Nunc ac&nbsp;<a href=\"http://rhythm.bestlooker.pro/blog-single-sidebar-left.html#\" style=\"box-sizing: border-box; color: rgb(17, 17, 17); -webkit-tap-highlight-color: transparent; background-color: transparent;\">ultricies</a>&nbsp;leo. Nulla ac ultrices arcu. Nullam adipiscing lacus in consectetur posuere. Nunc malesuada tellus turpis, ac pretium orci molestie vel. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n\r\n<ul style=\"box-sizing: border-box; margin: 0px 0px 1.5em; -webkit-tap-highlight-color: transparent; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">\r\n	<li style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent;\">First item of the list</li>\r\n	<li style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent;\">Second item of the list</li>\r\n	<li style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent;\">Third item of the list</li>\r\n</ul>\r\n\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(95, 95, 95); font-family: \'Open Sans\', arial, sans-serif; font-size: 16px; line-height: 28.7999992370605px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem.</p>\r\n','<p>Summary: Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris non laoreet dui. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa.</p>\r\n\r\n<p>Fusce non ante sed lorem rutrum feugiat. Vestibulum pellentesque, purus ut&nbsp;dignissim consectetur, nulla erat ultrices purus, ut&nbsp;consequat sem elit non sem. Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>','ckeditor'),

('nd_blog',0,7,7,'en',0,'[nd_video url=\"https://www.youtube.com/watch?v=w2JUhDd0CAA\" different_values=\"0\"] [/nd_video]','','shortcodes'),

('nd_blog',0,8,8,'en',0,'<p>Suspendisse accumsan interdum tellus, eu imperdiet lacus consectetur sed. Aliquam in ligula ac lacus blandit commodo vel luctus quam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Cras eu ultrices mauris.</p>\r\n','','ckeditor'),

('nd_blog',0,9,9,'en',0,'[nd_quote different_values=\"0\" type=\"blog-item-q\" class=\"ui-sortable-handle\"]\r\n[html format=\"full_html\" different_values=\"0\"]<p>Curabitur iaculis, ligula facilisis volutpat suscipit, sapien felis tempor, consequat vitae velit</p>[/html]\r\n[/nd_quote]\r\n ','','shortcodes'),

('nd_portfolio',0,10,10,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,11,11,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,12,12,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,13,13,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,14,14,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,15,15,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,16,16,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,17,17,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,18,18,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,19,19,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,20,20,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,21,21,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,22,22,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,23,23,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,24,24,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,25,25,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,26,26,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,27,27,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,28,28,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,29,29,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,30,30,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,31,31,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,32,32,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_portfolio',0,33,33,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('page',0,34,34,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\" multiple_active=\"1\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,34,35,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\" multiple_active=\"1\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,34,36,'en',0,'[row][/row]','','shortcodes'),

('page',0,34,37,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[/col]\r\n[/row]','','shortcodes'),

('page',0,34,38,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\" multiple_active=\"1\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,34,41,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions different_values=\"0\" multiple_active=\"1\"]\r\n[nd_accordion title=\"First\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Second\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Third\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,35,39,'en',0,'[nd_bg different_values=\"0\" banner=\"0\" slider=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_progress type=\"Thin Line\" different_values=\"0\" frames=\"10\" duration=\"2000\" percent=\"85\" title=\"Brending\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Thin Line\" title=\"Design\" percent=\"80\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Thin Line\" title=\"Development\" percent=\"85\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Thin Line\" title=\"Photography\" percent=\"75\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_bg different_values=\"0\" extra_classes=\"page-section\" banner=\"0\" slider=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[col tablet=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_progress type=\"Wide Line\" title=\"Branding\" percent=\"80\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Wide Line\" title=\"Design\" percent=\"85\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Wide Line\" title=\"Development\" percent=\"75\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Wide Line\" title=\"Photography\" percent=\"70\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/nd_container]\r\n[/nd_bg]\r\n ','','shortcodes'),

('page',0,35,42,'en',0,'[nd_bg different_values=\"0\" banner=\"0\" slider=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_chartpie stroke_color=\"bc1616\" donut=\"0\" different_values=\"0\"]\r\n[nd_chartpieitem title=\"Teach Profile\" value=\"30\" value_color=\"ea052c\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Blocks\" value=\"30\" value_color=\"8b0202\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Us 3\" value=\"40\" value_color=\"f42424\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[/nd_chartpie]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_chartpie stroke_color=\"bc1616\" donut=\"1\" different_values=\"0\"]\r\n[nd_chartpieitem title=\"Teach Profile\" value=\"20\" value_color=\"b72425\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Blocks\" value=\"30\" value_color=\"890000\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Us 3\" value=\"40\" value_color=\"fb2122\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[nd_chartpieitem title=\"About Us 3\" value=\"10\" value_color=\"fc0000\" different_values=\"0\"]\r\n[/nd_chartpieitem]\r\n[/nd_chartpie]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg different_values=\"0\" banner=\"0\" slider=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_counter title=\"Current Year\" icon=\"fa fa-calendar\" number=\"2017\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg different_values=\"0\" banner=\"0\" slider=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_progress type=\"Thin Line\" different_values=\"0\" frames=\"10\" duration=\"2000\" percent=\"85\" title=\"Brending\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Thin Line\" title=\"Design\" percent=\"80\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Thin Line\" title=\"Development\" percent=\"85\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Thin Line\" title=\"Photography\" percent=\"75\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_bg different_values=\"0\" extra_classes=\"page-section\" banner=\"0\" slider=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[col tablet=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[nd_progress type=\"Wide Line\" title=\"Branding\" percent=\"80\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Wide Line\" title=\"Design\" percent=\"85\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Wide Line\" title=\"Development\" percent=\"75\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress type=\"Wide Line\" title=\"Photography\" percent=\"70\" duration=\"2000\" frames=\"10\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/nd_container]\r\n[/nd_bg]\r\n ','','shortcodes'),

('page',0,36,40,'en',0,'[nd_bg banner=\"0\" slider=\"0\" extra_classes=\"page-section\" different_values=\"0\" bg_repeat=\"repeat\" no_paddings=\"0\" bg_texture=\"0\" full_height=\"0\" full_width_container=\"0\" full_width=\"1\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_title extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" different_values=\"0\" title=\"Buttons on white\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col wide=\"3\" desktop=\"3\" tablet=\"6\" different_values=\"0\" style_margin_bottom=\"40\"]\r\n[nd_button block=\"1\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"large\" border=\"0\"]\r\n[/nd_button]\r\n[nd_button different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"medium\" block=\"1\" border=\"0\"]\r\n[/nd_button]\r\n[nd_button different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"small\" block=\"1\"]\r\n[/nd_button]\r\n[nd_button different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" block=\"1\" border=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[col wide=\"3\" desktop=\"3\" tablet=\"6\" different_values=\"0\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" block=\"1\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"large\" border=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"medium\" block=\"1\" border=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"small\" block=\"1\" border=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" block=\"1\" border=\"1\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" size=\"large\" color=\"dark\" text=\"Button\" invert=\"0\"]\r\n[/nd_button]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" size=\"medium\" color=\"dark\" text=\"Button\"]\r\n[/nd_button]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" size=\"small\" color=\"dark\" text=\"Button\"]\r\n[/nd_button]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" color=\"dark\" text=\"Button\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"dark\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"dark\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"dark\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" color=\"dark\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg extra_classes=\"page-section\" different_values=\"0\" bg_repeat=\"repeat\" no_paddings=\"0\" bg_texture=\"0\" full_height=\"0\" full_width_container=\"0\" full_width=\"1\" color=\"bg-dark-lighter\" slider=\"0\" banner=\"0\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Buttons on dark\" size=\"h2\" extra_classes=\"section-title mb-70 mb-sm-40\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\" button_type=\"border\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\" button_type=\"border\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\" button_type=\"border\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\" button_type=\"border\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button icon=\"fa fa-usd\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-glass\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-heart\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-envelope\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" icon=\"fa fa-usd\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" icon=\"fa fa-glass\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" icon=\"fa fa-heart\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" icon=\"fa fa-envelope\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button icon=\"fa fa-usd\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-glass\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-heart\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-envelope\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"0\" button_type=\"glass\"]\r\n[/nd_button]\r\n[nd_button invert=\"0\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\" button_type=\"glass\"]\r\n[/nd_button]\r\n[nd_button invert=\"0\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\" button_type=\"glass\"]\r\n[/nd_button]\r\n[nd_button invert=\"0\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\" icon_position=\"beside\" button_type=\"glass\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n ','','shortcodes'),

('page',0,36,43,'en',0,'[nd_bg banner=\"0\" slider=\"0\" extra_classes=\"page-section\" different_values=\"0\" bg_repeat=\"repeat\" no_paddings=\"0\" bg_texture=\"0\" full_height=\"0\" full_width_container=\"0\" full_width=\"1\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_title extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" different_values=\"0\" title=\"Buttons on white\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col wide=\"3\" desktop=\"3\" tablet=\"6\" different_values=\"0\" style_margin_bottom=\"40\"]\r\n[nd_button block=\"1\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"large\" border=\"0\"]\r\n[/nd_button]\r\n[nd_button different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"medium\" block=\"1\" border=\"0\"]\r\n[/nd_button]\r\n[nd_button different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"small\" block=\"1\"]\r\n[/nd_button]\r\n[nd_button different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" block=\"1\" border=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[col wide=\"3\" desktop=\"3\" tablet=\"6\" different_values=\"0\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" block=\"1\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"large\" border=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"medium\" block=\"1\" border=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" size=\"small\" block=\"1\" border=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" display=\"round\" text=\"Button\" color=\"dark\" block=\"1\" border=\"1\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" size=\"large\" color=\"dark\" text=\"Button\" invert=\"0\"]\r\n[/nd_button]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" size=\"medium\" color=\"dark\" text=\"Button\"]\r\n[/nd_button]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" size=\"small\" color=\"dark\" text=\"Button\"]\r\n[/nd_button]\r\n[nd_button border=\"0\" different_values=\"0\" block=\"1\" display=\"circle\" color=\"dark\" text=\"Button\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"dark\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"dark\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"dark\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"1\" block=\"1\" display=\"circle\" text=\"Button\" color=\"dark\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"gray\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg extra_classes=\"page-section\" different_values=\"0\" bg_repeat=\"repeat\" no_paddings=\"0\" bg_texture=\"0\" full_height=\"0\" full_width_container=\"0\" full_width=\"1\" color=\"bg-dark-lighter\" slider=\"0\" banner=\"0\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"Buttons on dark\" size=\"h2\" extra_classes=\"section-title mb-70 mb-sm-40\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\" button_type=\"border\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\" button_type=\"border\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\" button_type=\"border\"]\r\n[/nd_button]\r\n[nd_button invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\" button_type=\"border\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button icon=\"fa fa-usd\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-glass\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-heart\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-envelope\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button button_type=\"border\" icon=\"fa fa-usd\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" icon=\"fa fa-glass\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" icon=\"fa fa-heart\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button button_type=\"border\" icon=\"fa fa-envelope\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button icon=\"fa fa-usd\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"1\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-glass\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-heart\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[nd_button icon=\"fa fa-envelope\" invert=\"1\" different_values=\"0\" border=\"0\" block=\"1\" display=\"circle\" text=\"Button\" color=\"grey\" icon_position=\"beside\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\" desktop=\"3\" wide=\"3\" style_margin_bottom=\"40\"]\r\n[nd_button different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"large\" color=\"grey\" invert=\"0\" button_type=\"glass\"]\r\n[/nd_button]\r\n[nd_button invert=\"0\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"medium\" color=\"grey\" icon_position=\"beside\" button_type=\"glass\"]\r\n[/nd_button]\r\n[nd_button invert=\"0\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" size=\"small\" color=\"grey\" icon_position=\"beside\" button_type=\"glass\"]\r\n[/nd_button]\r\n[nd_button invert=\"0\" different_values=\"0\" border=\"0\" block=\"1\" display=\"round\" text=\"Button\" color=\"grey\" icon_position=\"beside\" button_type=\"glass\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n ','','shortcodes'),

('page',0,37,44,'en',0,'[nd_container different_values=\"0\"]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-camera\" text=\"photography\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Cras luctus interdum sodales. Quisque quis odio dui. Sedes sit amet neque malesuada, lobortis commodo magna ntesque pharetra metus vivera sagittis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-tools-2\" text=\"development\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Fusce aliquet quam eget neque ultrices elementum. Nulla posuere felis id arcu blandit sagittis. Eleifender vestibulum purus, sit amet vulputate risus.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-anchor\" text=\"support\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. Praesent sed nisi eleifend, fermentum orci sit amet, iaculis libero interdum.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_feature type=\"benefit\" different_values=\"0\" icon=\"fa fa-paper-plane-o\" text=\"Ideas\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]Donec pulvinar rutrum mi, sit amet viverra justo hendrerit eget.[/html]\r\n[/nd_feature]\r\n[nd_feature type=\"benefit\" different_values=\"0\" icon=\"fa fa-cogs\" text=\"Discussions\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]Mauris tincidunt augue interdum phasellus luctus commodo.[/html]\r\n[/nd_feature]\r\n[nd_feature type=\"benefit\" different_values=\"0\" icon=\"fa fa-tencent-weibo\" text=\"Design\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]Sed sed dictum nibh. Vivamus semper eros nec consequat.[/html]\r\n[/nd_feature]\r\n[nd_feature type=\"benefit\" different_values=\"0\" icon=\"fa fa-life-ring\" text=\"Development\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]Donec pulvinar rutrum mi, sit amet viverra justo hendrerit eget.[/html]\r\n[/nd_feature]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"100\" style_margin_bottom=\"100\"]\r\n[/nd_hr]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row extra_classes=\"multi-columns-row\" different_values=\"0\"]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-service\" text=\"Branding\" icon=\"fa fa-paper-plane-o\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-service\" text=\"Web Design\" icon=\"fa fa-cogs\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Vivamus neque orci, ultricies blandit ultricies vel, semper interdum elit, non placerat suscipit.[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-service\" text=\"Logo Design\" icon=\"fa fa-tencent-weibo\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-service\" text=\"Support\" icon=\"fa fa-life-ring\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Semper interdum ultricies elit, non placerat nisi suscipit . Morbi dignissim nunc at risus convallis[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row extra_classes=\"alt-features-grid\" different_values=\"0\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-features\" text=\"Work process\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit.In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-features\" text=\"1. Discussion\" different_values=\"0\" icon=\"icon-chat\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-features\" text=\"2. Making\" different_values=\"0\" icon=\"icon-browser\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature type=\"alt-features\" text=\"3. Production\" different_values=\"0\" icon=\"icon-heart\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,38,45,'en',0,'[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_text_n_tooltip second_text=\" consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" tooltip_popup=\"Title text here\" tooltip=\"tooltip top\" first_text=\"Lorem ipsum dolor sit amet, \" title_size=\"H5\" title=\"One half\" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_text_n_tooltip title=\"One half\" title_size=\"H5\" first_text=\"Lorem ipsum dolor \" tooltip=\"tooltip bottom\" tooltip_popup=\"Title text here\" second_text=\" sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[/row]\r\n[nd_hr different_values=\"0\" style_padding_top=\"40\" style_padding_bottom=\"40\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"4\"]\r\n[nd_text_n_tooltip title=\"One third\" title_size=\"H5\" first_text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"4\"]\r\n[nd_text_n_tooltip title=\"One third\" title_size=\"H5\" first_text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"4\"]\r\n[nd_text_n_tooltip title=\"One third\" title_size=\"H5\" first_text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" different_values=\"0\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[/row]\r\n[nd_hr different_values=\"0\" style_padding_top=\"40\" style_padding_bottom=\"40\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"3\"]\r\n[nd_text_n_tooltip different_values=\"0\" first_text=\"Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" title_size=\"H5\" title=\"One fourth\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"3\"]\r\n[nd_text_n_tooltip different_values=\"0\" first_text=\"Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" title_size=\"H5\" title=\"One fourth\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"3\"]\r\n[nd_text_n_tooltip different_values=\"0\" first_text=\"Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" title_size=\"H5\" title=\"One fourth\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"3\"]\r\n[nd_text_n_tooltip different_values=\"0\" first_text=\"Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. \" title_size=\"H5\" title=\"One fourth\"]\r\n[/nd_text_n_tooltip]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,39,46,'en',0,'<div class=\"row\">\r\n                        <div class=\"col-md-8 col-md-offset-2 mb-30\">\r\n                            \r\n                            <div class=\"section-text align-center\">\r\n                                \r\n                                <p>\r\n                                    You can use a set of <a href=\"http://www.elegantthemes.com/blog/resources/how-to-use-and-embed-an-icon-font-on-your-website\" target=\"_blank\">100+ ET-Line Icons</a>\r\n                                </p>\r\n                                \r\n                                <div class=\"row\">\r\n                                    <div class=\"col-md-8 col-md-offset-2\">\r\n                                        \r\n                                        <div class=\"highlight\">\r\n                                            <pre><code class=\"html\">&lt;span class=\"icon-heart\"&gt;&lt;/span&gt; icon-heart</code></pre>\r\n                                        </div>\r\n                                        \r\n                                        <p>\r\n                                            <strong class=\"small\">Result:</strong>\r\n                                            &nbsp;<span class=\"icon-heart\"></span>\r\n                                            fa-heart\r\n                                        </p>\r\n                                        \r\n                                    </div>\r\n                                </div>\r\n                            </div>\r\n                            \r\n                        </div>\r\n                    </div>\r\n<div class=\"et-examples\">\r\n                        \r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-mobile\"></span>&nbsp;icon-mobile</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-laptop\"></span>&nbsp;icon-laptop</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-desktop\"></span>&nbsp;icon-desktop</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-tablet\"></span>&nbsp;icon-tablet</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-phone\"></span>&nbsp;icon-phone</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-document\"></span>&nbsp;icon-document</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-documents\"></span>&nbsp;icon-documents</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-search\"></span>&nbsp;icon-search</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-clipboard\"></span>&nbsp;icon-clipboard</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-newspaper\"></span>&nbsp;icon-newspaper</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-notebook\"></span>&nbsp;icon-notebook</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-book-open\"></span>&nbsp;icon-book-open</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-browser\"></span>&nbsp;icon-browser</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-calendar\"></span>&nbsp;icon-calendar</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-presentation\"></span>&nbsp;icon-presentation</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-picture\"></span>&nbsp;icon-picture</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-pictures\"></span>&nbsp;icon-pictures</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-video\"></span>&nbsp;icon-video</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-camera\"></span>&nbsp;icon-camera</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-printer\"></span>&nbsp;icon-printer</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-toolbox\"></span>&nbsp;icon-toolbox</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-briefcase\"></span>&nbsp;icon-briefcase</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-wallet\"></span>&nbsp;icon-wallet</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-gift\"></span>&nbsp;icon-gift</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-bargraph\"></span>&nbsp;icon-bargraph</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-grid\"></span>&nbsp;icon-grid</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-expand\"></span>&nbsp;icon-expand</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-focus\"></span>&nbsp;icon-focus</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-edit\"></span>&nbsp;icon-edit</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-adjustments\"></span>&nbsp;icon-adjustments</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-ribbon\"></span>&nbsp;icon-ribbon</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-hourglass\"></span>&nbsp;icon-hourglass</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-lock\"></span>&nbsp;icon-lock</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-megaphone\"></span>&nbsp;icon-megaphone</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-shield\"></span>&nbsp;icon-shield</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-trophy\"></span>&nbsp;icon-trophy</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-flag\"></span>&nbsp;icon-flag</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-map\"></span>&nbsp;icon-map</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-puzzle\"></span>&nbsp;icon-puzzle</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-basket\"></span>&nbsp;icon-basket</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-envelope\"></span>&nbsp;icon-envelope</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-streetsign\"></span>&nbsp;icon-streetsign</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-telescope\"></span>&nbsp;icon-telescope</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-gears\"></span>&nbsp;icon-gears</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-key\"></span>&nbsp;icon-key</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-paperclip\"></span>&nbsp;icon-paperclip</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-attachment\"></span>&nbsp;icon-attachment</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-pricetags\"></span>&nbsp;icon-pricetags</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-lightbulb\"></span>&nbsp;icon-lightbulb</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-layers\"></span>&nbsp;icon-layers</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-pencil\"></span>&nbsp;icon-pencil</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-tools\"></span>&nbsp;icon-tools</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-tools-2\"></span>&nbsp;icon-tools-2</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-scissors\"></span>&nbsp;icon-scissors</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-paintbrush\"></span>&nbsp;icon-paintbrush</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-magnifying-glass\"></span>&nbsp;icon-magnifying-glass</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-circle-compass\"></span>&nbsp;icon-circle-compass</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-linegraph\"></span>&nbsp;icon-linegraph</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-mic\"></span>&nbsp;icon-mic</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-strategy\"></span>&nbsp;icon-strategy</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-beaker\"></span>&nbsp;icon-beaker</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-caution\"></span>&nbsp;icon-caution</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-recycle\"></span>&nbsp;icon-recycle</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-anchor\"></span>&nbsp;icon-anchor</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-profile-male\"></span>&nbsp;icon-profile-male</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-profile-female\"></span>&nbsp;icon-profile-female</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-bike\"></span>&nbsp;icon-bike</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-wine\"></span>&nbsp;icon-wine</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-hotairballoon\"></span>&nbsp;icon-hotairballoon</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-globe\"></span>&nbsp;icon-globe</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-genius\"></span>&nbsp;icon-genius</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-map-pin\"></span>&nbsp;icon-map-pin</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-dial\"></span>&nbsp;icon-dial</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-chat\"></span>&nbsp;icon-chat</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-heart\"></span>&nbsp;icon-heart</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-cloud\"></span>&nbsp;icon-cloud</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-upload\"></span>&nbsp;icon-upload</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-download\"></span>&nbsp;icon-download</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-target\"></span>&nbsp;icon-target</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-hazardous\"></span>&nbsp;icon-hazardous</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-piechart\"></span>&nbsp;icon-piechart</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-speedometer\"></span>&nbsp;icon-speedometer</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-global\"></span>&nbsp;icon-global</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-compass\"></span>&nbsp;icon-compass</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-lifesaver\"></span>&nbsp;icon-lifesaver</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-clock\"></span>&nbsp;icon-clock</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-aperture\"></span>&nbsp;icon-aperture</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-quote\"></span>&nbsp;icon-quote</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-scope\"></span>&nbsp;icon-scope</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-alarmclock\"></span>&nbsp;icon-alarmclock</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-refresh\"></span>&nbsp;icon-refresh</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-happy\"></span>&nbsp;icon-happy</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-sad\"></span>&nbsp;icon-sad</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-facebook\"></span>&nbsp;icon-facebook</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-twitter\"></span>&nbsp;icon-twitter</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-googleplus\"></span>&nbsp;icon-googleplus</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-rss\"></span>&nbsp;icon-rss</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-tumblr\"></span>&nbsp;icon-tumblr</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-linkedin\"></span>&nbsp;icon-linkedin</span>\r\n                        <span class=\"box1\"><span aria-hidden=\"true\" class=\"icon-dribbble\"></span>&nbsp;icon-dribbble</span>\r\n                            \r\n                    </div>','','shortcodes'),

('page',0,40,47,'en',0,'<div class=\"row\">\r\n                        <div class=\"col-md-8 col-md-offset-2 mb-30\">\r\n                            \r\n                            <div class=\"section-text align-center\">\r\n                                \r\n                                <p>\r\n                                    You can use a set of <a href=\"http://fontawesome.io/icons/\" target=\"_blank\">400+ icons from Font Awesome</a>\r\n                                </p>\r\n                                \r\n                                <div class=\"row\">\r\n                                    <div class=\"col-md-8 col-md-offset-2\">\r\n                                        \r\n                                        <div class=\"highlight\">\r\n                                            <pre><code class=\"html\">&lt;i class=\"fa fa-heart\"&gt;&lt;/i&gt; fa-heart</code></pre>\r\n                                        </div>\r\n                                        \r\n                                        <p>\r\n                                            <strong class=\"small\">Result:</strong>\r\n                                            &nbsp;<i class=\"fa fa-heart\"></i>\r\n                                            fa-heart\r\n                                        </p>\r\n                                        \r\n                                    </div>\r\n                                </div>\r\n                            </div>\r\n                            \r\n                        </div>\r\n                    </div>\r\n<div class=\"row fa-examples\">\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-adjust<span class=\"muted\">[&amp;#xf042;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-adn<span class=\"muted\">[&amp;#xf170;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-align-center<span class=\"muted\">[&amp;#xf037;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-align-justify<span class=\"muted\">[&amp;#xf039;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-align-left<span class=\"muted\">[&amp;#xf036;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-align-right<span class=\"muted\">[&amp;#xf038;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ambulance<span class=\"muted\">[&amp;#xf0f9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-anchor<span class=\"muted\">[&amp;#xf13d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-android<span class=\"muted\">[&amp;#xf17b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-double-down<span class=\"muted\">[&amp;#xf103;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-double-left<span class=\"muted\">[&amp;#xf100;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-double-right<span class=\"muted\">[&amp;#xf101;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-double-up<span class=\"muted\">[&amp;#xf102;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-down<span class=\"muted\">[&amp;#xf107;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-left<span class=\"muted\">[&amp;#xf104;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-right<span class=\"muted\">[&amp;#xf105;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-angle-up<span class=\"muted\">[&amp;#xf106;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-apple<span class=\"muted\">[&amp;#xf179;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-archive<span class=\"muted\">[&amp;#xf187;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-down<span class=\"muted\">[&amp;#xf0ab;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-left<span class=\"muted\">[&amp;#xf0a8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-o-down<span class=\"muted\">[&amp;#xf01a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-o-left<span class=\"muted\">[&amp;#xf190;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-o-right<span class=\"muted\">[&amp;#xf18e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-o-up<span class=\"muted\">[&amp;#xf01b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-right<span class=\"muted\">[&amp;#xf0a9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-circle-up<span class=\"muted\">[&amp;#xf0aa;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-down<span class=\"muted\">[&amp;#xf063;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-left<span class=\"muted\">[&amp;#xf060;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-right<span class=\"muted\">[&amp;#xf061;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrow-up<span class=\"muted\">[&amp;#xf062;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrows<span class=\"muted\">[&amp;#xf047;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrows-alt<span class=\"muted\">[&amp;#xf0b2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrows-h<span class=\"muted\">[&amp;#xf07e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-arrows-v<span class=\"muted\">[&amp;#xf07d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-asterisk<span class=\"muted\">[&amp;#xf069;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-automobile<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1b9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-backward<span class=\"muted\">[&amp;#xf04a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ban<span class=\"muted\">[&amp;#xf05e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bank<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf19c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bar-chart-o<span class=\"muted\">[&amp;#xf080;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-barcode<span class=\"muted\">[&amp;#xf02a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bars<span class=\"muted\">[&amp;#xf0c9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-beer<span class=\"muted\">[&amp;#xf0fc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-behance<span class=\"muted\">[&amp;#xf1b4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-behance-square<span class=\"muted\">[&amp;#xf1b5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bell<span class=\"muted\">[&amp;#xf0f3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bell-o<span class=\"muted\">[&amp;#xf0a2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bitbucket<span class=\"muted\">[&amp;#xf171;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bitbucket-square<span class=\"muted\">[&amp;#xf172;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bitcoin<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf15a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bold<span class=\"muted\">[&amp;#xf032;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bolt<span class=\"muted\">[&amp;#xf0e7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bomb<span class=\"muted\">[&amp;#xf1e2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-book<span class=\"muted\">[&amp;#xf02d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bookmark<span class=\"muted\">[&amp;#xf02e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bookmark-o<span class=\"muted\">[&amp;#xf097;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-briefcase<span class=\"muted\">[&amp;#xf0b1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-btc<span class=\"muted\">[&amp;#xf15a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bug<span class=\"muted\">[&amp;#xf188;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-building<span class=\"muted\">[&amp;#xf1ad;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-building-o<span class=\"muted\">[&amp;#xf0f7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bullhorn<span class=\"muted\">[&amp;#xf0a1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-bullseye<span class=\"muted\">[&amp;#xf140;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cab<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1ba;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-calendar<span class=\"muted\">[&amp;#xf073;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-calendar-o<span class=\"muted\">[&amp;#xf133;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-camera<span class=\"muted\">[&amp;#xf030;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-camera-retro<span class=\"muted\">[&amp;#xf083;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-car<span class=\"muted\">[&amp;#xf1b9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-down<span class=\"muted\">[&amp;#xf0d7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-left<span class=\"muted\">[&amp;#xf0d9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-right<span class=\"muted\">[&amp;#xf0da;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-square-o-down<span class=\"muted\">[&amp;#xf150;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-square-o-left<span class=\"muted\">[&amp;#xf191;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-square-o-right<span class=\"muted\">[&amp;#xf152;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-square-o-up<span class=\"muted\">[&amp;#xf151;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-caret-up<span class=\"muted\">[&amp;#xf0d8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-certificate<span class=\"muted\">[&amp;#xf0a3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chain<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chain-broken<span class=\"muted\">[&amp;#xf127;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check<span class=\"muted\">[&amp;#xf00c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check-circle<span class=\"muted\">[&amp;#xf058;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check-circle-o<span class=\"muted\">[&amp;#xf05d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check-square<span class=\"muted\">[&amp;#xf14a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-check-square-o<span class=\"muted\">[&amp;#xf046;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-circle-down<span class=\"muted\">[&amp;#xf13a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-circle-left<span class=\"muted\">[&amp;#xf137;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-circle-right<span class=\"muted\">[&amp;#xf138;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-circle-up<span class=\"muted\">[&amp;#xf139;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-down<span class=\"muted\">[&amp;#xf078;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-left<span class=\"muted\">[&amp;#xf053;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-right<span class=\"muted\">[&amp;#xf054;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-chevron-up<span class=\"muted\">[&amp;#xf077;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-child<span class=\"muted\">[&amp;#xf1ae;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-circle<span class=\"muted\">[&amp;#xf111;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-circle-o<span class=\"muted\">[&amp;#xf10c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-circle-o-notch<span class=\"muted\">[&amp;#xf1ce;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-circle-thin<span class=\"muted\">[&amp;#xf1db;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-clipboard<span class=\"muted\">[&amp;#xf0ea;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-clock-o<span class=\"muted\">[&amp;#xf017;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cloud<span class=\"muted\">[&amp;#xf0c2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cloud-download<span class=\"muted\">[&amp;#xf0ed;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cloud-upload<span class=\"muted\">[&amp;#xf0ee;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cny<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf157;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-code<span class=\"muted\">[&amp;#xf121;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-code-fork<span class=\"muted\">[&amp;#xf126;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-codepen<span class=\"muted\">[&amp;#xf1cb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-coffee<span class=\"muted\">[&amp;#xf0f4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cog<span class=\"muted\">[&amp;#xf013;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cogs<span class=\"muted\">[&amp;#xf085;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-columns<span class=\"muted\">[&amp;#xf0db;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-comment<span class=\"muted\">[&amp;#xf075;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-comment-o<span class=\"muted\">[&amp;#xf0e5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-comments<span class=\"muted\">[&amp;#xf086;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-comments-o<span class=\"muted\">[&amp;#xf0e6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-compass<span class=\"muted\">[&amp;#xf14e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-compress<span class=\"muted\">[&amp;#xf066;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-copy<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-credit-card<span class=\"muted\">[&amp;#xf09d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-crop<span class=\"muted\">[&amp;#xf125;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-crosshairs<span class=\"muted\">[&amp;#xf05b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-css3<span class=\"muted\">[&amp;#xf13c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cube<span class=\"muted\">[&amp;#xf1b2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cubes<span class=\"muted\">[&amp;#xf1b3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cut<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-cutlery<span class=\"muted\">[&amp;#xf0f5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dashboard<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0e4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-database<span class=\"muted\">[&amp;#xf1c0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dedent<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf03b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-delicious<span class=\"muted\">[&amp;#xf1a5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-desktop<span class=\"muted\">[&amp;#xf108;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-deviantart<span class=\"muted\">[&amp;#xf1bd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-digg<span class=\"muted\">[&amp;#xf1a6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dollar<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf155;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dot-circle-o<span class=\"muted\">[&amp;#xf192;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-download<span class=\"muted\">[&amp;#xf019;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dribbble<span class=\"muted\">[&amp;#xf17d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-dropbox<span class=\"muted\">[&amp;#xf16b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-drupal<span class=\"muted\">[&amp;#xf1a9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-edit<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf044;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eject<span class=\"muted\">[&amp;#xf052;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ellipsis-h<span class=\"muted\">[&amp;#xf141;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ellipsis-v<span class=\"muted\">[&amp;#xf142;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-empire<span class=\"muted\">[&amp;#xf1d1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-envelope<span class=\"muted\">[&amp;#xf0e0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-envelope-o<span class=\"muted\">[&amp;#xf003;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-envelope-square<span class=\"muted\">[&amp;#xf199;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eraser<span class=\"muted\">[&amp;#xf12d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eur<span class=\"muted\">[&amp;#xf153;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-euro<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf153;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-exchange<span class=\"muted\">[&amp;#xf0ec;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-exclamation<span class=\"muted\">[&amp;#xf12a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-exclamation-circle<span class=\"muted\">[&amp;#xf06a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-exclamation-triangle<span class=\"muted\">[&amp;#xf071;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-expand<span class=\"muted\">[&amp;#xf065;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-external-link<span class=\"muted\">[&amp;#xf08e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-external-link-square<span class=\"muted\">[&amp;#xf14c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eye<span class=\"muted\">[&amp;#xf06e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-eye-slash<span class=\"muted\">[&amp;#xf070;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-facebook<span class=\"muted\">[&amp;#xf09a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-facebook-square<span class=\"muted\">[&amp;#xf082;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fast-backward<span class=\"muted\">[&amp;#xf049;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fast-forward<span class=\"muted\">[&amp;#xf050;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fax<span class=\"muted\">[&amp;#xf1ac;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-female<span class=\"muted\">[&amp;#xf182;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fighter-jet<span class=\"muted\">[&amp;#xf0fb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file<span class=\"muted\">[&amp;#xf15b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-archive-o<span class=\"muted\">[&amp;#xf1c6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-audio-o<span class=\"muted\">[&amp;#xf1c7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-code-o<span class=\"muted\">[&amp;#xf1c9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-excel-o<span class=\"muted\">[&amp;#xf1c3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-image-o<span class=\"muted\">[&amp;#xf1c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-movie-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-o<span class=\"muted\">[&amp;#xf016;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-pdf-o<span class=\"muted\">[&amp;#xf1c1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-photo-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-picture-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-powerpoint-o<span class=\"muted\">[&amp;#xf1c4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-sound-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-text<span class=\"muted\">[&amp;#xf15c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-text-o<span class=\"muted\">[&amp;#xf0f6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-video-o<span class=\"muted\">[&amp;#xf1c8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-word-o<span class=\"muted\">[&amp;#xf1c2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-file-zip-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1c6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-files-o<span class=\"muted\">[&amp;#xf0c5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-film<span class=\"muted\">[&amp;#xf008;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-filter<span class=\"muted\">[&amp;#xf0b0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fire<span class=\"muted\">[&amp;#xf06d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-fire-extinguisher<span class=\"muted\">[&amp;#xf134;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flag<span class=\"muted\">[&amp;#xf024;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flag-checkered<span class=\"muted\">[&amp;#xf11e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flag-o<span class=\"muted\">[&amp;#xf11d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flash<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0e7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flask<span class=\"muted\">[&amp;#xf0c3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-flickr<span class=\"muted\">[&amp;#xf16e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-floppy-o<span class=\"muted\">[&amp;#xf0c7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-folder<span class=\"muted\">[&amp;#xf07b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-folder-o<span class=\"muted\">[&amp;#xf114;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-folder-open<span class=\"muted\">[&amp;#xf07c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-folder-open-o<span class=\"muted\">[&amp;#xf115;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-font<span class=\"muted\">[&amp;#xf031;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-forward<span class=\"muted\">[&amp;#xf04e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-foursquare<span class=\"muted\">[&amp;#xf180;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-frown-o<span class=\"muted\">[&amp;#xf119;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gamepad<span class=\"muted\">[&amp;#xf11b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gavel<span class=\"muted\">[&amp;#xf0e3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gbp<span class=\"muted\">[&amp;#xf154;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ge<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gear<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf013;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gears<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf085;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gift<span class=\"muted\">[&amp;#xf06b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-git<span class=\"muted\">[&amp;#xf1d3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-git-square<span class=\"muted\">[&amp;#xf1d2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-github<span class=\"muted\">[&amp;#xf09b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-github-alt<span class=\"muted\">[&amp;#xf113;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-github-square<span class=\"muted\">[&amp;#xf092;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-gittip<span class=\"muted\">[&amp;#xf184;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-glass<span class=\"muted\">[&amp;#xf000;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-globe<span class=\"muted\">[&amp;#xf0ac;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-google<span class=\"muted\">[&amp;#xf1a0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-google-plus<span class=\"muted\">[&amp;#xf0d5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-google-plus-square<span class=\"muted\">[&amp;#xf0d4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-graduation-cap<span class=\"muted\">[&amp;#xf19d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-group<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-h-square<span class=\"muted\">[&amp;#xf0fd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hacker-news<span class=\"muted\">[&amp;#xf1d4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hand-o-down<span class=\"muted\">[&amp;#xf0a7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hand-o-left<span class=\"muted\">[&amp;#xf0a5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hand-o-right<span class=\"muted\">[&amp;#xf0a4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hand-o-up<span class=\"muted\">[&amp;#xf0a6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hdd-o<span class=\"muted\">[&amp;#xf0a0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-header<span class=\"muted\">[&amp;#xf1dc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-headphones<span class=\"muted\">[&amp;#xf025;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-heart<span class=\"muted\">[&amp;#xf004;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-heart-o<span class=\"muted\">[&amp;#xf08a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-history<span class=\"muted\">[&amp;#xf1da;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-home<span class=\"muted\">[&amp;#xf015;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-hospital-o<span class=\"muted\">[&amp;#xf0f8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-html5<span class=\"muted\">[&amp;#xf13b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-image<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf03e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-inbox<span class=\"muted\">[&amp;#xf01c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-indent<span class=\"muted\">[&amp;#xf03c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-info<span class=\"muted\">[&amp;#xf129;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-info-circle<span class=\"muted\">[&amp;#xf05a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-inr<span class=\"muted\">[&amp;#xf156;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-instagram<span class=\"muted\">[&amp;#xf16d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-institution<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf19c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-italic<span class=\"muted\">[&amp;#xf033;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-joomla<span class=\"muted\">[&amp;#xf1aa;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-jpy<span class=\"muted\">[&amp;#xf157;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-jsfiddle<span class=\"muted\">[&amp;#xf1cc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-key<span class=\"muted\">[&amp;#xf084;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-keyboard-o<span class=\"muted\">[&amp;#xf11c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-krw<span class=\"muted\">[&amp;#xf159;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-language<span class=\"muted\">[&amp;#xf1ab;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-laptop<span class=\"muted\">[&amp;#xf109;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-leaf<span class=\"muted\">[&amp;#xf06c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-legal<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0e3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-lemon-o<span class=\"muted\">[&amp;#xf094;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-level-down<span class=\"muted\">[&amp;#xf149;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-level-up<span class=\"muted\">[&amp;#xf148;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-life-bouy<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-life-ring<span class=\"muted\">[&amp;#xf1cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-life-saver<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-lightbulb-o<span class=\"muted\">[&amp;#xf0eb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-link<span class=\"muted\">[&amp;#xf0c1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-linkedin<span class=\"muted\">[&amp;#xf0e1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-linkedin-square<span class=\"muted\">[&amp;#xf08c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-linux<span class=\"muted\">[&amp;#xf17c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-list<span class=\"muted\">[&amp;#xf03a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-list-alt<span class=\"muted\">[&amp;#xf022;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-list-ol<span class=\"muted\">[&amp;#xf0cb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-list-ul<span class=\"muted\">[&amp;#xf0ca;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-location-arrow<span class=\"muted\">[&amp;#xf124;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-lock<span class=\"muted\">[&amp;#xf023;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-long-arrow-down<span class=\"muted\">[&amp;#xf175;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-long-arrow-left<span class=\"muted\">[&amp;#xf177;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-long-arrow-right<span class=\"muted\">[&amp;#xf178;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-long-arrow-up<span class=\"muted\">[&amp;#xf176;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-magic<span class=\"muted\">[&amp;#xf0d0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-magnet<span class=\"muted\">[&amp;#xf076;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mail-forward<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf064;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mail-reply<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf112;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mail-reply-all<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf122;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-male<span class=\"muted\">[&amp;#xf183;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-map-marker<span class=\"muted\">[&amp;#xf041;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-maxcdn<span class=\"muted\">[&amp;#xf136;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-medkit<span class=\"muted\">[&amp;#xf0fa;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-meh-o<span class=\"muted\">[&amp;#xf11a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-microphone<span class=\"muted\">[&amp;#xf130;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-microphone-slash<span class=\"muted\">[&amp;#xf131;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-minus<span class=\"muted\">[&amp;#xf068;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-minus-circle<span class=\"muted\">[&amp;#xf056;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-minus-square<span class=\"muted\">[&amp;#xf146;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-minus-square-o<span class=\"muted\">[&amp;#xf147;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mobile<span class=\"muted\">[&amp;#xf10b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mobile-phone<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf10b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-money<span class=\"muted\">[&amp;#xf0d6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-moon-o<span class=\"muted\">[&amp;#xf186;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-mortar-board<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf19d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-music<span class=\"muted\">[&amp;#xf001;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-navicon<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-openid<span class=\"muted\">[&amp;#xf19b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-outdent<span class=\"muted\">[&amp;#xf03b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pagelines<span class=\"muted\">[&amp;#xf18c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paper-plane<span class=\"muted\">[&amp;#xf1d8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paper-plane-o<span class=\"muted\">[&amp;#xf1d9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paperclip<span class=\"muted\">[&amp;#xf0c6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paragraph<span class=\"muted\">[&amp;#xf1dd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paste<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0ea;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pause<span class=\"muted\">[&amp;#xf04c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-paw<span class=\"muted\">[&amp;#xf1b0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pencil<span class=\"muted\">[&amp;#xf040;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pencil-square<span class=\"muted\">[&amp;#xf14b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pencil-square-o<span class=\"muted\">[&amp;#xf044;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-phone<span class=\"muted\">[&amp;#xf095;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-phone-square<span class=\"muted\">[&amp;#xf098;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-photo<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf03e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-picture-o<span class=\"muted\">[&amp;#xf03e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pied-piper<span class=\"muted\">[&amp;#xf1a7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pied-piper-alt<span class=\"muted\">[&amp;#xf1a8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pied-piper-square<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1a7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pinterest<span class=\"muted\">[&amp;#xf0d2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-pinterest-square<span class=\"muted\">[&amp;#xf0d3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plane<span class=\"muted\">[&amp;#xf072;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-play<span class=\"muted\">[&amp;#xf04b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-play-circle<span class=\"muted\">[&amp;#xf144;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-play-circle-o<span class=\"muted\">[&amp;#xf01d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plus<span class=\"muted\">[&amp;#xf067;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plus-circle<span class=\"muted\">[&amp;#xf055;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plus-square<span class=\"muted\">[&amp;#xf0fe;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-plus-square-o<span class=\"muted\">[&amp;#xf196;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-power-off<span class=\"muted\">[&amp;#xf011;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-print<span class=\"muted\">[&amp;#xf02f;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-puzzle-piece<span class=\"muted\">[&amp;#xf12e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-qq<span class=\"muted\">[&amp;#xf1d6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-qrcode<span class=\"muted\">[&amp;#xf029;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-question<span class=\"muted\">[&amp;#xf128;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-question-circle<span class=\"muted\">[&amp;#xf059;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-quote-left<span class=\"muted\">[&amp;#xf10d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-quote-right<span class=\"muted\">[&amp;#xf10e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ra<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-random<span class=\"muted\">[&amp;#xf074;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rebel<span class=\"muted\">[&amp;#xf1d0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-recycle<span class=\"muted\">[&amp;#xf1b8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reddit<span class=\"muted\">[&amp;#xf1a1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reddit-square<span class=\"muted\">[&amp;#xf1a2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-refresh<span class=\"muted\">[&amp;#xf021;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-renren<span class=\"muted\">[&amp;#xf18b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reorder<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-repeat<span class=\"muted\">[&amp;#xf01e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reply<span class=\"muted\">[&amp;#xf112;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-reply-all<span class=\"muted\">[&amp;#xf122;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-retweet<span class=\"muted\">[&amp;#xf079;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rmb<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf157;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-road<span class=\"muted\">[&amp;#xf018;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rocket<span class=\"muted\">[&amp;#xf135;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rotate-left<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0e2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rotate-right<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf01e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rouble<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf158;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rss<span class=\"muted\">[&amp;#xf09e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rss-square<span class=\"muted\">[&amp;#xf143;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rub<span class=\"muted\">[&amp;#xf158;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ruble<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf158;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-rupee<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf156;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-save<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0c7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-scissors<span class=\"muted\">[&amp;#xf0c4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-search<span class=\"muted\">[&amp;#xf002;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-search-minus<span class=\"muted\">[&amp;#xf010;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-search-plus<span class=\"muted\">[&amp;#xf00e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-send<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-send-o<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share<span class=\"muted\">[&amp;#xf064;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share-alt<span class=\"muted\">[&amp;#xf1e0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share-alt-square<span class=\"muted\">[&amp;#xf1e1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share-square<span class=\"muted\">[&amp;#xf14d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-share-square-o<span class=\"muted\">[&amp;#xf045;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-shield<span class=\"muted\">[&amp;#xf132;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-shopping-cart<span class=\"muted\">[&amp;#xf07a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sign-in<span class=\"muted\">[&amp;#xf090;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sign-out<span class=\"muted\">[&amp;#xf08b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-signal<span class=\"muted\">[&amp;#xf012;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sitemap<span class=\"muted\">[&amp;#xf0e8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-skype<span class=\"muted\">[&amp;#xf17e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-slack<span class=\"muted\">[&amp;#xf198;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sliders<span class=\"muted\">[&amp;#xf1de;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-smile-o<span class=\"muted\">[&amp;#xf118;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort<span class=\"muted\">[&amp;#xf0dc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-alpha-asc<span class=\"muted\">[&amp;#xf15d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-alpha-desc<span class=\"muted\">[&amp;#xf15e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-amount-asc<span class=\"muted\">[&amp;#xf160;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-amount-desc<span class=\"muted\">[&amp;#xf161;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-asc<span class=\"muted\">[&amp;#xf0de;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-desc<span class=\"muted\">[&amp;#xf0dd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-down<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0dd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-numeric-asc<span class=\"muted\">[&amp;#xf162;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-numeric-desc<span class=\"muted\">[&amp;#xf163;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sort-up<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0de;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-soundcloud<span class=\"muted\">[&amp;#xf1be;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-space-shuttle<span class=\"muted\">[&amp;#xf197;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-spinner<span class=\"muted\">[&amp;#xf110;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-spoon<span class=\"muted\">[&amp;#xf1b1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-spotify<span class=\"muted\">[&amp;#xf1bc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-square<span class=\"muted\">[&amp;#xf0c8;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-square-o<span class=\"muted\">[&amp;#xf096;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stack-exchange<span class=\"muted\">[&amp;#xf18d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stack-overflow<span class=\"muted\">[&amp;#xf16c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star<span class=\"muted\">[&amp;#xf005;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-half<span class=\"muted\">[&amp;#xf089;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-half-empty<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf123;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-half-full<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf123;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-half-o<span class=\"muted\">[&amp;#xf123;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-star-o<span class=\"muted\">[&amp;#xf006;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-steam<span class=\"muted\">[&amp;#xf1b6;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-steam-square<span class=\"muted\">[&amp;#xf1b7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-step-backward<span class=\"muted\">[&amp;#xf048;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-step-forward<span class=\"muted\">[&amp;#xf051;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stethoscope<span class=\"muted\">[&amp;#xf0f1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stop<span class=\"muted\">[&amp;#xf04d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-strikethrough<span class=\"muted\">[&amp;#xf0cc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stumbleupon<span class=\"muted\">[&amp;#xf1a4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-stumbleupon-circle<span class=\"muted\">[&amp;#xf1a3;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-subscript<span class=\"muted\">[&amp;#xf12c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-suitcase<span class=\"muted\">[&amp;#xf0f2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-sun-o<span class=\"muted\">[&amp;#xf185;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-superscript<span class=\"muted\">[&amp;#xf12b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-support<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-table<span class=\"muted\">[&amp;#xf0ce;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tablet<span class=\"muted\">[&amp;#xf10a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tachometer<span class=\"muted\">[&amp;#xf0e4;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tag<span class=\"muted\">[&amp;#xf02b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tags<span class=\"muted\">[&amp;#xf02c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tasks<span class=\"muted\">[&amp;#xf0ae;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-taxi<span class=\"muted\">[&amp;#xf1ba;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tencent-weibo<span class=\"muted\">[&amp;#xf1d5;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-terminal<span class=\"muted\">[&amp;#xf120;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-text-height<span class=\"muted\">[&amp;#xf034;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-text-width<span class=\"muted\">[&amp;#xf035;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-th<span class=\"muted\">[&amp;#xf00a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-th-large<span class=\"muted\">[&amp;#xf009;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-th-list<span class=\"muted\">[&amp;#xf00b;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumb-tack<span class=\"muted\">[&amp;#xf08d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumbs-down<span class=\"muted\">[&amp;#xf165;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumbs-o-down<span class=\"muted\">[&amp;#xf088;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumbs-o-up<span class=\"muted\">[&amp;#xf087;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-thumbs-up<span class=\"muted\">[&amp;#xf164;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-ticket<span class=\"muted\">[&amp;#xf145;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-times<span class=\"muted\">[&amp;#xf00d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-times-circle<span class=\"muted\">[&amp;#xf057;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-times-circle-o<span class=\"muted\">[&amp;#xf05c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tint<span class=\"muted\">[&amp;#xf043;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-toggle-down<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf150;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-toggle-left<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf191;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-toggle-right<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf152;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-toggle-up<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf151;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-trash-o<span class=\"muted\">[&amp;#xf014;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tree<span class=\"muted\">[&amp;#xf1bb;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-trello<span class=\"muted\">[&amp;#xf181;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-trophy<span class=\"muted\">[&amp;#xf091;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-truck<span class=\"muted\">[&amp;#xf0d1;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-try<span class=\"muted\">[&amp;#xf195;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tumblr<span class=\"muted\">[&amp;#xf173;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-tumblr-square<span class=\"muted\">[&amp;#xf174;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-turkish-lira<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf195;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-twitter<span class=\"muted\">[&amp;#xf099;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-twitter-square<span class=\"muted\">[&amp;#xf081;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-umbrella<span class=\"muted\">[&amp;#xf0e9;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-underline<span class=\"muted\">[&amp;#xf0cd;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-undo<span class=\"muted\">[&amp;#xf0e2;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-university<span class=\"muted\">[&amp;#xf19c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-unlink<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf127;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-unlock<span class=\"muted\">[&amp;#xf09c;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-unlock-alt<span class=\"muted\">[&amp;#xf13e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-unsorted<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf0dc;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-upload<span class=\"muted\">[&amp;#xf093;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-usd<span class=\"muted\">[&amp;#xf155;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-user<span class=\"muted\">[&amp;#xf007;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-user-md<span class=\"muted\">[&amp;#xf0f0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-users<span class=\"muted\">[&amp;#xf0c0;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-video-camera<span class=\"muted\">[&amp;#xf03d;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-vimeo-square<span class=\"muted\">[&amp;#xf194;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-vine<span class=\"muted\">[&amp;#xf1ca;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-vk<span class=\"muted\">[&amp;#xf189;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-volume-down<span class=\"muted\">[&amp;#xf027;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-volume-off<span class=\"muted\">[&amp;#xf026;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-volume-up<span class=\"muted\">[&amp;#xf028;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-warning<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf071;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-wechat<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf1d7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-weibo<span class=\"muted\">[&amp;#xf18a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-weixin<span class=\"muted\">[&amp;#xf1d7;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-wheelchair<span class=\"muted\">[&amp;#xf193;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-windows<span class=\"muted\">[&amp;#xf17a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-won<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf159;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-wordpress<span class=\"muted\">[&amp;#xf19a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-wrench<span class=\"muted\">[&amp;#xf0ad;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-xing<span class=\"muted\">[&amp;#xf168;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-xing-square<span class=\"muted\">[&amp;#xf169;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-yahoo<span class=\"muted\">[&amp;#xf19e;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-yen<span class=\"text-muted\">(alias)</span>\r\n                            <span class=\"muted\">[&amp;#xf157;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-youtube<span class=\"muted\">[&amp;#xf167;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-youtube-play<span class=\"muted\">[&amp;#xf16a;]</span>\r\n                        </div>\r\n                        <div class=\"col-md-4 col-sm-6 col-lg-3\">\r\n                            <i class=\"fa fa-fw\"></i>\r\n                            fa-youtube-square<span class=\"muted\">[&amp;#xf166;]</span>\r\n                        </div>\r\n                    </div>','','shortcodes'),

('page',0,41,48,'en',0,'[row different_values=\"0\"]\r\n[col different_values=\"0\" extra_classes=\"col-md-offset-2\" desktop=\"8\"]\r\n[nd_message different_values=\"0\" message_type=\"alert info\" text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\"]\r\n[/nd_message]\r\n[nd_message different_values=\"0\" message_type=\"alert success\" text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\"]\r\n[/nd_message]\r\n[nd_message different_values=\"0\" message_type=\"alert notice\" text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\"]\r\n[/nd_message]\r\n[nd_message different_values=\"0\" message_type=\"alert error\" text=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\"]\r\n[/nd_message]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,42,49,'en',0,'[nd_header type=\"bg-gray-lighter\" size=\"small-section\" breadcrumbs=\"1\" title=\"Page titles\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-gray\" size=\"small-section\" breadcrumbs=\"1\" title=\"Title Gray\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-lighter\" size=\"small-section\" breadcrumbs=\"1\" title=\"Title Dark 1\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark\" size=\"small-section\" breadcrumbs=\"1\" title=\"Title Dark 2\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-alfa-30\" size=\"small-section\" fid=\"3\" breadcrumbs=\"1\" title=\"Title with image\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-alfa-30\" size=\"page-section\" fid=\"4\" breadcrumbs=\"1\" title=\"Title large\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-gray-lighter\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-gray\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-lighter\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\"]\r\n[/nd_header]\r\n[nd_header type=\"bg-dark-alfa-50\" size=\"small-section pt-30 pb-30\" breadcrumbs=\"1\" title=\"Title small\" description=\"Lorem ipsum dolor sit amet consectetur\" different_values=\"0\" fid=\"5\"]\r\n[/nd_header]\r\n ','','shortcodes'),

('page',0,43,50,'en',0,'[nd_bg slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" desktop=\"7\"]\r\n[nd_slider different_values=\"0\" slide_autoplay=\"5000\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"2\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"3\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[col extra_classes=\"col-lg-offset-1\" wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col extra_classes=\"col-lg-offset-1\" wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" desktop=\"7\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"2\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"3\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg slider=\"0\" different_values=\"0\" fid=\"4\" color=\"bg-dark-alfa-70\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_slider slide_anim=\"wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" different_values=\"0\" icon=\"icon-hotairballoon\" text=\"We\'re Creative\" color=\"white\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]We find the best ideas for you[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-clock\" text=\"We\'re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\" extra_classes=\"features-descr\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-lightbulb\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-wine\" text=\"We\'re Creative\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We find the best ideas for you</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-tools\" text=\"We’re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-gears\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-browser\" text=\"We\'re Creative\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We find the best ideas for you</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-wallet\" text=\"We\'re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-document\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-gray\" different_values=\"0\" fid=\"2\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\" full_height=\"0\" scroll_icon=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"4\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"5\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"6\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_slider different_values=\"0\" slide_anim=\"fullwidth\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"7\" different_values=\"0\"]\r\n[nd_image type=\"0\" fid=\"23\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\"]\r\n[/nd_image]\r\n[/col]\r\n[col desktop=\"5\" wide=\"4\" extra_classes=\"col-lg-offset-1\" different_values=\"0\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"View online\" link=\"#\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"7\" different_values=\"0\"]\r\n[nd_image type=\"0\" fid=\"17\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\"]\r\n[/nd_image]\r\n[/col]\r\n[col desktop=\"5\" wide=\"4\" extra_classes=\"col-lg-offset-1\" different_values=\"0\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"View online\" link=\"#\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"5\" wide=\"4\" different_values=\"0\"]\r\n[nd_title title=\"Mega creative\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut. Phasellus facilisis mauris vel velit molestie pellentesqu accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"View online\" link=\"#\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[col extra_classes=\"col-lg-offset-1\" desktop=\"7\" different_values=\"0\"]\r\n[nd_video url=\"http://player.vimeo.com/video/37066208?title=0&amp;byline=0&amp;portrait=0&amp;color=ffffff\" different_values=\"0\"]\r\n[/nd_video]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n ','','shortcodes'),

('page',0,44,51,'en',0,'[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_title different_values=\"0\" extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" title=\"Standard tabs\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" extra_classes=\"col-sm-offset-2\" tablet=\"8\"]\r\n[nd_tabs centered=\"0\" transparent=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"First\" active=\"1\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Second\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Nam porta elementum tortor, eget tempor orci ullamcorper eget. Aliquam fermentum sem non vulputate dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Nulla at porttitor massa. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Third\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Pellentesque sed vehicula velit, vitae vulputate velit. Morbi nec porta augue, et dignissim enim. Vivamus suscipit, lorem vitae rhoncus pharetra, erat nisl scelerisque magna, ut mollis dui eros eget libero. Vivamus ut ornare tellus. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_title different_values=\"0\" extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" title=\"Minimal tabs\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" extra_classes=\"col-sm-offset-2\" tablet=\"8\"]\r\n[nd_tabs type=\"minimal\" centered=\"1\" transparent=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"First\" active=\"1\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Second\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Nam porta elementum tortor, eget tempor orci ullamcorper eget. Aliquam fermentum sem non vulputate dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Nulla at porttitor massa. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Third\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Pellentesque sed vehicula velit, vitae vulputate velit. Morbi nec porta augue, et dignissim enim. Vivamus suscipit, lorem vitae rhoncus pharetra, erat nisl scelerisque magna, ut mollis dui eros eget libero. Vivamus ut ornare tellus. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim. Nullam sit amet malesuada justo.[/html]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,45,52,'en',0,'[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" title=\"Formating\" styled=\"0\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[html different_values=\"0\" extra_classes=\"text\" format=\"nd_ckeditor\"]<h5 class=\"uppercase mb-30\">Paragraph</h5><p> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Consectetur adipiscing elit. Integer posuere erat a ante. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. </p>[/html]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_quote type=\"footer\" cite=\" Source Title\" different_values=\"0\" footer=\"Someone famous in\" testimonial=\"0\" style_margin_top=\"52\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"20\" style_margin_bottom=\"60\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" extra_classes=\"text\" different_values=\"0\"]<h5 class=\"uppercase mb-30\">	List UL</h5><ul><li>First item</li><li>Second item</li><li>Third item<ul><li>First item</li><li>Second item</li><li>Third item</li></ul></li><li>Fourth item</li><li>Fives item</li></ul>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" extra_classes=\"text\" different_values=\"0\"]<h5 class=\"uppercase mb-30\">List OL</h5><ol><li>First item</li><li>Second item</li><li>Third item<ol><li>First item</li><li>Second item</li><li>Third item</li></ol></li><li>Fourth item</li><li>Fives item</li></ol>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" extra_classes=\"text\" different_values=\"0\"]<h5 class=\"uppercase mb-30\">Emphasis</h5><p><small> This line of text is meant to be treated as fine print. </small></p><p><strong>Rendered as bold text</strong></p><p><em>Rendered as italicized text</em></p><p><span class=\"serif\">Rendered as italicized text</span></p>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" extra_classes=\"section-title mb-70 mb-sm-40\" size=\"h2\" title=\"Headings\" styled=\"0\" uppercase=\"0\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" extra_classes=\"align-center\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" size=\"h1\" title=\"Heading 1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h2\" title=\"Heading 2\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h3\" title=\"Heading 3\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h4\" title=\"Heading 4\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h5\" title=\"Heading 5\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h6\" title=\"Heading 6\"]\r\n[/nd_title]\r\n[/col]\r\n[col tablet=\"4\" extra_classes=\"align-center\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" size=\"h1\" title=\"Heading 1\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h2\" title=\"Heading 2\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h3\" title=\"Heading 3\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h4\" title=\"Heading 4\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h5\" title=\"Heading 5\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h6\" title=\"Heading 6\" styled=\"0\" uppercase=\"1\"]\r\n[/nd_title]\r\n[/col]\r\n[col tablet=\"4\" extra_classes=\"align-center\" different_values=\"0\"]\r\n[nd_title different_values=\"0\" size=\"h1\" title=\"Heading 1\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h2\" title=\"Heading 2\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h3\" title=\"Heading 3\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h4\" title=\"Heading 4\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h5\" title=\"Heading 5\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[nd_title different_values=\"0\" size=\"h6\" title=\"Heading 6\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,46,53,'en',0,'[nd_bg extra_classes=\"page-section\" different_values=\"0\" slider=\"0\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_video url=\"http://player.vimeo.com/video/79876010?title=0&amp;byline=0&amp;portrait=0&amp;color=ffffff\" different_values=\"0\" width=\"1170\" height=\"658\"]\r\n[/nd_video]\r\n[/col]\r\n[col different_values=\"0\" tablet=\"6\"]\r\n[nd_video url=\"http://www.youtube.com/embed/JuyB7NO0EYY\" different_values=\"0\" width=\"640\" height=\"360\"]\r\n[/nd_video]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\" style_padding_bottom=\"140\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<iframe width=\"100%\" height=\"166\" scrolling=\"no\" frameborder=\"no\" src=\"https://w.soundcloud.com/player/?url=https%3A//api.soundcloud.com/tracks/3752929&amp;color=111111&amp;auto_play=false&amp;hide_related=false&amp;show_comments=true&amp;show_user=true&amp;show_reposts=false\"></iframe>[/html]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,47,54,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed neque velit, ultrices in vulputate vitae, volutpat iaculis velit. In congue dolor a ligula cursus aliquam. Aliquam id malesuada metus. Donec ultricies lorem augue, ac fringilla felis aliquet et. Integer a rutrum dui, id varius neque. Donec orci massa, porttitor sit amet velit non, interdum feugiat lacus. Fusce tincidunt id erat at consequat. Cras vel aliquet mauris, ac tempor lorem. Donec faucibus sodales eros sed pretium. Praesent ut scelerisque lectus, ut feugiat mi.</p><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus. Curabitur vel vestibulum ipsum, convallis cursus nisl. Mauris scelerisque gravida faucibus. Morbi vitae sapien nibh. Integer libero orci, ullamcorper in tincidunt at, molestie quis ipsum.</p>[/html]\r\n ','','shortcodes'),

('page',0,48,55,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed neque velit, ultrices in vulputate vitae, volutpat iaculis velit. In congue dolor a ligula cursus aliquam. Aliquam id malesuada metus. Donec ultricies lorem augue, ac fringilla felis aliquet et. Integer a rutrum dui, id varius neque. Donec orci massa, porttitor sit amet velit non, interdum feugiat lacus. Fusce tincidunt id erat at consequat. Cras vel aliquet mauris, ac tempor lorem. Donec faucibus sodales eros sed pretium. Praesent ut scelerisque lectus, ut feugiat mi.</p><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus. Curabitur vel vestibulum ipsum, convallis cursus nisl. Mauris scelerisque gravida faucibus. Morbi vitae sapien nibh. Integer libero orci, ullamcorper in tincidunt at, molestie quis ipsum.</p>[/html]\r\n ','','shortcodes'),

('page',0,49,56,'en',0,'[row different_values=\"0\" extra_classes=\"mb-70 mb-xs-40\"]\r\n[col extra_classes=\"col-md-offset-2\" different_values=\"0\" desktop=\"8\"]\r\n[html different_values=\"0\" extra_classes=\"section-text align-center\" format=\"nd_ckeditor\"]Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum.[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\" extra_classes=\"multi-columns-row\"]\r\n[col tablet=\"4\" different_values=\"0\" desktop=\"4\" wide=\"4\"]\r\n[nd_pricing_table different_values=\"0\" button=\"Buy Now\" period=\"per month\" sign=\"$\" price=\"199\" title=\"Start\" icon=\"fa fa-paper-plane-o\" link=\"/node/48\" active=\"0\"]\r\n[nd_pricing_item different_values=\"0\" description=\"1 Gb Storage\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"3 Domain Names\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"5 FTP Users\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"Free Support\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\" desktop=\"4\" wide=\"4\"]\r\n[nd_pricing_table active=\"1\" different_values=\"0\" button=\"Buy Now\" period=\"month\" sign=\"$\" price=\"239\" title=\"Standard\" icon=\"fa fa-gift\"]\r\n[nd_pricing_item different_values=\"0\" description=\"3 Gb Storage\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"5 Domain Names\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"7 FTP Users\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"Free Support\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\" desktop=\"4\" wide=\"4\"]\r\n[nd_pricing_table different_values=\"0\" button=\"Buy Now\" period=\"month\" sign=\"$\" price=\"399\" title=\"Optima\" icon=\"fa fa-desktop\"]\r\n[nd_pricing_item different_values=\"0\" description=\"5 Gb Storage\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"9 Domain Names\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"15 FTP Users\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item different_values=\"0\" description=\"Free Support\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,50,57,'en',0,'[row different_values=\"0\" style_padding_bottom=\"70\"]\r\n[col desktop=\"8\" different_values=\"0\" extra_classes=\"col-md-offset-2\"]\r\n[html format=\"nd_ckeditor\" extra_classes=\"section-text align-center\" different_values=\"0\"]Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum.[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col desktop=\"3\" different_values=\"0\" tablet=\"6\"]\r\n[nd_pricing_table icon=\"fa fa-paper-plane-o\" title=\"Start\" price=\"199\" sign=\"$\" period=\"month\" button=\"Buy Now\" different_values=\"0\"]\r\n[nd_pricing_item description=\"1 Gb Storage\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"3 Domain Names\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"5 FTP Users\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Free Support\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col desktop=\"3\" different_values=\"0\" tablet=\"6\"]\r\n[nd_pricing_table icon=\"fa fa-gift\" title=\"Standard\" price=\"239\" sign=\"$\" period=\"month\" button=\"Buy Now\" different_values=\"0\"]\r\n[nd_pricing_item description=\"3 Gb Storage\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"5 Domain Names\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"7 FTP Users\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Free Support\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col desktop=\"3\" different_values=\"0\" tablet=\"6\"]\r\n[nd_pricing_table icon=\"fa fa-desktop\" title=\"Optima\" price=\"399\" sign=\"$\" period=\"month\" button=\"Buy Now\" different_values=\"0\"]\r\n[nd_pricing_item description=\"5 Gb Storage\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"9 Domain Names\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"15 FTP Users\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Free Support\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[col desktop=\"3\" different_values=\"0\" tablet=\"6\"]\r\n[nd_pricing_table icon=\"fa fa-suitcase\" title=\"Vip\" price=\"579\" sign=\"$\" period=\"month\" button=\"Buy Now\" different_values=\"0\"]\r\n[nd_pricing_item description=\"15 Gb Storage\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Unlimit Domain Names\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Unlimit FTP Users\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[nd_pricing_item description=\"Free Support\" different_values=\"0\"]\r\n[/nd_pricing_item]\r\n[/nd_pricing_table]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,54,61,'en',0,'<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed neque velit, ultrices in vulputate vitae, volutpat iaculis velit. In congue dolor a ligula cursus aliquam. Aliquam id malesuada metus. Donec ultricies lorem augue, ac fringilla felis aliquet et. Integer a rutrum dui, id varius neque. Donec orci massa, porttitor sit amet velit non, interdum feugiat lacus. Fusce tincidunt id erat at consequat. Cras vel aliquet mauris, ac tempor lorem. Donec faucibus sodales eros sed pretium. Praesent ut scelerisque lectus, ut feugiat mi.</p>\r\n\r\n<p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 15px; line-height: 25.5px;\">Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus. Curabitur vel vestibulum ipsum, convallis cursus nisl. Mauris scelerisque gravida faucibus. Morbi vitae sapien nibh. Integer libero orci, ullamcorper in tincidunt at, molestie quis ipsum.</p>\r\n','','ckeditor'),

('page',0,55,62,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed neque velit, ultrices in vulputate vitae, volutpat iaculis velit. In congue dolor a ligula cursus aliquam. Aliquam id malesuada metus. Donec ultricies lorem augue, ac fringilla felis aliquet et. Integer a rutrum dui, id varius neque. Donec orci massa, porttitor sit amet velit non, interdum feugiat lacus. Fusce tincidunt id erat at consequat. Cras vel aliquet mauris, ac tempor lorem. Donec faucibus sodales eros sed pretium. Praesent ut scelerisque lectus, ut feugiat mi.</p>\r\n\r\n<p>Nunc vulputate semper erat, non iaculis sapien congue sit amet. Duis non nulla volutpat, dignissim leo sit amet, porta nunc. Donec placerat fermentum metus ac scelerisque. In id sollicitudin nulla. Suspendisse potenti. Integer aliquam orci aliquam eros posuere ornare. Fusce augue felis, maximus non lacus vitae, ullamcorper dignissim leo. Ut congue feugiat turpis at aliquam. Donec eros neque, accumsan sed venenatis volutpat, tempor at metus. Curabitur vel vestibulum ipsum, convallis cursus nisl. Mauris scelerisque gravida faucibus. Morbi vitae sapien nibh. Integer libero orci, ullamcorper in tincidunt at, molestie quis ipsum.</p>\r\n','','ckeditor'),

('nd_portfolio',0,56,63,'en',0,'[row different_values=\"0\" style_padding_top=\"60\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"1. Case Study\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"2. RESULT\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"3. EXPERIENCE\" size=\"h5\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" spacing=\"ls-04\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"70\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_title title=\"PROJECT DETAILS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"gray\" different_values=\"0\" spacing=\"ls-02\" style_margin_top=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"work-full-detail\"]<p><strong>CLIENT: </strong>ENVATO USERS</p><p><strong>DATE: </strong>1TH FEBRUERY, 2014</p><p><strong>ONLINE: </strong>WWW.RHYTHM.BESTLOOKER.PRO</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>','shortcodes'),

('nd_person',0,57,64,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<h4 class=\"font-alt normal\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: normal; line-height: 1.4; color: rgb(119, 119, 119); margin-top: 10px; margin-bottom: 1.3em; font-size: 18px; text-transform: uppercase; letter-spacing: 0.2em; text-align: center;\">	HI TO ALL!</h4><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px; text-align: center;\">Adipiscing elit curabitur eu&nbsp;adipiscing lacus eu&nbsp;adipiscing lacus, a&nbsp;iaculis diam.</p>[/html]\r\n ','','shortcodes'),

('nd_person',0,58,65,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<h4 class=\"font-alt normal\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: normal; line-height: 1.4; color: rgb(119, 119, 119); margin-top: 10px; margin-bottom: 1.3em; font-size: 18px; text-transform: uppercase; letter-spacing: 0.2em; text-align: center;\">	HI TO ALL!</h4><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px; text-align: center;\">Adipiscing elit curabitur eu&nbsp;adipiscing lacus eu&nbsp;adipiscing lacus, a&nbsp;iaculis diam.</p>[/html]\r\n ','','shortcodes'),

('nd_person',0,59,66,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<h4 class=\"font-alt normal\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: normal; line-height: 1.4; color: rgb(119, 119, 119); margin-top: 10px; margin-bottom: 1.3em; font-size: 18px; text-transform: uppercase; letter-spacing: 0.2em; text-align: center;\">	HI TO ALL!</h4><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px; text-align: center;\">Adipiscing elit curabitur eu&nbsp;adipiscing lacus eu&nbsp;adipiscing lacus, a&nbsp;iaculis diam.</p>[/html]\r\n ','','shortcodes'),

('nd_person',0,60,67,'en',0,'[html format=\"nd_ckeditor\" different_values=\"0\"]<h4 class=\"font-alt normal\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: normal; line-height: 1.4; color: rgb(119, 119, 119); margin-top: 10px; margin-bottom: 1.3em; font-size: 18px; text-transform: uppercase; letter-spacing: 0.2em; text-align: center;\">	HI TO ALL!</h4><p style=\"box-sizing: border-box; margin: 0px 0px 2em; color: rgb(119, 119, 119); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px; text-align: center;\">Adipiscing elit curabitur eu&nbsp;adipiscing lacus eu&nbsp;adipiscing lacus, a&nbsp;iaculis diam.</p>[/html]\r\n ','','shortcodes'),

('page',0,61,68,'en',0,'[nd_container different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<h2 class=\"section-title font-alt mb-70 mb-sm-40 rtecenter\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: 400; line-height: 1.4; color: rgb(17, 17, 17); margin-top: 20px; margin-bottom: 70px; font-size: 18px; text-transform: uppercase; letter-spacing: 0.5em;\">	OUR CREATIVE MINDS</h2><div class=\"row\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; margin-left: -15px; margin-right: -15px; color: rgb(17, 17, 17); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px;\">	<div class=\"col-md-8 col-md-offset-2\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; position: relative; min-height: 1px; padding-left: 15px; padding-right: 15px; float: left; width: 780px; margin-left: 195px;\">		<div class=\"section-text align-center mb-70 mb-xs-40 rtecenter\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; font-size: 15px; color: rgb(119, 119, 119); line-height: 1.7; margin-bottom: 70px;\">			Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</div>	</div></div>[/html]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_2\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\" alignment=\" align-center\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,62,69,'en',0,'[nd_container different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<h2 class=\"section-title font-alt mb-70 mb-sm-40 rtecenter\" style=\"box-sizing: border-box; font-family: Dosis, arial, sans-serif; font-weight: 400; line-height: 1.4; color: rgb(17, 17, 17); margin-top: 20px; margin-bottom: 70px; font-size: 18px; text-transform: uppercase; letter-spacing: 0.5em;\">	OUR CREATIVE MINDS</h2><div class=\"row\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; margin-left: -15px; margin-right: -15px; color: rgb(17, 17, 17); font-family: \'Open Sans\', arial, sans-serif; font-size: 14px; line-height: 22.3999996185303px;\">	<div class=\"col-md-8 col-md-offset-2\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; position: relative; min-height: 1px; padding-left: 15px; padding-right: 15px; float: left; width: 780px; margin-left: 195px;\">		<div class=\"section-text align-center mb-70 mb-xs-40 rtecenter\" style=\"box-sizing: border-box; -webkit-tap-highlight-color: transparent; font-size: 15px; color: rgb(119, 119, 119); line-height: 1.7; margin-bottom: 70px;\">			Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</div>	</div></div>[/html]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_1\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"140\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\" alignment=\" align-center\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,63,70,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\" style_margin_top=\"-5\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>It doesn’t matter how many times I have to click, as long as each click is a mindless, unambiguous choice.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_2\" different_values=\"0\" style_padding_top=\"40\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\" style_margin_top=\"140\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\"]\r\n[row style_padding_top=\"20\" style_padding_bottom=\"20\" different_values=\"0\"]\r\n[col tablet=\"10\" extra_classes=\"col-md-offset-1\" different_values=\"0\"]\r\n[nd_slider slide_anim=\"small_wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"63\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"64\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"65\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"66\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"67\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,64,71,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\" extra_classes=\"wow fadeIn\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_progress title=\"Branding\" percent=\"90\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"Design\" percent=\"80\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"Development\" percent=\"85\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/row]\r\n[nd_div style_padding_left=\"20\" style_padding_right=\"20\" style_padding_top=\"40\" style_padding_bottom=\"40\" different_values=\"0\" style_margin_top=\"60\" extra_style=\"border: 1px solid rgba(0,0,0, .09);\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"PROJECTS DONE\" icon=\"fa fa-briefcase\" number=\"320\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"HAPPY CLIENTS\" icon=\"fa fa-heart\" number=\"150\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"COFFEE CUPS\" icon=\"fa fa-coffee\" number=\"933\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"GREAT IDEAS\" icon=\"fa fa-lightbulb-o\" number=\"975\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[/row]\r\n[/nd_div]\r\n[/nd_container]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\" style_margin_top=\"140\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\"]\r\n[row style_padding_top=\"20\" style_padding_bottom=\"20\" different_values=\"0\"]\r\n[col tablet=\"10\" extra_classes=\"col-md-offset-1\" different_values=\"0\"]\r\n[nd_slider slide_anim=\"small_wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"63\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"64\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"65\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"66\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"67\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_padding_top=\"120\"]\r\n[nd_title title=\"OUR TEAM\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" text_align=\"center\" different_values=\"0\"]<p>In auctor ex id urna faucibus porttitor. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_1\" different_values=\"0\" style_padding_top=\"40\" animation=\"fadeInUp\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"130\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,65,72,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_title title=\"WHO WE ARE?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam.</p><p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_progress title=\"Branding\" percent=\"90\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"Design\" percent=\"80\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"Development\" percent=\"85\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"PHOTO\" percent=\"75\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[/row]\r\n[nd_div style_padding_left=\"20\" style_padding_right=\"20\" style_padding_top=\"40\" style_padding_bottom=\"40\" different_values=\"0\" style_margin_top=\"60\" extra_style=\"border: 1px solid rgba(0,0,0, .09);\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"PROJECTS DONE\" icon=\"fa fa-briefcase\" number=\"320\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"HAPPY CLIENTS\" icon=\"fa fa-heart\" number=\"150\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"COFFEE CUPS\" icon=\"fa fa-coffee\" number=\"933\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_counter title=\"GREAT IDEAS\" icon=\"fa fa-lightbulb-o\" number=\"975\" different_values=\"0\"]\r\n[/nd_counter]\r\n[/col]\r\n[/row]\r\n[/nd_div]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_1\" different_values=\"0\" style_padding_top=\"70\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\" style_margin_top=\"140\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\"]\r\n[row style_padding_top=\"20\" style_padding_bottom=\"20\" different_values=\"0\"]\r\n[col tablet=\"10\" extra_classes=\"col-md-offset-1\" different_values=\"0\"]\r\n[nd_slider slide_anim=\"small_wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"63\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"64\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"65\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"66\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"67\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\" style_padding_top=\"140\"]\r\n[nd_title title=\"OUR STORY\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-sm-offset-2\" different_values=\"0\"]\r\n[nd_tabs type=\"minimal\" centered=\"1\" different_values=\"0\"]\r\n[nd_tab title=\"Mission\" active=\"1\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim.</p>[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Vision\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim.</p>[/html]\r\n[/nd_tab]\r\n[nd_tab title=\"Ideas\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque mollis lacus augue, a hendrerit leo tristique vitae. Mauris non ipsum molestie, sagittis elit ac, vulputate odio. Fusce quam augue, gravida tincidunt dui nec, tempor iaculis justo. Aliquam tortor leo, pharetra non congue sit amet, bibendum sit amet enim.</p>[/html]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,66,73,'en',0,'[nd_container different_values=\"0\"]\r\n[nd_tabs type=\"alt\" centered=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"Branding\" icon=\"icon-strategy\" icon_type=\"big\" active=\"1\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>It doesn’t matter how many times I have to click, as long as each click is a mindless, unambiguous choice.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"WEB DESIGN\" icon=\"icon-desktop\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"graphic design\" icon=\"icon-tools\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Development\" icon=\"icon-gears\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Photography\" icon=\"icon-camera\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/nd_container]\r\n[nd_bg banner=\"0\" fid=\"44\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" style_margin_top=\"120\" full_height=\"0\" scroll_icon=\"0\" style_padding_top=\"0\" style_padding_bottom=\"0\" video_sound=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"45\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,67,74,'en',0,'[nd_container different_values=\"0\"]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-camera\" text=\"photography\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Cras luctus interdum sodales. Quisque quis odio dui. Sedes sit amet neque malesuada, lobortis commodo magna ntesque pharetra metus vivera sagittis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-tools-2\" text=\"development\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Fusce aliquet quam eget neque ultrices elementum. Nulla posuere felis id arcu blandit sagittis. Eleifender vestibulum purus, sit amet vulputate risus.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-anchor\" text=\"support\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. Praesent sed nisi eleifend, fermentum orci sit amet, iaculis libero interdum.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_bg banner=\"1\" fid=\"55\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" style_margin_top=\"140\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"56\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_title title=\"WORK PROCESS\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam. Aliquam elementum tellus non erat porttitor mollis. Morbi viverra sollicitudin nisl eu sodales.</p><p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions multiple_active=\"0\" different_values=\"0\"]\r\n[nd_accordion title=\"1. Discussion\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"2. Design\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"3. Development\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,68,75,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"3\" different_values=\"0\" style_margin_top=\"70\"]\r\n[nd_title title=\"WORK PROCESS\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. DISCUSSION\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. MAKING\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. PRODUCTION\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[nd_hr style_margin_top=\"30\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_hr]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_image fid=\"58\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" style_margin_bottom=\"23\"]\r\n[/nd_image]\r\n[nd_title title=\"DIGITAL BRANDING\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"6\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_image fid=\"59\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" style_margin_bottom=\"23\"]\r\n[/nd_image]\r\n[nd_title title=\"DESIGN &amp; DEVELOPMENT\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"6\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_image fid=\"60\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" style_margin_bottom=\"23\"]\r\n[/nd_image]\r\n[nd_title title=\"MARKETING\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"6\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_bg banner=\"1\" fid=\"55\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" style_margin_top=\"140\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"56\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam. Aliquam elementum tellus non erat porttitor mollis. Morbi viverra sollicitudin nisl eu sodales.</p><p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.</p>[/html]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_accordions multiple_active=\"0\" different_values=\"0\"]\r\n[nd_accordion title=\" We are professionals\" different_values=\"0\" icon=\"fa fa-users\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\" We are punctual\" different_values=\"0\" icon=\"fa fa-clock-o\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"We are friendly\" different_values=\"0\" icon=\"fa fa-heart\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Donec nec justo eget felis facilisis fermentum. Aliquam porttitor mauris sit amet orci. Aenean dignissim pellentesque felis.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,69,76,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\" style_margin_bottom=\"-10\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" text_align=\"center\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque efficitur nulla orci, in sollicitudin mauris viverra<br>	id. Donec est lectus, eleifend vitae rutrum eu, porta sed nisl. Nunc vehicula enim eget risus faucibus, id<br>	interdum nisi commodo. Nunc eget massa eget ipsum mattis iaculis ut in urna.</p>[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"68\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"HIPSTER INC.\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"69\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"OTHER COMPANY\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"70\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"CREATIVE STUDIO\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"71\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"DIGITAL STUFF\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"72\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"BIGSTREAM INC.\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[col tablet=\"4\" style_padding_top=\"70\" different_values=\"0\"]\r\n[nd_image fid=\"73\" different_values=\"0\"]\r\n[/nd_image]\r\n[nd_title title=\"RHYTHM AND PARTNERS\" size=\"h5\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"21\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\" style_margin_top=\"140\" full_height=\"0\" scroll_icon=\"0\" style_padding_top=\"140\" style_padding_bottom=\"140\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\"]\r\n[row style_padding_top=\"20\" style_padding_bottom=\"20\" different_values=\"0\"]\r\n[col tablet=\"10\" extra_classes=\"col-md-offset-1\" different_values=\"0\"]\r\n[nd_slider slide_anim=\"small_wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"63\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"64\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"65\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"66\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"67\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image fid=\"62\" type=\"0\" hover=\"None\" shadow=\"0\" border=\"0\" different_values=\"0\" image_style=\"logo_autox67\" height=\"67\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_top=\"140\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,70,77,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\" text_align=\"center\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[nd_quote different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</p>[/html]\r\n[/nd_quote]\r\n[nd_div different_values=\"0\"]\r\n[nd_button button_type=\"border\" block=\"0\" display=\"round\" size=\"medium\" text=\"SEE MORE\" invert=\"0\" different_values=\"0\" style_margin_right=\"7\"]\r\n[/nd_button]\r\n[nd_button block=\"0\" display=\"round\" size=\"medium\" text=\"BUY NOW\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_div]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WE PROVIDE BEST DIGITAL SERVICES\" size=\"h3\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row different_values=\"0\" text_align=\"center\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" style_margin_bottom=\"70\" different_values=\"0\" text_align=\"center\"]<p><span style=\"font-size:15px;\">Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</span></p>[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"BRANDING\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-gift\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"WEB DESIGN\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-desktop\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"LOGO DESIGN\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-bug\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"ILLUSTRATIONS\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-heart\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col desktop=\"6\" wide=\"6\" different_values=\"0\" extra_classes=\"hidden-xs hidden-sm\'\"]\r\n[nd_image fid=\"49\" different_values=\"0\"]\r\n[/nd_image]\r\n[/col]\r\n[col tablet=\"6\" desktop=\"3\" wide=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"DEVELOPMENT\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-cogs\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"PHOTOGRAPHY\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-camera\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"MARKETING\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-area-chart\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[nd_feature text=\"SUPPORT\" type=\"alt-service\" different_values=\"0\" icon=\"fa fa-life-ring\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, elit. Vitae gravida nibh. Morbi dignissim nunc at risus convallis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" desktop=\"7\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"17\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"47\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[col extra_classes=\"col-lg-offset-1\" wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_bg extra_classes=\"text\" different_values=\"0\" slider=\"0\" banner=\"0\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_bg extra_classes=\"text\" different_values=\"0\" slider=\"0\" banner=\"0\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n[/col]\r\n[col different_values=\"0\" desktop=\"7\" extra_classes=\"col-lg-offset-1\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"17\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"76\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_margin_bottom=\"-20\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,71,78,'en',0,'[row different_values=\"0\" style_padding_bottom=\"120\"]\r\n[col extra_classes=\" col-md-offset-2\" different_values=\"0\" tablet=\"8\"]\r\n[nd_accordions different_values=\"0\"]\r\n[nd_accordion title=\"WHAT DO YOU MEAN BY AN END PRODUCT?\" active=\"1\" different_values=\"0\"]\r\n[html format=\"ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"I HAVE BOUGHT A PRODUCT THAT HAS FILES MISSING, WHAT DO I DO?\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"DO I NEED TO BUY A LICENCE FOR EACH SITE?\" active=\"1\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"IS MY LICENSE TRANSFERABLE?\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"CAN I INCORPORATE ADVERTISING IN MY END PRODUCT WITH A REGULAR LICENCE?\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[nd_accordion title=\"Do I need a separate license each time I use an item in a series?\" active=\"0\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/nd_accordion]\r\n[/nd_accordions]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,72,79,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[nd_block admin_url=\"admin/structure/block/manage/rhythm_search\" different_values=\"0\" style_padding_bottom = \"50\"]\r\n[/nd_block]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" style_margin_bottom=\"100\" text_align=\"center\"]<p>Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"WHAT DO YOU MEAN BY AN END PRODUCT?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"I HAVE BOUGHT A PRODUCT THAT HAS FILES MISSING, WHAT DO I DO?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"DO I NEED TO BUY A LICENCE FOR EACH SITE?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"IS MY LICENSE TRANSFERABLE?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[nd_hr style_margin_bottom=\"30\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_title title=\"CAN I INCORPORATE ADVERTISING IN MY END PRODUCT WITH A REGULAR LICENCE?\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur vehicula porttitor rutrum. Ut laoreet sodales rutrum. Ut eget tristique nibh. Cras mattis est eget lacus dignissim, non consectetur velit pellentesque. Ut sit amet placerat eros, id gravida arcu. Sed felis purus, tempor ac vestibulum nec, consectetur at purus.</p>[/html]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,74,81,'en',0,'[nd_title title=\"HAVE A QUESTIONS?\" size=\"h2\" styled=\"0\" uppercase=\"0\" extra_classes=\"section-title font-alt mb-70 mb-sm-40\" different_values=\"0\" alignment=\" align-center\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Call Us\" icon=\"fa fa-phone\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]+61 3 8376 6284[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-map-marker\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]245 Quigley Blvd, Ste K[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-envelope\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"mailto:support@bestlooker.pro\">support@bestlooker.pro</a>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[nd_node admin_url=\"node/73/edit\" different_values=\"0\"]\r\n[/nd_node]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,75,82,'en',0,'[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" style_margin_bottom=\"70\" text_align=\"center\"]<p>Curabitur eu adipiscing lacus, a iaculis diam. Nullam placerat blandit auctor. Nulla accumsan ipsum et nibh rhoncus, eget tempus sapien ultricies. Donec mollis lorem vehicula.</p>[/html]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Call Us\" icon=\"fa fa-phone\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]+61 3 8376 6284[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-map-marker\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]245 Quigley Blvd, Ste K[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-envelope\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"mailto:support@bestlooker.pro\">support@bestlooker.pro</a>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[nd_node admin_url=\"node/73/edit\" different_values=\"0\"]\r\n[/nd_node]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,95,102,'en',0,'<p>THE PAGE YOU WERE LOOKING FOR COULD NOT BE FOUND.</p>\r\n','','basic_html'),

('page',0,96,103,'en',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus mi urna, vehicula aliquam dapibus ornare, semper semper nisl.</p>\r\n','','basic_html'),

('page',0,97,104,'en',0,'[nd_container different_values=\"0\"]\r\n[row different_values=\"0\" style_margin_bottom=\"60\"]\r\n[col tablet=\"6\" different_values=\"0\" animation=\"fadeInLeft\"]\r\n[nd_title title=\"ABOUT STUDIO\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\" animation=\"fadeInRight\"]\r\n[html format=\"nd_ckeditor\" text_align=\"right\" different_values=\"0\"]<p><a class=\"section-more right\" href=\"#\">MORE ABOUT US <i class=\"fa fa-angle-right\"></i></a></p>[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_progress title=\"BRANDING\" percent=\"90\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"DESIGN\" percent=\"80\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[nd_progress title=\"DEVELOPMENT\" percent=\"85\" type=\"Thin Line\" different_values=\"0\"]\r\n[/nd_progress]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"section-text\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"section-text\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"SERVICES\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_tabs type=\"alt\" centered=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"Branding\" icon=\"icon-strategy\" icon_type=\"big\" active=\"1\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>It doesn’t matter how many times I have to click, as long as each click is a mindless, unambiguous choice.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"WEB DESIGN\" icon=\"icon-desktop\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"graphic design\" icon=\"icon-tools\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Development\" icon=\"icon-gears\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Photography\" icon=\"icon-camera\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" text_align=\"center\"]<p><a class=\"section-more font-alt\" href=\"#about\">View all services </a></p>[/html]\r\n[/nd_container]\r\n[nd_bg banner=\"0\" fid=\"44\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" full_height=\"0\" scroll_icon=\"0\" style_margin_top=\"70\" style_padding_top=\"0\" style_padding_bottom=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"45\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg banner=\"0\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\" color=\"black\" id=\"about\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-camera\" text=\"photography\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Cras luctus interdum sodales. Quisque quis odio dui. Sedes sit amet neque malesuada, lobortis commodo magna ntesque pharetra metus vivera sagittis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-tools-2\" text=\"development\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Fusce aliquet quam eget neque ultrices elementum. Nulla posuere felis id arcu blandit sagittis. Eleifender vestibulum purus, sit amet vulputate risus.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-anchor\" text=\"support\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. Praesent sed nisi eleifend, fermentum orci sit amet, iaculis libero interdum.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"46\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_margin_top=\"140\"]\r\n[row different_values=\"0\"]\r\n[col different_values=\"0\" desktop=\"7\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"48\" image_style=\"portfolio_650xauto_\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"47\" image_style=\"portfolio_650xauto_\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[col extra_classes=\"col-lg-offset-1\" wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" style_padding_bottom=\"140\"]\r\n[row different_values=\"0\"]\r\n[col wide=\"4\" different_values=\"0\" desktop=\"5\"]\r\n[nd_title title=\"Creative project\" size=\"h3\" different_values=\"0\" styled=\"1\" uppercase=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus facilisis mauris vel velit molestie pellentesque. Donec rutrum, tortor ut elementum venenatis, purus magna bibendum nisl, ut accumsan ipsum erat eu sapien.</p>[/html]\r\n[nd_button size=\"medium\" button_type=\"border\" block=\"0\" display=\"round\" text=\"View online\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/col]\r\n[col different_values=\"0\" desktop=\"7\" extra_classes=\"col-lg-offset-1\"]\r\n[nd_slider different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"49\" image_style=\"portfolio_650xauto_\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"48\" image_style=\"portfolio_650xauto_\"]\r\n[/nd_image]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_bg slider=\"0\" different_values=\"0\" fid=\"50\" color=\"bg-dark-alfa-70\" extra_classes=\"page-section\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[nd_slider slide_anim=\"wide\" different_values=\"0\"]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" different_values=\"0\" icon=\"icon-hotairballoon\" text=\"We\'re Creative\" color=\"white\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]We find the best ideas for you[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-clock\" text=\"We\'re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\" extra_classes=\"features-descr\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-lightbulb\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-wine\" text=\"We\'re Creative\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We find the best ideas for you</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-tools\" text=\"We’re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-gears\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-browser\" text=\"We\'re Creative\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We find the best ideas for you</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-wallet\" text=\"We\'re Punctual\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>We always do your tasks on time</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[nd_slider_item different_values=\"0\"]\r\n[nd_feature type=\"features\" color=\"white\" different_values=\"0\" icon=\"icon-document\" text=\"We have magic\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>You will be delighted</p>[/html]\r\n[/nd_feature]\r\n[/nd_slider_item]\r\n[/nd_slider]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container style_padding_top=\"140\" style_padding_bottom=\"140\" different_values=\"0\"]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col phone=\"6\" different_values=\"0\"]\r\n[nd_title title=\"latest news\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[col phone=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"/blog\" class=\"section-more right\">ALL NEWS IN OUR BLOG <i class=\"fa fa-angle-right\"></i></a>[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/blog_grid/edit/page_4\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" style_padding_top=\"70\" style_padding_bottom=\"70\"]\r\n[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" extra_classes=\"col-md-offset-3\" different_values=\"0\"]\r\n[nd_title title=\"STAY INFORMED WITH OUR NEWSLETTER\" size=\"h4\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_node admin_url=\"node/98/edit\" different_values=\"0\" style_margin_bottom=\"-15\"]\r\n[/nd_node]\r\n[html format=\"html\" different_values=\"0\" text_align=\"center\"]<div class=\"form-tip\"> <i class=\"fa fa-info-circle\"></i> Please trust us, we will never send you spam </div>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[nd_title title=\"FIND US\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" different_values=\"0\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Call Us\" icon=\"fa fa-phone\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]+61 3 8376 6284[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-map-marker\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]245 Quigley Blvd, Ste K[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-envelope\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"mailto:support@bestlooker.pro\">support@bestlooker.pro</a>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,100,107,'en',0,'[nd_div vertical_align=\"0\" different_values=\"0\"]\r\n[/nd_div]\r\n ','','shortcodes'),

('page',0,101,108,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"FREELANCE PHOTOGRAPHERS\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" extra_classes=\"section-title\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"section-text\" style_margin_bottom=\"70\"]<p>In auctor ex id urna faucibus porttitor. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[nd_image fid=\"85\" align=\"center\" different_values=\"0\" width=\"170\" height=\"55\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n ','','shortcodes'),

('page',0,102,109,'en',0,'[nd_container different_values=\"0\" id=\"about\"]\r\n[row different_values=\"0\" style_margin_bottom=\"60\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[nd_title title=\"ABOUT STUDIO\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" text_align=\"right\" different_values=\"0\"]<p><a class=\"section-more right\" href=\"#\">MORE ABOUT US <i class=\"fa fa-angle-right\"></i></a></p>[/html]\r\n[/col]\r\n[/row]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote type=\"footer\" footer=\"LOUIS KAHN\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Design is not making beauty, beauty emerges from selection, affinities, integration, love.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero. Donec vel ultricies purus. Nam dictum sem, eu aliquam.</p>[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/team/edit/block_1\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_hr style_margin_top=\"140\" style_margin_bottom=\"140\" different_values=\"0\"]\r\n[/nd_hr]\r\n[nd_container different_values=\"0\" id=\"services\"]\r\n[nd_title title=\"SERVICES\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_tabs type=\"alt\" centered=\"0\" different_values=\"0\"]\r\n[nd_tab title=\"Branding\" icon=\"icon-strategy\" icon_type=\"big\" active=\"1\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>It doesn’t matter how many times I have to click, as long as each click is a mindless, unambiguous choice.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"WEB DESIGN\" icon=\"icon-desktop\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"graphic design\" icon=\"icon-tools\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Development\" icon=\"icon-gears\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[nd_tab title=\"Photography\" icon=\"icon-camera\" icon_type=\"big\" active=\"0\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[nd_quote footer=\"JEFF BEZOS\" different_values=\"0\" type=\"footer\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>A brand for a company is like a reputation for a person. You earn reputation by trying to do hard things well.</p>[/html]\r\n[/nd_quote]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum volutpat nibh, accumsan purus. Lorem ipsum dolor sit semper amet, consectetur adipiscing elit. In maximus ligula metus pellentesque mattis.</p>[/html]\r\n[/col]\r\n[col tablet=\"4\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]Donec vel ultricies purus. Nam dictum sem, ipsum aliquam . Etiam sit amet fringilla lacus. Pellentesque suscipit ante at ullamcorper pulvinar neque porttitor. Integer lectus. Praesent sed nisi eleifend, fermentum orci amet, iaculis libero.[/html]\r\n[/col]\r\n[/row]\r\n[/nd_tab]\r\n[/nd_tabs]\r\n[/nd_container]\r\n[nd_bg banner=\"0\" fid=\"44\" color=\"bg-dark\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\" full_height=\"0\" scroll_icon=\"0\" style_margin_top=\"70\" style_padding_top=\"0\" style_padding_bottom=\"0\" video_sound=\"0\"]\r\n[nd_container extra_classes=\"relative\" different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<div class=\"mt-140 mt-lg-80 mb-140 mb-lg-80\"><div class=\"banner-content\"><h3 class=\"banner-heading font-alt\">Looking for exclusive digital services?</h3><div class=\"banner-decription\"> Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. </div><div class=\"local-scroll\"><a class=\"btn btn-mod btn-w btn-medium btn-round\" href=\"#contact\">Lets talk</a></div></div></div>[/html]\r\n[/col]\r\n[col extra_style=\"visibility: visible; animation-name: fadeInUp;\" extra_classes=\"banner-image wow fadeInUp animated\" tablet=\"6\" different_values=\"0\"]\r\n[nd_image type=\"0\" different_values=\"0\" border=\"0\" shadow=\"0\" hover=\"None\" fid=\"45\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\" style_padding_bottom=\"70\" id=\"portfolio\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[nd_title title=\"Portfolio\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" style_margin_top=\"20\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" text_align=\"center\" different_values=\"0\"]<p>In auctor ex id urna faucibus porttitor. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_view admin_url=\"admin/structure/views/view/portfolio_boxed/edit/block_1\" different_values=\"0\"]\r\n[/nd_view]\r\n[nd_bg color=\"bg-dark\" slider=\"0\" banner=\"0\" full_height=\"0\" scroll_icon=\"0\" different_values=\"0\" style_padding_top=\"70\" style_padding_bottom=\"70\" text_align=\"center\"]\r\n[nd_title title=\"LIKE OUR CREATIVE WORKS?\" size=\"h4_styled\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"white\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_button button_type=\"gray\" block=\"0\" display=\"round\" size=\"medium\" text=\"START PROJECT\" invert=\"0\" different_values=\"0\"]\r\n[/nd_button]\r\n[/nd_bg]\r\n[nd_bg banner=\"0\" slider=\"0\" different_values=\"0\" extra_classes=\"page-section\"]\r\n[nd_container different_values=\"0\"]\r\n[nd_title title=\"WHY CHOOSE US?\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" style_margin_bottom=\"70\" different_values=\"0\"]\r\n[/nd_title]\r\n[row extra_classes=\"multi-columns-row alt-features-grid\" different_values=\"0\"]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" color=\"black\" icon=\"icon-circle-compass\" text=\"Branding\" different_values=\"0\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-presentation\" text=\"Marketing\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Proin fringilla augue at maximus vestibulum. Nam pulvinar vitae neque et porttitor. Praesent sed nisi eleifend, lorem fermentum orci sit amet, iaculis libero.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-browser\" text=\"web design\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Curabitur iaculis accumsan augue, nec finibus mauris pretium eu. Duis placerat ex gravida nibh tristique porta. Nulla facilisi. Suspendisse ultricies eros blandit.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-camera\" text=\"photography\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Cras luctus interdum sodales. Quisque quis odio dui. Sedes sit amet neque malesuada, lobortis commodo magna ntesque pharetra metus vivera sagittis.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-tools-2\" text=\"development\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Fusce aliquet quam eget neque ultrices elementum. Nulla posuere felis id arcu blandit sagittis. Eleifender vestibulum purus, sit amet vulputate risus.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col different_values=\"0\" wide=\"4\" desktop=\"4\" tablet=\"6\"]\r\n[nd_feature type=\"alt-features\" different_values=\"0\" icon=\"icon-anchor\" text=\"support\" color=\"black\"]\r\n[html different_values=\"0\" format=\"nd_ckeditor\"]<p>Pulvinar vitae neque et porttitor. Integer non dapibus diam, ac eleifend lectus. Praesent sed nisi eleifend, fermentum orci sit amet, iaculis libero interdum.</p>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_bg color=\"bg-dark-alfa-90\" different_values=\"0\" fid=\"61\" extra_classes=\"page-section\" slider=\"1\" banner=\"0\"]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" testimonial=\"1\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[nd_container different_values=\"0\" extra_classes=\"relative\"]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2 align-center\" different_values=\"0\"]\r\n[nd_feature different_values=\"0\" icon=\"icon-quote\" text=\"What people say?\" color=\"light\" type=\"medium\"]\r\n[nd_quote type=\"testimonial\" footer=\" John Doe, doodle inc. \" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit. Aenean congue, risus utaliquam dapibus. Thanks!</p>[/html]\r\n[/nd_quote]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container style_padding_top=\"140\" style_padding_bottom=\"140\" different_values=\"0\" id=\"news\"]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col phone=\"6\" different_values=\"0\"]\r\n[nd_title title=\"latest news\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[/col]\r\n[col phone=\"6\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"/blog\" class=\"section-more right\">ALL NEWS IN OUR BLOG <i class=\"fa fa-angle-right\"></i></a>[/html]\r\n[/col]\r\n[/row]\r\n[nd_view admin_url=\"admin/structure/views/view/blog_grid/edit/block_1\" different_values=\"0\"]\r\n[/nd_view]\r\n[/nd_container]\r\n[nd_bg color=\"bg-gray\" slider=\"0\" banner=\"0\" different_values=\"0\" style_padding_bottom=\"70\" full_height=\"0\" scroll_icon=\"0\"]\r\n[nd_container different_values=\"0\"]\r\n[row different_values=\"0\"]\r\n[col tablet=\"6\" extra_classes=\"col-md-offset-3\" different_values=\"0\"]\r\n[nd_title title=\"STAY INFORMED WITH OUR NEWSLETTER\" size=\"h4\" alignment=\" align-center\" styled=\"0\" uppercase=\"1\" different_values=\"0\"]\r\n[/nd_title]\r\n[nd_node admin_url=\"node/117/edit\" different_values=\"0\" style_margin_bottom=\"-15\"]\r\n[/nd_node]\r\n[html format=\"html\" different_values=\"0\" text_align=\"center\"]<div class=\"form-tip\"> <i class=\"fa fa-info-circle\"></i> Please trust us, we will never send you spam </div>[/html]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n[/nd_bg]\r\n[nd_container different_values=\"0\" style_padding_top=\"140\" id=\"contacts\"]\r\n[nd_title title=\"contact\" size=\"h2\" styled=\"0\" uppercase=\"0\" extra_classes=\"section-title font-alt mb-70 mb-sm-40\" different_values=\"0\" alignment=\" align-center\" color=\"black\"]\r\n[/nd_title]\r\n[row different_values=\"0\"]\r\n[col desktop=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\"]\r\n[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Call Us\" icon=\"fa fa-phone\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]+61 3 8376 6284[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-map-marker\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]245 Quigley Blvd, Ste K[/html]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"6\" wide=\"4\" extra_classes=\"pt-20 pb-20 pb-xs-0\" different_values=\"0\"]\r\n[nd_feature type=\"ci\" text=\"Address\" icon=\"fa fa-envelope\" different_values=\"0\"]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<a href=\"mailto:support@bestlooker.pro\">support@bestlooker.pro</a>[/html]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n[nd_node admin_url=\"node/106/edit\" different_values=\"0\"]\r\n[/nd_node]\r\n[/col]\r\n[/row]\r\n[/nd_container]\r\n ','','shortcodes'),

('page',0,103,110,'en',0,'[row different_values=\"0\"]\r\n[col tablet=\"8\" extra_classes=\"col-md-offset-2\" different_values=\"0\" text_align=\"center\"]\r\n[nd_title title=\"FREELANCE PHOTOGRAPHERS\" size=\"h4\" alignment=\" align-center\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\" extra_classes=\"section-title\" style_margin_bottom=\"70\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\" extra_classes=\"section-text\" style_margin_bottom=\"70\"]<p>In auctor ex id urna faucibus porttitor. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim sagittis quam, id porta quam. Sed id dolor consectetur fermentum nibh volutpat, accumsan purus.</p>[/html]\r\n[nd_image fid=\"85\" align=\"center\" different_values=\"0\" width=\"170\" height=\"55\"]\r\n[/nd_image]\r\n[/col]\r\n[/row]\r\n ','','shortcodes');

/*Table structure for table `node_revision__comment` */

DROP TABLE IF EXISTS `node_revision__comment`;

CREATE TABLE `node_revision__comment` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field comment.';

/*Data for the table `node_revision__comment` */

/*Table structure for table `node_revision__field_blog_category` */

DROP TABLE IF EXISTS `node_revision__field_blog_category`;

CREATE TABLE `node_revision__field_blog_category` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_blog_category_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_blog_category_target_id` (`field_blog_category_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_blog_category.';

/*Data for the table `node_revision__field_blog_category` */

insert  into `node_revision__field_blog_category`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_blog_category_target_id`) values 

('nd_blog',0,2,2,'en',0,5),

('nd_blog',0,2,2,'en',1,3),

('nd_blog',0,2,2,'en',2,4),

('nd_blog',0,3,3,'en',0,2),

('nd_blog',0,3,3,'en',1,9),

('nd_blog',0,3,3,'en',2,8),

('nd_blog',0,4,4,'en',0,1),

('nd_blog',0,4,4,'en',1,2),

('nd_blog',0,4,4,'en',2,9),

('nd_blog',0,5,5,'en',0,4),

('nd_blog',0,5,5,'en',1,1),

('nd_blog',0,5,5,'en',2,2),

('nd_blog',0,6,6,'en',0,4),

('nd_blog',0,6,6,'en',1,1),

('nd_blog',0,7,7,'en',0,4),

('nd_blog',0,7,7,'en',1,1),

('nd_blog',0,8,8,'en',0,8),

('nd_blog',0,8,8,'en',1,7),

('nd_blog',0,9,9,'en',0,8),

('nd_blog',0,9,9,'en',1,7);

/*Table structure for table `node_revision__field_category` */

DROP TABLE IF EXISTS `node_revision__field_category`;

CREATE TABLE `node_revision__field_category` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_category_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_category_target_id` (`field_category_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_category.';

/*Data for the table `node_revision__field_category` */

insert  into `node_revision__field_category`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_category_target_id`) values 

('nd_portfolio',0,10,10,'en',0,29),

('nd_portfolio',0,10,10,'en',1,30),

('nd_portfolio',0,11,11,'en',0,28),

('nd_portfolio',0,11,11,'en',1,29),

('nd_portfolio',0,12,12,'en',0,28),

('nd_portfolio',0,12,12,'en',1,29),

('nd_portfolio',0,13,13,'en',0,28),

('nd_portfolio',0,13,13,'en',1,29),

('nd_portfolio',0,14,14,'en',0,31),

('nd_portfolio',0,14,14,'en',1,32),

('nd_portfolio',0,15,15,'en',0,28),

('nd_portfolio',0,16,16,'en',0,28),

('nd_portfolio',0,17,17,'en',0,30),

('nd_portfolio',0,18,18,'en',0,30),

('nd_portfolio',0,19,19,'en',0,28),

('nd_portfolio',0,20,20,'en',0,30),

('nd_portfolio',0,21,21,'en',0,30),

('nd_portfolio',0,22,22,'en',0,28),

('nd_portfolio',0,23,23,'en',0,28),

('nd_portfolio',0,24,24,'en',0,30),

('nd_portfolio',0,25,25,'en',0,30),

('nd_portfolio',0,26,26,'en',0,30),

('nd_portfolio',0,27,27,'en',0,29),

('nd_portfolio',0,28,28,'en',0,28),

('nd_portfolio',0,29,29,'en',0,30),

('nd_portfolio',0,30,30,'en',0,28),

('nd_portfolio',0,31,31,'en',0,28),

('nd_portfolio',0,32,32,'en',0,31),

('nd_portfolio',0,33,33,'en',0,31),

('nd_portfolio',0,56,63,'en',0,28);

/*Table structure for table `node_revision__field_comments` */

DROP TABLE IF EXISTS `node_revision__field_comments`;

CREATE TABLE `node_revision__field_comments` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_comments_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_comments.';

/*Data for the table `node_revision__field_comments` */

insert  into `node_revision__field_comments`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_comments_status`) values 

('nd_blog',0,4,4,'en',0,2),

('nd_blog',0,5,5,'en',0,2),

('nd_blog',0,6,6,'en',0,2),

('nd_blog',0,7,7,'en',0,2),

('nd_blog',0,8,8,'en',0,2),

('nd_blog',0,9,9,'en',0,2);

/*Table structure for table `node_revision__field_description` */

DROP TABLE IF EXISTS `node_revision__field_description`;

CREATE TABLE `node_revision__field_description` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_description_value` longtext NOT NULL,
  `field_description_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_description_format` (`field_description_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_description.';

/*Data for the table `node_revision__field_description` */

insert  into `node_revision__field_description`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_description_value`,`field_description_format`) values 

('nd_portfolio',0,10,10,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,11,11,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,12,12,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,13,13,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,14,14,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,15,15,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,16,16,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,17,17,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,18,18,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,19,19,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,20,20,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,21,21,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,22,22,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,23,23,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,24,24,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,25,25,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,26,26,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,27,27,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,28,28,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,29,29,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,30,30,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,31,31,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,32,32,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,33,33,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes'),

('nd_portfolio',0,56,63,'en',0,'[row different_values=\"0\" style_padding_bottom=\"60\"]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_title title=\"about\" size=\"h4\" alignment=\" align-left\" styled=\"1\" uppercase=\"1\" color=\"black\" different_values=\"0\"]\r\n[/nd_title]\r\n[html format=\"nd_ckeditor\" different_values=\"0\"]<p>Lorem ipsum dolor sit amet, c-r adipiscing elit. In maximus ligula semper metus pellentesque mattis. Maecenas volutpat, diam enim.</p>[/html]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"1. Discuss\" icon=\"icon-chat\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"2. Make\" icon=\"icon-browser\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[col tablet=\"3\" different_values=\"0\"]\r\n[nd_feature text=\"3. Product\" icon=\"icon-heart\" type=\"alt-features\" different_values=\"0\"]\r\n[/nd_feature]\r\n[/col]\r\n[/row]\r\n ','shortcodes');

/*Table structure for table `node_revision__field_gallery` */

DROP TABLE IF EXISTS `node_revision__field_gallery`;

CREATE TABLE `node_revision__field_gallery` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_gallery_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_gallery_target_id` (`field_gallery_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_gallery.';

/*Data for the table `node_revision__field_gallery` */

insert  into `node_revision__field_gallery`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_gallery_target_id`) values 

('gallery_item',0,76,83,'en',0,33),

('gallery_item',0,77,84,'en',0,33),

('gallery_item',0,78,85,'en',0,33),

('gallery_item',0,79,86,'en',0,33),

('gallery_item',0,80,87,'en',0,33),

('gallery_item',0,80,87,'en',1,34),

('gallery_item',0,81,88,'en',0,34),

('gallery_item',0,82,89,'en',0,33),

('gallery_item',0,83,90,'en',0,33),

('gallery_item',0,84,91,'en',0,33),

('gallery_item',0,85,92,'en',0,33),

('gallery_item',0,86,93,'en',0,35),

('gallery_item',0,87,94,'en',0,35),

('gallery_item',0,88,95,'en',0,35),

('gallery_item',0,89,96,'en',0,35),

('gallery_item',0,90,97,'en',0,35),

('gallery_item',0,91,98,'en',0,35),

('gallery_item',0,92,99,'en',0,35),

('gallery_item',0,93,100,'en',0,35),

('gallery_item',0,99,106,'en',0,33);

/*Table structure for table `node_revision__field_image` */

DROP TABLE IF EXISTS `node_revision__field_image`;

CREATE TABLE `node_revision__field_image` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_image_target_id` (`field_image_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_image.';

/*Data for the table `node_revision__field_image` */

insert  into `node_revision__field_image`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_image_target_id`,`field_image_alt`,`field_image_title`,`field_image_width`,`field_image_height`) values 

('nd_person',0,57,64,'en',0,28,'A','',370,450),

('nd_person',0,58,65,'en',0,29,'B','',370,450),

('nd_person',0,59,66,'en',0,27,'A','',370,450),

('nd_person',0,60,67,'en',0,30,'B','',370,450),

('gallery_item',0,76,83,'en',0,31,'A','',1920,1280),

('gallery_item',0,77,84,'en',0,32,'B','',1920,1280),

('gallery_item',0,78,85,'en',0,33,'A','',1920,1280),

('gallery_item',0,79,86,'en',0,34,'a','',1920,1278),

('gallery_item',0,80,87,'en',0,35,'a','',1920,1280),

('gallery_item',0,81,88,'en',0,36,'f','',1920,1280),

('gallery_item',0,82,89,'en',0,37,'r','',1920,1280),

('gallery_item',0,83,90,'en',0,38,'s','',1920,1280),

('gallery_item',0,84,91,'en',0,39,'q','',1920,1279),

('gallery_item',0,85,92,'en',0,40,'d','',1920,1280),

('gallery_item',0,86,93,'en',0,20,'f','',650,418),

('gallery_item',0,87,94,'en',0,25,'s','',1920,1080),

('gallery_item',0,88,95,'en',0,21,'s','',650,418),

('gallery_item',0,89,96,'en',0,18,'v','',650,418),

('gallery_item',0,90,97,'en',0,15,'v','',650,418),

('gallery_item',0,91,98,'en',0,19,'b','',650,418),

('gallery_item',0,92,99,'en',0,31,'d','',1920,1280),

('gallery_item',0,93,100,'en',0,32,'f','',1920,1280),

('gallery_item',0,94,101,'en',0,33,'f','',1920,1280),

('gallery_item',0,99,106,'en',0,45,'a','',529,439);

/*Table structure for table `node_revision__field_images` */

DROP TABLE IF EXISTS `node_revision__field_images`;

CREATE TABLE `node_revision__field_images` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_images_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_images_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_images_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_images_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_images_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_images_target_id` (`field_images_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_images.';

/*Data for the table `node_revision__field_images` */

insert  into `node_revision__field_images`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_images_target_id`,`field_images_alt`,`field_images_title`,`field_images_width`,`field_images_height`) values 

('nd_blog',0,2,2,'en',0,2,'Alt','',2280,1284),

('nd_blog',0,2,2,'en',1,3,'Alt','',2280,1284),

('nd_blog',0,2,2,'en',2,4,'Alt','',2280,1284),

('nd_blog',0,3,3,'en',0,6,'Alt','',2280,1284),

('nd_blog',0,3,3,'en',1,2,'Alt','',2280,1284),

('nd_blog',0,4,4,'en',0,2,'Alt','',2280,1284),

('nd_blog',0,4,4,'en',1,3,'Alt','',2280,1284),

('nd_blog',0,5,5,'en',0,7,'A','',2280,1284),

('nd_blog',0,5,5,'en',1,2,'A','',2280,1284),

('nd_blog',0,5,5,'en',2,3,'B','',2280,1284),

('nd_blog',0,6,6,'en',0,5,'a','',2280,1284),

('nd_blog',0,6,6,'en',1,2,'b','',2280,1284),

('nd_blog',0,6,6,'en',2,3,'c','',2280,1284),

('nd_portfolio',0,10,10,'en',0,9,'A','',650,418),

('nd_portfolio',0,10,10,'en',1,9,'A','',650,418),

('nd_portfolio',0,10,10,'en',2,10,'B','',650,418),

('nd_portfolio',0,10,10,'en',3,10,'B','',650,418),

('nd_portfolio',0,11,11,'en',0,11,'A','',650,418),

('nd_portfolio',0,11,11,'en',1,11,'A','',650,418),

('nd_portfolio',0,11,11,'en',2,12,'B','',650,418),

('nd_portfolio',0,11,11,'en',3,12,'B','',650,418),

('nd_portfolio',0,11,11,'en',4,15,'C','',650,418),

('nd_portfolio',0,11,11,'en',5,15,'C','',650,418),

('nd_portfolio',0,12,12,'en',0,14,'A','',650,418),

('nd_portfolio',0,12,12,'en',1,11,'A','',650,418),

('nd_portfolio',0,13,13,'en',0,17,'A','',650,418),

('nd_portfolio',0,13,13,'en',1,17,'A','',650,418),

('nd_portfolio',0,13,13,'en',2,18,'B','',650,418),

('nd_portfolio',0,13,13,'en',3,18,'B','',650,418),

('nd_portfolio',0,14,14,'en',0,19,'C','',650,418),

('nd_portfolio',0,14,14,'en',1,19,'C','',650,418),

('nd_portfolio',0,14,14,'en',2,20,'D','',650,418),

('nd_portfolio',0,14,14,'en',3,20,'D','',650,418),

('nd_portfolio',0,15,15,'en',0,21,'A','',650,418),

('nd_portfolio',0,15,15,'en',1,21,'A','',650,418),

('nd_portfolio',0,16,16,'en',0,20,'F','',650,418),

('nd_portfolio',0,16,16,'en',1,19,'D','',650,418),

('nd_portfolio',0,17,17,'en',0,20,'F','',650,418),

('nd_portfolio',0,17,17,'en',1,17,'f','',650,418),

('nd_portfolio',0,18,18,'en',0,17,'b','',650,418),

('nd_portfolio',0,18,18,'en',1,18,'d','',650,418),

('nd_portfolio',0,19,19,'en',0,18,'f','',650,418),

('nd_portfolio',0,19,19,'en',1,15,'f','',650,418),

('nd_portfolio',0,20,20,'en',0,15,'t','',650,418),

('nd_portfolio',0,20,20,'en',1,16,'y','',650,418),

('nd_portfolio',0,21,21,'en',0,16,'d','',650,418),

('nd_portfolio',0,21,21,'en',1,13,'b','',650,418),

('nd_portfolio',0,22,22,'en',0,13,'h','',650,418),

('nd_portfolio',0,22,22,'en',1,14,'h','',650,418),

('nd_portfolio',0,23,23,'en',0,14,'a','',650,418),

('nd_portfolio',0,23,23,'en',1,11,'b','',650,418),

('nd_portfolio',0,24,24,'en',0,11,'t','',650,418),

('nd_portfolio',0,24,24,'en',1,12,'y','',650,418),

('nd_portfolio',0,25,25,'en',0,9,'g','',650,418),

('nd_portfolio',0,25,25,'en',1,10,'f','',650,418),

('nd_portfolio',0,26,26,'en',0,10,'t','',650,418),

('nd_portfolio',0,26,26,'en',1,7,'f','',2280,1284),

('nd_portfolio',0,27,27,'en',0,21,'a','',650,418),

('nd_portfolio',0,27,27,'en',1,19,'b','',650,418),

('nd_portfolio',0,28,28,'en',0,19,'r','',650,418),

('nd_portfolio',0,28,28,'en',1,20,'d','',650,418),

('nd_portfolio',0,29,29,'en',0,20,'a','',650,418),

('nd_portfolio',0,29,29,'en',1,17,'g','',650,418),

('nd_portfolio',0,30,30,'en',0,17,'t','',650,418),

('nd_portfolio',0,30,30,'en',1,18,'f','',650,418),

('nd_portfolio',0,31,31,'en',0,18,'t','',650,418),

('nd_portfolio',0,31,31,'en',1,15,'t','',650,418),

('nd_portfolio',0,32,32,'en',0,16,'t','',650,418),

('nd_portfolio',0,32,32,'en',1,13,'y','',650,418),

('nd_portfolio',0,33,33,'en',0,13,'y','',650,418),

('nd_portfolio',0,33,33,'en',1,14,'h','',650,418),

('nd_portfolio',0,56,63,'en',0,26,'A','',1800,2315);

/*Table structure for table `node_revision__field_lead_text` */

DROP TABLE IF EXISTS `node_revision__field_lead_text`;

CREATE TABLE `node_revision__field_lead_text` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_lead_text_value` longtext NOT NULL,
  `field_lead_text_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_lead_text_format` (`field_lead_text_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_lead_text.';

/*Data for the table `node_revision__field_lead_text` */

insert  into `node_revision__field_lead_text`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_lead_text_value`,`field_lead_text_format`) values 

('nd_blog',0,2,2,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','basic_html'),

('nd_blog',0,3,3,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','ckeditor'),

('nd_blog',0,4,4,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','ckeditor'),

('nd_blog',0,5,5,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','ckeditor'),

('nd_blog',0,6,6,'en',0,'<p>Morbi lacus massa, euismod ut turpis molestie, tristique sodales est. Integer sit amet mi id sapien tempor molestie in nec massa. Fusce non ante sed lorem rutrum feugiat.</p>\r\n','ckeditor');

/*Table structure for table `node_revision__field_portfolio_category` */

DROP TABLE IF EXISTS `node_revision__field_portfolio_category`;

CREATE TABLE `node_revision__field_portfolio_category` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_portfolio_category_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_portfolio_category_target_id` (`field_portfolio_category_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_portfolio…';

/*Data for the table `node_revision__field_portfolio_category` */

insert  into `node_revision__field_portfolio_category`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_portfolio_category_target_id`) values 

('nd_portfolio',0,10,10,'en',0,26),

('nd_portfolio',0,10,10,'en',1,27),

('nd_portfolio',0,11,11,'en',0,25),

('nd_portfolio',0,11,11,'en',1,24),

('nd_portfolio',0,12,12,'en',0,25),

('nd_portfolio',0,12,12,'en',1,24),

('nd_portfolio',0,13,13,'en',0,25),

('nd_portfolio',0,13,13,'en',1,24),

('nd_portfolio',0,14,14,'en',0,22),

('nd_portfolio',0,14,14,'en',1,23),

('nd_portfolio',0,15,15,'en',0,26),

('nd_portfolio',0,15,15,'en',1,27),

('nd_portfolio',0,16,16,'en',0,26),

('nd_portfolio',0,16,16,'en',1,27),

('nd_portfolio',0,17,17,'en',0,25),

('nd_portfolio',0,18,18,'en',0,25),

('nd_portfolio',0,19,19,'en',0,23),

('nd_portfolio',0,19,19,'en',1,25),

('nd_portfolio',0,20,20,'en',0,27),

('nd_portfolio',0,21,21,'en',0,26),

('nd_portfolio',0,22,22,'en',0,26),

('nd_portfolio',0,23,23,'en',0,25),

('nd_portfolio',0,24,24,'en',0,26),

('nd_portfolio',0,25,25,'en',0,26),

('nd_portfolio',0,26,26,'en',0,26),

('nd_portfolio',0,27,27,'en',0,26),

('nd_portfolio',0,28,28,'en',0,26),

('nd_portfolio',0,29,29,'en',0,22),

('nd_portfolio',0,30,30,'en',0,26),

('nd_portfolio',0,31,31,'en',0,26),

('nd_portfolio',0,32,32,'en',0,26),

('nd_portfolio',0,33,33,'en',0,26),

('nd_portfolio',0,56,63,'en',0,26),

('nd_portfolio',0,56,63,'en',1,27);

/*Table structure for table `node_revision__field_position` */

DROP TABLE IF EXISTS `node_revision__field_position`;

CREATE TABLE `node_revision__field_position` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_position_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_position.';

/*Data for the table `node_revision__field_position` */

insert  into `node_revision__field_position`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_position_value`) values 

('nd_person',0,57,64,'en',0,'Creative Director'),

('nd_person',0,58,65,'en',0,'Web Director'),

('nd_person',0,59,66,'en',0,'Designer'),

('nd_person',0,60,67,'en',0,'CEO');

/*Table structure for table `node_revision__field_project` */

DROP TABLE IF EXISTS `node_revision__field_project`;

CREATE TABLE `node_revision__field_project` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_project_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_project_target_id` (`field_project_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_project.';

/*Data for the table `node_revision__field_project` */

insert  into `node_revision__field_project`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_project_target_id`) values 

('nd_portfolio',0,10,10,'en',0,16),

('nd_portfolio',0,10,10,'en',1,17),

('nd_portfolio',0,11,11,'en',0,17),

('nd_portfolio',0,11,11,'en',1,19),

('nd_portfolio',0,12,12,'en',0,17),

('nd_portfolio',0,12,12,'en',1,19),

('nd_portfolio',0,13,13,'en',0,17),

('nd_portfolio',0,13,13,'en',1,19),

('nd_portfolio',0,14,14,'en',0,21),

('nd_portfolio',0,14,14,'en',1,16),

('nd_portfolio',0,15,15,'en',0,17),

('nd_portfolio',0,16,16,'en',0,20),

('nd_portfolio',0,17,17,'en',0,21),

('nd_portfolio',0,18,18,'en',0,18),

('nd_portfolio',0,19,19,'en',0,20),

('nd_portfolio',0,20,20,'en',0,16),

('nd_portfolio',0,21,21,'en',0,21),

('nd_portfolio',0,22,22,'en',0,17),

('nd_portfolio',0,23,23,'en',0,16),

('nd_portfolio',0,24,24,'en',0,21),

('nd_portfolio',0,25,25,'en',0,16),

('nd_portfolio',0,26,26,'en',0,20),

('nd_portfolio',0,27,27,'en',0,16),

('nd_portfolio',0,28,28,'en',0,16),

('nd_portfolio',0,29,29,'en',0,16),

('nd_portfolio',0,30,30,'en',0,17),

('nd_portfolio',0,31,31,'en',0,16),

('nd_portfolio',0,32,32,'en',0,17),

('nd_portfolio',0,33,33,'en',0,16),

('nd_portfolio',0,56,63,'en',0,17);

/*Table structure for table `node_revision__field_project_link` */

DROP TABLE IF EXISTS `node_revision__field_project_link`;

CREATE TABLE `node_revision__field_project_link` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_project_link_uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `field_project_link_title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `field_project_link_options` longblob COMMENT 'Serialized array of options for the link.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_project_link_uri` (`field_project_link_uri`(30))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_project_link.';

/*Data for the table `node_revision__field_project_link` */

insert  into `node_revision__field_project_link`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_project_link_uri`,`field_project_link_title`,`field_project_link_options`) values 

('nd_portfolio',0,10,10,'en',0,'internal:/node/67','View Online','a:0:{}'),

('nd_portfolio',0,11,11,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,12,12,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,13,13,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,14,14,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,15,15,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,16,16,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,17,17,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,18,18,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,19,19,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,20,20,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,21,21,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,22,22,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,23,23,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,24,24,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,25,25,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,26,26,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,27,27,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,28,28,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,29,29,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,30,30,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,31,31,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,32,32,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,33,33,'en',0,'http://google.com','View project','a:0:{}'),

('nd_portfolio',0,56,63,'en',0,'internal:/','Visit Project','a:0:{}');

/*Table structure for table `node_revision__field_second_title` */

DROP TABLE IF EXISTS `node_revision__field_second_title`;

CREATE TABLE `node_revision__field_second_title` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_second_title_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_second_title.';

/*Data for the table `node_revision__field_second_title` */

insert  into `node_revision__field_second_title`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_second_title_value`) values 

('nd_blog',0,2,2,'en',0,'Here is the big headline for your blog post'),

('nd_blog',0,3,3,'en',0,'Here is the big headline for your blog post'),

('nd_blog',0,4,4,'en',0,'Here is the big headline for your blog post'),

('nd_blog',0,5,5,'en',0,'Here is the big headline for your blog post'),

('nd_blog',0,6,6,'en',0,'Here is the big headline for your blog post');

/*Table structure for table `node_revision__field_social_links` */

DROP TABLE IF EXISTS `node_revision__field_social_links`;

CREATE TABLE `node_revision__field_social_links` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_social_links_uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `field_social_links_title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `field_social_links_options` longblob COMMENT 'Serialized array of options for the link.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_social_links_uri` (`field_social_links_uri`(30))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_social_links.';

/*Data for the table `node_revision__field_social_links` */

insert  into `node_revision__field_social_links`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_social_links_uri`,`field_social_links_title`,`field_social_links_options`) values 

('nd_person',0,57,64,'en',0,'http://facebook.com/nikadevs','fa fa-facebook','a:0:{}'),

('nd_person',0,57,64,'en',1,'http://twitter.com/nikadevs','fa fa-twitter','a:0:{}'),

('nd_person',0,57,64,'en',2,'http://themeforest.com','fa fa-pinterest','a:0:{}'),

('nd_person',0,58,65,'en',0,'http://facebook.com/nikadevs','fa fa-facebook','a:0:{}'),

('nd_person',0,58,65,'en',1,'http://twitter.com/nikadevs','fa fa-twitter','a:0:{}'),

('nd_person',0,59,66,'en',0,'http://twitter.com/nikadevs','fa fa-twitter','a:0:{}'),

('nd_person',0,59,66,'en',1,'http://facebook.com/nikadevs','fa fa-facebook','a:0:{}'),

('nd_person',0,60,67,'en',0,'http://facebook.com/nikadevs','fa fa-facebook','a:0:{}'),

('nd_person',0,60,67,'en',1,'http://twitter.com/nikadevs','fa fa-twitter','a:0:{}');

/*Table structure for table `node_revision__field_tags` */

DROP TABLE IF EXISTS `node_revision__field_tags`;

CREATE TABLE `node_revision__field_tags` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_tags_target_id` (`field_tags_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_tags.';

/*Data for the table `node_revision__field_tags` */

insert  into `node_revision__field_tags`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`field_tags_target_id`) values 

('nd_blog',0,3,3,'en',0,10),

('nd_blog',0,3,3,'en',1,12),

('nd_blog',0,3,3,'en',2,15),

('nd_blog',0,4,4,'en',0,10),

('nd_blog',0,5,5,'en',0,12),

('nd_blog',0,6,6,'en',0,12);

/*Table structure for table `node_revision__webform` */

DROP TABLE IF EXISTS `node_revision__webform`;

CREATE TABLE `node_revision__webform` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `webform_target_id` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the webform entity.',
  `webform_default_data` text COMMENT 'Default submission data.',
  `webform_status` varchar(20) DEFAULT NULL COMMENT 'Flag to control whether this webform should be open, closed, or scheduled for new submissions.',
  `webform_open` varchar(20) DEFAULT NULL COMMENT 'The open date/time.',
  `webform_close` varchar(20) DEFAULT NULL COMMENT 'The close date/time.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `webform_target_id` (`webform_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field webform.';

/*Data for the table `node_revision__webform` */

insert  into `node_revision__webform`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`webform_target_id`,`webform_default_data`,`webform_status`,`webform_open`,`webform_close`) values 

('webform',0,73,80,'en',0,'contact_1','','open',NULL,NULL),

('webform',0,98,105,'en',0,'subscribe','','open',NULL,NULL);

/*Table structure for table `old_57c6cfmenu_link_content` */

DROP TABLE IF EXISTS `old_57c6cfmenu_link_content`;

CREATE TABLE `old_57c6cfmenu_link_content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `bundle` varchar(32) CHARACTER SET ascii NOT NULL,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `menu_link_content_field__uuid__value` (`uuid`)
) ENGINE=InnoDB AUTO_INCREMENT=150 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for menu_link_content entities.';

/*Data for the table `old_57c6cfmenu_link_content` */

insert  into `old_57c6cfmenu_link_content`(`id`,`bundle`,`uuid`,`langcode`) values 

(1,'menu_link_content','89fbca33-fb65-4e6c-91ba-9a25d68514bc','en'),

(2,'menu_link_content','5cdb5b2b-389c-47b0-8140-19bcaee5eb6b','en'),

(3,'menu_link_content','29958b9c-166f-47a0-ad23-1a1934a31d4c','en'),

(4,'menu_link_content','ac9a45ab-a3e4-4771-9d12-016c19b8cd87','en'),

(5,'menu_link_content','92dae41b-bd24-4890-b442-1c209567d7ff','en'),

(6,'menu_link_content','961ccfdb-fc32-416f-b479-33645b457808','en'),

(7,'menu_link_content','a3ee399f-9674-40b8-a77b-af91a5415b33','en'),

(8,'menu_link_content','ffbafeb5-13ce-4a9e-aebb-517a82b75abf','en'),

(9,'menu_link_content','be27f22d-c5ff-4994-92d5-a3185bc2c43e','en'),

(10,'menu_link_content','bf32227d-9747-40a2-92f2-76f9a59cac2d','en'),

(11,'menu_link_content','fdde11a8-2a92-4936-91e9-4b802ab31b5b','en'),

(12,'menu_link_content','0c8d517f-c88c-429b-808c-99be0d64142c','en'),

(13,'menu_link_content','37367b13-a605-42e8-9472-0e5788a65542','en'),

(14,'menu_link_content','46d6164c-bf4c-4e3b-8a63-f3a0bb29becb','en'),

(15,'menu_link_content','59c760df-faa4-4c04-a71d-6ebed8addc3b','en'),

(16,'menu_link_content','9300ca4c-bce1-4990-8f18-f2e888c2fb04','en'),

(17,'menu_link_content','36321b57-7fe6-4eac-a535-bfdbfb32f86f','en'),

(18,'menu_link_content','1d8b7d03-1fbd-47d7-ac61-14b66ae230cc','en'),

(19,'menu_link_content','40656ee6-77d0-4bdc-8d5b-89bfb1846fd7','en'),

(20,'menu_link_content','bbdf5868-dc3c-4d40-bf02-ed5a98de6baa','en'),

(22,'menu_link_content','2dd67deb-b273-48e1-897e-3c0bcbcf5718','en'),

(23,'menu_link_content','32567f5e-6902-41e1-87a2-140840992d0f','en'),

(24,'menu_link_content','c065ff63-c661-41e5-afdc-f27d0815c3b0','en'),

(26,'menu_link_content','60c6e846-93d3-4d9f-89f5-98a254894a66','en'),

(27,'menu_link_content','7a4cb156-8ec2-434f-8f59-7bad246535dc','en'),

(28,'menu_link_content','743658b6-30d0-4736-aa24-bbe727e981f8','en'),

(29,'menu_link_content','bf270903-a251-43ce-b89c-526df226d233','en'),

(30,'menu_link_content','bde03df4-5838-4fea-bb45-0a5ba212e6e7','en'),

(31,'menu_link_content','fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb','en'),

(32,'menu_link_content','c9aa1e7a-a176-4c07-9695-f9094a6f3962','en'),

(33,'menu_link_content','bf873034-5b24-4c7d-b866-99804a20c5f6','en'),

(34,'menu_link_content','8a7af66c-92d3-49a8-943a-27fecb926b5a','en'),

(35,'menu_link_content','4f236593-06cc-4d7d-87aa-b5a394eaa67f','en'),

(36,'menu_link_content','09d313ce-a46e-4904-9fc9-2c3fd86f49d8','en'),

(37,'menu_link_content','ff7b7d33-e0fa-4e19-8826-2cefa9c972b2','en'),

(38,'menu_link_content','314f69c9-6761-46c8-8f7f-eba5ba26b421','en'),

(39,'menu_link_content','7a67997c-7b80-46b1-820b-a1b9c57535e5','en'),

(40,'menu_link_content','4adcc82e-4225-4b54-ae75-1874f637e3d6','en'),

(41,'menu_link_content','733a539d-3c2a-45fd-a73b-bb5063207240','en'),

(42,'menu_link_content','3d302ce2-fcbc-427c-b63e-7dd13fd3d705','en'),

(43,'menu_link_content','367c68ba-1ef2-4e41-bf74-7688e5904093','en'),

(44,'menu_link_content','e91489b9-2232-4827-8e2e-2668769f7665','en'),

(45,'menu_link_content','71554a3f-b4c2-4cf1-acd0-f3e91727b086','en'),

(46,'menu_link_content','34c07aab-b309-4699-b861-a6c292e165d2','en'),

(47,'menu_link_content','c1470211-9873-446f-9797-6089dffdee4f','en'),

(48,'menu_link_content','c73021cd-900f-469b-9491-07e016d521aa','en'),

(49,'menu_link_content','86580bef-aa20-4a1b-a234-30eeb1f64b8d','en'),

(50,'menu_link_content','b329caef-882c-4fb4-88d6-5c0e956c3230','en'),

(51,'menu_link_content','6d235af9-aa59-4a1f-86f4-f7cf95990571','en'),

(52,'menu_link_content','7ac5c97e-66e5-44ba-9701-3a4250b7b1d9','en'),

(62,'menu_link_content','16141053-6ad4-4886-8a35-c406aac8e9e4','en'),

(63,'menu_link_content','776125fa-b4d7-4344-bf41-1ea5892e91ef','en'),

(64,'menu_link_content','d2a5e366-81b2-4334-84c8-31557554f0e1','en'),

(65,'menu_link_content','f24ed196-0a8b-471e-95d8-177e20a9e9ba','en'),

(66,'menu_link_content','a669b9ca-166c-45ba-8e77-1faad3feb3eb','en'),

(67,'menu_link_content','d9f4d184-1bcf-483a-ac64-9a287afa146b','en'),

(68,'menu_link_content','861d0785-e6ed-4109-969a-c8aa12644e81','en'),

(69,'menu_link_content','c4129e2d-44f0-4687-a510-ad45c568bce1','en'),

(70,'menu_link_content','d4d5b6bd-9b29-4eb5-9acf-f87af995214c','en'),

(71,'menu_link_content','691ba057-a9fe-4a02-9bc4-105aa7e3d5f4','en'),

(73,'menu_link_content','fe3cc388-c8c1-4e13-91e2-c6d26d4f10e3','en'),

(74,'menu_link_content','9483d07a-5aa5-41a3-8ad6-456f80f78ac3','en'),

(75,'menu_link_content','506ee439-af38-47ef-a5e4-59c275e58937','en'),

(76,'menu_link_content','ce38002a-7dec-4a04-89f3-91f46b47858a','en'),

(77,'menu_link_content','48eb8cfb-67f8-44a4-b680-a154f132796c','en'),

(78,'menu_link_content','d0a9cd75-588f-4e44-98a6-d3b4bfbd80b2','en'),

(79,'menu_link_content','c74a5095-9a45-49ae-8da3-0be2e4717b32','en'),

(80,'menu_link_content','4dc6c8de-d27e-484f-8968-01b208414702','en'),

(81,'menu_link_content','ba223303-602f-4245-9b65-1c11d81c46f2','en'),

(84,'menu_link_content','eb3345f8-d32e-449f-a28d-3384b6b4ac96','en'),

(85,'menu_link_content','6b2a820d-9368-4a7f-8b42-465f88d3e1bb','en'),

(86,'menu_link_content','222834a3-6345-46a6-bebb-10e7a1a11a3b','en'),

(87,'menu_link_content','236c28f7-a0d8-437d-bcd1-8b5adb13c8d1','en'),

(88,'menu_link_content','6cd87830-2d5d-42e6-bd6c-85af56f90c99','en'),

(89,'menu_link_content','c287b16f-42a0-4a74-90ff-aacec6433bf0','en'),

(90,'menu_link_content','610c8dac-92d7-4a5b-89fb-f3214b8c8a09','en'),

(91,'menu_link_content','f63d2556-8199-4e69-9967-d99e0d4591b4','en'),

(93,'menu_link_content','491a5e02-691d-4f41-b6c2-e9513ae049ce','en'),

(94,'menu_link_content','ad36f87b-f542-454b-9685-2da56272071d','en'),

(95,'menu_link_content','58547176-ac14-452d-9bab-fe6204fcd2ea','en'),

(96,'menu_link_content','c5f9385e-3b46-4f25-b2a0-1b22b4df4c2d','en'),

(97,'menu_link_content','d03a8906-685a-4fa6-b4bb-e753de92fff6','en'),

(98,'menu_link_content','76e447c9-6d4f-4814-8a67-83d92a294ba4','en'),

(99,'menu_link_content','137a5d20-1c92-46b1-adc8-6986ef4ba061','en'),

(100,'menu_link_content','a8ebb28d-2a08-4f46-bc41-c7d2e380e341','en'),

(101,'menu_link_content','12b26d04-ea1a-467a-b0d3-72733ba93a88','en'),

(102,'menu_link_content','2999ccf3-e949-47dc-911a-51ce4f0b1f4b','en'),

(103,'menu_link_content','6df35863-66bf-4822-b031-aea60d06ef46','en'),

(104,'menu_link_content','92a230bd-a998-4bd2-b5ef-4266cb0e45a4','en'),

(105,'menu_link_content','cebaa43c-205f-4f89-b0fc-6ff322ecfd39','en'),

(106,'menu_link_content','3fa83a2b-7b51-4597-9cbe-70ba8d569b58','en'),

(107,'menu_link_content','7cd859fa-e56c-460a-b258-fbdb90e4d2b6','en'),

(108,'menu_link_content','d953421d-2381-48a2-8ec6-b3556e193d27','en'),

(109,'menu_link_content','e1b2f94e-df9b-4de0-994d-896fea2a566c','en'),

(110,'menu_link_content','76dce2dd-4bbe-48ce-be35-01e61c904ba0','en'),

(111,'menu_link_content','7c682988-9e8a-4380-aeba-a2bc289d04b1','en'),

(112,'menu_link_content','0de6635d-abe6-46ad-a198-30427b7ef1a5','en'),

(113,'menu_link_content','fd17614d-d7f1-4ba4-a132-ae8a0b4113b6','en'),

(114,'menu_link_content','e7e67b14-7d3a-48e2-aa6f-1efbd14a7cce','en'),

(115,'menu_link_content','6d3a98ea-8ac7-47f3-a41b-f95903b6b944','en'),

(116,'menu_link_content','bdf3d8d7-7e39-4761-9517-525862ece922','en'),

(117,'menu_link_content','f0751b8b-ca71-400c-8ed4-8f17ff2e9b04','en'),

(118,'menu_link_content','19579bde-904c-4869-bcc0-d577fca81c00','en'),

(119,'menu_link_content','0cb1c61d-8003-44c3-b0b3-436b7965c92d','en'),

(120,'menu_link_content','54d0a093-232c-4a42-807c-99e5f261c476','en'),

(121,'menu_link_content','d36bda57-2f21-43c6-acf0-1028c0dfc419','en'),

(122,'menu_link_content','4cc45e07-f95f-43c4-911b-d611e55bffed','en'),

(123,'menu_link_content','63af3b84-3b40-4e78-ae2a-6a82bed21ce0','en'),

(124,'menu_link_content','8de4bf5b-4d62-49dc-a8f3-17312f378b96','en'),

(125,'menu_link_content','e8b2b5e6-1fd0-4879-add1-d64f65071e52','en'),

(126,'menu_link_content','c2758267-44c1-47cc-ad2f-9ed26b5a7b66','en'),

(127,'menu_link_content','d70e25d4-48f8-4d30-ad1b-140b19b8d86d','en'),

(128,'menu_link_content','0c2acf13-be99-400e-a516-3eeb0250a939','en'),

(129,'menu_link_content','7f9d4c9f-e68c-45e9-bba3-b8a7606a6e44','en'),

(130,'menu_link_content','6079aec3-9b0f-44ac-b956-f456e93598ef','en'),

(131,'menu_link_content','5fe360b7-8317-4fb0-82c7-c96816ce453c','en'),

(132,'menu_link_content','27fbc9d4-80f5-4766-aa51-033eb100c01e','en'),

(133,'menu_link_content','75001a20-1143-4b16-a9a0-52cb6cdb7a37','en'),

(134,'menu_link_content','91cfd1c4-b40e-488c-9c60-8e7390a84b68','en'),

(135,'menu_link_content','0c806bda-6622-44ad-acd3-ea6039e259de','en'),

(136,'menu_link_content','63d22618-b4fe-4342-8655-821ad8640798','en'),

(137,'menu_link_content','cbd74fb9-4e21-48a4-8255-cf16a114b84b','en'),

(138,'menu_link_content','4326f5db-5e0d-44dc-9a52-5dc744ef772d','en'),

(139,'menu_link_content','dd84e93e-078f-45c7-a7e6-a0797fc4cb89','en'),

(140,'menu_link_content','63c6495e-8c2e-45f4-b372-b542fc123fdb','en'),

(141,'menu_link_content','018d37e6-b392-4228-8943-7c3f433d837d','en'),

(142,'menu_link_content','a046d288-c42b-45a6-b22d-c4e7e341e473','en'),

(143,'menu_link_content','8795dfe3-3f26-42dc-b987-3e9353df3831','en'),

(144,'menu_link_content','f9df1e47-273b-4684-81e4-da37304c140d','en'),

(145,'menu_link_content','65a0627d-7961-40e4-b2f1-93280c2f0a20','en'),

(146,'menu_link_content','192ee9a4-4616-4135-9de9-ad3f469f1c22','en'),

(147,'menu_link_content','34b6823d-aaf3-4b00-ab45-fdb544c8a354','en'),

(148,'menu_link_content','86a4b73a-822d-4a11-95f4-efdcb5e34973','en'),

(149,'menu_link_content','37310cde-bf20-4b44-bf35-ad1befa88b75','en');

/*Table structure for table `old_57c6cfmenu_link_content_data` */

DROP TABLE IF EXISTS `old_57c6cfmenu_link_content_data`;

CREATE TABLE `old_57c6cfmenu_link_content_data` (
  `id` int(10) unsigned NOT NULL,
  `bundle` varchar(32) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `menu_name` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `link__uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `link__title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `link__options` longblob COMMENT 'Serialized array of options for the link.',
  `external` tinyint(4) DEFAULT NULL,
  `rediscover` tinyint(4) DEFAULT NULL,
  `weight` int(11) DEFAULT NULL,
  `expanded` tinyint(4) DEFAULT NULL,
  `enabled` tinyint(4) NOT NULL,
  `parent` varchar(255) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`,`langcode`),
  KEY `menu_link_content_field__link__uri` (`link__uri`(30)),
  KEY `menu_link_content__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `menu_link_content__enabled_bundle` (`enabled`,`bundle`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for menu_link_content entities.';

/*Data for the table `old_57c6cfmenu_link_content_data` */

insert  into `old_57c6cfmenu_link_content_data`(`id`,`bundle`,`langcode`,`title`,`description`,`menu_name`,`link__uri`,`link__title`,`link__options`,`external`,`rediscover`,`weight`,`expanded`,`enabled`,`parent`,`changed`,`default_langcode`) values 

(1,'menu_link_content','en','Blog',NULL,'main','internal:/blog-fullwidth','','a:0:{}',0,1,-46,1,1,NULL,1485799719,1),

(2,'menu_link_content','en','Classic',NULL,'main','internal:/blog-fullwidth','','a:0:{}',0,1,-50,1,1,'menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc',1480936876,1),

(3,'menu_link_content','en','Blog Grid',NULL,'main','internal:/blog-2-columns','','a:0:{}',0,1,-48,1,1,'menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc',1480938015,1),

(4,'menu_link_content','en','Blog Masonry',NULL,'main','internal:/blog-masonry-2-columns','','a:0:{}',0,1,-47,1,1,'menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc',1480938015,1),

(5,'menu_link_content','en','Single ',NULL,'main','internal:/node/6','','a:0:{}',0,1,-46,1,1,'menu_link_content:89fbca33-fb65-4e6c-91ba-9a25d68514bc',1480938015,1),

(6,'menu_link_content','en','FullWidth',NULL,'main','internal:/node/6','','a:0:{}',0,1,-50,0,1,'menu_link_content:92dae41b-bd24-4890-b442-1c209567d7ff',1480938015,1),

(7,'menu_link_content','en','Accordions',NULL,'main','entity:node/34',NULL,'a:0:{}',0,0,-50,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1480938086,1),

(8,'menu_link_content','en','Bar (Progress)',NULL,'main','entity:node/35',NULL,'a:0:{}',0,0,-49,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1480938086,1),

(9,'menu_link_content','en','Buttons',NULL,'main','entity:node/36',NULL,'a:0:{}',0,0,-48,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1480938086,1),

(10,'menu_link_content','en','Features Box',NULL,'main','entity:node/37',NULL,'a:0:{}',0,0,-47,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1481653776,1),

(11,'menu_link_content','en','Grid',NULL,'main','entity:node/38',NULL,'a:0:{}',0,0,-46,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1481653776,1),

(12,'menu_link_content','en','Icons Et-Line',NULL,'main','entity:node/39',NULL,'a:0:{}',0,0,-45,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(13,'menu_link_content','en','Icons Font Awesome',NULL,'main','entity:node/40',NULL,'a:0:{}',0,0,-44,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(14,'menu_link_content','en','Messages',NULL,'main','entity:node/41',NULL,'a:0:{}',0,0,-43,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(15,'menu_link_content','en','Page Titles',NULL,'main','entity:node/42',NULL,'a:0:{}',0,0,-42,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(16,'menu_link_content','en','Sliders',NULL,'main','entity:node/43',NULL,'a:0:{}',0,0,-41,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(17,'menu_link_content','en','Tabs',NULL,'main','entity:node/44',NULL,'a:0:{}',0,0,-40,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(18,'menu_link_content','en','Typography',NULL,'main','entity:node/45',NULL,'a:0:{}',0,0,-39,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(19,'menu_link_content','en','Video & Sound',NULL,'main','entity:node/46',NULL,'a:0:{}',0,0,-38,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(20,'menu_link_content','en','Header Dark',NULL,'main','entity:node/47',NULL,'a:0:{}',0,0,-35,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(22,'menu_link_content','en','Header Dark Transparent',NULL,'main','entity:node/48',NULL,'a:0:{}',0,0,-37,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(23,'menu_link_content','en','Pricing 1',NULL,'main','entity:node/49',NULL,'a:0:{}',0,0,15,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(24,'menu_link_content','en','Pricing 2',NULL,'main','entity:node/50',NULL,'a:0:{}',0,0,16,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(26,'menu_link_content','en','Elements',NULL,'main','internal:/node/34','','a:0:{}',0,1,-48,1,1,NULL,1485799719,1),

(27,'menu_link_content','en','Portfolio',NULL,'main','internal:/portfolio-boxed','','a:0:{}',0,1,-47,1,1,NULL,1485799719,1),

(28,'menu_link_content','en','Pages',NULL,'main','internal:/node/49','','a:0:{}',0,1,-49,1,1,NULL,1480938170,1),

(29,'menu_link_content','en','Header White',NULL,'main','entity:node/54',NULL,'a:0:{}',0,0,-34,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(30,'menu_link_content','en','Header White Transparent',NULL,'main','entity:node/55',NULL,'a:0:{}',0,0,-36,0,1,'menu_link_content:60c6e846-93d3-4d9f-89f5-98a254894a66',1485799253,1),

(31,'menu_link_content','en','Boxed',NULL,'main','internal:/portfolio-boxed','','a:0:{}',0,1,-73,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1),

(32,'menu_link_content','en','Boxed (Gutter)',NULL,'main','internal:/portfolio-boxed-gutter-2-columns','','a:0:{}',0,1,-72,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1),

(33,'menu_link_content','en','Boxed (Titles)',NULL,'main','internal:/portfolio-boxed-title-2-columns','','a:0:{}',0,1,-71,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1),

(34,'menu_link_content','en','Wide',NULL,'main','internal:/portfolio-boxed-wide-2-columns','','a:0:{}',0,1,-70,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1),

(35,'menu_link_content','en','Wide (Gutter)',NULL,'main','internal:/portfolio-gutter-wide-2-columns','','a:0:{}',0,1,-69,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1),

(36,'menu_link_content','en','Wide (Titles)',NULL,'main','internal:/portfolio-title-wide-2-columns','','a:0:{}',0,1,-68,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481048566,1),

(37,'menu_link_content','en','Masonry',NULL,'main','internal:/portfolio-masonry-2-columns','','a:0:{}',0,1,0,1,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481049885,1),

(38,'menu_link_content','en','Single Project',NULL,'main','entity:node/16',NULL,'a:0:{}',0,0,0,0,1,'menu_link_content:7a4cb156-8ec2-434f-8f59-7bad246535dc',1481152669,1),

(39,'menu_link_content','en','Team 1',NULL,'main','entity:node/61',NULL,'a:0:{}',0,0,11,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(40,'menu_link_content','en','Team 2',NULL,'main','entity:node/62',NULL,'a:0:{}',0,0,12,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(41,'menu_link_content','en','About Us 1',NULL,'main','entity:node/63',NULL,'a:0:{}',0,0,3,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(42,'menu_link_content','en','About Us 2',NULL,'main','entity:node/64',NULL,'a:0:{}',0,0,4,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(43,'menu_link_content','en','About Us 3',NULL,'main','entity:node/65',NULL,'a:0:{}',0,0,5,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(44,'menu_link_content','en','Services 1',NULL,'main','entity:node/66',NULL,'a:0:{}',0,0,6,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(45,'menu_link_content','en','Services 2',NULL,'main','entity:node/67',NULL,'a:0:{}',0,0,7,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(46,'menu_link_content','en','Services 3',NULL,'main','entity:node/68',NULL,'a:0:{}',0,0,8,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(47,'menu_link_content','en','Clients',NULL,'main','entity:node/69',NULL,'a:0:{}',0,0,9,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(48,'menu_link_content','en','Landing Page',NULL,'main','entity:node/70',NULL,'a:0:{}',0,0,10,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(49,'menu_link_content','en','FAQ 1',NULL,'main','entity:node/71',NULL,'a:0:{}',0,0,13,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(50,'menu_link_content','en','FAQ 2',NULL,'main','entity:node/72',NULL,'a:0:{}',0,0,14,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(51,'menu_link_content','en','Contact 1',NULL,'main','entity:node/74',NULL,'a:0:{}',0,0,17,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(52,'menu_link_content','en','Contact 2',NULL,'main','entity:node/75',NULL,'a:0:{}',0,0,18,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(62,'menu_link_content','en','Page not found',NULL,'main','entity:node/95',NULL,'a:0:{}',0,0,26,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(63,'menu_link_content','en','Maintenance Page',NULL,'main','entity:node/96',NULL,'a:0:{}',0,0,25,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(64,'menu_link_content','en','Login / Register',NULL,'main','internal:/user/login','','a:0:{}',0,1,24,0,1,'menu_link_content:743658b6-30d0-4736-aa24-bbe727e981f8',1485799253,1),

(65,'menu_link_content','en','Main Demo',NULL,'main','entity:node/97',NULL,'a:0:{}',0,0,26,0,1,'standard.front_page',1485799088,1),

(66,'menu_link_content','en','Image Parallax 1',NULL,'main','internal:/home/1','','a:0:{}',0,1,27,0,1,'standard.front_page',1485799088,1),

(67,'menu_link_content','en','Image Parallax 2',NULL,'main','internal:/home/2','','a:0:{}',0,1,28,0,1,'standard.front_page',1485799088,1),

(68,'menu_link_content','en','Image Parallax 3',NULL,'main','internal:/home/3','','a:0:{}',0,1,29,0,1,'standard.front_page',1485799088,1),

(69,'menu_link_content','en','Image Parallax 4',NULL,'main','internal:/home/4','','a:0:{}',0,1,30,0,1,'standard.front_page',1485799088,1),

(70,'menu_link_content','en','Image Parallax 5',NULL,'main','internal:/home/5','','a:0:{}',0,1,31,0,1,'standard.front_page',1485799088,1),

(71,'menu_link_content','en','FullWidth Image',NULL,'main','internal:/home/6','','a:0:{}',0,1,32,0,1,'standard.front_page',1485799088,1),

(73,'menu_link_content','en','Text Rotator',NULL,'main','internal:/home/7','','a:0:{}',0,1,33,0,1,'standard.front_page',1485799088,1),

(74,'menu_link_content','en','Slider FullScreen',NULL,'main','internal:/home/8','','a:0:{}',0,1,34,0,1,'standard.front_page',1485799088,1),

(75,'menu_link_content','en','Slider Zoom Effect',NULL,'main','internal:/home/9','','a:0:{}',0,1,35,0,1,'standard.front_page',1485799088,1),

(76,'menu_link_content','en','Slider FullWidth',NULL,'main','internal:/home/10','','a:0:{}',0,1,36,0,1,'standard.front_page',1485799088,1),

(77,'menu_link_content','en','Slider Background',NULL,'main','internal:/home/11','','a:0:{}',0,1,37,0,1,'standard.front_page',1485799088,1),

(78,'menu_link_content','en','With Play Button',NULL,'main','internal:/home/12','','a:0:{}',0,1,38,0,1,'standard.front_page',1485799088,1),

(79,'menu_link_content','en','BG Video FullWidth',NULL,'main','internal:/home/13','','a:0:{}',0,1,39,0,1,'standard.front_page',1485799088,1),

(80,'menu_link_content','en','BG Video FullScreen 1',NULL,'main','internal:/home/14','','a:0:{}',0,1,40,0,1,'standard.front_page',1485799088,1),

(81,'menu_link_content','en','BG Video FullScreen 2',NULL,'main','internal:/home/15','','a:0:{}',0,1,41,0,1,'standard.front_page',1485799088,1),

(84,'menu_link_content','en','Agency Header',NULL,'main','internal:/home/16','','a:0:{}',0,1,42,0,1,'standard.front_page',1485799088,1),

(85,'menu_link_content','en','Photography with fullscreen menu',NULL,'main','entity:node/101',NULL,'a:0:{}',0,0,43,0,1,'standard.front_page',1485799088,1),

(86,'menu_link_content','en','Home',NULL,'one-page','internal:#home','','a:0:{}',0,1,-50,0,1,NULL,1484927826,1),

(87,'menu_link_content','en','About',NULL,'one-page','internal:#about','','a:0:{}',0,1,-49,0,1,NULL,1484927826,1),

(88,'menu_link_content','en','Services',NULL,'one-page','internal:#services','','a:0:{}',0,1,-48,0,1,NULL,1484927826,1),

(89,'menu_link_content','en','Portfolio',NULL,'one-page','internal:#portfolio','','a:0:{}',0,1,-47,0,1,NULL,1484927826,1),

(90,'menu_link_content','en','News',NULL,'one-page','internal:#news','','a:0:{}',0,1,-46,0,1,NULL,1484927826,1),

(91,'menu_link_content','en','Contacts',NULL,'one-page','internal:#contacts','','a:0:{}',0,1,-45,0,1,NULL,1484927826,1),

(93,'menu_link_content','en','All Demos',NULL,'one-page','internal:/','','a:0:{}',0,1,-44,0,1,NULL,1484927826,1),

(94,'menu_link_content','en','Main Demo',NULL,'main','internal:/onepage/0','','a:0:{}',0,1,44,0,1,'standard.front_page',1485799088,1),

(95,'menu_link_content','en','Image Parallax 1',NULL,'main','internal:/onepage/1','','a:0:{}',0,1,45,0,1,'standard.front_page',1485799088,1),

(96,'menu_link_content','en','Image Parallax 2',NULL,'main','internal:/onepage/2','','a:0:{}',0,1,46,0,1,'standard.front_page',1485799088,1),

(97,'menu_link_content','en','Image Parallax 3',NULL,'main','internal:/onepage/3','','a:0:{}',0,1,47,0,1,'standard.front_page',1485799088,1),

(98,'menu_link_content','en','Image Parallax 4',NULL,'main','internal:/onepage/4','','a:0:{}',0,1,48,0,1,'standard.front_page',1485799088,1),

(99,'menu_link_content','en','Image Parallax 5',NULL,'main','internal:/onepage/5','','a:0:{}',0,1,49,0,1,'standard.front_page',1485799088,1),

(100,'menu_link_content','en','FullWidth Image',NULL,'main','internal:/onepage/6','','a:0:{}',0,1,50,0,1,'standard.front_page',1485799088,1),

(101,'menu_link_content','en','Text Rotator',NULL,'main','internal:/onepage/7','','a:0:{}',0,1,51,0,1,'standard.front_page',1485799088,1),

(102,'menu_link_content','en','Slider FullScreen',NULL,'main','internal:/onepage/8','','a:0:{}',0,1,52,0,1,'standard.front_page',1485799088,1),

(103,'menu_link_content','en','Slider Zoom Effect',NULL,'main','internal:/onepage/9','','a:0:{}',0,1,53,0,1,'standard.front_page',1485799088,1),

(104,'menu_link_content','en','Slider FullWidth',NULL,'main','internal:/onepage/10','','a:0:{}',0,1,54,0,1,'standard.front_page',1485799088,1),

(105,'menu_link_content','en','Slider Background',NULL,'main','internal:/onepage/11','','a:0:{}',0,1,55,0,1,'standard.front_page',1485799088,1),

(106,'menu_link_content','en','With Play Button',NULL,'main','internal:/onepage/12','','a:0:{}',0,1,56,0,1,'standard.front_page',1485799088,1),

(107,'menu_link_content','en','BG Video FullWidth',NULL,'main','internal:/onepage/13','','a:0:{}',0,1,57,0,1,'standard.front_page',1485799088,1),

(108,'menu_link_content','en','BG Video FullScreen 1',NULL,'main','internal:/onepage/14','','a:0:{}',0,1,58,0,1,'standard.front_page',1485799088,1),

(109,'menu_link_content','en','BG Video FullScreen 2',NULL,'main','internal:/onepage/15','','a:0:{}',0,1,59,0,1,'standard.front_page',1485799088,1),

(110,'menu_link_content','en','Agency Header',NULL,'main','internal:/onepage/16','','a:0:{}',0,1,60,0,1,'standard.front_page',1485799088,1),

(111,'menu_link_content','en','Photography with fullscreen menu',NULL,'main','internal:/onepage/17','','a:0:{}',0,1,61,0,1,'standard.front_page',1485799088,1),

(112,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-boxed','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553188,1),

(113,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-boxed-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553204,1),

(114,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-boxed-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553213,1),

(115,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-boxed-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553220,1),

(116,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-boxed-5-columns-black','','a:0:{}',0,1,0,0,1,'menu_link_content:fa7dbf3e-ac8d-42cf-a8b2-c722391ec9eb',1486553231,1),

(117,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-boxed-gutter-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553253,1),

(118,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-boxed-gutter-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553263,1),

(119,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-boxed-gutter-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553270,1),

(120,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-boxed-gutter-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553278,1),

(121,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-boxed-gutter-5-black-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:c9aa1e7a-a176-4c07-9695-f9094a6f3962',1486553300,1),

(122,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-boxed-title-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553317,1),

(123,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-boxed-title-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553326,1),

(124,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-boxed-title-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553336,1),

(125,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-boxed-title-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553344,1),

(126,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-boxed-title-5-columns-black','','a:0:{}',0,1,0,0,1,'menu_link_content:bf873034-5b24-4c7d-b866-99804a20c5f6',1486553357,1),

(127,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-boxed-wide-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553373,1),

(128,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-boxed-wide-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553381,1),

(129,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-boxed-wide-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553388,1),

(130,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-boxed-wide-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553396,1),

(131,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-boxed-wide-5-columns-dark','','a:0:{}',0,1,0,0,1,'menu_link_content:8a7af66c-92d3-49a8-943a-27fecb926b5a',1486553408,1),

(132,'menu_link_content','en','2 Columns',NULL,'main','internal:/rhythm/portfolio-gutter-wide-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553428,1),

(133,'menu_link_content','en','3 Columns',NULL,'main','internal:/rhythm/portfolio-gutter-wide-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553437,1),

(134,'menu_link_content','en','4 Columns',NULL,'main','internal:/rhythm/portfolio-gutter-wide-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553447,1),

(135,'menu_link_content','en','5 Columns',NULL,'main','internal:/rhythm/portfolio-gutter-wide-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553457,1),

(136,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-gutter-wide-5-columns-dark','','a:0:{}',0,1,0,0,1,'menu_link_content:4f236593-06cc-4d7d-87aa-b5a394eaa67f',1486553470,1),

(137,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-title-wide-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553501,1),

(138,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-title-wide-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553512,1),

(139,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-title-wide-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553519,1),

(140,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-title-wide-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553526,1),

(141,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-title-wide-5-columns-dark','','a:0:{}',0,1,0,0,1,'menu_link_content:09d313ce-a46e-4904-9fc9-2c3fd86f49d8',1486553537,1),

(142,'menu_link_content','en','2 Columns',NULL,'main','internal:/portfolio-masonry-2-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553552,1),

(143,'menu_link_content','en','3 Columns',NULL,'main','internal:/portfolio-masonry-3-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553560,1),

(144,'menu_link_content','en','4 Columns',NULL,'main','internal:/portfolio-masonry-4-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553570,1),

(145,'menu_link_content','en','5 Columns',NULL,'main','internal:/portfolio-masonry-5-columns','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553580,1),

(146,'menu_link_content','en','Black Hover',NULL,'main','internal:/portfolio-masonry-5-columns-dark','','a:0:{}',0,1,0,0,1,'menu_link_content:ff7b7d33-e0fa-4e19-8826-2cefa9c972b2',1486553592,1),

(147,'menu_link_content','en','Shop',NULL,'main','entity:node/107',NULL,'a:0:{}',0,0,-44,0,1,NULL,1503047489,1),

(148,'menu_link_content','en','Shopping Cart',NULL,'main','internal:/cart','','a:0:{}',0,1,5,0,1,'menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354',1503578059,1),

(149,'menu_link_content','en','Single Product',NULL,'main','internal:/product/4','','a:0:{}',0,1,4,0,1,'menu_link_content:34b6823d-aaf3-4b00-ab45-fdb544c8a354',1503578059,1);

/*Table structure for table `old_f979f4taxonomy_term__parent` */

DROP TABLE IF EXISTS `old_f979f4taxonomy_term__parent`;

CREATE TABLE `old_f979f4taxonomy_term__parent` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `parent_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `parent_target_id` (`parent_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for taxonomy_term field parent.';

/*Data for the table `old_f979f4taxonomy_term__parent` */

insert  into `old_f979f4taxonomy_term__parent`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`parent_target_id`) values 

('blog_category',0,1,1,'en',0,0),

('blog_category',0,2,2,'en',0,0),

('blog_category',0,3,3,'en',0,0),

('blog_category',0,4,4,'en',0,0),

('blog_category',0,5,5,'en',0,0),

('blog_category',0,6,6,'en',0,0),

('blog_category',0,7,7,'en',0,0),

('blog_category',0,8,8,'en',0,0),

('blog_category',0,9,9,'en',0,0),

('tags',0,10,10,'en',0,0),

('tags',0,11,11,'en',0,0),

('tags',0,12,12,'en',0,0),

('tags',0,13,13,'en',0,0),

('tags',0,14,14,'en',0,0),

('tags',0,15,15,'en',0,0),

('project',0,16,16,'en',0,0),

('project',0,17,17,'en',0,0),

('project',0,18,18,'en',0,0),

('project',0,19,19,'en',0,0),

('project',0,20,20,'en',0,0),

('project',0,21,21,'en',0,0),

('portfolio_category',0,22,22,'en',0,0),

('portfolio_category',0,23,23,'en',0,0),

('portfolio_category',0,24,24,'en',0,0),

('portfolio_category',0,25,25,'en',0,0),

('portfolio_category',0,26,26,'en',0,0),

('portfolio_category',0,27,27,'en',0,0),

('category',0,28,28,'en',0,0),

('category',0,29,29,'en',0,0),

('category',0,30,30,'en',0,0),

('category',0,31,31,'en',0,0),

('category',0,32,32,'en',0,0),

('gallery',0,33,33,'en',0,0),

('gallery',0,34,34,'en',0,0),

('gallery',0,35,35,'en',0,0),

('category',0,36,36,'en',0,0),

('tags',0,37,37,'en',0,0),

('tags',0,38,38,'en',0,0),

('tags',0,39,39,'en',0,0);

/*Table structure for table `old_f979f4taxonomy_term_data` */

DROP TABLE IF EXISTS `old_f979f4taxonomy_term_data`;

CREATE TABLE `old_f979f4taxonomy_term_data` (
  `tid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `vid` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`tid`),
  UNIQUE KEY `taxonomy_term_field__uuid__value` (`uuid`),
  KEY `taxonomy_term_field__vid__target_id` (`vid`)
) ENGINE=InnoDB AUTO_INCREMENT=40 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for taxonomy_term entities.';

/*Data for the table `old_f979f4taxonomy_term_data` */

insert  into `old_f979f4taxonomy_term_data`(`tid`,`vid`,`uuid`,`langcode`) values 

(1,'blog_category','1c9ee1c8-2d40-44db-8e28-2dc133a880ba','en'),

(2,'blog_category','59ea2970-18c9-4e9e-bf22-9a5333644bdd','en'),

(3,'blog_category','ac8b0829-cbd1-42b5-8bd9-84140c9826b5','en'),

(4,'blog_category','7d22a3ff-9bfc-486e-bae7-dea2c7a53305','en'),

(5,'blog_category','f8faee50-9bb7-4ae4-8901-34ca33a027f0','en'),

(6,'blog_category','9666ef8e-8235-446e-abc3-f051f7d9cccc','en'),

(7,'blog_category','07357e8a-c9a0-485a-8661-b9e99ed5a509','en'),

(8,'blog_category','78a25b13-722c-4974-a260-7e0c5ca11944','en'),

(9,'blog_category','989a8ad2-99de-40b3-928a-22474d2f4dd3','en'),

(10,'tags','4cbf4b4c-6554-4161-8b96-6e1d69112203','en'),

(11,'tags','386d7757-ad1c-41f3-a175-2ab3c6fe0634','en'),

(12,'tags','e2555647-4703-413d-9810-a33c9cc821a2','en'),

(13,'tags','b95ea51e-88cc-4286-8437-0997c0530fbc','en'),

(14,'tags','d04b4722-a006-4b6b-938f-fa916526a7b2','en'),

(15,'tags','19f096b7-aa03-4a63-ae95-4edd334e3b6a','en'),

(16,'project','b35478ef-de59-4811-88ce-cc6e21145a63','en'),

(17,'project','5482971c-b169-4587-9690-b1a0bf0e66bd','en'),

(18,'project','d0c9503c-ca1b-4386-bc83-d904d63c9058','en'),

(19,'project','16bfca8c-a21d-4306-98a1-63129443f678','en'),

(20,'project','9f1a8fb8-a519-4961-8c8c-ef3ee8cc8602','en'),

(21,'project','0b30adab-4e2b-45e0-99bc-d614cc6aa44f','en'),

(22,'portfolio_category','00d9cf99-374c-4318-8e51-50f419b7aa75','en'),

(23,'portfolio_category','719eebe6-bb82-4872-b674-636f6dbeeece','en'),

(24,'portfolio_category','5cb59063-f2bc-4940-b830-0b98a802faf8','en'),

(25,'portfolio_category','34f0b551-25e6-430f-8c05-3676757569eb','en'),

(26,'portfolio_category','dc08f4f7-f90b-4ac9-9270-ba60a927c897','en'),

(27,'portfolio_category','1d87cf60-deec-45ed-aaf8-e4bfa5338569','en'),

(28,'category','7b09da11-dad7-4754-ada1-5978b747d1ce','en'),

(29,'category','0e2447fb-30e7-4363-b081-4163a11b1e8e','en'),

(30,'category','9f5b1ef0-8f78-44db-9d37-e81c8534fad1','en'),

(31,'category','2ca5dde9-11c6-4624-a956-0904fa72d95b','en'),

(32,'category','fb3d7b5f-9ace-4c2f-bbf1-119449a58691','en'),

(33,'gallery','b23e0207-1eff-4a7f-bf90-937d5dbd6787','en'),

(34,'gallery','b2708a02-550b-40f8-a418-a3ed658d7c1a','en'),

(35,'gallery','fa02b512-9419-43d7-8389-b774271a3a7a','en'),

(36,'category','89b27a09-a947-4e3c-a3dd-750da151aef0','en'),

(37,'tags','db3e03dc-a063-45da-9c37-41b0575ada27','en'),

(38,'tags','7440647c-2bb4-47e3-b21a-580e7ad8a0bc','en'),

(39,'tags','294555b9-3cc5-4a85-b9f9-5be52efc76ff','en');

/*Table structure for table `old_f979f4taxonomy_term_field_data` */

DROP TABLE IF EXISTS `old_f979f4taxonomy_term_field_data`;

CREATE TABLE `old_f979f4taxonomy_term_field_data` (
  `tid` int(10) unsigned NOT NULL,
  `vid` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `name` varchar(255) NOT NULL,
  `description__value` longtext,
  `description__format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `weight` int(11) NOT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `status` tinyint(4) NOT NULL,
  PRIMARY KEY (`tid`,`langcode`),
  KEY `taxonomy_term_field__name` (`name`(191)),
  KEY `taxonomy_term__id__default_langcode__langcode` (`tid`,`default_langcode`,`langcode`),
  KEY `taxonomy_term__tree` (`vid`,`weight`,`name`(191)),
  KEY `taxonomy_term__vid_name` (`vid`,`name`(191)),
  KEY `taxonomy_term__status_vid` (`status`,`vid`,`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for taxonomy_term entities.';

/*Data for the table `old_f979f4taxonomy_term_field_data` */

insert  into `old_f979f4taxonomy_term_field_data`(`tid`,`vid`,`langcode`,`name`,`description__value`,`description__format`,`weight`,`changed`,`default_langcode`,`status`) values 

(1,'blog_category','en','Fashion',NULL,NULL,0,1479923373,1,1),

(2,'blog_category','en','Luxury',NULL,NULL,0,1479923378,1,1),

(3,'blog_category','en','Development',NULL,NULL,0,1479923381,1,1),

(4,'blog_category','en','Drupal',NULL,NULL,0,1479923383,1,1),

(5,'blog_category','en','Design',NULL,NULL,0,1479923386,1,1),

(6,'blog_category','en','Trends',NULL,NULL,0,1479923389,1,1),

(7,'blog_category','en','Theme',NULL,NULL,0,1479923394,1,1),

(8,'blog_category','en','Quality',NULL,NULL,0,1479923402,1,1),

(9,'blog_category','en','Purchase theme',NULL,NULL,0,1480029413,1,1),

(10,'tags','en','drupal',NULL,NULL,0,1479931011,1,1),

(11,'tags','en','Development',NULL,NULL,0,1479931019,1,1),

(12,'tags','en','javascript',NULL,NULL,0,1479931025,1,1),

(13,'tags','en','html',NULL,NULL,0,1479931027,1,1),

(14,'tags','en','seo',NULL,NULL,0,1479931029,1,1),

(15,'tags','en','nikadevs',NULL,NULL,0,1479931036,1,1),

(16,'project','en','Drupal 7',NULL,NULL,0,1480353694,1,1),

(17,'project','en','Drupal 8',NULL,NULL,0,1480353699,1,1),

(18,'project','en','Wordpress',NULL,NULL,0,1480353702,1,1),

(19,'project','en','Joomla',NULL,NULL,0,1480353704,1,1),

(20,'project','en','Template',NULL,NULL,0,1480353710,1,1),

(21,'project','en','CMS',NULL,NULL,0,1480353712,1,1),

(22,'portfolio_category','en','Design',NULL,NULL,0,1480353745,1,1),

(23,'portfolio_category','en','Images',NULL,NULL,0,1480353749,1,1),

(24,'portfolio_category','en','Video',NULL,NULL,0,1480353753,1,1),

(25,'portfolio_category','en','Trends',NULL,NULL,0,1480353758,1,1),

(26,'portfolio_category','en','3D Design',NULL,NULL,0,1480353766,1,1),

(27,'portfolio_category','en','Architecture',NULL,NULL,0,1480353774,1,1),

(28,'category','en','Branding',NULL,NULL,0,1480353801,1,1),

(29,'category','en','Design',NULL,NULL,0,1480353805,1,1),

(30,'category','en','Fashion',NULL,NULL,0,1480353808,1,1),

(31,'category','en','Polo Shirts',NULL,NULL,0,1480353813,1,1),

(32,'category','en','Sport Shirts',NULL,NULL,0,1480353819,1,1),

(33,'gallery','en','Gallery 1',NULL,NULL,0,1481650042,1,1),

(34,'gallery','en','Gallery 2',NULL,NULL,0,1481650047,1,1),

(35,'gallery','en','Gallery 3',NULL,NULL,0,1481650050,1,1),

(36,'category','en','Fashion wear',NULL,NULL,0,1503051091,1,1),

(37,'tags','en','Branding',NULL,NULL,0,1503051552,1,1),

(38,'tags','en','Clean',NULL,NULL,0,1503051567,1,1),

(39,'tags','en','Digital',NULL,NULL,0,1503053356,1,1);

/*Table structure for table `profile` */

DROP TABLE IF EXISTS `profile`;

CREATE TABLE `profile` (
  `profile_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `revision_id` int(10) unsigned DEFAULT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `status` tinyint(4) NOT NULL,
  `is_default` tinyint(4) DEFAULT NULL,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `data` longblob,
  PRIMARY KEY (`profile_id`),
  UNIQUE KEY `profile_field__uuid__value` (`uuid`),
  UNIQUE KEY `profile__revision_id` (`revision_id`),
  KEY `profile_field__type__target_id` (`type`),
  KEY `profile_field__uid__target_id` (`uid`),
  KEY `profile__status_type` (`status`,`type`,`profile_id`),
  KEY `profile__uid_type_status_is_default` (`uid`,`type`,`status`,`is_default`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for profile entities.';

/*Data for the table `profile` */

insert  into `profile`(`profile_id`,`revision_id`,`type`,`uuid`,`uid`,`status`,`is_default`,`created`,`changed`,`data`) values 

(1,1,'customer','11a86cbe-9951-473f-b232-22d43d115998',0,1,1,1503490068,1503490068,NULL),

(2,2,'customer','4e62698d-c6e7-477c-b2e6-205bbc61e815',0,1,1,1511523385,1511523385,NULL);

/*Table structure for table `profile__address` */

DROP TABLE IF EXISTS `profile__address`;

CREATE TABLE `profile__address` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `address_langcode` varchar(32) DEFAULT NULL,
  `address_country_code` varchar(2) DEFAULT NULL,
  `address_administrative_area` varchar(255) DEFAULT NULL,
  `address_locality` varchar(255) DEFAULT NULL,
  `address_dependent_locality` varchar(255) DEFAULT NULL,
  `address_postal_code` varchar(255) DEFAULT NULL,
  `address_sorting_code` varchar(255) DEFAULT NULL,
  `address_address_line1` varchar(255) DEFAULT NULL,
  `address_address_line2` varchar(255) DEFAULT NULL,
  `address_organization` varchar(255) DEFAULT NULL,
  `address_given_name` varchar(255) DEFAULT NULL,
  `address_additional_name` varchar(255) DEFAULT NULL,
  `address_family_name` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for profile field address.';

/*Data for the table `profile__address` */

insert  into `profile__address`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`address_langcode`,`address_country_code`,`address_administrative_area`,`address_locality`,`address_dependent_locality`,`address_postal_code`,`address_sorting_code`,`address_address_line1`,`address_address_line2`,`address_organization`,`address_given_name`,`address_additional_name`,`address_family_name`) values 

('customer',0,1,1,'und',0,'en','US','CA','Los Angeles',NULL,'90210',NULL,'Sunset','','Dev','Andrew',NULL,'Freeman'),

('customer',0,2,2,'und',0,'en','CA','AB','hdfgh',NULL,'T1A7L4',NULL,'dfghd','fghdffg','dfgh','fgh',NULL,'dfgh');

/*Table structure for table `profile_revision` */

DROP TABLE IF EXISTS `profile_revision`;

CREATE TABLE `profile_revision` (
  `profile_id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `status` tinyint(4) NOT NULL,
  `is_default` tinyint(4) DEFAULT NULL,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `revision_default` tinyint(4) DEFAULT NULL,
  `data` longblob,
  `revision_created` int(11) DEFAULT NULL,
  `revision_user` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `revision_log_message` longtext,
  PRIMARY KEY (`revision_id`),
  KEY `profile_field__uid__target_id` (`uid`),
  KEY `profile__profile_id` (`profile_id`),
  KEY `profile_field__revision_user__target_id` (`revision_user`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='The revision table for profile entities.';

/*Data for the table `profile_revision` */

insert  into `profile_revision`(`profile_id`,`revision_id`,`uid`,`status`,`is_default`,`created`,`changed`,`revision_default`,`data`,`revision_created`,`revision_user`,`revision_log_message`) values 

(1,1,0,1,1,1503490068,1503490068,1,NULL,1503490068,1,NULL),

(2,2,0,1,1,1511523385,1511523385,1,NULL,1511523385,0,NULL);

/*Table structure for table `profile_revision__address` */

DROP TABLE IF EXISTS `profile_revision__address`;

CREATE TABLE `profile_revision__address` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `address_langcode` varchar(32) DEFAULT NULL,
  `address_country_code` varchar(2) DEFAULT NULL,
  `address_administrative_area` varchar(255) DEFAULT NULL,
  `address_locality` varchar(255) DEFAULT NULL,
  `address_dependent_locality` varchar(255) DEFAULT NULL,
  `address_postal_code` varchar(255) DEFAULT NULL,
  `address_sorting_code` varchar(255) DEFAULT NULL,
  `address_address_line1` varchar(255) DEFAULT NULL,
  `address_address_line2` varchar(255) DEFAULT NULL,
  `address_organization` varchar(255) DEFAULT NULL,
  `address_given_name` varchar(255) DEFAULT NULL,
  `address_additional_name` varchar(255) DEFAULT NULL,
  `address_family_name` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for profile field address.';

/*Data for the table `profile_revision__address` */

insert  into `profile_revision__address`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`address_langcode`,`address_country_code`,`address_administrative_area`,`address_locality`,`address_dependent_locality`,`address_postal_code`,`address_sorting_code`,`address_address_line1`,`address_address_line2`,`address_organization`,`address_given_name`,`address_additional_name`,`address_family_name`) values 

('customer',0,1,1,'und',0,'en','US','CA','Los Angeles',NULL,'90210',NULL,'Sunset','','Dev','Andrew',NULL,'Freeman'),

('customer',0,2,2,'und',0,'en','CA','AB','hdfgh',NULL,'T1A7L4',NULL,'dfghd','fghdffg','dfgh','fgh',NULL,'dfgh');

/*Table structure for table `queue` */

DROP TABLE IF EXISTS `queue`;

CREATE TABLE `queue` (
  `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique item ID.',
  `name` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The queue name.',
  `data` longblob COMMENT 'The arbitrary data for the item.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the claim lease expires on the item.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the item was created.',
  PRIMARY KEY (`item_id`),
  KEY `name_created` (`name`,`created`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB AUTO_INCREMENT=35 DEFAULT CHARSET=utf8mb4 COMMENT='Stores items in queues.';

/*Data for the table `queue` */

/*Table structure for table `router` */

DROP TABLE IF EXISTS `router`;

CREATE TABLE `router` (
  `name` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Primary Key: Machine name of this route',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'The path for this URI',
  `pattern_outline` varchar(255) NOT NULL DEFAULT '' COMMENT 'The pattern',
  `fit` int(11) NOT NULL DEFAULT '0' COMMENT 'A numeric representation of how specific the path is.',
  `route` longblob COMMENT 'A serialized Route object',
  `number_parts` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Number of parts in this router path.',
  PRIMARY KEY (`name`),
  KEY `pattern_outline_parts` (`pattern_outline`(191),`number_parts`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Maps paths to various callbacks (access, page and title)';

/*Data for the table `router` */

insert  into `router`(`name`,`path`,`pattern_outline`,`fit`,`route`,`number_parts`) values 

('<current>','/<current>','/<current>',1,'C:31:\"Symfony\\Component\\Routing\\Route\":681:{a:9:{s:4:\"path\";s:10:\"/<current>\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:0:{}s:12:\"requirements\";a:0:{}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/\\<current\\>$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/<current>\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:10:\"/<current>\";s:8:\"numParts\";i:1;}}}}',1),

('<front>','/','/',1,'C:31:\"Symfony\\Component\\Routing\\Route\":748:{a:9:{s:4:\"path\";s:1:\"/\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:6:\"_title\";s:4:\"Home\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":297:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:8:\"#^/$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:1:\"/\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:1:\"/\";s:8:\"numParts\";i:1;}}}}',1),

('<nolink>','/','/',1,'C:31:\"Symfony\\Component\\Routing\\Route\":743:{a:9:{s:4:\"path\";s:1:\"/\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:0:{}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"_no_path\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":297:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:8:\"#^/$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:1:\"/\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:1:\"/\";s:8:\"numParts\";i:1;}}}}',1),

('<none>','/','/',1,'C:31:\"Symfony\\Component\\Routing\\Route\":743:{a:9:{s:4:\"path\";s:1:\"/\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:0:{}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"_no_path\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":297:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:8:\"#^/$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:1:\"/\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:1:\"/\";s:8:\"numParts\";i:1;}}}}',1),

('admin_toolbar.run.cron','/run-cron','/run-cron',1,'C:31:\"Symfony\\Component\\Routing\\Route\":971:{a:9:{s:4:\"path\";s:9:\"/run-cron\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:65:\"\\Drupal\\admin_toolbar_tools\\Controller\\ToolbarController::runCron\";s:6:\"_title\";s:8:\"Run cron\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":323:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/run\\-cron$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/run-cron\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:9:\"/run-cron\";s:8:\"numParts\";i:1;}}}}',1),

('admin_toolbar_tools.cssjs','/admin/flush/cssjs','/admin/flush/cssjs',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1053:{a:9:{s:4:\"path\";s:18:\"/admin/flush/cssjs\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\admin_toolbar_tools\\Controller\\ToolbarController::flushJsCss\";s:6:\"_title\";s:24:\"Flush Css and Javascript\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":351:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/admin/flush/cssjs$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/admin/flush/cssjs\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:18:\"/admin/flush/cssjs\";s:8:\"numParts\";i:3;}}}}',3),

('admin_toolbar_tools.flush','/admin/flush','/admin/flush',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1019:{a:9:{s:4:\"path\";s:12:\"/admin/flush\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:66:\"\\Drupal\\admin_toolbar_tools\\Controller\\ToolbarController::flushAll\";s:6:\"_title\";s:16:\"Flush all caches\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":333:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/admin/flush$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/admin/flush\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/admin/flush\";s:8:\"numParts\";i:2;}}}}',2),

('admin_toolbar_tools.flush_menu','/admin/flush/menu','/admin/flush/menu',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1027:{a:9:{s:4:\"path\";s:17:\"/admin/flush/menu\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:67:\"\\Drupal\\admin_toolbar_tools\\Controller\\ToolbarController::flushMenu\";s:6:\"_title\";s:4:\"Menu\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":348:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/admin/flush/menu$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/admin/flush/menu\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:17:\"/admin/flush/menu\";s:8:\"numParts\";i:3;}}}}',3),

('admin_toolbar_tools.flush_rendercache','/admin/flush/rendercache','/admin/flush/rendercache',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1066:{a:9:{s:4:\"path\";s:24:\"/admin/flush/rendercache\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:69:\"\\Drupal\\admin_toolbar_tools\\Controller\\ToolbarController::cacheRender\";s:6:\"_title\";s:12:\"Render cache\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/flush/rendercache$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/flush/rendercache\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/flush/rendercache\";s:8:\"numParts\";i:3;}}}}',3),

('admin_toolbar_tools.flush_static','/admin/flush/static-caches','/admin/flush/static-caches',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1076:{a:9:{s:4:\"path\";s:26:\"/admin/flush/static-caches\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:69:\"\\Drupal\\admin_toolbar_tools\\Controller\\ToolbarController::flushStatic\";s:6:\"_title\";s:13:\"Static caches\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":376:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/admin/flush/static\\-caches$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/flush/static-caches\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:26:\"/admin/flush/static-caches\";s:8:\"numParts\";i:3;}}}}',3),

('admin_toolbar_tools.flush_twig','/admin/flush/twig','/admin/flush/twig',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1027:{a:9:{s:4:\"path\";s:17:\"/admin/flush/twig\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:67:\"\\Drupal\\admin_toolbar_tools\\Controller\\ToolbarController::flushTwig\";s:6:\"_title\";s:4:\"Twig\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":348:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/admin/flush/twig$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/admin/flush/twig\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:17:\"/admin/flush/twig\";s:8:\"numParts\";i:3;}}}}',3),

('admin_toolbar_tools.flush_views','/admin/flush/views','/admin/flush/views',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1033:{a:9:{s:4:\"path\";s:18:\"/admin/flush/views\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\admin_toolbar_tools\\Controller\\ToolbarController::flushViews\";s:6:\"_title\";s:5:\"Views\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":351:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/admin/flush/views$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/admin/flush/views\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:18:\"/admin/flush/views\";s:8:\"numParts\";i:3;}}}}',3),

('admin_toolbar_tools.plugin','/admin/flush/plugin','/admin/flush/plugin',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1040:{a:9:{s:4:\"path\";s:19:\"/admin/flush/plugin\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:70:\"\\Drupal\\admin_toolbar_tools\\Controller\\ToolbarController::flushPlugins\";s:6:\"_title\";s:6:\"Plugin\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":354:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/flush/plugin$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/admin/flush/plugin\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/admin/flush/plugin\";s:8:\"numParts\";i:3;}}}}',3),

('block.admin_add','/admin/structure/block/add/{plugin_id}/{theme}','/admin/structure/block/add/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1325:{a:9:{s:4:\"path\";s:46:\"/admin/structure/block/add/{plugin_id}/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:66:\"\\Drupal\\block\\Controller\\BlockAddController::blockAddConfigureForm\";s:5:\"theme\";N;s:6:\"_title\";s:15:\"Configure block\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":663:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"plugin_id\";i:1;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/admin/structure/block/add/(?P<plugin_id>[^/]++)(?:/(?P<theme>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"plugin_id\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/block/add\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"plugin_id\";i:1;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:28:\"/admin/structure/block/add/%\";s:8:\"numParts\";i:6;}}}}',6),

('block.admin_demo','/admin/structure/block/demo/{theme}','/admin/structure/block/demo/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1208:{a:9:{s:4:\"path\";s:35:\"/admin/structure/block/demo/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:46:\"\\Drupal\\block\\Controller\\BlockController::demo\";s:15:\"_title_callback\";s:21:\"theme_handler:getName\";}s:12:\"requirements\";a:2:{s:13:\"_access_theme\";s:4:\"TRUE\";s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:0;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:18:\"access_check.theme\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":513:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/admin/structure/block/demo/(?P<theme>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/block/demo\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:29:\"/admin/structure/block/demo/%\";s:8:\"numParts\";i:5;}}}}',5),

('block.admin_display','/admin/structure/block','/admin/structure/block',7,'C:31:\"Symfony\\Component\\Routing\\Route\":971:{a:9:{s:4:\"path\";s:22:\"/admin/structure/block\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:53:\"\\Drupal\\block\\Controller\\BlockListController::listing\";s:6:\"_title\";s:12:\"Block layout\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/structure/block$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/block\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/structure/block\";s:8:\"numParts\";i:3;}}}}',3),

('block.admin_display_theme','/admin/structure/block/list/{theme}','/admin/structure/block/list/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1196:{a:9:{s:4:\"path\";s:35:\"/admin/structure/block/list/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:53:\"\\Drupal\\block\\Controller\\BlockListController::listing\";s:6:\"_title\";s:12:\"Block layout\";}s:12:\"requirements\";a:2:{s:13:\"_access_theme\";s:4:\"TRUE\";s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:18:\"access_check.theme\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":513:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/admin/structure/block/list/(?P<theme>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/block/list\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:29:\"/admin/structure/block/list/%\";s:8:\"numParts\";i:5;}}}}',5),

('block.admin_library','/admin/structure/block/library/{theme}','/admin/structure/block/library/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1213:{a:9:{s:4:\"path\";s:38:\"/admin/structure/block/library/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:59:\"\\Drupal\\block\\Controller\\BlockLibraryController::listBlocks\";s:6:\"_title\";s:11:\"Place block\";}s:12:\"requirements\";a:2:{s:13:\"_access_theme\";s:4:\"TRUE\";s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:18:\"access_check.theme\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":522:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/admin/structure/block/library/(?P<theme>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/structure/block/library\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:32:\"/admin/structure/block/library/%\";s:8:\"numParts\";i:5;}}}}',5),

('block.category_autocomplete','/block-category/autocomplete','/block-category/autocomplete',3,'C:31:\"Symfony\\Component\\Routing\\Route\":955:{a:9:{s:4:\"path\";s:28:\"/block-category/autocomplete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:69:\"\\Drupal\\block\\Controller\\CategoryAutocompleteController::autocomplete\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/block\\-category/autocomplete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/block-category/autocomplete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:28:\"/block-category/autocomplete\";s:8:\"numParts\";i:2;}}}}',2),

('block_content.add_form','/block/add/{block_content_type}','/block/add/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1400:{a:9:{s:4:\"path\";s:31:\"/block/add/{block_content_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:64:\"\\Drupal\\block_content\\Controller\\BlockContentController::addForm\";s:15:\"_title_callback\";s:71:\"Drupal\\block_content\\Controller\\BlockContentController::getAddFormTitle\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":516:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/block/add/(?P<block_content_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/block/add\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:12:\"/block/add/%\";s:8:\"numParts\";i:3;}}}}',3),

('block_content.add_page','/block/add','/block/add',3,'C:31:\"Symfony\\Component\\Routing\\Route\":934:{a:9:{s:4:\"path\";s:10:\"/block/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\block_content\\Controller\\BlockContentController::add\";s:6:\"_title\";s:16:\"Add custom block\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":327:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/block/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/block/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:10:\"/block/add\";s:8:\"numParts\";i:2;}}}}',2),

('block_content.type_add','/admin/structure/block/block-content/types/add','/admin/structure/block/block-content/types/add',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1029:{a:9:{s:4:\"path\";s:46:\"/admin/structure/block/block-content/types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:22:\"block_content_type.add\";s:6:\"_title\";s:3:\"Add\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":437:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/admin/structure/block/block\\-content/types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/structure/block/block-content/types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:46:\"/admin/structure/block/block-content/types/add\";s:8:\"numParts\";i:6;}}}}',6),

('comment.admin','/admin/content/comment','/admin/content/comment',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1292:{a:9:{s:4:\"path\";s:22:\"/admin/content/comment\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Comments\";s:7:\"view_id\";s:7:\"comment\";s:10:\"display_id\";s:14:\"page_published\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"administer comments\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/content/comment$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/content/comment\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/content/comment\";s:8:\"numParts\";i:3;}}}}',3),

('comment.admin_approval','/admin/content/comment/approval','/admin/content/comment/approval',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1330:{a:9:{s:4:\"path\";s:31:\"/admin/content/comment/approval\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Comments\";s:7:\"view_id\";s:7:\"comment\";s:10:\"display_id\";s:15:\"page_unapproved\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"administer comments\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/content/comment/approval$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/content/comment/approval\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/content/comment/approval\";s:8:\"numParts\";i:4;}}}}',4),

('comment.approve','/comment/{comment}/approve','/comment/%/approve',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1340:{a:9:{s:4:\"path\";s:26:\"/comment/{comment}/approve\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:7:\"Approve\";s:11:\"_controller\";s:60:\"\\Drupal\\comment\\Controller\\CommentController::commentApprove\";s:11:\"entity_type\";s:7:\"comment\";}s:12:\"requirements\";a:3:{s:14:\"_entity_access\";s:15:\"comment.approve\";s:11:\"_csrf_token\";s:4:\"TRUE\";s:7:\"comment\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":516:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/comment/(?P<comment>\\d+)/approve$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/approve\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"comment\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:18:\"/comment/%/approve\";s:8:\"numParts\";i:3;}}}}',3),

('comment.multiple_delete_confirm','/admin/content/comment/delete','/admin/content/comment/delete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1031:{a:9:{s:4:\"path\";s:29:\"/admin/content/comment/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:6:\"Delete\";s:5:\"_form\";s:42:\"\\Drupal\\comment\\Form\\ConfirmDeleteMultiple\";s:14:\"entity_type_id\";s:7:\"comment\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:7:\"comment\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/content/comment/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/content/comment/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/content/comment/delete\";s:8:\"numParts\";i:4;}}}}',4),

('comment.new_comments_node_links','/comments/render_new_comments_node_links','/comments/render_new_comments_node_links',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1002:{a:9:{s:4:\"path\";s:40:\"/comments/render_new_comments_node_links\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:72:\"\\Drupal\\comment\\Controller\\CommentController::renderNewCommentsNodeLinks\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":417:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/comments/render_new_comments_node_links$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/comments/render_new_comments_node_links\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:40:\"/comments/render_new_comments_node_links\";s:8:\"numParts\";i:2;}}}}',2),

('comment.node_redirect','/comment/{node}/reply','/comment/%/reply',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1218:{a:9:{s:4:\"path\";s:21:\"/comment/{node}/reply\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:57:\"Drupal\\comment\\Controller\\CommentController::redirectNode\";}s:12:\"requirements\";a:3:{s:14:\"_entity_access\";s:9:\"node.view\";s:20:\"_module_dependencies\";s:4:\"node\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":498:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/comment/(?P<node>\\d+)/reply$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/reply\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:16:\"/comment/%/reply\";s:8:\"numParts\";i:3;}}}}',3),

('comment.reply','/comment/reply/{entity_type}/{entity}/{field_name}/{pid}','/comment/reply/%/%/%',24,'C:31:\"Symfony\\Component\\Routing\\Route\":1776:{a:9:{s:4:\"path\";s:56:\"/comment/reply/{entity_type}/{entity}/{field_name}/{pid}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:58:\"\\Drupal\\comment\\Controller\\CommentController::getReplyForm\";s:6:\"_title\";s:15:\"Add new comment\";s:3:\"pid\";N;}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:61:\"\\Drupal\\comment\\Controller\\CommentController::replyFormAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":926:{a:11:{s:4:\"vars\";a:4:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:3:\"pid\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:108:\"#^/comment/reply/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/(?P<field_name>[^/]++)(?:/(?P<pid>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"pid\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"field_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";i:4;b:1;}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/comment/reply\";}}s:9:\"path_vars\";a:4:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:3:\"pid\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:24;s:14:\"patternOutline\";s:20:\"/comment/reply/%/%/%\";s:8:\"numParts\";i:6;}}}}',6),

('commerce.admin_commerce','/admin/commerce','/admin/commerce',3,'C:31:\"Symfony\\Component\\Routing\\Route\":972:{a:9:{s:4:\"path\";s:15:\"/admin/commerce\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:8:\"Commerce\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:36:\"access commerce administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":342:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:22:\"#^/admin/commerce$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/admin/commerce\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:15:\"/admin/commerce\";s:8:\"numParts\";i:2;}}}}',2),

('commerce.configuration','/admin/commerce/config','/admin/commerce/config',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1034:{a:9:{s:4:\"path\";s:22:\"/admin/commerce/config\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:52:\"\\Drupal\\system\\Controller\\SystemController::overview\";s:7:\"link_id\";s:22:\"commerce.configuration\";s:6:\"_title\";s:13:\"Configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:36:\"access commerce administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/commerce/config$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/config\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/commerce/config\";s:8:\"numParts\";i:3;}}}}',3),

('commerce.store_configuration','/admin/commerce/config/store','/admin/commerce/config/store',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1022:{a:9:{s:4:\"path\";s:28:\"/admin/commerce/config/store\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:5:\"Store\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:36:\"access commerce administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/commerce/config/store$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/commerce/config/store\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/commerce/config/store\";s:8:\"numParts\";i:4;}}}}',4),

('commerce_cart.page','/cart','/cart',1,'C:31:\"Symfony\\Component\\Routing\\Route\":859:{a:9:{s:4:\"path\";s:5:\"/cart\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:57:\"\\Drupal\\commerce_cart\\Controller\\CartController::cartPage\";s:6:\"_title\";s:13:\"Shopping cart\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":310:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:12:\"#^/cart$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/cart\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:5:\"/cart\";s:8:\"numParts\";i:1;}}}}',1),

('commerce_checkout.form','/checkout/{commerce_order}/{step}','/checkout/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1431:{a:9:{s:4:\"path\";s:33:\"/checkout/{commerce_order}/{step}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:65:\"\\Drupal\\commerce_checkout\\Controller\\CheckoutController::formPage\";s:6:\"_title\";s:8:\"Checkout\";s:4:\"step\";N;}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:68:\"\\Drupal\\commerce_checkout\\Controller\\CheckoutController::checkAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":629:{a:11:{s:4:\"vars\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:4:\"step\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/checkout/(?P<commerce_order>[^/]++)(?:/(?P<step>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"step\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/checkout\";}}s:9:\"path_vars\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:4:\"step\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:11:\"/checkout/%\";s:8:\"numParts\";i:3;}}}}',3),

('commerce_order.address_book.add_form','/user/{user}/address-book/add/{profile_type}','/user/%/address-book/add/%',22,'C:31:\"Symfony\\Component\\Routing\\Route\":1630:{a:9:{s:4:\"path\";s:44:\"/user/{user}/address-book/add/{profile_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"profile.address-book-add\";s:6:\"_title\";s:11:\"Add address\";}s:12:\"requirements\";a:2:{s:20:\"_address_book_access\";s:4:\"TRUE\";s:14:\"_custom_access\";s:74:\"\\Drupal\\commerce_order\\Controller\\AddressBookController::checkCreateAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:25:\"access_check.address_book\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":696:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:72:\"#^/user/(?P<user>[^/]++)/address\\-book/add/(?P<profile_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/address-book/add\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:22;s:14:\"patternOutline\";s:26:\"/user/%/address-book/add/%\";s:8:\"numParts\";i:5;}}}}',5),

('commerce_order.address_book.delete_form','/user/{user}/address-book/{profile}/delete','/user/%/address-book/%/delete',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1667:{a:9:{s:4:\"path\";s:42:\"/user/{user}/address-book/{profile}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:27:\"profile.address-book-delete\";s:15:\"_title_callback\";s:68:\"\\Drupal\\commerce_order\\Controller\\AddressBookController::deleteTitle\";}s:12:\"requirements\";a:3:{s:20:\"_address_book_access\";s:4:\"TRUE\";s:14:\"_entity_access\";s:14:\"profile.delete\";s:7:\"profile\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:7:\"profile\";a:2:{s:4:\"type\";s:14:\"entity:profile\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:25:\"access_check.address_book\";i:1;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":712:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:7:\"profile\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/user/(?P<user>[^/]++)/address\\-book/(?P<profile>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"profile\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/address-book\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:7:\"profile\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:29:\"/user/%/address-book/%/delete\";s:8:\"numParts\";i:5;}}}}',5),

('commerce_order.address_book.edit_form','/user/{user}/address-book/{profile}/edit','/user/%/address-book/%/edit',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1655:{a:9:{s:4:\"path\";s:40:\"/user/{user}/address-book/{profile}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"profile.address-book-edit\";s:15:\"_title_callback\";s:66:\"\\Drupal\\commerce_order\\Controller\\AddressBookController::editTitle\";}s:12:\"requirements\";a:3:{s:20:\"_address_book_access\";s:4:\"TRUE\";s:14:\"_entity_access\";s:14:\"profile.update\";s:7:\"profile\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:7:\"profile\";a:2:{s:4:\"type\";s:14:\"entity:profile\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:25:\"access_check.address_book\";i:1;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":706:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:7:\"profile\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/user/(?P<user>[^/]++)/address\\-book/(?P<profile>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"profile\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/address-book\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:7:\"profile\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:27:\"/user/%/address-book/%/edit\";s:8:\"numParts\";i:5;}}}}',5),

('commerce_order.address_book.overview','/user/{user}/address-book','/user/%/address-book',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1371:{a:9:{s:4:\"path\";s:25:\"/user/{user}/address-book\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:69:\"\\Drupal\\commerce_order\\Controller\\AddressBookController::overviewPage\";s:6:\"_title\";s:12:\"Address book\";}s:12:\"requirements\";a:2:{s:20:\"_address_book_access\";s:4:\"TRUE\";s:14:\"_custom_access\";s:76:\"\\Drupal\\commerce_order\\Controller\\AddressBookController::checkOverviewAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:25:\"access_check.address_book\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":518:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/user/(?P<user>[^/]++)/address\\-book$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/address-book\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:20:\"/user/%/address-book\";s:8:\"numParts\";i:3;}}}}',3),

('commerce_order.address_book.set_default','/user/{user}/address-book/{profile}/set-default','/user/%/address-book/%/set-default',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1688:{a:9:{s:4:\"path\";s:47:\"/user/{user}/address-book/{profile}/set-default\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:67:\"\\Drupal\\commerce_order\\Controller\\AddressBookController::setDefault\";}s:12:\"requirements\";a:4:{s:20:\"_address_book_access\";s:4:\"TRUE\";s:14:\"_entity_access\";s:14:\"profile.update\";s:7:\"profile\";s:3:\"\\d+\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:7:\"profile\";a:2:{s:4:\"type\";s:14:\"entity:profile\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:3:{i:0;s:25:\"access_check.address_book\";i:1;s:19:\"access_check.entity\";i:2;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":729:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:7:\"profile\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:73:\"#^/user/(?P<user>[^/]++)/address\\-book/(?P<profile>\\d+)/set\\-default$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/set-default\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"profile\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/address-book\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:7:\"profile\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:34:\"/user/%/address-book/%/set-default\";s:8:\"numParts\";i:5;}}}}',5),

('commerce_order.configuration','/admin/commerce/config/orders','/admin/commerce/config/orders',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1027:{a:9:{s:4:\"path\";s:29:\"/admin/commerce/config/orders\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:6:\"Orders\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:36:\"access commerce administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/commerce/config/orders$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/commerce/config/orders\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/commerce/config/orders\";s:8:\"numParts\";i:4;}}}}',4),

('commerce_payment.checkout.cancel','/checkout/{commerce_order}/{step}/cancel','/checkout/%/%/cancel',9,'C:31:\"Symfony\\Component\\Routing\\Route\":1512:{a:9:{s:4:\"path\";s:40:\"/checkout/{commerce_order}/{step}/cancel\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:73:\"\\Drupal\\commerce_payment\\Controller\\PaymentCheckoutController::cancelPage\";}s:12:\"requirements\";a:2:{s:14:\"_custom_access\";s:68:\"\\Drupal\\commerce_checkout\\Controller\\CheckoutController::checkAccess\";s:20:\"_module_dependencies\";s:17:\"commerce_checkout\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":683:{a:11:{s:4:\"vars\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:4:\"step\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/checkout/(?P<commerce_order>[^/]++)/(?P<step>[^/]++)/cancel$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/cancel\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"step\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/checkout\";}}s:9:\"path_vars\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:4:\"step\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:9;s:14:\"patternOutline\";s:20:\"/checkout/%/%/cancel\";s:8:\"numParts\";i:4;}}}}',4),

('commerce_payment.checkout.return','/checkout/{commerce_order}/{step}/return','/checkout/%/%/return',9,'C:31:\"Symfony\\Component\\Routing\\Route\":1512:{a:9:{s:4:\"path\";s:40:\"/checkout/{commerce_order}/{step}/return\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:73:\"\\Drupal\\commerce_payment\\Controller\\PaymentCheckoutController::returnPage\";}s:12:\"requirements\";a:2:{s:14:\"_custom_access\";s:68:\"\\Drupal\\commerce_checkout\\Controller\\CheckoutController::checkAccess\";s:20:\"_module_dependencies\";s:17:\"commerce_checkout\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":683:{a:11:{s:4:\"vars\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:4:\"step\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/checkout/(?P<commerce_order>[^/]++)/(?P<step>[^/]++)/return$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/return\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"step\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/checkout\";}}s:9:\"path_vars\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:4:\"step\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:9;s:14:\"patternOutline\";s:20:\"/checkout/%/%/return\";s:8:\"numParts\";i:4;}}}}',4),

('commerce_payment.configuration','/admin/commerce/config/payment','/admin/commerce/config/payment',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1032:{a:9:{s:4:\"path\";s:30:\"/admin/commerce/config/payment\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:7:\"Payment\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:36:\"access commerce administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":388:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/commerce/config/payment$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/commerce/config/payment\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:30:\"/admin/commerce/config/payment\";s:8:\"numParts\";i:4;}}}}',4),

('commerce_payment.notify','/payment/notify/{commerce_payment_gateway}','/payment/notify/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1285:{a:9:{s:4:\"path\";s:42:\"/payment/notify/{commerce_payment_gateway}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:77:\"\\Drupal\\commerce_payment\\Controller\\PaymentNotificationController::notifyPage\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_payment_gateway\";a:2:{s:4:\"type\";s:31:\"entity:commerce_payment_gateway\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":555:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_payment_gateway\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/payment/notify/(?P<commerce_payment_gateway>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_payment_gateway\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/payment/notify\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_payment_gateway\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:17:\"/payment/notify/%\";s:8:\"numParts\";i:3;}}}}',3),

('commerce_payment_example.dummy_redirect_302','/commerce_payment_example/dummy_redirect_302','/commerce_payment_example/dummy_redirect_302',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1020:{a:9:{s:4:\"path\";s:44:\"/commerce_payment_example/dummy_redirect_302\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:74:\"\\Drupal\\commerce_payment_example\\Controller\\DummyRedirectController::on302\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"no_cache\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":429:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/commerce_payment_example/dummy_redirect_302$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/commerce_payment_example/dummy_redirect_302\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:44:\"/commerce_payment_example/dummy_redirect_302\";s:8:\"numParts\";i:2;}}}}',2),

('commerce_payment_example.dummy_redirect_post','/commerce_payment_example/dummy_redirect_post','/commerce_payment_example/dummy_redirect_post',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1023:{a:9:{s:4:\"path\";s:45:\"/commerce_payment_example/dummy_redirect_post\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:73:\"\\Drupal\\commerce_payment_example\\Controller\\DummyRedirectController::post\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"no_cache\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":432:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/commerce_payment_example/dummy_redirect_post$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:45:\"/commerce_payment_example/dummy_redirect_post\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:45:\"/commerce_payment_example/dummy_redirect_post\";s:8:\"numParts\";i:2;}}}}',2),

('commerce_product.configuration','/admin/commerce/config/products','/admin/commerce/config/products',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1037:{a:9:{s:4:\"path\";s:31:\"/admin/commerce/config/products\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:8:\"Products\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:36:\"access commerce administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/commerce/config/products$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/commerce/config/products\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/commerce/config/products\";s:8:\"numParts\";i:4;}}}}',4),

('config.diff','/admin/config/development/configuration/sync/diff/{source_name}/{target_name}','/admin/config/development/configuration/sync/diff/%',126,'C:31:\"Symfony\\Component\\Routing\\Route\":1426:{a:9:{s:4:\"path\";s:77:\"/admin/config/development/configuration/sync/diff/{source_name}/{target_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\config\\Controller\\ConfigController::diff\";s:11:\"target_name\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"synchronize configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":772:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"source_name\";i:1;s:11:\"target_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:109:\"#^/admin/config/development/configuration/sync/diff/(?P<source_name>[^/]++)(?:/(?P<target_name>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"target_name\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"source_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:49:\"/admin/config/development/configuration/sync/diff\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"source_name\";i:1;s:11:\"target_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:126;s:14:\"patternOutline\";s:51:\"/admin/config/development/configuration/sync/diff/%\";s:8:\"numParts\";i:8;}}}}',8),

('config.diff_collection','/admin/config/development/configuration/sync/diff_collection/{collection}/{source_name}/{target_name}','/admin/config/development/configuration/sync/diff_collection/%/%',252,'C:31:\"Symfony\\Component\\Routing\\Route\":1641:{a:9:{s:4:\"path\";s:101:\"/admin/config/development/configuration/sync/diff_collection/{collection}/{source_name}/{target_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\config\\Controller\\ConfigController::diff\";s:11:\"target_name\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"synchronize configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":962:{a:11:{s:4:\"vars\";a:3:{i:0;s:10:\"collection\";i:1;s:11:\"source_name\";i:2;s:11:\"target_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:143:\"#^/admin/config/development/configuration/sync/diff_collection/(?P<collection>[^/]++)/(?P<source_name>[^/]++)(?:/(?P<target_name>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"target_name\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"source_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"collection\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:60:\"/admin/config/development/configuration/sync/diff_collection\";}}s:9:\"path_vars\";a:3:{i:0;s:10:\"collection\";i:1;s:11:\"source_name\";i:2;s:11:\"target_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:252;s:14:\"patternOutline\";s:64:\"/admin/config/development/configuration/sync/diff_collection/%/%\";s:8:\"numParts\";i:9;}}}}',9),

('config.export_download','/admin/config/development/configuration/full/export-download','/admin/config/development/configuration/full/export-download',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1100:{a:9:{s:4:\"path\";s:60:\"/admin/config/development/configuration/full/export-download\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\config\\Controller\\ConfigController::downloadExport\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"export configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":479:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/config/development/configuration/full/export\\-download$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:60:\"/admin/config/development/configuration/full/export-download\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:60:\"/admin/config/development/configuration/full/export-download\";s:8:\"numParts\";i:6;}}}}',6),

('config.export_full','/admin/config/development/configuration/full/export','/admin/config/development/configuration/full/export',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1060:{a:9:{s:4:\"path\";s:51:\"/admin/config/development/configuration/full/export\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:36:\"\\Drupal\\config\\Form\\ConfigExportForm\";s:6:\"_title\";s:6:\"Export\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"export configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":451:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/admin/config/development/configuration/full/export$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:51:\"/admin/config/development/configuration/full/export\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:51:\"/admin/config/development/configuration/full/export\";s:8:\"numParts\";i:6;}}}}',6),

('config.export_single','/admin/config/development/configuration/single/export/{config_type}/{config_name}','/admin/config/development/configuration/single/export',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1481:{a:9:{s:4:\"path\";s:81:\"/admin/config/development/configuration/single/export/{config_type}/{config_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:6:\"_title\";s:13:\"Single export\";s:5:\"_form\";s:42:\"\\Drupal\\config\\Form\\ConfigSingleExportForm\";s:11:\"config_type\";N;s:11:\"config_name\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"export configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":786:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"config_type\";i:1;s:11:\"config_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:118:\"#^/admin/config/development/configuration/single/export(?:/(?P<config_type>[^/]++)(?:/(?P<config_name>[^/]++))?)?$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"config_name\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"config_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:53:\"/admin/config/development/configuration/single/export\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"config_type\";i:1;s:11:\"config_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:53:\"/admin/config/development/configuration/single/export\";s:8:\"numParts\";i:8;}}}}',8),

('config.import_full','/admin/config/development/configuration/full/import','/admin/config/development/configuration/full/import',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1060:{a:9:{s:4:\"path\";s:51:\"/admin/config/development/configuration/full/import\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:36:\"\\Drupal\\config\\Form\\ConfigImportForm\";s:6:\"_title\";s:6:\"Import\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"import configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":451:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/admin/config/development/configuration/full/import$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:51:\"/admin/config/development/configuration/full/import\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:51:\"/admin/config/development/configuration/full/import\";s:8:\"numParts\";i:6;}}}}',6),

('config.import_single','/admin/config/development/configuration/single/import','/admin/config/development/configuration/single/import',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1082:{a:9:{s:4:\"path\";s:53:\"/admin/config/development/configuration/single/import\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:13:\"Single import\";s:5:\"_form\";s:42:\"\\Drupal\\config\\Form\\ConfigSingleImportForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"import configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":457:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:60:\"#^/admin/config/development/configuration/single/import$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:53:\"/admin/config/development/configuration/single/import\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:53:\"/admin/config/development/configuration/single/import\";s:8:\"numParts\";i:6;}}}}',6),

('config.sync','/admin/config/development/configuration','/admin/config/development/configuration',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1017:{a:9:{s:4:\"path\";s:39:\"/admin/config/development/configuration\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:30:\"\\Drupal\\config\\Form\\ConfigSync\";s:6:\"_title\";s:11:\"Synchronize\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"synchronize configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":415:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/config/development/configuration$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/development/configuration\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:39:\"/admin/config/development/configuration\";s:8:\"numParts\";i:4;}}}}',4),

('contact.form_add','/admin/structure/contact/add','/admin/structure/contact/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":971:{a:9:{s:4:\"path\";s:28:\"/admin/structure/contact/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"contact_form.add\";s:6:\"_title\";s:16:\"Add contact form\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer contact forms\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/structure/contact/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/contact/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/structure/contact/add\";s:8:\"numParts\";i:4;}}}}',4),

('contact.site_page','/contact','/contact',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1057:{a:9:{s:4:\"path\";s:8:\"/contact\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:7:\"Contact\";s:11:\"_controller\";s:61:\"\\Drupal\\contact\\Controller\\ContactController::contactSitePage\";s:12:\"contact_form\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"access site-wide contact form\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":319:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:15:\"#^/contact$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/contact\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:8:\"/contact\";s:8:\"numParts\";i:1;}}}}',1),

('contextual.render','/contextual/render','/contextual/render',3,'C:31:\"Symfony\\Component\\Routing\\Route\":898:{a:9:{s:4:\"path\";s:18:\"/contextual/render\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:47:\"\\Drupal\\contextual\\ContextualController::render\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"access contextual links\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":351:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/contextual/render$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/contextual/render\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:18:\"/contextual/render\";s:8:\"numParts\";i:2;}}}}',2),

('dblog.access_denied','/admin/reports/access-denied','/admin/reports/access-denied',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1047:{a:9:{s:4:\"path\";s:28:\"/admin/reports/access-denied\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:26:\"Top \'access denied\' errors\";s:11:\"_controller\";s:56:\"\\Drupal\\dblog\\Controller\\DbLogController::topLogMessages\";s:4:\"type\";s:13:\"access denied\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/reports/access\\-denied$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/reports/access-denied\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:28:\"/admin/reports/access-denied\";s:8:\"numParts\";i:3;}}}}',3),

('dblog.confirm','/admin/reports/dblog/confirm','/admin/reports/dblog/confirm',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1003:{a:9:{s:4:\"path\";s:28:\"/admin/reports/dblog/confirm\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"\\Drupal\\dblog\\Form\\DblogClearLogConfirmForm\";s:6:\"_title\";s:34:\"Confirm delete recent log messages\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/reports/dblog/confirm$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/reports/dblog/confirm\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/reports/dblog/confirm\";s:8:\"numParts\";i:4;}}}}',4),

('dblog.event','/admin/reports/dblog/event/{event_id}','/admin/reports/dblog/event/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1142:{a:9:{s:4:\"path\";s:37:\"/admin/reports/dblog/event/{event_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\dblog\\Controller\\DbLogController::eventDetails\";s:6:\"_title\";s:7:\"Details\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":522:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"event_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/admin/reports/dblog/event/(?P<event_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"event_id\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/reports/dblog/event\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"event_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:28:\"/admin/reports/dblog/event/%\";s:8:\"numParts\";i:5;}}}}',5),

('dblog.overview','/admin/reports/dblog','/admin/reports/dblog',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1286:{a:9:{s:4:\"path\";s:20:\"/admin/reports/dblog\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:19:\"Recent log messages\";s:7:\"view_id\";s:8:\"watchdog\";s:10:\"display_id\";s:4:\"page\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"access site reports\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":357:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/reports/dblog$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/reports/dblog\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/reports/dblog\";s:8:\"numParts\";i:3;}}}}',3),

('dblog.page_not_found','/admin/reports/page-not-found','/admin/reports/page-not-found',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1054:{a:9:{s:4:\"path\";s:29:\"/admin/reports/page-not-found\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:27:\"Top \'page not found\' errors\";s:11:\"_controller\";s:56:\"\\Drupal\\dblog\\Controller\\DbLogController::topLogMessages\";s:4:\"type\";s:14:\"page not found\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":386:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/reports/page\\-not\\-found$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/reports/page-not-found\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:29:\"/admin/reports/page-not-found\";s:8:\"numParts\";i:3;}}}}',3),

('dblog.search','/admin/reports/search','/admin/reports/search',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1043:{a:9:{s:4:\"path\";s:21:\"/admin/reports/search\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"\\Drupal\\dblog\\Controller\\DbLogController::topLogMessages\";s:6:\"_title\";s:18:\"Top search phrases\";s:4:\"type\";s:6:\"search\";}s:12:\"requirements\";a:2:{s:20:\"_module_dependencies\";s:6:\"search\";s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":360:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/reports/search$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/reports/search\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/reports/search\";s:8:\"numParts\";i:3;}}}}',3),

('dropzonejs.upload','/dropzonejs/upload','/dropzonejs/upload',3,'C:31:\"Symfony\\Component\\Routing\\Route\":969:{a:9:{s:4:\"path\";s:18:\"/dropzonejs/upload\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:61:\"\\Drupal\\dropzonejs\\Controller\\UploadController::handleUploads\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:21:\"dropzone upload files\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":351:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/dropzonejs/upload$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/dropzonejs/upload\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:18:\"/dropzonejs/upload\";s:8:\"numParts\";i:2;}}}}',2),

('editor.field_untransformed_text','/editor/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}','/editor/%/%/%/%/%',32,'C:31:\"Symfony\\Component\\Routing\\Route\":1909:{a:9:{s:4:\"path\";s:69:\"/editor/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:53:\"\\Drupal\\editor\\EditorController::getUntransformedText\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:23:\"access in-place editing\";s:30:\"_access_quickedit_entity_field\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1086:{a:11:{s:4:\"vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:126:\"#^/editor/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/(?P<field_name>[^/]++)/(?P<langcode>[^/]++)/(?P<view_mode_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"view_mode_id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"langcode\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"field_name\";i:4;b:1;}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";i:4;b:1;}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/editor\";}}s:9:\"path_vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:32;s:14:\"patternOutline\";s:17:\"/editor/%/%/%/%/%\";s:8:\"numParts\";i:6;}}}}',6),

('editor.filter_xss','/editor/filter_xss/{filter_format}','/editor/filter_xss/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1206:{a:9:{s:4:\"path\";s:34:\"/editor/filter_xss/{filter_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:42:\"\\Drupal\\editor\\EditorController::filterXss\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:17:\"filter_format.use\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":520:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/editor/filter_xss/(?P<filter_format>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/editor/filter_xss\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:20:\"/editor/filter_xss/%\";s:8:\"numParts\";i:3;}}}}',3),

('editor.image_dialog','/editor/dialog/image/{editor}','/editor/dialog/image/%',14,'C:31:\"Symfony\\Component\\Routing\\Route\":1176:{a:9:{s:4:\"path\";s:29:\"/editor/dialog/image/{editor}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\editor\\Form\\EditorImageDialog\";s:6:\"_title\";s:12:\"Upload image\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:10:\"editor.use\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:6:\"editor\";a:2:{s:4:\"type\";s:13:\"entity:editor\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":496:{a:11:{s:4:\"vars\";a:1:{i:0;s:6:\"editor\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/editor/dialog/image/(?P<editor>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"editor\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/editor/dialog/image\";}}s:9:\"path_vars\";a:1:{i:0;s:6:\"editor\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:22:\"/editor/dialog/image/%\";s:8:\"numParts\";i:4;}}}}',4),

('editor.link_dialog','/editor/dialog/link/{editor}','/editor/dialog/link/%',14,'C:31:\"Symfony\\Component\\Routing\\Route\":1166:{a:9:{s:4:\"path\";s:28:\"/editor/dialog/link/{editor}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:36:\"\\Drupal\\editor\\Form\\EditorLinkDialog\";s:6:\"_title\";s:8:\"Add link\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:10:\"editor.use\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:6:\"editor\";a:2:{s:4:\"type\";s:13:\"entity:editor\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":493:{a:11:{s:4:\"vars\";a:1:{i:0;s:6:\"editor\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/editor/dialog/link/(?P<editor>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"editor\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/editor/dialog/link\";}}s:9:\"path_vars\";a:1:{i:0;s:6:\"editor\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:21:\"/editor/dialog/link/%\";s:8:\"numParts\";i:4;}}}}',4),

('embed.button_add','/admin/config/content/embed/button/add','/admin/config/content/embed/button/add',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1012:{a:9:{s:4:\"path\";s:38:\"/admin/config/content/embed/button/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"embed_button.add\";s:6:\"_title\";s:16:\"Add embed button\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:12:\"embed_button\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":412:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/content/embed/button/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/admin/config/content/embed/button/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:38:\"/admin/config/content/embed/button/add\";s:8:\"numParts\";i:6;}}}}',6),

('embed.preview','/embed/preview/{filter_format}','/embed/preview/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1232:{a:9:{s:4:\"path\";s:30:\"/embed/preview/{filter_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:49:\"\\Drupal\\embed\\Controller\\EmbedController::preview\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:17:\"filter_format.use\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:6:\"_theme\";s:14:\"ajax_base_page\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":508:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/embed/preview/(?P<filter_format>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/embed/preview\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:16:\"/embed/preview/%\";s:8:\"numParts\";i:3;}}}}',3),

('embed.settings','/admin/config/content/embed/settings','/admin/config/content/embed/settings',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1006:{a:9:{s:4:\"path\";s:36:\"/admin/config/content/embed/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:36:\"\\Drupal\\embed\\Form\\EmbedSettingsForm\";s:6:\"_title\";s:8:\"Settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer embed buttons\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":406:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/config/content/embed/settings$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/content/embed/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:36:\"/admin/config/content/embed/settings\";s:8:\"numParts\";i:5;}}}}',5),

('entity.block.delete_form','/admin/structure/block/manage/{block}/delete','/admin/structure/block/manage/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1326:{a:9:{s:4:\"path\";s:44:\"/admin/structure/block/manage/{block}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:12:\"block.delete\";s:6:\"_title\";s:12:\"Delete block\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":576:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/admin/structure/block/manage/(?P<block>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/block/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/block/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.block.disable','/admin/structure/block/manage/{block}/disable','/admin/structure/block/manage/%/disable',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1419:{a:9:{s:4:\"path\";s:45:\"/admin/structure/block/manage/{block}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\block\\Controller\\BlockController::performOperation\";s:2:\"op\";s:7:\"disable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:13:\"block.disable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":579:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:62:\"#^/admin/structure/block/manage/(?P<block>[^/]++)/disable$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/block/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:39:\"/admin/structure/block/manage/%/disable\";s:8:\"numParts\";i:6;}}}}',6),

('entity.block.edit_form','/admin/structure/block/manage/{block}','/admin/structure/block/manage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1260:{a:9:{s:4:\"path\";s:37:\"/admin/structure/block/manage/{block}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"block.default\";s:6:\"_title\";s:15:\"Configure block\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:12:\"block.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":519:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/admin/structure/block/manage/(?P<block>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/block/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:31:\"/admin/structure/block/manage/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.block.enable','/admin/structure/block/manage/{block}/enable','/admin/structure/block/manage/%/enable',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1413:{a:9:{s:4:\"path\";s:44:\"/admin/structure/block/manage/{block}/enable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\block\\Controller\\BlockController::performOperation\";s:2:\"op\";s:6:\"enable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:12:\"block.enable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":576:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/admin/structure/block/manage/(?P<block>[^/]++)/enable$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/enable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/block/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/block/manage/%/enable\";s:8:\"numParts\";i:6;}}}}',6),

('entity.block_content.canonical','/block/{block_content}','/block/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1185:{a:9:{s:4:\"path\";s:22:\"/block/{block_content}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:18:\"block_content.edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"block_content.update\";s:13:\"block_content\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"block_content\";a:2:{s:4:\"type\";s:20:\"entity:block_content\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":476:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/block/(?P<block_content>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"block_content\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/block\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:8:\"/block/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.block_content.collection','/admin/structure/block/block-content','/admin/structure/block/block-content',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1359:{a:9:{s:4:\"path\";s:36:\"/admin/structure/block/block-content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:20:\"Custom block library\";s:7:\"view_id\";s:13:\"block_content\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer blocks\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":407:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/structure/block/block\\-content$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/structure/block/block-content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:36:\"/admin/structure/block/block-content\";s:8:\"numParts\";i:4;}}}}',4),

('entity.block_content.delete_form','/block/{block_content}/delete','/block/%/delete',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1278:{a:9:{s:4:\"path\";s:29:\"/block/{block_content}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:20:\"block_content.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"block_content.delete\";s:13:\"block_content\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"block_content\";a:2:{s:4:\"type\";s:20:\"entity:block_content\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":534:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/block/(?P<block_content>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"block_content\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/block\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/block/%/delete\";s:8:\"numParts\";i:3;}}}}',3),

('entity.block_content.edit_form','/block/{block_content}','/block/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1185:{a:9:{s:4:\"path\";s:22:\"/block/{block_content}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:18:\"block_content.edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"block_content.update\";s:13:\"block_content\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"block_content\";a:2:{s:4:\"type\";s:20:\"entity:block_content\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":476:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/block/(?P<block_content>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"block_content\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/block\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:8:\"/block/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.block_content.field_ui_fields','/admin/structure/block/block-content/manage/{block_content_type}/fields','/admin/structure/block/block-content/manage/%/fields',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1597:{a:9:{s:4:\"path\";s:71:\"/admin/structure/block/block-content/manage/{block_content_type}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer block_content fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":675:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:89:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:52:\"/admin/structure/block/block-content/manage/%/fields\";s:8:\"numParts\";i:7;}}}}',7),

('entity.block_content_type.collection','/admin/structure/block/block-content/types','/admin/structure/block/block-content/types',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1086:{a:9:{s:4:\"path\";s:42:\"/admin/structure/block/block-content/types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:18:\"block_content_type\";s:6:\"_title\";s:20:\"Custom block library\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":425:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/admin/structure/block/block\\-content/types$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/block/block-content/types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:42:\"/admin/structure/block/block-content/types\";s:8:\"numParts\";i:5;}}}}',5),

('entity.block_content_type.delete_form','/admin/structure/block/block-content/manage/{block_content_type}/delete','/admin/structure/block/block-content/manage/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1557:{a:9:{s:4:\"path\";s:71:\"/admin/structure/block/block-content/manage/{block_content_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"block_content_type.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"block_content_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":675:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:89:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:52:\"/admin/structure/block/block-content/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.block_content_type.edit_form','/admin/structure/block/block-content/manage/{block_content_type}','/admin/structure/block/block-content/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1488:{a:9:{s:4:\"path\";s:64:\"/admin/structure/block/block-content/manage/{block_content_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"block_content_type.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"block_content_type.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":617:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:82:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:45:\"/admin/structure/block/block-content/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.comment.canonical','/comment/{comment}','/comment/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1250:{a:9:{s:4:\"path\";s:18:\"/comment/{comment}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:15:\"_title_callback\";s:67:\"\\Drupal\\comment\\Controller\\CommentController::commentPermalinkTitle\";s:11:\"_controller\";s:62:\"\\Drupal\\comment\\Controller\\CommentController::commentPermalink\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:12:\"comment.view\";s:7:\"comment\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":456:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/comment/(?P<comment>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"comment\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:10:\"/comment/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.comment.delete_form','/comment/{comment}/delete','/comment/%/delete',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1197:{a:9:{s:4:\"path\";s:25:\"/comment/{comment}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:6:\"Delete\";s:12:\"_entity_form\";s:14:\"comment.delete\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"comment.delete\";s:7:\"comment\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":513:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/comment/(?P<comment>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"comment\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/comment/%/delete\";s:8:\"numParts\";i:3;}}}}',3),

('entity.comment.delete_multiple_form','/admin/content/comment/delete','/admin/content/comment/delete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1031:{a:9:{s:4:\"path\";s:29:\"/admin/content/comment/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:6:\"Delete\";s:5:\"_form\";s:42:\"\\Drupal\\comment\\Form\\ConfirmDeleteMultiple\";s:14:\"entity_type_id\";s:7:\"comment\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:7:\"comment\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/content/comment/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/content/comment/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/content/comment/delete\";s:8:\"numParts\";i:4;}}}}',4),

('entity.comment.edit_form','/comment/{comment}/edit','/comment/%/edit',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1188:{a:9:{s:4:\"path\";s:23:\"/comment/{comment}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:4:\"Edit\";s:12:\"_entity_form\";s:15:\"comment.default\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"comment.update\";s:7:\"comment\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":507:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/comment/(?P<comment>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"comment\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/comment/%/edit\";s:8:\"numParts\";i:3;}}}}',3),

('entity.comment.field_ui_fields','/admin/structure/comment/manage/{comment_type}/fields','/admin/structure/comment/manage/%/fields',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1492:{a:9:{s:4:\"path\";s:53:\"/admin/structure/comment/manage/{comment_type}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer comment fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":613:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/comment/manage/%/fields\";s:8:\"numParts\";i:6;}}}}',6),

('entity.comment_type.add_form','/admin/structure/comment/types/add','/admin/structure/comment/types/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":995:{a:9:{s:4:\"path\";s:34:\"/admin/structure/comment/types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"comment_type.add\";s:6:\"_title\";s:16:\"Add comment type\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer comment types\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/admin/structure/comment/types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/structure/comment/types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:34:\"/admin/structure/comment/types/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.comment_type.collection','/admin/structure/comment','/admin/structure/comment',7,'C:31:\"Symfony\\Component\\Routing\\Route\":947:{a:9:{s:4:\"path\";s:24:\"/admin/structure/comment\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:12:\"comment_type\";s:6:\"_title\";s:13:\"Comment types\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer comment types\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/structure/comment$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/structure/comment\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/structure/comment\";s:8:\"numParts\";i:3;}}}}',3),

('entity.comment_type.delete_form','/admin/structure/comment/manage/{comment_type}/delete','/admin/structure/comment/manage/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1388:{a:9:{s:4:\"path\";s:53:\"/admin/structure/comment/manage/{comment_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"comment_type.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"comment_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":613:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/comment/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.comment_type.edit_form','/admin/structure/comment/manage/{comment_type}','/admin/structure/comment/manage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1320:{a:9:{s:4:\"path\";s:46:\"/admin/structure/comment/manage/{comment_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"comment_type.edit\";s:6:\"_title\";s:4:\"Edit\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"comment_type.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":556:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:33:\"/admin/structure/comment/manage/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_checkout_flow.add_form','/admin/commerce/config/checkout-flows/add','/admin/commerce/config/checkout-flows/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1147:{a:9:{s:4:\"path\";s:41:\"/admin/commerce/config/checkout-flows/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:26:\"commerce_checkout_flow.add\";s:14:\"entity_type_id\";s:22:\"commerce_checkout_flow\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:22:\"commerce_checkout_flow\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":422:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:49:\"#^/admin/commerce/config/checkout\\-flows/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/config/checkout-flows/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:41:\"/admin/commerce/config/checkout-flows/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_checkout_flow.collection','/admin/commerce/config/checkout-flows','/admin/commerce/config/checkout-flows',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1080:{a:9:{s:4:\"path\";s:37:\"/admin/commerce/config/checkout-flows\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:22:\"commerce_checkout_flow\";s:6:\"_title\";s:14:\"Checkout flows\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer commerce_checkout_flow\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":410:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/commerce/config/checkout\\-flows$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/commerce/config/checkout-flows\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/commerce/config/checkout-flows\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_checkout_flow.delete_form','/admin/commerce/config/checkout-flows/manage/{commerce_checkout_flow}/delete','/admin/commerce/config/checkout-flows/manage/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1597:{a:9:{s:4:\"path\";s:76:\"/admin/commerce/config/checkout-flows/manage/{commerce_checkout_flow}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:29:\"commerce_checkout_flow.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:29:\"commerce_checkout_flow.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:22:\"commerce_checkout_flow\";a:2:{s:4:\"type\";s:29:\"entity:commerce_checkout_flow\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":694:{a:11:{s:4:\"vars\";a:1:{i:0;s:22:\"commerce_checkout_flow\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:94:\"#^/admin/commerce/config/checkout\\-flows/manage/(?P<commerce_checkout_flow>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:22:\"commerce_checkout_flow\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/commerce/config/checkout-flows/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:22:\"commerce_checkout_flow\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:53:\"/admin/commerce/config/checkout-flows/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_checkout_flow.edit_form','/admin/commerce/config/checkout-flows/manage/{commerce_checkout_flow}','/admin/commerce/config/checkout-flows/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1528:{a:9:{s:4:\"path\";s:69:\"/admin/commerce/config/checkout-flows/manage/{commerce_checkout_flow}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:27:\"commerce_checkout_flow.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:29:\"commerce_checkout_flow.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:22:\"commerce_checkout_flow\";a:2:{s:4:\"type\";s:29:\"entity:commerce_checkout_flow\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":636:{a:11:{s:4:\"vars\";a:1:{i:0;s:22:\"commerce_checkout_flow\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/commerce/config/checkout\\-flows/manage/(?P<commerce_checkout_flow>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:22:\"commerce_checkout_flow\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/commerce/config/checkout-flows/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:22:\"commerce_checkout_flow\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:46:\"/admin/commerce/config/checkout-flows/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_currency.add_form','/admin/commerce/config/currencies/add-custom','/admin/commerce/config/currencies/add-custom',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1127:{a:9:{s:4:\"path\";s:44:\"/admin/commerce/config/currencies/add-custom\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:21:\"commerce_currency.add\";s:14:\"entity_type_id\";s:17:\"commerce_currency\";s:15:\"_title_callback\";s:0:\"\";s:6:\"_title\";s:19:\"Add custom currency\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:17:\"commerce_currency\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":431:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/admin/commerce/config/currencies/add\\-custom$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/commerce/config/currencies/add-custom\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:44:\"/admin/commerce/config/currencies/add-custom\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_currency.collection','/admin/commerce/config/currencies','/admin/commerce/config/currencies',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1049:{a:9:{s:4:\"path\";s:33:\"/admin/commerce/config/currencies\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:17:\"commerce_currency\";s:6:\"_title\";s:10:\"Currencies\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer commerce_currency\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/commerce/config/currencies$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/commerce/config/currencies\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:33:\"/admin/commerce/config/currencies\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_currency.delete_form','/admin/commerce/config/currencies/{commerce_currency}/delete','/admin/commerce/config/currencies/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1506:{a:9:{s:4:\"path\";s:60:\"/admin/commerce/config/currencies/{commerce_currency}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"commerce_currency.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:24:\"commerce_currency.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:17:\"commerce_currency\";a:2:{s:4:\"type\";s:24:\"entity:commerce_currency\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":639:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"commerce_currency\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/commerce/config/currencies/(?P<commerce_currency>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"commerce_currency\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/commerce/config/currencies\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"commerce_currency\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:42:\"/admin/commerce/config/currencies/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_currency.edit_form','/admin/commerce/config/currencies/{commerce_currency}','/admin/commerce/config/currencies/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1438:{a:9:{s:4:\"path\";s:53:\"/admin/commerce/config/currencies/{commerce_currency}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:22:\"commerce_currency.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:24:\"commerce_currency.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:17:\"commerce_currency\";a:2:{s:4:\"type\";s:24:\"entity:commerce_currency\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":582:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"commerce_currency\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/commerce/config/currencies/(?P<commerce_currency>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"commerce_currency\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/commerce/config/currencies\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"commerce_currency\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:35:\"/admin/commerce/config/currencies/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_currency.import','/admin/commerce/config/currencies/add','/admin/commerce/config/currencies/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1029:{a:9:{s:4:\"path\";s:37:\"/admin/commerce/config/currencies/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:46:\"\\Drupal\\commerce_price\\Form\\CurrencyImportForm\";s:6:\"_title\";s:12:\"Add currency\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer commerce_currency\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/commerce/config/currencies/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/commerce/config/currencies/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:37:\"/admin/commerce/config/currencies/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_order.add_page','/admin/commerce/orders/add','/admin/commerce/orders/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":992:{a:9:{s:4:\"path\";s:26:\"/admin/commerce/orders/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\commerce_order\\Form\\OrderAddForm\";s:6:\"_title\";s:18:\"Create a new order\";}s:12:\"requirements\";a:1:{s:25:\"_entity_create_any_access\";s:14:\"commerce_order\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.entity_create_any\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":376:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/commerce/orders/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/commerce/orders/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/commerce/orders/add\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_order.canonical','/admin/commerce/orders/{commerce_order}','/admin/commerce/orders/%',14,'C:31:\"Symfony\\Component\\Routing\\Route\":1346:{a:9:{s:4:\"path\";s:39:\"/admin/commerce/orders/{commerce_order}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_view\";s:20:\"commerce_order.admin\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:19:\"commerce_order.view\";s:14:\"commerce_order\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":531:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/commerce/orders/(?P<commerce_order>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:24:\"/admin/commerce/orders/%\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_order.collection','/admin/commerce/orders','/admin/commerce/orders',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1301:{a:9:{s:4:\"path\";s:22:\"/admin/commerce/orders\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:6:\"Orders\";s:7:\"view_id\";s:15:\"commerce_orders\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:30:\"access commerce_order overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/commerce/orders$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/commerce/orders\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_order.delete_form','/admin/commerce/orders/{commerce_order}/delete','/admin/commerce/orders/%/delete',29,'C:31:\"Symfony\\Component\\Routing\\Route\":1419:{a:9:{s:4:\"path\";s:46:\"/admin/commerce/orders/{commerce_order}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"commerce_order.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:21:\"commerce_order.delete\";s:14:\"commerce_order\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":588:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:60:\"#^/admin/commerce/orders/(?P<commerce_order>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:29;s:14:\"patternOutline\";s:31:\"/admin/commerce/orders/%/delete\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_order.delete_multiple_form','/admin/commerce/orders/delete','/admin/commerce/orders/delete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1017:{a:9:{s:4:\"path\";s:29:\"/admin/commerce/orders/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"\\Drupal\\entity\\Form\\DeleteMultipleForm\";s:14:\"entity_type_id\";s:14:\"commerce_order\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:14:\"commerce_order\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/commerce/orders/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/commerce/orders/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/commerce/orders/delete\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_order.edit_form','/admin/commerce/orders/{commerce_order}/edit','/admin/commerce/orders/%/edit',29,'C:31:\"Symfony\\Component\\Routing\\Route\":1407:{a:9:{s:4:\"path\";s:44:\"/admin/commerce/orders/{commerce_order}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"commerce_order.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:21:\"commerce_order.update\";s:14:\"commerce_order\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":582:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/admin/commerce/orders/(?P<commerce_order>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:29;s:14:\"patternOutline\";s:29:\"/admin/commerce/orders/%/edit\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_order.field_ui_fields','/admin/commerce/config/order-types/{commerce_order_type}/edit/fields','/admin/commerce/config/order-types/%/edit/fields',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1591:{a:9:{s:4:\"path\";s:68:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer commerce_order fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":668:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:48:\"/admin/commerce/config/order-types/%/edit/fields\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_order.reassign_form','/admin/commerce/orders/{commerce_order}/reassign','/admin/commerce/orders/%/reassign',29,'C:31:\"Symfony\\Component\\Routing\\Route\":1366:{a:9:{s:4:\"path\";s:48:\"/admin/commerce/orders/{commerce_order}/reassign\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:45:\"\\Drupal\\commerce_order\\Form\\OrderReassignForm\";s:6:\"_title\";s:14:\"Reassign order\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer commerce_order\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":600:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/commerce/orders/(?P<commerce_order>[^/]++)/reassign$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/reassign\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:29;s:14:\"patternOutline\";s:33:\"/admin/commerce/orders/%/reassign\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_order.resend_receipt_form','/admin/commerce/orders/{commerce_order}/resend-receipt','/admin/commerce/orders/%/resend-receipt',29,'C:31:\"Symfony\\Component\\Routing\\Route\":1463:{a:9:{s:4:\"path\";s:54:\"/admin/commerce/orders/{commerce_order}/resend-receipt\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:29:\"commerce_order.resend-receipt\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:29:\"commerce_order.resend_receipt\";s:14:\"commerce_order\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":614:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/commerce/orders/(?P<commerce_order>\\d+)/resend\\-receipt$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/resend-receipt\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:29;s:14:\"patternOutline\";s:39:\"/admin/commerce/orders/%/resend-receipt\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_order.unlock_form','/admin/commerce/orders/{commerce_order}/unlock','/admin/commerce/orders/%/unlock',29,'C:31:\"Symfony\\Component\\Routing\\Route\":1302:{a:9:{s:4:\"path\";s:46:\"/admin/commerce/orders/{commerce_order}/unlock\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:21:\"commerce_order.unlock\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:21:\"commerce_order.unlock\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":594:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/admin/commerce/orders/(?P<commerce_order>[^/]++)/unlock$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/unlock\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:29;s:14:\"patternOutline\";s:31:\"/admin/commerce/orders/%/unlock\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_order.user_view','/user/{user}/orders/{commerce_order}','/user/%/orders/%',10,'C:31:\"Symfony\\Component\\Routing\\Route\":1471:{a:9:{s:4:\"path\";s:36:\"/user/{user}/orders/{commerce_order}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_view\";s:19:\"commerce_order.user\";s:6:\"_title\";s:17:\"Order information\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"commerce_order.view\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:6:\"entity\";a:2:{s:4:\"user\";s:11:\"entity:user\";s:14:\"commerce_order\";s:12:\"entity:order\";}s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":672:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/user/(?P<user>[^/]++)/orders/(?P<commerce_order>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/orders\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:10;s:14:\"patternOutline\";s:16:\"/user/%/orders/%\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_order_item.field_ui_fields','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields','/admin/commerce/config/order-item-types/%/edit/fields',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1657:{a:9:{s:4:\"path\";s:78:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer commerce_order_item fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":704:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:53:\"/admin/commerce/config/order-item-types/%/edit/fields\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_order_item_type.add_form','/admin/commerce/config/order-item-types/add','/admin/commerce/config/order-item-types/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1162:{a:9:{s:4:\"path\";s:43:\"/admin/commerce/config/order-item-types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:28:\"commerce_order_item_type.add\";s:14:\"entity_type_id\";s:24:\"commerce_order_item_type\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:24:\"commerce_order_item_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":429:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/admin/commerce/config/order\\-item\\-types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/commerce/config/order-item-types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:43:\"/admin/commerce/config/order-item-types/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_order_item_type.collection','/admin/commerce/config/order-item-types','/admin/commerce/config/order-item-types',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1090:{a:9:{s:4:\"path\";s:39:\"/admin/commerce/config/order-item-types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:24:\"commerce_order_item_type\";s:6:\"_title\";s:16:\"Order item types\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:30:\"administer commerce_order_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":417:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/admin/commerce/config/order\\-item\\-types$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:39:\"/admin/commerce/config/order-item-types\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_order_item_type.delete_form','/admin/commerce/config/order-item-types/{commerce_order_item_type}/delete','/admin/commerce/config/order-item-types/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1595:{a:9:{s:4:\"path\";s:73:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:31:\"commerce_order_item_type.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:31:\"commerce_order_item_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":687:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:92:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:48:\"/admin/commerce/config/order-item-types/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_order_item_type.duplicate_form','/admin/commerce/config/order-item-types/{commerce_order_item_type}/duplicate','/admin/commerce/config/order-item-types/%/duplicate',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1686:{a:9:{s:4:\"path\";s:76:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:24:\"commerce_order_item_type\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:34:\"commerce_order_item_type.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":697:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:95:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:51:\"/admin/commerce/config/order-item-types/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_order_item_type.edit_form','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit','/admin/commerce/config/order-item-types/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1583:{a:9:{s:4:\"path\";s:71:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:29:\"commerce_order_item_type.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:31:\"commerce_order_item_type.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":681:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:90:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:46:\"/admin/commerce/config/order-item-types/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_order_type.add_form','/admin/commerce/config/order-types/add','/admin/commerce/config/order-types/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1126:{a:9:{s:4:\"path\";s:38:\"/admin/commerce/config/order-types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:23:\"commerce_order_type.add\";s:14:\"entity_type_id\";s:19:\"commerce_order_type\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:19:\"commerce_order_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":413:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/commerce/config/order\\-types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/admin/commerce/config/order-types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:38:\"/admin/commerce/config/order-types/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_order_type.collection','/admin/commerce/config/order-types','/admin/commerce/config/order-types',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1059:{a:9:{s:4:\"path\";s:34:\"/admin/commerce/config/order-types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:19:\"commerce_order_type\";s:6:\"_title\";s:11:\"Order types\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:30:\"administer commerce_order_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":401:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/commerce/config/order\\-types$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:34:\"/admin/commerce/config/order-types\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_order_type.delete_form','/admin/commerce/config/order-types/{commerce_order_type}/delete','/admin/commerce/config/order-types/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1529:{a:9:{s:4:\"path\";s:63:\"/admin/commerce/config/order-types/{commerce_order_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:26:\"commerce_order_type.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:26:\"commerce_order_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":651:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:81:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:43:\"/admin/commerce/config/order-types/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_order_type.duplicate_form','/admin/commerce/config/order-types/{commerce_order_type}/duplicate','/admin/commerce/config/order-types/%/duplicate',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1620:{a:9:{s:4:\"path\";s:66:\"/admin/commerce/config/order-types/{commerce_order_type}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:19:\"commerce_order_type\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:29:\"commerce_order_type.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":661:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:46:\"/admin/commerce/config/order-types/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_order_type.edit_form','/admin/commerce/config/order-types/{commerce_order_type}/edit','/admin/commerce/config/order-types/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1517:{a:9:{s:4:\"path\";s:61:\"/admin/commerce/config/order-types/{commerce_order_type}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"commerce_order_type.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:26:\"commerce_order_type.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":645:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:41:\"/admin/commerce/config/order-types/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_payment.add_form','/admin/commerce/orders/{commerce_order}/payments/add','/admin/commerce/orders/%/payments/add',59,'C:31:\"Symfony\\Component\\Routing\\Route\":1391:{a:9:{s:4:\"path\";s:52:\"/admin/commerce/orders/{commerce_order}/payments/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:44:\"\\Drupal\\commerce_payment\\Form\\PaymentAddForm\";s:6:\"_title\";s:11:\"Add payment\";}s:12:\"requirements\";a:1:{s:25:\"_entity_create_any_access\";s:16:\"commerce_payment\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.entity_create_any\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":613:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/commerce/orders/(?P<commerce_order>[^/]++)/payments/add$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/payments/add\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:59;s:14:\"patternOutline\";s:37:\"/admin/commerce/orders/%/payments/add\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_payment.collection','/admin/commerce/orders/{commerce_order}/payments','/admin/commerce/orders/%/payments',29,'C:31:\"Symfony\\Component\\Routing\\Route\":1340:{a:9:{s:4:\"path\";s:48:\"/admin/commerce/orders/{commerce_order}/payments\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:16:\"commerce_payment\";s:6:\"_title\";s:8:\"Payments\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"administer commerce_payment\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":600:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/commerce/orders/(?P<commerce_order>[^/]++)/payments$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/payments\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:29;s:14:\"patternOutline\";s:33:\"/admin/commerce/orders/%/payments\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_payment.delete_form','/admin/commerce/orders/{commerce_order}/payments/{commerce_payment}/delete','/admin/commerce/orders/%/payments/%/delete',117,'C:31:\"Symfony\\Component\\Routing\\Route\":1702:{a:9:{s:4:\"path\";s:74:\"/admin/commerce/orders/{commerce_order}/payments/{commerce_payment}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"commerce_payment.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:23:\"commerce_payment.delete\";s:16:\"commerce_payment\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"commerce_payment\";a:2:{s:4:\"type\";s:23:\"entity:commerce_payment\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":833:{a:11:{s:4:\"vars\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:16:\"commerce_payment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/commerce/orders/(?P<commerce_order>[^/]++)/payments/(?P<commerce_payment>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:16:\"commerce_payment\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/payments\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:16:\"commerce_payment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:117;s:14:\"patternOutline\";s:42:\"/admin/commerce/orders/%/payments/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_payment.edit_form','/admin/commerce/orders/{commerce_order}/payments/commerce_payment/edit','/admin/commerce/orders/%/payments/commerce_payment/edit',119,'C:31:\"Symfony\\Component\\Routing\\Route\":1532:{a:9:{s:4:\"path\";s:70:\"/admin/commerce/orders/{commerce_order}/payments/commerce_payment/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"commerce_payment.default\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:23:\"commerce_payment.update\";s:16:\"commerce_payment\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"commerce_payment\";a:2:{s:4:\"type\";s:23:\"entity:commerce_payment\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":668:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_order\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/commerce/orders/(?P<commerce_order>[^/]++)/payments/commerce_payment/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/payments/commerce_payment/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_order\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:119;s:14:\"patternOutline\";s:55:\"/admin/commerce/orders/%/payments/commerce_payment/edit\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_payment.operation_form','/admin/commerce/orders/{commerce_order}/payments/{commerce_payment}/operation/{operation}','/admin/commerce/orders/%/payments/%/operation/%',234,'C:31:\"Symfony\\Component\\Routing\\Route\":1896:{a:9:{s:4:\"path\";s:89:\"/admin/commerce/orders/{commerce_order}/payments/{commerce_payment}/operation/{operation}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:26:\"commerce_payment.operation\";}s:12:\"requirements\";a:1:{s:34:\"_commerce_payment_operation_access\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:21:\"entity:commerce_order\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:16:\"commerce_payment\";a:2:{s:4:\"type\";s:23:\"entity:commerce_payment\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:39:\"access_check.commerce_payment.operation\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1000:{a:11:{s:4:\"vars\";a:3:{i:0;s:14:\"commerce_order\";i:1;s:16:\"commerce_payment\";i:2;s:9:\"operation\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:126:\"#^/admin/commerce/orders/(?P<commerce_order>[^/]++)/payments/(?P<commerce_payment>[^/]++)/operation/(?P<operation>[^/]++)$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"operation\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/operation\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"commerce_payment\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/payments\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"commerce_order\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:3:{i:0;s:14:\"commerce_order\";i:1;s:16:\"commerce_payment\";i:2;s:9:\"operation\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:234;s:14:\"patternOutline\";s:47:\"/admin/commerce/orders/%/payments/%/operation/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.commerce_payment_gateway.add_form','/admin/commerce/config/payment-gateways/add','/admin/commerce/config/payment-gateways/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1161:{a:9:{s:4:\"path\";s:43:\"/admin/commerce/config/payment-gateways/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:28:\"commerce_payment_gateway.add\";s:14:\"entity_type_id\";s:24:\"commerce_payment_gateway\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:24:\"commerce_payment_gateway\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":428:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/admin/commerce/config/payment\\-gateways/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/commerce/config/payment-gateways/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:43:\"/admin/commerce/config/payment-gateways/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_payment_gateway.collection','/admin/commerce/config/payment-gateways','/admin/commerce/config/payment-gateways',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1094:{a:9:{s:4:\"path\";s:39:\"/admin/commerce/config/payment-gateways\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:24:\"commerce_payment_gateway\";s:6:\"_title\";s:16:\"Payment gateways\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:35:\"administer commerce_payment_gateway\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":416:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/commerce/config/payment\\-gateways$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/payment-gateways\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:39:\"/admin/commerce/config/payment-gateways\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_payment_gateway.delete_form','/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}/delete','/admin/commerce/config/payment-gateways/manage/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1623:{a:9:{s:4:\"path\";s:80:\"/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:31:\"commerce_payment_gateway.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:31:\"commerce_payment_gateway.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_payment_gateway\";a:2:{s:4:\"type\";s:31:\"entity:commerce_payment_gateway\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":708:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_payment_gateway\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/commerce/config/payment\\-gateways/manage/(?P<commerce_payment_gateway>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_payment_gateway\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/payment-gateways/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_payment_gateway\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:55:\"/admin/commerce/config/payment-gateways/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_payment_gateway.duplicate_form','/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}/duplicate','/admin/commerce/config/payment-gateways/manage/%/duplicate',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1715:{a:9:{s:4:\"path\";s:83:\"/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:24:\"commerce_payment_gateway\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:34:\"commerce_payment_gateway.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_payment_gateway\";a:2:{s:4:\"type\";s:31:\"entity:commerce_payment_gateway\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":719:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_payment_gateway\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:101:\"#^/admin/commerce/config/payment\\-gateways/manage/(?P<commerce_payment_gateway>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_payment_gateway\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/payment-gateways/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_payment_gateway\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:58:\"/admin/commerce/config/payment-gateways/manage/%/duplicate\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_payment_gateway.edit_form','/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}','/admin/commerce/config/payment-gateways/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1554:{a:9:{s:4:\"path\";s:73:\"/admin/commerce/config/payment-gateways/manage/{commerce_payment_gateway}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:29:\"commerce_payment_gateway.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:31:\"commerce_payment_gateway.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_payment_gateway\";a:2:{s:4:\"type\";s:31:\"entity:commerce_payment_gateway\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":650:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_payment_gateway\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:91:\"#^/admin/commerce/config/payment\\-gateways/manage/(?P<commerce_payment_gateway>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_payment_gateway\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/payment-gateways/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_payment_gateway\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:48:\"/admin/commerce/config/payment-gateways/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_payment_method.add_form','/user/{user}/payment-methods/add','/user/%/payment-methods/add',11,'C:31:\"Symfony\\Component\\Routing\\Route\":1297:{a:9:{s:4:\"path\";s:32:\"/user/{user}/payment-methods/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:50:\"\\Drupal\\commerce_payment\\Form\\PaymentMethodAddForm\";s:6:\"_title\";s:18:\"Add payment method\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:69:\"\\Drupal\\commerce_payment\\Access\\PaymentMethodAccessCheck::checkAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":540:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/user/(?P<user>[^/]++)/payment\\-methods/add$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/payment-methods/add\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:27:\"/user/%/payment-methods/add\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_payment_method.collection','/user/{user}/payment-methods','/user/%/payment-methods',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1258:{a:9:{s:4:\"path\";s:28:\"/user/{user}/payment-methods\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:23:\"commerce_payment_method\";s:6:\"_title\";s:15:\"Payment methods\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:69:\"\\Drupal\\commerce_payment\\Access\\PaymentMethodAccessCheck::checkAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":527:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/user/(?P<user>[^/]++)/payment\\-methods$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/payment-methods\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:23:\"/user/%/payment-methods\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_payment_method.delete_form','/user/{user}/payment-methods/{commerce_payment_method}/delete','/user/%/payment-methods/%/delete',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1655:{a:9:{s:4:\"path\";s:61:\"/user/{user}/payment-methods/{commerce_payment_method}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:30:\"commerce_payment_method.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:30:\"commerce_payment_method.delete\";s:23:\"commerce_payment_method\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:23:\"commerce_payment_method\";a:2:{s:4:\"type\";s:30:\"entity:commerce_payment_method\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":788:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:23:\"commerce_payment_method\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/user/(?P<user>[^/]++)/payment\\-methods/(?P<commerce_payment_method>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:23:\"commerce_payment_method\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/payment-methods\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:23:\"commerce_payment_method\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:32:\"/user/%/payment-methods/%/delete\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_payment_method.edit_form','/user/{user}/payment-methods/{commerce_payment_method}/edit','/user/%/payment-methods/%/edit',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1643:{a:9:{s:4:\"path\";s:59:\"/user/{user}/payment-methods/{commerce_payment_method}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:28:\"commerce_payment_method.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:30:\"commerce_payment_method.update\";s:23:\"commerce_payment_method\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:23:\"commerce_payment_method\";a:2:{s:4:\"type\";s:30:\"entity:commerce_payment_method\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":782:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:23:\"commerce_payment_method\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/user/(?P<user>[^/]++)/payment\\-methods/(?P<commerce_payment_method>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:23:\"commerce_payment_method\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/payment-methods\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:23:\"commerce_payment_method\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:30:\"/user/%/payment-methods/%/edit\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_product.add_form','/product/add/{commerce_product_type}','/product/add/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1503:{a:9:{s:4:\"path\";s:36:\"/product/add/{commerce_product_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:20:\"commerce_product.add\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:15:\"_title_callback\";s:62:\"Drupal\\Core\\Entity\\Controller\\EntityController::addBundleTitle\";s:16:\"bundle_parameter\";s:21:\"commerce_product_type\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:40:\"commerce_product:{commerce_product_type}\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:3:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:21:\"with_config_overrides\";b:1;s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":534:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/product/add/(?P<commerce_product_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/product/add\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:14:\"/product/add/%\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_product.add_page','/product/add','/product/add',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1053:{a:9:{s:4:\"path\";s:12:\"/product/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:55:\"Drupal\\Core\\Entity\\Controller\\EntityController::addPage\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";s:14:\"entity_type_id\";s:16:\"commerce_product\";}s:12:\"requirements\";a:1:{s:25:\"_entity_create_any_access\";s:16:\"commerce_product\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.entity_create_any\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":333:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/product/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/product/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/product/add\";s:8:\"numParts\";i:2;}}}}',2),

('entity.commerce_product.canonical','/product/{commerce_product}','/product/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1283:{a:9:{s:4:\"path\";s:27:\"/product/{commerce_product}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_view\";s:21:\"commerce_product.full\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:21:\"commerce_product.view\";s:16:\"commerce_product\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"commerce_product\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":495:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"commerce_product\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/product/(?P<commerce_product>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:16:\"commerce_product\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/product\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"commerce_product\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:10:\"/product/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.commerce_product.collection','/admin/commerce/products','/admin/commerce/products',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1315:{a:9:{s:4:\"path\";s:24:\"/admin/commerce/products\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Products\";s:7:\"view_id\";s:17:\"commerce_products\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:32:\"access commerce_product overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/commerce/products$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/commerce/products\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/commerce/products\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_product.delete_form','/product/{commerce_product}/delete','/product/%/delete',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1381:{a:9:{s:4:\"path\";s:34:\"/product/{commerce_product}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"commerce_product.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:23:\"commerce_product.delete\";s:16:\"commerce_product\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"commerce_product\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":552:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"commerce_product\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/product/(?P<commerce_product>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:16:\"commerce_product\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/product\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"commerce_product\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/product/%/delete\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_product.delete_multiple_form','/admin/commerce/products/delete','/admin/commerce/products/delete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1029:{a:9:{s:4:\"path\";s:31:\"/admin/commerce/products/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"\\Drupal\\entity\\Form\\DeleteMultipleForm\";s:14:\"entity_type_id\";s:16:\"commerce_product\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:16:\"commerce_product\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/commerce/products/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/commerce/products/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/commerce/products/delete\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_product.edit_form','/product/{commerce_product}/edit','/product/%/edit',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1369:{a:9:{s:4:\"path\";s:32:\"/product/{commerce_product}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"commerce_product.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:23:\"commerce_product.update\";s:16:\"commerce_product\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"commerce_product\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":546:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"commerce_product\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/product/(?P<commerce_product>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:16:\"commerce_product\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/product\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"commerce_product\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/product/%/edit\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_product.field_ui_fields','/admin/commerce/config/product-types/{commerce_product_type}/edit/fields','/admin/commerce/config/product-types/%/edit/fields',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1617:{a:9:{s:4:\"path\";s:72:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:34:\"administer commerce_product fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":682:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:90:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:50:\"/admin/commerce/config/product-types/%/edit/fields\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_product_attribute.add_form','/admin/commerce/product-attributes/add','/admin/commerce/product-attributes/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1147:{a:9:{s:4:\"path\";s:38:\"/admin/commerce/product-attributes/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:30:\"commerce_product_attribute.add\";s:14:\"entity_type_id\";s:26:\"commerce_product_attribute\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:26:\"commerce_product_attribute\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":413:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/commerce/product\\-attributes/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/admin/commerce/product-attributes/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:38:\"/admin/commerce/product-attributes/add\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_product_attribute.collection','/admin/commerce/product-attributes','/admin/commerce/product-attributes',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1122:{a:9:{s:4:\"path\";s:34:\"/admin/commerce/product-attributes\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:26:\"commerce_product_attribute\";s:6:\"_title\";s:18:\"Product attributes\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:80:\"administer commerce_product_attribute+access commerce_product_attribute overview\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/commerce/product\\-attributes$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/product-attributes\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:34:\"/admin/commerce/product-attributes\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_product_attribute.delete_form','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/delete','/admin/commerce/product-attributes/manage/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1620:{a:9:{s:4:\"path\";s:77:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:33:\"commerce_product_attribute.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:33:\"commerce_product_attribute.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":700:{a:11:{s:4:\"vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:95:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:50:\"/admin/commerce/product-attributes/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_product_attribute.edit_form','/admin/commerce/product-attributes/manage/{commerce_product_attribute}','/admin/commerce/product-attributes/manage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1552:{a:9:{s:4:\"path\";s:70:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:31:\"commerce_product_attribute.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:33:\"commerce_product_attribute.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":643:{a:11:{s:4:\"vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:43:\"/admin/commerce/product-attributes/manage/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_product_attribute_value.field_ui_fields','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields','/admin/commerce/product-attributes/manage/%/fields',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1682:{a:9:{s:4:\"path\";s:77:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:50:\"administer commerce_product_attribute_value fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":700:{a:11:{s:4:\"vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:95:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:50:\"/admin/commerce/product-attributes/manage/%/fields\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_product_type.add_form','/admin/commerce/config/product-types/add','/admin/commerce/config/product-types/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1140:{a:9:{s:4:\"path\";s:40:\"/admin/commerce/config/product-types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"commerce_product_type.add\";s:14:\"entity_type_id\";s:21:\"commerce_product_type\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:21:\"commerce_product_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":419:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/admin/commerce/config/product\\-types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/commerce/config/product-types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:40:\"/admin/commerce/config/product-types/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_product_type.collection','/admin/commerce/config/product-types','/admin/commerce/config/product-types',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1073:{a:9:{s:4:\"path\";s:36:\"/admin/commerce/config/product-types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:21:\"commerce_product_type\";s:6:\"_title\";s:13:\"Product types\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer commerce_product_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":407:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/commerce/config/product\\-types$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:36:\"/admin/commerce/config/product-types\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_product_type.delete_form','/admin/commerce/config/product-types/{commerce_product_type}/delete','/admin/commerce/config/product-types/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1555:{a:9:{s:4:\"path\";s:67:\"/admin/commerce/config/product-types/{commerce_product_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:28:\"commerce_product_type.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:28:\"commerce_product_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":665:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:85:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:45:\"/admin/commerce/config/product-types/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_product_type.duplicate_form','/admin/commerce/config/product-types/{commerce_product_type}/duplicate','/admin/commerce/config/product-types/%/duplicate',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1646:{a:9:{s:4:\"path\";s:70:\"/admin/commerce/config/product-types/{commerce_product_type}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:21:\"commerce_product_type\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:31:\"commerce_product_type.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":675:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:48:\"/admin/commerce/config/product-types/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_product_type.edit_form','/admin/commerce/config/product-types/{commerce_product_type}/edit','/admin/commerce/config/product-types/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1543:{a:9:{s:4:\"path\";s:65:\"/admin/commerce/config/product-types/{commerce_product_type}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:26:\"commerce_product_type.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:28:\"commerce_product_type.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":659:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:83:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:43:\"/admin/commerce/config/product-types/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_product_variation.add_form','/product/{commerce_product}/variations/add','/product/%/variations/add',11,'C:31:\"Symfony\\Component\\Routing\\Route\":1477:{a:9:{s:4:\"path\";s:42:\"/product/{commerce_product}/variations/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:30:\"commerce_product_variation.add\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:15:\"_title_callback\";s:71:\"Drupal\\commerce_product\\Controller\\ProductVariationController::addTitle\";}s:12:\"requirements\";a:1:{s:32:\"_product_variation_create_access\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"commerce_product\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:37:\"access_check.product_variation_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":584:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"commerce_product\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/product/(?P<commerce_product>[^/]++)/variations/add$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/variations/add\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"commerce_product\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/product\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"commerce_product\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:25:\"/product/%/variations/add\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_product_variation.collection','/product/{commerce_product}/variations','/product/%/variations',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1415:{a:9:{s:4:\"path\";s:38:\"/product/{commerce_product}/variations\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:26:\"commerce_product_variation\";s:15:\"_title_callback\";s:78:\"Drupal\\commerce_product\\Controller\\ProductVariationController::collectionTitle\";}s:12:\"requirements\";a:1:{s:36:\"_product_variation_collection_access\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"commerce_product\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:41:\"access_check.product_variation_collection\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":571:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"commerce_product\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/product/(?P<commerce_product>[^/]++)/variations$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/variations\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"commerce_product\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/product\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"commerce_product\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:21:\"/product/%/variations\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_product_variation.delete_form','/product/{commerce_product}/variations/{commerce_product_variation}/delete','/product/%/variations/%/delete',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1894:{a:9:{s:4:\"path\";s:74:\"/product/{commerce_product}/variations/{commerce_product_variation}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:33:\"commerce_product_variation.delete\";s:15:\"_title_callback\";s:74:\"Drupal\\commerce_product\\Controller\\ProductVariationController::deleteTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:33:\"commerce_product_variation.delete\";s:26:\"commerce_product_variation\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:16:\"commerce_product\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:26:\"commerce_product_variation\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_variation\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":844:{a:11:{s:4:\"vars\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:26:\"commerce_product_variation\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/product/(?P<commerce_product>[^/]++)/variations/(?P<commerce_product_variation>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:26:\"commerce_product_variation\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/variations\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"commerce_product\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/product\";}}s:9:\"path_vars\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:26:\"commerce_product_variation\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:30:\"/product/%/variations/%/delete\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_product_variation.duplicate_form','/product/{commerce_product}/variations/{commerce_product_variation}/duplicate','/product/%/variations/%/duplicate',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1855:{a:9:{s:4:\"path\";s:77:\"/product/{commerce_product}/variations/{commerce_product_variation}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:36:\"commerce_product_variation.duplicate\";s:26:\"commerce_product_variation\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_variation\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_variation\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":855:{a:11:{s:4:\"vars\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:26:\"commerce_product_variation\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:101:\"#^/product/(?P<commerce_product>[^/]++)/variations/(?P<commerce_product_variation>\\d+)/duplicate$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:26:\"commerce_product_variation\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/variations\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"commerce_product\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/product\";}}s:9:\"path_vars\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:26:\"commerce_product_variation\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:33:\"/product/%/variations/%/duplicate\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_product_variation.edit_form','/product/{commerce_product}/variations/{commerce_product_variation}/edit','/product/%/variations/%/edit',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1882:{a:9:{s:4:\"path\";s:72:\"/product/{commerce_product}/variations/{commerce_product_variation}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:31:\"commerce_product_variation.edit\";s:15:\"_title_callback\";s:72:\"Drupal\\commerce_product\\Controller\\ProductVariationController::editTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:33:\"commerce_product_variation.update\";s:26:\"commerce_product_variation\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:16:\"commerce_product\";a:2:{s:4:\"type\";s:23:\"entity:commerce_product\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:26:\"commerce_product_variation\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_variation\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":838:{a:11:{s:4:\"vars\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:26:\"commerce_product_variation\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:96:\"#^/product/(?P<commerce_product>[^/]++)/variations/(?P<commerce_product_variation>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:26:\"commerce_product_variation\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/variations\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"commerce_product\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/product\";}}s:9:\"path_vars\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:26:\"commerce_product_variation\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:28:\"/product/%/variations/%/edit\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_product_variation.field_ui_fields','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields','/admin/commerce/config/product-variation-types/%/edit/fields',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1749:{a:9:{s:4:\"path\";s:92:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:44:\"administer commerce_product_variation fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":754:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:111:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:60:\"/admin/commerce/config/product-variation-types/%/edit/fields\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_product_variation_type.add_form','/admin/commerce/config/product-variation-types/add','/admin/commerce/config/product-variation-types/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1211:{a:9:{s:4:\"path\";s:50:\"/admin/commerce/config/product-variation-types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:35:\"commerce_product_variation_type.add\";s:14:\"entity_type_id\";s:31:\"commerce_product_variation_type\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:31:\"commerce_product_variation_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":450:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/admin/commerce/config/product\\-variation\\-types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:50:\"/admin/commerce/config/product-variation-types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:50:\"/admin/commerce/config/product-variation-types/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_product_variation_type.collection','/admin/commerce/config/product-variation-types','/admin/commerce/config/product-variation-types',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1134:{a:9:{s:4:\"path\";s:46:\"/admin/commerce/config/product-variation-types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:31:\"commerce_product_variation_type\";s:6:\"_title\";s:23:\"Product variation types\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer commerce_product_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":438:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/admin/commerce/config/product\\-variation\\-types$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:46:\"/admin/commerce/config/product-variation-types\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_product_variation_type.delete_form','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/delete','/admin/commerce/config/product-variation-types/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1687:{a:9:{s:4:\"path\";s:87:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:38:\"commerce_product_variation_type.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:38:\"commerce_product_variation_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":737:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:106:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:55:\"/admin/commerce/config/product-variation-types/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_product_variation_type.duplicate_form','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/duplicate','/admin/commerce/config/product-variation-types/%/duplicate',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1778:{a:9:{s:4:\"path\";s:90:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:31:\"commerce_product_variation_type\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:41:\"commerce_product_variation_type.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":747:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:109:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:58:\"/admin/commerce/config/product-variation-types/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_product_variation_type.edit_form','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit','/admin/commerce/config/product-variation-types/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1675:{a:9:{s:4:\"path\";s:85:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:36:\"commerce_product_variation_type.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:38:\"commerce_product_variation_type.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":731:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:53:\"/admin/commerce/config/product-variation-types/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_promotion.add_form','/promotion/add','/promotion/add',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1025:{a:9:{s:4:\"path\";s:14:\"/promotion/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:22:\"commerce_promotion.add\";s:14:\"entity_type_id\";s:18:\"commerce_promotion\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:18:\"commerce_promotion\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":339:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/promotion/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/promotion/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/promotion/add\";s:8:\"numParts\";i:2;}}}}',2),

('entity.commerce_promotion.collection','/admin/commerce/promotions','/admin/commerce/promotions',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1057:{a:9:{s:4:\"path\";s:26:\"/admin/commerce/promotions\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:18:\"commerce_promotion\";s:6:\"_title\";s:10:\"Promotions\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:64:\"administer commerce_promotion+access commerce_promotion overview\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":375:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/commerce/promotions$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/commerce/promotions\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:26:\"/admin/commerce/promotions\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_promotion.delete_form','/promotion/{commerce_promotion}/delete','/promotion/%/delete',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1410:{a:9:{s:4:\"path\";s:38:\"/promotion/{commerce_promotion}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"commerce_promotion.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:25:\"commerce_promotion.delete\";s:18:\"commerce_promotion\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"commerce_promotion\";a:2:{s:4:\"type\";s:25:\"entity:commerce_promotion\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":567:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/promotion/(?P<commerce_promotion>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:18:\"commerce_promotion\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/promotion\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:19:\"/promotion/%/delete\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_promotion.delete_multiple_form','/admin/commerce/promotions/delete','/admin/commerce/promotions/delete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1041:{a:9:{s:4:\"path\";s:33:\"/admin/commerce/promotions/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"\\Drupal\\entity\\Form\\DeleteMultipleForm\";s:14:\"entity_type_id\";s:18:\"commerce_promotion\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:18:\"commerce_promotion\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/commerce/promotions/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/commerce/promotions/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:33:\"/admin/commerce/promotions/delete\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_promotion.duplicate_form','/promotion/{commerce_promotion}/duplicate','/promotion/%/duplicate',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1501:{a:9:{s:4:\"path\";s:41:\"/promotion/{commerce_promotion}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:18:\"commerce_promotion\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:28:\"commerce_promotion.duplicate\";s:18:\"commerce_promotion\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"commerce_promotion\";a:2:{s:4:\"type\";s:25:\"entity:commerce_promotion\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":577:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/promotion/(?P<commerce_promotion>\\d+)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:18:\"commerce_promotion\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/promotion\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:22:\"/promotion/%/duplicate\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_promotion.edit_form','/promotion/{commerce_promotion}/edit','/promotion/%/edit',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1398:{a:9:{s:4:\"path\";s:36:\"/promotion/{commerce_promotion}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"commerce_promotion.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:25:\"commerce_promotion.update\";s:18:\"commerce_promotion\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"commerce_promotion\";a:2:{s:4:\"type\";s:25:\"entity:commerce_promotion\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":561:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/promotion/(?P<commerce_promotion>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:18:\"commerce_promotion\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/promotion\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/promotion/%/edit\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_promotion_coupon.add_form','/promotion/{commerce_promotion}/coupons/add','/promotion/%/coupons/add',11,'C:31:\"Symfony\\Component\\Routing\\Route\":1457:{a:9:{s:4:\"path\";s:43:\"/promotion/{commerce_promotion}/coupons/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:29:\"commerce_promotion_coupon.add\";s:14:\"entity_type_id\";s:25:\"commerce_promotion_coupon\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"commerce_promotion.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"commerce_promotion\";a:2:{s:4:\"type\";s:25:\"entity:commerce_promotion\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":590:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:60:\"#^/promotion/(?P<commerce_promotion>[^/]++)/coupons/add$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/coupons/add\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"commerce_promotion\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/promotion\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:24:\"/promotion/%/coupons/add\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_promotion_coupon.collection','/promotion/{commerce_promotion}/coupons','/promotion/%/coupons',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1320:{a:9:{s:4:\"path\";s:39:\"/promotion/{commerce_promotion}/coupons\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:25:\"commerce_promotion_coupon\";s:6:\"_title\";s:7:\"Coupons\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"commerce_promotion.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"commerce_promotion\";a:2:{s:4:\"type\";s:25:\"entity:commerce_promotion\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":576:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:56:\"#^/promotion/(?P<commerce_promotion>[^/]++)/coupons$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/coupons\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"commerce_promotion\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/promotion\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:20:\"/promotion/%/coupons\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_promotion_coupon.delete_form','/promotion/{commerce_promotion}/coupons/{commerce_promotion_coupon}/delete','/promotion/%/coupons/%/delete',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1759:{a:9:{s:4:\"path\";s:74:\"/promotion/{commerce_promotion}/coupons/{commerce_promotion_coupon}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:32:\"commerce_promotion_coupon.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:32:\"commerce_promotion_coupon.delete\";s:25:\"commerce_promotion_coupon\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:25:\"commerce_promotion_coupon\";a:2:{s:4:\"type\";s:32:\"entity:commerce_promotion_coupon\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":845:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"commerce_promotion\";i:1;s:25:\"commerce_promotion_coupon\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/promotion/(?P<commerce_promotion>[^/]++)/coupons/(?P<commerce_promotion_coupon>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:25:\"commerce_promotion_coupon\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/coupons\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"commerce_promotion\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/promotion\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"commerce_promotion\";i:1;s:25:\"commerce_promotion_coupon\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:29:\"/promotion/%/coupons/%/delete\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_promotion_coupon.edit_form','/promotion/{commerce_promotion}/coupons/{commerce_promotion_coupon}/edit','/promotion/%/coupons/%/edit',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1747:{a:9:{s:4:\"path\";s:72:\"/promotion/{commerce_promotion}/coupons/{commerce_promotion_coupon}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:30:\"commerce_promotion_coupon.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:32:\"commerce_promotion_coupon.update\";s:25:\"commerce_promotion_coupon\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:25:\"commerce_promotion_coupon\";a:2:{s:4:\"type\";s:32:\"entity:commerce_promotion_coupon\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":839:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"commerce_promotion\";i:1;s:25:\"commerce_promotion_coupon\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:96:\"#^/promotion/(?P<commerce_promotion>[^/]++)/coupons/(?P<commerce_promotion_coupon>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:25:\"commerce_promotion_coupon\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/coupons\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"commerce_promotion\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/promotion\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"commerce_promotion\";i:1;s:25:\"commerce_promotion_coupon\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:27:\"/promotion/%/coupons/%/edit\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_promotion_coupon.generate_form','/promotion/{commerce_promotion}/coupons/generate','/promotion/%/coupons/generate',11,'C:31:\"Symfony\\Component\\Routing\\Route\":1400:{a:9:{s:4:\"path\";s:48:\"/promotion/{commerce_promotion}/coupons/generate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:50:\"\\Drupal\\commerce_promotion\\Form\\CouponGenerateForm\";s:6:\"_title\";s:16:\"Generate coupons\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:39:\"bulk generate commerce_promotion_coupon\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"commerce_promotion\";a:2:{s:4:\"type\";s:25:\"entity:commerce_promotion\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":605:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/promotion/(?P<commerce_promotion>[^/]++)/coupons/generate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/coupons/generate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"commerce_promotion\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/promotion\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"commerce_promotion\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:29:\"/promotion/%/coupons/generate\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_store.add_form','/store/add/{commerce_store_type}','/store/add/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1471:{a:9:{s:4:\"path\";s:32:\"/store/add/{commerce_store_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:18:\"commerce_store.add\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:15:\"_title_callback\";s:62:\"Drupal\\Core\\Entity\\Controller\\EntityController::addBundleTitle\";s:16:\"bundle_parameter\";s:19:\"commerce_store_type\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:36:\"commerce_store:{commerce_store_type}\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:3:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:21:\"with_config_overrides\";b:1;s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":520:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:49:\"#^/store/add/(?P<commerce_store_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/store/add\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:12:\"/store/add/%\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_store.add_page','/store/add','/store/add',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1041:{a:9:{s:4:\"path\";s:10:\"/store/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:55:\"Drupal\\Core\\Entity\\Controller\\EntityController::addPage\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";s:14:\"entity_type_id\";s:14:\"commerce_store\";}s:12:\"requirements\";a:1:{s:25:\"_entity_create_any_access\";s:14:\"commerce_store\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.entity_create_any\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":327:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/store/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/store/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:10:\"/store/add\";s:8:\"numParts\";i:2;}}}}',2),

('entity.commerce_store.canonical','/store/{commerce_store}','/store/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1254:{a:9:{s:4:\"path\";s:23:\"/store/{commerce_store}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_view\";s:19:\"commerce_store.full\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:19:\"commerce_store.view\";s:14:\"commerce_store\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_store\";a:2:{s:4:\"type\";s:21:\"entity:commerce_store\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":480:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_store\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/store/(?P<commerce_store>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:14:\"commerce_store\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/store\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_store\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:8:\"/store/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.commerce_store.collection','/admin/commerce/config/stores','/admin/commerce/config/stores',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1330:{a:9:{s:4:\"path\";s:29:\"/admin/commerce/config/stores\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:6:\"Stores\";s:7:\"view_id\";s:15:\"commerce_stores\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:30:\"access commerce_store overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/commerce/config/stores$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/commerce/config/stores\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/commerce/config/stores\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_store.delete_form','/store/{commerce_store}/delete','/store/%/delete',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1353:{a:9:{s:4:\"path\";s:30:\"/store/{commerce_store}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"commerce_store.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:21:\"commerce_store.delete\";s:14:\"commerce_store\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_store\";a:2:{s:4:\"type\";s:21:\"entity:commerce_store\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":538:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_store\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/store/(?P<commerce_store>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:14:\"commerce_store\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/store\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_store\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/store/%/delete\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_store.delete_multiple_form','/admin/commerce/config/stores/delete','/admin/commerce/config/stores/delete',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1045:{a:9:{s:4:\"path\";s:36:\"/admin/commerce/config/stores/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"\\Drupal\\entity\\Form\\DeleteMultipleForm\";s:14:\"entity_type_id\";s:14:\"commerce_store\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:14:\"commerce_store\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":406:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/commerce/config/stores/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/stores/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:36:\"/admin/commerce/config/stores/delete\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_store.duplicate_form','/store/{commerce_store}/duplicate','/store/%/duplicate',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1444:{a:9:{s:4:\"path\";s:33:\"/store/{commerce_store}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:14:\"commerce_store\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:24:\"commerce_store.duplicate\";s:14:\"commerce_store\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_store\";a:2:{s:4:\"type\";s:21:\"entity:commerce_store\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":548:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_store\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/store/(?P<commerce_store>\\d+)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:14:\"commerce_store\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/store\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_store\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:18:\"/store/%/duplicate\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_store.edit_form','/store/{commerce_store}/edit','/store/%/edit',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1341:{a:9:{s:4:\"path\";s:28:\"/store/{commerce_store}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"commerce_store.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:21:\"commerce_store.update\";s:14:\"commerce_store\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:14:\"commerce_store\";a:2:{s:4:\"type\";s:21:\"entity:commerce_store\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":532:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"commerce_store\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/store/(?P<commerce_store>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:14:\"commerce_store\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/store\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"commerce_store\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:13:\"/store/%/edit\";s:8:\"numParts\";i:3;}}}}',3),

('entity.commerce_store.field_ui_fields','/admin/commerce/config/store-types/{commerce_store_type}/edit/fields','/admin/commerce/config/store-types/%/edit/fields',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1591:{a:9:{s:4:\"path\";s:68:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer commerce_store fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":668:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:48:\"/admin/commerce/config/store-types/%/edit/fields\";s:8:\"numParts\";i:7;}}}}',7),

('entity.commerce_store_type.add_form','/admin/commerce/config/store-types/add','/admin/commerce/config/store-types/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1126:{a:9:{s:4:\"path\";s:38:\"/admin/commerce/config/store-types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:23:\"commerce_store_type.add\";s:14:\"entity_type_id\";s:19:\"commerce_store_type\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:19:\"commerce_store_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":413:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/commerce/config/store\\-types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/admin/commerce/config/store-types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:38:\"/admin/commerce/config/store-types/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.commerce_store_type.collection','/admin/commerce/config/store-types','/admin/commerce/config/store-types',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1059:{a:9:{s:4:\"path\";s:34:\"/admin/commerce/config/store-types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:19:\"commerce_store_type\";s:6:\"_title\";s:11:\"Store types\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:30:\"administer commerce_store_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":401:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/commerce/config/store\\-types$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:34:\"/admin/commerce/config/store-types\";s:8:\"numParts\";i:4;}}}}',4),

('entity.commerce_store_type.delete_form','/admin/commerce/config/store-types/{commerce_store_type}/delete','/admin/commerce/config/store-types/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1529:{a:9:{s:4:\"path\";s:63:\"/admin/commerce/config/store-types/{commerce_store_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:26:\"commerce_store_type.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:26:\"commerce_store_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":651:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:81:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:43:\"/admin/commerce/config/store-types/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_store_type.duplicate_form','/admin/commerce/config/store-types/{commerce_store_type}/duplicate','/admin/commerce/config/store-types/%/duplicate',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1620:{a:9:{s:4:\"path\";s:66:\"/admin/commerce/config/store-types/{commerce_store_type}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:19:\"commerce_store_type\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:29:\"commerce_store_type.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":661:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:46:\"/admin/commerce/config/store-types/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),

('entity.commerce_store_type.edit_form','/admin/commerce/config/store-types/{commerce_store_type}/edit','/admin/commerce/config/store-types/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1517:{a:9:{s:4:\"path\";s:61:\"/admin/commerce/config/store-types/{commerce_store_type}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"commerce_store_type.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:26:\"commerce_store_type.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":645:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:41:\"/admin/commerce/config/store-types/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.configurable_language.collection','/admin/config/regional/language','/admin/config/regional/language',15,'C:31:\"Symfony\\Component\\Routing\\Route\":976:{a:9:{s:4:\"path\";s:31:\"/admin/config/regional/language\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:21:\"configurable_language\";s:6:\"_title\";s:9:\"Languages\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer languages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/config/regional/language$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/config/regional/language\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/config/regional/language\";s:8:\"numParts\";i:4;}}}}',4),

('entity.configurable_language.delete_form','/admin/config/regional/language/delete/{configurable_language}','/admin/config/regional/language/delete/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1443:{a:9:{s:4:\"path\";s:62:\"/admin/config/regional/language/delete/{configurable_language}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:28:\"configurable_language.delete\";s:6:\"_title\";s:15:\"Delete language\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:28:\"configurable_language.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:21:\"configurable_language\";a:2:{s:4:\"type\";s:28:\"entity:configurable_language\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":613:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"configurable_language\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/admin/config/regional/language/delete/(?P<configurable_language>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"configurable_language\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/admin/config/regional/language/delete\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"configurable_language\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:40:\"/admin/config/regional/language/delete/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.configurable_language.edit_form','/admin/config/regional/language/edit/{configurable_language}','/admin/config/regional/language/edit/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1431:{a:9:{s:4:\"path\";s:60:\"/admin/config/regional/language/edit/{configurable_language}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:26:\"configurable_language.edit\";s:6:\"_title\";s:13:\"Edit language\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:28:\"configurable_language.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:21:\"configurable_language\";a:2:{s:4:\"type\";s:28:\"entity:configurable_language\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":607:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"configurable_language\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/regional/language/edit/(?P<configurable_language>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"configurable_language\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/regional/language/edit\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"configurable_language\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:38:\"/admin/config/regional/language/edit/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.contact_form.canonical','/contact/{contact_form}','/contact/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1204:{a:9:{s:4:\"path\";s:23:\"/contact/{contact_form}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:7:\"Contact\";s:11:\"_controller\";s:61:\"\\Drupal\\contact\\Controller\\ContactController::contactSitePage\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:17:\"contact_form.view\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":485:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/contact/(?P<contact_form>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/contact\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:10:\"/contact/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.contact_form.collection','/admin/structure/contact','/admin/structure/contact',7,'C:31:\"Symfony\\Component\\Routing\\Route\":947:{a:9:{s:4:\"path\";s:24:\"/admin/structure/contact\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:12:\"contact_form\";s:6:\"_title\";s:13:\"Contact forms\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer contact forms\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/structure/contact$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/structure/contact\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/structure/contact\";s:8:\"numParts\";i:3;}}}}',3),

('entity.contact_form.delete_form','/admin/structure/contact/manage/{contact_form}/delete','/admin/structure/contact/manage/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1388:{a:9:{s:4:\"path\";s:53:\"/admin/structure/contact/manage/{contact_form}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"contact_form.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"contact_form.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":613:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/contact/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.contact_form.edit_form','/admin/structure/contact/manage/{contact_form}','/admin/structure/contact/manage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1334:{a:9:{s:4:\"path\";s:46:\"/admin/structure/contact/manage/{contact_form}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"contact_form.edit\";s:6:\"_title\";s:17:\"Edit contact form\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"contact_form.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":556:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:33:\"/admin/structure/contact/manage/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.contact_message.field_ui_fields','/admin/structure/contact/manage/{contact_form}/fields','/admin/structure/contact/manage/%/fields',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1509:{a:9:{s:4:\"path\";s:53:\"/admin/structure/contact/manage/{contact_form}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer contact_message fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":613:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/contact/manage/%/fields\";s:8:\"numParts\";i:6;}}}}',6),

('entity.date_format.collection','/admin/config/regional/date-time','/admin/config/regional/date-time',15,'C:31:\"Symfony\\Component\\Routing\\Route\":993:{a:9:{s:4:\"path\";s:32:\"/admin/config/regional/date-time\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:11:\"date_format\";s:6:\"_title\";s:21:\"Date and time formats\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":395:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/config/regional/date\\-time$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/regional/date-time\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:32:\"/admin/config/regional/date-time\";s:8:\"numParts\";i:4;}}}}',4),

('entity.date_format.delete_form','/admin/config/regional/date-time/formats/manage/{date_format}/delete','/admin/config/regional/date-time/formats/manage/%/delete',253,'C:31:\"Symfony\\Component\\Routing\\Route\":1458:{a:9:{s:4:\"path\";s:68:\"/admin/config/regional/date-time/formats/manage/{date_format}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"date_format.delete\";s:6:\"_title\";s:18:\"Delete date format\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:18:\"date_format.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"date_format\";a:2:{s:4:\"type\";s:18:\"entity:date_format\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":659:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"date_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/config/regional/date\\-time/formats/manage/(?P<date_format>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"date_format\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:47:\"/admin/config/regional/date-time/formats/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"date_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:253;s:14:\"patternOutline\";s:56:\"/admin/config/regional/date-time/formats/manage/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.date_format.edit_form','/admin/config/regional/date-time/formats/manage/{date_format}','/admin/config/regional/date-time/formats/manage/%',126,'C:31:\"Symfony\\Component\\Routing\\Route\":1390:{a:9:{s:4:\"path\";s:61:\"/admin/config/regional/date-time/formats/manage/{date_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"date_format.edit\";s:6:\"_title\";s:16:\"Edit date format\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:18:\"date_format.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"date_format\";a:2:{s:4:\"type\";s:18:\"entity:date_format\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":602:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"date_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/admin/config/regional/date\\-time/formats/manage/(?P<date_format>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"date_format\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:47:\"/admin/config/regional/date-time/formats/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"date_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:126;s:14:\"patternOutline\";s:49:\"/admin/config/regional/date-time/formats/manage/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.embed_button.collection','/admin/config/content/embed','/admin/config/content/embed',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1046:{a:9:{s:4:\"path\";s:27:\"/admin/config/content/embed\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityListController::listing\";s:11:\"entity_type\";s:12:\"embed_button\";s:6:\"_title\";s:13:\"Embed buttons\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer embed buttons\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":379:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/admin/config/content/embed$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/config/content/embed\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:27:\"/admin/config/content/embed\";s:8:\"numParts\";i:4;}}}}',4),

('entity.embed_button.delete_form','/admin/config/content/embed/button/manage/{embed_button}/delete','/admin/config/content/embed/button/manage/%/delete',253,'C:31:\"Symfony\\Component\\Routing\\Route\":1443:{a:9:{s:4:\"path\";s:63:\"/admin/config/content/embed/button/manage/{embed_button}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"embed_button.delete\";s:6:\"_title\";s:19:\"Delete embed button\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"embed_button.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"embed_button\";a:2:{s:4:\"type\";s:19:\"entity:embed_button\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":644:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"embed_button\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/admin/config/content/embed/button/manage/(?P<embed_button>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"embed_button\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/content/embed/button/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"embed_button\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:253;s:14:\"patternOutline\";s:50:\"/admin/config/content/embed/button/manage/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.embed_button.edit_form','/admin/config/content/embed/button/manage/{embed_button}','/admin/config/content/embed/button/manage/%',126,'C:31:\"Symfony\\Component\\Routing\\Route\":1375:{a:9:{s:4:\"path\";s:56:\"/admin/config/content/embed/button/manage/{embed_button}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"embed_button.edit\";s:6:\"_title\";s:17:\"Edit embed button\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"embed_button.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"embed_button\";a:2:{s:4:\"type\";s:19:\"entity:embed_button\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":587:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"embed_button\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:73:\"#^/admin/config/content/embed/button/manage/(?P<embed_button>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"embed_button\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/content/embed/button/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"embed_button\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:126;s:14:\"patternOutline\";s:43:\"/admin/config/content/embed/button/manage/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_browser.add_form','/admin/config/content/entity_browser/add','/admin/config/content/entity_browser/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1075:{a:9:{s:4:\"path\";s:40:\"/admin/config/content/entity_browser/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"entity_browser.edit\";s:6:\"_title\";s:18:\"Add Entity browser\";s:12:\"tempstore_id\";s:21:\"entity_browser.config\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer entity browsers\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":418:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/config/content/entity_browser/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/config/content/entity_browser/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:40:\"/admin/config/content/entity_browser/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.entity_browser.collection','/admin/config/content/entity_browser','/admin/config/content/entity_browser',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1002:{a:9:{s:4:\"path\";s:36:\"/admin/config/content/entity_browser\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:14:\"entity_browser\";s:6:\"_title\";s:15:\"Entity Browsers\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer entity browsers\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":406:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/config/content/entity_browser$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/content/entity_browser\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:36:\"/admin/config/content/entity_browser\";s:8:\"numParts\";i:4;}}}}',4),

('entity.entity_browser.delete_form','/admin/config/content/entity_browser/{entity_browser}/delete','/admin/config/content/entity_browser/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1448:{a:9:{s:4:\"path\";s:60:\"/admin/config/content/entity_browser/{entity_browser}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"entity_browser.delete\";s:6:\"_title\";s:21:\"Delete Entity browser\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer entity browsers\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:14:\"entity_browser\";a:2:{s:4:\"type\";s:21:\"entity:entity_browser\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":636:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_browser\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/content/entity_browser/(?P<entity_browser>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_browser\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/content/entity_browser\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_browser\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:45:\"/admin/config/content/entity_browser/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_browser.edit_form','/admin/config/content/entity_browser/{entity_browser}/edit','/admin/config/content/entity_browser/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1436:{a:9:{s:4:\"path\";s:58:\"/admin/config/content/entity_browser/{entity_browser}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"entity_browser.edit\";s:6:\"_title\";s:19:\"Edit Entity Browser\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer entity browsers\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:14:\"entity_browser\";a:2:{s:4:\"type\";s:21:\"entity:entity_browser\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":630:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_browser\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/config/content/entity_browser/(?P<entity_browser>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_browser\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/content/entity_browser\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_browser\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:43:\"/admin/config/content/entity_browser/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_browser.edit_widgets','/admin/config/content/entity_browser/{entity_browser}/widgets','/admin/config/content/entity_browser/%/widgets',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1449:{a:9:{s:4:\"path\";s:61:\"/admin/config/content/entity_browser/{entity_browser}/widgets\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:27:\"entity_browser.edit_widgets\";s:6:\"_title\";s:12:\"Edit Widgets\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer entity browsers\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:14:\"entity_browser\";a:2:{s:4:\"type\";s:21:\"entity:entity_browser\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":639:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_browser\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/admin/config/content/entity_browser/(?P<entity_browser>[^/]++)/widgets$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/widgets\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_browser\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/content/entity_browser\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_browser\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:46:\"/admin/config/content/entity_browser/%/widgets\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_form_display.block_content.default','/admin/structure/block/block-content/manage/{block_content_type}/form-display','/admin/structure/block/block-content/manage/%/form-display',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1657:{a:9:{s:4:\"path\";s:77:\"/admin/structure/block/block-content/manage/{block_content_type}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:37:\"administer block_content form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":695:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:96:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:58:\"/admin/structure/block/block-content/manage/%/form-display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.block_content.form_mode','/admin/structure/block/block-content/manage/{block_content_type}/form-display/{form_mode_name}','/admin/structure/block/block-content/manage/%/form-display/%',250,'C:31:\"Symfony\\Component\\Routing\\Route\":1812:{a:9:{s:4:\"path\";s:94:\"/admin/structure/block/block-content/manage/{block_content_type}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:37:\"administer block_content form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":869:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:123:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:60:\"/admin/structure/block/block-content/manage/%/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_form_display.comment.default','/admin/structure/comment/manage/{comment_type}/form-display','/admin/structure/comment/manage/%/form-display',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1552:{a:9:{s:4:\"path\";s:59:\"/admin/structure/comment/manage/{comment_type}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:31:\"administer comment form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":633:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:46:\"/admin/structure/comment/manage/%/form-display\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_form_display.comment.form_mode','/admin/structure/comment/manage/{comment_type}/form-display/{form_mode_name}','/admin/structure/comment/manage/%/form-display/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1708:{a:9:{s:4:\"path\";s:76:\"/admin/structure/comment/manage/{comment_type}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:31:\"administer comment form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":808:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:48:\"/admin/structure/comment/manage/%/form-display/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.commerce_order.default','/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display','/admin/commerce/config/order-types/%/edit/form-display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1650:{a:9:{s:4:\"path\";s:74:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:38:\"administer commerce_order form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":687:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:93:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:54:\"/admin/commerce/config/order-types/%/edit/form-display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.commerce_order.form_mode','/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/{form_mode_name}','/admin/commerce/config/order-types/%/edit/form-display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1805:{a:9:{s:4:\"path\";s:91:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:38:\"administer commerce_order form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":861:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:120:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:56:\"/admin/commerce/config/order-types/%/edit/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_form_display.commerce_order_item.default','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display','/admin/commerce/config/order-item-types/%/edit/form-display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1717:{a:9:{s:4:\"path\";s:84:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:43:\"administer commerce_order_item form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":724:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:59:\"/admin/commerce/config/order-item-types/%/edit/form-display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.commerce_order_item.form_mode','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/{form_mode_name}','/admin/commerce/config/order-item-types/%/edit/form-display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1872:{a:9:{s:4:\"path\";s:101:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:43:\"administer commerce_order_item form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":897:{a:11:{s:4:\"vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:131:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:61:\"/admin/commerce/config/order-item-types/%/edit/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_form_display.commerce_product.default','/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display','/admin/commerce/config/product-types/%/edit/form-display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1676:{a:9:{s:4:\"path\";s:78:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:40:\"administer commerce_product form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":701:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:56:\"/admin/commerce/config/product-types/%/edit/form-display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.commerce_product.form_mode','/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/{form_mode_name}','/admin/commerce/config/product-types/%/edit/form-display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1831:{a:9:{s:4:\"path\";s:95:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:40:\"administer commerce_product form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":875:{a:11:{s:4:\"vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:124:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:58:\"/admin/commerce/config/product-types/%/edit/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_form_display.commerce_product_attribute_value.default','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display','/admin/commerce/product-attributes/manage/%/form-display',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1743:{a:9:{s:4:\"path\";s:83:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:56:\"administer commerce_product_attribute_value form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":721:{a:11:{s:4:\"vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:102:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:56:\"/admin/commerce/product-attributes/manage/%/form-display\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_form_display.commerce_product_attribute_value.form_mode','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/{form_mode_name}','/admin/commerce/product-attributes/manage/%/form-display/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1899:{a:9:{s:4:\"path\";s:100:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:56:\"administer commerce_product_attribute_value form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":895:{a:11:{s:4:\"vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:129:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:58:\"/admin/commerce/product-attributes/manage/%/form-display/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.commerce_product_variation.default','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display','/admin/commerce/config/product-variation-types/%/edit/form-display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1808:{a:9:{s:4:\"path\";s:98:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:50:\"administer commerce_product_variation form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":773:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:118:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:66:\"/admin/commerce/config/product-variation-types/%/edit/form-display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.commerce_product_variation.form_mode','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/{form_mode_name}','/admin/commerce/config/product-variation-types/%/edit/form-display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1963:{a:9:{s:4:\"path\";s:115:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:50:\"administer commerce_product_variation form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":946:{a:11:{s:4:\"vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:145:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:68:\"/admin/commerce/config/product-variation-types/%/edit/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_form_display.commerce_store.default','/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display','/admin/commerce/config/store-types/%/edit/form-display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1650:{a:9:{s:4:\"path\";s:74:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:38:\"administer commerce_store form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":687:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:93:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:54:\"/admin/commerce/config/store-types/%/edit/form-display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.commerce_store.form_mode','/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/{form_mode_name}','/admin/commerce/config/store-types/%/edit/form-display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1805:{a:9:{s:4:\"path\";s:91:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:38:\"administer commerce_store form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":861:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:120:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:56:\"/admin/commerce/config/store-types/%/edit/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_form_display.contact_message.default','/admin/structure/contact/manage/{contact_form}/form-display','/admin/structure/contact/manage/%/form-display',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1569:{a:9:{s:4:\"path\";s:59:\"/admin/structure/contact/manage/{contact_form}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:39:\"administer contact_message form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":633:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:46:\"/admin/structure/contact/manage/%/form-display\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_form_display.contact_message.form_mode','/admin/structure/contact/manage/{contact_form}/form-display/{form_mode_name}','/admin/structure/contact/manage/%/form-display/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1725:{a:9:{s:4:\"path\";s:76:\"/admin/structure/contact/manage/{contact_form}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:39:\"administer contact_message form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":808:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:48:\"/admin/structure/contact/manage/%/form-display/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.node.default','/admin/structure/types/manage/{node_type}/form-display','/admin/structure/types/manage/%/form-display',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1513:{a:9:{s:4:\"path\";s:54:\"/admin/structure/types/manage/{node_type}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:28:\"administer node form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":612:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:72:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:44:\"/admin/structure/types/manage/%/form-display\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_form_display.node.form_mode','/admin/structure/types/manage/{node_type}/form-display/{form_mode_name}','/admin/structure/types/manage/%/form-display/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1668:{a:9:{s:4:\"path\";s:71:\"/admin/structure/types/manage/{node_type}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:28:\"administer node form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":786:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:99:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:46:\"/admin/structure/types/manage/%/form-display/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.profile.default','/admin/config/people/profile-types/manage/{profile_type}/form-display','/admin/config/people/profile-types/manage/%/form-display',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1594:{a:9:{s:4:\"path\";s:69:\"/admin/config/people/profile-types/manage/{profile_type}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:7:\"profile\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:31:\"administer profile form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":665:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:56:\"/admin/config/people/profile-types/manage/%/form-display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.profile.form_mode','/admin/config/people/profile-types/manage/{profile_type}/form-display/{form_mode_name}','/admin/config/people/profile-types/manage/%/form-display/%',250,'C:31:\"Symfony\\Component\\Routing\\Route\":1749:{a:9:{s:4:\"path\";s:86:\"/admin/config/people/profile-types/manage/{profile_type}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:7:\"profile\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:31:\"administer profile form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":839:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:115:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:58:\"/admin/config/people/profile-types/manage/%/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_form_display.taxonomy_term.default','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display','/admin/structure/taxonomy/manage/%/overview/form-display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1655:{a:9:{s:4:\"path\";s:76:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:37:\"administer taxonomy_term form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":692:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:94:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/form\\-display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/overview/form-display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:56:\"/admin/structure/taxonomy/manage/%/overview/form-display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_display.taxonomy_term.form_mode','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{form_mode_name}','/admin/structure/taxonomy/manage/%/overview/form-display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1810:{a:9:{s:4:\"path\";s:93:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:37:\"administer taxonomy_term form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":866:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:121:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/overview/form-display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:58:\"/admin/structure/taxonomy/manage/%/overview/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_form_display.user.default','/admin/config/people/accounts/form-display','/admin/config/people/accounts/form-display',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1150:{a:9:{s:4:\"path\";s:42:\"/admin/config/people/accounts/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:28:\"administer user form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":425:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/admin/config/people/accounts/form\\-display$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/people/accounts/form-display\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:42:\"/admin/config/people/accounts/form-display\";s:8:\"numParts\";i:5;}}}}',5),

('entity.entity_form_display.user.form_mode','/admin/config/people/accounts/form-display/{form_mode_name}','/admin/config/people/accounts/form-display/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1304:{a:9:{s:4:\"path\";s:59:\"/admin/config/people/accounts/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:28:\"administer user form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":598:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/people/accounts/form\\-display/(?P<form_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/people/accounts/form-display\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/config/people/accounts/form-display/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_form_mode.add_form','/admin/structure/display-modes/form/add/{entity_type_id}','/admin/structure/display-modes/form/add/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1207:{a:9:{s:4:\"path\";s:56:\"/admin/structure/display-modes/form/add/{entity_type_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:20:\"entity_form_mode.add\";s:6:\"_title\";s:13:\"Add form mode\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":589:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:74:\"#^/admin/structure/display\\-modes/form/add/(?P<entity_type_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_type_id\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/display-modes/form/add\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:41:\"/admin/structure/display-modes/form/add/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_form_mode.collection','/admin/structure/display-modes/form','/admin/structure/display-modes/form',15,'C:31:\"Symfony\\Component\\Routing\\Route\":994:{a:9:{s:4:\"path\";s:35:\"/admin/structure/display-modes/form\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:16:\"entity_form_mode\";s:6:\"_title\";s:10:\"Form modes\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":404:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/structure/display\\-modes/form$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/admin/structure/display-modes/form\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:35:\"/admin/structure/display-modes/form\";s:8:\"numParts\";i:4;}}}}',4),

('entity.entity_form_mode.delete_form','/admin/structure/display-modes/form/manage/{entity_form_mode}/delete','/admin/structure/display-modes/form/manage/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1481:{a:9:{s:4:\"path\";s:68:\"/admin/structure/display-modes/form/manage/{entity_form_mode}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"entity_form_mode.delete\";s:6:\"_title\";s:16:\"Delete form mode\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"entity_form_mode.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:16:\"entity_form_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_form_mode\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":664:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/structure/display\\-modes/form/manage/(?P<entity_form_mode>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_form_mode\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/display-modes/form/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/structure/display-modes/form/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_form_mode.edit_form','/admin/structure/display-modes/form/manage/{entity_form_mode}','/admin/structure/display-modes/form/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1412:{a:9:{s:4:\"path\";s:61:\"/admin/structure/display-modes/form/manage/{entity_form_mode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"entity_form_mode.edit\";s:6:\"_title\";s:14:\"Edit form mode\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"entity_form_mode.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:16:\"entity_form_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_form_mode\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":606:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/admin/structure/display\\-modes/form/manage/(?P<entity_form_mode>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_form_mode\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/display-modes/form/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/structure/display-modes/form/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_view_display.block_content.default','/admin/structure/block/block-content/manage/{block_content_type}/display','/admin/structure/block/block-content/manage/%/display',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1625:{a:9:{s:4:\"path\";s:72:\"/admin/structure/block/block-content/manage/{block_content_type}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:32:\"administer block_content display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":678:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:90:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:53:\"/admin/structure/block/block-content/manage/%/display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.block_content.view_mode','/admin/structure/block/block-content/manage/{block_content_type}/display/{view_mode_name}','/admin/structure/block/block-content/manage/%/display/%',250,'C:31:\"Symfony\\Component\\Routing\\Route\":1780:{a:9:{s:4:\"path\";s:89:\"/admin/structure/block/block-content/manage/{block_content_type}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:32:\"administer block_content display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":852:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:117:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:55:\"/admin/structure/block/block-content/manage/%/display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_view_display.comment.default','/admin/structure/comment/manage/{comment_type}/display','/admin/structure/comment/manage/%/display',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1520:{a:9:{s:4:\"path\";s:54:\"/admin/structure/comment/manage/{comment_type}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:26:\"administer comment display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":616:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:41:\"/admin/structure/comment/manage/%/display\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_view_display.comment.view_mode','/admin/structure/comment/manage/{comment_type}/display/{view_mode_name}','/admin/structure/comment/manage/%/display/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1675:{a:9:{s:4:\"path\";s:71:\"/admin/structure/comment/manage/{comment_type}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:26:\"administer comment display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":790:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:43:\"/admin/structure/comment/manage/%/display/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.commerce_order.default','/admin/commerce/config/order-types/{commerce_order_type}/edit/display','/admin/commerce/config/order-types/%/edit/display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1619:{a:9:{s:4:\"path\";s:69:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:33:\"administer commerce_order display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":671:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:49:\"/admin/commerce/config/order-types/%/edit/display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.commerce_order.view_mode','/admin/commerce/config/order-types/{commerce_order_type}/edit/display/{view_mode_name}','/admin/commerce/config/order-types/%/edit/display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1774:{a:9:{s:4:\"path\";s:86:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:33:\"administer commerce_order display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":845:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:114:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:51:\"/admin/commerce/config/order-types/%/edit/display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_view_display.commerce_order_item.default','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display','/admin/commerce/config/order-item-types/%/edit/display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1685:{a:9:{s:4:\"path\";s:79:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:38:\"administer commerce_order_item display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":707:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:54:\"/admin/commerce/config/order-item-types/%/edit/display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.commerce_order_item.view_mode','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/{view_mode_name}','/admin/commerce/config/order-item-types/%/edit/display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1840:{a:9:{s:4:\"path\";s:96:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:38:\"administer commerce_order_item display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":881:{a:11:{s:4:\"vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:125:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:56:\"/admin/commerce/config/order-item-types/%/edit/display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_view_display.commerce_product.default','/admin/commerce/config/product-types/{commerce_product_type}/edit/display','/admin/commerce/config/product-types/%/edit/display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1645:{a:9:{s:4:\"path\";s:73:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:35:\"administer commerce_product display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":685:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:91:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:51:\"/admin/commerce/config/product-types/%/edit/display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.commerce_product.view_mode','/admin/commerce/config/product-types/{commerce_product_type}/edit/display/{view_mode_name}','/admin/commerce/config/product-types/%/edit/display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1800:{a:9:{s:4:\"path\";s:90:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:35:\"administer commerce_product display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":859:{a:11:{s:4:\"vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:118:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:53:\"/admin/commerce/config/product-types/%/edit/display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_view_display.commerce_product_attribute_value.default','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display','/admin/commerce/product-attributes/manage/%/display',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1710:{a:9:{s:4:\"path\";s:78:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:51:\"administer commerce_product_attribute_value display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":703:{a:11:{s:4:\"vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:96:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:51:\"/admin/commerce/product-attributes/manage/%/display\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_view_display.commerce_product_attribute_value.view_mode','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/{view_mode_name}','/admin/commerce/product-attributes/manage/%/display/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1866:{a:9:{s:4:\"path\";s:95:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:51:\"administer commerce_product_attribute_value display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":878:{a:11:{s:4:\"vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:123:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:53:\"/admin/commerce/product-attributes/manage/%/display/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.commerce_product_variation.default','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display','/admin/commerce/config/product-variation-types/%/edit/display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1777:{a:9:{s:4:\"path\";s:93:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:45:\"administer commerce_product_variation display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":757:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:112:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:61:\"/admin/commerce/config/product-variation-types/%/edit/display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.commerce_product_variation.view_mode','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/{view_mode_name}','/admin/commerce/config/product-variation-types/%/edit/display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1932:{a:9:{s:4:\"path\";s:110:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:45:\"administer commerce_product_variation display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":930:{a:11:{s:4:\"vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:139:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:63:\"/admin/commerce/config/product-variation-types/%/edit/display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_view_display.commerce_store.default','/admin/commerce/config/store-types/{commerce_store_type}/edit/display','/admin/commerce/config/store-types/%/edit/display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1619:{a:9:{s:4:\"path\";s:69:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:33:\"administer commerce_store display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":671:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:49:\"/admin/commerce/config/store-types/%/edit/display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.commerce_store.view_mode','/admin/commerce/config/store-types/{commerce_store_type}/edit/display/{view_mode_name}','/admin/commerce/config/store-types/%/edit/display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1774:{a:9:{s:4:\"path\";s:86:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:33:\"administer commerce_store display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":845:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:114:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:51:\"/admin/commerce/config/store-types/%/edit/display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_view_display.contact_message.default','/admin/structure/contact/manage/{contact_form}/display','/admin/structure/contact/manage/%/display',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1537:{a:9:{s:4:\"path\";s:54:\"/admin/structure/contact/manage/{contact_form}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:34:\"administer contact_message display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":616:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:41:\"/admin/structure/contact/manage/%/display\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_view_display.contact_message.view_mode','/admin/structure/contact/manage/{contact_form}/display/{view_mode_name}','/admin/structure/contact/manage/%/display/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1692:{a:9:{s:4:\"path\";s:71:\"/admin/structure/contact/manage/{contact_form}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:34:\"administer contact_message display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":790:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:43:\"/admin/structure/contact/manage/%/display/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.node.default','/admin/structure/types/manage/{node_type}/display','/admin/structure/types/manage/%/display',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1481:{a:9:{s:4:\"path\";s:49:\"/admin/structure/types/manage/{node_type}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:23:\"administer node display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":595:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:66:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:39:\"/admin/structure/types/manage/%/display\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_view_display.node.view_mode','/admin/structure/types/manage/{node_type}/display/{view_mode_name}','/admin/structure/types/manage/%/display/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1636:{a:9:{s:4:\"path\";s:66:\"/admin/structure/types/manage/{node_type}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:23:\"administer node display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":769:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:93:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:41:\"/admin/structure/types/manage/%/display/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.profile.default','/admin/config/people/profile-types/manage/{profile_type}/display','/admin/config/people/profile-types/manage/%/display',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1562:{a:9:{s:4:\"path\";s:64:\"/admin/config/people/profile-types/manage/{profile_type}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:7:\"profile\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:26:\"administer profile display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":648:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:82:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/config/people/profile-types/manage/%/display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.profile.view_mode','/admin/config/people/profile-types/manage/{profile_type}/display/{view_mode_name}','/admin/config/people/profile-types/manage/%/display/%',250,'C:31:\"Symfony\\Component\\Routing\\Route\":1717:{a:9:{s:4:\"path\";s:81:\"/admin/config/people/profile-types/manage/{profile_type}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:7:\"profile\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:26:\"administer profile display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":822:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:109:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:53:\"/admin/config/people/profile-types/manage/%/display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_view_display.taxonomy_term.default','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display','/admin/structure/taxonomy/manage/%/overview/display',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1624:{a:9:{s:4:\"path\";s:71:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:32:\"administer taxonomy_term display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":676:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/display$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/overview/display\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:51:\"/admin/structure/taxonomy/manage/%/overview/display\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_display.taxonomy_term.view_mode','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{view_mode_name}','/admin/structure/taxonomy/manage/%/overview/display/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1779:{a:9:{s:4:\"path\";s:88:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:32:\"administer taxonomy_term display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":850:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:115:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/overview/display\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:53:\"/admin/structure/taxonomy/manage/%/overview/display/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.entity_view_display.user.default','/admin/config/people/accounts/display','/admin/config/people/accounts/display',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1119:{a:9:{s:4:\"path\";s:37:\"/admin/config/people/accounts/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:23:\"administer user display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/config/people/accounts/display$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/people/accounts/display\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:37:\"/admin/config/people/accounts/display\";s:8:\"numParts\";i:5;}}}}',5),

('entity.entity_view_display.user.view_mode','/admin/config/people/accounts/display/{view_mode_name}','/admin/config/people/accounts/display/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1273:{a:9:{s:4:\"path\";s:54:\"/admin/config/people/accounts/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:23:\"administer user display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":582:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/config/people/accounts/display/(?P<view_mode_name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/people/accounts/display\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:39:\"/admin/config/people/accounts/display/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_view_mode.add_form','/admin/structure/display-modes/view/add/{entity_type_id}','/admin/structure/display-modes/view/add/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1207:{a:9:{s:4:\"path\";s:56:\"/admin/structure/display-modes/view/add/{entity_type_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:20:\"entity_view_mode.add\";s:6:\"_title\";s:13:\"Add view mode\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":589:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:74:\"#^/admin/structure/display\\-modes/view/add/(?P<entity_type_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_type_id\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/display-modes/view/add\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:41:\"/admin/structure/display-modes/view/add/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.entity_view_mode.collection','/admin/structure/display-modes/view','/admin/structure/display-modes/view',15,'C:31:\"Symfony\\Component\\Routing\\Route\":994:{a:9:{s:4:\"path\";s:35:\"/admin/structure/display-modes/view\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:16:\"entity_view_mode\";s:6:\"_title\";s:10:\"View modes\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":404:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/structure/display\\-modes/view$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/admin/structure/display-modes/view\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:35:\"/admin/structure/display-modes/view\";s:8:\"numParts\";i:4;}}}}',4),

('entity.entity_view_mode.delete_form','/admin/structure/display-modes/view/manage/{entity_view_mode}/delete','/admin/structure/display-modes/view/manage/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1481:{a:9:{s:4:\"path\";s:68:\"/admin/structure/display-modes/view/manage/{entity_view_mode}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"entity_view_mode.delete\";s:6:\"_title\";s:16:\"Delete view mode\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"entity_view_mode.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:16:\"entity_view_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_view_mode\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":664:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/structure/display\\-modes/view/manage/(?P<entity_view_mode>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_view_mode\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/display-modes/view/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/structure/display-modes/view/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.entity_view_mode.edit_form','/admin/structure/display-modes/view/manage/{entity_view_mode}','/admin/structure/display-modes/view/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1412:{a:9:{s:4:\"path\";s:61:\"/admin/structure/display-modes/view/manage/{entity_view_mode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"entity_view_mode.edit\";s:6:\"_title\";s:14:\"Edit view mode\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"entity_view_mode.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:16:\"entity_view_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_view_mode\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":606:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/admin/structure/display\\-modes/view/manage/(?P<entity_view_mode>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_view_mode\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/display-modes/view/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/structure/display-modes/view/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.field_config.block_content_field_delete_form','/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}/delete','/admin/structure/block/block-content/manage/%/fields/%/delete',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1904:{a:9:{s:4:\"path\";s:93:\"/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":898:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:121:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:61:\"/admin/structure/block/block-content/manage/%/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.block_content_field_edit_form','/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}','/admin/structure/block/block-content/manage/%/fields/%',250,'C:31:\"Symfony\\Component\\Routing\\Route\":1920:{a:9:{s:4:\"path\";s:86:\"/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":841:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:114:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:54:\"/admin/structure/block/block-content/manage/%/fields/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.block_content_storage_edit_form','/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}/storage','/admin/structure/block/block-content/manage/%/fields/%/storage',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1776:{a:9:{s:4:\"path\";s:94:\"/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer block_content fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":901:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:122:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:62:\"/admin/structure/block/block-content/manage/%/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.comment_field_delete_form','/admin/structure/comment/manage/{comment_type}/fields/{field_config}/delete','/admin/structure/comment/manage/%/fields/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1806:{a:9:{s:4:\"path\";s:75:\"/admin/structure/comment/manage/{comment_type}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":837:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:102:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:49:\"/admin/structure/comment/manage/%/fields/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.comment_field_edit_form','/admin/structure/comment/manage/{comment_type}/fields/{field_config}','/admin/structure/comment/manage/%/fields/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1821:{a:9:{s:4:\"path\";s:68:\"/admin/structure/comment/manage/{comment_type}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":779:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:95:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:42:\"/admin/structure/comment/manage/%/fields/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.field_config.comment_storage_edit_form','/admin/structure/comment/manage/{comment_type}/fields/{field_config}/storage','/admin/structure/comment/manage/%/fields/%/storage',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1672:{a:9:{s:4:\"path\";s:76:\"/admin/structure/comment/manage/{comment_type}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer comment fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":840:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:103:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:50:\"/admin/structure/comment/manage/%/fields/%/storage\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.commerce_order_field_delete_form','/admin/commerce/config/order-types/{commerce_order_type}/edit/fields/{field_config}/delete','/admin/commerce/config/order-types/%/edit/fields/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1897:{a:9:{s:4:\"path\";s:90:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":891:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:118:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:57:\"/admin/commerce/config/order-types/%/edit/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.commerce_order_field_edit_form','/admin/commerce/config/order-types/{commerce_order_type}/edit/fields/{field_config}','/admin/commerce/config/order-types/%/edit/fields/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1913:{a:9:{s:4:\"path\";s:83:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":834:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:111:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:50:\"/admin/commerce/config/order-types/%/edit/fields/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.commerce_order_item_field_delete_form','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields/{field_config}/delete','/admin/commerce/config/order-item-types/%/edit/fields/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1959:{a:9:{s:4:\"path\";s:100:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":927:{a:11:{s:4:\"vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:129:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:62:\"/admin/commerce/config/order-item-types/%/edit/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.commerce_order_item_field_edit_form','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields/{field_config}','/admin/commerce/config/order-item-types/%/edit/fields/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1974:{a:9:{s:4:\"path\";s:93:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":870:{a:11:{s:4:\"vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:122:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:55:\"/admin/commerce/config/order-item-types/%/edit/fields/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.commerce_order_item_storage_edit_form','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields/{field_config}/storage','/admin/commerce/config/order-item-types/%/edit/fields/%/storage',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1837:{a:9:{s:4:\"path\";s:101:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer commerce_order_item fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":930:{a:11:{s:4:\"vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:130:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:63:\"/admin/commerce/config/order-item-types/%/edit/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.commerce_order_storage_edit_form','/admin/commerce/config/order-types/{commerce_order_type}/edit/fields/{field_config}/storage','/admin/commerce/config/order-types/%/edit/fields/%/storage',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1770:{a:9:{s:4:\"path\";s:91:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer commerce_order fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":894:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:119:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:58:\"/admin/commerce/config/order-types/%/edit/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.commerce_product_attribute_value_field_delete_form','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields/{field_config}/delete','/admin/commerce/product-attributes/manage/%/fields/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1971:{a:9:{s:4:\"path\";s:99:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":924:{a:11:{s:4:\"vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:127:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:59:\"/admin/commerce/product-attributes/manage/%/fields/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.commerce_product_attribute_value_field_edit_form','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields/{field_config}','/admin/commerce/product-attributes/manage/%/fields/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1987:{a:9:{s:4:\"path\";s:92:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":867:{a:11:{s:4:\"vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:120:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:52:\"/admin/commerce/product-attributes/manage/%/fields/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.field_config.commerce_product_attribute_value_storage_edit_form','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields/{field_config}/storage','/admin/commerce/product-attributes/manage/%/fields/%/storage',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1863:{a:9:{s:4:\"path\";s:100:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:50:\"administer commerce_product_attribute_value fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":927:{a:11:{s:4:\"vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:128:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:60:\"/admin/commerce/product-attributes/manage/%/fields/%/storage\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.commerce_product_field_delete_form','/admin/commerce/config/product-types/{commerce_product_type}/edit/fields/{field_config}/delete','/admin/commerce/config/product-types/%/edit/fields/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1921:{a:9:{s:4:\"path\";s:94:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":905:{a:11:{s:4:\"vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:122:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:59:\"/admin/commerce/config/product-types/%/edit/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.commerce_product_field_edit_form','/admin/commerce/config/product-types/{commerce_product_type}/edit/fields/{field_config}','/admin/commerce/config/product-types/%/edit/fields/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1937:{a:9:{s:4:\"path\";s:87:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":848:{a:11:{s:4:\"vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:115:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:52:\"/admin/commerce/config/product-types/%/edit/fields/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.commerce_product_storage_edit_form','/admin/commerce/config/product-types/{commerce_product_type}/edit/fields/{field_config}/storage','/admin/commerce/config/product-types/%/edit/fields/%/storage',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1796:{a:9:{s:4:\"path\";s:95:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:34:\"administer commerce_product fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":908:{a:11:{s:4:\"vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:123:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:60:\"/admin/commerce/config/product-types/%/edit/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.commerce_product_variation_field_delete_form','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields/{field_config}/delete','/admin/commerce/config/product-variation-types/%/edit/fields/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2043:{a:9:{s:4:\"path\";s:114:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":976:{a:11:{s:4:\"vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:143:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:69:\"/admin/commerce/config/product-variation-types/%/edit/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.commerce_product_variation_field_edit_form','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields/{field_config}','/admin/commerce/config/product-variation-types/%/edit/fields/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":2059:{a:9:{s:4:\"path\";s:107:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":919:{a:11:{s:4:\"vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:136:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:62:\"/admin/commerce/config/product-variation-types/%/edit/fields/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.commerce_product_variation_storage_edit_form','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields/{field_config}/storage','/admin/commerce/config/product-variation-types/%/edit/fields/%/storage',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1928:{a:9:{s:4:\"path\";s:115:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:44:\"administer commerce_product_variation fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":979:{a:11:{s:4:\"vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:144:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:70:\"/admin/commerce/config/product-variation-types/%/edit/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.commerce_store_field_delete_form','/admin/commerce/config/store-types/{commerce_store_type}/edit/fields/{field_config}/delete','/admin/commerce/config/store-types/%/edit/fields/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1897:{a:9:{s:4:\"path\";s:90:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":891:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:118:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:57:\"/admin/commerce/config/store-types/%/edit/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.commerce_store_field_edit_form','/admin/commerce/config/store-types/{commerce_store_type}/edit/fields/{field_config}','/admin/commerce/config/store-types/%/edit/fields/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1913:{a:9:{s:4:\"path\";s:83:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":834:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:111:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:50:\"/admin/commerce/config/store-types/%/edit/fields/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.commerce_store_storage_edit_form','/admin/commerce/config/store-types/{commerce_store_type}/edit/fields/{field_config}/storage','/admin/commerce/config/store-types/%/edit/fields/%/storage',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1770:{a:9:{s:4:\"path\";s:91:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer commerce_store fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":894:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:119:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/edit/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:58:\"/admin/commerce/config/store-types/%/edit/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.contact_message_field_delete_form','/admin/structure/contact/manage/{contact_form}/fields/{field_config}/delete','/admin/structure/contact/manage/%/fields/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1815:{a:9:{s:4:\"path\";s:75:\"/admin/structure/contact/manage/{contact_form}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":837:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:102:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:49:\"/admin/structure/contact/manage/%/fields/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.contact_message_field_edit_form','/admin/structure/contact/manage/{contact_form}/fields/{field_config}','/admin/structure/contact/manage/%/fields/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1830:{a:9:{s:4:\"path\";s:68:\"/admin/structure/contact/manage/{contact_form}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":779:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:95:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:42:\"/admin/structure/contact/manage/%/fields/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.field_config.contact_message_storage_edit_form','/admin/structure/contact/manage/{contact_form}/fields/{field_config}/storage','/admin/structure/contact/manage/%/fields/%/storage',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1689:{a:9:{s:4:\"path\";s:76:\"/admin/structure/contact/manage/{contact_form}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer contact_message fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":840:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:103:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:50:\"/admin/structure/contact/manage/%/fields/%/storage\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.node_field_delete_form','/admin/structure/types/manage/{node_type}/fields/{field_config}/delete','/admin/structure/types/manage/%/fields/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1769:{a:9:{s:4:\"path\";s:70:\"/admin/structure/types/manage/{node_type}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":815:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:47:\"/admin/structure/types/manage/%/fields/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.node_field_edit_form','/admin/structure/types/manage/{node_type}/fields/{field_config}','/admin/structure/types/manage/%/fields/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1785:{a:9:{s:4:\"path\";s:63:\"/admin/structure/types/manage/{node_type}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":758:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:90:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:40:\"/admin/structure/types/manage/%/fields/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.field_config.node_storage_edit_form','/admin/structure/types/manage/{node_type}/fields/{field_config}/storage','/admin/structure/types/manage/%/fields/%/storage',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1632:{a:9:{s:4:\"path\";s:71:\"/admin/structure/types/manage/{node_type}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer node fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":818:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:48:\"/admin/structure/types/manage/%/fields/%/storage\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.profile_field_delete_form','/admin/config/people/profile-types/manage/{profile_type}/fields/{field_config}/delete','/admin/config/people/profile-types/manage/%/fields/%/delete',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1847:{a:9:{s:4:\"path\";s:85:\"/admin/config/people/profile-types/manage/{profile_type}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:7:\"profile\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":868:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:113:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:59:\"/admin/config/people/profile-types/manage/%/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.profile_field_edit_form','/admin/config/people/profile-types/manage/{profile_type}/fields/{field_config}','/admin/config/people/profile-types/manage/%/fields/%',250,'C:31:\"Symfony\\Component\\Routing\\Route\":1863:{a:9:{s:4:\"path\";s:78:\"/admin/config/people/profile-types/manage/{profile_type}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:7:\"profile\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":811:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:106:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:52:\"/admin/config/people/profile-types/manage/%/fields/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.profile_storage_edit_form','/admin/config/people/profile-types/manage/{profile_type}/fields/{field_config}/storage','/admin/config/people/profile-types/manage/%/fields/%/storage',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1713:{a:9:{s:4:\"path\";s:86:\"/admin/config/people/profile-types/manage/{profile_type}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:7:\"profile\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer profile fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":871:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:114:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:60:\"/admin/config/people/profile-types/manage/%/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.taxonomy_term_field_delete_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}/delete','/admin/structure/taxonomy/manage/%/overview/fields/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1903:{a:9:{s:4:\"path\";s:92:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":896:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:119:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/overview/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:59:\"/admin/structure/taxonomy/manage/%/overview/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.taxonomy_term_field_edit_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}','/admin/structure/taxonomy/manage/%/overview/fields/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1919:{a:9:{s:4:\"path\";s:85:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":839:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:112:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/overview/fields\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:52:\"/admin/structure/taxonomy/manage/%/overview/fields/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.field_config.taxonomy_term_storage_edit_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}/storage','/admin/structure/taxonomy/manage/%/overview/fields/%/storage',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1775:{a:9:{s:4:\"path\";s:93:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer taxonomy_term fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":899:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:120:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/overview/fields\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:60:\"/admin/structure/taxonomy/manage/%/overview/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),

('entity.field_config.user_field_delete_form','/admin/config/people/accounts/fields/{field_config}/delete','/admin/config/people/accounts/fields/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1431:{a:9:{s:4:\"path\";s:58:\"/admin/config/people/accounts/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":629:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/config/people/accounts/fields/(?P<field_config>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/people/accounts/fields\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:45:\"/admin/config/people/accounts/fields/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.field_config.user_field_edit_form','/admin/config/people/accounts/fields/{field_config}','/admin/config/people/accounts/fields/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1446:{a:9:{s:4:\"path\";s:51:\"/admin/config/people/accounts/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":571:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/config/people/accounts/fields/(?P<field_config>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/people/accounts/fields\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:38:\"/admin/config/people/accounts/fields/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.field_config.user_storage_edit_form','/admin/config/people/accounts/fields/{field_config}/storage','/admin/config/people/accounts/fields/%/storage',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1270:{a:9:{s:4:\"path\";s:59:\"/admin/config/people/accounts/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer user fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":632:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/config/people/accounts/fields/(?P<field_config>[^/]++)/storage$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/people/accounts/fields\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:46:\"/admin/config/people/accounts/fields/%/storage\";s:8:\"numParts\";i:7;}}}}',7),

('entity.field_storage_config.collection','/admin/reports/fields','/admin/reports/fields',7,'C:31:\"Symfony\\Component\\Routing\\Route\":940:{a:9:{s:4:\"path\";s:21:\"/admin/reports/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:20:\"field_storage_config\";s:6:\"_title\";s:10:\"Field list\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer content types\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":360:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/reports/fields$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/reports/fields\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/reports/fields\";s:8:\"numParts\";i:3;}}}}',3),

('entity.filter_format.disable','/admin/config/content/formats/manage/{filter_format}/disable','/admin/config/content/formats/manage/%/disable',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1438:{a:9:{s:4:\"path\";s:60:\"/admin/config/content/formats/manage/{filter_format}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"filter_format.disable\";s:6:\"_title\";s:19:\"Disable text format\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:21:\"filter_format.disable\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":636:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/content/formats/manage/(?P<filter_format>[^/]++)/disable$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/content/formats/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:46:\"/admin/config/content/formats/manage/%/disable\";s:8:\"numParts\";i:7;}}}}',7),

('entity.filter_format.edit_form','/admin/config/content/formats/manage/{filter_format}','/admin/config/content/formats/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1408:{a:9:{s:4:\"path\";s:52:\"/admin/config/content/formats/manage/{filter_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"filter_format.edit\";s:15:\"_title_callback\";s:52:\"\\Drupal\\filter\\Controller\\FilterController::getLabel\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:20:\"filter_format.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":575:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/config/content/formats/manage/(?P<filter_format>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/content/formats/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:38:\"/admin/config/content/formats/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.image_style.collection','/admin/config/media/image-styles','/admin/config/media/image-styles',15,'C:31:\"Symfony\\Component\\Routing\\Route\":978:{a:9:{s:4:\"path\";s:32:\"/admin/config/media/image-styles\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:11:\"image_style\";s:6:\"_title\";s:12:\"Image styles\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":395:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/config/media/image\\-styles$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/media/image-styles\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:32:\"/admin/config/media/image-styles\";s:8:\"numParts\";i:4;}}}}',4),

('entity.image_style.delete_form','/admin/config/media/image-styles/manage/{image_style}/delete','/admin/config/media/image-styles/manage/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1419:{a:9:{s:4:\"path\";s:60:\"/admin/config/media/image-styles/manage/{image_style}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"image_style.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":635:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"image_style\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"image_style\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:48:\"/admin/config/media/image-styles/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.image_style.edit_form','/admin/config/media/image-styles/manage/{image_style}','/admin/config/media/image-styles/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1357:{a:9:{s:4:\"path\";s:53:\"/admin/config/media/image-styles/manage/{image_style}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"image_style.edit\";s:6:\"_title\";s:10:\"Edit style\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":577:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"image_style\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"image_style\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:41:\"/admin/config/media/image-styles/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.image_style.flush_form','/admin/config/media/image-styles/manage/{image_style}/flush','/admin/config/media/image-styles/manage/%/flush',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1413:{a:9:{s:4:\"path\";s:59:\"/admin/config/media/image-styles/manage/{image_style}/flush\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"image_style.flush\";s:6:\"_title\";s:5:\"Flush\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":632:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"image_style\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/flush$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/flush\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"image_style\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:47:\"/admin/config/media/image-styles/manage/%/flush\";s:8:\"numParts\";i:7;}}}}',7),

('entity.menu.add_form','/admin/structure/menu/add','/admin/structure/menu/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":933:{a:9:{s:4:\"path\";s:25:\"/admin/structure/menu/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:8:\"menu.add\";s:6:\"_title\";s:8:\"Add menu\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:4:\"menu\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":373:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/structure/menu/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/structure/menu/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:25:\"/admin/structure/menu/add\";s:8:\"numParts\";i:4;}}}}',4),

('entity.menu.add_link_form','/admin/structure/menu/manage/{menu}/add','/admin/structure/menu/manage/%/add',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1364:{a:9:{s:4:\"path\";s:39:\"/admin/structure/menu/manage/{menu}/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\menu_link_content\\Controller\\MenuController::addLink\";s:6:\"_title\";s:13:\"Add menu link\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:17:\"menu_link_content\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"menu\";a:2:{s:4:\"type\";s:11:\"entity:menu\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":560:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"menu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:56:\"#^/admin/structure/menu/manage/(?P<menu>[^/]++)/add$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:4:\"/add\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"menu\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/menu/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"menu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:34:\"/admin/structure/menu/manage/%/add\";s:8:\"numParts\";i:6;}}}}',6),

('entity.menu.collection','/admin/structure/menu','/admin/structure/menu',7,'C:31:\"Symfony\\Component\\Routing\\Route\":908:{a:9:{s:4:\"path\";s:21:\"/admin/structure/menu\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:4:\"menu\";s:6:\"_title\";s:5:\"Menus\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:15:\"administer menu\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":360:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/structure/menu$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/structure/menu\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/structure/menu\";s:8:\"numParts\";i:3;}}}}',3),

('entity.menu.delete_form','/admin/structure/menu/manage/{menu}/delete','/admin/structure/menu/manage/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1306:{a:9:{s:4:\"path\";s:42:\"/admin/structure/menu/manage/{menu}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:11:\"menu.delete\";s:6:\"_title\";s:11:\"Delete menu\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"menu.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"menu\";a:2:{s:4:\"type\";s:11:\"entity:menu\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":569:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"menu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/admin/structure/menu/manage/(?P<menu>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"menu\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/menu/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"menu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:37:\"/admin/structure/menu/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.menu.edit_form','/admin/structure/menu/manage/{menu}','/admin/structure/menu/manage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1290:{a:9:{s:4:\"path\";s:35:\"/admin/structure/menu/manage/{menu}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:9:\"menu.edit\";s:15:\"_title_callback\";s:52:\"\\Drupal\\menu_ui\\Controller\\MenuController::menuTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"menu.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"menu\";a:2:{s:4:\"type\";s:11:\"entity:menu\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":512:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"menu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/admin/structure/menu/manage/(?P<menu>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"menu\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/menu/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"menu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:30:\"/admin/structure/menu/manage/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.menu_link_content.canonical','/admin/structure/menu/item/{menu_link_content}/edit','/admin/structure/menu/item/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1373:{a:9:{s:4:\"path\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"menu_link_content.default\";s:6:\"_title\";s:14:\"Edit menu link\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:24:\"menu_link_content.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:17:\"menu_link_content\";a:2:{s:4:\"type\";s:24:\"entity:menu_link_content\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":612:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/structure/menu/item/(?P<menu_link_content>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"menu_link_content\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/item\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:33:\"/admin/structure/menu/item/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.menu_link_content.delete_form','/admin/structure/menu/item/{menu_link_content}/delete','/admin/structure/menu/item/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1382:{a:9:{s:4:\"path\";s:53:\"/admin/structure/menu/item/{menu_link_content}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"menu_link_content.delete\";s:6:\"_title\";s:16:\"Delete menu link\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:24:\"menu_link_content.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:17:\"menu_link_content\";a:2:{s:4:\"type\";s:24:\"entity:menu_link_content\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":618:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/structure/menu/item/(?P<menu_link_content>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"menu_link_content\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/item\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:35:\"/admin/structure/menu/item/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.menu_link_content.edit_form','/admin/structure/menu/item/{menu_link_content}/edit','/admin/structure/menu/item/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1373:{a:9:{s:4:\"path\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"menu_link_content.default\";s:6:\"_title\";s:14:\"Edit menu link\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:24:\"menu_link_content.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:17:\"menu_link_content\";a:2:{s:4:\"type\";s:24:\"entity:menu_link_content\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":612:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/structure/menu/item/(?P<menu_link_content>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"menu_link_content\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/item\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:33:\"/admin/structure/menu/item/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.canonical','/node/{node}','/node/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1177:{a:9:{s:4:\"path\";s:12:\"/node/{node}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\node\\Controller\\NodeViewController::view\";s:15:\"_title_callback\";s:49:\"\\Drupal\\node\\Controller\\NodeViewController::title\";}s:12:\"requirements\";a:2:{s:4:\"node\";s:3:\"\\d+\";s:14:\"_entity_access\";s:9:\"node.view\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":434:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/node/(?P<node>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:7:\"/node/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.node.delete_form','/node/{node}/delete','/node/%/delete',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1212:{a:9:{s:4:\"path\";s:19:\"/node/{node}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:11:\"node.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:2:{s:4:\"node\";s:3:\"\\d+\";s:14:\"_entity_access\";s:11:\"node.delete\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":492:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/node/(?P<node>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:14:\"/node/%/delete\";s:8:\"numParts\";i:3;}}}}',3),

('entity.node.delete_multiple_form','/admin/content/node/delete','/admin/content/node/delete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":977:{a:9:{s:4:\"path\";s:26:\"/admin/content/node/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:32:\"\\Drupal\\node\\Form\\DeleteMultiple\";s:14:\"entity_type_id\";s:4:\"node\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:4:\"node\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":376:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/content/node/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/content/node/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/content/node/delete\";s:8:\"numParts\";i:4;}}}}',4),

('entity.node.edit_form','/node/{node}/edit','/node/%/edit',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1175:{a:9:{s:4:\"path\";s:17:\"/node/{node}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:9:\"node.edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"node.update\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":486:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/node/(?P<node>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:12:\"/node/%/edit\";s:8:\"numParts\";i:3;}}}}',3),

('entity.node.field_ui_fields','/admin/structure/types/manage/{node_type}/fields','/admin/structure/types/manage/%/fields',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1453:{a:9:{s:4:\"path\";s:48:\"/admin/structure/types/manage/{node_type}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer node fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":592:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/types/manage/%/fields\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.preview','/node/preview/{node_preview}/{view_mode_id}','/node/preview/%/%',12,'C:31:\"Symfony\\Component\\Routing\\Route\":1475:{a:9:{s:4:\"path\";s:43:\"/node/preview/{node_preview}/{view_mode_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:51:\"\\Drupal\\node\\Controller\\NodePreviewController::view\";s:15:\"_title_callback\";s:52:\"\\Drupal\\node\\Controller\\NodePreviewController::title\";}s:12:\"requirements\";a:1:{s:20:\"_node_preview_access\";s:14:\"{node_preview}\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"node_preview\";a:2:{s:4:\"type\";s:12:\"node_preview\";s:9:\"converter\";s:42:\"drupal.proxy_original_service.node_preview\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:25:\"access_check.node.preview\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":667:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"node_preview\";i:1;s:12:\"view_mode_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/node/preview/(?P<node_preview>[^/]++)/(?P<view_mode_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"view_mode_id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"node_preview\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/node/preview\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"node_preview\";i:1;s:12:\"view_mode_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:12;s:14:\"patternOutline\";s:17:\"/node/preview/%/%\";s:8:\"numParts\";i:4;}}}}',4),

('entity.node.revision','/node/{node}/revisions/{node_revision}/view','/node/%/revisions/%/view',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1402:{a:9:{s:4:\"path\";s:43:\"/node/{node}/revisions/{node_revision}/view\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:52:\"\\Drupal\\node\\Controller\\NodeController::revisionShow\";s:15:\"_title_callback\";s:57:\"\\Drupal\\node\\Controller\\NodeController::revisionPageTitle\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:4:\"view\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":723:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/node/(?P<node>\\d+)/revisions/(?P<node_revision>[^/]++)/view$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/view\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"node_revision\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:24:\"/node/%/revisions/%/view\";s:8:\"numParts\";i:5;}}}}',5),

('entity.node.version_history','/node/{node}/revisions','/node/%/revisions',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1278:{a:9:{s:4:\"path\";s:22:\"/node/{node}/revisions\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:9:\"Revisions\";s:11:\"_controller\";s:56:\"\\Drupal\\node\\Controller\\NodeController::revisionOverview\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:4:\"view\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":502:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/node/(?P<node>\\d+)/revisions$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/node/%/revisions\";s:8:\"numParts\";i:3;}}}}',3),

('entity.node.webform.confirmation','/node/{node}/webform/confirmation','/node/%/webform/confirmation',11,'C:31:\"Symfony\\Component\\Routing\\Route\":1663:{a:9:{s:4:\"path\";s:33:\"/node/{node}/webform/confirmation\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformEntityController::confirmation\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";s:9:\"operation\";s:4:\"view\";s:13:\"entity_access\";s:25:\"webform.submission_create\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:3:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":542:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/node/(?P<node>[^/]++)/webform/confirmation$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/webform/confirmation\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:28:\"/node/%/webform/confirmation\";s:8:\"numParts\";i:4;}}}}',4),

('entity.node.webform.entity_reference.set','/node/{node}/webform/change/{webform}','/node/%/webform/change/%',22,'C:31:\"Symfony\\Component\\Routing\\Route\":1678:{a:9:{s:4:\"path\";s:37:\"/node/{node}/webform/change/{webform}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:76:\"\\Drupal\\webform_node\\Controller\\WebformNodeEntityReferenceController::change\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:27:\"webform.submission_view_any\";}s:12:\"requirements\";a:2:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformAccess\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.custom\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":666:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/node/(?P<node>[^/]++)/webform/change/(?P<webform>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/webform/change\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:22;s:14:\"patternOutline\";s:24:\"/node/%/webform/change/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.node.webform.results_clear','/node/{node}/webform/results/clear','/node/%/webform/results/clear',23,'C:31:\"Symfony\\Component\\Routing\\Route\":1476:{a:9:{s:4:\"path\";s:34:\"/node/{node}/webform/results/clear\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:43:\"Drupal\\webform\\Form\\WebformResultsClearForm\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";s:9:\"operation\";s:25:\"webform_submission_delete\";s:13:\"entity_access\";s:28:\"webform.submission_purge_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:72:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":545:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/node/(?P<node>[^/]++)/webform/results/clear$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/webform/results/clear\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:23;s:14:\"patternOutline\";s:29:\"/node/%/webform/results/clear\";s:8:\"numParts\";i:5;}}}}',5),

('entity.node.webform.results_export','/node/{node}/webform/results/download','/node/%/webform/results/download',23,'C:31:\"Symfony\\Component\\Routing\\Route\":1513:{a:9:{s:4:\"path\";s:37:\"/node/{node}/webform/results/download\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformResultsExportController::index\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:27:\"webform.submission_view_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:72:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":554:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/node/(?P<node>[^/]++)/webform/results/download$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/webform/results/download\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:23;s:14:\"patternOutline\";s:32:\"/node/%/webform/results/download\";s:8:\"numParts\";i:5;}}}}',5),

('entity.node.webform.results_export_file','/node/{node}/webform/results/download/file/{filename}','/node/%/webform/results/download/file/%',94,'C:31:\"Symfony\\Component\\Routing\\Route\":1692:{a:9:{s:4:\"path\";s:53:\"/node/{node}/webform/results/download/file/{filename}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:63:\"\\Drupal\\webform\\Controller\\WebformResultsExportController::file\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:27:\"webform.submission_view_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:72:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":715:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"filename\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/node/(?P<node>[^/]++)/webform/results/download/file/(?P<filename>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"filename\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/webform/results/download/file\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"filename\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:94;s:14:\"patternOutline\";s:39:\"/node/%/webform/results/download/file/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.node.webform.results_submissions','/node/{node}/webform/results/submissions/{submission_view}','/node/%/webform/results/submissions',23,'C:31:\"Symfony\\Component\\Routing\\Route\":1708:{a:9:{s:4:\"path\";s:58:\"/node/{node}/webform/results/submissions/{submission_view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_list\";s:18:\"webform_submission\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";s:15:\"submission_view\";s:0:\"\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:27:\"webform.submission_view_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:72:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":743:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:15:\"submission_view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:90:\"#^/node/(?P<node>[^/]++)/webform/results/submissions(?:/(?P<submission_view>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"submission_view\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/webform/results/submissions\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:15:\"submission_view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:23;s:14:\"patternOutline\";s:35:\"/node/%/webform/results/submissions\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform.results_submissions.custom','/node/{node}/webform/results/submissions/custom','/node/%/webform/results/submissions/custom',47,'C:31:\"Symfony\\Component\\Routing\\Route\":1477:{a:9:{s:4:\"path\";s:47:\"/node/{node}/webform/results/submissions/custom\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:44:\"Drupal\\webform\\Form\\WebformResultsCustomForm\";s:6:\"_title\";s:15:\"Customize table\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:27:\"webform.submission_view_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:72:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":584:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/node/(?P<node>[^/]++)/webform/results/submissions/custom$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/webform/results/submissions/custom\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:47;s:14:\"patternOutline\";s:42:\"/node/%/webform/results/submissions/custom\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform.test_form','/node/{node}/webform/test','/node/%/webform/test',11,'C:31:\"Symfony\\Component\\Routing\\Route\":1413:{a:9:{s:4:\"path\";s:25:\"/node/{node}/webform/test\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:58:\"\\Drupal\\webform\\Controller\\WebformTestController::testForm\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:12:\"webform.test\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":518:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/node/(?P<node>[^/]++)/webform/test$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/webform/test\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:20:\"/node/%/webform/test\";s:8:\"numParts\";i:4;}}}}',4),

('entity.node.webform.user.drafts','/node/{node}/webform/drafts/{submission_view}','/node/%/webform/drafts',11,'C:31:\"Symfony\\Component\\Routing\\Route\":1550:{a:9:{s:4:\"path\";s:45:\"/node/{node}/webform/drafts/{submission_view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_list\";s:18:\"webform_submission\";s:6:\"_title\";s:6:\"Drafts\";s:15:\"submission_view\";s:0:\"\";s:9:\"operation\";s:4:\"view\";s:13:\"entity_access\";s:25:\"webform.submission_create\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:71:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformDraftsAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":704:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:15:\"submission_view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/node/(?P<node>[^/]++)/webform/drafts(?:/(?P<submission_view>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"submission_view\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/webform/drafts\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:15:\"submission_view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:22:\"/node/%/webform/drafts\";s:8:\"numParts\";i:5;}}}}',5),

('entity.node.webform.user.submission','/node/{node}/webform/submissions/{webform_submission}','/node/%/webform/submissions/%',22,'C:31:\"Symfony\\Component\\Routing\\Route\":1837:{a:9:{s:4:\"path\";s:53:\"/node/{node}/webform/submissions/{webform_submission}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:4:\"html\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:23:\"webform_submission.view\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":728:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/node/(?P<node>[^/]++)/webform/submissions/(?P<webform_submission>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/webform/submissions\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:22;s:14:\"patternOutline\";s:29:\"/node/%/webform/submissions/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.node.webform.user.submission.delete','/node/{node}/webform/submissions/{webform_submission}/delete','/node/%/webform/submissions/%/delete',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1790:{a:9:{s:4:\"path\";s:60:\"/node/{node}/webform/submissions/{webform_submission}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:25:\"webform_submission.delete\";s:6:\"_title\";s:25:\"Delete webform submission\";s:9:\"operation\";s:25:\"webform_submission_delete\";s:13:\"entity_access\";s:25:\"webform_submission.delete\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":785:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/node/(?P<node>[^/]++)/webform/submissions/(?P<webform_submission>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/webform/submissions\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:36:\"/node/%/webform/submissions/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform.user.submission.duplicate','/node/{node}/webform/submissions/{webform_submission}/duplicate','/node/%/webform/submissions/%/duplicate',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1879:{a:9:{s:4:\"path\";s:63:\"/node/{node}/webform/submissions/{webform_submission}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:28:\"webform_submission.duplicate\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"duplicate\";b:1;s:9:\"operation\";s:28:\"webform_submission_duplicate\";s:13:\"entity_access\";s:25:\"webform_submission.update\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":795:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:90:\"#^/node/(?P<node>[^/]++)/webform/submissions/(?P<webform_submission>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/webform/submissions\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:39:\"/node/%/webform/submissions/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform.user.submission.edit','/node/{node}/webform/submissions/{webform_submission}/edit','/node/%/webform/submissions/%/edit',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1828:{a:9:{s:4:\"path\";s:58:\"/node/{node}/webform/submissions/{webform_submission}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:23:\"webform_submission.edit\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"operation\";s:23:\"webform_submission_edit\";s:13:\"entity_access\";s:25:\"webform_submission.update\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":779:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:85:\"#^/node/(?P<node>[^/]++)/webform/submissions/(?P<webform_submission>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/webform/submissions\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:34:\"/node/%/webform/submissions/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform.user.submissions','/node/{node}/webform/submissions/{submission_view}','/node/%/webform/submissions',11,'C:31:\"Symfony\\Component\\Routing\\Route\":1568:{a:9:{s:4:\"path\";s:50:\"/node/{node}/webform/submissions/{submission_view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_list\";s:18:\"webform_submission\";s:6:\"_title\";s:11:\"Submissions\";s:15:\"submission_view\";s:0:\"\";s:9:\"operation\";s:0:\"\";s:13:\"entity_access\";s:27:\"webform.submission_view_own\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":719:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:15:\"submission_view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:82:\"#^/node/(?P<node>[^/]++)/webform/submissions(?:/(?P<submission_view>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"submission_view\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/webform/submissions\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:15:\"submission_view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:27:\"/node/%/webform/submissions\";s:8:\"numParts\";i:5;}}}}',5),

('entity.node.webform_submission.canonical','/node/{node}/webform/submission/{webform_submission}','/node/%/webform/submission/%',22,'C:31:\"Symfony\\Component\\Routing\\Route\":1857:{a:9:{s:4:\"path\";s:52:\"/node/{node}/webform/submission/{webform_submission}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:4:\"html\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:23:\"webform_submission.view\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":725:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:22;s:14:\"patternOutline\";s:28:\"/node/%/webform/submission/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.node.webform_submission.delete_form','/node/{node}/webform/submission/{webform_submission}/delete','/node/%/webform/submission/%/delete',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1810:{a:9:{s:4:\"path\";s:59:\"/node/{node}/webform/submission/{webform_submission}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:25:\"webform_submission.delete\";s:6:\"_title\";s:25:\"Delete webform submission\";s:9:\"operation\";s:25:\"webform_submission_delete\";s:13:\"entity_access\";s:25:\"webform_submission.delete\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":782:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:35:\"/node/%/webform/submission/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform_submission.duplicate_form','/node/{node}/webform/submission/{webform_submission}/duplicate','/node/%/webform/submission/%/duplicate',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1903:{a:9:{s:4:\"path\";s:62:\"/node/{node}/webform/submission/{webform_submission}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:28:\"webform_submission.duplicate\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"operation\";s:28:\"webform_submission_duplicate\";s:13:\"entity_access\";s:29:\"webform_submission.update_any\";s:9:\"duplicate\";b:1;}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":792:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:89:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:38:\"/node/%/webform/submission/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform_submission.edit_form','/node/{node}/webform/submission/{webform_submission}/edit','/node/%/webform/submission/%/edit',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1848:{a:9:{s:4:\"path\";s:57:\"/node/{node}/webform/submission/{webform_submission}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:23:\"webform_submission.edit\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"operation\";s:23:\"webform_submission_edit\";s:13:\"entity_access\";s:25:\"webform_submission.update\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":776:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:33:\"/node/%/webform/submission/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform_submission.edit_form.all','/node/{node}/webform/submission/{webform_submission}/edit/all','/node/%/webform/submission/%/edit/all',91,'C:31:\"Symfony\\Component\\Routing\\Route\":1872:{a:9:{s:4:\"path\";s:61:\"/node/{node}/webform/submission/{webform_submission}/edit/all\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:27:\"webform_submission.edit_all\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"operation\";s:27:\"webform_submission_edit_all\";s:13:\"entity_access\";s:25:\"webform_submission.update\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":788:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)/edit/all$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/edit/all\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:91;s:14:\"patternOutline\";s:37:\"/node/%/webform/submission/%/edit/all\";s:8:\"numParts\";i:7;}}}}',7),

('entity.node.webform_submission.notes_form','/node/{node}/webform/submission/{webform_submission}/notes','/node/%/webform/submission/%/notes',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1858:{a:9:{s:4:\"path\";s:58:\"/node/{node}/webform/submission/{webform_submission}/notes\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"webform_submission.notes\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"operation\";s:24:\"webform_submission_notes\";s:13:\"entity_access\";s:29:\"webform_submission.update_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":779:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:85:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)/notes$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/notes\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:34:\"/node/%/webform/submission/%/notes\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform_submission.resend_form','/node/{node}/webform/submission/{webform_submission}/resend','/node/%/webform/submission/%/resend',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1878:{a:9:{s:4:\"path\";s:59:\"/node/{node}/webform/submission/{webform_submission}/resend\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:47:\"Drupal\\webform\\Form\\WebformSubmissionResendForm\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"operation\";s:25:\"webform_submission_resend\";s:13:\"entity_access\";s:29:\"webform_submission.update_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":782:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)/resend$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/resend\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:35:\"/node/%/webform/submission/%/resend\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform_submission.table','/node/{node}/webform/submission/{webform_submission}/table','/node/%/webform/submission/%/table',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1922:{a:9:{s:4:\"path\";s:58:\"/node/{node}/webform/submission/{webform_submission}/table\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:5:\"table\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:27:\"webform_submission.view_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":779:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:85:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)/table$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/table\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:34:\"/node/%/webform/submission/%/table\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform_submission.text','/node/{node}/webform/submission/{webform_submission}/text','/node/%/webform/submission/%/text',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1917:{a:9:{s:4:\"path\";s:57:\"/node/{node}/webform/submission/{webform_submission}/text\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:4:\"text\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:27:\"webform_submission.view_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":776:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)/text$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/text\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:33:\"/node/%/webform/submission/%/text\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node.webform_submission.yaml','/node/{node}/webform/submission/{webform_submission}/yaml','/node/%/webform/submission/%/yaml',45,'C:31:\"Symfony\\Component\\Routing\\Route\":1917:{a:9:{s:4:\"path\";s:57:\"/node/{node}/webform/submission/{webform_submission}/yaml\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:4:\"yaml\";s:9:\"operation\";s:23:\"webform_submission_view\";s:13:\"entity_access\";s:27:\"webform_submission.view_any\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:75:\"\\Drupal\\webform_node\\Access\\WebformNodeAccess::checkWebformSubmissionAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":776:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/node/(?P<node>[^/]++)/webform/submission/(?P<webform_submission>[^/]++)/yaml$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/yaml\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:45;s:14:\"patternOutline\";s:33:\"/node/%/webform/submission/%/yaml\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node_type.collection','/admin/structure/types','/admin/structure/types',7,'C:31:\"Symfony\\Component\\Routing\\Route\":935:{a:9:{s:4:\"path\";s:22:\"/admin/structure/types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:9:\"node_type\";s:6:\"_title\";s:13:\"Content types\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer content types\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/structure/types$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/structure/types\";s:8:\"numParts\";i:3;}}}}',3),

('entity.node_type.delete_form','/admin/structure/types/manage/{node_type}/delete','/admin/structure/types/manage/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1349:{a:9:{s:4:\"path\";s:48:\"/admin/structure/types/manage/{node_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"node_type.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"node_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":592:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/types/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.node_type.edit_form','/admin/structure/types/manage/{node_type}','/admin/structure/types/manage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1351:{a:9:{s:4:\"path\";s:41:\"/admin/structure/types/manage/{node_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:14:\"node_type.edit\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer content types\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":535:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:31:\"/admin/structure/types/manage/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.pathauto_pattern.add_form','/admin/config/search/path/patterns/add','/admin/config/search/path/patterns/add',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1062:{a:9:{s:4:\"path\";s:38:\"/admin/config/search/path/patterns/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:24:\"pathauto_pattern.default\";s:6:\"_title\";s:20:\"Add Pathauto pattern\";s:12:\"tempstore_id\";s:16:\"pathauto.pattern\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"administer pathauto\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":412:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/search/path/patterns/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/admin/config/search/path/patterns/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:38:\"/admin/config/search/path/patterns/add\";s:8:\"numParts\";i:6;}}}}',6),

('entity.pathauto_pattern.collection','/admin/config/search/path/patterns','/admin/config/search/path/patterns',31,'C:31:\"Symfony\\Component\\Routing\\Route\":981:{a:9:{s:4:\"path\";s:34:\"/admin/config/search/path/patterns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:16:\"pathauto_pattern\";s:6:\"_title\";s:8:\"Patterns\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"administer pathauto\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/admin/config/search/path/patterns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/search/path/patterns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:34:\"/admin/config/search/path/patterns\";s:8:\"numParts\";i:5;}}}}',5),

('entity.pathauto_pattern.delete_form','/admin/config/search/path/patterns/{pathauto_pattern}/delete','/admin/config/search/path/patterns/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1502:{a:9:{s:4:\"path\";s:60:\"/admin/config/search/path/patterns/{pathauto_pattern}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"pathauto_pattern.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"pathauto_pattern.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"pathauto_pattern\";a:2:{s:4:\"type\";s:23:\"entity:pathauto_pattern\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":639:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/search/path/patterns/(?P<pathauto_pattern>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"pathauto_pattern\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/search/path/patterns\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:43:\"/admin/config/search/path/patterns/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.pathauto_pattern.disable','/admin/config/search/path/patterns/{pathauto_pattern}/disable','/admin/config/search/path/patterns/%/disable',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1416:{a:9:{s:4:\"path\";s:61:\"/admin/config/search/path/patterns/{pathauto_pattern}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:24:\"pathauto_pattern.disable\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"pathauto_pattern.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:16:\"pathauto_pattern\";a:2:{s:4:\"type\";s:23:\"entity:pathauto_pattern\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":642:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/admin/config/search/path/patterns/(?P<pathauto_pattern>[^/]++)/disable$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"pathauto_pattern\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/search/path/patterns\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:44:\"/admin/config/search/path/patterns/%/disable\";s:8:\"numParts\";i:7;}}}}',7),

('entity.pathauto_pattern.duplicate_form','/admin/config/search/path/patterns/{pathauto_pattern}/duplicate','/admin/config/search/path/patterns/%/duplicate',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1515:{a:9:{s:4:\"path\";s:63:\"/admin/config/search/path/patterns/{pathauto_pattern}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:26:\"pathauto_pattern.duplicate\";s:6:\"_title\";s:26:\"Duplicate Pathauto pattern\";s:12:\"tempstore_id\";s:16:\"pathauto.pattern\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"administer pathauto\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:16:\"pathauto_pattern\";a:2:{s:4:\"type\";s:23:\"entity:pathauto_pattern\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":649:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/admin/config/search/path/patterns/(?P<pathauto_pattern>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"pathauto_pattern\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/search/path/patterns\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:46:\"/admin/config/search/path/patterns/%/duplicate\";s:8:\"numParts\";i:7;}}}}',7),

('entity.pathauto_pattern.edit_form','/admin/config/search/path/patterns/{pathauto_pattern}','/admin/config/search/path/patterns/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1436:{a:9:{s:4:\"path\";s:53:\"/admin/config/search/path/patterns/{pathauto_pattern}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"pathauto_pattern.default\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"pathauto_pattern.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"pathauto_pattern\";a:2:{s:4:\"type\";s:23:\"entity:pathauto_pattern\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":581:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/config/search/path/patterns/(?P<pathauto_pattern>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"pathauto_pattern\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/search/path/patterns\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:36:\"/admin/config/search/path/patterns/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.pathauto_pattern.enable','/admin/config/search/path/patterns/{pathauto_pattern}/enable','/admin/config/search/path/patterns/%/enable',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1411:{a:9:{s:4:\"path\";s:60:\"/admin/config/search/path/patterns/{pathauto_pattern}/enable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:23:\"pathauto_pattern.enable\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"pathauto_pattern.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:16:\"pathauto_pattern\";a:2:{s:4:\"type\";s:23:\"entity:pathauto_pattern\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":639:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/search/path/patterns/(?P<pathauto_pattern>[^/]++)/enable$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/enable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"pathauto_pattern\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/search/path/patterns\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"pathauto_pattern\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:43:\"/admin/config/search/path/patterns/%/enable\";s:8:\"numParts\";i:7;}}}}',7),

('entity.profile.canonical','/profile/{profile}','/profile/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1188:{a:9:{s:4:\"path\";s:18:\"/profile/{profile}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_view\";s:12:\"profile.full\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:12:\"profile.view\";s:7:\"profile\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"profile\";a:2:{s:4:\"type\";s:14:\"entity:profile\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":456:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"profile\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/profile/(?P<profile>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"profile\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/profile\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"profile\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:10:\"/profile/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.profile.collection','/admin/people/profiles','/admin/people/profiles',7,'C:31:\"Symfony\\Component\\Routing\\Route\":980:{a:9:{s:4:\"path\";s:22:\"/admin/people/profiles\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:7:\"profile\";s:6:\"_title\";s:8:\"Profiles\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer profile\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/people/profiles$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/people/profiles\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/people/profiles\";s:8:\"numParts\";i:3;}}}}',3),

('entity.profile.delete_form','/profile/{profile}/delete','/profile/%/delete',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1262:{a:9:{s:4:\"path\";s:25:\"/profile/{profile}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:14:\"profile.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"profile.delete\";s:7:\"profile\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"profile\";a:2:{s:4:\"type\";s:14:\"entity:profile\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":513:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"profile\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/profile/(?P<profile>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"profile\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/profile\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"profile\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/profile/%/delete\";s:8:\"numParts\";i:3;}}}}',3),

('entity.profile.delete_multiple_form','/admin/content/profile/delete','/admin/content/profile/delete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1005:{a:9:{s:4:\"path\";s:29:\"/admin/content/profile/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:42:\"Drupal\\Core\\Entity\\Form\\DeleteMultipleForm\";s:14:\"entity_type_id\";s:7:\"profile\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:7:\"profile\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/content/profile/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/content/profile/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/content/profile/delete\";s:8:\"numParts\";i:4;}}}}',4),

('entity.profile.edit_form','/profile/{profile}/edit','/profile/%/edit',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1250:{a:9:{s:4:\"path\";s:23:\"/profile/{profile}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:12:\"profile.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"profile.update\";s:7:\"profile\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"profile\";a:2:{s:4:\"type\";s:14:\"entity:profile\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":507:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"profile\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/profile/(?P<profile>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"profile\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/profile\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"profile\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/profile/%/edit\";s:8:\"numParts\";i:3;}}}}',3),

('entity.profile.field_ui_fields','/admin/config/people/profile-types/manage/{profile_type}/fields','/admin/config/people/profile-types/manage/%/fields',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1534:{a:9:{s:4:\"path\";s:63:\"/admin/config/people/profile-types/manage/{profile_type}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:7:\"profile\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer profile fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":645:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:81:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:50:\"/admin/config/people/profile-types/manage/%/fields\";s:8:\"numParts\";i:7;}}}}',7),

('entity.profile.set_default','/profile/{profile}/set-default','/profile/%/set-default',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1275:{a:9:{s:4:\"path\";s:30:\"/profile/{profile}/set-default\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:56:\"\\Drupal\\profile\\Controller\\ProfileController::setDefault\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"profile.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"profile\";a:2:{s:4:\"type\";s:14:\"entity:profile\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":536:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"profile\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/profile/(?P<profile>[^/]++)/set\\-default$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/set-default\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"profile\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/profile\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"profile\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:22:\"/profile/%/set-default\";s:8:\"numParts\";i:3;}}}}',3),

('entity.profile_type.add_form','/admin/config/people/profile-types/add','/admin/config/people/profile-types/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1105:{a:9:{s:4:\"path\";s:38:\"/admin/config/people/profile-types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:16:\"profile_type.add\";s:14:\"entity_type_id\";s:12:\"profile_type\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:12:\"profile_type\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":413:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/config/people/profile\\-types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/admin/config/people/profile-types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:38:\"/admin/config/people/profile-types/add\";s:8:\"numParts\";i:5;}}}}',5),

('entity.profile_type.collection','/admin/config/people/profile-types','/admin/config/people/profile-types',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1048:{a:9:{s:4:\"path\";s:34:\"/admin/config/people/profile-types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:12:\"profile_type\";s:6:\"_title\";s:13:\"Profile types\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer profile types\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":401:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/config/people/profile\\-types$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/people/profile-types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:34:\"/admin/config/people/profile-types\";s:8:\"numParts\";i:4;}}}}',4),

('entity.profile_type.delete_form','/admin/config/people/profile-types/manage/{profile_type}/delete','/admin/config/people/profile-types/manage/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1495:{a:9:{s:4:\"path\";s:63:\"/admin/config/people/profile-types/manage/{profile_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"profile_type.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"profile_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":645:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:81:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:50:\"/admin/config/people/profile-types/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.profile_type.duplicate_form','/admin/config/people/profile-types/manage/{profile_type}/duplicate','/admin/config/people/profile-types/manage/%/duplicate',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1586:{a:9:{s:4:\"path\";s:66:\"/admin/config/people/profile-types/manage/{profile_type}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"Drupal\\entity\\Controller\\EntityDuplicateController::form\";s:15:\"_title_callback\";s:57:\"Drupal\\entity\\Controller\\EntityDuplicateController::title\";s:14:\"entity_type_id\";s:12:\"profile_type\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:22:\"profile_type.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":655:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:53:\"/admin/config/people/profile-types/manage/%/duplicate\";s:8:\"numParts\";i:7;}}}}',7),

('entity.profile_type.edit_form','/admin/config/people/profile-types/manage/{profile_type}','/admin/config/people/profile-types/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1426:{a:9:{s:4:\"path\";s:56:\"/admin/config/people/profile-types/manage/{profile_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"profile_type.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"profile_type.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":587:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:74:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:43:\"/admin/config/people/profile-types/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.search_page.collection','/admin/config/search/pages','/admin/config/search/pages',15,'C:31:\"Symfony\\Component\\Routing\\Route\":947:{a:9:{s:4:\"path\";s:26:\"/admin/config/search/pages\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:11:\"search_page\";s:6:\"_title\";s:12:\"Search pages\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer search\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":376:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/config/search/pages$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/config/search/pages\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/config/search/pages\";s:8:\"numParts\";i:4;}}}}',4),

('entity.search_page.delete_form','/admin/config/search/pages/manage/{search_page}/delete','/admin/config/search/pages/manage/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1388:{a:9:{s:4:\"path\";s:54:\"/admin/config/search/pages/manage/{search_page}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"search_page.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:18:\"search_page.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":616:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:42:\"/admin/config/search/pages/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.search_page.disable','/admin/config/search/pages/manage/{search_page}/disable','/admin/config/search/pages/manage/%/disable',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1490:{a:9:{s:4:\"path\";s:55:\"/admin/config/search/pages/manage/{search_page}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\search\\Controller\\SearchController::performOperation\";s:2:\"op\";s:7:\"disable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:19:\"search_page.disable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":619:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:72:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)/disable$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:43:\"/admin/config/search/pages/manage/%/disable\";s:8:\"numParts\";i:7;}}}}',7),

('entity.search_page.edit_form','/admin/config/search/pages/manage/{search_page}','/admin/config/search/pages/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1379:{a:9:{s:4:\"path\";s:47:\"/admin/config/search/pages/manage/{search_page}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"search_page.edit\";s:15:\"_title_callback\";s:53:\"\\Drupal\\search\\Controller\\SearchController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:18:\"search_page.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":558:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:35:\"/admin/config/search/pages/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.search_page.enable','/admin/config/search/pages/manage/{search_page}/enable','/admin/config/search/pages/manage/%/enable',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1484:{a:9:{s:4:\"path\";s:54:\"/admin/config/search/pages/manage/{search_page}/enable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\search\\Controller\\SearchController::performOperation\";s:2:\"op\";s:6:\"enable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:18:\"search_page.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":616:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)/enable$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/enable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:42:\"/admin/config/search/pages/manage/%/enable\";s:8:\"numParts\";i:7;}}}}',7),

('entity.search_page.set_default','/admin/config/search/pages/manage/{search_page}/set-default','/admin/config/search/pages/manage/%/set-default',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1480:{a:9:{s:4:\"path\";s:59:\"/admin/config/search/pages/manage/{search_page}/set-default\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:56:\"\\Drupal\\search\\Controller\\SearchController::setAsDefault\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:18:\"search_page.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":633:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)/set\\-default$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/set-default\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:47:\"/admin/config/search/pages/manage/%/set-default\";s:8:\"numParts\";i:7;}}}}',7),

('entity.shortcut.canonical','/admin/config/user-interface/shortcut/link/{shortcut}','/admin/config/user-interface/shortcut/link/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1305:{a:9:{s:4:\"path\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"shortcut.default\";s:6:\"_title\";s:4:\"Edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:15:\"shortcut.update\";s:8:\"shortcut\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":565:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/config/user\\-interface/shortcut/link/(?P<shortcut>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:8:\"shortcut\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/user-interface/shortcut/link\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/config/user-interface/shortcut/link/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.shortcut.delete_form','/admin/config/user-interface/shortcut/link/{shortcut}/delete','/admin/config/user-interface/shortcut/link/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1371:{a:9:{s:4:\"path\";s:60:\"/admin/config/user-interface/shortcut/link/{shortcut}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"shortcut.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:15:\"shortcut.delete\";s:8:\"shortcut\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":623:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/config/user\\-interface/shortcut/link/(?P<shortcut>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:8:\"shortcut\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/user-interface/shortcut/link\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/config/user-interface/shortcut/link/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.shortcut.edit_form','/admin/config/user-interface/shortcut/link/{shortcut}','/admin/config/user-interface/shortcut/link/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1305:{a:9:{s:4:\"path\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"shortcut.default\";s:6:\"_title\";s:4:\"Edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:15:\"shortcut.update\";s:8:\"shortcut\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":565:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/config/user\\-interface/shortcut/link/(?P<shortcut>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:8:\"shortcut\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/user-interface/shortcut/link\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/config/user-interface/shortcut/link/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.shortcut.link_delete_inline','/admin/config/user-interface/shortcut/link/{shortcut}/delete-inline','/admin/config/user-interface/shortcut/link/%/delete-inline',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1489:{a:9:{s:4:\"path\";s:67:\"/admin/config/user-interface/shortcut/link/{shortcut}/delete-inline\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:71:\"Drupal\\shortcut\\Controller\\ShortcutController::deleteShortcutLinkInline\";}s:12:\"requirements\";a:3:{s:14:\"_entity_access\";s:15:\"shortcut.delete\";s:11:\"_csrf_token\";s:4:\"TRUE\";s:8:\"shortcut\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":646:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:83:\"#^/admin/config/user\\-interface/shortcut/link/(?P<shortcut>\\d+)/delete\\-inline$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/delete-inline\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:8:\"shortcut\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/user-interface/shortcut/link\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:58:\"/admin/config/user-interface/shortcut/link/%/delete-inline\";s:8:\"numParts\";i:7;}}}}',7),

('entity.shortcut_set.collection','/admin/config/user-interface/shortcut','/admin/config/user-interface/shortcut',15,'C:31:\"Symfony\\Component\\Routing\\Route\":992:{a:9:{s:4:\"path\";s:37:\"/admin/config/user-interface/shortcut\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:12:\"shortcut_set\";s:6:\"_title\";s:9:\"Shortcuts\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer shortcuts\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":410:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/user\\-interface/shortcut$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/user-interface/shortcut\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/user-interface/shortcut\";s:8:\"numParts\";i:4;}}}}',4),

('entity.shortcut_set.customize_form','/admin/config/user-interface/shortcut/manage/{shortcut_set}/customize','/admin/config/user-interface/shortcut/manage/%/customize',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1463:{a:9:{s:4:\"path\";s:69:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/customize\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:22:\"shortcut_set.customize\";s:6:\"_title\";s:10:\"List links\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"shortcut_set.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":664:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)/customize$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/customize\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:56:\"/admin/config/user-interface/shortcut/manage/%/customize\";s:8:\"numParts\";i:7;}}}}',7),

('entity.shortcut_set.delete_form','/admin/config/user-interface/shortcut/manage/{shortcut_set}/delete','/admin/config/user-interface/shortcut/manage/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1456:{a:9:{s:4:\"path\";s:66:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"shortcut_set.delete\";s:6:\"_title\";s:19:\"Delete shortcut set\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"shortcut_set.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":654:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:53:\"/admin/config/user-interface/shortcut/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.shortcut_set.edit_form','/admin/config/user-interface/shortcut/manage/{shortcut_set}','/admin/config/user-interface/shortcut/manage/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1387:{a:9:{s:4:\"path\";s:59:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"shortcut_set.edit\";s:6:\"_title\";s:17:\"Edit shortcut set\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"shortcut_set.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":596:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:46:\"/admin/config/user-interface/shortcut/manage/%\";s:8:\"numParts\";i:6;}}}}',6),

('entity.taxonomy_term.add_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/add','/admin/structure/taxonomy/manage/%/add',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1496:{a:9:{s:4:\"path\";s:58:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\taxonomy\\Controller\\TaxonomyController::addForm\";s:6:\"_title\";s:8:\"Add term\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:35:\"taxonomy_term:{taxonomy_vocabulary}\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":635:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/add$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:4:\"/add\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/taxonomy/manage/%/add\";s:8:\"numParts\";i:6;}}}}',6),

('entity.taxonomy_term.canonical','/taxonomy/term/{taxonomy_term}','/taxonomy/term/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1662:{a:9:{s:4:\"path\";s:30:\"/taxonomy/term/{taxonomy_term}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:6:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:13:\"taxonomy_term\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;s:15:\"_title_callback\";s:57:\"\\Drupal\\taxonomy\\Controller\\TaxonomyController::termTitle\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:13:\"taxonomy_term\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"taxonomy_term\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":508:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/taxonomy/term/(?P<taxonomy_term>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"taxonomy_term\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:16:\"/taxonomy/term/%\";s:8:\"numParts\";i:3;}}}}',3),

('entity.taxonomy_term.delete_form','/taxonomy/term/{taxonomy_term}/delete','/taxonomy/term/%/delete',13,'C:31:\"Symfony\\Component\\Routing\\Route\":1318:{a:9:{s:4:\"path\";s:37:\"/taxonomy/term/{taxonomy_term}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:20:\"taxonomy_term.delete\";s:6:\"_title\";s:11:\"Delete term\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"taxonomy_term.delete\";s:13:\"taxonomy_term\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"taxonomy_term\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":560:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/taxonomy/term/(?P<taxonomy_term>\\d+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"taxonomy_term\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:23:\"/taxonomy/term/%/delete\";s:8:\"numParts\";i:4;}}}}',4),

('entity.taxonomy_term.edit_form','/taxonomy/term/{taxonomy_term}/edit','/taxonomy/term/%/edit',13,'C:31:\"Symfony\\Component\\Routing\\Route\":1308:{a:9:{s:4:\"path\";s:35:\"/taxonomy/term/{taxonomy_term}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"taxonomy_term.default\";s:6:\"_title\";s:9:\"Edit term\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"taxonomy_term.update\";s:13:\"taxonomy_term\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"taxonomy_term\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":554:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:49:\"#^/taxonomy/term/(?P<taxonomy_term>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"taxonomy_term\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:21:\"/taxonomy/term/%/edit\";s:8:\"numParts\";i:4;}}}}',4),

('entity.taxonomy_term.field_ui_fields','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields','/admin/structure/taxonomy/manage/%/overview/fields',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1596:{a:9:{s:4:\"path\";s:70:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer taxonomy_term fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":673:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/overview/fields\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:50:\"/admin/structure/taxonomy/manage/%/overview/fields\";s:8:\"numParts\";i:7;}}}}',7),

('entity.taxonomy_vocabulary.add_form','/admin/structure/taxonomy/add','/admin/structure/taxonomy/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1093:{a:9:{s:4:\"path\";s:29:\"/admin/structure/taxonomy/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:27:\"taxonomy_vocabulary.default\";s:14:\"entity_type_id\";s:19:\"taxonomy_vocabulary\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:19:\"taxonomy_vocabulary\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/structure/taxonomy/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/taxonomy/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/structure/taxonomy/add\";s:8:\"numParts\";i:4;}}}}',4),

('entity.taxonomy_vocabulary.collection','/admin/structure/taxonomy','/admin/structure/taxonomy',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1031:{a:9:{s:4:\"path\";s:25:\"/admin/structure/taxonomy\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:19:\"taxonomy_vocabulary\";s:6:\"_title\";s:8:\"Taxonomy\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:44:\"access taxonomy overview+administer taxonomy\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":372:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/structure/taxonomy$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/structure/taxonomy\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/structure/taxonomy\";s:8:\"numParts\";i:3;}}}}',3),

('entity.taxonomy_vocabulary.delete_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/delete','/admin/structure/taxonomy/manage/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1520:{a:9:{s:4:\"path\";s:61:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:26:\"taxonomy_vocabulary.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:26:\"taxonomy_vocabulary.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":644:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:41:\"/admin/structure/taxonomy/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.taxonomy_vocabulary.edit_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}','/admin/structure/taxonomy/manage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1455:{a:9:{s:4:\"path\";s:54:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:27:\"taxonomy_vocabulary.default\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:26:\"taxonomy_vocabulary.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":587:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:34:\"/admin/structure/taxonomy/manage/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.taxonomy_vocabulary.overview_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview','/admin/structure/taxonomy/manage/%/overview',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1548:{a:9:{s:4:\"path\";s:63:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:15:\"_title_callback\";s:62:\"Drupal\\taxonomy\\Controller\\TaxonomyController::vocabularyTitle\";s:5:\"_form\";s:34:\"Drupal\\taxonomy\\Form\\OverviewTerms\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:44:\"taxonomy_vocabulary.access taxonomy overview\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":650:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/overview\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:43:\"/admin/structure/taxonomy/manage/%/overview\";s:8:\"numParts\";i:6;}}}}',6),

('entity.taxonomy_vocabulary.reset_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/reset','/admin/structure/taxonomy/manage/%/reset',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1443:{a:9:{s:4:\"path\";s:60:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/reset\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"taxonomy_vocabulary.reset\";s:6:\"_title\";s:5:\"Reset\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"administer taxonomy\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":641:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/reset$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/reset\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/taxonomy/manage/%/reset\";s:8:\"numParts\";i:6;}}}}',6),

('entity.tb_megamenu.add_form','/admin/structure/tb-megamenu/add','/admin/structure/tb-megamenu/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":984:{a:9:{s:4:\"path\";s:32:\"/admin/structure/tb-megamenu/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"tb_megamenu.add\";s:6:\"_title\";s:15:\"Add a Mega Menu\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer tb_megamenu\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":395:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/structure/tb\\-megamenu/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/tb-megamenu/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:32:\"/admin/structure/tb-megamenu/add\";s:8:\"numParts\";i:4;}}}}',4),

('entity.tb_megamenu.collection','/admin/structure/tb-megamenu','/admin/structure/tb-megamenu',7,'C:31:\"Symfony\\Component\\Routing\\Route\":960:{a:9:{s:4:\"path\";s:28:\"/admin/structure/tb-megamenu\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:11:\"tb_megamenu\";s:6:\"_title\";s:12:\"TB Mega Menu\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer tb_megamenu\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/structure/tb\\-megamenu$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/tb-megamenu\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:28:\"/admin/structure/tb-megamenu\";s:8:\"numParts\";i:3;}}}}',3),

('entity.tb_megamenu.delete_form','/admin/structure/tb-megamenu/{tb_megamenu}/delete','/admin/structure/tb-megamenu/%/delete',29,'C:31:\"Symfony\\Component\\Routing\\Route\":1442:{a:9:{s:4:\"path\";s:49:\"/admin/structure/tb-megamenu/{tb_megamenu}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"tb_megamenu.delete\";s:6:\"_title\";s:16:\"Delete Mega Menu\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:22:\"administer tb_megamenu\";s:11:\"tb_megamenu\";s:14:\"[a-zA-Z0-9_-]+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"tb_megamenu\";a:2:{s:4:\"type\";s:18:\"entity:tb_megamenu\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":618:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"tb_megamenu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/structure/tb\\-megamenu/(?P<tb_megamenu>[a-zA-Z0-9_-]+)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:14:\"[a-zA-Z0-9_-]+\";i:3;s:11:\"tb_megamenu\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/tb-megamenu\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"tb_megamenu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:29;s:14:\"patternOutline\";s:37:\"/admin/structure/tb-megamenu/%/delete\";s:8:\"numParts\";i:5;}}}}',5),

('entity.tb_megamenu.edit_form','/admin/structure/tb-megamenu/{tb_megamenu}','/admin/structure/tb-megamenu/%',14,'C:31:\"Symfony\\Component\\Routing\\Route\":1434:{a:9:{s:4:\"path\";s:42:\"/admin/structure/tb-megamenu/{tb_megamenu}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:19:\"Config TB Mega Menu\";s:11:\"_controller\";s:72:\"\\Drupal\\tb_megamenu\\Controller\\TBMegaMenuAdminController::configMegaMenu\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:22:\"administer tb_megamenu\";s:11:\"tb_megamenu\";s:14:\"[a-zA-Z0-9_-]+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"tb_megamenu\";a:2:{s:4:\"type\";s:18:\"entity:tb_megamenu\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":561:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"tb_megamenu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/structure/tb\\-megamenu/(?P<tb_megamenu>[a-zA-Z0-9_-]+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:14:\"[a-zA-Z0-9_-]+\";i:3;s:11:\"tb_megamenu\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/tb-megamenu\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"tb_megamenu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:30:\"/admin/structure/tb-megamenu/%\";s:8:\"numParts\";i:4;}}}}',4),

('entity.user.admin_form','/admin/config/people/accounts','/admin/config/people/accounts',15,'C:31:\"Symfony\\Component\\Routing\\Route\":986:{a:9:{s:4:\"path\";s:29:\"/admin/config/people/accounts\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:32:\"\\Drupal\\user\\AccountSettingsForm\";s:6:\"_title\";s:16:\"Account settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"administer account settings\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/config/people/accounts$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/config/people/accounts\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/config/people/accounts\";s:8:\"numParts\";i:4;}}}}',4),

('entity.user.cancel_form','/user/{user}/cancel','/user/%/cancel',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1188:{a:9:{s:4:\"path\";s:19:\"/user/{user}/cancel\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:14:\"Cancel account\";s:12:\"_entity_form\";s:11:\"user.cancel\";}s:12:\"requirements\";a:2:{s:4:\"user\";s:3:\"\\d+\";s:14:\"_entity_access\";s:11:\"user.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":492:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/user/(?P<user>\\d+)/cancel$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/cancel\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:14:\"/user/%/cancel\";s:8:\"numParts\";i:3;}}}}',3),

('entity.user.canonical','/user/{user}','/user/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1137:{a:9:{s:4:\"path\";s:12:\"/user/{user}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_view\";s:9:\"user.full\";s:15:\"_title_callback\";s:48:\"Drupal\\user\\Controller\\UserController::userTitle\";}s:12:\"requirements\";a:2:{s:4:\"user\";s:3:\"\\d+\";s:14:\"_entity_access\";s:9:\"user.view\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":434:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/user/(?P<user>\\d+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:7:\"/user/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.user.collection','/admin/people','/admin/people',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1253:{a:9:{s:4:\"path\";s:13:\"/admin/people\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:6:\"People\";s:7:\"view_id\";s:17:\"user_admin_people\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:0;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:16:\"administer users\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:0;s:16:\"returns_response\";b:0;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":336:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/admin/people$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/admin/people\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/admin/people\";s:8:\"numParts\";i:2;}}}}',2),

('entity.user.contact_form','/user/{user}/contact','/user/%/contact',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1229:{a:9:{s:4:\"path\";s:20:\"/user/{user}/contact\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:7:\"Contact\";s:11:\"_controller\";s:65:\"\\Drupal\\contact\\Controller\\ContactController::contactPersonalPage\";}s:12:\"requirements\";a:2:{s:28:\"_access_contact_personal_tab\";s:4:\"TRUE\";s:4:\"user\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:29:\"access_check.contact_personal\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":495:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/user/(?P<user>\\d+)/contact$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/contact\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/user/%/contact\";s:8:\"numParts\";i:3;}}}}',3),

('entity.user.edit_form','/user/{user}/edit','/user/%/edit',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1225:{a:9:{s:4:\"path\";s:17:\"/user/{user}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:12:\"user.default\";s:15:\"_title_callback\";s:48:\"Drupal\\user\\Controller\\UserController::userTitle\";}s:12:\"requirements\";a:2:{s:4:\"user\";s:3:\"\\d+\";s:14:\"_entity_access\";s:11:\"user.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":486:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/user/(?P<user>\\d+)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:12:\"/user/%/edit\";s:8:\"numParts\";i:3;}}}}',3),

('entity.user.field_ui_fields','/admin/config/people/accounts/fields','/admin/config/people/accounts/fields',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1091:{a:9:{s:4:\"path\";s:36:\"/admin/config/people/accounts/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer user fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":406:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/config/people/accounts/fields$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/people/accounts/fields\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:36:\"/admin/config/people/accounts/fields\";s:8:\"numParts\";i:5;}}}}',5),

('entity.user_role.collection','/admin/people/roles','/admin/people/roles',7,'C:31:\"Symfony\\Component\\Routing\\Route\":912:{a:9:{s:4:\"path\";s:19:\"/admin/people/roles\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:9:\"user_role\";s:6:\"_title\";s:5:\"Roles\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer permissions\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":354:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/people/roles$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/admin/people/roles\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/admin/people/roles\";s:8:\"numParts\";i:3;}}}}',3),

('entity.user_role.delete_form','/admin/people/roles/manage/{user_role}/delete','/admin/people/roles/manage/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1343:{a:9:{s:4:\"path\";s:45:\"/admin/people/roles/manage/{user_role}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"user_role.delete\";s:6:\"_title\";s:11:\"Delete role\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"user_role.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"user_role\";a:2:{s:4:\"type\";s:16:\"entity:user_role\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":583:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"user_role\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:62:\"#^/admin/people/roles/manage/(?P<user_role>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"user_role\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/people/roles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"user_role\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:35:\"/admin/people/roles/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.user_role.edit_form','/admin/people/roles/manage/{user_role}','/admin/people/roles/manage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1277:{a:9:{s:4:\"path\";s:38:\"/admin/people/roles/manage/{user_role}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"user_role.default\";s:6:\"_title\";s:9:\"Edit role\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"user_role.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"user_role\";a:2:{s:4:\"type\";s:16:\"entity:user_role\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":526:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"user_role\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/admin/people/roles/manage/(?P<user_role>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"user_role\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/people/roles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"user_role\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:28:\"/admin/people/roles/manage/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.user_role.edit_permissions_form','/admin/people/permissions/{user_role}','/admin/people/permissions/%',14,'C:31:\"Symfony\\Component\\Routing\\Route\":1297:{a:9:{s:4:\"path\";s:37:\"/admin/people/permissions/{user_role}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:49:\"\\Drupal\\user\\Form\\UserPermissionsRoleSpecificForm\";s:6:\"_title\";s:9:\"Edit role\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"user_role.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"user_role\";a:2:{s:4:\"type\";s:16:\"entity:user_role\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":523:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"user_role\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/admin/people/permissions/(?P<user_role>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"user_role\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/people/permissions\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"user_role\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:27:\"/admin/people/permissions/%\";s:8:\"numParts\";i:4;}}}}',4),

('entity.view.break_lock_form','/admin/structure/views/view/{view}/break-lock','/admin/structure/views/view/%/break-lock',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1327:{a:9:{s:4:\"path\";s:45:\"/admin/structure/views/view/{view}/break-lock\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"view.break_lock\";s:6:\"_title\";s:10:\"Break lock\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:15:\"view.break-lock\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":580:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/admin/structure/views/view/(?P<view>[^/]++)/break\\-lock$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/break-lock\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/views/view/%/break-lock\";s:8:\"numParts\";i:6;}}}}',6),

('entity.view.collection','/admin/structure/views','/admin/structure/views',7,'C:31:\"Symfony\\Component\\Routing\\Route\":913:{a:9:{s:4:\"path\";s:22:\"/admin/structure/views\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:4:\"view\";s:6:\"_title\";s:5:\"Views\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/structure/views$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/structure/views\";s:8:\"numParts\";i:3;}}}}',3),

('entity.view.delete_form','/admin/structure/views/view/{view}/delete','/admin/structure/views/view/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1302:{a:9:{s:4:\"path\";s:41:\"/admin/structure/views/view/{view}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:11:\"view.delete\";s:6:\"_title\";s:11:\"Delete view\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"view.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":566:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/admin/structure/views/view/(?P<view>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:36:\"/admin/structure/views/view/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.view.disable','/admin/structure/views/view/{view}/disable','/admin/structure/views/view/%/disable',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1405:{a:9:{s:4:\"path\";s:42:\"/admin/structure/views/view/{view}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::ajaxOperation\";s:2:\"op\";s:7:\"disable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:12:\"view.disable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":569:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/admin/structure/views/view/(?P<view>[^/]++)/disable$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:37:\"/admin/structure/views/view/%/disable\";s:8:\"numParts\";i:6;}}}}',6),

('entity.view.duplicate_form','/admin/structure/views/view/{view}/duplicate','/admin/structure/views/view/%/duplicate',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1324:{a:9:{s:4:\"path\";s:44:\"/admin/structure/views/view/{view}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:14:\"view.duplicate\";s:6:\"_title\";s:14:\"Duplicate view\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"view.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":576:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/admin/structure/views/view/(?P<view>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:39:\"/admin/structure/views/view/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),

('entity.view.edit_display_form','/admin/structure/views/view/{view}/edit/{display_id}','/admin/structure/views/view/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1504:{a:9:{s:4:\"path\";s:52:\"/admin/structure/views/view/{view}/edit/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:51:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::edit\";s:10:\"display_id\";N;}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"view.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":720:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"view\";i:1;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/admin/structure/views/view/(?P<view>[^/]++)/edit(?:/(?P<display_id>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"view\";i:1;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:34:\"/admin/structure/views/view/%/edit\";s:8:\"numParts\";i:7;}}}}',7),

('entity.view.edit_form','/admin/structure/views/view/{view}','/admin/structure/views/view/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1255:{a:9:{s:4:\"path\";s:34:\"/admin/structure/views/view/{view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::edit\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"view.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":509:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/admin/structure/views/view/(?P<view>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:29:\"/admin/structure/views/view/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.view.enable','/admin/structure/views/view/{view}/enable','/admin/structure/views/view/%/enable',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1399:{a:9:{s:4:\"path\";s:41:\"/admin/structure/views/view/{view}/enable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::ajaxOperation\";s:2:\"op\";s:6:\"enable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.enable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":566:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/admin/structure/views/view/(?P<view>[^/]++)/enable$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/enable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:36:\"/admin/structure/views/view/%/enable\";s:8:\"numParts\";i:6;}}}}',6),

('entity.view.preview_form','/admin/structure/views/view/{view}/preview/{display_id}','/admin/structure/views/view/%/preview',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1484:{a:9:{s:4:\"path\";s:55:\"/admin/structure/views/view/{view}/preview/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:12:\"view.preview\";s:10:\"display_id\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":729:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"view\";i:1;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/structure/views/view/(?P<view>[^/]++)/preview(?:/(?P<display_id>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/preview\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"view\";i:1;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:37:\"/admin/structure/views/view/%/preview\";s:8:\"numParts\";i:7;}}}}',7),

('entity.vote_type.collection','/admin/structure/vote-types','/admin/structure/vote-types',7,'C:31:\"Symfony\\Component\\Routing\\Route\":950:{a:9:{s:4:\"path\";s:27:\"/admin/structure/vote-types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:9:\"vote_type\";s:6:\"_title\";s:10:\"Vote Types\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer vote types\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":379:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/structure/vote\\-types$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/vote-types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:27:\"/admin/structure/vote-types\";s:8:\"numParts\";i:3;}}}}',3),

('entity.vote_type.delete_form','/admin/structure/vote-types/{vote_type}/delete','/admin/structure/vote-types/%/delete',29,'C:31:\"Symfony\\Component\\Routing\\Route\":1342:{a:9:{s:4:\"path\";s:46:\"/admin/structure/vote-types/{vote_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"vote_type.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"vote_type.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"vote_type\";a:2:{s:4:\"type\";s:16:\"entity:vote_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":587:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"vote_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/admin/structure/vote\\-types/(?P<vote_type>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"vote_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/vote-types\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"vote_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:29;s:14:\"patternOutline\";s:36:\"/admin/structure/vote-types/%/delete\";s:8:\"numParts\";i:5;}}}}',5),

('entity.vote_type.edit_form','/admin/structure/vote-types/{vote_type}','/admin/structure/vote-types/%',14,'C:31:\"Symfony\\Component\\Routing\\Route\":1256:{a:9:{s:4:\"path\";s:39:\"/admin/structure/vote-types/{vote_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:14:\"vote_type.edit\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer vote types\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"vote_type\";a:2:{s:4:\"type\";s:16:\"entity:vote_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":530:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"vote_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:57:\"#^/admin/structure/vote\\-types/(?P<vote_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"vote_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/vote-types\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"vote_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:29:\"/admin/structure/vote-types/%\";s:8:\"numParts\";i:4;}}}}',4),

('entity.webform.access_denied','/webform/{webform}/access-denied','/webform/%/access-denied',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1314:{a:9:{s:4:\"path\";s:32:\"/webform/{webform}/access-denied\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformEntityController::accessDenied\";s:15:\"_title_callback\";s:69:\"\\Drupal\\webform\\Controller\\WebformEntityController::accessDeniedTitle\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":542:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/webform/(?P<webform>[^/]++)/access\\-denied$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/access-denied\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:24:\"/webform/%/access-denied\";s:8:\"numParts\";i:3;}}}}',3),

('entity.webform.add_form','/admin/structure/webform/add','/admin/structure/webform/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":956:{a:9:{s:4:\"path\";s:28:\"/admin/structure/webform/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:11:\"webform.add\";s:6:\"_title\";s:11:\"Add webform\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:7:\"webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/structure/webform/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/webform/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/structure/webform/add\";s:8:\"numParts\";i:4;}}}}',4),

('entity.webform.assets.css','/webform/css/{webform}','/webform/css/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1144:{a:9:{s:4:\"path\";s:22:\"/webform/css/{webform}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:55:\"\\Drupal\\webform\\Controller\\WebformEntityController::css\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:12:\"webform.view\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":475:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/webform/css/(?P<webform>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/webform/css\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:14:\"/webform/css/%\";s:8:\"numParts\";i:3;}}}}',3),

('entity.webform.assets.javascript','/webform/javascript/{webform}','/webform/javascript/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1179:{a:9:{s:4:\"path\";s:29:\"/webform/javascript/{webform}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:62:\"\\Drupal\\webform\\Controller\\WebformEntityController::javascript\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:12:\"webform.view\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":496:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/webform/javascript/(?P<webform>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/webform/javascript\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:21:\"/webform/javascript/%\";s:8:\"numParts\";i:3;}}}}',3),

('entity.webform.autocomplete','/admin/structure/webform/autocomplete','/admin/structure/webform/autocomplete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1056:{a:9:{s:4:\"path\";s:37:\"/admin/structure/webform/autocomplete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformEntityController::autocomplete\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:64:\"\\Drupal\\webform\\Access\\WebformAccountAccess::checkOverviewAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/structure/webform/autocomplete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/structure/webform/autocomplete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/structure/webform/autocomplete\";s:8:\"numParts\";i:4;}}}}',4),

('entity.webform.autocomplete.archived','/admin/structure/webform/autocomplete/archived','/admin/structure/webform/autocomplete/archived',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1111:{a:9:{s:4:\"path\";s:46:\"/admin/structure/webform/autocomplete/archived\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformEntityController::autocomplete\";s:8:\"archived\";b:1;}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:64:\"\\Drupal\\webform\\Access\\WebformAccountAccess::checkOverviewAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":436:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/structure/webform/autocomplete/archived$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/structure/webform/autocomplete/archived\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:46:\"/admin/structure/webform/autocomplete/archived\";s:8:\"numParts\";i:5;}}}}',5),

('entity.webform.canonical','/webform/{webform}','/webform/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1230:{a:9:{s:4:\"path\";s:18:\"/webform/{webform}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:59:\"\\Drupal\\webform\\Controller\\WebformEntityController::addForm\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"webform.submission_page\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":462:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/webform/(?P<webform>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:10:\"/webform/%\";s:8:\"numParts\";i:2;}}}}',2),

('entity.webform.collection','/admin/structure/webform','/admin/structure/webform',7,'C:31:\"Symfony\\Component\\Routing\\Route\":974:{a:9:{s:4:\"path\";s:24:\"/admin/structure/webform\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:7:\"webform\";s:6:\"_title\";s:8:\"Webforms\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:64:\"\\Drupal\\webform\\Access\\WebformAccountAccess::checkOverviewAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/structure/webform$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/structure/webform\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/structure/webform\";s:8:\"numParts\";i:3;}}}}',3),

('entity.webform.confirmation','/webform/{webform}/confirmation','/webform/%/confirmation',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1434:{a:9:{s:4:\"path\";s:31:\"/webform/{webform}/confirmation\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformEntityController::confirmation\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:12:\"webform.view\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":538:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/webform/(?P<webform>[^/]++)/confirmation$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/confirmation\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:23:\"/webform/%/confirmation\";s:8:\"numParts\";i:3;}}}}',3),

('entity.webform.delete_form','/admin/structure/webform/manage/{webform}/delete','/admin/structure/webform/manage/%/delete',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1348:{a:9:{s:4:\"path\";s:48:\"/admin/structure/webform/manage/{webform}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:14:\"webform.delete\";s:6:\"_title\";s:14:\"Delete webform\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":590:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/webform/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform.duplicate_form','/admin/structure/webform/manage/{webform}/duplicate','/admin/structure/webform/manage/%/duplicate',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1370:{a:9:{s:4:\"path\";s:51:\"/admin/structure/webform/manage/{webform}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"webform.duplicate\";s:6:\"_title\";s:17:\"Duplicate webform\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:17:\"webform.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":600:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:43:\"/admin/structure/webform/manage/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform.edit_form','/admin/structure/webform/manage/{webform}','/admin/structure/webform/manage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1335:{a:9:{s:4:\"path\";s:41:\"/admin/structure/webform/manage/{webform}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:12:\"webform.edit\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":533:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:33:\"/admin/structure/webform/manage/%\";s:8:\"numParts\";i:5;}}}}',5),

('entity.webform.export_form','/admin/structure/webform/manage/{webform}/export','/admin/structure/webform/manage/%/export',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1408:{a:9:{s:4:\"path\";s:48:\"/admin/structure/webform/manage/{webform}/export\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:14:\"webform.export\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"export configuration\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":590:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/export$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/export\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/webform/manage/%/export\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform.handler','/admin/structure/webform/manage/{webform}/handlers/add','/admin/structure/webform/manage/%/handlers/add',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1556:{a:9:{s:4:\"path\";s:54:\"/admin/structure/webform/manage/{webform}/handlers/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:71:\"\\Drupal\\webform\\Controller\\WebformPluginHandlerController::listHandlers\";s:6:\"_title\";s:16:\"Select a handler\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"webform.update\";s:14:\"_custom_access\";s:63:\"\\Drupal\\webform\\Access\\WebformHandlerAccess::checkHandlerAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":610:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/handlers/add$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/handlers/add\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:46:\"/admin/structure/webform/manage/%/handlers/add\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform.handler.add_email','/admin/structure/webform/manage/{webform}/handlers/add/email','/admin/structure/webform/manage/%/handlers/add/email',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1571:{a:9:{s:4:\"path\";s:60:\"/admin/structure/webform/manage/{webform}/handlers/add/email\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:42:\"\\Drupal\\webform\\Form\\WebformHandlerAddForm\";s:6:\"_title\";s:9:\"Add email\";s:15:\"webform_handler\";s:5:\"email\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"webform.update\";s:14:\"_custom_access\";s:63:\"\\Drupal\\webform\\Access\\WebformHandlerAccess::checkHandlerAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":628:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/handlers/add/email$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/handlers/add/email\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:52:\"/admin/structure/webform/manage/%/handlers/add/email\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.handler.add_form','/admin/structure/webform/manage/{webform}/handlers/add/{webform_handler}','/admin/structure/webform/manage/%/handlers/add/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1718:{a:9:{s:4:\"path\";s:72:\"/admin/structure/webform/manage/{webform}/handlers/add/{webform_handler}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:42:\"\\Drupal\\webform\\Form\\WebformHandlerAddForm\";s:6:\"_title\";s:19:\"Add webform handler\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"webform.update\";s:14:\"_custom_access\";s:63:\"\\Drupal\\webform\\Access\\WebformHandlerAccess::checkHandlerAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":787:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:99:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/handlers/add/(?P<webform_handler>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_handler\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/handlers/add\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:48:\"/admin/structure/webform/manage/%/handlers/add/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.handler.delete_form','/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/delete','/admin/structure/webform/manage/%/handlers/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1648:{a:9:{s:4:\"path\";s:75:\"/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:45:\"\\Drupal\\webform\\Form\\WebformHandlerDeleteForm\";s:6:\"_title\";s:22:\"Delete webform handler\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":832:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:102:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/handlers/(?P<webform_handler>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_handler\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/handlers\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:51:\"/admin/structure/webform/manage/%/handlers/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.handler.disable','/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/disable','/admin/structure/webform/manage/%/handlers/%/disable',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1709:{a:9:{s:4:\"path\";s:76:\"/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:56:\"\\Drupal\\webform\\WebformEntityHandlersForm::ajaxOperation\";s:2:\"op\";s:7:\"disable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"webform.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":835:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:103:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/handlers/(?P<webform_handler>[^/]++)/disable$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_handler\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/handlers\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:52:\"/admin/structure/webform/manage/%/handlers/%/disable\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.handler.duplicate_form','/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/duplicate','/admin/structure/webform/manage/%/handlers/%/duplicate',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1667:{a:9:{s:4:\"path\";s:78:\"/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:48:\"\\Drupal\\webform\\Form\\WebformHandlerDuplicateForm\";s:6:\"_title\";s:25:\"Duplicate webform handler\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":842:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:105:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/handlers/(?P<webform_handler>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_handler\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/handlers\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:54:\"/admin/structure/webform/manage/%/handlers/%/duplicate\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.handler.edit_form','/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/edit','/admin/structure/webform/manage/%/handlers/%/edit',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1636:{a:9:{s:4:\"path\";s:73:\"/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"\\Drupal\\webform\\Form\\WebformHandlerEditForm\";s:6:\"_title\";s:20:\"Edit webform handler\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":826:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:100:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/handlers/(?P<webform_handler>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_handler\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/handlers\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:49:\"/admin/structure/webform/manage/%/handlers/%/edit\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.handler.enable','/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/enable','/admin/structure/webform/manage/%/handlers/%/enable',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1704:{a:9:{s:4:\"path\";s:75:\"/admin/structure/webform/manage/{webform}/handlers/{webform_handler}/enable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:56:\"\\Drupal\\webform\\WebformEntityHandlersForm::ajaxOperation\";s:2:\"op\";s:6:\"enable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"webform.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":832:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:102:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/handlers/(?P<webform_handler>[^/]++)/enable$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/enable\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_handler\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/handlers\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"webform_handler\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:51:\"/admin/structure/webform/manage/%/handlers/%/enable\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.handlers','/admin/structure/webform/manage/{webform}/handlers','/admin/structure/webform/manage/%/handlers',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1411:{a:9:{s:4:\"path\";s:50:\"/admin/structure/webform/manage/{webform}/handlers\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"webform.handlers\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":596:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/handlers$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/handlers\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:42:\"/admin/structure/webform/manage/%/handlers\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform.references','/admin/structure/webform/manage/{webform}/references','/admin/structure/webform/manage/%/references',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1479:{a:9:{s:4:\"path\";s:52:\"/admin/structure/webform/manage/{webform}/references\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:76:\"\\Drupal\\webform_node\\Controller\\WebformNodeReferencesListController::listing\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":603:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/references$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/references\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:44:\"/admin/structure/webform/manage/%/references\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform.results.source_entity.autocomplete','/admin/structure/webform/manage/{webform}/results/source-entity/autocomplete','/admin/structure/webform/manage/%/results/source-entity/autocomplete',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1629:{a:9:{s:4:\"path\";s:76:\"/admin/structure/webform/manage/{webform}/results/source-entity/autocomplete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:81:\"\\Drupal\\webform\\Controller\\WebformSubmissionsController::sourceEntityAutocomplete\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:27:\"webform.submission_view_any\";s:14:\"_custom_access\";s:61:\"\\Drupal\\webform\\Access\\WebformEntityAccess:checkResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":677:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:94:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/results/source\\-entity/autocomplete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/results/source-entity/autocomplete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:68:\"/admin/structure/webform/manage/%/results/source-entity/autocomplete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.results_clear','/admin/structure/webform/manage/{webform}/results/clear','/admin/structure/webform/manage/%/results/clear',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1588:{a:9:{s:4:\"path\";s:55:\"/admin/structure/webform/manage/{webform}/results/clear\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"Drupal\\webform\\Form\\WebformResultsClearForm\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:28:\"webform.submission_purge_any\";s:14:\"_custom_access\";s:61:\"\\Drupal\\webform\\Access\\WebformEntityAccess:checkResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":613:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:72:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/results/clear$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/results/clear\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:47:\"/admin/structure/webform/manage/%/results/clear\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform.results_export','/admin/structure/webform/manage/{webform}/results/download','/admin/structure/webform/manage/%/results/download',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1627:{a:9:{s:4:\"path\";s:58:\"/admin/structure/webform/manage/{webform}/results/download\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformResultsExportController::index\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:27:\"webform.submission_view_any\";s:14:\"_custom_access\";s:61:\"\\Drupal\\webform\\Access\\WebformEntityAccess:checkResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":622:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/results/download$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/results/download\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:50:\"/admin/structure/webform/manage/%/results/download\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform.results_export_file','/admin/structure/webform/manage/{webform}/results/download/file/{filename}','/admin/structure/webform/manage/%/results/download/file/%',494,'C:31:\"Symfony\\Component\\Routing\\Route\":1804:{a:9:{s:4:\"path\";s:74:\"/admin/structure/webform/manage/{webform}/results/download/file/{filename}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:63:\"\\Drupal\\webform\\Controller\\WebformResultsExportController::file\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:27:\"webform.submission_view_any\";s:14:\"_custom_access\";s:61:\"\\Drupal\\webform\\Access\\WebformEntityAccess:checkResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":784:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:8:\"filename\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:101:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/results/download/file/(?P<filename>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"filename\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/results/download/file\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:8:\"filename\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:494;s:14:\"patternOutline\";s:57:\"/admin/structure/webform/manage/%/results/download/file/%\";s:8:\"numParts\";i:9;}}}}',9),

('entity.webform.results_submissions','/admin/structure/webform/manage/{webform}/results/submissions/{submission_view}','/admin/structure/webform/manage/%/results/submissions',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1823:{a:9:{s:4:\"path\";s:79:\"/admin/structure/webform/manage/{webform}/results/submissions/{submission_view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_list\";s:18:\"webform_submission\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";s:15:\"submission_view\";s:0:\"\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:27:\"webform.submission_view_any\";s:14:\"_custom_access\";s:61:\"\\Drupal\\webform\\Access\\WebformEntityAccess:checkResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":812:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"submission_view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:111:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/results/submissions(?:/(?P<submission_view>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"submission_view\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/results/submissions\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"submission_view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:53:\"/admin/structure/webform/manage/%/results/submissions\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.results_submissions.custom','/admin/structure/webform/manage/{webform}/results/submissions/custom','/admin/structure/webform/manage/%/results/submissions/custom',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1575:{a:9:{s:4:\"path\";s:68:\"/admin/structure/webform/manage/{webform}/results/submissions/custom\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:44:\"Drupal\\webform\\Form\\WebformResultsCustomForm\";s:6:\"_title\";s:15:\"Customize table\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"webform.update\";s:14:\"_custom_access\";s:61:\"\\Drupal\\webform\\Access\\WebformEntityAccess:checkResultsAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":652:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:85:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/results/submissions/custom$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/results/submissions/custom\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:60:\"/admin/structure/webform/manage/%/results/submissions/custom\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform.settings','/admin/structure/webform/manage/{webform}/settings','/admin/structure/webform/manage/%/settings',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1411:{a:9:{s:4:\"path\";s:50:\"/admin/structure/webform/manage/{webform}/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"webform.settings\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":596:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/settings$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/settings\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:42:\"/admin/structure/webform/manage/%/settings\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform.settings_access','/admin/structure/webform/manage/{webform}/access','/admin/structure/webform/manage/%/access',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1410:{a:9:{s:4:\"path\";s:48:\"/admin/structure/webform/manage/{webform}/access\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"webform.settings_access\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":590:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/access$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/access\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/webform/manage/%/access\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform.settings_assets','/admin/structure/webform/manage/{webform}/settings/assets','/admin/structure/webform/manage/%/settings/assets',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1529:{a:9:{s:4:\"path\";s:57:\"/admin/structure/webform/manage/{webform}/settings/assets\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"webform.settings_assets\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"webform.update\";s:11:\"_permission\";s:19:\"edit webform assets\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":619:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:74:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/settings/assets$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/settings/assets\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:49:\"/admin/structure/webform/manage/%/settings/assets\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform.settings_confirmation','/admin/structure/webform/manage/{webform}/settings/confirmation','/admin/structure/webform/manage/%/settings/confirmation',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1478:{a:9:{s:4:\"path\";s:63:\"/admin/structure/webform/manage/{webform}/settings/confirmation\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:29:\"webform.settings_confirmation\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":637:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/settings/confirmation$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/settings/confirmation\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:55:\"/admin/structure/webform/manage/%/settings/confirmation\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform.settings_form','/admin/structure/webform/manage/{webform}/settings/form','/admin/structure/webform/manage/%/settings/form',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1438:{a:9:{s:4:\"path\";s:55:\"/admin/structure/webform/manage/{webform}/settings/form\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"webform.settings_form\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":613:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:72:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/settings/form$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/settings/form\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:47:\"/admin/structure/webform/manage/%/settings/form\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform.settings_submissions','/admin/structure/webform/manage/{webform}/settings/submissions','/admin/structure/webform/manage/%/settings/submissions',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1473:{a:9:{s:4:\"path\";s:62:\"/admin/structure/webform/manage/{webform}/settings/submissions\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:28:\"webform.settings_submissions\";s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"webform.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":634:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/settings/submissions$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/settings/submissions\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:54:\"/admin/structure/webform/manage/%/settings/submissions\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform.source_form','/admin/structure/webform/manage/{webform}/source','/admin/structure/webform/manage/%/source',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1454:{a:9:{s:4:\"path\";s:48:\"/admin/structure/webform/manage/{webform}/source\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:15:\"_title_callback\";s:57:\"\\Drupal\\webform\\Controller\\WebformEntityController::title\";s:12:\"_entity_form\";s:14:\"webform.source\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:67:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformSourceAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":590:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/source$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/source\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/webform/manage/%/source\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform.test_form','/webform/{webform}/test','/webform/%/test',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1272:{a:9:{s:4:\"path\";s:23:\"/webform/{webform}/test\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\webform\\Controller\\WebformTestController::testForm\";s:15:\"_title_callback\";s:55:\"\\Drupal\\webform\\Controller\\WebformTestController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:12:\"webform.test\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":513:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/webform/(?P<webform>[^/]++)/test$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/test\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/webform/%/test\";s:8:\"numParts\";i:3;}}}}',3),

('entity.webform.user.drafts','/webform/{webform}/drafts/{submission_view}','/webform/%/drafts',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1544:{a:9:{s:4:\"path\";s:43:\"/webform/{webform}/drafts/{submission_view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_list\";s:18:\"webform_submission\";s:6:\"_title\";s:6:\"Drafts\";s:15:\"submission_view\";s:0:\"\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:25:\"webform.submission_create\";s:14:\"_custom_access\";s:61:\"\\Drupal\\webform\\Access\\WebformEntityAccess::checkDraftsAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":699:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"submission_view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/webform/(?P<webform>[^/]++)/drafts(?:/(?P<submission_view>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"submission_view\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/drafts\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"submission_view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/webform/%/drafts\";s:8:\"numParts\";i:4;}}}}',4),

('entity.webform.user.submission','/webform/{webform}/submissions/{webform_submission}','/webform/%/submissions/%',10,'C:31:\"Symfony\\Component\\Routing\\Route\":1589:{a:9:{s:4:\"path\";s:51:\"/webform/{webform}/submissions/{webform_submission}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:4:\"html\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"webform_submission.view\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":725:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/webform/(?P<webform>[^/]++)/submissions/(?P<webform_submission>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/submissions\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:10;s:14:\"patternOutline\";s:24:\"/webform/%/submissions/%\";s:8:\"numParts\";i:4;}}}}',4),

('entity.webform.user.submission.delete','/webform/{webform}/submissions/{webform_submission}/delete','/webform/%/submissions/%/delete',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1540:{a:9:{s:4:\"path\";s:58:\"/webform/{webform}/submissions/{webform_submission}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"webform_submission.delete\";s:6:\"_title\";s:25:\"Delete webform submission\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"webform_submission.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":782:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:85:\"#^/webform/(?P<webform>[^/]++)/submissions/(?P<webform_submission>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/submissions\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:31:\"/webform/%/submissions/%/delete\";s:8:\"numParts\";i:5;}}}}',5),

('entity.webform.user.submission.duplicate','/webform/{webform}/submissions/{webform_submission}/duplicate','/webform/%/submissions/%/duplicate',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1916:{a:9:{s:4:\"path\";s:61:\"/webform/{webform}/submissions/{webform_submission}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:28:\"webform_submission.duplicate\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"duplicate\";b:1;s:7:\"setting\";s:25:\"submission_user_duplicate\";s:5:\"value\";b:1;}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:25:\"webform_submission.update\";s:14:\"_custom_access\";s:68:\"\\Drupal\\webform\\Access\\WebformEntityAccess::checkWebformSettingValue\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":792:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/webform/(?P<webform>[^/]++)/submissions/(?P<webform_submission>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/submissions\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:34:\"/webform/%/submissions/%/duplicate\";s:8:\"numParts\";i:5;}}}}',5),

('entity.webform.user.submission.edit','/webform/{webform}/submissions/{webform_submission}/edit','/webform/%/submissions/%/edit',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1580:{a:9:{s:4:\"path\";s:56:\"/webform/{webform}/submissions/{webform_submission}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"webform_submission.edit\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"webform_submission.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":776:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:83:\"#^/webform/(?P<webform>[^/]++)/submissions/(?P<webform_submission>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/submissions\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:29:\"/webform/%/submissions/%/edit\";s:8:\"numParts\";i:5;}}}}',5),

('entity.webform.user.submissions','/webform/{webform}/submissions/{submission_view}','/webform/%/submissions',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1451:{a:9:{s:4:\"path\";s:48:\"/webform/{webform}/submissions/{submission_view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_list\";s:18:\"webform_submission\";s:6:\"_title\";s:11:\"Submissions\";s:15:\"submission_view\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:27:\"webform.submission_view_own\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":715:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"submission_view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/webform/(?P<webform>[^/]++)/submissions(?:/(?P<submission_view>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"submission_view\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/submissions\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:15:\"submission_view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:22:\"/webform/%/submissions\";s:8:\"numParts\";i:4;}}}}',4),

('entity.webform_options.add_form','/admin/structure/webform/config/options/manage/add','/admin/structure/webform/config/options/manage/add',127,'C:31:\"Symfony\\Component\\Routing\\Route\":1070:{a:9:{s:4:\"path\";s:50:\"/admin/structure/webform/config/options/manage/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"webform_options.add\";s:6:\"_title\";s:19:\"Add webform options\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:15:\"webform_options\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":449:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:57:\"#^/admin/structure/webform/config/options/manage/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:50:\"/admin/structure/webform/config/options/manage/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:127;s:14:\"patternOutline\";s:50:\"/admin/structure/webform/config/options/manage/add\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform_options.autocomplete','/admin/structure/webform/config/options/autocomplete','/admin/structure/webform/config/options/autocomplete',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1072:{a:9:{s:4:\"path\";s:52:\"/admin/structure/webform/config/options/autocomplete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:65:\"\\Drupal\\webform\\Controller\\WebformOptionsController::autocomplete\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":454:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/admin/structure/webform/config/options/autocomplete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:52:\"/admin/structure/webform/config/options/autocomplete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:52:\"/admin/structure/webform/config/options/autocomplete\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform_options.collection','/admin/structure/webform/config/options/manage','/admin/structure/webform/config/options/manage',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1037:{a:9:{s:4:\"path\";s:46:\"/admin/structure/webform/config/options/manage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:15:\"webform_options\";s:6:\"_title\";s:17:\"Webforms: Options\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":436:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/structure/webform/config/options/manage$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/structure/webform/config/options/manage\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:46:\"/admin/structure/webform/config/options/manage\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform_options.delete_form','/admin/structure/webform/config/options/{webform_options}/delete','/admin/structure/webform/config/options/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1465:{a:9:{s:4:\"path\";s:64:\"/admin/structure/webform/config/options/{webform_options}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:22:\"webform_options.delete\";s:6:\"_title\";s:22:\"Delete webform options\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:22:\"webform_options.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:15:\"webform_options\";a:2:{s:4:\"type\";s:22:\"entity:webform_options\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":650:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"webform_options\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:81:\"#^/admin/structure/webform/config/options/(?P<webform_options>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_options\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/webform/config/options\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"webform_options\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:48:\"/admin/structure/webform/config/options/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform_options.duplicate_form','/admin/structure/webform/config/options/{webform_options}/duplicate','/admin/structure/webform/config/options/%/duplicate',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1487:{a:9:{s:4:\"path\";s:67:\"/admin/structure/webform/config/options/{webform_options}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"webform_options.duplicate\";s:6:\"_title\";s:25:\"Duplicate webform options\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"webform_options.duplicate\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:15:\"webform_options\";a:2:{s:4:\"type\";s:22:\"entity:webform_options\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":660:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"webform_options\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:84:\"#^/admin/structure/webform/config/options/(?P<webform_options>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_options\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/webform/config/options\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"webform_options\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/structure/webform/config/options/%/duplicate\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform_options.edit_form','/admin/structure/webform/config/options/manage/{webform_options}/edit','/admin/structure/webform/config/options/manage/%/edit',253,'C:31:\"Symfony\\Component\\Routing\\Route\":1481:{a:9:{s:4:\"path\";s:69:\"/admin/structure/webform/config/options/manage/{webform_options}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:20:\"webform_options.edit\";s:6:\"_title\";s:20:\"Edit webform options\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:22:\"webform_options.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:15:\"webform_options\";a:2:{s:4:\"type\";s:22:\"entity:webform_options\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":665:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"webform_options\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/structure/webform/config/options/manage/(?P<webform_options>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_options\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/structure/webform/config/options/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"webform_options\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:253;s:14:\"patternOutline\";s:53:\"/admin/structure/webform/config/options/manage/%/edit\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_options.source_form','/admin/structure/webform/config/options/manage/{webform_options}/source','/admin/structure/webform/config/options/manage/%/source',253,'C:31:\"Symfony\\Component\\Routing\\Route\":1501:{a:9:{s:4:\"path\";s:71:\"/admin/structure/webform/config/options/manage/{webform_options}/source\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:22:\"webform_options.source\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:73:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformOptionSourceAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:15:\"webform_options\";a:2:{s:4:\"type\";s:22:\"entity:webform_options\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":671:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"webform_options\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/structure/webform/config/options/manage/(?P<webform_options>[^/]++)/source$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/source\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"webform_options\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/structure/webform/config/options/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"webform_options\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:253;s:14:\"patternOutline\";s:55:\"/admin/structure/webform/config/options/manage/%/source\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.access_denied','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/access-denied','/admin/structure/webform/manage/%/submission/%/access-denied',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1896:{a:9:{s:4:\"path\";s:87:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/access-denied\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\webform\\Controller\\WebformSubmissionController::accessDenied\";s:15:\"_title_callback\";s:73:\"\\Drupal\\webform\\Controller\\WebformSubmissionController::accessDeniedTitle\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":874:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:115:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/access\\-denied$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/access-denied\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:60:\"/admin/structure/webform/manage/%/submission/%/access-denied\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.canonical','/admin/structure/webform/manage/{webform}/submission/{webform_submission}','/admin/structure/webform/manage/%/submission/%',122,'C:31:\"Symfony\\Component\\Routing\\Route\":1704:{a:9:{s:4:\"path\";s:73:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:4:\"html\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"webform_submission.view\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":794:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:100:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:46:\"/admin/structure/webform/manage/%/submission/%\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform_submission.collection','/admin/structure/webform/submissions/manage/{submission_view}','/admin/structure/webform/submissions/manage',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1306:{a:9:{s:4:\"path\";s:61:\"/admin/structure/webform/submissions/manage/{submission_view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_list\";s:18:\"webform_submission\";s:6:\"_title\";s:21:\"Webforms: Submissions\";s:15:\"submission_view\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform\\Access\\WebformAccountAccess:checkSubmissionAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":607:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"submission_view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:83:\"#^/admin/structure/webform/submissions/manage(?:/(?P<submission_view>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"submission_view\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/webform/submissions/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"submission_view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:43:\"/admin/structure/webform/submissions/manage\";s:8:\"numParts\";i:6;}}}}',6),

('entity.webform_submission.collection_purge','/admin/structure/webform/submissions/purge','/admin/structure/webform/submissions/purge',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1055:{a:9:{s:4:\"path\";s:42:\"/admin/structure/webform/submissions/purge\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:47:\"Drupal\\webform\\Form\\WebformSubmissionsPurgeForm\";s:6:\"_title\";s:27:\"Webforms: Submissions purge\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":424:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:49:\"#^/admin/structure/webform/submissions/purge$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/webform/submissions/purge\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:42:\"/admin/structure/webform/submissions/purge\";s:8:\"numParts\";i:5;}}}}',5),

('entity.webform_submission.delete_form','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/delete','/admin/structure/webform/manage/%/submission/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1655:{a:9:{s:4:\"path\";s:80:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"webform_submission.delete\";s:6:\"_title\";s:25:\"Delete webform submission\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"webform_submission.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":851:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/webform/manage/%/submission/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.duplicate_form','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/duplicate','/admin/structure/webform/manage/%/submission/%/duplicate',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1745:{a:9:{s:4:\"path\";s:83:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:28:\"webform_submission.duplicate\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"duplicate\";b:1;}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:29:\"webform_submission.update_any\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":861:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:110:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:56:\"/admin/structure/webform/manage/%/submission/%/duplicate\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.edit_form','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/edit','/admin/structure/webform/manage/%/submission/%/edit',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1695:{a:9:{s:4:\"path\";s:78:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"webform_submission.edit\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"webform_submission.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":845:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:105:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:51:\"/admin/structure/webform/manage/%/submission/%/edit\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.edit_form.all','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/edit/all','/admin/structure/webform/manage/%/submission/%/edit/all',491,'C:31:\"Symfony\\Component\\Routing\\Route\":1846:{a:9:{s:4:\"path\";s:82:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/edit/all\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:27:\"webform_submission.edit_all\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:25:\"webform_submission.update\";s:14:\"_custom_access\";s:70:\"\\Drupal\\webform\\Access\\WebformSubmissionAccess::checkWizardPagesAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":857:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:109:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/edit/all$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/edit/all\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:491;s:14:\"patternOutline\";s:55:\"/admin/structure/webform/manage/%/submission/%/edit/all\";s:8:\"numParts\";i:9;}}}}',9),

('entity.webform_submission.locked_toggle','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/locked','/admin/structure/webform/manage/%/submission/%/locked',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1704:{a:9:{s:4:\"path\";s:80:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/locked\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:62:\"\\Drupal\\webform\\Controller\\WebformSubmissionController::locked\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:25:\"webform_submission.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":851:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/locked$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/locked\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/webform/manage/%/submission/%/locked\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.notes_form','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/notes','/admin/structure/webform/manage/%/submission/%/notes',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1699:{a:9:{s:4:\"path\";s:79:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/notes\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"webform_submission.notes\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:24:\"webform_submission.notes\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":848:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:106:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/notes$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/notes\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:52:\"/admin/structure/webform/manage/%/submission/%/notes\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.resend_form','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/resend','/admin/structure/webform/manage/%/submission/%/resend',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1849:{a:9:{s:4:\"path\";s:80:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/resend\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:47:\"Drupal\\webform\\Form\\WebformSubmissionResendForm\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:29:\"webform_submission.update_any\";s:14:\"_custom_access\";s:65:\"\\Drupal\\webform\\Access\\WebformSubmissionAccess::checkResendAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":851:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/resend$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/resend\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/webform/manage/%/submission/%/resend\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.sticky_toggle','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/sticky','/admin/structure/webform/manage/%/submission/%/sticky',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1704:{a:9:{s:4:\"path\";s:80:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/sticky\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:62:\"\\Drupal\\webform\\Controller\\WebformSubmissionController::sticky\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:25:\"webform_submission.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":851:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/sticky$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/sticky\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/webform/manage/%/submission/%/sticky\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.table','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/table','/admin/structure/webform/manage/%/submission/%/table',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1765:{a:9:{s:4:\"path\";s:79:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/table\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:5:\"table\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"webform_submission.view\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":848:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:106:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/table$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/table\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:52:\"/admin/structure/webform/manage/%/submission/%/table\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.text','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/text','/admin/structure/webform/manage/%/submission/%/text',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1764:{a:9:{s:4:\"path\";s:78:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/text\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:4:\"text\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:27:\"webform_submission.view_any\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":845:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:105:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/text$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/text\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:51:\"/admin/structure/webform/manage/%/submission/%/text\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_submission.user','/user/{user}/submissions/{submission_view}','/user/%/submissions',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1462:{a:9:{s:4:\"path\";s:42:\"/user/{user}/submissions/{submission_view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_list\";s:18:\"webform_submission\";s:6:\"_title\";s:11:\"Submissions\";s:15:\"submission_view\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:71:\"\\Drupal\\webform\\Access\\WebformAccountAccess::checkUserSubmissionsAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":694:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:15:\"submission_view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:74:\"#^/user/(?P<user>[^/]++)/submissions(?:/(?P<submission_view>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"submission_view\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/submissions\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:15:\"submission_view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:19:\"/user/%/submissions\";s:8:\"numParts\";i:4;}}}}',4),

('entity.webform_submission.yaml','/admin/structure/webform/manage/{webform}/submission/{webform_submission}/yaml','/admin/structure/webform/manage/%/submission/%/yaml',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1845:{a:9:{s:4:\"path\";s:78:\"/admin/structure/webform/manage/{webform}/submission/{webform_submission}/yaml\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::view\";s:15:\"_title_callback\";s:65:\"\\Drupal\\webform\\Controller\\WebformSubmissionViewController::title\";s:9:\"view_mode\";s:4:\"yaml\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"edit webform source\";s:14:\"_entity_access\";s:27:\"webform_submission.view_any\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"webform_submission\";a:2:{s:4:\"type\";s:25:\"entity:webform_submission\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":845:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:105:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/submission/(?P<webform_submission>[^/]++)/yaml$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/yaml\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"webform_submission\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/submission\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:18:\"webform_submission\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:51:\"/admin/structure/webform/manage/%/submission/%/yaml\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_ui.change_element','/admin/structure/webform/manage/{webform}/element/{key}/change','/admin/structure/webform/manage/%/element/%/change',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1641:{a:9:{s:4:\"path\";s:62:\"/admin/structure/webform/manage/{webform}/element/{key}/change\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:54:\"\\Drupal\\webform_ui\\Form\\WebformUiElementTypeChangeForm\";s:6:\"_title\";s:23:\"Select new element type\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformEditAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":777:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:89:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/element/(?P<key>[^/]++)/change$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/change\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"key\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/element\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:50:\"/admin/structure/webform/manage/%/element/%/change\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_ui.element','/admin/structure/webform/manage/{webform}/element/add','/admin/structure/webform/manage/%/element/add',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1456:{a:9:{s:4:\"path\";s:53:\"/admin/structure/webform/manage/{webform}/element/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:54:\"\\Drupal\\webform_ui\\Form\\WebformUiElementTypeSelectForm\";s:6:\"_title\";s:17:\"Select an element\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformEditAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":607:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/element/add$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/element/add\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:45:\"/admin/structure/webform/manage/%/element/add\";s:8:\"numParts\";i:7;}}}}',7),

('entity.webform_ui.element.add_form','/admin/structure/webform/manage/{webform}/element/add/{type}','/admin/structure/webform/manage/%/element/add/%',246,'C:31:\"Symfony\\Component\\Routing\\Route\":1583:{a:9:{s:4:\"path\";s:60:\"/admin/structure/webform/manage/{webform}/element/add/{type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:47:\"\\Drupal\\webform_ui\\Form\\WebformUiElementAddForm\";s:6:\"_title\";s:11:\"Add element\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:68:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformElementAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":737:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/element/add/(?P<type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/element/add\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:47:\"/admin/structure/webform/manage/%/element/add/%\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_ui.element.add_layout','/admin/structure/webform/manage/{webform}/element/add/layout','/admin/structure/webform/manage/%/element/add/layout',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1507:{a:9:{s:4:\"path\";s:60:\"/admin/structure/webform/manage/{webform}/element/add/layout\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:47:\"\\Drupal\\webform_ui\\Form\\WebformUiElementAddForm\";s:6:\"_title\";s:10:\"Add layout\";s:4:\"type\";s:15:\"webform_flexbox\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:68:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformElementAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":628:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/element/add/layout$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/element/add/layout\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:52:\"/admin/structure/webform/manage/%/element/add/layout\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_ui.element.add_page','/admin/structure/webform/manage/{webform}/element/add/page','/admin/structure/webform/manage/%/element/add/page',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1500:{a:9:{s:4:\"path\";s:58:\"/admin/structure/webform/manage/{webform}/element/add/page\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:47:\"\\Drupal\\webform_ui\\Form\\WebformUiElementAddForm\";s:6:\"_title\";s:8:\"Add page\";s:4:\"type\";s:19:\"webform_wizard_page\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:68:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformElementAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":622:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"webform\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/element/add/page$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/element/add/page\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"webform\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:50:\"/admin/structure/webform/manage/%/element/add/page\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_ui.element.delete_form','/admin/structure/webform/manage/{webform}/element/{key}/delete','/admin/structure/webform/manage/%/element/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1628:{a:9:{s:4:\"path\";s:62:\"/admin/structure/webform/manage/{webform}/element/{key}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:50:\"\\Drupal\\webform_ui\\Form\\WebformUiElementDeleteForm\";s:6:\"_title\";s:14:\"Delete element\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformEditAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":777:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:89:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/element/(?P<key>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"key\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/element\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:50:\"/admin/structure/webform/manage/%/element/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_ui.element.duplicate_form','/admin/structure/webform/manage/{webform}/element/{key}/duplicate','/admin/structure/webform/manage/%/element/%/duplicate',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1647:{a:9:{s:4:\"path\";s:65:\"/admin/structure/webform/manage/{webform}/element/{key}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:53:\"\\Drupal\\webform_ui\\Form\\WebformUiElementDuplicateForm\";s:6:\"_title\";s:17:\"Duplicate element\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformEditAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":787:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:92:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/element/(?P<key>[^/]++)/duplicate$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"key\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/element\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/webform/manage/%/element/%/duplicate\";s:8:\"numParts\";i:8;}}}}',8),

('entity.webform_ui.element.edit_form','/admin/structure/webform/manage/{webform}/element/{key}/edit','/admin/structure/webform/manage/%/element/%/edit',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1616:{a:9:{s:4:\"path\";s:60:\"/admin/structure/webform/manage/{webform}/element/{key}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:48:\"\\Drupal\\webform_ui\\Form\\WebformUiElementEditForm\";s:6:\"_title\";s:12:\"Edit element\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:65:\"\\Drupal\\webform_ui\\Access\\WebformUiAccess::checkWebformEditAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":771:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/structure/webform/manage/(?P<webform>[^/]++)/element/(?P<key>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"key\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/element\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:48:\"/admin/structure/webform/manage/%/element/%/edit\";s:8:\"numParts\";i:8;}}}}',8),

('entity_browser.browse_files','/entity-browser/iframe/browse_files','/entity-browser/iframe/browse_files',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1184:{a:9:{s:4:\"path\";s:35:\"/entity-browser/iframe/browse_files\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:79:\"Drupal\\entity_browser\\Controllers\\EntityBrowserFormController::getContentResult\";s:15:\"_title_callback\";s:68:\"Drupal\\entity_browser\\Controllers\\EntityBrowserFormController::title\";s:17:\"entity_browser_id\";s:12:\"browse_files\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:40:\"access browse_files entity browser pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":403:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/entity\\-browser/iframe/browse_files$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/entity-browser/iframe/browse_files\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:35:\"/entity-browser/iframe/browse_files\";s:8:\"numParts\";i:3;}}}}',3),

('entity_browser.browse_files_modal','/entity-browser/modal/browse_files_modal','/entity-browser/modal/browse_files_modal',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1216:{a:9:{s:4:\"path\";s:40:\"/entity-browser/modal/browse_files_modal\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:79:\"Drupal\\entity_browser\\Controllers\\EntityBrowserFormController::getContentResult\";s:15:\"_title_callback\";s:68:\"Drupal\\entity_browser\\Controllers\\EntityBrowserFormController::title\";s:17:\"entity_browser_id\";s:18:\"browse_files_modal\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:46:\"access browse_files_modal entity browser pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":418:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/entity\\-browser/modal/browse_files_modal$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/entity-browser/modal/browse_files_modal\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:40:\"/entity-browser/modal/browse_files_modal\";s:8:\"numParts\";i:3;}}}}',3),

('entity_browser.edit_form','/entity_browser/{entity_type}/{entity}/edit','/entity_browser/%/%/edit',9,'C:31:\"Symfony\\Component\\Routing\\Route\":1476:{a:9:{s:4:\"path\";s:43:\"/entity_browser/{entity_type}/{entity}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:77:\"\\Drupal\\entity_browser\\Controllers\\EntityBrowserController::entityBrowserEdit\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:13:\"entity.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":692:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/entity_browser/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/entity_browser\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:9;s:14:\"patternOutline\";s:24:\"/entity_browser/%/%/edit\";s:8:\"numParts\";i:4;}}}}',4),

('entity_embed.dialog','/entity-embed/dialog/{editor}/{embed_button}','/entity-embed/dialog/%/%',12,'C:31:\"Symfony\\Component\\Routing\\Route\":1491:{a:9:{s:4:\"path\";s:44:\"/entity-embed/dialog/{editor}/{embed_button}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"\\Drupal\\entity_embed\\Form\\EntityEmbedDialog\";s:6:\"_title\";s:12:\"Embed entity\";}s:12:\"requirements\";a:1:{s:27:\"_embed_button_editor_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:6:\"editor\";a:2:{s:4:\"type\";s:13:\"entity:editor\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:12:\"embed_button\";a:2:{s:4:\"type\";s:19:\"entity:embed_button\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:32:\"access_check.embed_button_editor\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":662:{a:11:{s:4:\"vars\";a:2:{i:0;s:6:\"editor\";i:1;s:12:\"embed_button\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:72:\"#^/entity\\-embed/dialog/(?P<editor>[^/]++)/(?P<embed_button>[^/]++)$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"embed_button\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"editor\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/entity-embed/dialog\";}}s:9:\"path_vars\";a:2:{i:0;s:6:\"editor\";i:1;s:12:\"embed_button\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:12;s:14:\"patternOutline\";s:24:\"/entity-embed/dialog/%/%\";s:8:\"numParts\";i:4;}}}}',4),

('entity_embed.preview','/entity-embed/preview/{filter_format}','/entity-embed/preview/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1235:{a:9:{s:4:\"path\";s:37:\"/entity-embed/preview/{filter_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\entity_embed\\Controller\\PreviewController::preview\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:17:\"filter_format.use\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":530:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/entity\\-embed/preview/(?P<filter_format>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/entity-embed/preview\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:23:\"/entity-embed/preview/%\";s:8:\"numParts\";i:3;}}}}',3),

('entity_reference_revisions.delete_orphans','/admin/config/system/delete-orphans','/admin/config/system/delete-orphans',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1067:{a:9:{s:4:\"path\";s:35:\"/admin/config/system/delete-orphans\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:74:\"Drupal\\entity_reference_revisions\\Form\\OrphanedCompositeEntitiesDeleteForm\";s:6:\"_title\";s:34:\"Delete orphaned composite entities\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"delete orphan revisions\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":404:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/config/system/delete\\-orphans$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/admin/config/system/delete-orphans\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:35:\"/admin/config/system/delete-orphans\";s:8:\"numParts\";i:4;}}}}',4),

('field_ui.display_mode','/admin/structure/display-modes','/admin/structure/display-modes',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1027:{a:9:{s:4:\"path\";s:30:\"/admin/structure/display-modes\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:13:\"Display modes\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":388:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/structure/display\\-modes$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/structure/display-modes\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:30:\"/admin/structure/display-modes\";s:8:\"numParts\";i:3;}}}}',3),

('field_ui.entity_form_mode_add','/admin/structure/display-modes/form/add','/admin/structure/display-modes/form/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1089:{a:9:{s:4:\"path\";s:39:\"/admin/structure/display-modes/form/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:78:\"\\Drupal\\field_ui\\Controller\\EntityDisplayModeController::formModeTypeSelection\";s:6:\"_title\";s:28:\"Choose form mode entity type\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":416:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/structure/display\\-modes/form/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/display-modes/form/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:39:\"/admin/structure/display-modes/form/add\";s:8:\"numParts\";i:5;}}}}',5),

('field_ui.entity_view_mode_add','/admin/structure/display-modes/view/add','/admin/structure/display-modes/view/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1089:{a:9:{s:4:\"path\";s:39:\"/admin/structure/display-modes/view/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:78:\"\\Drupal\\field_ui\\Controller\\EntityDisplayModeController::viewModeTypeSelection\";s:6:\"_title\";s:28:\"Choose view mode entity type\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":416:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/structure/display\\-modes/view/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/display-modes/view/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:39:\"/admin/structure/display-modes/view/add\";s:8:\"numParts\";i:5;}}}}',5),

('field_ui.field_group_add_block_content.display','/admin/structure/block/block-content/manage/{block_content_type}/display/add-group','/admin/structure/block/block-content/manage/%/display/add-group',251,'C:31:\"Symfony\\Component\\Routing\\Route\":1789:{a:9:{s:4:\"path\";s:82:\"/admin/structure/block/block-content/manage/{block_content_type}/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:13:\"block_content\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer block_content display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:18:\"block_content_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":711:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:101:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:251;s:14:\"patternOutline\";s:63:\"/admin/structure/block/block-content/manage/%/display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_block_content.display.view_mode','/admin/structure/block/block-content/manage/{block_content_type}/display/{view_mode_name}/add-group','/admin/structure/block/block-content/manage/%/display/%/add-group',501,'C:31:\"Symfony\\Component\\Routing\\Route\":2015:{a:9:{s:4:\"path\";s:99:\"/admin/structure/block/block-content/manage/{block_content_type}/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:13:\"block_content\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer block_content display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:18:\"block_content_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":920:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:128:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:65:\"/admin/structure/block/block-content/manage/%/display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_block_content.form_display','/admin/structure/block/block-content/manage/{block_content_type}/form-display/add-group','/admin/structure/block/block-content/manage/%/form-display/add-group',251,'C:31:\"Symfony\\Component\\Routing\\Route\":1815:{a:9:{s:4:\"path\";s:87:\"/admin/structure/block/block-content/manage/{block_content_type}/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:13:\"block_content\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer block_content form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:18:\"block_content_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":727:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:251;s:14:\"patternOutline\";s:68:\"/admin/structure/block/block-content/manage/%/form-display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_block_content.form_display.form_mode','/admin/structure/block/block-content/manage/{block_content_type}/form-display/{form_mode_name}/add-group','/admin/structure/block/block-content/manage/%/form-display/%/add-group',501,'C:31:\"Symfony\\Component\\Routing\\Route\":2043:{a:9:{s:4:\"path\";s:104:\"/admin/structure/block/block-content/manage/{block_content_type}/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:13:\"block_content\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer block_content form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:18:\"block_content_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":937:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:134:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:70:\"/admin/structure/block/block-content/manage/%/form-display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_comment.display','/admin/structure/comment/manage/{comment_type}/display/add-group','/admin/structure/comment/manage/%/display/add-group',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1678:{a:9:{s:4:\"path\";s:64:\"/admin/structure/comment/manage/{comment_type}/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:7:\"comment\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer comment display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"comment_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":649:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:82:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:51:\"/admin/structure/comment/manage/%/display/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_add_comment.display.view_mode','/admin/structure/comment/manage/{comment_type}/display/{view_mode_name}/add-group','/admin/structure/comment/manage/%/display/%/add-group',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1905:{a:9:{s:4:\"path\";s:81:\"/admin/structure/comment/manage/{comment_type}/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:7:\"comment\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer comment display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"comment_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":859:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:109:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/comment/manage/%/display/%/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_comment.form_display','/admin/structure/comment/manage/{comment_type}/form-display/add-group','/admin/structure/comment/manage/%/form-display/add-group',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1704:{a:9:{s:4:\"path\";s:69:\"/admin/structure/comment/manage/{comment_type}/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:7:\"comment\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer comment form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"comment_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":665:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:56:\"/admin/structure/comment/manage/%/form-display/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_add_comment.form_display.form_mode','/admin/structure/comment/manage/{comment_type}/form-display/{form_mode_name}/add-group','/admin/structure/comment/manage/%/form-display/%/add-group',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1932:{a:9:{s:4:\"path\";s:86:\"/admin/structure/comment/manage/{comment_type}/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:7:\"comment\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer comment form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"comment_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":876:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:115:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:58:\"/admin/structure/comment/manage/%/form-display/%/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_order.display','/admin/commerce/config/order-types/{commerce_order_type}/edit/display/add-group','/admin/commerce/config/order-types/%/edit/display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1782:{a:9:{s:4:\"path\";s:79:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer commerce_order display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_order_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":702:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/edit/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:59:\"/admin/commerce/config/order-types/%/edit/display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_order.display.view_mode','/admin/commerce/config/order-types/{commerce_order_type}/edit/display/{view_mode_name}/add-group','/admin/commerce/config/order-types/%/edit/display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2010:{a:9:{s:4:\"path\";s:96:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer commerce_order display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_order_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":913:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:125:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:61:\"/admin/commerce/config/order-types/%/edit/display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_commerce_order.form_display','/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/add-group','/admin/commerce/config/order-types/%/edit/form-display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1809:{a:9:{s:4:\"path\";s:84:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_order form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_order_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":719:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/edit/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:64:\"/admin/commerce/config/order-types/%/edit/form-display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_order.form_display.form_mode','/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/{form_mode_name}/add-group','/admin/commerce/config/order-types/%/edit/form-display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2037:{a:9:{s:4:\"path\";s:101:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_order form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_order_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":929:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:131:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:66:\"/admin/commerce/config/order-types/%/edit/form-display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_commerce_order_item.display','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/add-group','/admin/commerce/config/order-item-types/%/edit/display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1854:{a:9:{s:4:\"path\";s:89:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_order_item display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:24:\"commerce_order_item_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":739:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:109:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/edit/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:64:\"/admin/commerce/config/order-item-types/%/edit/display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_order_item.display.view_mode','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/{view_mode_name}/add-group','/admin/commerce/config/order-item-types/%/edit/display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2082:{a:9:{s:4:\"path\";s:106:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_order_item display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:24:\"commerce_order_item_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":949:{a:11:{s:4:\"vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:136:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:66:\"/admin/commerce/config/order-item-types/%/edit/display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_commerce_order_item.form_display','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/add-group','/admin/commerce/config/order-item-types/%/edit/form-display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1880:{a:9:{s:4:\"path\";s:94:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:43:\"administer commerce_order_item form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:24:\"commerce_order_item_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":755:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:115:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/edit/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:69:\"/admin/commerce/config/order-item-types/%/edit/form-display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_order_item.form_display.form_mode','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/{form_mode_name}/add-group','/admin/commerce/config/order-item-types/%/edit/form-display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2108:{a:9:{s:4:\"path\";s:111:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:43:\"administer commerce_order_item form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:24:\"commerce_order_item_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":965:{a:11:{s:4:\"vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:142:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:71:\"/admin/commerce/config/order-item-types/%/edit/form-display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_commerce_product.display','/admin/commerce/config/product-types/{commerce_product_type}/edit/display/add-group','/admin/commerce/config/product-types/%/edit/display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1811:{a:9:{s:4:\"path\";s:83:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:35:\"administer commerce_product display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:21:\"commerce_product_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":717:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:102:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/edit/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:61:\"/admin/commerce/config/product-types/%/edit/display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_product.display.view_mode','/admin/commerce/config/product-types/{commerce_product_type}/edit/display/{view_mode_name}/add-group','/admin/commerce/config/product-types/%/edit/display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2039:{a:9:{s:4:\"path\";s:100:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:35:\"administer commerce_product display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:21:\"commerce_product_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":927:{a:11:{s:4:\"vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:129:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:63:\"/admin/commerce/config/product-types/%/edit/display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_commerce_product.form_display','/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/add-group','/admin/commerce/config/product-types/%/edit/form-display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1837:{a:9:{s:4:\"path\";s:88:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:40:\"administer commerce_product form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:21:\"commerce_product_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":733:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:108:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/edit/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:66:\"/admin/commerce/config/product-types/%/edit/form-display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_product.form_display.form_mode','/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/{form_mode_name}/add-group','/admin/commerce/config/product-types/%/edit/form-display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2065:{a:9:{s:4:\"path\";s:105:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:40:\"administer commerce_product form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:21:\"commerce_product_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":943:{a:11:{s:4:\"vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:135:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:68:\"/admin/commerce/config/product-types/%/edit/form-display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_commerce_product_attribute_value.display','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/add-group','/admin/commerce/product-attributes/manage/%/display/add-group',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1883:{a:9:{s:4:\"path\";s:88:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:51:\"administer commerce_product_attribute_value display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:26:\"commerce_product_attribute\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":737:{a:11:{s:4:\"vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:61:\"/admin/commerce/product-attributes/manage/%/display/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_add_commerce_product_attribute_value.display.view_mode','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/{view_mode_name}/add-group','/admin/commerce/product-attributes/manage/%/display/%/add-group',245,'C:31:\"Symfony\\Component\\Routing\\Route\":2110:{a:9:{s:4:\"path\";s:105:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:51:\"administer commerce_product_attribute_value display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:26:\"commerce_product_attribute\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":946:{a:11:{s:4:\"vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:134:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:63:\"/admin/commerce/product-attributes/manage/%/display/%/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_product_attribute_value.form_display','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/add-group','/admin/commerce/product-attributes/manage/%/form-display/add-group',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1909:{a:9:{s:4:\"path\";s:93:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:56:\"administer commerce_product_attribute_value form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:26:\"commerce_product_attribute\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":753:{a:11:{s:4:\"vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:113:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:66:\"/admin/commerce/product-attributes/manage/%/form-display/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_add_commerce_product_attribute_value.form_display.form_mode','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/{form_mode_name}/add-group','/admin/commerce/product-attributes/manage/%/form-display/%/add-group',245,'C:31:\"Symfony\\Component\\Routing\\Route\":2137:{a:9:{s:4:\"path\";s:110:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:56:\"administer commerce_product_attribute_value form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:26:\"commerce_product_attribute\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":963:{a:11:{s:4:\"vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:140:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:68:\"/admin/commerce/product-attributes/manage/%/form-display/%/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_product_variation.display','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/add-group','/admin/commerce/config/product-variation-types/%/edit/display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1953:{a:9:{s:4:\"path\";s:103:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:45:\"administer commerce_product_variation display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:31:\"commerce_product_variation_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":788:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:123:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/edit/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:71:\"/admin/commerce/config/product-variation-types/%/edit/display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_product_variation.display.view_mode','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/{view_mode_name}/add-group','/admin/commerce/config/product-variation-types/%/edit/display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2180:{a:9:{s:4:\"path\";s:120:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:45:\"administer commerce_product_variation display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:31:\"commerce_product_variation_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":998:{a:11:{s:4:\"vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:150:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:73:\"/admin/commerce/config/product-variation-types/%/edit/display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_commerce_product_variation.form_display','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/add-group','/admin/commerce/config/product-variation-types/%/edit/form-display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1979:{a:9:{s:4:\"path\";s:108:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:50:\"administer commerce_product_variation form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:31:\"commerce_product_variation_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":804:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:129:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/edit/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:76:\"/admin/commerce/config/product-variation-types/%/edit/form-display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_product_variation.form_display.form_mode','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/{form_mode_name}/add-group','/admin/commerce/config/product-variation-types/%/edit/form-display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2207:{a:9:{s:4:\"path\";s:125:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:50:\"administer commerce_product_variation form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:31:\"commerce_product_variation_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1014:{a:11:{s:4:\"vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:156:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:78:\"/admin/commerce/config/product-variation-types/%/edit/form-display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_commerce_store.display','/admin/commerce/config/store-types/{commerce_store_type}/edit/display/add-group','/admin/commerce/config/store-types/%/edit/display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1782:{a:9:{s:4:\"path\";s:79:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer commerce_store display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_store_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":702:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/edit/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:59:\"/admin/commerce/config/store-types/%/edit/display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_store.display.view_mode','/admin/commerce/config/store-types/{commerce_store_type}/edit/display/{view_mode_name}/add-group','/admin/commerce/config/store-types/%/edit/display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2010:{a:9:{s:4:\"path\";s:96:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer commerce_store display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_store_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":913:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:125:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:61:\"/admin/commerce/config/store-types/%/edit/display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_commerce_store.form_display','/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/add-group','/admin/commerce/config/store-types/%/edit/form-display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1809:{a:9:{s:4:\"path\";s:84:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_store form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_store_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":719:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/edit/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:64:\"/admin/commerce/config/store-types/%/edit/form-display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_commerce_store.form_display.form_mode','/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/{form_mode_name}/add-group','/admin/commerce/config/store-types/%/edit/form-display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2037:{a:9:{s:4:\"path\";s:101:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_store form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_store_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":929:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:131:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:66:\"/admin/commerce/config/store-types/%/edit/form-display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_contact_message.display','/admin/structure/contact/manage/{contact_form}/display/add-group','/admin/structure/contact/manage/%/display/add-group',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1695:{a:9:{s:4:\"path\";s:64:\"/admin/structure/contact/manage/{contact_form}/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:34:\"administer contact_message display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"contact_form\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":649:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:82:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:51:\"/admin/structure/contact/manage/%/display/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_add_contact_message.display.view_mode','/admin/structure/contact/manage/{contact_form}/display/{view_mode_name}/add-group','/admin/structure/contact/manage/%/display/%/add-group',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1922:{a:9:{s:4:\"path\";s:81:\"/admin/structure/contact/manage/{contact_form}/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:34:\"administer contact_message display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"contact_form\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":859:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:109:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/contact/manage/%/display/%/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_contact_message.form_display','/admin/structure/contact/manage/{contact_form}/form-display/add-group','/admin/structure/contact/manage/%/form-display/add-group',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1721:{a:9:{s:4:\"path\";s:69:\"/admin/structure/contact/manage/{contact_form}/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:39:\"administer contact_message form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"contact_form\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":665:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:56:\"/admin/structure/contact/manage/%/form-display/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_add_contact_message.form_display.form_mode','/admin/structure/contact/manage/{contact_form}/form-display/{form_mode_name}/add-group','/admin/structure/contact/manage/%/form-display/%/add-group',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1949:{a:9:{s:4:\"path\";s:86:\"/admin/structure/contact/manage/{contact_form}/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:39:\"administer contact_message form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"contact_form\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":876:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:115:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:58:\"/admin/structure/contact/manage/%/form-display/%/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_node.display','/admin/structure/types/manage/{node_type}/display/add-group','/admin/structure/types/manage/%/display/add-group',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1635:{a:9:{s:4:\"path\";s:59:\"/admin/structure/types/manage/{node_type}/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:4:\"node\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer node display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:9:\"node_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":628:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:49:\"/admin/structure/types/manage/%/display/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_add_node.display.view_mode','/admin/structure/types/manage/{node_type}/display/{view_mode_name}/add-group','/admin/structure/types/manage/%/display/%/add-group',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1862:{a:9:{s:4:\"path\";s:76:\"/admin/structure/types/manage/{node_type}/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:4:\"node\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer node display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:9:\"node_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":838:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:51:\"/admin/structure/types/manage/%/display/%/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_node.form_display','/admin/structure/types/manage/{node_type}/form-display/add-group','/admin/structure/types/manage/%/form-display/add-group',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1661:{a:9:{s:4:\"path\";s:64:\"/admin/structure/types/manage/{node_type}/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:4:\"node\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer node form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:9:\"node_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":644:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:83:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:54:\"/admin/structure/types/manage/%/form-display/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_add_node.form_display.form_mode','/admin/structure/types/manage/{node_type}/form-display/{form_mode_name}/add-group','/admin/structure/types/manage/%/form-display/%/add-group',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1889:{a:9:{s:4:\"path\";s:81:\"/admin/structure/types/manage/{node_type}/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:4:\"node\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer node form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:9:\"node_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":855:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:110:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:56:\"/admin/structure/types/manage/%/form-display/%/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_profile.display','/admin/config/people/profile-types/manage/{profile_type}/display/add-group','/admin/config/people/profile-types/manage/%/display/add-group',251,'C:31:\"Symfony\\Component\\Routing\\Route\":1719:{a:9:{s:4:\"path\";s:74:\"/admin/config/people/profile-types/manage/{profile_type}/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:7:\"profile\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer profile display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"profile_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":680:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:93:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:251;s:14:\"patternOutline\";s:61:\"/admin/config/people/profile-types/manage/%/display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_profile.display.view_mode','/admin/config/people/profile-types/manage/{profile_type}/display/{view_mode_name}/add-group','/admin/config/people/profile-types/manage/%/display/%/add-group',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1946:{a:9:{s:4:\"path\";s:91:\"/admin/config/people/profile-types/manage/{profile_type}/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:7:\"profile\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer profile display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"profile_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":890:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:120:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:63:\"/admin/config/people/profile-types/manage/%/display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_profile.form_display','/admin/config/people/profile-types/manage/{profile_type}/form-display/add-group','/admin/config/people/profile-types/manage/%/form-display/add-group',251,'C:31:\"Symfony\\Component\\Routing\\Route\":1745:{a:9:{s:4:\"path\";s:79:\"/admin/config/people/profile-types/manage/{profile_type}/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:7:\"profile\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer profile form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"profile_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":696:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:99:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:251;s:14:\"patternOutline\";s:66:\"/admin/config/people/profile-types/manage/%/form-display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_profile.form_display.form_mode','/admin/config/people/profile-types/manage/{profile_type}/form-display/{form_mode_name}/add-group','/admin/config/people/profile-types/manage/%/form-display/%/add-group',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1973:{a:9:{s:4:\"path\";s:96:\"/admin/config/people/profile-types/manage/{profile_type}/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:7:\"profile\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer profile form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"profile_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":907:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:126:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:68:\"/admin/config/people/profile-types/manage/%/form-display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_taxonomy_term.display','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/add-group','/admin/structure/taxonomy/manage/%/overview/display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1787:{a:9:{s:4:\"path\";s:81:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer taxonomy_term display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"taxonomy_vocabulary\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":707:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:99:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/overview/display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:61:\"/admin/structure/taxonomy/manage/%/overview/display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_taxonomy_term.display.view_mode','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{view_mode_name}/add-group','/admin/structure/taxonomy/manage/%/overview/display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2015:{a:9:{s:4:\"path\";s:98:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer taxonomy_term display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"taxonomy_vocabulary\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":918:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:126:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/overview/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:63:\"/admin/structure/taxonomy/manage/%/overview/display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_taxonomy_term.form_display','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/add-group','/admin/structure/taxonomy/manage/%/overview/form-display/add-group',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1814:{a:9:{s:4:\"path\";s:86:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer taxonomy_term form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"taxonomy_vocabulary\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":724:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:105:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/overview/form-display/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:66:\"/admin/structure/taxonomy/manage/%/overview/form-display/add-group\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_add_taxonomy_term.form_display.form_mode','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{form_mode_name}/add-group','/admin/structure/taxonomy/manage/%/overview/form-display/%/add-group',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2042:{a:9:{s:4:\"path\";s:103:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer taxonomy_term form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"taxonomy_vocabulary\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":934:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:132:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/overview/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:68:\"/admin/structure/taxonomy/manage/%/overview/form-display/%/add-group\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_add_user.display','/admin/config/people/accounts/display/add-group','/admin/config/people/accounts/display/add-group',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1281:{a:9:{s:4:\"path\";s:47:\"/admin/config/people/accounts/display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:4:\"user\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer user display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";N;s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":440:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/admin/config/people/accounts/display/add\\-group$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:47:\"/admin/config/people/accounts/display/add-group\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:47:\"/admin/config/people/accounts/display/add-group\";s:8:\"numParts\";i:6;}}}}',6),

('field_ui.field_group_add_user.display.view_mode','/admin/config/people/accounts/display/{view_mode_name}/add-group','/admin/config/people/accounts/display/%/add-group',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1509:{a:9:{s:4:\"path\";s:64:\"/admin/config/people/accounts/display/{view_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:4:\"user\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer user display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";N;s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":651:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:82:\"#^/admin/config/people/accounts/display/(?P<view_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/people/accounts/display\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:49:\"/admin/config/people/accounts/display/%/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_add_user.form_display','/admin/config/people/accounts/form-display/add-group','/admin/config/people/accounts/form-display/add-group',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1307:{a:9:{s:4:\"path\";s:52:\"/admin/config/people/accounts/form-display/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:4:\"user\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer user form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";N;s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":456:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/admin/config/people/accounts/form\\-display/add\\-group$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:52:\"/admin/config/people/accounts/form-display/add-group\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:52:\"/admin/config/people/accounts/form-display/add-group\";s:8:\"numParts\";i:6;}}}}',6),

('field_ui.field_group_add_user.form_display.form_mode','/admin/config/people/accounts/form-display/{form_mode_name}/add-group','/admin/config/people/accounts/form-display/%/add-group',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1535:{a:9:{s:4:\"path\";s:69:\"/admin/config/people/accounts/form-display/{form_mode_name}/add-group\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:4:\"user\";s:5:\"_form\";s:42:\"\\Drupal\\field_group\\Form\\FieldGroupAddForm\";s:6:\"_title\";s:9:\"Add group\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer user form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";N;s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":667:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/config/people/accounts/form\\-display/(?P<form_mode_name>[^/]++)/add\\-group$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add-group\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/people/accounts/form-display\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:54:\"/admin/config/people/accounts/form-display/%/add-group\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_delete_block_content.display','/admin/structure/block/block-content/manage/{block_content_type}/display/{field_group_name}/delete','/admin/structure/block/block-content/manage/%/display/%/delete',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1985:{a:9:{s:4:\"path\";s:98:\"/admin/structure/block/block-content/manage/{block_content_type}/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:13:\"block_content\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer block_content display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:18:\"block_content_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":917:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:126:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:62:\"/admin/structure/block/block-content/manage/%/display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_block_content.display.view_mode','/admin/structure/block/block-content/manage/{block_content_type}/display/{view_mode_name}/{field_group_name}/delete','/admin/structure/block/block-content/manage/%/display/%/%/delete',1001,'C:31:\"Symfony\\Component\\Routing\\Route\":2179:{a:9:{s:4:\"path\";s:115:\"/admin/structure/block/block-content/manage/{block_content_type}/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:13:\"block_content\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer block_content display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:18:\"block_content_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1092:{a:11:{s:4:\"vars\";a:3:{i:0;s:18:\"block_content_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:153:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:18:\"block_content_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1001;s:14:\"patternOutline\";s:64:\"/admin/structure/block/block-content/manage/%/display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_block_content.form_display','/admin/structure/block/block-content/manage/{block_content_type}/form-display/{field_group_name}/delete','/admin/structure/block/block-content/manage/%/form-display/%/delete',501,'C:31:\"Symfony\\Component\\Routing\\Route\":2013:{a:9:{s:4:\"path\";s:103:\"/admin/structure/block/block-content/manage/{block_content_type}/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:13:\"block_content\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer block_content form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:18:\"block_content_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":934:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:132:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:67:\"/admin/structure/block/block-content/manage/%/form-display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_block_content.form_display.form_mode','/admin/structure/block/block-content/manage/{block_content_type}/form-display/{form_mode_name}/{field_group_name}/delete','/admin/structure/block/block-content/manage/%/form-display/%/%/delete',1001,'C:31:\"Symfony\\Component\\Routing\\Route\":2206:{a:9:{s:4:\"path\";s:120:\"/admin/structure/block/block-content/manage/{block_content_type}/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:13:\"block_content\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer block_content form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:18:\"block_content_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1109:{a:11:{s:4:\"vars\";a:3:{i:0;s:18:\"block_content_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:159:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:18:\"block_content_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1001;s:14:\"patternOutline\";s:69:\"/admin/structure/block/block-content/manage/%/form-display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_comment.display','/admin/structure/comment/manage/{comment_type}/display/{field_group_name}/delete','/admin/structure/comment/manage/%/display/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1875:{a:9:{s:4:\"path\";s:80:\"/admin/structure/comment/manage/{comment_type}/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:7:\"comment\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer comment display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"comment_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":856:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:50:\"/admin/structure/comment/manage/%/display/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_delete_comment.display.view_mode','/admin/structure/comment/manage/{comment_type}/display/{view_mode_name}/{field_group_name}/delete','/admin/structure/comment/manage/%/display/%/%/delete',489,'C:31:\"Symfony\\Component\\Routing\\Route\":2066:{a:9:{s:4:\"path\";s:97:\"/admin/structure/comment/manage/{comment_type}/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:7:\"comment\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer comment display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"comment_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1029:{a:11:{s:4:\"vars\";a:3:{i:0;s:12:\"comment_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:134:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:12:\"comment_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:489;s:14:\"patternOutline\";s:52:\"/admin/structure/comment/manage/%/display/%/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_comment.form_display','/admin/structure/comment/manage/{comment_type}/form-display/{field_group_name}/delete','/admin/structure/comment/manage/%/form-display/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1902:{a:9:{s:4:\"path\";s:85:\"/admin/structure/comment/manage/{comment_type}/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:7:\"comment\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer comment form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"comment_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":873:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:113:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:55:\"/admin/structure/comment/manage/%/form-display/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_delete_comment.form_display.form_mode','/admin/structure/comment/manage/{comment_type}/form-display/{form_mode_name}/{field_group_name}/delete','/admin/structure/comment/manage/%/form-display/%/%/delete',489,'C:31:\"Symfony\\Component\\Routing\\Route\":2094:{a:9:{s:4:\"path\";s:102:\"/admin/structure/comment/manage/{comment_type}/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:7:\"comment\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer comment form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"comment_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1046:{a:11:{s:4:\"vars\";a:3:{i:0;s:12:\"comment_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:140:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:12:\"comment_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:489;s:14:\"patternOutline\";s:57:\"/admin/structure/comment/manage/%/form-display/%/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_order.display','/admin/commerce/config/order-types/{commerce_order_type}/edit/display/{field_group_name}/delete','/admin/commerce/config/order-types/%/edit/display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1980:{a:9:{s:4:\"path\";s:95:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer commerce_order display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_order_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":910:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:123:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:58:\"/admin/commerce/config/order-types/%/edit/display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_order.display.view_mode','/admin/commerce/config/order-types/{commerce_order_type}/edit/display/{view_mode_name}/{field_group_name}/delete','/admin/commerce/config/order-types/%/edit/display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2173:{a:9:{s:4:\"path\";s:112:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer commerce_order display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_order_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1084:{a:11:{s:4:\"vars\";a:3:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:150:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:3:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:60:\"/admin/commerce/config/order-types/%/edit/display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_commerce_order.form_display','/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/{field_group_name}/delete','/admin/commerce/config/order-types/%/edit/form-display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2007:{a:9:{s:4:\"path\";s:100:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_order form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_order_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":926:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:129:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_order_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:63:\"/admin/commerce/config/order-types/%/edit/form-display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_order.form_display.form_mode','/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete','/admin/commerce/config/order-types/%/edit/form-display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2199:{a:9:{s:4:\"path\";s:117:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_order form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_order_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1100:{a:11:{s:4:\"vars\";a:3:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:156:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:3:{i:0;s:19:\"commerce_order_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:65:\"/admin/commerce/config/order-types/%/edit/form-display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_commerce_order_item.display','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/{field_group_name}/delete','/admin/commerce/config/order-item-types/%/edit/display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2052:{a:9:{s:4:\"path\";s:105:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_order_item display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:24:\"commerce_order_item_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":946:{a:11:{s:4:\"vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:134:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:63:\"/admin/commerce/config/order-item-types/%/edit/display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_order_item.display.view_mode','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/{view_mode_name}/{field_group_name}/delete','/admin/commerce/config/order-item-types/%/edit/display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2244:{a:9:{s:4:\"path\";s:122:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_order_item display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:24:\"commerce_order_item_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1120:{a:11:{s:4:\"vars\";a:3:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:161:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:3:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:65:\"/admin/commerce/config/order-item-types/%/edit/display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_commerce_order_item.form_display','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/{field_group_name}/delete','/admin/commerce/config/order-item-types/%/edit/form-display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2078:{a:9:{s:4:\"path\";s:110:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:43:\"administer commerce_order_item form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:24:\"commerce_order_item_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":962:{a:11:{s:4:\"vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:140:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:2:{i:0;s:24:\"commerce_order_item_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:68:\"/admin/commerce/config/order-item-types/%/edit/form-display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_order_item.form_display.form_mode','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete','/admin/commerce/config/order-item-types/%/edit/form-display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2270:{a:9:{s:4:\"path\";s:127:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:43:\"administer commerce_order_item form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:24:\"commerce_order_item_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1136:{a:11:{s:4:\"vars\";a:3:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:167:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:3:{i:0;s:24:\"commerce_order_item_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:70:\"/admin/commerce/config/order-item-types/%/edit/form-display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_commerce_product.display','/admin/commerce/config/product-types/{commerce_product_type}/edit/display/{field_group_name}/delete','/admin/commerce/config/product-types/%/edit/display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2008:{a:9:{s:4:\"path\";s:99:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:35:\"administer commerce_product display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:21:\"commerce_product_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":924:{a:11:{s:4:\"vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:127:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:60:\"/admin/commerce/config/product-types/%/edit/display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_product.display.view_mode','/admin/commerce/config/product-types/{commerce_product_type}/edit/display/{view_mode_name}/{field_group_name}/delete','/admin/commerce/config/product-types/%/edit/display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2201:{a:9:{s:4:\"path\";s:116:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:35:\"administer commerce_product display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:21:\"commerce_product_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1098:{a:11:{s:4:\"vars\";a:3:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:154:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:3:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:62:\"/admin/commerce/config/product-types/%/edit/display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_commerce_product.form_display','/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/{field_group_name}/delete','/admin/commerce/config/product-types/%/edit/form-display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2035:{a:9:{s:4:\"path\";s:104:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:40:\"administer commerce_product form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:21:\"commerce_product_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":940:{a:11:{s:4:\"vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:133:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:2:{i:0;s:21:\"commerce_product_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:65:\"/admin/commerce/config/product-types/%/edit/form-display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_product.form_display.form_mode','/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete','/admin/commerce/config/product-types/%/edit/form-display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2227:{a:9:{s:4:\"path\";s:121:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:40:\"administer commerce_product form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:21:\"commerce_product_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1114:{a:11:{s:4:\"vars\";a:3:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:160:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:3:{i:0;s:21:\"commerce_product_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:67:\"/admin/commerce/config/product-types/%/edit/form-display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_commerce_product_attribute_value.display','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/{field_group_name}/delete','/admin/commerce/product-attributes/manage/%/display/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":2080:{a:9:{s:4:\"path\";s:104:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:51:\"administer commerce_product_attribute_value display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:26:\"commerce_product_attribute\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":943:{a:11:{s:4:\"vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:132:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:60:\"/admin/commerce/product-attributes/manage/%/display/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_delete_commerce_product_attribute_value.display.view_mode','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/{view_mode_name}/{field_group_name}/delete','/admin/commerce/product-attributes/manage/%/display/%/%/delete',489,'C:31:\"Symfony\\Component\\Routing\\Route\":2271:{a:9:{s:4:\"path\";s:121:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:51:\"administer commerce_product_attribute_value display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:26:\"commerce_product_attribute\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1116:{a:11:{s:4:\"vars\";a:3:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:159:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:489;s:14:\"patternOutline\";s:62:\"/admin/commerce/product-attributes/manage/%/display/%/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_product_attribute_value.form_display','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/{field_group_name}/delete','/admin/commerce/product-attributes/manage/%/form-display/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":2107:{a:9:{s:4:\"path\";s:109:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:56:\"administer commerce_product_attribute_value form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:26:\"commerce_product_attribute\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":960:{a:11:{s:4:\"vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:138:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:26:\"commerce_product_attribute\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:65:\"/admin/commerce/product-attributes/manage/%/form-display/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_delete_commerce_product_attribute_value.form_display.form_mode','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/{form_mode_name}/{field_group_name}/delete','/admin/commerce/product-attributes/manage/%/form-display/%/%/delete',489,'C:31:\"Symfony\\Component\\Routing\\Route\":2298:{a:9:{s:4:\"path\";s:126:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:56:\"administer commerce_product_attribute_value form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:26:\"commerce_product_attribute\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1133:{a:11:{s:4:\"vars\";a:3:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:165:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:26:\"commerce_product_attribute\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:489;s:14:\"patternOutline\";s:67:\"/admin/commerce/product-attributes/manage/%/form-display/%/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_product_variation.display','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/{field_group_name}/delete','/admin/commerce/config/product-variation-types/%/edit/display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2150:{a:9:{s:4:\"path\";s:119:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:45:\"administer commerce_product_variation display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:31:\"commerce_product_variation_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":995:{a:11:{s:4:\"vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:148:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:70:\"/admin/commerce/config/product-variation-types/%/edit/display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_product_variation.display.view_mode','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/{view_mode_name}/{field_group_name}/delete','/admin/commerce/config/product-variation-types/%/edit/display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2342:{a:9:{s:4:\"path\";s:136:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:45:\"administer commerce_product_variation display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:31:\"commerce_product_variation_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1169:{a:11:{s:4:\"vars\";a:3:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:175:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:3:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:72:\"/admin/commerce/config/product-variation-types/%/edit/display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_commerce_product_variation.form_display','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/{field_group_name}/delete','/admin/commerce/config/product-variation-types/%/edit/form-display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2177:{a:9:{s:4:\"path\";s:124:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:50:\"administer commerce_product_variation form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:31:\"commerce_product_variation_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1011:{a:11:{s:4:\"vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:154:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:2:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:75:\"/admin/commerce/config/product-variation-types/%/edit/form-display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_product_variation.form_display.form_mode','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete','/admin/commerce/config/product-variation-types/%/edit/form-display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2368:{a:9:{s:4:\"path\";s:141:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:50:\"administer commerce_product_variation form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:31:\"commerce_product_variation_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1185:{a:11:{s:4:\"vars\";a:3:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:181:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:3:{i:0;s:31:\"commerce_product_variation_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:77:\"/admin/commerce/config/product-variation-types/%/edit/form-display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_commerce_store.display','/admin/commerce/config/store-types/{commerce_store_type}/edit/display/{field_group_name}/delete','/admin/commerce/config/store-types/%/edit/display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1980:{a:9:{s:4:\"path\";s:95:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer commerce_store display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_store_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":910:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:123:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:58:\"/admin/commerce/config/store-types/%/edit/display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_store.display.view_mode','/admin/commerce/config/store-types/{commerce_store_type}/edit/display/{view_mode_name}/{field_group_name}/delete','/admin/commerce/config/store-types/%/edit/display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2173:{a:9:{s:4:\"path\";s:112:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer commerce_store display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_store_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1084:{a:11:{s:4:\"vars\";a:3:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:150:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:3:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:60:\"/admin/commerce/config/store-types/%/edit/display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_commerce_store.form_display','/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/{field_group_name}/delete','/admin/commerce/config/store-types/%/edit/form-display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2007:{a:9:{s:4:\"path\";s:100:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_store form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_store_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":926:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:129:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"commerce_store_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:63:\"/admin/commerce/config/store-types/%/edit/form-display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_commerce_store.form_display.form_mode','/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete','/admin/commerce/config/store-types/%/edit/form-display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2199:{a:9:{s:4:\"path\";s:117:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:38:\"administer commerce_store form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"commerce_store_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1100:{a:11:{s:4:\"vars\";a:3:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:156:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/edit/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:3:{i:0;s:19:\"commerce_store_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:65:\"/admin/commerce/config/store-types/%/edit/form-display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_contact_message.display','/admin/structure/contact/manage/{contact_form}/display/{field_group_name}/delete','/admin/structure/contact/manage/%/display/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1892:{a:9:{s:4:\"path\";s:80:\"/admin/structure/contact/manage/{contact_form}/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:34:\"administer contact_message display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"contact_form\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":856:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:50:\"/admin/structure/contact/manage/%/display/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_delete_contact_message.display.view_mode','/admin/structure/contact/manage/{contact_form}/display/{view_mode_name}/{field_group_name}/delete','/admin/structure/contact/manage/%/display/%/%/delete',489,'C:31:\"Symfony\\Component\\Routing\\Route\":2083:{a:9:{s:4:\"path\";s:97:\"/admin/structure/contact/manage/{contact_form}/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:34:\"administer contact_message display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"contact_form\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1029:{a:11:{s:4:\"vars\";a:3:{i:0;s:12:\"contact_form\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:134:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:12:\"contact_form\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:489;s:14:\"patternOutline\";s:52:\"/admin/structure/contact/manage/%/display/%/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_contact_message.form_display','/admin/structure/contact/manage/{contact_form}/form-display/{field_group_name}/delete','/admin/structure/contact/manage/%/form-display/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1919:{a:9:{s:4:\"path\";s:85:\"/admin/structure/contact/manage/{contact_form}/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:39:\"administer contact_message form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"contact_form\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":873:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:113:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:55:\"/admin/structure/contact/manage/%/form-display/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_delete_contact_message.form_display.form_mode','/admin/structure/contact/manage/{contact_form}/form-display/{form_mode_name}/{field_group_name}/delete','/admin/structure/contact/manage/%/form-display/%/%/delete',489,'C:31:\"Symfony\\Component\\Routing\\Route\":2111:{a:9:{s:4:\"path\";s:102:\"/admin/structure/contact/manage/{contact_form}/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:39:\"administer contact_message form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"contact_form\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1046:{a:11:{s:4:\"vars\";a:3:{i:0;s:12:\"contact_form\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:140:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:12:\"contact_form\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:489;s:14:\"patternOutline\";s:57:\"/admin/structure/contact/manage/%/form-display/%/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_node.display','/admin/structure/types/manage/{node_type}/display/{field_group_name}/delete','/admin/structure/types/manage/%/display/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1832:{a:9:{s:4:\"path\";s:75:\"/admin/structure/types/manage/{node_type}/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:4:\"node\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer node display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:9:\"node_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":835:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:102:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:48:\"/admin/structure/types/manage/%/display/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_delete_node.display.view_mode','/admin/structure/types/manage/{node_type}/display/{view_mode_name}/{field_group_name}/delete','/admin/structure/types/manage/%/display/%/%/delete',489,'C:31:\"Symfony\\Component\\Routing\\Route\":2023:{a:9:{s:4:\"path\";s:92:\"/admin/structure/types/manage/{node_type}/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:4:\"node\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer node display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:9:\"node_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1008:{a:11:{s:4:\"vars\";a:3:{i:0;s:9:\"node_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:129:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:9:\"node_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:489;s:14:\"patternOutline\";s:50:\"/admin/structure/types/manage/%/display/%/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_node.form_display','/admin/structure/types/manage/{node_type}/form-display/{field_group_name}/delete','/admin/structure/types/manage/%/form-display/%/delete',245,'C:31:\"Symfony\\Component\\Routing\\Route\":1859:{a:9:{s:4:\"path\";s:80:\"/admin/structure/types/manage/{node_type}/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:4:\"node\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer node form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:9:\"node_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":852:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:108:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/types/manage/%/form-display/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_delete_node.form_display.form_mode','/admin/structure/types/manage/{node_type}/form-display/{form_mode_name}/{field_group_name}/delete','/admin/structure/types/manage/%/form-display/%/%/delete',489,'C:31:\"Symfony\\Component\\Routing\\Route\":2050:{a:9:{s:4:\"path\";s:97:\"/admin/structure/types/manage/{node_type}/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:4:\"node\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer node form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:9:\"node_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1025:{a:11:{s:4:\"vars\";a:3:{i:0;s:9:\"node_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:135:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:9:\"node_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:489;s:14:\"patternOutline\";s:55:\"/admin/structure/types/manage/%/form-display/%/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_profile.display','/admin/config/people/profile-types/manage/{profile_type}/display/{field_group_name}/delete','/admin/config/people/profile-types/manage/%/display/%/delete',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1916:{a:9:{s:4:\"path\";s:90:\"/admin/config/people/profile-types/manage/{profile_type}/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:7:\"profile\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer profile display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"profile_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":887:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:118:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:60:\"/admin/config/people/profile-types/manage/%/display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_profile.display.view_mode','/admin/config/people/profile-types/manage/{profile_type}/display/{view_mode_name}/{field_group_name}/delete','/admin/config/people/profile-types/manage/%/display/%/%/delete',1001,'C:31:\"Symfony\\Component\\Routing\\Route\":2110:{a:9:{s:4:\"path\";s:107:\"/admin/config/people/profile-types/manage/{profile_type}/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:7:\"profile\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"administer profile display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"profile_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1062:{a:11:{s:4:\"vars\";a:3:{i:0;s:12:\"profile_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:145:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:12:\"profile_type\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1001;s:14:\"patternOutline\";s:62:\"/admin/config/people/profile-types/manage/%/display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_profile.form_display','/admin/config/people/profile-types/manage/{profile_type}/form-display/{field_group_name}/delete','/admin/config/people/profile-types/manage/%/form-display/%/delete',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1943:{a:9:{s:4:\"path\";s:95:\"/admin/config/people/profile-types/manage/{profile_type}/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:7:\"profile\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer profile form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"profile_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":904:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:124:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"profile_type\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:65:\"/admin/config/people/profile-types/manage/%/form-display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_profile.form_display.form_mode','/admin/config/people/profile-types/manage/{profile_type}/form-display/{form_mode_name}/{field_group_name}/delete','/admin/config/people/profile-types/manage/%/form-display/%/%/delete',1001,'C:31:\"Symfony\\Component\\Routing\\Route\":2137:{a:9:{s:4:\"path\";s:112:\"/admin/config/people/profile-types/manage/{profile_type}/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:7:\"profile\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer profile form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:12:\"profile_type\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1079:{a:11:{s:4:\"vars\";a:3:{i:0;s:12:\"profile_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:151:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:12:\"profile_type\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1001;s:14:\"patternOutline\";s:67:\"/admin/config/people/profile-types/manage/%/form-display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_taxonomy_term.display','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{field_group_name}/delete','/admin/structure/taxonomy/manage/%/overview/display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":1985:{a:9:{s:4:\"path\";s:97:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer taxonomy_term display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"taxonomy_vocabulary\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":915:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:124:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/overview/display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:60:\"/admin/structure/taxonomy/manage/%/overview/display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_taxonomy_term.display.view_mode','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{view_mode_name}/{field_group_name}/delete','/admin/structure/taxonomy/manage/%/overview/display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2178:{a:9:{s:4:\"path\";s:114:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer taxonomy_term display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"taxonomy_vocabulary\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1089:{a:11:{s:4:\"vars\";a:3:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:151:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/overview/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"view_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:62:\"/admin/structure/taxonomy/manage/%/overview/display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_taxonomy_term.form_display','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{field_group_name}/delete','/admin/structure/taxonomy/manage/%/overview/form-display/%/delete',493,'C:31:\"Symfony\\Component\\Routing\\Route\":2012:{a:9:{s:4:\"path\";s:102:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer taxonomy_term form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"taxonomy_vocabulary\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":931:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:130:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/overview/form-display\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:65:\"/admin/structure/taxonomy/manage/%/overview/form-display/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('field_ui.field_group_delete_taxonomy_term.form_display.form_mode','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{form_mode_name}/{field_group_name}/delete','/admin/structure/taxonomy/manage/%/overview/form-display/%/%/delete',985,'C:31:\"Symfony\\Component\\Routing\\Route\":2204:{a:9:{s:4:\"path\";s:119:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer taxonomy_term form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";s:19:\"taxonomy_vocabulary\";s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1105:{a:11:{s:4:\"vars\";a:3:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:157:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/overview/form-display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:3:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"form_mode_name\";i:2;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:985;s:14:\"patternOutline\";s:67:\"/admin/structure/taxonomy/manage/%/overview/form-display/%/%/delete\";s:8:\"numParts\";i:10;}}}}',10),

('field_ui.field_group_delete_user.display','/admin/config/people/accounts/display/{field_group_name}/delete','/admin/config/people/accounts/display/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1479:{a:9:{s:4:\"path\";s:63:\"/admin/config/people/accounts/display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:4:\"user\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer user display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";N;s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":648:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/admin/config/people/accounts/display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/people/accounts/display\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:46:\"/admin/config/people/accounts/display/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_delete_user.display.view_mode','/admin/config/people/accounts/display/{view_mode_name}/{field_group_name}/delete','/admin/config/people/accounts/display/%/%/delete',249,'C:31:\"Symfony\\Component\\Routing\\Route\":1670:{a:9:{s:4:\"path\";s:80:\"/admin/config/people/accounts/display/{view_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"view\";s:14:\"entity_type_id\";s:4:\"user\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer user display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";N;s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":822:{a:11:{s:4:\"vars\";a:2:{i:0;s:14:\"view_mode_name\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/config/people/accounts/display/(?P<view_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/people/accounts/display\";}}s:9:\"path_vars\";a:2:{i:0;s:14:\"view_mode_name\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:249;s:14:\"patternOutline\";s:48:\"/admin/config/people/accounts/display/%/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_group_delete_user.form_display','/admin/config/people/accounts/form-display/{field_group_name}/delete','/admin/config/people/accounts/form-display/%/delete',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1505:{a:9:{s:4:\"path\";s:68:\"/admin/config/people/accounts/form-display/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:4:\"user\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer user form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";N;s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":664:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/config/people/accounts/form\\-display/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/people/accounts/form-display\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/config/people/accounts/form-display/%/delete\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_group_delete_user.form_display.form_mode','/admin/config/people/accounts/form-display/{form_mode_name}/{field_group_name}/delete','/admin/config/people/accounts/form-display/%/%/delete',249,'C:31:\"Symfony\\Component\\Routing\\Route\":1696:{a:9:{s:4:\"path\";s:85:\"/admin/config/people/accounts/form-display/{form_mode_name}/{field_group_name}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:7:\"context\";s:4:\"form\";s:14:\"entity_type_id\";s:4:\"user\";s:5:\"_form\";s:45:\"\\Drupal\\field_group\\Form\\FieldGroupDeleteForm\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:28:\"administer user form display\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:11:\"field_group\";a:3:{s:4:\"type\";s:11:\"field_group\";s:11:\"entity_type\";N;s:9:\"converter\";s:27:\"field_group.param_converter\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":838:{a:11:{s:4:\"vars\";a:2:{i:0;s:14:\"form_mode_name\";i:1;s:16:\"field_group_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:113:\"#^/admin/config/people/accounts/form\\-display/(?P<form_mode_name>[^/]++)/(?P<field_group_name>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"field_group_name\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/people/accounts/form-display\";}}s:9:\"path_vars\";a:2:{i:0;s:14:\"form_mode_name\";i:1;s:16:\"field_group_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:249;s:14:\"patternOutline\";s:53:\"/admin/config/people/accounts/form-display/%/%/delete\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_storage_config_add_block_content','/admin/structure/block/block-content/manage/{block_content_type}/fields/add-field','/admin/structure/block/block-content/manage/%/fields/add-field',251,'C:31:\"Symfony\\Component\\Routing\\Route\":1607:{a:9:{s:4:\"path\";s:81:\"/admin/structure/block/block-content/manage/{block_content_type}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer block_content fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":708:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:100:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:251;s:14:\"patternOutline\";s:62:\"/admin/structure/block/block-content/manage/%/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_storage_config_add_comment','/admin/structure/comment/manage/{comment_type}/fields/add-field','/admin/structure/comment/manage/%/fields/add-field',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1502:{a:9:{s:4:\"path\";s:63:\"/admin/structure/comment/manage/{comment_type}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer comment fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":646:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:81:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:50:\"/admin/structure/comment/manage/%/fields/add-field\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_storage_config_add_commerce_order','/admin/commerce/config/order-types/{commerce_order_type}/edit/fields/add-field','/admin/commerce/config/order-types/%/edit/fields/add-field',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1599:{a:9:{s:4:\"path\";s:78:\"/admin/commerce/config/order-types/{commerce_order_type}/edit/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:14:\"commerce_order\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer commerce_order fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_order_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_order_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":699:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/admin/commerce/config/order\\-types/(?P<commerce_order_type>[^/]++)/edit/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/edit/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_order_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/order-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_order_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:58:\"/admin/commerce/config/order-types/%/edit/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_storage_config_add_commerce_order_item','/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields/add-field','/admin/commerce/config/order-item-types/%/edit/fields/add-field',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1666:{a:9:{s:4:\"path\";s:88:\"/admin/commerce/config/order-item-types/{commerce_order_item_type}/edit/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:19:\"commerce_order_item\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:37:\"administer commerce_order_item fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:24:\"commerce_order_item_type\";a:2:{s:4:\"type\";s:31:\"entity:commerce_order_item_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":736:{a:11:{s:4:\"vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:108:\"#^/admin/commerce/config/order\\-item\\-types/(?P<commerce_order_item_type>[^/]++)/edit/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/edit/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:24:\"commerce_order_item_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/commerce/config/order-item-types\";}}s:9:\"path_vars\";a:1:{i:0;s:24:\"commerce_order_item_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:63:\"/admin/commerce/config/order-item-types/%/edit/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_storage_config_add_commerce_product','/admin/commerce/config/product-types/{commerce_product_type}/edit/fields/add-field','/admin/commerce/config/product-types/%/edit/fields/add-field',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1626:{a:9:{s:4:\"path\";s:82:\"/admin/commerce/config/product-types/{commerce_product_type}/edit/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:16:\"commerce_product\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:34:\"administer commerce_product fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:21:\"commerce_product_type\";a:2:{s:4:\"type\";s:28:\"entity:commerce_product_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":714:{a:11:{s:4:\"vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:101:\"#^/admin/commerce/config/product\\-types/(?P<commerce_product_type>[^/]++)/edit/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/edit/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:21:\"commerce_product_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/commerce/config/product-types\";}}s:9:\"path_vars\";a:1:{i:0;s:21:\"commerce_product_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:60:\"/admin/commerce/config/product-types/%/edit/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_storage_config_add_commerce_product_attribute_value','/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields/add-field','/admin/commerce/product-attributes/manage/%/fields/add-field',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1693:{a:9:{s:4:\"path\";s:87:\"/admin/commerce/product-attributes/manage/{commerce_product_attribute}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:32:\"commerce_product_attribute_value\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:50:\"administer commerce_product_attribute_value fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:26:\"commerce_product_attribute\";a:2:{s:4:\"type\";s:33:\"entity:commerce_product_attribute\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":734:{a:11:{s:4:\"vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:106:\"#^/admin/commerce/product\\-attributes/manage/(?P<commerce_product_attribute>[^/]++)/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:26:\"commerce_product_attribute\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/commerce/product-attributes/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:26:\"commerce_product_attribute\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:60:\"/admin/commerce/product-attributes/manage/%/fields/add-field\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_storage_config_add_commerce_product_variation','/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields/add-field','/admin/commerce/config/product-variation-types/%/edit/fields/add-field',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1758:{a:9:{s:4:\"path\";s:102:\"/admin/commerce/config/product-variation-types/{commerce_product_variation_type}/edit/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:26:\"commerce_product_variation\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:44:\"administer commerce_product_variation fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"commerce_product_variation_type\";a:2:{s:4:\"type\";s:38:\"entity:commerce_product_variation_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":785:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:122:\"#^/admin/commerce/config/product\\-variation\\-types/(?P<commerce_product_variation_type>[^/]++)/edit/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/edit/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"commerce_product_variation_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/commerce/config/product-variation-types\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"commerce_product_variation_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:70:\"/admin/commerce/config/product-variation-types/%/edit/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_storage_config_add_commerce_store','/admin/commerce/config/store-types/{commerce_store_type}/edit/fields/add-field','/admin/commerce/config/store-types/%/edit/fields/add-field',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1599:{a:9:{s:4:\"path\";s:78:\"/admin/commerce/config/store-types/{commerce_store_type}/edit/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:14:\"commerce_store\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:32:\"administer commerce_store fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"commerce_store_type\";a:2:{s:4:\"type\";s:26:\"entity:commerce_store_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":699:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/admin/commerce/config/store\\-types/(?P<commerce_store_type>[^/]++)/edit/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/edit/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"commerce_store_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/commerce/config/store-types\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"commerce_store_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:58:\"/admin/commerce/config/store-types/%/edit/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_storage_config_add_contact_message','/admin/structure/contact/manage/{contact_form}/fields/add-field','/admin/structure/contact/manage/%/fields/add-field',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1519:{a:9:{s:4:\"path\";s:63:\"/admin/structure/contact/manage/{contact_form}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer contact_message fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":646:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:81:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:50:\"/admin/structure/contact/manage/%/fields/add-field\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_storage_config_add_node','/admin/structure/types/manage/{node_type}/fields/add-field','/admin/structure/types/manage/%/fields/add-field',123,'C:31:\"Symfony\\Component\\Routing\\Route\":1463:{a:9:{s:4:\"path\";s:58:\"/admin/structure/types/manage/{node_type}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer node fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":625:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:48:\"/admin/structure/types/manage/%/fields/add-field\";s:8:\"numParts\";i:7;}}}}',7),

('field_ui.field_storage_config_add_profile','/admin/config/people/profile-types/manage/{profile_type}/fields/add-field','/admin/config/people/profile-types/manage/%/fields/add-field',251,'C:31:\"Symfony\\Component\\Routing\\Route\":1543:{a:9:{s:4:\"path\";s:73:\"/admin/config/people/profile-types/manage/{profile_type}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:7:\"profile\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer profile fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":677:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:92:\"#^/admin/config/people/profile\\-types/manage/(?P<profile_type>[^/]++)/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/people/profile-types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:251;s:14:\"patternOutline\";s:60:\"/admin/config/people/profile-types/manage/%/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_storage_config_add_taxonomy_term','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/add-field','/admin/structure/taxonomy/manage/%/overview/fields/add-field',247,'C:31:\"Symfony\\Component\\Routing\\Route\":1604:{a:9:{s:4:\"path\";s:80:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer taxonomy_term fields\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":704:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/overview/fields/add-field\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:60:\"/admin/structure/taxonomy/manage/%/overview/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),

('field_ui.field_storage_config_add_user','/admin/config/people/accounts/fields/add-field','/admin/config/people/accounts/fields/add-field',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1099:{a:9:{s:4:\"path\";s:46:\"/admin/config/people/accounts/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer user fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":437:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/admin/config/people/accounts/fields/add\\-field$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/config/people/accounts/fields/add-field\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:46:\"/admin/config/people/accounts/fields/add-field\";s:8:\"numParts\";i:6;}}}}',6),

('file.ajax_progress','/file/progress/{key}','/file/progress/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1016:{a:9:{s:4:\"path\";s:20:\"/file/progress/{key}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\file\\Controller\\FileWidgetAjaxController::progress\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":465:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/file/progress/(?P<key>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"key\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/file/progress\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:16:\"/file/progress/%\";s:8:\"numParts\";i:3;}}}}',3),

('file_browser.preview','/admin/file-browser-preview/{file}/{image_style}','/admin/file-browser-preview/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1458:{a:9:{s:4:\"path\";s:48:\"/admin/file-browser-preview/{file}/{image_style}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:7:\"Preview\";s:11:\"_controller\";s:62:\"\\Drupal\\file_browser\\Controller\\FileBrowserController::preview\";s:11:\"image_style\";s:0:\"\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:9:\"file.view\";s:4:\"file\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"file\";a:2:{s:4:\"type\";s:11:\"entity:file\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":668:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"file\";i:1;s:11:\"image_style\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/admin/file\\-browser\\-preview/(?P<file>\\d+)(?:/(?P<image_style>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"file\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/file-browser-preview\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"file\";i:1;s:11:\"image_style\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:29:\"/admin/file-browser-preview/%\";s:8:\"numParts\";i:4;}}}}',4),

('filter.admin_overview','/admin/config/content/formats','/admin/config/content/formats',15,'C:31:\"Symfony\\Component\\Routing\\Route\":974:{a:9:{s:4:\"path\";s:29:\"/admin/config/content/formats\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:13:\"filter_format\";s:6:\"_title\";s:24:\"Text formats and editors\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer filters\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/config/content/formats$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/config/content/formats\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/config/content/formats\";s:8:\"numParts\";i:4;}}}}',4),

('filter.format_add','/admin/config/content/formats/add','/admin/config/content/formats/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":993:{a:9:{s:4:\"path\";s:33:\"/admin/config/content/formats/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"filter_format.add\";s:6:\"_title\";s:15:\"Add text format\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:13:\"filter_format\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/config/content/formats/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/content/formats/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:33:\"/admin/config/content/formats/add\";s:8:\"numParts\";i:5;}}}}',5),

('filter.tips','/filter/tips/{filter_format}','/filter/tips/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1227:{a:9:{s:4:\"path\";s:28:\"/filter/tips/{filter_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\filter\\Controller\\FilterController::filterTips\";s:6:\"_title\";s:12:\"Compose tips\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:17:\"filter_format.use\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":502:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/filter/tips/(?P<filter_format>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/filter/tips\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:14:\"/filter/tips/%\";s:8:\"numParts\";i:3;}}}}',3),

('filter.tips_all','/filter/tips','/filter/tips',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1021:{a:9:{s:4:\"path\";s:12:\"/filter/tips\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\filter\\Controller\\FilterController::filterTips\";s:6:\"_title\";s:12:\"Compose tips\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":333:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/filter/tips$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/filter/tips\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/filter/tips\";s:8:\"numParts\";i:2;}}}}',2),

('help.main','/admin/help','/admin/help',3,'C:31:\"Symfony\\Component\\Routing\\Route\":923:{a:9:{s:4:\"path\";s:11:\"/admin/help\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\help\\Controller\\HelpController::helpMain\";s:6:\"_title\";s:4:\"Help\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":330:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/admin/help$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/admin/help\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/admin/help\";s:8:\"numParts\";i:2;}}}}',2),

('help.page','/admin/help/{name}','/admin/help/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1060:{a:9:{s:4:\"path\";s:18:\"/admin/help/{name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\help\\Controller\\HelpController::helpPage\";s:6:\"_title\";s:4:\"Help\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":460:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/help/(?P<name>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"name\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/admin/help\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:13:\"/admin/help/%\";s:8:\"numParts\";i:3;}}}}',3),

('image.effect_add_form','/admin/config/media/image-styles/manage/{image_style}/add/{image_effect}','/admin/config/media/image-styles/manage/%/add/%',250,'C:31:\"Symfony\\Component\\Routing\\Route\":1610:{a:9:{s:4:\"path\";s:72:\"/admin/config/media/image-styles/manage/{image_style}/add/{image_effect}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\image\\Form\\ImageEffectAddForm\";s:6:\"_title\";s:16:\"Add image effect\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":792:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:100:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/add/(?P<image_effect>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"image_effect\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:4:\"/add\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:47:\"/admin/config/media/image-styles/manage/%/add/%\";s:8:\"numParts\";i:8;}}}}',8),

('image.effect_delete','/admin/config/media/image-styles/manage/{image_style}/effects/{image_effect}/delete','/admin/config/media/image-styles/manage/%/effects/%/delete',501,'C:31:\"Symfony\\Component\\Routing\\Route\":1696:{a:9:{s:4:\"path\";s:83:\"/admin/config/media/image-styles/manage/{image_style}/effects/{image_effect}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\image\\Form\\ImageEffectDeleteForm\";s:6:\"_title\";s:19:\"Delete image effect\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":861:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:111:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/effects/(?P<image_effect>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"image_effect\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/effects\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:58:\"/admin/config/media/image-styles/manage/%/effects/%/delete\";s:8:\"numParts\";i:9;}}}}',9),

('image.effect_edit_form','/admin/config/media/image-styles/manage/{image_style}/effects/{image_effect}','/admin/config/media/image-styles/manage/%/effects/%',250,'C:31:\"Symfony\\Component\\Routing\\Route\":1628:{a:9:{s:4:\"path\";s:76:\"/admin/config/media/image-styles/manage/{image_style}/effects/{image_effect}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"\\Drupal\\image\\Form\\ImageEffectEditForm\";s:6:\"_title\";s:17:\"Edit image effect\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":804:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/effects/(?P<image_effect>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"image_effect\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/effects\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:51:\"/admin/config/media/image-styles/manage/%/effects/%\";s:8:\"numParts\";i:8;}}}}',8),

('image.info','/quickedit/image/info/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}','/quickedit/image/info/%/%/%/%/%',224,'C:31:\"Symfony\\Component\\Routing\\Route\":1996:{a:9:{s:4:\"path\";s:83:\"/quickedit/image/info/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\image\\Controller\\QuickEditImageController::getInfo\";}s:12:\"requirements\";a:3:{s:11:\"_permission\";s:23:\"access in-place editing\";s:30:\"_access_quickedit_entity_field\";s:4:\"TRUE\";s:7:\"_method\";s:3:\"GET\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1130:{a:11:{s:4:\"vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:140:\"#^/quickedit/image/info/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/(?P<field_name>[^/]++)/(?P<langcode>[^/]++)/(?P<view_mode_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"view_mode_id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"langcode\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"field_name\";i:4;b:1;}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";i:4;b:1;}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/quickedit/image/info\";}}s:9:\"path_vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:224;s:14:\"patternOutline\";s:31:\"/quickedit/image/info/%/%/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),

('image.style_add','/admin/config/media/image-styles/add','/admin/config/media/image-styles/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1001:{a:9:{s:4:\"path\";s:36:\"/admin/config/media/image-styles/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"image_style.add\";s:6:\"_title\";s:15:\"Add image style\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":407:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/config/media/image\\-styles/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/media/image-styles/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:36:\"/admin/config/media/image-styles/add\";s:8:\"numParts\";i:5;}}}}',5),

('image.style_private','/system/files/styles/{image_style}/{scheme}','/system/files/styles/%/%',28,'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:43:\"/system/files/styles/{image_style}/{scheme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:62:\"\\Drupal\\image\\Controller\\ImageStyleDownloadController::deliver\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":657:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:6:\"scheme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/system/files/styles/(?P<image_style>[^/]++)/(?P<scheme>[^/]++)$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"scheme\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/system/files/styles\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:6:\"scheme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:28;s:14:\"patternOutline\";s:24:\"/system/files/styles/%/%\";s:8:\"numParts\";i:5;}}}}',5),

('image.style_public','/sites/default/files/styles/{image_style}/{scheme}','/sites/default/files/styles/%/%',60,'C:31:\"Symfony\\Component\\Routing\\Route\":1374:{a:9:{s:4:\"path\";s:50:\"/sites/default/files/styles/{image_style}/{scheme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:61:\"Drupal\\image\\Controller\\ImageStyleDownloadController::deliver\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":678:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:6:\"scheme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/sites/default/files/styles/(?P<image_style>[^/]++)/(?P<scheme>[^/]++)$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"scheme\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/sites/default/files/styles\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:6:\"scheme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:60;s:14:\"patternOutline\";s:31:\"/sites/default/files/styles/%/%\";s:8:\"numParts\";i:6;}}}}',6),

('image.upload','/quickedit/image/upload/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}','/quickedit/image/upload/%/%/%/%/%',224,'C:31:\"Symfony\\Component\\Routing\\Route\":2004:{a:9:{s:4:\"path\";s:85:\"/quickedit/image/upload/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:57:\"\\Drupal\\image\\Controller\\QuickEditImageController::upload\";}s:12:\"requirements\";a:3:{s:11:\"_permission\";s:23:\"access in-place editing\";s:30:\"_access_quickedit_entity_field\";s:4:\"TRUE\";s:7:\"_method\";s:4:\"POST\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1136:{a:11:{s:4:\"vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:142:\"#^/quickedit/image/upload/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/(?P<field_name>[^/]++)/(?P<langcode>[^/]++)/(?P<view_mode_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"view_mode_id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"langcode\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"field_name\";i:4;b:1;}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";i:4;b:1;}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/quickedit/image/upload\";}}s:9:\"path_vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:224;s:14:\"patternOutline\";s:33:\"/quickedit/image/upload/%/%/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),

('language.add','/admin/config/regional/language/add','/admin/config/regional/language/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1014:{a:9:{s:4:\"path\";s:35:\"/admin/config/regional/language/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"configurable_language.add\";s:6:\"_title\";s:12:\"Add language\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:21:\"configurable_language\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":403:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/config/regional/language/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/admin/config/regional/language/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:35:\"/admin/config/regional/language/add\";s:8:\"numParts\";i:5;}}}}',5),

('language.content_settings_page','/admin/config/regional/content-language','/admin/config/regional/content-language',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1036:{a:9:{s:4:\"path\";s:39:\"/admin/config/regional/content-language\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:16:\"Content language\";s:5:\"_form\";s:48:\"Drupal\\language\\Form\\ContentLanguageSettingsForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer languages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":416:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/config/regional/content\\-language$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/regional/content-language\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:39:\"/admin/config/regional/content-language\";s:8:\"numParts\";i:4;}}}}',4),

('language.negotiation','/admin/config/regional/language/detection','/admin/config/regional/language/detection',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1048:{a:9:{s:4:\"path\";s:41:\"/admin/config/regional/language/detection\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:46:\"\\Drupal\\language\\Form\\NegotiationConfigureForm\";s:6:\"_title\";s:23:\"Detection and selection\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer languages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":421:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/admin/config/regional/language/detection$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/regional/language/detection\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:41:\"/admin/config/regional/language/detection\";s:8:\"numParts\";i:5;}}}}',5),

('language.negotiation_browser','/admin/config/regional/language/detection/browser','/admin/config/regional/language/detection/browser',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1095:{a:9:{s:4:\"path\";s:49:\"/admin/config/regional/language/detection/browser\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:44:\"\\Drupal\\language\\Form\\NegotiationBrowserForm\";s:6:\"_title\";s:40:\"Browser language detection configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer languages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":445:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:56:\"#^/admin/config/regional/language/detection/browser$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:49:\"/admin/config/regional/language/detection/browser\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:49:\"/admin/config/regional/language/detection/browser\";s:8:\"numParts\";i:6;}}}}',6),

('language.negotiation_browser_delete','/admin/config/regional/language/detection/browser/delete/{browser_langcode}','/admin/config/regional/language/detection/browser/delete/%',254,'C:31:\"Symfony\\Component\\Routing\\Route\":1295:{a:9:{s:4:\"path\";s:75:\"/admin/config/regional/language/detection/browser/delete/{browser_langcode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:50:\"\\Drupal\\language\\Form\\NegotiationBrowserDeleteForm\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer languages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":648:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"browser_langcode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:92:\"#^/admin/config/regional/language/detection/browser/delete/(?P<browser_langcode>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"browser_langcode\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:56:\"/admin/config/regional/language/detection/browser/delete\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"browser_langcode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:254;s:14:\"patternOutline\";s:58:\"/admin/config/regional/language/detection/browser/delete/%\";s:8:\"numParts\";i:8;}}}}',8),

('language.negotiation_selected','/admin/config/regional/language/detection/selected','/admin/config/regional/language/detection/selected',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1090:{a:9:{s:4:\"path\";s:50:\"/admin/config/regional/language/detection/selected\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:44:\"Drupal\\language\\Form\\NegotiationSelectedForm\";s:6:\"_title\";s:31:\"Selected language configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer languages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":448:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:57:\"#^/admin/config/regional/language/detection/selected$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:50:\"/admin/config/regional/language/detection/selected\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:50:\"/admin/config/regional/language/detection/selected\";s:8:\"numParts\";i:6;}}}}',6),

('language.negotiation_session','/admin/config/regional/language/detection/session','/admin/config/regional/language/detection/session',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1094:{a:9:{s:4:\"path\";s:49:\"/admin/config/regional/language/detection/session\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"Drupal\\language\\Form\\NegotiationSessionForm\";s:6:\"_title\";s:40:\"Session language detection configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer languages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":445:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:56:\"#^/admin/config/regional/language/detection/session$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:49:\"/admin/config/regional/language/detection/session\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:49:\"/admin/config/regional/language/detection/session\";s:8:\"numParts\";i:6;}}}}',6),

('language.negotiation_url','/admin/config/regional/language/detection/url','/admin/config/regional/language/detection/url',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1070:{a:9:{s:4:\"path\";s:45:\"/admin/config/regional/language/detection/url\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"Drupal\\language\\Form\\NegotiationUrlForm\";s:6:\"_title\";s:36:\"URL language detection configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer languages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":433:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/admin/config/regional/language/detection/url$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:45:\"/admin/config/regional/language/detection/url\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:45:\"/admin/config/regional/language/detection/url\";s:8:\"numParts\";i:6;}}}}',6),

('menu_ui.link_edit','/admin/structure/menu/link/{menu_link_plugin}/edit','/admin/structure/menu/link/%/edit',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1387:{a:9:{s:4:\"path\";s:50:\"/admin/structure/menu/link/{menu_link_plugin}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:36:\"Drupal\\menu_ui\\Form\\MenuLinkEditForm\";s:6:\"_title\";s:14:\"Edit menu link\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:15:\"administer menu\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"menu_link_plugin\";a:2:{s:4:\"type\";s:16:\"menu_link_plugin\";s:9:\"converter\";s:54:\"drupal.proxy_original_service.paramconverter.menu_link\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":608:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"menu_link_plugin\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/structure/menu/link/(?P<menu_link_plugin>[^/]++)/edit$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"menu_link_plugin\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/link\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"menu_link_plugin\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:33:\"/admin/structure/menu/link/%/edit\";s:8:\"numParts\";i:6;}}}}',6),

('menu_ui.link_reset','/admin/structure/menu/link/{menu_link_plugin}/reset','/admin/structure/menu/link/%/reset',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1510:{a:9:{s:4:\"path\";s:51:\"/admin/structure/menu/link/{menu_link_plugin}/reset\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"Drupal\\menu_ui\\Form\\MenuLinkResetForm\";s:6:\"_title\";s:15:\"Reset menu link\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:15:\"administer menu\";s:14:\"_custom_access\";s:56:\"\\Drupal\\menu_ui\\Form\\MenuLinkResetForm::linkIsResettable\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"menu_link_plugin\";a:2:{s:4:\"type\";s:16:\"menu_link_plugin\";s:9:\"converter\";s:54:\"drupal.proxy_original_service.paramconverter.menu_link\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":611:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"menu_link_plugin\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/structure/menu/link/(?P<menu_link_plugin>[^/]++)/reset$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/reset\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"menu_link_plugin\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/link\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"menu_link_plugin\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:34:\"/admin/structure/menu/link/%/reset\";s:8:\"numParts\";i:6;}}}}',6),

('menu_ui.parent_options_js','/admin/structure/menu/parents','/admin/structure/menu/parents',15,'C:31:\"Symfony\\Component\\Routing\\Route\":971:{a:9:{s:4:\"path\";s:29:\"/admin/structure/menu/parents\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:59:\"\\Drupal\\menu_ui\\Controller\\MenuController::getParentOptions\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:15:\"administer menu\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/structure/menu/parents$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/menu/parents\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/structure/menu/parents\";s:8:\"numParts\";i:4;}}}}',4),

('nd_visualshortcodes.settings','/admin/config/content/nd_visualshortcodes','/admin/config/content/nd_visualshortcodes',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1073:{a:9:{s:4:\"path\";s:41:\"/admin/config/content/nd_visualshortcodes\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:64:\"\\Drupal\\nd_visualshortcodes\\Form\\nd_visualshortcodesSettingsForm\";s:6:\"_title\";s:17:\"Visual shortcodes\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer nd nd_visualshortcodes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":421:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/admin/config/content/nd_visualshortcodes$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/content/nd_visualshortcodes\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:41:\"/admin/config/content/nd_visualshortcodes\";s:8:\"numParts\";i:4;}}}}',4),

('nd_visualshortcodes_ajax_backend_layout','/ajax/nd_visualshortcodes/ajax_backend_layout','/ajax/nd_visualshortcodes/ajax_backend_layout',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1072:{a:9:{s:4:\"path\";s:45:\"/ajax/nd_visualshortcodes/ajax_backend_layout\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:109:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_backend_layout\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":432:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/ajax/nd_visualshortcodes/ajax_backend_layout$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:45:\"/ajax/nd_visualshortcodes/ajax_backend_layout\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:45:\"/ajax/nd_visualshortcodes/ajax_backend_layout\";s:8:\"numParts\";i:3;}}}}',3),

('nd_visualshortcodes_ajax_backend_shortcode','/admin_ajax/nd_visualshortcodes/ajax_backend_shortcode','/admin_ajax/nd_visualshortcodes/ajax_backend_shortcode',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1111:{a:9:{s:4:\"path\";s:54:\"/admin_ajax/nd_visualshortcodes/ajax_backend_shortcode\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:112:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_backend_shortcode\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":459:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/admin_ajax/nd_visualshortcodes/ajax_backend_shortcode$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:54:\"/admin_ajax/nd_visualshortcodes/ajax_backend_shortcode\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:54:\"/admin_ajax/nd_visualshortcodes/ajax_backend_shortcode\";s:8:\"numParts\";i:3;}}}}',3),

('nd_visualshortcodes_ajax_backend_shortcode_preview','/ajax/nd_visualshortcodes/ajax_backend_shortcode_preview','/ajax/nd_visualshortcodes/ajax_backend_shortcode_preview',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1127:{a:9:{s:4:\"path\";s:56:\"/ajax/nd_visualshortcodes/ajax_backend_shortcode_preview\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:120:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_backend_shortcode_preview\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":465:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/ajax/nd_visualshortcodes/ajax_backend_shortcode_preview$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:56:\"/ajax/nd_visualshortcodes/ajax_backend_shortcode_preview\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:56:\"/ajax/nd_visualshortcodes/ajax_backend_shortcode_preview\";s:8:\"numParts\";i:3;}}}}',3),

('nd_visualshortcodes_ajax_icons_autocomplete','/admin/ajax/nd_visualshortcodes/icons_autocomplete','/admin/ajax/nd_visualshortcodes/icons_autocomplete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1121:{a:9:{s:4:\"path\";s:50:\"/admin/ajax/nd_visualshortcodes/icons_autocomplete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:113:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_icons_autocomplete\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":448:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:57:\"#^/admin/ajax/nd_visualshortcodes/icons_autocomplete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:50:\"/admin/ajax/nd_visualshortcodes/icons_autocomplete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:50:\"/admin/ajax/nd_visualshortcodes/icons_autocomplete\";s:8:\"numParts\";i:4;}}}}',4),

('nd_visualshortcodes_ajax_node_autocomplete','/admin/ajax/nd_visualshortcodes/node_autocomplete','/admin/ajax/nd_visualshortcodes/node_autocomplete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1102:{a:9:{s:4:\"path\";s:49:\"/admin/ajax/nd_visualshortcodes/node_autocomplete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:112:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_node_autocomplete\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":445:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:56:\"#^/admin/ajax/nd_visualshortcodes/node_autocomplete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:49:\"/admin/ajax/nd_visualshortcodes/node_autocomplete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:49:\"/admin/ajax/nd_visualshortcodes/node_autocomplete\";s:8:\"numParts\";i:4;}}}}',4),

('nd_visualshortcodes_ajax_shortcodes_delete','/ajax/nd_visualshortcodes/ajax_backend_delete_saved','/ajax/nd_visualshortcodes/ajax_backend_delete_saved',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1105:{a:9:{s:4:\"path\";s:51:\"/ajax/nd_visualshortcodes/ajax_backend_delete_saved\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:118:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_shortcodes_delete_saved\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":450:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/ajax/nd_visualshortcodes/ajax_backend_delete_saved$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:51:\"/ajax/nd_visualshortcodes/ajax_backend_delete_saved\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:51:\"/ajax/nd_visualshortcodes/ajax_backend_delete_saved\";s:8:\"numParts\";i:3;}}}}',3),

('nd_visualshortcodes_ajax_shortcodes_list','/ajax/nd_visualshortcodes/shortcodes_list','/ajax/nd_visualshortcodes/shortcodes_list',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1057:{a:9:{s:4:\"path\";s:41:\"/ajax/nd_visualshortcodes/shortcodes_list\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:110:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_shortcodes_list\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":420:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/ajax/nd_visualshortcodes/shortcodes_list$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/ajax/nd_visualshortcodes/shortcodes_list\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:41:\"/ajax/nd_visualshortcodes/shortcodes_list\";s:8:\"numParts\";i:3;}}}}',3),

('nd_visualshortcodes_ajax_shortcodes_list_add','/ajax/nd_visualshortcodes/shortcodes_list_add','/ajax/nd_visualshortcodes/shortcodes_list_add',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1077:{a:9:{s:4:\"path\";s:45:\"/ajax/nd_visualshortcodes/shortcodes_list_add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:114:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_shortcodes_list_add\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":432:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/ajax/nd_visualshortcodes/shortcodes_list_add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:45:\"/ajax/nd_visualshortcodes/shortcodes_list_add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:45:\"/ajax/nd_visualshortcodes/shortcodes_list_add\";s:8:\"numParts\";i:3;}}}}',3),

('nd_visualshortcodes_ajax_shortcodes_save','/ajax/nd_visualshortcodes/shortcodes_save','/ajax/nd_visualshortcodes/shortcodes_save',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1057:{a:9:{s:4:\"path\";s:41:\"/ajax/nd_visualshortcodes/shortcodes_save\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:110:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_shortcodes_save\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":420:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/ajax/nd_visualshortcodes/shortcodes_save$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/ajax/nd_visualshortcodes/shortcodes_save\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:41:\"/ajax/nd_visualshortcodes/shortcodes_save\";s:8:\"numParts\";i:3;}}}}',3),

('nd_visualshortcodes_ajax_upload_img','/ajax/nd_visualshortcodes/upload_img','/ajax/nd_visualshortcodes/upload_img',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1018:{a:9:{s:4:\"path\";s:36:\"/ajax/nd_visualshortcodes/upload_img\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:105:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_ajax_upload_img\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":405:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/ajax/nd_visualshortcodes/upload_img$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/ajax/nd_visualshortcodes/upload_img\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:36:\"/ajax/nd_visualshortcodes/upload_img\";s:8:\"numParts\";i:3;}}}}',3),

('nd_visualshortcodes_media_upload_image','/ajax/nd_visualshortcodes/media_upload_image','/ajax/nd_visualshortcodes/media_upload_image',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1067:{a:9:{s:4:\"path\";s:44:\"/ajax/nd_visualshortcodes/media_upload_image\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:108:\"\\Drupal\\nd_visualshortcodes\\Controller\\nd_visualshortcodesController::nd_visualshortcodes_media_upload_image\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:26:\"use nd nd_visualshortcodes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":429:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/ajax/nd_visualshortcodes/media_upload_image$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/ajax/nd_visualshortcodes/media_upload_image\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:44:\"/ajax/nd_visualshortcodes/media_upload_image\";s:8:\"numParts\";i:3;}}}}',3),

('nikadevs_cms.blockupdate','/nikadevs_cms/block_settings/update','/nikadevs_cms/block_settings/update',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1032:{a:9:{s:4:\"path\";s:35:\"/nikadevs_cms/block_settings/update\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:89:\"\\Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController::nikadevs_cms_block_settings_update\";s:6:\"_title\";s:10:\"Manage CMS\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"use nikadevs cms\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":402:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/nikadevs_cms/block_settings/update$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/nikadevs_cms/block_settings/update\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:35:\"/nikadevs_cms/block_settings/update\";s:8:\"numParts\";i:3;}}}}',3),

('nikadevs_cms.drop','/admin/drop_layout_builder','/admin/drop_layout_builder',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1018:{a:9:{s:4:\"path\";s:26:\"/admin/drop_layout_builder\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:87:\"\\Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController::nikadevs_cms_drop_layout_builder\";s:6:\"_title\";s:10:\"Manage CMS\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"use nikadevs cms\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":375:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/drop_layout_builder$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/drop_layout_builder\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:26:\"/admin/drop_layout_builder\";s:8:\"numParts\";i:2;}}}}',2),

('nikadevs_cms.filedelete','/nikadevs_cms/file_delete/%file','/nikadevs_cms/file_delete/%file',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1005:{a:9:{s:4:\"path\";s:31:\"/nikadevs_cms/file_delete/%file\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:78:\"\\Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController::nikadevs_cms_filedelete\";s:6:\"_title\";s:10:\"Manage CMS\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"use nikadevs cms\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":390:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/nikadevs_cms/file_delete/%file$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/nikadevs_cms/file_delete/%file\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:31:\"/nikadevs_cms/file_delete/%file\";s:8:\"numParts\";i:3;}}}}',3),

('nikadevs_cms.flag_cleanup','/nikadevs_cms/flag_cleanup','/nikadevs_cms/flag_cleanup',3,'C:31:\"Symfony\\Component\\Routing\\Route\":974:{a:9:{s:4:\"path\";s:26:\"/nikadevs_cms/flag_cleanup\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:67:\"\\Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController::flag_cleanup\";s:6:\"_title\";s:10:\"Manage CMS\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"use nikadevs cms\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":375:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/nikadevs_cms/flag_cleanup$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/nikadevs_cms/flag_cleanup\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:26:\"/nikadevs_cms/flag_cleanup\";s:8:\"numParts\";i:2;}}}}',2),

('nikadevs_cms.manage','/admin/config/cms','/admin/config/cms',7,'C:31:\"Symfony\\Component\\Routing\\Route\":968:{a:9:{s:4:\"path\";s:17:\"/admin/config/cms\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:73:\"\\Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController::nikadevs_cms_admin\";s:6:\"_title\";s:10:\"Manage CMS\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"use nikadevs cms\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":348:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/admin/config/cms$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/admin/config/cms\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:17:\"/admin/config/cms\";s:8:\"numParts\";i:3;}}}}',3),

('nikadevs_cms.release','/nikadevs_cms/release','/nikadevs_cms/release',3,'C:31:\"Symfony\\Component\\Routing\\Route\":957:{a:9:{s:4:\"path\";s:21:\"/nikadevs_cms/release\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:70:\"\\Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController::release_cleanup\";s:6:\"_title\";s:10:\"Manage CMS\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"use nikadevs cms\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":360:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/nikadevs_cms/release$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/nikadevs_cms/release\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:21:\"/nikadevs_cms/release\";s:8:\"numParts\";i:2;}}}}',2),

('nikadevs_cms.update','/nikadevs_cms/layout_builder/update','/nikadevs_cms/layout_builder/update',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1032:{a:9:{s:4:\"path\";s:35:\"/nikadevs_cms/layout_builder/update\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:89:\"\\Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController::nikadevs_cms_layout_builder_update\";s:6:\"_title\";s:10:\"Manage CMS\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"use nikadevs cms\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":402:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/nikadevs_cms/layout_builder/update$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/nikadevs_cms/layout_builder/update\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:35:\"/nikadevs_cms/layout_builder/update\";s:8:\"numParts\";i:3;}}}}',3),

('node.add','/node/add/{node_type}','/node/add/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1314:{a:9:{s:4:\"path\";s:21:\"/node/add/{node_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:43:\"\\Drupal\\node\\Controller\\NodeController::add\";s:15:\"_title_callback\";s:52:\"\\Drupal\\node\\Controller\\NodeController::addPageTitle\";}s:12:\"requirements\";a:1:{s:16:\"_node_add_access\";s:16:\"node:{node_type}\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:3:{s:21:\"with_config_overrides\";b:1;s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:21:\"access_check.node.add\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":473:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/node/add/(?P<node_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/node/add\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:11:\"/node/add/%\";s:8:\"numParts\";i:3;}}}}',3),

('node.add_page','/node/add','/node/add',3,'C:31:\"Symfony\\Component\\Routing\\Route\":931:{a:9:{s:4:\"path\";s:9:\"/node/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:11:\"Add content\";s:11:\"_controller\";s:47:\"\\Drupal\\node\\Controller\\NodeController::addPage\";}s:12:\"requirements\";a:1:{s:16:\"_node_add_access\";s:4:\"node\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:21:\"access_check.node.add\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":322:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:16:\"#^/node/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/node/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:9:\"/node/add\";s:8:\"numParts\";i:2;}}}}',2),

('node.configure_rebuild_confirm','/admin/reports/status/rebuild','/admin/reports/status/rebuild',15,'C:31:\"Symfony\\Component\\Routing\\Route\":956:{a:9:{s:4:\"path\";s:29:\"/admin/reports/status/rebuild\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:5:\"_form\";s:39:\"Drupal\\node\\Form\\RebuildPermissionsForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/reports/status/rebuild$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/reports/status/rebuild\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/reports/status/rebuild\";s:8:\"numParts\";i:4;}}}}',4),

('node.multiple_delete_confirm','/admin/content/node/delete','/admin/content/node/delete',15,'C:31:\"Symfony\\Component\\Routing\\Route\":977:{a:9:{s:4:\"path\";s:26:\"/admin/content/node/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:32:\"\\Drupal\\node\\Form\\DeleteMultiple\";s:14:\"entity_type_id\";s:4:\"node\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:4:\"node\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":376:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/content/node/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/content/node/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/content/node/delete\";s:8:\"numParts\";i:4;}}}}',4),

('node.revision_delete_confirm','/node/{node}/revisions/{node_revision}/delete','/node/%/revisions/%/delete',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1406:{a:9:{s:4:\"path\";s:45:\"/node/{node}/revisions/{node_revision}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\node\\Form\\NodeRevisionDeleteForm\";s:6:\"_title\";s:23:\"Delete earlier revision\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:6:\"delete\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":729:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/node/(?P<node>\\d+)/revisions/(?P<node_revision>[^/]++)/delete$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"node_revision\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:26:\"/node/%/revisions/%/delete\";s:8:\"numParts\";i:5;}}}}',5),

('node.revision_revert_confirm','/node/{node}/revisions/{node_revision}/revert','/node/%/revisions/%/revert',21,'C:31:\"Symfony\\Component\\Routing\\Route\":1409:{a:9:{s:4:\"path\";s:45:\"/node/{node}/revisions/{node_revision}/revert\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\node\\Form\\NodeRevisionRevertForm\";s:6:\"_title\";s:26:\"Revert to earlier revision\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:6:\"update\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":729:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/node/(?P<node>\\d+)/revisions/(?P<node_revision>[^/]++)/revert$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/revert\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"node_revision\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:26:\"/node/%/revisions/%/revert\";s:8:\"numParts\";i:5;}}}}',5),

('node.revision_revert_translation_confirm','/node/{node}/revisions/{node_revision}/revert/{langcode}','/node/%/revisions/%/revert/%',42,'C:31:\"Symfony\\Component\\Routing\\Route\":1594:{a:9:{s:4:\"path\";s:56:\"/node/{node}/revisions/{node_revision}/revert/{langcode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:51:\"\\Drupal\\node\\Form\\NodeRevisionRevertTranslationForm\";s:6:\"_title\";s:43:\"Revert to earlier revision of a translation\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:6:\"update\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":875:{a:11:{s:4:\"vars\";a:3:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:8:\"langcode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:90:\"#^/node/(?P<node>\\d+)/revisions/(?P<node_revision>[^/]++)/revert/(?P<langcode>[^/]++)$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"langcode\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/revert\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"node_revision\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:3:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:8:\"langcode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:42;s:14:\"patternOutline\";s:28:\"/node/%/revisions/%/revert/%\";s:8:\"numParts\";i:6;}}}}',6),

('node.type_add','/admin/structure/types/add','/admin/structure/types/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":960:{a:9:{s:4:\"path\";s:26:\"/admin/structure/types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"node_type.add\";s:6:\"_title\";s:16:\"Add content type\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer content types\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":376:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/structure/types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/structure/types/add\";s:8:\"numParts\";i:4;}}}}',4),

('path.admin_add','/admin/config/search/path/add','/admin/config/search/path/add',31,'C:31:\"Symfony\\Component\\Routing\\Route\":966:{a:9:{s:4:\"path\";s:29:\"/admin/config/search/path/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:9:\"Add alias\";s:5:\"_form\";s:25:\"\\Drupal\\path\\Form\\AddForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/config/search/path/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/config/search/path/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:29:\"/admin/config/search/path/add\";s:8:\"numParts\";i:5;}}}}',5),

('path.admin_edit','/admin/config/search/path/edit/{pid}','/admin/config/search/path/edit/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1105:{a:9:{s:4:\"path\";s:36:\"/admin/config/search/path/edit/{pid}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:10:\"Edit alias\";s:5:\"_form\";s:26:\"\\Drupal\\path\\Form\\EditForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":514:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"pid\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/config/search/path/edit/(?P<pid>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"pid\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/config/search/path/edit\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"pid\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:32:\"/admin/config/search/path/edit/%\";s:8:\"numParts\";i:6;}}}}',6),

('path.admin_overview','/admin/config/search/path','/admin/config/search/path',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1001:{a:9:{s:4:\"path\";s:25:\"/admin/config/search/path\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:11:\"URL aliases\";s:11:\"_controller\";s:53:\"\\Drupal\\path\\Controller\\PathController::adminOverview\";s:4:\"keys\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":373:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/config/search/path$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/config/search/path\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:25:\"/admin/config/search/path\";s:8:\"numParts\";i:4;}}}}',4),

('path.admin_overview_filter','/admin/config/search/path/filter','/admin/config/search/path/filter',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1016:{a:9:{s:4:\"path\";s:32:\"/admin/config/search/path/filter\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:11:\"URL aliases\";s:11:\"_controller\";s:53:\"\\Drupal\\path\\Controller\\PathController::adminOverview\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/admin/config/search/path/filter$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/search/path/filter\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:32:\"/admin/config/search/path/filter\";s:8:\"numParts\";i:5;}}}}',5),

('path.delete','/admin/config/search/path/delete/{pid}','/admin/config/search/path/delete/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1117:{a:9:{s:4:\"path\";s:38:\"/admin/config/search/path/delete/{pid}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:28:\"\\Drupal\\path\\Form\\DeleteForm\";s:6:\"_title\";s:12:\"Delete alias\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":520:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"pid\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/admin/config/search/path/delete/(?P<pid>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"pid\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/search/path/delete\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"pid\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:34:\"/admin/config/search/path/delete/%\";s:8:\"numParts\";i:6;}}}}',6),

('pathauto.admin.delete','/admin/config/search/path/delete_bulk','/admin/config/search/path/delete_bulk',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1020:{a:9:{s:4:\"path\";s:37:\"/admin/config/search/path/delete_bulk\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:41:\"\\Drupal\\pathauto\\Form\\PathautoAdminDelete\";s:6:\"_title\";s:14:\"Delete aliases\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/config/search/path/delete_bulk$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/search/path/delete_bulk\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:37:\"/admin/config/search/path/delete_bulk\";s:8:\"numParts\";i:5;}}}}',5),

('pathauto.bulk.update.form','/admin/config/search/path/update_bulk','/admin/config/search/path/update_bulk',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1022:{a:9:{s:4:\"path\";s:37:\"/admin/config/search/path/update_bulk\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:44:\"\\Drupal\\pathauto\\Form\\PathautoBulkUpdateForm\";s:6:\"_title\";s:13:\"Bulk generate\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/config/search/path/update_bulk$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/search/path/update_bulk\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:37:\"/admin/config/search/path/update_bulk\";s:8:\"numParts\";i:5;}}}}',5),

('pathauto.settings.form','/admin/config/search/path/settings','/admin/config/search/path/settings',31,'C:31:\"Symfony\\Component\\Routing\\Route\":999:{a:9:{s:4:\"path\";s:34:\"/admin/config/search/path/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:42:\"\\Drupal\\pathauto\\Form\\PathautoSettingsForm\";s:6:\"_title\";s:8:\"Settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"administer pathauto\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/admin/config/search/path/settings$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/search/path/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:34:\"/admin/config/search/path/settings\";s:8:\"numParts\";i:5;}}}}',5),

('profile.user_page.add_form','/user/{user}/{profile_type}/add','/user/%/%/add',9,'C:31:\"Symfony\\Component\\Routing\\Route\":1597:{a:9:{s:4:\"path\";s:31:\"/user/{user}/{profile_type}/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:50:\"\\Drupal\\profile\\Controller\\UserController::addForm\";s:6:\"_title\";s:11:\"Add profile\";}s:12:\"requirements\";a:2:{s:22:\"_profile_type_multiple\";s:4:\"TRUE\";s:14:\"_custom_access\";s:60:\"\\Drupal\\profile\\Controller\\UserController::checkCreateAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:34:\"access_check.profile_type_multiple\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":654:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/user/(?P<user>[^/]++)/(?P<profile_type>[^/]++)/add$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:4:\"/add\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:9;s:14:\"patternOutline\";s:13:\"/user/%/%/add\";s:8:\"numParts\";i:4;}}}}',4),

('profile.user_page.multiple','/user/{user}/{profile_type}/list','/user/%/%/list',9,'C:31:\"Symfony\\Component\\Routing\\Route\":1647:{a:9:{s:4:\"path\";s:32:\"/user/{user}/{profile_type}/list\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\profile\\Controller\\UserController::multiplePage\";s:15:\"_title_callback\";s:48:\"\\Drupal\\profile\\Controller\\UserController::title\";}s:12:\"requirements\";a:2:{s:22:\"_profile_type_multiple\";s:4:\"TRUE\";s:14:\"_custom_access\";s:54:\"\\Drupal\\profile\\Controller\\UserController::checkAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:34:\"access_check.profile_type_multiple\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":657:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/user/(?P<user>[^/]++)/(?P<profile_type>[^/]++)/list$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/list\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:9;s:14:\"patternOutline\";s:14:\"/user/%/%/list\";s:8:\"numParts\";i:4;}}}}',4),

('profile.user_page.single','/user/{user}/{profile_type}','/user/%/%',4,'C:31:\"Symfony\\Component\\Routing\\Route\":1589:{a:9:{s:4:\"path\";s:27:\"/user/{user}/{profile_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:53:\"\\Drupal\\profile\\Controller\\UserController::singlePage\";s:15:\"_title_callback\";s:48:\"\\Drupal\\profile\\Controller\\UserController::title\";}s:12:\"requirements\";a:2:{s:22:\"_profile_type_multiple\";s:5:\"FALSE\";s:14:\"_custom_access\";s:54:\"\\Drupal\\profile\\Controller\\UserController::checkAccess\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:2:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}s:12:\"profile_type\";a:2:{s:4:\"type\";s:19:\"entity:profile_type\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:34:\"access_check.profile_type_multiple\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":605:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"user\";i:1;s:12:\"profile_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/user/(?P<user>[^/]++)/(?P<profile_type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"profile_type\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"user\";i:1;s:12:\"profile_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:4;s:14:\"patternOutline\";s:9:\"/user/%/%\";s:8:\"numParts\";i:3;}}}}',3),

('rest.csrftoken','/rest/session/token','/rest/session/token',7,'C:31:\"Symfony\\Component\\Routing\\Route\":883:{a:9:{s:4:\"path\";s:19:\"/rest/session/token\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:56:\"\\Drupal\\system\\Controller\\CsrfTokenController::csrfToken\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":354:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/rest/session/token$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/rest/session/token\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/rest/session/token\";s:8:\"numParts\";i:3;}}}}',3),

('rhythm_cms_home','/home/{type}','/home/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1017:{a:9:{s:4:\"path\";s:12:\"/home/{type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:64:\"\\Drupal\\rhythm_cms\\Controller\\RhythmCMSController::home_variants\";s:6:\"_title\";s:8:\"Homepage\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":440:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/home/(?P<type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/home\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:7:\"/home/%\";s:8:\"numParts\";i:2;}}}}',2),

('rhythm_cms_onepage','/onepage/{type}','/onepage/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":1032:{a:9:{s:4:\"path\";s:15:\"/onepage/{type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:67:\"\\Drupal\\rhythm_cms\\Controller\\RhythmCMSController::onepage_variants\";s:6:\"_title\";s:7:\"Onepage\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":450:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/onepage/(?P<type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/onepage\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:10:\"/onepage/%\";s:8:\"numParts\";i:2;}}}}',2),

('search.add_type','/admin/config/search/pages/add/{search_plugin_id}','/admin/config/search/pages/add/%',62,'C:31:\"Symfony\\Component\\Routing\\Route\":1181:{a:9:{s:4:\"path\";s:49:\"/admin/config/search/pages/add/{search_plugin_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"search_page.add\";s:6:\"_title\";s:19:\"Add new search page\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:11:\"search_page\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":569:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"search_plugin_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:66:\"#^/admin/config/search/pages/add/(?P<search_plugin_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"search_plugin_id\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/config/search/pages/add\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"search_plugin_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:32:\"/admin/config/search/pages/add/%\";s:8:\"numParts\";i:6;}}}}',6),

('search.help_node_search','/search/node/help','/search/node/help',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1152:{a:9:{s:4:\"path\";s:17:\"/search/node/help\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:53:\"Drupal\\search\\Controller\\SearchController::searchHelp\";s:6:\"_title\";s:11:\"Search help\";s:6:\"entity\";s:11:\"node_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":348:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/search/node/help$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/search/node/help\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:17:\"/search/node/help\";s:8:\"numParts\";i:3;}}}}',3),

('search.help_user_search','/search/user/help','/search/user/help',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1152:{a:9:{s:4:\"path\";s:17:\"/search/user/help\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:53:\"Drupal\\search\\Controller\\SearchController::searchHelp\";s:6:\"_title\";s:11:\"Search help\";s:6:\"entity\";s:11:\"user_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":348:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/search/user/help$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/search/user/help\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:17:\"/search/user/help\";s:8:\"numParts\";i:3;}}}}',3),

('search.reindex_confirm','/admin/config/search/pages/reindex','/admin/config/search/pages/reindex',31,'C:31:\"Symfony\\Component\\Routing\\Route\":993:{a:9:{s:4:\"path\";s:34:\"/admin/config/search/pages/reindex\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:34:\"\\Drupal\\search\\Form\\ReindexConfirm\";s:6:\"_title\";s:11:\"Clear index\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer search\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/admin/config/search/pages/reindex$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/search/pages/reindex\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:34:\"/admin/config/search/pages/reindex\";s:8:\"numParts\";i:5;}}}}',5),

('search.view','/search','/search',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1111:{a:9:{s:4:\"path\";s:7:\"/search\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:61:\"Drupal\\search\\Controller\\SearchController::redirectSearchPage\";s:6:\"_title\";s:6:\"Search\";s:6:\"entity\";s:11:\"node_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":316:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:14:\"#^/search$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/search\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:7:\"/search\";s:8:\"numParts\";i:1;}}}}',1),

('search.view_node_search','/search/node','/search/node',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1120:{a:9:{s:4:\"path\";s:12:\"/search/node\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:47:\"Drupal\\search\\Controller\\SearchController::view\";s:6:\"_title\";s:6:\"Search\";s:6:\"entity\";s:11:\"node_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":333:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/search/node$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/search/node\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/search/node\";s:8:\"numParts\";i:2;}}}}',2),

('search.view_user_search','/search/user','/search/user',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1120:{a:9:{s:4:\"path\";s:12:\"/search/user\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:47:\"Drupal\\search\\Controller\\SearchController::view\";s:6:\"_title\";s:6:\"Search\";s:6:\"entity\";s:11:\"user_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":333:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/search/user$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/search/user\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/search/user\";s:8:\"numParts\";i:2;}}}}',2),

('shortcut.link_add','/admin/config/user-interface/shortcut/manage/{shortcut_set}/add-link','/admin/config/user-interface/shortcut/manage/%/add-link',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1506:{a:9:{s:4:\"path\";s:68:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/add-link\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\shortcut\\Controller\\ShortcutController::addForm\";s:6:\"_title\";s:8:\"Add link\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:23:\"shortcut:{shortcut_set}\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":661:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)/add\\-link$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/add-link\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:55:\"/admin/config/user-interface/shortcut/manage/%/add-link\";s:8:\"numParts\";i:7;}}}}',7),

('shortcut.link_add_inline','/admin/config/user-interface/shortcut/manage/{shortcut_set}/add-link-inline','/admin/config/user-interface/shortcut/manage/%/add-link-inline',125,'C:31:\"Symfony\\Component\\Routing\\Route\":1565:{a:9:{s:4:\"path\";s:75:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/add-link-inline\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:71:\"Drupal\\shortcut\\Controller\\ShortcutSetController::addShortcutLinkInline\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:19:\"shortcut_set.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":684:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:95:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)/add\\-link\\-inline$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/add-link-inline\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:62:\"/admin/config/user-interface/shortcut/manage/%/add-link-inline\";s:8:\"numParts\";i:7;}}}}',7),

('shortcut.set_add','/admin/config/user-interface/shortcut/add-set','/admin/config/user-interface/shortcut/add-set',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1042:{a:9:{s:4:\"path\";s:45:\"/admin/config/user-interface/shortcut/add-set\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"shortcut_set.add\";s:6:\"_title\";s:16:\"Add shortcut set\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:12:\"shortcut_set\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":435:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/admin/config/user\\-interface/shortcut/add\\-set$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:45:\"/admin/config/user-interface/shortcut/add-set\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:45:\"/admin/config/user-interface/shortcut/add-set\";s:8:\"numParts\";i:5;}}}}',5),

('shortcut.set_switch','/user/{user}/shortcuts','/user/%/shortcuts',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1260:{a:9:{s:4:\"path\";s:22:\"/user/{user}/shortcuts\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"Drupal\\shortcut\\Form\\SwitchShortcutSet\";s:6:\"_title\";s:9:\"Shortcuts\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:51:\"Drupal\\shortcut\\Form\\SwitchShortcutSet::checkAccess\";}s:7:\"options\";a:6:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"user\";s:3:\"\\d+\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":508:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/user/(?P<user>[^/]++)/shortcuts$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/shortcuts\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/user/%/shortcuts\";s:8:\"numParts\";i:3;}}}}',3),

('system.401','/system/401','/system/401',3,'C:31:\"Symfony\\Component\\Routing\\Route\":877:{a:9:{s:4:\"path\";s:11:\"/system/401\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\system\\Controller\\Http4xxController:on401\";s:6:\"_title\";s:12:\"Unauthorized\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":330:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/system/401$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/system/401\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/system/401\";s:8:\"numParts\";i:2;}}}}',2),

('system.403','/system/403','/system/403',3,'C:31:\"Symfony\\Component\\Routing\\Route\":878:{a:9:{s:4:\"path\";s:11:\"/system/403\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\system\\Controller\\Http4xxController:on403\";s:6:\"_title\";s:13:\"Access denied\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":330:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/system/403$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/system/403\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/system/403\";s:8:\"numParts\";i:2;}}}}',2),

('system.404','/system/404','/system/404',3,'C:31:\"Symfony\\Component\\Routing\\Route\":879:{a:9:{s:4:\"path\";s:11:\"/system/404\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\system\\Controller\\Http4xxController:on404\";s:6:\"_title\";s:14:\"Page not found\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":330:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/system/404$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/system/404\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/system/404\";s:8:\"numParts\";i:2;}}}}',2),

('system.4xx','/system/4xx','/system/4xx',3,'C:31:\"Symfony\\Component\\Routing\\Route\":877:{a:9:{s:4:\"path\";s:11:\"/system/4xx\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\system\\Controller\\Http4xxController:on4xx\";s:6:\"_title\";s:12:\"Client error\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":330:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/system/4xx$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/system/4xx\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/system/4xx\";s:8:\"numParts\";i:2;}}}}',2),

('system.admin','/admin','/admin',1,'C:31:\"Symfony\\Component\\Routing\\Route\":931:{a:9:{s:4:\"path\";s:6:\"/admin\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:14:\"Administration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":313:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:13:\"#^/admin$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/admin\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:6:\"/admin\";s:8:\"numParts\";i:1;}}}}',1),

('system.admin_compact_page','/admin/compact/{mode}','/admin/compact',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1078:{a:9:{s:4:\"path\";s:21:\"/admin/compact/{mode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"Drupal\\system\\Controller\\SystemController::compactPage\";s:4:\"mode\";s:3:\"off\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":472:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/compact(?:/(?P<mode>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"mode\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/compact\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/compact\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_config','/admin/config','/admin/config',3,'C:31:\"Symfony\\Component\\Routing\\Route\":986:{a:9:{s:4:\"path\";s:13:\"/admin/config\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:52:\"\\Drupal\\system\\Controller\\SystemController::overview\";s:7:\"link_id\";s:19:\"system.admin_config\";s:6:\"_title\";s:13:\"Configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":336:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/admin/config$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/admin/config\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/admin/config\";s:8:\"numParts\";i:2;}}}}',2),

('system.admin_config_content','/admin/config/content','/admin/config/content',7,'C:31:\"Symfony\\Component\\Routing\\Route\":997:{a:9:{s:4:\"path\";s:21:\"/admin/config/content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:17:\"Content authoring\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":360:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/config/content$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/config/content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/config/content\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_config_development','/admin/config/development','/admin/config/development',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1007:{a:9:{s:4:\"path\";s:25:\"/admin/config/development\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:11:\"Development\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":372:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/config/development$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/config/development\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/config/development\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_config_media','/admin/config/media','/admin/config/media',7,'C:31:\"Symfony\\Component\\Routing\\Route\":976:{a:9:{s:4:\"path\";s:19:\"/admin/config/media\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:5:\"Media\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":354:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/config/media$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/admin/config/media\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/admin/config/media\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_config_regional','/admin/config/regional','/admin/config/regional',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1005:{a:9:{s:4:\"path\";s:22:\"/admin/config/regional\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:21:\"Regional and language\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/config/regional$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/config/regional\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/config/regional\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_config_search','/admin/config/search','/admin/config/search',7,'C:31:\"Symfony\\Component\\Routing\\Route\":995:{a:9:{s:4:\"path\";s:20:\"/admin/config/search\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:19:\"Search and metadata\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":357:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/config/search$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/config/search\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/config/search\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_config_services','/admin/config/services','/admin/config/services',7,'C:31:\"Symfony\\Component\\Routing\\Route\":996:{a:9:{s:4:\"path\";s:22:\"/admin/config/services\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:12:\"Web services\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/config/services$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/config/services\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/config/services\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_config_system','/admin/config/system','/admin/config/system',7,'C:31:\"Symfony\\Component\\Routing\\Route\":981:{a:9:{s:4:\"path\";s:20:\"/admin/config/system\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:6:\"System\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":357:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/config/system$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/config/system\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/config/system\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_config_ui','/admin/config/user-interface','/admin/config/user-interface',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1023:{a:9:{s:4:\"path\";s:28:\"/admin/config/user-interface\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:14:\"User interface\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/config/user\\-interface$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/config/user-interface\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:28:\"/admin/config/user-interface\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_config_workflow','/admin/config/workflow','/admin/config/workflow',7,'C:31:\"Symfony\\Component\\Routing\\Route\":991:{a:9:{s:4:\"path\";s:22:\"/admin/config/workflow\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:8:\"Workflow\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/config/workflow$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/config/workflow\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/config/workflow\";s:8:\"numParts\";i:3;}}}}',3),

('system.admin_content','/admin/content','/admin/content',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1254:{a:9:{s:4:\"path\";s:14:\"/admin/content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:7:\"Content\";s:7:\"view_id\";s:7:\"content\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:0;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:23:\"access content overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:0;s:16:\"returns_response\";b:0;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":339:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/admin/content$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/content\";s:8:\"numParts\";i:2;}}}}',2),

('system.admin_index','/admin/index','/admin/index',3,'C:31:\"Symfony\\Component\\Routing\\Route\":938:{a:9:{s:4:\"path\";s:12:\"/admin/index\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\system\\Controller\\AdminController::index\";s:6:\"_title\";s:14:\"Administration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":333:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/admin/index$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/admin/index\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/admin/index\";s:8:\"numParts\";i:2;}}}}',2),

('system.admin_reports','/admin/reports','/admin/reports',3,'C:31:\"Symfony\\Component\\Routing\\Route\":950:{a:9:{s:4:\"path\";s:14:\"/admin/reports\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:7:\"Reports\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":339:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/admin/reports$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/reports\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/reports\";s:8:\"numParts\";i:2;}}}}',2),

('system.admin_structure','/admin/structure','/admin/structure',3,'C:31:\"Symfony\\Component\\Routing\\Route\":968:{a:9:{s:4:\"path\";s:16:\"/admin/structure\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:9:\"Structure\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":345:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/admin/structure$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/admin/structure\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:16:\"/admin/structure\";s:8:\"numParts\";i:2;}}}}',2),

('system.batch_page.html','/batch','/batch',1,'C:31:\"Symfony\\Component\\Routing\\Route\":961:{a:9:{s:4:\"path\";s:6:\"/batch\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:52:\"\\Drupal\\system\\Controller\\BatchController::batchPage\";s:15:\"_title_callback\";s:57:\"\\Drupal\\system\\Controller\\BatchController::batchPageTitle\";}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":313:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:13:\"#^/batch$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/batch\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:6:\"/batch\";s:8:\"numParts\";i:1;}}}}',1),

('system.batch_page.json','/batch','/batch',1,'C:31:\"Symfony\\Component\\Routing\\Route\":873:{a:9:{s:4:\"path\";s:6:\"/batch\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:52:\"\\Drupal\\system\\Controller\\BatchController::batchPage\";}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:4:\"json\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":313:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:13:\"#^/batch$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/batch\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:6:\"/batch\";s:8:\"numParts\";i:1;}}}}',1),

('system.cron','/cron/{key}','/cron/%',2,'C:31:\"Symfony\\Component\\Routing\\Route\":964:{a:9:{s:4:\"path\";s:11:\"/cron/{key}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:34:\"\\Drupal\\system\\CronController::run\";}s:12:\"requirements\";a:1:{s:19:\"_access_system_cron\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"no_cache\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:17:\"access_check.cron\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":436:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/cron/(?P<key>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"key\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/cron\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:7:\"/cron/%\";s:8:\"numParts\";i:2;}}}}',2),

('system.cron_settings','/admin/config/system/cron','/admin/config/system/cron',15,'C:31:\"Symfony\\Component\\Routing\\Route\":954:{a:9:{s:4:\"path\";s:25:\"/admin/config/system/cron\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:27:\"Drupal\\system\\Form\\CronForm\";s:6:\"_title\";s:4:\"Cron\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":373:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/config/system/cron$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/config/system/cron\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:25:\"/admin/config/system/cron\";s:8:\"numParts\";i:4;}}}}',4),

('system.csrftoken','/session/token','/session/token',3,'C:31:\"Symfony\\Component\\Routing\\Route\":863:{a:9:{s:4:\"path\";s:14:\"/session/token\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:56:\"\\Drupal\\system\\Controller\\CsrfTokenController::csrfToken\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":339:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/session/token$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/session/token\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/session/token\";s:8:\"numParts\";i:2;}}}}',2),

('system.date_format_add','/admin/config/regional/date-time/formats/add','/admin/config/regional/date-time/formats/add',63,'C:31:\"Symfony\\Component\\Routing\\Route\":1039:{a:9:{s:4:\"path\";s:44:\"/admin/config/regional/date-time/formats/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"date_format.add\";s:6:\"_title\";s:15:\"Add date format\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":431:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/admin/config/regional/date\\-time/formats/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/regional/date-time/formats/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:44:\"/admin/config/regional/date-time/formats/add\";s:8:\"numParts\";i:6;}}}}',6),

('system.db_update','/update.php/{op}','/update.php',1,'C:31:\"Symfony\\Component\\Routing\\Route\":996:{a:9:{s:4:\"path\";s:16:\"/update.php/{op}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:2:\"op\";s:4:\"info\";}s:12:\"requirements\";a:1:{s:21:\"_access_system_update\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"default_url_options\";a:1:{s:15:\"path_processing\";b:0;}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:22:\"access_check.db_update\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":456:{a:11:{s:4:\"vars\";a:1:{i:0;s:2:\"op\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/update\\.php(?:/(?P<op>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"op\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/update.php\";}}s:9:\"path_vars\";a:1:{i:0;s:2:\"op\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:11:\"/update.php\";s:8:\"numParts\";i:2;}}}}',2),

('system.entity_autocomplete','/entity_reference_autocomplete/{target_type}/{selection_handler}/{selection_settings_key}','/entity_reference_autocomplete/%/%/%',8,'C:31:\"Symfony\\Component\\Routing\\Route\":1556:{a:9:{s:4:\"path\";s:89:\"/entity_reference_autocomplete/{target_type}/{selection_handler}/{selection_settings_key}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:74:\"\\Drupal\\system\\Controller\\EntityAutocompleteController::handleAutocomplete\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":939:{a:11:{s:4:\"vars\";a:3:{i:0;s:11:\"target_type\";i:1;s:17:\"selection_handler\";i:2;s:22:\"selection_settings_key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:126:\"#^/entity_reference_autocomplete/(?P<target_type>[^/]++)/(?P<selection_handler>[^/]++)/(?P<selection_settings_key>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:22:\"selection_settings_key\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"selection_handler\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"target_type\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/entity_reference_autocomplete\";}}s:9:\"path_vars\";a:3:{i:0;s:11:\"target_type\";i:1;s:17:\"selection_handler\";i:2;s:22:\"selection_settings_key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:8;s:14:\"patternOutline\";s:36:\"/entity_reference_autocomplete/%/%/%\";s:8:\"numParts\";i:4;}}}}',4),

('system.files','/system/files/{scheme}','/system/files',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1026:{a:9:{s:4:\"path\";s:22:\"/system/files/{scheme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:46:\"Drupal\\system\\FileDownloadController::download\";s:6:\"scheme\";s:7:\"private\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":477:{a:11:{s:4:\"vars\";a:1:{i:0;s:6:\"scheme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/system/files(?:/(?P<scheme>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"scheme\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/system/files\";}}s:9:\"path_vars\";a:1:{i:0;s:6:\"scheme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/system/files\";s:8:\"numParts\";i:3;}}}}',3),

('system.file_system_settings','/admin/config/media/file-system','/admin/config/media/file-system',15,'C:31:\"Symfony\\Component\\Routing\\Route\":993:{a:9:{s:4:\"path\";s:31:\"/admin/config/media/file-system\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:33:\"Drupal\\system\\Form\\FileSystemForm\";s:6:\"_title\";s:11:\"File system\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":392:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/admin/config/media/file\\-system$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/config/media/file-system\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/config/media/file-system\";s:8:\"numParts\";i:4;}}}}',4),

('system.image_toolkit_settings','/admin/config/media/image-toolkit','/admin/config/media/image-toolkit',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1005:{a:9:{s:4:\"path\";s:33:\"/admin/config/media/image-toolkit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:35:\"Drupal\\system\\Form\\ImageToolkitForm\";s:6:\"_title\";s:13:\"Image toolkit\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":398:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/admin/config/media/image\\-toolkit$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/media/image-toolkit\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:33:\"/admin/config/media/image-toolkit\";s:8:\"numParts\";i:4;}}}}',4),

('system.logging_settings','/admin/config/development/logging','/admin/config/development/logging',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1004:{a:9:{s:4:\"path\";s:33:\"/admin/config/development/logging\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:30:\"Drupal\\system\\Form\\LoggingForm\";s:6:\"_title\";s:18:\"Logging and errors\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/config/development/logging$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/development/logging\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:33:\"/admin/config/development/logging\";s:8:\"numParts\";i:4;}}}}',4),

('system.machine_name_transliterate','/machine_name/transliterate','/machine_name/transliterate',3,'C:31:\"Symfony\\Component\\Routing\\Route\":929:{a:9:{s:4:\"path\";s:27:\"/machine_name/transliterate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"\\Drupal\\system\\MachineNameController::transliterate\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":378:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/machine_name/transliterate$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/machine_name/transliterate\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:27:\"/machine_name/transliterate\";s:8:\"numParts\";i:2;}}}}',2),

('system.modules_list','/admin/modules','/admin/modules',3,'C:31:\"Symfony\\Component\\Routing\\Route\":952:{a:9:{s:4:\"path\";s:14:\"/admin/modules\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:6:\"Extend\";s:14:\"_title_context\";s:15:\"With components\";s:5:\"_form\";s:34:\"Drupal\\system\\Form\\ModulesListForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":339:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/admin/modules$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/modules\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/modules\";s:8:\"numParts\";i:2;}}}}',2),

('system.modules_list_confirm','/admin/modules/list/confirm','/admin/modules/list/confirm',15,'C:31:\"Symfony\\Component\\Routing\\Route\":999:{a:9:{s:4:\"path\";s:27:\"/admin/modules/list/confirm\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:41:\"Drupal\\system\\Form\\ModulesListConfirmForm\";s:6:\"_title\";s:37:\"Some required modules must be enabled\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":379:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/admin/modules/list/confirm$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/modules/list/confirm\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:27:\"/admin/modules/list/confirm\";s:8:\"numParts\";i:4;}}}}',4),

('system.modules_list_experimental_confirm','/admin/modules/list/confirm-experimental','/admin/modules/list/confirm-experimental',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1047:{a:9:{s:4:\"path\";s:40:\"/admin/modules/list/confirm-experimental\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:53:\"Drupal\\system\\Form\\ModulesListExperimentalConfirmForm\";s:6:\"_title\";s:20:\"Experimental modules\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":419:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/admin/modules/list/confirm\\-experimental$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/modules/list/confirm-experimental\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:40:\"/admin/modules/list/confirm-experimental\";s:8:\"numParts\";i:4;}}}}',4),

('system.modules_uninstall','/admin/modules/uninstall','/admin/modules/uninstall',7,'C:31:\"Symfony\\Component\\Routing\\Route\":955:{a:9:{s:4:\"path\";s:24:\"/admin/modules/uninstall\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"Drupal\\system\\Form\\ModulesUninstallForm\";s:6:\"_title\";s:9:\"Uninstall\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/modules/uninstall$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/modules/uninstall\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/modules/uninstall\";s:8:\"numParts\";i:3;}}}}',3),

('system.modules_uninstall_confirm','/admin/modules/uninstall/confirm','/admin/modules/uninstall/confirm',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1004:{a:9:{s:4:\"path\";s:32:\"/admin/modules/uninstall/confirm\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:46:\"Drupal\\system\\Form\\ModulesUninstallConfirmForm\";s:6:\"_title\";s:17:\"Confirm uninstall\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/admin/modules/uninstall/confirm$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/modules/uninstall/confirm\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:32:\"/admin/modules/uninstall/confirm\";s:8:\"numParts\";i:4;}}}}',4),

('system.performance_settings','/admin/config/development/performance','/admin/config/development/performance',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1017:{a:9:{s:4:\"path\";s:37:\"/admin/config/development/performance\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:34:\"Drupal\\system\\Form\\PerformanceForm\";s:6:\"_title\";s:11:\"Performance\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/config/development/performance$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/development/performance\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/development/performance\";s:8:\"numParts\";i:4;}}}}',4),

('system.php','/admin/reports/status/php','/admin/reports/status/php',15,'C:31:\"Symfony\\Component\\Routing\\Route\":960:{a:9:{s:4:\"path\";s:25:\"/admin/reports/status/php\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:50:\"Drupal\\system\\Controller\\SystemInfoController::php\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:0;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":373:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/reports/status/php$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/reports/status/php\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:25:\"/admin/reports/status/php\";s:8:\"numParts\";i:4;}}}}',4),

('system.prepare_modules_entity_uninstall','/admin/modules/uninstall/entity/{entity_type_id}','/admin/modules/uninstall/entity/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1254:{a:9:{s:4:\"path\";s:48:\"/admin/modules/uninstall/entity/{entity_type_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:53:\"\\Drupal\\system\\Form\\PrepareModulesEntityUninstallForm\";s:15:\"_title_callback\";s:64:\"\\Drupal\\system\\Form\\PrepareModulesEntityUninstallForm::formTitle\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":564:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/modules/uninstall/entity/(?P<entity_type_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_type_id\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/modules/uninstall/entity\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:33:\"/admin/modules/uninstall/entity/%\";s:8:\"numParts\";i:5;}}}}',5),

('system.private_file_download','/system/files/{filepath}','/system/files/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1022:{a:9:{s:4:\"path\";s:24:\"/system/files/{filepath}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:46:\"Drupal\\system\\FileDownloadController::download\";}s:12:\"requirements\";a:2:{s:8:\"filepath\";s:2:\".+\";s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":474:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"filepath\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/system/files/(?P<filepath>.+)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:2:\".+\";i:3;s:8:\"filepath\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/system/files\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"filepath\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:15:\"/system/files/%\";s:8:\"numParts\";i:3;}}}}',3),

('system.regional_settings','/admin/config/regional/settings','/admin/config/regional/settings',15,'C:31:\"Symfony\\Component\\Routing\\Route\":996:{a:9:{s:4:\"path\";s:31:\"/admin/config/regional/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"Drupal\\system\\Form\\RegionalForm\";s:6:\"_title\";s:17:\"Regional settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/config/regional/settings$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/config/regional/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/config/regional/settings\";s:8:\"numParts\";i:4;}}}}',4),

('system.rss_feeds_settings','/admin/config/services/rss-publishing','/admin/config/services/rss-publishing',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1018:{a:9:{s:4:\"path\";s:37:\"/admin/config/services/rss-publishing\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"Drupal\\system\\Form\\RssFeedsForm\";s:6:\"_title\";s:14:\"RSS publishing\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":410:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/services/rss\\-publishing$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/services/rss-publishing\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/services/rss-publishing\";s:8:\"numParts\";i:4;}}}}',4),

('system.run_cron','/admin/reports/status/run-cron','/admin/reports/status/run-cron',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1051:{a:9:{s:4:\"path\";s:30:\"/admin/reports/status/run-cron\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:42:\"\\Drupal\\system\\CronController::runManually\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"no_cache\";b:1;s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":389:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/reports/status/run\\-cron$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/reports/status/run-cron\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:30:\"/admin/reports/status/run-cron\";s:8:\"numParts\";i:4;}}}}',4),

('system.site_information_settings','/admin/config/system/site-information','/admin/config/system/site-information',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1030:{a:9:{s:4:\"path\";s:37:\"/admin/config/system/site-information\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"Drupal\\system\\Form\\SiteInformationForm\";s:6:\"_title\";s:19:\"Basic site settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":410:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/system/site\\-information$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/system/site-information\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/system/site-information\";s:8:\"numParts\";i:4;}}}}',4),

('system.site_maintenance_mode','/admin/config/development/maintenance','/admin/config/development/maintenance',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1030:{a:9:{s:4:\"path\";s:37:\"/admin/config/development/maintenance\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:42:\"Drupal\\system\\Form\\SiteMaintenanceModeForm\";s:6:\"_title\";s:16:\"Maintenance mode\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/config/development/maintenance$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/development/maintenance\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/development/maintenance\";s:8:\"numParts\";i:4;}}}}',4),

('system.status','/admin/reports/status','/admin/reports/status',7,'C:31:\"Symfony\\Component\\Routing\\Route\":981:{a:9:{s:4:\"path\";s:21:\"/admin/reports/status\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\system\\Controller\\SystemInfoController::status\";s:6:\"_title\";s:13:\"Status report\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":360:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/reports/status$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/reports/status\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/reports/status\";s:8:\"numParts\";i:3;}}}}',3),

('system.temporary','/system/temporary','/system/temporary',3,'C:31:\"Symfony\\Component\\Routing\\Route\":895:{a:9:{s:4:\"path\";s:17:\"/system/temporary\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:47:\"\\Drupal\\system\\FileDownloadController::download\";s:6:\"scheme\";s:9:\"temporary\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":348:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/system/temporary$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/system/temporary\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:17:\"/system/temporary\";s:8:\"numParts\";i:2;}}}}',2),

('system.themes_page','/admin/appearance','/admin/appearance',3,'C:31:\"Symfony\\Component\\Routing\\Route\":950:{a:9:{s:4:\"path\";s:17:\"/admin/appearance\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:10:\"Appearance\";s:11:\"_controller\";s:54:\"\\Drupal\\system\\Controller\\SystemController::themesPage\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer themes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":348:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/admin/appearance$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/admin/appearance\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:17:\"/admin/appearance\";s:8:\"numParts\";i:2;}}}}',2),

('system.theme_install','/admin/appearance/install','/admin/appearance/install',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1005:{a:9:{s:4:\"path\";s:25:\"/admin/appearance/install\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:49:\"Drupal\\system\\Controller\\ThemeController::install\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer themes\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":372:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/appearance/install$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/appearance/install\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/appearance/install\";s:8:\"numParts\";i:3;}}}}',3),

('system.theme_settings','/admin/appearance/settings','/admin/appearance/settings',7,'C:31:\"Symfony\\Component\\Routing\\Route\":971:{a:9:{s:4:\"path\";s:26:\"/admin/appearance/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\system\\Form\\ThemeSettingsForm\";s:6:\"_title\";s:19:\"Appearance settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer themes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":375:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/appearance/settings$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/appearance/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:26:\"/admin/appearance/settings\";s:8:\"numParts\";i:3;}}}}',3),

('system.theme_settings_theme','/admin/appearance/settings/{theme}','/admin/appearance/settings/%',14,'C:31:\"Symfony\\Component\\Routing\\Route\":1126:{a:9:{s:4:\"path\";s:34:\"/admin/appearance/settings/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\system\\Form\\ThemeSettingsForm\";s:15:\"_title_callback\";s:21:\"theme_handler:getName\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer themes\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":510:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/admin/appearance/settings/(?P<theme>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/appearance/settings\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:28:\"/admin/appearance/settings/%\";s:8:\"numParts\";i:4;}}}}',4),

('system.theme_set_default','/admin/appearance/default','/admin/appearance/default',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1055:{a:9:{s:4:\"path\";s:25:\"/admin/appearance/default\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:20:\"Set as default theme\";s:11:\"_controller\";s:58:\"\\Drupal\\system\\Controller\\ThemeController::setDefaultTheme\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer themes\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":372:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/appearance/default$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/appearance/default\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/appearance/default\";s:8:\"numParts\";i:3;}}}}',3),

('system.theme_uninstall','/admin/appearance/uninstall','/admin/appearance/uninstall',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1015:{a:9:{s:4:\"path\";s:27:\"/admin/appearance/uninstall\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"Drupal\\system\\Controller\\ThemeController::uninstall\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer themes\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":378:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/admin/appearance/uninstall$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/appearance/uninstall\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:27:\"/admin/appearance/uninstall\";s:8:\"numParts\";i:3;}}}}',3),

('system.timezone','/system/timezone/{abbreviation}/{offset}/{is_daylight_saving_time}','/system/timezone',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1522:{a:9:{s:4:\"path\";s:66:\"/system/timezone/{abbreviation}/{offset}/{is_daylight_saving_time}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:57:\"\\Drupal\\system\\Controller\\TimezoneController::getTimezone\";s:12:\"abbreviation\";s:0:\"\";s:6:\"offset\";i:-1;s:23:\"is_daylight_saving_time\";N;}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":867:{a:11:{s:4:\"vars\";a:3:{i:0;s:12:\"abbreviation\";i:1;s:6:\"offset\";i:2;s:23:\"is_daylight_saving_time\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:118:\"#^/system/timezone(?:/(?P<abbreviation>[^/]++)(?:/(?P<offset>[^/]++)(?:/(?P<is_daylight_saving_time>[^/]++))?)?)?$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:23:\"is_daylight_saving_time\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"offset\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"abbreviation\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/system/timezone\";}}s:9:\"path_vars\";a:3:{i:0;s:12:\"abbreviation\";i:1;s:6:\"offset\";i:2;s:23:\"is_daylight_saving_time\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:16:\"/system/timezone\";s:8:\"numParts\";i:5;}}}}',5),

('tb_megamenu.admin.save','/admin/structure/tb-megamenu/save','/admin/structure/tb-megamenu/save',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1066:{a:9:{s:4:\"path\";s:33:\"/admin/structure/tb-megamenu/save\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:34:\"Save configuration of TB Mega Menu\";s:11:\"_controller\";s:75:\"\\Drupal\\tb_megamenu\\Controller\\TBMegaMenuAdminController::saveConfiguration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer tb_megamenu\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":398:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/admin/structure/tb\\-megamenu/save$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/structure/tb-megamenu/save\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:33:\"/admin/structure/tb-megamenu/save\";s:8:\"numParts\";i:4;}}}}',4),

('token.autocomplete','/token/autocomplete/{token_type}/{filter}','/token/autocomplete/%/%',12,'C:31:\"Symfony\\Component\\Routing\\Route\":1211:{a:9:{s:4:\"path\";s:41:\"/token/autocomplete/{token_type}/{filter}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:66:\"\\Drupal\\token\\Controller\\TokenAutocompleteController::autocomplete\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":650:{a:11:{s:4:\"vars\";a:2:{i:0;s:10:\"token_type\";i:1;s:6:\"filter\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/token/autocomplete/(?P<token_type>[^/]++)/(?P<filter>[^/]++)$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"filter\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"token_type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/token/autocomplete\";}}s:9:\"path_vars\";a:2:{i:0;s:10:\"token_type\";i:1;s:6:\"filter\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:12;s:14:\"patternOutline\";s:23:\"/token/autocomplete/%/%\";s:8:\"numParts\";i:4;}}}}',4),

('token.tree','/token/tree','/token/tree',3,'C:31:\"Symfony\\Component\\Routing\\Route\":853:{a:9:{s:4:\"path\";s:11:\"/token/tree\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:56:\"\\Drupal\\token\\Controller\\TokenTreeController::outputTree\";}s:12:\"requirements\";a:1:{s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":330:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/token/tree$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/token/tree\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/token/tree\";s:8:\"numParts\";i:2;}}}}',2),

('toolbar.subtrees','/toolbar/subtrees/{hash}','/toolbar/subtrees/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1082:{a:9:{s:4:\"path\";s:24:\"/toolbar/subtrees/{hash}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\toolbar\\Controller\\ToolbarController::subtreesAjax\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:64:\"\\Drupal\\toolbar\\Controller\\ToolbarController::checkSubTreeAccess\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":478:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"hash\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/toolbar/subtrees/(?P<hash>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"hash\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/toolbar/subtrees\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"hash\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:19:\"/toolbar/subtrees/%\";s:8:\"numParts\";i:3;}}}}',3),

('update.confirmation_page','/admin/update/ready','/admin/update/ready',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1030:{a:9:{s:4:\"path\";s:19:\"/admin/update/ready\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"\\Drupal\\update\\Form\\UpdateReady\";s:6:\"_title\";s:15:\"Ready to update\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":354:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/update/ready$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/admin/update/ready\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/admin/update/ready\";s:8:\"numParts\";i:3;}}}}',3),

('update.manual_status','/admin/reports/updates/check','/admin/reports/updates/check',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1085:{a:9:{s:4:\"path\";s:28:\"/admin/reports/updates/check\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:19:\"Manual update check\";s:11:\"_controller\";s:64:\"\\Drupal\\update\\Controller\\UpdateController::updateStatusManually\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/reports/updates/check$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/reports/updates/check\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/reports/updates/check\";s:8:\"numParts\";i:4;}}}}',4),

('update.module_install','/admin/modules/install','/admin/modules/install',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1054:{a:9:{s:4:\"path\";s:22:\"/admin/modules/install\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\update\\Form\\UpdateManagerInstall\";s:6:\"_title\";s:18:\"Install new module\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/modules/install$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/modules/install\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/modules/install\";s:8:\"numParts\";i:3;}}}}',3),

('update.module_update','/admin/modules/update','/admin/modules/update',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1036:{a:9:{s:4:\"path\";s:21:\"/admin/modules/update\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"\\Drupal\\update\\Form\\UpdateManagerUpdate\";s:6:\"_title\";s:6:\"Update\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":360:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/modules/update$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/modules/update\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/modules/update\";s:8:\"numParts\";i:3;}}}}',3),

('update.report_install','/admin/reports/updates/install','/admin/reports/updates/install',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1075:{a:9:{s:4:\"path\";s:30:\"/admin/reports/updates/install\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\update\\Form\\UpdateManagerInstall\";s:6:\"_title\";s:7:\"Install\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":388:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/reports/updates/install$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/reports/updates/install\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:30:\"/admin/reports/updates/install\";s:8:\"numParts\";i:4;}}}}',4),

('update.report_update','/admin/reports/updates/update','/admin/reports/updates/update',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1069:{a:9:{s:4:\"path\";s:29:\"/admin/reports/updates/update\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"\\Drupal\\update\\Form\\UpdateManagerUpdate\";s:6:\"_title\";s:6:\"Update\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/reports/updates/update$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/reports/updates/update\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/reports/updates/update\";s:8:\"numParts\";i:4;}}}}',4),

('update.settings','/admin/reports/updates/settings','/admin/reports/updates/settings',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1004:{a:9:{s:4:\"path\";s:31:\"/admin/reports/updates/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:33:\"\\Drupal\\update\\UpdateSettingsForm\";s:6:\"_title\";s:23:\"Update Manager settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/reports/updates/settings$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/reports/updates/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/reports/updates/settings\";s:8:\"numParts\";i:4;}}}}',4),

('update.status','/admin/reports/updates','/admin/reports/updates',7,'C:31:\"Symfony\\Component\\Routing\\Route\":991:{a:9:{s:4:\"path\";s:22:\"/admin/reports/updates\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:56:\"\\Drupal\\update\\Controller\\UpdateController::updateStatus\";s:6:\"_title\";s:17:\"Available updates\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/reports/updates$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/reports/updates\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/reports/updates\";s:8:\"numParts\";i:3;}}}}',3),

('update.theme_install','/admin/theme/install','/admin/theme/install',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1045:{a:9:{s:4:\"path\";s:20:\"/admin/theme/install\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\update\\Form\\UpdateManagerInstall\";s:6:\"_title\";s:17:\"Install new theme\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":357:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/theme/install$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/theme/install\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/theme/install\";s:8:\"numParts\";i:3;}}}}',3),

('update.theme_update','/admin/theme/update','/admin/theme/update',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1028:{a:9:{s:4:\"path\";s:19:\"/admin/theme/update\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"\\Drupal\\update\\Form\\UpdateManagerUpdate\";s:6:\"_title\";s:6:\"Update\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":354:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/theme/update$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/admin/theme/update\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/admin/theme/update\";s:8:\"numParts\";i:3;}}}}',3),

('user.admin_create','/admin/people/create','/admin/people/create',7,'C:31:\"Symfony\\Component\\Routing\\Route\":918:{a:9:{s:4:\"path\";s:20:\"/admin/people/create\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"user.register\";s:6:\"_title\";s:8:\"Add user\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:4:\"user\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":357:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/people/create$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/people/create\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/people/create\";s:8:\"numParts\";i:3;}}}}',3),

('user.admin_index','/admin/config/people','/admin/config/people',7,'C:31:\"Symfony\\Component\\Routing\\Route\":981:{a:9:{s:4:\"path\";s:20:\"/admin/config/people\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:6:\"People\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":357:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/config/people$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/config/people\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/config/people\";s:8:\"numParts\";i:3;}}}}',3),

('user.admin_permissions','/admin/people/permissions','/admin/people/permissions',7,'C:31:\"Symfony\\Component\\Routing\\Route\":964:{a:9:{s:4:\"path\";s:25:\"/admin/people/permissions\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\user\\Form\\UserPermissionsForm\";s:6:\"_title\";s:11:\"Permissions\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer permissions\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":372:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/people/permissions$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/people/permissions\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/people/permissions\";s:8:\"numParts\";i:3;}}}}',3),

('user.cancel_confirm','/user/{user}/cancel/confirm/{timestamp}/{hashed_pass}','/user/%/cancel/confirm',11,'C:31:\"Symfony\\Component\\Routing\\Route\":1642:{a:9:{s:4:\"path\";s:53:\"/user/{user}/cancel/confirm/{timestamp}/{hashed_pass}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:6:\"_title\";s:28:\"Confirm account cancellation\";s:11:\"_controller\";s:53:\"\\Drupal\\user\\Controller\\UserController::confirmCancel\";s:9:\"timestamp\";i:0;s:11:\"hashed_pass\";s:0:\"\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"user.delete\";s:4:\"user\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":835:{a:11:{s:4:\"vars\";a:3:{i:0;s:4:\"user\";i:1;s:9:\"timestamp\";i:2;s:11:\"hashed_pass\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/user/(?P<user>\\d+)/cancel/confirm(?:/(?P<timestamp>[^/]++)(?:/(?P<hashed_pass>[^/]++))?)?$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"hashed_pass\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"timestamp\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/cancel/confirm\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:3:{i:0;s:4:\"user\";i:1;s:9:\"timestamp\";i:2;s:11:\"hashed_pass\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:22:\"/user/%/cancel/confirm\";s:8:\"numParts\";i:6;}}}}',6),

('user.login','/user/login','/user/login',3,'C:31:\"Symfony\\Component\\Routing\\Route\":899:{a:9:{s:4:\"path\";s:11:\"/user/login\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"\\Drupal\\user\\Form\\UserLoginForm\";s:6:\"_title\";s:6:\"Log in\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:5:\"FALSE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":330:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/user/login$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/login\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/user/login\";s:8:\"numParts\";i:2;}}}}',2),

('user.login.http','/user/login','/user/login',3,'C:31:\"Symfony\\Component\\Routing\\Route\":902:{a:9:{s:4:\"path\";s:11:\"/user/login\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:59:\"\\Drupal\\user\\Controller\\UserAuthenticationController::login\";}s:12:\"requirements\";a:2:{s:18:\"_user_is_logged_in\";s:5:\"FALSE\";s:7:\"_format\";s:17:\"json|hal_json|xml\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":330:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/user/login$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/login\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/user/login\";s:8:\"numParts\";i:2;}}}}',2),

('user.login_status.http','/user/login_status','/user/login_status',3,'C:31:\"Symfony\\Component\\Routing\\Route\":912:{a:9:{s:4:\"path\";s:18:\"/user/login_status\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:65:\"\\Drupal\\user\\Controller\\UserAuthenticationController::loginStatus\";}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:17:\"json|hal_json|xml\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:3:\"GET\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":351:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/user/login_status$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/user/login_status\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:18:\"/user/login_status\";s:8:\"numParts\";i:2;}}}}',2),

('user.logout','/user/logout','/user/logout',3,'C:31:\"Symfony\\Component\\Routing\\Route\":867:{a:9:{s:4:\"path\";s:12:\"/user/logout\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:46:\"\\Drupal\\user\\Controller\\UserController::logout\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":333:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/user/logout$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/user/logout\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/user/logout\";s:8:\"numParts\";i:2;}}}}',2),

('user.logout.http','/user/logout','/user/logout',3,'C:31:\"Symfony\\Component\\Routing\\Route\":965:{a:9:{s:4:\"path\";s:12:\"/user/logout\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:60:\"\\Drupal\\user\\Controller\\UserAuthenticationController::logout\";}s:12:\"requirements\";a:3:{s:18:\"_user_is_logged_in\";s:4:\"TRUE\";s:7:\"_format\";s:17:\"json|hal_json|xml\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:30:\"access_check.user.login_status\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":333:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/user/logout$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/user/logout\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/user/logout\";s:8:\"numParts\";i:2;}}}}',2),

('user.multiple_cancel_confirm','/admin/people/cancel','/admin/people/cancel',7,'C:31:\"Symfony\\Component\\Routing\\Route\":944:{a:9:{s:4:\"path\";s:20:\"/admin/people/cancel\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"\\Drupal\\user\\Form\\UserMultipleCancelConfirm\";s:6:\"_title\";s:11:\"Cancel user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer users\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":357:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/people/cancel$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/people/cancel\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/people/cancel\";s:8:\"numParts\";i:3;}}}}',3),

('user.page','/user','/user',1,'C:31:\"Symfony\\Component\\Routing\\Route\":869:{a:9:{s:4:\"path\";s:5:\"/user\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\user\\Controller\\UserController::userPage\";s:6:\"_title\";s:10:\"My account\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":310:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:12:\"#^/user$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:5:\"/user\";s:8:\"numParts\";i:1;}}}}',1),

('user.pass','/user/password','/user/password',3,'C:31:\"Symfony\\Component\\Routing\\Route\":905:{a:9:{s:4:\"path\";s:14:\"/user/password\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:34:\"\\Drupal\\user\\Form\\UserPasswordForm\";s:6:\"_title\";s:19:\"Reset your password\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":339:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/user/password$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/user/password\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/user/password\";s:8:\"numParts\";i:2;}}}}',2),

('user.pass.http','/user/password','/user/password',3,'C:31:\"Symfony\\Component\\Routing\\Route\":899:{a:9:{s:4:\"path\";s:14:\"/user/password\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:67:\"\\Drupal\\user\\Controller\\UserAuthenticationController::resetPassword\";}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:17:\"json|hal_json|xml\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":339:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/user/password$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/user/password\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/user/password\";s:8:\"numParts\";i:2;}}}}',2),

('user.register','/user/register','/user/register',3,'C:31:\"Symfony\\Component\\Routing\\Route\":881:{a:9:{s:4:\"path\";s:14:\"/user/register\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"user.register\";s:6:\"_title\";s:18:\"Create new account\";}s:12:\"requirements\";a:1:{s:21:\"_access_user_register\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.user.register\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":339:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/user/register$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/user/register\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/user/register\";s:8:\"numParts\";i:2;}}}}',2),

('user.reset','/user/reset/{uid}/{timestamp}/{hash}','/user/reset/%/%/%',24,'C:31:\"Symfony\\Component\\Routing\\Route\":1361:{a:9:{s:4:\"path\";s:36:\"/user/reset/{uid}/{timestamp}/{hash}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\user\\Controller\\UserController::resetPass\";s:6:\"_title\";s:14:\"Reset password\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:8:\"no_cache\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":737:{a:11:{s:4:\"vars\";a:3:{i:0;s:3:\"uid\";i:1;s:9:\"timestamp\";i:2;s:4:\"hash\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:73:\"#^/user/reset/(?P<uid>[^/]++)/(?P<timestamp>[^/]++)/(?P<hash>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"hash\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"timestamp\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"uid\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/reset\";}}s:9:\"path_vars\";a:3:{i:0;s:3:\"uid\";i:1;s:9:\"timestamp\";i:2;s:4:\"hash\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:24;s:14:\"patternOutline\";s:17:\"/user/reset/%/%/%\";s:8:\"numParts\";i:5;}}}}',5),

('user.reset.form','/user/reset/{uid}','/user/reset/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1091:{a:9:{s:4:\"path\";s:17:\"/user/reset/{uid}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:56:\"\\Drupal\\user\\Controller\\UserController::getResetPassForm\";s:6:\"_title\";s:14:\"Reset password\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:5:\"FALSE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:8:\"no_cache\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":456:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"uid\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/user/reset/(?P<uid>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"uid\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/reset\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"uid\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:13:\"/user/reset/%\";s:8:\"numParts\";i:3;}}}}',3),

('user.reset.login','/user/reset/{uid}/{timestamp}/{hash}/login','/user/reset/%/%/%/login',49,'C:31:\"Symfony\\Component\\Routing\\Route\":1449:{a:9:{s:4:\"path\";s:42:\"/user/reset/{uid}/{timestamp}/{hash}/login\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\user\\Controller\\UserController::resetPassLogin\";s:6:\"_title\";s:14:\"Reset password\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:5:\"FALSE\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:8:\"no_cache\";b:1;s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":791:{a:11:{s:4:\"vars\";a:3:{i:0;s:3:\"uid\";i:1;s:9:\"timestamp\";i:2;s:4:\"hash\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/user/reset/(?P<uid>[^/]++)/(?P<timestamp>[^/]++)/(?P<hash>[^/]++)/login$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/login\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"hash\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"timestamp\";i:4;b:1;}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"uid\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/reset\";}}s:9:\"path_vars\";a:3:{i:0;s:3:\"uid\";i:1;s:9:\"timestamp\";i:2;s:4:\"hash\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:49;s:14:\"patternOutline\";s:23:\"/user/reset/%/%/%/login\";s:8:\"numParts\";i:6;}}}}',6),

('user.role_add','/admin/people/roles/add','/admin/people/roles/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":941:{a:9:{s:4:\"path\";s:23:\"/admin/people/roles/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"user_role.default\";s:6:\"_title\";s:8:\"Add role\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer permissions\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":367:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/admin/people/roles/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/admin/people/roles/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:23:\"/admin/people/roles/add\";s:8:\"numParts\";i:4;}}}}',4),

('view.block_content.page_1','/admin/structure/block/block-content','/admin/structure/block/block-content',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1388:{a:9:{s:4:\"path\";s:36:\"/admin/structure/block/block-content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:20:\"Custom block library\";s:7:\"view_id\";s:13:\"block_content\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer blocks\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":407:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/structure/block/block\\-content$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/structure/block/block-content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:36:\"/admin/structure/block/block-content\";s:8:\"numParts\";i:4;}}}}',4),

('view.blog_fullwidth.page_1','/blog-fullwidth','/blog-fullwidth',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1271:{a:9:{s:4:\"path\";s:15:\"/blog-fullwidth\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:14:\"Blog Fullwidth\";s:7:\"view_id\";s:14:\"blog_fullwidth\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":343:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/blog\\-fullwidth$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/blog-fullwidth\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:15:\"/blog-fullwidth\";s:8:\"numParts\";i:1;}}}}',1),

('view.blog_grid.page_1','/blog-2-columns','/blog-2-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1260:{a:9:{s:4:\"path\";s:15:\"/blog-2-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:9:\"Blog Grid\";s:7:\"view_id\";s:9:\"blog_grid\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":344:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/blog\\-2\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/blog-2-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:15:\"/blog-2-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.blog_grid.page_2','/blog-3-columns','/blog-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1260:{a:9:{s:4:\"path\";s:15:\"/blog-3-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:9:\"Blog Grid\";s:7:\"view_id\";s:9:\"blog_grid\";s:10:\"display_id\";s:6:\"page_2\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":344:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/blog\\-3\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/blog-3-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:15:\"/blog-3-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.blog_grid.page_3','/blog-4-columns','/blog-4-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1260:{a:9:{s:4:\"path\";s:15:\"/blog-4-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:9:\"Blog Grid\";s:7:\"view_id\";s:9:\"blog_grid\";s:10:\"display_id\";s:6:\"page_3\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":344:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/blog\\-4\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/blog-4-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:15:\"/blog-4-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.blog_grid.page_4','/blog-3-items','/blog-3-items',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1250:{a:9:{s:4:\"path\";s:13:\"/blog-3-items\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:7:\"3 Items\";s:7:\"view_id\";s:9:\"blog_grid\";s:10:\"display_id\";s:6:\"page_4\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:22:\"#^/blog\\-3\\-items$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/blog-3-items\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:13:\"/blog-3-items\";s:8:\"numParts\";i:1;}}}}',1),

('view.blog_masonry.page_1','/blog-masonry-2-columns','/blog-masonry-2-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1297:{a:9:{s:4:\"path\";s:23:\"/blog-masonry-2-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:9:\"Blog Grid\";s:7:\"view_id\";s:12:\"blog_masonry\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/blog\\-masonry\\-2\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/blog-masonry-2-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:23:\"/blog-masonry-2-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.blog_masonry.page_2','/blog-masonry-3-columns','/blog-masonry-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1297:{a:9:{s:4:\"path\";s:23:\"/blog-masonry-3-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:9:\"Blog Grid\";s:7:\"view_id\";s:12:\"blog_masonry\";s:10:\"display_id\";s:6:\"page_2\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/blog\\-masonry\\-3\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/blog-masonry-3-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:23:\"/blog-masonry-3-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.blog_masonry.page_3','/blog-masonry-4-columns','/blog-masonry-4-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1297:{a:9:{s:4:\"path\";s:23:\"/blog-masonry-4-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:9:\"Blog Grid\";s:7:\"view_id\";s:12:\"blog_masonry\";s:10:\"display_id\";s:6:\"page_3\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/blog\\-masonry\\-4\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/blog-masonry-4-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:23:\"/blog-masonry-4-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.blog_timeline.page_1','/blog-timeline','/blog-timeline',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1266:{a:9:{s:4:\"path\";s:14:\"/blog-timeline\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:14:\"Blog Fullwidth\";s:7:\"view_id\";s:13:\"blog_timeline\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":340:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:22:\"#^/blog\\-timeline$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/blog-timeline\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:14:\"/blog-timeline\";s:8:\"numParts\";i:1;}}}}',1),

('view.comment.page_published','/admin/content/comment','/admin/content/comment',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1321:{a:9:{s:4:\"path\";s:22:\"/admin/content/comment\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Comments\";s:7:\"view_id\";s:7:\"comment\";s:10:\"display_id\";s:14:\"page_published\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"administer comments\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/content/comment$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/content/comment\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/content/comment\";s:8:\"numParts\";i:3;}}}}',3),

('view.comment.page_unapproved','/admin/content/comment/approval','/admin/content/comment/approval',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1359:{a:9:{s:4:\"path\";s:31:\"/admin/content/comment/approval\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Comments\";s:7:\"view_id\";s:7:\"comment\";s:10:\"display_id\";s:15:\"page_unapproved\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"administer comments\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/content/comment/approval$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/content/comment/approval\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/content/comment/approval\";s:8:\"numParts\";i:4;}}}}',4),

('view.commerce_carts.page_1','/admin/commerce/orders/carts','/admin/commerce/orders/carts',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1353:{a:9:{s:4:\"path\";s:28:\"/admin/commerce/orders/carts\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:5:\"Carts\";s:7:\"view_id\";s:14:\"commerce_carts\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:30:\"access commerce_order overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/commerce/orders/carts$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/commerce/orders/carts\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/commerce/orders/carts\";s:8:\"numParts\";i:4;}}}}',4),

('view.commerce_orders.page_1','/admin/commerce/orders','/admin/commerce/orders',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1330:{a:9:{s:4:\"path\";s:22:\"/admin/commerce/orders\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:6:\"Orders\";s:7:\"view_id\";s:15:\"commerce_orders\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:30:\"access commerce_order overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":363:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/commerce/orders$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/commerce/orders\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/commerce/orders\";s:8:\"numParts\";i:3;}}}}',3),

('view.commerce_products.page_1','/admin/commerce/products','/admin/commerce/products',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1344:{a:9:{s:4:\"path\";s:24:\"/admin/commerce/products\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Products\";s:7:\"view_id\";s:17:\"commerce_products\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:32:\"access commerce_product overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":369:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/commerce/products$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/commerce/products\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/commerce/products\";s:8:\"numParts\";i:3;}}}}',3),

('view.commerce_stores.page_1','/admin/commerce/config/stores','/admin/commerce/config/stores',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1359:{a:9:{s:4:\"path\";s:29:\"/admin/commerce/config/stores\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:6:\"Stores\";s:7:\"view_id\";s:15:\"commerce_stores\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:30:\"access commerce_store overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/commerce/config/stores$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/commerce/config/stores\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/commerce/config/stores\";s:8:\"numParts\";i:4;}}}}',4),

('view.commerce_user_orders.order_page','/user/{user}/orders','/user/%/orders',5,'C:31:\"Symfony\\Component\\Routing\\Route\":1464:{a:9:{s:4:\"path\";s:19:\"/user/{user}/orders\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:6:\"Orders\";s:7:\"view_id\";s:20:\"commerce_user_orders\";s:10:\"display_id\";s:10:\"order_page\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:23:\"view own commerce_order\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:4:\"user\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":498:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/user/(?P<user>[^/]++)/orders$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/orders\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:14:\"/user/%/orders\";s:8:\"numParts\";i:3;}}}}',3),

('view.content.page_1','/admin/content','/admin/content',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1283:{a:9:{s:4:\"path\";s:14:\"/admin/content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:7:\"Content\";s:7:\"view_id\";s:7:\"content\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:0;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:23:\"access content overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:0;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":339:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/admin/content$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/content\";s:8:\"numParts\";i:2;}}}}',2),

('view.files.page_1','/admin/content/files','/admin/content/files',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1301:{a:9:{s:4:\"path\";s:20:\"/admin/content/files\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:5:\"Files\";s:7:\"view_id\";s:5:\"files\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:21:\"access files overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":357:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/content/files$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/content/files\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/content/files\";s:8:\"numParts\";i:3;}}}}',3),

('view.files.page_2','/admin/content/files/usage/{arg_0}','/admin/content/files/usage/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1498:{a:9:{s:4:\"path\";s:34:\"/admin/content/files/usage/{arg_0}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:10:\"File usage\";s:7:\"view_id\";s:5:\"files\";s:10:\"display_id\";s:6:\"page_2\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:21:\"access files overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":510:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/admin/content/files/usage/(?P<arg_0>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/content/files/usage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:28:\"/admin/content/files/usage/%\";s:8:\"numParts\";i:5;}}}}',5),

('view.frontpage.feed_1','/rss.xml','/rss.xml',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1194:{a:9:{s:4:\"path\";s:8:\"/rss.xml\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:9:\"frontpage\";s:10:\"display_id\";s:6:\"feed_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"feed\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Feed\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":320:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:16:\"#^/rss\\.xml$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/rss.xml\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:8:\"/rss.xml\";s:8:\"numParts\";i:1;}}}}',1),

('view.frontpage.page_1','/node','/node',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1206:{a:9:{s:4:\"path\";s:5:\"/node\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:9:\"frontpage\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":310:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:12:\"#^/node$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:5:\"/node\";s:8:\"numParts\";i:1;}}}}',1),

('view.gallery.page_1','/gallery','/gallery',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1237:{a:9:{s:4:\"path\";s:8:\"/gallery\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:20:\"GalleryGallery Col 1\";s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":319:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:15:\"#^/gallery$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/gallery\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:8:\"/gallery\";s:8:\"numParts\";i:1;}}}}',1),

('view.gallery.page_2','/gallery-col-2','/gallery-col-2',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1259:{a:9:{s:4:\"path\";s:14:\"/gallery-col-2\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:13:\"Gallery Col 2\";s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_2\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":341:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/gallery\\-col\\-2$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/gallery-col-2\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:14:\"/gallery-col-2\";s:8:\"numParts\";i:1;}}}}',1),

('view.gallery.page_3','/gallery-col-3','/gallery-col-3',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1259:{a:9:{s:4:\"path\";s:14:\"/gallery-col-3\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:13:\"Gallery Col 3\";s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_3\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":341:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/gallery\\-col\\-3$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/gallery-col-3\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:14:\"/gallery-col-3\";s:8:\"numParts\";i:1;}}}}',1),

('view.gallery.page_4','/gallery-col-4','/gallery-col-4',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1259:{a:9:{s:4:\"path\";s:14:\"/gallery-col-4\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:13:\"Gallery Col 4\";s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_4\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":341:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/gallery\\-col\\-4$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/gallery-col-4\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:14:\"/gallery-col-4\";s:8:\"numParts\";i:1;}}}}',1),

('view.gallery.page_5','/gallery-col-6','/gallery-col-6',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1259:{a:9:{s:4:\"path\";s:14:\"/gallery-col-6\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:13:\"Gallery Col 6\";s:7:\"view_id\";s:7:\"gallery\";s:10:\"display_id\";s:6:\"page_5\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":341:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/gallery\\-col\\-6$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/gallery-col-6\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:14:\"/gallery-col-6\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_1','/portfolio-boxed','/portfolio-boxed',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1278:{a:9:{s:4:\"path\";s:16:\"/portfolio-boxed\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:16:\"Boxed: 2 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":346:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/portfolio\\-boxed$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/portfolio-boxed\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:16:\"/portfolio-boxed\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_10','/portfolio-boxed-gutter-5-black-columns','/portfolio-boxed-gutter-5-black-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1388:{a:9:{s:4:\"path\";s:39:\"/portfolio-boxed-gutter-5-black-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:29:\"Boxed Gutter: 5 Columns Black\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_10\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":419:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/portfolio\\-boxed\\-gutter\\-5\\-black\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/portfolio-boxed-gutter-5-black-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:39:\"/portfolio-boxed-gutter-5-black-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_11','/portfolio-boxed-title-2-columns','/portfolio-boxed-title-2-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:32:\"/portfolio-boxed-title-2-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:22:\"Boxed Title: 2 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_11\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/portfolio\\-boxed\\-title\\-2\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/portfolio-boxed-title-2-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:32:\"/portfolio-boxed-title-2-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_12','/portfolio-boxed-title-3-columns','/portfolio-boxed-title-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:32:\"/portfolio-boxed-title-3-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:22:\"Boxed Title: 3 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_12\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/portfolio\\-boxed\\-title\\-3\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/portfolio-boxed-title-3-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:32:\"/portfolio-boxed-title-3-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_13','/portfolio-boxed-title-4-columns','/portfolio-boxed-title-4-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:32:\"/portfolio-boxed-title-4-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:22:\"Boxed Title: 4 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_13\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/portfolio\\-boxed\\-title\\-4\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/portfolio-boxed-title-4-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:32:\"/portfolio-boxed-title-4-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_14','/portfolio-boxed-title-5-columns','/portfolio-boxed-title-5-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:32:\"/portfolio-boxed-title-5-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:22:\"Boxed Title: 5 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_14\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/portfolio\\-boxed\\-title\\-5\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/portfolio-boxed-title-5-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:32:\"/portfolio-boxed-title-5-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_15','/portfolio-boxed-title-5-columns-black','/portfolio-boxed-title-5-columns-black',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1383:{a:9:{s:4:\"path\";s:38:\"/portfolio-boxed-title-5-columns-black\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:28:\"Boxed Title: 5 Columns Black\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_15\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":416:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/portfolio\\-boxed\\-title\\-5\\-columns\\-black$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/portfolio-boxed-title-5-columns-black\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:38:\"/portfolio-boxed-title-5-columns-black\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_16','/portfolio-boxed-wide-2-columns','/portfolio-boxed-wide-2-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:31:\"/portfolio-boxed-wide-2-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:21:\"Boxed Wide: 2 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_16\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/portfolio\\-boxed\\-wide\\-2\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/portfolio-boxed-wide-2-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:31:\"/portfolio-boxed-wide-2-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_17','/portfolio-boxed-wide-3-columns','/portfolio-boxed-wide-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:31:\"/portfolio-boxed-wide-3-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:21:\"Boxed Wide: 3 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_17\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/portfolio\\-boxed\\-wide\\-3\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/portfolio-boxed-wide-3-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:31:\"/portfolio-boxed-wide-3-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_18','/portfolio-boxed-wide-4-columns','/portfolio-boxed-wide-4-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:31:\"/portfolio-boxed-wide-4-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:21:\"Boxed Wide: 4 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_18\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/portfolio\\-boxed\\-wide\\-4\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/portfolio-boxed-wide-4-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:31:\"/portfolio-boxed-wide-4-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_19','/portfolio-boxed-wide-5-columns','/portfolio-boxed-wide-5-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:31:\"/portfolio-boxed-wide-5-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:21:\"Boxed Wide: 5 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_19\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/portfolio\\-boxed\\-wide\\-5\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/portfolio-boxed-wide-5-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:31:\"/portfolio-boxed-wide-5-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_2','/portfolio-boxed-3-columns','/portfolio-boxed-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1320:{a:9:{s:4:\"path\";s:26:\"/portfolio-boxed-3-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:16:\"Boxed: 3 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:6:\"page_2\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":378:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/portfolio\\-boxed\\-3\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/portfolio-boxed-3-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:26:\"/portfolio-boxed-3-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_20','/portfolio-boxed-wide-5-columns-dark','/portfolio-boxed-wide-5-columns-dark',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1373:{a:9:{s:4:\"path\";s:36:\"/portfolio-boxed-wide-5-columns-dark\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:26:\"Boxed Wide: 5 Columns Dark\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_20\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":410:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/portfolio\\-boxed\\-wide\\-5\\-columns\\-dark$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/portfolio-boxed-wide-5-columns-dark\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:36:\"/portfolio-boxed-wide-5-columns-dark\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_21','/portfolio-gutter-wide-2-columns','/portfolio-gutter-wide-2-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:32:\"/portfolio-gutter-wide-2-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:22:\"Gutter Wide: 2 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_21\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/portfolio\\-gutter\\-wide\\-2\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/portfolio-gutter-wide-2-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:32:\"/portfolio-gutter-wide-2-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_22','/portfolio-gutter-wide-3-columns','/portfolio-gutter-wide-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:32:\"/portfolio-gutter-wide-3-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:22:\"Gutter Wide: 3 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_22\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/portfolio\\-gutter\\-wide\\-3\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/portfolio-gutter-wide-3-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:32:\"/portfolio-gutter-wide-3-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_23','/portfolio-gutter-wide-4-columns','/portfolio-gutter-wide-4-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:32:\"/portfolio-gutter-wide-4-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:22:\"Gutter Wide: 4 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_23\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/portfolio\\-gutter\\-wide\\-4\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/portfolio-gutter-wide-4-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:32:\"/portfolio-gutter-wide-4-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_24','/portfolio-gutter-wide-5-columns','/portfolio-gutter-wide-5-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:32:\"/portfolio-gutter-wide-5-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:22:\"Gutter Wide: 5 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_24\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/portfolio\\-gutter\\-wide\\-5\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/portfolio-gutter-wide-5-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:32:\"/portfolio-gutter-wide-5-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_25','/portfolio-gutter-wide-5-columns-dark','/portfolio-gutter-wide-5-columns-dark',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1378:{a:9:{s:4:\"path\";s:37:\"/portfolio-gutter-wide-5-columns-dark\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:27:\"Gutter Wide: 5 Columns Dark\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_25\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":413:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:49:\"#^/portfolio\\-gutter\\-wide\\-5\\-columns\\-dark$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/portfolio-gutter-wide-5-columns-dark\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:37:\"/portfolio-gutter-wide-5-columns-dark\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_26','/portfolio-title-wide-2-columns','/portfolio-title-wide-2-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:31:\"/portfolio-title-wide-2-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:21:\"Wide Title: 2 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_26\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/portfolio\\-title\\-wide\\-2\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/portfolio-title-wide-2-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:31:\"/portfolio-title-wide-2-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_27','/portfolio-title-wide-3-columns','/portfolio-title-wide-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:31:\"/portfolio-title-wide-3-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:21:\"Wide Title: 3 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_27\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/portfolio\\-title\\-wide\\-3\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/portfolio-title-wide-3-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:31:\"/portfolio-title-wide-3-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_28','/portfolio-title-wide-4-columns','/portfolio-title-wide-4-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:31:\"/portfolio-title-wide-4-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:21:\"Wide Title: 4 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_28\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/portfolio\\-title\\-wide\\-4\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/portfolio-title-wide-4-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:31:\"/portfolio-title-wide-4-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_29','/portfolio-title-wide-5-columns','/portfolio-title-wide-5-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:31:\"/portfolio-title-wide-5-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:21:\"Wide Title: 5 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_29\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/portfolio\\-title\\-wide\\-5\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/portfolio-title-wide-5-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:31:\"/portfolio-title-wide-5-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_3','/portfolio-boxed-4-columns','/portfolio-boxed-4-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1320:{a:9:{s:4:\"path\";s:26:\"/portfolio-boxed-4-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:16:\"Boxed: 4 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:6:\"page_3\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":378:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/portfolio\\-boxed\\-4\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/portfolio-boxed-4-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:26:\"/portfolio-boxed-4-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_30','/portfolio-title-wide-5-columns-dark','/portfolio-title-wide-5-columns-dark',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1373:{a:9:{s:4:\"path\";s:36:\"/portfolio-title-wide-5-columns-dark\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:26:\"Wide Title: 5 Columns Dark\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_30\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":410:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/portfolio\\-title\\-wide\\-5\\-columns\\-dark$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/portfolio-title-wide-5-columns-dark\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:36:\"/portfolio-title-wide-5-columns-dark\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_31','/portfolio-masonry-2-columns','/portfolio-masonry-2-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1327:{a:9:{s:4:\"path\";s:28:\"/portfolio-masonry-2-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:14:\"Masonry: 2 Col\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_31\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/portfolio\\-masonry\\-2\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/portfolio-masonry-2-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:28:\"/portfolio-masonry-2-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_32','/portfolio-masonry-3-columns','/portfolio-masonry-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1327:{a:9:{s:4:\"path\";s:28:\"/portfolio-masonry-3-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:14:\"Masonry: 3 Col\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_32\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/portfolio\\-masonry\\-3\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/portfolio-masonry-3-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:28:\"/portfolio-masonry-3-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_33','/portfolio-masonry-4-columns','/portfolio-masonry-4-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1327:{a:9:{s:4:\"path\";s:28:\"/portfolio-masonry-4-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:14:\"Masonry: 4 Col\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_33\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/portfolio\\-masonry\\-4\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/portfolio-masonry-4-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:28:\"/portfolio-masonry-4-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_34','/portfolio-masonry-5-columns','/portfolio-masonry-5-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1327:{a:9:{s:4:\"path\";s:28:\"/portfolio-masonry-5-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:14:\"Masonry: 5 Col\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_34\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/portfolio\\-masonry\\-5\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/portfolio-masonry-5-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:28:\"/portfolio-masonry-5-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_35','/portfolio-masonry-5-columns-dark','/portfolio-masonry-5-columns-dark',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1353:{a:9:{s:4:\"path\";s:33:\"/portfolio-masonry-5-columns-dark\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:19:\"Masonry: 5 Col Dark\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:7:\"page_35\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/portfolio\\-masonry\\-5\\-columns\\-dark$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/portfolio-masonry-5-columns-dark\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:33:\"/portfolio-masonry-5-columns-dark\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_4','/portfolio-boxed-5-columns','/portfolio-boxed-5-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1320:{a:9:{s:4:\"path\";s:26:\"/portfolio-boxed-5-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:16:\"Boxed: 5 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:6:\"page_4\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":378:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/portfolio\\-boxed\\-5\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/portfolio-boxed-5-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:26:\"/portfolio-boxed-5-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_5','/portfolio-boxed-gutter-2-columns','/portfolio-boxed-gutter-2-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1356:{a:9:{s:4:\"path\";s:33:\"/portfolio-boxed-gutter-2-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:23:\"Boxed Gutter: 2 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:6:\"page_5\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/portfolio\\-boxed\\-gutter\\-2\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/portfolio-boxed-gutter-2-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:33:\"/portfolio-boxed-gutter-2-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_6','/portfolio-boxed-gutter-3-columns','/portfolio-boxed-gutter-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1356:{a:9:{s:4:\"path\";s:33:\"/portfolio-boxed-gutter-3-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:23:\"Boxed Gutter: 3 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:6:\"page_6\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/portfolio\\-boxed\\-gutter\\-3\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/portfolio-boxed-gutter-3-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:33:\"/portfolio-boxed-gutter-3-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_7','/portfolio-boxed-gutter-4-columns','/portfolio-boxed-gutter-4-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1356:{a:9:{s:4:\"path\";s:33:\"/portfolio-boxed-gutter-4-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:23:\"Boxed Gutter: 4 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:6:\"page_7\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/portfolio\\-boxed\\-gutter\\-4\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/portfolio-boxed-gutter-4-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:33:\"/portfolio-boxed-gutter-4-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_8','/portfolio-boxed-gutter-5-columns','/portfolio-boxed-gutter-5-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1356:{a:9:{s:4:\"path\";s:33:\"/portfolio-boxed-gutter-5-columns\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:23:\"Boxed Gutter: 5 Columns\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:6:\"page_8\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/portfolio\\-boxed\\-gutter\\-5\\-columns$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/portfolio-boxed-gutter-5-columns\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:33:\"/portfolio-boxed-gutter-5-columns\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_boxed.page_9','/portfolio-boxed-5-columns-black','/portfolio-boxed-5-columns-black',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1351:{a:9:{s:4:\"path\";s:32:\"/portfolio-boxed-5-columns-black\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:22:\"Boxed: 5 Columns Black\";s:7:\"view_id\";s:15:\"portfolio_boxed\";s:10:\"display_id\";s:6:\"page_9\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/portfolio\\-boxed\\-5\\-columns\\-black$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/portfolio-boxed-5-columns-black\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:32:\"/portfolio-boxed-5-columns-black\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_parallax.page_1','/portfolio-parallax','/portfolio-parallax',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1295:{a:9:{s:4:\"path\";s:19:\"/portfolio-parallax\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:18:\"Portfolio Parallax\";s:7:\"view_id\";s:18:\"portfolio_parallax\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":355:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/portfolio\\-parallax$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/portfolio-parallax\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:19:\"/portfolio-parallax\";s:8:\"numParts\";i:1;}}}}',1),

('view.portfolio_promo.page_1','/portfolio-promo','/portfolio-promo',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1277:{a:9:{s:4:\"path\";s:16:\"/portfolio-promo\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:15:\"Portfolio Promo\";s:7:\"view_id\";s:15:\"portfolio_promo\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":346:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/portfolio\\-promo$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/portfolio-promo\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:16:\"/portfolio-promo\";s:8:\"numParts\";i:1;}}}}',1),

('view.shop_columns.page','/shop-2-columns/{arg_0}','/shop-2-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1432:{a:9:{s:4:\"path\";s:23:\"/shop-2-columns/{arg_0}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:6:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:14:\"Shop 2 Columns\";s:7:\"view_id\";s:12:\"shop_columns\";s:10:\"display_id\";s:4:\"page\";s:30:\"_view_display_show_admin_links\";b:1;s:5:\"arg_0\";N;}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":481:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/shop\\-2\\-columns(?:/(?P<arg_0>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/shop-2-columns\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:15:\"/shop-2-columns\";s:8:\"numParts\";i:2;}}}}',2),

('view.shop_columns.page_1','/shop-3-columns/{arg_0}','/shop-3-columns',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1434:{a:9:{s:4:\"path\";s:23:\"/shop-3-columns/{arg_0}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:6:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:14:\"Shop 3 Columns\";s:7:\"view_id\";s:12:\"shop_columns\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;s:5:\"arg_0\";N;}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":481:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/shop\\-3\\-columns(?:/(?P<arg_0>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/shop-3-columns\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:15:\"/shop-3-columns\";s:8:\"numParts\";i:2;}}}}',2),

('view.shop_columns.page_2','/4-columns-shop/{arg_0}','/4-columns-shop',1,'C:31:\"Symfony\\Component\\Routing\\Route\":1434:{a:9:{s:4:\"path\";s:23:\"/4-columns-shop/{arg_0}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:6:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:14:\"Shop 4 Columns\";s:7:\"view_id\";s:12:\"shop_columns\";s:10:\"display_id\";s:6:\"page_2\";s:30:\"_view_display_show_admin_links\";b:1;s:5:\"arg_0\";N;}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":481:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/4\\-columns\\-shop(?:/(?P<arg_0>[^/]++))?$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/4-columns-shop\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:15:\"/4-columns-shop\";s:8:\"numParts\";i:2;}}}}',2),

('view.taxonomy_term.feed_1','/taxonomy/term/{arg_0}/feed','/taxonomy/term/%/feed',13,'C:31:\"Symfony\\Component\\Routing\\Route\":1448:{a:9:{s:4:\"path\";s:27:\"/taxonomy/term/{arg_0}/feed\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:13:\"taxonomy_term\";s:10:\"display_id\";s:6:\"feed_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"feed\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Feed\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":525:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/taxonomy/term/(?P<arg_0>[^/]++)/feed$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/feed\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:21:\"/taxonomy/term/%/feed\";s:8:\"numParts\";i:4;}}}}',4),

('view.taxonomy_term.page_1','/taxonomy/term/{arg_0}','/taxonomy/term/%',6,'C:31:\"Symfony\\Component\\Routing\\Route\":1416:{a:9:{s:4:\"path\";s:22:\"/taxonomy/term/{arg_0}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:13:\"taxonomy_term\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":473:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/taxonomy/term/(?P<arg_0>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:16:\"/taxonomy/term/%\";s:8:\"numParts\";i:3;}}}}',3),

('view.user_admin_people.page_1','/admin/people','/admin/people',3,'C:31:\"Symfony\\Component\\Routing\\Route\":1282:{a:9:{s:4:\"path\";s:13:\"/admin/people\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:6:\"People\";s:7:\"view_id\";s:17:\"user_admin_people\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:0;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:16:\"administer users\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:0;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":336:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/admin/people$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/admin/people\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/admin/people\";s:8:\"numParts\";i:2;}}}}',2),

('view.watchdog.page','/admin/reports/dblog','/admin/reports/dblog',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1315:{a:9:{s:4:\"path\";s:20:\"/admin/reports/dblog\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:19:\"Recent log messages\";s:7:\"view_id\";s:8:\"watchdog\";s:10:\"display_id\";s:4:\"page\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"access site reports\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:9:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}s:4:\"utf8\";b:1;}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":357:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/reports/dblog$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/reports/dblog\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/reports/dblog\";s:8:\"numParts\";i:3;}}}}',3),

('views.ajax','/views/ajax','/views/ajax',3,'C:31:\"Symfony\\Component\\Routing\\Route\":848:{a:9:{s:4:\"path\";s:11:\"/views/ajax\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:53:\"\\Drupal\\views\\Controller\\ViewAjaxController::ajaxView\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":330:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/views/ajax$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/views/ajax\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/views/ajax\";s:8:\"numParts\";i:2;}}}}',2),

('views_ui.add','/admin/structure/views/add','/admin/structure/views/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":937:{a:9:{s:4:\"path\";s:26:\"/admin/structure/views/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:8:\"view.add\";s:6:\"_title\";s:8:\"Add view\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:4:\"view\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":376:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/structure/views/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/views/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/structure/views/add\";s:8:\"numParts\";i:4;}}}}',4),

('views_ui.autocomplete','/admin/views/ajax/autocomplete/tag','/admin/views/ajax/autocomplete/tag',31,'C:31:\"Symfony\\Component\\Routing\\Route\":995:{a:9:{s:4:\"path\";s:34:\"/admin/views/ajax/autocomplete/tag\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:62:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::autocompleteTag\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/admin/views/ajax/autocomplete/tag$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/views/ajax/autocomplete/tag\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:34:\"/admin/views/ajax/autocomplete/tag\";s:8:\"numParts\";i:5;}}}}',5),

('views_ui.form_add_handler','/admin/structure/views/{js}/add-handler/{view}/{display_id}/{type}','/admin/structure/views/%/add-handler/%/%/%',232,'C:31:\"Symfony\\Component\\Routing\\Route\":1783:{a:9:{s:4:\"path\";s:66:\"/admin/structure/views/{js}/add-handler/{view}/{display_id}/{type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:46:\"\\Drupal\\views_ui\\Form\\Ajax\\AddHandler::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":985:{a:11:{s:4:\"vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:117:\"#^/admin/structure/views/(?P<js>nojs|ajax)/add\\-handler/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/add-handler\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:232;s:14:\"patternOutline\";s:42:\"/admin/structure/views/%/add-handler/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),

('views_ui.form_analyze','/admin/structure/views/{js}/analyze/{view}/{display_id}','/admin/structure/views/%/analyze/%/%',116,'C:31:\"Symfony\\Component\\Routing\\Route\":1624:{a:9:{s:4:\"path\";s:55:\"/admin/structure/views/{js}/analyze/{view}/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:43:\"\\Drupal\\views_ui\\Form\\Ajax\\Analyze::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":840:{a:11:{s:4:\"vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:95:\"#^/admin/structure/views/(?P<js>nojs|ajax)/analyze/(?P<view>[^/]++)/(?P<display_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/analyze\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:116;s:14:\"patternOutline\";s:36:\"/admin/structure/views/%/analyze/%/%\";s:8:\"numParts\";i:7;}}}}',7),

('views_ui.form_display','/admin/structure/views/{js}/display/{view}/{display_id}/{type}','/admin/structure/views/%/display/%/%/%',232,'C:31:\"Symfony\\Component\\Routing\\Route\":1762:{a:9:{s:4:\"path\";s:62:\"/admin/structure/views/{js}/display/{view}/{display_id}/{type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:43:\"\\Drupal\\views_ui\\Form\\Ajax\\Display::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":971:{a:11:{s:4:\"vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:112:\"#^/admin/structure/views/(?P<js>nojs|ajax)/display/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:232;s:14:\"patternOutline\";s:38:\"/admin/structure/views/%/display/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),

('views_ui.form_edit_details','/admin/structure/views/{js}/edit-details/{view}/{display_id}','/admin/structure/views/%/edit-details/%/%',116,'C:31:\"Symfony\\Component\\Routing\\Route\":1651:{a:9:{s:4:\"path\";s:60:\"/admin/structure/views/{js}/edit-details/{view}/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:47:\"\\Drupal\\views_ui\\Form\\Ajax\\EditDetails::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":858:{a:11:{s:4:\"vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:101:\"#^/admin/structure/views/(?P<js>nojs|ajax)/edit\\-details/(?P<view>[^/]++)/(?P<display_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit-details\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:116;s:14:\"patternOutline\";s:41:\"/admin/structure/views/%/edit-details/%/%\";s:8:\"numParts\";i:7;}}}}',7),

('views_ui.form_handler','/admin/structure/views/{js}/handler/{view}/{display_id}/{type}/{id}','/admin/structure/views/%/handler/%/%/%/%',464,'C:31:\"Symfony\\Component\\Routing\\Route\":1896:{a:9:{s:4:\"path\";s:67:\"/admin/structure/views/{js}/handler/{view}/{display_id}/{type}/{id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:49:\"\\Drupal\\views_ui\\Form\\Ajax\\ConfigHandler::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1093:{a:11:{s:4:\"vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:127:\"#^/admin/structure/views/(?P<js>nojs|ajax)/handler/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)/(?P<id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:7:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/handler\";}i:5;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:6;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:464;s:14:\"patternOutline\";s:40:\"/admin/structure/views/%/handler/%/%/%/%\";s:8:\"numParts\";i:9;}}}}',9),

('views_ui.form_handler_extra','/admin/structure/views/{js}/handler-extra/{view}/{display_id}/{type}/{id}','/admin/structure/views/%/handler-extra/%/%/%/%',464,'C:31:\"Symfony\\Component\\Routing\\Route\":1927:{a:9:{s:4:\"path\";s:73:\"/admin/structure/views/{js}/handler-extra/{view}/{display_id}/{type}/{id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:54:\"\\Drupal\\views_ui\\Form\\Ajax\\ConfigHandlerExtra::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1113:{a:11:{s:4:\"vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:134:\"#^/admin/structure/views/(?P<js>nojs|ajax)/handler\\-extra/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)/(?P<id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:7:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/handler-extra\";}i:5;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:6;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:464;s:14:\"patternOutline\";s:46:\"/admin/structure/views/%/handler-extra/%/%/%/%\";s:8:\"numParts\";i:9;}}}}',9),

('views_ui.form_handler_group','/admin/structure/views/{js}/handler-group/{view}/{display_id}/{type}/{id}','/admin/structure/views/%/handler-group/%/%/%/%',464,'C:31:\"Symfony\\Component\\Routing\\Route\":1947:{a:9:{s:4:\"path\";s:73:\"/admin/structure/views/{js}/handler-group/{view}/{display_id}/{type}/{id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\views_ui\\Form\\Ajax\\ConfigHandlerGroup::getForm\";s:10:\"form_state\";N;}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1113:{a:11:{s:4:\"vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:134:\"#^/admin/structure/views/(?P<js>nojs|ajax)/handler\\-group/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)/(?P<id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:7:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/handler-group\";}i:5;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:6;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:464;s:14:\"patternOutline\";s:46:\"/admin/structure/views/%/handler-group/%/%/%/%\";s:8:\"numParts\";i:9;}}}}',9),

('views_ui.form_rearrange','/admin/structure/views/{js}/rearrange/{view}/{display_id}/{type}','/admin/structure/views/%/rearrange/%/%/%',232,'C:31:\"Symfony\\Component\\Routing\\Route\":1773:{a:9:{s:4:\"path\";s:64:\"/admin/structure/views/{js}/rearrange/{view}/{display_id}/{type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:45:\"\\Drupal\\views_ui\\Form\\Ajax\\Rearrange::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":978:{a:11:{s:4:\"vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:114:\"#^/admin/structure/views/(?P<js>nojs|ajax)/rearrange/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)$#sDu\";s:11:\"path_tokens\";a:6:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/rearrange\";}i:4;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:5;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:232;s:14:\"patternOutline\";s:40:\"/admin/structure/views/%/rearrange/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),

('views_ui.form_rearrange_filter','/admin/structure/views/{js}/rearrange-filter/{view}/{display_id}','/admin/structure/views/%/rearrange-filter/%/%',116,'C:31:\"Symfony\\Component\\Routing\\Route\":1671:{a:9:{s:4:\"path\";s:64:\"/admin/structure/views/{js}/rearrange-filter/{view}/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"\\Drupal\\views_ui\\Form\\Ajax\\RearrangeFilter::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":870:{a:11:{s:4:\"vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:105:\"#^/admin/structure/views/(?P<js>nojs|ajax)/rearrange\\-filter/(?P<view>[^/]++)/(?P<display_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/rearrange-filter\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:116;s:14:\"patternOutline\";s:45:\"/admin/structure/views/%/rearrange-filter/%/%\";s:8:\"numParts\";i:7;}}}}',7),

('views_ui.form_reorder_displays','/admin/structure/views/{js}/reorder-displays/{view}/{display_id}','/admin/structure/views/%/reorder-displays/%/%',116,'C:31:\"Symfony\\Component\\Routing\\Route\":1671:{a:9:{s:4:\"path\";s:64:\"/admin/structure/views/{js}/reorder-displays/{view}/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"\\Drupal\\views_ui\\Form\\Ajax\\ReorderDisplays::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":870:{a:11:{s:4:\"vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:105:\"#^/admin/structure/views/(?P<js>nojs|ajax)/reorder\\-displays/(?P<view>[^/]++)/(?P<display_id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:5:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/reorder-displays\";}i:3;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";i:4;b:1;}i:4;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:116;s:14:\"patternOutline\";s:45:\"/admin/structure/views/%/reorder-displays/%/%\";s:8:\"numParts\";i:7;}}}}',7),

('views_ui.reports_fields','/admin/reports/fields/views-fields','/admin/reports/fields/views-fields',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1027:{a:9:{s:4:\"path\";s:34:\"/admin/reports/fields/views-fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:59:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::reportFields\";s:6:\"_title\";s:13:\"Used in views\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":401:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/reports/fields/views\\-fields$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/reports/fields/views-fields\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:34:\"/admin/reports/fields/views-fields\";s:8:\"numParts\";i:4;}}}}',4),

('views_ui.reports_plugins','/admin/reports/views-plugins','/admin/reports/views-plugins',7,'C:31:\"Symfony\\Component\\Routing\\Route\":1003:{a:9:{s:4:\"path\";s:28:\"/admin/reports/views-plugins\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::reportPlugins\";s:6:\"_title\";s:13:\"Views plugins\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":382:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/reports/views\\-plugins$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/reports/views-plugins\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:28:\"/admin/reports/views-plugins\";s:8:\"numParts\";i:3;}}}}',3),

('views_ui.settings_advanced','/admin/structure/views/settings/advanced','/admin/structure/views/settings/advanced',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1036:{a:9:{s:4:\"path\";s:40:\"/admin/structure/views/settings/advanced\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:42:\"\\Drupal\\views_ui\\Form\\AdvancedSettingsForm\";s:6:\"_title\";s:23:\"Advanced Views settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":418:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/structure/views/settings/advanced$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/structure/views/settings/advanced\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:40:\"/admin/structure/views/settings/advanced\";s:8:\"numParts\";i:5;}}}}',5),

('views_ui.settings_basic','/admin/structure/views/settings','/admin/structure/views/settings',15,'C:31:\"Symfony\\Component\\Routing\\Route\":988:{a:9:{s:4:\"path\";s:31:\"/admin/structure/views/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"\\Drupal\\views_ui\\Form\\BasicSettingsForm\";s:6:\"_title\";s:14:\"Views settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/structure/views/settings$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/views/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/structure/views/settings\";s:8:\"numParts\";i:4;}}}}',4),

('votingapi.admin_settings','/admin/config/search/votingapi','/admin/config/search/votingapi',15,'C:31:\"Symfony\\Component\\Routing\\Route\":990:{a:9:{s:4:\"path\";s:30:\"/admin/config/search/votingapi\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:19:\"Voting API settings\";s:5:\"_form\";s:35:\"\\Drupal\\votingapi\\Form\\SettingsForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer voting api\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":388:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/config/search/votingapi$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/config/search/votingapi\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:30:\"/admin/config/search/votingapi\";s:8:\"numParts\";i:4;}}}}',4),

('votingapi.type_add','/admin/structure/vote-types/add','/admin/structure/vote-types/add',15,'C:31:\"Symfony\\Component\\Routing\\Route\":975:{a:9:{s:4:\"path\";s:31:\"/admin/structure/vote-types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"vote_type.add\";s:6:\"_title\";s:13:\"Add vote type\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer vote types\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":392:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/admin/structure/vote\\-types/add$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/vote-types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/structure/vote-types/add\";s:8:\"numParts\";i:4;}}}}',4),

('webform.addons','/admin/structure/webform/addons','/admin/structure/webform/addons',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1018:{a:9:{s:4:\"path\";s:31:\"/admin/structure/webform/addons\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:57:\"\\Drupal\\webform\\Controller\\WebformAddonsController::index\";s:6:\"_title\";s:17:\"Webforms: Add-ons\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/structure/webform/addons$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/addons\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/structure/webform/addons\";s:8:\"numParts\";i:4;}}}}',4),

('webform.config','/admin/structure/webform/config','/admin/structure/webform/config',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1026:{a:9:{s:4:\"path\";s:31:\"/admin/structure/webform/config\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:60:\"\\Drupal\\webform\\Form\\AdminConfig\\WebformAdminConfigFormsForm\";s:6:\"_title\";s:29:\"Webforms: Forms configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/structure/webform/config$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/webform/config\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/structure/webform/config\";s:8:\"numParts\";i:4;}}}}',4),

('webform.config.advanced','/admin/structure/webform/config/advanced','/admin/structure/webform/config/advanced',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1068:{a:9:{s:4:\"path\";s:40:\"/admin/structure/webform/config/advanced\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:63:\"\\Drupal\\webform\\Form\\AdminConfig\\WebformAdminConfigAdvancedForm\";s:6:\"_title\";s:32:\"Webforms: Advanced configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":418:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/structure/webform/config/advanced$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/structure/webform/config/advanced\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:40:\"/admin/structure/webform/config/advanced\";s:8:\"numParts\";i:5;}}}}',5),

('webform.config.elements','/admin/structure/webform/config/elements','/admin/structure/webform/config/elements',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1068:{a:9:{s:4:\"path\";s:40:\"/admin/structure/webform/config/elements\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:63:\"\\Drupal\\webform\\Form\\AdminConfig\\WebformAdminConfigElementsForm\";s:6:\"_title\";s:32:\"Webforms: Elements configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":418:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/structure/webform/config/elements$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/structure/webform/config/elements\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:40:\"/admin/structure/webform/config/elements\";s:8:\"numParts\";i:5;}}}}',5),

('webform.config.exporters','/admin/structure/webform/config/exporters','/admin/structure/webform/config/exporters',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1074:{a:9:{s:4:\"path\";s:41:\"/admin/structure/webform/config/exporters\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:64:\"\\Drupal\\webform\\Form\\AdminConfig\\WebformAdminConfigExportersForm\";s:6:\"_title\";s:33:\"Webforms: Exporters configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":421:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/admin/structure/webform/config/exporters$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/structure/webform/config/exporters\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:41:\"/admin/structure/webform/config/exporters\";s:8:\"numParts\";i:5;}}}}',5),

('webform.config.handlers','/admin/structure/webform/config/handlers','/admin/structure/webform/config/handlers',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1068:{a:9:{s:4:\"path\";s:40:\"/admin/structure/webform/config/handlers\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:63:\"\\Drupal\\webform\\Form\\AdminConfig\\WebformAdminConfigHandlersForm\";s:6:\"_title\";s:32:\"Webforms: Handlers configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":418:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/structure/webform/config/handlers$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/structure/webform/config/handlers\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:40:\"/admin/structure/webform/config/handlers\";s:8:\"numParts\";i:5;}}}}',5),

('webform.config.libraries','/admin/structure/webform/config/libraries','/admin/structure/webform/config/libraries',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1074:{a:9:{s:4:\"path\";s:41:\"/admin/structure/webform/config/libraries\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:64:\"\\Drupal\\webform\\Form\\AdminConfig\\WebformAdminConfigLibrariesForm\";s:6:\"_title\";s:33:\"Webforms: Libraries configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":421:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/admin/structure/webform/config/libraries$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/structure/webform/config/libraries\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:41:\"/admin/structure/webform/config/libraries\";s:8:\"numParts\";i:5;}}}}',5),

('webform.config.submissions','/admin/structure/webform/config/submissions','/admin/structure/webform/config/submissions',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1086:{a:9:{s:4:\"path\";s:43:\"/admin/structure/webform/config/submissions\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:66:\"\\Drupal\\webform\\Form\\AdminConfig\\WebformAdminConfigSubmissionsForm\";s:6:\"_title\";s:35:\"Webforms: Submissions configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":427:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/admin/structure/webform/config/submissions$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/webform/config/submissions\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:43:\"/admin/structure/webform/config/submissions\";s:8:\"numParts\";i:5;}}}}',5),

('webform.element.autocomplete','/webform/{webform}/autocomplete/{key}','/webform/%/autocomplete/%',10,'C:31:\"Symfony\\Component\\Routing\\Route\":1370:{a:9:{s:4:\"path\";s:37:\"/webform/{webform}/autocomplete/{key}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:65:\"\\Drupal\\webform\\Controller\\WebformElementController::autocomplete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"webform.submission_page\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:21:\"paramconverter.entity\";}}s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":665:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/webform/(?P<webform>[^/]++)/autocomplete/(?P<key>[^/]++)$#sDu\";s:11:\"path_tokens\";a:4:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"key\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/autocomplete\";}i:2;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"webform\";i:4;b:1;}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/webform\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"webform\";i:1;s:3:\"key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:10;s:14:\"patternOutline\";s:25:\"/webform/%/autocomplete/%\";s:8:\"numParts\";i:4;}}}}',4),

('webform.element.message.close','/webform/message/close/{storage}/{id}','/webform/message/close/%/%',28,'C:31:\"Symfony\\Component\\Routing\\Route\":1284:{a:9:{s:4:\"path\";s:37:\"/webform/message/close/{storage}/{id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\webform\\Controller\\WebformElementController::close\";s:8:\"_storage\";s:4:\"user\";}s:12:\"requirements\";a:2:{s:18:\"_user_is_logged_in\";s:4:\"TRUE\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:30:\"access_check.user.login_status\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":628:{a:11:{s:4:\"vars\";a:2:{i:0;s:7:\"storage\";i:1;s:2:\"id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/webform/message/close/(?P<storage>[^/]++)/(?P<id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"id\";i:4;b:1;}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"storage\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/webform/message/close\";}}s:9:\"path_vars\";a:2:{i:0;s:7:\"storage\";i:1;s:2:\"id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:28;s:14:\"patternOutline\";s:26:\"/webform/message/close/%/%\";s:8:\"numParts\";i:5;}}}}',5),

('webform.help','/admin/structure/webform/help','/admin/structure/webform/help',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1001:{a:9:{s:4:\"path\";s:29:\"/admin/structure/webform/help\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\webform\\Controller\\WebformHelpController::index\";s:6:\"_title\";s:14:\"Webforms: Help\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/structure/webform/help$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/webform/help\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/structure/webform/help\";s:8:\"numParts\";i:4;}}}}',4),

('webform.help.video','/admin/help/webform/video/{id}','/admin/help/webform/video/%',30,'C:31:\"Symfony\\Component\\Routing\\Route\":1056:{a:9:{s:4:\"path\";s:30:\"/admin/help/webform/video/{id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:5:\"_form\";s:41:\"\\Drupal\\webform\\Form\\WebformHelpVideoForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":495:{a:11:{s:4:\"vars\";a:1:{i:0;s:2:\"id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/help/webform/video/(?P<id>[^/]++)$#sDu\";s:11:\"path_tokens\";a:2:{i:0;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"id\";i:4;b:1;}i:1;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/help/webform/video\";}}s:9:\"path_vars\";a:1:{i:0;s:2:\"id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:27:\"/admin/help/webform/video/%\";s:8:\"numParts\";i:5;}}}}',5),

('webform.reports_plugins.elements','/admin/reports/webform-plugins/elements','/admin/reports/webform-plugins/elements',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1066:{a:9:{s:4:\"path\";s:39:\"/admin/reports/webform-plugins/elements\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformPluginElementController::index\";s:6:\"_title\";s:25:\"Webform plugins: Elements\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":416:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/reports/webform\\-plugins/elements$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/reports/webform-plugins/elements\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:39:\"/admin/reports/webform-plugins/elements\";s:8:\"numParts\";i:4;}}}}',4),

('webform.reports_plugins.elements.test','/admin/reports/webform-plugins/elements/{type}/test','/admin/reports/webform-plugins/elements/%/test',61,'C:31:\"Symfony\\Component\\Routing\\Route\":1387:{a:9:{s:4:\"path\";s:51:\"/admin/reports/webform-plugins/elements/{type}/test\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:48:\"\\Drupal\\webform_ui\\Form\\WebformUiElementTestForm\";s:6:\"_title\";s:12:\"Test element\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:10:\"parameters\";a:1:{s:7:\"webform\";a:2:{s:4:\"type\";s:14:\"entity:webform\";s:9:\"converter\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":597:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/reports/webform\\-plugins/elements/(?P<type>[^/]++)/test$#sDu\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/test\";}i:1;a:5:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";i:4;b:1;}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/reports/webform-plugins/elements\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:46:\"/admin/reports/webform-plugins/elements/%/test\";s:8:\"numParts\";i:6;}}}}',6),

('webform.reports_plugins.exporters','/admin/reports/webform-plugins/exporters','/admin/reports/webform-plugins/exporters',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1072:{a:9:{s:4:\"path\";s:40:\"/admin/reports/webform-plugins/exporters\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:65:\"\\Drupal\\webform\\Controller\\WebformPluginExporterController::index\";s:6:\"_title\";s:26:\"Webform plugins: Exporters\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":419:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/admin/reports/webform\\-plugins/exporters$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/reports/webform-plugins/exporters\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:40:\"/admin/reports/webform-plugins/exporters\";s:8:\"numParts\";i:4;}}}}',4),

('webform.reports_plugins.handlers','/admin/reports/webform-plugins/handlers','/admin/reports/webform-plugins/handlers',15,'C:31:\"Symfony\\Component\\Routing\\Route\":1066:{a:9:{s:4:\"path\";s:39:\"/admin/reports/webform-plugins/handlers\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:64:\"\\Drupal\\webform\\Controller\\WebformPluginHandlerController::index\";s:6:\"_title\";s:25:\"Webform plugins: Handlers\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer webform\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":416:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/reports/webform\\-plugins/handlers$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/reports/webform-plugins/handlers\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:39:\"/admin/reports/webform-plugins/handlers\";s:8:\"numParts\";i:4;}}}}',4),

('webform_submission.multiple_delete_confirm','/admin/structure/webform/results/delete','/admin/structure/webform/results/delete',31,'C:31:\"Symfony\\Component\\Routing\\Route\":1011:{a:9:{s:4:\"path\";s:39:\"/admin/structure/webform/results/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:5:\"_form\";s:52:\"\\Drupal\\webform\\Form\\WebformSubmissionDeleteMultiple\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer webform submission\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:33:\"Drupal\\Core\\Routing\\RouteCompiler\";s:4:\"utf8\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":415:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/structure/webform/results/delete$#sDu\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/webform/results/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:39:\"/admin/structure/webform/results/delete\";s:8:\"numParts\";i:5;}}}}',5);

/*Table structure for table `search_dataset` */

DROP TABLE IF EXISTS `search_dataset`;

CREATE TABLE `search_dataset` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Search item ID, e.g. node ID for nodes.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The languages.langcode of the item variant.',
  `type` varchar(64) CHARACTER SET ascii NOT NULL COMMENT 'Type of item, e.g. node.',
  `data` longtext NOT NULL COMMENT 'List of space-separated words from the item.',
  `reindex` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Set to force node reindexing.',
  PRIMARY KEY (`sid`,`langcode`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores items that will be searched.';

/*Data for the table `search_dataset` */

insert  into `search_dataset`(`sid`,`langcode`,`type`,`data`,`reindex`) values 

(2,'en','node_search',' design trends in 2015 year design trends in 2015 year here is the big headline for your blog post admin wed 11232016 2254 morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit integer posuere erat a ante someone famous in source title praesent ultricies ut ipsum non laoreet nunc ac  ultricies  leo nulla ac ultrices arcu nullam adipiscing lacus in consectetur posuere nunc malesuada tellus turpis ac pretium orci molestie vel morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat first item of the list second item of the list third item of the list lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem  ',0),

(3,'en','node_search',' style in web design and logo style in web design and logo here is the big headline for your blog post admin thu 11242016 14 morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit integer posuere erat a ante someone famous in source title praesent ultricies ut ipsum non laoreet nunc ac  ultricies  leo nulla ac ultrices arcu nullam adipiscing lacus in consectetur posuere nunc malesuada tellus turpis ac pretium orci molestie vel morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat first item of the list second item of the list third item of the list lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem admin fri 11252016 221  permalink   reply ',1511846889),

(4,'en','node_search',' hipster s style in web design and logo hipster s style in web design and logo here is the big headline for your blog post admin mon 11282016 134 morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit integer posuere erat a ante someone famous in source title praesent ultricies ut ipsum non laoreet nunc ac  ultricies  leo nulla ac ultrices arcu nullam adipiscing lacus in consectetur posuere nunc malesuada tellus turpis ac pretium orci molestie vel morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat first item of the list second item of the list third item of the list lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem  ',1511820336),

(5,'en','node_search',' minimalistic design forever minimalistic design forever here is the big headline for your blog post admin mon 11282016 137 morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit integer posuere erat a ante someone famous in source title praesent ultricies ut ipsum non laoreet nunc ac  ultricies  leo nulla ac ultrices arcu nullam adipiscing lacus in consectetur posuere nunc malesuada tellus turpis ac pretium orci molestie vel morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat first item of the list second item of the list third item of the list lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem  ',1511816447),

(6,'en','node_search',' new web design trends in 2015 year new web design trends in 2015 year here is the big headline for your blog post admin mon 11282016 144 morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat lorem ipsum dolor sit amet consectetur adipiscing elit integer posuere erat a ante someone famous in source title praesent ultricies ut ipsum non laoreet nunc ac  ultricies  leo nulla ac ultrices arcu nullam adipiscing lacus in consectetur posuere nunc malesuada tellus turpis ac pretium orci molestie vel morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat first item of the list second item of the list third item of the list lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer sit amet mi id sapien tempor molestie in nec massa fusce non ante sed lorem rutrum feugiat vestibulum pellentesque purus ut dignissim consectetur nulla erat ultrices purus ut consequat sem elit non sem admin mon 11282016 1303  permalink   reply lorem ipsum dolor sit amet consectetur adipiscing elit quisque at magna ut ante eleifend eleifend admin mon 11282016 1709  permalink   reply lorem ipsum dolor sit amet consectetur adipiscing elit quisque at magna ut ante eleifend eleifend admin mon 11282016 1716  permalink   reply lorem ipsum dolor sit amet consectetur adipiscing elit quisque at magna ut ante eleifend eleifend admin mon 11282016 1716  permalink   reply lorem ipsum dolor sit amet consectetur adipiscing elit quisque at magna ut ante eleifend eleifend  ',1500822777),

(7,'en','node_search',' video post only video post only admin mon 11282016 157  ',0),

(8,'en','node_search',' post with text only post with text only admin mon 11282016 209 suspendisse accumsan interdum tellus eu imperdiet lacus consectetur sed aliquam in ligula ac lacus blandit commodo vel luctus quam pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas cras eu ultrices mauris  ',0),

(9,'en','node_search',' quote post only quote post only admin mon 11282016 209 curabitur iaculis ligula facilisis volutpat suscipit sapien felis tempor consequat vitae velit  ',0),

(10,'en','node_search',' creative project creative project about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin mon 11282016 2025 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(11,'en','node_search',' awesome stuff awesome stuff about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(12,'en','node_search',' creative project creative project about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(13,'en','node_search',' portrait portrait about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(14,'en','node_search',' vase 3d vase 3d about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(15,'en','node_search',' boy in tshirt boy in tshirt about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(16,'en','node_search',' model model about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(17,'en','node_search',' space space about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(18,'en','node_search',' young man young man about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(19,'en','node_search',' tablet tablet about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(20,'en','node_search',' awesome stuff awesome stuff about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(21,'en','node_search',' another project another project about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(22,'en','node_search',' young man young man about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(23,'en','node_search',' tablet tablet about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(24,'en','node_search',' young man young man about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(25,'en','node_search',' boy in tshirt boy in tshirt about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(26,'en','node_search',' model model about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(27,'en','node_search',' space space about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(28,'en','node_search',' model model about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(29,'en','node_search',' portrait portrait about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(30,'en','node_search',' vase 3d vase 3d about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(31,'en','node_search',' creative project creative project about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(32,'en','node_search',' young man young man about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(33,'en','node_search',' another project another project about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 11292016 55 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(34,'en','node_search',' accordions accordions admin wed 11302016 12 first lorem ipsum dolor sit amet consectetur adipiscing elit quam lectus facilisis auctor ultrices ut elementum vulputate nunc second lorem ipsum dolor sit amet consectetur adipiscing elit quam lectus facilisis auctor ultrices ut elementum vulputate nunc third lorem ipsum dolor sit amet consectetur adipiscing elit quam lectus facilisis auctor ultrices ut elementum vulputate nunc first lorem ipsum dolor sit amet consectetur adipiscing elit quam lectus facilisis auctor ultrices ut elementum vulputate nunc second lorem ipsum dolor sit amet consectetur adipiscing elit quam lectus facilisis auctor ultrices ut elementum vulputate nunc third lorem ipsum dolor sit amet consectetur adipiscing elit quam lectus facilisis auctor ultrices ut elementum vulputate nunc  ',0),

(35,'en','node_search',' bar progress  bar progress admin wed 11302016 133 teach profile about blocks about us 3 teach profile about blocks about us 3 about us 3 2017 current year brending 85 design 80 development 85 photography 75 branding 80 design 85 development 75 photography 70  ',0),

(36,'en','node_search',' buttons buttons admin wed 11302016 154 buttons on white button button button button button button button button button button button button button button button button button button button button button button button button buttons on dark button button button button button button button button button button button button button button button button button button button button button button button button button button button button button button button button ',0),

(37,'en','node_search',' features box features box admin sun 12042016 1254 branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit photography cras luctus interdum sodales quisque quis odio dui sedes sit amet neque malesuada lobortis commodo magna ntesque pharetra metus vivera sagittis development fusce aliquet quam eget neque ultrices elementum nulla posuere felis id arcu blandit sagittis eleifender vestibulum purus sit amet vulputate risus support pulvinar vitae neque et porttitor integer non dapibus diam ac eleifend lectus praesent sed nisi eleifend fermentum orci sit amet iaculis libero interdum ideas donec pulvinar rutrum mi sit amet viverra justo hendrerit eget discussions mauris tincidunt augue interdum phasellus luctus commodo design sed sed dictum nibh vivamus semper eros nec consequat development donec pulvinar rutrum mi sit amet viverra justo hendrerit eget branding lorem ipsum dolor sit amet elit vitae gravida nibh morbi dignissim nunc at risus convallis web design vivamus neque orci ultricies blandit ultricies vel semper interdum elit non placerat suscipit logo design lorem ipsum dolor sit amet elit vitae gravida nibh morbi dignissim nunc at risus convallis support semper interdum ultricies elit non placerat nisi suscipit morbi dignissim nunc at risus convallis work process lorem ipsum dolor sit amet cr adipiscing elitin maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discussion 2 making 3 production ',0),

(38,'en','node_search',' grid grid admin sun 12042016 1300 one half lorem ipsum dolor sit amet  tooltip top consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo one half lorem ipsum dolor tooltip bottom sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo one third lorem ipsum dolor sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo one third lorem ipsum dolor sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo one third lorem ipsum dolor sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo one fourth quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo one fourth quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo one fourth quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo one fourth quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo  ',0),

(39,'en','node_search',' icons etline icons etline admin sun 12042016 1311 you can use a set of 100 etline icons  span class iconheart span iconheart result   faheart iconmobile iconlaptop icondesktop icontablet iconphone icondocument icondocuments iconsearch iconclipboard iconnewspaper iconnotebook iconbookopen iconbrowser iconcalendar iconpresentation iconpicture iconpictures iconvideo iconcamera iconprinter icontoolbox iconbriefcase iconwallet icongift iconbargraph icongrid iconexpand iconfocus iconedit iconadjustments iconribbon iconhourglass iconlock iconmegaphone iconshield icontrophy iconflag iconmap iconpuzzle iconbasket iconenvelope iconstreetsign icontelescope icongears iconkey iconpaperclip iconattachment iconpricetags iconlightbulb iconlayers iconpencil icontools icontools2 iconscissors iconpaintbrush iconmagnifyingglass iconcirclecompass iconlinegraph iconmic iconstrategy iconbeaker iconcaution iconrecycle iconanchor iconprofilemale iconprofilefemale iconbike iconwine iconhotairballoon iconglobe icongenius iconmappin icondial iconchat iconheart iconcloud iconupload icondownload icontarget iconhazardous iconpiechart iconspeedometer iconglobal iconcompass iconlifesaver iconclock iconaperture iconquote iconscope iconalarmclock iconrefresh iconhappy iconsad iconfacebook icontwitter icongoogleplus iconrss icontumblr iconlinkedin icondribbble  ',0),

(40,'en','node_search',' icons font awesome icons font awesome admin sun 12042016 1311 you can use a set of 400 icons from font awesome  i class fa faheart i faheart result    faheart   faadjust xf042    faadn xf170    faaligncenter xf037    faalignjustify xf039    faalignleft xf036    faalignright xf038    faambulance xf0f9    faanchor xf13d    faandroid xf17b    faangledoubledown xf103    faangledoubleleft xf100    faangledoubleright xf101    faangledoubleup xf102    faangledown xf107    faangleleft xf104    faangleright xf105    faangleup xf106    faapple xf179    faarchive xf187    faarrowcircledown xf0ab    faarrowcircleleft xf0a8    faarrowcircleodown xf01a    faarrowcircleoleft xf190    faarrowcircleoright xf18e    faarrowcircleoup xf01b    faarrowcircleright xf0a9    faarrowcircleup xf0aa    faarrowdown xf063    faarrowleft xf060    faarrowright xf061    faarrowup xf062    faarrows xf047    faarrowsalt xf0b2    faarrowsh xf07e    faarrowsv xf07d    faasterisk xf069    faautomobile alias xf1b9    fabackward xf04a    faban xf05e    fabank alias xf19c    fabarcharto xf080    fabarcode xf02a    fabars xf0c9    fabeer xf0fc    fabehance xf1b4    fabehancesquare xf1b5    fabell xf0f3    fabello xf0a2    fabitbucket xf171    fabitbucketsquare xf172    fabitcoin alias xf15a    fabold xf032    fabolt xf0e7    fabomb xf1e2    fabook xf02d    fabookmark xf02e    fabookmarko xf097    fabriefcase xf0b1    fabtc xf15a    fabug xf188    fabuilding xf1ad    fabuildingo xf0f7    fabullhorn xf0a1    fabullseye xf140    facab alias xf1ba    facalendar xf073    facalendaro xf133    facamera xf030    facameraretro xf083    facar xf1b9    facaretdown xf0d7    facaretleft xf0d9    facaretright xf0da    facaretsquareodown xf150    facaretsquareoleft xf191    facaretsquareoright xf152    facaretsquareoup xf151    facaretup xf0d8    facertificate xf0a3    fachain alias xf0c1    fachainbroken xf127    facheck xf00c    facheckcircle xf058    facheckcircleo xf05d    fachecksquare xf14a    fachecksquareo xf046    fachevroncircledown xf13a    fachevroncircleleft xf137    fachevroncircleright xf138    fachevroncircleup xf139    fachevrondown xf078    fachevronleft xf053    fachevronright xf054    fachevronup xf077    fachild xf1ae    facircle xf111    facircleo xf10c    facircleonotch xf1ce    facirclethin xf1db    faclipboard xf0ea    faclocko xf017    facloud xf0c2    faclouddownload xf0ed    facloudupload xf0ee    facny alias xf157    facode xf121    facodefork xf126    facodepen xf1cb    facoffee xf0f4    facog xf013    facogs xf085    facolumns xf0db    facomment xf075    facommento xf0e5    facomments xf086    facommentso xf0e6    facompass xf14e    facompress xf066    facopy alias xf0c5    facreditcard xf09d    facrop xf125    facrosshairs xf05b    facss3 xf13c    facube xf1b2    facubes xf1b3    facut alias xf0c4    facutlery xf0f5    fadashboard alias xf0e4    fadatabase xf1c0    fadedent alias xf03b    fadelicious xf1a5    fadesktop xf108    fadeviantart xf1bd    fadigg xf1a6    fadollar alias xf155    fadotcircleo xf192    fadownload xf019    fadribbble xf17d    fadropbox xf16b    fadrupal xf1a9    faedit alias xf044    faeject xf052    faellipsish xf141    faellipsisv xf142    faempire xf1d1    faenvelope xf0e0    faenvelopeo xf003    faenvelopesquare xf199    faeraser xf12d    faeur xf153    faeuro alias xf153    faexchange xf0ec    faexclamation xf12a    faexclamationcircle xf06a    faexclamationtriangle xf071    faexpand xf065    faexternallink xf08e    faexternallinksquare xf14c    faeye xf06e    faeyeslash xf070    fafacebook xf09a    fafacebooksquare xf082    fafastbackward xf049    fafastforward xf050    fafax xf1ac    fafemale xf182    fafighterjet xf0fb    fafile xf15b    fafilearchiveo xf1c6    fafileaudioo xf1c7    fafilecodeo xf1c9    fafileexcelo xf1c3    fafileimageo xf1c5    fafilemovieo alias xf1c8    fafileo xf016    fafilepdfo xf1c1    fafilephotoo alias xf1c5    fafilepictureo alias xf1c5    fafilepowerpointo xf1c4    fafilesoundo alias xf1c7    fafiletext xf15c    fafiletexto xf0f6    fafilevideoo xf1c8    fafilewordo xf1c2    fafilezipo alias xf1c6    fafileso xf0c5    fafilm xf008    fafilter xf0b0    fafire xf06d    fafireextinguisher xf134    faflag xf024    faflagcheckered xf11e    faflago xf11d    faflash alias xf0e7    faflask xf0c3    faflickr xf16e    fafloppyo xf0c7    fafolder xf07b    fafoldero xf114    fafolderopen xf07c    fafolderopeno xf115    fafont xf031    faforward xf04e    fafoursquare xf180    fafrowno xf119    fagamepad xf11b    fagavel xf0e3    fagbp xf154    fage alias xf1d1    fagear alias xf013    fagears alias xf085    fagift xf06b    fagit xf1d3    fagitsquare xf1d2    fagithub xf09b    fagithubalt xf113    fagithubsquare xf092    fagittip xf184    faglass xf000    faglobe xf0ac    fagoogle xf1a0    fagoogleplus xf0d5    fagoogleplussquare xf0d4    fagraduationcap xf19d    fagroup alias xf0c0    fahsquare xf0fd    fahackernews xf1d4    fahandodown xf0a7    fahandoleft xf0a5    fahandoright xf0a4    fahandoup xf0a6    fahddo xf0a0    faheader xf1dc    faheadphones xf025    faheart xf004    fahearto xf08a    fahistory xf1da    fahome xf015    fahospitalo xf0f8    fahtml5 xf13b    faimage alias xf03e    fainbox xf01c    faindent xf03c    fainfo xf129    fainfocircle xf05a    fainr xf156    fainstagram xf16d    fainstitution alias xf19c    faitalic xf033    fajoomla xf1aa    fajpy xf157    fajsfiddle xf1cc    fakey xf084    fakeyboardo xf11c    fakrw xf159    falanguage xf1ab    falaptop xf109    faleaf xf06c    falegal alias xf0e3    falemono xf094    faleveldown xf149    falevelup xf148    falifebouy alias xf1cd    falifering xf1cd    falifesaver alias xf1cd    falightbulbo xf0eb    falink xf0c1    falinkedin xf0e1    falinkedinsquare xf08c    falinux xf17c    falist xf03a    falistalt xf022    falistol xf0cb    falistul xf0ca    falocationarrow xf124    falock xf023    falongarrowdown xf175    falongarrowleft xf177    falongarrowright xf178    falongarrowup xf176    famagic xf0d0    famagnet xf076    famailforward alias xf064    famailreply alias xf112    famailreplyall alias xf122    famale xf183    famapmarker xf041    famaxcdn xf136    famedkit xf0fa    fameho xf11a    famicrophone xf130    famicrophoneslash xf131    faminus xf068    faminuscircle xf056    faminussquare xf146    faminussquareo xf147    famobile xf10b    famobilephone alias xf10b    famoney xf0d6    famoono xf186    famortarboard alias xf19d    famusic xf001    fanavicon alias xf0c9    faopenid xf19b    faoutdent xf03b    fapagelines xf18c    fapaperplane xf1d8    fapaperplaneo xf1d9    fapaperclip xf0c6    faparagraph xf1dd    fapaste alias xf0ea    fapause xf04c    fapaw xf1b0    fapencil xf040    fapencilsquare xf14b    fapencilsquareo xf044    faphone xf095    faphonesquare xf098    faphoto alias xf03e    fapictureo xf03e    fapiedpiper xf1a7    fapiedpiperalt xf1a8    fapiedpipersquare alias xf1a7    fapinterest xf0d2    fapinterestsquare xf0d3    faplane xf072    faplay xf04b    faplaycircle xf144    faplaycircleo xf01d    faplus xf067    fapluscircle xf055    faplussquare xf0fe    faplussquareo xf196    fapoweroff xf011    faprint xf02f    fapuzzlepiece xf12e    faqq xf1d6    faqrcode xf029    faquestion xf128    faquestioncircle xf059    faquoteleft xf10d    faquoteright xf10e    fara alias xf1d0    farandom xf074    farebel xf1d0    farecycle xf1b8    fareddit xf1a1    faredditsquare xf1a2    farefresh xf021    farenren xf18b    fareorder alias xf0c9    farepeat xf01e    fareply xf112    fareplyall xf122    faretweet xf079    farmb alias xf157    faroad xf018    farocket xf135    farotateleft alias xf0e2    farotateright alias xf01e    farouble alias xf158    farss xf09e    farsssquare xf143    farub xf158    faruble alias xf158    farupee alias xf156    fasave alias xf0c7    fascissors xf0c4    fasearch xf002    fasearchminus xf010    fasearchplus xf00e    fasend alias xf1d8    fasendo alias xf1d9    fashare xf064    fasharealt xf1e0    fasharealtsquare xf1e1    fasharesquare xf14d    fasharesquareo xf045    fashield xf132    fashoppingcart xf07a    fasignin xf090    fasignout xf08b    fasignal xf012    fasitemap xf0e8    faskype xf17e    faslack xf198    fasliders xf1de    fasmileo xf118    fasort xf0dc    fasortalphaasc xf15d    fasortalphadesc xf15e    fasortamountasc xf160    fasortamountdesc xf161    fasortasc xf0de    fasortdesc xf0dd    fasortdown alias xf0dd    fasortnumericasc xf162    fasortnumericdesc xf163    fasortup alias xf0de    fasoundcloud xf1be    faspaceshuttle xf197    faspinner xf110    faspoon xf1b1    faspotify xf1bc    fasquare xf0c8    fasquareo xf096    fastackexchange xf18d    fastackoverflow xf16c    fastar xf005    fastarhalf xf089    fastarhalfempty alias xf123    fastarhalffull alias xf123    fastarhalfo xf123    fastaro xf006    fasteam xf1b6    fasteamsquare xf1b7    fastepbackward xf048    fastepforward xf051    fastethoscope xf0f1    fastop xf04d    fastrikethrough xf0cc    fastumbleupon xf1a4    fastumbleuponcircle xf1a3    fasubscript xf12c    fasuitcase xf0f2    fasuno xf185    fasuperscript xf12b    fasupport alias xf1cd    fatable xf0ce    fatablet xf10a    fatachometer xf0e4    fatag xf02b    fatags xf02c    fatasks xf0ae    fataxi xf1ba    fatencentweibo xf1d5    faterminal xf120    fatextheight xf034    fatextwidth xf035    fath xf00a    fathlarge xf009    fathlist xf00b    fathumbtack xf08d    fathumbsdown xf165    fathumbsodown xf088    fathumbsoup xf087    fathumbsup xf164    faticket xf145    fatimes xf00d    fatimescircle xf057    fatimescircleo xf05c    fatint xf043    fatoggledown alias xf150    fatoggleleft alias xf191    fatoggleright alias xf152    fatoggleup alias xf151    fatrasho xf014    fatree xf1bb    fatrello xf181    fatrophy xf091    fatruck xf0d1    fatry xf195    fatumblr xf173    fatumblrsquare xf174    faturkishlira alias xf195    fatwitter xf099    fatwittersquare xf081    faumbrella xf0e9    faunderline xf0cd    faundo xf0e2    fauniversity xf19c    faunlink alias xf127    faunlock xf09c    faunlockalt xf13e    faunsorted alias xf0dc    faupload xf093    fausd xf155    fauser xf007    fausermd xf0f0    fausers xf0c0    favideocamera xf03d    favimeosquare xf194    favine xf1ca    favk xf189    favolumedown xf027    favolumeoff xf026    favolumeup xf028    fawarning alias xf071    fawechat alias xf1d7    faweibo xf18a    faweixin xf1d7    fawheelchair xf193    fawindows xf17a    fawon alias xf159    fawordpress xf19a    fawrench xf0ad    faxing xf168    faxingsquare xf169    fayahoo xf19e    fayen alias xf157    fayoutube xf167    fayoutubeplay xf16a    fayoutubesquare xf166  ',0),

(41,'en','node_search',' messages messages admin sun 12042016 1321 lorem ipsum dolor sit amet consectetur adipiscing elit lorem ipsum dolor sit amet consectetur adipiscing elit lorem ipsum dolor sit amet consectetur adipiscing elit lorem ipsum dolor sit amet consectetur adipiscing elit  ',0),

(42,'en','node_search',' page titles page titles admin sun 12042016 1339 page titles lorem ipsum dolor sit amet consectetur title gray lorem ipsum dolor sit amet consectetur title dark 1 lorem ipsum dolor sit amet consectetur title dark 2 lorem ipsum dolor sit amet consectetur title with image lorem ipsum dolor sit amet consectetur title large lorem ipsum dolor sit amet consectetur title small title small title small title small title small ',0),

(43,'en','node_search',' sliders sliders admin sun 12042016 1510 creative project phasellus facilisis mauris vel velit molestie pellentesque donec rutrum tortor ut elementum venenatis purus magna bibendum nisl ut accumsan ipsum erat eu sapien view online creative project phasellus facilisis mauris vel velit molestie pellentesque donec rutrum tortor ut elementum venenatis purus magna bibendum nisl ut accumsan ipsum erat eu sapien view online we re creative we find the best ideas for you we re punctual we always do your tasks on time we have magic you will be delighted we re creative we find the best ideas for you we re punctual we always do your tasks on time we have magic you will be delighted we re creative we find the best ideas for you we re punctual we always do your tasks on time we have magic you will be delighted what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc creative project phasellus facilisis mauris vel velit molestie pellentesque donec rutrum tortor ut elementum venenatis purus magna bibendum nisl ut accumsan ipsum erat eu sapien view online creative project phasellus facilisis mauris vel velit molestie pellentesque donec rutrum tortor ut elementum venenatis purus magna bibendum nisl ut accumsan ipsum erat eu sapien view online mega creative donec rutrum tortor ut elementum venenatis purus magna bibendum nisl ut phasellus facilisis mauris vel velit molestie pellentesqu accumsan ipsum erat eu sapien view online ',1506588741),

(44,'en','node_search',' tabs tabs admin sun 12042016 2014 standard tabs first second third lorem ipsum dolor sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo aliquam tortor leo pharetra non congue sit amet bibendum sit amet enim nullam sit amet malesuada justo nam porta elementum tortor eget tempor orci ullamcorper eget aliquam fermentum sem non vulputate dapibus vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae nulla at porttitor massa aliquam tortor leo pharetra non congue sit amet bibendum sit amet enim nullam sit amet malesuada justo pellentesque sed vehicula velit vitae vulputate velit morbi nec porta augue et dignissim enim vivamus suscipit lorem vitae rhoncus pharetra erat nisl scelerisque magna ut mollis dui eros eget libero vivamus ut ornare tellus aliquam tortor leo pharetra non congue sit amet bibendum sit amet enim nullam sit amet malesuada justo minimal tabs first second third lorem ipsum dolor sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo aliquam tortor leo pharetra non congue sit amet bibendum sit amet enim nullam sit amet malesuada justo nam porta elementum tortor eget tempor orci ullamcorper eget aliquam fermentum sem non vulputate dapibus vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae nulla at porttitor massa aliquam tortor leo pharetra non congue sit amet bibendum sit amet enim nullam sit amet malesuada justo pellentesque sed vehicula velit vitae vulputate velit morbi nec porta augue et dignissim enim vivamus suscipit lorem vitae rhoncus pharetra erat nisl scelerisque magna ut mollis dui eros eget libero vivamus ut ornare tellus aliquam tortor leo pharetra non congue sit amet bibendum sit amet enim nullam sit amet malesuada justo  ',0),

(45,'en','node_search',' typography typography admin sun 12042016 2015 formating paragraph lorem ipsum dolor sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae consectetur adipiscing elit integer posuere erat a ante mauris non ipsum molestie sagittis elit ac vulputate odio lorem ipsum dolor sit amet consectetur adipiscing elit integer posuere erat a ante someone famous in source title list ul first item second item third item first item second item third item fourth item fives item list ol first item second item third item first item second item third item fourth item fives item emphasis this line of text is meant to be treated as fine print rendered as bold text rendered as italicized text rendered as italicized text headings heading 1 heading 2 heading 3 heading 4 heading 5 heading 6 heading 1 heading 2 heading 3 heading 4 heading 5 heading 6 heading 1 heading 2 heading 3 heading 4 heading 5 heading 6 ',0),

(46,'en','node_search',' video sound video sound admin sun 12042016 2021  ',0),

(47,'en','node_search',' header header admin mon 12052016 115 lorem ipsum dolor sit amet consectetur adipiscing elit sed neque velit ultrices in vulputate vitae volutpat iaculis velit in congue dolor a ligula cursus aliquam aliquam id malesuada metus donec ultricies lorem augue ac fringilla felis aliquet et integer a rutrum dui id varius neque donec orci massa porttitor sit amet velit non interdum feugiat lacus fusce tincidunt id erat at consequat cras vel aliquet mauris ac tempor lorem donec faucibus sodales eros sed pretium praesent ut scelerisque lectus ut feugiat mi nunc vulputate semper erat non iaculis sapien congue sit amet duis non nulla volutpat dignissim leo sit amet porta nunc donec placerat fermentum metus ac scelerisque in id sollicitudin nulla suspendisse potenti integer aliquam orci aliquam eros posuere ornare fusce augue felis maximus non lacus vitae ullamcorper dignissim leo ut congue feugiat turpis at aliquam donec eros neque accumsan sed venenatis volutpat tempor at metus curabitur vel vestibulum ipsum convallis cursus nisl mauris scelerisque gravida faucibus morbi vitae sapien nibh integer libero orci ullamcorper in tincidunt at molestie quis ipsum  ',0),

(48,'en','node_search',' header dark transparent header dark transparent admin mon 12052016 124 lorem ipsum dolor sit amet consectetur adipiscing elit sed neque velit ultrices in vulputate vitae volutpat iaculis velit in congue dolor a ligula cursus aliquam aliquam id malesuada metus donec ultricies lorem augue ac fringilla felis aliquet et integer a rutrum dui id varius neque donec orci massa porttitor sit amet velit non interdum feugiat lacus fusce tincidunt id erat at consequat cras vel aliquet mauris ac tempor lorem donec faucibus sodales eros sed pretium praesent ut scelerisque lectus ut feugiat mi nunc vulputate semper erat non iaculis sapien congue sit amet duis non nulla volutpat dignissim leo sit amet porta nunc donec placerat fermentum metus ac scelerisque in id sollicitudin nulla suspendisse potenti integer aliquam orci aliquam eros posuere ornare fusce augue felis maximus non lacus vitae ullamcorper dignissim leo ut congue feugiat turpis at aliquam donec eros neque accumsan sed venenatis volutpat tempor at metus curabitur vel vestibulum ipsum convallis cursus nisl mauris scelerisque gravida faucibus morbi vitae sapien nibh integer libero orci ullamcorper in tincidunt at molestie quis ipsum  ',0),

(49,'en','node_search',' pricing 1 pricing 1 admin mon 12052016 132 curabitur eu adipiscing lacus a iaculis diam nullam placerat blandit auctor nulla accumsan ipsum et nibh rhoncus eget tempus sapien ultricies donec mollis lorem vehicula lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum start 1 gb storage 3 domain names 5 ftp users free support 199 per month buy now standard 3 gb storage 5 domain names 7 ftp users free support 239 month buy now optima 5 gb storage 9 domain names 15 ftp users free support 399 month buy now ',0),

(50,'en','node_search',' pricing 2 pricing 2 admin mon 12052016 209 curabitur eu adipiscing lacus a iaculis diam nullam placerat blandit auctor nulla accumsan ipsum et nibh rhoncus eget tempus sapien ultricies donec mollis lorem vehicula lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum start 1 gb storage 3 domain names 5 ftp users free support 199 month buy now standard 3 gb storage 5 domain names 7 ftp users free support 239 month buy now optima 5 gb storage 9 domain names 15 ftp users free support 399 month buy now vip 15 gb storage unlimit domain names unlimit ftp users free support 579 month buy now ',0),

(54,'en','node_search',' header white header white admin mon 12052016 1552 lorem ipsum dolor sit amet consectetur adipiscing elit sed neque velit ultrices in vulputate vitae volutpat iaculis velit in congue dolor a ligula cursus aliquam aliquam id malesuada metus donec ultricies lorem augue ac fringilla felis aliquet et integer a rutrum dui id varius neque donec orci massa porttitor sit amet velit non interdum feugiat lacus fusce tincidunt id erat at consequat cras vel aliquet mauris ac tempor lorem donec faucibus sodales eros sed pretium praesent ut scelerisque lectus ut feugiat mi nunc vulputate semper erat non iaculis sapien congue sit amet duis non nulla volutpat dignissim leo sit amet porta nunc donec placerat fermentum metus ac scelerisque in id sollicitudin nulla suspendisse potenti integer aliquam orci aliquam eros posuere ornare fusce augue felis maximus non lacus vitae ullamcorper dignissim leo ut congue feugiat turpis at aliquam donec eros neque accumsan sed venenatis volutpat tempor at metus curabitur vel vestibulum ipsum convallis cursus nisl mauris scelerisque gravida faucibus morbi vitae sapien nibh integer libero orci ullamcorper in tincidunt at molestie quis ipsum  ',0),

(55,'en','node_search',' header white transparent header white transparent admin mon 12052016 1558 lorem ipsum dolor sit amet consectetur adipiscing elit sed neque velit ultrices in vulputate vitae volutpat iaculis velit in congue dolor a ligula cursus aliquam aliquam id malesuada metus donec ultricies lorem augue ac fringilla felis aliquet et integer a rutrum dui id varius neque donec orci massa porttitor sit amet velit non interdum feugiat lacus fusce tincidunt id erat at consequat cras vel aliquet mauris ac tempor lorem donec faucibus sodales eros sed pretium praesent ut scelerisque lectus ut feugiat mi nunc vulputate semper erat non iaculis sapien congue sit amet duis non nulla volutpat dignissim leo sit amet porta nunc donec placerat fermentum metus ac scelerisque in id sollicitudin nulla suspendisse potenti integer aliquam orci aliquam eros posuere ornare fusce augue felis maximus non lacus vitae ullamcorper dignissim leo ut congue feugiat turpis at aliquam donec eros neque accumsan sed venenatis volutpat tempor at metus curabitur vel vestibulum ipsum convallis cursus nisl mauris scelerisque gravida faucibus morbi vitae sapien nibh integer libero orci ullamcorper in tincidunt at molestie quis ipsum  ',0),

(56,'en','node_search',' awesome stuff awesome stuff about lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discuss 2 make 3 product admin tue 12062016 2140 1 case study lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 2 result proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero 3 experience curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit project details client  envato users date  1th februery 2014 online  wwwrhythmbestlookerpro lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam  ',0),

(57,'en','node_search',' emma connor emma connor hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam admin thu 12082016 2309 creative director  ',0),

(58,'en','node_search',' steve anders steve anders hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam admin thu 12082016 2309 web director  ',0),

(59,'en','node_search',' marta laning marta laning hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam admin thu 12082016 2309 designer  ',0),

(60,'en','node_search',' thomas rhythm thomas rhythm hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam admin thu 12082016 2309 ceo  ',0),

(61,'en','node_search',' team 1 team 1 admin tue 12132016 305 our creative minds curabitur eu adipiscing lacus a iaculis diam nullam placerat blandit auctor nulla accumsan ipsum et nibh rhoncus eget tempus sapien ultricies donec mollis lorem vehicula hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam emma connor creative director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam steve anders web director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam marta laning designer why choose us  branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit  ',0),

(62,'en','node_search',' team 2 team 2 admin tue 12132016 310 our creative minds curabitur eu adipiscing lacus a iaculis diam nullam placerat blandit auctor nulla accumsan ipsum et nibh rhoncus eget tempus sapien ultricies donec mollis lorem vehicula hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam emma connor creative director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam steve anders web director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam marta laning designer hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam thomas rhythm ceo why choose us  branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit  ',0),

(63,'en','node_search',' about us 1 about us 1 admin tue 12132016 1917 it doesn t matter how many times i have to click as long as each click is a mindless unambiguous choice jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam emma connor creative director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam steve anders web director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam marta laning designer what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc why choose us  branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit  ',0),

(64,'en','node_search',' about us 2 about us 2 admin tue 12132016 1919 maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero branding 90 design 80 development 85 320 projects done 150 happy clients 933 coffee cups 975 great ideas what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc our team in auctor ex id urna faucibus porttitor lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam emma connor creative director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam steve anders web director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam marta laning designer hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam thomas rhythm ceo why choose us  branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit  ',0),

(65,'en','node_search',' about us 3 about us 3 admin tue 12132016 1921 who we are  lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero branding 90 design 80 development 85 photo 75 320 projects done 150 happy clients 933 coffee cups 975 great ideas hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam emma connor creative director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam steve anders web director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam marta laning designer hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam thomas rhythm ceo what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc our story mission vision ideas lorem ipsum dolor sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo aliquam tortor leo pharetra non congue sit amet bibendum sit amet enim lorem ipsum dolor sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo aliquam tortor leo pharetra non congue sit amet bibendum sit amet enim lorem ipsum dolor sit amet consectetur adipiscing elit quisque mollis lacus augue a hendrerit leo tristique vitae mauris non ipsum molestie sagittis elit ac vulputate odio fusce quam augue gravida tincidunt dui nec tempor iaculis justo aliquam tortor leo pharetra non congue sit amet bibendum sit amet enim  ',0),

(66,'en','node_search',' services 1 services 1 admin tue 12132016 1928 branding web design graphic design development photography it doesn t matter how many times i have to click as long as each click is a mindless unambiguous choice jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero looking for exclusive digital services  proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor integer non dapibus diam ac eleifend lectus lets talk why choose us  branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit  ',0),

(67,'en','node_search',' services 2 services 2 admin tue 12132016 1928 branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit photography cras luctus interdum sodales quisque quis odio dui sedes sit amet neque malesuada lobortis commodo magna ntesque pharetra metus vivera sagittis development fusce aliquet quam eget neque ultrices elementum nulla posuere felis id arcu blandit sagittis eleifender vestibulum purus sit amet vulputate risus support pulvinar vitae neque et porttitor integer non dapibus diam ac eleifend lectus praesent sed nisi eleifend fermentum orci sit amet iaculis libero interdum looking for exclusive digital services  proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor integer non dapibus diam ac eleifend lectus lets talk work process lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam aliquam elementum tellus non erat porttitor mollis morbi viverra sollicitudin nisl eu sodales etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero 1 discussion donec nec justo eget felis facilisis fermentum aliquam porttitor mauris sit amet orci aenean dignissim pellentesque felis 2 design donec nec justo eget felis facilisis fermentum aliquam porttitor mauris sit amet orci aenean dignissim pellentesque felis 3 development donec nec justo eget felis facilisis fermentum aliquam porttitor mauris sit amet orci aenean dignissim pellentesque felis  ',0),

(68,'en','node_search',' services 3 services 3 admin tue 12132016 1929 work process lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim 1 discussion 2 making 3 production digital branding maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus design development maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus marketing maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus looking for exclusive digital services  proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor integer non dapibus diam ac eleifend lectus lets talk why choose us  lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam aliquam elementum tellus non erat porttitor mollis morbi viverra sollicitudin nisl eu sodales etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero we are professionals donec nec justo eget felis facilisis fermentum aliquam porttitor mauris sit amet orci aenean dignissim pellentesque felis we are punctual donec nec justo eget felis facilisis fermentum aliquam porttitor mauris sit amet orci aenean dignissim pellentesque felis we are friendly donec nec justo eget felis facilisis fermentum aliquam porttitor mauris sit amet orci aenean dignissim pellentesque felis  ',0),

(69,'en','node_search',' clients clients admin tue 12132016 1931 lorem ipsum dolor sit amet consectetur adipiscing elit quisque efficitur nulla orci in sollicitudin mauris viverra id donec est lectus eleifend vitae rutrum eu porta sed nisl nunc vehicula enim eget risus faucibus id interdum nisi commodo nunc eget massa eget ipsum mattis iaculis ut in urna hipster inc lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim other company lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim creative studio lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim digital stuff lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim bigstream inc lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim rhythm and partners lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc why choose us  branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit  ',0),

(70,'en','node_search',' landing page landing page admin tue 12132016 1934 curabitur eu adipiscing lacus a iaculis diam nullam placerat blandit auctor nulla accumsan ipsum et nibh rhoncus eget tempus sapien ultricies donec mollis lorem vehicula see more buy now we provide best digital services curabitur eu adipiscing lacus a iaculis diam nullam placerat blandit auctor nulla accumsan ipsum et nibh rhoncus eget tempus sapien ultricies donec mollis lorem vehicula branding lorem ipsum dolor sit amet elit vitae gravida nibh morbi dignissim nunc at risus convallis web design lorem ipsum dolor sit amet elit vitae gravida nibh morbi dignissim nunc at risus convallis logo design lorem ipsum dolor sit amet elit vitae gravida nibh morbi dignissim nunc at risus convallis illustrations lorem ipsum dolor sit amet elit vitae gravida nibh morbi dignissim nunc at risus convallis  ',1507618849),

(71,'en','node_search',' faq 1 faq 1 admin tue 12132016 1934 what do you mean by an end product  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus i have bought a product that has files missing what do i do  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus do i need to buy a licence for each site  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus is my license transferable  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus can i incorporate advertising in my end product with a regular licence  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus do i need a separate license each time i use an item in a series  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus  ',1496781502),

(72,'en','node_search',' faq 2 faq 2 admin tue 12132016 1935 cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus what do you mean by an end product  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus i have bought a product that has files missing what do i do  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus do i need to buy a licence for each site  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus is my license transferable  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus can i incorporate advertising in my end product with a regular licence  lorem ipsum dolor sit amet consectetur adipiscing elit curabitur vehicula porttitor rutrum ut laoreet sodales rutrum ut eget tristique nibh cras mattis est eget lacus dignissim non consectetur velit pellentesque ut sit amet placerat eros id gravida arcu sed felis purus tempor ac vestibulum nec consectetur at purus  ',0),

(73,'en','node_search',' contact 1 form contact 1 form admin tue 12132016 1952 all the fields are required  ',0),

(74,'en','node_search',' contact 1 contact 1 admin tue 12132016 1957 have a questions  call us 61 3 8376 6284 address 245 quigley blvd ste k address support bestlookerpro all the fields are required  ',0),

(75,'en','node_search',' contact 2 contact 2 admin tue 12132016 2002 curabitur eu adipiscing lacus a iaculis diam nullam placerat blandit auctor nulla accumsan ipsum et nibh rhoncus eget tempus sapien ultricies donec mollis lorem vehicula call us 61 3 8376 6284 address 245 quigley blvd ste k address support bestlookerpro all the fields are required  ',0),

(76,'en','node_search',' young man young man admin tue 12132016 2039  ',0),

(77,'en','node_search',' boy in tshirt boy in tshirt admin tue 12132016 2040  ',0),

(78,'en','node_search',' awesome photo awesome photo admin tue 12132016 2040  ',0),

(79,'en','node_search',' creative project creative project admin tue 12132016 2042  ',0),

(80,'en','node_search',' young man young man admin tue 12132016 2042  ',0),

(81,'en','node_search',' boy in tshirt boy in tshirt admin tue 12132016 2043  ',0),

(82,'en','node_search',' young man young man admin tue 12132016 2043  ',0),

(83,'en','node_search',' model model admin tue 12132016 2043  ',0),

(84,'en','node_search',' creative project creative project admin tue 12132016 2044  ',0),

(85,'en','node_search',' creative project creative project admin tue 12132016 2044  ',0),

(86,'en','node_search',' another project another project admin tue 12132016 2045  ',0),

(87,'en','node_search',' awesome photo awesome photo admin tue 12132016 2045  ',0),

(88,'en','node_search',' awesome stuff awesome stuff admin tue 12132016 2046  ',0),

(89,'en','node_search',' boy in tshirt boy in tshirt admin tue 12132016 2047  ',0),

(90,'en','node_search',' creative project creative project admin tue 12132016 2047  ',0),

(91,'en','node_search',' vase 3d vase 3d admin tue 12132016 2047  ',0),

(92,'en','node_search',' young man young man admin tue 12132016 2048  ',0),

(93,'en','node_search',' another project another project admin tue 12132016 2049  ',0),

(94,'en','node_search',' awesome photo awesome photo admin tue 12132016 2049  ',0),

(95,'en','node_search',' page not found page not found admin tue 12132016 2141 the page you were looking for could not be found  ',0),

(96,'en','node_search',' maintenance page maintenance page admin tue 12132016 2143 lorem ipsum dolor sit amet consectetur adipiscing elit phasellus mi urna vehicula aliquam dapibus ornare semper semper nisl  ',0),

(97,'en','node_search',' main demo main demo admin tue 12132016 2156 about studio more about us branding 90 design 80 development 85 lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam services branding web design graphic design development photography it doesn t matter how many times i have to click as long as each click is a mindless unambiguous choice jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero view all services looking for exclusive digital services  proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor integer non dapibus diam ac eleifend lectus lets talk why choose us  branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit photography cras luctus interdum sodales quisque quis odio dui sedes sit amet neque malesuada lobortis commodo magna ntesque pharetra metus vivera sagittis development fusce aliquet quam eget neque ultrices elementum nulla posuere felis id arcu blandit sagittis eleifender vestibulum purus sit amet vulputate risus support pulvinar vitae neque et porttitor integer non dapibus diam ac eleifend lectus praesent sed nisi eleifend fermentum orci sit amet iaculis libero interdum what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc creative project phasellus facilisis mauris vel velit molestie pellentesque donec rutrum tortor ut elementum venenatis purus magna bibendum nisl ut accumsan ipsum erat eu sapien view online creative project phasellus facilisis mauris vel velit molestie pellentesque donec rutrum tortor ut elementum venenatis purus magna bibendum nisl ut accumsan ipsum erat eu sapien view online we re creative we find the best ideas for you we re punctual we always do your tasks on time we have magic you will be delighted we re creative we find the best ideas for you we re punctual we always do your tasks on time we have magic you will be delighted we re creative we find the best ideas for you we re punctual we always do your tasks on time we have magic you will be delighted latest news all news in our blog new web design trends in 2015 year admin 28 november lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer read more minimalistic design forever admin 28 november lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer read more hipster s style in web design and logo admin 28 november lorem ipsum dolor sit amet consectetur adipiscing elit mauris non laoreet dui morbi lacus massa euismod ut turpis molestie tristique sodales est integer read more stay informed with our newsletter subscribe please trust us we will never send you spam find us call us 61 3 8376 6284 address 245 quigley blvd ste k address support bestlookerpro ',1492592311),

(98,'en','node_search',' subscribe inline subscribe inline admin tue 12132016 2335 subscribe  ',0),

(99,'en','node_search',' d d admin fri 12162016 1939  ',0),

(100,'en','node_search',' test test admin thu 12292016 2019  ',0),

(101,'en','node_search',' special photographer portfolio special photographer portfolio admin fri 1202017 1425 freelance photographers in auctor ex id urna faucibus porttitor lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus  ',0),

(102,'en','node_search',' one page one page admin fri 1202017 1859 about studio more about us design is not making beauty beauty emerges from selection affinities integration love louis kahn lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero donec vel ultricies purus nam dictum sem eu aliquam hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam emma connor creative director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam steve anders web director hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam marta laning designer hi to all  adipiscing elit curabitur eu adipiscing lacus eu adipiscing lacus a iaculis diam thomas rhythm ceo services branding web design graphic design development photography it doesn t matter how many times i have to click as long as each click is a mindless unambiguous choice jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero a brand for a company is like a reputation for a person you earn reputation by trying to do hard things well jeff bezos maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum volutpat nibh accumsan purus lorem ipsum dolor sit semper amet consectetur adipiscing elit in maximus ligula metus pellentesque mattis donec vel ultricies purus nam dictum sem ipsum aliquam etiam sit amet fringilla lacus pellentesque suscipit ante at ullamcorper pulvinar neque porttitor integer lectus praesent sed nisi eleifend fermentum orci amet iaculis libero looking for exclusive digital services  proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor integer non dapibus diam ac eleifend lectus lets talk portfolio in auctor ex id urna faucibus porttitor lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus like our creative works  start project why choose us  branding lorem ipsum dolor sit amet cr adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim marketing proin fringilla augue at maximus vestibulum nam pulvinar vitae neque et porttitor praesent sed nisi eleifend lorem fermentum orci sit amet iaculis libero web design curabitur iaculis accumsan augue nec finibus mauris pretium eu duis placerat ex gravida nibh tristique porta nulla facilisi suspendisse ultricies eros blandit photography cras luctus interdum sodales quisque quis odio dui sedes sit amet neque malesuada lobortis commodo magna ntesque pharetra metus vivera sagittis development fusce aliquet quam eget neque ultrices elementum nulla posuere felis id arcu blandit sagittis eleifender vestibulum purus sit amet vulputate risus support pulvinar vitae neque et porttitor integer non dapibus diam ac eleifend lectus praesent sed nisi eleifend fermentum orci sit amet iaculis libero interdum what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc what people say  phasellus luctus commodo ullamcorper a posuere rhoncus commodo elit aenean congue risus utaliquam dapibus thanks john doe doodle inc latest news all news in our blog stay informed with our newsletter please trust us we will never send you spam contact call us 61 3 8376 6284 address 245 quigley blvd ste k address support bestlookerpro ',0),

(103,'en','node_search',' special photographer portfolio onepage special photographer portfolio onepage admin tue 1242017 151 freelance photographers in auctor ex id urna faucibus porttitor lorem ipsum dolor sit amet consectetur adipiscing elit in maximus ligula semper metus pellentesque mattis maecenas volutpat diam enim sagittis quam id porta quam sed id dolor consectetur fermentum nibh volutpat accumsan purus  ',0);

/*Table structure for table `search_index` */

DROP TABLE IF EXISTS `search_index`;

CREATE TABLE `search_index` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'The search_total.word that is associated with the search item.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item to which the word belongs.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The languages.langcode of the item variant.',
  `type` varchar(64) CHARACTER SET ascii NOT NULL COMMENT 'The search_dataset.type of the searchable item to which the word belongs.',
  `score` float DEFAULT NULL COMMENT 'The numeric score of the word, higher being more important.',
  PRIMARY KEY (`word`,`sid`,`langcode`,`type`),
  KEY `sid_type` (`sid`,`langcode`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores the search index, associating words, items and…';

/*Data for the table `search_index` */

/*Table structure for table `search_total` */

DROP TABLE IF EXISTS `search_total`;

CREATE TABLE `search_total` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique word in the search index.',
  `count` float DEFAULT NULL COMMENT 'The count of the word in the index using Zipf''s law to equalize the probability distribution.',
  PRIMARY KEY (`word`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores search totals for words.';

/*Data for the table `search_total` */

/*Table structure for table `semaphore` */

DROP TABLE IF EXISTS `semaphore`;

CREATE TABLE `semaphore` (
  `name` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique name.',
  `value` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'A value for the semaphore.',
  `expire` double NOT NULL COMMENT 'A Unix timestamp with microseconds indicating when the semaphore should expire.',
  PRIMARY KEY (`name`),
  KEY `value` (`value`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Table for holding semaphores, locks, flags, etc. that…';

/*Data for the table `semaphore` */

/*Table structure for table `sequences` */

DROP TABLE IF EXISTS `sequences`;

CREATE TABLE `sequences` (
  `value` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The value of the sequence.',
  PRIMARY KEY (`value`)
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARSET=utf8mb4 COMMENT='Stores IDs.';

/*Data for the table `sequences` */

insert  into `sequences`(`value`) values 

(33);

/*Table structure for table `sessions` */

DROP TABLE IF EXISTS `sessions`;

CREATE TABLE `sessions` (
  `uid` int(10) unsigned NOT NULL COMMENT 'The users.uid corresponding to a session, or 0 for anonymous user.',
  `sid` varchar(128) CHARACTER SET ascii NOT NULL COMMENT 'A session ID (hashed). The value is generated by Drupal''s session handlers.',
  `hostname` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The IP address that last used this session ID (sid).',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this session last requested a page. Old records are purged by PHP automatically.',
  `session` longblob COMMENT 'The serialized contents of $_SESSION, an array of name/value pairs that persists across page requests by this session ID. Drupal loads $_SESSION from here at the start of each request and saves it at the end.',
  PRIMARY KEY (`sid`),
  KEY `timestamp` (`timestamp`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Drupal''s session handlers read and write into the sessions…';

/*Data for the table `sessions` */

insert  into `sessions`(`uid`,`sid`,`hostname`,`timestamp`,`session`) values 

(1,'30A7tUwNzFTHBlRt9jt0NlRL-g7Vn_v6hCMddXh5f7k','127.0.0.1',1570974748,'_sf2_attributes|a:1:{s:3:\"uid\";s:1:\"1\";}_sf2_meta|a:4:{s:1:\"u\";i:1570974761;s:1:\"c\";i:1570956815;s:1:\"l\";s:7:\"2000000\";s:1:\"s\";s:43:\"6ulnySEpCuCGARES3Gfi-y0YTqrebldapu5cb9PjdnU\";}'),

(0,'ayVJh8egKsnw-pCI-rxKP9jXDRy1j7xGjcK5YPoDFXg','127.0.0.1',1570956707,'_symfony_flashes|a:1:{s:5:\"error\";a:1:{i:0;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:13263:\"<em class=\"placeholder\">Warning</em>: rename(sites/default/files/php/twig/.wg_KSQN718673WprNn2l8NXpegM,sites/default/files/php/twig/5da2e58e18108_status-messages.html.twig_TnlvkPnFoQGFQv4X1L4dUAdOD/GygH_w-bOdtsliQyny8iM4iujLALWGSTsbxB3PQv8_s.php): �������� � �������. (code: 5) in <em class=\"placeholder\">Drupal\\Component\\PhpStorage\\MTimeProtectedFastFileStorage-&gt;save()</em> (line <em class=\"placeholder\">88</em> of <em class=\"placeholder\">core\\lib\\Drupal\\Component\\PhpStorage\\MTimeProtectedFastFileStorage.php</em>). <pre class=\"backtrace\">Drupal\\Component\\PhpStorage\\MTimeProtectedFastFileStorage-&gt;save(&#039;5da2e58e18108_status-messages.html.twig_TnlvkPnFoQGFQv4X1L4dUAdOD&#039;, &#039;&amp;lt;?php\n\nuse Twig\\Environment;\nuse Twig\\Error\\LoaderError;\nuse Twig\\Error\\RuntimeError;\nuse Twig\\Markup;\nuse Twig\\Sandbox\\SecurityError;\nuse Twig\\Sandbox\\SecurityNotAllowedTagError;\nuse Twig\\Sandbox\\SecurityNotAllowedFilterError;\nuse Twig\\Sandbox\\SecurityNotAllowedFunctionError;\nuse Twig\\Source;\nuse Twig\\Template;\n\n/* themes/custom/rhythm/templates/status-messages.html.twig */\nclass __TwigTemplate_e38017b1dd248cb78a8cc2c5e3ed9e8d3c41beafd73dfe7d45964f537c2847e3 extends \\Twig\\Template\n{\n    public function __construct(Environment $env)\n    {\n        parent::__construct($env);\n\n        $this-&amp;gt;blocks = [\n            &#039;messages&#039; =&amp;gt; [$this, &#039;block_messages&#039;],\n        ];\n        $this-&amp;gt;sandbox = $this-&amp;gt;env-&amp;gt;getExtension(&#039;\\Twig\\Extension\\SandboxExtension&#039;);\n        $tags = [&quot;if&quot; =&amp;gt; 24];\n        $filters = [&quot;escape&quot; =&amp;gt; 25];\n        $functions = [&quot;attach_library&quot; =&amp;gt; 25];\n\n        try {\n            $this-&amp;gt;sandbox-&amp;gt;checkSecurity(\n                [&#039;if&#039;],\n                [&#039;escape&#039;],\n                [&#039;attach_library&#039;]\n            );\n        } catch (SecurityError $e) {\n            $e-&amp;gt;setSourceContext($this-&amp;gt;getSourceContext());\n\n            if ($e instanceof SecurityNotAllowedTagError &amp;amp;&amp;amp; isset($tags[$e-&amp;gt;getTagName()])) {\n                $e-&amp;gt;setTemplateLine($tags[$e-&amp;gt;getTagName()]);\n            } elseif ($e instanceof SecurityNotAllowedFilterError &amp;amp;&amp;amp; isset($filters[$e-&amp;gt;getFilterName()])) {\n                $e-&amp;gt;setTemplateLine($filters[$e-&amp;gt;getFilterName()]);\n            } elseif ($e instanceof SecurityNotAllowedFunctionError &amp;amp;&amp;amp; isset($functions[$e-&amp;gt;getFunctionName()])) {\n                $e-&amp;gt;setTemplateLine($functions[$e-&amp;gt;getFunctionName()]);\n            }\n\n            throw $e;\n        }\n\n    }\n\n    protected function doGetParent(array $context)\n    {\n        // line 1\n        return &quot;@classy/misc/status-messages.html.twig&quot;;\n    }\n\n    protected function doDisplay(array $context, array $blocks = [])\n    {\n        $this-&amp;gt;parent = $this-&amp;gt;loadTemplate(&quot;@classy/misc/status-messages.html.twig&quot;, &quot;themes/custom/rhythm/templates/status-messages.html.twig&quot;, 1);\n        $this-&amp;gt;parent-&amp;gt;display($context, array_merge($this-&amp;gt;blocks, $blocks));\n    }\n\n    // line 23\n    public function block_messages($context, array $blocks = [])\n    {\n        // line 24\n        echo &quot;  &quot;;\n        if ( !twig_test_empty(($context[&quot;message_list&quot;] ?? null))) {\n            // line 25\n            echo &quot;    &quot;;\n            echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;attachLibrary(&quot;bartik/messages&quot;), &quot;html&quot;, null, true);\n            echo &quot;\n    \n      &quot;;\n            // line 27\n            $this-&amp;gt;displayParentBlock(&quot;messages&quot;, $context, $blocks);\n            echo &quot;\n    \n  &quot;;\n        }\n    }\n\n    public function getTemplateName()\n    {\n        return &quot;themes/custom/rhythm/templates/status-messages.html.twig&quot;;\n    }\n\n    public function isTraitable()\n    {\n        return false;\n    }\n\n    public function getDebugInfo()\n    {\n        return array (  76 =&amp;gt; 27,  70 =&amp;gt; 25,  67 =&amp;gt; 24,  64 =&amp;gt; 23,  54 =&amp;gt; 1,);\n    }\n\n    /** @deprecated since 1.27 (to be removed in 2.0). Use getSourceContext() instead */\n    public function getSource()\n    {\n        @trigger_error(&#039;The &#039;.__METHOD__.&#039; method is deprecated since version 1.27 and will be removed in 2.0. Use getSourceContext() instead.&#039;, E_USER_DEPRECATED);\n\n        return $this-&amp;gt;getSourceContext()-&amp;gt;getCode();\n    }\n\n    public function getSourceContext()\n    {\n        return new Source(&quot;&quot;, &quot;themes/custom/rhythm/templates/status-messages.html.twig&quot;, &quot;C:\\\\OpenServer\\\\domains\\\\local.nikadevs.existing.com\\\\themes\\\\custom\\\\rhythm\\\\templates\\\\status-messages.html.twig&quot;);\n    }\n}\n&#039;) (Line: 111)\nDrupal\\Core\\Template\\TwigPhpStorageCache-&gt;write(&#039;5da2e58e18108_status-messages.html.twig_TnlvkPnFoQGFQv4X1L4dUAdOD&#039;, &#039;&amp;lt;?php\n\nuse Twig\\Environment;\nuse Twig\\Error\\LoaderError;\nuse Twig\\Error\\RuntimeError;\nuse Twig\\Markup;\nuse Twig\\Sandbox\\SecurityError;\nuse Twig\\Sandbox\\SecurityNotAllowedTagError;\nuse Twig\\Sandbox\\SecurityNotAllowedFilterError;\nuse Twig\\Sandbox\\SecurityNotAllowedFunctionError;\nuse Twig\\Source;\nuse Twig\\Template;\n\n/* themes/custom/rhythm/templates/status-messages.html.twig */\nclass __TwigTemplate_e38017b1dd248cb78a8cc2c5e3ed9e8d3c41beafd73dfe7d45964f537c2847e3 extends \\Twig\\Template\n{\n    public function __construct(Environment $env)\n    {\n        parent::__construct($env);\n\n        $this-&amp;gt;blocks = [\n            &#039;messages&#039; =&amp;gt; [$this, &#039;block_messages&#039;],\n        ];\n        $this-&amp;gt;sandbox = $this-&amp;gt;env-&amp;gt;getExtension(&#039;\\Twig\\Extension\\SandboxExtension&#039;);\n        $tags = [&quot;if&quot; =&amp;gt; 24];\n        $filters = [&quot;escape&quot; =&amp;gt; 25];\n        $functions = [&quot;attach_library&quot; =&amp;gt; 25];\n\n        try {\n            $this-&amp;gt;sandbox-&amp;gt;checkSecurity(\n                [&#039;if&#039;],\n                [&#039;escape&#039;],\n                [&#039;attach_library&#039;]\n            );\n        } catch (SecurityError $e) {\n            $e-&amp;gt;setSourceContext($this-&amp;gt;getSourceContext());\n\n            if ($e instanceof SecurityNotAllowedTagError &amp;amp;&amp;amp; isset($tags[$e-&amp;gt;getTagName()])) {\n                $e-&amp;gt;setTemplateLine($tags[$e-&amp;gt;getTagName()]);\n            } elseif ($e instanceof SecurityNotAllowedFilterError &amp;amp;&amp;amp; isset($filters[$e-&amp;gt;getFilterName()])) {\n                $e-&amp;gt;setTemplateLine($filters[$e-&amp;gt;getFilterName()]);\n            } elseif ($e instanceof SecurityNotAllowedFunctionError &amp;amp;&amp;amp; isset($functions[$e-&amp;gt;getFunctionName()])) {\n                $e-&amp;gt;setTemplateLine($functions[$e-&amp;gt;getFunctionName()]);\n            }\n\n            throw $e;\n        }\n\n    }\n\n    protected function doGetParent(array $context)\n    {\n        // line 1\n        return &quot;@classy/misc/status-messages.html.twig&quot;;\n    }\n\n    protected function doDisplay(array $context, array $blocks = [])\n    {\n        $this-&amp;gt;parent = $this-&amp;gt;loadTemplate(&quot;@classy/misc/status-messages.html.twig&quot;, &quot;themes/custom/rhythm/templates/status-messages.html.twig&quot;, 1);\n        $this-&amp;gt;parent-&amp;gt;display($context, array_merge($this-&amp;gt;blocks, $blocks));\n    }\n\n    // line 23\n    public function block_messages($context, array $blocks = [])\n    {\n        // line 24\n        echo &quot;  &quot;;\n        if ( !twig_test_empty(($context[&quot;message_list&quot;] ?? null))) {\n            // line 25\n            echo &quot;    &quot;;\n            echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;attachLibrary(&quot;bartik/messages&quot;), &quot;html&quot;, null, true);\n            echo &quot;\n    \n      &quot;;\n            // line 27\n            $this-&amp;gt;displayParentBlock(&quot;messages&quot;, $context, $blocks);\n            echo &quot;\n    \n  &quot;;\n        }\n    }\n\n    public function getTemplateName()\n    {\n        return &quot;themes/custom/rhythm/templates/status-messages.html.twig&quot;;\n    }\n\n    public function isTraitable()\n    {\n        return false;\n    }\n\n    public function getDebugInfo()\n    {\n        return array (  76 =&amp;gt; 27,  70 =&amp;gt; 25,  67 =&amp;gt; 24,  64 =&amp;gt; 23,  54 =&amp;gt; 1,);\n    }\n\n    /** @deprecated since 1.27 (to be removed in 2.0). Use getSourceContext() instead */\n    public function getSource()\n    {\n        @trigger_error(&#039;The &#039;.__METHOD__.&#039; method is deprecated since version 1.27 and will be removed in 2.0. Use getSourceContext() instead.&#039;, E_USER_DEPRECATED);\n\n        return $this-&amp;gt;getSourceContext()-&amp;gt;getCode();\n    }\n\n    public function getSourceContext()\n    {\n        return new Source(&quot;&quot;, &quot;themes/custom/rhythm/templates/status-messages.html.twig&quot;, &quot;C:\\\\OpenServer\\\\domains\\\\local.nikadevs.existing.com\\\\themes\\\\custom\\\\rhythm\\\\templates\\\\status-messages.html.twig&quot;);\n    }\n}\n&#039;) (Line: 487)\nTwig\\Environment-&gt;loadClass(&#039;__TwigTemplate_e38017b1dd248cb78a8cc2c5e3ed9e8d3c41beafd73dfe7d45964f537c2847e3&#039;, &#039;themes/custom/rhythm/templates/status-messages.html.twig&#039;, NULL) (Line: 445)\nTwig\\Environment-&gt;loadTemplate(&#039;themes/custom/rhythm/templates/status-messages.html.twig&#039;) (Line: 64)\ntwig_render_template(&#039;themes/custom/rhythm/templates/status-messages.html.twig&#039;, Array) (Line: 384)\nDrupal\\Core\\Theme\\ThemeManager-&gt;render(&#039;status_messages&#039;, Array) (Line: 437)\nDrupal\\Core\\Render\\Renderer-&gt;doRender(Array, 1) (Line: 195)\nDrupal\\Core\\Render\\Renderer-&gt;render(Array, 1) (Line: 151)\nDrupal\\Core\\Render\\Renderer-&gt;Drupal\\Core\\Render\\{closure}() (Line: 582)\nDrupal\\Core\\Render\\Renderer-&gt;executeInRenderContext(Object, Object) (Line: 152)\nDrupal\\Core\\Render\\Renderer-&gt;renderPlain(Array) (Line: 166)\nDrupal\\Core\\Render\\Renderer-&gt;renderPlaceholder(&#039;&#039;, Array) (Line: 673)\nDrupal\\Core\\Render\\Renderer-&gt;replacePlaceholders(Array) (Line: 552)\nDrupal\\Core\\Render\\Renderer-&gt;doRender(Array, 1) (Line: 195)\nDrupal\\Core\\Render\\Renderer-&gt;render(Array, 1) (Line: 139)\nDrupal\\Core\\Render\\Renderer-&gt;Drupal\\Core\\Render\\{closure}() (Line: 582)\nDrupal\\Core\\Render\\Renderer-&gt;executeInRenderContext(Object, Object) (Line: 140)\nDrupal\\Core\\Render\\Renderer-&gt;renderRoot(Array) (Line: 282)\nDrupal\\Core\\Render\\HtmlResponseAttachmentsProcessor-&gt;renderPlaceholders(Object) (Line: 131)\nDrupal\\Core\\Render\\HtmlResponseAttachmentsProcessor-&gt;processAttachments(Object) (Line: 45)\nDrupal\\Core\\EventSubscriber\\HtmlResponseSubscriber-&gt;onRespond(Object, &#039;kernel.response&#039;, Object)\ncall_user_func(Array, Object, &#039;kernel.response&#039;, Object) (Line: 111)\nDrupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher-&gt;dispatch(&#039;kernel.response&#039;, Object) (Line: 191)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;filterResponse(Object, Object, 2) (Line: 173)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;handleRaw(Object, 2) (Line: 68)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;handle(Object, 2, 1) (Line: 57)\nDrupal\\Core\\StackMiddleware\\Session-&gt;handle(Object, 2, 1) (Line: 47)\nDrupal\\Core\\StackMiddleware\\KernelPreHandle-&gt;handle(Object, 2, 1) (Line: 47)\nDrupal\\Core\\StackMiddleware\\ReverseProxyMiddleware-&gt;handle(Object, 2, 1) (Line: 52)\nDrupal\\Core\\StackMiddleware\\NegotiationMiddleware-&gt;handle(Object, 2, 1) (Line: 23)\nStack\\StackedHttpKernel-&gt;handle(Object, 2) (Line: 166)\nDrupal\\Core\\EventSubscriber\\DefaultExceptionHtmlSubscriber-&gt;makeSubrequest(Object, &#039;/system/404&#039;, 404) (Line: 122)\nDrupal\\Core\\EventSubscriber\\DefaultExceptionHtmlSubscriber-&gt;on404(Object) (Line: 109)\nDrupal\\Core\\EventSubscriber\\HttpExceptionSubscriberBase-&gt;onException(Object, &#039;kernel.exception&#039;, Object)\ncall_user_func(Array, Object, &#039;kernel.exception&#039;, Object) (Line: 111)\nDrupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher-&gt;dispatch(&#039;kernel.exception&#039;, Object) (Line: 227)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;handleException(Object, Object, 1) (Line: 79)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;handle(Object, 1, 1) (Line: 57)\nDrupal\\Core\\StackMiddleware\\Session-&gt;handle(Object, 1, 1) (Line: 47)\nDrupal\\Core\\StackMiddleware\\KernelPreHandle-&gt;handle(Object, 1, 1) (Line: 47)\nDrupal\\Core\\StackMiddleware\\ReverseProxyMiddleware-&gt;handle(Object, 1, 1) (Line: 52)\nDrupal\\Core\\StackMiddleware\\NegotiationMiddleware-&gt;handle(Object, 1, 1) (Line: 23)\nStack\\StackedHttpKernel-&gt;handle(Object, 1, 1) (Line: 693)\nDrupal\\Core\\DrupalKernel-&gt;handle(Object) (Line: 19)\n</pre>\";}}}_sf2_meta|a:3:{s:1:\"u\";i:1570956708;s:1:\"c\";i:1570956708;s:1:\"l\";s:7:\"2000000\";}'),

(1,'liH0xFFat8HaojSSa4aqgTICuK4G68qtdOs8i0tbLVg','127.0.0.1',1570955835,'_sf2_attributes|a:1:{s:3:\"uid\";s:1:\"1\";}_sf2_meta|a:4:{s:1:\"u\";i:1570955835;s:1:\"c\";i:1569657699;s:1:\"l\";s:7:\"2000000\";s:1:\"s\";s:43:\"LQ2yZ0WVXk91d5A162C9WiyYV1C_ERk7VfJaMBLqbMc\";}updates_remaining|a:0:{}'),

(0,'ood_7Yl07z2Pe9Aw3QidNqOIguOJDZq8uRo8ksMKqOM','127.0.0.1',1570956707,'_symfony_flashes|a:1:{s:5:\"error\";a:1:{i:0;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:23214:\"<em class=\"placeholder\">Warning</em>: rename(sites/default/files/php/twig/.g6dporFhC5z4HyYViHrfobVbvYM,sites/default/files/php/twig/5da2e58e18108_status-messages.html.twig_aIBgmf7QwXks-apR7d5yJ1Fkw/k6RMOFrNPt_fH-61zkOCeGc7WhlQgFZzU3Gu2J6SseA.php): �������� � �������. (code: 5) in <em class=\"placeholder\">Drupal\\Component\\PhpStorage\\MTimeProtectedFastFileStorage-&gt;save()</em> (line <em class=\"placeholder\">88</em> of <em class=\"placeholder\">core\\lib\\Drupal\\Component\\PhpStorage\\MTimeProtectedFastFileStorage.php</em>). <pre class=\"backtrace\">Drupal\\Component\\PhpStorage\\MTimeProtectedFastFileStorage-&gt;save(&#039;5da2e58e18108_status-messages.html.twig_aIBgmf7QwXks-apR7d5yJ1Fkw&#039;, &#039;&amp;lt;?php\n\nuse Twig\\Environment;\nuse Twig\\Error\\LoaderError;\nuse Twig\\Error\\RuntimeError;\nuse Twig\\Markup;\nuse Twig\\Sandbox\\SecurityError;\nuse Twig\\Sandbox\\SecurityNotAllowedTagError;\nuse Twig\\Sandbox\\SecurityNotAllowedFilterError;\nuse Twig\\Sandbox\\SecurityNotAllowedFunctionError;\nuse Twig\\Source;\nuse Twig\\Template;\n\n/* @classy/misc/status-messages.html.twig */\nclass __TwigTemplate_da0970010493e04501c37799e271a3b637e203fa981dd0524aaa1c95efe2e6e1 extends \\Twig\\Template\n{\n    public function __construct(Environment $env)\n    {\n        parent::__construct($env);\n\n        $this-&amp;gt;parent = false;\n\n        $this-&amp;gt;blocks = [\n            &#039;messages&#039; =&amp;gt; [$this, &#039;block_messages&#039;],\n        ];\n        $this-&amp;gt;sandbox = $this-&amp;gt;env-&amp;gt;getExtension(&#039;\\Twig\\Extension\\SandboxExtension&#039;);\n        $tags = [&quot;block&quot; =&amp;gt; 23, &quot;for&quot; =&amp;gt; 24, &quot;set&quot; =&amp;gt; 26, &quot;if&quot; =&amp;gt; 32];\n        $filters = [&quot;escape&quot; =&amp;gt; 31, &quot;without&quot; =&amp;gt; 31, &quot;length&quot; =&amp;gt; 38, &quot;first&quot; =&amp;gt; 45];\n        $functions = [];\n\n        try {\n            $this-&amp;gt;sandbox-&amp;gt;checkSecurity(\n                [&#039;block&#039;, &#039;for&#039;, &#039;set&#039;, &#039;if&#039;],\n                [&#039;escape&#039;, &#039;without&#039;, &#039;length&#039;, &#039;first&#039;],\n                []\n            );\n        } catch (SecurityError $e) {\n            $e-&amp;gt;setSourceContext($this-&amp;gt;getSourceContext());\n\n            if ($e instanceof SecurityNotAllowedTagError &amp;amp;&amp;amp; isset($tags[$e-&amp;gt;getTagName()])) {\n                $e-&amp;gt;setTemplateLine($tags[$e-&amp;gt;getTagName()]);\n            } elseif ($e instanceof SecurityNotAllowedFilterError &amp;amp;&amp;amp; isset($filters[$e-&amp;gt;getFilterName()])) {\n                $e-&amp;gt;setTemplateLine($filters[$e-&amp;gt;getFilterName()]);\n            } elseif ($e instanceof SecurityNotAllowedFunctionError &amp;amp;&amp;amp; isset($functions[$e-&amp;gt;getFunctionName()])) {\n                $e-&amp;gt;setTemplateLine($functions[$e-&amp;gt;getFunctionName()]);\n            }\n\n            throw $e;\n        }\n\n    }\n\n    protected function doDisplay(array $context, array $blocks = [])\n    {\n        // line 22\n        echo &quot;\n&quot;;\n        // line 23\n        $this-&amp;gt;displayBlock(&#039;messages&#039;, $context, $blocks);\n        // line 55\n        echo &quot;\n&quot;;\n    }\n\n    // line 23\n    public function block_messages($context, array $blocks = [])\n    {\n        // line 24\n        $context[&#039;_parent&#039;] = $context;\n        $context[&#039;_seq&#039;] = twig_ensure_traversable(($context[&quot;message_list&quot;] ?? null));\n        foreach ($context[&#039;_seq&#039;] as $context[&quot;type&quot;] =&amp;gt; $context[&quot;messages&quot;]) {\n            // line 25\n            echo &quot;  &quot;;\n            // line 26\n            $context[&quot;classes&quot;] = [0 =&amp;gt; &quot;messages&quot;, 1 =&amp;gt; (&quot;messages--&quot; . $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed(            // line 28\n$context[&quot;type&quot;]))];\n            // line 31\n            echo &quot;  env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($this-&amp;gt;getAttribute(($context[&quot;status_headings&quot;] ?? null), $context[&quot;type&quot;], [], &quot;array&quot;)), &quot;html&quot;, null, true);\n            echo &quot;\\&quot;&quot;;\n            echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;withoutFilter($this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($this-&amp;gt;getAttribute(($context[&quot;attributes&quot;] ?? null), &quot;addClass&quot;, [0 =&amp;gt; ($context[&quot;classes&quot;] ?? null)], &quot;method&quot;)), &quot;role&quot;, &quot;aria-label&quot;), &quot;html&quot;, null, true);\n            echo &quot;&amp;gt;\n    &quot;;\n            // line 32\n            if (($context[&quot;type&quot;] == &quot;error&quot;)) {\n                // line 33\n                echo &quot;      \n    &quot;;\n            }\n            // line 35\n            echo &quot;      &quot;;\n            if ($this-&amp;gt;getAttribute(($context[&quot;status_headings&quot;] ?? null), $context[&quot;type&quot;], [], &quot;array&quot;)) {\n                // line 36\n                echo &quot;        &quot;;\n                echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($this-&amp;gt;getAttribute(($context[&quot;status_headings&quot;] ?? null), $context[&quot;type&quot;], [], &quot;array&quot;)), &quot;html&quot;, null, true);\n                echo &quot;\n      &quot;;\n            }\n            // line 38\n            echo &quot;      &quot;;\n            if ((twig_length_filter($this-&amp;gt;env, $context[&quot;messages&quot;]) &amp;gt; 1)) {\n                // line 39\n                echo &quot;        &lt;ul&gt;\n          &quot;;\n                // line 40\n                $context[&#039;_parent&#039;] = $context;\n                $context[&#039;_seq&#039;] = twig_ensure_traversable($context[&quot;messages&quot;]);\n                foreach ($context[&#039;_seq&#039;] as $context[&quot;_key&quot;] =&amp;gt; $context[&quot;message&quot;]) {\n                    // line 41\n                    echo &quot;            &lt;li&gt;&quot;;\n                    echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($context[&quot;message&quot;]), &quot;html&quot;, null, true);\n                    echo &quot;&lt;/li&gt;\n          &quot;;\n                }\n                $_parent = $context[&#039;_parent&#039;];\n                unset($context[&#039;_seq&#039;], $context[&#039;_iterated&#039;], $context[&#039;_key&#039;], $context[&#039;message&#039;], $context[&#039;_parent&#039;], $context[&#039;loop&#039;]);\n                $context = array_intersect_key($context, $_parent) + $_parent;\n                // line 43\n                echo &quot;        &lt;/ul&gt;\n      &quot;;\n            } else {\n                // line 45\n                echo &quot;        &quot;;\n                echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, twig_first($this-&amp;gt;env, $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($context[&quot;messages&quot;])), &quot;html&quot;, null, true);\n                echo &quot;\n      &quot;;\n            }\n            // line 47\n            echo &quot;    &quot;;\n            if (($context[&quot;type&quot;] == &quot;error&quot;)) {\n                // line 48\n                echo &quot;      \n    &quot;;\n            }\n            // line 50\n            echo &quot;  \n  &quot;;\n            // line 52\n            echo &quot;  &quot;;\n            $context[&quot;attributes&quot;] = $this-&amp;gt;getAttribute(($context[&quot;attributes&quot;] ?? null), &quot;removeClass&quot;, [0 =&amp;gt; ($context[&quot;classes&quot;] ?? null)], &quot;method&quot;);\n        }\n        $_parent = $context[&#039;_parent&#039;];\n        unset($context[&#039;_seq&#039;], $context[&#039;_iterated&#039;], $context[&#039;type&#039;], $context[&#039;messages&#039;], $context[&#039;_parent&#039;], $context[&#039;loop&#039;]);\n        $context = array_intersect_key($context, $_parent) + $_parent;\n    }\n\n    public function getTemplateName()\n    {\n        return &quot;@classy/misc/status-messages.html.twig&quot;;\n    }\n\n    public function getDebugInfo()\n    {\n        return array (  139 =&amp;gt; 52,  136 =&amp;gt; 50,  132 =&amp;gt; 48,  129 =&amp;gt; 47,  123 =&amp;gt; 45,  119 =&amp;gt; 43,  110 =&amp;gt; 41,  106 =&amp;gt; 40,  103 =&amp;gt; 39,  100 =&amp;gt; 38,  94 =&amp;gt; 36,  91 =&amp;gt; 35,  87 =&amp;gt; 33,  85 =&amp;gt; 32,  78 =&amp;gt; 31,  76 =&amp;gt; 28,  75 =&amp;gt; 26,  73 =&amp;gt; 25,  69 =&amp;gt; 24,  66 =&amp;gt; 23,  61 =&amp;gt; 55,  59 =&amp;gt; 23,  56 =&amp;gt; 22,);\n    }\n\n    /** @deprecated since 1.27 (to be removed in 2.0). Use getSourceContext() instead */\n    public function getSource()\n    {\n        @trigger_error(&#039;The &#039;.__METHOD__.&#039; method is deprecated since version 1.27 and will be removed in 2.0. Use getSourceContext() instead.&#039;, E_USER_DEPRECATED);\n\n        return $this-&amp;gt;getSourceContext()-&amp;gt;getCode();\n    }\n\n    public function getSourceContext()\n    {\n        return new Source(&quot;&quot;, &quot;@classy/misc/status-messages.html.twig&quot;, &quot;C:\\\\OpenServer\\\\domains\\\\local.nikadevs.existing.com\\\\core\\\\themes\\\\classy\\\\templates\\\\misc\\\\status-messages.html.twig&quot;);\n    }\n}\n&#039;) (Line: 111)\nDrupal\\Core\\Template\\TwigPhpStorageCache-&gt;write(&#039;5da2e58e18108_status-messages.html.twig_aIBgmf7QwXks-apR7d5yJ1Fkw&#039;, &#039;&amp;lt;?php\n\nuse Twig\\Environment;\nuse Twig\\Error\\LoaderError;\nuse Twig\\Error\\RuntimeError;\nuse Twig\\Markup;\nuse Twig\\Sandbox\\SecurityError;\nuse Twig\\Sandbox\\SecurityNotAllowedTagError;\nuse Twig\\Sandbox\\SecurityNotAllowedFilterError;\nuse Twig\\Sandbox\\SecurityNotAllowedFunctionError;\nuse Twig\\Source;\nuse Twig\\Template;\n\n/* @classy/misc/status-messages.html.twig */\nclass __TwigTemplate_da0970010493e04501c37799e271a3b637e203fa981dd0524aaa1c95efe2e6e1 extends \\Twig\\Template\n{\n    public function __construct(Environment $env)\n    {\n        parent::__construct($env);\n\n        $this-&amp;gt;parent = false;\n\n        $this-&amp;gt;blocks = [\n            &#039;messages&#039; =&amp;gt; [$this, &#039;block_messages&#039;],\n        ];\n        $this-&amp;gt;sandbox = $this-&amp;gt;env-&amp;gt;getExtension(&#039;\\Twig\\Extension\\SandboxExtension&#039;);\n        $tags = [&quot;block&quot; =&amp;gt; 23, &quot;for&quot; =&amp;gt; 24, &quot;set&quot; =&amp;gt; 26, &quot;if&quot; =&amp;gt; 32];\n        $filters = [&quot;escape&quot; =&amp;gt; 31, &quot;without&quot; =&amp;gt; 31, &quot;length&quot; =&amp;gt; 38, &quot;first&quot; =&amp;gt; 45];\n        $functions = [];\n\n        try {\n            $this-&amp;gt;sandbox-&amp;gt;checkSecurity(\n                [&#039;block&#039;, &#039;for&#039;, &#039;set&#039;, &#039;if&#039;],\n                [&#039;escape&#039;, &#039;without&#039;, &#039;length&#039;, &#039;first&#039;],\n                []\n            );\n        } catch (SecurityError $e) {\n            $e-&amp;gt;setSourceContext($this-&amp;gt;getSourceContext());\n\n            if ($e instanceof SecurityNotAllowedTagError &amp;amp;&amp;amp; isset($tags[$e-&amp;gt;getTagName()])) {\n                $e-&amp;gt;setTemplateLine($tags[$e-&amp;gt;getTagName()]);\n            } elseif ($e instanceof SecurityNotAllowedFilterError &amp;amp;&amp;amp; isset($filters[$e-&amp;gt;getFilterName()])) {\n                $e-&amp;gt;setTemplateLine($filters[$e-&amp;gt;getFilterName()]);\n            } elseif ($e instanceof SecurityNotAllowedFunctionError &amp;amp;&amp;amp; isset($functions[$e-&amp;gt;getFunctionName()])) {\n                $e-&amp;gt;setTemplateLine($functions[$e-&amp;gt;getFunctionName()]);\n            }\n\n            throw $e;\n        }\n\n    }\n\n    protected function doDisplay(array $context, array $blocks = [])\n    {\n        // line 22\n        echo &quot;\n&quot;;\n        // line 23\n        $this-&amp;gt;displayBlock(&#039;messages&#039;, $context, $blocks);\n        // line 55\n        echo &quot;\n&quot;;\n    }\n\n    // line 23\n    public function block_messages($context, array $blocks = [])\n    {\n        // line 24\n        $context[&#039;_parent&#039;] = $context;\n        $context[&#039;_seq&#039;] = twig_ensure_traversable(($context[&quot;message_list&quot;] ?? null));\n        foreach ($context[&#039;_seq&#039;] as $context[&quot;type&quot;] =&amp;gt; $context[&quot;messages&quot;]) {\n            // line 25\n            echo &quot;  &quot;;\n            // line 26\n            $context[&quot;classes&quot;] = [0 =&amp;gt; &quot;messages&quot;, 1 =&amp;gt; (&quot;messages--&quot; . $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed(            // line 28\n$context[&quot;type&quot;]))];\n            // line 31\n            echo &quot;  env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($this-&amp;gt;getAttribute(($context[&quot;status_headings&quot;] ?? null), $context[&quot;type&quot;], [], &quot;array&quot;)), &quot;html&quot;, null, true);\n            echo &quot;\\&quot;&quot;;\n            echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;withoutFilter($this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($this-&amp;gt;getAttribute(($context[&quot;attributes&quot;] ?? null), &quot;addClass&quot;, [0 =&amp;gt; ($context[&quot;classes&quot;] ?? null)], &quot;method&quot;)), &quot;role&quot;, &quot;aria-label&quot;), &quot;html&quot;, null, true);\n            echo &quot;&amp;gt;\n    &quot;;\n            // line 32\n            if (($context[&quot;type&quot;] == &quot;error&quot;)) {\n                // line 33\n                echo &quot;      \n    &quot;;\n            }\n            // line 35\n            echo &quot;      &quot;;\n            if ($this-&amp;gt;getAttribute(($context[&quot;status_headings&quot;] ?? null), $context[&quot;type&quot;], [], &quot;array&quot;)) {\n                // line 36\n                echo &quot;        &quot;;\n                echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($this-&amp;gt;getAttribute(($context[&quot;status_headings&quot;] ?? null), $context[&quot;type&quot;], [], &quot;array&quot;)), &quot;html&quot;, null, true);\n                echo &quot;\n      &quot;;\n            }\n            // line 38\n            echo &quot;      &quot;;\n            if ((twig_length_filter($this-&amp;gt;env, $context[&quot;messages&quot;]) &amp;gt; 1)) {\n                // line 39\n                echo &quot;        &lt;ul&gt;\n          &quot;;\n                // line 40\n                $context[&#039;_parent&#039;] = $context;\n                $context[&#039;_seq&#039;] = twig_ensure_traversable($context[&quot;messages&quot;]);\n                foreach ($context[&#039;_seq&#039;] as $context[&quot;_key&quot;] =&amp;gt; $context[&quot;message&quot;]) {\n                    // line 41\n                    echo &quot;            &lt;li&gt;&quot;;\n                    echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($context[&quot;message&quot;]), &quot;html&quot;, null, true);\n                    echo &quot;&lt;/li&gt;\n          &quot;;\n                }\n                $_parent = $context[&#039;_parent&#039;];\n                unset($context[&#039;_seq&#039;], $context[&#039;_iterated&#039;], $context[&#039;_key&#039;], $context[&#039;message&#039;], $context[&#039;_parent&#039;], $context[&#039;loop&#039;]);\n                $context = array_intersect_key($context, $_parent) + $_parent;\n                // line 43\n                echo &quot;        &lt;/ul&gt;\n      &quot;;\n            } else {\n                // line 45\n                echo &quot;        &quot;;\n                echo $this-&amp;gt;env-&amp;gt;getExtension(&#039;Drupal\\Core\\Template\\TwigExtension&#039;)-&amp;gt;escapeFilter($this-&amp;gt;env, twig_first($this-&amp;gt;env, $this-&amp;gt;sandbox-&amp;gt;ensureToStringAllowed($context[&quot;messages&quot;])), &quot;html&quot;, null, true);\n                echo &quot;\n      &quot;;\n            }\n            // line 47\n            echo &quot;    &quot;;\n            if (($context[&quot;type&quot;] == &quot;error&quot;)) {\n                // line 48\n                echo &quot;      \n    &quot;;\n            }\n            // line 50\n            echo &quot;  \n  &quot;;\n            // line 52\n            echo &quot;  &quot;;\n            $context[&quot;attributes&quot;] = $this-&amp;gt;getAttribute(($context[&quot;attributes&quot;] ?? null), &quot;removeClass&quot;, [0 =&amp;gt; ($context[&quot;classes&quot;] ?? null)], &quot;method&quot;);\n        }\n        $_parent = $context[&#039;_parent&#039;];\n        unset($context[&#039;_seq&#039;], $context[&#039;_iterated&#039;], $context[&#039;type&#039;], $context[&#039;messages&#039;], $context[&#039;_parent&#039;], $context[&#039;loop&#039;]);\n        $context = array_intersect_key($context, $_parent) + $_parent;\n    }\n\n    public function getTemplateName()\n    {\n        return &quot;@classy/misc/status-messages.html.twig&quot;;\n    }\n\n    public function getDebugInfo()\n    {\n        return array (  139 =&amp;gt; 52,  136 =&amp;gt; 50,  132 =&amp;gt; 48,  129 =&amp;gt; 47,  123 =&amp;gt; 45,  119 =&amp;gt; 43,  110 =&amp;gt; 41,  106 =&amp;gt; 40,  103 =&amp;gt; 39,  100 =&amp;gt; 38,  94 =&amp;gt; 36,  91 =&amp;gt; 35,  87 =&amp;gt; 33,  85 =&amp;gt; 32,  78 =&amp;gt; 31,  76 =&amp;gt; 28,  75 =&amp;gt; 26,  73 =&amp;gt; 25,  69 =&amp;gt; 24,  66 =&amp;gt; 23,  61 =&amp;gt; 55,  59 =&amp;gt; 23,  56 =&amp;gt; 22,);\n    }\n\n    /** @deprecated since 1.27 (to be removed in 2.0). Use getSourceContext() instead */\n    public function getSource()\n    {\n        @trigger_error(&#039;The &#039;.__METHOD__.&#039; method is deprecated since version 1.27 and will be removed in 2.0. Use getSourceContext() instead.&#039;, E_USER_DEPRECATED);\n\n        return $this-&amp;gt;getSourceContext()-&amp;gt;getCode();\n    }\n\n    public function getSourceContext()\n    {\n        return new Source(&quot;&quot;, &quot;@classy/misc/status-messages.html.twig&quot;, &quot;C:\\\\OpenServer\\\\domains\\\\local.nikadevs.existing.com\\\\core\\\\themes\\\\classy\\\\templates\\\\misc\\\\status-messages.html.twig&quot;);\n    }\n}\n&#039;) (Line: 487)\nTwig\\Environment-&gt;loadClass(&#039;__TwigTemplate_da0970010493e04501c37799e271a3b637e203fa981dd0524aaa1c95efe2e6e1&#039;, &#039;@classy/misc/status-messages.html.twig&#039;, NULL) (Line: 445)\nTwig\\Environment-&gt;loadTemplate(&#039;@classy/misc/status-messages.html.twig&#039;, NULL) (Line: 377)\nTwig\\Template-&gt;loadTemplate(&#039;@classy/misc/status-messages.html.twig&#039;, &#039;themes/custom/rhythm/templates/status-messages.html.twig&#039;, 1) (Line: 59)\n__TwigTemplate_e38017b1dd248cb78a8cc2c5e3ed9e8d3c41beafd73dfe7d45964f537c2847e3-&gt;doDisplay(Array, Array) (Line: 455)\nTwig\\Template-&gt;displayWithErrorHandling(Array, Array) (Line: 422)\nTwig\\Template-&gt;display(Array) (Line: 434)\nTwig\\Template-&gt;render(Array) (Line: 64)\ntwig_render_template(&#039;themes/custom/rhythm/templates/status-messages.html.twig&#039;, Array) (Line: 384)\nDrupal\\Core\\Theme\\ThemeManager-&gt;render(&#039;status_messages&#039;, Array) (Line: 437)\nDrupal\\Core\\Render\\Renderer-&gt;doRender(Array, 1) (Line: 195)\nDrupal\\Core\\Render\\Renderer-&gt;render(Array, 1) (Line: 151)\nDrupal\\Core\\Render\\Renderer-&gt;Drupal\\Core\\Render\\{closure}() (Line: 582)\nDrupal\\Core\\Render\\Renderer-&gt;executeInRenderContext(Object, Object) (Line: 152)\nDrupal\\Core\\Render\\Renderer-&gt;renderPlain(Array) (Line: 166)\nDrupal\\Core\\Render\\Renderer-&gt;renderPlaceholder(&#039;&#039;, Array) (Line: 673)\nDrupal\\Core\\Render\\Renderer-&gt;replacePlaceholders(Array) (Line: 552)\nDrupal\\Core\\Render\\Renderer-&gt;doRender(Array, 1) (Line: 195)\nDrupal\\Core\\Render\\Renderer-&gt;render(Array, 1) (Line: 139)\nDrupal\\Core\\Render\\Renderer-&gt;Drupal\\Core\\Render\\{closure}() (Line: 582)\nDrupal\\Core\\Render\\Renderer-&gt;executeInRenderContext(Object, Object) (Line: 140)\nDrupal\\Core\\Render\\Renderer-&gt;renderRoot(Array) (Line: 282)\nDrupal\\Core\\Render\\HtmlResponseAttachmentsProcessor-&gt;renderPlaceholders(Object) (Line: 131)\nDrupal\\Core\\Render\\HtmlResponseAttachmentsProcessor-&gt;processAttachments(Object) (Line: 45)\nDrupal\\Core\\EventSubscriber\\HtmlResponseSubscriber-&gt;onRespond(Object, &#039;kernel.response&#039;, Object)\ncall_user_func(Array, Object, &#039;kernel.response&#039;, Object) (Line: 111)\nDrupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher-&gt;dispatch(&#039;kernel.response&#039;, Object) (Line: 191)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;filterResponse(Object, Object, 2) (Line: 173)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;handleRaw(Object, 2) (Line: 68)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;handle(Object, 2, 1) (Line: 57)\nDrupal\\Core\\StackMiddleware\\Session-&gt;handle(Object, 2, 1) (Line: 47)\nDrupal\\Core\\StackMiddleware\\KernelPreHandle-&gt;handle(Object, 2, 1) (Line: 47)\nDrupal\\Core\\StackMiddleware\\ReverseProxyMiddleware-&gt;handle(Object, 2, 1) (Line: 52)\nDrupal\\Core\\StackMiddleware\\NegotiationMiddleware-&gt;handle(Object, 2, 1) (Line: 23)\nStack\\StackedHttpKernel-&gt;handle(Object, 2) (Line: 166)\nDrupal\\Core\\EventSubscriber\\DefaultExceptionHtmlSubscriber-&gt;makeSubrequest(Object, &#039;/system/404&#039;, 404) (Line: 122)\nDrupal\\Core\\EventSubscriber\\DefaultExceptionHtmlSubscriber-&gt;on404(Object) (Line: 109)\nDrupal\\Core\\EventSubscriber\\HttpExceptionSubscriberBase-&gt;onException(Object, &#039;kernel.exception&#039;, Object)\ncall_user_func(Array, Object, &#039;kernel.exception&#039;, Object) (Line: 111)\nDrupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher-&gt;dispatch(&#039;kernel.exception&#039;, Object) (Line: 227)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;handleException(Object, Object, 1) (Line: 79)\nSymfony\\Component\\HttpKernel\\HttpKernel-&gt;handle(Object, 1, 1) (Line: 57)\nDrupal\\Core\\StackMiddleware\\Session-&gt;handle(Object, 1, 1) (Line: 47)\nDrupal\\Core\\StackMiddleware\\KernelPreHandle-&gt;handle(Object, 1, 1) (Line: 47)\nDrupal\\Core\\StackMiddleware\\ReverseProxyMiddleware-&gt;handle(Object, 1, 1) (Line: 52)\nDrupal\\Core\\StackMiddleware\\NegotiationMiddleware-&gt;handle(Object, 1, 1) (Line: 23)\nStack\\StackedHttpKernel-&gt;handle(Object, 1, 1) (Line: 693)\nDrupal\\Core\\DrupalKernel-&gt;handle(Object) (Line: 19)\n</pre>\";}}}_sf2_meta|a:3:{s:1:\"u\";i:1570956708;s:1:\"c\";i:1570956708;s:1:\"l\";s:7:\"2000000\";}');

/*Table structure for table `shortcut` */

DROP TABLE IF EXISTS `shortcut`;

CREATE TABLE `shortcut` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `shortcut_set` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `shortcut_field__uuid__value` (`uuid`),
  KEY `shortcut_field__shortcut_set__target_id` (`shortcut_set`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for shortcut entities.';

/*Data for the table `shortcut` */

insert  into `shortcut`(`id`,`shortcut_set`,`uuid`,`langcode`) values 

(1,'default','794f4a3a-bc20-4c00-82fb-03c42ffa3c9e','en');

/*Table structure for table `shortcut_field_data` */

DROP TABLE IF EXISTS `shortcut_field_data`;

CREATE TABLE `shortcut_field_data` (
  `id` int(10) unsigned NOT NULL,
  `shortcut_set` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `weight` int(11) DEFAULT NULL,
  `link__uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `link__title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `link__options` longblob COMMENT 'Serialized array of options for the link.',
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`,`langcode`),
  KEY `shortcut__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `shortcut_field__shortcut_set__target_id` (`shortcut_set`),
  KEY `shortcut_field__link__uri` (`link__uri`(30))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for shortcut entities.';

/*Data for the table `shortcut_field_data` */

insert  into `shortcut_field_data`(`id`,`shortcut_set`,`langcode`,`title`,`weight`,`link__uri`,`link__title`,`link__options`,`default_langcode`) values 

(1,'default','en','Add Product Display',NULL,'internal:/product/add/product_display',NULL,'a:0:{}',1);

/*Table structure for table `shortcut_set_users` */

DROP TABLE IF EXISTS `shortcut_set_users`;

CREATE TABLE `shortcut_set_users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid for this set.',
  `set_name` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The shortcut_set.set_name that will be displayed for this user.',
  PRIMARY KEY (`uid`),
  KEY `set_name` (`set_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Maps users to shortcut sets.';

/*Data for the table `shortcut_set_users` */

/*Table structure for table `taxonomy_index` */

DROP TABLE IF EXISTS `taxonomy_index`;

CREATE TABLE `taxonomy_index` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record tracks.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The term ID.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node is published (visible to non-administrators).',
  `sticky` tinyint(4) DEFAULT '0' COMMENT 'Boolean indicating whether the node is sticky.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  PRIMARY KEY (`nid`,`tid`),
  KEY `term_node` (`tid`,`status`,`sticky`,`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Maintains denormalized information about node/term…';

/*Data for the table `taxonomy_index` */

insert  into `taxonomy_index`(`nid`,`tid`,`status`,`sticky`,`created`) values 

(4,1,1,0,1480286083),

(5,1,1,0,1480286238),

(6,1,1,0,1480286668),

(7,1,1,0,1480287436),

(3,2,1,0,1479935645),

(4,2,1,0,1480286083),

(5,2,1,0,1480286238),

(2,3,1,0,1479930877),

(2,4,1,0,1479930877),

(5,4,1,0,1480286238),

(6,4,1,0,1480286668),

(7,4,1,0,1480287436),

(2,5,1,0,1479930877),

(8,7,1,0,1480288167),

(9,7,1,0,1480288193),

(3,8,1,0,1479935645),

(8,8,1,0,1480288167),

(9,8,1,0,1480288193),

(3,9,1,0,1479935645),

(4,9,1,0,1480286083),

(3,10,1,0,1479935645),

(4,10,1,0,1480286083),

(3,12,1,0,1479935645),

(5,12,1,0,1480286238),

(6,12,1,0,1480286668),

(3,15,1,0,1479935645),

(10,16,1,0,1480353947),

(14,16,1,0,1480370156),

(20,16,1,0,1480370156),

(23,16,1,0,1480370156),

(25,16,1,0,1480370156),

(27,16,1,0,1480370156),

(28,16,1,0,1480370156),

(29,16,1,0,1480370156),

(31,16,1,0,1480370156),

(33,16,1,0,1480370156),

(10,17,1,0,1480353947),

(11,17,1,0,1480370156),

(12,17,1,0,1480370156),

(13,17,1,0,1480370156),

(15,17,1,0,1480370156),

(22,17,1,0,1480370156),

(30,17,1,0,1480370156),

(32,17,1,0,1480370156),

(56,17,1,0,1481049607),

(18,18,1,0,1480370156),

(11,19,1,0,1480370156),

(12,19,1,0,1480370156),

(13,19,1,0,1480370156),

(16,20,1,0,1480370156),

(19,20,1,0,1480370156),

(26,20,1,0,1480370156),

(14,21,1,0,1480370156),

(17,21,1,0,1480370156),

(21,21,1,0,1480370156),

(24,21,1,0,1480370156),

(14,22,1,0,1480370156),

(29,22,1,0,1480370156),

(14,23,1,0,1480370156),

(19,23,1,0,1480370156),

(11,24,1,0,1480370156),

(12,24,1,0,1480370156),

(13,24,1,0,1480370156),

(11,25,1,0,1480370156),

(12,25,1,0,1480370156),

(13,25,1,0,1480370156),

(17,25,1,0,1480370156),

(18,25,1,0,1480370156),

(19,25,1,0,1480370156),

(23,25,1,0,1480370156),

(10,26,1,0,1480353947),

(15,26,1,0,1480370156),

(16,26,1,0,1480370156),

(21,26,1,0,1480370156),

(22,26,1,0,1480370156),

(24,26,1,0,1480370156),

(25,26,1,0,1480370156),

(26,26,1,0,1480370156),

(27,26,1,0,1480370156),

(28,26,1,0,1480370156),

(30,26,1,0,1480370156),

(31,26,1,0,1480370156),

(32,26,1,0,1480370156),

(33,26,1,0,1480370156),

(56,26,1,0,1481049607),

(10,27,1,0,1480353947),

(15,27,1,0,1480370156),

(16,27,1,0,1480370156),

(20,27,1,0,1480370156),

(56,27,1,0,1481049607),

(11,28,1,0,1480370156),

(12,28,1,0,1480370156),

(13,28,1,0,1480370156),

(15,28,1,0,1480370156),

(16,28,1,0,1480370156),

(19,28,1,0,1480370156),

(22,28,1,0,1480370156),

(23,28,1,0,1480370156),

(28,28,1,0,1480370156),

(30,28,1,0,1480370156),

(31,28,1,0,1480370156),

(56,28,1,0,1481049607),

(10,29,1,0,1480353947),

(11,29,1,0,1480370156),

(12,29,1,0,1480370156),

(13,29,1,0,1480370156),

(27,29,1,0,1480370156),

(10,30,1,0,1480353947),

(17,30,1,0,1480370156),

(18,30,1,0,1480370156),

(20,30,1,0,1480370156),

(21,30,1,0,1480370156),

(24,30,1,0,1480370156),

(25,30,1,0,1480370156),

(26,30,1,0,1480370156),

(29,30,1,0,1480370156),

(14,31,1,0,1480370156),

(32,31,1,0,1480370156),

(33,31,1,0,1480370156),

(14,32,1,0,1480370156),

(76,33,1,0,1481650769),

(77,33,1,0,1481650807),

(78,33,1,0,1481650832),

(79,33,1,0,1481650938),

(80,33,1,0,1481650966),

(82,33,1,0,1481651008),

(83,33,1,0,1481651028),

(84,33,1,0,1481651051),

(85,33,1,0,1481651072),

(99,33,1,0,1481906370),

(80,34,1,0,1481650966),

(81,34,1,0,1481650987),

(86,35,1,0,1481651121),

(87,35,1,0,1481651150),

(88,35,1,0,1481651178),

(89,35,1,0,1481651224),

(90,35,1,0,1481651255),

(91,35,1,0,1481651278),

(92,35,1,0,1481651334),

(93,35,1,0,1481651356);

/*Table structure for table `taxonomy_index_commerce_product` */

DROP TABLE IF EXISTS `taxonomy_index_commerce_product`;

CREATE TABLE `taxonomy_index_commerce_product` (
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The commerce_product ID this record tracks.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The term ID.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the commerce_product was created.',
  PRIMARY KEY (`product_id`,`tid`),
  KEY `term_commerce_product` (`tid`,`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Maintains denormalized information about commerce_product…';

/*Data for the table `taxonomy_index_commerce_product` */

insert  into `taxonomy_index_commerce_product`(`product_id`,`tid`,`created`) values 

(2,28,1503052396),

(4,28,1503053593),

(3,29,1503053273),

(2,30,1503052396),

(1,31,1503051226),

(4,31,1503053593),

(1,32,1503051226),

(1,36,1503051226),

(2,36,1503052396),

(3,36,1503053273),

(1,37,1503051226),

(2,37,1503052396),

(4,37,1503053593),

(1,38,1503051226),

(3,38,1503053273),

(4,38,1503053593),

(3,39,1503053273);

/*Table structure for table `taxonomy_term__parent` */

DROP TABLE IF EXISTS `taxonomy_term__parent`;

CREATE TABLE `taxonomy_term__parent` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `parent_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `revision_id` (`revision_id`),
  KEY `parent_target_id` (`parent_target_id`),
  KEY `bundle_delta_target_id` (`bundle`,`delta`,`parent_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for taxonomy_term field parent.';

/*Data for the table `taxonomy_term__parent` */

insert  into `taxonomy_term__parent`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`parent_target_id`) values 

('blog_category',0,1,1,'en',0,0),

('blog_category',0,2,2,'en',0,0),

('blog_category',0,3,3,'en',0,0),

('blog_category',0,4,4,'en',0,0),

('blog_category',0,5,5,'en',0,0),

('blog_category',0,6,6,'en',0,0),

('blog_category',0,7,7,'en',0,0),

('blog_category',0,8,8,'en',0,0),

('blog_category',0,9,9,'en',0,0),

('tags',0,10,10,'en',0,0),

('tags',0,11,11,'en',0,0),

('tags',0,12,12,'en',0,0),

('tags',0,13,13,'en',0,0),

('tags',0,14,14,'en',0,0),

('tags',0,15,15,'en',0,0),

('project',0,16,16,'en',0,0),

('project',0,17,17,'en',0,0),

('project',0,18,18,'en',0,0),

('project',0,19,19,'en',0,0),

('project',0,20,20,'en',0,0),

('project',0,21,21,'en',0,0),

('portfolio_category',0,22,22,'en',0,0),

('portfolio_category',0,23,23,'en',0,0),

('portfolio_category',0,24,24,'en',0,0),

('portfolio_category',0,25,25,'en',0,0),

('portfolio_category',0,26,26,'en',0,0),

('portfolio_category',0,27,27,'en',0,0),

('category',0,28,28,'en',0,0),

('category',0,29,29,'en',0,0),

('category',0,30,30,'en',0,0),

('category',0,31,31,'en',0,0),

('category',0,32,32,'en',0,0),

('gallery',0,33,33,'en',0,0),

('gallery',0,34,34,'en',0,0),

('gallery',0,35,35,'en',0,0),

('category',0,36,36,'en',0,0),

('tags',0,37,37,'en',0,0),

('tags',0,38,38,'en',0,0),

('tags',0,39,39,'en',0,0);

/*Table structure for table `taxonomy_term_data` */

DROP TABLE IF EXISTS `taxonomy_term_data`;

CREATE TABLE `taxonomy_term_data` (
  `tid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `revision_id` int(10) unsigned DEFAULT NULL,
  `vid` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`tid`),
  UNIQUE KEY `taxonomy_term_field__uuid__value` (`uuid`),
  UNIQUE KEY `taxonomy_term__revision_id` (`revision_id`),
  KEY `taxonomy_term_field__vid__target_id` (`vid`)
) ENGINE=InnoDB AUTO_INCREMENT=40 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for taxonomy_term entities.';

/*Data for the table `taxonomy_term_data` */

insert  into `taxonomy_term_data`(`tid`,`revision_id`,`vid`,`uuid`,`langcode`) values 

(1,1,'blog_category','1c9ee1c8-2d40-44db-8e28-2dc133a880ba','en'),

(2,2,'blog_category','59ea2970-18c9-4e9e-bf22-9a5333644bdd','en'),

(3,3,'blog_category','ac8b0829-cbd1-42b5-8bd9-84140c9826b5','en'),

(4,4,'blog_category','7d22a3ff-9bfc-486e-bae7-dea2c7a53305','en'),

(5,5,'blog_category','f8faee50-9bb7-4ae4-8901-34ca33a027f0','en'),

(6,6,'blog_category','9666ef8e-8235-446e-abc3-f051f7d9cccc','en'),

(7,7,'blog_category','07357e8a-c9a0-485a-8661-b9e99ed5a509','en'),

(8,8,'blog_category','78a25b13-722c-4974-a260-7e0c5ca11944','en'),

(9,9,'blog_category','989a8ad2-99de-40b3-928a-22474d2f4dd3','en'),

(10,10,'tags','4cbf4b4c-6554-4161-8b96-6e1d69112203','en'),

(11,11,'tags','386d7757-ad1c-41f3-a175-2ab3c6fe0634','en'),

(12,12,'tags','e2555647-4703-413d-9810-a33c9cc821a2','en'),

(13,13,'tags','b95ea51e-88cc-4286-8437-0997c0530fbc','en'),

(14,14,'tags','d04b4722-a006-4b6b-938f-fa916526a7b2','en'),

(15,15,'tags','19f096b7-aa03-4a63-ae95-4edd334e3b6a','en'),

(16,16,'project','b35478ef-de59-4811-88ce-cc6e21145a63','en'),

(17,17,'project','5482971c-b169-4587-9690-b1a0bf0e66bd','en'),

(18,18,'project','d0c9503c-ca1b-4386-bc83-d904d63c9058','en'),

(19,19,'project','16bfca8c-a21d-4306-98a1-63129443f678','en'),

(20,20,'project','9f1a8fb8-a519-4961-8c8c-ef3ee8cc8602','en'),

(21,21,'project','0b30adab-4e2b-45e0-99bc-d614cc6aa44f','en'),

(22,22,'portfolio_category','00d9cf99-374c-4318-8e51-50f419b7aa75','en'),

(23,23,'portfolio_category','719eebe6-bb82-4872-b674-636f6dbeeece','en'),

(24,24,'portfolio_category','5cb59063-f2bc-4940-b830-0b98a802faf8','en'),

(25,25,'portfolio_category','34f0b551-25e6-430f-8c05-3676757569eb','en'),

(26,26,'portfolio_category','dc08f4f7-f90b-4ac9-9270-ba60a927c897','en'),

(27,27,'portfolio_category','1d87cf60-deec-45ed-aaf8-e4bfa5338569','en'),

(28,28,'category','7b09da11-dad7-4754-ada1-5978b747d1ce','en'),

(29,29,'category','0e2447fb-30e7-4363-b081-4163a11b1e8e','en'),

(30,30,'category','9f5b1ef0-8f78-44db-9d37-e81c8534fad1','en'),

(31,31,'category','2ca5dde9-11c6-4624-a956-0904fa72d95b','en'),

(32,32,'category','fb3d7b5f-9ace-4c2f-bbf1-119449a58691','en'),

(33,33,'gallery','b23e0207-1eff-4a7f-bf90-937d5dbd6787','en'),

(34,34,'gallery','b2708a02-550b-40f8-a418-a3ed658d7c1a','en'),

(35,35,'gallery','fa02b512-9419-43d7-8389-b774271a3a7a','en'),

(36,36,'category','89b27a09-a947-4e3c-a3dd-750da151aef0','en'),

(37,37,'tags','db3e03dc-a063-45da-9c37-41b0575ada27','en'),

(38,38,'tags','7440647c-2bb4-47e3-b21a-580e7ad8a0bc','en'),

(39,39,'tags','294555b9-3cc5-4a85-b9f9-5be52efc76ff','en');

/*Table structure for table `taxonomy_term_field_data` */

DROP TABLE IF EXISTS `taxonomy_term_field_data`;

CREATE TABLE `taxonomy_term_field_data` (
  `tid` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `vid` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `name` varchar(255) NOT NULL,
  `description__value` longtext,
  `description__format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `weight` int(11) NOT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `status` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`tid`,`langcode`),
  KEY `taxonomy_term__id__default_langcode__langcode` (`tid`,`default_langcode`,`langcode`),
  KEY `taxonomy_term__revision_id` (`revision_id`),
  KEY `taxonomy_term_field__name` (`name`(191)),
  KEY `taxonomy_term__status_vid` (`status`,`vid`,`tid`),
  KEY `taxonomy_term__tree` (`vid`,`weight`,`name`(191)),
  KEY `taxonomy_term__vid_name` (`vid`,`name`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for taxonomy_term entities.';

/*Data for the table `taxonomy_term_field_data` */

insert  into `taxonomy_term_field_data`(`tid`,`revision_id`,`vid`,`langcode`,`name`,`description__value`,`description__format`,`weight`,`changed`,`default_langcode`,`status`,`revision_translation_affected`) values 

(1,1,'blog_category','en','Fashion',NULL,NULL,0,1479923373,1,1,1),

(2,2,'blog_category','en','Luxury',NULL,NULL,0,1479923378,1,1,1),

(3,3,'blog_category','en','Development',NULL,NULL,0,1479923381,1,1,1),

(4,4,'blog_category','en','Drupal',NULL,NULL,0,1479923383,1,1,1),

(5,5,'blog_category','en','Design',NULL,NULL,0,1479923386,1,1,1),

(6,6,'blog_category','en','Trends',NULL,NULL,0,1479923389,1,1,1),

(7,7,'blog_category','en','Theme',NULL,NULL,0,1479923394,1,1,1),

(8,8,'blog_category','en','Quality',NULL,NULL,0,1479923402,1,1,1),

(9,9,'blog_category','en','Purchase theme',NULL,NULL,0,1480029413,1,1,1),

(10,10,'tags','en','drupal',NULL,NULL,0,1479931011,1,1,1),

(11,11,'tags','en','Development',NULL,NULL,0,1479931019,1,1,1),

(12,12,'tags','en','javascript',NULL,NULL,0,1479931025,1,1,1),

(13,13,'tags','en','html',NULL,NULL,0,1479931027,1,1,1),

(14,14,'tags','en','seo',NULL,NULL,0,1479931029,1,1,1),

(15,15,'tags','en','nikadevs',NULL,NULL,0,1479931036,1,1,1),

(16,16,'project','en','Drupal 7',NULL,NULL,0,1480353694,1,1,1),

(17,17,'project','en','Drupal 8',NULL,NULL,0,1480353699,1,1,1),

(18,18,'project','en','Wordpress',NULL,NULL,0,1480353702,1,1,1),

(19,19,'project','en','Joomla',NULL,NULL,0,1480353704,1,1,1),

(20,20,'project','en','Template',NULL,NULL,0,1480353710,1,1,1),

(21,21,'project','en','CMS',NULL,NULL,0,1480353712,1,1,1),

(22,22,'portfolio_category','en','Design',NULL,NULL,0,1480353745,1,1,1),

(23,23,'portfolio_category','en','Images',NULL,NULL,0,1480353749,1,1,1),

(24,24,'portfolio_category','en','Video',NULL,NULL,0,1480353753,1,1,1),

(25,25,'portfolio_category','en','Trends',NULL,NULL,0,1480353758,1,1,1),

(26,26,'portfolio_category','en','3D Design',NULL,NULL,0,1480353766,1,1,1),

(27,27,'portfolio_category','en','Architecture',NULL,NULL,0,1480353774,1,1,1),

(28,28,'category','en','Branding',NULL,NULL,0,1480353801,1,1,1),

(29,29,'category','en','Design',NULL,NULL,0,1480353805,1,1,1),

(30,30,'category','en','Fashion',NULL,NULL,0,1480353808,1,1,1),

(31,31,'category','en','Polo Shirts',NULL,NULL,0,1480353813,1,1,1),

(32,32,'category','en','Sport Shirts',NULL,NULL,0,1480353819,1,1,1),

(33,33,'gallery','en','Gallery 1',NULL,NULL,0,1481650042,1,1,1),

(34,34,'gallery','en','Gallery 2',NULL,NULL,0,1481650047,1,1,1),

(35,35,'gallery','en','Gallery 3',NULL,NULL,0,1481650050,1,1,1),

(36,36,'category','en','Fashion wear',NULL,NULL,0,1503051091,1,1,1),

(37,37,'tags','en','Branding',NULL,NULL,0,1503051552,1,1,1),

(38,38,'tags','en','Clean',NULL,NULL,0,1503051567,1,1,1),

(39,39,'tags','en','Digital',NULL,NULL,0,1503053356,1,1,1);

/*Table structure for table `taxonomy_term_field_revision` */

DROP TABLE IF EXISTS `taxonomy_term_field_revision`;

CREATE TABLE `taxonomy_term_field_revision` (
  `tid` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description__value` longtext,
  `description__format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `status` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`revision_id`,`langcode`),
  KEY `taxonomy_term__id__default_langcode__langcode` (`tid`,`default_langcode`,`langcode`),
  KEY `taxonomy_term_field__description__format` (`description__format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The revision data table for taxonomy_term entities.';

/*Data for the table `taxonomy_term_field_revision` */

insert  into `taxonomy_term_field_revision`(`tid`,`revision_id`,`langcode`,`name`,`description__value`,`description__format`,`changed`,`default_langcode`,`status`,`revision_translation_affected`) values 

(1,1,'en','Fashion',NULL,NULL,1479923373,1,1,1),

(2,2,'en','Luxury',NULL,NULL,1479923378,1,1,1),

(3,3,'en','Development',NULL,NULL,1479923381,1,1,1),

(4,4,'en','Drupal',NULL,NULL,1479923383,1,1,1),

(5,5,'en','Design',NULL,NULL,1479923386,1,1,1),

(6,6,'en','Trends',NULL,NULL,1479923389,1,1,1),

(7,7,'en','Theme',NULL,NULL,1479923394,1,1,1),

(8,8,'en','Quality',NULL,NULL,1479923402,1,1,1),

(9,9,'en','Purchase theme',NULL,NULL,1480029413,1,1,1),

(10,10,'en','drupal',NULL,NULL,1479931011,1,1,1),

(11,11,'en','Development',NULL,NULL,1479931019,1,1,1),

(12,12,'en','javascript',NULL,NULL,1479931025,1,1,1),

(13,13,'en','html',NULL,NULL,1479931027,1,1,1),

(14,14,'en','seo',NULL,NULL,1479931029,1,1,1),

(15,15,'en','nikadevs',NULL,NULL,1479931036,1,1,1),

(16,16,'en','Drupal 7',NULL,NULL,1480353694,1,1,1),

(17,17,'en','Drupal 8',NULL,NULL,1480353699,1,1,1),

(18,18,'en','Wordpress',NULL,NULL,1480353702,1,1,1),

(19,19,'en','Joomla',NULL,NULL,1480353704,1,1,1),

(20,20,'en','Template',NULL,NULL,1480353710,1,1,1),

(21,21,'en','CMS',NULL,NULL,1480353712,1,1,1),

(22,22,'en','Design',NULL,NULL,1480353745,1,1,1),

(23,23,'en','Images',NULL,NULL,1480353749,1,1,1),

(24,24,'en','Video',NULL,NULL,1480353753,1,1,1),

(25,25,'en','Trends',NULL,NULL,1480353758,1,1,1),

(26,26,'en','3D Design',NULL,NULL,1480353766,1,1,1),

(27,27,'en','Architecture',NULL,NULL,1480353774,1,1,1),

(28,28,'en','Branding',NULL,NULL,1480353801,1,1,1),

(29,29,'en','Design',NULL,NULL,1480353805,1,1,1),

(30,30,'en','Fashion',NULL,NULL,1480353808,1,1,1),

(31,31,'en','Polo Shirts',NULL,NULL,1480353813,1,1,1),

(32,32,'en','Sport Shirts',NULL,NULL,1480353819,1,1,1),

(33,33,'en','Gallery 1',NULL,NULL,1481650042,1,1,1),

(34,34,'en','Gallery 2',NULL,NULL,1481650047,1,1,1),

(35,35,'en','Gallery 3',NULL,NULL,1481650050,1,1,1),

(36,36,'en','Fashion wear',NULL,NULL,1503051091,1,1,1),

(37,37,'en','Branding',NULL,NULL,1503051552,1,1,1),

(38,38,'en','Clean',NULL,NULL,1503051567,1,1,1),

(39,39,'en','Digital',NULL,NULL,1503053356,1,1,1);

/*Table structure for table `taxonomy_term_revision` */

DROP TABLE IF EXISTS `taxonomy_term_revision`;

CREATE TABLE `taxonomy_term_revision` (
  `tid` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `revision_default` tinyint(4) DEFAULT NULL,
  `revision_user` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `revision_created` int(11) DEFAULT NULL,
  `revision_log_message` longtext,
  PRIMARY KEY (`revision_id`),
  KEY `taxonomy_term__tid` (`tid`),
  KEY `taxonomy_term_field__revision_user__target_id` (`revision_user`)
) ENGINE=InnoDB AUTO_INCREMENT=40 DEFAULT CHARSET=utf8mb4 COMMENT='The revision table for taxonomy_term entities.';

/*Data for the table `taxonomy_term_revision` */

insert  into `taxonomy_term_revision`(`tid`,`revision_id`,`langcode`,`revision_default`,`revision_user`,`revision_created`,`revision_log_message`) values 

(1,1,'en',1,NULL,NULL,NULL),

(2,2,'en',1,NULL,NULL,NULL),

(3,3,'en',1,NULL,NULL,NULL),

(4,4,'en',1,NULL,NULL,NULL),

(5,5,'en',1,NULL,NULL,NULL),

(6,6,'en',1,NULL,NULL,NULL),

(7,7,'en',1,NULL,NULL,NULL),

(8,8,'en',1,NULL,NULL,NULL),

(9,9,'en',1,NULL,NULL,NULL),

(10,10,'en',1,NULL,NULL,NULL),

(11,11,'en',1,NULL,NULL,NULL),

(12,12,'en',1,NULL,NULL,NULL),

(13,13,'en',1,NULL,NULL,NULL),

(14,14,'en',1,NULL,NULL,NULL),

(15,15,'en',1,NULL,NULL,NULL),

(16,16,'en',1,NULL,NULL,NULL),

(17,17,'en',1,NULL,NULL,NULL),

(18,18,'en',1,NULL,NULL,NULL),

(19,19,'en',1,NULL,NULL,NULL),

(20,20,'en',1,NULL,NULL,NULL),

(21,21,'en',1,NULL,NULL,NULL),

(22,22,'en',1,NULL,NULL,NULL),

(23,23,'en',1,NULL,NULL,NULL),

(24,24,'en',1,NULL,NULL,NULL),

(25,25,'en',1,NULL,NULL,NULL),

(26,26,'en',1,NULL,NULL,NULL),

(27,27,'en',1,NULL,NULL,NULL),

(28,28,'en',1,NULL,NULL,NULL),

(29,29,'en',1,NULL,NULL,NULL),

(30,30,'en',1,NULL,NULL,NULL),

(31,31,'en',1,NULL,NULL,NULL),

(32,32,'en',1,NULL,NULL,NULL),

(33,33,'en',1,NULL,NULL,NULL),

(34,34,'en',1,NULL,NULL,NULL),

(35,35,'en',1,NULL,NULL,NULL),

(36,36,'en',1,NULL,NULL,NULL),

(37,37,'en',1,NULL,NULL,NULL),

(38,38,'en',1,NULL,NULL,NULL),

(39,39,'en',1,NULL,NULL,NULL);

/*Table structure for table `taxonomy_term_revision__parent` */

DROP TABLE IF EXISTS `taxonomy_term_revision__parent`;

CREATE TABLE `taxonomy_term_revision__parent` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `parent_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `parent_target_id` (`parent_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for taxonomy_term field parent.';

/*Data for the table `taxonomy_term_revision__parent` */

insert  into `taxonomy_term_revision__parent`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`parent_target_id`) values 

('blog_category',0,1,1,'en',0,0),

('blog_category',0,2,2,'en',0,0),

('blog_category',0,3,3,'en',0,0),

('blog_category',0,4,4,'en',0,0),

('blog_category',0,5,5,'en',0,0),

('blog_category',0,6,6,'en',0,0),

('blog_category',0,7,7,'en',0,0),

('blog_category',0,8,8,'en',0,0),

('blog_category',0,9,9,'en',0,0),

('tags',0,10,10,'en',0,0),

('tags',0,11,11,'en',0,0),

('tags',0,12,12,'en',0,0),

('tags',0,13,13,'en',0,0),

('tags',0,14,14,'en',0,0),

('tags',0,15,15,'en',0,0),

('project',0,16,16,'en',0,0),

('project',0,17,17,'en',0,0),

('project',0,18,18,'en',0,0),

('project',0,19,19,'en',0,0),

('project',0,20,20,'en',0,0),

('project',0,21,21,'en',0,0),

('portfolio_category',0,22,22,'en',0,0),

('portfolio_category',0,23,23,'en',0,0),

('portfolio_category',0,24,24,'en',0,0),

('portfolio_category',0,25,25,'en',0,0),

('portfolio_category',0,26,26,'en',0,0),

('portfolio_category',0,27,27,'en',0,0),

('category',0,28,28,'en',0,0),

('category',0,29,29,'en',0,0),

('category',0,30,30,'en',0,0),

('category',0,31,31,'en',0,0),

('category',0,32,32,'en',0,0),

('gallery',0,33,33,'en',0,0),

('gallery',0,34,34,'en',0,0),

('gallery',0,35,35,'en',0,0),

('category',0,36,36,'en',0,0),

('tags',0,37,37,'en',0,0),

('tags',0,38,38,'en',0,0),

('tags',0,39,39,'en',0,0);

/*Table structure for table `url_alias` */

DROP TABLE IF EXISTS `url_alias`;

CREATE TABLE `url_alias` (
  `pid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'A unique path alias identifier.',
  `source` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path this alias is for. e.g. node/12.',
  `alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'The alias for this path. e.g. title-of-the-story.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code this alias is for. if ''und'', the alias will be used for unknown languages. Each Drupal path can have an alias for each supported language.',
  PRIMARY KEY (`pid`),
  KEY `alias_langcode_pid` (`alias`(191),`langcode`,`pid`),
  KEY `source_langcode_pid` (`source`(191),`langcode`,`pid`)
) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=utf8mb4 COMMENT='A list of URL aliases for Drupal paths. a user may visit…';

/*Data for the table `url_alias` */

insert  into `url_alias`(`pid`,`source`,`alias`,`langcode`) values 

(1,'/webform/contact','/form/contact','en'),

(2,'/webform/contact','/form/contact','und'),

(3,'/webform/contact/confirmation','/form/contact/confirmation','en'),

(4,'/webform/contact/confirmation','/form/contact/confirmation','und'),

(5,'/webform/contact/submissions','/form/contact/submissions','en'),

(6,'/webform/contact/submissions','/form/contact/submissions','und'),

(7,'/webform/contact_1','/form/contact-1','en'),

(8,'/webform/contact_1','/form/contact-1','und'),

(9,'/webform/contact_1/confirmation','/form/contact-1/confirmation','en'),

(10,'/webform/contact_1/confirmation','/form/contact-1/confirmation','und'),

(11,'/webform/contact_1/submissions','/form/contact-1/submissions','en'),

(12,'/webform/contact_1/submissions','/form/contact-1/submissions','und'),

(13,'/webform/subscribe','/form/subscribe','en'),

(14,'/webform/subscribe','/form/subscribe','und'),

(15,'/webform/subscribe/confirmation','/form/subscribe/confirmation','en'),

(16,'/webform/subscribe/confirmation','/form/subscribe/confirmation','und'),

(17,'/webform/subscribe/submissions','/form/subscribe/submissions','en'),

(18,'/webform/subscribe/submissions','/form/subscribe/submissions','und'),

(19,'/node/107','/content/shop','en'),

(20,'/product/1','/product/only-sons-pique-polo-shirt','und'),

(21,'/product/2','/product/polo-shirt-floral-sleeves','und'),

(22,'/product/3','/product/g-star-polo-applique-jersey','und'),

(23,'/product/4','/product/religion-jersey-polo-shirts','en'),

(24,'/node/43','/content/sliders','en'),

(25,'/webform/contact/drafts','/form/contact/drafts','en'),

(26,'/webform/contact/drafts','/form/contact/drafts','und'),

(27,'/webform/contact_1/drafts','/form/contact-1/drafts','en'),

(28,'/webform/contact_1/drafts','/form/contact-1/drafts','und'),

(29,'/webform/subscribe/drafts','/form/subscribe/drafts','en'),

(30,'/webform/subscribe/drafts','/form/subscribe/drafts','und'),

(31,'/node/70','/content/landing-page','en');

/*Table structure for table `user__commerce_remote_id` */

DROP TABLE IF EXISTS `user__commerce_remote_id`;

CREATE TABLE `user__commerce_remote_id` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_remote_id_provider` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The provider.',
  `commerce_remote_id_remote_id` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The remote ID.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for user field commerce_remote_id.';

/*Data for the table `user__commerce_remote_id` */

/*Table structure for table `user__roles` */

DROP TABLE IF EXISTS `user__roles`;

CREATE TABLE `user__roles` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `roles_target_id` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `roles_target_id` (`roles_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for user field roles.';

/*Data for the table `user__roles` */

insert  into `user__roles`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`roles_target_id`) values 

('user',0,1,1,'en',0,'administrator');

/*Table structure for table `user__user_picture` */

DROP TABLE IF EXISTS `user__user_picture`;

CREATE TABLE `user__user_picture` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `user_picture_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `user_picture_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `user_picture_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `user_picture_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `user_picture_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `user_picture_target_id` (`user_picture_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for user field user_picture.';

/*Data for the table `user__user_picture` */

insert  into `user__user_picture`(`bundle`,`deleted`,`entity_id`,`revision_id`,`langcode`,`delta`,`user_picture_target_id`,`user_picture_alt`,`user_picture_title`,`user_picture_width`,`user_picture_height`) values 

('user',0,1,1,'en',0,8,'','',85,85);

/*Table structure for table `users` */

DROP TABLE IF EXISTS `users`;

CREATE TABLE `users` (
  `uid` int(10) unsigned NOT NULL,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`uid`),
  UNIQUE KEY `user_field__uuid__value` (`uuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for user entities.';

/*Data for the table `users` */

insert  into `users`(`uid`,`uuid`,`langcode`) values 

(0,'eca5e04c-3da5-4590-a13d-f8ed195ee459','en'),

(1,'cd4ab506-5336-4ccc-bc2b-1fd970c6686a','en');

/*Table structure for table `users_data` */

DROP TABLE IF EXISTS `users_data`;

CREATE TABLE `users_data` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary key: users.uid for user.',
  `module` varchar(50) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The name of the module declaring the variable.',
  `name` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The identifier of the data.',
  `value` longblob COMMENT 'The value.',
  `serialized` tinyint(3) unsigned DEFAULT '0' COMMENT 'Whether value is serialized.',
  PRIMARY KEY (`uid`,`module`,`name`),
  KEY `module` (`module`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores module data as key/value pairs per user.';

/*Data for the table `users_data` */

insert  into `users_data`(`uid`,`module`,`name`,`value`,`serialized`) values 

(1,'contact','enabled','1',0);

/*Table structure for table `users_field_data` */

DROP TABLE IF EXISTS `users_field_data`;

CREATE TABLE `users_field_data` (
  `uid` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `preferred_langcode` varchar(12) CHARACTER SET ascii DEFAULT NULL,
  `preferred_admin_langcode` varchar(12) CHARACTER SET ascii DEFAULT NULL,
  `name` varchar(60) NOT NULL,
  `pass` varchar(255) DEFAULT NULL,
  `mail` varchar(254) DEFAULT NULL,
  `timezone` varchar(32) DEFAULT NULL,
  `status` tinyint(4) DEFAULT NULL,
  `created` int(11) NOT NULL,
  `changed` int(11) DEFAULT NULL,
  `access` int(11) NOT NULL,
  `login` int(11) DEFAULT NULL,
  `init` varchar(254) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`uid`,`langcode`),
  UNIQUE KEY `user__name` (`name`,`langcode`),
  KEY `user__id__default_langcode__langcode` (`uid`,`default_langcode`,`langcode`),
  KEY `user_field__mail` (`mail`(191)),
  KEY `user_field__created` (`created`),
  KEY `user_field__access` (`access`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for user entities.';

/*Data for the table `users_field_data` */

insert  into `users_field_data`(`uid`,`langcode`,`preferred_langcode`,`preferred_admin_langcode`,`name`,`pass`,`mail`,`timezone`,`status`,`created`,`changed`,`access`,`login`,`init`,`default_langcode`) values 

(0,'en','en',NULL,'',NULL,NULL,'',0,1478015440,1478015440,0,0,NULL,1),

(1,'en','en',NULL,'Admin','$S$EK6Qqcs8A69geE.JSbbYJX7VhIyJnd/7Kn42RzT5RrkxHFZfiRYQ','admin@example.com','Europe/Moscow',1,1478015440,1503940164,1570974748,1570956815,'admin@example.com',1);

/*Table structure for table `votingapi_result` */

DROP TABLE IF EXISTS `votingapi_result`;

CREATE TABLE `votingapi_result` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(32) CHARACTER SET ascii DEFAULT NULL COMMENT 'The ID of the target entity.',
  `entity_type` varchar(64) DEFAULT NULL,
  `entity_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `value` float DEFAULT NULL,
  `value_type` varchar(64) DEFAULT NULL,
  `timestamp` int(11) DEFAULT NULL,
  `function` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `vote_result_field__type__target_id` (`type`),
  KEY `vote_result_field__entity_id__target_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for vote_result entities.';

/*Data for the table `votingapi_result` */

/*Table structure for table `votingapi_vote` */

DROP TABLE IF EXISTS `votingapi_vote`;

CREATE TABLE `votingapi_vote` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `entity_type` varchar(64) DEFAULT NULL,
  `entity_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `value` float DEFAULT NULL,
  `value_type` varchar(64) DEFAULT NULL,
  `user_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `timestamp` int(11) DEFAULT NULL,
  `vote_source` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `vote_field__uuid__value` (`uuid`),
  KEY `vote_field__type__target_id` (`type`),
  KEY `vote_field__entity_id__target_id` (`entity_id`),
  KEY `vote_field__user_id__target_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for vote entities.';

/*Data for the table `votingapi_vote` */

/*Table structure for table `watchdog` */

DROP TABLE IF EXISTS `watchdog`;

CREATE TABLE `watchdog` (
  `wid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique watchdog event ID.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who triggered the event.',
  `type` varchar(64) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Type of log message, for example "user" or "page not found."',
  `message` longtext NOT NULL COMMENT 'Text of log message to be passed into the t() function.',
  `variables` longblob NOT NULL COMMENT 'Serialized array of variables that match the message string and that is passed into the t() function.',
  `severity` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The severity level of the event. ranges from 0 (Emergency) to 7 (Debug)',
  `link` text COMMENT 'Link to view the result of the event.',
  `location` text NOT NULL COMMENT 'URL of the origin of the event.',
  `referer` text COMMENT 'URL of referring page.',
  `hostname` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Hostname of the user who triggered the event.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of when event occurred.',
  PRIMARY KEY (`wid`),
  KEY `type` (`type`),
  KEY `uid` (`uid`),
  KEY `severity` (`severity`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='Table that contains logs of all system events.';

/*Data for the table `watchdog` */

insert  into `watchdog`(`wid`,`uid`,`type`,`message`,`variables`,`severity`,`link`,`location`,`referer`,`hostname`,`timestamp`) values 

(1,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.','a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:158:\"unlink(C:\\OpenServer\\domains\\local.nikadevs.existing.com\\sites\\default\\files/GOPR0252.MP4_snapshot_06.01_[2017.03.05_17.19.14].jpg): No such file or directory\";}s:9:\"%function\";s:71:\"Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController->release_cleanup()\";s:5:\"%file\";s:118:\"C:\\OpenServer\\domains\\local.nikadevs.existing.com\\modules\\custom\\nikadevs_cms\\src\\Controller\\NikaDevsCmsController.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:3349:\"#0 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\includes\\bootstrap.inc(587): _drupal_error_handler_real(2, \'unlink(C:\\\\OpenS...\', \'C:\\\\OpenServer\\\\d...\', 116, Array)\n#1 [internal function]: _drupal_error_handler(2, \'unlink(C:\\\\OpenS...\', \'C:\\\\OpenServer\\\\d...\', 116, Array)\n#2 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\modules\\custom\\nikadevs_cms\\src\\Controller\\NikaDevsCmsController.php(116): unlink(\'C:\\\\OpenServer\\\\d...\')\n#3 [internal function]: Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController->release_cleanup()\n#4 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#5 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\Render\\Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#6 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#7 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#8 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\symfony\\http-kernel\\HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#9 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\symfony\\http-kernel\\HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#10 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware.php(47): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\stack\\builder\\src\\Stack\\StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\DrupalKernel.php(693): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 {main}\";}',4,'','http://local.nikadevs.existing.com/nikadevs_cms/release','','127.0.0.1',1570974826),

(2,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.','a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:120:\"unlink(C:\\OpenServer\\domains\\local.nikadevs.existing.com\\sites\\default\\files/nikadevs-59.png): No such file or directory\";}s:9:\"%function\";s:71:\"Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController->release_cleanup()\";s:5:\"%file\";s:118:\"C:\\OpenServer\\domains\\local.nikadevs.existing.com\\modules\\custom\\nikadevs_cms\\src\\Controller\\NikaDevsCmsController.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:3349:\"#0 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\includes\\bootstrap.inc(587): _drupal_error_handler_real(2, \'unlink(C:\\\\OpenS...\', \'C:\\\\OpenServer\\\\d...\', 116, Array)\n#1 [internal function]: _drupal_error_handler(2, \'unlink(C:\\\\OpenS...\', \'C:\\\\OpenServer\\\\d...\', 116, Array)\n#2 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\modules\\custom\\nikadevs_cms\\src\\Controller\\NikaDevsCmsController.php(116): unlink(\'C:\\\\OpenServer\\\\d...\')\n#3 [internal function]: Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController->release_cleanup()\n#4 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#5 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\Render\\Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#6 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#7 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#8 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\symfony\\http-kernel\\HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#9 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\symfony\\http-kernel\\HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#10 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware.php(47): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\stack\\builder\\src\\Stack\\StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\DrupalKernel.php(693): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 {main}\";}',4,'','http://local.nikadevs.existing.com/nikadevs_cms/release','','127.0.0.1',1570974826),

(3,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.','a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:135:\"unlink(C:\\OpenServer\\domains\\local.nikadevs.existing.com\\sites\\default\\files\\inline-images/Screenshot_1.png): No such file or directory\";}s:9:\"%function\";s:71:\"Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController->release_cleanup()\";s:5:\"%file\";s:118:\"C:\\OpenServer\\domains\\local.nikadevs.existing.com\\modules\\custom\\nikadevs_cms\\src\\Controller\\NikaDevsCmsController.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:3349:\"#0 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\includes\\bootstrap.inc(587): _drupal_error_handler_real(2, \'unlink(C:\\\\OpenS...\', \'C:\\\\OpenServer\\\\d...\', 116, Array)\n#1 [internal function]: _drupal_error_handler(2, \'unlink(C:\\\\OpenS...\', \'C:\\\\OpenServer\\\\d...\', 116, Array)\n#2 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\modules\\custom\\nikadevs_cms\\src\\Controller\\NikaDevsCmsController.php(116): unlink(\'C:\\\\OpenServer\\\\d...\')\n#3 [internal function]: Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController->release_cleanup()\n#4 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#5 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\Render\\Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#6 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#7 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#8 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\symfony\\http-kernel\\HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#9 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\symfony\\http-kernel\\HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#10 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware.php(47): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\stack\\builder\\src\\Stack\\StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\DrupalKernel.php(693): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 {main}\";}',4,'','http://local.nikadevs.existing.com/nikadevs_cms/release','','127.0.0.1',1570974826),

(4,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.','a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:137:\"unlink(C:\\OpenServer\\domains\\local.nikadevs.existing.com\\sites\\default\\files\\inline-images/Screenshot_1_0.png): No such file or directory\";}s:9:\"%function\";s:71:\"Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController->release_cleanup()\";s:5:\"%file\";s:118:\"C:\\OpenServer\\domains\\local.nikadevs.existing.com\\modules\\custom\\nikadevs_cms\\src\\Controller\\NikaDevsCmsController.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:3349:\"#0 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\includes\\bootstrap.inc(587): _drupal_error_handler_real(2, \'unlink(C:\\\\OpenS...\', \'C:\\\\OpenServer\\\\d...\', 116, Array)\n#1 [internal function]: _drupal_error_handler(2, \'unlink(C:\\\\OpenS...\', \'C:\\\\OpenServer\\\\d...\', 116, Array)\n#2 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\modules\\custom\\nikadevs_cms\\src\\Controller\\NikaDevsCmsController.php(116): unlink(\'C:\\\\OpenServer\\\\d...\')\n#3 [internal function]: Drupal\\nikadevs_cms\\Controller\\NikaDevsCmsController->release_cleanup()\n#4 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#5 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\Render\\Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#6 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#7 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#8 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\symfony\\http-kernel\\HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#9 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\symfony\\http-kernel\\HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#10 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware.php(47): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\StackMiddleware\\NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\vendor\\stack\\builder\\src\\Stack\\StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\core\\lib\\Drupal\\Core\\DrupalKernel.php(693): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 C:\\OpenServer\\domains\\local.nikadevs.existing.com\\index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 {main}\";}',4,'','http://local.nikadevs.existing.com/nikadevs_cms/release','','127.0.0.1',1570974826);

/*Table structure for table `webform` */

DROP TABLE IF EXISTS `webform`;

CREATE TABLE `webform` (
  `webform_id` varchar(32) NOT NULL COMMENT 'The webform id.',
  `next_serial` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The serial number to give to the next submission to this webform.',
  PRIMARY KEY (`webform_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores all webform data.';

/*Data for the table `webform` */

insert  into `webform`(`webform_id`,`next_serial`) values 

('contact',1),

('contact_1',3),

('subscribe',2);

/*Table structure for table `webform_submission` */

DROP TABLE IF EXISTS `webform_submission`;

CREATE TABLE `webform_submission` (
  `sid` int(11) NOT NULL AUTO_INCREMENT,
  `webform_id` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `serial` int(11) DEFAULT NULL,
  `token` varchar(255) DEFAULT NULL,
  `uri` varchar(2000) DEFAULT NULL,
  `created` int(11) DEFAULT NULL,
  `completed` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `in_draft` tinyint(4) DEFAULT NULL,
  `current_page` varchar(128) DEFAULT NULL,
  `remote_addr` varchar(128) DEFAULT NULL,
  `uid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `entity_type` varchar(32) CHARACTER SET ascii DEFAULT NULL,
  `entity_id` varchar(255) DEFAULT NULL,
  `sticky` tinyint(4) DEFAULT NULL,
  `notes` longtext,
  `locked` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`sid`),
  UNIQUE KEY `webform_submission_field__uuid__value` (`uuid`),
  KEY `webform_submission_field__webform_id__target_id` (`webform_id`),
  KEY `webform_submission_field__uid__target_id` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for webform_submission entities.';

/*Data for the table `webform_submission` */

insert  into `webform_submission`(`sid`,`webform_id`,`uuid`,`serial`,`token`,`uri`,`created`,`completed`,`changed`,`in_draft`,`current_page`,`remote_addr`,`uid`,`langcode`,`entity_type`,`entity_id`,`sticky`,`notes`,`locked`) values 

(1,'subscribe','b0274136-32fd-4051-88e7-2d4074e03d63',1,'5Z0p8vSPGYFOqHqOC6H5DsTEdzSbjLXNQXQkm-RX1SA','/',1481661795,1481661795,1481661795,0,NULL,'127.0.0.1',1,'en','node','97',0,NULL,0),

(2,'contact_1','bcff89c8-594b-4fca-84c1-b467100dd067',1,'ioiGI-uOmxjwEX_F_dDTMRrB8xJRG7rM_wbx9LSSlTY','/node/75',1511820443,1511820443,1511820443,0,NULL,'5.188.211.35',0,'en','node','73',0,NULL,0),

(3,'contact_1','127e2d3d-7595-4ee7-b4e9-d207e390a670',2,'YHpkA8h8YIL3I1bmQ5Gv3_g05sG7BLNOaQF9EgJN6D4','/node/74',1511853511,1511853511,1511853511,0,NULL,'5.188.211.35',0,'en','node','73',0,NULL,0);

/*Table structure for table `webform_submission_data` */

DROP TABLE IF EXISTS `webform_submission_data`;

CREATE TABLE `webform_submission_data` (
  `webform_id` varchar(32) NOT NULL COMMENT 'The webform id.',
  `sid` int(10) unsigned NOT NULL COMMENT 'The unique identifier for this submission.',
  `name` varchar(128) NOT NULL COMMENT 'The name of the element.',
  `property` varchar(128) NOT NULL DEFAULT '' COMMENT 'The property of the element''s value.',
  `delta` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The delta of the element''s value.',
  `value` mediumtext NOT NULL COMMENT 'The element''s value.',
  PRIMARY KEY (`sid`,`name`,`property`,`delta`),
  KEY `webform_id` (`webform_id`),
  KEY `sid_webform_id` (`sid`,`webform_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores all submitted data for webform submissions.';

/*Data for the table `webform_submission_data` */

insert  into `webform_submission_data`(`webform_id`,`sid`,`name`,`property`,`delta`,`value`) values 

('subscribe',1,'email','',0,''),

('contact_1',2,'email','',0,''),

('contact_1',2,'message','',0,'ol8FVu http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('contact_1',2,'name','',0,'JimmiNil'),

('contact_1',3,'email','',0,''),

('contact_1',3,'message','',0,'KOemp8 http://www.LnAJ7K8QSpfMO2wQ8gO.com'),

('contact_1',3,'name','',0,'JimmiNil');

/*Table structure for table `webform_submission_log` */

DROP TABLE IF EXISTS `webform_submission_log`;

CREATE TABLE `webform_submission_log` (
  `lid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique log event ID.',
  `webform_id` varchar(32) NOT NULL COMMENT 'The webform id.',
  `sid` int(10) unsigned DEFAULT NULL COMMENT 'The webform submission id.',
  `handler_id` varchar(64) DEFAULT NULL COMMENT 'The webform handler id.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who triggered the event.',
  `operation` varchar(64) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Type of operation, for example "save", "sent", or "update."',
  `message` longtext NOT NULL COMMENT 'Text of log message.',
  `data` longblob NOT NULL COMMENT 'Serialized array of data.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of when event occurred.',
  PRIMARY KEY (`lid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Table that contains logs of all webform submission events.';

/*Data for the table `webform_submission_log` */

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
